--
-- PostgreSQL database dump
--

-- Dumped from database version 9.5.11
-- Dumped by pg_dump version 9.5.11

SET statement_timeout = 0;
SET lock_timeout = 0;
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: acesso; Type: SCHEMA; Schema: -; Owner: postgres
--

CREATE SCHEMA acesso;


ALTER SCHEMA acesso OWNER TO postgres;

--
-- Name: alimentos; Type: SCHEMA; Schema: -; Owner: postgres
--

CREATE SCHEMA alimentos;


ALTER SCHEMA alimentos OWNER TO postgres;

--
-- Name: cadastro; Type: SCHEMA; Schema: -; Owner: postgres
--

CREATE SCHEMA cadastro;


ALTER SCHEMA cadastro OWNER TO postgres;

--
-- Name: consistenciacao; Type: SCHEMA; Schema: -; Owner: postgres
--

CREATE SCHEMA consistenciacao;


ALTER SCHEMA consistenciacao OWNER TO postgres;

--
-- Name: conv_functions; Type: SCHEMA; Schema: -; Owner: postgres
--

CREATE SCHEMA conv_functions;


ALTER SCHEMA conv_functions OWNER TO postgres;

--
-- Name: historico; Type: SCHEMA; Schema: -; Owner: postgres
--

CREATE SCHEMA historico;


ALTER SCHEMA historico OWNER TO postgres;

--
-- Name: modules; Type: SCHEMA; Schema: -; Owner: postgres
--

CREATE SCHEMA modules;


ALTER SCHEMA modules OWNER TO postgres;

--
-- Name: pmiacoes; Type: SCHEMA; Schema: -; Owner: postgres
--

CREATE SCHEMA pmiacoes;


ALTER SCHEMA pmiacoes OWNER TO postgres;

--
-- Name: pmicontrolesis; Type: SCHEMA; Schema: -; Owner: postgres
--

CREATE SCHEMA pmicontrolesis;


ALTER SCHEMA pmicontrolesis OWNER TO postgres;

--
-- Name: pmidrh; Type: SCHEMA; Schema: -; Owner: postgres
--

CREATE SCHEMA pmidrh;


ALTER SCHEMA pmidrh OWNER TO postgres;

--
-- Name: pmieducar; Type: SCHEMA; Schema: -; Owner: postgres
--

CREATE SCHEMA pmieducar;


ALTER SCHEMA pmieducar OWNER TO postgres;

--
-- Name: pmiotopic; Type: SCHEMA; Schema: -; Owner: postgres
--

CREATE SCHEMA pmiotopic;


ALTER SCHEMA pmiotopic OWNER TO postgres;

--
-- Name: portal; Type: SCHEMA; Schema: -; Owner: postgres
--

CREATE SCHEMA portal;


ALTER SCHEMA portal OWNER TO postgres;

--
-- Name: serieciasc; Type: SCHEMA; Schema: -; Owner: postgres
--

CREATE SCHEMA serieciasc;


ALTER SCHEMA serieciasc OWNER TO postgres;

--
-- Name: urbano; Type: SCHEMA; Schema: -; Owner: postgres
--

CREATE SCHEMA urbano;


ALTER SCHEMA urbano OWNER TO postgres;

--
-- Name: plpgsql; Type: EXTENSION; Schema: -; Owner:
--

CREATE EXTENSION IF NOT EXISTS plpgsql WITH SCHEMA pg_catalog;


--
-- Name: EXTENSION plpgsql; Type: COMMENT; Schema: -; Owner:
--

COMMENT ON EXTENSION plpgsql IS 'PL/pgSQL procedural language';


--
-- Name: pg_stat_statements; Type: EXTENSION; Schema: -; Owner:
--

CREATE EXTENSION IF NOT EXISTS pg_stat_statements WITH SCHEMA public;


--
-- Name: EXTENSION pg_stat_statements; Type: COMMENT; Schema: -; Owner:
--

COMMENT ON EXTENSION pg_stat_statements IS 'track execution statistics of all SQL statements executed';


--
-- Name: unaccent; Type: EXTENSION; Schema: -; Owner:
--

CREATE EXTENSION IF NOT EXISTS unaccent WITH SCHEMA public;


--
-- Name: EXTENSION unaccent; Type: COMMENT; Schema: -; Owner:
--

COMMENT ON EXTENSION unaccent IS 'text search dictionary that removes accents';


SET search_path = public, pg_catalog;

--
-- Name: typ_idlog; Type: TYPE; Schema: public; Owner: postgres
--

CREATE TYPE typ_idlog AS (
	idlog integer
);


ALTER TYPE typ_idlog OWNER TO postgres;

--
-- Name: typ_idpes; Type: TYPE; Schema: public; Owner: postgres
--

CREATE TYPE typ_idpes AS (
	idpes integer
);


ALTER TYPE typ_idpes OWNER TO postgres;

SET search_path = alimentos, pg_catalog;

--
-- Name: fcn_calcular_qtde_cardapio(character varying, integer, integer, numeric); Type: FUNCTION; Schema: alimentos; Owner: postgres
--

CREATE FUNCTION fcn_calcular_qtde_cardapio(character varying, integer, integer, numeric) RETURNS character varying
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_cli ALIAS for $1;
  v_id_car ALIAS for $2;
  v_id_pro ALIAS for $3;
  v_qtde_per_capita ALIAS for $4;
  reg_unidade RECORD;
  v_inscritos char(1);
  v_correcao numeric:=0;
  v_coccao numeric:=0;
  v_qtde numeric:= 0;
  v_qtde_retorno varchar(20);
BEGIN
  SELECT INTO v_inscritos inscritos
  FROM alimentos.cliente
  WHERE alimentos.cliente.idcli = v_id_cli;
  SELECT INTO v_correcao,v_coccao fator_correcao,fator_coccao
  FROM alimentos.produto
  WHERE alimentos.produto.idpro = v_id_pro;
  FOR reg_unidade IN SELECT unf.num_inscritos as insc, unf.num_matriculados as matr
        FROM alimentos.cardapio_faixa_unidade car,
                     alimentos.unidade_faixa_etaria unf
        WHERE car.idfeu = unf.idfeu
        AND   car.idcar = v_id_car LOOP
    IF v_inscritos = 'S' THEN
      v_qtde := v_qtde + (v_qtde_per_capita * reg_unidade.insc * v_correcao * v_coccao);
    ELSE
      v_qtde := v_qtde + (v_qtde_per_capita * reg_unidade.matr * v_correcao * v_coccao);
    END IF;
  END LOOP;

  v_qtde_retorno := trim(to_char(v_qtde, '9999999999.99'));
  RETURN v_qtde_retorno;
END;$_$;


ALTER FUNCTION alimentos.fcn_calcular_qtde_cardapio(character varying, integer, integer, numeric) OWNER TO postgres;

--
-- Name: fcn_calcular_qtde_percapita(character varying, integer, integer, integer, integer); Type: FUNCTION; Schema: alimentos; Owner: postgres
--

CREATE FUNCTION fcn_calcular_qtde_percapita(character varying, integer, integer, integer, integer) RETURNS numeric
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_cli ALIAS for $1;
  v_id_uni ALIAS for $2;
  v_id_pro ALIAS for $3;
  v_data_inicial ALIAS for $4;
  v_data_final ALIAS for $5;
  v_sql_qtde_produto text;
  v_reg_qtde_produto RECORD;
  v_qtde_produto_periodo numeric;
  v_existe_unidade integer;
BEGIN
  v_sql_qtde_produto := 'SELECT car.dt_cardapio
    ,cap.quantidade as qtde
    ,car.idcar as idcar
  FROM alimentos.cardapio car
      ,alimentos.cardapio_produto cap
  WHERE car.idcar = cap.idcar
  AND cap.idpro = ' || v_id_pro || '
  AND car.finalizado = ''S''
  AND car.idcli = ''' ||  v_id_cli || '''
  AND TO_NUMBER(TO_CHAR(car.dt_cardapio,''YYYYMMDD''),''99999999'') BETWEEN ' || v_data_inicial || ' AND  ' || v_data_final;
  v_qtde_produto_periodo := 0;
  v_existe_unidade := 0;
  FOR v_reg_qtde_produto IN EXECUTE v_sql_qtde_produto LOOP
    --
    -- Verifica se o cardápio atende a unidade em questão
    --
    SELECT INTO v_existe_unidade distinct uni.iduni
    FROM alimentos.cardapio car
      ,alimentos.cardapio_faixa_unidade caf
      ,alimentos.unidade_atendida uni
      ,alimentos.unidade_faixa_etaria ufa
    WHERE car.idcar = caf.idcar
    AND caf.idfeu = ufa.idfeu
    AND ufa.iduni = uni.iduni
    AND uni.iduni = v_id_uni
    AND car.idcar = v_reg_qtde_produto.idcar;
    IF v_existe_unidade > 0 THEN
      v_qtde_produto_periodo := v_qtde_produto_periodo  + v_reg_qtde_produto.qtde;
    END IF;
  END LOOP;
  RETURN v_qtde_produto_periodo;
END;$_$;


ALTER FUNCTION alimentos.fcn_calcular_qtde_percapita(character varying, integer, integer, integer, integer) OWNER TO postgres;

--
-- Name: fcn_calcular_qtde_unidade(character varying, integer, integer, numeric, integer, integer); Type: FUNCTION; Schema: alimentos; Owner: postgres
--

CREATE FUNCTION fcn_calcular_qtde_unidade(character varying, integer, integer, numeric, integer, integer) RETURNS numeric
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_cli ALIAS for $1;
  v_id_uni ALIAS for $2;
  v_id_pro ALIAS for $3;
  v_qtde_per_capita ALIAS for $4;
  v_data_inicial ALIAS for $5;
  v_data_final ALIAS for $6;
  v_reg_faixa RECORD;
  v_inscritos char(1);
  v_correcao numeric:=0;
  v_coccao numeric:=0;
  v_qtde numeric:= 0;
  v_peso numeric:=0;
  v_qtde_produto_periodo numeric:=0;
  v_num_inscritos integer;
  v_num_matriculados integer;
BEGIN
  SELECT INTO v_inscritos inscritos
  FROM alimentos.cliente
  WHERE alimentos.cliente.idcli = v_id_cli;
  SELECT INTO v_correcao,v_coccao,v_peso pro.fator_correcao, pro.fator_coccao, unp.peso
  FROM alimentos.produto pro, alimentos.unidade_produto unp
  WHERE   pro.idunp = unp.idunp
  AND unp.idcli = v_id_cli
  AND     pro.idpro = v_id_pro;
  --
  -- Obtém inscritos e matriculados para a unidade
  --
  v_num_inscritos:=0;
  v_num_matriculados:=0;
  FOR v_reg_faixa IN SELECT distinct ufa.idfae as idfae
      ,ufa.num_inscritos as num_inscritos
      ,ufa.num_matriculados as num_matriculados
    FROM  alimentos.cardapio car
      ,alimentos.cardapio_faixa_unidade caf
      ,alimentos.unidade_atendida uni
      ,alimentos.unidade_faixa_etaria ufa
    WHERE car.idcar = caf.idcar
    AND   caf.idfeu = ufa.idfeu
    AND ufa.iduni = uni.iduni
    AND     uni.iduni = v_id_uni
    AND     car.finalizado = 'S'
    AND car.idcli = v_id_cli
    AND TO_NUMBER(TO_CHAR(car.dt_cardapio,'YYYYMMDD'),'99999999') BETWEEN v_data_inicial AND v_data_final LOOP
    v_num_inscritos:=v_num_inscritos + v_reg_faixa.num_inscritos;
    v_num_matriculados:=v_num_matriculados + v_reg_faixa.num_matriculados;
  END LOOP;
  --
  -- Calcula a qtde percapita necessária do produto para o período
  --
  select INTO v_qtde_produto_periodo
  alimentos.fcn_calcular_qtde_percapita (v_id_cli,v_id_uni,v_id_pro,v_data_inicial,v_data_final);
  IF v_inscritos = 'S' THEN
    v_qtde := v_qtde_produto_periodo * v_num_inscritos * v_correcao * v_coccao;
  ELSE
    v_qtde := v_qtde_produto_periodo * v_num_matriculados * v_correcao * v_coccao;
  END IF;
  RETURN round(v_qtde/v_peso);
END;$_$;


ALTER FUNCTION alimentos.fcn_calcular_qtde_unidade(character varying, integer, integer, numeric, integer, integer) OWNER TO postgres;

--
-- Name: fcn_gerar_guia_remessa(text, text, integer, integer, character varying, character varying, character varying, integer); Type: FUNCTION; Schema: alimentos; Owner: postgres
--

CREATE FUNCTION fcn_gerar_guia_remessa(text, text, integer, integer, character varying, character varying, character varying, integer) RETURNS text
    LANGUAGE plpgsql
    AS $_$DECLARE
   -- Parâmetro recebidos
   v_array_fornecedor ALIAS for $1;
   v_array_unidade ALIAS for $2;
   v_data_inicial ALIAS for $3;
   v_data_final ALIAS for $4;
   v_classe ALIAS for $5;
   v_id_cliente ALIAS for $6;
   v_login ALIAS for $7;
   v_id_log ALIAS for $8;
   v_sql_unidade text;
   v_reg_unidade RECORD;
   v_reg_faixa RECORD;
   v_sql_produto text;
   v_reg_produto RECORD;
   v_sql_fornecedor text;
   v_reg_fornecedor RECORD;
   v_num_inscritos integer;
   v_num_matriculados integer;
   v_inscritos char(1);
   v_qtde_necessaria numeric;         -- quantidade total necessaria para o produto
   v_qtde_necessaria_saldo numeric;   -- saldo do produto a fornecer
   v_qtde_nec_saldo_ant numeric;      -- saldo anterior do produto
   v_qtde_guia_produto numeric;       -- qtde do produto com guia de remessa gerada
   v_qtde_disponivel numeric;         -- qtde total disponível no(s) fornecedor(res)
   v_qtde_total_contrato numeric;     -- qtde total contratada com o fornecedor
   v_percentual_forn numeric;         -- percentual que pode ser fornecido pelo forn
   -- quantidade fornecida para o produto pelo fornecedor na guia
   v_qtde_forn numeric;
   v_qtde_guia integer:=0;
   v_qtde_produto_periodo numeric:=0; -- qtde de produto necessária para o período
              --(somatória da qtde percapita da receita)

   v_id_guia integer:=0;
   v_id_guia_produto integer:=0;
   v_sequencial integer:=0;         -- sequencial da guia de remessa gerada
   v_num_inscr_matr integer:=0;
   v_num_refeicao integer:=0;
   v_dt_cardapio_ini_x date;
   v_dt_cardapio_ini_y integer:=0;
   v_dt_cardapio_ini date;
   v_dt_cardapio_fim date;
   v_classe_aux VARCHAR(2);
   v_peso numeric;
   v_existe_forn integer:=0;
   v_existe_produto integer:=0;
   v_existe_estoque integer:=0;
   --v_id_log integer:=0;

BEGIN
   --
   -- Converte data numérica invertida para o formato DD/MM/YYYY
   --
   v_dt_cardapio_ini := TO_DATE(substr(TRIM(TO_CHAR(v_data_inicial,'99999999')),7,2)|| '/' || substr(TRIM(TO_CHAR(v_data_inicial,'99999999')),5,2)|| '/' || substr(TRIM(TO_CHAR(v_data_inicial,'99999999')),1,4),'DD/MM/YYYY');
   v_dt_cardapio_ini_x := v_dt_cardapio_ini;
   v_dt_cardapio_fim := TO_DATE(substr(TRIM(TO_CHAR(v_data_final,'99999999')),7,2)|| '/' || substr(TRIM(TO_CHAR(v_data_final,'99999999')),5,2)|| '/' || substr(TRIM(TO_CHAR(v_data_final,'99999999')),1,4),'DD/MM/YYYY');
   --
   -- INSERE LOG
   --
   --v_id_log:=nextval('alimentos.log_guia_remessa_idlogguia_seq'::text);
   INSERT INTO alimentos.log_guia_remessa
    (idlogguia
    ,login
    ,idcli
    ,dt_inicial
    ,dt_final
    ,unidade
    ,fornecedor
    ,classe
    ,dt_geracao
    ,mensagem)
  VALUES
    (v_id_log
    ,v_login
    ,v_id_cliente
    ,v_dt_cardapio_ini
    ,v_dt_cardapio_fim
    ,v_array_unidade
    ,v_array_fornecedor
    ,v_classe
    ,CURRENT_TIMESTAMP
    ,'*** INÍCIO ***');
   --
   -- Obtém indicação de inscritos ou matriculados para o cliente
   --
   SELECT INTO v_inscritos inscritos
   FROM alimentos.cliente
   WHERE alimentos.cliente.idcli = v_id_cliente;
   RAISE NOTICE 'Inscritos(%)',v_inscritos;
   --
   -- GRAVA LOG
   --
   UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n Inscritos: ' || v_inscritos WHERE idlogguia = v_id_log;
   --
   -- Obtém o número de tipos de refeições que serão atendidas
   -- (total café da manhã, total almoço, etc)
   --
   SELECT INTO v_num_refeicao COUNT(distinct idtre)
   FROM alimentos.cardapio car
   WHERE car.idcli = v_id_cliente
   AND car.finalizado = 'S'
   AND TO_NUMBER(TO_CHAR(car.dt_cardapio,'YYYYMMDD'),'99999999') BETWEEN v_data_inicial AND v_data_final;
   WHILE v_dt_cardapio_ini_x <= v_dt_cardapio_fim LOOP

      RAISE NOTICE '---------------->>1º Loop Data(%)',v_dt_cardapio_ini_x;

      --
      -- GRAVA LOG
      --
      UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n      ----- 1º Loop Data ' || TO_CHAR(v_dt_cardapio_ini_x,'DD/MM/YYYY') || ' -----' WHERE idlogguia = v_id_log;
      --
      -- Prepara SELECT para obter as unidades que atendem aos filtros informados
      --
      v_sql_unidade := 'SELECT distinct uni.iduni as iduni
      ,TRIM(uni.nome) as nome
      FROM alimentos.cardapio car
       ,alimentos.cardapio_faixa_unidade caf
       ,alimentos.unidade_atendida uni
       ,alimentos.unidade_faixa_etaria ufa
      WHERE car.idcar = caf.idcar
      AND caf.idfeu = ufa.idfeu
      AND ufa.iduni = uni.iduni';

      IF v_array_unidade <> '0' THEN
         v_sql_unidade := v_sql_unidade || ' AND uni.iduni IN (' || v_array_unidade || ')';
      END IF;

      v_sql_unidade := v_sql_unidade || ' AND car.finalizado = ''S''
      AND car.idcli = ''' || v_id_cliente || '''
      AND car.dt_cardapio = ''' || v_dt_cardapio_ini_x || '''';

      --
      -- Executa SELECT para obter as unidades
      --
      FOR v_reg_unidade IN EXECUTE v_sql_unidade LOOP

         RAISE NOTICE '                                          ';
         RAISE NOTICE '2º Loop Unidade(%)',v_reg_unidade.nome;

         --
         -- GRAVA LOG
         --
         UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n      ----- 2º Loop Unidade ' || TRIM(TO_CHAR(v_reg_unidade.iduni, '9999999999')) || '-' || v_reg_unidade.nome || ' -----' WHERE idlogguia = v_id_log;
         v_num_inscritos:=0;
   v_num_matriculados:=0;

         --
         -- Obtém inscritos e matriculados para a unidade
         --

         FOR v_reg_faixa IN SELECT distinct ufa.idfae as idfae
                   ,ufa.num_inscritos as num_inscritos
             ,ufa.num_matriculados as num_matriculados
      FROM alimentos.cardapio car
    ,alimentos.cardapio_faixa_unidade caf
    ,alimentos.unidade_atendida uni
    ,alimentos.unidade_faixa_etaria ufa
      WHERE car.idcar = caf.idcar
      AND caf.idfeu = ufa.idfeu
      AND ufa.iduni = uni.iduni
      AND uni.iduni = v_reg_unidade.iduni
      AND car.finalizado = 'S'
      AND car.idcli = v_id_cliente
      AND car.dt_cardapio = v_dt_cardapio_ini_x LOOP

            v_num_inscritos:=v_num_inscritos + v_reg_faixa.num_inscritos;
      v_num_matriculados:=v_num_matriculados + v_reg_faixa.num_matriculados;

   END LOOP;
   RAISE NOTICE 'Inscritos(%)',v_num_inscritos;
   RAISE NOTICE 'Matriculados(%)',v_num_matriculados;

         --
         -- GRAVA LOG
         --
         UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n      Nº Inscritos: ' || TRIM(TO_CHAR(v_num_inscritos, '9999999999')) WHERE idlogguia = v_id_log;
   UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n      Nº Matriculados: ' || TRIM(TO_CHAR(v_num_matriculados, '9999999999')) WHERE idlogguia = v_id_log;
   --
   -- Prepara SELECT para carregar produtos existentes no cardápio
   --
         v_sql_produto := 'SELECT distinct cap.idpro as idpro
        ,cap.quantidade as qtde
        ,pro.fator_correcao as fator_correcao
        ,pro.fator_coccao as fator_coccao
        ,TRIM(pro.nome_compra) as nome_compra
        ,unp.peso as peso
      FROM  alimentos.cardapio car
        ,alimentos.cardapio_produto cap
        ,alimentos.produto pro
        ,alimentos.unidade_produto unp
        ,alimentos.cardapio_faixa_unidade caf
        ,alimentos.unidade_atendida uni
        ,alimentos.unidade_faixa_etaria ufa
      WHERE car.idcar = cap.idcar
      AND cap.idpro = pro.idpro
      AND     pro.idunp = unp.idunp
      AND     unp.idcli = ''' || v_id_cliente || '''
      AND car.idcar = caf.idcar
      AND   caf.idfeu = ufa.idfeu
      AND ufa.iduni = uni.iduni';
   IF v_classe is not null THEN
      v_sql_produto := v_sql_produto || ' AND pro.classe = ''' || v_classe || '''';
         END IF;

         --
   -- Seleciona somente os produtos do cardápio que o fornecedor
         -- pode fornecedor
   --
         IF v_array_fornecedor <> '0' THEN
      v_sql_produto := v_sql_produto || ' AND pro.idpro IN (
         SELECT cop.idpro
            FROM alimentos.contrato con
          ,alimentos.contrato_produto cop
                  WHERE cop.idcon = con.idcon
                AND con.cancelado = ''N''
                AND con.finalizado = ''S''
                AND con.ultimo_contrato = ''S''
                AND con.idfor IN (' || v_array_fornecedor || ')
                  AND cop.qtde_remessa < cop.qtde_contratada
                  AND cop.idpro = pro.idpro)';
         END IF;

         v_sql_produto := v_sql_produto || '
      AND uni.iduni = ' || v_reg_unidade.iduni || '
            AND car.finalizado = ''S''
            AND car.idcli = ''' || v_id_cliente || '''
            AND car.dt_cardapio = ''' || v_dt_cardapio_ini_x || '''
            ORDER BY TRIM(pro.nome_compra)';

         --
         -- Obtém os produtos do cardápio utilizados pela unidade
         --

         FOR v_reg_produto IN EXECUTE v_sql_produto LOOP

            RAISE NOTICE '                                          ';
            RAISE NOTICE '3º Loop Produto(%)',v_reg_produto.nome_compra;

            --
            -- GRAVA LOG
            --
            UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n \n      3º Loop Produto ' || TRIM(TO_CHAR(v_reg_produto.idpro, '9999999999')) || '-' || v_reg_produto.nome_compra WHERE idlogguia = v_id_log;

            v_existe_produto := v_existe_produto + 1;

            --
            -- Calcula a qtde percapita necessária do produto para o período
            --

            v_dt_cardapio_ini_y := TO_NUMBER(TO_CHAR(v_dt_cardapio_ini_x, 'YYYYMMDD'),'99999999');

            select INTO v_qtde_produto_periodo alimentos.fcn_calcular_qtde_percapita (v_id_cliente, v_reg_unidade.iduni, v_reg_produto.idpro, v_dt_cardapio_ini_y, v_dt_cardapio_ini_y);

            --
            --
            -- Calcula a qtde necessária para o produto e para a unidade considerando
            -- os inscritos/matriculados
            --
            if v_inscritos = 'S' THEN
               v_qtde_necessaria := v_qtde_produto_periodo * v_num_inscritos * v_reg_produto.fator_correcao * v_reg_produto.fator_coccao;
            ELSE
               v_qtde_necessaria := v_qtde_produto_periodo * v_num_matriculados * v_reg_produto.fator_correcao * v_reg_produto.fator_coccao;
            END IF;

            --
            -- Divide qtde total em gramas pelo peso da unidade do produto
            --
            v_qtde_necessaria := ROUND(v_qtde_necessaria / v_reg_produto.peso);

            --
            -- Obtém qtde do produto já gerado em outras guias
            --
            v_qtde_guia_produto := 0;

            SELECT INTO v_qtde_guia_produto COALESCE(SUM(qtde),0)
               FROM alimentos.guia_produto_diario
               WHERE idpro = v_reg_produto.idpro
               AND iduni = v_reg_unidade.iduni
               AND dt_guia = v_dt_cardapio_ini_x;

            v_qtde_necessaria_saldo:=v_qtde_necessaria - v_qtde_guia_produto;


            --
            -- GRAVA LOG
            --
            UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n      Qtde per capita: ' || TRIM(TO_CHAR(v_qtde_produto_periodo, '9999999999.99')) WHERE idlogguia = v_id_log;

            UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n      Fator correção: ' || TRIM(TO_CHAR(v_reg_produto.fator_correcao, '9999999999.99')) WHERE idlogguia = v_id_log;

            UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n      Fator cocção: ' || TRIM(TO_CHAR(v_reg_produto.fator_coccao, '9999999999.99')) WHERE idlogguia = v_id_log;

            UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n      Peso: ' || TRIM(TO_CHAR(v_reg_produto.peso, '9999999999.99')) WHERE idlogguia = v_id_log;
            UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n      Qtde necessária: ' || TRIM(TO_CHAR(v_qtde_necessaria, '9999999999.99')) WHERE idlogguia = v_id_log;

            RAISE NOTICE 'Qtde per capita(%)',v_qtde_produto_periodo;
            RAISE NOTICE 'Fator correção(%)',v_reg_produto.fator_correcao;
            RAISE NOTICE 'Fator cocção(%)',v_reg_produto.fator_coccao;
            RAISE NOTICE 'Peso(%)',v_reg_produto.peso;
            RAISE NOTICE 'Qtde Necessária(%)',v_qtde_necessaria;

            --
            -- Obtém qtde do produto em contrato, incluindo
            -- todos os fornecedores autorizados a fornecer para a unidade
            -- e que tenham produtos a fornecer (qtde remessa < qtde contrato)
            -- ou qtde remessa = qtde_contrato (estoque zerado) e contrato vigente porque
            -- possuem outros produtos a fornecer
            --
            v_sql_fornecedor := 'SELECT con.idfor as idfor
               ,COALESCE(SUM(cop.qtde_contratada-cop.qtde_remessa),0) as qtde
               ,SUM(cop.qtde_contratada) as qtde_contratada
               FROM alimentos.contrato con
                   ,alimentos.contrato_produto cop
               WHERE con.idcon = cop.idcon
         AND con.cancelado = ''N''
         AND con.finalizado = ''S''
         AND con.ultimo_contrato = ''S''
         AND con.idfor IN (SELECT idfor
                  FROM alimentos.fornecedor_unidade_atendida
                  WHERE iduni = ' || v_reg_unidade.iduni || ')
               AND (cop.qtde_remessa < cop.qtde_contratada
               OR  (cop.qtde_remessa  = cop.qtde_contratada
               AND (SELECT COALESCE(SUM(cop2.qtde_contratada-cop2.qtde_remessa),0)
                       FROM alimentos.contrato_produto cop2
                       WHERE cop2.idcon = con.idcon
                       AND cop2.idpro <> ' ||  v_reg_produto.idpro || ' ) > 0 ))
               AND cop.idpro = ' || v_reg_produto.idpro || '
               GROUP BY con.idfor ';

            v_qtde_total_contrato := 0;
            v_existe_forn := 0;

            FOR v_reg_fornecedor IN EXECUTE v_sql_fornecedor LOOP
               v_existe_forn := 1;
               v_qtde_total_contrato:= v_qtde_total_contrato + v_reg_fornecedor.qtde_contratada;
            END LOOP;

            RAISE NOTICE 'Qtde total contrato(%)',v_qtde_total_contrato;

            --
            -- GRAVA LOG
            --
            UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n      Qtde total contrato: ' || TRIM(TO_CHAR(v_qtde_total_contrato, '9999999999.99')) WHERE idlogguia = v_id_log;

            --
            -- Testa se fornecedor tem contrato e autorização para fornecer para a
            -- unidade
            --
            IF v_existe_forn = 0 THEN

               --
               -- GRAVA LOG
               --
               UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n      *** existe forn: N ***' WHERE idlogguia = v_id_log;

               RETURN '-1 Produto: ' || v_reg_produto.nome_compra || ' não tem contrato ou o fornecedor contratado não está autorizado a fornecer para a unidade ' || v_reg_unidade.nome || '.';

            END IF;

            --
            -- Qtde necessária deve ser > 0
            --
            IF v_qtde_necessaria > 0 THEN

               --
               -- Calcula a quantidade a ser fornecida por cada fornecedor
               --

               -- PREPARA SELECT
               v_sql_fornecedor := 'SELECT con.idcon as idcon
                  ,con.idfor as idfor
                  ,TRIM(con.codigo) as codigo
                  ,cop.qtde_contratada as qtde_contratada
                  ,cop.qtde_remessa as qtde_remessa
                  ,cop.idcop as idcop
                  ,TRIM(forn.nome_fantasia) as nome
                  FROM  alimentos.contrato con
                       ,alimentos.contrato_produto cop
                       ,alimentos.fornecedor forn
                  WHERE con.idcon = cop.idcon
                  AND con.idfor = forn.idfor
                  AND     con.cancelado = ''N''
                  AND     con.finalizado = ''S''
                  AND con.ultimo_contrato = ''S''';

               IF v_array_fornecedor <> '0' THEN
                  v_sql_fornecedor := v_sql_fornecedor || ' AND con.idfor IN (' || v_array_fornecedor || ')';
               END IF;

               v_sql_fornecedor := v_sql_fornecedor || ' AND con.idfor IN
                  (SELECT idfor
                      FROM alimentos.fornecedor_unidade_atendida
                      WHERE iduni = ' || v_reg_unidade.iduni || ')
                      AND cop.qtde_remessa < cop.qtde_contratada
                      AND cop.idpro = ' || v_reg_produto.idpro;

               v_qtde_disponivel := 0;
               v_existe_estoque := 0;

               -- EXECUTA SELECT PREPARADO
               FOR v_reg_fornecedor IN EXECUTE v_sql_fornecedor LOOP

                  RAISE NOTICE '                                          ';
                  RAISE NOTICE '4º Loop Fornecedor(%)',v_reg_fornecedor.nome;

                  --
                  -- GRAVA LOG
                  --
                  UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n \n           4º Loop Fornecedor ' || TRIM(TO_CHAR(v_reg_fornecedor.idfor, '9999999999')) || '-' || v_reg_fornecedor.nome || ' Contrato: ' || v_reg_fornecedor.codigo  WHERE idlogguia = v_id_log;

                  v_existe_estoque := 1;

                  v_qtde_disponivel:=COALESCE(v_reg_fornecedor.qtde_contratada- v_reg_fornecedor.qtde_remessa,0);

                  v_percentual_forn:=(v_reg_fornecedor.qtde_contratada * 100) / v_qtde_total_contrato;

                  v_qtde_forn:=ROUND((v_qtde_necessaria * v_percentual_forn) / 100 );

                  --
                  -- Verifica quantidade de saldo a ser fornecida é < 0
                  -- Deve ser verificado por questões de arredondamento,
                  -- evitando enviar uma qtde maior que a necessária

                  v_qtde_nec_saldo_ant := v_qtde_necessaria_saldo;
                  v_qtde_necessaria_saldo:=v_qtde_necessaria_saldo - v_qtde_forn;

                  RAISE NOTICE 'Qtde disponível(%)',v_qtde_disponivel;
                  RAISE NOTICE 'Percentual(%)',v_percentual_forn;
                  RAISE NOTICE 'Qtde a fornecer(%)',v_qtde_forn;

                  --
                  -- GRAVA LOG
                  --
                  UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || '  \n           Qtde disponível: ' || TRIM(TO_CHAR(v_qtde_disponivel, '9999999999.99')) WHERE idlogguia = v_id_log;

                  UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || '  \n           Percentual: ' || TRIM(TO_CHAR(v_percentual_forn, '9999999999.9999999999')) WHERE idlogguia = v_id_log;

                  UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || '  \n           Qtde a fornecer: ' || TRIM(TO_CHAR(v_qtde_forn, '9999999999')) WHERE idlogguia = v_id_log;

                  IF v_qtde_necessaria_saldo < 0 THEN

                     v_qtde_forn := v_qtde_nec_saldo_ant;
                     RAISE NOTICE 'Qtde a fornecer ajustada(%)',v_qtde_forn;

                     --
                     -- GRAVA LOG
                     --
                     UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || '  \n           Qtde a fornecer ajustada: ' || TRIM(TO_CHAR(v_qtde_forn, '9999999999')) WHERE idlogguia = v_id_log;

                  END IF;

                  --
                  -- Qtde a ser fornecida do produto deve ser maior que zero
                  -- Qtde disponível > qtde a ser fornecida

                  IF v_qtde_forn > 0 AND v_qtde_disponivel >= v_qtde_forn THEN

                     --
                     -- Grava a Guia de Remessa para a Unidade, Forn, Produto
                     -- e Contrato
                     --
                     v_id_guia:=0;
                     -- Verifica se existe guia gravada
                     SELECT INTO v_id_guia gui.idgui
                        FROM alimentos.guia_remessa gui
                        WHERE gui.iduni = v_reg_unidade.iduni
                        AND gui.idfor = v_reg_fornecedor.idfor
                        AND gui.idcon = v_reg_fornecedor.idcon
                        AND gui.classe_produto = COALESCE (v_classe, gui.classe_produto)
                        AND gui.situacao = 'E'
                        AND gui.dt_cardapio_inicial  = v_dt_cardapio_ini
                        AND gui.dt_cardapio_final = v_dt_cardapio_fim FOR UPDATE;

                     IF v_id_guia IS NULL THEN

                        -- Obtém ID próxima guia
                        v_id_guia := nextval( 'alimentos.guia_remessa_idgui_seq'::text);

                        IF v_inscritos = 'S' THEN
                           v_num_inscr_matr := v_num_inscritos;
                        ELSE
                           v_num_inscr_matr := v_num_matriculados;
                        END IF;

                        v_classe_aux := v_classe;
                        IF v_classe IS NULL THEN
                           v_classe_aux := 'PN';
                        END IF;

                        -- Obtém o próximo sequencial anual para guia
                        SELECT INTO v_sequencial
                           COALESCE(MAX(sequencial),0) + 1
                           FROM alimentos.guia_remessa gui
                           WHERE gui.ano = TO_NUMBER(TO_CHAR(CURRENT_TIMESTAMP, 'YYYY'),'9999')
                           AND gui.idcli = v_id_cliente;

                        --
                        -- GRAVA LOG
                        --
                        UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n \n           ID Nova guia: ' || TRIM(TO_CHAR(v_id_guia, '9999999999')) || ' Sequencial: ' || TRIM(TO_CHAR(v_sequencial, '9999999999')) WHERE idlogguia = v_id_log;

                        INSERT INTO alimentos.guia_remessa
         (idgui
                           ,idcon
                           ,login_emissao
                           ,idfor
                           ,iduni
                           ,idcli
                           ,dt_emissao
                           ,ano
                           ,sequencial
                           ,dt_cardapio_inicial
                           ,dt_cardapio_final
                           ,num_inscr_matr
                           ,num_refeicao
                           ,situacao
                           ,classe_produto)
                           VALUES (v_id_guia
                           ,v_reg_fornecedor.idcon
                           ,v_login
                           ,v_reg_fornecedor.idfor
                           ,v_reg_unidade.iduni
                           ,v_id_cliente
                           ,CURRENT_TIMESTAMP
                           ,TO_NUMBER(TO_CHAR(CURRENT_TIMESTAMP,'YYYY'),'9999')
                           ,v_sequencial
                           ,v_dt_cardapio_ini
                           ,v_dt_cardapio_fim
                           ,v_num_inscr_matr
                           ,v_num_refeicao
                           ,'E'
                           ,v_classe_aux);

                        v_qtde_guia := v_qtde_guia + 1;

                     END IF;

                     v_id_guia_produto:=0;
                     -- Verifica se produto já existe na guia
                     SELECT INTO v_id_guia_produto gup.idgup
                        FROM alimentos.guia_remessa_produto gup
                            ,alimentos.guia_remessa gui
                        WHERE gui.idgui = gup.idgui
                        AND gup.idpro = v_reg_produto.idpro
                        AND TRIM(gui.login_emissao) = TRIM(v_login)
                        AND gui.idgui = v_id_guia FOR UPDATE;

                     v_peso := v_reg_produto.peso;

                     IF v_peso = 0 THEN
                        v_peso := 1;
                     END IF;

                     IF v_id_guia_produto IS NULL THEN

                        --
                        -- GRAVA LOG
                        --
                        UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n \n           *** Novo produto na guia ***   ID Guia:  ' || TRIM(TO_CHAR(v_id_guia, '9999999999')) || ' *** ' WHERE idlogguia = v_id_log;

                        -- Insere novo produto na guia
                        INSERT INTO alimentos.guia_remessa_produto (
                            idgui
                           ,idpro
                           ,qtde_per_capita
                           ,qtde_guia
                           ,peso
                           ,qtde_recebida
                           ,peso_total)
                           VALUES(v_id_guia
                           ,v_reg_produto.idpro
                           ,v_reg_produto.qtde
                           ,v_qtde_forn
                           ,v_peso
                           ,0
                           ,ROUND((v_qtde_forn*v_peso),3));

                     ELSE

                        --
                        -- GRAVA LOG
                        --
                        UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n \n           Update ID guia_produto: ' || TRIM(TO_CHAR(v_id_guia_produto, '9999999999')) || '   ID Guia: ' || TRIM(TO_CHAR(v_id_guia, '9999999999')) WHERE idlogguia = v_id_log;

                        UPDATE alimentos.guia_remessa_produto
                           SET qtde_guia = (qtde_guia + v_qtde_forn)
                           ,peso_total = ROUND(((qtde_guia + v_qtde_forn)*v_peso),3)
                           WHERE idgup = v_id_guia_produto;

                     END IF;

                     --
                     -- Grava guia_produto_diario.
                     -- Armazena a qtde a ser fornecida do produto em uma data
                     -- e unidade, ou seja, diariamente.
                     --
                     INSERT INTO alimentos.guia_produto_diario
                        (idgui
                        ,idpro
                        ,iduni
                        ,dt_guia
                        ,qtde)
                        VALUES
                        (v_id_guia
                        ,v_reg_produto.idpro
                        ,v_reg_unidade.iduni
                        ,v_dt_cardapio_ini_x
                        ,v_qtde_forn);

                     --
                     -- Diminui estoque do produto
                     --
                     UPDATE alimentos.produto
                        SET qtde_estoque = ROUND((qtde_estoque - v_qtde_forn),2)
                        WHERE idpro = v_reg_produto.idpro;

                     --
                     -- Aumenta quantidade de remessa emitida para o contrato
                     --
                     UPDATE alimentos.contrato_produto
                        SET qtde_remessa = ROUND((qtde_remessa + v_qtde_forn),2)
                        WHERE idcop = v_reg_fornecedor.idcop;

                  ELSE

                     IF v_qtde_disponivel < v_qtde_forn THEN

                        --
                        -- GRAVA LOG
                        --
                        UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n \n           *** Estoque insuficiente ***' WHERE idlogguia = v_id_log;

                        RETURN '-1 Fornecedor: ' ||  v_reg_fornecedor.nome || ' está com estoque insuficiente para o produto: ' || v_reg_produto.nome_compra || '.';

                     END IF;

                  END IF;

               END LOOP;

               --
               -- Identifica que existe contrato com fornecedor, porém
               -- contrato está com estoque zerado.
               IF v_existe_estoque = 0 THEN

                  --
                  -- GRAVA LOG
                  --
                  UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n \n      *** Estoque zerado ***' WHERE idlogguia = v_id_log;

                  RETURN '-1 Produto: ' ||  v_reg_produto.nome_compra || ' está com estoque zerado.';

               END IF;

            END IF;

         END LOOP;

      END LOOP;

      v_dt_cardapio_ini_x := v_dt_cardapio_ini_x + interval '1 day';

   END LOOP;

   IF v_existe_produto = 0 AND v_array_fornecedor <> '0' THEN

      --
      -- GRAVA LOG
      --
      UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n \n     *** Fornecedor não possui produtos para fornecer no período. ***' WHERE idlogguia = v_id_log;

      RETURN '-1 Fornecedor não possui produtos para fornecer no período. Verifique os contratos elaborados com o fornecedor.';

   ELSIF v_qtde_guia > 0 THEN

      --
      -- GRAVA LOG
      --
      UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n \n *** GUIAS GERADAS: ' ||  TRIM(TO_CHAR(v_qtde_guia, '9999999999')) || ' ***' WHERE idlogguia = v_id_log;

      RETURN 'Foram geradas ' || REPLACE(TRIM(TO_CHAR(v_qtde_guia,'9,999,999,999')),',','.') || ' guias de remessas.';

   ELSE

      --
      -- GRAVA LOG
      --
      UPDATE alimentos.log_guia_remessa SET mensagem = mensagem || ' \n \n     *** Não existem dados para gerar guias de acordo com os filtros informados. ***' WHERE idlogguia = v_id_log;

      RETURN 'Não existem dados para gerar guias de acordo com os filtros informados.';

   END IF;

END;$_$;


ALTER FUNCTION alimentos.fcn_gerar_guia_remessa(text, text, integer, integer, character varying, character varying, character varying, integer) OWNER TO postgres;

SET search_path = cadastro, pg_catalog;

--
-- Name: fcn_aft_documento(); Type: FUNCTION; Schema: cadastro; Owner: postgres
--

CREATE FUNCTION fcn_aft_documento() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
                DECLARE
                  v_idpes   numeric;
                  BEGIN
                    v_idpes := NEW.idpes;
                    EXECUTE E'DELETE FROM cadastro.documento WHERE ( (rg = \'0\' OR rg IS NULL) AND (idorg_exp_rg IS NULL) AND data_exp_rg IS NULL AND (sigla_uf_exp_rg IS NULL OR length(trim(sigla_uf_exp_rg))=0) AND (tipo_cert_civil = 0 OR tipo_cert_civil IS NULL) AND (num_termo = 0 OR num_termo IS NULL) AND (num_livro = \'0\' OR num_livro IS NULL) AND (num_livro = \'0\' OR num_livro IS NULL) AND (num_folha = 0 OR num_folha IS NULL) AND data_emissao_cert_civil IS NULL AND (sigla_uf_cert_civil IS NULL OR length(trim(sigla_uf_cert_civil))=0) AND (sigla_uf_cart_trabalho IS NULL OR length(trim(sigla_uf_cart_trabalho))=0) AND (cartorio_cert_civil IS NULL OR length(trim(cartorio_cert_civil))=0) AND (num_cart_trabalho = 0 OR num_cart_trabalho IS NULL) AND (serie_cart_trabalho = 0 OR serie_cart_trabalho IS NULL) AND data_emissao_cart_trabalho IS NULL AND (num_tit_eleitor = 0 OR num_tit_eleitor IS NULL) AND (zona_tit_eleitor = 0 OR zona_tit_eleitor IS NULL) AND (secao_tit_eleitor = 0 OR secao_tit_eleitor IS NULL) ) AND idpes='||quote_literal(v_idpes)||' AND certidao_nascimento is null';
                  RETURN NEW;
                END; $$;


ALTER FUNCTION cadastro.fcn_aft_documento() OWNER TO postgres;

--
-- Name: fcn_aft_documento_provisorio(); Type: FUNCTION; Schema: cadastro; Owner: postgres
--

CREATE FUNCTION fcn_aft_documento_provisorio() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
  DECLARE
    v_idpes       numeric;
    v_rg        text;
    v_uf_expedicao      text;
    v_verificacao_provisorio  numeric;

    v_comando     text;
    v_registro      record;

    BEGIN
      v_idpes     := NEW.idpes;
      v_rg      := COALESCE(NEW.rg, '-1');
      v_uf_expedicao    := TRIM(COALESCE(NEW.sigla_uf_exp_rg, ''));

      v_verificacao_provisorio:= 0;

      -- verificar se a situação do cadastro da pessoa é provisório
      FOR v_registro IN SELECT situacao FROM cadastro.pessoa WHERE idpes=v_idpes LOOP
        IF v_registro.situacao = 'P' THEN
          v_verificacao_provisorio := 1;
        END IF;
      END LOOP;

      -- Verificação para atualizar ou não a situação do cadastro da pessoa para Ativo
      IF LENGTH(v_uf_expedicao) > 0 AND v_rg != '' AND v_rg != '-1' AND v_verificacao_provisorio = 1 THEN
        EXECUTE 'UPDATE cadastro.pessoa SET situacao='||quote_literal('A')||'WHERE idpes='||quote_literal(v_idpes)||';';
      END IF;
    RETURN NEW;
  END; $$;


ALTER FUNCTION cadastro.fcn_aft_documento_provisorio() OWNER TO postgres;

--
-- Name: fcn_aft_fisica(); Type: FUNCTION; Schema: cadastro; Owner: postgres
--

CREATE FUNCTION fcn_aft_fisica() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
  v_idpes       numeric;
  v_idpes_mae     numeric;
  v_idpes_pai     numeric;
  v_idpes_responsavel   numeric;
  v_idpes_conjuge     numeric;

  v_nome_mae      text;
  v_nome_pai      text;
  v_nome_responsavel    text;
  v_nome_conjuge      text;

  v_verificacao_mae   numeric;
  v_verificacao_pai   numeric;
  v_verificacao_conjuge   numeric;
  v_verificacao_responsavel numeric;

  v_num_aviso_mae     numeric;
  v_num_aviso_pai     numeric;
  v_num_aviso_conjuge   numeric;
  v_num_aviso_responsavel   numeric;

  v_existe_aviso_mae    numeric;
  v_existe_aviso_pai    numeric;
  v_existe_aviso_conjuge    numeric;
  v_existe_aviso_responsavel  numeric;

  v_comando     text;
  v_registro      record;

  BEGIN
    v_idpes     := NEW.idpes;
    v_idpes_mae   := NEW.idpes_mae;
    v_idpes_pai   := NEW.idpes_pai;
    v_idpes_responsavel := NEW.idpes_responsavel;
    v_idpes_conjuge   := NEW.idpes_con;
    v_nome_mae    := TRIM(NEW.nome_mae);
    v_nome_pai    := TRIM(NEW.nome_pai);
    v_nome_responsavel  := TRIM(NEW.nome_responsavel);
    v_nome_conjuge    := TRIM(NEW.nome_conjuge);

    v_num_aviso_mae   := 1;
    v_num_aviso_pai   := 2;
    v_num_aviso_conjuge := 3;
    v_num_aviso_responsavel := 4;

    v_verificacao_mae   := 0;
    v_verificacao_pai   := 0;
    v_verificacao_conjuge   := 0;
    v_verificacao_responsavel := 0;

    v_existe_aviso_mae    := 0;
    v_existe_aviso_pai    := 0;
    v_existe_aviso_conjuge    := 0;
    v_existe_aviso_responsavel  := 0;

    -- obter os avisos já existentes para a pessoa
    FOR v_registro IN SELECT aviso FROM cadastro.aviso_nome WHERE idpes=v_idpes LOOP
      IF v_registro.aviso = 1 THEN
        v_existe_aviso_mae := 1;
      ELSIF v_registro.aviso = 2 THEN
        v_existe_aviso_pai := 1;
      ELSIF v_registro.aviso = 3 THEN
        v_existe_aviso_conjuge := 1;
      ELSIF v_registro.aviso = 4 THEN
        v_existe_aviso_responsavel := 1;
      END IF;
    END LOOP;

    -- MAE
    IF v_idpes_mae > 0 AND v_idpes_mae IS NOT NULL AND LENGTH(v_nome_mae) > 0 AND v_nome_mae IS NOT NULL THEN
      FOR v_registro IN SELECT * from public.fcn_compara_nome_pessoa_fonetica(v_nome_mae, v_idpes_mae) LOOP
        v_verificacao_mae := v_registro.fcn_compara_nome_pessoa_fonetica;
      END LOOP;
    ELSE
      v_verificacao_mae := 1;
    END IF;

    -- PAI
    IF v_idpes_pai > 0 AND v_idpes_pai IS NOT NULL AND LENGTH(v_nome_pai) > 0 AND v_nome_pai IS NOT NULL THEN
      FOR v_registro IN SELECT * from public.fcn_compara_nome_pessoa_fonetica(v_nome_pai, v_idpes_pai) LOOP
        v_verificacao_pai := v_registro.fcn_compara_nome_pessoa_fonetica;
      END LOOP;
    ELSE
      v_verificacao_pai := 1;
    END IF;

    -- CONJUGE
    IF v_idpes_conjuge > 0 AND v_idpes_conjuge IS NOT NULL AND LENGTH(v_nome_conjuge) > 0 AND v_nome_conjuge IS NOT NULL THEN
      FOR v_registro IN SELECT * from public.fcn_compara_nome_pessoa_fonetica(v_nome_conjuge, v_idpes_conjuge) LOOP
        v_verificacao_conjuge := v_registro.fcn_compara_nome_pessoa_fonetica;
      END LOOP;
    ELSE
      v_verificacao_conjuge := 1;
    END IF;

    -- RESPONSAVEL
    IF v_idpes_responsavel > 0 AND v_idpes_responsavel IS NOT NULL AND LENGTH(v_nome_responsavel) > 0 AND v_nome_responsavel IS NOT NULL THEN
      FOR v_registro IN SELECT * from public.fcn_compara_nome_pessoa_fonetica(v_nome_responsavel, v_idpes_responsavel) LOOP
        v_verificacao_responsavel := v_registro.fcn_compara_nome_pessoa_fonetica;
      END LOOP;
    ELSE
      v_verificacao_responsavel := 1;
    END IF;
    -- Inserir ou Deletar aviso da MAE
    IF v_verificacao_mae = 0 AND v_existe_aviso_mae = 0 THEN
      EXECUTE 'INSERT INTO cadastro.aviso_nome (idpes, aviso) VALUES ('||quote_literal(v_idpes)||','||v_num_aviso_mae||');';
    ELSIF v_verificacao_mae = 1 AND v_existe_aviso_mae = 1 THEN
      EXECUTE 'DELETE FROM cadastro.aviso_nome WHERE idpes='||quote_literal(v_idpes)||' AND aviso='||v_num_aviso_mae||';';
    END IF;

    -- Inserir ou Deletar aviso do PAI
    IF v_verificacao_pai = 0 AND v_existe_aviso_pai = 0 THEN
      EXECUTE 'INSERT INTO cadastro.aviso_nome (idpes, aviso) VALUES ('||quote_literal(v_idpes)||','||v_num_aviso_pai||');';
    ELSIF v_verificacao_pai = 1 AND v_existe_aviso_pai = 1 THEN
      EXECUTE 'DELETE FROM cadastro.aviso_nome WHERE idpes='||quote_literal(v_idpes)||' AND aviso='||v_num_aviso_pai||';';
    END IF;

    -- Inserir ou Deletar aviso do CONJUGE
    IF v_verificacao_conjuge = 0 AND v_existe_aviso_conjuge = 0 THEN
      EXECUTE 'INSERT INTO cadastro.aviso_nome (idpes, aviso) VALUES ('||quote_literal(v_idpes)||','||v_num_aviso_conjuge||');';
    ELSIF v_verificacao_conjuge = 1 AND v_existe_aviso_conjuge = 1 THEN
      EXECUTE 'DELETE FROM cadastro.aviso_nome WHERE idpes='||quote_literal(v_idpes)||' AND aviso='||v_num_aviso_conjuge||';';
    END IF;

    -- Inserir ou Deletar aviso do RESPONSAVEL
    IF v_verificacao_responsavel = 0 AND v_existe_aviso_responsavel = 0 THEN
      EXECUTE 'INSERT INTO cadastro.aviso_nome (idpes, aviso) VALUES ('||quote_literal(v_idpes)||','||v_num_aviso_responsavel||');';
    ELSIF v_verificacao_responsavel = 1 AND v_existe_aviso_responsavel = 1 THEN
      EXECUTE 'DELETE FROM cadastro.aviso_nome WHERE idpes='||quote_literal(v_idpes)||' AND aviso='||v_num_aviso_responsavel||';';
    END IF;
  RETURN NEW;
END; $$;


ALTER FUNCTION cadastro.fcn_aft_fisica() OWNER TO postgres;

--
-- Name: fcn_aft_fisica_cpf_provisorio(); Type: FUNCTION; Schema: cadastro; Owner: postgres
--

CREATE FUNCTION fcn_aft_fisica_cpf_provisorio() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
  v_idpes       numeric;
  v_cpf       numeric;
  v_verificacao_provisorio  numeric;

  v_comando     text;
  v_registro      record;

  BEGIN
    v_idpes     := NEW.idpes;
    v_cpf     := COALESCE(NEW.cpf, -1);

    v_verificacao_provisorio:= 0;

    -- verificar se a situação do cadastro da pessoa é provisório
    FOR v_registro IN SELECT situacao FROM cadastro.pessoa WHERE idpes=v_idpes LOOP
      IF v_registro.situacao = 'P' THEN
        v_verificacao_provisorio := 1;
      END IF;
    END LOOP;

    -- Verificação para atualizar ou não a situação do cadastro da pessoa para Ativo
    IF v_cpf > 0 AND v_verificacao_provisorio = 1 THEN
      EXECUTE 'UPDATE cadastro.pessoa SET situacao='||quote_literal('A')||'WHERE idpes='||quote_literal(v_idpes)||';';
    END IF;
  RETURN NEW;
END; $$;


ALTER FUNCTION cadastro.fcn_aft_fisica_cpf_provisorio() OWNER TO postgres;

--
-- Name: fcn_aft_fisica_provisorio(); Type: FUNCTION; Schema: cadastro; Owner: postgres
--

CREATE FUNCTION fcn_aft_fisica_provisorio() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
  v_idpes       numeric;
  v_idpes_mae     numeric;
  v_nome_mae      text;
  v_data_nascimento   text;
  v_verificacao_provisorio  numeric;

  v_comando     text;
  v_registro      record;

  BEGIN
    v_idpes     := NEW.idpes;
    v_idpes_mae   := COALESCE(NEW.idpes_mae, -1);
    v_nome_mae    := TRIM(COALESCE(NEW.nome_mae, ''));
    v_data_nascimento := COALESCE(TO_CHAR(NEW.data_nasc, 'DD/MM/YYYY'), '');

    v_verificacao_provisorio:= 0;

    -- verificar se a situação do cadastro da pessoa é provisório
    FOR v_registro IN SELECT situacao FROM cadastro.pessoa WHERE idpes=v_idpes LOOP
      IF v_registro.situacao = 'P' THEN
        v_verificacao_provisorio := 1;
      END IF;
    END LOOP;

    -- Verificação para atualizar ou não a situação do cadastro da pessoa para Ativo
    IF v_data_nascimento <> '' AND (LENGTH(v_nome_mae) > 0 OR v_idpes_mae > 0) AND v_verificacao_provisorio = 1 THEN
      EXECUTE 'UPDATE cadastro.pessoa SET situacao='||quote_literal('A')||'WHERE idpes='||quote_literal(v_idpes)||';';
    END IF;
  RETURN NEW;
END; $$;


ALTER FUNCTION cadastro.fcn_aft_fisica_provisorio() OWNER TO postgres;

--
-- Name: fcn_aft_ins_endereco_externo(); Type: FUNCTION; Schema: cadastro; Owner: postgres
--

CREATE FUNCTION fcn_aft_ins_endereco_externo() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
  v_idpes   numeric;
  v_tipo_endereco text;
  BEGIN
    v_idpes   := NEW.idpes;
    v_tipo_endereco := NEW.tipo;
    EXECUTE 'DELETE FROM cadastro.endereco_pessoa WHERE idpes='||quote_literal(v_idpes)||' AND tipo='||v_tipo_endereco||';';
  RETURN NEW;
END; $$;


ALTER FUNCTION cadastro.fcn_aft_ins_endereco_externo() OWNER TO postgres;

--
-- Name: fcn_aft_ins_endereco_pessoa(); Type: FUNCTION; Schema: cadastro; Owner: postgres
--

CREATE FUNCTION fcn_aft_ins_endereco_pessoa() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
  v_idpes   numeric;
  v_tipo_endereco text;
  BEGIN
    v_idpes   := NEW.idpes;
    v_tipo_endereco := NEW.tipo;
    EXECUTE 'DELETE FROM cadastro.endereco_externo WHERE idpes='||quote_literal(v_idpes)||' AND tipo='||v_tipo_endereco||';';
  RETURN NEW;
END; $$;


ALTER FUNCTION cadastro.fcn_aft_ins_endereco_pessoa() OWNER TO postgres;

SET search_path = consistenciacao, pg_catalog;

--
-- Name: fcn_delete_temp_cadastro_unificacao_cmf(integer); Type: FUNCTION; Schema: consistenciacao; Owner: postgres
--

CREATE FUNCTION fcn_delete_temp_cadastro_unificacao_cmf(integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parametro recebidos
  v_idpes ALIAS for $1;
BEGIN
  -- Deleta dados da tabela temp_cadastro_unificacao_cmf
  DELETE FROM consistenciacao.temp_cadastro_unificacao_cmf WHERE idpes = v_idpes;
  RETURN 0;
END;$_$;


ALTER FUNCTION consistenciacao.fcn_delete_temp_cadastro_unificacao_cmf(integer) OWNER TO postgres;

--
-- Name: fcn_delete_temp_cadastro_unificacao_siam(integer); Type: FUNCTION; Schema: consistenciacao; Owner: postgres
--

CREATE FUNCTION fcn_delete_temp_cadastro_unificacao_siam(integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parametro recebidos
  v_idpes ALIAS for $1;
BEGIN
  -- Deleta dados da tabela temp_cadastro_unificacao_siam
  DELETE FROM consistenciacao.temp_cadastro_unificacao_siam WHERE idpes = v_idpes;
  RETURN 0;
END;$_$;


ALTER FUNCTION consistenciacao.fcn_delete_temp_cadastro_unificacao_siam(integer) OWNER TO postgres;

--
-- Name: fcn_documento_historico_campo(); Type: FUNCTION; Schema: consistenciacao; Owner: postgres
--

CREATE FUNCTION fcn_documento_historico_campo() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
                        DECLARE
                          v_idpes         numeric;

                          v_data_expedicao_rg_nova    date;
                          v_data_expedicao_rg_antiga    date;
                          v_data_emissao_cert_civil_nova    date;
                          v_data_emissao_cert_civil_antiga  date;
                          v_data_emissao_cart_trabalho_nova date;
                          v_data_emissao_cart_trabalho_antiga date;
                          v_orgao_expedicao_rg_novo   numeric;
                          v_orgao_expedicao_rg_antigo   numeric;
                          v_numero_rg_novo      text;
                          v_numero_rg_antigo      text;
                          v_numero_titulo_eleitor_novo    numeric;
                          v_numero_titulo_eleitor_antigo    numeric;
                          v_numero_zona_titulo_novo   numeric;
                          v_numero_zona_titulo_antigo   numeric;
                          v_numero_secao_titulo_novo    numeric;
                          v_numero_secao_titulo_antigo    numeric;
                          v_numero_cart_trabalho_novo   numeric;
                          v_numero_cart_trabalho_antigo   numeric;
                          v_numero_serie_cart_trabalho_novo numeric;
                          v_numero_serie_cart_trabalho_antigo numeric;
                          v_tipo_certidao_civil_novo    numeric;
                          v_tipo_certidao_civil_antigo    numeric;
                          v_numero_termo_certidao_civil_novo  numeric;
                          v_numero_termo_certidao_civil_antigo  numeric;
                          v_numero_livro_certidao_civil_novo  varchar;
                          v_numero_livro_certidao_civil_antigo  varchar;
                          v_numero_folha_certidao_civil_novo  numeric;
                          v_numero_folha_certidao_civil_antigo  numeric;
                          v_cartorio_certidao_civil_novo    text;
                          v_cartorio_certidao_civil_antigo  text;
                          v_uf_expedicao_rg_novo      text;
                          v_uf_expedicao_rg_antigo    text;
                          v_uf_emissao_certidao_civil_novo  text;
                          v_uf_emissao_certidao_civil_antigo  text;
                          v_uf_emissao_carteira_trabalho_novo text;
                          v_uf_emissao_carteira_trabalho_antigo text;

                          v_comando     text;
                          v_origem_gravacao   text;

                          v_credibilidade_maxima    numeric;
                          v_credibilidade_alta    numeric;
                          v_sem_credibilidade   numeric;

                          v_nova_credibilidade    numeric;

                          v_registro      record;
                          v_aux_data_nova     text;
                          v_aux_data_antiga   text;

                          -- ID dos campos
                          v_idcam_numero_rg     numeric;
                          v_idcam_orgao_expedidor_rg    numeric;
                          v_idcam_data_expedicao_rg   numeric;
                          v_idcam_uf_expedicao_rg     numeric;
                          v_idcam_tipo_certidao_civil   numeric;
                          v_idcam_numero_termo_certidao_civil numeric;
                          v_idcam_numero_livro_certidao_civil numeric;
                          v_idcam_numero_folha_certidao_civil numeric;
                          v_idcam_data_emissao_certidao_civil numeric;
                          v_idcam_cartorio_certidao_civil        numeric;
                          v_idcam_uf_emissao_certidao_civil numeric;
                          v_idcam_numero_carteira_trabalho  numeric;
                          v_idcam_numero_serie_carteira_trabalho  numeric;
                          v_idcam_data_emissao_carteira_trabalho  numeric;
                          v_idcam_uf_emissao_carteira_trabalho  numeric;
                          v_idcam_numero_titulo_eleitor   numeric;
                          v_idcam_numero_zona_titulo_eleitor  numeric;
                          v_idcam_numero_secao_titulo_eleitor numeric;

                          /*
                          consistenciacao.historico_campo.credibilidade: 1 = Maxima, 2 = Alta, 3 = Media, 4 = Baixa, 5 = Sem credibilidade
                          cadastro.pessoa.origem_gravacao: M = Migracao, U = Usuario, C = Rotina de confrontacao, O = Oscar
                          */
                          BEGIN
                            v_idpes         := NEW.idpes;

                            v_data_expedicao_rg_nova    := NEW.data_exp_rg;
                            v_data_emissao_cert_civil_nova    := NEW.data_emissao_cert_civil;
                            v_data_emissao_cart_trabalho_nova := NEW.data_emissao_cart_trabalho;
                            v_orgao_expedicao_rg_novo   := NEW.idorg_exp_rg;
                            v_numero_rg_novo      := NEW.rg;
                            v_numero_titulo_eleitor_novo    := NEW.num_tit_eleitor;
                            v_numero_zona_titulo_novo   := NEW.zona_tit_eleitor;
                            v_numero_secao_titulo_novo    := NEW.secao_tit_eleitor;
                            v_numero_cart_trabalho_novo   := NEW.num_cart_trabalho;
                            v_numero_serie_cart_trabalho_novo := NEW.serie_cart_trabalho;
                            v_tipo_certidao_civil_novo    := NEW.tipo_cert_civil;
                            v_numero_termo_certidao_civil_novo  := NEW.num_termo;
                            v_numero_livro_certidao_civil_novo  := NEW.num_livro;
                            v_numero_folha_certidao_civil_novo  := NEW.num_folha;
                            v_cartorio_certidao_civil_novo    := NEW.cartorio_cert_civil;
                            v_uf_expedicao_rg_novo      := NEW.sigla_uf_exp_rg;
                            v_uf_emissao_certidao_civil_novo  := NEW.sigla_uf_cert_civil;
                            v_uf_emissao_carteira_trabalho_novo := NEW.sigla_uf_cart_trabalho;

                            IF TG_OP <> 'UPDATE' THEN
                              v_data_expedicao_rg_antiga    := NULL;
                              v_data_emissao_cert_civil_antiga  := NULL;
                              v_data_emissao_cart_trabalho_antiga := NULL;
                              v_orgao_expedicao_rg_antigo   := 0;
                              v_numero_rg_antigo      := '';
                              v_numero_titulo_eleitor_antigo    := 0;
                              v_numero_zona_titulo_antigo   := 0;
                              v_numero_secao_titulo_antigo    := 0;
                              v_numero_cart_trabalho_antigo   := 0;
                              v_numero_serie_cart_trabalho_antigo := 0;
                              v_tipo_certidao_civil_antigo    := 0;
                              v_numero_termo_certidao_civil_antigo  := 0;
                              v_numero_livro_certidao_civil_antigo  := '';
                              v_numero_folha_certidao_civil_antigo  := 0;
                              v_cartorio_certidao_civil_antigo  := '';
                              v_uf_expedicao_rg_antigo    := '';
                              v_uf_emissao_certidao_civil_antigo  := '';
                              v_uf_emissao_carteira_trabalho_antigo := '';
                            ELSE
                              v_data_expedicao_rg_antiga    := OLD.data_exp_rg;
                              v_data_emissao_cert_civil_antiga  := OLD.data_emissao_cert_civil;
                              v_data_emissao_cart_trabalho_antiga := OLD.data_emissao_cart_trabalho;
                              v_orgao_expedicao_rg_antigo   := COALESCE(OLD.idorg_exp_rg, 0);
                              v_numero_rg_antigo      := COALESCE(OLD.rg, '');
                              v_numero_titulo_eleitor_antigo    := COALESCE(OLD.num_tit_eleitor, 0);
                              v_numero_zona_titulo_antigo   := COALESCE(OLD.zona_tit_eleitor, 0);
                              v_numero_secao_titulo_antigo    := COALESCE(OLD.secao_tit_eleitor, 0);
                              v_numero_cart_trabalho_antigo   := COALESCE(OLD.num_cart_trabalho, 0);
                              v_numero_serie_cart_trabalho_antigo := COALESCE(OLD.serie_cart_trabalho, 0);
                              v_tipo_certidao_civil_antigo    := COALESCE(OLD.tipo_cert_civil, 0);
                              v_numero_termo_certidao_civil_antigo  := COALESCE(OLD.num_termo, 0);
                              v_numero_livro_certidao_civil_antigo  := OLD.num_livro;
                              v_numero_folha_certidao_civil_antigo  := COALESCE(OLD.num_folha, 0);
                              v_cartorio_certidao_civil_antigo  := COALESCE(OLD.cartorio_cert_civil, '');
                              v_uf_expedicao_rg_antigo    := COALESCE(OLD.sigla_uf_exp_rg, '');
                              v_uf_emissao_certidao_civil_antigo  := COALESCE(OLD.sigla_uf_cert_civil, '');
                              v_uf_emissao_carteira_trabalho_antigo := COALESCE(OLD.sigla_uf_cart_trabalho, '');
                            END IF;

                            v_idcam_numero_rg     := 6;
                            v_idcam_orgao_expedidor_rg    := 7;
                            v_idcam_data_expedicao_rg   := 8;
                            v_idcam_uf_expedicao_rg     := 9;
                            v_idcam_tipo_certidao_civil   := 10;
                            v_idcam_numero_termo_certidao_civil := 11;
                            v_idcam_numero_livro_certidao_civil := 12;
                            v_idcam_numero_folha_certidao_civil := 13;
                            v_idcam_data_emissao_certidao_civil := 14;
                            v_idcam_cartorio_certidao_civil   := 15;
                            v_idcam_uf_emissao_certidao_civil := 16;
                            v_idcam_numero_carteira_trabalho  := 17;
                            v_idcam_numero_serie_carteira_trabalho  := 18;
                            v_idcam_data_emissao_carteira_trabalho  := 19;
                            v_idcam_uf_emissao_carteira_trabalho  := 20;
                            v_idcam_numero_titulo_eleitor   := 21;
                            v_idcam_numero_zona_titulo_eleitor  := 22;
                            v_idcam_numero_secao_titulo_eleitor := 23;

                            v_nova_credibilidade := 0;
                            v_credibilidade_maxima := 1;
                            v_credibilidade_alta := 2;
                            v_sem_credibilidade := 5;
                            v_comando := 'SELECT origem_gravacao FROM cadastro.pessoa WHERE idpes='||quote_literal(v_idpes)||';';

                            FOR v_registro IN EXECUTE v_comando LOOP
                              v_origem_gravacao := v_registro.origem_gravacao;
                            END LOOP;

                            IF v_origem_gravacao = 'U' OR v_origem_gravacao = 'O' THEN -- os dados foram editados pelo usuario ou pelo usuario do Oscar
                              v_nova_credibilidade := v_credibilidade_maxima;
                            ELSIF v_origem_gravacao = 'M' THEN -- os dados foram originados por migracao
                              v_nova_credibilidade := v_credibilidade_alta;
                            END IF;

                            IF v_nova_credibilidade > 0 THEN

                              -- DATA DE EXPEDICAO DO RG
                              v_aux_data_nova := COALESCE(TO_CHAR (v_data_expedicao_rg_nova, 'DD/MM/YYYY'), '');
                              v_aux_data_antiga := COALESCE(TO_CHAR (v_data_expedicao_rg_antiga, 'DD/MM/YYYY'), '');

                              IF v_aux_data_nova <> v_aux_data_antiga THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_expedicao_rg||','||v_nova_credibilidade||');';
                              END IF;

                              -- DATA DE EMISSAO CERTIDAO CIVIL
                              v_aux_data_nova := COALESCE(TO_CHAR (v_data_emissao_cert_civil_nova, 'DD/MM/YYYY'), '');
                              v_aux_data_antiga := COALESCE(TO_CHAR (v_data_emissao_cert_civil_antiga, 'DD/MM/YYYY'), '');

                              IF v_aux_data_nova <> v_aux_data_antiga THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_emissao_certidao_civil||','||v_nova_credibilidade||');';
                              END IF;

                              -- DATA DE EMISSAO CARTEIRA DE TRABALHO
                              v_aux_data_nova := COALESCE(TO_CHAR (v_data_emissao_cart_trabalho_nova, 'DD/MM/YYYY'), '');
                              v_aux_data_antiga := COALESCE(TO_CHAR (v_data_emissao_cart_trabalho_antiga, 'DD/MM/YYYY'), '');

                              IF v_aux_data_nova <> v_aux_data_antiga THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_emissao_carteira_trabalho||','||v_nova_credibilidade||');';
                              END IF;

                              -- ORGAO EXPEDIDOR DO RG
                              IF v_orgao_expedicao_rg_novo <> v_orgao_expedicao_rg_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_orgao_expedidor_rg||','||v_nova_credibilidade||');';
                              END IF;

                              -- RG
                              IF v_numero_rg_novo <> v_numero_rg_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_rg||','||v_nova_credibilidade||');';
                              END IF;

                              -- TITULO ELEITOR
                              IF v_numero_titulo_eleitor_novo <> v_numero_titulo_eleitor_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_titulo_eleitor||','||v_nova_credibilidade||');';
                              END IF;

                              -- ZONA TITULO ELEITOR
                              IF v_numero_zona_titulo_novo <> v_numero_zona_titulo_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_zona_titulo_eleitor||','||v_nova_credibilidade||');';
                              END IF;

                              -- SECAO TITULO ELEITOR
                              IF v_numero_secao_titulo_novo <> v_numero_secao_titulo_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_secao_titulo_eleitor||','||v_nova_credibilidade||');';
                              END IF;

                              -- CARTEIRA DE TRABALHO
                              IF v_numero_cart_trabalho_novo <> v_numero_cart_trabalho_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_carteira_trabalho||','||v_nova_credibilidade||');';
                              END IF;

                              -- SERIE CARTEIRA DE TRABALHO
                              IF v_numero_serie_cart_trabalho_novo <> v_numero_serie_cart_trabalho_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_serie_carteira_trabalho||','||v_nova_credibilidade||');';
                              END IF;

                              -- TIPO CERTIDAO CIVIL
                              IF v_tipo_certidao_civil_novo <> v_tipo_certidao_civil_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_tipo_certidao_civil||','||v_nova_credibilidade||');';
                              END IF;

                              -- NUMERO TERMO CERTIDAO CIVIL
                              IF v_numero_termo_certidao_civil_novo <> v_numero_termo_certidao_civil_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_termo_certidao_civil||','||v_nova_credibilidade||');';
                              END IF;

                              -- NUMERO LIVRO CERTIDAO CIVIL
                              IF v_numero_livro_certidao_civil_novo <> v_numero_livro_certidao_civil_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_livro_certidao_civil||','||v_nova_credibilidade||');';
                              END IF;

                              -- NUMERO FOLHA CERTIDAO CIVIL
                              IF v_numero_folha_certidao_civil_novo <> v_numero_folha_certidao_civil_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_folha_certidao_civil||','||v_nova_credibilidade||');';
                              END IF;

                              -- CARTORIO CERTIDAO CIVIL
                              IF v_cartorio_certidao_civil_novo <> v_cartorio_certidao_civil_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_cartorio_certidao_civil||','||v_nova_credibilidade||');';
                              END IF;

                              -- UF EXPEDICAO RG
                              IF v_uf_expedicao_rg_novo <> v_uf_expedicao_rg_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_uf_expedicao_rg||','||v_nova_credibilidade||');';
                              END IF;

                              -- UF EMISSAO CERTIDAO CIVIL
                              IF v_uf_emissao_certidao_civil_novo <> v_uf_emissao_certidao_civil_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_uf_emissao_certidao_civil||','||v_nova_credibilidade||');';
                              END IF;

                              -- UF EMISSAO CARTEIRA DE TRABALHO
                              IF v_uf_emissao_carteira_trabalho_novo <> v_uf_emissao_carteira_trabalho_antigo THEN
                                EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_uf_emissao_carteira_trabalho||','||v_nova_credibilidade||');';
                              END IF;

                            END IF;
                            -- Verificar os campos Vazios ou Nulos
                            -- DATA DE EXPEDICAO DO RG
                            IF TRIM(v_data_expedicao_rg_nova::varchar)='' OR v_data_expedicao_rg_nova IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_expedicao_rg||','||v_sem_credibilidade||');';
                            END IF;
                            -- DATA DE EMISSAO CERTIDAO CIVIL
                            IF TRIM(v_data_emissao_cert_civil_nova::varchar)='' OR v_data_emissao_cert_civil_nova IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_emissao_certidao_civil||','||v_sem_credibilidade||');';
                            END IF;
                            -- DATA DE EMISSAO CARTEIRA DE TRABALHO
                            IF TRIM(v_data_emissao_cart_trabalho_nova::varchar)='' OR v_data_emissao_cart_trabalho_nova IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_emissao_carteira_trabalho||','||v_sem_credibilidade||');';
                            END IF;
                            -- ORGAO EXPEDIDOR DO RG
                            IF v_orgao_expedicao_rg_novo <= 0 OR v_orgao_expedicao_rg_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_orgao_expedidor_rg||','||v_sem_credibilidade||');';
                            END IF;
                            -- RG
                            IF v_numero_rg_novo = '' OR v_numero_rg_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_rg||','||v_sem_credibilidade||');';
                            END IF;
                            -- TITULO ELEITOR
                            IF v_numero_titulo_eleitor_novo <= 0 OR v_numero_titulo_eleitor_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_titulo_eleitor||','||v_sem_credibilidade||');';
                            END IF;
                            -- ZONA TITULO ELEITOR
                            IF v_numero_zona_titulo_novo <= 0 OR v_numero_zona_titulo_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_zona_titulo_eleitor||','||v_sem_credibilidade||');';
                            END IF;
                            -- SECAO TITULO ELEITOR
                            IF v_numero_secao_titulo_novo <= 0 OR v_numero_secao_titulo_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_secao_titulo_eleitor||','||v_sem_credibilidade||');';
                            END IF;
                            -- CARTEIRA DE TRABALHO
                            IF v_numero_cart_trabalho_novo <= 0 OR v_numero_cart_trabalho_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_carteira_trabalho||','||v_sem_credibilidade||');';
                            END IF;
                            -- SERIE CARTEIRA DE TRABALHO
                            IF v_numero_serie_cart_trabalho_novo <= 0 OR v_numero_serie_cart_trabalho_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_serie_carteira_trabalho||','||v_sem_credibilidade||');';
                            END IF;
                            -- TIPO CERTIDAO CIVIL
                            IF v_tipo_certidao_civil_novo <= 0 OR v_tipo_certidao_civil_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_tipo_certidao_civil||','||v_sem_credibilidade||');';
                            END IF;
                            -- NUMERO TERMO CERTIDAO CIVIL
                            IF v_numero_termo_certidao_civil_novo <= 0 OR v_numero_termo_certidao_civil_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_termo_certidao_civil||','||v_sem_credibilidade||');';
                            END IF;
                            -- NUMERO LIVRO CERTIDAO CIVIL
                            IF v_numero_livro_certidao_civil_novo = '' OR v_numero_livro_certidao_civil_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_livro_certidao_civil||','||v_sem_credibilidade||');';
                            END IF;
                            -- NUMERO FOLHA CERTIDAO CIVIL
                            IF v_numero_folha_certidao_civil_novo <= 0 OR v_numero_folha_certidao_civil_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero_folha_certidao_civil||','||v_sem_credibilidade||');';
                            END IF;
                            -- CARTORIO CERTIDAO CIVIL
                            IF TRIM(v_cartorio_certidao_civil_novo)='' OR v_cartorio_certidao_civil_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_cartorio_certidao_civil||','||v_sem_credibilidade||');';
                            END IF;
                            -- UF EXPEDICAO RG
                            IF TRIM(v_uf_expedicao_rg_novo)='' OR v_uf_expedicao_rg_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_uf_expedicao_rg||','||v_sem_credibilidade||');';
                            END IF;
                            -- UF EMISSAO CERTIDAO CIVIL
                            IF TRIM(v_uf_emissao_certidao_civil_novo)='' OR v_uf_emissao_certidao_civil_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_uf_emissao_certidao_civil||','||v_sem_credibilidade||');';
                            END IF;
                            -- UF EMISSAO CARTEIRA DE TRABALHO
                            IF TRIM(v_uf_emissao_carteira_trabalho_novo)='' OR v_uf_emissao_carteira_trabalho_novo IS NULL THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_uf_emissao_carteira_trabalho||','||v_sem_credibilidade||');';
                            END IF;

                          RETURN NEW;
                        END;$$;


ALTER FUNCTION consistenciacao.fcn_documento_historico_campo() OWNER TO postgres;

--
-- Name: fcn_endereco_externo_historico_campo(); Type: FUNCTION; Schema: consistenciacao; Owner: postgres
--

CREATE FUNCTION fcn_endereco_externo_historico_campo() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
  v_idpes       numeric;

  v_sigla_uf_antiga   text;
  v_sigla_uf_nova     text;
  v_id_tipo_logradouro_antigo text;
  v_id_tipo_logradouro_novo text;
  v_logradouro_antigo   text;
  v_logradouro_novo   text;
  v_numero_antigo     numeric;
  v_numero_novo     numeric;
  v_letra_antiga      text;
  v_letra_nova      text;
  v_complemento_antigo    text;
  v_complemento_novo    text;
  v_bairro_antigo     text;
  v_bairro_novo     text;
  v_cep_antigo      numeric;
  v_cep_novo      numeric;
  v_cidade_antiga     text;
  v_cidade_nova     text;

  v_tipo_endereco     numeric;

  v_comando     text;
  v_origem_gravacao   text;

  v_credibilidade_maxima    numeric;
  v_credibilidade_alta    numeric;
  v_sem_credibilidade   numeric;

  v_nova_credibilidade    numeric;

  v_registro      record;

  -- ID dos campos
  v_idcam_sigla_uf_correspondencia    numeric;
  v_idcam_id_tipo_logradouro_correspondencia  numeric;
  v_idcam_logradouro_correspondencia    numeric;
  v_idcam_numero_correspondencia      numeric;
  v_idcam_letra_correspondencia     numeric;
  v_idcam_complemento_correspondencia   numeric;
  v_idcam_bairro_correspondencia      numeric;
  v_idcam_cep_correspondencia     numeric;
  v_idcam_cidade_correspondencia      numeric;

  v_idcam_sigla_uf_residencial      numeric;
  v_idcam_id_tipo_logradouro_residencial    numeric;
  v_idcam_logradouro_residencial      numeric;
  v_idcam_numero_residencial      numeric;
  v_idcam_letra_residencial     numeric;
  v_idcam_complemento_residencial     numeric;
  v_idcam_bairro_residencial      numeric;
  v_idcam_cep_residencial       numeric;
  v_idcam_cidade_residencial      numeric;

  v_idcam_sigla_uf_comercial      numeric;
  v_idcam_id_tipo_logradouro_comercial    numeric;
  v_idcam_logradouro_comercial      numeric;
  v_idcam_numero_comercial      numeric;
  v_idcam_letra_comercial       numeric;
  v_idcam_complemento_comercial     numeric;
  v_idcam_bairro_comercial      numeric;
  v_idcam_cep_comercial       numeric;
  v_idcam_cidade_comercial      numeric;

  v_idcam_sigla_uf    numeric;
  v_idcam_id_tipo_logradouro  numeric;
  v_idcam_logradouro    numeric;
  v_idcam_numero      numeric;
  v_idcam_letra     numeric;
  v_idcam_complemento   numeric;
  v_idcam_bairro      numeric;
  v_idcam_cep     numeric;
  v_idcam_cidade      numeric;

  /*
  consistenciacao.historico_campo.credibilidade: 1 = Máxima, 2 = Alta, 3 = Média, 4 = Baixa, 5 = Sem credibilidade
  cadastro.pessoa.origem_gravacao: M = Migração, U = Usuário, C = Rotina de confrontação, O = Oscar
  */
  BEGIN
    v_idpes       := NEW.idpes;
    v_tipo_endereco     := NEW.tipo;

    v_sigla_uf_nova     := NEW.sigla_uf;
    v_id_tipo_logradouro_novo := NEW.idtlog;
    v_logradouro_novo   := NEW.logradouro;
    v_numero_novo     := NEW.numero;
    v_letra_nova      := NEW.letra;
    v_complemento_novo    := NEW.complemento;
    v_bairro_novo     := NEW.bairro;
    v_cep_novo      := NEW.cep;
    v_cidade_nova     := NEW.cidade;

    IF TG_OP <> 'UPDATE' THEN
      v_sigla_uf_antiga   := '';
      v_id_tipo_logradouro_antigo := '';
      v_logradouro_antigo   := '';
      v_numero_antigo     := 0;
      v_letra_antiga      := '';
      v_complemento_antigo    := '';
      v_bairro_antigo     := '';
      v_cep_antigo      := 0;
      v_cidade_antiga     := '';
    ELSE
      v_sigla_uf_antiga   := COALESCE(OLD.sigla_uf, '');
      v_id_tipo_logradouro_antigo := COALESCE(OLD.idtlog, '');
      v_logradouro_antigo   := COALESCE(OLD.logradouro, '');
      v_numero_antigo     := COALESCE(OLD.numero, 0);
      v_letra_antiga      := COALESCE(OLD.letra, '');
      v_complemento_antigo    := COALESCE(OLD.complemento, '');
      v_bairro_antigo     := COALESCE(OLD.bairro, '');
      v_cep_antigo      := COALESCE(OLD.cep, 0);
      v_cidade_antiga     := COALESCE(OLD.cidade, '');
    END IF;

    v_idcam_sigla_uf_correspondencia    := 55;
    v_idcam_id_tipo_logradouro_correspondencia  := 48;
    v_idcam_logradouro_correspondencia    := 47;
    v_idcam_numero_correspondencia      := 49;
    v_idcam_letra_correspondencia     := 50;
    v_idcam_complemento_correspondencia   := 51;
    v_idcam_bairro_correspondencia      := 52;
    v_idcam_cep_correspondencia     := 53;
    v_idcam_cidade_correspondencia      := 54;
    v_idcam_sigla_uf_residencial      := 64;
    v_idcam_id_tipo_logradouro_residencial    := 57;
    v_idcam_logradouro_residencial      := 56;
    v_idcam_numero_residencial      := 58;
    v_idcam_letra_residencial     := 59;
    v_idcam_complemento_residencial     := 60;
    v_idcam_bairro_residencial      := 61;
    v_idcam_cep_residencial       := 62;
    v_idcam_cidade_residencial      := 63;
    v_idcam_sigla_uf_comercial      := 73;
    v_idcam_id_tipo_logradouro_comercial    := 66;
    v_idcam_logradouro_comercial      := 65;
    v_idcam_numero_comercial      := 67;
    v_idcam_letra_comercial       := 68;
    v_idcam_complemento_comercial     := 69;
    v_idcam_bairro_comercial      := 70;
    v_idcam_cep_comercial       := 71;
    v_idcam_cidade_comercial      := 72;

    v_nova_credibilidade := 0;
    v_credibilidade_maxima := 1;
    v_credibilidade_alta := 2;
    v_sem_credibilidade := 5;
    v_comando := 'SELECT origem_gravacao FROM cadastro.pessoa WHERE idpes='||quote_literal(v_idpes)||';';

    FOR v_registro IN EXECUTE v_comando LOOP
      v_origem_gravacao := v_registro.origem_gravacao;
    END LOOP;

    IF v_origem_gravacao = 'U' OR v_origem_gravacao = 'O' THEN -- os dados foram editados pelo usuário ou usuário do Oscar
      v_nova_credibilidade := v_credibilidade_maxima;
    ELSIF v_origem_gravacao = 'M' THEN -- os dados foram originados por migração
      v_nova_credibilidade := v_credibilidade_alta;
    END IF;

    IF v_tipo_endereco = 1 THEN
      v_idcam_sigla_uf    := v_idcam_sigla_uf_correspondencia;
      v_idcam_id_tipo_logradouro  := v_idcam_id_tipo_logradouro_correspondencia;
      v_idcam_logradouro    := v_idcam_logradouro_correspondencia;
      v_idcam_numero      := v_idcam_numero_correspondencia;
      v_idcam_letra     := v_idcam_letra_correspondencia;
      v_idcam_complemento   := v_idcam_complemento_correspondencia;
      v_idcam_bairro      := v_idcam_bairro_correspondencia;
      v_idcam_cep     := v_idcam_cep_correspondencia;
      v_idcam_cidade      := v_idcam_cidade_correspondencia;
    ELSIF v_tipo_endereco = 2 THEN
      v_idcam_sigla_uf    := v_idcam_sigla_uf_residencial;
      v_idcam_id_tipo_logradouro  := v_idcam_id_tipo_logradouro_residencial;
      v_idcam_logradouro    := v_idcam_logradouro_residencial;
      v_idcam_numero      := v_idcam_numero_residencial;
      v_idcam_letra     := v_idcam_letra_residencial;
      v_idcam_complemento   := v_idcam_complemento_residencial;
      v_idcam_bairro      := v_idcam_bairro_residencial;
      v_idcam_cep     := v_idcam_cep_residencial;
      v_idcam_cidade      := v_idcam_cidade_residencial;
    ELSIF v_tipo_endereco = 3 THEN
      v_idcam_sigla_uf    := v_idcam_sigla_uf_comercial;
      v_idcam_id_tipo_logradouro  := v_idcam_id_tipo_logradouro_comercial;
      v_idcam_logradouro    := v_idcam_logradouro_comercial;
      v_idcam_numero      := v_idcam_numero_comercial;
      v_idcam_letra     := v_idcam_letra_comercial;
      v_idcam_complemento   := v_idcam_complemento_comercial;
      v_idcam_bairro      := v_idcam_bairro_comercial;
      v_idcam_cep     := v_idcam_cep_comercial;
      v_idcam_cidade      := v_idcam_cidade_comercial;
    END IF;

    IF v_nova_credibilidade > 0 THEN
      -- UF
      IF v_sigla_uf_nova <> v_sigla_uf_antiga THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_sigla_uf||','||v_nova_credibilidade||');';
      END IF;

      -- ID TIPO LOGRADOURO
      IF v_id_tipo_logradouro_novo <> v_id_tipo_logradouro_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_id_tipo_logradouro||','||v_nova_credibilidade||');';
      END IF;

      -- LOGRADOURO
      IF v_logradouro_novo <> v_logradouro_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_logradouro||','||v_nova_credibilidade||');';
      END IF;

      -- NUMERO
      IF v_numero_novo <> v_numero_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero||','||v_nova_credibilidade||');';
      END IF;

      -- LETRA
      IF v_letra_nova <> v_letra_antiga THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_letra||','||v_nova_credibilidade||');';
      END IF;

      -- COMPLEMENTO
      IF v_complemento_novo <> v_complemento_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_complemento||','||v_nova_credibilidade||');';
      END IF;

      -- BAIRRO
      IF v_bairro_novo <> v_bairro_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_bairro||','||v_nova_credibilidade||');';
      END IF;

      -- CEP
      IF v_cep_novo <> v_cep_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_cep||','||v_nova_credibilidade||');';
      END IF;

      -- CIDADE
      IF v_cidade_nova <> v_cidade_antiga THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_cidade||','||v_nova_credibilidade||');';
      END IF;

    END IF;

    -- Verificar os campos Vazios ou Nulos

    -- UF
    IF TRIM(v_sigla_uf_nova)='' OR v_sigla_uf_nova IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_sigla_uf||','||v_sem_credibilidade||');';
    END IF;

    -- ID TIPO LOGRADOURO
    IF TRIM(v_id_tipo_logradouro_novo)='' OR v_id_tipo_logradouro_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_id_tipo_logradouro||','||v_sem_credibilidade||');';
    END IF;

    -- LOGRADOURO
    IF TRIM(v_logradouro_novo)='' OR v_logradouro_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_logradouro||','||v_sem_credibilidade||');';
    END IF;
    -- NUMERO
    IF v_numero_novo <= 0 OR v_numero_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero||','||v_sem_credibilidade||');';
    END IF;

    -- LETRA
    IF TRIM(v_letra_nova)='' OR v_letra_nova IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_letra||','||v_sem_credibilidade||');';
    END IF;

    -- COMPLEMENTO
    IF TRIM(v_complemento_novo)='' OR v_complemento_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_complemento||','||v_sem_credibilidade||');';
    END IF;

    -- BAIRRO
    IF TRIM(v_bairro_novo)='' OR v_bairro_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_bairro||','||v_sem_credibilidade||');';
    END IF;
    -- CEP
    IF v_cep_novo <= 0 OR v_cep_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_cep||','||v_sem_credibilidade||');';
    END IF;

    -- CIDADE
    IF TRIM(v_cidade_nova)='' OR v_cidade_nova IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_cidade||','||v_sem_credibilidade||');';
    END IF;

  RETURN NEW;
END; $$;


ALTER FUNCTION consistenciacao.fcn_endereco_externo_historico_campo() OWNER TO postgres;

--
-- Name: fcn_endereco_pessoa_historico_campo(); Type: FUNCTION; Schema: consistenciacao; Owner: postgres
--

CREATE FUNCTION fcn_endereco_pessoa_historico_campo() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
  v_idpes       numeric;
  v_cep_antigo      numeric;
  v_cep_novo      numeric;
  v_id_logradouro_antigo    numeric;
  v_id_logradouro_novo    numeric;
  v_id_bairro_antigo    numeric;
  v_id_bairro_novo    numeric;
  v_numero_antigo     numeric;
  v_numero_novo     numeric;
  v_letra_antiga      text;
  v_letra_nova      text;
  v_complemento_antigo    text;
  v_complemento_novo    text;
  v_tipo_endereco     numeric;
  v_comando     text;
  v_origem_gravacao   text;
  v_credibilidade_maxima    numeric;
  v_credibilidade_alta    numeric;
  v_sem_credibilidade   numeric;
  v_nova_credibilidade    numeric;

  v_registro      record;

  -- ID dos campos
  v_idcam_cep_correspondencia     numeric;
  v_idcam_id_logradouro_correspondencia   numeric;
  v_idcam_id_bairro_correspondencia   numeric;
  v_idcam_numero_correspondencia      numeric;
  v_idcam_letra_correspondencia     numeric;
  v_idcam_complemento_correspondencia   numeric;

  v_idcam_cep_residencial       numeric;
  v_idcam_id_logradouro_residencial   numeric;
  v_idcam_id_bairro_residencial     numeric;
  v_idcam_numero_residencial      numeric;
  v_idcam_letra_residencial     numeric;
  v_idcam_complemento_residencial     numeric;

  v_idcam_cep_comercial       numeric;
  v_idcam_id_logradouro_comercial     numeric;
  v_idcam_id_bairro_comercial     numeric;
  v_idcam_numero_comercial      numeric;
  v_idcam_letra_comercial       numeric;
  v_idcam_complemento_comercial     numeric;

  v_idcam_cep     numeric;
  v_idcam_id_logradouro   numeric;
  v_idcam_id_bairro   numeric;
  v_idcam_numero      numeric;
  v_idcam_letra     numeric;
  v_idcam_complemento   numeric;

  /*
  consistenciacao.historico_campo.credibilidade: 1 = Máxima, 2 = Alta, 3 = Média, 4 = Baixa, 5 = Sem credibilidade
  cadastro.pessoa.origem_gravacao: M = Migração, U = Usuário, C = Rotina de confrontação, O = Oscar
  */
  BEGIN
    v_idpes       := NEW.idpes;
    v_tipo_endereco     := NEW.tipo;

    v_cep_novo      := NEW.cep;
    v_id_logradouro_novo    := NEW.idlog;
    v_id_bairro_novo    := NEW.idbai;
    v_numero_novo     := NEW.numero;
    v_letra_nova      := NEW.letra;
    v_complemento_novo    := NEW.complemento;

    IF TG_OP <> 'UPDATE' THEN
      v_cep_antigo    := 0;
      v_id_logradouro_antigo  := 0;
      v_id_bairro_antigo  := 0;
      v_numero_antigo   := 0;
      v_letra_antiga    := '';
      v_complemento_antigo  := '';
    ELSE
      v_cep_antigo    := COALESCE(OLD.cep, 0);
      v_id_logradouro_antigo  := COALESCE(OLD.idlog, 0);
      v_id_bairro_antigo  := COALESCE(OLD.idbai, 0);
      v_numero_antigo   := COALESCE(OLD.numero, 0);
      v_letra_antiga    := COALESCE(OLD.letra, '');
      v_complemento_antigo  := COALESCE(OLD.complemento, '');
    END IF;

    v_idcam_cep_correspondencia     := 53;
    v_idcam_id_logradouro_correspondencia   := 47;
    v_idcam_id_bairro_correspondencia   := 52;
    v_idcam_numero_correspondencia      := 49;
    v_idcam_letra_correspondencia     := 50;
    v_idcam_complemento_correspondencia   := 51;
    v_idcam_cep_residencial       := 62;
    v_idcam_id_logradouro_residencial   := 56;
    v_idcam_id_bairro_residencial     := 61;
    v_idcam_numero_residencial      := 58;
    v_idcam_letra_residencial     := 59;
    v_idcam_complemento_residencial     := 60;
    v_idcam_cep_comercial       := 71;
    v_idcam_id_logradouro_comercial     := 65;
    v_idcam_id_bairro_comercial     := 70;
    v_idcam_numero_comercial      := 67;
    v_idcam_letra_comercial       := 68;
    v_idcam_complemento_comercial     := 69;

    v_nova_credibilidade := 0;
    v_credibilidade_maxima := 1;
    v_credibilidade_alta := 2;
    v_sem_credibilidade := 5;
    v_comando := 'SELECT origem_gravacao FROM cadastro.pessoa WHERE idpes='||quote_literal(v_idpes)||';';

    FOR v_registro IN EXECUTE v_comando LOOP
      v_origem_gravacao := v_registro.origem_gravacao;
    END LOOP;
    IF v_origem_gravacao = 'U' OR v_origem_gravacao = 'O' THEN -- os dados foram editados pelo usuário ou pelo usuário do Oscar
      v_nova_credibilidade := v_credibilidade_maxima;
    ELSIF v_origem_gravacao = 'M' THEN -- os dados foram originados por migração
      v_nova_credibilidade := v_credibilidade_alta;
    END IF;
    IF v_tipo_endereco = 1 THEN
      v_idcam_cep     := v_idcam_cep_correspondencia;
      v_idcam_id_logradouro   := v_idcam_id_logradouro_correspondencia;
      v_idcam_id_bairro   := v_idcam_id_bairro_correspondencia;
      v_idcam_numero      := v_idcam_numero_correspondencia;
      v_idcam_letra     := v_idcam_letra_correspondencia;
      v_idcam_complemento   := v_idcam_complemento_correspondencia;
    ELSIF v_tipo_endereco = 2 THEN
      v_idcam_cep     := v_idcam_cep_residencial;
      v_idcam_id_logradouro   := v_idcam_id_logradouro_residencial;
      v_idcam_id_bairro   := v_idcam_id_bairro_residencial;
      v_idcam_numero      := v_idcam_numero_residencial;
      v_idcam_letra     := v_idcam_letra_residencial;
      v_idcam_complemento   := v_idcam_complemento_residencial;
    ELSIF v_tipo_endereco = 3 THEN
      v_idcam_cep     := v_idcam_cep_comercial;
      v_idcam_id_logradouro   := v_idcam_id_logradouro_comercial;
      v_idcam_id_bairro   := v_idcam_id_bairro_comercial;
      v_idcam_numero      := v_idcam_numero_comercial;
      v_idcam_letra     := v_idcam_letra_comercial;
      v_idcam_complemento   := v_idcam_complemento_comercial;
    END IF;
    IF v_nova_credibilidade > 0 THEN
      -- CEP
      IF v_cep_novo <> v_cep_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_cep||','||v_nova_credibilidade||');';
      END IF;
      -- ID LOGRADOURO
      IF v_id_logradouro_novo <> v_id_logradouro_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_id_logradouro||','||v_nova_credibilidade||');';
      END IF;
      -- BAIRRO
      IF v_id_bairro_novo <> v_id_bairro_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_id_bairro||','||v_nova_credibilidade||');';
      END IF;

      -- NUMERO
      IF v_numero_novo <> v_numero_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero||','||v_nova_credibilidade||');';
      END IF;

      -- LETRA
      IF v_letra_nova <> v_letra_antiga THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_letra||','||v_nova_credibilidade||');';
      END IF;

      -- COMPLEMENTO
      IF v_complemento_novo <> v_complemento_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_complemento||','||v_nova_credibilidade||');';
      END IF;
    END IF;

    -- Verificar os campos Vazios ou Nulos

    -- CEP
    IF v_cep_novo <= 0 OR v_cep_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_cep||','||v_sem_credibilidade||');';
    END IF;

    -- ID LOGRADOURO
    IF v_id_logradouro_novo <= 0 OR v_id_logradouro_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_id_logradouro||','||v_sem_credibilidade||');';
    END IF;

    -- BAIRRO
    IF v_id_bairro_novo <= 0 OR v_id_bairro_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_id_bairro||','||v_sem_credibilidade||');';
    END IF;

    -- NUMERO
    IF v_numero_novo <= 0 OR v_numero_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_numero||','||v_sem_credibilidade||');';
    END IF;

    -- LETRA
    IF TRIM(v_letra_nova)='' OR v_letra_nova IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_letra||','||v_sem_credibilidade||');';
    END IF;

    -- COMPLEMENTO
    IF TRIM(v_complemento_novo)='' OR v_complemento_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_complemento||','||v_sem_credibilidade||');';
    END IF;
  RETURN NEW;
END; $$;


ALTER FUNCTION consistenciacao.fcn_endereco_pessoa_historico_campo() OWNER TO postgres;

--
-- Name: fcn_fisica_historico_campo(); Type: FUNCTION; Schema: consistenciacao; Owner: postgres
--

CREATE FUNCTION fcn_fisica_historico_campo() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
                      DECLARE
                        v_idpes       numeric;
                        v_data_nasc_nova    date;
                        v_data_nasc_antiga    date;
                        v_sexo_novo     text;
                        v_sexo_antigo     text;
                        v_nome_mae_novo     text;
                        v_nome_mae_antigo   text;
                        v_nome_pai_novo     text;
                        v_nome_pai_antigo   text;
                        v_nome_conjuge_novo   text;
                        v_nome_conjuge_antigo   text;
                        v_nome_responsavel_novo   text;
                        v_nome_responsavel_antigo text;
                        v_nome_ultima_empresa_novo  text;
                        v_nome_ultima_empresa_antigo  text;
                        v_id_ocupacao_novo    numeric;
                        v_id_ocupacao_antigo    numeric;
                        v_id_escolaridade_novo    numeric;
                        v_id_escolaridade_antigo  numeric;
                        v_id_estado_civil_novo    numeric;
                        v_id_estado_civil_antigo  numeric;
                        v_id_pais_origem_novo   numeric;
                        v_id_pais_origem_antigo   numeric;
                        v_data_chegada_brasil_nova  date;
                        v_data_chegada_brasil_antiga  date;
                        v_data_obito_nova   date;
                        v_data_obito_antiga   date;
                        v_data_uniao_nova   date;
                        v_data_uniao_antiga   date;

                        v_comando     text;
                        v_origem_gravacao   text;

                        v_credibilidade_maxima    numeric;
                        v_credibilidade_alta    numeric;
                        v_sem_credibilidade   numeric;

                        v_nova_credibilidade    numeric;

                        v_registro      record;
                        v_aux_data_nova     text;
                        v_aux_data_antiga   text;

                        -- ID dos campos
                        v_idcam_data_nasc   numeric;
                        v_idcam_sexo      numeric;
                        v_idcam_nome_mae    numeric;
                        v_idcam_nome_pai    numeric;
                        v_idcam_nome_conjuge    numeric;
                        v_idcam_nome_responsavel  numeric;
                        v_idcam_nome_ultima_empresa numeric;
                        v_idcam_ocupacao    numeric;
                        v_idcam_escolaridade    numeric;
                        v_idcam_estado_civil    numeric;
                        v_idcam_pais_origem   numeric;
                        v_idcam_data_chegada_brasil numeric;
                        v_idcam_data_obito    numeric;
                        v_idcam_data_uniao    numeric;

                        /*
                        consistenciacao.historico_campo.credibilidade: 1 = Máxima, 2 = Alta, 3 = Média, 4 = Baixa, 5 = Sem credibilidade
                        cadastro.pessoa.origem_gravacao: M = Migração, U = Usuário, C = Rotina de confrontação, O = Oscar
                        */
                        BEGIN
                          v_idpes       := NEW.idpes;
                          v_data_nasc_nova    := NEW.data_nasc;
                          v_sexo_novo     := NEW.sexo;
                          v_nome_mae_novo     := NEW.nome_mae;
                          v_nome_pai_novo     := NEW.nome_pai;
                          v_nome_conjuge_novo   := NEW.nome_conjuge;
                          v_nome_responsavel_novo   := NEW.nome_responsavel;
                          v_nome_ultima_empresa_novo  := NEW.ultima_empresa;
                          v_id_ocupacao_novo    := NEW.idocup;
                          v_id_escolaridade_novo    := NEW.idesco;
                          v_id_estado_civil_novo    := NEW.ideciv;
                          v_id_pais_origem_novo   := NEW.idpais_estrangeiro;
                          v_data_chegada_brasil_nova  := NEW.data_chegada_brasil;
                          v_data_obito_nova   := NEW.data_obito;
                          v_data_uniao_nova   := NEW.data_uniao;

                          IF TG_OP <> 'UPDATE' THEN
                            v_data_nasc_antiga    := NULL;
                            v_sexo_antigo     := '';
                            v_nome_mae_antigo   := '';
                            v_nome_pai_antigo   := '';
                            v_nome_conjuge_antigo   := '';
                            v_nome_responsavel_antigo := '';
                            v_nome_ultima_empresa_antigo  := '';
                            v_id_ocupacao_antigo    := 0;
                            v_id_escolaridade_antigo  := 0;
                            v_id_estado_civil_antigo  := 0;
                            v_id_pais_origem_antigo   := 0;
                            v_data_chegada_brasil_antiga  := NULL;
                            v_data_obito_antiga   := NULL;
                            v_data_uniao_antiga   := NULL;
                          ELSE
                            v_data_nasc_antiga    := OLD.data_nasc;
                            v_sexo_antigo     := COALESCE(OLD.sexo, '');
                            v_nome_mae_antigo   := COALESCE(OLD.nome_mae, '');
                            v_nome_pai_antigo   := COALESCE(OLD.nome_pai, '');
                            v_nome_conjuge_antigo   := COALESCE(OLD.nome_conjuge, '');
                            v_nome_responsavel_antigo := COALESCE(OLD.nome_responsavel, '');
                            v_nome_ultima_empresa_antigo  := COALESCE(OLD.ultima_empresa, '');
                            v_id_ocupacao_antigo    := COALESCE(OLD.idocup, 0);
                            v_id_escolaridade_antigo  := COALESCE(OLD.idesco, 0);
                            v_id_estado_civil_antigo  := COALESCE(OLD.ideciv, 0);
                            v_id_pais_origem_antigo   := COALESCE(OLD.idpais_estrangeiro, 0);
                            v_data_chegada_brasil_antiga  := OLD.data_chegada_brasil;
                            v_data_obito_antiga   := OLD.data_obito;
                            v_data_uniao_antiga   := OLD.data_uniao;
                          END IF;

                          v_idcam_data_nasc   := 5;
                          v_idcam_sexo      := 26;
                          v_idcam_nome_mae    := 27;
                          v_idcam_nome_pai    := 28;
                          v_idcam_nome_conjuge    := 29;
                          v_idcam_nome_responsavel  := 30;
                          v_idcam_nome_ultima_empresa := 31;
                          v_idcam_ocupacao    := 32;
                          v_idcam_escolaridade    := 33;
                          v_idcam_estado_civil    := 34;
                          v_idcam_pais_origem   := 35;
                          v_idcam_data_chegada_brasil := 36;
                          v_idcam_data_obito    := 37;
                          v_idcam_data_uniao    := 38;

                          v_nova_credibilidade := 0;
                          v_credibilidade_maxima := 1;
                          v_credibilidade_alta := 2;
                          v_sem_credibilidade := 5;
                          v_comando := 'SELECT origem_gravacao FROM cadastro.pessoa WHERE idpes='||quote_literal(v_idpes)||';';

                          FOR v_registro IN EXECUTE v_comando LOOP
                            v_origem_gravacao := v_registro.origem_gravacao;
                          END LOOP;

                          IF v_origem_gravacao = 'U' OR v_origem_gravacao = 'O' THEN -- os dados foram editados pelo usuário ou pelo usuário do Oscar
                            v_nova_credibilidade := v_credibilidade_maxima;
                          ELSIF v_origem_gravacao = 'M' THEN -- os dados foram originados por migração
                            v_nova_credibilidade := v_credibilidade_alta;
                          END IF;

                          IF v_nova_credibilidade > 0 THEN

                            -- DATA DE NASCIMENTO
                            v_aux_data_nova := COALESCE(TO_CHAR (v_data_nasc_nova, 'DD/MM/YYYY'), '');
                            v_aux_data_antiga := COALESCE(TO_CHAR (v_data_nasc_antiga, 'DD/MM/YYYY'), '');

                            IF v_aux_data_nova <> v_aux_data_antiga THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_nasc||','||v_nova_credibilidade||');';
                            END IF;

                            -- DATA DE UNIÃO
                            v_aux_data_nova := COALESCE(TO_CHAR (v_data_uniao_nova, 'DD/MM/YYYY'), '');
                            v_aux_data_antiga := COALESCE(TO_CHAR (v_data_uniao_antiga, 'DD/MM/YYYY'), '');

                            IF v_aux_data_nova <> v_aux_data_antiga THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_uniao||','||v_nova_credibilidade||');';
                            END IF;

                            -- DATA DE ÓBITO
                            v_aux_data_nova := COALESCE(TO_CHAR (v_data_obito_nova, 'DD/MM/YYYY'), '');
                            v_aux_data_antiga := COALESCE(TO_CHAR (v_data_obito_antiga, 'DD/MM/YYYY'), '');

                            IF v_aux_data_nova <> v_aux_data_antiga THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_obito||','||v_nova_credibilidade||');';
                            END IF;

                            -- DATA DE CHEGADA AO BRASIL
                            v_aux_data_nova := COALESCE(TO_CHAR (v_data_chegada_brasil_nova, 'DD/MM/YYYY'), '');
                            v_aux_data_antiga := COALESCE(TO_CHAR (v_data_chegada_brasil_antiga, 'DD/MM/YYYY'), '');

                            IF v_aux_data_nova <> v_aux_data_antiga THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_chegada_brasil||','||v_nova_credibilidade||');';
                            END IF;

                            -- NOME DA MÃE
                            IF v_nome_mae_novo <> v_nome_mae_antigo THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_nome_mae||','||v_nova_credibilidade||');';
                            END IF;

                            -- NOME DO PAI
                            IF v_nome_pai_novo <> v_nome_pai_antigo THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_nome_pai||','||v_nova_credibilidade||');';
                            END IF;

                            -- NOME DO CONJUGE
                            IF v_nome_conjuge_novo <> v_nome_conjuge_antigo THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_nome_conjuge||','||v_nova_credibilidade||');';
                            END IF;

                            -- NOME DO RESPONSAVEL
                            IF v_nome_responsavel_novo <> v_nome_responsavel_antigo THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_nome_responsavel||','||v_nova_credibilidade||');';
                            END IF;

                            -- NOME ÚLTIMA EMPRESA
                            IF v_nome_ultima_empresa_novo <> v_nome_ultima_empresa_antigo THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_nome_ultima_empresa||','||v_nova_credibilidade||');';
                            END IF;

                            -- SEXO
                            IF v_sexo_novo <> v_sexo_antigo THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_sexo||','||v_nova_credibilidade||');';
                            END IF;

                            -- ID OCUPAÇÃO PROFISSIONAL
                            IF v_id_ocupacao_novo <> v_id_ocupacao_antigo THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_ocupacao||','||v_nova_credibilidade||');';
                            END IF;

                            -- ID ESCOLARIDADE
                            IF v_id_escolaridade_novo <> v_id_escolaridade_antigo THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_escolaridade||','||v_nova_credibilidade||');';
                            END IF;

                            -- ID ESTADO CIVIL
                            IF v_id_estado_civil_novo <> v_id_estado_civil_antigo THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_estado_civil||','||v_nova_credibilidade||');';
                            END IF;

                            -- ID PAIS ORIGEM
                            IF v_id_pais_origem_novo <> v_id_pais_origem_antigo THEN
                              EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_pais_origem||','||v_nova_credibilidade||');';
                            END IF;

                          END IF;

                          -- Verificar os campos Vazios ou Nulos
                          -- DATA DE NASCIMENTO
                          IF TRIM(v_data_nasc_nova::varchar)='' OR v_data_nasc_nova IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_nasc||','||v_sem_credibilidade||');';
                          END IF;
                          -- DATA DE UNIÃO
                          IF TRIM(v_data_uniao_nova::varchar)='' OR v_data_uniao_nova IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_uniao||','||v_sem_credibilidade||');';
                          END IF;
                          -- DATA DE ÓBITO
                          IF TRIM(v_data_obito_nova::varchar)='' OR v_data_obito_nova IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_obito||','||v_sem_credibilidade||');';
                          END IF;
                          -- DATA DE CHEGADA AO BRASIL
                          IF TRIM(v_data_chegada_brasil_nova::varchar)='' OR v_data_chegada_brasil_nova IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_data_chegada_brasil||','||v_sem_credibilidade||');';
                          END IF;
                          -- NOME DA MÃE
                          IF TRIM(v_nome_mae_novo)='' OR v_nome_mae_novo IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_nome_mae||','||v_sem_credibilidade||');';
                          END IF;
                          -- NOME DO PAI
                          IF TRIM(v_nome_pai_novo)='' OR v_nome_pai_novo IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_nome_pai||','||v_sem_credibilidade||');';
                          END IF;
                          -- NOME DO CONJUGE
                          IF TRIM(v_nome_conjuge_novo)='' OR v_nome_conjuge_novo IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_nome_conjuge||','||v_sem_credibilidade||');';
                          END IF;
                          -- NOME DO RESPONSAVEL
                          IF TRIM(v_nome_responsavel_novo)='' OR v_nome_responsavel_novo IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_nome_responsavel||','||v_sem_credibilidade||');';
                          END IF;
                          -- NOME ÚLTIMA EMPRESA
                          IF TRIM(v_nome_ultima_empresa_novo)='' OR v_nome_ultima_empresa_novo IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_nome_ultima_empresa||','||v_sem_credibilidade||');';
                          END IF;
                          -- SEXO
                          IF TRIM(v_sexo_novo)='' OR v_sexo_novo IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_sexo||','||v_sem_credibilidade||');';
                          END IF;
                          -- ID OCUPAÇÃO PROFISSIONAL
                          IF v_id_ocupacao_novo <= 0 OR v_id_ocupacao_novo IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_ocupacao||','||v_sem_credibilidade||');';
                          END IF;
                          -- ID ESCOLARIDADE
                          IF v_id_escolaridade_novo <= 0 OR v_id_escolaridade_novo IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_escolaridade||','||v_sem_credibilidade||');';
                          END IF;
                          -- ID ESTADO CIVIL
                          IF v_id_estado_civil_novo <= 0 OR v_id_estado_civil_novo IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_estado_civil||','||v_sem_credibilidade||');';
                          END IF;
                          -- ID PAIS ORIGEM
                          IF v_id_pais_origem_novo <= 0 OR v_id_pais_origem_novo IS NULL THEN
                            EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_pais_origem||','||v_sem_credibilidade||');';
                          END IF;
                        RETURN NEW;
                      END; $$;


ALTER FUNCTION consistenciacao.fcn_fisica_historico_campo() OWNER TO postgres;

--
-- Name: fcn_fone_historico_campo(); Type: FUNCTION; Schema: consistenciacao; Owner: postgres
--

CREATE FUNCTION fcn_fone_historico_campo() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
  v_idpes       numeric;

  v_ddd_antigo      numeric;
  v_ddd_novo      numeric;
  v_fone_antigo     numeric;
  v_fone_novo     numeric;
  v_tipo_fone     numeric;

  v_comando     text;
  v_origem_gravacao   text;

  v_credibilidade_maxima    numeric;
  v_credibilidade_alta    numeric;
  v_sem_credibilidade   numeric;

  v_nova_credibilidade    numeric;

  v_registro      record;

  -- ID dos campos
  v_idcam_ddd_fone_residencial  numeric;
  v_idcam_fone_residencial  numeric;
  v_idcam_ddd_fone_comercial  numeric;
  v_idcam_fone_comercial    numeric;
  v_idcam_ddd_fone_celular  numeric;
  v_idcam_fone_celular    numeric;
  v_idcam_ddd_fax     numeric;
  v_idcam_fax     numeric;

  v_idcam_ddd     numeric;
  v_idcam_fone      numeric;

  /*
  consistenciacao.historico_campo.credibilidade: 1 = Máxima, 2 = Alta, 3 = Média, 4 = Baixa, 5 = Sem credibilidade
  cadastro.pessoa.origem_gravacao: M = Migração, U = Usuário, C = Rotina de confrontação, O = Oscar
  */
  BEGIN
    v_idpes   := NEW.idpes;
    v_tipo_fone := NEW.tipo;
    v_ddd_novo  := NEW.ddd;
    v_fone_novo := NEW.fone;

    IF TG_OP <> 'UPDATE' THEN
      v_ddd_antigo  := 0;
      v_fone_antigo := 0;
    ELSE
      v_ddd_antigo  := COALESCE(OLD.ddd, 0);
      v_fone_antigo := COALESCE(OLD.fone, 0);
    END IF;

    v_idcam_ddd_fone_residencial  := 39;
    v_idcam_fone_residencial  := 40;
    v_idcam_ddd_fone_comercial  := 41;
    v_idcam_fone_comercial    := 42;
    v_idcam_ddd_fone_celular  := 43;
    v_idcam_fone_celular    := 44;
    v_idcam_ddd_fax     := 45;
    v_idcam_fax     := 46;

    v_nova_credibilidade := 0;
    v_credibilidade_maxima := 1;
    v_credibilidade_alta := 2;
    v_sem_credibilidade := 5;
    v_comando := 'SELECT origem_gravacao FROM cadastro.pessoa WHERE idpes='||quote_literal(v_idpes)||';';

    FOR v_registro IN EXECUTE v_comando LOOP
      v_origem_gravacao := v_registro.origem_gravacao;
    END LOOP;

    IF v_origem_gravacao = 'U' OR v_origem_gravacao = 'O' THEN -- os dados foram editados pelo usuário ou usuário do Oscar
      v_nova_credibilidade := v_credibilidade_maxima;
    ELSIF v_origem_gravacao = 'M' THEN -- os dados foram originados por migração
      v_nova_credibilidade := v_credibilidade_alta;
    END IF;

    IF v_tipo_fone = 1 THEN
      v_idcam_ddd := v_idcam_ddd_fone_residencial;
      v_idcam_fone := v_idcam_fone_residencial;
    ELSIF v_tipo_fone = 2 THEN
      v_idcam_ddd := v_idcam_ddd_fone_comercial;
      v_idcam_fone := v_idcam_fone_comercial;
    ELSIF v_tipo_fone = 3 THEN
      v_idcam_ddd := v_idcam_ddd_fone_celular;
      v_idcam_fone := v_idcam_fone_celular;
    ELSIF v_tipo_fone = 4 THEN
      v_idcam_ddd := v_idcam_ddd_fax;
      v_idcam_fone := v_idcam_fax;
    END IF;

    IF v_nova_credibilidade > 0 THEN
      IF v_ddd_novo <> v_ddd_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_ddd||','||v_nova_credibilidade||');';
      END IF;

      IF v_fone_novo <> v_fone_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_fone||','||v_nova_credibilidade||');';
      END IF;
    END IF;

    -- Verificar os campos Vazios ou Nulos
    IF v_ddd_novo <= 0 OR v_ddd_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_ddd||','||v_sem_credibilidade||');';
    END IF;
    IF v_fone_novo <= 0 OR v_fone_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_fone||','||v_sem_credibilidade||');';
    END IF;

  RETURN NEW;
END; $$;


ALTER FUNCTION consistenciacao.fcn_fone_historico_campo() OWNER TO postgres;

--
-- Name: fcn_gravar_historico_campo(numeric, numeric, numeric); Type: FUNCTION; Schema: consistenciacao; Owner: postgres
--

CREATE FUNCTION fcn_gravar_historico_campo(numeric, numeric, numeric) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  v_idpes ALIAS for $1;
  v_idcam ALIAS for $2;
  v_credibilidade ALIAS for $3;

  v_comando   text;
  v_existe_historico  numeric;
  v_registro    record;

  BEGIN
    -- verificar se já existe histórico para o campo
    v_comando := 'SELECT idcam FROM consistenciacao.historico_campo WHERE idpes='||quote_literal(v_idpes)||' AND idcam='||quote_literal(v_idcam)||';';
    FOR v_registro IN EXECUTE v_comando LOOP
      v_existe_historico := v_registro.idcam;
    END LOOP;
    IF v_existe_historico > 0 THEN
      EXECUTE 'UPDATE consistenciacao.historico_campo SET credibilidade='||v_credibilidade||', data_hora=CURRENT_TIMESTAMP WHERE idpes='||quote_literal(v_idpes)||' AND idcam='||quote_literal(v_idcam)||';';
    ELSE
      EXECUTE 'INSERT INTO consistenciacao.historico_campo(idpes, idcam, credibilidade, data_hora) VALUES ('||quote_literal(v_idpes)||','|| quote_literal(v_idcam)||', '||quote_literal(v_credibilidade)||', CURRENT_TIMESTAMP);';
    END IF;
  RETURN 1;
END; $_$;


ALTER FUNCTION consistenciacao.fcn_gravar_historico_campo(numeric, numeric, numeric) OWNER TO postgres;

--
-- Name: fcn_juridica_historico_campo(); Type: FUNCTION; Schema: consistenciacao; Owner: postgres
--

CREATE FUNCTION fcn_juridica_historico_campo() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
  v_idpes       numeric;
  v_cnpj_novo     numeric;
  v_cnpj_antigo     numeric;
  v_fantasia_novo     text;
  v_fantasia_antigo   text;
  v_inscricao_estadual_novo numeric;
  v_inscricao_estadual_antigo numeric;

  v_comando     text;
  v_origem_gravacao   text;

  v_credibilidade_maxima    numeric;
  v_credibilidade_alta    numeric;
  v_sem_credibilidade   numeric;

  v_nova_credibilidade    numeric;

  v_registro      record;

  -- ID dos campos
  v_idcam_cnpj      numeric;
  v_idcam_fantasia    numeric;
  v_idcam_inscricao_estadual  numeric;

  /*
  consistenciacao.historico_campo.credibilidade: 1 = Máxima, 2 = Alta, 3 = Média, 4 = Baixa, 5 = Sem credibilidade
  cadastro.pessoa.origem_gravacao: M = Migração, U = Usuário, C = Rotina de confrontação, O = Oscar
  */
  BEGIN
    v_idpes       := NEW.idpes;
    v_cnpj_novo     := NEW.cnpj;
    v_fantasia_novo     := NEW.fantasia;
    v_inscricao_estadual_novo := NEW.insc_estadual;

    IF TG_OP <> 'UPDATE' THEN
      v_cnpj_antigo     := 0;
      v_fantasia_antigo   := '';
      v_inscricao_estadual_antigo := 0;
    ELSE
      v_cnpj_antigo     := COALESCE(OLD.cnpj, 0);
      v_fantasia_antigo   := COALESCE(OLD.fantasia, '');
      v_inscricao_estadual_antigo := COALESCE(OLD.insc_estadual, 0);
    END IF;

    v_idcam_cnpj      := 1;
    v_idcam_fantasia    := 24;
    v_idcam_inscricao_estadual  := 25;

    v_nova_credibilidade := 0;
    v_credibilidade_maxima := 1;
    v_credibilidade_alta := 2;
    v_sem_credibilidade := 5;
    v_comando := 'SELECT origem_gravacao FROM cadastro.pessoa WHERE idpes='||quote_literal(v_idpes)||';';

    FOR v_registro IN EXECUTE v_comando LOOP
      v_origem_gravacao := v_registro.origem_gravacao;
    END LOOP;

    IF v_origem_gravacao = 'U' OR v_origem_gravacao = 'O' THEN -- os dados foram editados pelo usuário ou pelo usuário do Oscar
      v_nova_credibilidade := v_credibilidade_maxima;
    ELSIF v_origem_gravacao = 'M' THEN -- os dados foram originados por migração
      v_nova_credibilidade := v_credibilidade_alta;
    END IF;

    IF v_nova_credibilidade > 0 THEN

      -- CNPJ
      IF v_cnpj_novo <> v_cnpj_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_cnpj||','||v_nova_credibilidade||');';
      END IF;

      -- NOME FANTASIA
      IF v_fantasia_novo <> v_fantasia_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_fantasia||','||v_nova_credibilidade||');';
      END IF;

      -- INSCRIÇÃO ESTADUAL
      IF v_inscricao_estadual_novo <> v_inscricao_estadual_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_inscricao_estadual||','||v_nova_credibilidade||');';
      END IF;
    END IF;

    -- Verificar os campos Vazios ou Nulos
    -- CNPJ
    IF v_cnpj_novo <= 0 OR v_cnpj_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_cnpj||','||v_sem_credibilidade||');';
    END IF;
    -- NOME FANTASIA
    IF TRIM(v_fantasia_novo)='' OR v_fantasia_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_fantasia||','||v_sem_credibilidade||');';
    END IF;

    -- INSCRIÇÃO ESTADUAL
    IF v_inscricao_estadual_novo <= 0 OR v_inscricao_estadual_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_inscricao_estadual||','||v_sem_credibilidade||');';
    END IF;
  RETURN NEW;
END; $$;


ALTER FUNCTION consistenciacao.fcn_juridica_historico_campo() OWNER TO postgres;

--
-- Name: fcn_pessoa_historico_campo(); Type: FUNCTION; Schema: consistenciacao; Owner: postgres
--

CREATE FUNCTION fcn_pessoa_historico_campo() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
  v_idpes       numeric;
  v_nome_novo     text;
  v_nome_antigo     text;
  v_email_novo      text;
  v_email_antigo      text;
  v_url_novo      text;
  v_url_antigo      text;

  v_comando     text;
  v_origem_gravacao   text;

  v_credibilidade_maxima    numeric;
  v_credibilidade_alta    numeric;
  v_sem_credibilidade   numeric;

  v_nova_credibilidade    numeric;

  v_registro      record;

  -- ID dos campos
  v_idcam_nome      numeric;
  v_idcam_email     numeric;
  v_idcam_url     numeric;

  /*
  consistenciacao.historico_campo.credibilidade: 1 = Máxima, 2 = Alta, 3 = Média, 4 = Baixa, 5 = Sem credibilidade
  cadastro.pessoa.origem_gravacao: M = Migração, U = Usuário, C = Rotina de confrontação, O = Oscar
  */
  BEGIN
    v_idpes   := NEW.idpes;
    v_nome_novo := NEW.nome;
    v_email_novo  := NEW.email;
    v_url_novo  := NEW.url;

    IF TG_OP <> 'UPDATE' THEN
      v_nome_antigo := '';
      v_email_antigo  := '';
      v_url_antigo  := '';
    ELSE
      v_nome_antigo := COALESCE(OLD.nome, '');
      v_email_antigo  := COALESCE(OLD.email, '');
      v_url_antigo  := COALESCE(OLD.url, '');
    END IF;

    v_idcam_nome  := 2;
    v_idcam_email := 3;
    v_idcam_url := 4;

    v_nova_credibilidade := 0;
    v_credibilidade_maxima := 1;
    v_credibilidade_alta := 2;
    v_sem_credibilidade := 5;
    v_comando := 'SELECT origem_gravacao FROM cadastro.pessoa WHERE idpes='||quote_literal(v_idpes)||';';

    FOR v_registro IN EXECUTE v_comando LOOP
      v_origem_gravacao := v_registro.origem_gravacao;
    END LOOP;

    IF v_origem_gravacao = 'U' OR v_origem_gravacao = 'O' THEN -- os dados foram editados pelo usuário ou pelo usuário do Oscar
      v_nova_credibilidade := v_credibilidade_maxima;
    ELSIF v_origem_gravacao = 'M' THEN -- os dados foram originados por migração
      v_nova_credibilidade := v_credibilidade_alta;
    END IF;

    IF v_nova_credibilidade > 0 THEN

      -- NOME
      IF v_nome_novo <> v_nome_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_nome||','||v_nova_credibilidade||');';
      END IF;

      -- E-MAIL
      IF v_email_novo <> v_email_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_email||','||v_nova_credibilidade||');';
      END IF;

      -- URL
      IF v_url_novo <> v_url_antigo THEN
        EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_url||','||v_nova_credibilidade||');';
      END IF;
    END IF;

    -- Verificar os campos Vazios ou Nulos
    -- NOME
    IF TRIM(v_nome_novo)='' OR v_nome_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_nome||','||v_sem_credibilidade||');';
    END IF;
    -- E-MAIL
    IF TRIM(v_email_novo)='' OR v_email_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_email||','||v_sem_credibilidade||');';
    END IF;
    -- URL
    IF TRIM(v_url_novo)='' OR v_url_novo IS NULL THEN
      EXECUTE 'SELECT consistenciacao.fcn_gravar_historico_campo('||v_idpes||','||v_idcam_url||','||v_sem_credibilidade||');';
    END IF;
  RETURN NEW;
END; $$;


ALTER FUNCTION consistenciacao.fcn_pessoa_historico_campo() OWNER TO postgres;

--
-- Name: fcn_unifica_cadastro(numeric, numeric); Type: FUNCTION; Schema: consistenciacao; Owner: postgres
--

CREATE FUNCTION fcn_unifica_cadastro(numeric, numeric) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parametro recebidos
  v_idpesVelho     ALIAS for $1;
  v_idpesNovo      ALIAS for $2;
  v_cpfAux           NUMERIC;
  v_cpfIdpesNovo     NUMERIC;
  v_reg          record;
  v_regAux         record;
BEGIN
  --Unificando registros das tabelas do cadastros de pessoas--
  SET search_path = cadastro, pg_catalog;
  --FONE_PESSOA--
  FOR v_reg IN SELECT *
       FROM fone_pessoa
       WHERE
       idpes = v_idpesVelho AND
       tipo NOT IN (SELECT tipo FROM fone_pessoa WHERE idpes = v_idpesNovo) LOOP
    INSERT INTO fone_pessoa (idpes, tipo, ddd, fone) VALUES (v_idpesNovo,v_reg.tipo, v_reg.ddd, v_reg.fone);
  END LOOP;
  --Atualizando os telefones do idpeNovo que tenham o DDD e o FONE igual a zero--
  FOR v_reg IN SELECT * FROM fone_pessoa WHERE idpes = v_idpesNovo AND ddd = 0 AND fone = 0 LOOP
    DELETE FROM fone_pessoa WHERE idpes = v_reg.idpes AND tipo = v_reg.tipo;
    FOR v_regAux IN SELECT * FROM fone_pessoa WHERE idpes = v_idpesVelho AND tipo = v_reg.tipo LOOP
      INSERT INTO fone_pessoa(idpes,tipo,ddd,fone) VALUES (v_reg.idpes,v_regAux.tipo,v_regAux.ddd,v_regAux.fone);
    END LOOP;
  END LOOP;
  DELETE FROM fone_pessoa WHERE idpes = v_idpesVelho;
  --JURIDICA--
  DELETE FROM juridica WHERE idpes = v_idpesVelho;
  --HISTORICO_CARTAO--
  UPDATE historico_cartao SET idpes_cidadao = v_idpesNovo WHERE idpes_cidadao = v_idpesVelho;
  --ENDERECO_PESSOA--
  FOR v_reg IN SELECT *
         FROM endereco_pessoa
         WHERE
         idpes = v_idpesVelho AND
         tipo NOT IN (SELECT tipo FROM endereco_pessoa WHERE idpes = v_idpesNovo) LOOP
    INSERT INTO endereco_pessoa (idpes, tipo, cep, idlog, idbai, numero, letra, complemento, reside_desde)
    VALUES (v_idpesNovo,v_reg.tipo, v_reg.cep, v_reg.idlog, v_reg.idbai, v_reg.numero, v_reg.letra, v_reg.complemento, v_reg.reside_desde);
  END LOOP;
  DELETE FROM endereco_pessoa WHERE idpes = v_idpesVelho;
  --ENDERECO_EXTERNO--
  FOR v_reg IN SELECT *
     FROM endereco_externo
     WHERE
     idpes = v_idpesVelho AND
     tipo NOT IN (SELECT tipo FROM endereco_externo WHERE idpes = v_idpesNovo) LOOP
    INSERT INTO endereco_externo (idpes, tipo, idtlog, logradouro, numero, letra, complemento, bairro, cep, cidade, sigla_uf,reside_desde)
    VALUES (v_idpesNovo, v_reg.tipo, v_reg.idtlog, v_reg.logradouro, v_reg.numero, v_reg.letra, v_reg.complemento, v_reg.bairro, v_reg.cep, v_reg.cidade, v_reg.sigla_uf,v_reg.reside_desde);
  END LOOP;
  DELETE FROM endereco_externo WHERE idpes = v_idpesVelho;
  --FISICA_CPF--
  --Obtendo enventual CPF da pessoa antiga para ser inserido na pessoa nova--
  FOR v_reg IN SELECT cpf FROM fisica_cpf WHERE idpes = v_idpesVelho AND idpes <> v_idpesNovo LOOP
    v_cpfAux := v_reg.cpf;
  END LOOP;
  DELETE FROM fisica_cpf WHERE idpes = v_idpesVelho;
  IF v_cpfAux IS NOT NULL THEN
    FOR v_reg IN SELECT cpf FROM fisica_cpf WHERE idpes = v_idpesNovo LOOP
      v_cpfIdpesNovo := v_reg.cpf;
    END LOOP;
    --Verificando se o idpess já possuí um CPF--
    IF v_cpfIdpesNovo IS NULL THEN
      INSERT INTO fisica_cpf (idpes, cpf) VALUES (v_idpesNovo,v_cpfAux);
    END IF;
  END IF;
  --FUNCIONARIO--
  UPDATE funcionario SET idpes = v_idpesNovo WHERE idpes = v_idpesVelho;
  --DOCUMENTO--
  DELETE FROM documento WHERE idpes = v_idpesVelho;
  --FISICA--
  DELETE FROM fisica WHERE idpes = v_idpesVelho;
  --PESSOA--
  DELETE FROM pessoa WHERE idpes = v_idpesVelho;
  RETURN 0;
END;$_$;


ALTER FUNCTION consistenciacao.fcn_unifica_cadastro(numeric, numeric) OWNER TO postgres;

--
-- Name: fcn_unifica_cmf(numeric, numeric); Type: FUNCTION; Schema: consistenciacao; Owner: postgres
--

CREATE FUNCTION fcn_unifica_cmf(numeric, numeric) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parametro recebidos
  v_idpesVelho ALIAS for $1;
  v_idpesNovo ALIAS for $2;

BEGIN
  --Unificando registros do SECM (Sistema de Emissao de Certidoes Municipais)--
  EXECUTE 'SELECT consistenciacao.fcn_unifica_secm('||v_idpesVelho||','||v_idpesNovo||');';
  --Unificando as tabelas do sistema de SGDO (Sistema de Gestao de Despesas Orcamentarias)--
  EXECUTE 'SELECT consistenciacao.fcn_unifica_sgdo('||v_idpesVelho||','||v_idpesNovo||');';
  --Unificando as tabelas do sistema de SGP (Sistema de Gerenciamento de Protocolo)--
  EXECUTE 'SELECT consistenciacao.fcn_unifica_sgp('||v_idpesVelho||','||v_idpesNovo||');';
  --Unificando as tabelas do sistema de SGPA (Sistema de Gestao da Praca de Atendimento)--
  EXECUTE 'SELECT consistenciacao.fcn_unifica_sgpa('||v_idpesVelho||','||v_idpesNovo||');';
  --Unificando as tabelas do sistema de SGSP (Sistema de Gerenciamento de Servicos consistenciacaoos)--
  EXECUTE 'SELECT consistenciacao.fcn_unifica_sgsp('||v_idpesVelho||','||v_idpesNovo||');';
      --Unificando registros das tabelas do SCD (Sistema de Consintenciacao de Dados)--
   EXECUTE 'SELECT consistenciacao.fcn_unifica_scd('||v_idpesVelho||','||v_idpesNovo||');';
  --Unificando registros das tabelas do SCA (Controle de acesso)--
  EXECUTE 'SELECT consistenciacao.fcn_unifica_sca('||v_idpesVelho||','||v_idpesNovo||');';
  --Unificando registros das tabelas de cadastro--
   EXECUTE 'SELECT consistenciacao.fcn_unifica_cadastro('||v_idpesVelho||','||v_idpesNovo||');';
  RETURN 0;
END;$_$;


ALTER FUNCTION consistenciacao.fcn_unifica_cmf(numeric, numeric) OWNER TO postgres;

--
-- Name: fcn_unifica_sca(numeric, numeric); Type: FUNCTION; Schema: consistenciacao; Owner: postgres
--

CREATE FUNCTION fcn_unifica_sca(numeric, numeric) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  --Parametro recebidos--
  v_idpesVelho ALIAS for $1;
  v_idpesNovo  ALIAS for $2;
  v_loginAux   varchar;
  v_reg      record;
BEGIN
  --Unificando registros das tabelas do SCA (Sistema de Controle de Acesso)--
  SET search_path = acesso, pg_catalog;
  --PESSOA_INSTITUICAO--
  --Inserindo as instituicoes do idvelho para o id novo--
  FOR v_reg IN SELECT *
               FROM pessoa_instituicao
               WHERE
         idpes = v_idpesVelho AND
         idins NOT IN
        (SELECT idins FROM
         pessoa_instituicao
         WHERE idpes = v_idpesNovo) LOOP
    INSERT INTO pessoa_instituicao (idpes,idins) VALUES (v_idpesNovo, v_reg.idins);
  END LOOP;
  --Apagando os registro do id velho--
  EXECUTE 'DELETE FROM pessoa_instituicao WHERE idpes = '||v_idpesVelho||';';
  --LOG_ACESSO--
  EXECUTE 'UPDATE log_acesso SET idpes ='||v_idpesNovo||' WHERE idpes = '||v_idpesVelho||';';
  --USUARIO_GRUPO--
  --Obtendo o login do novo idpes para ser usado na unificacao da tabela usuario_grupo--
  FOR v_reg IN SELECT login FROM usuario WHERE idpes = v_idpesNovo LOOP
    v_loginAux := v_reg.login;
  END LOOP;
  --Inserindo os grupos do idpes velho para o idpes novo--
  FOR v_reg IN SELECT *
         FROM usuario_grupo
         WHERE
         login IN (SELECT login FROM usuario WHERE idpes = v_idpesVelho) AND
         idgrp NOT IN (SELECT idgrp
                       FROM usuario_grupo
           WHERE
           login = v_loginAux) LOOP
    INSERT INTO usuario_grupo (idgrp,login) VALUES (v_reg.idgrp, v_loginAux);
  END LOOP;
  --Deletando os registros do idpes velho--
  EXECUTE 'DELETE FROM usuario_grupo
            WHERE login IN
         (SELECT login FROM usuario WHERE idpes ='|| v_idpesVelho ||');';
  --LOG_ERRO--
  EXECUTE 'UPDATE log_erro SET idpes = '||v_idpesNovo||' WHERE idpes = '||v_idpesVelho||';';

  --USUARIO--
  EXECUTE 'DELETE FROM usuario WHERE idpes ='|| v_idpesVelho||';';
  RETURN 0;
END;$_$;


ALTER FUNCTION consistenciacao.fcn_unifica_sca(numeric, numeric) OWNER TO postgres;

--
-- Name: fcn_unifica_scd(numeric, numeric); Type: FUNCTION; Schema: consistenciacao; Owner: postgres
--

CREATE FUNCTION fcn_unifica_scd(numeric, numeric) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parametro recebidos
  v_idpesVelho ALIAS for $1;
  v_idpesNovo  ALIAS for $2;
BEGIN
  --Unificando registros das tabelas do SCD (Sistema de Consintenciacao de Dados)--
  SET search_path = consistenciacao, pg_catalog;
  --INCOERENCIA--
  UPDATE incoerencia_pessoa_possivel SET idpes =  v_idpesNovo WHERE idpes = v_idpesVelho;
  --CONFRONTACAO--
  UPDATE confrontacao SET idpes =  v_idpesNovo WHERE idpes = v_idpesVelho;
  RETURN 0;
END;$_$;


ALTER FUNCTION consistenciacao.fcn_unifica_scd(numeric, numeric) OWNER TO postgres;

--
-- Name: fcn_unifica_sgp(numeric, numeric); Type: FUNCTION; Schema: consistenciacao; Owner: postgres
--

CREATE FUNCTION fcn_unifica_sgp(numeric, numeric) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parametro recebidos
  v_idpesVelho ALIAS for $1;
  v_idpesNovo ALIAS for $2;
BEGIN
  --Unificando as tabelas do sistema de SGP (Sistema de Gerenciamento de Protocolo)--
  SET search_path = protocolo, pg_catalog;
  --ATIVIDADE--
  UPDATE atividade SET idpes_ini = v_idpesNovo WHERE idpes_ini = v_idpesVelho;
  UPDATE atividade SET idpes_fim = v_idpesNovo WHERE idpes_fim = v_idpesVelho;
  --LOG_FUNC_PROCESSO--
  UPDATE log_func_processo SET idpes = v_idpesNovo WHERE idpes = v_idpesVelho;
  --PROCESSO--
  UPDATE processo SET idpesreq = v_idpesNovo WHERE idpesreq = v_idpesVelho;
  UPDATE processo SET idpesfav = v_idpesNovo WHERE idpesfav = v_idpesVelho;
  --TEMP_ATIVIDADE--
  UPDATE temp_atividade SET idpes = v_idpesNovo WHERE idpes = v_idpesVelho;
  RETURN 0;
END;$_$;


ALTER FUNCTION consistenciacao.fcn_unifica_sgp(numeric, numeric) OWNER TO postgres;

--
-- Name: fcn_unifica_sgpa(numeric, numeric); Type: FUNCTION; Schema: consistenciacao; Owner: postgres
--

CREATE FUNCTION fcn_unifica_sgpa(numeric, numeric) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parametro recebidos
  v_idpesVelho  ALIAS for $1;
  v_idpesNovo   ALIAS for $2;
  v_reg       record;
  v_idAtnVelho  numeric;
  v_idAtnNovo numeric;
BEGIN
  --Unificando as tabelas do sistema de SGPA (Sistema de getao da Praca de Atendimento)--
  SET search_path = praca, pg_catalog;
  --Obtendo o id do atendente velho para poder fazer UPDATE nas tabelas para o id do atendeentente novo--
  FOR v_reg IN SELECT idatn FROM atendente WHERE idpes = v_idpesVelho LOOP
    v_idAtnVelho := v_reg.idatn;
  END LOOP;
  FOR v_reg IN SELECT idatn FROM atendente WHERE idpes = v_idpesNovo LOOP
    v_idAtnNovo := v_reg.idatn;
  END LOOP;
  --ATENDIMENTO--
  UPDATE atendimento SET idpes = v_idpesNovo WHERE idpes = v_idpesVelho;
  UPDATE atendimento SET idatn = v_idAtnNovo WHERE idatn = v_idAtnVelho;
  --TURNO_ATENDENTE--
  FOR v_reg IN SELECT * FROM turno_atendente
         WHERE
         idatn = v_idAtnVelho AND
         idtur NOT IN (SELECT idtur FROM turno_atendente WHERE idatn = v_idAtnNovo) LOOP
    INSERT INTO turno_atendente (idmes,idins,idatn,idtur) VALUES (v_reg.idmes, v_reg.idins, v_idAtnNovo,v_reg.idtur);
  END LOOP;
  DELETE FROM turno_atendente WHERE idatn = v_idAtnVelho;
  --AUSENCIA--
  UPDATE ausencia SET idatn = v_idAtnNovo WHERE idatn = v_idAtnVelho;
  --SITUCAO_ATENDENTE--
  UPDATE situacao_atendente SET idatn = v_idAtnNovo WHERE idatn = v_idAtnVelho;
  --PRODUTIVIDADE--
  UPDATE produtividade SET idatn = v_idAtnNovo WHERE idatn = v_idAtnVelho;
  --ATENDENTE--
  DELETE FROM atendente WHERE idpes = v_idpesVelho;
  RETURN 0;
END;$_$;


ALTER FUNCTION consistenciacao.fcn_unifica_sgpa(numeric, numeric) OWNER TO postgres;

--
-- Name: fcn_unifica_sgsp(numeric, numeric); Type: FUNCTION; Schema: consistenciacao; Owner: postgres
--

CREATE FUNCTION fcn_unifica_sgsp(numeric, numeric) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parametro recebidos
  v_idpesVelho ALIAS for $1;
  v_idpesNovo  ALIAS for $2;
  v_reg      record;
BEGIN
  --Unificando registros das tabelas do SGSP (Sistema de Gererenciamento de Serviços Públicos)--
  SET search_path = servicos, pg_catalog;
  --FUNCIONARIO_AUTORIZADO--
  FOR v_reg IN SELECT *
         FROM funcionario_autorizado
         WHERE
         idpes = v_idpesVelho AND
         idpes <> v_idpesNovo LOOP
    INSERT INTO funcionario_autorizado (idpes, idins) VALUES (v_idpesNovo, v_reg.idins);
  END LOOP;
  --SOLICITACAO_SERVICO--
  UPDATE solicitacao_servico SET idpes_atendente = v_idpesNovo WHERE idpes_atendente = v_idpesVelho;
  UPDATE solicitacao_servico SET idpes_planejamento = v_idpesNovo WHERE idpes_planejamento = v_idpesVelho;
  --SOLICITANTE--
  UPDATE solicitante SET idpes = v_idpesNovo WHERE idpes = v_idpesVelho;
  --ORDEM_SERVICO--
  UPDATE ordem_servico SET idpes = v_idpesNovo WHERE idpes = v_idpesVelho;
  --APROVACAO--
  UPDATE aprovacao SET idpes_resposta = v_idpesNovo WHERE idpes_resposta = v_idpesVelho;
  --AUTORIZACAO_DIARIA--
  UPDATE autorizacao_diaria SET idpes_usuario = v_idpesNovo WHERE idpes_usuario = v_idpesVelho;
  UPDATE autorizacao_diaria SET idpes_autorizacao = v_idpesNovo WHERE idpes_autorizacao = v_idpesVelho;
  --FUNCIONARIO_AUTORIZADO--
  DELETE FROM funcionario_autorizado WHERE idpes = v_idpesVelho;
  RETURN 0;
END;$_$;


ALTER FUNCTION consistenciacao.fcn_unifica_sgsp(numeric, numeric) OWNER TO postgres;

SET search_path = conv_functions, pg_catalog;

--
-- Name: pr_normaliza_enderecos(); Type: FUNCTION; Schema: conv_functions; Owner: postgres
--

CREATE FUNCTION pr_normaliza_enderecos() RETURNS void
    LANGUAGE plpgsql
    AS $$
DECLARE
cur 	record;
i_counter integer;
i_idmun integer;
i_iddis integer;
i_idbai integer;
i_idlog integer;

BEGIN

i_counter := 0;

for cur in SELECT
      ee.idpes,
      ee.idtlog,
      ee.logradouro,
      ee.numero,
      ee.letra,
      ee.complemento,
      ee.bairro,
      ee.cep,
      ee.bloco,
      ee.andar,
      ee.cidade,
      ee.zona_localizacao,
      upper(ee.sigla_uf) as sigla_uf

    FROM cadastro.pessoa p
    LEFT JOIN cadastro.endereco_pessoa ep
      ON ep.idpes = p.idpes
    LEFT JOIN cadastro.endereco_externo ee
      ON ee.idpes = p.idpes
    WHERE ep.idpes is null
    and ee.idpes is not null loop

  i_counter := i_counter + 1;

  i_idmun := 0;
  i_iddis := 0;
  i_idbai := 0;
  i_idlog := 0;

  raise notice 'counter: %', i_counter;

  SELECT COALESCE((select m.idmun
            from public.municipio m
            WHERE unaccent(nome) ilike unaccent(cur.cidade)
            AND sigla_uf = cur.sigla_uf
            LIMIT 1),0) INTO i_idmun;

  If i_idmun = 0 then
    INSERT INTO public.municipio (nome, sigla_uf, tipo, idpes_cad, data_cad, origem_gravacao, operacao, idsis_cad)
      VALUES (cur.cidade, cur.sigla_uf, 'M', 1, NOW(), 'M', 'I', 9) RETURNING idmun INTO i_idmun ;
  End if;

  SELECT COALESCE((SELECT b.idbai
              FROM public.bairro b
              WHERE trim(unaccent(nome)) ilike trim(unaccent(cur.bairro))
              AND b.idmun = i_idmun
              LIMIT 1),0) INTO i_idbai;

  If i_idbai = 0 then
    SELECT COALESCE((SELECT d.iddis
                  FROM public.distrito d
                  WHERE d.idmun = i_idmun
                  LIMIT 1),0) INTO i_iddis;


    If i_iddis = 0 then
      INSERT INTO public.distrito (idmun, nome, origem_gravacao, idpes_cad, data_cad, operacao, idsis_cad)
        VALUES (i_idmun, cur.cidade, 'M', 1, now(), 'I', 1) returning iddis INTO i_iddis;
    End if;

    INSERT INTO public.bairro (idmun, iddis, nome, origem_gravacao, idpes_cad, data_cad, operacao, idsis_cad, zona_localizacao)
      VALUES (i_idmun, i_iddis, cur.bairro, 'M', 1, NOW(), 'I', 1, cur.zona_localizacao) RETURNING idbai INTO i_idbai;
  End if;

  SELECT COALESCE((SELECT idlog
    FROM public.logradouro
    WHERE idmun = i_idmun
    AND trim(unaccent(nome)) ILIKE trim(unaccent(cur.logradouro))
    LIMIT 1
    ),0) INTO i_idlog;

  If i_idlog = 0 THEN
    INSERT INTO public.logradouro (idtlog, nome, idmun, ident_oficial, origem_gravacao, idpes_cad, data_cad, operacao, idsis_cad)
    VALUES (cur.idtlog, cur.logradouro, i_idmun, 'S', 'M', 1, NOW(), 'I', 1) RETURNING idlog INTO i_idlog;

  End if;

  If NOT EXISTS (SELECT 1
              FROM urbano.cep_logradouro
              WHERE cep = cur.cep
              AND idlog = i_idlog) THEN
    INSERT INTO urbano.cep_logradouro (cep, idlog, origem_gravacao, idpes_cad, data_cad, operacao, idsis_cad)
      VALUES (cur.cep, i_idlog, 'M', 1, NOW(), 'I', 1);
  END if;

  If NOT EXISTS (SELECT 1
              FROM urbano.cep_logradouro_bairro
              WHERE cep = cur.cep
              AND idlog = i_idlog
              AND idbai = i_idbai
              ) THEN
    INSERT INTO urbano.cep_logradouro_bairro (cep, idlog, idbai, origem_gravacao, idpes_cad, data_cad, operacao, idsis_cad)
      VALUES (cur.cep, i_idlog, i_idbai, 'M', 1, NOW(), 'I', 1);
  END if;

  INSERT INTO cadastro.endereco_pessoa (idpes, tipo, cep, idlog, numero, letra, complemento, idbai, bloco, andar,  origem_gravacao, idpes_cad, data_cad, operacao, idsis_cad)
    VALUES (cur.idpes, 1, cur.cep, i_idlog, cur.numero, cur.letra, cur.complemento, i_idbai, cur.bloco, cur.andar, 'M', 1, NOW(), 'I', 1);

end loop;

end;
$$;


ALTER FUNCTION conv_functions.pr_normaliza_enderecos() OWNER TO postgres;

SET search_path = historico, pg_catalog;

--
-- Name: fcn_delete_grava_historico_bairro(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_delete_grava_historico_bairro() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idbai    numeric;
   v_idmun    numeric;
   v_nome   varchar;
   v_idpes_rev    numeric;
   v_data_rev   TIMESTAMP;
   v_origem_gravacao  char(1);
   v_idsis_rev    numeric;
   v_idpes_cad    numeric;
   v_data_cad   TIMESTAMP;
   v_idsis_cad    numeric;
BEGIN
   v_idbai    := OLD.idbai;
   v_idmun    := OLD.idmun;
   v_nome   := OLD.nome;
   v_idpes_rev    := OLD.idpes_rev;
   v_data_rev   := OLD.data_rev;
   v_origem_gravacao  := OLD.origem_gravacao;
   v_idsis_rev    := OLD.idsis_rev;
   v_idpes_cad    := OLD.idpes_cad;
   v_data_cad   := OLD.data_cad;
   v_idsis_cad    := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA BAIRRO
      INSERT INTO historico.bairro
      (idbai, idmun, nome, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idbai, v_idmun, v_nome, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_delete_grava_historico_bairro() OWNER TO postgres;

--
-- Name: fcn_delete_grava_historico_cep_logradouro(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_delete_grava_historico_cep_logradouro() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_cep    numeric;
   v_idlog    numeric;
   v_nroini   numeric;
   v_nrofin   numeric;
   v_idpes_rev    numeric;
   v_data_rev   TIMESTAMP;
   v_origem_gravacao  char(1);
   v_idsis_rev    numeric;
   v_idpes_cad    numeric;
   v_data_cad   TIMESTAMP;
   v_idsis_cad    numeric;
BEGIN
   v_cep    := OLD.cep;
   v_idlog    := OLD.idlog;
   v_nroini   := OLD.nroini;
   v_nrofin   := OLD.nrofin;
   v_idpes_rev    := OLD.idpes_rev;
   v_data_rev   := OLD.data_rev;
   v_origem_gravacao  := OLD.origem_gravacao;
   v_idsis_rev    := OLD.idsis_rev;
   v_idpes_cad    := OLD.idpes_cad;
   v_data_cad   := OLD.data_cad;
   v_idsis_cad    := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA CEP_LOGRADOURO
      INSERT INTO historico.cep_logradouro
      (cep, idlog, nroini, nrofin, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_cep, v_idlog, v_nroini, v_nrofin, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_delete_grava_historico_cep_logradouro() OWNER TO postgres;

--
-- Name: fcn_delete_grava_historico_cep_logradouro_bairro(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_delete_grava_historico_cep_logradouro_bairro() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idbai    numeric;
   v_idlog    numeric;
   v_cep    numeric;
   v_idpes_rev    numeric;
   v_data_rev   TIMESTAMP;
   v_origem_gravacao  char(1);
   v_idsis_rev    numeric;
   v_idpes_cad    numeric;
   v_data_cad   TIMESTAMP;
   v_idsis_cad    numeric;
   v_operacao   char(1);
BEGIN
   v_idbai    := OLD.idbai;
   v_idlog    := OLD.idlog;
   v_cep    := OLD.cep;
   v_idpes_rev    := OLD.idpes_rev;
   v_data_rev   := OLD.data_rev;
   v_origem_gravacao  := OLD.origem_gravacao;
   v_idsis_rev    := OLD.idsis_rev;
   v_idpes_cad    := OLD.idpes_cad;
   v_data_cad   := OLD.data_cad;
   v_idsis_cad    := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA CEP_LOGRADOURO_BAIRRO
      INSERT INTO historico.cep_logradouro_bairro
      (idbai, idlog, cep, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idbai, v_idlog, v_cep, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_delete_grava_historico_cep_logradouro_bairro() OWNER TO postgres;

--
-- Name: fcn_delete_grava_historico_documento(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_delete_grava_historico_documento() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes    numeric;
   v_sigla_uf_exp_rg  char(2);
   v_rg     numeric;
   v_data_exp_rg  date;
   v_tipo_cert_civil  numeric;
   v_num_termo    numeric;
   v_num_livro    varchar;
   v_num_folha    numeric;
   v_data_emissao_cert_civil  date;
   v_sigla_uf_cert_civil  char(2);
   v_sigla_uf_cart_trabalho char(2);
   v_cartorio_cert_civil  varchar;
   v_num_cart_trabalho    numeric;
   v_serie_cart_trabalho  numeric;
   v_data_emissao_cart_trabalho date;
   v_num_tit_eleitor  numeric;
   v_zona_tit_eleitor numeric;
   v_secao_tit_eleitor  numeric;
   v_idorg_exp_rg   numeric;
   v_idpes_rev    numeric;
   v_data_rev   TIMESTAMP;
   v_origem_gravacao  char(1);
   v_idsis_rev    numeric;
   v_idpes_cad    numeric;
   v_data_cad   TIMESTAMP;
   v_idsis_cad    numeric;
BEGIN
   v_idpes      := OLD.idpes;
   v_sigla_uf_exp_rg    := OLD.sigla_uf_exp_rg;
   v_rg       := OLD.rg;
   v_data_exp_rg    := OLD.data_exp_rg;
   v_tipo_cert_civil    := OLD.tipo_cert_civil;
   v_num_termo      := OLD.num_termo;
   v_num_livro      := OLD.num_livro;
   v_num_folha      := OLD.num_folha;
   v_data_emissao_cert_civil  := OLD.data_emissao_cert_civil;
   v_sigla_uf_cert_civil  := OLD.sigla_uf_cert_civil;
   v_sigla_uf_cart_trabalho := OLD.sigla_uf_cart_trabalho;
   v_cartorio_cert_civil  := OLD.cartorio_cert_civil;
   v_num_cart_trabalho    := OLD.num_cart_trabalho;
   v_serie_cart_trabalho  := OLD.serie_cart_trabalho;
   v_data_emissao_cart_trabalho := OLD.data_emissao_cart_trabalho;
   v_num_tit_eleitor    := OLD.num_tit_eleitor;
   v_zona_tit_eleitor   := OLD.zona_tit_eleitor;
   v_secao_tit_eleitor    := OLD.secao_tit_eleitor;
   v_idorg_exp_rg   := OLD.idorg_exp_rg;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA DOCUMENTO
      INSERT INTO historico.documento
      (idpes, sigla_uf_exp_rg, rg, data_exp_rg, tipo_cert_civil, num_termo, num_livro, num_folha, data_emissao_cert_civil, sigla_uf_cert_civil, sigla_uf_cart_trabalho, cartorio_cert_civil, num_cart_trabalho, serie_cart_trabalho, data_emissao_cart_trabalho, num_tit_eleitor, zona_tit_eleitor, secao_tit_eleitor, idorg_exp_rg, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_sigla_uf_exp_rg, v_rg, v_data_exp_rg, v_tipo_cert_civil, v_num_termo, v_num_livro, v_num_folha, v_data_emissao_cert_civil, v_sigla_uf_cert_civil, v_sigla_uf_cart_trabalho, v_cartorio_cert_civil, v_num_cart_trabalho, v_serie_cart_trabalho, v_data_emissao_cart_trabalho, v_num_tit_eleitor, v_zona_tit_eleitor, v_secao_tit_eleitor, v_idorg_exp_rg, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_delete_grava_historico_documento() OWNER TO postgres;

--
-- Name: fcn_delete_grava_historico_endereco_externo(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_delete_grava_historico_endereco_externo() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes    numeric;
   v_tipo   numeric;
   v_sigla_uf   char(2);
   v_idtlog   varchar;
   v_logradouro   varchar;
   v_numero   numeric;
   v_letra    char(1);
   v_complemento  varchar;
   v_bairro   varchar;
   v_cep    numeric;
   v_cidade   varchar;
   v_reside_desde date;
   v_idpes_rev    numeric;
   v_data_rev   TIMESTAMP;
   v_origem_gravacao  char(1);
   v_idsis_rev    numeric;
   v_idpes_cad    numeric;
   v_data_cad   TIMESTAMP;
   v_idsis_cad    numeric;
BEGIN
   v_idpes      := OLD.idpes;
   v_tipo     := OLD.tipo;
   v_sigla_uf     := OLD.sigla_uf;
   v_idtlog     := OLD.idtlog;
   v_logradouro     := OLD.logradouro;
   v_numero     := OLD.numero;
   v_letra      := OLD.letra;
   v_complemento    := OLD.complemento;
   v_bairro     := OLD.bairro;
   v_cep      := OLD.cep;
   v_cidade     := OLD.cidade;
   v_reside_desde   := OLD.reside_desde;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA ENDERECO_EXTERNO
      INSERT INTO historico.endereco_externo
      (idpes, tipo, sigla_uf, idtlog, logradouro, numero, letra, complemento, bairro, cep, cidade, reside_desde, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_tipo, v_sigla_uf, v_idtlog, v_logradouro, v_numero, v_letra, v_complemento, v_bairro, v_cep, v_cidade, v_reside_desde, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_delete_grava_historico_endereco_externo() OWNER TO postgres;

--
-- Name: fcn_delete_grava_historico_endereco_pessoa(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_delete_grava_historico_endereco_pessoa() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes    numeric;
   v_tipo   numeric;
   v_cep    numeric;
   v_idlog    numeric;
   v_idbai    numeric;
   v_numero   numeric;
   v_letra    char(1);
   v_complemento  varchar;
   v_reside_desde date;
   v_idpes_rev    numeric;
   v_data_rev   TIMESTAMP;
   v_origem_gravacao  char(1);
   v_idsis_rev    numeric;
   v_idpes_cad    numeric;
   v_data_cad   TIMESTAMP;
   v_idsis_cad    numeric;
BEGIN
   v_idpes    := OLD.idpes;
   v_tipo   := OLD.tipo;
   v_cep    := OLD.cep;
   v_idlog    := OLD.idlog;
   v_idbai    := OLD.idbai;
   v_numero   := OLD.numero;
   v_letra    := OLD.letra;
   v_complemento  := OLD.complemento;
   v_reside_desde := OLD.reside_desde;
   v_idpes_rev    := OLD.idpes_rev;
   v_data_rev   := OLD.data_rev;
   v_origem_gravacao  := OLD.origem_gravacao;
   v_idsis_rev    := OLD.idsis_rev;
   v_idpes_cad    := OLD.idpes_cad;
   v_data_cad   := OLD.data_cad;
   v_idsis_cad    := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA ENDERECO_PESSOA
      INSERT INTO historico.endereco_pessoa
      (idpes, tipo, cep, idlog, idbai, numero, letra, complemento, reside_desde, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_tipo, v_cep, v_idlog, v_idbai, v_numero, v_letra, v_complemento, v_reside_desde, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_delete_grava_historico_endereco_pessoa() OWNER TO postgres;

--
-- Name: fcn_delete_grava_historico_fisica(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_delete_grava_historico_fisica() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes      numeric;
   v_data_nasc      date;
   v_sexo     char(1);
   v_idpes_mae      numeric;
   v_idpes_pai      numeric;
   v_idpes_responsavel    numeric;
   v_idesco     numeric;
   v_ideciv     numeric;
   v_idpes_con      numeric;
   v_data_uniao     date;
   v_data_obito     date;
   v_nacionalidade    numeric;
   v_idpais_estrangeiro   numeric;
   v_data_chegada_brasil  date;
   v_idmun_nascimento   numeric;
   v_ultima_empresa   varchar;
   v_idocup     numeric;
   v_nome_mae     varchar;
   v_nome_pai     varchar;
   v_nome_conjuge   varchar;
   v_nome_responsavel   varchar;
   v_justificativa_provisorio varchar;
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
BEGIN
   v_idpes      := OLD.idpes;
   v_data_nasc      := OLD.data_nasc;
   v_sexo     := OLD.sexo;
   v_idpes_mae      := OLD.idpes_mae;
   v_idpes_pai      := OLD.idpes_pai;
   v_idpes_responsavel    := OLD.idpes_responsavel;
   v_idesco     := OLD.idesco;
   v_ideciv     := OLD.ideciv;
   v_idpes_con      := OLD.idpes_con;
   v_data_uniao     := OLD.data_uniao;
   v_data_obito     := OLD.data_obito;
   v_nacionalidade    := OLD.nacionalidade;
   v_idpais_estrangeiro   := OLD.idpais_estrangeiro;
   v_data_chegada_brasil  := OLD.data_chegada_brasil;
   v_idmun_nascimento   := OLD.idmun_nascimento;
   v_ultima_empresa   := OLD.ultima_empresa;
   v_idocup     := OLD.idocup;
   v_nome_mae     := OLD.nome_mae;
   v_nome_pai     := OLD.nome_pai;
   v_nome_conjuge   := OLD.nome_conjuge;
   v_nome_responsavel   := OLD.nome_responsavel;
   v_justificativa_provisorio := OLD.justificativa_provisorio;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA FISICA
      INSERT INTO historico.fisica
      (idpes, data_nasc, sexo, idpes_mae, idpes_pai, idpes_responsavel, idesco, ideciv, idpes_con, data_uniao, data_obito, nacionalidade, idpais_estrangeiro, data_chegada_brasil, idmun_nascimento, ultima_empresa, idocup, nome_mae, nome_pai, nome_conjuge, nome_responsavel, justificativa_provisorio, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_data_nasc, v_sexo, v_idpes_mae, v_idpes_pai, v_idpes_responsavel, v_idesco, v_ideciv, v_idpes_con, v_data_uniao, v_data_obito, v_nacionalidade, v_idpais_estrangeiro, v_data_chegada_brasil, v_idmun_nascimento, v_ultima_empresa, v_idocup, v_nome_mae, v_nome_pai, v_nome_conjuge, v_nome_responsavel, v_justificativa_provisorio, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_delete_grava_historico_fisica() OWNER TO postgres;

--
-- Name: fcn_delete_grava_historico_fisica_cpf(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_delete_grava_historico_fisica_cpf() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes      numeric;
   v_cpf      numeric;
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
BEGIN
   v_idpes      := OLD.idpes;
   v_cpf      := OLD.cpf;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA FISICA_CPF
      INSERT INTO historico.fisica_cpf
      (idpes, cpf, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_cpf, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_delete_grava_historico_fisica_cpf() OWNER TO postgres;

--
-- Name: fcn_delete_grava_historico_fone_pessoa(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_delete_grava_historico_fone_pessoa() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes      numeric;
   v_tipo     numeric;
   v_ddd      numeric;
   v_fone     numeric;
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
BEGIN
   v_idpes      := OLD.idpes;
   v_tipo     := OLD.tipo;
   v_ddd      := OLD.ddd;
   v_fone     := OLD.fone;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA FONE_PESSOA
      INSERT INTO historico.fone_pessoa
      (idpes, tipo, ddd, fone, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_tipo, v_ddd, v_fone, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_delete_grava_historico_fone_pessoa() OWNER TO postgres;

--
-- Name: fcn_delete_grava_historico_funcionario(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_delete_grava_historico_funcionario() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_matricula      numeric;
   v_idins      numeric;
   v_idset      numeric;
   v_idpes      numeric;
   v_situacao     char(1);
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
BEGIN
   v_matricula      := OLD.matricula;
   v_idins      := OLD.idins;
   v_idset      := OLD.idset;
   v_idpes      := OLD.idpes;
   v_situacao     := OLD.situacao;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA FUNCIONARIO
      INSERT INTO historico.funcionario
      (matricula, idins, idset, idpes, situacao, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_matricula, v_idins, v_idset, v_idpes, v_situacao, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_delete_grava_historico_funcionario() OWNER TO postgres;

--
-- Name: fcn_delete_grava_historico_juridica(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_delete_grava_historico_juridica() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes      numeric;
   v_cnpj     numeric;
   v_fantasia     varchar;
   v_insc_estadual    numeric;
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
BEGIN
   v_idpes      := OLD.idpes;
   v_cnpj     := OLD.cnpj;
   v_fantasia     := OLD.fantasia;
   v_insc_estadual    := OLD.insc_estadual;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA JURIDICA
      INSERT INTO historico.juridica
      (idpes, cnpj, fantasia, insc_estadual, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_cnpj, v_fantasia, v_insc_estadual, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_delete_grava_historico_juridica() OWNER TO postgres;

--
-- Name: fcn_delete_grava_historico_logradouro(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_delete_grava_historico_logradouro() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idlog      numeric;
   v_idtlog     varchar;
   v_nome     varchar;
   v_idmun      numeric;
   v_ident_oficial    char(1);
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
BEGIN
   v_idlog      := OLD.idlog;
   v_idtlog     := OLD.idtlog;
   v_nome     := OLD.nome;
   v_idmun      := OLD.idmun;
   v_ident_oficial    := OLD.ident_oficial;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA LOGRADOURO
      INSERT INTO historico.logradouro
      (idlog, idtlog, nome, idmun, ident_oficial, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idlog, v_idtlog, v_nome, v_idmun, v_ident_oficial, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_delete_grava_historico_logradouro() OWNER TO postgres;

--
-- Name: fcn_delete_grava_historico_municipio(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_delete_grava_historico_municipio() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idmun      numeric;
   v_sigla_uf     char(2);
   v_nome     varchar;
   v_area_km2     numeric;
   v_idmreg     numeric;
   v_idasmun      numeric;
   v_cod_ibge     numeric;
   v_geom     TEXT;
   v_tipo     char(1);
   v_idmun_pai      numeric;
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
BEGIN
   v_idmun      := OLD.idmun;
   v_sigla_uf     := OLD.sigla_uf;
   v_nome     := OLD.nome;
   v_area_km2     := OLD.area_km2;
   v_idmreg     := OLD.idmreg;
   v_idasmun      := OLD.idasmun;
   v_cod_ibge     := OLD.cod_ibge;
   v_geom     := OLD.geom;
   v_tipo     := OLD.tipo;
   v_idmun_pai      := OLD.idmun_pai;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA MUNICIPIO
      INSERT INTO historico.municipio
      (idmun, sigla_uf, nome, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idmun, v_sigla_uf, v_nome, v_area_km2, v_idmreg, v_idasmun, v_cod_ibge, v_geom, v_tipo, v_idmun_pai, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_delete_grava_historico_municipio() OWNER TO postgres;

--
-- Name: fcn_delete_grava_historico_pessoa(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_delete_grava_historico_pessoa() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes    numeric;
   v_nome   TEXT;
   v_idpes_cad    numeric;
   v_data_cad   timestamp;
   v_url    TEXT;
   v_tipo   char;
   v_idpes_rev    numeric;
   v_data_rev   timestamp;
   v_email    TEXT;
   v_situacao   char;
   v_origem_gravacao  char;
   v_idsis_rev    numeric;
   v_idsis_cad    numeric;
BEGIN
   v_idpes    := OLD.idpes;
   v_nome   := OLD.nome;
   v_idpes_cad    := OLD.idpes_cad;
   v_data_cad   := OLD.data_cad;
   v_url    := OLD.url;
   v_tipo   := OLD.tipo;
   v_idpes_rev    := OLD.idpes_rev;
   v_data_rev   := OLD.data_rev;
   v_email    := OLD.email;
   v_situacao   := OLD.situacao;
   v_origem_gravacao  := OLD.origem_gravacao;
   v_idsis_rev    := OLD.idsis_rev;
   v_idsis_cad    := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA PESSOA
      INSERT INTO historico.pessoa
      (idpes, nome, idpes_cad, data_cad, url, tipo, idpes_rev, data_rev, email, situacao, origem_gravacao, idsis_rev, idsis_cad, operacao) VALUES
      (v_idpes, v_nome, v_idpes_cad, v_data_cad, v_url, v_tipo, v_idpes_rev, v_data_rev, v_email, v_situacao, v_origem_gravacao, v_idsis_rev, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_delete_grava_historico_pessoa() OWNER TO postgres;

--
-- Name: fcn_delete_grava_historico_socio(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_delete_grava_historico_socio() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes_juridica   numeric;
   v_idpes_fisica   numeric;
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
BEGIN
   v_idpes_juridica   := OLD.idpes_juridica;
   v_idpes_fisica   := OLD.idpes_fisica;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA SOCIO
      INSERT INTO historico.socio
      (idpes_juridica, idpes_fisica, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes_juridica, v_idpes_fisica, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, 'E');

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_delete_grava_historico_socio() OWNER TO postgres;

--
-- Name: fcn_grava_historico_bairro(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_grava_historico_bairro() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idbai    numeric;
   v_idmun    numeric;
   v_nome   varchar;
   v_idpes_rev    numeric;
   v_data_rev   TIMESTAMP;
   v_origem_gravacao  char(1);
   v_idsis_rev    numeric;
   v_idpes_cad    numeric;
   v_data_cad   TIMESTAMP;
   v_idsis_cad    numeric;
   v_operacao   char(1);
BEGIN
   v_idbai    := OLD.idbai;
   v_idmun    := OLD.idmun;
   v_nome   := OLD.nome;
   v_idpes_rev    := OLD.idpes_rev;
   v_data_rev   := OLD.data_rev;
   v_origem_gravacao  := OLD.origem_gravacao;
   v_idsis_rev    := OLD.idsis_rev;
   v_idpes_cad    := OLD.idpes_cad;
   v_data_cad   := OLD.data_cad;
   v_idsis_cad    := OLD.idsis_cad;
   v_operacao   := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA BAIRRO
      INSERT INTO historico.bairro
      (idbai, idmun, nome, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idbai, v_idmun, v_nome, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_grava_historico_bairro() OWNER TO postgres;

--
-- Name: fcn_grava_historico_cep_logradouro(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_grava_historico_cep_logradouro() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_cep    numeric;
   v_idlog    numeric;
   v_nroini   numeric;
   v_nrofin   numeric;
   v_idpes_rev    numeric;
   v_data_rev   TIMESTAMP;
   v_origem_gravacao  char(1);
   v_idsis_rev    numeric;
   v_idpes_cad    numeric;
   v_data_cad   TIMESTAMP;
   v_idsis_cad    numeric;
   v_operacao   char(1);
BEGIN
   v_cep    := OLD.cep;
   v_idlog    := OLD.idlog;
   v_nroini   := OLD.nroini;
   v_nrofin   := OLD.nrofin;
   v_idpes_rev    := OLD.idpes_rev;
   v_data_rev   := OLD.data_rev;
   v_origem_gravacao  := OLD.origem_gravacao;
   v_idsis_rev    := OLD.idsis_rev;
   v_idpes_cad    := OLD.idpes_cad;
   v_data_cad   := OLD.data_cad;
   v_idsis_cad    := OLD.idsis_cad;
   v_operacao   := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA CEP_LOGRADOURO
      INSERT INTO historico.cep_logradouro
      (cep, idlog, nroini, nrofin, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_cep, v_idlog, v_nroini, v_nrofin, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_grava_historico_cep_logradouro() OWNER TO postgres;

--
-- Name: fcn_grava_historico_cep_logradouro_bairro(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_grava_historico_cep_logradouro_bairro() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idbai    numeric;
   v_idlog    numeric;
   v_cep    numeric;
   v_idpes_rev    numeric;
   v_data_rev   TIMESTAMP;
   v_origem_gravacao  char(1);
   v_idsis_rev    numeric;
   v_idpes_cad    numeric;
   v_data_cad   TIMESTAMP;
   v_idsis_cad    numeric;
   v_operacao   char(1);
BEGIN
   v_idbai    := OLD.idbai;
   v_idlog    := OLD.idlog;
   v_cep    := OLD.cep;
   v_idpes_rev    := OLD.idpes_rev;
   v_data_rev   := OLD.data_rev;
   v_origem_gravacao  := OLD.origem_gravacao;
   v_idsis_rev    := OLD.idsis_rev;
   v_idpes_cad    := OLD.idpes_cad;
   v_data_cad   := OLD.data_cad;
   v_idsis_cad    := OLD.idsis_cad;
   v_operacao   := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA CEP_LOGRADOURO_BAIRRO
      INSERT INTO historico.cep_logradouro_bairro
      (idbai, idlog, cep, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idbai, v_idlog, v_cep, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_grava_historico_cep_logradouro_bairro() OWNER TO postgres;

--
-- Name: fcn_grava_historico_documento(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_grava_historico_documento() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes    numeric;
   v_sigla_uf_exp_rg  char(2);
   v_rg     text;
   v_data_exp_rg  date;
   v_tipo_cert_civil  numeric;
   v_num_termo    numeric;
   v_num_livro    varchar;
   v_num_folha    numeric;
   v_data_emissao_cert_civil  date;
   v_sigla_uf_cert_civil  char(2);
   v_sigla_uf_cart_trabalho char(2);
   v_cartorio_cert_civil  varchar;
   v_num_cart_trabalho    numeric;
   v_serie_cart_trabalho  numeric;
   v_data_emissao_cart_trabalho date;
   v_num_tit_eleitor  numeric;
   v_zona_tit_eleitor numeric;
   v_secao_tit_eleitor  numeric;
   v_idorg_exp_rg   numeric;
   v_idpes_rev    numeric;
   v_data_rev   TIMESTAMP;
   v_origem_gravacao  char(1);
   v_idsis_rev    numeric;
   v_idpes_cad    numeric;
   v_data_cad   TIMESTAMP;
   v_idsis_cad    numeric;
   v_operacao   char(1);
BEGIN
   v_idpes      := OLD.idpes;
   v_sigla_uf_exp_rg    := OLD.sigla_uf_exp_rg;
   v_rg       := OLD.rg;
   v_data_exp_rg    := OLD.data_exp_rg;
   v_tipo_cert_civil    := OLD.tipo_cert_civil;
   v_num_termo      := OLD.num_termo;
   v_num_livro      := OLD.num_livro;
   v_num_folha      := OLD.num_folha;
   v_data_emissao_cert_civil  := OLD.data_emissao_cert_civil;
   v_sigla_uf_cert_civil  := OLD.sigla_uf_cert_civil;
   v_sigla_uf_cart_trabalho := OLD.sigla_uf_cart_trabalho;
   v_cartorio_cert_civil  := OLD.cartorio_cert_civil;
   v_num_cart_trabalho    := OLD.num_cart_trabalho;
   v_serie_cart_trabalho  := OLD.serie_cart_trabalho;
   v_data_emissao_cart_trabalho := OLD.data_emissao_cart_trabalho;
   v_num_tit_eleitor    := OLD.num_tit_eleitor;
   v_zona_tit_eleitor   := OLD.zona_tit_eleitor;
   v_secao_tit_eleitor    := OLD.secao_tit_eleitor;
   v_idorg_exp_rg   := OLD.idorg_exp_rg;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;
   v_operacao     := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA DOCUMENTO
      INSERT INTO historico.documento
      (idpes, sigla_uf_exp_rg, rg, data_exp_rg, tipo_cert_civil, num_termo, num_livro, num_folha, data_emissao_cert_civil, sigla_uf_cert_civil, sigla_uf_cart_trabalho, cartorio_cert_civil, num_cart_trabalho, serie_cart_trabalho, data_emissao_cart_trabalho, num_tit_eleitor, zona_tit_eleitor, secao_tit_eleitor, idorg_exp_rg, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_sigla_uf_exp_rg, v_rg, v_data_exp_rg, v_tipo_cert_civil, v_num_termo, v_num_livro, v_num_folha, v_data_emissao_cert_civil, v_sigla_uf_cert_civil, v_sigla_uf_cart_trabalho, v_cartorio_cert_civil, v_num_cart_trabalho, v_serie_cart_trabalho, v_data_emissao_cart_trabalho, v_num_tit_eleitor, v_zona_tit_eleitor, v_secao_tit_eleitor, v_idorg_exp_rg, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_grava_historico_documento() OWNER TO postgres;

--
-- Name: fcn_grava_historico_endereco_externo(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_grava_historico_endereco_externo() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes    numeric;
   v_tipo   numeric;
   v_sigla_uf   char(2);
   v_idtlog   varchar;
   v_logradouro   varchar;
   v_numero   numeric;
   v_letra    char(1);
   v_complemento  varchar;
   v_bairro   varchar;
   v_cep    numeric;
   v_cidade   varchar;
   v_reside_desde date;
   v_idpes_rev    numeric;
   v_data_rev   TIMESTAMP;
   v_origem_gravacao  char(1);
   v_idsis_rev    numeric;
   v_idpes_cad    numeric;
   v_data_cad   TIMESTAMP;
   v_idsis_cad    numeric;
   v_operacao   char(1);
BEGIN
   v_idpes    := OLD.idpes;
   v_tipo   := OLD.tipo;
   v_sigla_uf   := OLD.sigla_uf;
   v_idtlog   := OLD.idtlog;
   v_logradouro   := OLD.logradouro;
   v_numero   := OLD.numero;
   v_letra    := OLD.letra;
   v_complemento  := OLD.complemento;
   v_bairro   := OLD.bairro;
   v_cep    := OLD.cep;
   v_cidade   := OLD.cidade;
   v_reside_desde := OLD.reside_desde;
   v_idpes_rev    := OLD.idpes_rev;
   v_data_rev   := OLD.data_rev;
   v_origem_gravacao  := OLD.origem_gravacao;
   v_idsis_rev    := OLD.idsis_rev;
   v_idpes_cad    := OLD.idpes_cad;
   v_data_cad   := OLD.data_cad;
   v_idsis_cad    := OLD.idsis_cad;
   v_operacao   := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA ENDERECO_EXTERNO
      INSERT INTO historico.endereco_externo
      (idpes, tipo, sigla_uf, idtlog, logradouro, numero, letra, complemento, bairro, cep, cidade, reside_desde, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_tipo, v_sigla_uf, v_idtlog, v_logradouro, v_numero, v_letra, v_complemento, v_bairro, v_cep, v_cidade, v_reside_desde, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_grava_historico_endereco_externo() OWNER TO postgres;

--
-- Name: fcn_grava_historico_endereco_pessoa(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_grava_historico_endereco_pessoa() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes    numeric;
   v_tipo   numeric;
   v_cep    numeric;
   v_idlog    numeric;
   v_idbai    numeric;
   v_numero   numeric;
   v_letra    char(1);
   v_complemento  varchar;
   v_reside_desde date;
   v_idpes_rev    numeric;
   v_data_rev   TIMESTAMP;
   v_origem_gravacao  char(1);
   v_idsis_rev    numeric;
   v_idpes_cad    numeric;
   v_data_cad   TIMESTAMP;
   v_idsis_cad    numeric;
   v_operacao   char(1);
BEGIN
   v_idpes    := OLD.idpes;
   v_tipo   := OLD.tipo;
   v_cep    := OLD.cep;
   v_idlog    := OLD.idlog;
   v_idbai    := OLD.idbai;
   v_numero   := OLD.numero;
   v_letra    := OLD.letra;
   v_complemento  := OLD.complemento;
   v_reside_desde := OLD.reside_desde;
   v_idpes_rev    := OLD.idpes_rev;
   v_data_rev   := OLD.data_rev;
   v_origem_gravacao  := OLD.origem_gravacao;
   v_idsis_rev    := OLD.idsis_rev;
   v_idpes_cad    := OLD.idpes_cad;
   v_data_cad   := OLD.data_cad;
   v_idsis_cad    := OLD.idsis_cad;
   v_operacao   := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA ENDERECO_PESSOA
      INSERT INTO historico.endereco_pessoa
      (idpes, tipo, cep, idlog, idbai, numero, letra, complemento, reside_desde, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_tipo, v_cep, v_idlog, v_idbai, v_numero, v_letra, v_complemento, v_reside_desde, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_grava_historico_endereco_pessoa() OWNER TO postgres;

--
-- Name: fcn_grava_historico_fisica(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_grava_historico_fisica() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes      numeric;
   v_data_nasc      date;
   v_sexo     char(1);
   v_idpes_mae      numeric;
   v_idpes_pai      numeric;
   v_idpes_responsavel    numeric;
   v_idesco     numeric;
   v_ideciv     numeric;
   v_idpes_con      numeric;
   v_data_uniao     date;
   v_data_obito     date;
   v_nacionalidade    numeric;
   v_idpais_estrangeiro   numeric;
   v_data_chegada_brasil  date;
   v_idmun_nascimento   numeric;
   v_ultima_empresa   varchar;
   v_idocup     numeric;
   v_nome_mae     varchar;
   v_nome_pai     varchar;
   v_nome_conjuge   varchar;
   v_nome_responsavel   varchar;
   v_justificativa_provisorio varchar;
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
   v_operacao     char(1);
BEGIN
   v_idpes      := OLD.idpes;
   v_data_nasc      := OLD.data_nasc;
   v_sexo     := OLD.sexo;
   v_idpes_mae      := OLD.idpes_mae;
   v_idpes_pai      := OLD.idpes_pai;
   v_idpes_responsavel    := OLD.idpes_responsavel;
   v_idesco     := OLD.idesco;
   v_ideciv     := OLD.ideciv;
   v_idpes_con      := OLD.idpes_con;
   v_data_uniao     := OLD.data_uniao;
   v_data_obito     := OLD.data_obito;
   v_nacionalidade    := OLD.nacionalidade;
   v_idpais_estrangeiro   := OLD.idpais_estrangeiro;
   v_data_chegada_brasil  := OLD.data_chegada_brasil;
   v_idmun_nascimento   := OLD.idmun_nascimento;
   v_ultima_empresa   := OLD.ultima_empresa;
   v_idocup     := OLD.idocup;
   v_nome_mae     := OLD.nome_mae;
   v_nome_pai     := OLD.nome_pai;
   v_nome_conjuge   := OLD.nome_conjuge;
   v_nome_responsavel   := OLD.nome_responsavel;
   v_justificativa_provisorio := OLD.justificativa_provisorio;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;
   v_operacao     := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA FISICA
      INSERT INTO historico.fisica
      (idpes, data_nasc, sexo, idpes_mae, idpes_pai, idpes_responsavel, idesco, ideciv, idpes_con, data_uniao, data_obito, nacionalidade, idpais_estrangeiro, data_chegada_brasil, idmun_nascimento, ultima_empresa, idocup, nome_mae, nome_pai, nome_conjuge, nome_responsavel, justificativa_provisorio, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_data_nasc, v_sexo, v_idpes_mae, v_idpes_pai, v_idpes_responsavel, v_idesco, v_ideciv, v_idpes_con, v_data_uniao, v_data_obito, v_nacionalidade, v_idpais_estrangeiro, v_data_chegada_brasil, v_idmun_nascimento, v_ultima_empresa, v_idocup, v_nome_mae, v_nome_pai, v_nome_conjuge, v_nome_responsavel, v_justificativa_provisorio, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_grava_historico_fisica() OWNER TO postgres;

--
-- Name: fcn_grava_historico_fisica_cpf(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_grava_historico_fisica_cpf() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes      numeric;
   v_cpf      numeric;
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
   v_operacao     char(1);
BEGIN
   v_idpes      := OLD.idpes;
   v_cpf      := OLD.cpf;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;
   v_operacao     := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA FISICA_CPF
      INSERT INTO historico.fisica_cpf
      (idpes, cpf, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_cpf, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_grava_historico_fisica_cpf() OWNER TO postgres;

--
-- Name: fcn_grava_historico_fone_pessoa(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_grava_historico_fone_pessoa() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes      numeric;
   v_tipo     numeric;
   v_ddd      numeric;
   v_fone     numeric;
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
   v_operacao     char(1);
BEGIN
   v_idpes      := OLD.idpes;
   v_tipo     := OLD.tipo;
   v_ddd      := OLD.ddd;
   v_fone     := OLD.fone;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;
   v_operacao     := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA FONE_PESSOA
      INSERT INTO historico.fone_pessoa
      (idpes, tipo, ddd, fone, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_tipo, v_ddd, v_fone, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_grava_historico_fone_pessoa() OWNER TO postgres;

--
-- Name: fcn_grava_historico_funcionario(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_grava_historico_funcionario() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_matricula      numeric;
   v_idins      numeric;
   v_idset      numeric;
   v_idpes      numeric;
   v_situacao     char(1);
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
   v_operacao     char(1);
BEGIN
   v_matricula      := OLD.matricula;
   v_idins      := OLD.idins;
   v_idset      := OLD.idset;
   v_idpes      := OLD.idpes;
   v_situacao     := OLD.situacao;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;
   v_operacao     := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA FUNCIONARIO
      INSERT INTO historico.funcionario
      (matricula, idins, idset, idpes, situacao, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_matricula, v_idins, v_idset, v_idpes, v_situacao, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_grava_historico_funcionario() OWNER TO postgres;

--
-- Name: fcn_grava_historico_juridica(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_grava_historico_juridica() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes      numeric;
   v_cnpj     numeric;
   v_fantasia     varchar;
   v_insc_estadual    numeric;
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
   v_operacao     char(1);
BEGIN
   v_idpes      := OLD.idpes;
   v_cnpj     := OLD.cnpj;
   v_fantasia     := OLD.fantasia;
   v_insc_estadual    := OLD.insc_estadual;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;
   v_operacao     := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA JURIDICA
      INSERT INTO historico.juridica
      (idpes, cnpj, fantasia, insc_estadual, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes, v_cnpj, v_fantasia, v_insc_estadual, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_grava_historico_juridica() OWNER TO postgres;

--
-- Name: fcn_grava_historico_logradouro(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_grava_historico_logradouro() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idlog      numeric;
   v_idtlog     varchar;
   v_nome     varchar;
   v_idmun      numeric;
   v_ident_oficial    char(1);
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
   v_operacao     char(1);
BEGIN
   v_idlog      := OLD.idlog;
   v_idtlog     := OLD.idtlog;
   v_nome     := OLD.nome;
   v_idmun      := OLD.idmun;
   v_ident_oficial    := OLD.ident_oficial;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;
   v_operacao     := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA LOGRADOURO
      INSERT INTO historico.logradouro
      (idlog, idtlog, nome, idmun, ident_oficial, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idlog, v_idtlog, v_nome, v_idmun, v_ident_oficial, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_grava_historico_logradouro() OWNER TO postgres;

--
-- Name: fcn_grava_historico_municipio(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_grava_historico_municipio() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idmun      numeric;
   v_sigla_uf     char(2);
   v_nome     varchar;
   v_area_km2     numeric;
   v_idmreg     numeric;
   v_idasmun      numeric;
   v_cod_ibge     numeric;
   v_geom     TEXT;
   v_tipo     char(1);
   v_idmun_pai      numeric;
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
   v_operacao     char(1);
BEGIN
   v_idmun      := OLD.idmun;
   v_sigla_uf     := OLD.sigla_uf;
   v_nome     := OLD.nome;
   v_area_km2     := OLD.area_km2;
   v_idmreg     := OLD.idmreg;
   v_idasmun      := OLD.idasmun;
   v_cod_ibge     := OLD.cod_ibge;
   v_geom     := OLD.geom;
   v_tipo     := OLD.tipo;
   v_idmun_pai      := OLD.idmun_pai;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;
   v_operacao     := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA MUNICIPIO
      INSERT INTO historico.municipio
      (idmun, sigla_uf, nome, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idmun, v_sigla_uf, v_nome, v_area_km2, v_idmreg, v_idasmun, v_cod_ibge, v_geom, v_tipo, v_idmun_pai, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_grava_historico_municipio() OWNER TO postgres;

--
-- Name: fcn_grava_historico_pessoa(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_grava_historico_pessoa() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes    numeric;
   v_nome   TEXT;
   v_idpes_cad    numeric;
   v_data_cad   timestamp;
   v_url    TEXT;
   v_tipo   char;
   v_idpes_rev    numeric;
   v_data_rev   timestamp;
   v_email    TEXT;
   v_situacao   char;
   v_origem_gravacao  char;
   v_idsis_rev    numeric;
   v_idsis_cad    numeric;
   v_operacao   char(1);
BEGIN
   v_idpes    := OLD.idpes;
   v_nome   := OLD.nome;
   v_idpes_cad    := OLD.idpes_cad;
   v_data_cad   := OLD.data_cad;
   v_url    := OLD.url;
   v_tipo   := OLD.tipo;
   v_idpes_rev    := OLD.idpes_rev;
   v_data_rev   := OLD.data_rev;
   v_email    := OLD.email;
   v_situacao   := OLD.situacao;
   v_origem_gravacao  := OLD.origem_gravacao;
   v_idsis_rev    := OLD.idsis_rev;
   v_idsis_cad    := OLD.idsis_cad;
   v_operacao   := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA PESSOA
      INSERT INTO historico.pessoa
      (idpes, nome, idpes_cad, data_cad, url, tipo, idpes_rev, data_rev, email, situacao, origem_gravacao, idsis_rev, idsis_cad, operacao) VALUES
      (v_idpes, v_nome, v_idpes_cad, v_data_cad, v_url, v_tipo, v_idpes_rev, v_data_rev, v_email, v_situacao, v_origem_gravacao, v_idsis_rev, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_grava_historico_pessoa() OWNER TO postgres;

--
-- Name: fcn_grava_historico_socio(); Type: FUNCTION; Schema: historico; Owner: postgres
--

CREATE FUNCTION fcn_grava_historico_socio() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
   v_idpes_juridica   numeric;
   v_idpes_fisica   numeric;
   v_idpes_rev      numeric;
   v_data_rev     TIMESTAMP;
   v_origem_gravacao    char(1);
   v_idsis_rev      numeric;
   v_idpes_cad      numeric;
   v_data_cad     TIMESTAMP;
   v_idsis_cad      numeric;
   v_operacao     char(1);
BEGIN
   v_idpes_juridica   := OLD.idpes_juridica;
   v_idpes_fisica   := OLD.idpes_fisica;
   v_idpes_rev      := OLD.idpes_rev;
   v_data_rev     := OLD.data_rev;
   v_origem_gravacao    := OLD.origem_gravacao;
   v_idsis_rev      := OLD.idsis_rev;
   v_idpes_cad      := OLD.idpes_cad;
   v_data_cad     := OLD.data_cad;
   v_idsis_cad      := OLD.idsis_cad;
   v_operacao     := OLD.operacao;

  IF v_data_rev IS NULL THEN
          v_data_rev := CURRENT_TIMESTAMP;
        END IF;

      -- GRAVA HISTÓRICO PARA TABELA SOCIO
      INSERT INTO historico.socio
      (idpes_juridica, idpes_fisica, idpes_rev, data_rev, origem_gravacao, idsis_rev, idpes_cad, data_cad, idsis_cad, operacao) VALUES
      (v_idpes_juridica, v_idpes_fisica, v_idpes_rev, v_data_rev, v_origem_gravacao, v_idsis_rev, v_idpes_cad, v_data_cad, v_idsis_cad, v_operacao);

   RETURN NEW;

END; $$;


ALTER FUNCTION historico.fcn_grava_historico_socio() OWNER TO postgres;

SET search_path = modules, pg_catalog;

--
-- Name: copia_notas_transf(integer, integer); Type: FUNCTION; Schema: modules; Owner: ieducar
--

CREATE FUNCTION copia_notas_transf(old_matricula_id integer, new_matricula_id integer) RETURNS character varying
    LANGUAGE plpgsql
    AS $$
              DECLARE
              cur_comp RECORD;
              cur_comp_media RECORD;
              cur_geral RECORD;
              cur_geral_media RECORD;
              cur_falta_geral RECORD;
              cur_falta_comp RECORD;
              cur_parecer_geral RECORD;
              cur_parecer_comp RECORD;
              v_tipo_nota integer;
              v_tipo_parecer integer;
              v_tipo_falta integer;
              v_nota_id integer;
              v_old_nota_id integer;
              v_falta_id integer;
              v_old_falta_id integer;
              v_parecer_id integer;
              v_old_parecer_id integer;

              old_nota_aluno_id integer;
              new_nota_aluno_id integer;
              old_ano_matricula integer;
              new_ano_matricula integer;
              begin

              old_nota_aluno_id := (select id from modules.nota_aluno where matricula_id = old_matricula_id);
              new_nota_aluno_id := (select id from modules.nota_aluno where matricula_id = new_matricula_id);

              old_nota_aluno_id := (select (case when count(1) >= 1 then 1 else 0 end) from modules.nota_componente_curricular where nota_aluno_id = old_nota_aluno_id);
              new_nota_aluno_id := (select (case when count(1) >= 1 then 1 else 0 end) from modules.nota_componente_curricular where nota_aluno_id = new_nota_aluno_id);

              old_ano_matricula := (SELECT ano FROM pmieducar.matricula WHERE cod_matricula = old_matricula_id);
              new_ano_matricula := (SELECT ano FROM pmieducar.matricula WHERE cod_matricula = new_matricula_id);

              IF (old_nota_aluno_id = 1 and new_nota_aluno_id = 0) THEN
                /* VERIFICA SE AS MATRICULAS FAZEM PARTE DO MESMO ANO LETIVO*/
                IF (old_ano_matricula = new_ano_matricula) THEN

                  IF (
                   (  CASE WHEN (select padrao_ano_escolar from pmieducar.curso
                      where cod_curso = (select ref_cod_curso from pmieducar.matricula
                      where cod_matricula = new_matricula_id)) = 1
                     THEN  (select max(sequencial) as qtd_etapa from pmieducar.ano_letivo_modulo mod
                      inner join pmieducar.matricula mat on (mat.ref_ref_cod_escola = mod.ref_ref_cod_escola)
                                  where mat.cod_matricula = new_matricula_id)
                           ELSE (select count(ref_cod_modulo) from pmieducar.turma_modulo
                      where ref_cod_turma = (select ref_cod_turma from pmieducar.matricula_turma
                      where ref_cod_matricula = new_matricula_id))
                           END
                 ) = (CASE WHEN (select padrao_ano_escolar from pmieducar.curso
                      where cod_curso = (select ref_cod_curso from pmieducar.matricula
                      where cod_matricula = old_matricula_id)) = 1
                     THEN  (select max(sequencial) as qtd_etapa from pmieducar.ano_letivo_modulo mod
                            inner join pmieducar.matricula mat on (mat.ref_ref_cod_escola = mod.ref_ref_cod_escola)
                                  where mat.cod_matricula = old_matricula_id)
                           ELSE  (select count(ref_cod_modulo) from pmieducar.turma_modulo
                      where ref_cod_turma = (select max(ref_cod_turma) from pmieducar.matricula_turma
                      where ref_cod_matricula = old_matricula_id))
                           END
                      )
                ) THEN

                    /* VERIFICA SE UTILIZAM A MESMA REGRA DE AVALIAÇÃO*/
                    IF ((SELECT id FROM modules.regra_avaliacao rg
                        INNER JOIN pmieducar.serie s ON (rg.id = s.regra_avaliacao_id)
                        INNER JOIN pmieducar.matricula m ON (s.cod_serie = m.ref_ref_cod_serie)
                        where m.cod_matricula = old_matricula_id ) =
                          (SELECT id FROM modules.regra_avaliacao rg
                            INNER JOIN pmieducar.serie s ON (rg.id = s.regra_avaliacao_id)
                            INNER JOIN pmieducar.matricula m ON (s.cod_serie = m.ref_ref_cod_serie)
                            where m.cod_matricula = new_matricula_id ) ) THEN


                      v_tipo_nota := (SELECT tipo_nota FROM modules.regra_avaliacao rg
                                INNER JOIN pmieducar.serie s ON (rg.id = s.regra_avaliacao_id)
                                INNER JOIN pmieducar.matricula m ON (s.cod_serie = m.ref_ref_cod_serie)
                                where m.cod_matricula = old_matricula_id);

                      v_tipo_falta := (SELECT tipo_presenca FROM modules.regra_avaliacao rg
                                INNER JOIN pmieducar.serie s ON (rg.id = s.regra_avaliacao_id)
                                INNER JOIN pmieducar.matricula m ON (s.cod_serie = m.ref_ref_cod_serie)
                                where m.cod_matricula = old_matricula_id);

                      v_tipo_parecer := (SELECT parecer_descritivo FROM modules.regra_avaliacao rg
                                INNER JOIN pmieducar.serie s ON (rg.id = s.regra_avaliacao_id)
                                INNER JOIN pmieducar.matricula m ON (s.cod_serie = m.ref_ref_cod_serie)
                                where m.cod_matricula = old_matricula_id);
                      /* SE A REGRA UTILIZAR NOTA, COPIA AS NOTAS*/
                      IF (v_tipo_nota >0) THEN

                        INSERT INTO modules.nota_aluno (matricula_id) VALUES (new_matricula_id);
                        v_nota_id := (SELECT max(id) FROM modules.nota_aluno WHERE matricula_id = new_matricula_id);

                        v_old_nota_id := (SELECT max(id) FROM modules.nota_aluno WHERE matricula_id = old_matricula_id);

                        FOR cur_comp IN (SELECT * FROM modules.nota_componente_curricular where nota_aluno_id = v_old_nota_id) LOOP
                          INSERT INTO modules.nota_componente_curricular (nota_aluno_id,componente_curricular_id,nota,nota_arredondada,etapa, nota_recuperacao, nota_original, nota_recuperacao_especifica)
                          VALUES(v_nota_id,cur_comp.componente_curricular_id,cur_comp.nota,cur_comp.nota_arredondada,cur_comp.etapa,cur_comp.nota_recuperacao,cur_comp.nota_original,cur_comp.nota_recuperacao_especifica);
                        END LOOP;

                        FOR cur_comp_media IN (SELECT * FROM modules.nota_componente_curricular_media where nota_aluno_id = v_old_nota_id) LOOP
                          INSERT INTO modules.nota_componente_curricular_media (nota_aluno_id,componente_curricular_id,media,media_arredondada,etapa, situacao)
                          VALUES(v_nota_id,cur_comp_media.componente_curricular_id,cur_comp_media.media,cur_comp_media.media_arredondada,cur_comp_media.etapa, cur_comp_media.situacao);
                        END LOOP;

                        FOR cur_geral IN (SELECT * FROM modules.nota_geral where nota_aluno_id = v_old_nota_id) LOOP
                          INSERT INTO modules.nota_geral (nota_aluno_id,nota,nota_arredondada,etapa)
                          VALUES(v_nota_id,cur_geral.nota,cur_geral.nota_arredondada,cur_geral.etapa);
                        END LOOP;

                        FOR cur_geral_media IN (SELECT * FROM modules.media_geral where nota_aluno_id = v_old_nota_id) LOOP
                          INSERT INTO modules.media_geral (nota_aluno_id,media,media_arredondada,etapa)
                          VALUES(v_nota_id,cur_geral_media.media,cur_geral_media.media_arredondada,cur_geral_media.etapa);
                        END LOOP;
                      END IF;

                      IF (v_tipo_falta = 1) THEN

                          INSERT INTO modules.falta_aluno (matricula_id, tipo_falta) VALUES (new_matricula_id,1);
                          v_falta_id = (SELECT max(id) FROM modules.falta_aluno WHERE matricula_id = new_matricula_id);
                        v_old_falta_id := (SELECT max(id) FROM modules.falta_aluno WHERE matricula_id = old_matricula_id);

                        FOR cur_falta_geral IN (SELECT * FROM modules.falta_geral where falta_aluno_id = v_old_falta_id) LOOP
                          INSERT INTO modules.falta_geral (falta_aluno_id,quantidade,etapa)
                          VALUES(v_falta_id,cur_falta_geral.quantidade, cur_falta_geral.etapa);
                        END LOOP;
                      END IF;

                      IF (v_tipo_falta = 2) THEN

                        INSERT INTO modules.falta_aluno (matricula_id, tipo_falta) VALUES (new_matricula_id,2);
                        v_falta_id = (SELECT max(id) FROM modules.falta_aluno WHERE matricula_id = new_matricula_id);
                        v_old_falta_id := (SELECT max(id) FROM modules.falta_aluno WHERE matricula_id = old_matricula_id);

                        FOR cur_falta_comp IN (SELECT * FROM modules.falta_componente_curricular where falta_aluno_id = v_old_falta_id) LOOP
                          INSERT INTO modules.falta_componente_curricular (falta_aluno_id,componente_curricular_id,quantidade,etapa)
                          VALUES(v_falta_id,cur_falta_comp.componente_curricular_id,cur_falta_comp.quantidade, cur_falta_comp.etapa);
                        END LOOP;
                      END IF;

                      IF (v_tipo_parecer = 2) THEN

                        INSERT INTO modules.parecer_aluno (matricula_id, parecer_descritivo)VALUES (new_matricula_id,2);
                        v_parecer_id := (SELECT max(id) FROM modules.parecer_aluno WHERE matricula_id = new_matricula_id);
                        v_old_parecer_id := (SELECT max(id) FROM modules.parecer_aluno WHERE matricula_id = old_matricula_id);

                        FOR cur_parecer_comp IN (SELECT * FROM modules.parecer_componente_curricular where parecer_aluno_id = v_old_parecer_id) LOOP
                          INSERT INTO modules.parecer_componente_curricular (parecer_aluno_id,componente_curricular_id,parecer,etapa)
                          VALUES(v_parecer_id,cur_parecer_comp.componente_curricular_id,cur_parecer_comp.parecer, cur_parecer_comp.etapa);
                        END LOOP;
                      END IF;

                      IF (v_tipo_parecer = 3) THEN

                        INSERT INTO modules.parecer_aluno (matricula_id, parecer_descritivo)VALUES (new_matricula_id,3);
                        v_parecer_id := (SELECT max(id) FROM modules.parecer_aluno WHERE matricula_id = new_matricula_id);
                        v_old_parecer_id := (SELECT max(id) FROM modules.parecer_aluno WHERE matricula_id = old_matricula_id);

                        FOR cur_parecer_geral IN (SELECT * FROM modules.parecer_geral where parecer_aluno_id = v_old_parecer_id) LOOP
                          INSERT INTO modules.parecer_geral (parecer_aluno_id,parecer,etapa)
                          VALUES(v_parecer_id,cur_parecer_geral.parecer, cur_parecer_geral.etapa);
                        END LOOP;
                      END IF;

                      RETURN 'OK';

                    ELSE RETURN 'REGRA AVALIACAO DIFERENTE'; END IF;
                  ELSE RETURN 'ETAPA DIFERENTE'; END IF;
                ELSE RETURN 'MATRICULAS DE ANOS DIFERENTES';
                END IF;
              ELSE RETURN 'NAO EXISTE NOTAS';END IF;

              end;$$;


ALTER FUNCTION modules.copia_notas_transf(old_matricula_id integer, new_matricula_id integer) OWNER TO ieducar;

--
-- Name: corrige_sequencial_historico(); Type: FUNCTION; Schema: modules; Owner: postgres
--

CREATE FUNCTION corrige_sequencial_historico() RETURNS void
    LANGUAGE plpgsql
    AS $$
  DECLARE
  cur_aluno RECORD;
  cur_hist RECORD;
  contador integer;
  begin

  ALTER TABLE pmieducar.historico_escolar DISABLE TRIGGER USER;
  ALTER TABLE pmieducar.historico_escolar DROP CONSTRAINT historico_escolar_pkey cascade;
  FOR cur_aluno IN (SELECT cod_aluno as id FROM pmieducar.aluno) LOOP
    update pmieducar.historico_escolar set sequencial = sequencial + 100 where ref_cod_aluno = cur_aluno.id;
    contador:=1;
    FOR cur_hist IN (SELECT sequencial FROM pmieducar.historico_escolar WHERE ref_cod_aluno = cur_aluno.id ORDER BY ano, nm_serie, data_cadastro) LOOP
      update pmieducar.historico_escolar set sequencial = contador where ref_cod_aluno = cur_aluno.id and sequencial = cur_hist.sequencial;
      contador:=contador+1;
    END LOOP;
  END LOOP;
  ALTER TABLE pmieducar.historico_escolar ADD CONSTRAINT historico_escolar_pkey PRIMARY KEY(ref_cod_aluno, sequencial);
  ALTER TABLE pmieducar.historico_escolar ENABLE TRIGGER USER;
  end;$$;


ALTER FUNCTION modules.corrige_sequencial_historico() OWNER TO postgres;

--
-- Name: frequencia_da_matricula(integer); Type: FUNCTION; Schema: modules; Owner: ieducar
--

CREATE FUNCTION frequencia_da_matricula(p_matricula_id integer) RETURNS double precision
    LANGUAGE plpgsql
    AS $$
                      DECLARE
                        v_regra_falta integer;
                        v_falta_aluno_id  integer;
                        v_qtd_dias_letivos_serie NUMERIC;
                        v_total_faltas integer;
                        v_qtd_horas_serie integer;
                        v_hora_falta FLOAT;
                      BEGIN
                          /*
                            regra_falta:
                            1- Global
                            2- Por componente
                          */
                          v_regra_falta:= (SELECT rg.tipo_presenca
                                             FROM modules.regra_avaliacao rg
                                            INNER JOIN pmieducar.serie s ON (rg.id = s.regra_avaliacao_id)
                                            INNER JOIN pmieducar.matricula m ON (s.cod_serie = m.ref_ref_cod_serie)
                                            WHERE m.cod_matricula = p_matricula_id);
                          v_falta_aluno_id := (SELECT id
                                                 FROM modules.falta_aluno
                                                WHERE matricula_id = p_matricula_id
                                                ORDER BY id DESC
                                                LIMIT 1 );
                          IF (v_regra_falta = 1) THEN
                                v_qtd_dias_letivos_serie := (SELECT s.dias_letivos
                                                               FROM pmieducar.serie s
                                                              INNER JOIN pmieducar.matricula m ON (m.ref_ref_cod_serie = s.cod_serie)
                                                              WHERE m.cod_matricula = p_matricula_id);
                                v_total_faltas := (SELECT SUM(quantidade)
                                                     FROM modules.falta_geral
                                                    WHERE falta_aluno_id = v_falta_aluno_id);
                                RETURN TRUNC((((v_qtd_dias_letivos_serie - v_total_faltas) * 100 ) / v_qtd_dias_letivos_serie ),2);
                          ELSE

                            v_qtd_horas_serie := ( SELECT s.carga_horaria
                                                     FROM pmieducar.serie s
                                                    INNER JOIN pmieducar.matricula m ON (m.ref_ref_cod_serie = s.cod_serie)
                                                    WHERE m.cod_matricula = p_matricula_id);

                            v_total_faltas := (SELECT SUM(quantidade)
                                                 FROM falta_componente_curricular
                                                WHERE falta_aluno_id = v_falta_aluno_id);
                            v_hora_falta := (SELECT hora_falta
                                               FROM pmieducar.curso c
                                              INNER JOIN pmieducar.matricula m ON (c.cod_curso = m.ref_cod_curso)
                                              WHERE m.cod_matricula = p_matricula_id);
                            RETURN  (100 - ((v_total_faltas * (v_hora_falta*100))/v_qtd_horas_serie));
                          END IF;
                      END;$$;


ALTER FUNCTION modules.frequencia_da_matricula(p_matricula_id integer) OWNER TO ieducar;

--
-- Name: frequencia_etapa_padrao_ano_escolar_um(integer, integer, integer); Type: FUNCTION; Schema: modules; Owner: ieducar
--

CREATE FUNCTION frequencia_etapa_padrao_ano_escolar_um(cod_matricula_aluno integer, cod_etapa integer, id_componente_curricular integer) RETURNS numeric
    LANGUAGE plpgsql
    AS $$
                      		DECLARE
                      			dias_letivos_escola decimal;
                      			tipo_falta_aluno integer;
                      			faltas_aluno_geral decimal;
                      			faltas_aluno_componente decimal;
                      			cod_serie_ano_escolar integer;
                      		begin
                      			cod_serie_ano_escolar := (select ref_ref_cod_serie from pmieducar.matricula where matricula.cod_matricula = cod_matricula_aluno);
                      			tipo_falta_aluno := (select tipo_falta from modules.falta_aluno where matricula_id = cod_matricula_aluno);

                      			faltas_aluno_geral := (select quantidade
                      						 from modules.falta_aluno
                      					   inner join modules.falta_geral on (falta_aluno.id = falta_geral.falta_aluno_id)
                      					        where falta_aluno.matricula_id = cod_matricula_aluno
                      						  and etapa = cod_etapa::varchar);

                      			dias_letivos_escola := (select dias_letivos
                      						  from pmieducar.matricula
                      					    inner join pmieducar.ano_letivo_modulo on (matricula.ref_ref_cod_escola = ano_letivo_modulo.ref_ref_cod_escola
                      										       and matricula.ano = ano_letivo_modulo.ref_ano)
                      						 where cod_matricula = cod_matricula_aluno
                      						   and sequencial = cod_etapa);

                      			faltas_aluno_componente := (select quantidade
                      						      from modules.falta_aluno
                      					        inner join modules.falta_componente_curricular on (falta_aluno.id = falta_componente_curricular.falta_aluno_id)
                      						     where falta_aluno.matricula_id = cod_matricula_aluno
                      						       and etapa = cod_etapa::varchar
                      						       and componente_curricular_id = id_componente_curricular);

                      			if(dias_letivos_escola is not null and dias_letivos_escola <> 0) then

                      				if(tipo_falta_aluno = 1) then
                      					return round((((dias_letivos_escola - faltas_aluno_geral) * 100) / dias_letivos_escola), 2);
                      				else
                      					return round((((dias_letivos_escola - faltas_aluno_componente) * 100) / dias_letivos_escola), 2);
                      				end if;
                      			else
                      				return null;
                      			end if;
                      		end;
                      	$$;


ALTER FUNCTION modules.frequencia_etapa_padrao_ano_escolar_um(cod_matricula_aluno integer, cod_etapa integer, id_componente_curricular integer) OWNER TO ieducar;

--
-- Name: frequencia_etapa_padrao_ano_escolar_zero(integer, integer, integer); Type: FUNCTION; Schema: modules; Owner: postgres
--

CREATE FUNCTION frequencia_etapa_padrao_ano_escolar_zero(cod_matricula_aluno integer, cod_etapa integer, id_componente_curricular integer) RETURNS numeric
    LANGUAGE plpgsql
    AS $$
		DECLARE
			dias_letivos_turma decimal;
			tipo_falta_aluno integer;
			faltas_aluno_geral decimal;
			faltas_aluno_componente decimal;
			cod_serie_ano_escolar integer;
		begin
			cod_serie_ano_escolar := (select ref_ref_cod_serie from pmieducar.matricula where matricula.cod_matricula = cod_matricula_aluno);
			tipo_falta_aluno := (select tipo_falta from modules.falta_aluno where matricula_id = cod_matricula_aluno);

			dias_letivos_turma := (select turma_modulo.dias_letivos
						 from pmieducar.matricula
					   inner join pmieducar.matricula_turma on (matricula.cod_matricula = matricula_turma.ref_cod_matricula)
					   inner join pmieducar.turma on (matricula_turma.ref_cod_turma = turma.cod_turma)
					    left join pmieducar.turma_modulo on (turma.cod_turma = turma_modulo.ref_cod_turma)
						where matricula.cod_matricula = cod_matricula_aluno
						  and turma_modulo.sequencial = cod_etapa
						  and matricula_turma.ativo = 1);

			faltas_aluno_geral := (select quantidade
						 from modules.falta_aluno
					   inner join modules.falta_geral on (falta_aluno.id = falta_geral.falta_aluno_id)
						where falta_aluno.matricula_id = cod_matricula_aluno
						  and etapa = cod_etapa);

			faltas_aluno_componente := (select quantidade
						      from modules.falta_aluno
						inner join modules.falta_componente_curricular on (falta_aluno.id = falta_componente_curricular.falta_aluno_id)
						     where falta_aluno.matricula_id = cod_matricula_aluno
						       and etapa = cod_etapa
						       and componente_curricular_id = id_componente_curricular);

			if(dias_letivos_turma is not null and dias_letivos_turma <> 0) then

				if(tipo_falta_aluno = 1) then
					return round((((dias_letivos_turma - faltas_aluno_geral) * 100) / dias_letivos_turma), 2);
				else
					return round((((dias_letivos_turma - faltas_aluno_componente) * 100) / dias_letivos_turma), 2);
				end if;
			else
				return null;
			end if;
		end;
	$$;


ALTER FUNCTION modules.frequencia_etapa_padrao_ano_escolar_zero(cod_matricula_aluno integer, cod_etapa integer, id_componente_curricular integer) OWNER TO postgres;

--
-- Name: frequencia_matricula_por_etapa(integer, character varying); Type: FUNCTION; Schema: modules; Owner: ieducar
--

CREATE FUNCTION frequencia_matricula_por_etapa(matricula integer, etapa character varying) RETURNS numeric
    LANGUAGE plpgsql
    AS $_$
                          DECLARE
                            matricula integer;
                            etapa varchar;
                            ano_matricula integer;
                            escola_matricula integer;
                            turma integer;
                            faltas_geral_matricula decimal;
                            var_dias_letivos_turma_etapa decimal;
                            dias_letivos_escola_etapa decimal;

                            BEGIN
                              matricula := $1;
                              etapa := $2;
                              turma := (SELECT ref_cod_turma
                                          FROM pmieducar.matricula_turma
                                         WHERE ref_cod_matricula = $1
                                            AND matricula_turma.sequencial = relatorio.get_max_sequencial_matricula(ref_cod_matricula));
                              ano_matricula := (SELECT ano
                                                  FROM pmieducar.matricula
                                                 WHERE cod_matricula = $1);
                              escola_matricula := (SELECT ref_ref_cod_escola
                                                     FROM pmieducar.matricula
                                                    WHERE cod_matricula = $1);
                              faltas_geral_matricula := (SELECT sum(falta_geral.quantidade)
                                                               FROM modules.falta_geral,
                                                                    modules.falta_aluno
                                                              WHERE falta_geral.falta_aluno_id = falta_aluno.id
                                                                AND falta_aluno.matricula_id = $1
                                                                AND falta_geral.etapa = $2
                                                                AND falta_aluno.tipo_falta = 1);
                              var_dias_letivos_turma_etapa := (SELECT dias_letivos
                                                                 FROM pmieducar.turma_modulo
                                                                WHERE sequencial::varchar = $2
                                                                  AND ref_cod_turma = turma);
                              dias_letivos_escola_etapa := (SELECT dias_letivos
                                                                  FROM pmieducar.ano_letivo_modulo
                                                                 WHERE sequencial::varchar = $2
                                                                   AND ref_ano = ano_matricula
                                                                   AND ref_ref_cod_escola = escola_matricula);
                              IF (var_dias_letivos_turma_etapa IS NOT NULL AND var_dias_letivos_turma_etapa <> 0) THEN
                                RETURN ((var_dias_letivos_turma_etapa - faltas_geral_matricula) * 100) / var_dias_letivos_turma_etapa;
                              ELSE
                                IF (dias_letivos_escola_etapa IS NOT NULL AND dias_letivos_escola_etapa <> 0) THEN
                                  RETURN ((var_dias_letivos_turma_etapa - faltas_geral_matricula) * 100) / var_dias_letivos_turma_etapa;
                                END IF;
                              END IF;
                            END;
                          $_$;


ALTER FUNCTION modules.frequencia_matricula_por_etapa(matricula integer, etapa character varying) OWNER TO ieducar;

--
-- Name: frequencia_por_componente(integer, integer, integer); Type: FUNCTION; Schema: modules; Owner: ieducar
--

CREATE FUNCTION frequencia_por_componente(cod_matricula_id integer, cod_disciplina_id integer, cod_turma_id integer) RETURNS character varying
    LANGUAGE plpgsql
    AS $$
                          DECLARE
                             cod_falta_aluno_id integer;
                             v_qtd_dias_letivos_serie integer;
                             v_total_faltas integer;
                             qtde_carga_horaria integer;
                             v_hora_falta float;
                             cod_serie_id integer;
                          BEGIN

                            cod_falta_aluno_id := (SELECT id FROM modules.falta_aluno WHERE matricula_id = cod_matricula_id ORDER BY id DESC LIMIT 1);

                            qtde_carga_horaria := (SELECT carga_horaria :: int
                                  FROM modules.componente_curricular_turma
                                 WHERE componente_curricular_turma.componente_curricular_id = cod_disciplina_id
                                   AND componente_curricular_turma.turma_id = cod_turma_id);

                            IF (qtde_carga_horaria IS NULL) THEN
                                cod_serie_id := (SELECT ref_ref_cod_serie FROM pmieducar.turma WHERE cod_turma = cod_turma_id);
                                qtde_carga_horaria := (SELECT carga_horaria :: int
                                                     FROM modules.componente_curricular_ano_escolar
                                                WHERE componente_curricular_ano_escolar.componente_curricular_id = cod_disciplina_id
                                                  AND componente_curricular_ano_escolar.ano_escolar_id = cod_serie_id);
                            END IF;

                            v_total_faltas := (SELECT SUM(quantidade)
                                                 FROM falta_componente_curricular
                                                WHERE falta_aluno_id = cod_falta_aluno_id
                                                  AND componente_curricular_id = cod_disciplina_id);

                            v_hora_falta := (SELECT hora_falta FROM pmieducar.curso c
                                         INNER JOIN pmieducar.matricula m ON (c.cod_curso = m.ref_cod_curso)
                                              WHERE m.cod_matricula = cod_matricula_id);

                            RETURN  trunc((100 - ((v_total_faltas * (v_hora_falta*100))/qtde_carga_horaria))::numeric, 2);

                        END;
                        $$;


ALTER FUNCTION modules.frequencia_por_componente(cod_matricula_id integer, cod_disciplina_id integer, cod_turma_id integer) OWNER TO ieducar;

--
-- Name: preve_data_emprestimo(integer, date); Type: FUNCTION; Schema: modules; Owner: postgres
--

CREATE FUNCTION preve_data_emprestimo(biblioteca_id integer, data_prevista date) RETURNS date
    LANGUAGE plpgsql
    AS $$
  DECLARE
  begin

  IF (( select 1 from pmieducar.biblioteca_dia WHERE ref_cod_biblioteca = biblioteca_id AND dia = ((SELECT EXTRACT(DOW FROM data_prevista))+1) limit 1) IS NOT null) THEN
    IF ((SELECT 1 FROM pmieducar.biblioteca_feriados WHERE ref_cod_biblioteca = biblioteca_id and data_feriado = data_prevista) IS NULL) THEN
      RETURN data_prevista;
    ELSE
      RETURN modules.preve_data_emprestimo(biblioteca_id, data_prevista+1);
    END IF;
  ELSE
    RETURN modules.preve_data_emprestimo(biblioteca_id, data_prevista+1);
  END IF;

  end;$$;


ALTER FUNCTION modules.preve_data_emprestimo(biblioteca_id integer, data_prevista date) OWNER TO postgres;

SET search_path = pmieducar, pg_catalog;

--
-- Name: fcn_aft_update(); Type: FUNCTION; Schema: pmieducar; Owner: postgres
--

CREATE FUNCTION fcn_aft_update() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
  nm_tabela   varchar(255);
  alteracoes    text;
  data_cadastro   TIMESTAMP;
  v_insercao    int2;


  BEGIN
    v_insercao    := 0;
    nm_tabela   := TG_RELNAME;
    alteracoes    := NEW;
    data_cadastro   := CURRENT_TIMESTAMP;
    IF TG_OP = 'INSERT' THEN
      v_insercao := 1;
    END IF;
    insert into pmieducar.historico_educar (tabela, alteracao, data, insercao) values (nm_tabela, alteracoes, data_cadastro, v_insercao);
  RETURN NEW;
END; $$;


ALTER FUNCTION pmieducar.fcn_aft_update() OWNER TO postgres;

--
-- Name: migra_beneficios_para_tabela_aluno_aluno_beneficio(); Type: FUNCTION; Schema: pmieducar; Owner: postgres
--

CREATE FUNCTION migra_beneficios_para_tabela_aluno_aluno_beneficio() RETURNS void
    LANGUAGE plpgsql
    AS $$
  DECLARE
  cur_aluno RECORD;
  begin

  FOR cur_aluno IN (SELECT cod_aluno as id, ref_cod_aluno_beneficio as beneficio_id FROM pmieducar.aluno WHERE ref_cod_aluno_beneficio IS NOT NULL) LOOP
    INSERT INTO pmieducar.aluno_aluno_beneficio VALUES (cur_aluno.id, cur_aluno.beneficio_id);
  END LOOP;

  ALTER TABLE pmieducar.aluno DROP COLUMN ref_cod_aluno_beneficio;
  end;$$;


ALTER FUNCTION pmieducar.migra_beneficios_para_tabela_aluno_aluno_beneficio() OWNER TO postgres;

--
-- Name: normalizadeficienciaservidor(); Type: FUNCTION; Schema: pmieducar; Owner: postgres
--

CREATE FUNCTION normalizadeficienciaservidor() RETURNS void
    LANGUAGE plpgsql
    AS $$
  DECLARE
  cur_servidor RECORD;
  begin

    FOR cur_servidor IN (SELECT cod_servidor, ref_cod_deficiencia
                      FROM pmieducar.servidor
                      WHERE ref_cod_deficiencia is not null) LOOP


      IF ((SELECT 1 FROM cadastro.fisica_deficiencia fd WHERE fd.ref_idpes = cur_servidor.cod_servidor AND fd.ref_cod_deficiencia = cur_servidor.ref_cod_deficiencia) IS NULL ) THEN
        INSERT INTO cadastro.fisica_deficiencia VALUES (cur_servidor.cod_servidor, cur_servidor.ref_cod_deficiencia);
      END IF;

    END LOOP;

  end;$$;


ALTER FUNCTION pmieducar.normalizadeficienciaservidor() OWNER TO postgres;

--
-- Name: unifica_alunos(numeric, numeric[], integer); Type: FUNCTION; Schema: pmieducar; Owner: ieducar
--

CREATE FUNCTION unifica_alunos(alunoprincipal numeric, alunos numeric[], usuario integer) RETURNS void
    LANGUAGE plpgsql
    AS $_$
        DECLARE
            alunoPrincipal ALIAS FOR $1;
            alunos ALIAS FOR $2;
            usuario ALIAS FOR $3;
        BEGIN

            UPDATE pmieducar.historico_escolar
                SET ref_cod_aluno = alunoPrincipal, sequencial = he.seq+he.max_seq
            FROM
                (
                    SELECT ref_cod_aluno AS aluno, sequencial AS seq, COALESCE((
                        SELECT max(sequencial) FROM pmieducar.historico_escolar WHERE ref_cod_aluno = alunoPrincipal
                    ),0) AS max_seq
                    FROM pmieducar.historico_escolar
                    WHERE ref_cod_aluno = ANY(alunos)
                ) AS he
              WHERE sequencial = he.seq
              AND ref_cod_aluno = he.aluno;

            UPDATE pmieducar.matricula
                SET ref_cod_aluno = alunoPrincipal
            WHERE ref_cod_aluno = ANY(alunos);

            UPDATE pmieducar.aluno
                SET ativo = 0, data_exclusao = now(), ref_usuario_exc = usuario
            WHERE cod_aluno = ANY(alunos);

        END;$_$;


ALTER FUNCTION pmieducar.unifica_alunos(alunoprincipal numeric, alunos numeric[], usuario integer) OWNER TO ieducar;

--
-- Name: unifica_pessoas(numeric, numeric[], integer); Type: FUNCTION; Schema: pmieducar; Owner: ieducar
--

CREATE FUNCTION unifica_pessoas(pessoaprincipal numeric, pessoas numeric[], usuario integer) RETURNS void
    LANGUAGE plpgsql
    AS $_$
        DECLARE
            pessoaPrincipal ALIAS FOR $1;
            pessoas ALIAS FOR $2;
            usuario ALIAS FOR $3;
        BEGIN

            SET session_replication_role = REPLICA;

            IF
                (SELECT COUNT(1) FROM pmieducar.aluno WHERE ref_idpes = ANY(pessoas)) > 0 AND
                (SELECT COUNT(1) FROM pmieducar.aluno WHERE ref_idpes = pessoaPrincipal) = 0
                THEN
                    UPDATE pmieducar.aluno
                        SET ref_idpes = pessoaPrincipal
                    WHERE ref_idpes = ANY(pessoas)
                    AND ref_idpes <> pessoaPrincipal
                    AND cod_aluno = (SELECT MAX(cod_aluno) FROM pmieducar.aluno WHERE ref_idpes = ANY(pessoas));

                    PERFORM pmieducar.unifica_alunos(
                        (SELECT cod_aluno FROM pmieducar.aluno WHERE ref_idpes = pessoaPrincipal),
                        (SELECT ARRAY(SELECT cod_aluno::numeric FROM pmieducar.aluno WHERE ref_idpes = ANY(pessoas))),
                        1
                    );
            ELSEIF
                (SELECT COUNT(1) FROM pmieducar.aluno WHERE ref_idpes = pessoaPrincipal) > 0 AND
                (SELECT COUNT(1) FROM pmieducar.aluno WHERE ref_idpes = ANY(pessoas)) > 0
                THEN
                    PERFORM pmieducar.unifica_alunos(
                        (SELECT cod_aluno FROM pmieducar.aluno WHERE ref_idpes = pessoaPrincipal),
                        (SELECT ARRAY(SELECT cod_aluno::numeric FROM pmieducar.aluno WHERE ref_idpes = ANY(pessoas))),
                        1
                    );
	        END IF;

	        UPDATE cadastro.fisica
                SET idpes_pai = pessoaPrincipal
            WHERE idpes_pai = ANY(pessoas);

            UPDATE cadastro.fisica
                SET idpes_mae = pessoaPrincipal
            WHERE idpes_mae = ANY(pessoas);

	        UPDATE pmieducar.servidor_alocacao
                SET ref_cod_servidor = pessoaPrincipal
            WHERE ref_cod_servidor = ANY(pessoas);

	        UPDATE pmieducar.servidor_funcao
                SET ref_cod_servidor = pessoaPrincipal
            WHERE ref_cod_servidor = ANY(pessoas);

	        IF
	            (SELECT COUNT(1) FROM pmieducar.servidor WHERE cod_servidor = ANY(pessoas)) > 0 AND
	            (SELECT COUNT(1) FROM pmieducar.servidor WHERE cod_servidor = pessoaPrincipal) = 0
	            THEN
	                INSERT INTO pmieducar.servidor SELECT
	                pessoaPrincipal as cod_servidor,
        	            ref_cod_instituicao, ref_idesco, carga_horaria,
        	            data_cadastro, data_exclusao, ativo, ref_cod_subnivel,
        	            situacao_curso_superior_1, formacao_complementacao_pedagogica_1,
        	            codigo_curso_superior_1, ano_inicio_curso_superior_1,
        	            ano_conclusao_curso_superior_1, tipo_instituicao_curso_superior_1,
        	            instituicao_curso_superior_1, situacao_curso_superior_2,
        	            formacao_complementacao_pedagogica_2, codigo_curso_superior_2,
        	            ano_inicio_curso_superior_2, ano_conclusao_curso_superior_2,
        	            tipo_instituicao_curso_superior_2, instituicao_curso_superior_2,
        	            situacao_curso_superior_3, formacao_complementacao_pedagogica_3,
        	            codigo_curso_superior_3, ano_inicio_curso_superior_3,
        	            ano_conclusao_curso_superior_3, tipo_instituicao_curso_superior_3,
        	            instituicao_curso_superior_3, pos_especializacao,
        	            pos_mestrado, pos_doutorado, pos_nenhuma,
        	            curso_creche, curso_pre_escola, curso_anos_iniciais,
        	            curso_anos_finais, curso_ensino_medio, curso_eja, curso_educacao_especial,
        	            curso_educacao_indigena, curso_educacao_campo, curso_educacao_ambiental,
        	            curso_educacao_direitos_humanos, curso_genero_diversidade_sexual,
        	            curso_direito_crianca_adolescente, curso_relacoes_etnicorraciais,
        	            curso_outros, curso_nenhum, multi_seriado
    	        FROM pmieducar.servidor
    	        WHERE cod_servidor = ANY(pessoas)
    	        ORDER BY cod_servidor ASC
                LIMIT 1;
	        END IF;

	        DELETE FROM pmieducar.servidor WHERE cod_servidor = ANY(pessoas) AND cod_servidor <> pessoaPrincipal;
            DELETE FROM cadastro.documento WHERE idpes = ANY(pessoas) AND idpes <> pessoaPrincipal;
            DELETE FROM cadastro.fisica WHERE idpes = ANY(pessoas) AND idpes <> pessoaPrincipal;
            DELETE FROM cadastro.fone_pessoa WHERE idpes = ANY(pessoas) AND idpes <> pessoaPrincipal;
            DELETE FROM cadastro.pessoa WHERE idpes = ANY(pessoas) AND idpes <> pessoaPrincipal;

            SET session_replication_role = DEFAULT;

        END;$_$;


ALTER FUNCTION pmieducar.unifica_pessoas(pessoaprincipal numeric, pessoas numeric[], usuario integer) OWNER TO ieducar;

--
-- Name: unifica_tipos_transferencia(); Type: FUNCTION; Schema: pmieducar; Owner: postgres
--

CREATE FUNCTION unifica_tipos_transferencia() RETURNS void
    LANGUAGE plpgsql
    AS $$
  DECLARE
  cur_tipo RECORD;
  v_cod_tt INTEGER;
  begin

    ALTER TABLE pmieducar.transferencia_tipo ADD COLUMN ref_cod_instituicao INTEGER;

    ALTER TABLE pmieducar.transferencia_tipo ADD CONSTRAINT transferencia_tipo_ref_cod_instituicao
    FOREIGN KEY (ref_cod_instituicao) REFERENCES pmieducar.instituicao (cod_instituicao) MATCH SIMPLE
    ON UPDATE RESTRICT ON DELETE RESTRICT;

    FOR cur_tipo IN (SELECT tt.cod_transferencia_tipo AS id, tt.nm_tipo, escola.ref_cod_instituicao
                      FROM pmieducar.transferencia_tipo tt
                      INNER JOIN pmieducar.escola ON (tt.ref_cod_escola = escola.cod_escola)) LOOP

      v_cod_tt := (SELECT cod_transferencia_tipo FROM transferencia_tipo WHERE to_ascii(nm_tipo) ilike to_ascii(cur_tipo.nm_tipo)
                      AND cod_transferencia_tipo <= cur_tipo.id ORDER BY cod_transferencia_tipo LIMIT 1 );

      IF (v_cod_tt = cur_tipo.id) THEN
        UPDATE pmieducar.transferencia_tipo SET ref_cod_instituicao = cur_tipo.ref_cod_instituicao WHERE cod_transferencia_tipo = cur_tipo.id;
      ELSE
        UPDATE pmieducar.transferencia_solicitacao SET ref_cod_transferencia_tipo = v_cod_tt
                                                   WHERE ref_cod_transferencia_tipo = cur_tipo.id;
        DELETE FROM pmieducar.transferencia_tipo WHERE cod_transferencia_tipo = cur_tipo.id;

      END IF;

    END LOOP;

    ALTER TABLE pmieducar.transferencia_tipo  DROP CONSTRAINT transferencia_tipo_ref_cod_escola;

    ALTER TABLE pmieducar.transferencia_tipo DROP COLUMN ref_cod_escola;

  end;$$;


ALTER FUNCTION pmieducar.unifica_tipos_transferencia() OWNER TO postgres;

--
-- Name: updated_at_matricula(); Type: FUNCTION; Schema: pmieducar; Owner: postgres
--

CREATE FUNCTION updated_at_matricula() RETURNS trigger
    LANGUAGE plpgsql
    AS $$ BEGIN NEW.updated_at = now(); RETURN NEW; END; $$;


ALTER FUNCTION pmieducar.updated_at_matricula() OWNER TO postgres;

--
-- Name: updated_at_matricula_turma(); Type: FUNCTION; Schema: pmieducar; Owner: postgres
--

CREATE FUNCTION updated_at_matricula_turma() RETURNS trigger
    LANGUAGE plpgsql
    AS $$ BEGIN NEW.updated_at = now(); RETURN NEW; END; $$;


ALTER FUNCTION pmieducar.updated_at_matricula_turma() OWNER TO postgres;

SET search_path = public, pg_catalog;

--
-- Name: commacat_ignore_nulls(text, text); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION commacat_ignore_nulls(acc text, instr text) RETURNS text
    LANGUAGE plpgsql
    AS $$
  BEGIN
      IF acc IS NULL OR acc = '' THEN
        RETURN instr;
      ELSIF instr IS NULL OR instr = '' THEN
        RETURN acc || ' <br> ';
      ELSE
        RETURN acc || ' <br> ' || instr;
      END IF;
    END;
  $$;


ALTER FUNCTION public.commacat_ignore_nulls(acc text, instr text) OWNER TO postgres;

--
-- Name: count_weekdays(date, date); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION count_weekdays(date, date) RETURNS integer
    LANGUAGE plpgsql STABLE
    AS $_$
     DECLARE
      start_date alias for $1;
      end_date alias for $2;
      tmp_date date;
      tmp_dow integer;
      -- double precision returned from extract
      tot_dow integer;
     BEGIN
       tmp_date := start_date;
       tot_dow := 0;
       WHILE (tmp_date <= end_date) LOOP
         select into tmp_dow  cast(extract(dow from tmp_date) as integer);
         IF ((tmp_dow >= 2) and (tmp_dow <= 6)) THEN
           tot_dow := (tot_dow + 1);
         END IF;
         select into tmp_date (tmp_date + interval '1 day ');
       END LOOP;
       return tot_dow;

     END;
  $_$;


ALTER FUNCTION public.count_weekdays(date, date) OWNER TO postgres;

--
-- Name: cria_distritos(); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION cria_distritos() RETURNS void
    LANGUAGE plpgsql
    AS $$
  DECLARE
  cur_log RECORD;
  sequence_val INTEGER;
  begin

    FOR cur_log IN (SELECT idmun, nome, idpes_cad, data_cad, origem_gravacao, operacao, idsis_cad
                      FROM public.municipio ORDER BY idmun ASC) LOOP

      INSERT INTO public.distrito (idmun, iddis, nome, idpes_cad, data_cad, origem_gravacao, operacao, idsis_cad)
                  VALUES(cur_log.idmun, cur_log.idmun, cur_log.nome, cur_log.idpes_cad, cur_log.data_cad,
                         cur_log.origem_gravacao, cur_log.operacao, cur_log.idsis_cad);
    END LOOP;
    sequence_val := (SELECT max(iddis)+1 FROM public.distrito)::INT;
    PERFORM setval('public.seq_distrito', sequence_val);

  end;$$;


ALTER FUNCTION public.cria_distritos() OWNER TO postgres;

--
-- Name: data_para_extenso(date); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION data_para_extenso(data date) RETURNS character varying
    LANGUAGE plpgsql
    AS $$
DECLARE
	data_extenso varchar := '';
	mes_extenso varchar := '';
	dia integer := 0;
	mes integer := 0;
	ano integer := 0;
BEGIN

	dia := date_part('day', data)::integer;
	mes := date_part('month', data)::integer;
	ano := date_part('year', data)::integer;

	mes_extenso := case
				    when mes = 1  then 'Janeiro'
				    when mes = 2  then 'Fevereiro'
				    when mes = 3  then 'Março'
				    when mes = 4  then 'Abril'
				    when mes = 5  then 'Maio'
				    when mes = 6  then 'Junho'
				    when mes = 7  then 'Julho'
				    when mes = 8  then 'Agosto'
				    when mes = 9  then 'Setembro'
				    when mes = 10 then 'Outubro'
				    when mes = 11 then 'Novembro'
				    when mes = 12 then 'Dezembro'
				   else
				   	''
				   end;

	data_extenso := dia::varchar || ' de ' || mes_extenso || ' de ' || ano::varchar;

	return data_extenso;

END;
$$;


ALTER FUNCTION public.data_para_extenso(data date) OWNER TO postgres;

--
-- Name: fcn_aft_logradouro_fonetiza(); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_aft_logradouro_fonetiza() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
   DECLARE
    v_idlog    bigint;
    v_nome_n   text;
    v_nome_v   text;
    v_fonema   text;
    v_reg_fon  record;
   BEGIN
    IF TG_OP = 'INSERT' THEN
     v_idlog  := NEW.idlog;
     v_nome_n := NEW.nome;
     FOR v_reg_fon IN SELECT DISTINCT * from public.fcn_fonetiza(v_nome_n) LOOP
      v_fonema := v_reg_fon.fcn_fonetiza;
      EXECUTE 'INSERT INTO public.logradouro_fonetico (fonema,idlog) VALUES ('||quote_literal(v_fonema)||','||quote_literal(v_idlog)||');';
     END LOOP;
    ELSIF TG_OP = 'UPDATE' THEN
     v_idlog  := NEW.idlog;
     v_nome_n := NEW.nome;
     v_nome_v := OLD.nome;
     IF v_nome_n <> v_nome_v THEN
      EXECUTE 'DELETE FROM public.logradouro_fonetico WHERE idlog = '||quote_literal(v_idlog)||';';
      FOR v_reg_fon IN SELECT DISTINCT * from public.fcn_fonetiza(v_nome_n) LOOP
       v_fonema := v_reg_fon.fcn_fonetiza;
       EXECUTE 'INSERT INTO public.logradouro_fonetico (fonema,idlog) VALUES ('||quote_literal(v_fonema)||','||quote_literal(v_idlog)||');';
      END LOOP;
     END IF;
    END IF;
    RETURN NEW;
   END;
  $$;


ALTER FUNCTION public.fcn_aft_logradouro_fonetiza() OWNER TO postgres;

--
-- Name: fcn_aft_pessoa_fonetiza(); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_aft_pessoa_fonetiza() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
   DECLARE
    v_idpes    bigint;
    v_nome_n   text;
    v_nome_v   text;
    v_fonema   text;
    v_reg_fon  record;
   BEGIN
    IF TG_OP = 'INSERT' THEN
     v_idpes  := NEW.idpes;
     v_nome_n := NEW.nome;
     FOR v_reg_fon IN SELECT DISTINCT * from public.fcn_fonetiza(v_nome_n) LOOP
      v_fonema := v_reg_fon.fcn_fonetiza;
      EXECUTE 'INSERT INTO cadastro.pessoa_fonetico (fonema,idpes) VALUES ('||quote_literal(v_fonema)||','||quote_literal(v_idpes)||');';
     END LOOP;
    ELSIF TG_OP = 'UPDATE' THEN
     v_idpes  := NEW.idpes;
     v_nome_n := NEW.nome;
     v_nome_v := OLD.nome;
     IF v_nome_n <> v_nome_v THEN
      EXECUTE 'DELETE FROM cadastro.pessoa_fonetico WHERE idpes = '||quote_literal(v_idpes)||';';
      FOR v_reg_fon IN SELECT DISTINCT * from public.fcn_fonetiza(v_nome_n) LOOP
       v_fonema := v_reg_fon.fcn_fonetiza;
       EXECUTE 'INSERT INTO cadastro.pessoa_fonetico (fonema,idpes) VALUES
 ('||quote_literal(v_fonema)||','||quote_literal(v_idpes)||');';
      END LOOP;
     END IF;
    END IF;
    RETURN NEW;
   END;
  $$;


ALTER FUNCTION public.fcn_aft_pessoa_fonetiza() OWNER TO postgres;

--
-- Name: fcn_bef_ins_fisica(); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_bef_ins_fisica() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
   DECLARE
    v_idpes    cadastro.fisica.idpes%TYPE;
    v_contador integer;
   BEGIN
    SELECT INTO v_contador count(idpes) from cadastro.juridica where idpes = NEW.idpes;
    IF v_contador = 1 THEN
     RAISE EXCEPTION 'O Identificador % já está cadastrado como Pessoa Jurídica', NEW.idpes;
    END IF;
    RETURN NEW;
   END;
  $$;


ALTER FUNCTION public.fcn_bef_ins_fisica() OWNER TO postgres;

--
-- Name: fcn_bef_ins_juridica(); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_bef_ins_juridica() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
   DECLARE
    v_idpes    cadastro.juridica.idpes%TYPE;
    v_contador integer;
   BEGIN
    SELECT INTO v_contador count(idpes) from cadastro.fisica where idpes = NEW.idpes;
    IF v_contador = 1 THEN
     RAISE EXCEPTION 'O Identificador % já está cadastrado como Pessoa Física', NEW.idpes;
    END IF;
    RETURN NEW;
   END;
  $$;


ALTER FUNCTION public.fcn_bef_ins_juridica() OWNER TO postgres;

--
-- Name: fcn_bef_logradouro_fonetiza(); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_bef_logradouro_fonetiza() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
   DECLARE
    v_idlog    bigint;
   BEGIN
    v_idlog := OLD.idlog;
    EXECUTE 'DELETE FROM public.logradouro_fonetico WHERE idlog = '||quote_literal(v_idlog)||';';
    RETURN OLD;
   END;
  $$;


ALTER FUNCTION public.fcn_bef_logradouro_fonetiza() OWNER TO postgres;

--
-- Name: fcn_bef_pessoa_fonetiza(); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_bef_pessoa_fonetiza() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
   DECLARE
    v_idpes    bigint;
   BEGIN
    v_idpes := OLD.idpes;
    EXECUTE 'DELETE FROM cadastro.pessoa_fonetico WHERE idpes = '||quote_literal(v_idpes)||';';
    RETURN OLD;
   END;
  $$;


ALTER FUNCTION public.fcn_bef_pessoa_fonetiza() OWNER TO postgres;

--
-- Name: fcn_compara_nome_pessoa_fonetica(text, numeric); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_compara_nome_pessoa_fonetica(text, numeric) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  v_nome_parametro      ALIAS FOR $1;
  v_idpes_parametro     ALIAS FOR $2;
  v_nome_pessoa_1       text;
  v_nome_pessoa_2       text;
  v_registro        record;
  v_nome_primeiro_ultimo_pessoa_1   text;
  v_nome_primeiro_ultimo_pessoa_2   text;
  v_cont     integer;
  v_fonema   text;
  v_comando  text;

  BEGIN

  -- obter o nome da pessoa referente ao IDPES passado como parametro
  v_comando := 'SELECT nome FROM cadastro.pessoa WHERE idpes = '||quote_literal(v_idpes_parametro)||';';
  FOR v_registro IN EXECUTE v_comando LOOP
    v_nome_pessoa_1 := v_registro.nome;
  END LOOP;

  v_nome_pessoa_2 := v_nome_parametro;

  v_nome_primeiro_ultimo_pessoa_1 := '';
  v_nome_primeiro_ultimo_pessoa_2 := '';
  v_cont := 0;

  -- primeiro e último nome da pessoa com fonética
  FOR v_registro IN SELECT * FROM public.fcn_fonetiza(public.fcn_obter_primeiro_ultimo_nome(v_nome_pessoa_1)) LOOP
    v_cont := v_cont + 1;
    v_fonema := v_registro.fcn_fonetiza;

    IF v_cont > 1 THEN
      v_nome_primeiro_ultimo_pessoa_1 := v_nome_primeiro_ultimo_pessoa_1 || ' ';
    END IF;
    v_nome_primeiro_ultimo_pessoa_1 := v_nome_primeiro_ultimo_pessoa_1 || v_fonema;
  END LOOP;

  v_cont := 0;
  FOR v_registro IN SELECT * FROM public.fcn_fonetiza(public.fcn_obter_primeiro_ultimo_nome(v_nome_pessoa_2)) LOOP
    v_cont := v_cont + 1;
    v_fonema := v_registro.fcn_fonetiza;

    IF v_cont > 1 THEN
      v_nome_primeiro_ultimo_pessoa_2 := v_nome_primeiro_ultimo_pessoa_2 || ' ';
    END IF;
    v_nome_primeiro_ultimo_pessoa_2 := v_nome_primeiro_ultimo_pessoa_2 || v_fonema;
  END LOOP;

  IF v_nome_primeiro_ultimo_pessoa_1 = v_nome_primeiro_ultimo_pessoa_2 THEN
    RETURN 1;
  ELSE
    RETURN 0;
  END IF;
   END;
  $_$;


ALTER FUNCTION public.fcn_compara_nome_pessoa_fonetica(text, numeric) OWNER TO postgres;

--
-- Name: fcn_cons_log_fonetica(text, bigint); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_cons_log_fonetica(text, bigint) RETURNS SETOF typ_idlog
    LANGUAGE plpgsql
    AS $_$
   DECLARE
    v_texto    ALIAS FOR $1;
    v_idmun    ALIAS FOR $2;
    v_fonema   text;
    v_comando  text;
    v_idlog    bigint;
    v_reg_fon  record;
    v_cont     integer;
    retorno    typ_idlog%ROWTYPE;
   BEGIN
    v_cont := 0;
    v_comando := 'select public.logradouro_fonetico.idlog from public.logradouro_fonetico, public.logradouro where (fonema = ';
    FOR v_reg_fon IN SELECT DISTINCT * FROM public.fcn_fonetiza(v_texto) LOOP v_cont := v_cont + 1;
     v_fonema := v_reg_fon.fcn_fonetiza;
     IF v_cont > 1 THEN
      v_comando := v_comando||' or fonema = ';
     END IF;
     v_comando := v_comando||quote_literal(v_fonema);
    END LOOP;
    v_comando := v_comando||') AND public.logradouro.idlog = public.logradouro_fonetico.idlog';
    v_comando := v_comando||' AND public.logradouro.idmun = '||v_idmun;
    v_comando := v_comando||' group by public.logradouro_fonetico.idlog having count(fonema) = '||quote_literal(v_cont)||';';
    FOR retorno IN EXECUTE v_comando LOOP
     RETURN NEXT retorno;
    END LOOP;
    RETURN;
   END;
  $_$;


ALTER FUNCTION public.fcn_cons_log_fonetica(text, bigint) OWNER TO postgres;

--
-- Name: fcn_consulta_fonetica(text); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_consulta_fonetica(text) RETURNS SETOF typ_idpes
    LANGUAGE plpgsql
    AS $_$
   DECLARE
    v_texto    ALIAS FOR $1;
    v_fonema   text;
    v_comando  text;
    v_idpes    bigint;
    v_reg_fon  record;
    v_cont     integer;
    retorno typ_idpes%ROWTYPE;
   BEGIN
    v_cont := 0;
    v_comando := 'select idpes from cadastro.pessoa_fonetico where fonema = ';
    FOR v_reg_fon IN SELECT DISTINCT * FROM public.fcn_fonetiza(v_texto) LOOP
     v_cont := v_cont + 1;
     v_fonema := v_reg_fon.fcn_fonetiza;
     IF v_cont > 1 THEN
      v_comando := v_comando||' or fonema = ';
     END IF;
     v_comando := v_comando||quote_literal(v_fonema);
    END LOOP;
    v_comando := v_comando||' group by idpes having count(fonema) = '||quote_literal(v_cont)||';';
    FOR retorno IN EXECUTE v_comando LOOP
     RETURN NEXT retorno;
    END LOOP;
    RETURN;
   END;
  $_$;


ALTER FUNCTION public.fcn_consulta_fonetica(text) OWNER TO postgres;

--
-- Name: fcn_delete_endereco_externo(integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_delete_endereco_externo(integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_idpes ALIAS for $1;
  v_tipo ALIAS for $2;

BEGIN
  -- Deleta dados da tabela endereco_externo
  DELETE FROM cadastro.endereco_externo WHERE idpes = v_idpes AND tipo = v_tipo;
  RETURN 0;
END;$_$;


ALTER FUNCTION public.fcn_delete_endereco_externo(integer, integer) OWNER TO postgres;

--
-- Name: fcn_delete_endereco_pessoa(integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_delete_endereco_pessoa(integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_idpes ALIAS for $1;
  v_tipo ALIAS for $2;

BEGIN
  -- Deleta dados da tabela endereco_pessoa
  DELETE FROM cadastro.endereco_pessoa WHERE idpes = v_idpes AND tipo = v_tipo;
  RETURN 0;
END;$_$;


ALTER FUNCTION public.fcn_delete_endereco_pessoa(integer, integer) OWNER TO postgres;

--
-- Name: fcn_delete_fone_pessoa(integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_delete_fone_pessoa(integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;

BEGIN
  -- Deleta dados da tabela fone_pessoa
  DELETE FROM cadastro.fone_pessoa WHERE idpes = v_id_pes;
  RETURN 0;
END;$_$;


ALTER FUNCTION public.fcn_delete_fone_pessoa(integer) OWNER TO postgres;

--
-- Name: fcn_delete_funcionario(integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_delete_funcionario(integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_matricula ALIAS for $1;
  v_id_ins ALIAS for $2;

BEGIN
  -- Deleta dados da tabela funcionário
  DELETE FROM cadastro.funcionario WHERE matricula = v_matricula AND idins = v_id_ins;
  RETURN 0;
END;$_$;


ALTER FUNCTION public.fcn_delete_funcionario(integer, integer) OWNER TO postgres;

--
-- Name: fcn_dia_util(date, date); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_dia_util(date, date) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_dt_ini ALIAS for $1;
  v_dt_fim ALIAS for $2;
  v_dt_ini_x date;
  v_qtde integer;
BEGIN
  v_qtde := 0;
  v_dt_ini_x := v_dt_ini;
  WHILE v_dt_ini_x <= v_dt_fim LOOP
    IF to_char(v_dt_ini_x,'D') NOT IN ('1','7') THEN
      IF NOT EXISTS(SELECT idfer
             from servicos.feriado
             WHERE to_char(data,'DD/MM/YYYY') =
             to_char(v_dt_ini_x,'DD/MM/YYYY')) THEN
        v_qtde := v_qtde + 1;
      END IF;
    END IF;
    v_dt_ini_x := v_dt_ini_x + interval '1 day';
  END LOOP;
  RETURN v_qtde;
END;$_$;


ALTER FUNCTION public.fcn_dia_util(date, date) OWNER TO postgres;

--
-- Name: fcn_fonetiza(text); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_fonetiza(text) RETURNS SETOF text
    LANGUAGE plpgsql
    AS $_$
   DECLARE
    v_array         ALIAS FOR $1;
    orig            text := '';
    dest            text := '';
    ori             integer := 1;
    v_campo         integer;
   BEGIN
    orig := public.fcn_upper_nrm(v_array)||'  ';
    FOR ori IN 1..152 LOOP
     IF substr(orig, ori, 1) = ' ' THEN
      IF substr(orig, ori + 1, 1) = ' ' THEN
       IF dest IN ('DA','DAS','DOS','DU','DUS','DI','E','S/A','LTDA','OTIDA','S.A','DO','DE','-','AVI','I','OA','A','SA') THEN
        dest := '';
       END IF;
       IF dest <> ' ' AND
          dest <> '' THEN
        RETURN NEXT trim(dest);
        dest := '';
       END IF;
       ori := 152;
       EXIT;
      ELSE
       IF dest IN ('DA','DAS','DOS','DU','DUS','DI','E','S/A','LTDA','OTIDA','S.A','DO','DE','-','AVI','I','OA','A','SA') THEN
        dest := '';
       END IF;
       IF dest <> ' ' AND
          dest <> '' THEN
        RETURN NEXT trim(dest);
        dest := '';
       END IF;
       ori := ori + 1;
      END IF;
     ELSIF substr(orig,ori + 1,1) = '-' OR
           substr(orig,ori + 1,1) = '/' THEN
      IF substr(orig,ori,1) <> ' ' AND
         substr(orig,ori + 2,1) <> ' ' THEN
       orig = substr(orig,1,ori)||' '||substr(orig,ori + 1,42);
      END IF;
     END IF;
     -- Numero
     IF substr(orig,ori,1) >= '0' and
        substr(orig,ori,1) <= '9' THEN
      dest := dest||substr(orig,ori,1);
     -- Letra Igual
     ELSIF substr(orig,ori,1) = substr(orig,ori + 1,1) THEN
      IF length(dest) = 1 THEN
       dest := '';
      END IF;
     -- Letras A, I ou O
     ELSIF substr(orig,ori,1) = 'A' OR
           substr(orig,ori,1) = 'I' OR
           substr(orig,ori,1) = 'O' THEN
      dest := dest||substr(orig,ori,1);
     -- Letra E
     ELSIF substr(orig,ori,1) = 'E' THEN
      dest := dest||'I';
     -- Letra R
     ELSIF substr(orig,ori,1) = 'R' THEN
       dest := dest||'H';
     -- Letra S
     ELSIF substr(orig,ori,1) = 'S' THEN
      IF substr(orig,ori + 1,1) NOT IN ('A','E','I','O','U','Y') AND
         length(dest) = 0 THEN
       dest := dest||'IS';
      ELSIF substr(orig,ori + 1,1) = 'C' AND
            substr(orig,ori + 2,1) = 'H' THEN
       IF length(dest) = 1 THEN
        dest := '';
       END IF;
      ELSIF substr(orig,ori + 1,1) = 'H' THEN
       dest := dest||'KS';
       ori := ori + 1;
      ELSE
       dest := dest||substr(orig,ori,1);
      END IF;
     -- Letra N
     ELSIF substr(orig,ori,1) = 'N' THEN
      IF substr(orig,ori + 1,1) = 'H' THEN
       dest := dest||'NI';
      ELSE
       IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
        dest := dest||substr(orig,ori,1);
       ELSE
        dest := dest||'M';
       END IF;
      END IF;
     -- Letra L
     ELSIF substr(orig,ori,1) = 'L' THEN
      IF substr(orig,ori + 1,1) = 'H' THEN
       dest := dest||'LI';
      ELSIF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'O';
      END IF;
     -- Letra D
     ELSIF substr(orig,ori,1) = 'D' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') OR
         (substr(orig,ori + 1,1) = 'H' AND
          substr(orig,ori + 2,1) <> ' ') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'DI';
      END IF;
     -- Letra C
     ELSIF substr(orig,ori,1) = 'C' THEN
      IF substr(orig,ori + 1,1) = 'H' THEN
       IF substr(orig,ori + 2,1) IN ('A','E','I','O','U','Y') THEN
        dest := dest||'KS';
        ori := ori + 1;
       END IF;
      ELSIF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
       IF substr(orig,ori + 1,1) IN ('E','I','Y') THEN
        dest := dest||'S';
       ELSE
        dest := dest||'K';
       END IF;
      ELSE
       IF length(dest) = 1 THEN
        dest := '';
       END IF;
      END IF;
     -- Letra M
     ELSIF substr(orig,ori,1) = 'M' THEN
      IF substr(orig,ori + 1,1) = 'N' THEN
       IF length(dest) = 1 THEN
        dest := '';
       END IF;
      ELSE
       dest := dest||substr(orig,ori,1);
      END IF;
     -- Letra T
     ELSIF substr(orig,ori,1) = 'T' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') OR
         (substr(orig,ori + 1,1) = 'H' AND
          substr(orig,ori + 2,1) <> ' ') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'TI';
      END IF;
     -- Letra U
     ELSIF substr(orig,ori,1) = 'U' THEN
      dest := dest||'O';
     -- Letra V
     ELSIF substr(orig,ori,1) = 'V' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') OR
         (substr(orig,ori + 1,1) = 'H' AND
          substr(orig,ori + 2,1) <> ' ') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'VI';
      END IF;
     -- Letra G
     ELSIF substr(orig,ori,1) = 'G' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
       IF substr(orig,ori + 1,1) = 'U' AND
          substr(orig,ori + 2,1) IN ('I','E','Y') THEN
        dest := dest||'J';
        ori := ori + 1;
       ELSE
        dest := dest||'J';
       END IF;
      ELSE
       dest := dest||'JI';
      END IF;
     -- Letra B
     ELSIF substr(orig,ori,1) = 'B' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') OR
         (substr(orig,ori + 1,1) = 'H' AND
          substr(orig,ori + 2,1) <> ' ') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'BI';
      END IF;
     -- Letra P
     ELSIF substr(orig,ori,1) = 'P' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       IF substr(orig,ori + 1,1) = 'H' THEN
        dest := dest||'F';
       ELSE
        dest := dest||'PI';
       END IF;
      END IF;
     -- Letra Z
     ELSIF substr(orig,ori,1) = 'Z' THEN
       dest := dest||'S';
     -- Letra F
     ELSIF substr(orig,ori,1) = 'F' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') OR
         (substr(orig,ori + 1,1) = 'H' AND
          substr(orig,ori + 2,1) <> ' ') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'FI';
      END IF;
     -- Letra J
     ELSIF substr(orig,ori,1) = 'J' THEN
      dest := dest||'J';
     -- Letra K
     ELSIF substr(orig,ori,1) = 'K' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') OR
         (substr(orig,ori + 1,1) = 'H' AND
          substr(orig,ori + 2,1) <> ' ') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'KI';
      END IF;
     -- Letra Y
     ELSIF substr(orig,ori,1) = 'Y' THEN
      dest := dest||'I';
     -- Letra W
     ELSIF substr(orig,ori,1) = 'W' THEN
      IF ori = 1 THEN
       IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
        dest := dest||'V';
       ELSE
        dest := dest||'VI';
       END IF;
      ELSIF substr(orig,ori - 1,1) IN ('E','I') THEN
       IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
        dest := dest||'V';
       ELSE
        dest := dest||'O';
       END IF;
      ELSE
       dest := dest||'V';
      END IF;
     -- Letra Q
     ELSIF substr(orig,ori,1) = 'Q' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y',' ') THEN
       dest := dest||'K';
       IF substr(orig,ori + 1,1) = 'U' AND
          substr(orig,ori + 2,1) IN ('I','E','Y') THEN
        ori := ori + 1;
       END IF;
      ELSE
       dest := dest||'QI';
      END IF;
     -- Letra X
     ELSIF substr(orig,ori,1) = 'X' THEN
      dest := dest||'KS';
     END IF;
    END LOOP;
    dest := NULL;
    RETURN;
   END;
  $_$;


ALTER FUNCTION public.fcn_fonetiza(text) OWNER TO postgres;

--
-- Name: fcn_fonetiza_logr_geral(); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_fonetiza_logr_geral() RETURNS text
    LANGUAGE plpgsql
    AS $$
   DECLARE
    v_fonema   text;
    v_nomlog   text;
    v_idlog    bigint;
    v_reg_log  record;
    v_reg_fon  record;
    v_cont     integer;
   BEGIN
    FOR v_reg_log IN SELECT idlog, nome FROM public.logradouro LOOP
     v_nomlog := v_reg_log.nome;
     v_idlog  := v_reg_log.idlog;
     FOR v_reg_fon IN SELECT DISTINCT * FROM public.fcn_fonetiza(v_nomlog) LOOP
      v_fonema := v_reg_fon.fcn_fonetiza;
      EXECUTE 'INSERT INTO public.logradouro_fonetico (fonema,idlog) VALUES ('||quote_literal(v_fonema)||','||quote_literal(v_idlog)||');';
     END LOOP;
    END LOOP;
    SELECT count(idlog) INTO v_cont FROM public.logradouro_fonetico;
    v_fonema := 'Foram gravados '||to_char(v_cont,'9999999')||' registros em logradouro_fonetico';
    RETURN v_fonema;
   END;
  $$;


ALTER FUNCTION public.fcn_fonetiza_logr_geral() OWNER TO postgres;

--
-- Name: fcn_fonetiza_palavra(text); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_fonetiza_palavra(text) RETURNS text
    LANGUAGE plpgsql
    AS $_$
DECLARE
    v_array         ALIAS FOR $1;
    orig            text := '';
    dest            text := '';
    ori             integer := 1;
    v_campo         integer;
   BEGIN
    orig := public.fcn_upper_nrm(v_array)||'  ';
    FOR ori IN 1..152 LOOP
     IF substr(orig, ori, 1) = ' ' THEN
      IF substr(orig, ori + 1, 1) = ' ' THEN
       IF dest IN ('DA','DAS','DOS','DU','DUS','DI','E','S/A','LTDA','OTIDA','S.A','DO','DE','-','AVI','I','OA','A','SA') THEN
        dest := '';
       END IF;
       IF dest <> ' ' AND
          dest <> '' THEN
        RETURN trim(dest);
        dest := '';
       END IF;
       ori := 152;
       EXIT;
      ELSE
       IF dest IN ('DA','DAS','DOS','DU','DUS','DI','E','S/A','LTDA','OTIDA','S.A','DO','DE','-','AVI','I','OA','A','SA') THEN
        dest := '';
       END IF;
       IF dest <> ' ' AND
          dest <> '' THEN
        RETURN trim(dest);
        dest := '';
       END IF;
       ori := ori + 1;
      END IF;
     ELSIF substr(orig,ori + 1,1) = '-' OR
           substr(orig,ori + 1,1) = '/' THEN
      IF substr(orig,ori,1) <> ' ' AND
         substr(orig,ori + 2,1) <> ' ' THEN
       orig = substr(orig,1,ori)||' '||substr(orig,ori + 1,42);
      END IF;
     END IF;
     -- Numero
     IF substr(orig,ori,1) >= '0' and
        substr(orig,ori,1) <= '9' THEN
      dest := dest||substr(orig,ori,1);
     -- Letra Igual
     ELSIF substr(orig,ori,1) = substr(orig,ori + 1,1) THEN
      IF length(dest) = 1 THEN
       dest := '';
      END IF;
     -- Letras A, I ou O
     ELSIF substr(orig,ori,1) = 'A' OR
           substr(orig,ori,1) = 'I' OR
           substr(orig,ori,1) = 'O' THEN
      dest := dest||substr(orig,ori,1);
     -- Letra E
     ELSIF substr(orig,ori,1) = 'E' THEN
      dest := dest||'I';
     -- Letra R
     ELSIF substr(orig,ori,1) = 'R' THEN
       dest := dest||'H';
     -- Letra S
     ELSIF substr(orig,ori,1) = 'S' THEN
      IF substr(orig,ori + 1,1) NOT IN ('A','E','I','O','U','Y') AND
         length(dest) = 0 THEN
       dest := dest||'IS';
      ELSIF substr(orig,ori + 1,1) = 'C' AND
            substr(orig,ori + 2,1) = 'H' THEN
       IF length(dest) = 1 THEN
        dest := '';
       END IF;
      ELSIF substr(orig,ori + 1,1) = 'H' THEN
       dest := dest||'KS';
       ori := ori + 1;
      ELSE
       dest := dest||substr(orig,ori,1);
      END IF;
     -- Letra N
     ELSIF substr(orig,ori,1) = 'N' THEN
      IF substr(orig,ori + 1,1) = 'H' THEN
       dest := dest||'NI';
      ELSE
       IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
        dest := dest||substr(orig,ori,1);
       ELSE
        dest := dest||'M';
       END IF;
      END IF;
     -- Letra L
     ELSIF substr(orig,ori,1) = 'L' THEN
      IF substr(orig,ori + 1,1) = 'H' THEN
       dest := dest||'LI';
      ELSIF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'O';
      END IF;
     -- Letra D
     ELSIF substr(orig,ori,1) = 'D' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') OR
         (substr(orig,ori + 1,1) = 'H' AND
          substr(orig,ori + 2,1) <> ' ') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'DI';
      END IF;
     -- Letra C
     ELSIF substr(orig,ori,1) = 'C' THEN
      IF substr(orig,ori + 1,1) = 'H' THEN
       IF substr(orig,ori + 2,1) IN ('A','E','I','O','U','Y') THEN
        dest := dest||'KS';
        ori := ori + 1;
       END IF;
      ELSIF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
       IF substr(orig,ori + 1,1) IN ('E','I','Y') THEN
        dest := dest||'S';
       ELSE
        dest := dest||'K';
       END IF;
      ELSE
       IF length(dest) = 1 THEN
        dest := '';
       END IF;
      END IF;
     -- Letra M
     ELSIF substr(orig,ori,1) = 'M' THEN
      IF substr(orig,ori + 1,1) = 'N' THEN
       IF length(dest) = 1 THEN
        dest := '';
       END IF;
      ELSE
       dest := dest||substr(orig,ori,1);
      END IF;
     -- Letra T
     ELSIF substr(orig,ori,1) = 'T' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') OR
         (substr(orig,ori + 1,1) = 'H' AND
          substr(orig,ori + 2,1) <> ' ') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'TI';
      END IF;
     -- Letra U
     ELSIF substr(orig,ori,1) = 'U' THEN
      dest := dest||'O';
     -- Letra V
     ELSIF substr(orig,ori,1) = 'V' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') OR
         (substr(orig,ori + 1,1) = 'H' AND
          substr(orig,ori + 2,1) <> ' ') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'VI';
      END IF;
     -- Letra G
     ELSIF substr(orig,ori,1) = 'G' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
       IF substr(orig,ori + 1,1) = 'U' AND
          substr(orig,ori + 2,1) IN ('I','E','Y') THEN
        dest := dest||'J';
        ori := ori + 1;
       ELSE
        dest := dest||'J';
       END IF;
      ELSE
       dest := dest||'JI';
      END IF;
     -- Letra B
     ELSIF substr(orig,ori,1) = 'B' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') OR
         (substr(orig,ori + 1,1) = 'H' AND
          substr(orig,ori + 2,1) <> ' ') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'BI';
      END IF;
     -- Letra P
     ELSIF substr(orig,ori,1) = 'P' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       IF substr(orig,ori + 1,1) = 'H' THEN
        dest := dest||'F';
       ELSE
        dest := dest||'PI';
       END IF;
      END IF;
     -- Letra Z
     ELSIF substr(orig,ori,1) = 'Z' THEN
       dest := dest||'S';
     -- Letra F
     ELSIF substr(orig,ori,1) = 'F' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') OR
         (substr(orig,ori + 1,1) = 'H' AND
          substr(orig,ori + 2,1) <> ' ') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'FI';
      END IF;
     -- Letra J
     ELSIF substr(orig,ori,1) = 'J' THEN
      dest := dest||'J';
     -- Letra K
     ELSIF substr(orig,ori,1) = 'K' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') OR
         (substr(orig,ori + 1,1) = 'H' AND
          substr(orig,ori + 2,1) <> ' ') THEN
       dest := dest||substr(orig,ori,1);
      ELSE
       dest := dest||'KI';
      END IF;
     -- Letra Y
     ELSIF substr(orig,ori,1) = 'Y' THEN
      dest := dest||'I';
     -- Letra W
     ELSIF substr(orig,ori,1) = 'W' THEN
      IF ori = 1 THEN
       IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
        dest := dest||'V';
       ELSE
        dest := dest||'VI';
       END IF;
      ELSIF substr(orig,ori - 1,1) IN ('E','I') THEN
       IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y') THEN
        dest := dest||'V';
       ELSE
        dest := dest||'O';
       END IF;
      ELSE
       dest := dest||'V';
      END IF;
     -- Letra Q
     ELSIF substr(orig,ori,1) = 'Q' THEN
      IF substr(orig,ori + 1,1) IN ('A','E','I','O','U','Y',' ') THEN
       dest := dest||'K';
       IF substr(orig,ori + 1,1) = 'U' AND
          substr(orig,ori + 2,1) IN ('I','E','Y') THEN
        ori := ori + 1;
       END IF;
      ELSE
       dest := dest||'QI';
      END IF;
     -- Letra X
     ELSIF substr(orig,ori,1) = 'X' THEN
      dest := dest||'KS';
     END IF;
    END LOOP;
    dest := NULL;
    RETURN;
   END;
  $_$;


ALTER FUNCTION public.fcn_fonetiza_palavra(text) OWNER TO postgres;

--
-- Name: fcn_fonetiza_pessoa_geral(); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_fonetiza_pessoa_geral() RETURNS text
    LANGUAGE plpgsql
    AS $$
   DECLARE
    v_fonema   text;
    v_nome     text;
    v_idpes    bigint;
    v_reg_pes  record;
    v_reg_fon  record;
    v_cont     integer;
   BEGIN
    FOR v_reg_pes IN SELECT idpes, nome FROM cadastro.pessoa LOOP
     v_nome  := v_reg_pes.nome;
     v_idpes := v_reg_pes.idpes;
     FOR v_reg_fon IN SELECT DISTINCT * FROM public.fcn_fonetiza(v_nome) LOOP
      v_fonema := v_reg_fon.fcn_fonetiza;
      EXECUTE 'INSERT INTO cadastro.pessoa_fonetico (fonema,idpes) VALUES ('||quote_literal(v_fonema)||','||quote_literal(v_idpes)||');';
     END LOOP;
    END LOOP;
    SELECT count(idpes) INTO v_cont FROM cadastro.pessoa_fonetico;
    v_fonema := 'Foram gravados '||to_char(v_cont,'999999')||' registros em pessoa_fonetico';
    RETURN v_fonema;
   END;
  $$;


ALTER FUNCTION public.fcn_fonetiza_pessoa_geral() OWNER TO postgres;

--
-- Name: fcn_fonetiza_primeiro_ultimo_nome(text); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_fonetiza_primeiro_ultimo_nome(text) RETURNS text
    LANGUAGE plpgsql
    AS $_$
DECLARE
  v_nome_parametro    ALIAS FOR $1;
  v_registro      record;
  v_nome_primeiro_ultimo_pessoa text;
  v_cont          integer;
  v_fonema        text;
  BEGIN
  v_nome_primeiro_ultimo_pessoa := '';
  v_cont := 0;
  -- primeiro e último nome da pessoa com fonética
  FOR v_registro IN SELECT * FROM public.fcn_fonetiza(public.fcn_obter_primeiro_ultimo_nome(v_nome_parametro)) LOOP
    v_cont := v_cont + 1;
    v_fonema := v_registro.fcn_fonetiza;
    IF v_cont > 1 THEN
      v_nome_primeiro_ultimo_pessoa := v_nome_primeiro_ultimo_pessoa || ' ';
    END IF;
    v_nome_primeiro_ultimo_pessoa := v_nome_primeiro_ultimo_pessoa || v_fonema;
  END LOOP;
  RETURN v_nome_primeiro_ultimo_pessoa;
   END;
  $_$;


ALTER FUNCTION public.fcn_fonetiza_primeiro_ultimo_nome(text) OWNER TO postgres;

--
-- Name: fcn_insert_documento(integer, character varying, character varying, character varying, character varying, integer, integer, integer, integer, character varying, character varying, character varying, character varying, integer, integer, character varying, character varying, integer, integer, character, integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_insert_documento(integer, character varying, character varying, character varying, character varying, integer, integer, integer, integer, character varying, character varying, character varying, character varying, integer, integer, character varying, character varying, integer, integer, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_rg ALIAS for $2;
  v_orgao_exp_rg ALIAS for $3;
  v_data_exp_rg ALIAS for $4;
  v_sigla_uf_exp_rg ALIAS for $5;
      v_tipo_cert_civil ALIAS for $6;
      v_num_termo ALIAS for $7;
  v_num_livro ALIAS for $8;
  v_num_folha ALIAS for $9;
      v_data_emissao_cert_civil ALIAS for $10;
      v_sigla_uf_cert_civil ALIAS for $11;
  v_sigla_uf_cart_trabalho ALIAS for $12;
  v_cartorio_cert_civil ALIAS for $13;
  v_num_cart_trabalho ALIAS for $14;
      v_serie_cart_trabalho ALIAS for $15;
      v_data_emissao_cart_trabalho ALIAS for $16;
  v_num_tit_eleitor ALIAS for $17;
  v_zona_tit_eleitor ALIAS for $18;
  v_secao_tit_eleitor ALIAS for $19;
  v_origem_gravacao ALIAS for $20;
  v_idpes_cad ALIAS for $21;
  v_idsis_cad ALIAS for $22;

    -- Outras variáveis
      v_rg_aux varchar(10);
      v_orgao_exp_rg_aux varchar(10);
      v_sigla_uf_exp_rg_aux varchar(2);
  v_tipo_cert_civil_aux integer;
  v_num_termo_aux integer;
  v_num_livro_aux integer;
  v_num_folha_aux integer;
      v_sigla_uf_cert_civil_aux varchar(2);
  v_sigla_uf_cart_trabalho_aux varchar(2);
      v_cartorio_cert_civil_aux varchar(150);
      v_num_cart_trabalho_aux integer;
      v_serie_cart_trabalho_aux integer;
      v_num_tit_eleitor_aux varchar(13);
      v_zona_tit_eleitor_aux integer;
      v_secao_tit_eleitor_aux integer;
BEGIN
    IF v_rg = '' THEN
        v_rg_aux := NULL;
    ELSE
        v_rg_aux := v_rg;
    END IF;
    IF v_orgao_exp_rg = '' THEN
        v_orgao_exp_rg_aux := NULL;
    ELSE
        v_orgao_exp_rg_aux := v_orgao_exp_rg;
    END IF;
    IF v_sigla_uf_exp_rg = '' THEN
        v_sigla_uf_exp_rg_aux := NULL;
    ELSE
        v_sigla_uf_exp_rg_aux := v_sigla_uf_exp_rg;
    END IF;
    IF v_tipo_cert_civil = 0 THEN
        v_tipo_cert_civil_aux := NULL;
    ELSE
        v_tipo_cert_civil_aux := v_tipo_cert_civil;
    END IF;
    IF v_num_termo = 0 THEN
        v_num_termo_aux := NULL;
    ELSE
        v_num_termo_aux := v_num_termo;
    END IF;
    IF v_num_livro = 0 THEN
        v_num_livro_aux := NULL;
    ELSE
        v_num_livro_aux := v_num_livro;
    END IF;
    IF v_num_folha = 0 THEN
        v_num_folha_aux := NULL;
    ELSE
        v_num_folha_aux := v_num_folha;
    END IF;
    IF v_sigla_uf_cert_civil = '' THEN
        v_sigla_uf_cert_civil_aux := NULL;
    ELSE
        v_sigla_uf_cert_civil_aux := v_sigla_uf_cert_civil;
    END IF;
    IF v_sigla_uf_cart_trabalho = '' THEN
        v_sigla_uf_cart_trabalho_aux := NULL;
    ELSE
        v_sigla_uf_cart_trabalho_aux := v_sigla_uf_cart_trabalho;
    END IF;
    IF v_cartorio_cert_civil = '' THEN
        v_cartorio_cert_civil_aux := NULL;
    ELSE
        v_cartorio_cert_civil_aux := v_cartorio_cert_civil;
    END IF;
    IF v_num_cart_trabalho = 0 THEN
        v_num_cart_trabalho_aux := NULL;
    ELSE
        v_num_cart_trabalho_aux := v_num_cart_trabalho;
    END IF;
    IF v_serie_cart_trabalho = 0 THEN
        v_serie_cart_trabalho_aux := NULL;
    ELSE
        v_serie_cart_trabalho_aux := v_serie_cart_trabalho;
    END IF;
    IF v_num_tit_eleitor = '' THEN
        v_num_tit_eleitor_aux := NULL;
    ELSE
        v_num_tit_eleitor_aux := v_num_tit_eleitor;
    END IF;
    IF v_zona_tit_eleitor = 0 THEN
        v_zona_tit_eleitor_aux := NULL;
    ELSE
        v_zona_tit_eleitor_aux := v_zona_tit_eleitor;
    END IF;
    IF v_secao_tit_eleitor = 0 THEN
        v_secao_tit_eleitor_aux := NULL;
    ELSE
        v_secao_tit_eleitor_aux := v_secao_tit_eleitor;
    END IF;

  -- Insere dados na tabela funcionário
    INSERT INTO cadastro.documento (idpes, rg, idorg_exp_rg,
                                data_exp_rg, sigla_uf_exp_rg,
                                tipo_cert_civil, num_termo,
                                num_livro, num_folha,
                                data_emissao_cert_civil, sigla_uf_cert_civil,
                                sigla_uf_cart_trabalho, cartorio_cert_civil,
                                num_cart_trabalho, serie_cart_trabalho,
                                data_emissao_cart_trabalho, num_tit_eleitor,                                              zona_tit_eleitor, secao_tit_eleitor, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao)
    VALUES(v_id_pes, to_number(v_rg_aux,9999999999), to_number(v_orgao_exp_rg_aux,9999999999),
           to_date(v_data_exp_rg,'DD/MM/YYYY'), v_sigla_uf_exp_rg_aux,
           v_tipo_cert_civil_aux, v_num_termo_aux,
           v_num_livro_aux, v_num_folha_aux,
           to_date(v_data_emissao_cert_civil,'DD/MM/YYYY'), v_sigla_uf_cert_civil_aux,
           v_sigla_uf_cart_trabalho_aux, v_cartorio_cert_civil_aux,
           v_num_cart_trabalho_aux, v_serie_cart_trabalho_aux,
           to_date(v_data_emissao_cart_trabalho,'DD/MM/YYYY'), to_number(v_num_tit_eleitor_aux,9999999999999),
           v_zona_tit_eleitor_aux, v_secao_tit_eleitor_aux, v_origem_gravacao, v_idpes_cad, v_idsis_cad, CURRENT_TIMESTAMP, 'I');
  RETURN 0;
END;$_$;


ALTER FUNCTION public.fcn_insert_documento(integer, character varying, character varying, character varying, character varying, integer, integer, integer, integer, character varying, character varying, character varying, character varying, integer, integer, character varying, character varying, integer, integer, character, integer, integer) OWNER TO postgres;

--
-- Name: fcn_insert_endereco_externo(integer, integer, character varying, character varying, character varying, integer, character varying, character varying, character varying, integer, character varying, character varying, character, integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_insert_endereco_externo(integer, integer, character varying, character varying, character varying, integer, character varying, character varying, character varying, integer, character varying, character varying, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_tipo ALIAS for $2;
  v_sigla_uf ALIAS for $3;
  v_idtlog ALIAS for $4;
    v_logradouro ALIAS for $5;
    v_numero ALIAS for $6;
    v_letra ALIAS for $7;
    v_complemento ALIAS for $8;
    v_bairro ALIAS for $9;
    v_cep ALIAS for $10;
    v_cidade ALIAS for $11;
    v_reside_desde ALIAS for $12;
    v_origem_gravacao ALIAS for $13;
    v_idpes_cad ALIAS for $14;
    v_idsis_cad ALIAS for $15;

BEGIN
  -- Atualiza dados na tabela endereco_externo
    INSERT INTO cadastro.endereco_externo(idpes, tipo, sigla_uf, idtlog, logradouro, numero, letra, complemento, bairro, cep, cidade, reside_desde, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao)
    VALUES (v_id_pes, v_tipo, v_sigla_uf, v_idtlog, public.fcn_upper(v_logradouro), v_numero, public.fcn_upper(v_letra), public.fcn_upper(v_complemento), public.fcn_upper(v_bairro), v_cep, public.fcn_upper(v_cidade), to_date(v_reside_desde,'DD/MM/YYYY'), v_origem_gravacao, v_idpes_cad, v_idsis_cad, CURRENT_TIMESTAMP, 'I');

  RETURN 0;
END;$_$;


ALTER FUNCTION public.fcn_insert_endereco_externo(integer, integer, character varying, character varying, character varying, integer, character varying, character varying, character varying, integer, character varying, character varying, character, integer, integer) OWNER TO postgres;

--
-- Name: fcn_insert_endereco_pessoa(integer, integer, integer, integer, integer, integer, character varying, character varying, character varying, character, integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_insert_endereco_pessoa(integer, integer, integer, integer, integer, integer, character varying, character varying, character varying, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_tipo ALIAS for $2;
  v_cep ALIAS for $3;
  v_idlog ALIAS for $4;
  v_idbai ALIAS for $5;
  v_numero ALIAS for $6;
  v_letra ALIAS for $7;
  v_complemento ALIAS for $8;
  v_reside_desde ALIAS for $9;
  v_origem_gravacao ALIAS for $10;
      v_idpes_cad ALIAS for $11;
      v_idsis_cad ALIAS for $12;
BEGIN
  -- Insere dados na tabela endereco_pessoa
    INSERT INTO cadastro.endereco_pessoa (idpes,tipo,cep,idlog,idbai,numero,letra,complemento,reside_desde, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao)
  VALUES(v_id_pes,v_tipo,v_cep,v_idlog,v_idbai,v_numero,public.fcn_upper(v_letra),public.fcn_upper(v_complemento),to_date(v_reside_desde,'DD/MM/YYYY'), v_origem_gravacao, v_idpes_cad, v_idsis_cad, CURRENT_TIMESTAMP, 'I');
  RETURN 0;
END;$_$;


ALTER FUNCTION public.fcn_insert_endereco_pessoa(integer, integer, integer, integer, integer, integer, character varying, character varying, character varying, character, integer, integer) OWNER TO postgres;

--
-- Name: fcn_insert_fisica(integer, character varying, character varying, integer, integer, integer, integer, integer, integer, character varying, character varying, integer, integer, character varying, integer, character varying, integer, character varying, character varying, character varying, character varying, character varying, character, integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_insert_fisica(integer, character varying, character varying, integer, integer, integer, integer, integer, integer, character varying, character varying, integer, integer, character varying, integer, character varying, integer, character varying, character varying, character varying, character varying, character varying, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_data_nasc ALIAS for $2;
  v_sexo ALIAS for $3;
  v_id_pes_mae ALIAS for $4;
      v_id_pes_pai ALIAS for $5;
      v_id_pes_responsavel ALIAS for $6;
  v_id_esco ALIAS for $7;
  v_id_eciv ALIAS for $8;
  v_id_pes_con ALIAS for $9;
      v_data_uniao ALIAS for $10;
      v_data_obito ALIAS for $11;
  v_nacionalidade ALIAS for $12;
  v_id_pais_estrangeiro ALIAS for $13;
  v_data_chegada ALIAS for $14;
      v_id_mun_nascimento ALIAS for $15;
      v_ultima_empresa ALIAS for $16;
  v_id_ocup ALIAS for $17;
  v_nome_mae ALIAS for $18;
  v_nome_pai ALIAS for $19;
      v_nome_conjuge ALIAS for $20;
      v_nome_responsavel ALIAS for $21;
      v_justificativa_provisorio ALIAS for $22;
  v_origem_gravacao ALIAS for $23;
      v_idpes_cad ALIAS for $24;
      v_idsis_cad ALIAS for $25;
      -- Outras variáveis
      v_id_pes_mae_aux integer;
      v_id_pes_pai_aux integer;
      v_id_pes_responsavel_aux integer;
  v_id_esco_aux integer;
  v_id_eciv_aux integer;
  v_id_pes_con_aux integer;
      v_nacionalidade_aux integer;
  v_id_pais_estrangeiro_aux integer;
      v_id_mun_nascimento_aux integer;
      v_id_ocup_aux integer;
      v_sexo_aux text;
BEGIN
    IF v_id_pes_mae = 0 THEN
        v_id_pes_mae_aux := NULL;
    ELSE
        v_id_pes_mae_aux := v_id_pes_mae;
    END IF;
    IF v_id_pes_pai = 0 THEN
        v_id_pes_pai_aux := NULL;
    ELSE
        v_id_pes_pai_aux := v_id_pes_pai;
    END IF;
    IF v_id_pes_responsavel = 0 THEN
        v_id_pes_responsavel_aux := NULL;
    ELSE
        v_id_pes_responsavel_aux := v_id_pes_responsavel;
    END IF;
    IF v_id_esco = 0 THEN
        v_id_esco_aux := NULL;
    ELSE
        v_id_esco_aux := v_id_esco;
    END IF;
    IF v_id_eciv = 0 THEN
        v_id_eciv_aux := NULL;
    ELSE
        v_id_eciv_aux := v_id_eciv;
    END IF;
    IF v_id_pes_con = 0 THEN
        v_id_pes_con_aux := NULL;
    ELSE
        v_id_pes_con_aux := v_id_pes_con;
    END IF;
    IF v_nacionalidade = 0 THEN
        v_nacionalidade_aux := NULL;
    ELSE
        v_nacionalidade_aux := v_nacionalidade;
    END IF;
    IF v_id_pais_estrangeiro = 0 THEN
        v_id_pais_estrangeiro_aux := NULL;
    ELSE
        v_id_pais_estrangeiro_aux := v_id_pais_estrangeiro;
    END IF;
    IF v_id_mun_nascimento = 0 THEN
        v_id_mun_nascimento_aux := NULL;
    ELSE
        v_id_mun_nascimento_aux := v_id_mun_nascimento;
    END IF;
    IF v_id_ocup = 0 THEN
        v_id_ocup_aux := NULL;
    ELSE
        v_id_ocup_aux := v_id_ocup;
    END IF;
    IF TRIM(v_sexo) = '' THEN
        v_sexo_aux := NULL;
    ELSE
        v_sexo_aux := public.fcn_upper(v_sexo);
    END IF;
  -- Insere dados na tabela funcionário
    INSERT INTO cadastro.fisica (idpes, data_nasc, sexo,
                                idpes_mae,idpes_pai, idpes_responsavel,
                                idesco, ideciv, idpes_con,
                                data_uniao, data_obito, nacionalidade,
                                idpais_estrangeiro, data_chegada_brasil, idmun_nascimento,
                                ultima_empresa, idocup, nome_mae,
                                nome_pai, nome_conjuge,
                                nome_responsavel, justificativa_provisorio, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao)
    VALUES(v_id_pes,to_date(v_data_nasc,'DD/MM/YYYY'),v_sexo_aux,
           v_id_pes_mae_aux, v_id_pes_pai_aux, v_id_pes_responsavel_aux,
           v_id_esco_aux, v_id_eciv_aux, v_id_pes_con_aux,
           to_date(v_data_uniao,'DD/MM/YYYY'), to_date(v_data_obito,'DD/MM/YYYY'), v_nacionalidade_aux,
           v_id_pais_estrangeiro_aux, to_date(v_data_chegada,'DD/MM/YYYY'), v_id_mun_nascimento_aux,             public.fcn_upper(v_ultima_empresa), v_id_ocup_aux, public.fcn_upper(v_nome_mae),
           public.fcn_upper(v_nome_pai), public.fcn_upper(v_nome_conjuge),
           public.fcn_upper(v_nome_responsavel), v_justificativa_provisorio, v_origem_gravacao, v_idpes_cad, v_idsis_cad, CURRENT_TIMESTAMP, 'I');

  RETURN 0;
END;$_$;


ALTER FUNCTION public.fcn_insert_fisica(integer, character varying, character varying, integer, integer, integer, integer, integer, integer, character varying, character varying, integer, integer, character varying, integer, character varying, integer, character varying, character varying, character varying, character varying, character varying, character, integer, integer) OWNER TO postgres;

--
-- Name: fcn_insert_fisica_cpf(integer, text, character, integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_insert_fisica_cpf(integer, text, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_cpf ALIAS for $2;
  v_origem_gravacao ALIAS for $3;
      v_idpes_cad ALIAS for $4;
      v_idsis_cad ALIAS for $5;
BEGIN
  INSERT INTO cadastro.fisica_cpf (idpes,cpf, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (v_id_pes,to_number(v_cpf,99999999999), v_origem_gravacao, v_idpes_cad, v_idsis_cad, CURRENT_TIMESTAMP, 'I');
  RETURN 0;
END;$_$;


ALTER FUNCTION public.fcn_insert_fisica_cpf(integer, text, character, integer, integer) OWNER TO postgres;

--
-- Name: fcn_insert_fone_pessoa(integer, integer, integer, integer, character, integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_insert_fone_pessoa(integer, integer, integer, integer, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_tipo ALIAS for $2;
  v_ddd ALIAS for $3;
  v_fone ALIAS for $4;
  v_origem_gravacao ALIAS for $5;
      v_idpes_cad ALIAS for $6;
      v_idsis_cad ALIAS for $7;
BEGIN
  -- Insere dados na tabela fone_pessoa
  INSERT INTO cadastro.fone_pessoa (idpes,tipo,ddd,fone, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao)
    VALUES (v_id_pes,v_tipo,v_ddd,v_fone, v_origem_gravacao, v_idpes_cad, v_idsis_cad, CURRENT_TIMESTAMP, 'I');
  RETURN 0;
END;$_$;


ALTER FUNCTION public.fcn_insert_fone_pessoa(integer, integer, integer, integer, character, integer, integer) OWNER TO postgres;

--
-- Name: fcn_insert_funcionario(integer, integer, integer, integer, character varying, character, integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_insert_funcionario(integer, integer, integer, integer, character varying, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_matricula ALIAS for $1;
  v_id_ins ALIAS for $2;
  v_id_set ALIAS for $3;
  v_id_pes ALIAS for $4;
      v_situacao ALIAS for $5;
  v_origem_gravacao ALIAS for $6;
      v_idpes_cad ALIAS for $7;
      v_idsis_cad ALIAS for $8;
    -- Outras variáveis
    v_id_set_aux integer;
BEGIN
    IF v_id_set = 0 THEN
        v_id_set_aux := NULL;
    ELSE
        v_id_set_aux := v_id_set;
    END IF;
  -- Insere dados na tabela funcionário
    INSERT INTO cadastro.funcionario (matricula,idins,idset,idpes,situacao, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao)
    VALUES(v_matricula,v_id_ins,v_id_set_aux,v_id_pes,public.fcn_upper(v_situacao), v_origem_gravacao, v_idpes_cad, v_idsis_cad, CURRENT_TIMESTAMP, 'I');
  RETURN 0;
END;$_$;


ALTER FUNCTION public.fcn_insert_funcionario(integer, integer, integer, integer, character varying, character, integer, integer) OWNER TO postgres;

--
-- Name: fcn_insert_juridica(integer, character varying, character varying, character varying, character, integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_insert_juridica(integer, character varying, character varying, character varying, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_cnpj ALIAS for $2;
  v_fantasia ALIAS for $3;
  v_inscr_estadual ALIAS for $4;
  v_origem_gravacao ALIAS for $5;
      v_idpes_cad ALIAS for $6;
      v_idsis_cad ALIAS for $7;

BEGIN
  -- Insere dados na tabela juridica
    INSERT INTO cadastro.juridica (idpes,cnpj,fantasia,insc_estadual, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao)
    VALUES (v_id_pes,to_number(v_cnpj,99999999999999),public.fcn_upper(v_fantasia),to_number(v_inscr_estadual,9999999999), v_origem_gravacao, v_idpes_cad, v_idsis_cad, CURRENT_TIMESTAMP, 'I');
  RETURN 0;
END;$_$;


ALTER FUNCTION public.fcn_insert_juridica(integer, character varying, character varying, character varying, character, integer, integer) OWNER TO postgres;

--
-- Name: fcn_insert_pessoa(integer, character varying, character varying, character varying, character varying, integer, character varying, character varying, integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_insert_pessoa(integer, character varying, character varying, character varying, character varying, integer, character varying, character varying, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_razao_social ALIAS for $2;
  v_url ALIAS for $3;
  v_email ALIAS for $4;
  v_situacao ALIAS for $5;
  v_id_pes_logado ALIAS for $6;
  v_tipo ALIAS for $7;
  v_origem_gravacao ALIAS for $8;
      v_idpes_cad ALIAS for $9;
      v_idsis_cad ALIAS for $10;

  idpes_logado integer;
BEGIN
  idpes_logado := v_id_pes_logado;
  IF (idpes_logado <= 0) THEN
    INSERT INTO cadastro.pessoa (idpes,nome,idpes_cad,data_cad,url,tipo,email,situacao,origem_gravacao, idsis_cad, operacao) VALUES (v_id_pes,public.fcn_upper(v_razao_social),NULL,CURRENT_TIMESTAMP,v_url,v_tipo,v_email,v_situacao,v_origem_gravacao, v_idsis_cad, 'I');
  ELSE
    INSERT INTO cadastro.pessoa (idpes,nome,idpes_cad,data_cad,url,tipo,email,situacao,origem_gravacao, idsis_cad, operacao) VALUES (v_id_pes,public.fcn_upper(v_razao_social),idpes_logado,CURRENT_TIMESTAMP,v_url,v_tipo,v_email,v_situacao,v_origem_gravacao, v_idsis_cad, 'I');
  END IF;
  RETURN 0;
END;$_$;


ALTER FUNCTION public.fcn_insert_pessoa(integer, character varying, character varying, character varying, character varying, integer, character varying, character varying, integer, integer) OWNER TO postgres;

--
-- Name: fcn_obter_primeiro_ultimo_nome(text); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_obter_primeiro_ultimo_nome(text) RETURNS text
    LANGUAGE plpgsql
    AS $_$
DECLARE
  v_nome_parametro    ALIAS FOR $1;
  v_nome        text;
  v_primeiro_nome     text;
  v_ultimo_nome     text;
  v_posicao_espaco_primeiro_nome  integer;
  v_posicao_espaco_ultimo_nome  integer;
  v_cont        integer;
  v_fonema_junior     text;
  v_fonema_sobrinho   text;
  v_fonema_sobrinha   text;
  v_fonema_filho      text;
  v_fonema_filha      text;
  v_fonema_ultimo_nome    text;
  v_reg       record;
  v_total_caracteres    integer;
  BEGIN
  v_primeiro_nome := '';
  v_ultimo_nome := '';
  v_nome := TRIM(v_nome_parametro);
  v_total_caracteres := LENGTH(v_nome);
  -- obter somente o primeiro e o último nome das pessoas
  IF v_total_caracteres > 0 THEN
    -- retirar os espaços duplicados
    WHILE POSITION('  ' IN v_nome) > 0 LOOP
      v_nome := REPLACE(UPPER(v_nome),'  ', ' ');
    END LOOP;
    -- retirar ocorrências que devem ser ignoradas no nome
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E OUTROS', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E OUTRAS', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E OUTRO', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E OUTRA', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E OUTRS', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E OTS', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E OUTA', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E OUT', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E SM', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E S/M', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E OT', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' S/M', ''));
    v_total_caracteres := LENGTH(v_nome);
    IF v_total_caracteres = (POSITION(' OUTRO' IN v_nome) + 5) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' OUTRO', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' OUTRA' IN v_nome) + 5) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' OUTRA', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' OUTROS' IN v_nome) + 6) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' OUTROS', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' OUTRAS' IN v_nome) + 6) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' OUTRAS', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' OTS' IN v_nome) + 3) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' OTS', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' OUTA' IN v_nome) + 4) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' OUTA', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' OUT' IN v_nome) + 3) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' OUT', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' OUTRS' IN v_nome) + 5) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' OUTRS', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' SM' IN v_nome) + 2) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' SM', ''));
    END IF;
    v_nome := TRIM(v_nome);
    -- posição do espaço em branco para obter o primeiro nome
    v_posicao_espaco_primeiro_nome := POSITION(' ' IN v_nome);
    IF v_posicao_espaco_primeiro_nome > 0 THEN
      v_primeiro_nome := SUBSTR(v_nome, 1, (v_posicao_espaco_primeiro_nome - 1));
    ELSE
      v_primeiro_nome := v_nome;
    END IF;
    -- obter o último nome
    v_posicao_espaco_ultimo_nome := 0;
    IF v_posicao_espaco_primeiro_nome > 0 THEN
      v_cont := v_posicao_espaco_ultimo_nome + 1;
      -- obter posição do espaço em branco anterior ao último nome
      WHILE v_cont < LENGTH(v_nome) LOOP
        IF SUBSTR(v_nome, v_cont, 1) = ' ' THEN
          v_posicao_espaco_ultimo_nome = v_cont;
        END IF;
        v_cont := v_cont + 1;
      END LOOP;
      v_ultimo_nome := SUBSTR(v_nome, (v_posicao_espaco_ultimo_nome + 1));
      -- fonema do último nome
      FOR v_reg IN SELECT * FROM public.fcn_fonetiza(v_ultimo_nome) LOOP
        v_fonema_ultimo_nome := v_reg.fcn_fonetiza;
      END LOOP;
      -- verificar se o último nome termina com Junior, Sobrinho ou Filho e outros
      FOR v_reg IN SELECT * FROM public.fcn_fonetiza('junior') LOOP
        v_fonema_junior := v_reg.fcn_fonetiza;
      END LOOP;
      FOR v_reg IN SELECT * FROM public.fcn_fonetiza('sobrinho') LOOP
        v_fonema_sobrinho := v_reg.fcn_fonetiza;
      END LOOP;
      FOR v_reg IN SELECT * FROM public.fcn_fonetiza('filho') LOOP
        v_fonema_filho := v_reg.fcn_fonetiza;
      END LOOP;
      FOR v_reg IN SELECT * FROM public.fcn_fonetiza('filha') LOOP
        v_fonema_filha := v_reg.fcn_fonetiza;
      END LOOP;
      FOR v_reg IN SELECT * FROM public.fcn_fonetiza('sobrinha') LOOP
        v_fonema_sobrinha := v_reg.fcn_fonetiza;
      END LOOP;
      IF v_fonema_ultimo_nome = v_fonema_junior OR
                          v_fonema_ultimo_nome = v_fonema_sobrinho OR
                          v_fonema_ultimo_nome = v_fonema_filho OR
                          v_fonema_ultimo_nome = v_fonema_filha OR
                          v_fonema_ultimo_nome = v_fonema_sobrinha
                        THEN
        v_nome := TRIM(SUBSTR(v_nome, 1, (LENGTH(v_nome) - LENGTH(v_ultimo_nome) - 1)));
        v_primeiro_nome := '';
        v_ultimo_nome := '';
        -- obter novamente o primeiro nome
        v_posicao_espaco_primeiro_nome := POSITION(' ' IN v_nome);
        IF v_posicao_espaco_primeiro_nome > 0 THEN
          v_primeiro_nome := SUBSTR(v_nome, 1, (v_posicao_espaco_primeiro_nome - 1));
        END IF;

        -- obter o penultimo nome
        IF v_posicao_espaco_primeiro_nome > 0 THEN
          v_posicao_espaco_ultimo_nome := 0;
          v_cont := 1;

          -- obter posição do espaço em branco anterior ao último nome
          WHILE v_cont < LENGTH(v_nome) LOOP
          IF SUBSTR(v_nome, v_cont, 1) = ' ' THEN
            v_posicao_espaco_ultimo_nome = v_cont;
          END IF;
          v_cont := v_cont + 1;
          END LOOP;
          v_ultimo_nome := SUBSTR(v_nome, (v_posicao_espaco_ultimo_nome + 1));
        END IF;
      END IF;
    END IF;
  END IF;
  RETURN v_primeiro_nome || ' ' || v_ultimo_nome;
  END;
  $_$;


ALTER FUNCTION public.fcn_obter_primeiro_ultimo_nome(text) OWNER TO postgres;

--
-- Name: fcn_obter_primeiro_ultimo_nome_juridica(text); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_obter_primeiro_ultimo_nome_juridica(text) RETURNS text
    LANGUAGE plpgsql
    AS $_$
DECLARE
  v_nome_parametro    ALIAS FOR $1;
  v_nome        text;
  v_primeiro_nome     text;
  v_ultimo_nome     text;
  v_posicao_espaco_primeiro_nome  integer;
  v_posicao_espaco_ultimo_nome  integer;
  v_cont        integer;
  v_fonema_ultimo_nome    text;
  v_reg       record;
  v_total_caracteres    integer;
  BEGIN
  v_primeiro_nome := '';
  v_ultimo_nome := '';
  v_nome := TRIM(v_nome_parametro);
  v_total_caracteres := LENGTH(v_nome);
  -- obter somente o primeiro e o ultimo nome das pessoas
  IF v_total_caracteres > 0 THEN
    -- retirar os espaços duplicados
    WHILE POSITION('  ' IN v_nome) > 0 LOOP
      v_nome := REPLACE(UPPER(v_nome),'  ', ' ');
    END LOOP;
    -- retirar ocorrências que devem ser ignoradas no nome
    v_nome := TRIM(REPLACE(UPPER(v_nome),'&', ' '));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E CIA LTDA ME', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E CIA LTDA', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' LTDA E OUTRA', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' CIA LTDA ME', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' CIA LTDA', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' CIA. LTDA.', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' CIA.LTDA.', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' CIA.LTDA', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' CIA LTDA.', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' CIA. LTDA', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' SC LT', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' S/C LT', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' S/C L', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' SC L', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' S/C LTD', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' SC LTD', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' E CIA', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' LTDA ME', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' LTDA. ME', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),' LTDA.ME', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),'LTDA', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),'LTDA.', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),'S/C', ''));
    v_nome := TRIM(REPLACE(UPPER(v_nome),'S/A', ''));
    v_total_caracteres := LENGTH(v_nome);
    IF v_total_caracteres = (POSITION(' LT' IN v_nome) + 2) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' LT', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' LT.' IN v_nome) + 3) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' LT.', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' LTD' IN v_nome) + 3) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' LTD', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' LTD.' IN v_nome) + 4) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' LTD.', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' ME.' IN v_nome) + 3) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' ME.', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' ME' IN v_nome) + 2) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' ME', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' -ME' IN v_nome) + 3) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' -ME', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' -ME.' IN v_nome) + 4) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' -ME.', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' SA' IN v_nome) + 2) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' SA', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' S.A.' IN v_nome) + 4) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' S.A.', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' S.A' IN v_nome) + 3) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' S.A', ''));
    END IF;
    IF v_total_caracteres = (POSITION(' S A' IN v_nome) + 3) THEN
      v_nome := TRIM(REPLACE(UPPER(v_nome),' S A', ''));
    END IF;
    v_nome := TRIM(v_nome);
    -- posição do espaco em branco para obter o primeiro nome
    v_posicao_espaco_primeiro_nome := POSITION(' ' IN v_nome);
    IF v_posicao_espaco_primeiro_nome > 0 THEN
      v_primeiro_nome := SUBSTR(v_nome, 1, (v_posicao_espaco_primeiro_nome - 1));
    ELSE
      v_primeiro_nome := v_nome;
    END IF;
    -- obter o ultimo nome
    v_posicao_espaco_ultimo_nome := 0;
    IF v_posicao_espaco_primeiro_nome > 0 THEN
      v_cont := v_posicao_espaco_ultimo_nome + 1;
      -- obter posicao do espaco em branco anterior ao ultimo nome
      WHILE v_cont < LENGTH(v_nome) LOOP
        IF SUBSTR(v_nome, v_cont, 1) = ' ' THEN
          v_posicao_espaco_ultimo_nome = v_cont;
        END IF;
        v_cont := v_cont + 1;
      END LOOP;
      v_ultimo_nome := SUBSTR(v_nome, (v_posicao_espaco_ultimo_nome + 1));
    END IF;
  END IF;
  --Fonetizando o primeiro nome--
  FOR v_reg IN SELECT * FROM public.fcn_fonetiza(v_primeiro_nome) LOOP
    v_primeiro_nome := v_reg.fcn_fonetiza;
  END LOOP;
  --Fonetizando o ultimo nome nome--
  FOR v_reg IN SELECT * FROM public.fcn_fonetiza(v_ultimo_nome) LOOP
    v_ultimo_nome := v_reg.fcn_fonetiza;
  END LOOP;
  RETURN v_primeiro_nome || ' ' || v_ultimo_nome;
  END;
  $_$;


ALTER FUNCTION public.fcn_obter_primeiro_ultimo_nome_juridica(text) OWNER TO postgres;

--
-- Name: fcn_update_documento(integer, character varying, character varying, character varying, character varying, integer, integer, integer, integer, character varying, character varying, character varying, character varying, integer, integer, character varying, character varying, integer, integer, character, integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_update_documento(integer, character varying, character varying, character varying, character varying, integer, integer, integer, integer, character varying, character varying, character varying, character varying, integer, integer, character varying, character varying, integer, integer, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_rg ALIAS for $2;
  v_orgao_exp_rg ALIAS for $3;
  v_data_exp_rg ALIAS for $4;
  v_sigla_uf_exp_rg ALIAS for $5;
    v_tipo_cert_civil ALIAS for $6;
    v_num_termo ALIAS for $7;
  v_num_livro ALIAS for $8;
  v_num_folha ALIAS for $9;
    v_data_emissao_cert_civil ALIAS for $10;
    v_sigla_uf_cert_civil ALIAS for $11;
  v_sigla_uf_cart_trabalho ALIAS for $12;
  v_cartorio_cert_civil ALIAS for $13;
  v_num_cart_trabalho ALIAS for $14;
    v_serie_cart_trabalho ALIAS for $15;
    v_data_emissao_cart_trabalho ALIAS for $16;
  v_num_tit_eleitor ALIAS for $17;
  v_zona_tit_eleitor ALIAS for $18;
  v_secao_tit_eleitor ALIAS for $19;
  v_origem_gravacao ALIAS for $20;
  v_idpes_rev ALIAS for $21;
  v_idsis_rev ALIAS for $22;

    -- Outras variáveis
    v_rg_aux varchar(10);
    v_orgao_exp_rg_aux varchar(10);
    v_sigla_uf_exp_rg_aux varchar(2);
    v_tipo_cert_civil_aux integer;
  v_num_termo_aux integer;
  v_num_livro_aux integer;
  v_num_folha_aux integer;
    v_sigla_uf_cert_civil_aux varchar(2);
  v_sigla_uf_cart_trabalho_aux varchar(2);
    v_cartorio_cert_civil_aux varchar(150);
    v_num_cart_trabalho_aux integer;
    v_serie_cart_trabalho_aux integer;
    v_num_tit_eleitor_aux varchar(13);
    v_zona_tit_eleitor_aux integer;
    v_secao_tit_eleitor_aux integer;
BEGIN
    IF v_rg = '' THEN
        v_rg_aux := NULL;
    ELSE
        v_rg_aux := v_rg;
    END IF;
    IF v_orgao_exp_rg = '' THEN
        v_orgao_exp_rg_aux := NULL;
    ELSE
        v_orgao_exp_rg_aux := v_orgao_exp_rg;
    END IF;
    IF v_sigla_uf_exp_rg = '' THEN
        v_sigla_uf_exp_rg_aux := NULL;
    ELSE
        v_sigla_uf_exp_rg_aux := v_sigla_uf_exp_rg;
    END IF;
    IF v_tipo_cert_civil = 0 THEN
        v_tipo_cert_civil_aux := NULL;
    ELSE
        v_tipo_cert_civil_aux := v_tipo_cert_civil;
    END IF;
    IF v_num_termo = 0 THEN
        v_num_termo_aux := NULL;
    ELSE
        v_num_termo_aux := v_num_termo;
    END IF;
    IF v_num_livro = 0 THEN
        v_num_livro_aux := NULL;
    ELSE
        v_num_livro_aux := v_num_livro;
    END IF;
    IF v_num_folha = 0 THEN
        v_num_folha_aux := NULL;
    ELSE
        v_num_folha_aux := v_num_folha;
    END IF;
    IF v_sigla_uf_cert_civil = '' THEN
        v_sigla_uf_cert_civil_aux := NULL;
    ELSE
        v_sigla_uf_cert_civil_aux := v_sigla_uf_cert_civil;
    END IF;
    IF v_sigla_uf_cart_trabalho = '' THEN
        v_sigla_uf_cart_trabalho_aux := NULL;
    ELSE
        v_sigla_uf_cart_trabalho_aux := v_sigla_uf_cart_trabalho;
    END IF;
    IF v_cartorio_cert_civil = '' THEN
        v_cartorio_cert_civil_aux := NULL;
    ELSE
        v_cartorio_cert_civil_aux := v_cartorio_cert_civil;
    END IF;
    IF v_num_cart_trabalho = 0 THEN
        v_num_cart_trabalho_aux := NULL;
    ELSE
        v_num_cart_trabalho_aux := v_num_cart_trabalho;
    END IF;
    IF v_serie_cart_trabalho = 0 THEN
        v_serie_cart_trabalho_aux := NULL;
    ELSE
        v_serie_cart_trabalho_aux := v_serie_cart_trabalho;
    END IF;
    IF v_num_tit_eleitor = '' THEN
        v_num_tit_eleitor_aux := NULL;
    ELSE
        v_num_tit_eleitor_aux := v_num_tit_eleitor;
    END IF;
    IF v_zona_tit_eleitor = 0 THEN
        v_zona_tit_eleitor_aux := NULL;
    ELSE
        v_zona_tit_eleitor_aux := v_zona_tit_eleitor;
    END IF;
    IF v_secao_tit_eleitor = 0 THEN
        v_secao_tit_eleitor_aux := NULL;
    ELSE
        v_secao_tit_eleitor_aux := v_secao_tit_eleitor;
    END IF;

  -- Insere dados na tabela funcionário
    UPDATE cadastro.documento
    SET rg = to_number(v_rg_aux,9999999999),
        idorg_exp_rg = to_number(v_orgao_exp_rg_aux,9999999999),
        data_exp_rg = to_date(v_data_exp_rg,'DD/MM/YYYY'),
        sigla_uf_exp_rg = v_sigla_uf_exp_rg_aux,
        tipo_cert_civil = v_tipo_cert_civil_aux,
        num_termo = v_num_termo_aux,
        num_livro = v_num_livro_aux,
        num_folha = v_num_folha_aux,
        data_emissao_cert_civil = to_date(v_data_emissao_cert_civil,'DD/MM/YYYY'),
        sigla_uf_cert_civil = v_sigla_uf_cert_civil_aux,
        sigla_uf_cart_trabalho = v_sigla_uf_cart_trabalho_aux,
        cartorio_cert_civil = v_cartorio_cert_civil_aux,
        num_cart_trabalho = v_num_cart_trabalho_aux,
        serie_cart_trabalho = v_serie_cart_trabalho_aux,
        data_emissao_cart_trabalho = to_date(v_data_emissao_cart_trabalho,'DD/MM/YYYY'),
        num_tit_eleitor = to_number(v_num_tit_eleitor_aux,9999999999999),                                              zona_tit_eleitor = v_zona_tit_eleitor_aux,
        secao_tit_eleitor = v_secao_tit_eleitor_aux,
  origem_gravacao = v_origem_gravacao,
  idpes_rev = v_idpes_rev,
  idsis_rev = v_idsis_rev,
  data_rev = CURRENT_TIMESTAMP,
  operacao = 'A'
    WHERE idpes = v_id_pes;


  RETURN 0;
END;$_$;


ALTER FUNCTION public.fcn_update_documento(integer, character varying, character varying, character varying, character varying, integer, integer, integer, integer, character varying, character varying, character varying, character varying, integer, integer, character varying, character varying, integer, integer, character, integer, integer) OWNER TO postgres;

--
-- Name: fcn_update_endereco_externo(integer, integer, character varying, character varying, character varying, integer, character varying, character varying, character varying, integer, character varying, character varying, character, integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_update_endereco_externo(integer, integer, character varying, character varying, character varying, integer, character varying, character varying, character varying, integer, character varying, character varying, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_tipo ALIAS for $2;
  v_sigla_uf ALIAS for $3;
  v_idtlog ALIAS for $4;
    v_logradouro ALIAS for $5;
    v_numero ALIAS for $6;
    v_letra ALIAS for $7;
    v_complemento ALIAS for $8;
    v_bairro ALIAS for $9;
    v_cep ALIAS for $10;
    v_cidade ALIAS for $11;
    v_reside_desde ALIAS for $12;
    v_origem_gravacao ALIAS for $13;
    v_idpes_rev ALIAS for $14;
    v_idsis_rev ALIAS for $15;

BEGIN
  -- Atualiza dados na tabela endereco_externo
  UPDATE cadastro.endereco_externo
    SET sigla_uf = v_sigla_uf,
        idtlog = v_idtlog,
        logradouro = public.fcn_upper(v_logradouro),
        numero = v_numero,
        letra = public.fcn_upper(v_letra),
        complemento = public.fcn_upper(v_complemento),
        bairro = public.fcn_upper(v_bairro),
        cep = v_cep,
        cidade = public.fcn_upper(v_cidade),
        reside_desde = to_date(v_reside_desde,'DD/MM/YYYY'),
  origem_gravacao = v_origem_gravacao,
  idpes_rev = v_idpes_rev,
  idsis_rev = v_idsis_rev,
  data_rev = CURRENT_TIMESTAMP,
  operacao = 'A'
    WHERE idpes = v_id_pes
    AND tipo = v_tipo;
  RETURN 0;
END;$_$;


ALTER FUNCTION public.fcn_update_endereco_externo(integer, integer, character varying, character varying, character varying, integer, character varying, character varying, character varying, integer, character varying, character varying, character, integer, integer) OWNER TO postgres;

--
-- Name: fcn_update_endereco_pessoa(integer, integer, integer, integer, integer, integer, character varying, character varying, character varying, character, integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_update_endereco_pessoa(integer, integer, integer, integer, integer, integer, character varying, character varying, character varying, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
    -- Parâmetro recebidos
    v_id_pes ALIAS for $1;
    v_tipo ALIAS for $2;
    v_cep ALIAS for $3;
    v_idlog ALIAS for $4;
    v_idbai ALIAS for $5;
    v_numero ALIAS for $6;
    v_letra ALIAS for $7;
    v_complemento ALIAS for $8;
    v_reside_desde ALIAS for $9;
    v_origem_gravacao ALIAS for $10;
    v_idpes_rev ALIAS for $11;
    v_idsis_rev ALIAS for $12;
    v_sql_update text;
BEGIN
    -- Atualiza dados na tabela endereco_pessoa
    UPDATE cadastro.endereco_pessoa
    SET cep = v_cep,
        idlog = v_idlog,
        idbai = v_idbai,
        numero = v_numero,
        letra = public.fcn_upper(v_letra),
        complemento = public.fcn_upper(v_complemento),
        reside_desde = to_date(v_reside_desde,'DD/MM/YYYY'),
  origem_gravacao = v_origem_gravacao,
  idpes_rev = v_idpes_rev,
  idsis_rev = v_idsis_rev,
  data_rev = CURRENT_TIMESTAMP,
  operacao = 'A'
    WHERE idpes = v_id_pes
    AND tipo = v_tipo;
    RETURN 0;
END;$_$;


ALTER FUNCTION public.fcn_update_endereco_pessoa(integer, integer, integer, integer, integer, integer, character varying, character varying, character varying, character, integer, integer) OWNER TO postgres;

--
-- Name: fcn_update_fisica(integer, character varying, character varying, integer, integer, integer, integer, integer, integer, character varying, character varying, integer, integer, character varying, integer, character varying, integer, character varying, character varying, character varying, character varying, character varying, character, integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_update_fisica(integer, character varying, character varying, integer, integer, integer, integer, integer, integer, character varying, character varying, integer, integer, character varying, integer, character varying, integer, character varying, character varying, character varying, character varying, character varying, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_data_nasc ALIAS for $2;
  v_sexo ALIAS for $3;
  v_id_pes_mae ALIAS for $4;
      v_id_pes_pai ALIAS for $5;
      v_id_pes_responsavel ALIAS for $6;
  v_id_esco ALIAS for $7;
  v_id_eciv ALIAS for $8;
  v_id_pes_con ALIAS for $9;
      v_data_uniao ALIAS for $10;
      v_data_obito ALIAS for $11;
  v_nacionalidade ALIAS for $12;
  v_id_pais_estrangeiro ALIAS for $13;
  v_data_chegada ALIAS for $14;
      v_id_mun_nascimento ALIAS for $15;
      v_ultima_empresa ALIAS for $16;
  v_id_ocup ALIAS for $17;
  v_nome_mae ALIAS for $18;
  v_nome_pai ALIAS for $19;
      v_nome_conjuge ALIAS for $20;
      v_nome_responsavel ALIAS for $21;
      v_justificativa_provisorio ALIAS for $22;
      v_origem_gravacao ALIAS for $23;
      v_idpes_rev ALIAS for $24;
      v_idsis_rev ALIAS for $25;

      -- Outras variáveis
      v_id_pes_mae_aux integer;
      v_id_pes_pai_aux integer;
      v_id_pes_responsavel_aux integer;
  v_id_esco_aux integer;
  v_id_eciv_aux integer;
  v_id_pes_con_aux integer;
      v_nacionalidade_aux integer;
  v_id_pais_estrangeiro_aux integer;
      v_id_mun_nascimento_aux integer;
      v_id_ocup_aux integer;
  v_sexo_aux text;
BEGIN
    IF v_id_pes_mae = 0 THEN
        v_id_pes_mae_aux := NULL;
    ELSE
        v_id_pes_mae_aux := v_id_pes_mae;
    END IF;
    IF v_id_pes_pai = 0 THEN
        v_id_pes_pai_aux := NULL;
    ELSE
        v_id_pes_pai_aux := v_id_pes_pai;
    END IF;
    IF v_id_pes_responsavel = 0 THEN
        v_id_pes_responsavel_aux := NULL;
    ELSE
        v_id_pes_responsavel_aux := v_id_pes_responsavel;
    END IF;
    IF v_id_esco = 0 THEN
        v_id_esco_aux := NULL;
    ELSE
        v_id_esco_aux := v_id_esco;
    END IF;
    IF v_id_eciv = 0 THEN
        v_id_eciv_aux := NULL;
    ELSE
        v_id_eciv_aux := v_id_eciv;
    END IF;
    IF v_id_pes_con = 0 THEN
        v_id_pes_con_aux := NULL;
    ELSE
        v_id_pes_con_aux := v_id_pes_con;
    END IF;
    IF v_nacionalidade = 0 THEN
        v_nacionalidade_aux := NULL;
    ELSE
        v_nacionalidade_aux := v_nacionalidade;
    END IF;
    IF v_id_pais_estrangeiro = 0 THEN
        v_id_pais_estrangeiro_aux := NULL;
    ELSE
        v_id_pais_estrangeiro_aux := v_id_pais_estrangeiro;
    END IF;
    IF v_id_mun_nascimento = 0 THEN
        v_id_mun_nascimento_aux := NULL;
    ELSE
        v_id_mun_nascimento_aux := v_id_mun_nascimento;
    END IF;
    IF v_id_ocup = 0 THEN
        v_id_ocup_aux := NULL;
    ELSE
        v_id_ocup_aux := v_id_ocup;
    END IF;
    IF TRIM(v_sexo) = '' THEN
        v_sexo_aux := NULL;
    ELSE
        v_sexo_aux := public.fcn_upper(v_sexo);
    END IF;
  -- Insere dados na tabela funcionário
    UPDATE cadastro.fisica
    SET data_nasc = to_date(v_data_nasc,'DD/MM/YYYY'),
        sexo = v_sexo_aux,
        idpes_mae = v_id_pes_mae_aux,
        idpes_pai = v_id_pes_pai_aux,
        idpes_responsavel = v_id_pes_responsavel_aux,
        idesco = v_id_esco_aux,
        ideciv = v_id_eciv_aux,
        idpes_con = v_id_pes_con_aux,
        data_uniao = to_date(v_data_uniao,'DD/MM/YYYY'),
        data_obito = to_date(v_data_obito,'DD/MM/YYYY'),
        nacionalidade = v_nacionalidade_aux,
        idpais_estrangeiro = v_id_pais_estrangeiro_aux,
        data_chegada_brasil = to_date(v_data_chegada,'DD/MM/YYYY'),
        idmun_nascimento = v_id_mun_nascimento_aux,
        ultima_empresa = public.fcn_upper(v_ultima_empresa),
        idocup = v_id_ocup_aux,
        nome_mae = public.fcn_upper(v_nome_mae),
        nome_pai = public.fcn_upper(v_nome_pai),
        nome_conjuge = public.fcn_upper(v_nome_conjuge),
        nome_responsavel = public.fcn_upper(v_nome_responsavel),
        justificativa_provisorio = v_justificativa_provisorio,
  origem_gravacao = v_origem_gravacao,
  idpes_rev = v_idpes_rev,
  idsis_rev = v_idsis_rev,
  data_rev = CURRENT_TIMESTAMP,
  operacao = 'A'
    WHERE idpes = v_id_pes;

  RETURN 0;
END;$_$;


ALTER FUNCTION public.fcn_update_fisica(integer, character varying, character varying, integer, integer, integer, integer, integer, integer, character varying, character varying, integer, integer, character varying, integer, character varying, integer, character varying, character varying, character varying, character varying, character varying, character, integer, integer) OWNER TO postgres;

--
-- Name: fcn_update_fisica_cpf(integer, text, character, integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_update_fisica_cpf(integer, text, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_cpf ALIAS for $2;
  v_origem_gravacao ALIAS for $3;
  v_idpes_rev ALIAS for $4;
  v_idsis_rev ALIAS for $5;

BEGIN
  -- Atualiza dados na tabela fisica_cpf
  UPDATE cadastro.fisica_cpf SET
    origem_gravacao = v_origem_gravacao,
    idpes_rev = v_idpes_rev,
    idsis_rev = v_idsis_rev,
    data_rev = CURRENT_TIMESTAMP,
    operacao = 'A',
    cpf = to_number(v_cpf,99999999999)
    WHERE cadastro.fisica_cpf.idpes = v_id_pes;
  RETURN 0;
END;$_$;


ALTER FUNCTION public.fcn_update_fisica_cpf(integer, text, character, integer, integer) OWNER TO postgres;

--
-- Name: fcn_update_fone_pessoa(integer, integer, integer, integer, character, integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_update_fone_pessoa(integer, integer, integer, integer, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_tipo ALIAS for $2;
  v_ddd ALIAS for $3;
  v_fone ALIAS for $4;
  v_origem_gravacao ALIAS for $5;
      v_idpes_rev ALIAS for $6;
      v_idsis_rev ALIAS for $7;

BEGIN
  -- Atualiza dados na tabela fone_pessoa
  UPDATE cadastro.fone_pessoa
    SET ddd = v_ddd,
        fone = v_fone,
  origem_gravacao = v_origem_gravacao,
  idpes_rev = v_idpes_rev,
  idsis_rev = v_idsis_rev,
  data_rev = CURRENT_TIMESTAMP,
  operacao = 'A'
    WHERE idpes = v_id_pes
    AND tipo = v_tipo;
  RETURN 0;
END;$_$;


ALTER FUNCTION public.fcn_update_fone_pessoa(integer, integer, integer, integer, character, integer, integer) OWNER TO postgres;

--
-- Name: fcn_update_funcionario(numeric, integer, integer, character varying, character, integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_update_funcionario(numeric, integer, integer, character varying, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_matricula ALIAS for $1;
  v_id_ins ALIAS for $2;
  v_id_set ALIAS for $3;
  v_situacao ALIAS for $4;
      v_origem_gravacao ALIAS for $5;
      v_idpes_rev ALIAS for $6;
      v_idsis_rev ALIAS for $7;
  -- Outras variáveis
  v_id_set_aux integer;
  v_matricula_aux numeric;
  v_id_ins_aux integer;
  v_situacao_aux varchar(1);
BEGIN
  v_matricula_aux := v_matricula;
  v_id_ins_aux := v_id_ins;
  v_situacao_aux := v_situacao;
  IF v_id_set <= 0 THEN
    v_id_set_aux := NULL;
  ELSE
    v_id_set_aux := v_id_set;
  END IF;

  IF v_id_set_aux IS NULL AND v_id_set = -1 THEN
    -- Sql utilizado para ativar e desativar o registro na tabela funcionário
     UPDATE cadastro.funcionario
      SET situacao=v_situacao_aux,
      origem_gravacao = v_origem_gravacao,
      idpes_rev = v_idpes_rev,
      idsis_rev = v_idsis_rev,
      data_rev = CURRENT_DATE,
      operacao = 'A'
      WHERE
          matricula=v_matricula_aux AND
          idins=v_id_ins_aux;
  ELSE
    UPDATE cadastro.funcionario
      SET idset=v_id_set_aux,
          situacao=v_situacao_aux,
          origem_gravacao = v_origem_gravacao,
          idpes_rev = v_idpes_rev,
          idsis_rev = v_idsis_rev,
          data_rev = CURRENT_TIMESTAMP,
            operacao = 'A'
      WHERE
          matricula=v_matricula_aux AND
          idins=v_id_ins_aux;
  END IF;

  RETURN 0;
END;$_$;


ALTER FUNCTION public.fcn_update_funcionario(numeric, integer, integer, character varying, character, integer, integer) OWNER TO postgres;

--
-- Name: fcn_update_juridica(integer, character varying, character varying, character varying, character, integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_update_juridica(integer, character varying, character varying, character varying, character, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_cnpj ALIAS for $2;
  v_fantasia ALIAS for $3;
  v_inscr_estadual ALIAS for $4;
      v_origem_gravacao ALIAS for $5;
      v_idpes_rev ALIAS for $6;
      v_idsis_rev ALIAS for $7;

BEGIN
  -- Atualiza dados na tabela juridica
  UPDATE cadastro.juridica
    SET cnpj = to_number(v_cnpj,99999999999999),
        fantasia = public.fcn_upper(v_fantasia),
        insc_estadual = to_number(v_inscr_estadual,9999999999),
  origem_gravacao = v_origem_gravacao,
  idpes_rev = v_idpes_rev,
  idsis_rev = v_idsis_rev,
  data_rev = CURRENT_TIMESTAMP,
  operacao = 'A'
    WHERE idpes = v_id_pes;
  RETURN 0;
END;$_$;


ALTER FUNCTION public.fcn_update_juridica(integer, character varying, character varying, character varying, character, integer, integer) OWNER TO postgres;

--
-- Name: fcn_update_pessoa(integer, text, character varying, character varying, character varying, integer, character varying, integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_update_pessoa(integer, text, character varying, character varying, character varying, integer, character varying, integer, integer) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
  -- Parâmetro recebidos
  v_id_pes ALIAS for $1;
  v_razao_social ALIAS for $2;
  v_url ALIAS for $3;
  v_email ALIAS for $4;
  v_situacao ALIAS for $5;
  v_id_pes_logado ALIAS for $6;
  v_origem_gravacao ALIAS for $7;
      v_idpes_rev ALIAS for $8;
      v_idsis_rev ALIAS for $9;

  idpes_logado integer;
BEGIN
  idpes_logado := v_id_pes_logado;
  IF (idpes_logado <= 0) THEN
    -- Atualiza dados na tabela pessoa
    UPDATE cadastro.pessoa SET
        nome = public.fcn_upper(v_razao_social),
        url = v_url,
        email = v_email,
        situacao = v_situacao,
        idpes_rev = NULL,
        data_rev = CURRENT_TIMESTAMP,
              origem_gravacao = v_origem_gravacao,
        idsis_rev = v_idsis_rev,
        operacao = 'A'
        WHERE idpes = v_id_pes;
  ELSE
    -- Atualiza dados na tabela pessoa
    UPDATE cadastro.pessoa SET
        nome = public.fcn_upper(v_razao_social),
        url = v_url,
        email = v_email,
        situacao = v_situacao,
        idpes_rev = idpes_logado,
        data_rev = CURRENT_TIMESTAMP,
              origem_gravacao = v_origem_gravacao,
        idsis_rev = v_idsis_rev,
        operacao = 'A'
        WHERE idpes = v_id_pes;
    END IF;
  RETURN 0;
END;$_$;


ALTER FUNCTION public.fcn_update_pessoa(integer, text, character varying, character varying, character varying, integer, character varying, integer, integer) OWNER TO postgres;

--
-- Name: fcn_upper(text); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_upper(text) RETURNS text
    LANGUAGE plpgsql
    AS $_$
   DECLARE
    v_texto     ALIAS FOR $1;
    v_retorno   text := '';
   BEGIN
    IF v_texto IS NOT NULL THEN
     SELECT translate(upper(v_texto),'áéíóúýàèìòùãõâêîôûäëïöüç','ÁÉÍÓÚÝÀÈÌÒÙÃÕÂÊÎÔÛÄËÏÖÜÇ') INTO v_retorno;
    END IF;
    RETURN v_retorno;
   END;
  $_$;


ALTER FUNCTION public.fcn_upper(text) OWNER TO postgres;

--
-- Name: fcn_upper_nrm(text); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION fcn_upper_nrm(text) RETURNS text
    LANGUAGE plpgsql
    AS $_$
   DECLARE
    v_texto     ALIAS FOR $1;
    v_retorno   text := '';
   BEGIN
    IF v_texto IS NOT NULL THEN
     SELECT translate(upper(v_texto),'áéíóúýàèìòùãõâêîôûäëïöüÿçÁÉÍÓÚÝÀÈÌÒÙÃÕÂÊÎÔÛÄËÏÖÜÇ','AEIOUYAEIOUAOAEIOUAEIOUYCAEIOUYAEIOUAOAEIOUAEIOUC') INTO v_retorno;
    END IF;
    RETURN v_retorno;
   END;
  $_$;


ALTER FUNCTION public.fcn_upper_nrm(text) OWNER TO postgres;

--
-- Name: formata_cpf(numeric); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION formata_cpf(cpf numeric) RETURNS character varying
    LANGUAGE plpgsql
    AS $$
DECLARE
	cpf_formatado varchar := '';
BEGIN
  cpf_formatado := (SUBSTR(TO_CHAR(cpf, '00000000000'), 1, 4) || '.' ||
		    		SUBSTR(TO_CHAR(cpf, '00000000000'), 5, 3) || '.' ||
		    		SUBSTR(TO_CHAR(cpf, '00000000000'), 8, 3) || '-' ||
		    		SUBSTR(TO_CHAR(cpf, '00000000000'), 11, 2)) ;
  RETURN cpf_formatado;
END;
$$;


ALTER FUNCTION public.formata_cpf(cpf numeric) OWNER TO postgres;

--
-- Name: isnumeric(text); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION isnumeric(text) RETURNS boolean
    LANGUAGE plpgsql IMMUTABLE
    AS $_$
  DECLARE x NUMERIC;
    BEGIN
        x = $1::NUMERIC;
        RETURN TRUE;
    EXCEPTION WHEN others THEN
        RETURN FALSE;
    END;
  $_$;


ALTER FUNCTION public.isnumeric(text) OWNER TO postgres;

--
-- Name: retira_data_cancel_matricula_fun(); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION retira_data_cancel_matricula_fun() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
  BEGIN

  UPDATE pmieducar.matricula
  SET    data_cancel = NULL
  WHERE  cod_matricula = new.cod_matricula
  AND    data_cancel IS DISTINCT FROM NULL
  AND    aprovado = 3
  AND (SELECT 1 FROM pmieducar.transferencia_solicitacao WHERE ativo = 1 AND ref_cod_matricula_saida = new.cod_matricula limit 1) is null;

  RETURN NULL;
  END
  $$;


ALTER FUNCTION public.retira_data_cancel_matricula_fun() OWNER TO postgres;

--
-- Name: unifica_bairro(integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION unifica_bairro(p_idbai_duplicado integer, p_idbai_principal integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
DECLARE
cur_cep_log_bai RECORD;
begin

FOR cur_cep_log_bai IN (SELECT * FROM urbano.cep_logradouro_bairro clb WHERE clb.idbai = p_idbai_duplicado) LOOP

IF (SELECT 1 FROM urbano.cep_logradouro_bairro clb
      WHERE clb.idlog = cur_cep_log_bai.idlog
      AND clb.cep = cur_cep_log_bai.cep
      AND clb.idbai = p_idbai_principal
      LIMIT 1) IS NULL THEN

  INSERT INTO urbano.cep_logradouro_bairro (idlog, cep, idbai, origem_gravacao, idpes_cad, data_cad, operacao, idsis_cad)
                             VALUES (cur_cep_log_bai.idlog, cur_cep_log_bai.cep, p_idbai_principal, 'U', 1, NOW(), 'I', 9);


END IF;
END LOOP;

UPDATE cadastro.endereco_pessoa SET idbai = p_idbai_principal WHERE idbai = p_idbai_duplicado;
DELETE FROM urbano.cep_logradouro_bairro WHERE idbai = p_idbai_duplicado;
DELETE FROM public.bairro WHERE idbai = p_idbai_duplicado;

end;$$;


ALTER FUNCTION public.unifica_bairro(p_idbai_duplicado integer, p_idbai_principal integer) OWNER TO postgres;

--
-- Name: unifica_logradouro(integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION unifica_logradouro(p_idlog_duplicado integer, p_idlog_principal integer) RETURNS void
    LANGUAGE plpgsql
    AS $$
DECLARE
cur_cep_log RECORD;
begin

FOR cur_cep_log IN (SELECT * FROM urbano.cep_logradouro_bairro clb WHERE clb.idlog = p_idlog_duplicado) LOOP

IF (SELECT 1 FROM urbano.cep_logradouro cl
      WHERE cl.idlog = p_idlog_principal
      AND cl.cep = cur_cep_log.cep
      LIMIT 1) IS NULL THEN

  INSERT INTO urbano.cep_logradouro (idlog, cep, origem_gravacao, idpes_cad, data_cad, operacao, idsis_cad)
                             VALUES (p_idlog_principal, cur_cep_log.cep, 'U', 1, NOW(), 'I', 9);


END IF;

IF (SELECT 1 FROM urbano.cep_logradouro_bairro clb
      WHERE clb.idlog = p_idlog_principal
      AND clb.cep = cur_cep_log.cep
      AND clb.idbai = cur_cep_log.idbai
      LIMIT 1) IS NULL THEN

  INSERT INTO urbano.cep_logradouro_bairro (idlog, cep, idbai, origem_gravacao, idpes_cad, data_cad, operacao, idsis_cad)
                             VALUES (p_idlog_principal, cur_cep_log.cep, cur_cep_log.idbai, 'U', 1, NOW(), 'I', 9);


END IF;
END LOOP;

UPDATE cadastro.endereco_pessoa SET idlog = p_idlog_principal WHERE idlog = p_idlog_duplicado;
DELETE FROM urbano.cep_logradouro_bairro WHERE idlog = p_idlog_duplicado;
DELETE FROM urbano.cep_logradouro WHERE idlog = p_idlog_duplicado;
DELETE FROM public.logradouro WHERE idlog = p_idlog_duplicado;

end;$$;


ALTER FUNCTION public.unifica_logradouro(p_idlog_duplicado integer, p_idlog_principal integer) OWNER TO postgres;

--
-- Name: verifica_existe_matricula_posterior_mesma_turma(integer, integer); Type: FUNCTION; Schema: public; Owner: ieducar
--

CREATE FUNCTION verifica_existe_matricula_posterior_mesma_turma(cod_matricula integer, cod_turma integer) RETURNS boolean
    LANGUAGE plpgsql
    AS $$
                      DECLARE existe_matricula boolean;

                      BEGIN
                        existe_matricula := EXISTS (SELECT *
                                                      FROM pmieducar.matricula_turma mt
                                                     INNER JOIN pmieducar.matricula m ON (m.cod_matricula = mt.ref_cod_matricula)
                                                     INNER JOIN pmieducar.matricula m2 ON (m2.cod_matricula = m.cod_matricula)
                                                     INNER JOIN pmieducar.matricula_turma mt2 ON (mt2.ref_cod_matricula = m.cod_matricula
                                                                                                  AND mt2.ref_cod_turma = cod_turma)
                                                     WHERE mt.ref_cod_turma = mt2.ref_cod_turma
                                                       AND mt.ref_cod_matricula <> mt2.ref_cod_matricula
                                                       AND m.ref_cod_aluno = m2.ref_cod_aluno
                                                       AND mt.data_enturmacao > mt2.data_enturmacao
                                                       AND m.ativo = 1
                                                       AND m2.ativo = 1);

                        RETURN existe_matricula;
                      END;
                      $$;


ALTER FUNCTION public.verifica_existe_matricula_posterior_mesma_turma(cod_matricula integer, cod_turma integer) OWNER TO ieducar;

--
-- Name: verifica_existe_matricula_posterior_mesma_turma(integer, integer, integer); Type: FUNCTION; Schema: public; Owner: ieducar
--

CREATE FUNCTION verifica_existe_matricula_posterior_mesma_turma(cod_matricula integer, cod_turma integer, sequencial integer) RETURNS boolean
    LANGUAGE plpgsql
    AS $$

      DECLARE existe_matricula boolean;

      BEGIN
        existe_matricula := EXISTS (SELECT *
                                      FROM pmieducar.matricula_turma mt
                                     INNER JOIN pmieducar.matricula m ON (m.cod_matricula = mt.ref_cod_matricula)
                                     INNER JOIN pmieducar.matricula m2 ON (m2.cod_matricula = cod_matricula)
                                     INNER JOIN pmieducar.matricula_turma mt2 ON (mt2.ref_cod_matricula = cod_matricula
                                                                                  AND mt2.ref_cod_turma = cod_turma
                                                                                  AND mt2.sequencial = sequencial)
                                     WHERE mt.ref_cod_turma = mt2.ref_cod_turma
                                       AND mt.ref_cod_matricula <> mt2.ref_cod_matricula
                                       AND m.ref_cod_aluno = m2.ref_cod_aluno
                                       AND mt.data_enturmacao > mt2.data_enturmacao);

        RETURN existe_matricula;
      END;

      $$;


ALTER FUNCTION public.verifica_existe_matricula_posterior_mesma_turma(cod_matricula integer, cod_turma integer, sequencial integer) OWNER TO ieducar;



SET search_path = public, pg_catalog;

--
-- Name: textcat_all(text); Type: AGGREGATE; Schema: public; Owner: postgres
--

CREATE AGGREGATE textcat_all(text) (
    SFUNC = commacat_ignore_nulls,
    STYPE = text,
    INITCOND = ''
);


ALTER AGGREGATE public.textcat_all(text) OWNER TO postgres;

SET search_path = acesso, pg_catalog;

--
-- Name: funcao_idfunc_seq; Type: SEQUENCE; Schema: acesso; Owner: postgres
--

CREATE SEQUENCE funcao_idfunc_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE funcao_idfunc_seq OWNER TO postgres;

SET default_tablespace = '';

SET default_with_oids = true;

--
-- Name: funcao; Type: TABLE; Schema: acesso; Owner: postgres
--

CREATE TABLE funcao (
    idfunc integer DEFAULT nextval('funcao_idfunc_seq'::regclass) NOT NULL,
    idsis integer NOT NULL,
    idmen integer NOT NULL,
    nome character varying(100) NOT NULL,
    situacao character(1) NOT NULL,
    url character varying(250) NOT NULL,
    ordem numeric(2,0) NOT NULL,
    descricao character varying(250) NOT NULL,
    CONSTRAINT ck_funcao_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar)))
);


ALTER TABLE funcao OWNER TO postgres;

--
-- Name: grupo_idgrp_seq; Type: SEQUENCE; Schema: acesso; Owner: postgres
--

CREATE SEQUENCE grupo_idgrp_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE grupo_idgrp_seq OWNER TO postgres;

--
-- Name: grupo; Type: TABLE; Schema: acesso; Owner: postgres
--

CREATE TABLE grupo (
    idgrp integer DEFAULT nextval('grupo_idgrp_seq'::regclass) NOT NULL,
    nome character varying(40) NOT NULL,
    situacao character(1) NOT NULL,
    descricao character varying(250),
    CONSTRAINT ck_grupo_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar)))
);


ALTER TABLE grupo OWNER TO postgres;

--
-- Name: grupo_funcao; Type: TABLE; Schema: acesso; Owner: postgres
--

CREATE TABLE grupo_funcao (
    idmen integer NOT NULL,
    idsis integer NOT NULL,
    idgrp integer NOT NULL,
    idfunc integer NOT NULL
);


ALTER TABLE grupo_funcao OWNER TO postgres;

--
-- Name: grupo_menu; Type: TABLE; Schema: acesso; Owner: postgres
--

CREATE TABLE grupo_menu (
    idgrp integer NOT NULL,
    idsis integer NOT NULL,
    idmen integer NOT NULL
);


ALTER TABLE grupo_menu OWNER TO postgres;

--
-- Name: grupo_operacao; Type: TABLE; Schema: acesso; Owner: postgres
--

CREATE TABLE grupo_operacao (
    idfunc integer NOT NULL,
    idgrp integer NOT NULL,
    idsis integer NOT NULL,
    idmen integer NOT NULL,
    idope integer NOT NULL
);


ALTER TABLE grupo_operacao OWNER TO postgres;

--
-- Name: grupo_sistema; Type: TABLE; Schema: acesso; Owner: postgres
--

CREATE TABLE grupo_sistema (
    idsis integer NOT NULL,
    idgrp integer NOT NULL
);


ALTER TABLE grupo_sistema OWNER TO postgres;

--
-- Name: historico_senha; Type: TABLE; Schema: acesso; Owner: postgres
--

CREATE TABLE historico_senha (
    login character varying(16) NOT NULL,
    senha character varying(60) NOT NULL,
    data_cad timestamp without time zone NOT NULL
);


ALTER TABLE historico_senha OWNER TO postgres;

--
-- Name: instituicao_idins_seq; Type: SEQUENCE; Schema: acesso; Owner: postgres
--

CREATE SEQUENCE instituicao_idins_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE instituicao_idins_seq OWNER TO postgres;

--
-- Name: instituicao; Type: TABLE; Schema: acesso; Owner: postgres
--

CREATE TABLE instituicao (
    idins integer DEFAULT nextval('instituicao_idins_seq'::regclass) NOT NULL,
    nome character varying(60) NOT NULL,
    situacao character(1) NOT NULL,
    CONSTRAINT ck_instituicao_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar)))
);


ALTER TABLE instituicao OWNER TO postgres;

--
-- Name: log_acesso; Type: TABLE; Schema: acesso; Owner: postgres
--

CREATE TABLE log_acesso (
    data timestamp without time zone NOT NULL,
    idpes numeric(8,0) NOT NULL,
    idsis integer,
    idins integer,
    idcli character varying(10),
    operacao character(1) NOT NULL,
    CONSTRAINT ck_log_acesso_situacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'O'::bpchar)))
);


ALTER TABLE log_acesso OWNER TO postgres;

--
-- Name: log_erro; Type: TABLE; Schema: acesso; Owner: postgres
--

CREATE TABLE log_erro (
    data timestamp without time zone NOT NULL,
    idpes numeric(8,0),
    idsis integer,
    idmen integer,
    idfunc integer,
    idope integer,
    msg_erro text NOT NULL
);


ALTER TABLE log_erro OWNER TO postgres;

--
-- Name: menu_idmen_seq; Type: SEQUENCE; Schema: acesso; Owner: postgres
--

CREATE SEQUENCE menu_idmen_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE menu_idmen_seq OWNER TO postgres;

--
-- Name: menu; Type: TABLE; Schema: acesso; Owner: postgres
--

CREATE TABLE menu (
    idmen integer DEFAULT nextval('menu_idmen_seq'::regclass) NOT NULL,
    idsis integer NOT NULL,
    menu_idsis integer,
    menu_idmen integer,
    nome character varying(40) NOT NULL,
    descricao character varying(250) NOT NULL,
    situacao character(1) NOT NULL,
    ordem numeric(2,0) NOT NULL,
    CONSTRAINT ck_menu_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar)))
);


ALTER TABLE menu OWNER TO postgres;

--
-- Name: operacao_idope_seq; Type: SEQUENCE; Schema: acesso; Owner: postgres
--

CREATE SEQUENCE operacao_idope_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE operacao_idope_seq OWNER TO postgres;

--
-- Name: operacao; Type: TABLE; Schema: acesso; Owner: postgres
--

CREATE TABLE operacao (
    idope integer DEFAULT nextval('operacao_idope_seq'::regclass) NOT NULL,
    idsis integer,
    nome character varying(40) NOT NULL,
    situacao character(1) NOT NULL,
    descricao character varying(250) NOT NULL,
    CONSTRAINT ck_operacao_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar)))
);


ALTER TABLE operacao OWNER TO postgres;

--
-- Name: operacao_funcao; Type: TABLE; Schema: acesso; Owner: postgres
--

CREATE TABLE operacao_funcao (
    idmen integer NOT NULL,
    idsis integer NOT NULL,
    idfunc integer NOT NULL,
    idope integer NOT NULL
);


ALTER TABLE operacao_funcao OWNER TO postgres;

--
-- Name: pessoa_instituicao; Type: TABLE; Schema: acesso; Owner: postgres
--

CREATE TABLE pessoa_instituicao (
    idins integer NOT NULL,
    idpes numeric(8,0) NOT NULL
);


ALTER TABLE pessoa_instituicao OWNER TO postgres;

--
-- Name: sistema_idsis_seq; Type: SEQUENCE; Schema: acesso; Owner: postgres
--

CREATE SEQUENCE sistema_idsis_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE sistema_idsis_seq OWNER TO postgres;

--
-- Name: sistema; Type: TABLE; Schema: acesso; Owner: postgres
--

CREATE TABLE sistema (
    idsis integer DEFAULT nextval('sistema_idsis_seq'::regclass) NOT NULL,
    nome character varying(60) NOT NULL,
    descricao character varying(100) NOT NULL,
    contexto character varying(30) NOT NULL,
    situacao character(1) NOT NULL,
    CONSTRAINT ck_sistema_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar)))
);


ALTER TABLE sistema OWNER TO postgres;

--
-- Name: usuario; Type: TABLE; Schema: acesso; Owner: postgres
--

CREATE TABLE usuario (
    login character varying(16) NOT NULL,
    idpes numeric(8,0) NOT NULL,
    idpes_sga numeric(8,0),
    senha character varying(60) NOT NULL,
    datacad date NOT NULL,
    lastlogin timestamp without time zone NOT NULL,
    dica character varying(60),
    situacao character(1) NOT NULL,
    data_alt_senha date NOT NULL,
    exp_senha character(1),
    mudar_senha character(1),
    num_sessao_atual numeric(2,0) NOT NULL,
    prazo_exp numeric(3,0),
    estilo_menu character(1),
    CONSTRAINT ck_usuario_estilo_menu CHECK (((estilo_menu = 'C'::bpchar) OR (estilo_menu = 'D'::bpchar))),
    CONSTRAINT ck_usuario_exp_senha CHECK (((exp_senha = 'S'::bpchar) OR (exp_senha = 'N'::bpchar))),
    CONSTRAINT ck_usuario_mudar_senha CHECK (((mudar_senha = 'S'::bpchar) OR (mudar_senha = 'N'::bpchar))),
    CONSTRAINT ck_usuario_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar)))
);


ALTER TABLE usuario OWNER TO postgres;

--
-- Name: usuario_grupo; Type: TABLE; Schema: acesso; Owner: postgres
--

CREATE TABLE usuario_grupo (
    idgrp integer NOT NULL,
    login character varying(16) NOT NULL
);


ALTER TABLE usuario_grupo OWNER TO postgres;

SET search_path = alimentos, pg_catalog;

--
-- Name: baixa_guia_produto_idbap_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE baixa_guia_produto_idbap_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE baixa_guia_produto_idbap_seq OWNER TO postgres;

--
-- Name: baixa_guia_produto; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE baixa_guia_produto (
    idbap integer DEFAULT nextval('baixa_guia_produto_idbap_seq'::regclass) NOT NULL,
    idgup integer NOT NULL,
    idbai integer NOT NULL,
    dt_validade date,
    qtde_recebida numeric NOT NULL,
    dt_operacao date NOT NULL,
    login_baixa character varying(80) NOT NULL
);


ALTER TABLE baixa_guia_produto OWNER TO postgres;

--
-- Name: baixa_guia_remessa_idbai_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE baixa_guia_remessa_idbai_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE baixa_guia_remessa_idbai_seq OWNER TO postgres;

--
-- Name: baixa_guia_remessa; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE baixa_guia_remessa (
    idbai integer DEFAULT nextval('baixa_guia_remessa_idbai_seq'::regclass) NOT NULL,
    login_baixa character varying(80) NOT NULL,
    idgui integer NOT NULL,
    dt_recebimento date NOT NULL,
    nome_recebedor character varying(40) NOT NULL,
    cargo_recebedor character varying(40) NOT NULL,
    dt_operacao date NOT NULL
);


ALTER TABLE baixa_guia_remessa OWNER TO postgres;

--
-- Name: calendario_idcad_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE calendario_idcad_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE calendario_idcad_seq OWNER TO postgres;

--
-- Name: calendario; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE calendario (
    idcad integer DEFAULT nextval('calendario_idcad_seq'::regclass) NOT NULL,
    idcli character varying(10) NOT NULL,
    ano integer NOT NULL,
    descricao character varying(40) NOT NULL
);


ALTER TABLE calendario OWNER TO postgres;

--
-- Name: cardapio_idcar_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE cardapio_idcar_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE cardapio_idcar_seq OWNER TO postgres;

--
-- Name: cardapio; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE cardapio (
    idcar integer DEFAULT nextval('cardapio_idcar_seq'::regclass) NOT NULL,
    login_inclusao character varying(80) NOT NULL,
    login_alteracao character varying(80),
    idcli character varying(10) NOT NULL,
    idtre integer NOT NULL,
    dt_cardapio date NOT NULL,
    dt_inclusao timestamp without time zone NOT NULL,
    dt_ultima_alteracao timestamp without time zone,
    valor numeric NOT NULL,
    finalizado character(1) NOT NULL,
    CONSTRAINT ck_cardapio_finalizado CHECK (((finalizado = 'S'::bpchar) OR (finalizado = 'N'::bpchar)))
);


ALTER TABLE cardapio OWNER TO postgres;

--
-- Name: cardapio_faixa_unidade; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE cardapio_faixa_unidade (
    idfeu integer NOT NULL,
    idcar integer NOT NULL
);


ALTER TABLE cardapio_faixa_unidade OWNER TO postgres;

--
-- Name: cardapio_produto_idcpr_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE cardapio_produto_idcpr_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE cardapio_produto_idcpr_seq OWNER TO postgres;

--
-- Name: cardapio_produto; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE cardapio_produto (
    idcpr integer DEFAULT nextval('cardapio_produto_idcpr_seq'::regclass) NOT NULL,
    idpro integer NOT NULL,
    idcar integer NOT NULL,
    quantidade numeric NOT NULL,
    valor numeric NOT NULL
);


ALTER TABLE cardapio_produto OWNER TO postgres;

--
-- Name: cardapio_receita; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE cardapio_receita (
    idcar integer NOT NULL,
    idrec integer NOT NULL
);


ALTER TABLE cardapio_receita OWNER TO postgres;

--
-- Name: cliente; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE cliente (
    idcli character varying(10) NOT NULL,
    nome character varying(40) NOT NULL,
    cnpj character varying(14) NOT NULL,
    endereco character varying(60) NOT NULL,
    bairro character varying(30) NOT NULL,
    cidade character varying(18) NOT NULL,
    cep character varying(8),
    uf character varying(2) NOT NULL,
    telefone character varying(11) NOT NULL,
    fax character varying(11),
    email character varying(40),
    prefeito character varying(40) NOT NULL,
    educacao character varying(40) NOT NULL,
    administracao character varying(40) NOT NULL,
    coordenacao character varying(40) NOT NULL,
    inscritos character(1) NOT NULL,
    idpes integer NOT NULL,
    identificacao character varying(20) NOT NULL,
    tab_produtos character(1),
    CONSTRAINT ck_tab_produtos CHECK (((tab_produtos = '1'::bpchar) OR (tab_produtos = '2'::bpchar)))
);


ALTER TABLE cliente OWNER TO postgres;

--
-- Name: composto_quimico_idcom_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE composto_quimico_idcom_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE composto_quimico_idcom_seq OWNER TO postgres;

--
-- Name: composto_quimico; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE composto_quimico (
    idcom integer DEFAULT nextval('composto_quimico_idcom_seq'::regclass) NOT NULL,
    idcli character varying(10) NOT NULL,
    idgrpq integer NOT NULL,
    descricao character varying(50) NOT NULL,
    unidade character varying(5) NOT NULL
);


ALTER TABLE composto_quimico OWNER TO postgres;

--
-- Name: contrato_idcon_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE contrato_idcon_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE contrato_idcon_seq OWNER TO postgres;

--
-- Name: contrato; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE contrato (
    idcon integer DEFAULT nextval('contrato_idcon_seq'::regclass) NOT NULL,
    codigo character varying(20) NOT NULL,
    idcli character varying(10) NOT NULL,
    login character varying(80) NOT NULL,
    num_aditivo integer NOT NULL,
    idfor integer NOT NULL,
    dt_vigencia date NOT NULL,
    tipo character(1) NOT NULL,
    vlr_atual numeric NOT NULL,
    cancelado character(1) NOT NULL,
    dt_cancelamento timestamp without time zone,
    dt_inclusao timestamp without time zone NOT NULL,
    ultimo_contrato character(1) NOT NULL,
    vlr_original numeric NOT NULL,
    finalizado character(1) NOT NULL,
    CONSTRAINT ck_contrato_cancelado CHECK (((cancelado = 'S'::bpchar) OR (cancelado = 'N'::bpchar))),
    CONSTRAINT ck_contrato_finalizado CHECK (((finalizado = 'S'::bpchar) OR (finalizado = 'N'::bpchar))),
    CONSTRAINT ck_contrato_tipo CHECK (((tipo = 'C'::bpchar) OR (tipo = 'A'::bpchar))),
    CONSTRAINT ck_contrato_ultimo_contrato CHECK (((ultimo_contrato = 'S'::bpchar) OR (ultimo_contrato = 'N'::bpchar)))
);


ALTER TABLE contrato OWNER TO postgres;

--
-- Name: contrato_produto_idcop_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE contrato_produto_idcop_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE contrato_produto_idcop_seq OWNER TO postgres;

--
-- Name: contrato_produto; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE contrato_produto (
    idcop integer DEFAULT nextval('contrato_produto_idcop_seq'::regclass) NOT NULL,
    idcon integer NOT NULL,
    idpro integer NOT NULL,
    qtde_contratada numeric NOT NULL,
    vlr_unitario_atual numeric NOT NULL,
    qtde_remessa numeric NOT NULL,
    qtde_recebida numeric NOT NULL,
    qtde_aditivo numeric NOT NULL,
    vlr_unitario_original numeric NOT NULL,
    operacao character(1) NOT NULL,
    ajuste numeric,
    CONSTRAINT ck_contrato_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar) OR (operacao = 'N'::bpchar)))
);


ALTER TABLE contrato_produto OWNER TO postgres;

--
-- Name: evento_ideve_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE evento_ideve_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE evento_ideve_seq OWNER TO postgres;

--
-- Name: evento; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE evento (
    ideve integer DEFAULT nextval('evento_ideve_seq'::regclass) NOT NULL,
    idcad integer NOT NULL,
    mes integer NOT NULL,
    dia integer NOT NULL,
    dia_util character(1) NOT NULL,
    descricao character varying(50) NOT NULL,
    CONSTRAINT ck_evento_dia_util CHECK (((dia_util = 'S'::bpchar) OR (dia_util = 'N'::bpchar)))
);


ALTER TABLE evento OWNER TO postgres;

--
-- Name: faixa_composto_quimico_idfcp_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE faixa_composto_quimico_idfcp_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE faixa_composto_quimico_idfcp_seq OWNER TO postgres;

--
-- Name: faixa_composto_quimico; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE faixa_composto_quimico (
    idfcp integer DEFAULT nextval('faixa_composto_quimico_idfcp_seq'::regclass) NOT NULL,
    idcom integer NOT NULL,
    idfae integer NOT NULL,
    quantidade numeric NOT NULL,
    qtde_max_min character(3) NOT NULL,
    CONSTRAINT ck_qtde_max_min CHECK (((qtde_max_min = 'MAX'::bpchar) OR (qtde_max_min = 'MIN'::bpchar)))
);


ALTER TABLE faixa_composto_quimico OWNER TO postgres;

--
-- Name: faixa_etaria_idfae_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE faixa_etaria_idfae_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE faixa_etaria_idfae_seq OWNER TO postgres;

--
-- Name: faixa_etaria; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE faixa_etaria (
    idfae integer DEFAULT nextval('faixa_etaria_idfae_seq'::regclass) NOT NULL,
    idcli character varying(10) NOT NULL,
    descricao character varying(50) NOT NULL,
    vlr_base_refeicao numeric NOT NULL
);


ALTER TABLE faixa_etaria OWNER TO postgres;

--
-- Name: fornecedor_idfor_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE fornecedor_idfor_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE fornecedor_idfor_seq OWNER TO postgres;

--
-- Name: fornecedor; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE fornecedor (
    idfor integer DEFAULT nextval('fornecedor_idfor_seq'::regclass) NOT NULL,
    idpes integer NOT NULL,
    idcli character varying(10) NOT NULL,
    razao_social character varying(50) NOT NULL,
    nome_fantasia character varying(50) NOT NULL,
    endereco character varying(40) NOT NULL,
    complemento character varying(30),
    bairro character varying(30) NOT NULL,
    cep character varying(8),
    cidade character varying(18) NOT NULL,
    uf character varying(2) NOT NULL,
    telefone character varying(11) NOT NULL,
    fax character varying(11),
    email character varying(40),
    contato character varying(40) NOT NULL,
    cpf_cnpj character varying(14) NOT NULL,
    inscr_estadual character varying(20),
    inscr_municipal character varying(20),
    tipo character(1) NOT NULL,
    CONSTRAINT ck_fornecedor CHECK (((tipo = 'F'::bpchar) OR (tipo = 'J'::bpchar)))
);


ALTER TABLE fornecedor OWNER TO postgres;

--
-- Name: fornecedor_unidade_atendida; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE fornecedor_unidade_atendida (
    iduni integer NOT NULL,
    idfor integer NOT NULL
);


ALTER TABLE fornecedor_unidade_atendida OWNER TO postgres;

--
-- Name: grupo_quimico_idgrpq_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE grupo_quimico_idgrpq_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE grupo_quimico_idgrpq_seq OWNER TO postgres;

--
-- Name: grupo_quimico; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE grupo_quimico (
    idgrpq integer DEFAULT nextval('grupo_quimico_idgrpq_seq'::regclass) NOT NULL,
    idcli character varying(10) NOT NULL,
    descricao character varying(50) NOT NULL
);


ALTER TABLE grupo_quimico OWNER TO postgres;

--
-- Name: guia_produto_diario_idguiaprodiario_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE guia_produto_diario_idguiaprodiario_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE guia_produto_diario_idguiaprodiario_seq OWNER TO postgres;

--
-- Name: guia_produto_diario; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE guia_produto_diario (
    idguiaprodiario integer DEFAULT nextval('guia_produto_diario_idguiaprodiario_seq'::regclass) NOT NULL,
    idgui integer NOT NULL,
    idpro integer NOT NULL,
    iduni integer NOT NULL,
    dt_guia date NOT NULL,
    qtde numeric NOT NULL
);


ALTER TABLE guia_produto_diario OWNER TO postgres;

--
-- Name: guia_remessa_idgui_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE guia_remessa_idgui_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE guia_remessa_idgui_seq OWNER TO postgres;

--
-- Name: guia_remessa; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE guia_remessa (
    idgui integer DEFAULT nextval('guia_remessa_idgui_seq'::regclass) NOT NULL,
    idcon integer NOT NULL,
    login_cancelamento character varying(80),
    login_emissao character varying(80) NOT NULL,
    idfor integer NOT NULL,
    iduni integer NOT NULL,
    idcli character varying(10) NOT NULL,
    dt_emissao timestamp without time zone NOT NULL,
    ano integer NOT NULL,
    sequencial integer NOT NULL,
    dt_cardapio_inicial date NOT NULL,
    dt_cardapio_final date NOT NULL,
    num_inscr_matr integer NOT NULL,
    num_refeicao integer NOT NULL,
    situacao character(1) NOT NULL,
    dt_cancelamento timestamp without time zone,
    justificativa_cancelamento character varying(300),
    classe_produto character varying(2) NOT NULL,
    CONSTRAINT ck_guia_remessa_classe_produto CHECK ((((classe_produto)::text = 'P'::text) OR ((classe_produto)::text = 'N'::text) OR ((classe_produto)::text = 'PN'::text))),
    CONSTRAINT ck_guia_remessa_situacao CHECK (((situacao = 'E'::bpchar) OR (situacao = 'R'::bpchar) OR (situacao = 'C'::bpchar) OR (situacao = 'P'::bpchar)))
);


ALTER TABLE guia_remessa OWNER TO postgres;

--
-- Name: guia_remessa_produto_idgup_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE guia_remessa_produto_idgup_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE guia_remessa_produto_idgup_seq OWNER TO postgres;

--
-- Name: guia_remessa_produto; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE guia_remessa_produto (
    idgup integer DEFAULT nextval('guia_remessa_produto_idgup_seq'::regclass) NOT NULL,
    idgui integer NOT NULL,
    idpro integer NOT NULL,
    qtde_per_capita numeric NOT NULL,
    qtde_guia numeric NOT NULL,
    peso numeric NOT NULL,
    qtde_recebida numeric NOT NULL,
    peso_total numeric NOT NULL
);


ALTER TABLE guia_remessa_produto OWNER TO postgres;

--
-- Name: log_guia_remessa_idlogguia_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE log_guia_remessa_idlogguia_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE log_guia_remessa_idlogguia_seq OWNER TO postgres;

--
-- Name: log_guia_remessa; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE log_guia_remessa (
    idlogguia integer DEFAULT nextval('log_guia_remessa_idlogguia_seq'::regclass) NOT NULL,
    login character varying(80) NOT NULL,
    idcli character varying(10) NOT NULL,
    dt_inicial date NOT NULL,
    dt_final date NOT NULL,
    unidade character varying(80) NOT NULL,
    fornecedor character varying(80) NOT NULL,
    classe character(2),
    dt_geracao timestamp without time zone NOT NULL,
    mensagem text NOT NULL
);


ALTER TABLE log_guia_remessa OWNER TO postgres;

--
-- Name: medidas_caseiras; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE medidas_caseiras (
    idmedcas character varying(20) NOT NULL,
    idcli character varying(10) NOT NULL,
    descricao character varying(50) NOT NULL
);


ALTER TABLE medidas_caseiras OWNER TO postgres;

--
-- Name: pessoa_idpes_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE pessoa_idpes_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE pessoa_idpes_seq OWNER TO postgres;

--
-- Name: pessoa; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE pessoa (
    idpes integer DEFAULT nextval('pessoa_idpes_seq'::regclass) NOT NULL,
    tipo character varying(1) NOT NULL,
    CONSTRAINT ck_pessoa CHECK ((((tipo)::text = 'C'::text) OR ((tipo)::text = 'F'::text) OR ((tipo)::text = 'U'::text)))
);


ALTER TABLE pessoa OWNER TO postgres;

--
-- Name: produto_idpro_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE produto_idpro_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE produto_idpro_seq OWNER TO postgres;

--
-- Name: produto; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE produto (
    idpro integer DEFAULT nextval('produto_idpro_seq'::regclass) NOT NULL,
    idcli character varying(10) NOT NULL,
    idunp character varying(20) NOT NULL,
    idfnde character varying(15) NOT NULL,
    idtip integer NOT NULL,
    descricao character varying(60) NOT NULL,
    nome_compra character varying(60) NOT NULL,
    referencia_ceasa character varying(1) NOT NULL,
    fator_coccao numeric NOT NULL,
    fator_correcao numeric NOT NULL,
    vlr_unitario numeric NOT NULL,
    penultimo_vlr_unitario numeric,
    dt_ultima_compra timestamp without time zone,
    dt_penultima_compra timestamp without time zone,
    qtde_estoque numeric NOT NULL,
    classe character varying(1) NOT NULL,
    desc_composto character varying(300),
    idfor integer,
    CONSTRAINT ck_produto_classe CHECK ((((classe)::text = 'P'::text) OR ((classe)::text = 'N'::text))),
    CONSTRAINT ck_produto_referencia_ceasa CHECK ((((referencia_ceasa)::text = '1'::text) OR ((referencia_ceasa)::text = '0'::text)))
);


ALTER TABLE produto OWNER TO postgres;

--
-- Name: produto_composto_quimico_idpcq_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE produto_composto_quimico_idpcq_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE produto_composto_quimico_idpcq_seq OWNER TO postgres;

--
-- Name: produto_composto_quimico; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE produto_composto_quimico (
    idpcq integer DEFAULT nextval('produto_composto_quimico_idpcq_seq'::regclass) NOT NULL,
    idpro integer NOT NULL,
    idcom integer NOT NULL,
    quantidade numeric NOT NULL
);


ALTER TABLE produto_composto_quimico OWNER TO postgres;

--
-- Name: produto_fornecedor_idprf_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE produto_fornecedor_idprf_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE produto_fornecedor_idprf_seq OWNER TO postgres;

--
-- Name: produto_fornecedor; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE produto_fornecedor (
    idprf integer DEFAULT nextval('produto_fornecedor_idprf_seq'::regclass) NOT NULL,
    idfor integer NOT NULL,
    idpro integer NOT NULL,
    codigo_ean character varying(18) NOT NULL
);


ALTER TABLE produto_fornecedor OWNER TO postgres;

--
-- Name: produto_medida_caseira_idpmc_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE produto_medida_caseira_idpmc_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE produto_medida_caseira_idpmc_seq OWNER TO postgres;

--
-- Name: produto_medida_caseira; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE produto_medida_caseira (
    idpmc integer DEFAULT nextval('produto_medida_caseira_idpmc_seq'::regclass) NOT NULL,
    idcli character varying(10) NOT NULL,
    idmedcas character varying(20) NOT NULL,
    idpro integer NOT NULL,
    peso numeric NOT NULL
);


ALTER TABLE produto_medida_caseira OWNER TO postgres;

--
-- Name: receita_idrec_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE receita_idrec_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE receita_idrec_seq OWNER TO postgres;

--
-- Name: receita; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE receita (
    idrec integer DEFAULT nextval('receita_idrec_seq'::regclass) NOT NULL,
    idcli character varying(10) NOT NULL,
    valor numeric NOT NULL,
    descricao character varying(60) NOT NULL,
    modo_preparo text NOT NULL,
    rendimento integer NOT NULL,
    valor_percapita numeric NOT NULL
);


ALTER TABLE receita OWNER TO postgres;

--
-- Name: receita_composto_quimico_idrcq_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE receita_composto_quimico_idrcq_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE receita_composto_quimico_idrcq_seq OWNER TO postgres;

--
-- Name: receita_composto_quimico; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE receita_composto_quimico (
    idrcq integer DEFAULT nextval('receita_composto_quimico_idrcq_seq'::regclass) NOT NULL,
    idcom integer NOT NULL,
    idrec integer NOT NULL,
    quantidade numeric NOT NULL
);


ALTER TABLE receita_composto_quimico OWNER TO postgres;

--
-- Name: receita_produto_idrpr_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE receita_produto_idrpr_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE receita_produto_idrpr_seq OWNER TO postgres;

--
-- Name: receita_produto; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE receita_produto (
    idrpr integer DEFAULT nextval('receita_produto_idrpr_seq'::regclass) NOT NULL,
    idpro integer NOT NULL,
    idrec integer NOT NULL,
    idmedcas character varying(20),
    quantidade numeric NOT NULL,
    valor numeric NOT NULL,
    qtdemedidacaseira integer NOT NULL,
    valor_percapita numeric NOT NULL
);


ALTER TABLE receita_produto OWNER TO postgres;

--
-- Name: tipo_produto_idtip_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE tipo_produto_idtip_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE tipo_produto_idtip_seq OWNER TO postgres;

--
-- Name: tipo_produto; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE tipo_produto (
    idtip integer DEFAULT nextval('tipo_produto_idtip_seq'::regclass) NOT NULL,
    idcli character varying(10) NOT NULL,
    descricao character varying(50) NOT NULL
);


ALTER TABLE tipo_produto OWNER TO postgres;

--
-- Name: tipo_refeicao_idtre_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE tipo_refeicao_idtre_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE tipo_refeicao_idtre_seq OWNER TO postgres;

--
-- Name: tipo_refeicao; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE tipo_refeicao (
    idtre integer DEFAULT nextval('tipo_refeicao_idtre_seq'::regclass) NOT NULL,
    idcli character varying(10) NOT NULL,
    descricao character varying(30) NOT NULL
);


ALTER TABLE tipo_refeicao OWNER TO postgres;

--
-- Name: tipo_unidade_idtip_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE tipo_unidade_idtip_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE tipo_unidade_idtip_seq OWNER TO postgres;

--
-- Name: tipo_unidade; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE tipo_unidade (
    idtip integer DEFAULT nextval('tipo_unidade_idtip_seq'::regclass) NOT NULL,
    idcli character varying(10) NOT NULL,
    descricao character varying(50) NOT NULL
);


ALTER TABLE tipo_unidade OWNER TO postgres;

--
-- Name: unidade_atendida_iduni_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE unidade_atendida_iduni_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE unidade_atendida_iduni_seq OWNER TO postgres;

--
-- Name: unidade_atendida; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE unidade_atendida (
    iduni integer DEFAULT nextval('unidade_atendida_iduni_seq'::regclass) NOT NULL,
    idcad integer NOT NULL,
    idtip integer NOT NULL,
    codigo character varying(10) NOT NULL,
    idcli character varying(10) NOT NULL,
    nome character varying(40) NOT NULL,
    endereco character varying(60) NOT NULL,
    complemento character varying(30),
    bairro character varying(30) NOT NULL,
    cep character varying(8),
    telefone character varying(11) NOT NULL,
    fax character varying(11),
    email character varying(40),
    idpes integer NOT NULL,
    diretor character varying(40) NOT NULL
);


ALTER TABLE unidade_atendida OWNER TO postgres;

--
-- Name: unidade_faixa_etaria_idfeu_seq; Type: SEQUENCE; Schema: alimentos; Owner: postgres
--

CREATE SEQUENCE unidade_faixa_etaria_idfeu_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE unidade_faixa_etaria_idfeu_seq OWNER TO postgres;

--
-- Name: unidade_faixa_etaria; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE unidade_faixa_etaria (
    idfeu integer DEFAULT nextval('unidade_faixa_etaria_idfeu_seq'::regclass) NOT NULL,
    iduni integer NOT NULL,
    idfae integer NOT NULL,
    num_inscritos integer NOT NULL,
    num_matriculados integer NOT NULL
);


ALTER TABLE unidade_faixa_etaria OWNER TO postgres;

--
-- Name: unidade_produto; Type: TABLE; Schema: alimentos; Owner: postgres
--

CREATE TABLE unidade_produto (
    idunp character varying(20) NOT NULL,
    idcli character varying(10) NOT NULL,
    descricao character varying(50) NOT NULL,
    peso numeric NOT NULL
);


ALTER TABLE unidade_produto OWNER TO postgres;

SET search_path = cadastro, pg_catalog;

--
-- Name: aviso_nome; Type: TABLE; Schema: cadastro; Owner: postgres
--

CREATE TABLE aviso_nome (
    idpes numeric(8,0) NOT NULL,
    aviso numeric(1,0) NOT NULL,
    CONSTRAINT ck_aviso_nome_aviso CHECK (((aviso >= (1)::numeric) AND (aviso <= (4)::numeric)))
);


ALTER TABLE aviso_nome OWNER TO postgres;

--
-- Name: deficiencia_cod_deficiencia_seq; Type: SEQUENCE; Schema: cadastro; Owner: postgres
--

CREATE SEQUENCE deficiencia_cod_deficiencia_seq
    START WITH 15
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE deficiencia_cod_deficiencia_seq OWNER TO postgres;

--
-- Name: deficiencia; Type: TABLE; Schema: cadastro; Owner: postgres
--

CREATE TABLE deficiencia (
    cod_deficiencia integer DEFAULT nextval('deficiencia_cod_deficiencia_seq'::regclass) NOT NULL,
    nm_deficiencia character varying(70) NOT NULL,
    deficiencia_educacenso smallint
);


ALTER TABLE deficiencia OWNER TO postgres;

--
-- Name: documento; Type: TABLE; Schema: cadastro; Owner: postgres
--

CREATE TABLE documento (
    idpes numeric(8,0) NOT NULL,
    rg character varying(25),
    data_exp_rg date,
    sigla_uf_exp_rg character(2),
    tipo_cert_civil numeric(2,0),
    num_termo numeric(8,0),
    num_livro character varying(8),
    num_folha numeric(4,0),
    data_emissao_cert_civil date,
    sigla_uf_cert_civil character(2),
    cartorio_cert_civil character varying(150),
    num_cart_trabalho numeric(9,0),
    serie_cart_trabalho numeric(5,0),
    data_emissao_cart_trabalho date,
    sigla_uf_cart_trabalho character(2),
    num_tit_eleitor numeric(13,0),
    zona_tit_eleitor numeric(4,0),
    secao_tit_eleitor numeric(4,0),
    idorg_exp_rg integer,
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    certidao_nascimento character varying(50),
    cartorio_cert_civil_inep character varying(20),
    certidao_casamento character varying(50),
    passaporte character varying(20),
    comprovante_residencia character varying(255),
    declaracao_trabalho_autonomo character varying,
    CONSTRAINT ck_documento_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_documento_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_documento_tipo_cert CHECK (((tipo_cert_civil >= (91)::numeric) AND (tipo_cert_civil <= (92)::numeric)))
);


ALTER TABLE documento OWNER TO postgres;

--
-- Name: endereco_externo; Type: TABLE; Schema: cadastro; Owner: postgres
--

CREATE TABLE endereco_externo (
    idpes numeric(8,0) NOT NULL,
    tipo numeric(1,0) NOT NULL,
    idtlog character varying(5) NOT NULL,
    logradouro character varying(150) NOT NULL,
    numero numeric(6,0),
    letra character(1),
    complemento character varying(20),
    bairro character varying(40),
    cep numeric(8,0),
    cidade character varying(60) NOT NULL,
    sigla_uf character(2) NOT NULL,
    reside_desde date,
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    bloco character varying(20),
    andar numeric(2,0),
    apartamento numeric(6,0),
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    zona_localizacao integer DEFAULT 1,
    CONSTRAINT ck_endereco_externo_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_endereco_externo_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_endereco_externo_tipo CHECK (((tipo >= (1)::numeric) AND (tipo <= (3)::numeric)))
);


ALTER TABLE endereco_externo OWNER TO postgres;

--
-- Name: endereco_pessoa; Type: TABLE; Schema: cadastro; Owner: postgres
--

CREATE TABLE endereco_pessoa (
    idpes numeric(8,0) NOT NULL,
    tipo numeric(1,0) NOT NULL,
    cep numeric(8,0) NOT NULL,
    idlog numeric(6,0) NOT NULL,
    numero numeric(6,0),
    letra character(1),
    complemento character varying(50),
    reside_desde date,
    idbai numeric(6,0) NOT NULL,
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    bloco character varying(20),
    andar numeric(2,0),
    apartamento numeric(6,0),
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    CONSTRAINT ck_endereco_pessoa_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_endereco_pessoa_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_endereco_pessoa_tipo CHECK (((tipo >= (1)::numeric) AND (tipo <= (3)::numeric)))
);


ALTER TABLE endereco_pessoa OWNER TO postgres;

--
-- Name: escolaridade; Type: TABLE; Schema: cadastro; Owner: postgres
--

CREATE TABLE escolaridade (
    idesco numeric(2,0) NOT NULL,
    descricao character varying(60) NOT NULL,
    escolaridade smallint
);


ALTER TABLE escolaridade OWNER TO postgres;

--
-- Name: estado_civil; Type: TABLE; Schema: cadastro; Owner: postgres
--

CREATE TABLE estado_civil (
    ideciv numeric(1,0) NOT NULL,
    descricao character varying(15) NOT NULL
);


ALTER TABLE estado_civil OWNER TO postgres;

--
-- Name: fisica; Type: TABLE; Schema: cadastro; Owner: postgres
--

CREATE TABLE fisica (
    idpes numeric(8,0) NOT NULL,
    data_nasc date,
    sexo character(1),
    idpes_mae numeric(8,0),
    idpes_pai numeric(8,0),
    idpes_responsavel numeric(8,0),
    idesco numeric(2,0),
    ideciv numeric(1,0),
    idpes_con numeric(8,0),
    data_uniao date,
    data_obito date,
    nacionalidade numeric(1,0),
    idpais_estrangeiro numeric(3,0),
    data_chegada_brasil date,
    idmun_nascimento numeric(6,0),
    ultima_empresa character varying(150),
    idocup numeric(6,0),
    nome_mae character varying(150),
    nome_pai character varying(150),
    nome_conjuge character varying(150),
    nome_responsavel character varying(150),
    justificativa_provisorio character varying(150),
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    ref_cod_sistema integer,
    cpf numeric(11,0),
    ref_cod_religiao integer,
    nis_pis_pasep numeric(11,0),
    sus character varying(20),
    ocupacao character varying(255),
    empresa character varying(255),
    pessoa_contato character varying(255),
    renda_mensal numeric(10,2),
    data_admissao date,
    ddd_telefone_empresa numeric(3,0),
    telefone_empresa numeric(11,0),
    falecido boolean,
    ativo integer DEFAULT 1,
    ref_usuario_exc integer,
    data_exclusao timestamp without time zone,
    zona_localizacao_censo integer,
    tipo_trabalho integer,
    local_trabalho character varying,
    horario_inicial_trabalho time without time zone,
    horario_final_trabalho time without time zone,
    CONSTRAINT ck_fisica_nacionalidade CHECK (((nacionalidade >= (1)::numeric) AND (nacionalidade <= (3)::numeric))),
    CONSTRAINT ck_fisica_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_fisica_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_fisica_sexo CHECK (((sexo = 'M'::bpchar) OR (sexo = 'F'::bpchar)))
);


ALTER TABLE fisica OWNER TO postgres;

--
-- Name: fisica_cpf; Type: TABLE; Schema: cadastro; Owner: postgres
--

CREATE TABLE fisica_cpf (
    idpes numeric(8,0) NOT NULL,
    cpf numeric(11,0) NOT NULL,
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    CONSTRAINT ck_fisica_cpf_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_fisica_cpf_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar)))
);


ALTER TABLE fisica_cpf OWNER TO postgres;

--
-- Name: fisica_deficiencia; Type: TABLE; Schema: cadastro; Owner: postgres
--

CREATE TABLE fisica_deficiencia (
    ref_idpes integer NOT NULL,
    ref_cod_deficiencia integer NOT NULL
);


ALTER TABLE fisica_deficiencia OWNER TO postgres;

--
-- Name: fisica_foto; Type: TABLE; Schema: cadastro; Owner: postgres
--

CREATE TABLE fisica_foto (
    idpes integer NOT NULL,
    caminho character varying(255)
);


ALTER TABLE fisica_foto OWNER TO postgres;

--
-- Name: fisica_raca; Type: TABLE; Schema: cadastro; Owner: postgres
--

CREATE TABLE fisica_raca (
    ref_idpes integer NOT NULL,
    ref_cod_raca integer NOT NULL
);


ALTER TABLE fisica_raca OWNER TO postgres;

--
-- Name: fisica_sangue; Type: TABLE; Schema: cadastro; Owner: postgres
--

CREATE TABLE fisica_sangue (
    idpes numeric(8,0) NOT NULL,
    grupo character(2) NOT NULL,
    rh smallint NOT NULL
);


ALTER TABLE fisica_sangue OWNER TO postgres;

--
-- Name: fone_pessoa; Type: TABLE; Schema: cadastro; Owner: postgres
--

CREATE TABLE fone_pessoa (
    idpes numeric(8,0) NOT NULL,
    tipo numeric(1,0) NOT NULL,
    ddd numeric(3,0) NOT NULL,
    fone numeric(11,0) NOT NULL,
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    CONSTRAINT ck_fone_pessoa_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_fone_pessoa_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_fone_pessoa_tipo CHECK (((tipo >= (1)::numeric) AND (tipo <= (4)::numeric)))
);


ALTER TABLE fone_pessoa OWNER TO postgres;

--
-- Name: funcionario; Type: TABLE; Schema: cadastro; Owner: postgres
--

CREATE TABLE funcionario (
    matricula numeric(8,0) NOT NULL,
    idins integer NOT NULL,
    idset integer,
    idpes numeric(8,0) NOT NULL,
    situacao character(1) NOT NULL,
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    CONSTRAINT ck_funcionario_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_funcionario_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_funcionario_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar)))
);


ALTER TABLE funcionario OWNER TO postgres;

--
-- Name: historico_cartao; Type: TABLE; Schema: cadastro; Owner: postgres
--

CREATE TABLE historico_cartao (
    idpes_cidadao numeric(8,0) NOT NULL,
    data_hora timestamp without time zone NOT NULL,
    idpes_emitiu numeric(8,0) NOT NULL,
    tipo character(1) NOT NULL,
    CONSTRAINT ck_historico_cartao_tipo CHECK (((tipo = 'P'::bpchar) OR (tipo = 'D'::bpchar)))
);


ALTER TABLE historico_cartao OWNER TO postgres;

--
-- Name: juridica; Type: TABLE; Schema: cadastro; Owner: postgres
--

CREATE TABLE juridica (
    idpes numeric(8,0) NOT NULL,
    cnpj numeric(14,0) NOT NULL,
    insc_estadual numeric(20,0),
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    fantasia character varying(255),
    capital_social character varying(255),
    CONSTRAINT ck_juridica_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_juridica_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar)))
);


ALTER TABLE juridica OWNER TO postgres;

--
-- Name: ocupacao; Type: TABLE; Schema: cadastro; Owner: postgres
--

CREATE TABLE ocupacao (
    idocup numeric(6,0) NOT NULL,
    descricao character varying(250) NOT NULL
);


ALTER TABLE ocupacao OWNER TO postgres;

--
-- Name: orgao_emissor_rg_idorg_rg_seq; Type: SEQUENCE; Schema: cadastro; Owner: postgres
--

CREATE SEQUENCE orgao_emissor_rg_idorg_rg_seq
    START WITH 30
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE orgao_emissor_rg_idorg_rg_seq OWNER TO postgres;

--
-- Name: orgao_emissor_rg; Type: TABLE; Schema: cadastro; Owner: postgres
--

CREATE TABLE orgao_emissor_rg (
    idorg_rg integer DEFAULT nextval('orgao_emissor_rg_idorg_rg_seq'::regclass) NOT NULL,
    sigla character varying(20) NOT NULL,
    descricao character varying(60) NOT NULL,
    situacao character(1) NOT NULL,
    codigo_educacenso integer,
    CONSTRAINT ck_orgao_emissor_rg_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar)))
);


ALTER TABLE orgao_emissor_rg OWNER TO postgres;

--
-- Name: pessoa; Type: TABLE; Schema: cadastro; Owner: postgres
--

CREATE TABLE pessoa (
    idpes numeric(8,0) DEFAULT nextval(('cadastro.seq_pessoa'::text)::regclass) NOT NULL,
    nome character varying(150) NOT NULL,
    idpes_cad numeric(8,0),
    data_cad timestamp without time zone NOT NULL,
    url character varying(60),
    tipo character(1) NOT NULL,
    idpes_rev numeric(8,0),
    data_rev timestamp without time zone,
    email character varying(100),
    situacao character(1) NOT NULL,
    origem_gravacao character(1) NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    CONSTRAINT ck_pessoa_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_pessoa_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_pessoa_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar) OR (situacao = 'P'::bpchar))),
    CONSTRAINT ck_pessoa_tipo CHECK (((tipo = 'F'::bpchar) OR (tipo = 'J'::bpchar)))
);


ALTER TABLE pessoa OWNER TO postgres;

--
-- Name: pessoa_fonetico; Type: TABLE; Schema: cadastro; Owner: postgres
--

CREATE TABLE pessoa_fonetico (
    idpes numeric(8,0) NOT NULL,
    fonema character varying(30) NOT NULL
);


ALTER TABLE pessoa_fonetico OWNER TO postgres;

--
-- Name: raca_cod_raca_seq; Type: SEQUENCE; Schema: cadastro; Owner: postgres
--

CREATE SEQUENCE raca_cod_raca_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE raca_cod_raca_seq OWNER TO postgres;

--
-- Name: raca; Type: TABLE; Schema: cadastro; Owner: postgres
--

CREATE TABLE raca (
    cod_raca integer DEFAULT nextval('raca_cod_raca_seq'::regclass) NOT NULL,
    idpes_exc integer,
    idpes_cad integer NOT NULL,
    nm_raca character varying(50) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo boolean DEFAULT false,
    raca_educacenso smallint
);


ALTER TABLE raca OWNER TO postgres;

--
-- Name: religiao_cod_religiao_seq; Type: SEQUENCE; Schema: cadastro; Owner: postgres
--

CREATE SEQUENCE religiao_cod_religiao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE religiao_cod_religiao_seq OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: religiao; Type: TABLE; Schema: cadastro; Owner: postgres
--

CREATE TABLE religiao (
    cod_religiao integer DEFAULT nextval('religiao_cod_religiao_seq'::regclass) NOT NULL,
    idpes_exc integer,
    idpes_cad integer NOT NULL,
    nm_religiao character varying(50) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo boolean DEFAULT false
);


ALTER TABLE religiao OWNER TO postgres;

--
-- Name: seq_pessoa; Type: SEQUENCE; Schema: cadastro; Owner: postgres
--

CREATE SEQUENCE seq_pessoa
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE seq_pessoa OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: socio; Type: TABLE; Schema: cadastro; Owner: postgres
--

CREATE TABLE socio (
    idpes_juridica numeric(8,0) NOT NULL,
    idpes_fisica numeric(8,0) NOT NULL,
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    CONSTRAINT ck_socio_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_socio_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar)))
);


ALTER TABLE socio OWNER TO postgres;

SET search_path = public, pg_catalog;

--
-- Name: bairro; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE bairro (
    idmun numeric(6,0) NOT NULL,
    geom character varying,
    idbai numeric(6,0) DEFAULT nextval(('public.seq_bairro'::text)::regclass) NOT NULL,
    nome character varying(80) NOT NULL,
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    zona_localizacao integer DEFAULT 1,
    iddis integer NOT NULL,
    idsetorbai numeric(6,0),
    CONSTRAINT ck_bairro_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_bairro_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar)))
);


ALTER TABLE bairro OWNER TO postgres;

--
-- Name: logradouro; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE logradouro (
    idlog numeric(6,0) DEFAULT nextval(('public.seq_logradouro'::text)::regclass) NOT NULL,
    idtlog character varying(5) NOT NULL,
    nome character varying(150) NOT NULL,
    idmun numeric(6,0) NOT NULL,
    geom character varying,
    ident_oficial character(1),
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    CONSTRAINT ck_logradouro_ident_oficial CHECK (((ident_oficial = 'S'::bpchar) OR (ident_oficial = 'N'::bpchar))),
    CONSTRAINT ck_logradouro_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_logradouro_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar)))
);


ALTER TABLE logradouro OWNER TO postgres;

--
-- Name: municipio; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE municipio (
    idmun numeric(6,0) DEFAULT nextval(('public.seq_municipio'::text)::regclass) NOT NULL,
    nome character varying(60) NOT NULL,
    sigla_uf character varying(3) NOT NULL,
    area_km2 numeric(6,0),
    idmreg numeric(2,0),
    idasmun numeric(2,0),
    cod_ibge numeric(20,0),
    geom character varying,
    tipo character(1) NOT NULL,
    idmun_pai numeric(6,0),
    idpes_rev numeric,
    idpes_cad numeric,
    data_rev timestamp without time zone,
    data_cad timestamp without time zone NOT NULL,
    origem_gravacao character(1) NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    CONSTRAINT ck_municipio_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_municipio_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_municipio_tipo CHECK (((tipo = 'D'::bpchar) OR (tipo = 'M'::bpchar) OR (tipo = 'P'::bpchar) OR (tipo = 'R'::bpchar)))
);


ALTER TABLE municipio OWNER TO postgres;

SET search_path = cadastro, pg_catalog;

--
-- Name: v_endereco; Type: VIEW; Schema: cadastro; Owner: postgres
--

CREATE VIEW v_endereco AS
 SELECT e.idpes,
    e.cep,
    e.idlog,
    e.numero,
    e.letra,
    e.complemento,
    e.idbai,
    e.bloco,
    e.andar,
    e.apartamento,
    l.nome AS logradouro,
    l.idtlog,
    b.nome AS bairro,
    m.nome AS cidade,
    m.sigla_uf,
    b.zona_localizacao
   FROM endereco_pessoa e,
    public.logradouro l,
    public.bairro b,
    public.municipio m
  WHERE ((e.idlog = l.idlog) AND (e.idbai = b.idbai) AND (b.idmun = m.idmun) AND (e.tipo = (1)::numeric))
UNION
 SELECT e.idpes,
    e.cep,
    NULL::numeric AS idlog,
    e.numero,
    e.letra,
    e.complemento,
    NULL::numeric AS idbai,
    e.bloco,
    e.andar,
    e.apartamento,
    e.logradouro,
    e.idtlog,
    e.bairro,
    e.cidade,
    e.sigla_uf,
    e.zona_localizacao
   FROM endereco_externo e
  WHERE (e.tipo = (1)::numeric);


ALTER TABLE v_endereco OWNER TO postgres;

--
-- Name: v_fone_pessoa; Type: VIEW; Schema: cadastro; Owner: postgres
--

CREATE VIEW v_fone_pessoa AS
 SELECT DISTINCT t.idpes,
    ( SELECT t1.ddd
           FROM fone_pessoa t1
          WHERE ((t1.tipo = (1)::numeric) AND (t.idpes = t1.idpes))) AS ddd_1,
    ( SELECT t1.fone
           FROM fone_pessoa t1
          WHERE ((t1.tipo = (1)::numeric) AND (t.idpes = t1.idpes))) AS fone_1,
    ( SELECT t1.ddd
           FROM fone_pessoa t1
          WHERE ((t1.tipo = (2)::numeric) AND (t.idpes = t1.idpes))) AS ddd_2,
    ( SELECT t1.fone
           FROM fone_pessoa t1
          WHERE ((t1.tipo = (2)::numeric) AND (t.idpes = t1.idpes))) AS fone_2,
    ( SELECT t1.ddd
           FROM fone_pessoa t1
          WHERE ((t1.tipo = (3)::numeric) AND (t.idpes = t1.idpes))) AS ddd_mov,
    ( SELECT t1.fone
           FROM fone_pessoa t1
          WHERE ((t1.tipo = (3)::numeric) AND (t.idpes = t1.idpes))) AS fone_mov,
    ( SELECT t1.ddd
           FROM fone_pessoa t1
          WHERE ((t1.tipo = (4)::numeric) AND (t.idpes = t1.idpes))) AS ddd_fax,
    ( SELECT t1.fone
           FROM fone_pessoa t1
          WHERE ((t1.tipo = (4)::numeric) AND (t.idpes = t1.idpes))) AS fone_fax
   FROM fone_pessoa t
  ORDER BY t.idpes, ( SELECT t1.ddd
           FROM fone_pessoa t1
          WHERE ((t1.tipo = (1)::numeric) AND (t.idpes = t1.idpes))), ( SELECT t1.fone
           FROM fone_pessoa t1
          WHERE ((t1.tipo = (1)::numeric) AND (t.idpes = t1.idpes))), ( SELECT t1.ddd
           FROM fone_pessoa t1
          WHERE ((t1.tipo = (2)::numeric) AND (t.idpes = t1.idpes))), ( SELECT t1.fone
           FROM fone_pessoa t1
          WHERE ((t1.tipo = (2)::numeric) AND (t.idpes = t1.idpes))), ( SELECT t1.ddd
           FROM fone_pessoa t1
          WHERE ((t1.tipo = (3)::numeric) AND (t.idpes = t1.idpes))), ( SELECT t1.fone
           FROM fone_pessoa t1
          WHERE ((t1.tipo = (3)::numeric) AND (t.idpes = t1.idpes))), ( SELECT t1.ddd
           FROM fone_pessoa t1
          WHERE ((t1.tipo = (4)::numeric) AND (t.idpes = t1.idpes))), ( SELECT t1.fone
           FROM fone_pessoa t1
          WHERE ((t1.tipo = (4)::numeric) AND (t.idpes = t1.idpes)));


ALTER TABLE v_fone_pessoa OWNER TO postgres;

--
-- Name: v_pessoa_fisica; Type: VIEW; Schema: cadastro; Owner: postgres
--

CREATE VIEW v_pessoa_fisica AS
 SELECT p.idpes,
    p.nome,
    p.url,
    p.email,
    p.situacao,
    f.data_nasc,
    f.sexo,
    f.cpf,
    f.ref_cod_sistema,
    f.idesco,
    f.ativo
   FROM pessoa p,
    fisica f
  WHERE (p.idpes = f.idpes);


ALTER TABLE v_pessoa_fisica OWNER TO postgres;

--
-- Name: v_pessoa_fisica_simples; Type: VIEW; Schema: cadastro; Owner: postgres
--

CREATE VIEW v_pessoa_fisica_simples AS
 SELECT p.idpes,
    ( SELECT fisica_cpf.cpf
           FROM fisica_cpf
          WHERE (fisica_cpf.idpes = p.idpes)) AS cpf,
    f.ref_cod_sistema,
    f.idesco
   FROM pessoa p,
    fisica f
  WHERE (p.idpes = f.idpes);


ALTER TABLE v_pessoa_fisica_simples OWNER TO postgres;

--
-- Name: v_pessoa_fj; Type: VIEW; Schema: cadastro; Owner: postgres
--

CREATE VIEW v_pessoa_fj AS
 SELECT p.idpes,
    p.nome,
    ( SELECT fisica.ref_cod_sistema
           FROM fisica
          WHERE (fisica.idpes = p.idpes)) AS ref_cod_sistema,
    ( SELECT juridica.fantasia
           FROM juridica
          WHERE (juridica.idpes = p.idpes)) AS fantasia,
    p.tipo,
    COALESCE(( SELECT fisica.cpf
           FROM fisica
          WHERE (fisica.idpes = p.idpes)), ( SELECT juridica.cnpj
           FROM juridica
          WHERE (juridica.idpes = p.idpes))) AS id_federal
   FROM pessoa p;


ALTER TABLE v_pessoa_fj OWNER TO postgres;

--
-- Name: v_pessoa_juridica; Type: VIEW; Schema: cadastro; Owner: postgres
--

CREATE VIEW v_pessoa_juridica AS
 SELECT j.idpes,
    j.fantasia,
    j.cnpj,
    j.insc_estadual,
    j.capital_social,
    ( SELECT pessoa.nome
           FROM pessoa
          WHERE (pessoa.idpes = j.idpes)) AS nome
   FROM juridica j;


ALTER TABLE v_pessoa_juridica OWNER TO postgres;

--
-- Name: v_pessoafj_count; Type: VIEW; Schema: cadastro; Owner: postgres
--

CREATE VIEW v_pessoafj_count AS
 SELECT fisica.ref_cod_sistema,
    fisica.cpf AS id_federal
   FROM fisica
UNION ALL
 SELECT NULL::integer AS ref_cod_sistema,
    juridica.cnpj AS id_federal
   FROM juridica;


ALTER TABLE v_pessoafj_count OWNER TO postgres;

SET search_path = consistenciacao, pg_catalog;

--
-- Name: campo_consistenciacao; Type: TABLE; Schema: consistenciacao; Owner: postgres
--

CREATE TABLE campo_consistenciacao (
    idcam numeric(3,0) NOT NULL,
    campo character varying(50) NOT NULL,
    permite_regra_cadastrada character(1) NOT NULL,
    tamanho_maximo numeric(4,0),
    CONSTRAINT ck_campo_consistenciacao_permite_regra CHECK (((permite_regra_cadastrada = 'S'::bpchar) OR (permite_regra_cadastrada = 'N'::bpchar)))
);


ALTER TABLE campo_consistenciacao OWNER TO postgres;

--
-- Name: campo_metadado_id_campo_met_seq; Type: SEQUENCE; Schema: consistenciacao; Owner: postgres
--

CREATE SEQUENCE campo_metadado_id_campo_met_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE campo_metadado_id_campo_met_seq OWNER TO postgres;

--
-- Name: campo_metadado; Type: TABLE; Schema: consistenciacao; Owner: postgres
--

CREATE TABLE campo_metadado (
    id_campo_met integer DEFAULT nextval('campo_metadado_id_campo_met_seq'::regclass) NOT NULL,
    idmet integer NOT NULL,
    idreg integer,
    idcam numeric(3,0),
    posicao_inicial numeric(5,0),
    posicao_final numeric(5,0),
    posicao_coluna numeric(5,0),
    credibilidade numeric(1,0) NOT NULL,
    data_atualizacao character(1) NOT NULL,
    CONSTRAINT ck_cam_met_campo_cred CHECK (((credibilidade >= (2)::numeric) AND (credibilidade <= (4)::numeric))),
    CONSTRAINT ck_cam_met_data_atualizacao CHECK (((data_atualizacao = 'S'::bpchar) OR (data_atualizacao = 'N'::bpchar)))
);


ALTER TABLE campo_metadado OWNER TO postgres;

--
-- Name: confrontacao_idcon_seq; Type: SEQUENCE; Schema: consistenciacao; Owner: postgres
--

CREATE SEQUENCE confrontacao_idcon_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE confrontacao_idcon_seq OWNER TO postgres;

--
-- Name: confrontacao; Type: TABLE; Schema: consistenciacao; Owner: postgres
--

CREATE TABLE confrontacao (
    idcon integer DEFAULT nextval('confrontacao_idcon_seq'::regclass) NOT NULL,
    idins integer NOT NULL,
    idpes integer NOT NULL,
    idmet integer NOT NULL,
    arquivo_fonte_dados character varying(250) NOT NULL,
    ignorar_reg_fonte date,
    desconsiderar_reg_cred_maxima date,
    data_hora timestamp without time zone NOT NULL
);


ALTER TABLE confrontacao OWNER TO postgres;

--
-- Name: fonte_idfon_seq; Type: SEQUENCE; Schema: consistenciacao; Owner: postgres
--

CREATE SEQUENCE fonte_idfon_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE fonte_idfon_seq OWNER TO postgres;

--
-- Name: fonte; Type: TABLE; Schema: consistenciacao; Owner: postgres
--

CREATE TABLE fonte (
    idfon integer DEFAULT nextval('fonte_idfon_seq'::regclass) NOT NULL,
    nome character varying(60) NOT NULL,
    situacao character(1) NOT NULL,
    CONSTRAINT ck_fonte_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar)))
);


ALTER TABLE fonte OWNER TO postgres;

--
-- Name: historico_campo; Type: TABLE; Schema: consistenciacao; Owner: postgres
--

CREATE TABLE historico_campo (
    idpes numeric(8,0) NOT NULL,
    idcam numeric(3,0) NOT NULL,
    credibilidade numeric(1,0) NOT NULL,
    data_hora timestamp without time zone NOT NULL,
    CONSTRAINT ck_historico_campo_cred CHECK (((credibilidade >= (1)::numeric) AND (credibilidade <= (5)::numeric)))
);


ALTER TABLE historico_campo OWNER TO postgres;

--
-- Name: incoerencia_idinc_seq; Type: SEQUENCE; Schema: consistenciacao; Owner: postgres
--

CREATE SEQUENCE incoerencia_idinc_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE incoerencia_idinc_seq OWNER TO postgres;

--
-- Name: incoerencia; Type: TABLE; Schema: consistenciacao; Owner: postgres
--

CREATE TABLE incoerencia (
    idinc integer DEFAULT nextval('incoerencia_idinc_seq'::regclass) NOT NULL,
    idcon integer NOT NULL,
    data_gravacao date NOT NULL,
    ultima_etapa numeric(1,0) NOT NULL,
    cpf_cnpj numeric(14,0),
    nome character varying(150),
    email character varying(100),
    url character varying(60),
    data_nasc character varying(20),
    fantasia character varying(50),
    insc_estadual numeric(10,0),
    sexo character varying(10),
    nome_mae character varying(150),
    nome_pai character varying(150),
    nome_responsavel character varying(150),
    nome_conjuge character varying(150),
    ultima_empresa character varying(150),
    ocupacao character varying(250),
    escolaridade character varying(60),
    estado_civil character varying(15),
    pais_estrangeiro character varying(60),
    data_chegada_brasil character varying(20),
    data_obito character varying(20),
    data_uniao character varying(20)
);


ALTER TABLE incoerencia OWNER TO postgres;

--
-- Name: incoerencia_documento_id_inc_doc_seq; Type: SEQUENCE; Schema: consistenciacao; Owner: postgres
--

CREATE SEQUENCE incoerencia_documento_id_inc_doc_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE incoerencia_documento_id_inc_doc_seq OWNER TO postgres;

--
-- Name: incoerencia_documento; Type: TABLE; Schema: consistenciacao; Owner: postgres
--

CREATE TABLE incoerencia_documento (
    id_inc_doc integer DEFAULT nextval('incoerencia_documento_id_inc_doc_seq'::regclass) NOT NULL,
    idinc integer NOT NULL,
    rg numeric(10,0),
    orgao_exp_rg character varying(20),
    data_exp_rg character varying(20),
    sigla_uf_rg_exp character varying(30),
    tipo_cert_civil numeric(2,0),
    num_termo numeric(8,0),
    num_livro numeric(8,0),
    num_folha numeric(4,0),
    data_emissao_cert_civil character varying(20),
    cartorio_cert_civil character varying(150),
    sigla_uf_cert_civil character varying(30),
    num_cart_trabalho numeric(7,0),
    serie_cart_trabalho numeric(5,0),
    data_emissao_cart_trabalho character varying(20),
    sigla_uf_cart_trabalho character varying(30),
    num_tit_eleitor numeric(13,0),
    zona_tit_eleitor numeric(4,0),
    secao_tit_eleitor numeric(4,0)
);


ALTER TABLE incoerencia_documento OWNER TO postgres;

--
-- Name: incoerencia_endereco_id_inc_end_seq; Type: SEQUENCE; Schema: consistenciacao; Owner: postgres
--

CREATE SEQUENCE incoerencia_endereco_id_inc_end_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE incoerencia_endereco_id_inc_end_seq OWNER TO postgres;

--
-- Name: incoerencia_endereco; Type: TABLE; Schema: consistenciacao; Owner: postgres
--

CREATE TABLE incoerencia_endereco (
    id_inc_end integer DEFAULT nextval('incoerencia_endereco_id_inc_end_seq'::regclass) NOT NULL,
    idinc integer NOT NULL,
    tipo character varying(60) NOT NULL,
    tipo_logradouro character varying(15),
    logradouro character varying(150),
    numero numeric(6,0),
    letra character(1),
    complemento character varying(20),
    bairro character varying(40),
    cep numeric(8,0),
    cidade character varying(60),
    uf character varying(30),
    CONSTRAINT ck_incoerencia_endereco_tipo CHECK ((((tipo)::text >= ((1)::numeric)::text) AND ((tipo)::text <= ((3)::numeric)::text)))
);


ALTER TABLE incoerencia_endereco OWNER TO postgres;

--
-- Name: incoerencia_fone_id_inc_fone_seq; Type: SEQUENCE; Schema: consistenciacao; Owner: postgres
--

CREATE SEQUENCE incoerencia_fone_id_inc_fone_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE incoerencia_fone_id_inc_fone_seq OWNER TO postgres;

--
-- Name: incoerencia_fone; Type: TABLE; Schema: consistenciacao; Owner: postgres
--

CREATE TABLE incoerencia_fone (
    id_inc_fone integer DEFAULT nextval('incoerencia_fone_id_inc_fone_seq'::regclass) NOT NULL,
    idinc integer NOT NULL,
    tipo character varying(60) NOT NULL,
    ddd numeric(3,0),
    fone numeric(8,0),
    CONSTRAINT ck_incoerencia_fone_tipo CHECK ((((tipo)::text >= ((1)::numeric)::text) AND ((tipo)::text <= ((4)::numeric)::text)))
);


ALTER TABLE incoerencia_fone OWNER TO postgres;

--
-- Name: incoerencia_pessoa_possivel; Type: TABLE; Schema: consistenciacao; Owner: postgres
--

CREATE TABLE incoerencia_pessoa_possivel (
    idinc integer NOT NULL,
    idpes numeric(8,0) NOT NULL
);


ALTER TABLE incoerencia_pessoa_possivel OWNER TO postgres;

--
-- Name: incoerencia_tipo_incoerencia; Type: TABLE; Schema: consistenciacao; Owner: postgres
--

CREATE TABLE incoerencia_tipo_incoerencia (
    id_tipo_inc numeric(3,0) NOT NULL,
    idinc integer NOT NULL
);


ALTER TABLE incoerencia_tipo_incoerencia OWNER TO postgres;

--
-- Name: metadado_idmet_seq; Type: SEQUENCE; Schema: consistenciacao; Owner: postgres
--

CREATE SEQUENCE metadado_idmet_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE metadado_idmet_seq OWNER TO postgres;

--
-- Name: metadado; Type: TABLE; Schema: consistenciacao; Owner: postgres
--

CREATE TABLE metadado (
    idmet integer DEFAULT nextval('metadado_idmet_seq'::regclass) NOT NULL,
    idfon integer NOT NULL,
    nome character varying(60) NOT NULL,
    situacao character(1) NOT NULL,
    separador character(1),
    CONSTRAINT ck_metadado_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar)))
);


ALTER TABLE metadado OWNER TO postgres;

--
-- Name: ocorrencia_regra_campo; Type: TABLE; Schema: consistenciacao; Owner: postgres
--

CREATE TABLE ocorrencia_regra_campo (
    idreg integer NOT NULL,
    conteudo_padrao character varying(60) NOT NULL,
    ocorrencias text NOT NULL
);


ALTER TABLE ocorrencia_regra_campo OWNER TO postgres;

--
-- Name: regra_campo_idreg_seq; Type: SEQUENCE; Schema: consistenciacao; Owner: postgres
--

CREATE SEQUENCE regra_campo_idreg_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE regra_campo_idreg_seq OWNER TO postgres;

--
-- Name: regra_campo; Type: TABLE; Schema: consistenciacao; Owner: postgres
--

CREATE TABLE regra_campo (
    idreg integer DEFAULT nextval('regra_campo_idreg_seq'::regclass) NOT NULL,
    nome character varying(60) NOT NULL,
    tipo character(1) NOT NULL,
    CONSTRAINT ck_regra_campo_tipo CHECK (((tipo = 'S'::bpchar) OR (tipo = 'N'::bpchar)))
);


ALTER TABLE regra_campo OWNER TO postgres;

--
-- Name: temp_cadastro_unificacao_cmf; Type: TABLE; Schema: consistenciacao; Owner: postgres
--

CREATE TABLE temp_cadastro_unificacao_cmf (
    idpes numeric(8,0) NOT NULL,
    nome character varying(150) NOT NULL,
    cpf_cnpj character varying(14),
    rg character varying(10),
    uf_rg character varying(50),
    data_nascimento character varying(10),
    logradouro character varying(150),
    cep character varying(10),
    bairro character varying(40),
    numero character varying(6),
    cidade_end character varying(60),
    uf_end character varying(2),
    complemento character varying(20),
    fone character varying(14),
    nome_mae character varying(150),
    nome_mae_idpes character varying(150),
    data_cadastro character varying(10),
    data_atualizacao character varying(10),
    situacao character varying(15),
    tipo_pess character varying(1),
    nome_fantasia character varying(50),
    inscr_estadual character varying(10)
);


ALTER TABLE temp_cadastro_unificacao_cmf OWNER TO postgres;

--
-- Name: temp_cadastro_unificacao_siam; Type: TABLE; Schema: consistenciacao; Owner: postgres
--

CREATE TABLE temp_cadastro_unificacao_siam (
    idpes numeric(8,0) NOT NULL,
    nome character varying(40) NOT NULL,
    cpf_cnpj character varying(14),
    rg character varying(15),
    logradouro character varying(40),
    cep character varying(10),
    bairro character varying(20),
    cidade_end character varying(20),
    uf_end character varying(2),
    fone character varying(14),
    data_cadastro character varying(10)
);


ALTER TABLE temp_cadastro_unificacao_siam OWNER TO postgres;

--
-- Name: tipo_incoerencia; Type: TABLE; Schema: consistenciacao; Owner: postgres
--

CREATE TABLE tipo_incoerencia (
    id_tipo_inc numeric(3,0) NOT NULL,
    idcam numeric(3,0) NOT NULL,
    descricao character varying(250) NOT NULL
);


ALTER TABLE tipo_incoerencia OWNER TO postgres;

SET search_path = historico, pg_catalog;

--
-- Name: bairro; Type: TABLE; Schema: historico; Owner: postgres
--

CREATE TABLE bairro (
    idbai numeric(6,0) NOT NULL,
    idmun numeric(6,0) NOT NULL,
    nome character varying(80) NOT NULL,
    geom character varying,
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_bairro_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_bairro_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar)))
);


ALTER TABLE bairro OWNER TO postgres;

--
-- Name: cep_logradouro; Type: TABLE; Schema: historico; Owner: postgres
--

CREATE TABLE cep_logradouro (
    cep numeric(8,0) NOT NULL,
    idlog numeric(6,0) NOT NULL,
    nroini numeric(6,0),
    nrofin numeric(6,0),
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_cep_logradouro_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_cep_logradouro_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar)))
);


ALTER TABLE cep_logradouro OWNER TO postgres;

--
-- Name: cep_logradouro_bairro; Type: TABLE; Schema: historico; Owner: postgres
--

CREATE TABLE cep_logradouro_bairro (
    idbai numeric(6,0) NOT NULL,
    idlog numeric(6,0) NOT NULL,
    cep numeric(8,0) NOT NULL,
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_cep_logradouro_bairro_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_cep_logradouro_bairro_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar)))
);


ALTER TABLE cep_logradouro_bairro OWNER TO postgres;

--
-- Name: documento; Type: TABLE; Schema: historico; Owner: postgres
--

CREATE TABLE documento (
    idpes numeric(8,0) NOT NULL,
    rg character varying(25),
    data_exp_rg date,
    sigla_uf_exp_rg character(2),
    tipo_cert_civil numeric(2,0),
    num_termo numeric(8,0),
    num_livro character varying(8),
    num_folha numeric(4,0),
    data_emissao_cert_civil date,
    sigla_uf_cert_civil character(2),
    cartorio_cert_civil character varying(150),
    num_cart_trabalho numeric(7,0),
    serie_cart_trabalho numeric(5,0),
    data_emissao_cart_trabalho date,
    sigla_uf_cart_trabalho character(2),
    num_tit_eleitor numeric(13,0),
    zona_tit_eleitor numeric(4,0),
    secao_tit_eleitor numeric(4,0),
    idorg_exp_rg integer,
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_documento_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_documento_tipo_cert CHECK (((tipo_cert_civil >= (91)::numeric) AND (tipo_cert_civil <= (92)::numeric))),
    CONSTRAINT ck_fone_pessoa_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar)))
);


ALTER TABLE documento OWNER TO postgres;

--
-- Name: endereco_externo; Type: TABLE; Schema: historico; Owner: postgres
--

CREATE TABLE endereco_externo (
    idpes numeric(8,0) NOT NULL,
    tipo numeric(1,0) NOT NULL,
    idtlog character varying(5) NOT NULL,
    logradouro character varying(150) NOT NULL,
    numero numeric(6,0),
    letra character(1),
    complemento character varying(20),
    bairro character varying(40),
    cep numeric(8,0),
    cidade character varying(60) NOT NULL,
    sigla_uf character(2) NOT NULL,
    reside_desde date,
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_endereco_externo_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_endereco_externo_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_endereco_externo_tipo CHECK (((tipo >= (1)::numeric) AND (tipo <= (3)::numeric)))
);


ALTER TABLE endereco_externo OWNER TO postgres;

--
-- Name: endereco_pessoa; Type: TABLE; Schema: historico; Owner: postgres
--

CREATE TABLE endereco_pessoa (
    idpes numeric(8,0) NOT NULL,
    tipo numeric(1,0) NOT NULL,
    cep numeric(8,0) NOT NULL,
    idlog numeric(6,0) NOT NULL,
    idbai numeric(6,0) NOT NULL,
    numero numeric(6,0),
    letra character(1),
    complemento character varying(50),
    reside_desde date,
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_endereco_pessoa_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_endereco_pessoa_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_endereco_pessoa_tipo CHECK (((tipo >= (1)::numeric) AND (tipo <= (3)::numeric)))
);


ALTER TABLE endereco_pessoa OWNER TO postgres;

--
-- Name: fisica; Type: TABLE; Schema: historico; Owner: postgres
--

CREATE TABLE fisica (
    idpes numeric(8,0) NOT NULL,
    data_nasc date,
    sexo character(1),
    idpes_mae numeric(8,0),
    idpes_pai numeric(8,0),
    idpes_responsavel numeric(8,0),
    idesco numeric(2,0),
    ideciv numeric(1,0),
    idpes_con numeric(8,0),
    data_uniao date,
    data_obito date,
    nacionalidade numeric(1,0),
    idpais_estrangeiro numeric(3,0),
    data_chegada_brasil date,
    idmun_nascimento numeric(6,0),
    ultima_empresa character varying(150),
    idocup numeric(6,0),
    nome_mae character varying(150),
    nome_pai character varying(150),
    nome_conjuge character varying(150),
    nome_responsavel character varying(150),
    justificativa_provisorio character varying(150),
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_fisica_nacionalidade CHECK (((nacionalidade >= (1)::numeric) AND (nacionalidade <= (3)::numeric))),
    CONSTRAINT ck_fisica_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_fisica_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_fisica_sexo CHECK (((sexo = 'M'::bpchar) OR (sexo = 'F'::bpchar)))
);


ALTER TABLE fisica OWNER TO postgres;

--
-- Name: fisica_cpf; Type: TABLE; Schema: historico; Owner: postgres
--

CREATE TABLE fisica_cpf (
    idpes numeric(8,0) NOT NULL,
    cpf numeric(11,0) NOT NULL,
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_fisica_cpf_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_fone_pessoa_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar)))
);


ALTER TABLE fisica_cpf OWNER TO postgres;

--
-- Name: fone_pessoa; Type: TABLE; Schema: historico; Owner: postgres
--

CREATE TABLE fone_pessoa (
    idpes numeric(8,0) NOT NULL,
    tipo numeric(1,0) NOT NULL,
    ddd numeric(3,0) NOT NULL,
    fone numeric(11,0) NOT NULL,
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_fone_pessoa_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_fone_pessoa_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_fone_pessoa_tipo CHECK (((tipo >= (1)::numeric) AND (tipo <= (4)::numeric)))
);


ALTER TABLE fone_pessoa OWNER TO postgres;

--
-- Name: funcionario; Type: TABLE; Schema: historico; Owner: postgres
--

CREATE TABLE funcionario (
    matricula numeric(8,0) NOT NULL,
    idins integer NOT NULL,
    idset integer,
    idpes numeric(8,0) NOT NULL,
    situacao character(1) NOT NULL,
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_fone_pessoa_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_funcionario_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_funcionario_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar)))
);


ALTER TABLE funcionario OWNER TO postgres;

--
-- Name: juridica; Type: TABLE; Schema: historico; Owner: postgres
--

CREATE TABLE juridica (
    idpes numeric(8,0) NOT NULL,
    cnpj numeric(14,0) NOT NULL,
    insc_estadual numeric(20,0),
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    fantasia character varying(255),
    CONSTRAINT ck_juridica_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_juridica_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar)))
);


ALTER TABLE juridica OWNER TO postgres;

--
-- Name: logradouro; Type: TABLE; Schema: historico; Owner: postgres
--

CREATE TABLE logradouro (
    idlog numeric(6,0) NOT NULL,
    idtlog character varying(5) NOT NULL,
    nome character varying(150) NOT NULL,
    idmun numeric(6,0) NOT NULL,
    geom character varying,
    ident_oficial character(1),
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_logradouro_ident_oficial CHECK (((ident_oficial = 'S'::bpchar) OR (ident_oficial = 'N'::bpchar))),
    CONSTRAINT ck_logradouro_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_logradouro_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar)))
);


ALTER TABLE logradouro OWNER TO postgres;

--
-- Name: municipio; Type: TABLE; Schema: historico; Owner: postgres
--

CREATE TABLE municipio (
    idmun numeric(6,0) NOT NULL,
    nome character varying(60) NOT NULL,
    sigla_uf character(2) NOT NULL,
    area_km2 numeric(6,0),
    idmreg numeric(2,0),
    idasmun numeric(2,0),
    cod_ibge numeric(20,0),
    geom character varying,
    tipo character(1) NOT NULL,
    idmun_pai numeric(6,0),
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_municipio_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_municipio_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_municipio_tipo CHECK (((tipo = 'D'::bpchar) OR (tipo = 'M'::bpchar) OR (tipo = 'P'::bpchar) OR (tipo = 'R'::bpchar)))
);


ALTER TABLE municipio OWNER TO postgres;

--
-- Name: pessoa; Type: TABLE; Schema: historico; Owner: postgres
--

CREATE TABLE pessoa (
    idpes numeric(8,0) NOT NULL,
    nome character varying(150) NOT NULL,
    idpes_cad numeric(8,0),
    data_cad timestamp without time zone NOT NULL,
    url character varying(60),
    tipo character(1) NOT NULL,
    idpes_rev numeric(8,0),
    data_rev timestamp without time zone,
    email character varying(100),
    situacao character(1) NOT NULL,
    origem_gravacao character(1) NOT NULL,
    idsis_rev numeric,
    idsis_cad numeric NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_pessoa_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_pessoa_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_pessoa_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar) OR (situacao = 'P'::bpchar))),
    CONSTRAINT ck_pessoa_tipo CHECK (((tipo = 'F'::bpchar) OR (tipo = 'J'::bpchar)))
);


ALTER TABLE pessoa OWNER TO postgres;

--
-- Name: socio; Type: TABLE; Schema: historico; Owner: postgres
--

CREATE TABLE socio (
    idpes_juridica numeric(8,0) NOT NULL,
    idpes_fisica numeric(8,0) NOT NULL,
    idpes_rev numeric,
    idsis_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    idsis_cad numeric NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    CONSTRAINT ck_socio_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_socio_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar)))
);


ALTER TABLE socio OWNER TO postgres;

SET search_path = modules, pg_catalog;

SET default_with_oids = false;

--
-- Name: area_conhecimento; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE area_conhecimento (
    id integer NOT NULL,
    instituicao_id integer NOT NULL,
    nome character varying(200) NOT NULL,
    secao character varying(50),
    ordenamento_ac integer DEFAULT 99999
);


ALTER TABLE area_conhecimento OWNER TO postgres;

--
-- Name: area_conhecimento_id_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE area_conhecimento_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE area_conhecimento_id_seq OWNER TO postgres;

--
-- Name: area_conhecimento_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: postgres
--

ALTER SEQUENCE area_conhecimento_id_seq OWNED BY area_conhecimento.id;


--
-- Name: auditoria; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE auditoria (
    usuario character varying(300),
    operacao smallint,
    rotina character varying(300),
    valor_antigo text,
    valor_novo text,
    data_hora timestamp without time zone
);


ALTER TABLE auditoria OWNER TO postgres;

--
-- Name: auditoria_geral; Type: TABLE; Schema: modules; Owner: ieducar
--

CREATE TABLE auditoria_geral (
    usuario_id integer,
    operacao smallint,
    rotina character varying(50),
    valor_antigo json,
    valor_novo json,
    data_hora timestamp without time zone,
    codigo character varying
);


ALTER TABLE auditoria_geral OWNER TO ieducar;

--
-- Name: calendario_turma; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE calendario_turma (
    calendario_ano_letivo_id integer NOT NULL,
    ano integer NOT NULL,
    mes integer NOT NULL,
    dia integer NOT NULL,
    turma_id integer NOT NULL
);


ALTER TABLE calendario_turma OWNER TO postgres;

--
-- Name: componente_curricular; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE componente_curricular (
    id integer NOT NULL,
    instituicao_id integer NOT NULL,
    area_conhecimento_id integer NOT NULL,
    nome character varying(500) NOT NULL,
    abreviatura character varying(25) NOT NULL,
    tipo_base smallint NOT NULL,
    codigo_educacenso smallint,
    ordenamento integer DEFAULT 99999
);


ALTER TABLE componente_curricular OWNER TO postgres;

--
-- Name: componente_curricular_ano_escolar; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE componente_curricular_ano_escolar (
    componente_curricular_id integer NOT NULL,
    ano_escolar_id integer NOT NULL,
    carga_horaria numeric(7,3),
    tipo_nota integer
);


ALTER TABLE componente_curricular_ano_escolar OWNER TO postgres;

--
-- Name: componente_curricular_id_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE componente_curricular_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE componente_curricular_id_seq OWNER TO postgres;

--
-- Name: componente_curricular_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: postgres
--

ALTER SEQUENCE componente_curricular_id_seq OWNED BY componente_curricular.id;


--
-- Name: componente_curricular_turma; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE componente_curricular_turma (
    componente_curricular_id integer NOT NULL,
    ano_escolar_id integer NOT NULL,
    escola_id integer NOT NULL,
    turma_id integer NOT NULL,
    carga_horaria numeric(7,3),
    docente_vinculado smallint,
    etapas_especificas smallint,
    etapas_utilizadas character varying
);


ALTER TABLE componente_curricular_turma OWNER TO postgres;

--
-- Name: docente_licenciatura; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE docente_licenciatura (
    id integer NOT NULL,
    servidor_id integer NOT NULL,
    licenciatura integer NOT NULL,
    curso_id integer,
    ano_conclusao integer NOT NULL,
    ies_id integer,
    user_id integer NOT NULL,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


ALTER TABLE docente_licenciatura OWNER TO postgres;

--
-- Name: docente_licenciatura_id_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE docente_licenciatura_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE docente_licenciatura_id_seq OWNER TO postgres;

--
-- Name: docente_licenciatura_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: postgres
--

ALTER SEQUENCE docente_licenciatura_id_seq OWNED BY docente_licenciatura.id;


--
-- Name: educacenso_cod_aluno; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE educacenso_cod_aluno (
    cod_aluno integer NOT NULL,
    cod_aluno_inep bigint NOT NULL,
    nome_inep character varying(255),
    fonte character varying(255),
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


ALTER TABLE educacenso_cod_aluno OWNER TO postgres;

--
-- Name: educacenso_cod_docente; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE educacenso_cod_docente (
    cod_servidor integer NOT NULL,
    cod_docente_inep bigint NOT NULL,
    nome_inep character varying(255),
    fonte character varying(255),
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


ALTER TABLE educacenso_cod_docente OWNER TO postgres;

--
-- Name: educacenso_cod_escola; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE educacenso_cod_escola (
    cod_escola integer NOT NULL,
    cod_escola_inep bigint NOT NULL,
    nome_inep character varying(255),
    fonte character varying(255),
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


ALTER TABLE educacenso_cod_escola OWNER TO postgres;

--
-- Name: educacenso_cod_turma; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE educacenso_cod_turma (
    cod_turma integer NOT NULL,
    cod_turma_inep bigint NOT NULL,
    nome_inep character varying(255),
    fonte character varying(255),
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


ALTER TABLE educacenso_cod_turma OWNER TO postgres;

--
-- Name: educacenso_curso_superior; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE educacenso_curso_superior (
    id integer NOT NULL,
    curso_id character varying(100) NOT NULL,
    nome character varying(255) NOT NULL,
    classe_id integer NOT NULL,
    user_id integer NOT NULL,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone,
    grau_academico smallint
);


ALTER TABLE educacenso_curso_superior OWNER TO postgres;

--
-- Name: educacenso_curso_superior_id_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE educacenso_curso_superior_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE educacenso_curso_superior_id_seq OWNER TO postgres;

--
-- Name: educacenso_curso_superior_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: postgres
--

ALTER SEQUENCE educacenso_curso_superior_id_seq OWNED BY educacenso_curso_superior.id;


--
-- Name: educacenso_ies; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE educacenso_ies (
    id integer NOT NULL,
    ies_id integer NOT NULL,
    nome character varying(255) NOT NULL,
    dependencia_administrativa_id integer NOT NULL,
    tipo_instituicao_id integer NOT NULL,
    uf character(2),
    user_id integer NOT NULL,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


ALTER TABLE educacenso_ies OWNER TO postgres;

--
-- Name: educacenso_ies_id_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE educacenso_ies_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE educacenso_ies_id_seq OWNER TO postgres;

--
-- Name: educacenso_ies_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: postgres
--

ALTER SEQUENCE educacenso_ies_id_seq OWNED BY educacenso_ies.id;


--
-- Name: empresa_transporte_escolar_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE empresa_transporte_escolar_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE empresa_transporte_escolar_seq OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: empresa_transporte_escolar; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE empresa_transporte_escolar (
    cod_empresa_transporte_escolar integer DEFAULT nextval('empresa_transporte_escolar_seq'::regclass) NOT NULL,
    ref_idpes integer NOT NULL,
    ref_resp_idpes integer NOT NULL,
    observacao character varying(255)
);


ALTER TABLE empresa_transporte_escolar OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: etapas_curso_educacenso; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE etapas_curso_educacenso (
    etapa_id integer NOT NULL,
    curso_id integer NOT NULL
);


ALTER TABLE etapas_curso_educacenso OWNER TO postgres;

--
-- Name: etapas_educacenso; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE etapas_educacenso (
    id integer NOT NULL,
    nome character varying(255)
);


ALTER TABLE etapas_educacenso OWNER TO postgres;

--
-- Name: falta_aluno; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE falta_aluno (
    id integer NOT NULL,
    matricula_id integer NOT NULL,
    tipo_falta smallint NOT NULL
);


ALTER TABLE falta_aluno OWNER TO postgres;

--
-- Name: falta_aluno_id_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE falta_aluno_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE falta_aluno_id_seq OWNER TO postgres;

--
-- Name: falta_aluno_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: postgres
--

ALTER SEQUENCE falta_aluno_id_seq OWNED BY falta_aluno.id;


--
-- Name: falta_componente_curricular; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE falta_componente_curricular (
    id integer NOT NULL,
    falta_aluno_id integer NOT NULL,
    componente_curricular_id integer NOT NULL,
    quantidade integer DEFAULT 0,
    etapa character varying(2) NOT NULL
);


ALTER TABLE falta_componente_curricular OWNER TO postgres;

--
-- Name: falta_componente_curricular_id_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE falta_componente_curricular_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE falta_componente_curricular_id_seq OWNER TO postgres;

--
-- Name: falta_componente_curricular_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: postgres
--

ALTER SEQUENCE falta_componente_curricular_id_seq OWNED BY falta_componente_curricular.id;


--
-- Name: falta_geral; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE falta_geral (
    id integer NOT NULL,
    falta_aluno_id integer NOT NULL,
    quantidade integer DEFAULT 0,
    etapa character varying(2) NOT NULL
);


ALTER TABLE falta_geral OWNER TO postgres;

--
-- Name: falta_geral_id_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE falta_geral_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE falta_geral_id_seq OWNER TO postgres;

--
-- Name: falta_geral_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: postgres
--

ALTER SEQUENCE falta_geral_id_seq OWNED BY falta_geral.id;


SET default_with_oids = true;

--
-- Name: ficha_medica_aluno; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE ficha_medica_aluno (
    ref_cod_aluno integer NOT NULL,
    altura character varying(4),
    peso character varying(7),
    grupo_sanguineo character varying(2),
    fator_rh character varying(1),
    alergia_medicamento character(1),
    desc_alergia_medicamento character varying(100),
    alergia_alimento character(1),
    desc_alergia_alimento character varying(100),
    doenca_congenita character(1),
    desc_doenca_congenita character varying(100),
    fumante character(1),
    doenca_caxumba character(1),
    doenca_sarampo character(1),
    doenca_rubeola character(1),
    doenca_catapora character(1),
    doenca_escarlatina character(1),
    doenca_coqueluche character(1),
    doenca_outras character varying(100),
    epiletico character(1),
    epiletico_tratamento character(1),
    hemofilico character(1),
    hipertenso character(1),
    asmatico character(1),
    diabetico character(1),
    insulina character(1),
    tratamento_medico character(1),
    desc_tratamento_medico character varying(100),
    medicacao_especifica character(1),
    desc_medicacao_especifica character varying(100),
    acomp_medico_psicologico character(1),
    desc_acomp_medico_psicologico character varying(100),
    restricao_atividade_fisica character(1),
    desc_restricao_atividade_fisica character varying(100),
    fratura_trauma character(1),
    desc_fratura_trauma character varying(100),
    plano_saude character(1),
    desc_plano_saude character varying(50),
    hospital_clinica character varying(100),
    hospital_clinica_endereco character varying(50),
    hospital_clinica_telefone character varying(20),
    responsavel character varying(50),
    responsavel_parentesco character varying(20),
    responsavel_parentesco_telefone character varying(20),
    responsavel_parentesco_celular character varying(20),
    observacao character varying(255)
);


ALTER TABLE ficha_medica_aluno OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: formula_media; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE formula_media (
    id integer NOT NULL,
    instituicao_id integer NOT NULL,
    nome character varying(50) NOT NULL,
    formula_media character varying(200) NOT NULL,
    tipo_formula smallint DEFAULT 1,
    substitui_menor_nota_rc smallint DEFAULT 0 NOT NULL
);


ALTER TABLE formula_media OWNER TO postgres;

--
-- Name: formula_media_id_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE formula_media_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE formula_media_id_seq OWNER TO postgres;

--
-- Name: formula_media_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: postgres
--

ALTER SEQUENCE formula_media_id_seq OWNED BY formula_media.id;


--
-- Name: itinerario_transporte_escolar_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE itinerario_transporte_escolar_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE itinerario_transporte_escolar_seq OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: itinerario_transporte_escolar; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE itinerario_transporte_escolar (
    cod_itinerario_transporte_escolar integer DEFAULT nextval('itinerario_transporte_escolar_seq'::regclass) NOT NULL,
    ref_cod_rota_transporte_escolar integer NOT NULL,
    seq integer NOT NULL,
    ref_cod_ponto_transporte_escolar integer NOT NULL,
    ref_cod_veiculo integer,
    hora time without time zone,
    tipo character(1) NOT NULL
);


ALTER TABLE itinerario_transporte_escolar OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: lingua_indigena_educacenso; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE lingua_indigena_educacenso (
    id integer NOT NULL,
    lingua character varying(255)
);


ALTER TABLE lingua_indigena_educacenso OWNER TO postgres;

--
-- Name: media_geral; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE media_geral (
    nota_aluno_id integer NOT NULL,
    media numeric(8,4) DEFAULT 0,
    media_arredondada character varying(10) DEFAULT 0,
    etapa character varying(2) NOT NULL
);


ALTER TABLE media_geral OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: moradia_aluno; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE moradia_aluno (
    ref_cod_aluno integer NOT NULL,
    moradia character(1),
    material character(1) DEFAULT 'A'::bpchar,
    casa_outra character varying(20),
    moradia_situacao integer,
    quartos integer,
    sala integer,
    copa integer,
    banheiro integer,
    garagem integer,
    empregada_domestica character(1),
    automovel character(1),
    motocicleta character(1),
    computador character(1),
    geladeira character(1),
    fogao character(1),
    maquina_lavar character(1),
    microondas character(1),
    video_dvd character(1),
    televisao character(1),
    celular character(1),
    telefone character(1),
    quant_pessoas integer,
    renda double precision,
    agua_encanada character(1),
    poco character(1),
    energia character(1),
    esgoto character(1),
    fossa character(1),
    lixo character(1)
);


ALTER TABLE moradia_aluno OWNER TO postgres;

--
-- Name: motorista_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE motorista_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE motorista_seq OWNER TO postgres;

--
-- Name: motorista; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE motorista (
    cod_motorista integer DEFAULT nextval('motorista_seq'::regclass) NOT NULL,
    ref_idpes integer NOT NULL,
    cnh character varying(15),
    tipo_cnh character varying(2),
    dt_habilitacao date,
    vencimento_cnh date,
    ref_cod_empresa_transporte_escolar integer NOT NULL,
    observacao character varying(255)
);


ALTER TABLE motorista OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: nota_aluno; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE nota_aluno (
    id integer NOT NULL,
    matricula_id integer NOT NULL
);


ALTER TABLE nota_aluno OWNER TO postgres;

--
-- Name: nota_aluno_id_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE nota_aluno_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE nota_aluno_id_seq OWNER TO postgres;

--
-- Name: nota_aluno_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: postgres
--

ALTER SEQUENCE nota_aluno_id_seq OWNED BY nota_aluno.id;


--
-- Name: nota_componente_curricular; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE nota_componente_curricular (
    id integer NOT NULL,
    nota_aluno_id integer NOT NULL,
    componente_curricular_id integer NOT NULL,
    nota numeric(8,4) DEFAULT 0,
    nota_arredondada character varying(10) DEFAULT 0,
    etapa character varying(2) NOT NULL,
    nota_recuperacao character varying(10),
    nota_original character varying(10),
    nota_recuperacao_especifica character varying(10)
);


ALTER TABLE nota_componente_curricular OWNER TO postgres;

--
-- Name: nota_componente_curricular_id_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE nota_componente_curricular_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE nota_componente_curricular_id_seq OWNER TO postgres;

--
-- Name: nota_componente_curricular_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: postgres
--

ALTER SEQUENCE nota_componente_curricular_id_seq OWNED BY nota_componente_curricular.id;


--
-- Name: nota_componente_curricular_media; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE nota_componente_curricular_media (
    nota_aluno_id integer NOT NULL,
    componente_curricular_id integer NOT NULL,
    media numeric(8,4) DEFAULT 0,
    media_arredondada character varying(10) DEFAULT 0,
    etapa character varying(2) NOT NULL,
    situacao integer
);


ALTER TABLE nota_componente_curricular_media OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: nota_exame; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE nota_exame (
    ref_cod_matricula integer NOT NULL,
    ref_cod_componente_curricular integer NOT NULL,
    nota_exame numeric(6,3)
);


ALTER TABLE nota_exame OWNER TO postgres;

--
-- Name: nota_geral_id_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE nota_geral_id_seq
    START WITH 958638
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE nota_geral_id_seq OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: nota_geral; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE nota_geral (
    id integer DEFAULT nextval('nota_geral_id_seq'::regclass) NOT NULL,
    nota_aluno_id integer NOT NULL,
    nota numeric(8,4) DEFAULT 0,
    nota_arredondada character varying(10) DEFAULT 0,
    etapa character varying(2) NOT NULL
);


ALTER TABLE nota_geral OWNER TO postgres;

--
-- Name: parecer_aluno; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE parecer_aluno (
    id integer NOT NULL,
    matricula_id integer NOT NULL,
    parecer_descritivo smallint NOT NULL
);


ALTER TABLE parecer_aluno OWNER TO postgres;

--
-- Name: parecer_aluno_id_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE parecer_aluno_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE parecer_aluno_id_seq OWNER TO postgres;

--
-- Name: parecer_aluno_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: postgres
--

ALTER SEQUENCE parecer_aluno_id_seq OWNED BY parecer_aluno.id;


--
-- Name: parecer_componente_curricular; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE parecer_componente_curricular (
    id integer NOT NULL,
    parecer_aluno_id integer NOT NULL,
    componente_curricular_id integer NOT NULL,
    parecer text,
    etapa character varying(2) NOT NULL
);


ALTER TABLE parecer_componente_curricular OWNER TO postgres;

--
-- Name: parecer_componente_curricular_id_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE parecer_componente_curricular_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE parecer_componente_curricular_id_seq OWNER TO postgres;

--
-- Name: parecer_componente_curricular_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: postgres
--

ALTER SEQUENCE parecer_componente_curricular_id_seq OWNED BY parecer_componente_curricular.id;


--
-- Name: parecer_geral; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE parecer_geral (
    id integer NOT NULL,
    parecer_aluno_id integer NOT NULL,
    parecer text,
    etapa character varying(2) NOT NULL
);


ALTER TABLE parecer_geral OWNER TO postgres;

--
-- Name: parecer_geral_id_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE parecer_geral_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE parecer_geral_id_seq OWNER TO postgres;

--
-- Name: parecer_geral_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: postgres
--

ALTER SEQUENCE parecer_geral_id_seq OWNED BY parecer_geral.id;


--
-- Name: pessoa_transporte_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE pessoa_transporte_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE pessoa_transporte_seq OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: pessoa_transporte; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE pessoa_transporte (
    cod_pessoa_transporte integer DEFAULT nextval('pessoa_transporte_seq'::regclass) NOT NULL,
    ref_idpes integer NOT NULL,
    ref_cod_rota_transporte_escolar integer NOT NULL,
    ref_cod_ponto_transporte_escolar integer,
    ref_idpes_destino integer,
    observacao character varying(255),
    turno character varying(255)
);


ALTER TABLE pessoa_transporte OWNER TO postgres;

--
-- Name: ponto_transporte_escolar_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE ponto_transporte_escolar_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ponto_transporte_escolar_seq OWNER TO postgres;

--
-- Name: ponto_transporte_escolar; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE ponto_transporte_escolar (
    cod_ponto_transporte_escolar integer DEFAULT nextval('ponto_transporte_escolar_seq'::regclass) NOT NULL,
    descricao character varying(70) NOT NULL,
    cep numeric(8,0),
    idlog numeric(6,0),
    idbai numeric(6,0),
    numero numeric(6,0),
    complemento character varying(20),
    latitude character varying(20),
    longitude character varying(20)
);


ALTER TABLE ponto_transporte_escolar OWNER TO postgres;

--
-- Name: professor_turma_id_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE professor_turma_id_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE professor_turma_id_seq OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: professor_turma; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE professor_turma (
    id integer DEFAULT nextval('professor_turma_id_seq'::regclass) NOT NULL,
    ano smallint NOT NULL,
    instituicao_id integer NOT NULL,
    turma_id integer NOT NULL,
    servidor_id integer NOT NULL,
    funcao_exercida smallint NOT NULL,
    tipo_vinculo smallint,
    permite_lancar_faltas_componente integer DEFAULT 0,
    updated_at timestamp without time zone
);


ALTER TABLE professor_turma OWNER TO postgres;

--
-- Name: professor_turma_disciplina; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE professor_turma_disciplina (
    professor_turma_id integer NOT NULL,
    componente_curricular_id integer NOT NULL
);


ALTER TABLE professor_turma_disciplina OWNER TO postgres;

--
-- Name: regra_avaliacao; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE regra_avaliacao (
    id integer NOT NULL,
    instituicao_id integer NOT NULL,
    formula_media_id integer,
    formula_recuperacao_id integer DEFAULT 0,
    tabela_arredondamento_id integer,
    nome character varying(50) NOT NULL,
    tipo_nota smallint NOT NULL,
    tipo_progressao smallint NOT NULL,
    media numeric(5,3) DEFAULT 0.000,
    porcentagem_presenca numeric(6,3) DEFAULT 0.000,
    parecer_descritivo smallint DEFAULT 0,
    tipo_presenca smallint NOT NULL,
    media_recuperacao numeric(5,3) DEFAULT 0.000,
    tipo_recuperacao_paralela smallint DEFAULT 0,
    media_recuperacao_paralela numeric(5,3),
    nota_maxima_geral integer DEFAULT 10 NOT NULL,
    nota_maxima_exame_final integer DEFAULT 10 NOT NULL,
    qtd_casas_decimais integer DEFAULT 2 NOT NULL,
    nota_geral_por_etapa smallint DEFAULT 0,
    qtd_disciplinas_dependencia smallint DEFAULT 0 NOT NULL,
    aprova_media_disciplina smallint DEFAULT 0,
    reprovacao_automatica smallint DEFAULT 0,
    definir_componente_etapa smallint,
    qtd_matriculas_dependencia smallint DEFAULT 0 NOT NULL,
    nota_minima_geral integer DEFAULT 0,
    tabela_arredondamento_id_conceitual integer
);


ALTER TABLE regra_avaliacao OWNER TO postgres;

--
-- Name: regra_avaliacao_id_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE regra_avaliacao_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE regra_avaliacao_id_seq OWNER TO postgres;

--
-- Name: regra_avaliacao_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: postgres
--

ALTER SEQUENCE regra_avaliacao_id_seq OWNED BY regra_avaliacao.id;


--
-- Name: regra_avaliacao_recuperacao_id_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE regra_avaliacao_recuperacao_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE regra_avaliacao_recuperacao_id_seq OWNER TO postgres;

--
-- Name: regra_avaliacao_recuperacao; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE regra_avaliacao_recuperacao (
    id integer DEFAULT nextval('regra_avaliacao_recuperacao_id_seq'::regclass) NOT NULL,
    regra_avaliacao_id integer NOT NULL,
    descricao character varying(25) NOT NULL,
    etapas_recuperadas character varying(25) NOT NULL,
    substitui_menor_nota boolean,
    media numeric(8,4) NOT NULL,
    nota_maxima numeric(8,4) NOT NULL
);


ALTER TABLE regra_avaliacao_recuperacao OWNER TO postgres;

--
-- Name: rota_transporte_escolar_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE rota_transporte_escolar_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE rota_transporte_escolar_seq OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: rota_transporte_escolar; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE rota_transporte_escolar (
    cod_rota_transporte_escolar integer DEFAULT nextval('rota_transporte_escolar_seq'::regclass) NOT NULL,
    ref_idpes_destino integer NOT NULL,
    descricao character varying(50) NOT NULL,
    ano integer NOT NULL,
    tipo_rota character(1) NOT NULL,
    km_pav double precision,
    km_npav double precision,
    ref_cod_empresa_transporte_escolar integer,
    tercerizado character(1) NOT NULL
);


ALTER TABLE rota_transporte_escolar OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: tabela_arredondamento; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE tabela_arredondamento (
    id integer NOT NULL,
    instituicao_id integer NOT NULL,
    nome character varying(50) NOT NULL,
    tipo_nota smallint DEFAULT 1 NOT NULL
);


ALTER TABLE tabela_arredondamento OWNER TO postgres;

--
-- Name: tabela_arredondamento_id_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE tabela_arredondamento_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE tabela_arredondamento_id_seq OWNER TO postgres;

--
-- Name: tabela_arredondamento_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: postgres
--

ALTER SEQUENCE tabela_arredondamento_id_seq OWNED BY tabela_arredondamento.id;


--
-- Name: tabela_arredondamento_valor; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE tabela_arredondamento_valor (
    id integer NOT NULL,
    tabela_arredondamento_id integer NOT NULL,
    nome character varying(5) NOT NULL,
    descricao character varying(25),
    valor_minimo numeric(5,3),
    valor_maximo numeric(5,3),
    casa_decimal_exata smallint,
    acao smallint
);


ALTER TABLE tabela_arredondamento_valor OWNER TO postgres;

--
-- Name: tabela_arredondamento_valor_id_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE tabela_arredondamento_valor_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE tabela_arredondamento_valor_id_seq OWNER TO postgres;

--
-- Name: tabela_arredondamento_valor_id_seq; Type: SEQUENCE OWNED BY; Schema: modules; Owner: postgres
--

ALTER SEQUENCE tabela_arredondamento_valor_id_seq OWNED BY tabela_arredondamento_valor.id;


--
-- Name: tipo_veiculo_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE tipo_veiculo_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE tipo_veiculo_seq OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: tipo_veiculo; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE tipo_veiculo (
    cod_tipo_veiculo integer DEFAULT nextval('tipo_veiculo_seq'::regclass) NOT NULL,
    descricao character varying(60)
);


ALTER TABLE tipo_veiculo OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: transporte_aluno; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE transporte_aluno (
    aluno_id integer NOT NULL,
    responsavel integer NOT NULL,
    user_id integer NOT NULL,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


ALTER TABLE transporte_aluno OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: uniforme_aluno; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE uniforme_aluno (
    ref_cod_aluno integer NOT NULL,
    recebeu_uniforme character(1),
    quantidade_camiseta integer,
    tamanho_camiseta character(2),
    quantidade_blusa_jaqueta integer,
    tamanho_blusa_jaqueta character(2),
    quantidade_bermuda integer,
    tamanho_bermuda character(2),
    quantidade_calca integer,
    tamanho_calca character(2),
    quantidade_saia integer,
    tamanho_saia character(2),
    quantidade_calcado integer,
    tamanho_calcado character(2),
    quantidade_meia integer,
    tamanho_meia character(2)
);


ALTER TABLE uniforme_aluno OWNER TO postgres;

--
-- Name: veiculo_seq; Type: SEQUENCE; Schema: modules; Owner: postgres
--

CREATE SEQUENCE veiculo_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE veiculo_seq OWNER TO postgres;

--
-- Name: veiculo; Type: TABLE; Schema: modules; Owner: postgres
--

CREATE TABLE veiculo (
    cod_veiculo integer DEFAULT nextval('veiculo_seq'::regclass) NOT NULL,
    descricao character varying(255) NOT NULL,
    placa character varying(10),
    renavam character varying(15) NOT NULL,
    chassi character varying(30),
    marca character varying(50),
    ano_fabricacao integer,
    ano_modelo integer,
    passageiros integer NOT NULL,
    malha character(1) NOT NULL,
    ref_cod_tipo_veiculo integer NOT NULL,
    exclusivo_transporte_escolar character(1) NOT NULL,
    adaptado_necessidades_especiais character(1) NOT NULL,
    ativo character(1),
    descricao_inativo character(155),
    ref_cod_empresa_transporte_escolar integer NOT NULL,
    ref_cod_motorista integer,
    observacao character varying(255)
);


ALTER TABLE veiculo OWNER TO postgres;

SET search_path = pmiacoes, pg_catalog;

--
-- Name: acao_governo_cod_acao_governo_seq; Type: SEQUENCE; Schema: pmiacoes; Owner: postgres
--

CREATE SEQUENCE acao_governo_cod_acao_governo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE acao_governo_cod_acao_governo_seq OWNER TO postgres;

--
-- Name: acao_governo; Type: TABLE; Schema: pmiacoes; Owner: postgres
--

CREATE TABLE acao_governo (
    cod_acao_governo integer DEFAULT nextval('acao_governo_cod_acao_governo_seq'::regclass) NOT NULL,
    ref_funcionario_exc integer,
    ref_funcionario_cad integer NOT NULL,
    nm_acao character varying(255) NOT NULL,
    descricao text,
    data_inauguracao timestamp without time zone,
    valor double precision,
    destaque smallint DEFAULT (0)::smallint NOT NULL,
    status_acao smallint DEFAULT (0)::smallint NOT NULL,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    numero_acao smallint DEFAULT 0,
    categoria smallint,
    idbai bigint
);


ALTER TABLE acao_governo OWNER TO postgres;

--
-- Name: acao_governo_arquivo_cod_acao_governo_arquivo_seq; Type: SEQUENCE; Schema: pmiacoes; Owner: postgres
--

CREATE SEQUENCE acao_governo_arquivo_cod_acao_governo_arquivo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE acao_governo_arquivo_cod_acao_governo_arquivo_seq OWNER TO postgres;

--
-- Name: acao_governo_arquivo; Type: TABLE; Schema: pmiacoes; Owner: postgres
--

CREATE TABLE acao_governo_arquivo (
    cod_acao_governo_arquivo integer DEFAULT nextval('acao_governo_arquivo_cod_acao_governo_arquivo_seq'::regclass) NOT NULL,
    ref_funcionario_cad integer NOT NULL,
    ref_cod_acao_governo integer NOT NULL,
    nm_arquivo character varying(255) NOT NULL,
    caminho_arquivo character varying(255) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL
);


ALTER TABLE acao_governo_arquivo OWNER TO postgres;

--
-- Name: acao_governo_categoria; Type: TABLE; Schema: pmiacoes; Owner: postgres
--

CREATE TABLE acao_governo_categoria (
    ref_cod_categoria integer NOT NULL,
    ref_cod_acao_governo integer NOT NULL
);


ALTER TABLE acao_governo_categoria OWNER TO postgres;

--
-- Name: acao_governo_foto_cod_acao_governo_foto_seq; Type: SEQUENCE; Schema: pmiacoes; Owner: postgres
--

CREATE SEQUENCE acao_governo_foto_cod_acao_governo_foto_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE acao_governo_foto_cod_acao_governo_foto_seq OWNER TO postgres;

--
-- Name: acao_governo_foto; Type: TABLE; Schema: pmiacoes; Owner: postgres
--

CREATE TABLE acao_governo_foto (
    cod_acao_governo_foto integer DEFAULT nextval('acao_governo_foto_cod_acao_governo_foto_seq'::regclass) NOT NULL,
    ref_funcionario_cad integer NOT NULL,
    ref_cod_acao_governo integer NOT NULL,
    nm_foto character varying(255) NOT NULL,
    caminho character varying(255) NOT NULL,
    data_foto timestamp without time zone,
    data_cadastro timestamp without time zone NOT NULL
);


ALTER TABLE acao_governo_foto OWNER TO postgres;

--
-- Name: acao_governo_foto_portal; Type: TABLE; Schema: pmiacoes; Owner: postgres
--

CREATE TABLE acao_governo_foto_portal (
    ref_cod_acao_governo integer NOT NULL,
    ref_cod_foto_portal integer NOT NULL,
    ref_funcionario_cad integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL
);


ALTER TABLE acao_governo_foto_portal OWNER TO postgres;

--
-- Name: acao_governo_noticia; Type: TABLE; Schema: pmiacoes; Owner: postgres
--

CREATE TABLE acao_governo_noticia (
    ref_cod_acao_governo integer NOT NULL,
    ref_cod_not_portal integer NOT NULL,
    ref_funcionario_cad integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL
);


ALTER TABLE acao_governo_noticia OWNER TO postgres;

--
-- Name: acao_governo_setor; Type: TABLE; Schema: pmiacoes; Owner: postgres
--

CREATE TABLE acao_governo_setor (
    ref_cod_acao_governo integer NOT NULL,
    ref_cod_setor integer NOT NULL,
    ref_funcionario_cad integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL
);


ALTER TABLE acao_governo_setor OWNER TO postgres;

--
-- Name: categoria_cod_categoria_seq; Type: SEQUENCE; Schema: pmiacoes; Owner: postgres
--

CREATE SEQUENCE categoria_cod_categoria_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE categoria_cod_categoria_seq OWNER TO postgres;

--
-- Name: categoria; Type: TABLE; Schema: pmiacoes; Owner: postgres
--

CREATE TABLE categoria (
    cod_categoria integer DEFAULT nextval('categoria_cod_categoria_seq'::regclass) NOT NULL,
    ref_funcionario_exc integer,
    ref_funcionario_cad integer NOT NULL,
    nm_categoria character varying(255) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE categoria OWNER TO postgres;

--
-- Name: secretaria_responsavel; Type: TABLE; Schema: pmiacoes; Owner: postgres
--

CREATE TABLE secretaria_responsavel (
    ref_cod_setor integer NOT NULL,
    ref_cod_funcionario_cad integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL
);


ALTER TABLE secretaria_responsavel OWNER TO postgres;

SET search_path = pmicontrolesis, pg_catalog;

--
-- Name: acontecimento_cod_acontecimento_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: postgres
--

CREATE SEQUENCE acontecimento_cod_acontecimento_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE acontecimento_cod_acontecimento_seq OWNER TO postgres;

--
-- Name: acontecimento; Type: TABLE; Schema: pmicontrolesis; Owner: postgres
--

CREATE TABLE acontecimento (
    cod_acontecimento integer DEFAULT nextval('acontecimento_cod_acontecimento_seq'::regclass) NOT NULL,
    ref_cod_tipo_acontecimento integer NOT NULL,
    ref_cod_funcionario_cad integer NOT NULL,
    ref_cod_funcionario_exc integer,
    titulo character varying(255),
    descricao text,
    dt_inicio timestamp without time zone,
    dt_fim timestamp without time zone,
    hr_inicio time without time zone,
    hr_fim time without time zone,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint,
    local character varying,
    contato character varying,
    link character varying
);


ALTER TABLE acontecimento OWNER TO postgres;

--
-- Name: artigo_cod_artigo_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: postgres
--

CREATE SEQUENCE artigo_cod_artigo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE artigo_cod_artigo_seq OWNER TO postgres;

--
-- Name: artigo; Type: TABLE; Schema: pmicontrolesis; Owner: postgres
--

CREATE TABLE artigo (
    cod_artigo integer DEFAULT nextval('artigo_cod_artigo_seq'::regclass) NOT NULL,
    texto text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint
);


ALTER TABLE artigo OWNER TO postgres;

--
-- Name: foto_evento_cod_foto_evento_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: postgres
--

CREATE SEQUENCE foto_evento_cod_foto_evento_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE foto_evento_cod_foto_evento_seq OWNER TO postgres;

--
-- Name: foto_evento; Type: TABLE; Schema: pmicontrolesis; Owner: postgres
--

CREATE TABLE foto_evento (
    cod_foto_evento integer DEFAULT nextval('foto_evento_cod_foto_evento_seq'::regclass) NOT NULL,
    ref_ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL,
    data_foto timestamp without time zone,
    titulo character varying(255),
    descricao text,
    caminho character varying(255),
    altura integer,
    largura integer,
    nm_credito character varying(255)
);


ALTER TABLE foto_evento OWNER TO postgres;

--
-- Name: foto_vinc_cod_foto_vinc_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: postgres
--

CREATE SEQUENCE foto_vinc_cod_foto_vinc_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE foto_vinc_cod_foto_vinc_seq OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: foto_vinc; Type: TABLE; Schema: pmicontrolesis; Owner: postgres
--

CREATE TABLE foto_vinc (
    cod_foto_vinc integer DEFAULT nextval('foto_vinc_cod_foto_vinc_seq'::regclass) NOT NULL,
    ref_cod_acontecimento integer NOT NULL,
    ref_cod_foto_evento integer NOT NULL
);


ALTER TABLE foto_vinc OWNER TO postgres;

--
-- Name: itinerario_cod_itinerario_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: postgres
--

CREATE SEQUENCE itinerario_cod_itinerario_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE itinerario_cod_itinerario_seq OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: itinerario; Type: TABLE; Schema: pmicontrolesis; Owner: postgres
--

CREATE TABLE itinerario (
    cod_itinerario integer DEFAULT nextval('itinerario_cod_itinerario_seq'::regclass) NOT NULL,
    ref_funcionario_cad integer NOT NULL,
    ref_funcionario_exc integer,
    numero integer,
    itinerario text,
    retorno text,
    horarios text,
    descricao_horario text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    nome character varying(255) NOT NULL
);


ALTER TABLE itinerario OWNER TO postgres;

--
-- Name: menu_cod_menu_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: postgres
--

CREATE SEQUENCE menu_cod_menu_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE menu_cod_menu_seq OWNER TO postgres;

--
-- Name: menu; Type: TABLE; Schema: pmicontrolesis; Owner: postgres
--

CREATE TABLE menu (
    cod_menu integer DEFAULT nextval('menu_cod_menu_seq'::regclass) NOT NULL,
    ref_cod_menu_submenu integer,
    ref_cod_menu_pai integer,
    tt_menu character varying(255) NOT NULL,
    ord_menu integer NOT NULL,
    caminho character varying(255),
    alvo character varying(20),
    suprime_menu smallint DEFAULT 1,
    ref_cod_tutormenu integer,
    ref_cod_ico integer,
    tipo_menu integer
);


ALTER TABLE menu OWNER TO postgres;

--
-- Name: menu_portal_cod_menu_portal_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: postgres
--

CREATE SEQUENCE menu_portal_cod_menu_portal_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE menu_portal_cod_menu_portal_seq OWNER TO postgres;

--
-- Name: menu_portal; Type: TABLE; Schema: pmicontrolesis; Owner: postgres
--

CREATE TABLE menu_portal (
    cod_menu_portal integer DEFAULT nextval('menu_portal_cod_menu_portal_seq'::regclass) NOT NULL,
    ref_funcionario_cad integer NOT NULL,
    ref_funcionario_exc integer,
    nm_menu character varying(15) DEFAULT ''::character varying NOT NULL,
    title character varying(255),
    caminho character varying(255),
    cor character varying(255),
    posicao character(1) DEFAULT 'E'::bpchar NOT NULL,
    ordem double precision DEFAULT (0)::double precision NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    expansivel smallint
);


ALTER TABLE menu_portal OWNER TO postgres;

--
-- Name: portais_cod_portais_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: postgres
--

CREATE SEQUENCE portais_cod_portais_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE portais_cod_portais_seq OWNER TO postgres;

--
-- Name: portais; Type: TABLE; Schema: pmicontrolesis; Owner: postgres
--

CREATE TABLE portais (
    cod_portais integer DEFAULT nextval('portais_cod_portais_seq'::regclass) NOT NULL,
    ref_cod_funcionario_cad integer NOT NULL,
    ref_cod_funcionario_exc integer,
    url character varying(255),
    caminho character varying(255),
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint,
    title character varying(255),
    descricao text
);


ALTER TABLE portais OWNER TO postgres;

--
-- Name: servicos_cod_servicos_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: postgres
--

CREATE SEQUENCE servicos_cod_servicos_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE servicos_cod_servicos_seq OWNER TO postgres;

--
-- Name: servicos; Type: TABLE; Schema: pmicontrolesis; Owner: postgres
--

CREATE TABLE servicos (
    cod_servicos integer DEFAULT nextval('servicos_cod_servicos_seq'::regclass) NOT NULL,
    ref_cod_funcionario_cad integer NOT NULL,
    ref_cod_funcionario_exc integer,
    url character varying(255),
    caminho character varying(255),
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint,
    title character varying(255),
    descricao text
);


ALTER TABLE servicos OWNER TO postgres;

--
-- Name: sistema_cod_sistema_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: postgres
--

CREATE SEQUENCE sistema_cod_sistema_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE sistema_cod_sistema_seq OWNER TO postgres;

--
-- Name: sistema; Type: TABLE; Schema: pmicontrolesis; Owner: postgres
--

CREATE TABLE sistema (
    cod_sistema integer DEFAULT nextval('sistema_cod_sistema_seq'::regclass) NOT NULL,
    nm_sistema character varying(255) NOT NULL,
    ref_cod_funcionario_cad integer NOT NULL,
    ref_cod_funcionario_exc integer,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint
);


ALTER TABLE sistema OWNER TO postgres;

--
-- Name: submenu_portal_cod_submenu_portal_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: postgres
--

CREATE SEQUENCE submenu_portal_cod_submenu_portal_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE submenu_portal_cod_submenu_portal_seq OWNER TO postgres;

--
-- Name: submenu_portal; Type: TABLE; Schema: pmicontrolesis; Owner: postgres
--

CREATE TABLE submenu_portal (
    cod_submenu_portal integer DEFAULT nextval('submenu_portal_cod_submenu_portal_seq'::regclass) NOT NULL,
    ref_funcionario_cad integer NOT NULL,
    ref_funcionario_exc integer,
    ref_cod_menu_portal integer DEFAULT 0 NOT NULL,
    nm_submenu character varying(255) DEFAULT ''::character varying NOT NULL,
    arquivo character varying(255) DEFAULT ''::character varying NOT NULL,
    target character(1) DEFAULT 'S'::bpchar NOT NULL,
    title text,
    ordem double precision DEFAULT (0)::double precision NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE submenu_portal OWNER TO postgres;

--
-- Name: telefones_cod_telefones_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: postgres
--

CREATE SEQUENCE telefones_cod_telefones_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE telefones_cod_telefones_seq OWNER TO postgres;

--
-- Name: telefones; Type: TABLE; Schema: pmicontrolesis; Owner: postgres
--

CREATE TABLE telefones (
    cod_telefones integer DEFAULT nextval('telefones_cod_telefones_seq'::regclass) NOT NULL,
    ref_funcionario_cad integer NOT NULL,
    ref_funcionario_exc integer,
    nome character varying(255) NOT NULL,
    numero character varying,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE telefones OWNER TO postgres;

--
-- Name: tipo_acontecimento_cod_tipo_acontecimento_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: postgres
--

CREATE SEQUENCE tipo_acontecimento_cod_tipo_acontecimento_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE tipo_acontecimento_cod_tipo_acontecimento_seq OWNER TO postgres;

--
-- Name: tipo_acontecimento; Type: TABLE; Schema: pmicontrolesis; Owner: postgres
--

CREATE TABLE tipo_acontecimento (
    cod_tipo_acontecimento integer DEFAULT nextval('tipo_acontecimento_cod_tipo_acontecimento_seq'::regclass) NOT NULL,
    ref_cod_funcionario_cad integer NOT NULL,
    ref_cod_funcionario_exc integer,
    nm_tipo character varying(255),
    caminho character varying(255),
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint
);


ALTER TABLE tipo_acontecimento OWNER TO postgres;

--
-- Name: topo_portal_cod_topo_portal_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: postgres
--

CREATE SEQUENCE topo_portal_cod_topo_portal_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE topo_portal_cod_topo_portal_seq OWNER TO postgres;

--
-- Name: topo_portal; Type: TABLE; Schema: pmicontrolesis; Owner: postgres
--

CREATE TABLE topo_portal (
    cod_topo_portal integer DEFAULT nextval('topo_portal_cod_topo_portal_seq'::regclass) NOT NULL,
    ref_funcionario_cad integer NOT NULL,
    ref_funcionario_exc integer,
    ref_cod_menu_portal integer DEFAULT 0,
    caminho1 character varying(255),
    caminho2 character varying(255),
    caminho3 character varying(255),
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE topo_portal OWNER TO postgres;

--
-- Name: tutormenu_cod_tutormenu_seq; Type: SEQUENCE; Schema: pmicontrolesis; Owner: postgres
--

CREATE SEQUENCE tutormenu_cod_tutormenu_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE tutormenu_cod_tutormenu_seq OWNER TO postgres;

--
-- Name: tutormenu; Type: TABLE; Schema: pmicontrolesis; Owner: postgres
--

CREATE TABLE tutormenu (
    cod_tutormenu integer DEFAULT nextval('tutormenu_cod_tutormenu_seq'::regclass) NOT NULL,
    nm_tutormenu character varying(200) NOT NULL
);


ALTER TABLE tutormenu OWNER TO postgres;

SET search_path = pmidrh, pg_catalog;

--
-- Name: diaria_cod_diaria_seq; Type: SEQUENCE; Schema: pmidrh; Owner: postgres
--

CREATE SEQUENCE diaria_cod_diaria_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE diaria_cod_diaria_seq OWNER TO postgres;

--
-- Name: diaria; Type: TABLE; Schema: pmidrh; Owner: postgres
--

CREATE TABLE diaria (
    cod_diaria integer DEFAULT nextval('diaria_cod_diaria_seq'::regclass) NOT NULL,
    ref_funcionario_cadastro integer NOT NULL,
    ref_cod_diaria_grupo integer NOT NULL,
    ref_funcionario integer NOT NULL,
    conta_corrente integer,
    agencia integer,
    banco integer,
    dotacao_orcamentaria character varying(50),
    objetivo text,
    data_partida timestamp without time zone,
    data_chegada timestamp without time zone,
    estadual smallint,
    destino character varying(100),
    data_pedido timestamp without time zone,
    vl100 double precision,
    vl75 double precision,
    vl50 double precision,
    vl25 double precision,
    roteiro integer,
    ativo boolean DEFAULT true,
    ref_cod_setor integer,
    num_diaria numeric(6,0)
);


ALTER TABLE diaria OWNER TO postgres;

--
-- Name: diaria_grupo_cod_diaria_grupo_seq; Type: SEQUENCE; Schema: pmidrh; Owner: postgres
--

CREATE SEQUENCE diaria_grupo_cod_diaria_grupo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE diaria_grupo_cod_diaria_grupo_seq OWNER TO postgres;

--
-- Name: diaria_grupo; Type: TABLE; Schema: pmidrh; Owner: postgres
--

CREATE TABLE diaria_grupo (
    cod_diaria_grupo integer DEFAULT nextval('diaria_grupo_cod_diaria_grupo_seq'::regclass) NOT NULL,
    desc_grupo character varying(255) NOT NULL
);


ALTER TABLE diaria_grupo OWNER TO postgres;

--
-- Name: diaria_valores_cod_diaria_valores_seq; Type: SEQUENCE; Schema: pmidrh; Owner: postgres
--

CREATE SEQUENCE diaria_valores_cod_diaria_valores_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE diaria_valores_cod_diaria_valores_seq OWNER TO postgres;

--
-- Name: diaria_valores; Type: TABLE; Schema: pmidrh; Owner: postgres
--

CREATE TABLE diaria_valores (
    cod_diaria_valores integer DEFAULT nextval('diaria_valores_cod_diaria_valores_seq'::regclass) NOT NULL,
    ref_funcionario_cadastro integer NOT NULL,
    ref_cod_diaria_grupo integer NOT NULL,
    estadual smallint NOT NULL,
    p100 double precision,
    p75 double precision,
    p50 double precision,
    p25 double precision,
    data_vigencia timestamp without time zone NOT NULL
);


ALTER TABLE diaria_valores OWNER TO postgres;

--
-- Name: setor_cod_setor_seq; Type: SEQUENCE; Schema: pmidrh; Owner: postgres
--

CREATE SEQUENCE setor_cod_setor_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE setor_cod_setor_seq OWNER TO postgres;

--
-- Name: setor; Type: TABLE; Schema: pmidrh; Owner: postgres
--

CREATE TABLE setor (
    cod_setor integer DEFAULT nextval('setor_cod_setor_seq'::regclass) NOT NULL,
    ref_cod_pessoa_exc integer,
    ref_cod_pessoa_cad integer NOT NULL,
    ref_cod_setor integer,
    nm_setor character varying(255) NOT NULL,
    sgl_setor character varying(15) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    nivel smallint DEFAULT (1)::smallint NOT NULL,
    no_paco smallint DEFAULT 1,
    endereco text,
    tipo character(1),
    ref_idpes_resp integer
);


ALTER TABLE setor OWNER TO postgres;

SET search_path = pmieducar, pg_catalog;

--
-- Name: abandono_tipo_cod_abandono_tipo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE abandono_tipo_cod_abandono_tipo_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE abandono_tipo_cod_abandono_tipo_seq OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: abandono_tipo; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE abandono_tipo (
    cod_abandono_tipo integer DEFAULT nextval('abandono_tipo_cod_abandono_tipo_seq'::regclass) NOT NULL,
    ref_cod_instituicao integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer,
    nome character varying(255) NOT NULL,
    data_cadastro timestamp without time zone,
    data_exclusao timestamp without time zone,
    ativo integer
);


ALTER TABLE abandono_tipo OWNER TO postgres;

--
-- Name: acervo_cod_acervo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE acervo_cod_acervo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE acervo_cod_acervo_seq OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: acervo; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE acervo (
    cod_acervo integer DEFAULT nextval('acervo_cod_acervo_seq'::regclass) NOT NULL,
    ref_cod_exemplar_tipo integer NOT NULL,
    ref_cod_acervo integer,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_acervo_colecao integer,
    ref_cod_acervo_idioma integer NOT NULL,
    ref_cod_acervo_editora integer NOT NULL,
    titulo character varying(255) NOT NULL,
    sub_titulo character varying(255),
    cdu character varying(20),
    cutter character varying(20),
    volume integer,
    num_edicao integer,
    ano character varying(25),
    num_paginas integer,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_biblioteca integer NOT NULL,
    isbn character varying(255),
    cdd character varying(20),
    estante character varying(20),
    dimencao character varying(255),
    material_ilustrativo character varying(255),
    dimencao_ilustrativo character varying(255),
    local character varying(255),
    ref_cod_tipo_autor integer,
    tipo_autor character varying(255)
);


ALTER TABLE acervo OWNER TO postgres;

--
-- Name: acervo_acervo_assunto; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE acervo_acervo_assunto (
    ref_cod_acervo integer NOT NULL,
    ref_cod_acervo_assunto integer NOT NULL
);


ALTER TABLE acervo_acervo_assunto OWNER TO postgres;

--
-- Name: acervo_acervo_autor; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE acervo_acervo_autor (
    ref_cod_acervo_autor integer NOT NULL,
    ref_cod_acervo integer NOT NULL,
    principal smallint DEFAULT (0)::smallint NOT NULL
);


ALTER TABLE acervo_acervo_autor OWNER TO postgres;

--
-- Name: acervo_assunto_cod_acervo_assunto_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE acervo_assunto_cod_acervo_assunto_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE acervo_assunto_cod_acervo_assunto_seq OWNER TO postgres;

--
-- Name: acervo_assunto; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE acervo_assunto (
    cod_acervo_assunto integer DEFAULT nextval('acervo_assunto_cod_acervo_assunto_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_assunto character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_biblioteca integer
);


ALTER TABLE acervo_assunto OWNER TO postgres;

--
-- Name: acervo_autor_cod_acervo_autor_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE acervo_autor_cod_acervo_autor_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE acervo_autor_cod_acervo_autor_seq OWNER TO postgres;

--
-- Name: acervo_autor; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE acervo_autor (
    cod_acervo_autor integer DEFAULT nextval('acervo_autor_cod_acervo_autor_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_autor character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_biblioteca integer NOT NULL
);


ALTER TABLE acervo_autor OWNER TO postgres;

--
-- Name: acervo_colecao_cod_acervo_colecao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE acervo_colecao_cod_acervo_colecao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE acervo_colecao_cod_acervo_colecao_seq OWNER TO postgres;

--
-- Name: acervo_colecao; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE acervo_colecao (
    cod_acervo_colecao integer DEFAULT nextval('acervo_colecao_cod_acervo_colecao_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_colecao character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_biblioteca integer
);


ALTER TABLE acervo_colecao OWNER TO postgres;

--
-- Name: acervo_editora_cod_acervo_editora_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE acervo_editora_cod_acervo_editora_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE acervo_editora_cod_acervo_editora_seq OWNER TO postgres;

--
-- Name: acervo_editora; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE acervo_editora (
    cod_acervo_editora integer DEFAULT nextval('acervo_editora_cod_acervo_editora_seq'::regclass) NOT NULL,
    ref_usuario_cad integer NOT NULL,
    ref_usuario_exc integer,
    ref_idtlog character varying(20),
    ref_sigla_uf character(2),
    nm_editora character varying(255) NOT NULL,
    cep numeric(8,0),
    cidade character varying(60),
    bairro character varying(60),
    logradouro character varying(255),
    numero numeric(6,0),
    telefone integer,
    ddd_telefone numeric(3,0),
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_biblioteca integer
);


ALTER TABLE acervo_editora OWNER TO postgres;

--
-- Name: acervo_idioma_cod_acervo_idioma_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE acervo_idioma_cod_acervo_idioma_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE acervo_idioma_cod_acervo_idioma_seq OWNER TO postgres;

--
-- Name: acervo_idioma; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE acervo_idioma (
    cod_acervo_idioma integer DEFAULT nextval('acervo_idioma_cod_acervo_idioma_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_idioma character varying(255) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_biblioteca integer
);


ALTER TABLE acervo_idioma OWNER TO postgres;

--
-- Name: aluno_cod_aluno_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE aluno_cod_aluno_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE aluno_cod_aluno_seq OWNER TO postgres;

--
-- Name: aluno; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE aluno (
    cod_aluno integer DEFAULT nextval('aluno_cod_aluno_seq'::regclass) NOT NULL,
    ref_cod_religiao integer,
    ref_usuario_exc integer,
    ref_usuario_cad integer,
    ref_idpes integer,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    caminho_foto character varying(255),
    analfabeto smallint DEFAULT (0)::smallint,
    nm_pai character varying(255),
    nm_mae character varying(255),
    tipo_responsavel character(1),
    aluno_estado_id character varying(25),
    recurso_prova_inep_aux_ledor smallint,
    recurso_prova_inep_aux_transcricao smallint,
    recurso_prova_inep_guia_interprete smallint,
    recurso_prova_inep_interprete_libras smallint,
    recurso_prova_inep_leitura_labial smallint,
    recurso_prova_inep_prova_ampliada_16 smallint,
    recurso_prova_inep_prova_ampliada_20 smallint,
    recurso_prova_inep_prova_ampliada_24 smallint,
    recurso_prova_inep_prova_braille smallint,
    justificativa_falta_documentacao smallint,
    url_laudo_medico json,
    codigo_sistema character varying(30),
    veiculo_transporte_escolar smallint,
    autorizado_um character varying(150),
    parentesco_um character varying(150),
    autorizado_dois character varying(150),
    parentesco_dois character varying(150),
    autorizado_tres character varying(150),
    parentesco_tres character varying(150),
    autorizado_quatro character varying(150),
    parentesco_quatro character varying(150),
    autorizado_cinco character varying(150),
    parentesco_cinco character varying(150),
    url_documento json,
    recebe_escolarizacao_em_outro_espaco smallint
);


ALTER TABLE aluno OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: aluno_aluno_beneficio; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE aluno_aluno_beneficio (
    aluno_id integer NOT NULL,
    aluno_beneficio_id integer NOT NULL
);


ALTER TABLE aluno_aluno_beneficio OWNER TO postgres;

--
-- Name: aluno_beneficio_cod_aluno_beneficio_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE aluno_beneficio_cod_aluno_beneficio_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE aluno_beneficio_cod_aluno_beneficio_seq OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: aluno_beneficio; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE aluno_beneficio (
    cod_aluno_beneficio integer DEFAULT nextval('aluno_beneficio_cod_aluno_beneficio_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_beneficio character varying(255) NOT NULL,
    desc_beneficio text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE aluno_beneficio OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: aluno_historico_altura_peso; Type: TABLE; Schema: pmieducar; Owner: ieducar
--

CREATE TABLE aluno_historico_altura_peso (
    ref_cod_aluno integer NOT NULL,
    data_historico date NOT NULL,
    altura numeric(12,2) NOT NULL,
    peso numeric(12,2) NOT NULL
);


ALTER TABLE aluno_historico_altura_peso OWNER TO ieducar;

SET default_with_oids = true;

--
-- Name: ano_letivo_modulo; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE ano_letivo_modulo (
    ref_ano integer NOT NULL,
    ref_ref_cod_escola integer NOT NULL,
    sequencial integer NOT NULL,
    ref_cod_modulo integer NOT NULL,
    data_inicio date NOT NULL,
    data_fim date NOT NULL,
    dias_letivos numeric(5,0)
);


ALTER TABLE ano_letivo_modulo OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: auditoria_falta_componente_dispensa; Type: TABLE; Schema: pmieducar; Owner: ieducar
--

CREATE TABLE auditoria_falta_componente_dispensa (
    id integer NOT NULL,
    ref_cod_matricula integer NOT NULL,
    ref_cod_componente_curricular integer NOT NULL,
    quantidade integer NOT NULL,
    etapa integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL
);


ALTER TABLE auditoria_falta_componente_dispensa OWNER TO ieducar;

--
-- Name: auditoria_falta_componente_dispensa_id_seq; Type: SEQUENCE; Schema: pmieducar; Owner: ieducar
--

CREATE SEQUENCE auditoria_falta_componente_dispensa_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE auditoria_falta_componente_dispensa_id_seq OWNER TO ieducar;

--
-- Name: auditoria_falta_componente_dispensa_id_seq; Type: SEQUENCE OWNED BY; Schema: pmieducar; Owner: ieducar
--

ALTER SEQUENCE auditoria_falta_componente_dispensa_id_seq OWNED BY auditoria_falta_componente_dispensa.id;


--
-- Name: auditoria_nota_dispensa; Type: TABLE; Schema: pmieducar; Owner: ieducar
--

CREATE TABLE auditoria_nota_dispensa (
    id integer NOT NULL,
    ref_cod_matricula integer NOT NULL,
    ref_cod_componente_curricular integer NOT NULL,
    nota numeric(8,4) NOT NULL,
    etapa integer NOT NULL,
    nota_recuperacao character varying(10),
    nota_recuperacao_especifica character varying(10),
    data_cadastro timestamp without time zone NOT NULL
);


ALTER TABLE auditoria_nota_dispensa OWNER TO ieducar;

--
-- Name: auditoria_nota_dispensa_id_seq; Type: SEQUENCE; Schema: pmieducar; Owner: ieducar
--

CREATE SEQUENCE auditoria_nota_dispensa_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE auditoria_nota_dispensa_id_seq OWNER TO ieducar;

--
-- Name: auditoria_nota_dispensa_id_seq; Type: SEQUENCE OWNED BY; Schema: pmieducar; Owner: ieducar
--

ALTER SEQUENCE auditoria_nota_dispensa_id_seq OWNED BY auditoria_nota_dispensa.id;


SET default_with_oids = true;

--
-- Name: avaliacao_desempenho; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE avaliacao_desempenho (
    sequencial integer NOT NULL,
    ref_cod_servidor integer NOT NULL,
    ref_ref_cod_instituicao integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    descricao text NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    titulo_avaliacao character varying(255) NOT NULL
);


ALTER TABLE avaliacao_desempenho OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: backup; Type: TABLE; Schema: pmieducar; Owner: ieducar
--

CREATE TABLE backup (
    id integer NOT NULL,
    caminho character varying(255) NOT NULL,
    data_backup timestamp without time zone
);


ALTER TABLE backup OWNER TO ieducar;

--
-- Name: backup_id_seq; Type: SEQUENCE; Schema: pmieducar; Owner: ieducar
--

CREATE SEQUENCE backup_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE backup_id_seq OWNER TO ieducar;

--
-- Name: backup_id_seq; Type: SEQUENCE OWNED BY; Schema: pmieducar; Owner: ieducar
--

ALTER SEQUENCE backup_id_seq OWNED BY backup.id;


--
-- Name: biblioteca_cod_biblioteca_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE biblioteca_cod_biblioteca_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE biblioteca_cod_biblioteca_seq OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: biblioteca; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE biblioteca (
    cod_biblioteca integer DEFAULT nextval('biblioteca_cod_biblioteca_seq'::regclass) NOT NULL,
    ref_cod_instituicao integer,
    ref_cod_escola integer,
    nm_biblioteca character varying(255) NOT NULL,
    valor_multa double precision,
    max_emprestimo integer,
    valor_maximo_multa double precision,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    requisita_senha smallint DEFAULT (0)::smallint NOT NULL,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    dias_espera numeric(2,0),
    tombo_automatico boolean DEFAULT true,
    bloqueia_emprestimo_em_atraso boolean
);


ALTER TABLE biblioteca OWNER TO postgres;

--
-- Name: biblioteca_dia; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE biblioteca_dia (
    ref_cod_biblioteca integer NOT NULL,
    dia numeric(1,0) NOT NULL
);


ALTER TABLE biblioteca_dia OWNER TO postgres;

--
-- Name: biblioteca_feriados_cod_feriado_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE biblioteca_feriados_cod_feriado_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE biblioteca_feriados_cod_feriado_seq OWNER TO postgres;

--
-- Name: biblioteca_feriados; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE biblioteca_feriados (
    cod_feriado integer DEFAULT nextval('biblioteca_feriados_cod_feriado_seq'::regclass) NOT NULL,
    ref_cod_biblioteca integer NOT NULL,
    nm_feriado character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    data_feriado date NOT NULL
);


ALTER TABLE biblioteca_feriados OWNER TO postgres;

--
-- Name: biblioteca_usuario; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE biblioteca_usuario (
    ref_cod_biblioteca integer NOT NULL,
    ref_cod_usuario integer NOT NULL
);


ALTER TABLE biblioteca_usuario OWNER TO postgres;

--
-- Name: bloqueio_ano_letivo; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE bloqueio_ano_letivo (
    ref_cod_instituicao integer NOT NULL,
    ref_ano integer NOT NULL,
    data_inicio date NOT NULL,
    data_fim date NOT NULL
);


ALTER TABLE bloqueio_ano_letivo OWNER TO postgres;

SET search_path = public, pg_catalog;

--
-- Name: bloqueio_lancamento_faltas_notas_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE bloqueio_lancamento_faltas_notas_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE bloqueio_lancamento_faltas_notas_seq OWNER TO postgres;

SET search_path = pmieducar, pg_catalog;

SET default_with_oids = false;

--
-- Name: bloqueio_lancamento_faltas_notas; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE bloqueio_lancamento_faltas_notas (
    cod_bloqueio integer DEFAULT nextval('public.bloqueio_lancamento_faltas_notas_seq'::regclass) NOT NULL,
    ano integer NOT NULL,
    ref_cod_escola integer NOT NULL,
    etapa integer NOT NULL,
    data_inicio date NOT NULL,
    data_fim date NOT NULL
);


ALTER TABLE bloqueio_lancamento_faltas_notas OWNER TO postgres;

--
-- Name: calendario_ano_letivo_cod_calendario_ano_letivo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE calendario_ano_letivo_cod_calendario_ano_letivo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE calendario_ano_letivo_cod_calendario_ano_letivo_seq OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: calendario_ano_letivo; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE calendario_ano_letivo (
    cod_calendario_ano_letivo integer DEFAULT nextval('calendario_ano_letivo_cod_calendario_ano_letivo_seq'::regclass) NOT NULL,
    ref_cod_escola integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ano integer NOT NULL,
    data_cadastra timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE calendario_ano_letivo OWNER TO postgres;

--
-- Name: calendario_anotacao_cod_calendario_anotacao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE calendario_anotacao_cod_calendario_anotacao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE calendario_anotacao_cod_calendario_anotacao_seq OWNER TO postgres;

--
-- Name: calendario_anotacao; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE calendario_anotacao (
    cod_calendario_anotacao integer DEFAULT nextval('calendario_anotacao_cod_calendario_anotacao_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_anotacao character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint NOT NULL
);


ALTER TABLE calendario_anotacao OWNER TO postgres;

--
-- Name: calendario_dia; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE calendario_dia (
    ref_cod_calendario_ano_letivo integer NOT NULL,
    mes integer NOT NULL,
    dia integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_calendario_dia_motivo integer,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    descricao text
);


ALTER TABLE calendario_dia OWNER TO postgres;

--
-- Name: calendario_dia_anotacao; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE calendario_dia_anotacao (
    ref_dia integer NOT NULL,
    ref_mes integer NOT NULL,
    ref_ref_cod_calendario_ano_letivo integer NOT NULL,
    ref_cod_calendario_anotacao integer NOT NULL
);


ALTER TABLE calendario_dia_anotacao OWNER TO postgres;

--
-- Name: calendario_dia_motivo_cod_calendario_dia_motivo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE calendario_dia_motivo_cod_calendario_dia_motivo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE calendario_dia_motivo_cod_calendario_dia_motivo_seq OWNER TO postgres;

--
-- Name: calendario_dia_motivo; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE calendario_dia_motivo (
    cod_calendario_dia_motivo integer DEFAULT nextval('calendario_dia_motivo_cod_calendario_dia_motivo_seq'::regclass) NOT NULL,
    ref_cod_escola integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    sigla character varying(15) NOT NULL,
    descricao text,
    tipo character(1) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    nm_motivo character varying(255) NOT NULL
);


ALTER TABLE calendario_dia_motivo OWNER TO postgres;

SET default_with_oids = false;


--
-- Name: candidato_reserva_vaga_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE candidato_reserva_vaga_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE candidato_reserva_vaga_seq OWNER TO postgres;

--
-- Name: candidato_reserva_vaga; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE candidato_reserva_vaga (
    cod_candidato_reserva_vaga integer DEFAULT nextval('candidato_reserva_vaga_seq'::regclass) NOT NULL,
    ano_letivo integer NOT NULL,
    data_solicitacao date NOT NULL,
    ref_cod_aluno integer NOT NULL,
    ref_cod_serie integer NOT NULL,
    ref_cod_turno integer,
    ref_cod_pessoa_cad integer NOT NULL,
    data_cad timestamp without time zone DEFAULT now() NOT NULL,
    data_update timestamp without time zone DEFAULT now() NOT NULL,
    ref_cod_matricula integer,
    situacao character(1),
    data_situacao date,
    motivo character varying(255),
    ref_cod_escola integer,
    quantidade_membros smallint,
    mae_fez_pre_natal boolean DEFAULT false,
    membros_trabalham smallint,
    hora_solicitacao time without time zone
);


ALTER TABLE candidato_reserva_vaga OWNER TO postgres;

--
-- Name: categoria_nivel_cod_categoria_nivel_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE categoria_nivel_cod_categoria_nivel_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE categoria_nivel_cod_categoria_nivel_seq OWNER TO postgres;

--
-- Name: categoria_nivel; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE categoria_nivel (
    cod_categoria_nivel integer DEFAULT nextval('categoria_nivel_cod_categoria_nivel_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_categoria_nivel character varying(100) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo boolean DEFAULT true NOT NULL
);


ALTER TABLE categoria_nivel OWNER TO postgres;

--
-- Name: categoria_obra; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE categoria_obra (
    id integer NOT NULL,
    descricao character varying(100) NOT NULL,
    observacoes character varying(300)
);


ALTER TABLE categoria_obra OWNER TO postgres;

--
-- Name: categoria_obra_id_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE categoria_obra_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE categoria_obra_id_seq OWNER TO postgres;

--
-- Name: categoria_obra_id_seq; Type: SEQUENCE OWNED BY; Schema: pmieducar; Owner: postgres
--

ALTER SEQUENCE categoria_obra_id_seq OWNED BY categoria_obra.id;


--
-- Name: cliente_cod_cliente_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE cliente_cod_cliente_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE cliente_cod_cliente_seq OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: cliente; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE cliente (
    cod_cliente integer DEFAULT nextval('cliente_cod_cliente_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_idpes integer NOT NULL,
    login integer,
    senha character varying(255),
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    observacoes text
);


ALTER TABLE cliente OWNER TO postgres;

--
-- Name: cliente_suspensao; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE cliente_suspensao (
    sequencial integer NOT NULL,
    ref_cod_cliente integer NOT NULL,
    ref_cod_motivo_suspensao integer NOT NULL,
    ref_usuario_libera integer,
    ref_usuario_suspende integer NOT NULL,
    dias integer NOT NULL,
    data_suspensao timestamp without time zone NOT NULL,
    data_liberacao timestamp without time zone
);


ALTER TABLE cliente_suspensao OWNER TO postgres;

--
-- Name: cliente_tipo_cod_cliente_tipo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE cliente_tipo_cod_cliente_tipo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE cliente_tipo_cod_cliente_tipo_seq OWNER TO postgres;

--
-- Name: cliente_tipo; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE cliente_tipo (
    cod_cliente_tipo integer DEFAULT nextval('cliente_tipo_cod_cliente_tipo_seq'::regclass) NOT NULL,
    ref_cod_biblioteca integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_tipo character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE cliente_tipo OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: cliente_tipo_cliente; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE cliente_tipo_cliente (
    ref_cod_cliente_tipo integer NOT NULL,
    ref_cod_cliente integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ref_usuario_cad integer NOT NULL,
    ref_usuario_exc integer,
    ativo smallint DEFAULT (1)::smallint,
    ref_cod_biblioteca integer
);


ALTER TABLE cliente_tipo_cliente OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: cliente_tipo_exemplar_tipo; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE cliente_tipo_exemplar_tipo (
    ref_cod_cliente_tipo integer NOT NULL,
    ref_cod_exemplar_tipo integer NOT NULL,
    dias_emprestimo numeric(3,0)
);


ALTER TABLE cliente_tipo_exemplar_tipo OWNER TO postgres;

--
-- Name: coffebreak_tipo_cod_coffebreak_tipo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE coffebreak_tipo_cod_coffebreak_tipo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE coffebreak_tipo_cod_coffebreak_tipo_seq OWNER TO postgres;

--
-- Name: coffebreak_tipo; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE coffebreak_tipo (
    cod_coffebreak_tipo integer DEFAULT nextval('coffebreak_tipo_cod_coffebreak_tipo_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_tipo character varying(255) NOT NULL,
    desc_tipo text,
    custo_unitario double precision NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE coffebreak_tipo OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: configuracoes_gerais; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE configuracoes_gerais (
    ref_cod_instituicao integer NOT NULL,
    permite_relacionamento_posvendas integer DEFAULT 1 NOT NULL,
    url_novo_educacao character varying(100)
);


ALTER TABLE configuracoes_gerais OWNER TO postgres;

--
-- Name: curso_cod_curso_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE curso_cod_curso_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE curso_cod_curso_seq OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: curso; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE curso (
    cod_curso integer DEFAULT nextval('curso_cod_curso_seq'::regclass) NOT NULL,
    ref_usuario_cad integer NOT NULL,
    ref_cod_tipo_regime integer,
    ref_cod_nivel_ensino integer NOT NULL,
    ref_cod_tipo_ensino integer NOT NULL,
    nm_curso character varying(255) NOT NULL,
    sgl_curso character varying(15) NOT NULL,
    qtd_etapas smallint NOT NULL,
    carga_horaria double precision NOT NULL,
    ato_poder_publico character varying(255),
    objetivo_curso text,
    publico_alvo text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_usuario_exc integer,
    ref_cod_instituicao integer NOT NULL,
    padrao_ano_escolar smallint DEFAULT (0)::smallint NOT NULL,
    hora_falta double precision DEFAULT 0.00 NOT NULL,
    multi_seriado integer,
    modalidade_curso integer
);


ALTER TABLE curso OWNER TO postgres;

--
-- Name: disciplina_cod_disciplina_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE disciplina_cod_disciplina_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE disciplina_cod_disciplina_seq OWNER TO postgres;

--
-- Name: disciplina; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE disciplina (
    cod_disciplina integer DEFAULT nextval('disciplina_cod_disciplina_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    desc_disciplina text,
    desc_resumida text,
    abreviatura character varying(15) NOT NULL,
    carga_horaria integer NOT NULL,
    apura_falta smallint DEFAULT (0)::smallint NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    nm_disciplina character varying(255) NOT NULL,
    ref_cod_curso integer
);


ALTER TABLE disciplina OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: disciplina_dependencia; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE disciplina_dependencia (
    ref_cod_matricula integer NOT NULL,
    ref_cod_disciplina integer NOT NULL,
    ref_cod_escola integer NOT NULL,
    ref_cod_serie integer NOT NULL,
    observacao text,
    cod_disciplina_dependencia integer NOT NULL
);


ALTER TABLE disciplina_dependencia OWNER TO postgres;

--
-- Name: disciplina_serie; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE disciplina_serie (
    ref_cod_disciplina integer NOT NULL,
    ref_cod_serie integer NOT NULL,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE disciplina_serie OWNER TO postgres;

--
-- Name: disciplina_topico_cod_disciplina_topico_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE disciplina_topico_cod_disciplina_topico_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE disciplina_topico_cod_disciplina_topico_seq OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: disciplina_topico; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE disciplina_topico (
    cod_disciplina_topico integer DEFAULT nextval('disciplina_topico_cod_disciplina_topico_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_topico character varying(255) NOT NULL,
    desc_topico text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE disciplina_topico OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: dispensa_disciplina; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE dispensa_disciplina (
    ref_cod_matricula integer NOT NULL,
    ref_cod_disciplina integer NOT NULL,
    ref_cod_escola integer NOT NULL,
    ref_cod_serie integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_tipo_dispensa integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    observacao text,
    cod_dispensa integer NOT NULL
);


ALTER TABLE dispensa_disciplina OWNER TO postgres;

--
-- Name: dispensa_etapa; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE dispensa_etapa (
    ref_cod_dispensa integer,
    etapa integer
);


ALTER TABLE dispensa_etapa OWNER TO postgres;

--
-- Name: distribuicao_uniforme_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE distribuicao_uniforme_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE distribuicao_uniforme_seq OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: distribuicao_uniforme; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE distribuicao_uniforme (
    cod_distribuicao_uniforme integer DEFAULT nextval('distribuicao_uniforme_seq'::regclass) NOT NULL,
    ref_cod_aluno integer NOT NULL,
    ano integer NOT NULL,
    kit_completo boolean,
    agasalho_qtd smallint,
    camiseta_curta_qtd smallint,
    camiseta_longa_qtd smallint,
    meias_qtd smallint,
    bermudas_tectels_qtd smallint,
    bermudas_coton_qtd smallint,
    tenis_qtd smallint,
    data date,
    agasalho_tm character varying(20),
    camiseta_curta_tm character varying(20),
    camiseta_longa_tm character varying(20),
    meias_tm character varying(20),
    bermudas_tectels_tm character varying(20),
    bermudas_coton_tm character varying(20),
    tenis_tm character varying(20),
    ref_cod_escola integer
);


ALTER TABLE distribuicao_uniforme OWNER TO postgres;

--
-- Name: escola_cod_escola_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE escola_cod_escola_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE escola_cod_escola_seq OWNER TO postgres;

--
-- Name: escola; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE escola (
    cod_escola integer DEFAULT nextval('escola_cod_escola_seq'::regclass) NOT NULL,
    ref_usuario_cad integer NOT NULL,
    ref_usuario_exc integer,
    ref_cod_instituicao integer NOT NULL,
    ref_cod_escola_localizacao integer NOT NULL,
    ref_cod_escola_rede_ensino integer NOT NULL,
    ref_idpes integer,
    sigla character varying(20) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    bloquear_lancamento_diario_anos_letivos_encerrados integer,
    situacao_funcionamento integer DEFAULT 1,
    dependencia_administrativa integer DEFAULT 3,
    regulamentacao integer DEFAULT 1,
    longitude character varying(20),
    latitude character varying(20),
    acesso integer,
    ref_idpes_gestor integer,
    cargo_gestor integer,
    local_funcionamento integer,
    condicao integer DEFAULT 1,
    codigo_inep_escola_compartilhada integer,
    decreto_criacao character varying(50),
    area_terreno_total character varying(10),
    area_construida character varying(10),
    area_disponivel character varying(10),
    num_pavimentos integer,
    tipo_piso integer,
    medidor_energia integer,
    agua_consumida integer,
    agua_rede_publica integer,
    agua_poco_artesiano integer,
    agua_cacimba_cisterna_poco integer,
    agua_fonte_rio integer,
    agua_inexistente integer,
    energia_rede_publica integer,
    energia_gerador integer,
    energia_outros integer,
    energia_inexistente integer,
    esgoto_rede_publica integer,
    esgoto_fossa integer,
    esgoto_inexistente integer,
    lixo_coleta_periodica integer,
    lixo_queima integer,
    lixo_joga_outra_area integer,
    lixo_recicla integer,
    lixo_enterra integer,
    lixo_outros integer,
    dependencia_sala_diretoria integer,
    dependencia_sala_professores integer,
    dependencia_sala_secretaria integer,
    dependencia_laboratorio_informatica integer,
    dependencia_laboratorio_ciencias integer,
    dependencia_sala_aee integer,
    dependencia_quadra_coberta integer,
    dependencia_quadra_descoberta integer,
    dependencia_cozinha integer,
    dependencia_biblioteca integer,
    dependencia_sala_leitura integer,
    dependencia_parque_infantil integer,
    dependencia_bercario integer,
    dependencia_banheiro_fora integer,
    dependencia_banheiro_dentro integer,
    dependencia_banheiro_infantil integer,
    dependencia_banheiro_deficiente integer,
    dependencia_banheiro_chuveiro integer,
    dependencia_refeitorio integer,
    dependencia_dispensa integer,
    dependencia_aumoxarifado integer,
    dependencia_auditorio integer,
    dependencia_patio_coberto integer,
    dependencia_patio_descoberto integer,
    dependencia_alojamento_aluno integer,
    dependencia_alojamento_professor integer,
    dependencia_area_verde integer,
    dependencia_lavanderia integer,
    dependencia_unidade_climatizada integer,
    dependencia_quantidade_ambiente_climatizado integer,
    dependencia_nenhuma_relacionada integer,
    dependencia_numero_salas_existente integer,
    dependencia_numero_salas_utilizadas integer,
    porte_quadra_descoberta integer,
    porte_quadra_coberta integer,
    tipo_cobertura_patio integer,
    total_funcionario integer,
    atendimento_aee integer DEFAULT 0,
    atividade_complementar integer DEFAULT 0,
    fundamental_ciclo integer,
    localizacao_diferenciada integer DEFAULT 7,
    didatico_nao_utiliza integer,
    didatico_quilombola integer,
    didatico_indigena integer,
    educacao_indigena integer,
    lingua_ministrada integer,
    espaco_brasil_aprendizado integer,
    abre_final_semana integer,
    codigo_lingua_indigena integer,
    proposta_pedagogica integer,
    televisoes smallint,
    videocassetes smallint,
    dvds smallint,
    antenas_parabolicas smallint,
    copiadoras smallint,
    retroprojetores smallint,
    impressoras smallint,
    aparelhos_de_som smallint,
    projetores_digitais smallint,
    faxs smallint,
    maquinas_fotograficas smallint,
    computadores smallint,
    computadores_administrativo smallint,
    computadores_alunos smallint,
    acesso_internet smallint,
    banda_larga smallint,
    ato_criacao character varying(255),
    dependencia_vias_deficiente smallint,
    utiliza_regra_diferenciada boolean,
    orgao_regional integer,
    ato_autorizativo character varying(255),
    ref_idpes_secretario_escolar integer,
    impressoras_multifuncionais smallint,
    categoria_escola_privada integer,
    conveniada_com_poder_publico integer,
    cnpj_mantenedora_principal numeric(14,0),
    mantenedora_escola_privada integer[]
);


ALTER TABLE escola OWNER TO postgres;

--
-- Name: escola_ano_letivo; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE escola_ano_letivo (
    ref_cod_escola integer NOT NULL,
    ano integer NOT NULL,
    ref_usuario_cad integer NOT NULL,
    ref_usuario_exc integer,
    andamento smallint DEFAULT (0)::smallint NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    turmas_por_ano smallint
);


ALTER TABLE escola_ano_letivo OWNER TO postgres;

--
-- Name: escola_complemento; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE escola_complemento (
    ref_cod_escola integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    cep numeric(8,0) NOT NULL,
    numero numeric(6,0),
    complemento character varying(50),
    email character varying(50),
    nm_escola character varying(255) NOT NULL,
    municipio character varying(60) NOT NULL,
    bairro character varying(40) NOT NULL,
    logradouro character varying(150) NOT NULL,
    ddd_telefone numeric(2,0),
    telefone numeric(11,0),
    ddd_fax numeric(2,0),
    fax numeric(11,0),
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE escola_complemento OWNER TO postgres;

--
-- Name: escola_curso; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE escola_curso (
    ref_cod_escola integer NOT NULL,
    ref_cod_curso integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    autorizacao character varying(255)
);


ALTER TABLE escola_curso OWNER TO postgres;

--
-- Name: escola_localizacao_cod_escola_localizacao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE escola_localizacao_cod_escola_localizacao_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE escola_localizacao_cod_escola_localizacao_seq OWNER TO postgres;

--
-- Name: escola_localizacao; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE escola_localizacao (
    cod_escola_localizacao integer DEFAULT nextval('escola_localizacao_cod_escola_localizacao_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_localizacao character varying(255) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_instituicao integer NOT NULL
);


ALTER TABLE escola_localizacao OWNER TO postgres;

--
-- Name: escola_rede_ensino_cod_escola_rede_ensino_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE escola_rede_ensino_cod_escola_rede_ensino_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE escola_rede_ensino_cod_escola_rede_ensino_seq OWNER TO postgres;

--
-- Name: escola_rede_ensino; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE escola_rede_ensino (
    cod_escola_rede_ensino integer DEFAULT nextval('escola_rede_ensino_cod_escola_rede_ensino_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_rede character varying(255) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_instituicao integer NOT NULL
);


ALTER TABLE escola_rede_ensino OWNER TO postgres;

--
-- Name: escola_serie; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE escola_serie (
    ref_cod_escola integer NOT NULL,
    ref_cod_serie integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    hora_inicial time without time zone,
    hora_final time without time zone,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    hora_inicio_intervalo time without time zone,
    hora_fim_intervalo time without time zone,
    bloquear_enturmacao_sem_vagas integer,
    bloquear_cadastro_turma_para_serie_com_vagas integer
);


ALTER TABLE escola_serie OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: escola_serie_disciplina; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE escola_serie_disciplina (
    ref_ref_cod_serie integer NOT NULL,
    ref_ref_cod_escola integer NOT NULL,
    ref_cod_disciplina integer NOT NULL,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    carga_horaria numeric(7,3),
    etapas_especificas smallint,
    etapas_utilizadas character varying
);


ALTER TABLE escola_serie_disciplina OWNER TO postgres;

--
-- Name: escola_usuario; Type: TABLE; Schema: pmieducar; Owner: ieducar
--

CREATE TABLE escola_usuario (
    id integer NOT NULL,
    ref_cod_usuario integer NOT NULL,
    ref_cod_escola integer NOT NULL,
    escola_atual integer
);


ALTER TABLE escola_usuario OWNER TO ieducar;

--
-- Name: escola_usuario_id_seq; Type: SEQUENCE; Schema: pmieducar; Owner: ieducar
--

CREATE SEQUENCE escola_usuario_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE escola_usuario_id_seq OWNER TO ieducar;

--
-- Name: escola_usuario_id_seq; Type: SEQUENCE OWNED BY; Schema: pmieducar; Owner: ieducar
--

ALTER SEQUENCE escola_usuario_id_seq OWNED BY escola_usuario.id;


--
-- Name: exemplar_cod_exemplar_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE exemplar_cod_exemplar_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE exemplar_cod_exemplar_seq OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: exemplar; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE exemplar (
    cod_exemplar integer DEFAULT nextval('exemplar_cod_exemplar_seq'::regclass) NOT NULL,
    ref_cod_fonte integer NOT NULL,
    ref_cod_motivo_baixa integer,
    ref_cod_acervo integer NOT NULL,
    ref_cod_situacao integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    permite_emprestimo smallint DEFAULT (1)::smallint NOT NULL,
    preco double precision NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    data_aquisicao timestamp without time zone,
    tombo integer,
    sequencial integer,
    data_baixa_exemplar date
);


ALTER TABLE exemplar OWNER TO postgres;

--
-- Name: exemplar_emprestimo_cod_emprestimo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE exemplar_emprestimo_cod_emprestimo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE exemplar_emprestimo_cod_emprestimo_seq OWNER TO postgres;

--
-- Name: exemplar_emprestimo; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE exemplar_emprestimo (
    cod_emprestimo integer DEFAULT nextval('exemplar_emprestimo_cod_emprestimo_seq'::regclass) NOT NULL,
    ref_usuario_devolucao integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_cliente integer NOT NULL,
    ref_cod_exemplar integer NOT NULL,
    data_retirada timestamp without time zone NOT NULL,
    data_devolucao timestamp without time zone,
    valor_multa double precision
);


ALTER TABLE exemplar_emprestimo OWNER TO postgres;

--
-- Name: exemplar_tipo_cod_exemplar_tipo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE exemplar_tipo_cod_exemplar_tipo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE exemplar_tipo_cod_exemplar_tipo_seq OWNER TO postgres;

--
-- Name: exemplar_tipo; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE exemplar_tipo (
    cod_exemplar_tipo integer DEFAULT nextval('exemplar_tipo_cod_exemplar_tipo_seq'::regclass) NOT NULL,
    ref_cod_biblioteca integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_tipo character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE exemplar_tipo OWNER TO postgres;

--
-- Name: falta_aluno_cod_falta_aluno_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE falta_aluno_cod_falta_aluno_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE falta_aluno_cod_falta_aluno_seq OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: falta_aluno; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE falta_aluno (
    cod_falta_aluno integer DEFAULT nextval('falta_aluno_cod_falta_aluno_seq'::regclass) NOT NULL,
    ref_cod_disciplina integer,
    ref_cod_escola integer,
    ref_cod_serie integer,
    ref_cod_matricula integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    faltas integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    modulo smallint NOT NULL,
    ref_cod_curso_disciplina integer
);


ALTER TABLE falta_aluno OWNER TO postgres;

--
-- Name: falta_atraso_cod_falta_atraso_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE falta_atraso_cod_falta_atraso_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE falta_atraso_cod_falta_atraso_seq OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: falta_atraso; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE falta_atraso (
    cod_falta_atraso integer DEFAULT nextval('falta_atraso_cod_falta_atraso_seq'::regclass) NOT NULL,
    ref_cod_escola integer NOT NULL,
    ref_ref_cod_instituicao integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_servidor integer NOT NULL,
    tipo smallint NOT NULL,
    data_falta_atraso timestamp without time zone NOT NULL,
    qtd_horas integer,
    qtd_min integer,
    justificada smallint DEFAULT (0)::smallint NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE falta_atraso OWNER TO postgres;

--
-- Name: falta_atraso_compensado_cod_compensado_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE falta_atraso_compensado_cod_compensado_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE falta_atraso_compensado_cod_compensado_seq OWNER TO postgres;

--
-- Name: falta_atraso_compensado; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE falta_atraso_compensado (
    cod_compensado integer DEFAULT nextval('falta_atraso_compensado_cod_compensado_seq'::regclass) NOT NULL,
    ref_cod_escola integer NOT NULL,
    ref_ref_cod_instituicao integer NOT NULL,
    ref_cod_servidor integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    data_inicio timestamp without time zone NOT NULL,
    data_fim timestamp without time zone NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE falta_atraso_compensado OWNER TO postgres;

--
-- Name: faltas_sequencial_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE faltas_sequencial_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE faltas_sequencial_seq OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: faltas; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE faltas (
    ref_cod_matricula integer NOT NULL,
    sequencial integer DEFAULT nextval('faltas_sequencial_seq'::regclass) NOT NULL,
    ref_usuario_cad integer NOT NULL,
    falta integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL
);


ALTER TABLE faltas OWNER TO postgres;

--
-- Name: fonte_cod_fonte_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE fonte_cod_fonte_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE fonte_cod_fonte_seq OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: fonte; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE fonte (
    cod_fonte integer DEFAULT nextval('fonte_cod_fonte_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_fonte character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_biblioteca integer
);


ALTER TABLE fonte OWNER TO postgres;

--
-- Name: funcao_cod_funcao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE funcao_cod_funcao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE funcao_cod_funcao_seq OWNER TO postgres;

--
-- Name: funcao; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE funcao (
    cod_funcao integer DEFAULT nextval('funcao_cod_funcao_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_funcao character varying(255) NOT NULL,
    abreviatura character varying(30) NOT NULL,
    professor smallint DEFAULT (0)::smallint NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_instituicao integer NOT NULL
);


ALTER TABLE funcao OWNER TO postgres;

--
-- Name: habilitacao_cod_habilitacao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE habilitacao_cod_habilitacao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE habilitacao_cod_habilitacao_seq OWNER TO postgres;

--
-- Name: habilitacao; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE habilitacao (
    cod_habilitacao integer DEFAULT nextval('habilitacao_cod_habilitacao_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_tipo character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_instituicao integer NOT NULL
);


ALTER TABLE habilitacao OWNER TO postgres;

--
-- Name: habilitacao_curso; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE habilitacao_curso (
    ref_cod_habilitacao integer NOT NULL,
    ref_cod_curso integer NOT NULL
);


ALTER TABLE habilitacao_curso OWNER TO postgres;

--
-- Name: historico_disciplinas; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE historico_disciplinas (
    sequencial integer NOT NULL,
    ref_ref_cod_aluno integer NOT NULL,
    ref_sequencial integer NOT NULL,
    nm_disciplina character varying(255) NOT NULL,
    nota character varying(255) NOT NULL,
    faltas integer,
    import numeric(1,0),
    ordenamento integer,
    carga_horaria_disciplina integer,
    dependencia boolean DEFAULT false
);


ALTER TABLE historico_disciplinas OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: historico_educar; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE historico_educar (
    tabela character varying(50),
    alteracao text,
    data timestamp without time zone,
    insercao smallint DEFAULT 0
);


ALTER TABLE historico_educar OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: historico_escolar; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE historico_escolar (
    ref_cod_aluno integer NOT NULL,
    sequencial integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ano integer NOT NULL,
    carga_horaria double precision,
    dias_letivos integer,
    escola character varying(255) NOT NULL,
    escola_cidade character varying(255) NOT NULL,
    escola_uf character varying(3),
    observacao text,
    aprovado smallint DEFAULT (1)::smallint NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    faltas_globalizadas integer,
    nm_serie character varying(255),
    origem smallint DEFAULT (1)::smallint,
    extra_curricular smallint DEFAULT (0)::smallint,
    ref_cod_matricula integer,
    ref_cod_instituicao integer,
    import numeric(1,0),
    frequencia numeric(5,2) DEFAULT 0.000,
    registro character varying(50),
    livro character varying(50),
    folha character varying(50),
    historico_grade_curso_id integer,
    nm_curso character varying(255),
    aceleracao integer,
    ref_cod_escola integer,
    dependencia boolean,
    posicao integer
);


ALTER TABLE historico_escolar OWNER TO postgres;

--
-- Name: historico_grade_curso_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE historico_grade_curso_seq
    START WITH 3
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE historico_grade_curso_seq OWNER TO postgres;

--
-- Name: historico_grade_curso; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE historico_grade_curso (
    id integer DEFAULT nextval('historico_grade_curso_seq'::regclass) NOT NULL,
    descricao_etapa character varying(20) NOT NULL,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone,
    quantidade_etapas integer,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE historico_grade_curso OWNER TO postgres;

--
-- Name: infra_comodo_funcao_cod_infra_comodo_funcao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE infra_comodo_funcao_cod_infra_comodo_funcao_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE infra_comodo_funcao_cod_infra_comodo_funcao_seq OWNER TO postgres;

--
-- Name: infra_comodo_funcao; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE infra_comodo_funcao (
    cod_infra_comodo_funcao integer DEFAULT nextval('infra_comodo_funcao_cod_infra_comodo_funcao_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_funcao character varying(255) NOT NULL,
    desc_funcao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_escola integer
);


ALTER TABLE infra_comodo_funcao OWNER TO postgres;

--
-- Name: infra_predio_cod_infra_predio_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE infra_predio_cod_infra_predio_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE infra_predio_cod_infra_predio_seq OWNER TO postgres;

--
-- Name: infra_predio; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE infra_predio (
    cod_infra_predio integer DEFAULT nextval('infra_predio_cod_infra_predio_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_escola integer NOT NULL,
    nm_predio character varying(255) NOT NULL,
    desc_predio text,
    endereco text NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE infra_predio OWNER TO postgres;

--
-- Name: infra_predio_comodo_cod_infra_predio_comodo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE infra_predio_comodo_cod_infra_predio_comodo_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE infra_predio_comodo_cod_infra_predio_comodo_seq OWNER TO postgres;

--
-- Name: infra_predio_comodo; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE infra_predio_comodo (
    cod_infra_predio_comodo integer DEFAULT nextval('infra_predio_comodo_cod_infra_predio_comodo_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_infra_comodo_funcao integer NOT NULL,
    ref_cod_infra_predio integer NOT NULL,
    nm_comodo character varying(255) NOT NULL,
    desc_comodo text,
    area double precision NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE infra_predio_comodo OWNER TO postgres;

--
-- Name: instituicao_cod_instituicao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE instituicao_cod_instituicao_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE instituicao_cod_instituicao_seq OWNER TO postgres;

--
-- Name: instituicao; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE instituicao (
    cod_instituicao integer DEFAULT nextval('instituicao_cod_instituicao_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_idtlog character varying(20) NOT NULL,
    ref_sigla_uf character(2) NOT NULL,
    cep numeric(8,0) NOT NULL,
    cidade character varying(60) NOT NULL,
    bairro character varying(40) NOT NULL,
    logradouro character varying(255) NOT NULL,
    numero numeric(6,0),
    complemento character varying(50),
    nm_responsavel character varying(255) NOT NULL,
    ddd_telefone numeric(2,0),
    telefone numeric(11,0),
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    nm_instituicao character varying(255) NOT NULL,
    data_base_remanejamento date,
    data_base_transferencia date,
    controlar_espaco_utilizacao_aluno smallint,
    percentagem_maxima_ocupacao_salas numeric(5,2),
    quantidade_alunos_metro_quadrado integer,
    exigir_vinculo_turma_professor smallint,
    gerar_historico_transferencia boolean,
    matricula_apenas_bairro_escola boolean,
    restringir_historico_escolar boolean,
    coordenador_transporte character varying,
    restringir_multiplas_enturmacoes boolean,
    permissao_filtro_abandono_transferencia boolean,
    data_base_matricula date,
    multiplas_reserva_vaga boolean DEFAULT false NOT NULL,
    reserva_integral_somente_com_renda boolean DEFAULT false NOT NULL,
    data_expiracao_reserva_vaga date,
    data_fechamento date,
    componente_curricular_turma boolean,
    reprova_dependencia_ano_concluinte boolean,
    controlar_posicao_historicos boolean,
    data_educacenso date,
    bloqueia_matricula_serie_nao_seguinte boolean,
    permitir_carga_horaria boolean DEFAULT false,
    exigir_dados_socioeconomicos boolean DEFAULT false,
    altera_atestado_para_declaracao boolean
);


ALTER TABLE instituicao OWNER TO postgres;

--
-- Name: instituicao_documentacao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE instituicao_documentacao_seq
    START WITH 2
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE instituicao_documentacao_seq OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: instituicao_documentacao; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE instituicao_documentacao (
    id integer DEFAULT nextval('instituicao_documentacao_seq'::regclass) NOT NULL,
    instituicao_id integer NOT NULL,
    titulo_documento character varying(100) NOT NULL,
    url_documento character varying(255) NOT NULL,
    ref_usuario_cad integer DEFAULT 0 NOT NULL,
    ref_cod_escola integer
);


ALTER TABLE instituicao_documentacao OWNER TO postgres;

--
-- Name: material_didatico_cod_material_didatico_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE material_didatico_cod_material_didatico_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE material_didatico_cod_material_didatico_seq OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: material_didatico; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE material_didatico (
    cod_material_didatico integer DEFAULT nextval('material_didatico_cod_material_didatico_seq'::regclass) NOT NULL,
    ref_cod_instituicao integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_material_tipo integer NOT NULL,
    nm_material character varying(255) NOT NULL,
    desc_material text,
    custo_unitario double precision NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE material_didatico OWNER TO postgres;

--
-- Name: material_tipo_cod_material_tipo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE material_tipo_cod_material_tipo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE material_tipo_cod_material_tipo_seq OWNER TO postgres;

--
-- Name: material_tipo; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE material_tipo (
    cod_material_tipo integer DEFAULT nextval('material_tipo_cod_material_tipo_seq'::regclass) NOT NULL,
    ref_usuario_cad integer NOT NULL,
    ref_usuario_exc integer,
    nm_tipo character varying(255) NOT NULL,
    desc_tipo text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_instituicao integer NOT NULL
);


ALTER TABLE material_tipo OWNER TO postgres;

--
-- Name: matricula_cod_matricula_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE matricula_cod_matricula_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE matricula_cod_matricula_seq OWNER TO postgres;

--
-- Name: matricula; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE matricula (
    cod_matricula integer DEFAULT nextval('matricula_cod_matricula_seq'::regclass) NOT NULL,
    ref_cod_reserva_vaga integer,
    ref_ref_cod_escola integer,
    ref_ref_cod_serie integer,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_aluno integer NOT NULL,
    aprovado smallint DEFAULT (0)::smallint NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ano integer NOT NULL,
    ultima_matricula smallint DEFAULT (0)::smallint NOT NULL,
    modulo smallint DEFAULT 1 NOT NULL,
    descricao_reclassificacao text,
    formando smallint DEFAULT (0)::smallint NOT NULL,
    matricula_reclassificacao smallint DEFAULT (0)::smallint,
    ref_cod_curso integer,
    matricula_transferencia boolean DEFAULT false NOT NULL,
    semestre smallint,
    observacao character varying(300),
    data_matricula timestamp without time zone,
    data_cancel timestamp without time zone,
    ref_cod_abandono_tipo integer,
    turno_pre_matricula smallint,
    dependencia boolean DEFAULT false,
    updated_at timestamp without time zone,
    saida_escola boolean DEFAULT false,
    data_saida_escola date,
    turno_id integer
);


ALTER TABLE matricula OWNER TO postgres;

--
-- Name: matricula_excessao_cod_aluno_excessao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE matricula_excessao_cod_aluno_excessao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE matricula_excessao_cod_aluno_excessao_seq OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: matricula_excessao; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE matricula_excessao (
    cod_aluno_excessao integer DEFAULT nextval('matricula_excessao_cod_aluno_excessao_seq'::regclass) NOT NULL,
    ref_cod_matricula integer NOT NULL,
    ref_cod_turma integer NOT NULL,
    ref_sequencial integer NOT NULL,
    ref_cod_serie integer NOT NULL,
    ref_cod_escola integer NOT NULL,
    ref_cod_disciplina integer NOT NULL,
    reprovado_faltas boolean NOT NULL,
    precisa_exame boolean NOT NULL,
    permite_exame boolean
);


ALTER TABLE matricula_excessao OWNER TO postgres;

--
-- Name: ocorrencia_disciplinar_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE ocorrencia_disciplinar_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ocorrencia_disciplinar_seq OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: matricula_ocorrencia_disciplinar; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE matricula_ocorrencia_disciplinar (
    ref_cod_matricula integer NOT NULL,
    ref_cod_tipo_ocorrencia_disciplinar integer NOT NULL,
    sequencial integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    observacao text NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    visivel_pais integer,
    cod_ocorrencia_disciplinar integer DEFAULT nextval('ocorrencia_disciplinar_seq'::regclass) NOT NULL
);


ALTER TABLE matricula_ocorrencia_disciplinar OWNER TO postgres;

--
-- Name: matricula_turma; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE matricula_turma (
    ref_cod_matricula integer NOT NULL,
    ref_cod_turma integer NOT NULL,
    sequencial integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    data_enturmacao date NOT NULL,
    sequencial_fechamento integer DEFAULT 0 NOT NULL,
    transferido boolean,
    remanejado boolean,
    reclassificado boolean,
    abandono boolean,
    updated_at timestamp without time zone,
    falecido boolean
);


ALTER TABLE matricula_turma OWNER TO postgres;

--
-- Name: menu_tipo_usuario; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE menu_tipo_usuario (
    ref_cod_tipo_usuario integer NOT NULL,
    ref_cod_menu_submenu integer NOT NULL,
    cadastra smallint DEFAULT 0 NOT NULL,
    visualiza smallint DEFAULT 0 NOT NULL,
    exclui smallint DEFAULT 0 NOT NULL
);


ALTER TABLE menu_tipo_usuario OWNER TO postgres;

--
-- Name: modulo_cod_modulo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE modulo_cod_modulo_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE modulo_cod_modulo_seq OWNER TO postgres;

--
-- Name: modulo; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE modulo (
    cod_modulo integer DEFAULT nextval('modulo_cod_modulo_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_tipo character varying(255) NOT NULL,
    descricao text,
    num_meses numeric(2,0) NOT NULL,
    num_semanas integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_instituicao integer NOT NULL
);


ALTER TABLE modulo OWNER TO postgres;

--
-- Name: motivo_afastamento_cod_motivo_afastamento_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE motivo_afastamento_cod_motivo_afastamento_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE motivo_afastamento_cod_motivo_afastamento_seq OWNER TO postgres;

--
-- Name: motivo_afastamento; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE motivo_afastamento (
    cod_motivo_afastamento integer DEFAULT nextval('motivo_afastamento_cod_motivo_afastamento_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_motivo character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_instituicao integer NOT NULL
);


ALTER TABLE motivo_afastamento OWNER TO postgres;

--
-- Name: motivo_baixa_cod_motivo_baixa_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE motivo_baixa_cod_motivo_baixa_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE motivo_baixa_cod_motivo_baixa_seq OWNER TO postgres;

--
-- Name: motivo_baixa; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE motivo_baixa (
    cod_motivo_baixa integer DEFAULT nextval('motivo_baixa_cod_motivo_baixa_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_motivo_baixa character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_biblioteca integer
);


ALTER TABLE motivo_baixa OWNER TO postgres;

--
-- Name: motivo_suspensao_cod_motivo_suspensao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE motivo_suspensao_cod_motivo_suspensao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE motivo_suspensao_cod_motivo_suspensao_seq OWNER TO postgres;

--
-- Name: motivo_suspensao; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE motivo_suspensao (
    cod_motivo_suspensao integer DEFAULT nextval('motivo_suspensao_cod_motivo_suspensao_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_motivo character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_biblioteca integer
);


ALTER TABLE motivo_suspensao OWNER TO postgres;

--
-- Name: nivel_cod_nivel_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE nivel_cod_nivel_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE nivel_cod_nivel_seq OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: nivel; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE nivel (
    cod_nivel integer DEFAULT nextval('nivel_cod_nivel_seq'::regclass) NOT NULL,
    ref_cod_categoria_nivel integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_nivel_anterior integer,
    nm_nivel character varying(100) NOT NULL,
    salario_base double precision,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo boolean DEFAULT true NOT NULL
);


ALTER TABLE nivel OWNER TO postgres;

--
-- Name: nivel_ensino_cod_nivel_ensino_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE nivel_ensino_cod_nivel_ensino_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE nivel_ensino_cod_nivel_ensino_seq OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: nivel_ensino; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE nivel_ensino (
    cod_nivel_ensino integer DEFAULT nextval('nivel_ensino_cod_nivel_ensino_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_nivel character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_instituicao integer NOT NULL
);


ALTER TABLE nivel_ensino OWNER TO postgres;

--
-- Name: nota_aluno_cod_nota_aluno_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE nota_aluno_cod_nota_aluno_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE nota_aluno_cod_nota_aluno_seq OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: nota_aluno; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE nota_aluno (
    cod_nota_aluno integer DEFAULT nextval('nota_aluno_cod_nota_aluno_seq'::regclass) NOT NULL,
    ref_cod_disciplina integer,
    ref_cod_escola integer,
    ref_cod_serie integer,
    ref_cod_matricula integer NOT NULL,
    ref_sequencial integer,
    ref_ref_cod_tipo_avaliacao integer,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    modulo smallint NOT NULL,
    ref_cod_curso_disciplina integer,
    nota double precision
);


ALTER TABLE nota_aluno OWNER TO postgres;

--
-- Name: operador_cod_operador_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE operador_cod_operador_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE operador_cod_operador_seq OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: operador; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE operador (
    cod_operador integer DEFAULT nextval('operador_cod_operador_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nome character varying(50) NOT NULL,
    valor text NOT NULL,
    fim_sentenca smallint DEFAULT (1)::smallint NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE operador OWNER TO postgres;

--
-- Name: pagamento_multa_cod_pagamento_multa_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE pagamento_multa_cod_pagamento_multa_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE pagamento_multa_cod_pagamento_multa_seq OWNER TO postgres;

--
-- Name: pagamento_multa; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE pagamento_multa (
    cod_pagamento_multa integer DEFAULT nextval('pagamento_multa_cod_pagamento_multa_seq'::regclass) NOT NULL,
    ref_usuario_cad integer NOT NULL,
    ref_cod_cliente integer NOT NULL,
    valor_pago double precision NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    ref_cod_biblioteca integer NOT NULL
);


ALTER TABLE pagamento_multa OWNER TO postgres;

--
-- Name: pre_requisito_cod_pre_requisito_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE pre_requisito_cod_pre_requisito_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE pre_requisito_cod_pre_requisito_seq OWNER TO postgres;

--
-- Name: pre_requisito; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE pre_requisito (
    cod_pre_requisito integer DEFAULT nextval('pre_requisito_cod_pre_requisito_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    schema_ character varying(50) NOT NULL,
    tabela character varying(50) NOT NULL,
    nome character varying(50) NOT NULL,
    sql text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE pre_requisito OWNER TO postgres;

--
-- Name: projeto_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE projeto_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE projeto_seq OWNER TO postgres;

--
-- Name: projeto; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE projeto (
    cod_projeto integer DEFAULT nextval('projeto_seq'::regclass) NOT NULL,
    nome character varying(50),
    observacao character varying(255)
);


ALTER TABLE projeto OWNER TO postgres;

--
-- Name: projeto_aluno; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE projeto_aluno (
    ref_cod_projeto integer NOT NULL,
    ref_cod_aluno integer NOT NULL,
    data_inclusao date,
    data_desligamento date,
    turno integer
);


ALTER TABLE projeto_aluno OWNER TO postgres;

--
-- Name: quadro_horario_cod_quadro_horario_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE quadro_horario_cod_quadro_horario_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE quadro_horario_cod_quadro_horario_seq OWNER TO postgres;

--
-- Name: quadro_horario; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE quadro_horario (
    cod_quadro_horario integer DEFAULT nextval('quadro_horario_cod_quadro_horario_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_turma integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ano integer
);


ALTER TABLE quadro_horario OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: quadro_horario_horarios; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE quadro_horario_horarios (
    ref_cod_quadro_horario integer NOT NULL,
    sequencial integer NOT NULL,
    ref_cod_disciplina integer NOT NULL,
    ref_cod_escola integer NOT NULL,
    ref_cod_serie integer NOT NULL,
    ref_cod_instituicao_substituto integer,
    ref_cod_instituicao_servidor integer NOT NULL,
    ref_servidor_substituto integer,
    ref_servidor integer NOT NULL,
    dia_semana integer NOT NULL,
    hora_inicial time without time zone NOT NULL,
    hora_final time without time zone NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE quadro_horario_horarios OWNER TO postgres;

--
-- Name: quadro_horario_horarios_aux; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE quadro_horario_horarios_aux (
    ref_cod_quadro_horario integer NOT NULL,
    sequencial integer NOT NULL,
    ref_cod_disciplina integer NOT NULL,
    ref_cod_escola integer NOT NULL,
    ref_cod_serie integer NOT NULL,
    ref_cod_instituicao_servidor integer NOT NULL,
    ref_servidor integer NOT NULL,
    dia_semana integer NOT NULL,
    hora_inicial time without time zone NOT NULL,
    hora_final time without time zone NOT NULL,
    identificador character varying(30),
    data_cadastro timestamp without time zone NOT NULL
);


ALTER TABLE quadro_horario_horarios_aux OWNER TO postgres;

--
-- Name: quantidade_reserva_externa; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE quantidade_reserva_externa (
    ref_cod_instituicao integer NOT NULL,
    ref_cod_escola integer NOT NULL,
    ref_cod_curso integer NOT NULL,
    ref_cod_serie integer NOT NULL,
    ref_turma_turno_id integer NOT NULL,
    ano integer NOT NULL,
    qtd_alunos integer NOT NULL
);


ALTER TABLE quantidade_reserva_externa OWNER TO postgres;

--
-- Name: relacao_categoria_acervo; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE relacao_categoria_acervo (
    ref_cod_acervo integer NOT NULL,
    categoria_id integer NOT NULL
);


ALTER TABLE relacao_categoria_acervo OWNER TO postgres;

--
-- Name: religiao_cod_religiao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE religiao_cod_religiao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE religiao_cod_religiao_seq OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: religiao; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE religiao (
    cod_religiao integer DEFAULT nextval('religiao_cod_religiao_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_religiao character varying(255) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE religiao OWNER TO postgres;

--
-- Name: reserva_vaga_cod_reserva_vaga_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE reserva_vaga_cod_reserva_vaga_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE reserva_vaga_cod_reserva_vaga_seq OWNER TO postgres;

--
-- Name: reserva_vaga; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE reserva_vaga (
    cod_reserva_vaga integer DEFAULT nextval('reserva_vaga_cod_reserva_vaga_seq'::regclass) NOT NULL,
    ref_ref_cod_escola integer NOT NULL,
    ref_ref_cod_serie integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_aluno integer,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    nm_aluno character varying(255),
    cpf_responsavel numeric(11,0)
);


ALTER TABLE reserva_vaga OWNER TO postgres;

--
-- Name: reservas_cod_reserva_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE reservas_cod_reserva_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE reservas_cod_reserva_seq OWNER TO postgres;

--
-- Name: reservas; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE reservas (
    cod_reserva integer DEFAULT nextval('reservas_cod_reserva_seq'::regclass) NOT NULL,
    ref_usuario_libera integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_cliente integer NOT NULL,
    data_reserva timestamp without time zone,
    data_prevista_disponivel timestamp without time zone,
    data_retirada timestamp without time zone,
    ref_cod_exemplar integer NOT NULL,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE reservas OWNER TO postgres;

--
-- Name: sequencia_serie; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE sequencia_serie (
    ref_serie_origem integer NOT NULL,
    ref_serie_destino integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE sequencia_serie OWNER TO postgres;

--
-- Name: serie_cod_serie_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE serie_cod_serie_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE serie_cod_serie_seq OWNER TO postgres;

--
-- Name: serie; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE serie (
    cod_serie integer DEFAULT nextval('serie_cod_serie_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_curso integer NOT NULL,
    nm_serie character varying(255) NOT NULL,
    etapa_curso integer NOT NULL,
    concluinte smallint DEFAULT (0)::smallint NOT NULL,
    carga_horaria double precision NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    intervalo integer,
    idade_inicial numeric(3,0),
    idade_final numeric(3,0),
    regra_avaliacao_id integer,
    observacao_historico character varying(100),
    dias_letivos integer,
    regra_avaliacao_diferenciada_id integer,
    alerta_faixa_etaria boolean,
    bloquear_matricula_faixa_etaria boolean,
    idade_ideal integer,
    exigir_inep boolean
);


ALTER TABLE serie OWNER TO postgres;

--
-- Name: serie_pre_requisito; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE serie_pre_requisito (
    ref_cod_pre_requisito integer NOT NULL,
    ref_cod_operador integer NOT NULL,
    ref_cod_serie integer NOT NULL,
    valor character varying
);


ALTER TABLE serie_pre_requisito OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: serie_vaga; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE serie_vaga (
    ano integer NOT NULL,
    cod_serie_vaga integer NOT NULL,
    ref_cod_instituicao integer NOT NULL,
    ref_cod_escola integer NOT NULL,
    ref_cod_curso integer NOT NULL,
    ref_cod_serie integer NOT NULL,
    vagas smallint NOT NULL,
    turno smallint DEFAULT 1 NOT NULL
);


ALTER TABLE serie_vaga OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: servidor; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE servidor (
    cod_servidor integer NOT NULL,
    ref_cod_instituicao integer NOT NULL,
    ref_idesco numeric(2,0),
    carga_horaria double precision NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_subnivel integer,
    situacao_curso_superior_1 smallint,
    formacao_complementacao_pedagogica_1 smallint,
    codigo_curso_superior_1 integer,
    ano_inicio_curso_superior_1 numeric(4,0),
    ano_conclusao_curso_superior_1 numeric(4,0),
    tipo_instituicao_curso_superior_1 smallint,
    instituicao_curso_superior_1 smallint,
    situacao_curso_superior_2 smallint,
    formacao_complementacao_pedagogica_2 smallint,
    codigo_curso_superior_2 integer,
    ano_inicio_curso_superior_2 numeric(4,0),
    ano_conclusao_curso_superior_2 numeric(4,0),
    tipo_instituicao_curso_superior_2 smallint,
    instituicao_curso_superior_2 smallint,
    situacao_curso_superior_3 smallint,
    formacao_complementacao_pedagogica_3 smallint,
    codigo_curso_superior_3 integer,
    ano_inicio_curso_superior_3 numeric(4,0),
    ano_conclusao_curso_superior_3 numeric(4,0),
    tipo_instituicao_curso_superior_3 smallint,
    instituicao_curso_superior_3 smallint,
    pos_especializacao smallint,
    pos_mestrado smallint,
    pos_doutorado smallint,
    pos_nenhuma smallint,
    curso_creche smallint,
    curso_pre_escola smallint,
    curso_anos_iniciais smallint,
    curso_anos_finais smallint,
    curso_ensino_medio smallint,
    curso_eja smallint,
    curso_educacao_especial smallint,
    curso_educacao_indigena smallint,
    curso_educacao_campo smallint,
    curso_educacao_ambiental smallint,
    curso_educacao_direitos_humanos smallint,
    curso_genero_diversidade_sexual smallint,
    curso_direito_crianca_adolescente smallint,
    curso_relacoes_etnicorraciais smallint,
    curso_outros smallint,
    curso_nenhum smallint,
    multi_seriado boolean
);


ALTER TABLE servidor OWNER TO postgres;

--
-- Name: servidor_afastamento; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE servidor_afastamento (
    ref_cod_servidor integer NOT NULL,
    sequencial integer NOT NULL,
    ref_ref_cod_instituicao integer NOT NULL,
    ref_cod_motivo_afastamento integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    data_retorno timestamp without time zone,
    data_saida timestamp without time zone NOT NULL,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE servidor_afastamento OWNER TO postgres;

--
-- Name: servidor_alocacao_cod_servidor_alocacao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE servidor_alocacao_cod_servidor_alocacao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE servidor_alocacao_cod_servidor_alocacao_seq OWNER TO postgres;

--
-- Name: servidor_alocacao; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE servidor_alocacao (
    cod_servidor_alocacao integer DEFAULT nextval('servidor_alocacao_cod_servidor_alocacao_seq'::regclass) NOT NULL,
    ref_ref_cod_instituicao integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_escola integer NOT NULL,
    ref_cod_servidor integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    carga_horaria interval,
    periodo smallint DEFAULT (1)::smallint,
    hora_final time without time zone,
    hora_inicial time without time zone,
    dia_semana integer,
    ref_cod_servidor_funcao integer,
    ref_cod_funcionario_vinculo integer,
    ano integer
);


ALTER TABLE servidor_alocacao OWNER TO postgres;

--
-- Name: servidor_curso_cod_servidor_curso_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE servidor_curso_cod_servidor_curso_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE servidor_curso_cod_servidor_curso_seq OWNER TO postgres;

--
-- Name: servidor_curso; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE servidor_curso (
    cod_servidor_curso integer DEFAULT nextval('servidor_curso_cod_servidor_curso_seq'::regclass) NOT NULL,
    ref_cod_formacao integer NOT NULL,
    data_conclusao timestamp without time zone NOT NULL,
    data_registro timestamp without time zone,
    diplomas_registros text
);


ALTER TABLE servidor_curso OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: servidor_curso_ministra; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE servidor_curso_ministra (
    ref_cod_curso integer NOT NULL,
    ref_ref_cod_instituicao integer NOT NULL,
    ref_cod_servidor integer NOT NULL
);


ALTER TABLE servidor_curso_ministra OWNER TO postgres;

--
-- Name: servidor_disciplina; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE servidor_disciplina (
    ref_cod_disciplina integer NOT NULL,
    ref_ref_cod_instituicao integer NOT NULL,
    ref_cod_servidor integer NOT NULL,
    ref_cod_curso integer NOT NULL
);


ALTER TABLE servidor_disciplina OWNER TO postgres;

--
-- Name: servidor_formacao_cod_formacao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE servidor_formacao_cod_formacao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE servidor_formacao_cod_formacao_seq OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: servidor_formacao; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE servidor_formacao (
    cod_formacao integer DEFAULT nextval('servidor_formacao_cod_formacao_seq'::regclass) NOT NULL,
    ref_ref_cod_instituicao integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_servidor integer NOT NULL,
    nm_formacao character varying(255) NOT NULL,
    tipo character(1) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE servidor_formacao OWNER TO postgres;

--
-- Name: servidor_funcao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE servidor_funcao_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE servidor_funcao_seq OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: servidor_funcao; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE servidor_funcao (
    ref_ref_cod_instituicao integer NOT NULL,
    ref_cod_servidor integer NOT NULL,
    ref_cod_funcao integer NOT NULL,
    matricula character varying,
    cod_servidor_funcao integer DEFAULT nextval('servidor_funcao_seq'::regclass) NOT NULL
);


ALTER TABLE servidor_funcao OWNER TO postgres;

--
-- Name: servidor_titulo_concurso_cod_servidor_titulo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE servidor_titulo_concurso_cod_servidor_titulo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE servidor_titulo_concurso_cod_servidor_titulo_seq OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: servidor_titulo_concurso; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE servidor_titulo_concurso (
    cod_servidor_titulo integer DEFAULT nextval('servidor_titulo_concurso_cod_servidor_titulo_seq'::regclass) NOT NULL,
    ref_cod_formacao integer NOT NULL,
    data_vigencia_homolog timestamp without time zone NOT NULL,
    data_publicacao timestamp without time zone NOT NULL
);


ALTER TABLE servidor_titulo_concurso OWNER TO postgres;

--
-- Name: situacao_cod_situacao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE situacao_cod_situacao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE situacao_cod_situacao_seq OWNER TO postgres;

--
-- Name: situacao; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE situacao (
    cod_situacao integer DEFAULT nextval('situacao_cod_situacao_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_situacao character varying(255) NOT NULL,
    permite_emprestimo smallint DEFAULT (1)::smallint NOT NULL,
    descricao text,
    situacao_padrao smallint DEFAULT (0)::smallint NOT NULL,
    situacao_emprestada smallint DEFAULT (0)::smallint NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_biblioteca integer NOT NULL
);


ALTER TABLE situacao OWNER TO postgres;

--
-- Name: subnivel_cod_subnivel_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE subnivel_cod_subnivel_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE subnivel_cod_subnivel_seq OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: subnivel; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE subnivel (
    cod_subnivel integer DEFAULT nextval('subnivel_cod_subnivel_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_subnivel_anterior integer,
    ref_cod_nivel integer NOT NULL,
    nm_subnivel character varying(100),
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo boolean DEFAULT true NOT NULL,
    salario double precision NOT NULL
);


ALTER TABLE subnivel OWNER TO postgres;

--
-- Name: tipo_autor; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE tipo_autor (
    codigo integer,
    tipo_autor character varying(255)
);


ALTER TABLE tipo_autor OWNER TO postgres;

--
-- Name: tipo_avaliacao_cod_tipo_avaliacao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE tipo_avaliacao_cod_tipo_avaliacao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE tipo_avaliacao_cod_tipo_avaliacao_seq OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: tipo_avaliacao; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE tipo_avaliacao (
    cod_tipo_avaliacao integer DEFAULT nextval('tipo_avaliacao_cod_tipo_avaliacao_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_tipo character varying(255) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    conceitual smallint DEFAULT 1,
    ref_cod_instituicao integer NOT NULL
);


ALTER TABLE tipo_avaliacao OWNER TO postgres;

--
-- Name: tipo_avaliacao_valores; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE tipo_avaliacao_valores (
    ref_cod_tipo_avaliacao integer NOT NULL,
    sequencial integer NOT NULL,
    nome character varying(255) NOT NULL,
    valor double precision NOT NULL,
    valor_min double precision NOT NULL,
    valor_max double precision NOT NULL,
    ativo boolean DEFAULT true
);


ALTER TABLE tipo_avaliacao_valores OWNER TO postgres;

--
-- Name: tipo_dispensa_cod_tipo_dispensa_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE tipo_dispensa_cod_tipo_dispensa_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE tipo_dispensa_cod_tipo_dispensa_seq OWNER TO postgres;

--
-- Name: tipo_dispensa; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE tipo_dispensa (
    cod_tipo_dispensa integer DEFAULT nextval('tipo_dispensa_cod_tipo_dispensa_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_tipo character varying(255) NOT NULL,
    descricao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_instituicao integer NOT NULL
);


ALTER TABLE tipo_dispensa OWNER TO postgres;

--
-- Name: tipo_ensino_cod_tipo_ensino_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE tipo_ensino_cod_tipo_ensino_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE tipo_ensino_cod_tipo_ensino_seq OWNER TO postgres;

--
-- Name: tipo_ensino; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE tipo_ensino (
    cod_tipo_ensino integer DEFAULT nextval('tipo_ensino_cod_tipo_ensino_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_tipo character varying(255) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_instituicao integer NOT NULL,
    atividade_complementar boolean DEFAULT false
);


ALTER TABLE tipo_ensino OWNER TO postgres;

--
-- Name: tipo_ocorrencia_disciplinar_cod_tipo_ocorrencia_disciplinar_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE tipo_ocorrencia_disciplinar_cod_tipo_ocorrencia_disciplinar_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE tipo_ocorrencia_disciplinar_cod_tipo_ocorrencia_disciplinar_seq OWNER TO postgres;

--
-- Name: tipo_ocorrencia_disciplinar; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE tipo_ocorrencia_disciplinar (
    cod_tipo_ocorrencia_disciplinar integer DEFAULT nextval('tipo_ocorrencia_disciplinar_cod_tipo_ocorrencia_disciplinar_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_tipo character varying(255) NOT NULL,
    descricao text,
    max_ocorrencias integer,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_instituicao integer NOT NULL
);


ALTER TABLE tipo_ocorrencia_disciplinar OWNER TO postgres;

--
-- Name: tipo_regime_cod_tipo_regime_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE tipo_regime_cod_tipo_regime_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE tipo_regime_cod_tipo_regime_seq OWNER TO postgres;

--
-- Name: tipo_regime; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE tipo_regime (
    cod_tipo_regime integer DEFAULT nextval('tipo_regime_cod_tipo_regime_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_tipo character varying(255) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint NOT NULL,
    ref_cod_instituicao integer NOT NULL
);


ALTER TABLE tipo_regime OWNER TO postgres;

--
-- Name: tipo_usuario_cod_tipo_usuario_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE tipo_usuario_cod_tipo_usuario_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE tipo_usuario_cod_tipo_usuario_seq OWNER TO postgres;

--
-- Name: tipo_usuario; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE tipo_usuario (
    cod_tipo_usuario integer DEFAULT nextval('tipo_usuario_cod_tipo_usuario_seq'::regclass) NOT NULL,
    ref_funcionario_cad integer NOT NULL,
    ref_funcionario_exc integer,
    nm_tipo character varying(255) NOT NULL,
    descricao text,
    nivel integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE tipo_usuario OWNER TO postgres;

--
-- Name: transferencia_solicitacao_cod_transferencia_solicitacao_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE transferencia_solicitacao_cod_transferencia_solicitacao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE transferencia_solicitacao_cod_transferencia_solicitacao_seq OWNER TO postgres;

--
-- Name: transferencia_solicitacao; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE transferencia_solicitacao (
    cod_transferencia_solicitacao integer DEFAULT nextval('transferencia_solicitacao_cod_transferencia_solicitacao_seq'::regclass) NOT NULL,
    ref_cod_transferencia_tipo integer NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_cod_matricula_entrada integer,
    ref_cod_matricula_saida integer NOT NULL,
    observacao text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    data_transferencia timestamp without time zone,
    ref_cod_escola_destino integer,
    escola_destino_externa character varying,
    estado_escola_destino_externa character varying(60),
    municipio_escola_destino_externa character varying(60)
);


ALTER TABLE transferencia_solicitacao OWNER TO postgres;

--
-- Name: transferencia_tipo_cod_transferencia_tipo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE transferencia_tipo_cod_transferencia_tipo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE transferencia_tipo_cod_transferencia_tipo_seq OWNER TO postgres;

--
-- Name: transferencia_tipo; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE transferencia_tipo (
    cod_transferencia_tipo integer DEFAULT nextval('transferencia_tipo_cod_transferencia_tipo_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_tipo character varying(255) NOT NULL,
    desc_tipo text,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_instituicao integer
);


ALTER TABLE transferencia_tipo OWNER TO postgres;

--
-- Name: turma_cod_turma_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE turma_cod_turma_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE turma_cod_turma_seq OWNER TO postgres;

--
-- Name: turma; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE turma (
    cod_turma integer DEFAULT nextval('turma_cod_turma_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    ref_ref_cod_serie integer,
    ref_ref_cod_escola integer,
    ref_cod_infra_predio_comodo integer,
    nm_turma character varying(255) NOT NULL,
    sgl_turma character varying(15),
    max_aluno integer NOT NULL,
    multiseriada smallint DEFAULT (0)::smallint NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_turma_tipo integer NOT NULL,
    hora_inicial time without time zone,
    hora_final time without time zone,
    hora_inicio_intervalo time without time zone,
    hora_fim_intervalo time without time zone,
    ref_cod_regente integer,
    ref_cod_instituicao_regente integer,
    ref_cod_instituicao integer,
    ref_cod_curso integer,
    ref_ref_cod_serie_mult integer,
    ref_ref_cod_escola_mult integer,
    visivel boolean,
    tipo_boletim integer,
    turma_turno_id integer,
    ano integer,
    tipo_atendimento smallint,
    turma_mais_educacao smallint,
    atividade_complementar_1 integer,
    atividade_complementar_2 integer,
    atividade_complementar_3 integer,
    atividade_complementar_4 integer,
    atividade_complementar_5 integer,
    atividade_complementar_6 integer,
    aee_braille smallint,
    aee_recurso_optico smallint,
    aee_estrategia_desenvolvimento smallint,
    aee_tecnica_mobilidade smallint,
    aee_libras smallint,
    aee_caa smallint,
    aee_curricular smallint,
    aee_soroban smallint,
    aee_informatica smallint,
    aee_lingua_escrita smallint,
    aee_autonomia smallint,
    cod_curso_profissional integer,
    turma_sem_professor smallint,
    turma_unificada smallint,
    etapa_educacenso smallint,
    ref_cod_disciplina_dispensada integer,
    parecer_1_etapa text,
    parecer_2_etapa text,
    parecer_3_etapa text,
    parecer_4_etapa text,
    nao_informar_educacenso smallint,
    etapa_educacenso2 smallint,
    tipo_mediacao_didatico_pedagogico integer
);


ALTER TABLE turma OWNER TO postgres;

--
-- Name: turma_dia_semana; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE turma_dia_semana (
    dia_semana numeric(1,0) NOT NULL,
    ref_cod_turma integer NOT NULL,
    hora_inicial time without time zone,
    hora_final time without time zone
);


ALTER TABLE turma_dia_semana OWNER TO postgres;

--
-- Name: turma_modulo; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE turma_modulo (
    ref_cod_turma integer NOT NULL,
    ref_cod_modulo integer NOT NULL,
    sequencial integer NOT NULL,
    data_inicio date NOT NULL,
    data_fim date NOT NULL,
    dias_letivos integer
);


ALTER TABLE turma_modulo OWNER TO postgres;

--
-- Name: turma_tipo_cod_turma_tipo_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE turma_tipo_cod_turma_tipo_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE turma_tipo_cod_turma_tipo_seq OWNER TO postgres;

--
-- Name: turma_tipo; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE turma_tipo (
    cod_turma_tipo integer DEFAULT nextval('turma_tipo_cod_turma_tipo_seq'::regclass) NOT NULL,
    ref_usuario_exc integer,
    ref_usuario_cad integer NOT NULL,
    nm_tipo character varying(255) NOT NULL,
    sgl_tipo character varying(15) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_instituicao integer
);


ALTER TABLE turma_tipo OWNER TO postgres;

--
-- Name: turma_turno_id_seq; Type: SEQUENCE; Schema: pmieducar; Owner: postgres
--

CREATE SEQUENCE turma_turno_id_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE turma_turno_id_seq OWNER TO postgres;

--
-- Name: turma_turno; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE turma_turno (
    id integer DEFAULT nextval('turma_turno_id_seq'::regclass) NOT NULL,
    nome character varying(15) NOT NULL,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE turma_turno OWNER TO postgres;

--
-- Name: usuario; Type: TABLE; Schema: pmieducar; Owner: postgres
--

CREATE TABLE usuario (
    cod_usuario integer NOT NULL,
    ref_cod_instituicao integer,
    ref_funcionario_cad integer NOT NULL,
    ref_funcionario_exc integer,
    ref_cod_tipo_usuario integer,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE usuario OWNER TO postgres;

--
-- Name: v_matricula_matricula_turma; Type: VIEW; Schema: pmieducar; Owner: postgres
--

CREATE VIEW v_matricula_matricula_turma AS
 SELECT ma.cod_matricula,
    ma.ref_ref_cod_escola AS ref_cod_escola,
    ma.ref_ref_cod_serie AS ref_cod_serie,
    ma.ref_cod_aluno,
    ma.ref_cod_curso,
    mt.ref_cod_turma,
    ma.ano,
    ma.aprovado,
    ma.ultima_matricula,
    ma.modulo,
    mt.sequencial,
    ma.ativo,
    ( SELECT count(0) AS count
           FROM dispensa_disciplina dd
          WHERE (dd.ref_cod_matricula = ma.cod_matricula)) AS qtd_dispensa_disciplina,
    ( SELECT COALESCE((max(n.modulo))::integer, 0) AS "coalesce"
           FROM nota_aluno n
          WHERE ((n.ref_cod_matricula = ma.cod_matricula) AND (n.ativo = 1))) AS maior_modulo_com_nota
   FROM matricula ma,
    matricula_turma mt
  WHERE ((mt.ref_cod_matricula = ma.cod_matricula) AND (mt.ativo = ma.ativo));


ALTER TABLE v_matricula_matricula_turma OWNER TO postgres;

SET search_path = pmiotopic, pg_catalog;

--
-- Name: funcionario_su; Type: TABLE; Schema: pmiotopic; Owner: postgres
--

CREATE TABLE funcionario_su (
    ref_ref_cod_pessoa_fj integer NOT NULL
);


ALTER TABLE funcionario_su OWNER TO postgres;

--
-- Name: grupomoderador; Type: TABLE; Schema: pmiotopic; Owner: postgres
--

CREATE TABLE grupomoderador (
    ref_ref_cod_pessoa_fj integer NOT NULL,
    ref_cod_grupos integer NOT NULL,
    ref_pessoa_exc integer,
    ref_pessoa_cad integer NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE grupomoderador OWNER TO postgres;

--
-- Name: grupopessoa; Type: TABLE; Schema: pmiotopic; Owner: postgres
--

CREATE TABLE grupopessoa (
    ref_idpes integer NOT NULL,
    ref_cod_grupos integer NOT NULL,
    ref_grupos_exc integer,
    ref_pessoa_exc integer,
    ref_grupos_cad integer,
    ref_pessoa_cad integer,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_cod_auxiliar_cad integer,
    ref_ref_cod_atendimento_cad integer
);


ALTER TABLE grupopessoa OWNER TO postgres;

--
-- Name: grupos_cod_grupos_seq; Type: SEQUENCE; Schema: pmiotopic; Owner: postgres
--

CREATE SEQUENCE grupos_cod_grupos_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE grupos_cod_grupos_seq OWNER TO postgres;

--
-- Name: grupos; Type: TABLE; Schema: pmiotopic; Owner: postgres
--

CREATE TABLE grupos (
    cod_grupos integer DEFAULT nextval('grupos_cod_grupos_seq'::regclass) NOT NULL,
    ref_pessoa_exc integer,
    ref_pessoa_cad integer NOT NULL,
    nm_grupo character varying(255) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    atendimento smallint DEFAULT 0 NOT NULL
);


ALTER TABLE grupos OWNER TO postgres;

--
-- Name: notas; Type: TABLE; Schema: pmiotopic; Owner: postgres
--

CREATE TABLE notas (
    sequencial integer NOT NULL,
    ref_idpes integer NOT NULL,
    ref_pessoa_exc integer,
    ref_pessoa_cad integer NOT NULL,
    nota text NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE notas OWNER TO postgres;

--
-- Name: participante; Type: TABLE; Schema: pmiotopic; Owner: postgres
--

CREATE TABLE participante (
    sequencial integer NOT NULL,
    ref_ref_cod_grupos integer NOT NULL,
    ref_ref_idpes integer NOT NULL,
    ref_cod_reuniao integer NOT NULL,
    data_chegada timestamp without time zone NOT NULL,
    data_saida timestamp without time zone
);


ALTER TABLE participante OWNER TO postgres;

--
-- Name: reuniao_cod_reuniao_seq; Type: SEQUENCE; Schema: pmiotopic; Owner: postgres
--

CREATE SEQUENCE reuniao_cod_reuniao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE reuniao_cod_reuniao_seq OWNER TO postgres;

--
-- Name: reuniao; Type: TABLE; Schema: pmiotopic; Owner: postgres
--

CREATE TABLE reuniao (
    cod_reuniao integer DEFAULT nextval('reuniao_cod_reuniao_seq'::regclass) NOT NULL,
    ref_grupos_moderador integer NOT NULL,
    ref_moderador integer NOT NULL,
    data_inicio_marcado timestamp without time zone NOT NULL,
    data_fim_marcado timestamp without time zone NOT NULL,
    data_inicio_real timestamp without time zone,
    data_fim_real timestamp without time zone,
    descricao text NOT NULL,
    email_enviado timestamp without time zone,
    publica smallint DEFAULT 0 NOT NULL
);


ALTER TABLE reuniao OWNER TO postgres;

--
-- Name: topico_cod_topico_seq; Type: SEQUENCE; Schema: pmiotopic; Owner: postgres
--

CREATE SEQUENCE topico_cod_topico_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE topico_cod_topico_seq OWNER TO postgres;

--
-- Name: topico; Type: TABLE; Schema: pmiotopic; Owner: postgres
--

CREATE TABLE topico (
    cod_topico integer DEFAULT nextval('topico_cod_topico_seq'::regclass) NOT NULL,
    ref_idpes_cad integer NOT NULL,
    ref_cod_grupos_cad integer NOT NULL,
    assunto character varying(255) NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_exclusao timestamp without time zone,
    ativo smallint DEFAULT (1)::smallint NOT NULL,
    ref_idpes_exc integer,
    ref_cod_grupos_exc integer
);


ALTER TABLE topico OWNER TO postgres;

--
-- Name: topicoreuniao; Type: TABLE; Schema: pmiotopic; Owner: postgres
--

CREATE TABLE topicoreuniao (
    ref_cod_topico integer NOT NULL,
    ref_cod_reuniao integer NOT NULL,
    parecer text,
    finalizado smallint,
    data_parecer timestamp without time zone
);


ALTER TABLE topicoreuniao OWNER TO postgres;

SET search_path = portal, pg_catalog;

--
-- Name: acesso_cod_acesso_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE acesso_cod_acesso_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE acesso_cod_acesso_seq OWNER TO postgres;

--
-- Name: acesso; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE acesso (
    cod_acesso integer DEFAULT nextval('acesso_cod_acesso_seq'::regclass) NOT NULL,
    data_hora timestamp without time zone NOT NULL,
    ip_externo character varying(50) DEFAULT ''::character varying NOT NULL,
    ip_interno character varying(255) DEFAULT ''::character varying NOT NULL,
    cod_pessoa integer DEFAULT 0 NOT NULL,
    obs text,
    sucesso boolean DEFAULT true NOT NULL
);


ALTER TABLE acesso OWNER TO postgres;

--
-- Name: agenda_cod_agenda_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE agenda_cod_agenda_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE agenda_cod_agenda_seq OWNER TO postgres;

--
-- Name: agenda; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE agenda (
    cod_agenda integer DEFAULT nextval('agenda_cod_agenda_seq'::regclass) NOT NULL,
    ref_ref_cod_pessoa_exc integer,
    ref_ref_cod_pessoa_cad integer NOT NULL,
    nm_agenda character varying NOT NULL,
    publica smallint DEFAULT 0 NOT NULL,
    envia_alerta smallint DEFAULT 0 NOT NULL,
    data_cad timestamp without time zone NOT NULL,
    data_edicao timestamp without time zone,
    ref_ref_cod_pessoa_own integer
);


ALTER TABLE agenda OWNER TO postgres;

--
-- Name: agenda_compromisso; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE agenda_compromisso (
    cod_agenda_compromisso integer NOT NULL,
    versao integer NOT NULL,
    ref_cod_agenda integer NOT NULL,
    ref_ref_cod_pessoa_cad integer NOT NULL,
    ativo smallint DEFAULT 1,
    data_inicio timestamp without time zone,
    titulo character varying,
    descricao text,
    importante smallint DEFAULT 0 NOT NULL,
    publico smallint DEFAULT 0 NOT NULL,
    data_cadastro timestamp without time zone NOT NULL,
    data_fim timestamp without time zone
);


ALTER TABLE agenda_compromisso OWNER TO postgres;

--
-- Name: agenda_pref_cod_comp_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE agenda_pref_cod_comp_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE agenda_pref_cod_comp_seq OWNER TO postgres;

--
-- Name: agenda_pref; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE agenda_pref (
    cod_comp integer DEFAULT nextval('agenda_pref_cod_comp_seq'::regclass) NOT NULL,
    data_comp date NOT NULL,
    hora_comp time without time zone NOT NULL,
    hora_f_comp time without time zone NOT NULL,
    comp_comp text NOT NULL,
    local_comp character(1) DEFAULT 'I'::bpchar NOT NULL,
    publico_comp character(1) DEFAULT 'S'::bpchar NOT NULL,
    agenda_de character(1) DEFAULT 'P'::bpchar,
    ref_cad integer,
    versao integer DEFAULT 1 NOT NULL,
    ref_auto_cod integer
);


ALTER TABLE agenda_pref OWNER TO postgres;

--
-- Name: agenda_responsavel; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE agenda_responsavel (
    ref_cod_agenda integer NOT NULL,
    ref_ref_cod_pessoa_fj integer NOT NULL,
    principal smallint
);


ALTER TABLE agenda_responsavel OWNER TO postgres;

--
-- Name: compras_editais_editais_cod_compras_editais_editais_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE compras_editais_editais_cod_compras_editais_editais_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE compras_editais_editais_cod_compras_editais_editais_seq OWNER TO postgres;

--
-- Name: compras_editais_editais; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE compras_editais_editais (
    cod_compras_editais_editais integer DEFAULT nextval('compras_editais_editais_cod_compras_editais_editais_seq'::regclass) NOT NULL,
    ref_cod_compras_licitacoes integer DEFAULT 0 NOT NULL,
    versao integer DEFAULT 0 NOT NULL,
    data_hora timestamp without time zone NOT NULL,
    arquivo character varying(255) DEFAULT ''::character varying NOT NULL,
    ref_ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL,
    motivo_alteracao text,
    visivel smallint DEFAULT 1 NOT NULL
);


ALTER TABLE compras_editais_editais OWNER TO postgres;

--
-- Name: compras_editais_editais_empresas; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE compras_editais_editais_empresas (
    ref_cod_compras_editais_editais integer DEFAULT 0 NOT NULL,
    ref_cod_compras_editais_empresa integer DEFAULT 0 NOT NULL,
    data_hora timestamp without time zone NOT NULL
);


ALTER TABLE compras_editais_editais_empresas OWNER TO postgres;

--
-- Name: compras_editais_empresa_cod_compras_editais_empresa_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE compras_editais_empresa_cod_compras_editais_empresa_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE compras_editais_empresa_cod_compras_editais_empresa_seq OWNER TO postgres;

--
-- Name: compras_editais_empresa; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE compras_editais_empresa (
    cod_compras_editais_empresa integer DEFAULT nextval('compras_editais_empresa_cod_compras_editais_empresa_seq'::regclass) NOT NULL,
    cnpj character varying(20) DEFAULT ''::character varying NOT NULL,
    nm_empresa character varying(255) DEFAULT ''::character varying NOT NULL,
    email character varying(255) DEFAULT ''::character varying NOT NULL,
    data_hora timestamp without time zone NOT NULL,
    endereco text,
    ref_sigla_uf character(2),
    cidade character varying(255),
    bairro character varying(255),
    telefone bigint,
    fax bigint,
    cep bigint,
    nome_contato character varying(255),
    senha character varying(32) DEFAULT ''::character varying NOT NULL
);


ALTER TABLE compras_editais_empresa OWNER TO postgres;

--
-- Name: compras_final_pregao_cod_compras_final_pregao_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE compras_final_pregao_cod_compras_final_pregao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE compras_final_pregao_cod_compras_final_pregao_seq OWNER TO postgres;

--
-- Name: compras_final_pregao; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE compras_final_pregao (
    cod_compras_final_pregao integer DEFAULT nextval('compras_final_pregao_cod_compras_final_pregao_seq'::regclass) NOT NULL,
    nm_final character varying(255) DEFAULT ''::character varying NOT NULL
);


ALTER TABLE compras_final_pregao OWNER TO postgres;

--
-- Name: compras_funcionarios; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE compras_funcionarios (
    ref_ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL
);


ALTER TABLE compras_funcionarios OWNER TO postgres;

--
-- Name: compras_licitacoes_cod_compras_licitacoes_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE compras_licitacoes_cod_compras_licitacoes_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE compras_licitacoes_cod_compras_licitacoes_seq OWNER TO postgres;

--
-- Name: compras_licitacoes; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE compras_licitacoes (
    cod_compras_licitacoes integer DEFAULT nextval('compras_licitacoes_cod_compras_licitacoes_seq'::regclass) NOT NULL,
    ref_ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL,
    ref_cod_compras_modalidade integer DEFAULT 0 NOT NULL,
    numero character varying(30) DEFAULT ''::character varying NOT NULL,
    objeto text NOT NULL,
    data_hora timestamp without time zone NOT NULL,
    cod_licitacao_semasa integer,
    oculto boolean DEFAULT false
);


ALTER TABLE compras_licitacoes OWNER TO postgres;

--
-- Name: compras_modalidade_cod_compras_modalidade_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE compras_modalidade_cod_compras_modalidade_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE compras_modalidade_cod_compras_modalidade_seq OWNER TO postgres;

--
-- Name: compras_modalidade; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE compras_modalidade (
    cod_compras_modalidade integer DEFAULT nextval('compras_modalidade_cod_compras_modalidade_seq'::regclass) NOT NULL,
    nm_modalidade character varying(255) DEFAULT ''::character varying NOT NULL
);


ALTER TABLE compras_modalidade OWNER TO postgres;

--
-- Name: compras_pregao_execucao_cod_compras_pregao_execucao_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE compras_pregao_execucao_cod_compras_pregao_execucao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE compras_pregao_execucao_cod_compras_pregao_execucao_seq OWNER TO postgres;

--
-- Name: compras_pregao_execucao; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE compras_pregao_execucao (
    cod_compras_pregao_execucao integer DEFAULT nextval('compras_pregao_execucao_cod_compras_pregao_execucao_seq'::regclass) NOT NULL,
    ref_cod_compras_licitacoes integer DEFAULT 0 NOT NULL,
    ref_pregoeiro integer DEFAULT 0 NOT NULL,
    ref_equipe1 integer DEFAULT 0 NOT NULL,
    ref_equipe2 integer DEFAULT 0 NOT NULL,
    ref_equipe3 integer DEFAULT 0 NOT NULL,
    ano_processo integer,
    mes_processo integer,
    seq_processo integer,
    seq_portaria integer,
    ano_portaria integer,
    valor_referencia double precision,
    valor_real double precision,
    ref_cod_compras_final_pregao integer
);


ALTER TABLE compras_pregao_execucao OWNER TO postgres;

--
-- Name: compras_prestacao_contas_cod_compras_prestacao_contas_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE compras_prestacao_contas_cod_compras_prestacao_contas_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE compras_prestacao_contas_cod_compras_prestacao_contas_seq OWNER TO postgres;

--
-- Name: compras_prestacao_contas; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE compras_prestacao_contas (
    cod_compras_prestacao_contas integer DEFAULT nextval('compras_prestacao_contas_cod_compras_prestacao_contas_seq'::regclass) NOT NULL,
    caminho character varying(255) DEFAULT ''::character varying NOT NULL,
    mes integer DEFAULT 0 NOT NULL,
    ano integer DEFAULT 0 NOT NULL
);


ALTER TABLE compras_prestacao_contas OWNER TO postgres;

--
-- Name: foto_portal_cod_foto_portal_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE foto_portal_cod_foto_portal_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE foto_portal_cod_foto_portal_seq OWNER TO postgres;

--
-- Name: foto_portal; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE foto_portal (
    cod_foto_portal integer DEFAULT nextval('foto_portal_cod_foto_portal_seq'::regclass) NOT NULL,
    ref_cod_foto_secao integer,
    ref_cod_credito integer,
    ref_ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL,
    data_foto timestamp without time zone,
    titulo character varying(255),
    descricao text,
    caminho character varying(255),
    altura integer,
    largura integer,
    nm_credito character varying(255),
    bkp_ref_secao bigint
);


ALTER TABLE foto_portal OWNER TO postgres;

--
-- Name: foto_secao_cod_foto_secao_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE foto_secao_cod_foto_secao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE foto_secao_cod_foto_secao_seq OWNER TO postgres;

--
-- Name: foto_secao; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE foto_secao (
    cod_foto_secao integer DEFAULT nextval('foto_secao_cod_foto_secao_seq'::regclass) NOT NULL,
    nm_secao character varying(255)
);


ALTER TABLE foto_secao OWNER TO postgres;

--
-- Name: funcionario; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE funcionario (
    ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL,
    matricula character varying(12),
    senha character varying(32),
    ativo smallint,
    ref_sec integer,
    ramal character varying(10),
    sequencial character(3),
    opcao_menu text,
    ref_cod_setor integer,
    ref_cod_funcionario_vinculo integer,
    tempo_expira_senha integer,
    tempo_expira_conta integer,
    data_troca_senha date,
    data_reativa_conta date,
    ref_ref_cod_pessoa_fj integer,
    proibido integer DEFAULT 0 NOT NULL,
    ref_cod_setor_new integer,
    matricula_new bigint,
    matricula_permanente smallint DEFAULT 0,
    tipo_menu smallint DEFAULT 0 NOT NULL,
    ip_logado character varying(50),
    data_login timestamp without time zone,
    email character varying(50),
    status_token character varying(50),
    matricula_interna character varying(30),
    receber_novidades smallint,
    atualizou_cadastro smallint
);


ALTER TABLE funcionario OWNER TO postgres;

--
-- Name: funcionario_vinculo_cod_funcionario_vinculo_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE funcionario_vinculo_cod_funcionario_vinculo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE funcionario_vinculo_cod_funcionario_vinculo_seq OWNER TO postgres;

--
-- Name: funcionario_vinculo; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE funcionario_vinculo (
    cod_funcionario_vinculo integer DEFAULT nextval('funcionario_vinculo_cod_funcionario_vinculo_seq'::regclass) NOT NULL,
    nm_vinculo character varying(255) DEFAULT ''::character varying NOT NULL
);


ALTER TABLE funcionario_vinculo OWNER TO postgres;

--
-- Name: imagem_cod_imagem_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE imagem_cod_imagem_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE imagem_cod_imagem_seq OWNER TO postgres;

--
-- Name: imagem; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE imagem (
    cod_imagem integer DEFAULT nextval('imagem_cod_imagem_seq'::regclass) NOT NULL,
    ref_cod_imagem_tipo integer NOT NULL,
    caminho character varying(255) NOT NULL,
    nm_imagem character varying(100),
    extensao character(3) NOT NULL,
    altura integer,
    largura integer,
    data_cadastro timestamp without time zone NOT NULL,
    ref_cod_pessoa_cad integer NOT NULL,
    data_exclusao timestamp without time zone,
    ref_cod_pessoa_exc integer
);


ALTER TABLE imagem OWNER TO postgres;

--
-- Name: imagem_tipo_cod_imagem_tipo_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE imagem_tipo_cod_imagem_tipo_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE imagem_tipo_cod_imagem_tipo_seq OWNER TO postgres;

--
-- Name: imagem_tipo; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE imagem_tipo (
    cod_imagem_tipo integer DEFAULT nextval('imagem_tipo_cod_imagem_tipo_seq'::regclass) NOT NULL,
    nm_tipo character varying(100) NOT NULL
);


ALTER TABLE imagem_tipo OWNER TO postgres;

--
-- Name: intranet_segur_permissao_nega_cod_intranet_segur_permissao__seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE intranet_segur_permissao_nega_cod_intranet_segur_permissao__seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE intranet_segur_permissao_nega_cod_intranet_segur_permissao__seq OWNER TO postgres;

--
-- Name: intranet_segur_permissao_negada; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE intranet_segur_permissao_negada (
    cod_intranet_segur_permissao_negada integer DEFAULT nextval('intranet_segur_permissao_nega_cod_intranet_segur_permissao__seq'::regclass) NOT NULL,
    ref_ref_cod_pessoa_fj integer,
    ip_externo character varying(15) DEFAULT ''::character varying NOT NULL,
    ip_interno character varying(255),
    data_hora timestamp without time zone NOT NULL,
    pagina character varying(255),
    variaveis text
);


ALTER TABLE intranet_segur_permissao_negada OWNER TO postgres;

--
-- Name: jor_arquivo; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE jor_arquivo (
    ref_cod_jor_edicao integer DEFAULT 0 NOT NULL,
    jor_arquivo smallint DEFAULT (0)::smallint NOT NULL,
    jor_caminho character varying(255) DEFAULT ''::character varying NOT NULL
);


ALTER TABLE jor_arquivo OWNER TO postgres;

--
-- Name: jor_edicao_cod_jor_edicao_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE jor_edicao_cod_jor_edicao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE jor_edicao_cod_jor_edicao_seq OWNER TO postgres;

--
-- Name: jor_edicao; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE jor_edicao (
    cod_jor_edicao integer DEFAULT nextval('jor_edicao_cod_jor_edicao_seq'::regclass) NOT NULL,
    ref_ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL,
    jor_ano_edicao character varying(5) DEFAULT ''::character varying NOT NULL,
    jor_edicao integer DEFAULT 0 NOT NULL,
    jor_dt_inicial date NOT NULL,
    jor_dt_final date,
    jor_extra smallint DEFAULT (0)::smallint
);


ALTER TABLE jor_edicao OWNER TO postgres;

--
-- Name: mailling_email_cod_mailling_email_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE mailling_email_cod_mailling_email_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE mailling_email_cod_mailling_email_seq OWNER TO postgres;

--
-- Name: mailling_email; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE mailling_email (
    cod_mailling_email integer DEFAULT nextval('mailling_email_cod_mailling_email_seq'::regclass) NOT NULL,
    nm_pessoa character varying(255) DEFAULT ''::character varying NOT NULL,
    email character varying(255) DEFAULT ''::character varying NOT NULL
);


ALTER TABLE mailling_email OWNER TO postgres;

--
-- Name: mailling_email_conteudo_cod_mailling_email_conteudo_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE mailling_email_conteudo_cod_mailling_email_conteudo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE mailling_email_conteudo_cod_mailling_email_conteudo_seq OWNER TO postgres;

--
-- Name: mailling_email_conteudo; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE mailling_email_conteudo (
    cod_mailling_email_conteudo integer DEFAULT nextval('mailling_email_conteudo_cod_mailling_email_conteudo_seq'::regclass) NOT NULL,
    ref_ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL,
    conteudo text NOT NULL,
    nm_remetente character varying(255),
    email_remetente character varying(255),
    assunto character varying(255)
);


ALTER TABLE mailling_email_conteudo OWNER TO postgres;

--
-- Name: mailling_fila_envio_cod_mailling_fila_envio_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE mailling_fila_envio_cod_mailling_fila_envio_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE mailling_fila_envio_cod_mailling_fila_envio_seq OWNER TO postgres;

--
-- Name: mailling_fila_envio; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE mailling_fila_envio (
    cod_mailling_fila_envio integer DEFAULT nextval('mailling_fila_envio_cod_mailling_fila_envio_seq'::regclass) NOT NULL,
    ref_cod_mailling_email_conteudo integer DEFAULT 0 NOT NULL,
    ref_cod_mailling_email integer,
    ref_ref_cod_pessoa_fj integer,
    data_cadastro timestamp without time zone NOT NULL,
    data_envio timestamp without time zone
);


ALTER TABLE mailling_fila_envio OWNER TO postgres;

--
-- Name: mailling_grupo_cod_mailling_grupo_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE mailling_grupo_cod_mailling_grupo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE mailling_grupo_cod_mailling_grupo_seq OWNER TO postgres;

--
-- Name: mailling_grupo; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE mailling_grupo (
    cod_mailling_grupo integer DEFAULT nextval('mailling_grupo_cod_mailling_grupo_seq'::regclass) NOT NULL,
    nm_grupo character varying(255) DEFAULT ''::character varying NOT NULL
);


ALTER TABLE mailling_grupo OWNER TO postgres;

--
-- Name: mailling_grupo_email; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE mailling_grupo_email (
    ref_cod_mailling_email integer DEFAULT 0 NOT NULL,
    ref_cod_mailling_grupo integer DEFAULT 0 NOT NULL
);


ALTER TABLE mailling_grupo_email OWNER TO postgres;

--
-- Name: mailling_historico_cod_mailling_historico_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE mailling_historico_cod_mailling_historico_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE mailling_historico_cod_mailling_historico_seq OWNER TO postgres;

--
-- Name: mailling_historico; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE mailling_historico (
    cod_mailling_historico integer DEFAULT nextval('mailling_historico_cod_mailling_historico_seq'::regclass) NOT NULL,
    ref_cod_not_portal integer DEFAULT 0 NOT NULL,
    ref_cod_mailling_grupo integer DEFAULT 0 NOT NULL,
    ref_ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL,
    data_hora timestamp without time zone NOT NULL
);


ALTER TABLE mailling_historico OWNER TO postgres;

--
-- Name: menu_funcionario; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE menu_funcionario (
    ref_ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL,
    cadastra smallint DEFAULT (0)::smallint NOT NULL,
    exclui smallint DEFAULT (0)::smallint NOT NULL,
    ref_cod_menu_submenu integer DEFAULT 0 NOT NULL
);


ALTER TABLE menu_funcionario OWNER TO postgres;

--
-- Name: menu_menu_cod_menu_menu_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE menu_menu_cod_menu_menu_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE menu_menu_cod_menu_menu_seq OWNER TO postgres;

--
-- Name: menu_menu; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE menu_menu (
    cod_menu_menu integer DEFAULT nextval('menu_menu_cod_menu_menu_seq'::regclass) NOT NULL,
    nm_menu character varying(255) DEFAULT ''::character varying NOT NULL,
    title character varying(255),
    ref_cod_menu_pai integer,
    caminho character varying(255) DEFAULT '#'::character varying,
    ord_menu integer DEFAULT 9999,
    ativo boolean DEFAULT true,
    icon_class character varying(20)
);


ALTER TABLE menu_menu OWNER TO postgres;

--
-- Name: menu_submenu_cod_menu_submenu_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE menu_submenu_cod_menu_submenu_seq
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE menu_submenu_cod_menu_submenu_seq OWNER TO postgres;

--
-- Name: menu_submenu; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE menu_submenu (
    cod_menu_submenu integer DEFAULT nextval('menu_submenu_cod_menu_submenu_seq'::regclass) NOT NULL,
    ref_cod_menu_menu integer,
    cod_sistema integer,
    nm_submenu character varying(255) DEFAULT ''::character varying NOT NULL,
    arquivo character varying(255) DEFAULT ''::character varying NOT NULL,
    title text,
    nivel smallint DEFAULT (3)::smallint NOT NULL
);


ALTER TABLE menu_submenu OWNER TO postgres;

--
-- Name: not_portal_cod_not_portal_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE not_portal_cod_not_portal_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE not_portal_cod_not_portal_seq OWNER TO postgres;

--
-- Name: not_portal; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE not_portal (
    cod_not_portal integer DEFAULT nextval('not_portal_cod_not_portal_seq'::regclass) NOT NULL,
    ref_ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL,
    titulo character varying(255),
    descricao text,
    data_noticia timestamp without time zone NOT NULL
);


ALTER TABLE not_portal OWNER TO postgres;

--
-- Name: not_portal_tipo; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE not_portal_tipo (
    ref_cod_not_portal integer DEFAULT 0 NOT NULL,
    ref_cod_not_tipo integer DEFAULT 0 NOT NULL
);


ALTER TABLE not_portal_tipo OWNER TO postgres;

--
-- Name: not_tipo_cod_not_tipo_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE not_tipo_cod_not_tipo_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE not_tipo_cod_not_tipo_seq OWNER TO postgres;

--
-- Name: not_tipo; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE not_tipo (
    cod_not_tipo integer DEFAULT nextval('not_tipo_cod_not_tipo_seq'::regclass) NOT NULL,
    nm_tipo character varying(255) DEFAULT ''::character varying NOT NULL
);


ALTER TABLE not_tipo OWNER TO postgres;

--
-- Name: not_vinc_portal; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE not_vinc_portal (
    ref_cod_not_portal integer DEFAULT 0 NOT NULL,
    vic_num integer DEFAULT 0 NOT NULL,
    tipo character(1) DEFAULT 'F'::bpchar NOT NULL,
    cod_vinc integer,
    caminho character varying(255),
    nome_arquivo character varying(255)
);


ALTER TABLE not_vinc_portal OWNER TO postgres;

--
-- Name: notificacao_cod_notificacao_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE notificacao_cod_notificacao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE notificacao_cod_notificacao_seq OWNER TO postgres;

--
-- Name: notificacao; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE notificacao (
    cod_notificacao integer DEFAULT nextval('notificacao_cod_notificacao_seq'::regclass) NOT NULL,
    ref_cod_funcionario integer NOT NULL,
    titulo character varying,
    conteudo text,
    data_hora_ativa timestamp without time zone,
    url character varying,
    visualizacoes smallint DEFAULT 0 NOT NULL
);


ALTER TABLE notificacao OWNER TO postgres;

--
-- Name: pessoa_atividade_cod_pessoa_atividade_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE pessoa_atividade_cod_pessoa_atividade_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE pessoa_atividade_cod_pessoa_atividade_seq OWNER TO postgres;

--
-- Name: pessoa_atividade; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE pessoa_atividade (
    cod_pessoa_atividade integer DEFAULT nextval('pessoa_atividade_cod_pessoa_atividade_seq'::regclass) NOT NULL,
    ref_cod_ramo_atividade integer DEFAULT 0 NOT NULL,
    nm_atividade character varying(255)
);


ALTER TABLE pessoa_atividade OWNER TO postgres;

--
-- Name: pessoa_fj_cod_pessoa_fj_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE pessoa_fj_cod_pessoa_fj_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE pessoa_fj_cod_pessoa_fj_seq OWNER TO postgres;

--
-- Name: pessoa_fj; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE pessoa_fj (
    cod_pessoa_fj integer DEFAULT nextval('pessoa_fj_cod_pessoa_fj_seq'::regclass) NOT NULL,
    nm_pessoa character varying(255) DEFAULT ''::character varying NOT NULL,
    id_federal character varying(30),
    endereco text,
    cep character varying(9),
    ref_bairro integer,
    ddd_telefone_1 integer,
    telefone_1 character varying(15),
    ddd_telefone_2 integer,
    telefone_2 character varying(15),
    ddd_telefone_mov integer,
    telefone_mov character varying(15),
    ddd_telefone_fax integer,
    telefone_fax character varying(15),
    email character varying(255),
    http character varying(255),
    tipo_pessoa character(1) DEFAULT 'F'::bpchar NOT NULL,
    sexo smallint,
    razao_social character varying(255),
    ins_est character varying(30),
    ins_mun character varying(30),
    rg character varying(30),
    ref_cod_pessoa_pai integer,
    ref_cod_pessoa_mae integer,
    data_nasc date,
    ref_ref_cod_pessoa_fj integer
);


ALTER TABLE pessoa_fj OWNER TO postgres;

--
-- Name: pessoa_fj_pessoa_atividade; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE pessoa_fj_pessoa_atividade (
    ref_cod_pessoa_atividade integer DEFAULT 0 NOT NULL,
    ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL
);


ALTER TABLE pessoa_fj_pessoa_atividade OWNER TO postgres;

--
-- Name: pessoa_ramo_atividade_cod_ramo_atividade_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE pessoa_ramo_atividade_cod_ramo_atividade_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE pessoa_ramo_atividade_cod_ramo_atividade_seq OWNER TO postgres;

--
-- Name: pessoa_ramo_atividade; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE pessoa_ramo_atividade (
    cod_ramo_atividade integer DEFAULT nextval('pessoa_ramo_atividade_cod_ramo_atividade_seq'::regclass) NOT NULL,
    nm_ramo_atividade character varying(255)
);


ALTER TABLE pessoa_ramo_atividade OWNER TO postgres;

--
-- Name: portal_banner_cod_portal_banner_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE portal_banner_cod_portal_banner_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE portal_banner_cod_portal_banner_seq OWNER TO postgres;

--
-- Name: portal_concurso_cod_portal_concurso_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE portal_concurso_cod_portal_concurso_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE portal_concurso_cod_portal_concurso_seq OWNER TO postgres;

--
-- Name: portal_concurso; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE portal_concurso (
    cod_portal_concurso integer DEFAULT nextval('portal_concurso_cod_portal_concurso_seq'::regclass) NOT NULL,
    ref_ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL,
    nm_concurso character varying(255) DEFAULT ''::character varying NOT NULL,
    descricao text,
    caminho character varying(255) DEFAULT ''::character varying NOT NULL,
    tipo_arquivo character(3) DEFAULT ''::bpchar NOT NULL,
    data_hora timestamp without time zone
);


ALTER TABLE portal_concurso OWNER TO postgres;

--
-- Name: sistema_cod_sistema_seq; Type: SEQUENCE; Schema: portal; Owner: postgres
--

CREATE SEQUENCE sistema_cod_sistema_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE sistema_cod_sistema_seq OWNER TO postgres;

--
-- Name: sistema; Type: TABLE; Schema: portal; Owner: postgres
--

CREATE TABLE sistema (
    cod_sistema integer DEFAULT nextval('sistema_cod_sistema_seq'::regclass) NOT NULL,
    nome character varying(255),
    versao smallint NOT NULL,
    release smallint NOT NULL,
    patch smallint NOT NULL,
    tipo character varying(255)
);


ALTER TABLE sistema OWNER TO postgres;

--
-- Name: v_funcionario; Type: VIEW; Schema: portal; Owner: postgres
--

CREATE VIEW v_funcionario AS
 SELECT f.ref_cod_pessoa_fj,
    f.matricula,
    f.matricula_interna,
    f.senha,
    f.ativo,
    f.ramal,
    f.sequencial,
    f.opcao_menu,
    f.ref_cod_setor,
    f.ref_cod_funcionario_vinculo,
    f.tempo_expira_senha,
    f.tempo_expira_conta,
    f.data_troca_senha,
    f.data_reativa_conta,
    f.ref_ref_cod_pessoa_fj,
    f.proibido,
    f.ref_cod_setor_new,
    f.email,
    ( SELECT pessoa.nome
           FROM cadastro.pessoa
          WHERE (pessoa.idpes = (f.ref_cod_pessoa_fj)::numeric)) AS nome
   FROM funcionario f;


ALTER TABLE v_funcionario OWNER TO postgres;

SET search_path = public, pg_catalog;

--
-- Name: bairro_regiao; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE bairro_regiao (
    ref_cod_regiao integer NOT NULL,
    ref_idbai integer NOT NULL
);


ALTER TABLE bairro_regiao OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: changelog; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE changelog (
    change_number bigint NOT NULL,
    delta_set character varying(10) NOT NULL,
    start_dt timestamp without time zone NOT NULL,
    complete_dt timestamp without time zone,
    applied_by character varying(100) NOT NULL,
    description character varying(500) NOT NULL
);


ALTER TABLE changelog OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: distrito; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE distrito (
    idmun numeric(6,0) NOT NULL,
    geom character varying,
    iddis numeric(6,0) DEFAULT nextval(('public.seq_distrito'::text)::regclass) NOT NULL,
    nome character varying(80) NOT NULL,
    cod_ibge character varying(7),
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    CONSTRAINT ck_distrito_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar))),
    CONSTRAINT ck_distrito_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar)))
);


ALTER TABLE distrito OWNER TO postgres;

--
-- Name: logradouro_fonetico; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE logradouro_fonetico (
    fonema character varying(30) NOT NULL,
    idlog numeric(8,0) NOT NULL
);


ALTER TABLE logradouro_fonetico OWNER TO postgres;

--
-- Name: pais; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE pais (
    idpais numeric(3,0) NOT NULL,
    nome character varying(60) NOT NULL,
    geom character varying,
    cod_ibge integer
);


ALTER TABLE pais OWNER TO postgres;

SET default_with_oids = false;

--
-- Name: pghero_query_stats; Type: TABLE; Schema: public; Owner: ieducar
--

CREATE TABLE pghero_query_stats (
    id integer NOT NULL,
    database text,
    "user" text,
    query text,
    query_hash bigint,
    total_time double precision,
    calls bigint,
    captured_at timestamp without time zone
);


ALTER TABLE pghero_query_stats OWNER TO ieducar;

--
-- Name: pghero_query_stats_id_seq; Type: SEQUENCE; Schema: public; Owner: ieducar
--

CREATE SEQUENCE pghero_query_stats_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE pghero_query_stats_id_seq OWNER TO ieducar;

--
-- Name: pghero_query_stats_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: ieducar
--

ALTER SEQUENCE pghero_query_stats_id_seq OWNED BY pghero_query_stats.id;

--
-- Name: portal_banner_cod_portal_banner_seq; Type: SEQUENCE; Schema: public; Owner: ieducar
--

CREATE SEQUENCE portal_banner_cod_portal_banner_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE portal_banner_cod_portal_banner_seq OWNER TO ieducar;

--
-- Name: portal_banner; Type: TABLE; Schema: public; Owner: ieducar
--

CREATE TABLE portal_banner (
    cod_portal_banner integer DEFAULT nextval('portal_banner_cod_portal_banner_seq'::regclass) NOT NULL,
    ref_ref_cod_pessoa_fj integer DEFAULT 0 NOT NULL,
    caminho character varying(255) DEFAULT ''::character varying NOT NULL,
    title character varying(255),
    prioridade integer DEFAULT 0 NOT NULL,
    link character varying(255) DEFAULT ''::character varying NOT NULL,
    lateral_ smallint DEFAULT (1)::smallint NOT NULL
);


ALTER TABLE portal_banner OWNER TO ieducar;

--
-- Name: regiao_cod_regiao_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE regiao_cod_regiao_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE regiao_cod_regiao_seq OWNER TO postgres;

SET default_with_oids = true;

--
-- Name: regiao; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE regiao (
    cod_regiao integer DEFAULT nextval('regiao_cod_regiao_seq'::regclass) NOT NULL,
    nm_regiao character varying(100)
);


ALTER TABLE regiao OWNER TO postgres;

--
-- Name: seq_bairro; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE seq_bairro
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE seq_bairro OWNER TO postgres;

--
-- Name: seq_distrito; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE seq_distrito
    START WITH 0
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE seq_distrito OWNER TO postgres;

--
-- Name: seq_logradouro; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE seq_logradouro
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE seq_logradouro OWNER TO postgres;

--
-- Name: seq_municipio; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE seq_municipio
    START WITH 5565
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE seq_municipio OWNER TO postgres;

--
-- Name: seq_setor_bai; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE seq_setor_bai
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE seq_setor_bai OWNER TO postgres;

--
-- Name: setor_idset_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE setor_idset_seq
    START WITH 1
    INCREMENT BY 1
    MINVALUE 0
    NO MAXVALUE
    CACHE 1;


ALTER TABLE setor_idset_seq OWNER TO postgres;

--
-- Name: setor; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE setor (
    idset integer DEFAULT nextval('setor_idset_seq'::regclass) NOT NULL,
    nivel numeric(1,0) NOT NULL,
    nome character varying(100) NOT NULL,
    sigla character varying(25),
    idsetsub integer,
    idsetredir integer,
    situacao character(1) NOT NULL,
    localizacao character(1) NOT NULL,
    CONSTRAINT ck_setor_localizacao CHECK (((localizacao = 'E'::bpchar) OR (localizacao = 'I'::bpchar))),
    CONSTRAINT ck_setor_situacao CHECK (((situacao = 'A'::bpchar) OR (situacao = 'I'::bpchar)))
);


ALTER TABLE setor OWNER TO postgres;

--
-- Name: setor_bai; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE setor_bai (
    idsetorbai numeric(6,0) DEFAULT nextval(('public.seq_setor_bai'::text)::regclass) NOT NULL,
    nome character varying(80) NOT NULL
);


ALTER TABLE setor_bai OWNER TO postgres;

--
-- Name: uf; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE uf (
    sigla_uf character varying(3) NOT NULL,
    nome character varying(30) NOT NULL,
    geom character varying,
    idpais numeric(3,0),
    cod_ibge numeric(6,0)
);


ALTER TABLE uf OWNER TO postgres;

--
-- Name: vila; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE vila (
    idvil numeric(4,0) NOT NULL,
    idmun numeric(6,0) NOT NULL,
    nome character varying(50) NOT NULL,
    geom character varying
);


ALTER TABLE vila OWNER TO postgres;

SET search_path = urbano, pg_catalog;

--
-- Name: tipo_logradouro; Type: TABLE; Schema: urbano; Owner: postgres
--

CREATE TABLE tipo_logradouro (
    idtlog character varying(5) NOT NULL,
    descricao character varying(40) NOT NULL
);


ALTER TABLE tipo_logradouro OWNER TO postgres;

SET search_path = serieciasc, pg_catalog;

SET default_with_oids = false;

--
-- Name: aluno_cod_aluno; Type: TABLE; Schema: serieciasc; Owner: postgres
--

CREATE TABLE aluno_cod_aluno (
    cod_aluno integer NOT NULL,
    cod_ciasc bigint NOT NULL,
    user_id integer,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


ALTER TABLE aluno_cod_aluno OWNER TO postgres;

--
-- Name: aluno_uniforme; Type: TABLE; Schema: serieciasc; Owner: postgres
--

CREATE TABLE aluno_uniforme (
    ref_cod_aluno integer NOT NULL,
    data_recebimento timestamp without time zone NOT NULL,
    camiseta character(2),
    quantidade_camiseta integer,
    bermuda character(2),
    quantidade_bermuda integer,
    jaqueta character(2),
    quantidade_jaqueta integer,
    calca character(2),
    quantidade_calca integer,
    meia character(2),
    quantidade_meia integer,
    tenis character(2),
    quantidade_tenis integer,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


ALTER TABLE aluno_uniforme OWNER TO postgres;

--
-- Name: escola_agua; Type: TABLE; Schema: serieciasc; Owner: postgres
--

CREATE TABLE escola_agua (
    ref_cod_escola integer NOT NULL,
    rede_publica integer DEFAULT 0,
    poco_artesiano integer DEFAULT 0,
    cisterna integer DEFAULT 0,
    fonte_rio integer DEFAULT 0,
    inexistente integer DEFAULT 0,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


ALTER TABLE escola_agua OWNER TO postgres;

--
-- Name: escola_energia; Type: TABLE; Schema: serieciasc; Owner: postgres
--

CREATE TABLE escola_energia (
    ref_cod_escola integer NOT NULL,
    rede_publica integer DEFAULT 0,
    gerador_proprio integer DEFAULT 0,
    solar integer DEFAULT 0,
    eolica integer DEFAULT 0,
    inexistente integer DEFAULT 0,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


ALTER TABLE escola_energia OWNER TO postgres;

--
-- Name: escola_lingua_indigena; Type: TABLE; Schema: serieciasc; Owner: postgres
--

CREATE TABLE escola_lingua_indigena (
    ref_cod_escola integer NOT NULL,
    educacao_indigena integer DEFAULT 0,
    lingua_indigena integer DEFAULT 0,
    lingua_portuguesa integer DEFAULT 0,
    materiais_especificos integer DEFAULT 0,
    ue_terra_indigena integer DEFAULT 0,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


ALTER TABLE escola_lingua_indigena OWNER TO postgres;

--
-- Name: escola_lixo; Type: TABLE; Schema: serieciasc; Owner: postgres
--

CREATE TABLE escola_lixo (
    ref_cod_escola integer NOT NULL,
    coleta integer DEFAULT 0,
    queima integer DEFAULT 0,
    outra_area integer DEFAULT 0,
    recicla integer DEFAULT 0,
    reutiliza integer DEFAULT 0,
    enterra integer DEFAULT 0,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


ALTER TABLE escola_lixo OWNER TO postgres;

--
-- Name: escola_projeto; Type: TABLE; Schema: serieciasc; Owner: postgres
--

CREATE TABLE escola_projeto (
    ref_cod_escola integer NOT NULL,
    danca integer DEFAULT 0,
    folclorico integer DEFAULT 0,
    teatral integer DEFAULT 0,
    ambiental integer DEFAULT 0,
    coral integer DEFAULT 0,
    fanfarra integer DEFAULT 0,
    artes_plasticas integer DEFAULT 0,
    integrada integer DEFAULT 0,
    ambiente_alimentacao integer DEFAULT 0,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


ALTER TABLE escola_projeto OWNER TO postgres;

--
-- Name: escola_regulamentacao; Type: TABLE; Schema: serieciasc; Owner: postgres
--

CREATE TABLE escola_regulamentacao (
    ref_cod_escola integer NOT NULL,
    regulamentacao integer DEFAULT 1 NOT NULL,
    situacao integer DEFAULT 1 NOT NULL,
    data_criacao date,
    ato_criacao integer DEFAULT 0,
    numero_ato_criacao character varying(20),
    data_ato_criacao date,
    ato_paralizacao integer DEFAULT 0,
    numero_ato_paralizacao character varying(20),
    data_ato_paralizacao date,
    data_extincao date,
    ato_extincao integer DEFAULT 0,
    numero_ato_extincao character varying(20),
    data_ato_extincao date,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


ALTER TABLE escola_regulamentacao OWNER TO postgres;

--
-- Name: escola_sanitario; Type: TABLE; Schema: serieciasc; Owner: postgres
--

CREATE TABLE escola_sanitario (
    ref_cod_escola integer NOT NULL,
    rede_publica integer DEFAULT 0,
    fossa integer DEFAULT 0,
    inexistente integer DEFAULT 0,
    created_at timestamp without time zone NOT NULL,
    updated_at timestamp without time zone
);


ALTER TABLE escola_sanitario OWNER TO postgres;

SET search_path = urbano, pg_catalog;

SET default_with_oids = true;

--
-- Name: cep_logradouro; Type: TABLE; Schema: urbano; Owner: postgres
--

CREATE TABLE cep_logradouro (
    cep numeric(8,0) NOT NULL,
    idlog numeric(6,0) NOT NULL,
    nroini numeric(6,0),
    nrofin numeric(6,0),
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    CONSTRAINT ck_cep_logradouro_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_logradouro_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar)))
);


ALTER TABLE cep_logradouro OWNER TO postgres;

--
-- Name: cep_logradouro_bairro; Type: TABLE; Schema: urbano; Owner: postgres
--

CREATE TABLE cep_logradouro_bairro (
    idlog numeric(6,0) NOT NULL,
    cep numeric(8,0) NOT NULL,
    idbai numeric(6,0) NOT NULL,
    idpes_rev numeric,
    data_rev timestamp without time zone,
    origem_gravacao character(1) NOT NULL,
    idpes_cad numeric,
    data_cad timestamp without time zone NOT NULL,
    operacao character(1) NOT NULL,
    idsis_rev integer,
    idsis_cad integer NOT NULL,
    CONSTRAINT ck_cep_logradouro_bairro_origem_gravacao CHECK (((origem_gravacao = 'M'::bpchar) OR (origem_gravacao = 'U'::bpchar) OR (origem_gravacao = 'C'::bpchar) OR (origem_gravacao = 'O'::bpchar))),
    CONSTRAINT ck_logradouro_operacao CHECK (((operacao = 'I'::bpchar) OR (operacao = 'A'::bpchar) OR (operacao = 'E'::bpchar)))
);


ALTER TABLE cep_logradouro_bairro OWNER TO postgres;

SET search_path = modules, pg_catalog;

--
-- Name: id; Type: DEFAULT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY area_conhecimento ALTER COLUMN id SET DEFAULT nextval('area_conhecimento_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY componente_curricular ALTER COLUMN id SET DEFAULT nextval('componente_curricular_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY docente_licenciatura ALTER COLUMN id SET DEFAULT nextval('docente_licenciatura_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY educacenso_curso_superior ALTER COLUMN id SET DEFAULT nextval('educacenso_curso_superior_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY educacenso_ies ALTER COLUMN id SET DEFAULT nextval('educacenso_ies_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY falta_aluno ALTER COLUMN id SET DEFAULT nextval('falta_aluno_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY falta_componente_curricular ALTER COLUMN id SET DEFAULT nextval('falta_componente_curricular_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY falta_geral ALTER COLUMN id SET DEFAULT nextval('falta_geral_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY formula_media ALTER COLUMN id SET DEFAULT nextval('formula_media_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY nota_aluno ALTER COLUMN id SET DEFAULT nextval('nota_aluno_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY nota_componente_curricular ALTER COLUMN id SET DEFAULT nextval('nota_componente_curricular_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY parecer_aluno ALTER COLUMN id SET DEFAULT nextval('parecer_aluno_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY parecer_componente_curricular ALTER COLUMN id SET DEFAULT nextval('parecer_componente_curricular_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY parecer_geral ALTER COLUMN id SET DEFAULT nextval('parecer_geral_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY regra_avaliacao ALTER COLUMN id SET DEFAULT nextval('regra_avaliacao_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY tabela_arredondamento ALTER COLUMN id SET DEFAULT nextval('tabela_arredondamento_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY tabela_arredondamento_valor ALTER COLUMN id SET DEFAULT nextval('tabela_arredondamento_valor_id_seq'::regclass);


SET search_path = pmieducar, pg_catalog;

--
-- Name: id; Type: DEFAULT; Schema: pmieducar; Owner: ieducar
--

ALTER TABLE ONLY auditoria_falta_componente_dispensa ALTER COLUMN id SET DEFAULT nextval('auditoria_falta_componente_dispensa_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: pmieducar; Owner: ieducar
--

ALTER TABLE ONLY auditoria_nota_dispensa ALTER COLUMN id SET DEFAULT nextval('auditoria_nota_dispensa_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: pmieducar; Owner: ieducar
--

ALTER TABLE ONLY backup ALTER COLUMN id SET DEFAULT nextval('backup_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY categoria_obra ALTER COLUMN id SET DEFAULT nextval('categoria_obra_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: pmieducar; Owner: ieducar
--

ALTER TABLE ONLY escola_usuario ALTER COLUMN id SET DEFAULT nextval('escola_usuario_id_seq'::regclass);


SET search_path = public, pg_catalog;

--
-- Name: id; Type: DEFAULT; Schema: public; Owner: ieducar
--

ALTER TABLE ONLY pghero_query_stats ALTER COLUMN id SET DEFAULT nextval('pghero_query_stats_id_seq'::regclass);


SET search_path = acesso, pg_catalog;

--
-- Data for Name: funcao; Type: TABLE DATA; Schema: acesso; Owner: postgres
--



--
-- Name: funcao_idfunc_seq; Type: SEQUENCE SET; Schema: acesso; Owner: postgres
--

SELECT pg_catalog.setval('funcao_idfunc_seq', 1, false);


--
-- Data for Name: grupo; Type: TABLE DATA; Schema: acesso; Owner: postgres
--



--
-- Data for Name: grupo_funcao; Type: TABLE DATA; Schema: acesso; Owner: postgres
--



--
-- Name: grupo_idgrp_seq; Type: SEQUENCE SET; Schema: acesso; Owner: postgres
--

SELECT pg_catalog.setval('grupo_idgrp_seq', 1, false);


--
-- Data for Name: grupo_menu; Type: TABLE DATA; Schema: acesso; Owner: postgres
--



--
-- Data for Name: grupo_operacao; Type: TABLE DATA; Schema: acesso; Owner: postgres
--



--
-- Data for Name: grupo_sistema; Type: TABLE DATA; Schema: acesso; Owner: postgres
--



--
-- Data for Name: historico_senha; Type: TABLE DATA; Schema: acesso; Owner: postgres
--



--
-- Data for Name: instituicao; Type: TABLE DATA; Schema: acesso; Owner: postgres
--



--
-- Name: instituicao_idins_seq; Type: SEQUENCE SET; Schema: acesso; Owner: postgres
--

SELECT pg_catalog.setval('instituicao_idins_seq', 1, false);


--
-- Data for Name: log_acesso; Type: TABLE DATA; Schema: acesso; Owner: postgres
--



--
-- Data for Name: log_erro; Type: TABLE DATA; Schema: acesso; Owner: postgres
--



--
-- Data for Name: menu; Type: TABLE DATA; Schema: acesso; Owner: postgres
--



--
-- Name: menu_idmen_seq; Type: SEQUENCE SET; Schema: acesso; Owner: postgres
--

SELECT pg_catalog.setval('menu_idmen_seq', 1, false);


--
-- Data for Name: operacao; Type: TABLE DATA; Schema: acesso; Owner: postgres
--



--
-- Data for Name: operacao_funcao; Type: TABLE DATA; Schema: acesso; Owner: postgres
--



--
-- Name: operacao_idope_seq; Type: SEQUENCE SET; Schema: acesso; Owner: postgres
--

SELECT pg_catalog.setval('operacao_idope_seq', 1, false);


--
-- Data for Name: pessoa_instituicao; Type: TABLE DATA; Schema: acesso; Owner: postgres
--



--
-- Data for Name: sistema; Type: TABLE DATA; Schema: acesso; Owner: postgres
--

INSERT INTO sistema (idsis, nome, descricao, contexto, situacao) VALUES (1, 'i-Educar', 'Sistema básico', '', 'A');
INSERT INTO sistema (idsis, nome, descricao, contexto, situacao) VALUES (9, 'Código legado', 'Sistema básico', '', 'A');
INSERT INTO sistema (idsis, nome, descricao, contexto, situacao) VALUES (17, 'Código legado', 'Sistema básico', '', 'A');


--
-- Name: sistema_idsis_seq; Type: SEQUENCE SET; Schema: acesso; Owner: postgres
--

SELECT pg_catalog.setval('sistema_idsis_seq', 17, true);


--
-- Data for Name: usuario; Type: TABLE DATA; Schema: acesso; Owner: postgres
--



--
-- Data for Name: usuario_grupo; Type: TABLE DATA; Schema: acesso; Owner: postgres
--



SET search_path = alimentos, pg_catalog;

--
-- Data for Name: baixa_guia_produto; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: baixa_guia_produto_idbap_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('baixa_guia_produto_idbap_seq', 1, false);


--
-- Data for Name: baixa_guia_remessa; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: baixa_guia_remessa_idbai_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('baixa_guia_remessa_idbai_seq', 1, false);


--
-- Data for Name: calendario; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: calendario_idcad_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('calendario_idcad_seq', 1, false);


--
-- Data for Name: cardapio; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Data for Name: cardapio_faixa_unidade; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: cardapio_idcar_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('cardapio_idcar_seq', 1, false);


--
-- Data for Name: cardapio_produto; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: cardapio_produto_idcpr_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('cardapio_produto_idcpr_seq', 1, false);


--
-- Data for Name: cardapio_receita; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Data for Name: cliente; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Data for Name: composto_quimico; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: composto_quimico_idcom_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('composto_quimico_idcom_seq', 1, false);


--
-- Data for Name: contrato; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: contrato_idcon_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('contrato_idcon_seq', 1, false);


--
-- Data for Name: contrato_produto; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: contrato_produto_idcop_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('contrato_produto_idcop_seq', 1, false);


--
-- Data for Name: evento; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: evento_ideve_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('evento_ideve_seq', 1, false);


--
-- Data for Name: faixa_composto_quimico; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: faixa_composto_quimico_idfcp_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('faixa_composto_quimico_idfcp_seq', 1, false);


--
-- Data for Name: faixa_etaria; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: faixa_etaria_idfae_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('faixa_etaria_idfae_seq', 1, false);


--
-- Data for Name: fornecedor; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: fornecedor_idfor_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('fornecedor_idfor_seq', 1, false);


--
-- Data for Name: fornecedor_unidade_atendida; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Data for Name: grupo_quimico; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: grupo_quimico_idgrpq_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('grupo_quimico_idgrpq_seq', 1, false);


--
-- Data for Name: guia_produto_diario; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: guia_produto_diario_idguiaprodiario_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('guia_produto_diario_idguiaprodiario_seq', 1, false);


--
-- Data for Name: guia_remessa; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: guia_remessa_idgui_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('guia_remessa_idgui_seq', 1, false);


--
-- Data for Name: guia_remessa_produto; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: guia_remessa_produto_idgup_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('guia_remessa_produto_idgup_seq', 1, false);


--
-- Data for Name: log_guia_remessa; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: log_guia_remessa_idlogguia_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('log_guia_remessa_idlogguia_seq', 1, false);


--
-- Data for Name: medidas_caseiras; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Data for Name: pessoa; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: pessoa_idpes_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('pessoa_idpes_seq', 1, false);


--
-- Data for Name: produto; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Data for Name: produto_composto_quimico; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: produto_composto_quimico_idpcq_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('produto_composto_quimico_idpcq_seq', 1, false);


--
-- Data for Name: produto_fornecedor; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: produto_fornecedor_idprf_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('produto_fornecedor_idprf_seq', 1, false);


--
-- Name: produto_idpro_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('produto_idpro_seq', 1, false);


--
-- Data for Name: produto_medida_caseira; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: produto_medida_caseira_idpmc_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('produto_medida_caseira_idpmc_seq', 1, false);


--
-- Data for Name: receita; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Data for Name: receita_composto_quimico; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: receita_composto_quimico_idrcq_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('receita_composto_quimico_idrcq_seq', 1, false);


--
-- Name: receita_idrec_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('receita_idrec_seq', 1, false);


--
-- Data for Name: receita_produto; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: receita_produto_idrpr_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('receita_produto_idrpr_seq', 1, false);


--
-- Data for Name: tipo_produto; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: tipo_produto_idtip_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('tipo_produto_idtip_seq', 1, false);


--
-- Data for Name: tipo_refeicao; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: tipo_refeicao_idtre_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('tipo_refeicao_idtre_seq', 1, false);


--
-- Data for Name: tipo_unidade; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: tipo_unidade_idtip_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('tipo_unidade_idtip_seq', 1, false);


--
-- Data for Name: unidade_atendida; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: unidade_atendida_iduni_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('unidade_atendida_iduni_seq', 1, false);


--
-- Data for Name: unidade_faixa_etaria; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



--
-- Name: unidade_faixa_etaria_idfeu_seq; Type: SEQUENCE SET; Schema: alimentos; Owner: postgres
--

SELECT pg_catalog.setval('unidade_faixa_etaria_idfeu_seq', 1, false);


--
-- Data for Name: unidade_produto; Type: TABLE DATA; Schema: alimentos; Owner: postgres
--



SET search_path = cadastro, pg_catalog;

--
-- Data for Name: aviso_nome; Type: TABLE DATA; Schema: cadastro; Owner: postgres
--



--
-- Data for Name: deficiencia; Type: TABLE DATA; Schema: cadastro; Owner: postgres
--

INSERT INTO deficiencia (cod_deficiencia, nm_deficiencia, deficiencia_educacenso) VALUES (8, 'Deficiência Mental', NULL);
INSERT INTO deficiencia (cod_deficiencia, nm_deficiencia, deficiencia_educacenso) VALUES (10, 'Autismo Clássico', NULL);
INSERT INTO deficiencia (cod_deficiencia, nm_deficiencia, deficiencia_educacenso) VALUES (11, 'Síndrome de Asperger', NULL);
INSERT INTO deficiencia (cod_deficiencia, nm_deficiencia, deficiencia_educacenso) VALUES (12, 'Síndrome de Rett', NULL);
INSERT INTO deficiencia (cod_deficiencia, nm_deficiencia, deficiencia_educacenso) VALUES (13, 'Transtorno desintegrativo da infância (psicose infantil)', NULL);
INSERT INTO deficiencia (cod_deficiencia, nm_deficiencia, deficiencia_educacenso) VALUES (14, 'Altas Habilidades/Superdotação', NULL);
INSERT INTO deficiencia (cod_deficiencia, nm_deficiencia, deficiencia_educacenso) VALUES (2, 'Cegueira', 1);
INSERT INTO deficiencia (cod_deficiencia, nm_deficiencia, deficiencia_educacenso) VALUES (3, 'Baixa Visão', 2);
INSERT INTO deficiencia (cod_deficiencia, nm_deficiencia, deficiencia_educacenso) VALUES (4, 'Surdez', 3);
INSERT INTO deficiencia (cod_deficiencia, nm_deficiencia, deficiencia_educacenso) VALUES (5, 'Deficiência Auditiva', 4);
INSERT INTO deficiencia (cod_deficiencia, nm_deficiencia, deficiencia_educacenso) VALUES (6, 'Surdocegueira', 5);
INSERT INTO deficiencia (cod_deficiencia, nm_deficiencia, deficiencia_educacenso) VALUES (7, 'Deficiência Física', 6);
INSERT INTO deficiencia (cod_deficiencia, nm_deficiencia, deficiencia_educacenso) VALUES (9, 'Deficiência Múltipla', 8);


--
-- Name: deficiencia_cod_deficiencia_seq; Type: SEQUENCE SET; Schema: cadastro; Owner: postgres
--

SELECT pg_catalog.setval('deficiencia_cod_deficiencia_seq', 15, false);


--
-- Data for Name: documento; Type: TABLE DATA; Schema: cadastro; Owner: postgres
--



--
-- Data for Name: endereco_externo; Type: TABLE DATA; Schema: cadastro; Owner: postgres
--



--
-- Data for Name: endereco_pessoa; Type: TABLE DATA; Schema: cadastro; Owner: postgres
--



--
-- Data for Name: escolaridade; Type: TABLE DATA; Schema: cadastro; Owner: postgres
--

INSERT INTO escolaridade (idesco, descricao, escolaridade) VALUES (1, 'Fundamental Incompleto', 1);
INSERT INTO escolaridade (idesco, descricao, escolaridade) VALUES (2, 'Fundamental Completo', 2);
INSERT INTO escolaridade (idesco, descricao, escolaridade) VALUES (3, 'Ensino Médio (Normal/Magistério)', 3);
INSERT INTO escolaridade (idesco, descricao, escolaridade) VALUES (4, 'Ensino Médio (Normal/Magistério Indígena)', 4);
INSERT INTO escolaridade (idesco, descricao, escolaridade) VALUES (5, 'Ensino Médio', 5);
INSERT INTO escolaridade (idesco, descricao, escolaridade) VALUES (6, 'Superior Completo', 6);


--
-- Data for Name: estado_civil; Type: TABLE DATA; Schema: cadastro; Owner: postgres
--

INSERT INTO estado_civil (ideciv, descricao) VALUES (1, 'Solteiro(a)');
INSERT INTO estado_civil (ideciv, descricao) VALUES (2, 'Casado(a)');
INSERT INTO estado_civil (ideciv, descricao) VALUES (3, 'Divorciado(a)');
INSERT INTO estado_civil (ideciv, descricao) VALUES (4, 'Separado(a)');
INSERT INTO estado_civil (ideciv, descricao) VALUES (5, 'Viúvo(a)');
INSERT INTO estado_civil (ideciv, descricao) VALUES (6, 'Companheiro(a)');


--
-- Data for Name: fisica; Type: TABLE DATA; Schema: cadastro; Owner: postgres
--

INSERT INTO fisica (idpes, data_nasc, sexo, idpes_mae, idpes_pai, idpes_responsavel, idesco, ideciv, idpes_con, data_uniao, data_obito, nacionalidade, idpais_estrangeiro, data_chegada_brasil, idmun_nascimento, ultima_empresa, idocup, nome_mae, nome_pai, nome_conjuge, nome_responsavel, justificativa_provisorio, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad, ref_cod_sistema, cpf, ref_cod_religiao, nis_pis_pasep, sus, ocupacao, empresa, pessoa_contato, renda_mensal, data_admissao, ddd_telefone_empresa, telefone_empresa, falecido, ativo, ref_usuario_exc, data_exclusao, zona_localizacao_censo, tipo_trabalho, local_trabalho, horario_inicial_trabalho, horario_final_trabalho) VALUES (1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'M', NULL, '2010-01-06 18:30:32.475015', 'I', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL);


--
-- Data for Name: fisica_cpf; Type: TABLE DATA; Schema: cadastro; Owner: postgres
--



--
-- Data for Name: fisica_deficiencia; Type: TABLE DATA; Schema: cadastro; Owner: postgres
--



--
-- Data for Name: fisica_foto; Type: TABLE DATA; Schema: cadastro; Owner: postgres
--



--
-- Data for Name: fisica_raca; Type: TABLE DATA; Schema: cadastro; Owner: postgres
--



--
-- Data for Name: fisica_sangue; Type: TABLE DATA; Schema: cadastro; Owner: postgres
--



--
-- Data for Name: fone_pessoa; Type: TABLE DATA; Schema: cadastro; Owner: postgres
--



--
-- Data for Name: funcionario; Type: TABLE DATA; Schema: cadastro; Owner: postgres
--



--
-- Data for Name: historico_cartao; Type: TABLE DATA; Schema: cadastro; Owner: postgres
--



--
-- Data for Name: juridica; Type: TABLE DATA; Schema: cadastro; Owner: postgres
--



--
-- Data for Name: ocupacao; Type: TABLE DATA; Schema: cadastro; Owner: postgres
--



--
-- Data for Name: orgao_emissor_rg; Type: TABLE DATA; Schema: cadastro; Owner: postgres
--

INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (1, 'SSP', 'SSP', 'I', 10);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (2, 'MMil', 'Ministérios Militares', 'I', 40);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (3, 'MAer', 'Ministério da Aeronáutica', 'I', 41);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (4, 'MExe', 'Ministério do Exército', 'I', 42);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (5, 'MMar', 'Ministério da Marinha', 'I', 43);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (6, 'PF', 'Polícia Federal', 'I', 44);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (7, 'CIC', 'Carteira de Identidade Classista', 'I', 60);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (8, 'CRA', 'Conselho Regional de Administração', 'I', 61);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (10, 'CRB', 'Conselho Regional de Biblioteconomia', 'I', 63);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (11, 'CRC', 'Conselho Regional de Contabilidade', 'I', 64);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (12, 'CRECI', 'Conselho Regional de Corretores Imóveis', 'I', 65);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (14, 'CREA', 'Conselho Regional de Engenharia, Arquitetura e Agronomia', 'I', 67);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (18, 'CRM', 'Conselho Regional de Medicina', 'I', 71);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (19, 'CRMV', 'Conselho Regional de Medicina Veterinária', 'I', 72);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (20, 'OMB', 'Ordem dos Músicos do Brasil', 'I', 73);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (22, 'CRO', 'Conselho Regional de Odontologia', 'I', 75);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (24, 'CRP', 'Conselho Regional de Psicologia', 'I', 77);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (25, 'CRQ', 'Conselho Regional de Química', 'I', 78);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (27, 'OAB', 'Ordem dos Advogados do Brasil', 'I', 80);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (28, 'OEmi', 'Outros Emissores', 'I', 81);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (29, 'DExt', 'Documento Estrangeiro', 'I', 82);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (9, 'CRESS', 'Conselho Regional de Assist. Social', 'I', 62);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (13, 'COREN', 'Conselho Regional de Enfermagem', 'I', 66);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (15, 'CONRE', 'Conselho Regional de Estatística', 'I', 68);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (16, 'CRF', 'Conselho Regional de Farmácia', 'I', 69);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (17, 'CREFITO', 'Conselho Regional de Fisioterapia e Terapia Ocupacional', 'I', 70);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (21, 'CRN', 'Conselho Regional de Nutrição', 'I', 74);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (23, 'CONRERP', 'Conselho Regional de Profissionais de Relações Públicas', 'I', 76);
INSERT INTO orgao_emissor_rg (idorg_rg, sigla, descricao, situacao, codigo_educacenso) VALUES (26, 'CORE', 'Conselho Regional de Representantes Comerciais', 'I', 79);


--
-- Name: orgao_emissor_rg_idorg_rg_seq; Type: SEQUENCE SET; Schema: cadastro; Owner: postgres
--

SELECT pg_catalog.setval('orgao_emissor_rg_idorg_rg_seq', 30, false);


--
-- Data for Name: pessoa; Type: TABLE DATA; Schema: cadastro; Owner: postgres
--

INSERT INTO pessoa (idpes, nome, idpes_cad, data_cad, url, tipo, idpes_rev, data_rev, email, situacao, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1, 'Administrador', NULL, '2010-01-06 18:30:32.510871', NULL, 'F', NULL, NULL, '', 'A', 'M', 'I', NULL, 1);


--
-- Data for Name: pessoa_fonetico; Type: TABLE DATA; Schema: cadastro; Owner: postgres
--



--
-- Data for Name: raca; Type: TABLE DATA; Schema: cadastro; Owner: postgres
--

INSERT INTO raca (cod_raca, idpes_exc, idpes_cad, nm_raca, data_cadastro, data_exclusao, ativo, raca_educacenso) VALUES (1, NULL, 1, 'Branca', '2010-12-22 17:09:31.64', NULL, true, 1);
INSERT INTO raca (cod_raca, idpes_exc, idpes_cad, nm_raca, data_cadastro, data_exclusao, ativo, raca_educacenso) VALUES (2, NULL, 1, 'Preta', '2010-12-22 17:09:31.64', NULL, true, 2);
INSERT INTO raca (cod_raca, idpes_exc, idpes_cad, nm_raca, data_cadastro, data_exclusao, ativo, raca_educacenso) VALUES (3, NULL, 1, 'Parda', '2010-12-22 17:09:31.64', NULL, true, 3);
INSERT INTO raca (cod_raca, idpes_exc, idpes_cad, nm_raca, data_cadastro, data_exclusao, ativo, raca_educacenso) VALUES (4, NULL, 1, 'Amarela', '2010-12-22 17:09:31.64', NULL, true, 4);
INSERT INTO raca (cod_raca, idpes_exc, idpes_cad, nm_raca, data_cadastro, data_exclusao, ativo, raca_educacenso) VALUES (5, NULL, 1, 'Indígena', '2010-12-22 17:09:31.64', NULL, true, 5);
INSERT INTO raca (cod_raca, idpes_exc, idpes_cad, nm_raca, data_cadastro, data_exclusao, ativo, raca_educacenso) VALUES (6, NULL, 1, 'Não Declarada', '2010-12-22 17:09:31.64', NULL, true, 0);


--
-- Name: raca_cod_raca_seq; Type: SEQUENCE SET; Schema: cadastro; Owner: postgres
--

SELECT pg_catalog.setval('raca_cod_raca_seq', 1, false);


--
-- Data for Name: religiao; Type: TABLE DATA; Schema: cadastro; Owner: postgres
--



--
-- Name: religiao_cod_religiao_seq; Type: SEQUENCE SET; Schema: cadastro; Owner: postgres
--

SELECT pg_catalog.setval('religiao_cod_religiao_seq', 1, false);


--
-- Name: seq_pessoa; Type: SEQUENCE SET; Schema: cadastro; Owner: postgres
--

SELECT pg_catalog.setval('seq_pessoa', 3, true);


--
-- Data for Name: socio; Type: TABLE DATA; Schema: cadastro; Owner: postgres
--



SET search_path = consistenciacao, pg_catalog;

--
-- Data for Name: campo_consistenciacao; Type: TABLE DATA; Schema: consistenciacao; Owner: postgres
--

INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (1, 'CPF ou CNPJ', 'N', 14);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (2, 'Nome pessoa física ou jurídica', 'N', 150);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (3, 'E-mail', 'N', 50);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (4, 'URL', 'N', 60);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (5, 'Data nascimento', 'N', 20);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (6, 'Número RG', 'N', 10);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (7, 'Órgão expedidor RG', 'S', 20);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (8, 'Data expedição RG', 'N', 20);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (9, 'UF expedição RG', 'S', 30);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (10, 'Tipo certidão civil', 'S', 2);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (11, 'Número termo certidão civil', 'N', 8);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (12, 'Número livro certidão civil', 'N', 8);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (13, 'Número folha certidão civil', 'N', 4);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (14, 'Data emissão certidão civil', 'N', 20);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (15, 'Cartório emissor certidão civil', 'N', 150);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (16, 'UF emissão certidão civil', 'S', 30);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (17, 'Número carteira trabalho', 'N', 7);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (18, 'Número série carteira trabalho', 'N', 5);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (19, 'Data emissão carteira trabalho', 'N', 20);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (20, 'UF emissão carteira trabalho', 'S', 30);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (21, 'Número título de eleitor', 'N', 13);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (22, 'Número zona título eleitor', 'N', 4);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (23, 'Número seção título eleitor', 'N', 4);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (24, 'Nome fantasia pessoa jurídica', 'N', 50);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (25, 'Número inscrição estadual', 'N', 10);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (26, 'Sexo pessoa física', 'S', 10);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (27, 'Nome mãe', 'N', 150);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (28, 'Nome pai', 'N', 150);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (29, 'Nome cônjuge', 'N', 150);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (30, 'Nome responsável', 'N', 150);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (31, 'Nome última empresa', 'N', 150);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (32, 'Ocupação profissional', 'S', 250);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (33, 'Escolaridade', 'S', 60);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (34, 'Estado civil', 'S', 15);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (35, 'País de origem(se estrangeiro)', 'S', 60);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (36, 'Data chegada ao Brasil', 'N', 20);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (37, 'Data óbito', 'N', 20);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (38, 'Data união com cônjuge', 'N', 20);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (39, 'DDD telefone residencial', 'N', 3);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (40, 'Telefone residencial', 'N', 8);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (41, 'DDD telefone comercial', 'N', 3);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (42, 'Telefone comercial', 'N', 8);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (43, 'DDD telefone celular', 'N', 3);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (44, 'Telefone celular', 'N', 8);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (45, 'DDD fax', 'N', 3);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (46, 'Fax', 'N', 8);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (47, 'Logradouro (end. correspondência)', 'N', 150);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (48, 'Tipo logradouro (end. correspondência)', 'S', 15);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (49, 'Número (end. correspondência)', 'N', 6);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (50, 'Letra (end. correspondência)', 'N', 1);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (51, 'Complemento (end. correspondência)', 'N', 20);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (52, 'Bairro (end. correspondência)', 'N', 40);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (53, 'CEP (end. correspondência)', 'N', 8);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (54, 'Cidade (end. correspondência)', 'N', 60);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (55, 'UF (end. correspondência)', 'S', 30);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (56, 'Logradouro (end. residencial)', 'N', 150);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (57, 'Tipo logradouro (end. residencial)', 'S', 15);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (58, 'Número (end. residencial)', 'N', 6);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (59, 'Letra (end. residencial)', 'N', 1);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (60, 'Complemento (end. residencial)', 'N', 20);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (61, 'Bairro (end. residencial)', 'N', 40);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (62, 'CEP (end. residencial)', 'N', 8);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (63, 'Cidade (end. residencial)', 'N', 60);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (64, 'UF (end. residencial)', 'S', 30);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (65, 'Logradouro (end. comercial)', 'N', 150);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (66, 'Tipo logradouro (end. comercial)', 'S', 15);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (67, 'Número (end. comercial)', 'N', 6);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (68, 'Letra (end. comercial)', 'N', 1);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (69, 'Complemento (end. comercial)', 'N', 20);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (70, 'Bairro (end. comercial)', 'N', 40);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (71, 'CEP (end. comercial)', 'N', 8);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (72, 'Cidade (end. comercial)', 'N', 60);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (73, 'UF (end. comercial)', 'S', 30);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (74, 'Logradouro (correspondência ou residencial)', 'N', 150);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (75, 'Tipo logradouro (correspondência ou residencial)', 'S', 15);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (76, 'Número (correspondência ou residencial)', 'N', 6);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (77, 'Letra (correspondência ou residencial)', 'N', 1);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (78, 'Complemento (correspondência ou residencial)', 'N', 20);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (79, 'Bairro (correspondência ou residencial)', 'N', 40);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (80, 'CEP (correspondência ou residencial)', 'N', 8);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (81, 'Cidade (correspondência ou residencial)', 'N', 60);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (82, 'UF (correspondência ou residencial)', 'S', 30);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (83, 'Logradouro (correspondência ou comercial)', 'N', 150);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (84, 'Tipo logradouro (correspondência ou comercial)', 'S', 15);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (85, 'Número (correspondência ou comercial)', 'N', 6);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (86, 'Letra (correspondência ou comercial)', 'N', 1);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (87, 'Complemento (correspondência ou comercial)', 'N', 20);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (88, 'Bairro (correspondência ou comercial)', 'N', 40);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (89, 'CEP (correspondência ou comercial)', 'N', 8);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (90, 'Cidade (correspondência ou comercial)', 'N', 60);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (91, 'UF (correspondência ou comercial)', 'S', 30);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (92, 'DDD telefone comercial ou residencial', 'N', 3);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (93, 'Telefone comercial ou residencial', 'N', 8);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (94, 'CPF', 'N', 14);
INSERT INTO campo_consistenciacao (idcam, campo, permite_regra_cadastrada, tamanho_maximo) VALUES (95, 'CNPJ', 'N', 14);


--
-- Data for Name: campo_metadado; Type: TABLE DATA; Schema: consistenciacao; Owner: postgres
--



--
-- Name: campo_metadado_id_campo_met_seq; Type: SEQUENCE SET; Schema: consistenciacao; Owner: postgres
--

SELECT pg_catalog.setval('campo_metadado_id_campo_met_seq', 1, false);


--
-- Data for Name: confrontacao; Type: TABLE DATA; Schema: consistenciacao; Owner: postgres
--



--
-- Name: confrontacao_idcon_seq; Type: SEQUENCE SET; Schema: consistenciacao; Owner: postgres
--

SELECT pg_catalog.setval('confrontacao_idcon_seq', 1, false);


--
-- Data for Name: fonte; Type: TABLE DATA; Schema: consistenciacao; Owner: postgres
--



--
-- Name: fonte_idfon_seq; Type: SEQUENCE SET; Schema: consistenciacao; Owner: postgres
--

SELECT pg_catalog.setval('fonte_idfon_seq', 1, false);


--
-- Data for Name: historico_campo; Type: TABLE DATA; Schema: consistenciacao; Owner: postgres
--



--
-- Data for Name: incoerencia; Type: TABLE DATA; Schema: consistenciacao; Owner: postgres
--



--
-- Data for Name: incoerencia_documento; Type: TABLE DATA; Schema: consistenciacao; Owner: postgres
--



--
-- Name: incoerencia_documento_id_inc_doc_seq; Type: SEQUENCE SET; Schema: consistenciacao; Owner: postgres
--

SELECT pg_catalog.setval('incoerencia_documento_id_inc_doc_seq', 1, false);


--
-- Data for Name: incoerencia_endereco; Type: TABLE DATA; Schema: consistenciacao; Owner: postgres
--



--
-- Name: incoerencia_endereco_id_inc_end_seq; Type: SEQUENCE SET; Schema: consistenciacao; Owner: postgres
--

SELECT pg_catalog.setval('incoerencia_endereco_id_inc_end_seq', 1, false);


--
-- Data for Name: incoerencia_fone; Type: TABLE DATA; Schema: consistenciacao; Owner: postgres
--



--
-- Name: incoerencia_fone_id_inc_fone_seq; Type: SEQUENCE SET; Schema: consistenciacao; Owner: postgres
--

SELECT pg_catalog.setval('incoerencia_fone_id_inc_fone_seq', 1, false);


--
-- Name: incoerencia_idinc_seq; Type: SEQUENCE SET; Schema: consistenciacao; Owner: postgres
--

SELECT pg_catalog.setval('incoerencia_idinc_seq', 1, false);


--
-- Data for Name: incoerencia_pessoa_possivel; Type: TABLE DATA; Schema: consistenciacao; Owner: postgres
--



--
-- Data for Name: incoerencia_tipo_incoerencia; Type: TABLE DATA; Schema: consistenciacao; Owner: postgres
--



--
-- Data for Name: metadado; Type: TABLE DATA; Schema: consistenciacao; Owner: postgres
--



--
-- Name: metadado_idmet_seq; Type: SEQUENCE SET; Schema: consistenciacao; Owner: postgres
--

SELECT pg_catalog.setval('metadado_idmet_seq', 1, false);


--
-- Data for Name: ocorrencia_regra_campo; Type: TABLE DATA; Schema: consistenciacao; Owner: postgres
--



--
-- Data for Name: regra_campo; Type: TABLE DATA; Schema: consistenciacao; Owner: postgres
--



--
-- Name: regra_campo_idreg_seq; Type: SEQUENCE SET; Schema: consistenciacao; Owner: postgres
--

SELECT pg_catalog.setval('regra_campo_idreg_seq', 1, false);


--
-- Data for Name: temp_cadastro_unificacao_cmf; Type: TABLE DATA; Schema: consistenciacao; Owner: postgres
--



--
-- Data for Name: temp_cadastro_unificacao_siam; Type: TABLE DATA; Schema: consistenciacao; Owner: postgres
--



--
-- Data for Name: tipo_incoerencia; Type: TABLE DATA; Schema: consistenciacao; Owner: postgres
--



SET search_path = historico, pg_catalog;

--
-- Data for Name: bairro; Type: TABLE DATA; Schema: historico; Owner: postgres
--



--
-- Data for Name: cep_logradouro; Type: TABLE DATA; Schema: historico; Owner: postgres
--



--
-- Data for Name: cep_logradouro_bairro; Type: TABLE DATA; Schema: historico; Owner: postgres
--



--
-- Data for Name: documento; Type: TABLE DATA; Schema: historico; Owner: postgres
--



--
-- Data for Name: endereco_externo; Type: TABLE DATA; Schema: historico; Owner: postgres
--



--
-- Data for Name: endereco_pessoa; Type: TABLE DATA; Schema: historico; Owner: postgres
--



--
-- Data for Name: fisica; Type: TABLE DATA; Schema: historico; Owner: postgres
--



--
-- Data for Name: fisica_cpf; Type: TABLE DATA; Schema: historico; Owner: postgres
--



--
-- Data for Name: fone_pessoa; Type: TABLE DATA; Schema: historico; Owner: postgres
--



--
-- Data for Name: funcionario; Type: TABLE DATA; Schema: historico; Owner: postgres
--



--
-- Data for Name: juridica; Type: TABLE DATA; Schema: historico; Owner: postgres
--



--
-- Data for Name: logradouro; Type: TABLE DATA; Schema: historico; Owner: postgres
--



--
-- Data for Name: municipio; Type: TABLE DATA; Schema: historico; Owner: postgres
--

INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (43, 'Sao Felipe D Oeste', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.747041', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (197, 'Eldorado dos Carajas', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.917067', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (258, 'Santa Isabel do Para', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.990198', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (684, 'Barra D Alcantara', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.457797', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (809, 'Olho D Agua do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.590304', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (976, 'Itapage', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.777235', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1184, 'Presidente Juscelino', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.010971', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1539, 'Iguaraci', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.397826', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2773, 'Olhos-d Agua', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.728505', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5278, 'Poxoreo', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.486341', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1, 'Alta Floresta D''oeste', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.699228', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5, 'Ariquemes', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.703562', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (7, 'Cabixi', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.7053', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (9, 'Cacoal', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.707047', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (13, 'Cerejeiras', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.711055', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (15, 'Colorado do Oeste', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.712932', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (16, 'Corumbiara', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.713842', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (17, 'Costa Marques', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.714738', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (19, 'Espigao D''oeste', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.716704', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (21, 'Guajara-mirim', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.718803', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (23, 'Jaru', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.720746', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (24, 'Ji-parana', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.721775', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (25, 'Machadinho D''oeste', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.722776', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (29, 'Nova Brasilandia D''oeste', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.73323', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (33, 'Ouro Preto do Oeste', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.737108', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (35, 'Pimenta Bueno', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.73925', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (37, 'Porto Velho', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.741221', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (38, 'Presidente Medici', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.742117', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (40, 'Rio Crespo', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.744066', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (41, 'Rolim de Moura', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.745017', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (42, 'Santa Luzia D''oeste', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.745909', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (52, 'Vilhena', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.754961', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (45, 'Sao Miguel do Guapore', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.748533', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (30, 'Nova Mamore', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.734184', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4, 'Alvorada D''oeste', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.70262', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2, 'Alto Alegre dos Parecis', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.700901', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3, 'Alto Paraiso', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.701715', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (6, 'Buritis', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.704461', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (32, 'Novo Horizonte do Oeste', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.73613', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (8, 'Cacaulandia', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.706175', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (10, 'Campo Novo de Rondonia', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.70796', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (11, 'Candeias do Jamari', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.708884', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (12, 'Castanheiras', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.709859', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (14, 'Chupinguaia', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.711993', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (18, 'Cujubim', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.715723', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (20, 'Governador Jorge Teixeira', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.717717', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (22, 'Itapua do Oeste', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.719743', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (26, 'Ministro Andreazza', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.723813', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (27, 'Mirante da Serra', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.725075', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (28, 'Monte Negro', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.731957', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (31, 'Nova Uniao', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.735123', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (34, 'Parecis', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.738213', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (36, 'Pimenteiras do Oeste', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.740233', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (39, 'Primavera de Rondonia', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.743068', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (44, 'Sao Francisco do Guapore', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.747752', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (46, 'Seringueiras', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.749422', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (47, 'Teixeiropolis', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.750356', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (48, 'Theobroma', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.751289', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (49, 'Urupa', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.752266', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (50, 'Vale do Anari', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.753153', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (51, 'Vale do Paraiso', 'RO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.754014', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (53, 'Acrelandia', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.756206', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (54, 'Assis Brasil', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.757065', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (55, 'Brasileia', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.757891', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (56, 'Bujari', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.758909', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (57, 'Capixaba', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.759844', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (58, 'Cruzeiro do Sul', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.760768', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (59, 'Epitaciolandia', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.761618', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (60, 'Feijo', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.762592', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (61, 'Jordao', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.763501', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (62, 'Mancio Lima', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.764379', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (63, 'Manoel Urbano', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.765356', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (64, 'Marechal Thaumaturgo', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.772448', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (65, 'Placido de Castro', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.77356', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (67, 'Porto Walter', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.775372', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (68, 'Rio Branco', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.776144', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (69, 'Rodrigues Alves', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.777086', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (70, 'Santa Rosa do Purus', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.778157', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (72, 'Senador Guiomard', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.780338', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (71, 'Sena Madureira', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.779501', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (73, 'Tarauaca', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.781279', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (74, 'Xapuri', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.782326', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (66, 'Porto Acre', 'AC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.774455', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (75, 'Alvaraes', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.783307', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (76, 'Amatura', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.78444', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (77, 'Anama', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.785298', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (78, 'Anori', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.7862', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (79, 'Apui', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.787062', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (80, 'Atalaia do Norte', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.787924', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (81, 'Autazes', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.788882', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (82, 'Barcelos', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.789694', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (83, 'Barreirinha', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.790558', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (84, 'Benjamin Constant', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.791396', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (85, 'Beruri', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.792246', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (86, 'Boa Vista do Ramos', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.793161', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (87, 'Boca do Acre', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.794181', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (88, 'Borba', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.795002', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (89, 'Caapiranga', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.795793', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (90, 'Canutama', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.796734', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (91, 'Carauari', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.797699', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (92, 'Careiro', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.798687', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (93, 'Careiro da Varzea', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.799621', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (94, 'Coari', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.800826', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (95, 'Codajas', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.801802', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (96, 'Eirunepe', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.802748', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (97, 'Envira', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.803632', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (98, 'Fonte Boa', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.804528', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (99, 'Guajara', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.805459', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (100, 'Humaita', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.806293', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (101, 'Ipixuna', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.813076', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (102, 'Iranduba', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.814239', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (103, 'Itamarati', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.815178', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (104, 'Itapiranga', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.816065', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (105, 'Japura', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.81715', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (106, 'Jurua', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.818091', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (107, 'Jutai', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.819038', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (108, 'Labrea', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.820032', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (109, 'Manacapuru', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.820907', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (110, 'Manaquiri', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.821753', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (111, 'Manaus', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.822972', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (112, 'Manicore', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.823952', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (113, 'Maraa', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.824889', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (114, 'Maues', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.825835', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (115, 'Nhamunda', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.826766', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (116, 'Nova Olinda do Norte', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.827685', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (117, 'Novo Airao', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.828719', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (118, 'Novo Aripuana', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.829683', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (119, 'Parintins', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.830562', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (120, 'Pauini', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.83138', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (121, 'Presidente Figueiredo', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.832207', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (122, 'Rio Preto da Eva', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.833161', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (123, 'Santa Isabel do Rio Negro', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.834228', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (124, 'Santo Antonio do Ica', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.835121', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (125, 'Sao Gabriel da Cachoeira', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.836046', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (126, 'Sao Paulo de Olivenca', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.836988', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (127, 'Sao Sebastiao do Uatuma', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.837813', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (128, 'Silves', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.838766', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (129, 'Tabatinga', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.839732', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (130, 'Tapaua', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.840639', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (131, 'Tefe', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.841614', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (132, 'Tonantins', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.842553', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (133, 'Uarini', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.843379', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (134, 'Urucara', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.844178', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (135, 'Urucurituba', 'AM', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.845408', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (137, 'Amajari', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.853924', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (136, 'Alto Alegre', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.846512', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (138, 'Boa Vista', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.855192', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (139, 'Bonfim', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.856157', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (140, 'Canta', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.856972', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (141, 'Caracarai', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.857888', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (142, 'Caroebe', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.858888', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (143, 'Iracema', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.859891', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (144, 'Mucajai', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.860859', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (145, 'Normandia', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.861807', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (146, 'Pacaraima', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.862761', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (147, 'Rorainopolis', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.86373', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (148, 'Sao Joao da Baliza', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.864648', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (149, 'Sao Luiz', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.865518', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (150, 'Uiramuta', 'RR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.866386', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (151, 'Abaetetuba', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.867591', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (152, 'Abel Figueiredo', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.868448', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (153, 'Acara', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.869342', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (154, 'Afua', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.87027', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (155, 'Agua Azul do Norte', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.871096', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (156, 'Alenquer', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.872038', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (157, 'Almeirim', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.872959', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (158, 'Altamira', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.873993', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (159, 'Anajas', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.874868', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (160, 'Ananindeua', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.875805', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (161, 'Anapu', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.87672', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (162, 'Augusto Correa', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.877656', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (163, 'Aurora do Para', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.878762', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (164, 'Aveiro', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.879577', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (165, 'Bagre', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.88047', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (166, 'Baiao', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.881428', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (167, 'Bannach', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.882419', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (168, 'Barcarena', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.883321', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (169, 'Belem', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.884275', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (170, 'Belterra', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.885225', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (171, 'Benevides', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.886172', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (172, 'Bom Jesus do Tocantins', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.887134', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (173, 'Bonito', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.894617', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (174, 'Braganca', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.895728', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (175, 'Brasil Novo', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.896566', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (176, 'Brejo Grande do Araguaia', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.897635', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (177, 'Breu Branco', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.898564', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (178, 'Breves', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.899242', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (179, 'Bujaru', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.900159', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (181, 'Cachoeira do Piria', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.902107', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (180, 'Cachoeira do Arari', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.901094', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (182, 'Cameta', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.903016', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (183, 'Canaa dos Carajas', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.903963', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (184, 'Capanema', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.904782', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (185, 'Capitao Poco', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.905681', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (186, 'Castanhal', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.906554', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (187, 'Chaves', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.907603', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (188, 'Colares', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.908482', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (189, 'Conceicao do Araguaia', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.909368', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (190, 'Concordia do Para', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.910192', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (191, 'Cumaru do Norte', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.911121', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (192, 'Curionopolis', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.912262', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (193, 'Curralinho', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.913215', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (194, 'Curua', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.914119', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (195, 'Curuca', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.915017', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (196, 'Dom Eliseu', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.91602', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (198, 'Faro', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.91806', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (199, 'Floresta do Araguaia', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.918982', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (200, 'Garrafao do Norte', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.919913', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (201, 'Goianesia do Para', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.92081', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (202, 'Gurupa', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.921711', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (203, 'Igarape-acu', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.922705', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (204, 'Igarape-miri', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.92357', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (205, 'Inhangapi', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.924586', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (206, 'Ipixuna do Para', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.9256', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (207, 'Irituia', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.926608', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (208, 'Itaituba', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.92776', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (209, 'Itupiranga', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.928737', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (210, 'Jacareacanga', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.936088', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (211, 'Jacunda', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.937324', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (212, 'Juruti', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.938243', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (213, 'Limoeiro do Ajuru', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.939321', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (214, 'Mae do Rio', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.940188', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (215, 'Magalhaes Barata', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.941158', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (216, 'Maraba', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.942124', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (217, 'Maracana', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.943021', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (218, 'Marapanim', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.943981', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (219, 'Marituba', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.944811', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (220, 'Medicilandia', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.945759', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (221, 'Melgaco', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.946559', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (222, 'Mocajuba', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.947482', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (223, 'Moju', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.948244', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (224, 'Monte Alegre', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.949614', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (225, 'Muana', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.950555', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (226, 'Nova Esperanca do Piria', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.9514', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (227, 'Nova Ipixuna', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.952304', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (228, 'Nova Timboteua', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.953216', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (229, 'Novo Progresso', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.954085', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (230, 'Novo Repartimento', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.955006', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (231, 'Obidos', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.95593', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (232, 'Oeiras do Para', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.956865', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (233, 'Oriximina', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.957786', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (234, 'Ourem', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.958709', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (235, 'Ourilandia do Norte', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.959504', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (236, 'Pacaja', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.960374', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (237, 'Palestina do Para', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.96127', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (238, 'Paragominas', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.962164', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (239, 'Parauapebas', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.963118', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (240, 'Pau D''arco', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.963912', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (241, 'Peixe-boi', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.964888', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (242, 'Picarra', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.965834', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (243, 'Placas', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.966852', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (244, 'Ponta de Pedras', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.968025', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (245, 'Portel', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.969061', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (246, 'Porto de Moz', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.970034', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (247, 'Prainha', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.978985', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (248, 'Primavera', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.980101', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (249, 'Quatipuru', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.981208', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (250, 'Redencao', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.982118', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (251, 'Rio Maria', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.983216', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (252, 'Rondon do Para', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.984434', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (253, 'Ruropolis', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.985502', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (254, 'Salinopolis', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.986493', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (255, 'Salvaterra', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.987353', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (256, 'Santa Barbara do Para', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.988251', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (257, 'Santa Cruz do Arari', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.989048', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (259, 'Santa Luzia do Para', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.991128', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (260, 'Santa Maria das Barreiras', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.991911', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (261, 'Santa Maria do Para', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.992886', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (262, 'Santana do Araguaia', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.993845', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (263, 'Santarem', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.994763', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (264, 'Santarem Novo', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.995664', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (265, 'Santo Antonio do Taua', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.996463', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (266, 'Sao Caetano de Odivelas', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.997262', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (267, 'Sao Domingos do Araguaia', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.998092', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (268, 'Sao Domingos do Capim', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.999037', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (269, 'Sao Felix do Xingu', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:33.999952', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (270, 'Sao Francisco do Para', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.001019', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (271, 'Sao Geraldo do Araguaia', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.001861', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (272, 'Sao Joao da Ponta', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.002762', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (273, 'Sao Joao de Pirabas', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.003681', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (274, 'Sao Joao do Araguaia', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.004606', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (275, 'Sao Miguel do Guama', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.005566', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (276, 'Sao Sebastiao da Boa Vista', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.006395', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (277, 'Sapucaia', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.007271', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (278, 'Senador Jose Porfirio', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.008163', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (279, 'Soure', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.009091', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (280, 'Tailandia', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.010067', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (281, 'Terra Alta', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.01103', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (282, 'Terra Santa', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.012083', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (283, 'Tome-acu', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.012862', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (284, 'Tracuateua', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.020208', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (285, 'Trairao', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.021367', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (286, 'Tucuma', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.022234', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (287, 'Tucurui', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.023243', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (288, 'Ulianopolis', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.024129', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (289, 'Uruara', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.024966', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (290, 'Vigia', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.025883', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (291, 'Viseu', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.026802', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (292, 'Vitoria do Xingu', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.027745', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (293, 'Xinguara', 'PA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.028653', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (307, 'Serra do Navio', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.041419', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (294, 'Amapa', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.029605', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (303, 'Pedra Branca do Amapari', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.037751', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (295, 'Calcoene', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.030519', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (296, 'Cutias', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.031457', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (297, 'Ferreira Gomes', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.032313', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (298, 'Itaubal', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.033162', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (299, 'Laranjal do Jari', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.034147', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (300, 'Macapa', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.035017', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (301, 'Mazagao', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.036028', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (302, 'Oiapoque', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.036905', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (304, 'Porto Grande', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.038704', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (305, 'Pracuuba', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.039594', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (306, 'Santana', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.040511', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (308, 'Tartarugalzinho', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.042303', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (309, 'Vitoria do Jari', 'AP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.043135', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (310, 'Abreulandia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.044063', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (311, 'Aguiarnopolis', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.045079', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (312, 'Alianca do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.04621', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (313, 'Almas', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.047192', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (314, 'Alvorada', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.048146', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (315, 'Ananas', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.049117', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (316, 'Angico', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.050076', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (317, 'Aparecida do Rio Negro', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.050987', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (318, 'Aragominas', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.051903', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (319, 'Araguacema', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.052846', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (320, 'Araguacu', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.053962', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (321, 'Araguaina', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.061617', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (322, 'Araguana', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.062755', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (323, 'Araguatins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.063685', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (324, 'Arapoema', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.064569', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (325, 'Arraias', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.06559', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (326, 'Augustinopolis', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.066518', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (327, 'Aurora do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.067488', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (328, 'Axixa do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.06855', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (329, 'Babaculandia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.069459', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (330, 'Bandeirantes do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.070302', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (331, 'Barra do Ouro', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.071172', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (332, 'Barrolandia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.072056', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (333, 'Bernardo Sayao', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.072885', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (334, 'Bom Jesus do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.073818', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (335, 'Brasilandia do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.074694', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (336, 'Brejinho de Nazare', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.075521', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (337, 'Buriti do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.076484', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (338, 'Cachoeirinha', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.077361', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (339, 'Campos Lindos', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.078201', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (340, 'Cariri do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.079159', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (341, 'Carmolandia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.079958', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (342, 'Carrasco Bonito', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.081026', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (343, 'Caseara', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.082012', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (344, 'Centenario', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.082934', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (346, 'Chapada de Areia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.084657', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (345, 'Chapada da Natividade', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.083733', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (347, 'Colinas do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.085702', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (349, 'Combinado', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.087767', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (350, 'Conceicao do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.088722', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (352, 'Cristalandia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.090779', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (353, 'Crixas do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.091635', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (354, 'Darcinopolis', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.092435', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (355, 'Dianopolis', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.093325', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (356, 'Divinopolis do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.094239', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (357, 'Dois Irmaos do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.09535', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (358, 'Duere', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.102276', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (359, 'Esperantina', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.103367', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (360, 'Fatima', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.104253', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (361, 'Figueiropolis', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.105111', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (362, 'Filadelfia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.106031', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (363, 'Formoso do Araguaia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.106844', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (364, 'Fortaleza do Tabocao', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.107791', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (365, 'Goianorte', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.108687', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (366, 'Goiatins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.10958', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (367, 'Guarai', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.110381', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (368, 'Gurupi', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.111293', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (369, 'Ipueiras', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.112298', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (370, 'Itacaja', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.113135', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (371, 'Itaguatins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.113912', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (372, 'Itapiratins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.1149', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (373, 'Itapora do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.11572', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (374, 'Jau do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.116488', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (375, 'Juarina', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.117396', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (376, 'Lagoa da Confusao', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.11813', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (377, 'Lagoa do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.118825', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (378, 'Lajeado', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.119873', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (379, 'Lavandeira', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.120739', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (380, 'Lizarda', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.121597', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (381, 'Luzinopolis', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.122538', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (382, 'Marianopolis do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.123445', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (383, 'Mateiros', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.124297', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (384, 'Maurilandia do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.125143', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (385, 'Miracema do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.125927', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (386, 'Miranorte', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.126827', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (387, 'Monte do Carmo', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.127756', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (388, 'Monte Santo do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.128688', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (400, 'Palmeiras do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.146676', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (389, 'Muricilandia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.129605', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (390, 'Natividade', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.13038', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (391, 'Nazare', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.131401', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (392, 'Nova Olinda', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.132322', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (393, 'Nova Rosalandia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.133154', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (394, 'Novo Acordo', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.134133', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (395, 'Novo Alegre', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.135242', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (396, 'Novo Jardim', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.13607', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (397, 'Oliveira de Fatima', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.143376', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (399, 'Palmeirante', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.145386', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (401, 'Palmeiropolis', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.14756', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (402, 'Paraiso do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.148448', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (403, 'Parana', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.149167', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (404, 'Pau D''arco', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.150069', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (405, 'Pedro Afonso', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.151063', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (406, 'Peixe', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.151996', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (407, 'Pequizeiro', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.152856', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (348, 'Colmeia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.086822', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (408, 'Pindorama do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.153748', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (409, 'Piraque', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.154606', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (410, 'Pium', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.155474', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (411, 'Ponte Alta do Bom Jesus', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.156408', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (412, 'Ponte Alta do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.157673', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (413, 'Porto Alegre do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.158647', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (414, 'Porto Nacional', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.159639', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (415, 'Praia Norte', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.160437', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (416, 'Presidente Kennedy', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.16134', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (417, 'Pugmil', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.16224', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (418, 'Recursolandia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.163175', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (419, 'Riachinho', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.164096', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (420, 'Rio da Conceicao', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.164921', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (421, 'Rio dos Bois', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.165967', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (422, 'Rio Sono', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.166949', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (423, 'Sampaio', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.167811', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (424, 'Sandolandia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.168809', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (425, 'Santa Fe do Araguaia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.169817', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (426, 'Santa Maria do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.170766', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (427, 'Santa Rita do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.171677', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (428, 'Santa Rosa do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.172572', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (429, 'Santa Tereza do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.173518', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (430, 'Santa Terezinha do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.174352', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (431, 'Sao Bento do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.17523', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (432, 'Sao Felix do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.176102', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (433, 'Sao Miguel do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.177106', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (434, 'Sao Salvador do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.18496', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (435, 'Sao Sebastiao do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.186102', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (437, 'Silvanopolis', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.187777', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (438, 'Sitio Novo do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.188758', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (439, 'Sucupira', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.189661', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (440, 'Taguatinga', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.190463', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (441, 'Taipas do Tocantins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.191273', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (442, 'Talisma', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.192128', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (398, 'Palmas', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.144446', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (443, 'Tocantinia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.193041', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (444, 'Tocantinopolis', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.19396', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (445, 'Tupirama', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.194937', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (446, 'Tupiratins', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.195867', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (447, 'Wanderlandia', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.196689', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (448, 'Xambioa', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.197644', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (449, 'Acailandia', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.198538', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (450, 'Afonso Cunha', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.199462', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (451, 'Agua Doce do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.200279', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (452, 'Alcantara', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.201164', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (453, 'Aldeias Altas', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.202176', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (454, 'Altamira do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.203261', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (455, 'Alto Alegre do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.204215', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (456, 'Alto Alegre do Pindare', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.205089', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (457, 'Alto Parnaiba', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.206158', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (458, 'Amapa do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.20716', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (459, 'Amarante do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.208081', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (460, 'Anajatuba', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.208976', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (461, 'Anapurus', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.209855', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (462, 'Apicum-acu', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.210782', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (463, 'Araguana', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.211696', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (464, 'Araioses', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.212717', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (465, 'Arame', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.21353', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (466, 'Arari', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.214388', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (467, 'Axixa', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.215297', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (468, 'Bacabal', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.21624', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (469, 'Bacabeira', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.217163', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (470, 'Bacuri', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.218068', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (471, 'Bacurituba', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.218906', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (472, 'Balsas', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.226511', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (473, 'Barao de Grajau', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.227641', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (474, 'Barra do Corda', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.228529', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (475, 'Barreirinhas', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.22946', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (477, 'Belagua', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.231267', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (476, 'Bela Vista do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.230349', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (478, 'Benedito Leite', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.232219', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (479, 'Bequimao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.233065', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (480, 'Bernardo do Mearim', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.23398', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (481, 'Boa Vista do Gurupi', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.234892', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (482, 'Bom Jardim', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.235799', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (483, 'Bom Jesus das Selvas', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.236707', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (484, 'Bom Lugar', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.237544', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (485, 'Brejo', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.238393', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (486, 'Brejo de Areia', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.23924', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (487, 'Buriti', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.240212', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (488, 'Buriti Bravo', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.24103', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (489, 'Buriticupu', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.241945', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (490, 'Buritirana', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.242839', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (491, 'Cachoeira Grande', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.243731', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (492, 'Cajapio', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.244628', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (493, 'Cajari', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.245516', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (494, 'Campestre do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.246481', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (495, 'Candido Mendes', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.247331', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (496, 'Cantanhede', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.248243', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (497, 'Capinzal do Norte', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.249166', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (498, 'Carolina', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.250112', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (499, 'Carutapera', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.251005', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (500, 'Caxias', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.251858', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (501, 'Cedral', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.252814', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (502, 'Central do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.253724', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (503, 'Centro do Guilherme', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.254702', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (504, 'Centro Novo do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.255559', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (505, 'Chapadinha', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.256472', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (506, 'Cidelandia', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.257495', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (507, 'Codo', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.258325', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (508, 'Coelho Neto', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.259107', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (509, 'Colinas', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.259977', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (510, 'Conceicao do Lago-acu', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.267016', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (511, 'Coroata', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.268195', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (512, 'Cururupu', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.269164', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (513, 'Davinopolis', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.270095', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (514, 'Dom Pedro', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.271002', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (515, 'Duque Bacelar', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.271929', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (516, 'Esperantinopolis', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.27286', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (517, 'Estreito', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.273795', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (518, 'Feira Nova do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.274839', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (519, 'Fernando Falcao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.275832', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (520, 'Formosa da Serra Negra', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.276788', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (521, 'Fortaleza dos Nogueiras', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.27762', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (522, 'Fortuna', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.278459', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (523, 'Godofredo Viana', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.279542', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (524, 'Goncalves Dias', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.280371', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (525, 'Governador Archer', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.281277', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (526, 'Governador Edison Lobao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.282223', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (527, 'Governador Eugenio Barros', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.283125', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (528, 'Governador Luiz Rocha', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.283974', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (529, 'Governador Newton Bello', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.284782', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (530, 'Governador Nunes Freire', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.285675', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (531, 'Graca Aranha', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.286846', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (532, 'Grajau', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.287677', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (533, 'Guimaraes', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.288667', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (534, 'Humberto de Campos', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.289578', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (535, 'Icatu', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.290557', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (536, 'Igarape do Meio', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.291496', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (537, 'Igarape Grande', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.2924', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (538, 'Imperatriz', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.293262', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (539, 'Itaipava do Grajau', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.294094', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (540, 'Itapecuru Mirim', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.295124', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (541, 'Itinga do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.296028', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (542, 'Jatoba', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.296978', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (543, 'Jenipapo dos Vieiras', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.29789', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (544, 'Joao Lisboa', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.298837', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (545, 'Joselandia', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.299813', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (546, 'Junco do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.300907', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (547, 'Lago da Pedra', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.302071', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (548, 'Lago do Junco', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.307903', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (550, 'Lago Verde', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.310138', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (551, 'Lagoa do Mato', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.311156', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (549, 'Lago dos Rodrigues', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.309158', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (552, 'Lagoa Grande do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.312133', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (553, 'Lajeado Novo', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.313052', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (554, 'Lima Campos', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.313916', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (555, 'Loreto', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.31479', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (556, 'Luis Domingues', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.315685', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (557, 'Magalhaes de Almeida', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.316626', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (558, 'Maracacume', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.317519', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (559, 'Maraja do Sena', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.318381', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (560, 'Maranhaozinho', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.319219', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (561, 'Mata Roma', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.320109', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (562, 'Matinha', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.320966', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (563, 'Matoes', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.321907', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (564, 'Matoes do Norte', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.32282', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (565, 'Milagres do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.32375', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (566, 'Mirador', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.324883', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (567, 'Miranda do Norte', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.325801', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (568, 'Mirinzal', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.326849', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (569, 'Moncao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.327637', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (570, 'Montes Altos', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.328569', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (571, 'Morros', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.329367', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (572, 'Nina Rodrigues', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.330692', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (573, 'Nova Colinas', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.332095', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (574, 'Nova Iorque', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.333022', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (575, 'Nova Olinda do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.333932', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (576, 'Olho D''agua das Cunhas', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.334867', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (577, 'Olinda Nova do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.335779', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (578, 'Paco do Lumiar', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.33655', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (579, 'Palmeirandia', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.337518', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (580, 'Paraibano', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.338445', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (581, 'Parnarama', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.340223', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (582, 'Passagem Franca', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.341359', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (583, 'Pastos Bons', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.342182', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (584, 'Paulino Neves', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.352812', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (585, 'Paulo Ramos', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.353828', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (586, 'Pedreiras', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.354689', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (587, 'Pedro do Rosario', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.355564', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (588, 'Penalva', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.356425', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (589, 'Peri Mirim', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.357303', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (590, 'Peritoro', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.358268', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (592, 'Pinheiro', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.360105', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (593, 'Pio Xii', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.361003', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (594, 'Pirapemas', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.361829', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (595, 'Pocao de Pedras', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.362741', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (596, 'Porto Franco', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.363626', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (597, 'Porto Rico do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.364534', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (598, 'Presidente Dutra', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.365368', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (599, 'Presidente Juscelino', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.366202', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (600, 'Presidente Medici', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.367133', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (601, 'Presidente Sarney', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.368047', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (602, 'Presidente Vargas', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.368937', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (603, 'Primeira Cruz', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.369823', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (604, 'Raposa', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.370771', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (605, 'Riachao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.371655', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (606, 'Ribamar Fiquene', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.372579', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (607, 'Rosario', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.373524', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (608, 'Sambaiba', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.374298', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (609, 'Santa Filomena do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.375097', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (610, 'Santa Helena', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.376', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (611, 'Santa Ines', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.376926', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (612, 'Santa Luzia', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.37791', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (613, 'Santa Luzia do Parua', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.378894', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (614, 'Santa Quiteria do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.379769', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (615, 'Santa Rita', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.380996', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (616, 'Santana do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.381789', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (617, 'Santo Amaro do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.382757', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (618, 'Santo Antonio dos Lopes', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.38365', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (619, 'Sao Benedito do Rio Preto', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.384567', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (620, 'Sao Bento', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.385444', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (621, 'Sao Bernardo', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.386272', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (622, 'Sao Domingos do Azeitao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.388381', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (623, 'Sao Domingos do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.395118', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (624, 'Sao Felix de Balsas', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.39616', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (625, 'Sao Francisco do Brejao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.397025', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (626, 'Sao Francisco do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.398044', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (627, 'Sao Joao Batista', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.39892', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (628, 'Sao Joao do Caru', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.399745', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (629, 'Sao Joao do Paraiso', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.400816', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (630, 'Sao Joao do Soter', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.401759', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (631, 'Sao Joao dos Patos', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.402956', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (632, 'Sao Jose de Ribamar', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.403809', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (633, 'Sao Jose dos Basilios', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.404643', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (634, 'Sao Luis', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.405647', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (635, 'Sao Luis Gonzaga do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.40646', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (636, 'Sao Mateus do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.407324', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (637, 'Sao Pedro da Agua Branca', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.408245', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (638, 'Sao Pedro dos Crentes', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.409364', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (639, 'Sao Raimundo das Mangabeiras', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.410289', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (640, 'Sao Raimundo do Doca Bezerra', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.411219', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (641, 'Sao Roberto', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.412187', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (642, 'Sao Vicente Ferrer', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.413132', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (643, 'Satubinha', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.414213', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (644, 'Senador Alexandre Costa', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.41502', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (645, 'Senador La Rocque', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.416003', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (646, 'Serrano do Maranhao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.416907', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (647, 'Sitio Novo', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.417788', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (648, 'Sucupira do Norte', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.418657', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (649, 'Sucupira do Riachao', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.419524', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (650, 'Tasso Fragoso', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.420459', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (651, 'Timbiras', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.421346', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (652, 'Timon', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.422227', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (653, 'Trizidela do Vale', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.4231', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (654, 'Tufilandia', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.424033', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (655, 'Tuntum', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.425218', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (656, 'Turiacu', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.426154', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (657, 'Turilandia', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.426947', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (658, 'Tutoia', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.427726', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (659, 'Urbano Santos', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.428556', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (660, 'Vargem Grande', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.435067', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (661, 'Viana', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.436627', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (662, 'Vila Nova dos Martirios', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.43748', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (663, 'Vitoria do Mearim', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.438392', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (664, 'Vitorino Freire', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.439218', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (665, 'Ze Doca', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.440175', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (666, 'Acaua', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.441086', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (667, 'Agricolandia', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.44202', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (668, 'Agua Branca', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.443259', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (669, 'Alagoinha do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.444215', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (670, 'Alegrete do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.445155', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (671, 'Alto Longa', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.446035', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (672, 'Altos', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.446996', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (673, 'Alvorada do Gurgueia', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.447826', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (674, 'Amarante', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.448565', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (675, 'Angical do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.449534', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (676, 'Anisio de Abreu', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.450473', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (677, 'Antonio Almeida', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.451325', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (678, 'Aroazes', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.452206', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (680, 'Arraial', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.453937', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (681, 'Assuncao do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.454994', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (682, 'Avelino Lopes', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.455933', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (683, 'Baixa Grande do Ribeiro', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.456842', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (685, 'Barras', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.458843', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (686, 'Barreiras do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.460085', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (687, 'Barro Duro', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.461037', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (688, 'Batalha', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.461931', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (689, 'Bela Vista do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.462988', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (690, 'Belem do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.463815', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (691, 'Beneditinos', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.464727', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (692, 'Bertolinia', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.465651', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (693, 'Betania do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.466532', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (694, 'Boa Hora', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.467333', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (695, 'Bocaina', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.468202', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (696, 'Bom Jesus', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.469091', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (697, 'Bom Principio do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.476209', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (698, 'Bonfim do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.477453', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (699, 'Boqueirao do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.478284', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (700, 'Brasileira', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.479141', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (701, 'Brejo do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.479943', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (702, 'Buriti dos Lopes', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.481156', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (703, 'Buriti dos Montes', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.481975', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (704, 'Cabeceiras do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.482873', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (705, 'Cajazeiras do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.483761', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (706, 'Cajueiro da Praia', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.484708', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (707, 'Caldeirao Grande do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.485653', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (708, 'Campinas do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.4866', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (709, 'Campo Alegre do Fidalgo', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.487558', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (710, 'Campo Grande do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.488623', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (711, 'Campo Largo do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.489554', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (712, 'Campo Maior', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.490426', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (713, 'Canavieira', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.491345', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (714, 'Canto do Buriti', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.492473', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (715, 'Capitao de Campos', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.493449', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (716, 'Capitao Gervasio Oliveira', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.49426', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (717, 'Caracol', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.495011', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (718, 'Caraubas do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.495894', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (719, 'Caridade do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.496798', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (720, 'Castelo do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.49769', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (721, 'Caxingo', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.498551', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (722, 'Cocal', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.49945', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (723, 'Cocal de Telha', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.500365', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (724, 'Cocal dos Alves', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.501178', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (725, 'Coivaras', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.50203', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (726, 'Colonia do Gurgueia', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.502948', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (727, 'Colonia do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.503724', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (728, 'Conceicao do Caninde', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.504605', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (729, 'Coronel Jose Dias', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.50551', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (730, 'Corrente', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.506368', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (731, 'Cristalandia do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.507245', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (732, 'Cristino Castro', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.508161', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (733, 'Curimata', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.509093', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (734, 'Currais', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.509915', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (736, 'Curralinhos', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.517649', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (735, 'Curral Novo do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.516478', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (737, 'Demerval Lobao', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.518747', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (738, 'Dirceu Arcoverde', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.519566', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (739, 'Dom Expedito Lopes', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.520463', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (741, 'Domingos Mourao', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.522', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (740, 'Dom Inocencio', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.521277', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (742, 'Elesbao Veloso', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.522894', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (743, 'Eliseu Martins', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.52379', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (744, 'Esperantina', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.524652', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (745, 'Fartura do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.526063', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (746, 'Flores do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.527005', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (747, 'Floresta do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.527865', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (748, 'Floriano', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.528733', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (749, 'Francinopolis', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.529749', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (750, 'Francisco Ayres', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.530678', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (751, 'Francisco Macedo', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.531546', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (752, 'Francisco Santos', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.532468', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (753, 'Fronteiras', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.533279', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (754, 'Geminiano', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.534092', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (755, 'Gilbues', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.535027', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (756, 'Guadalupe', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.535945', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (757, 'Guaribas', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.536987', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (758, 'Hugo Napoleao', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.53787', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (759, 'Ilha Grande', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.538744', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (760, 'Inhuma', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.539664', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (761, 'Ipiranga do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.540631', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (762, 'Isaias Coelho', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.541589', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (763, 'Itainopolis', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.54226', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (764, 'Itaueira', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.543208', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (765, 'Jacobina do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.544013', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (766, 'Jaicos', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.544932', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (767, 'Jardim do Mulato', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.545843', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (768, 'Jatoba do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.546727', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (769, 'Jerumenha', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.547582', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (770, 'Joao Costa', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.548411', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (771, 'Joaquim Pires', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.549224', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (772, 'Joca Marques', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.550172', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (773, 'Jose de Freitas', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.557', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (774, 'Juazeiro do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.558345', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (775, 'Julio Borges', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.559238', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (776, 'Jurema', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.560161', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (782, 'Lagoinha do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.565646', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (777, 'Lagoa Alegre', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.561061', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (779, 'Lagoa do Barro do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.56292', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (778, 'Lagoa de Sao Francisco', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.562032', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (780, 'Lagoa do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.56385', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (781, 'Lagoa do Sitio', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.56476', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (783, 'Landri Sales', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.566526', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (784, 'Luis Correia', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.567389', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (785, 'Luzilandia', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.568333', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (786, 'Madeiro', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.569282', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (787, 'Manoel Emidio', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.57028', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (788, 'Marcolandia', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.571109', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (789, 'Marcos Parente', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.571924', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (790, 'Massape do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.572792', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (791, 'Matias Olimpio', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.573727', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (792, 'Miguel Alves', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.574699', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (793, 'Miguel Leao', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.575592', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (794, 'Milton Brandao', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.576731', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (795, 'Monsenhor Gil', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.577659', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (796, 'Monsenhor Hipolito', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.578489', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (797, 'Monte Alegre do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.579329', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (798, 'Morro Cabeca No Tempo', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.580308', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (799, 'Morro do Chapeu do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.581572', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (800, 'Murici dos Portelas', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.582369', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (801, 'Nazare do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.583261', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (803, 'Nossa Senhora de Nazare', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.585035', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (804, 'Nossa Senhora dos Remedios', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.585913', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (806, 'Novo Oriente do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.587703', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (807, 'Novo Santo Antonio', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.588561', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (808, 'Oeiras', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.58949', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (810, 'Padre Marcos', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.591217', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (811, 'Paes Landim', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.592557', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (812, 'Pajeu do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.598809', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (813, 'Palmeira do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.599731', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (814, 'Palmeirais', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.600651', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (815, 'Paqueta', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.601586', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (816, 'Parnagua', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.603105', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (817, 'Parnaiba', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.603974', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (818, 'Passagem Franca do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.604851', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (819, 'Patos do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.605756', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (820, 'Pau D''arco do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.606727', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (821, 'Paulistana', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.607612', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (822, 'Pavussu', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.608647', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (823, 'Pedro Ii', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.609674', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (824, 'Pedro Laurentino', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.610587', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (805, 'Nova Santa Rita', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.58681', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (825, 'Picos', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.611502', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (826, 'Pimenteiras', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.61237', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (827, 'Pio Ix', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.61325', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (828, 'Piracuruca', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.6142', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (829, 'Piripiri', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.615071', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (830, 'Porto', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.616029', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (831, 'Porto Alegre do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.617018', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (832, 'Prata do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.617877', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (833, 'Queimada Nova', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.618689', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (834, 'Redencao do Gurgueia', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.619662', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (835, 'Regeneracao', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.620619', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (836, 'Riacho Frio', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.621548', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (837, 'Ribeira do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.62253', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (838, 'Ribeiro Goncalves', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.623518', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (839, 'Rio Grande do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.624477', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (840, 'Santa Cruz do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.625541', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (841, 'Santa Cruz dos Milagres', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.626406', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (842, 'Santa Filomena', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.627271', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (843, 'Santa Luz', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.628246', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (845, 'Santana do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.630097', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (844, 'Santa Rosa do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.629172', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (846, 'Santo Antonio de Lisboa', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.630983', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (847, 'Santo Antonio dos Milagres', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.631953', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (848, 'Santo Inacio do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.638737', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (849, 'Sao Braz do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.640018', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (850, 'Sao Felix do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.641003', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (851, 'Sao Francisco de Assis do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.641974', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (852, 'Sao Francisco do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.642905', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (853, 'Sao Goncalo do Gurgueia', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.643859', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (854, 'Sao Goncalo do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.644778', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (855, 'Sao Joao da Canabrava', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.645729', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (856, 'Sao Joao da Fronteira', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.646746', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (857, 'Sao Joao da Serra', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.64776', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (858, 'Sao Joao da Varjota', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.648584', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (859, 'Sao Joao do Arraial', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.649445', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (860, 'Sao Joao do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.65029', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (861, 'Sao Jose do Divino', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.65123', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (862, 'Sao Jose do Peixe', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.652159', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (863, 'Sao Jose do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.653052', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (864, 'Sao Juliao', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.654041', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (865, 'Sao Lourenco do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.654978', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (866, 'Sao Luis do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.655997', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (867, 'Sao Miguel da Baixa Grande', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.656848', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (868, 'Sao Miguel do Fidalgo', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.657708', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (869, 'Sao Miguel do Tapuio', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.658591', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (870, 'Sao Pedro do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.659708', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (871, 'Sao Raimundo Nonato', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.660725', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (872, 'Sebastiao Barros', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.661633', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (873, 'Sebastiao Leal', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.662743', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (874, 'Sigefredo Pacheco', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.663614', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (875, 'Simoes', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.664475', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (876, 'Simplicio Mendes', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.665361', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (877, 'Socorro do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.666288', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (878, 'Sussuapara', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.667165', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (879, 'Tamboril do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.668103', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (880, 'Tanque do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.669016', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (881, 'Teresina', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.670074', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (882, 'Uniao', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.670865', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (883, 'Urucui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.671796', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (884, 'Valenca do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.67261', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (885, 'Varzea Branca', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.679609', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (886, 'Varzea Grande', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.680844', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (887, 'Vera Mendes', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.681873', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (888, 'Vila Nova do Piaui', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.68279', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (889, 'Wall Ferraz', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.683613', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (890, 'Abaiara', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.684498', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (891, 'Acarape', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.685459', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (892, 'Acarau', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.686316', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (893, 'Acopiara', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.687319', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (894, 'Aiuaba', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.688458', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (895, 'Alcantaras', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.68946', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (896, 'Altaneira', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.690345', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (897, 'Alto Santo', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.691214', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (898, 'Amontada', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.692091', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (899, 'Antonina do Norte', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.693258', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (900, 'Apuiares', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.69425', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (901, 'Aquiraz', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.695167', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (902, 'Aracati', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.69614', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (903, 'Aracoiaba', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.69696', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (904, 'Ararenda', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.697861', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (905, 'Araripe', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.698832', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (906, 'Aratuba', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.69974', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (907, 'Arneiroz', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.700663', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (908, 'Assare', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.701591', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (909, 'Aurora', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.702351', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (910, 'Baixio', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.703411', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (911, 'Banabuiu', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.704293', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (912, 'Barbalha', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.705191', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (913, 'Barreira', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.706139', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (914, 'Barro', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.707138', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (915, 'Barroquinha', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.708104', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (916, 'Baturite', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.70905', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (917, 'Beberibe', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.71002', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (918, 'Bela Cruz', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.710898', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (919, 'Boa Viagem', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.711755', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (920, 'Brejo Santo', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.712556', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (921, 'Camocim', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.713478', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (922, 'Campos Sales', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.720078', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (923, 'Caninde', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.721176', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (924, 'Capistrano', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.722137', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (925, 'Caridade', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.723051', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (926, 'Carire', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.724031', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (927, 'Caririacu', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.725002', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (928, 'Carius', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.72603', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (929, 'Carnaubal', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.726882', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (930, 'Cascavel', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.72791', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (931, 'Catarina', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.728846', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (932, 'Catunda', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.72975', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (933, 'Caucaia', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.73058', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (934, 'Cedro', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.731508', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (935, 'Chaval', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.732465', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (936, 'Choro', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.733347', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (937, 'Chorozinho', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.734151', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (938, 'Coreau', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.735038', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (939, 'Crateus', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.735982', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (940, 'Crato', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.736982', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (941, 'Croata', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.73788', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (942, 'Cruz', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.738764', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (943, 'Deputado Irapuan Pinheiro', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.739701', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (944, 'Erere', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.740766', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (945, 'Eusebio', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.741714', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (946, 'Farias Brito', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.742725', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (947, 'Forquilha', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.743617', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (948, 'Fortaleza', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.744504', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (949, 'Fortim', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.74536', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (950, 'Frecheirinha', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.7463', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (951, 'General Sampaio', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.747206', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (952, 'Graca', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.748217', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (953, 'Granja', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.74904', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (954, 'Granjeiro', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.749942', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (955, 'Groairas', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.750947', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (956, 'Guaiuba', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.751904', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (957, 'Guaraciaba do Norte', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.752745', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (958, 'Guaramiranga', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.753708', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (959, 'Hidrolandia', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.760735', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (960, 'Horizonte', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.761924', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (961, 'Ibaretama', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.762867', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (962, 'Ibiapina', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.763788', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (963, 'Ibicuitinga', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.764672', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (964, 'Icapui', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.765576', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (965, 'Ico', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.76682', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (966, 'Iguatu', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.767721', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (967, 'Independencia', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.768666', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (968, 'Ipaporanga', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.769582', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (969, 'Ipaumirim', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.770486', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (970, 'Ipu', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.771489', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (971, 'Ipueiras', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.772507', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (972, 'Iracema', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.773512', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (973, 'Iraucuba', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.774468', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (974, 'Itaicaba', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.77543', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (975, 'Itaitinga', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.77631', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (977, 'Itapipoca', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.778328', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (978, 'Itapiuna', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.779217', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (979, 'Itarema', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.780134', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (980, 'Itatira', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.781004', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (981, 'Jaguaretama', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.781931', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (982, 'Jaguaribara', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.782755', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (983, 'Jaguaribe', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.783553', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (984, 'Jaguaruana', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.784418', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (985, 'Jardim', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.785258', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (986, 'Jati', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.786168', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (987, 'Jijoca de Jericoacoara', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.787039', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (988, 'Juazeiro do Norte', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.787963', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (989, 'Jucas', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.788883', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (990, 'Lavras da Mangabeira', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.789684', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (991, 'Limoeiro do Norte', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.790614', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (992, 'Madalena', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.791485', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (993, 'Maracanau', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.79239', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (994, 'Maranguape', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.793456', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (995, 'Marco', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.794381', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (996, 'Martinopole', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.801277', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (997, 'Massape', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.802543', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (998, 'Mauriti', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.805558', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (999, 'Meruoca', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.806559', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1000, 'Milagres', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.80731', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1001, 'Milha', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.808353', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1002, 'Miraima', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.809236', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1003, 'Missao Velha', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.810299', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1004, 'Mombaca', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.811154', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1005, 'Monsenhor Tabosa', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.81203', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1006, 'Morada Nova', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.812903', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1007, 'Moraujo', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.81377', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1008, 'Morrinhos', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.814722', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1009, 'Mucambo', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.815781', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1010, 'Mulungu', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.816724', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1011, 'Nova Olinda', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.817636', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1012, 'Nova Russas', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.81856', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1013, 'Novo Oriente', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.819509', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1014, 'Ocara', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.820449', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1015, 'Oros', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.821307', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1016, 'Pacajus', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.822177', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1017, 'Pacatuba', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.823119', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1018, 'Pacoti', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.823944', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1019, 'Pacuja', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.824879', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1020, 'Palhano', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.825848', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1021, 'Palmacia', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.826961', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1022, 'Paracuru', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.827911', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1023, 'Paraipaba', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.828797', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1024, 'Parambu', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.829733', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1025, 'Paramoti', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.830639', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1026, 'Pedra Branca', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.831545', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1027, 'Penaforte', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.832489', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1028, 'Pentecoste', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.83333', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1029, 'Pereiro', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.834139', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1030, 'Pindoretama', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.835062', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1031, 'Piquet Carneiro', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.842709', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1032, 'Pires Ferreira', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.843807', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1033, 'Poranga', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.844903', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1034, 'Porteiras', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.846084', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1035, 'Potengi', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.847051', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1036, 'Potiretama', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.848016', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1037, 'Quiterianopolis', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.849214', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1038, 'Quixada', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.850112', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1039, 'Quixelo', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.851035', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1040, 'Quixeramobim', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.851966', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1041, 'Quixere', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.852901', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1042, 'Redencao', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.853907', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1043, 'Reriutaba', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.855028', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1044, 'Russas', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.85597', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1045, 'Saboeiro', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.856853', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1046, 'Salitre', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.857981', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1048, 'Santana do Acarau', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.85981', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1049, 'Santana do Cariri', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.860708', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1047, 'Santa Quiteria', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.858908', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1050, 'Sao Benedito', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.861601', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1051, 'Sao Goncalo do Amarante', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.862529', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1052, 'Sao Joao do Jaguaribe', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.863447', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1053, 'Sao Luis do Curu', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.864358', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1054, 'Senador Pompeu', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.865343', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1055, 'Senador Sa', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.866271', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1056, 'Sobral', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.86725', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1057, 'Solonopole', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.868244', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1058, 'Tabuleiro do Norte', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.869195', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1059, 'Tamboril', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.87011', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1060, 'Tarrafas', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.871112', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1061, 'Taua', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.872086', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1062, 'Tejucuoca', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.873195', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1063, 'Tiangua', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.874116', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1064, 'Trairi', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.875052', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1065, 'Tururu', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.875935', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1066, 'Ubajara', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.883523', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1067, 'Umari', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.884695', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1068, 'Umirim', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.885677', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1069, 'Uruburetama', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.886516', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1070, 'Uruoca', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.887569', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1071, 'Varjota', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.88856', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1072, 'Varzea Alegre', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.889456', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1073, 'Vicosa do Ceara', 'CE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.890355', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1074, 'Acari', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.891402', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1075, 'Acu', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.892249', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1076, 'Afonso Bezerra', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.893143', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1077, 'Agua Nova', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.894078', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1078, 'Alexandria', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.895039', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1079, 'Almino Afonso', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.895926', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1080, 'Alto do Rodrigues', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.896798', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1081, 'Angicos', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.897649', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1082, 'Antonio Martins', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.898468', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1083, 'Apodi', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.899511', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1084, 'Areia Branca', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.900457', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1085, 'Ares', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.901317', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1086, 'Augusto Severo', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.902303', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1087, 'Baia Formosa', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.903218', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1088, 'Barauna', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.904292', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1089, 'Barcelona', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.905211', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1090, 'Bento Fernandes', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.906199', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1091, 'Bodo', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.907136', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1092, 'Bom Jesus', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.908193', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1093, 'Brejinho', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.909163', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1094, 'Caicara do Norte', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.910096', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1095, 'Caicara do Rio do Vento', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.911027', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1096, 'Caico', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.911823', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1097, 'Campo Redondo', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.912823', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1098, 'Canguaretama', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.913613', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1099, 'Caraubas', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.914478', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1100, 'Carnauba dos Dantas', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.915516', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1101, 'Carnaubais', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.916333', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1102, 'Ceara-mirim', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.917214', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1103, 'Cerro Cora', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.924082', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1104, 'Coronel Ezequiel', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.925293', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1105, 'Coronel Joao Pessoa', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.926424', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1106, 'Cruzeta', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.927437', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1107, 'Currais Novos', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.928357', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1108, 'Doutor Severiano', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.92922', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1170, 'Parnamirim', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.992169', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1109, 'Encanto', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.930124', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1110, 'Equador', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.930949', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1111, 'Espirito Santo', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.93187', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1112, 'Extremoz', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.93282', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1113, 'Felipe Guerra', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.933753', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1114, 'Fernando Pedroza', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.934712', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1115, 'Florania', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.935678', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1116, 'Francisco Dantas', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.936647', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1117, 'Frutuoso Gomes', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.93762', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1118, 'Galinhos', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.938502', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1119, 'Goianinha', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.939453', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1120, 'Governador Dix-sept Rosado', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.940328', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1121, 'Grossos', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.941151', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1122, 'Guamare', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.942246', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1123, 'Ielmo Marinho', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.943257', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1124, 'Ipanguacu', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.944128', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1125, 'Ipueira', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.945019', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1126, 'Itaja', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.946076', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1127, 'Itau', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.946989', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1128, 'Jacana', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.947875', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1129, 'Jandaira', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.948829', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1130, 'Janduis', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.949781', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1131, 'Januario Cicco', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.950601', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1132, 'Japi', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.951564', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1133, 'Jardim de Angicos', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.952483', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1134, 'Jardim de Piranhas', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.953409', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1135, 'Jardim do Serido', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.954238', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1136, 'Joao Camara', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.955149', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1137, 'Joao Dias', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.956075', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1138, 'Jose da Penha', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.957006', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1139, 'Jucurutu', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.957905', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1140, 'Jundia', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.958828', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1141, 'Lagoa D''anta', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.965134', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1142, 'Lagoa de Pedras', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.966233', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1143, 'Lagoa de Velhos', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.967108', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1144, 'Lagoa Nova', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.96806', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1145, 'Lagoa Salgada', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.968966', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1146, 'Lajes', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.96988', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1147, 'Lajes Pintadas', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.970916', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1148, 'Lucrecia', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.971944', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1149, 'Luis Gomes', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.973018', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1150, 'Macaiba', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.973955', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1151, 'Macau', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.974833', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1152, 'Major Sales', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.975688', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1153, 'Marcelino Vieira', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.976567', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1154, 'Martins', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.977442', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1155, 'Maxaranguape', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.978517', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1156, 'Messias Targino', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.979498', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1157, 'Montanhas', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.980416', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1158, 'Monte Alegre', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.981295', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1159, 'Monte das Gameleiras', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.982178', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1160, 'Mossoro', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.983168', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1161, 'Natal', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.98404', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1162, 'Nisia Floresta', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.984957', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1163, 'Nova Cruz', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.98583', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1164, 'Olho-d''agua do Borges', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.986796', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1165, 'Ouro Branco', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.987717', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1166, 'Parana', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.988598', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1167, 'Parau', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.989498', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1168, 'Parazinho', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.990437', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1169, 'Parelhas', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.99129', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1191, 'Rio do Fogo', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.017658', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1171, 'Passa e Fica', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.99297', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1172, 'Passagem', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.994099', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1173, 'Patu', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.994899', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1195, 'Santa Maria', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.021445', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1174, 'Pau dos Ferros', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.995778', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1175, 'Pedra Grande', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.996685', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1176, 'Pedra Preta', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.997564', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1177, 'Pedro Avelino', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.998571', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1178, 'Pedro Velho', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.005427', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1179, 'Pendencias', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.00655', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1180, 'Piloes', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.007471', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1181, 'Poco Branco', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.00834', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1182, 'Portalegre', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.009265', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1183, 'Porto do Mangue', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.010181', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1185, 'Pureza', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.012', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1186, 'Rafael Fernandes', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.012814', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1187, 'Rafael Godeiro', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.013633', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1188, 'Riacho da Cruz', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.014532', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1189, 'Riacho de Santana', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.015533', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1190, 'Riachuelo', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.016688', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1192, 'Rodolfo Fernandes', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.018555', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1229, 'Tibau', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.059823', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1193, 'Ruy Barbosa', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.019556', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1194, 'Santa Cruz', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.020402', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1196, 'Santana do Matos', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.022177', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1197, 'Santana do Serido', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.023022', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1198, 'Santo Antonio', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.023864', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1199, 'Sao Bento do Norte', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.024666', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1200, 'Sao Bento do Trairi', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.025598', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1201, 'Sao Fernando', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.026479', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1202, 'Sao Francisco do Oeste', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.027777', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1203, 'Sao Goncalo do Amarante', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.028644', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1204, 'Sao Joao do Sabugi', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.029513', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1205, 'Sao Jose de Mipibu', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.03041', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1206, 'Sao Jose do Campestre', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.031271', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1207, 'Sao Jose do Serido', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.032197', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1208, 'Sao Miguel', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.03317', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1209, 'Sao Miguel do Gostoso', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.034112', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1210, 'Sao Paulo do Potengi', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.035023', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1211, 'Sao Pedro', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.035951', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1212, 'Sao Rafael', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.03703', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1213, 'Sao Tome', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.037977', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1214, 'Sao Vicente', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.039135', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1215, 'Senador Eloi de Souza', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.045963', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1216, 'Senador Georgino Avelino', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.047205', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1217, 'Serra de Sao Bento', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.048251', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1218, 'Serra do Mel', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.049257', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1219, 'Serra Negra do Norte', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.050121', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1220, 'Serrinha', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.051006', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1221, 'Serrinha dos Pintos', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.052384', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1222, 'Severiano Melo', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.053323', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1223, 'Sitio Novo', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.05422', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1224, 'Taboleiro Grande', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.055116', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1225, 'Taipu', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.055992', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1226, 'Tangara', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.056821', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1227, 'Tenente Ananias', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.057772', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1228, 'Tenente Laurentino Cruz', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.058756', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1230, 'Tibau do Sul', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.061144', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1231, 'Timbauba dos Batistas', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.062201', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1232, 'Touros', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.063184', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1233, 'Triunfo Potiguar', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.064106', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1234, 'Umarizal', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.065006', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1235, 'Upanema', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.065955', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1236, 'Varzea', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.066769', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1237, 'Venha-ver', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.067688', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1238, 'Vera Cruz', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.068614', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1239, 'Vicosa', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.069524', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1240, 'Vila Flor', 'RN', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.070393', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1241, 'Agua Branca', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.071439', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1242, 'Aguiar', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.072434', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1243, 'Alagoa Grande', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.073282', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1244, 'Alagoa Nova', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.074227', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1245, 'Alagoinha', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.075158', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1246, 'Alcantil', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.076009', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1247, 'Algodao de Jandaira', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.076841', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1248, 'Alhandra', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.07777', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1423, 'Sao Joao do Rio do Peixe', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.271743', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1249, 'Amparo', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.078587', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1250, 'Aparecida', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.079657', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1251, 'Aracagi', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.086461', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1252, 'Arara', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.087625', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1253, 'Araruna', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.088977', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1254, 'Areia', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.089891', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1255, 'Areia de Baraunas', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.090763', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1256, 'Areial', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.09166', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1257, 'Aroeiras', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.092651', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1258, 'Assuncao', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.093528', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1259, 'Baia da Traicao', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.094762', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1260, 'Bananeiras', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.0956', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1261, 'Barauna', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.096454', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1263, 'Barra de Santana', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.098328', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1262, 'Barra de Santa Rosa', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.097433', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1264, 'Barra de Sao Miguel', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.099207', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1265, 'Bayeux', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.100233', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1266, 'Belem', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.101175', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1267, 'Belem do Brejo do Cruz', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.102014', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1268, 'Bernardino Batista', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.102935', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1269, 'Boa Ventura', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.10377', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1270, 'Boa Vista', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.104778', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1271, 'Bom Jesus', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.105776', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1272, 'Bom Sucesso', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.106763', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1273, 'Bonito de Santa Fe', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.107652', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1274, 'Boqueirao', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.108561', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1326, 'Igaracy', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.169184', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1275, 'Borborema', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.109233', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1276, 'Brejo do Cruz', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.110176', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1277, 'Brejo dos Santos', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.111091', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1278, 'Caapora', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.112052', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1279, 'Cabaceiras', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.112919', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1280, 'Cabedelo', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.113819', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1281, 'Cachoeira dos Indios', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.114792', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1282, 'Cacimba de Areia', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.115622', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1283, 'Cacimba de Dentro', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.116562', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1284, 'Cacimbas', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.117359', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1285, 'Caicara', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.118234', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1286, 'Cajazeiras', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.119142', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1287, 'Cajazeirinhas', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.120118', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1288, 'Caldas Brandao', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.126902', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1289, 'Camalau', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.128216', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1290, 'Campina Grande', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.129109', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1292, 'Capim', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.130913', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1293, 'Caraubas', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.131989', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1294, 'Carrapateira', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.132966', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1295, 'Casserengue', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.133895', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1296, 'Catingueira', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.134819', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1297, 'Catole do Rocha', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.135839', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1298, 'Caturite', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.136857', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1299, 'Conceicao', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.137768', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1300, 'Condado', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.138687', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1301, 'Conde', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.139541', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1302, 'Congo', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.140593', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1303, 'Coremas', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.141567', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1304, 'Coxixola', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.142408', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1305, 'Cruz do Espirito Santo', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.143316', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1306, 'Cubati', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.144275', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1307, 'Cuite', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.145159', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1309, 'Cuitegi', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.146933', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1308, 'Cuite de Mamanguape', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.146038', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1310, 'Curral de Cima', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.147807', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1311, 'Curral Velho', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.14869', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1312, 'Damiao', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.149547', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1313, 'Desterro', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.150441', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1462, 'Vista Serrana', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.312486', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1314, 'Diamante', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.151433', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1315, 'Dona Ines', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.152276', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1316, 'Duas Estradas', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.153226', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1317, 'Emas', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.154106', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1318, 'Esperanca', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.154937', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1319, 'Fagundes', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.15573', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1320, 'Frei Martinho', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.156702', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1321, 'Gado Bravo', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.157619', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1322, 'Guarabira', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.158561', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1323, 'Gurinhem', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.159521', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1324, 'Gurjao', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.160604', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1325, 'Ibiara', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.168082', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1327, 'Imaculada', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.170197', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1328, 'Inga', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.171029', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1329, 'Itabaiana', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.172174', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1330, 'Itaporanga', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.173123', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1331, 'Itapororoca', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.174094', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1332, 'Itatuba', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.174905', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1333, 'Jacarau', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.175971', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1334, 'Jerico', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.176834', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1335, 'Joao Pessoa', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.177745', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1336, 'Juarez Tavora', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.178614', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1337, 'Juazeirinho', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.179447', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1338, 'Junco do Serido', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.180365', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1339, 'Juripiranga', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.181348', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1340, 'Juru', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.182217', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1341, 'Lagoa', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.183149', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1342, 'Lagoa de Dentro', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.184115', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1343, 'Lagoa Seca', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.185256', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1344, 'Lastro', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.186203', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1345, 'Livramento', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.187139', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1346, 'Logradouro', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.18807', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1347, 'Lucena', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.188966', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1348, 'Mae D''agua', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.189872', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1349, 'Malta', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.190783', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1350, 'Mamanguape', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.191714', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1351, 'Manaira', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.192634', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1352, 'Marcacao', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.193573', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1353, 'Mari', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.194537', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1354, 'Marizopolis', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.195373', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1355, 'Massaranduba', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.196294', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1356, 'Mataraca', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.197125', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1357, 'Matinhas', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.198047', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1358, 'Mato Grosso', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.198975', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1359, 'Matureia', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.199965', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1360, 'Mogeiro', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.200795', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1361, 'Montadas', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.201784', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1362, 'Monte Horebe', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.209441', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1363, 'Monteiro', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.210611', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1364, 'Mulungu', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.21166', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1365, 'Natuba', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.212408', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1366, 'Nazarezinho', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.213326', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1367, 'Nova Floresta', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.214238', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1368, 'Nova Olinda', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.215124', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1369, 'Nova Palmeira', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.215985', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1370, 'Olho D''agua', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.216966', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1371, 'Olivedos', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.217879', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1372, 'Ouro Velho', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.218822', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1373, 'Parari', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.219627', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1374, 'Passagem', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.220662', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1375, 'Patos', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.22147', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1376, 'Paulista', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.222548', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1377, 'Pedra Branca', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.223486', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1378, 'Pedra Lavrada', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.224321', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1379, 'Pedras de Fogo', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.225261', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1381, 'Pianco', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.22712', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1382, 'Picui', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.228008', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1383, 'Pilar', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.228887', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1384, 'Piloes', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.230081', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1385, 'Piloezinhos', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.230945', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1386, 'Pirpirituba', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.231857', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1387, 'Pitimbu', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.232742', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1388, 'Pocinhos', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.233566', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1389, 'Poco Dantas', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.234628', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1390, 'Poco de Jose de Moura', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.235532', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1391, 'Pombal', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.236417', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1392, 'Prata', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.23723', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1393, 'Princesa Isabel', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.238127', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1394, 'Puxinana', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.238929', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1395, 'Queimadas', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.239764', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1396, 'Quixaba', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.240693', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1397, 'Remigio', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.241454', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1380, 'Pedro Regis', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.226144', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1398, 'Riachao', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.242406', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1399, 'Riachao do Bacamarte', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.243145', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1400, 'Riachao do Poco', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.249788', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1401, 'Riacho de Santo Antonio', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.250952', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1402, 'Riacho dos Cavalos', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.252411', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1403, 'Rio Tinto', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.253304', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1404, 'Salgadinho', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.25416', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1405, 'Salgado de Sao Felix', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.255117', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1406, 'Santa Cecilia', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.256209', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1407, 'Santa Cruz', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.25718', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1408, 'Santa Helena', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.258032', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1409, 'Santa Ines', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.258871', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1410, 'Santa Luzia', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.25973', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1413, 'Santana de Mangueira', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.262825', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1414, 'Santana dos Garrotes', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.263649', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1411, 'Santa Rita', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.260598', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1412, 'Santa Teresinha', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.261849', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1416, 'Santo Andre', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.265495', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1418, 'Sao Bento', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.26724', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1417, 'Sao Bentinho', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.266426', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1420, 'Sao Domingos do Cariri', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.269057', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1421, 'Sao Francisco', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.269946', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1422, 'Sao Joao do Cariri', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.270871', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1424, 'Sao Joao do Tigre', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.272737', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1425, 'Sao Jose da Lagoa Tapada', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.273614', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1426, 'Sao Jose de Caiana', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.274688', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1427, 'Sao Jose de Espinharas', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.27563', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1434, 'Sao Jose dos Ramos', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.281823', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1428, 'Sao Jose de Piranhas', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.276506', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1429, 'Sao Jose de Princesa', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.277443', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1430, 'Sao Jose do Bonfim', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.278377', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1431, 'Sao Jose do Brejo do Cruz', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.279212', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1432, 'Sao Jose do Sabugi', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.280095', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1433, 'Sao Jose dos Cordeiros', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.280958', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1435, 'Sao Mamede', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.282705', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1436, 'Sao Miguel de Taipu', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.283547', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1437, 'Sao Sebastiao de Lagoa de Roca', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.290398', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1438, 'Sao Sebastiao do Umbuzeiro', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.291562', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1440, 'Sape', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.293434', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1439, 'Sao Vicente do Serido', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.292442', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1441, 'Serra Branca', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.294291', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1442, 'Serra da Raiz', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.295204', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1443, 'Serra Grande', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.29615', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1444, 'Serra Redonda', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.296925', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1445, 'Serraria', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.297727', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1446, 'Sertaozinho', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.298636', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1447, 'Sobrado', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.299495', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1448, 'Solanea', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.300403', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1449, 'Soledade', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.301233', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1450, 'Sossego', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.302085', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1451, 'Sousa', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.302975', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1452, 'Sume', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.303766', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1453, 'Taperoa', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.304635', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1454, 'Tavares', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.305527', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1455, 'Teixeira', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.306383', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1456, 'Tenorio', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.3074', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1457, 'Triunfo', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.308232', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1458, 'Uirauna', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.309099', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1459, 'Umbuzeiro', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.309848', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1460, 'Varzea', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.310707', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1461, 'Vieiropolis', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.311518', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1463, 'Zabele', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.31346', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1464, 'Abreu e Lima', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.314455', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1465, 'Afogados da Ingazeira', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.315369', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1466, 'Afranio', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.316283', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1467, 'Agrestina', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.317184', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1468, 'Agua Preta', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.318148', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1469, 'Aguas Belas', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.319228', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1470, 'Alagoinha', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.320145', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1471, 'Alianca', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.32101', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1472, 'Altinho', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.321895', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1473, 'Amaraji', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.322767', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1474, 'Angelim', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.32367', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1475, 'Aracoiaba', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.324482', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1476, 'Araripina', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.330102', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1477, 'Arcoverde', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.331269', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1478, 'Barra de Guabiraba', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.332372', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1479, 'Barreiros', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.333472', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1480, 'Belem de Maria', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.334393', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1482, 'Belo Jardim', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.336241', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1483, 'Betania', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.337129', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1484, 'Bezerros', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.338076', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1485, 'Bodoco', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.338907', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1486, 'Bom Conselho', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.339929', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1487, 'Bom Jardim', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.340936', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1488, 'Bonito', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.34216', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1489, 'Brejao', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.343086', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1490, 'Brejinho', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.344037', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1491, 'Brejo da Madre de Deus', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.344934', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1492, 'Buenos Aires', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.345842', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1493, 'Buique', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.346767', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1494, 'Cabo de Santo Agostinho', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.347774', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1495, 'Cabrobo', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.348738', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1496, 'Cachoeirinha', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.349556', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1497, 'Caetes', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.350314', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1498, 'Calcado', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.351203', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1499, 'Calumbi', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.35222', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1500, 'Camaragibe', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.352986', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1501, 'Camocim de Sao Felix', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.35396', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1502, 'Camutanga', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.35491', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1503, 'Canhotinho', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.355843', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1504, 'Capoeiras', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.356719', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1505, 'Carnaiba', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.357596', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1506, 'Carnaubeira da Penha', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.358502', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1507, 'Carpina', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.359433', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1508, 'Caruaru', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.360254', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1509, 'Casinhas', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.361206', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1510, 'Catende', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.362152', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1511, 'Cedro', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.363201', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1512, 'Cha de Alegria', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.364172', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1513, 'Cha Grande', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.364895', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1514, 'Condado', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.365661', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1515, 'Correntes', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.366715', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1516, 'Cortes', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.376836', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1517, 'Cumaru', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.377881', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1518, 'Cupira', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.378741', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1519, 'Custodia', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.379657', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1520, 'Dormentes', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.380527', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1521, 'Escada', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.381407', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1522, 'Exu', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.382617', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1523, 'Feira Nova', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.383472', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1524, 'Fernando de Noronha', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.384317', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1525, 'Ferreiros', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.3852', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1526, 'Flores', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.386058', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1527, 'Floresta', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.386923', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1528, 'Frei Miguelinho', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.387844', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1529, 'Gameleira', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.388718', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1530, 'Garanhuns', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.389733', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1531, 'Gloria do Goita', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.390524', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1532, 'Goiana', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.391405', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1533, 'Granito', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.392255', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1534, 'Gravata', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.393148', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1535, 'Iati', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.394064', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1536, 'Ibimirim', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.394992', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1537, 'Ibirajuba', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.395927', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1538, 'Igarassu', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.396835', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1540, 'Inaja', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.398738', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1541, 'Ingazeira', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.399746', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1542, 'Ipojuca', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.400727', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1543, 'Ipubi', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.401708', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1544, 'Itacuruba', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.402642', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1545, 'Itaiba', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.403569', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1547, 'Itambe', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.405413', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1548, 'Itapetim', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.40621', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1549, 'Itapissuma', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.407134', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1550, 'Itaquitinga', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.408047', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1551, 'Jaboatao dos Guararapes', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.408818', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1552, 'Jaqueira', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.409756', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1553, 'Jatauba', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.410498', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1554, 'Jatoba', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.411876', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1555, 'Joao Alfredo', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.417932', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1556, 'Joaquim Nabuco', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.419099', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1557, 'Jucati', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.420118', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1558, 'Jupi', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.421181', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1559, 'Jurema', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.422125', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1560, 'Lagoa do Carro', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.423115', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1562, 'Lagoa do Ouro', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.424996', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1563, 'Lagoa dos Gatos', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.425859', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1564, 'Lagoa Grande', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.42668', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1565, 'Lajedo', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.427665', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1566, 'Limoeiro', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.428572', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1567, 'Macaparana', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.429473', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1568, 'Machados', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.430395', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1569, 'Manari', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.431315', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1570, 'Maraial', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.432227', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1571, 'Mirandiba', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.433144', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1573, 'Moreno', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.434923', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1574, 'Nazare da Mata', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.435804', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1575, 'Olinda', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.436674', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1576, 'Orobo', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.437566', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1577, 'Oroco', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.438497', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1578, 'Ouricuri', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.439384', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1579, 'Palmares', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.44018', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1580, 'Palmeirina', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.441107', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1581, 'Panelas', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.442238', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1582, 'Paranatama', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.443039', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1583, 'Parnamirim', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.44394', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1584, 'Passira', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.444874', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1585, 'Paudalho', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.445746', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1586, 'Paulista', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.446509', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1587, 'Pedra', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.447374', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1588, 'Pesqueira', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.448217', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1589, 'Petrolandia', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.449198', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1590, 'Petrolina', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.450099', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1591, 'Pocao', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.451059', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1592, 'Pombos', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.458158', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1593, 'Primavera', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.459513', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1594, 'Quipapa', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.460461', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1595, 'Quixaba', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.461303', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1596, 'Recife', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.462202', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1597, 'Riacho das Almas', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.463132', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1598, 'Ribeirao', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.464166', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1599, 'Rio Formoso', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.46508', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1600, 'Saire', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.466141', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1601, 'Salgadinho', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.467057', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1602, 'Salgueiro', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.467963', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1603, 'Saloa', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.468887', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1604, 'Sanharo', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.469786', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1605, 'Santa Cruz', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.470673', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1606, 'Santa Cruz da Baixa Verde', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.471456', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1607, 'Santa Cruz do Capibaribe', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.47243', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1608, 'Santa Filomena', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.473203', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1609, 'Santa Maria da Boa Vista', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.474049', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1610, 'Santa Maria do Cambuca', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.474981', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1611, 'Santa Terezinha', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.475798', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1612, 'Sao Benedito do Sul', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.47664', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1613, 'Sao Bento do Una', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.477417', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1614, 'Sao Caitano', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.478275', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1615, 'Sao Joao', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.479132', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1616, 'Sao Joaquim do Monte', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.479973', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1617, 'Sao Jose da Coroa Grande', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.48086', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1618, 'Sao Jose do Belmonte', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.481801', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1619, 'Sao Jose do Egito', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.482835', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1620, 'Sao Lourenco da Mata', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.48371', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1621, 'Sao Vicente Ferrer', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.484603', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1622, 'Serra Talhada', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.485455', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1623, 'Serrita', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.486433', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1624, 'Sertania', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.487232', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1625, 'Sirinhaem', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.48815', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1572, 'Moreilandia', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.434075', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1626, 'Solidao', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.489012', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1627, 'Surubim', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.489863', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1628, 'Tabira', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.490792', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1629, 'Tacaimbo', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.491684', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1630, 'Tacaratu', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.492321', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1631, 'Tamandare', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.49933', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1632, 'Taquaritinga do Norte', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.500598', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1633, 'Terezinha', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.501611', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1634, 'Terra Nova', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.502516', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1635, 'Timbauba', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.503375', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1636, 'Toritama', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.504224', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1637, 'Tracunhaem', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.505121', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1638, 'Trindade', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.505974', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1639, 'Triunfo', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.506916', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1640, 'Tupanatinga', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.507922', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1641, 'Tuparetama', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.508899', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1642, 'Venturosa', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.509757', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1643, 'Verdejante', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.510673', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1644, 'Vertente do Lerio', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.511529', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1645, 'Vertentes', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.512415', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1646, 'Vicencia', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.513303', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1647, 'Vitoria de Santo Antao', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.51418', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1648, 'Xexeu', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.515121', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1649, 'Agua Branca', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.515958', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1650, 'Anadia', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.516876', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1651, 'Arapiraca', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.517813', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1652, 'Atalaia', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.518801', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1653, 'Barra de Santo Antonio', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.519858', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1654, 'Barra de Sao Miguel', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.520772', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1655, 'Batalha', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.521655', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1656, 'Belem', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.522539', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1657, 'Belo Monte', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.523412', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1658, 'Boca da Mata', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.524257', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1659, 'Branquinha', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.525049', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1660, 'Cacimbinhas', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.525871', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1661, 'Cajueiro', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.526778', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1662, 'Campestre', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.527574', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1663, 'Campo Alegre', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.528462', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1664, 'Campo Grande', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.529366', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1665, 'Canapi', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.5303', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1666, 'Capela', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.531062', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1667, 'Carneiros', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.531967', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1668, 'Cha Preta', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.532762', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1669, 'Coite do Noia', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.53981', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1670, 'Colonia Leopoldina', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.540909', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1671, 'Coqueiro Seco', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.541931', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1672, 'Coruripe', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.542806', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1673, 'Craibas', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.543615', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1674, 'Delmiro Gouveia', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.544416', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1675, 'Dois Riachos', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.545079', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1676, 'Estrela de Alagoas', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.545943', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1677, 'Feira Grande', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.546837', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1678, 'Feliz Deserto', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.547708', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1679, 'Flexeiras', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.54858', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1680, 'Girau do Ponciano', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.549416', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1681, 'Ibateguara', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.550297', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1682, 'Igaci', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.551161', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1683, 'Igreja Nova', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.552215', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1684, 'Inhapi', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.553518', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1685, 'Jacare dos Homens', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.554435', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1686, 'Jacuipe', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.555236', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1687, 'Japaratinga', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.556108', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1688, 'Jaramataia', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.556965', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1689, 'Jequia da Praia', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.557886', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1690, 'Joaquim Gomes', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.558773', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1691, 'Jundia', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.55955', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1692, 'Junqueiro', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.560447', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1693, 'Lagoa da Canoa', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.561361', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1694, 'Limoeiro de Anadia', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.562239', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1695, 'Maceio', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.563152', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1696, 'Major Isidoro', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.564162', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1698, 'Maragogi', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.566063', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1699, 'Maravilha', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.566937', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1700, 'Marechal Deodoro', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.56783', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1701, 'Maribondo', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.568607', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1697, 'Mar Vermelho', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.56511', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1702, 'Mata Grande', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.569485', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1703, 'Matriz de Camaragibe', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.570409', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1704, 'Messias', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.57126', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1705, 'Minador do Negrao', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.572177', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1706, 'Monteiropolis', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.573135', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1707, 'Murici', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.579953', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1708, 'Novo Lino', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.58127', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1709, 'Olho D''agua das Flores', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.582212', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1710, 'Olho D''agua do Casado', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.583111', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1711, 'Olho D''agua Grande', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.583997', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1712, 'Olivenca', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.584857', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1713, 'Ouro Branco', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.585722', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1714, 'Palestina', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.58684', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1715, 'Palmeira dos Indios', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.587745', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1716, 'Pao de Acucar', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.58866', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1717, 'Pariconha', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.589445', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1718, 'Paripueira', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.590225', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1719, 'Passo de Camaragibe', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.59101', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1720, 'Paulo Jacinto', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.591854', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1721, 'Penedo', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.592907', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1722, 'Piacabucu', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.593907', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1723, 'Pilar', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.594781', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1724, 'Pindoba', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.595808', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1725, 'Piranhas', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.596659', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1726, 'Poco das Trincheiras', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.597518', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1727, 'Porto Calvo', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.598531', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1728, 'Porto de Pedras', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.599515', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1729, 'Porto Real do Colegio', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.600386', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1730, 'Quebrangulo', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.601248', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1731, 'Rio Largo', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.602118', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1732, 'Roteiro', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.602974', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1733, 'Santa Luzia do Norte', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.60384', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1734, 'Santana do Ipanema', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.604666', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1735, 'Santana do Mundau', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.605464', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1736, 'Sao Bras', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.60638', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1737, 'Sao Jose da Laje', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.607218', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1738, 'Sao Jose da Tapera', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.608123', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1739, 'Sao Luis do Quitunde', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.609231', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1740, 'Sao Miguel dos Campos', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.610109', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1741, 'Sao Miguel dos Milagres', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.610971', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1742, 'Sao Sebastiao', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.611868', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1743, 'Satuba', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.612769', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1744, 'Senador Rui Palmeira', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.61364', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1745, 'Tanque D''arca', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.621045', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1746, 'Taquarana', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.622171', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1747, 'Teotonio Vilela', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.623156', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1748, 'Traipu', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.624182', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1749, 'Uniao dos Palmares', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.625153', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1750, 'Vicosa', 'AL', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.626119', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1751, 'Amparo de Sao Francisco', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.626967', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1752, 'Aquidaba', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.627865', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1753, 'Aracaju', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.628811', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1754, 'Araua', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.629694', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1755, 'Areia Branca', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.630578', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1756, 'Barra dos Coqueiros', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.631545', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1757, 'Boquim', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.632563', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1758, 'Brejo Grande', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.633428', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1759, 'Campo do Brito', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.63429', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1760, 'Canhoba', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.635169', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1761, 'Caninde de Sao Francisco', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.636006', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1762, 'Capela', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.636835', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1763, 'Carira', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.637698', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1764, 'Carmopolis', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.638589', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1765, 'Cedro de Sao Joao', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.639453', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1766, 'Cristinapolis', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.640358', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1767, 'Cumbe', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.641238', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1768, 'Divina Pastora', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.642203', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1769, 'Estancia', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.642975', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1770, 'Feira Nova', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.643769', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1771, 'Frei Paulo', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.64469', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1772, 'Gararu', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.645572', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1773, 'General Maynard', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.646491', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1774, 'Gracho Cardoso', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.64737', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1775, 'Ilha das Flores', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.648183', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1776, 'Indiaroba', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.649012', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1777, 'Itabaiana', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.649896', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1778, 'Itabaianinha', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.650772', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1779, 'Itabi', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.651642', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1780, 'Itaporanga D''ajuda', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.652555', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1781, 'Japaratuba', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.653348', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1782, 'Japoata', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.654107', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1783, 'Lagarto', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.654821', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1784, 'Laranjeiras', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.655682', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1785, 'Macambira', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.661933', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1786, 'Malhada dos Bois', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.663166', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1787, 'Malhador', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.664217', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1788, 'Maruim', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.665029', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1789, 'Moita Bonita', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.665899', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1790, 'Monte Alegre de Sergipe', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.666702', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1791, 'Muribeca', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.667607', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1792, 'Neopolis', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.668505', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1793, 'Nossa Senhora Aparecida', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.66942', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1794, 'Nossa Senhora da Gloria', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.670251', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1795, 'Nossa Senhora das Dores', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.671045', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1796, 'Nossa Senhora de Lourdes', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.671969', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1797, 'Nossa Senhora do Socorro', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.672835', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1798, 'Pacatuba', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.673744', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1799, 'Pedra Mole', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.674638', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1800, 'Pedrinhas', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.675565', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1801, 'Pinhao', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.676278', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1802, 'Pirambu', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.677143', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1803, 'Poco Redondo', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.67807', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1804, 'Poco Verde', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.678996', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1805, 'Porto da Folha', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.679867', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1806, 'Propria', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.680723', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1807, 'Riachao do Dantas', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.68163', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1808, 'Riachuelo', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.68251', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1809, 'Ribeiropolis', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.683399', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1810, 'Rosario do Catete', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.684327', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1811, 'Salgado', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.685208', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1812, 'Santa Luzia do Itanhy', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.686053', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1814, 'Santana do Sao Francisco', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.688243', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1813, 'Santa Rosa de Lima', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.687431', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1815, 'Santo Amaro das Brotas', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.689158', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1816, 'Sao Cristovao', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.690023', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1817, 'Sao Domingos', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.690888', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1818, 'Sao Francisco', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.691767', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1819, 'Sao Miguel do Aleixo', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.692583', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1820, 'Simao Dias', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.693538', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1821, 'Siriri', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.694316', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1822, 'Telha', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.695302', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1823, 'Tobias Barreto', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.696176', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1824, 'Tomar do Geru', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.703912', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1825, 'Umbauba', 'SE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.704998', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1826, 'Abaira', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.705862', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1827, 'Abare', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.706776', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1828, 'Acajutiba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.707772', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1829, 'Adustina', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.708678', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1830, 'Agua Fria', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.709564', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1949, 'Erico Cardoso', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.835874', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1831, 'Aiquara', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.710453', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1832, 'Alagoinhas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.711342', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1833, 'Alcobaca', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.712309', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1834, 'Almadina', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.713183', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1835, 'Amargosa', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.714102', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1836, 'Amelia Rodrigues', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.714937', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1837, 'America Dourada', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.715822', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1838, 'Anage', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.716687', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1839, 'Andarai', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.717527', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1840, 'Andorinha', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.718396', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1841, 'Angical', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.719204', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1842, 'Anguera', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.720208', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1843, 'Antas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.720988', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1844, 'Antonio Cardoso', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.721872', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1845, 'Antonio Goncalves', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.72283', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1846, 'Apora', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.723737', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1847, 'Apuarema', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.72468', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1849, 'Aracatu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.72638', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1848, 'Aracas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.725609', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1850, 'Araci', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.727157', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1851, 'Aramari', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.727919', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1852, 'Arataca', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.728798', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1853, 'Aratuipe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.729676', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1854, 'Aurelino Leal', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.730623', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1855, 'Baianopolis', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.731629', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1856, 'Baixa Grande', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.732415', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1857, 'Banzae', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.733268', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1858, 'Barra', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.734163', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1859, 'Barra da Estiva', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.735027', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1860, 'Barra do Choca', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.735986', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1861, 'Barra do Mendes', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.736784', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1862, 'Barra do Rocha', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.737614', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1863, 'Barreiras', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.743632', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1864, 'Barro Alto', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.745185', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1865, 'Barrocas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.746183', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1866, 'Belmonte', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.747082', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1867, 'Belo Campo', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.747989', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1868, 'Biritinga', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.748862', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1869, 'Boa Nova', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.749789', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1870, 'Boa Vista do Tupim', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.750607', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1871, 'Bom Jesus da Lapa', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.7516', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1872, 'Bom Jesus da Serra', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.752527', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1873, 'Boninal', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.753467', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1874, 'Bonito', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.754333', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1875, 'Boquira', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.755177', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1876, 'Botupora', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.756099', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1877, 'Brejoes', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.756961', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1878, 'Brejolandia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.757913', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1879, 'Brotas de Macaubas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.758779', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1880, 'Brumado', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.759633', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1881, 'Buerarema', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.760497', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1882, 'Buritirama', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.761353', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1883, 'Caatiba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.762303', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1884, 'Cabaceiras do Paraguacu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.763755', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1885, 'Cachoeira', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.764694', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1886, 'Cacule', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.765572', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1887, 'Caem', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.766486', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1888, 'Caetanos', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.767347', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1889, 'Caetite', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.768201', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1890, 'Cafarnaum', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.769048', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1891, 'Cairu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.769993', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1892, 'Caldeirao Grande', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.770885', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1893, 'Camacan', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.771855', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1894, 'Camacari', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.772719', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1895, 'Camamu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.773477', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1896, 'Campo Alegre de Lourdes', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.774295', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1897, 'Campo Formoso', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.775204', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1898, 'Canapolis', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.776195', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1899, 'Canarana', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.776955', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1900, 'Canavieiras', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.777826', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1901, 'Candeal', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.778621', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1902, 'Candeias', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.785654', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1903, 'Candiba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.786875', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1904, 'Candido Sales', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.787762', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1905, 'Cansancao', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.788735', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1906, 'Canudos', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.789648', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1907, 'Capela do Alto Alegre', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.790552', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1908, 'Capim Grosso', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.791373', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1909, 'Caraibas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.792368', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1910, 'Caravelas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.793239', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1911, 'Cardeal da Silva', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.794153', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1912, 'Carinhanha', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.795076', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1913, 'Casa Nova', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.796126', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1914, 'Castro Alves', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.797062', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1915, 'Catolandia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.797944', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1916, 'Catu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.798905', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1917, 'Caturama', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.799835', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1918, 'Central', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.800762', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1919, 'Chorrocho', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.801673', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1920, 'Cicero Dantas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.80256', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1921, 'Cipo', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.803435', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1922, 'Coaraci', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.804362', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1923, 'Cocos', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.805142', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1924, 'Conceicao da Feira', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.806049', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1925, 'Conceicao do Almeida', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.80693', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1926, 'Conceicao do Coite', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.807792', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1927, 'Conceicao do Jacuipe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.808715', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1928, 'Conde', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.809636', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1929, 'Condeuba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.810398', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1930, 'Contendas do Sincora', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.811224', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1931, 'Coracao de Maria', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.812079', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1932, 'Cordeiros', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.812982', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1933, 'Coribe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.81392', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1934, 'Coronel Joao Sa', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.814844', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1935, 'Correntina', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.815785', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1936, 'Cotegipe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.816686', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1937, 'Cravolandia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.817527', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1938, 'Crisopolis', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.818343', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1939, 'Cristopolis', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.819171', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1940, 'Cruz das Almas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.826554', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1941, 'Curaca', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.827636', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1942, 'Dario Meira', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.829405', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1943, 'Dias D''avila', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.830489', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1944, 'Dom Basilio', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.831352', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1945, 'Dom Macedo Costa', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.83241', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1946, 'Elisio Medrado', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.833251', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1947, 'Encruzilhada', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.83412', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1948, 'Entre Rios', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.835064', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1950, 'Esplanada', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.836741', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1951, 'Euclides da Cunha', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.837646', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1952, 'Eunapolis', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.838519', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1953, 'Fatima', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.839335', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1954, 'Feira da Mata', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.840193', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1955, 'Feira de Santana', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.841117', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1956, 'Filadelfia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.842011', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1957, 'Firmino Alves', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.842944', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1958, 'Floresta Azul', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.843755', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1959, 'Formosa do Rio Preto', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.844635', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1960, 'Gandu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.845544', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1961, 'Gaviao', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.846441', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1962, 'Gentio do Ouro', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.847284', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1963, 'Gloria', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.84819', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1964, 'Gongogi', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.84909', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1966, 'Governador Mangabeira', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.850857', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1967, 'Guajeru', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.85184', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1968, 'Guanambi', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.852748', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1969, 'Guaratinga', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.853646', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1970, 'Heliopolis', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.854517', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1971, 'Iacu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.855462', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1972, 'Ibiassuce', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.856356', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1973, 'Ibicarai', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.857175', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1974, 'Ibicoara', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.858076', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1975, 'Ibicui', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.858999', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1976, 'Ibipeba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.859993', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1977, 'Ibipitanga', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.867007', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1978, 'Ibiquera', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.868154', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1979, 'Ibirapitanga', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.869284', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1980, 'Ibirapua', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.870219', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1981, 'Ibirataia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.871155', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1982, 'Ibitiara', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.872193', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1983, 'Ibitita', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.873038', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1984, 'Ibotirama', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.873833', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1985, 'Ichu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.874719', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1986, 'Igapora', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.875578', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1987, 'Igrapiuna', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.876442', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1988, 'Iguai', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.877337', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1989, 'Ilheus', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.878226', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1990, 'Inhambupe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.87915', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1991, 'Ipecaeta', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.880071', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1992, 'Ipiau', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.880952', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1993, 'Ipira', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.881831', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1994, 'Ipupiara', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.882705', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1995, 'Irajuba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.883566', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1996, 'Iramaia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.88439', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1997, 'Iraquara', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.885298', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1998, 'Irara', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.886211', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (1999, 'Irece', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.887131', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2000, 'Itabela', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.88815', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2001, 'Itaberaba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.888959', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2002, 'Itabuna', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.889845', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2003, 'Itacare', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.890749', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2004, 'Itaete', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.891611', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2005, 'Itagi', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.892478', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2006, 'Itagiba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.893317', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2007, 'Itagimirim', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.894412', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2008, 'Itaguacu da Bahia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.895374', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2009, 'Itaju do Colonia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.896523', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2010, 'Itajuipe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.897461', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2011, 'Itamaraju', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.898265', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2012, 'Itamari', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.89943', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2013, 'Itambe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.900314', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2014, 'Itanagra', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.901209', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2015, 'Itanhem', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.902022', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2016, 'Itaparica', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.906287', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2017, 'Itape', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.909995', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2018, 'Itapebi', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.911146', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2019, 'Itapetinga', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.911973', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2020, 'Itapicuru', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.913016', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2021, 'Itapitanga', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.913895', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2022, 'Itaquara', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.914769', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2023, 'Itarantim', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.915654', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2024, 'Itatim', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.916552', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2025, 'Itirucu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.917472', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2026, 'Itiuba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.918303', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2027, 'Itororo', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.919192', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2028, 'Ituacu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.920019', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2029, 'Itubera', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.920842', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2030, 'Iuiu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.921738', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2031, 'Jaborandi', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.922718', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2032, 'Jacaraci', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.923539', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2033, 'Jacobina', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.92442', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2034, 'Jaguaquara', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.925284', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2035, 'Jaguarari', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.926186', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2036, 'Jaguaripe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.927091', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2037, 'Jandaira', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.928038', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2038, 'Jequie', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.928884', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2039, 'Jeremoabo', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.929851', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2040, 'Jiquirica', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.930853', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2041, 'Jitauna', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.93178', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2042, 'Joao Dourado', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.932709', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2043, 'Juazeiro', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.933661', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2044, 'Jucurucu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.934595', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2045, 'Jussara', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.935594', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2046, 'Jussari', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.93641', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2047, 'Jussiape', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.937255', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2048, 'Lafaiete Coutinho', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.938148', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2049, 'Lagoa Real', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.938963', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2050, 'Laje', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.939756', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2051, 'Lajedao', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.940684', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2052, 'Lajedinho', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.941599', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2053, 'Lajedo do Tabocal', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.942474', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2054, 'Lamarao', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.943451', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2055, 'Lapao', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.947684', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2056, 'Lauro de Freitas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.951579', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2057, 'Lencois', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.952621', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2058, 'Licinio de Almeida', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.953576', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2059, 'Livramento de Nossa Senhora', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.954557', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2060, 'Luis Eduardo Magalhaes', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.955329', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2061, 'Macajuba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.956202', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2062, 'Macarani', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.957096', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2063, 'Macaubas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.957889', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2064, 'Macurure', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.958774', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2065, 'Madre de Deus', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.959587', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2066, 'Maetinga', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.960638', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2067, 'Maiquinique', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.962121', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2068, 'Mairi', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.963012', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2069, 'Malhada', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.963901', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2070, 'Malhada de Pedras', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.964883', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2071, 'Manoel Vitorino', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.966277', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2072, 'Mansidao', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.967204', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2073, 'Maracas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.968095', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2074, 'Maragogipe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.968973', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2075, 'Marau', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.969912', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2076, 'Marcionilio Souza', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.970761', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2077, 'Mascote', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.971642', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2078, 'Mata de Sao Joao', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.972526', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2079, 'Matina', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.973388', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2080, 'Medeiros Neto', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.974232', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2081, 'Miguel Calmon', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.975182', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2082, 'Milagres', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.976164', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2083, 'Mirangaba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.977016', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2084, 'Mirante', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.977772', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2085, 'Monte Santo', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.978653', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2086, 'Morpara', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.979569', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2087, 'Morro do Chapeu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.980474', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2088, 'Mortugaba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.981328', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2089, 'Mucuge', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.982184', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2090, 'Mucuri', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.982993', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2091, 'Mulungu do Morro', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.983851', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2092, 'Mundo Novo', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.984848', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2093, 'Muniz Ferreira', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.996997', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2094, 'Muquem de Sao Francisco', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.998112', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2095, 'Muritiba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.999036', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2096, 'Mutuipe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:35.999876', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2097, 'Nazare', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.000716', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2098, 'Nilo Pecanha', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.001605', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2099, 'Nordestina', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.002445', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2100, 'Nova Canaa', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.003325', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2101, 'Nova Fatima', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.004235', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2102, 'Nova Ibia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.005107', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2103, 'Nova Itarana', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.006013', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2104, 'Nova Redencao', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.006882', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2105, 'Nova Soure', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.007768', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2106, 'Nova Vicosa', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.008715', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2107, 'Novo Horizonte', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.009609', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2108, 'Novo Triunfo', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.01077', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2109, 'Olindina', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.011563', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2110, 'Oliveira dos Brejinhos', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.012481', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2111, 'Ouricangas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.013345', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2112, 'Ourolandia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.014162', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2113, 'Palmas de Monte Alto', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.015029', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2114, 'Palmeiras', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.015951', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2115, 'Paramirim', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.016875', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2116, 'Paratinga', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.017719', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2117, 'Paripiranga', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.018511', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2118, 'Pau Brasil', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.019288', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2119, 'Paulo Afonso', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.020202', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2120, 'Pe de Serra', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.021133', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2121, 'Pedrao', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.022051', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2122, 'Pedro Alexandre', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.022977', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2123, 'Piata', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.023897', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2124, 'Pilao Arcado', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.024776', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2125, 'Pindai', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.025676', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2126, 'Pindobacu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.026444', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2127, 'Pintadas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.027298', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2128, 'Pirai do Norte', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.028163', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2129, 'Piripa', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.028991', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2130, 'Piritiba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.02981', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2131, 'Planaltino', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.030618', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2132, 'Planalto', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.037238', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2133, 'Pocoes', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.038394', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2134, 'Pojuca', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.039305', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2135, 'Ponto Novo', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.040288', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2136, 'Porto Seguro', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.041156', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2137, 'Potiragua', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.042018', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2138, 'Prado', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.042931', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2139, 'Presidente Dutra', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.04386', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2140, 'Presidente Janio Quadros', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.044678', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2141, 'Presidente Tancredo Neves', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.045568', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2142, 'Queimadas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.046592', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2143, 'Quijingue', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.047491', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2144, 'Quixabeira', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.04839', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2145, 'Rafael Jambeiro', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.049242', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2146, 'Remanso', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.050108', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2147, 'Retirolandia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.051116', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2148, 'Riachao das Neves', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.051964', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2149, 'Riachao do Jacuipe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.052816', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2150, 'Riacho de Santana', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.053696', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2151, 'Ribeira do Amparo', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.054615', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2152, 'Ribeira do Pombal', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.055463', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2153, 'Ribeirao do Largo', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.05629', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2154, 'Rio de Contas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.057205', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2155, 'Rio do Antonio', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.058091', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2156, 'Rio do Pires', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.059061', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2157, 'Rio Real', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.0599', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2158, 'Rodelas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.060828', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2159, 'Ruy Barbosa', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.061686', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2160, 'Salinas da Margarida', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.062613', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2161, 'Salvador', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.063432', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2162, 'Santa Barbara', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.064199', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2163, 'Santa Brigida', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.065113', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2164, 'Santa Cruz Cabralia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.066096', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2165, 'Santa Cruz da Vitoria', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.066868', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2166, 'Santa Ines', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.067781', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2171, 'Santaluz', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.081182', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2167, 'Santa Luzia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.068555', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2168, 'Santa Maria da Vitoria', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.069542', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2172, 'Santana', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.082258', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2173, 'Santanopolis', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.083118', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2169, 'Santa Rita de Cassia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.070478', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2170, 'Santa Teresinha', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.071319', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2174, 'Santo Amaro', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.083992', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2175, 'Santo Antonio de Jesus', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.084795', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2176, 'Santo Estevao', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.085639', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2177, 'Sao Desiderio', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.086513', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2178, 'Sao Domingos', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.087428', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2180, 'Sao Felix', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.089086', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2181, 'Sao Felix do Coribe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.089995', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2179, 'Sao Felipe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.088306', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2182, 'Sao Francisco do Conde', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.09092', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2183, 'Sao Gabriel', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.091797', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2184, 'Sao Goncalo dos Campos', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.092756', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2185, 'Sao Jose da Vitoria', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.093833', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2186, 'Sao Jose do Jacuipe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.094768', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2187, 'Sao Miguel das Matas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.095662', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2188, 'Sao Sebastiao do Passe', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.096542', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2189, 'Sapeacu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.09736', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2190, 'Satiro Dias', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.09819', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2191, 'Saubara', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.099108', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2192, 'Saude', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.100012', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2193, 'Seabra', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.100826', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2194, 'Sebastiao Laranjeiras', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.101718', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2195, 'Senhor do Bonfim', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.102614', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2197, 'Serra do Ramalho', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.10448', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2196, 'Sento Se', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.103547', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2198, 'Serra Dourada', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.105375', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2199, 'Serra Preta', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.106273', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2200, 'Serrinha', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.107175', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2201, 'Serrolandia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.108078', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2202, 'Simoes Filho', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.108929', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2203, 'Sitio do Mato', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.109993', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2204, 'Sitio do Quinto', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.11146', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2205, 'Sobradinho', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.112381', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2206, 'Souto Soares', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.113153', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2207, 'Tabocas do Brejo Velho', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.113976', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2208, 'Tanhacu', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.114785', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2209, 'Tanque Novo', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.121459', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2210, 'Tanquinho', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.122594', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2211, 'Taperoa', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.123519', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2212, 'Tapiramuta', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.124406', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2213, 'Teixeira de Freitas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.125229', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2214, 'Teodoro Sampaio', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.126164', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2215, 'Teofilandia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.127128', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2216, 'Teolandia', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.128089', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2217, 'Terra Nova', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.129228', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2218, 'Tremedal', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.130582', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2219, 'Tucano', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.132366', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2220, 'Uaua', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.133639', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2221, 'Ubaira', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.134487', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2222, 'Ubaitaba', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.135357', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2223, 'Ubata', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.136179', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2224, 'Uibai', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.136978', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2225, 'Umburanas', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.137875', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2226, 'Una', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.138736', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2227, 'Urandi', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.139603', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2228, 'Urucuca', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.14047', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2229, 'Utinga', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.14136', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2230, 'Valenca', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.142211', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2231, 'Valente', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.143101', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2232, 'Varzea da Roca', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.144044', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2233, 'Varzea do Poco', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.145026', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2234, 'Varzea Nova', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.145932', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2235, 'Varzedo', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.146908', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2236, 'Vera Cruz', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.147866', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2237, 'Vereda', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.148738', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2238, 'Vitoria da Conquista', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.149664', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2239, 'Wagner', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.150535', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2240, 'Wanderley', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.151529', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2241, 'Wenceslau Guimaraes', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.152442', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2242, 'Xique-xique', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.153258', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2243, 'Abadia dos Dourados', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.154189', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2244, 'Abaete', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.155248', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2245, 'Abre Campo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.158797', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2246, 'Acaiaca', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.164872', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2247, 'Acucena', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.166041', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2248, 'Agua Boa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.166914', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2249, 'Agua Comprida', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.167694', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2250, 'Aguanil', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.168652', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2251, 'Aguas Formosas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.169451', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2252, 'Aguas Vermelhas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.170365', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2253, 'Aimores', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.171249', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2254, 'Aiuruoca', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.172198', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2255, 'Alagoa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.17309', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2256, 'Albertina', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.174065', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2257, 'Alem Paraiba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.175052', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2258, 'Alfenas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.176142', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2259, 'Alfredo Vasconcelos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.177086', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2260, 'Almenara', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.17799', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2261, 'Alpercata', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.178942', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2262, 'Alpinopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.179848', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2263, 'Alterosa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.180759', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2264, 'Alto Caparao', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.181657', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2266, 'Alto Rio Doce', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.183515', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2267, 'Alvarenga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.184402', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2268, 'Alvinopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.185229', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2269, 'Alvorada de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.186152', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2270, 'Amparo do Serra', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.187321', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2271, 'Andradas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.188228', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2349, 'Cachoeira de Pajeu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.269483', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2272, 'Andrelandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.189253', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2273, 'Angelandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.190148', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2274, 'Antonio Carlos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.19103', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2275, 'Antonio Dias', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.191859', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2276, 'Antonio Prado de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.192799', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2277, 'Aracai', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.193762', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2278, 'Aracitaba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.194635', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2279, 'Aracuai', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.195558', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2280, 'Araguari', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.196367', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2281, 'Arantina', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.197243', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2282, 'Araponga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.198178', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2283, 'Arapora', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.203217', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2284, 'Arapua', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.205244', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2285, 'Araujos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.206219', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2286, 'Araxa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.207117', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2287, 'Arceburgo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.207902', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2288, 'Arcos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.208814', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2289, 'Areado', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.209723', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2290, 'Argirita', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.210605', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2291, 'Aricanduva', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.211483', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2292, 'Arinos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.212377', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2293, 'Astolfo Dutra', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.213327', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2294, 'Ataleia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.214154', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2295, 'Augusto de Lima', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.21493', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2296, 'Baependi', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.215936', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2297, 'Baldim', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.216871', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2298, 'Bambui', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.217768', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2299, 'Bandeira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.218649', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2300, 'Bandeira do Sul', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.219508', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2301, 'Barao de Cocais', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.220377', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2302, 'Barao de Monte Alto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.221268', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2303, 'Barbacena', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.222198', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2304, 'Barra Longa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.223036', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2305, 'Barroso', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.22391', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2306, 'Bela Vista de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.224974', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2307, 'Belmiro Braga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.225963', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2308, 'Belo Horizonte', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.227024', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2309, 'Belo Oriente', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.227973', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2310, 'Belo Vale', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.228893', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2311, 'Berilo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.229677', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2313, 'Bertopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.23149', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2312, 'Berizal', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.230571', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2314, 'Betim', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.232321', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2315, 'Bias Fortes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.233321', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2316, 'Bicas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.23414', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2317, 'Biquinhas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.234928', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2318, 'Boa Esperanca', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.235855', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2319, 'Bocaina de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.236779', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2320, 'Bocaiuva', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.23773', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2321, 'Bom Despacho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.23865', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2322, 'Bom Jardim de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.239378', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2323, 'Bom Jesus da Penha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.245946', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2324, 'Bom Jesus do Amparo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.246959', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2325, 'Bom Jesus do Galho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.247908', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2326, 'Bom Repouso', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.248786', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2327, 'Bom Sucesso', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.249675', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2328, 'Bonfim', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.250542', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2329, 'Bonfinopolis de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.251343', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2330, 'Bonito de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.252162', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2331, 'Borda da Mata', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.253039', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2332, 'Botelhos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.253931', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2333, 'Botumirim', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.254856', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2335, 'Brasilandia de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.256563', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2336, 'Brasilia de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.257427', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2334, 'Bras Pires', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.255745', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2338, 'Braunas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.259273', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2339, 'Brumadinho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.260042', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2340, 'Bueno Brandao', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.260966', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2341, 'Buenopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.261895', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2342, 'Bugre', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.262933', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2343, 'Buritis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.263793', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2344, 'Buritizeiro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.264812', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2345, 'Cabeceira Grande', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.265722', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2346, 'Cabo Verde', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.266748', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2347, 'Cachoeira da Prata', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.267638', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2348, 'Cachoeira de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.268607', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2350, 'Cachoeira Dourada', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.270382', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2351, 'Caetanopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.271481', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2352, 'Caete', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.272398', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2353, 'Caiana', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.273259', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2354, 'Cajuri', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.274121', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2355, 'Caldas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.275028', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2356, 'Camacho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.275929', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2357, 'Camanducaia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.27681', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2358, 'Cambui', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.277738', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2359, 'Cambuquira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.278606', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2360, 'Campanario', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.279653', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2361, 'Campanha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.28044', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2362, 'Campestre', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.286607', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2363, 'Campina Verde', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.287827', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2364, 'Campo Azul', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.288775', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2365, 'Campo Belo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.289665', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2366, 'Campo do Meio', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.290592', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2367, 'Campo Florido', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.291403', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2368, 'Campos Altos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.292443', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2369, 'Campos Gerais', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.293274', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2371, 'Canaa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.295135', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2372, 'Canapolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.296192', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2370, 'Cana Verde', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.294208', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2373, 'Candeias', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.297115', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2374, 'Cantagalo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.297958', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2375, 'Caparao', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.298869', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2376, 'Capela Nova', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.299725', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2377, 'Capelinha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.300742', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2378, 'Capetinga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.301628', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2379, 'Capim Branco', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.302484', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2380, 'Capinopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.303332', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2381, 'Capitao Andrade', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.304204', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2382, 'Capitao Eneas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.304996', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2383, 'Capitolio', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.305772', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2384, 'Caputira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.306769', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2385, 'Carai', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.307704', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2386, 'Caranaiba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.308589', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2387, 'Carandai', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.309503', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2388, 'Carangola', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.310414', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2389, 'Caratinga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.311411', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2390, 'Carbonita', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.312275', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2391, 'Careacu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.313165', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2392, 'Carlos Chagas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.313963', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2393, 'Carmesia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.31478', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2394, 'Carmo da Cachoeira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.31565', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2395, 'Carmo da Mata', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.316547', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2396, 'Carmo de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.317444', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2397, 'Carmo do Cajuru', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.318302', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2398, 'Carmo do Paranaiba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.319164', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2399, 'Carmo do Rio Claro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.320006', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2400, 'Carmopolis de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.326946', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2401, 'Carneirinho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.328069', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2402, 'Carrancas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.328901', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2403, 'Carvalhopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.329932', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2404, 'Carvalhos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.33101', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2405, 'Casa Grande', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.331982', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2406, 'Cascalho Rico', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.333627', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2407, 'Cassia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.334661', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2431, 'Conceicao da Barra de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.356084', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2408, 'Cataguases', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.335576', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2409, 'Catas Altas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.336441', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2410, 'Catas Altas da Noruega', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.337408', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2411, 'Catuji', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.338303', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2412, 'Catuti', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.339177', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2413, 'Caxambu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.340022', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2414, 'Cedro do Abaete', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.3409', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2415, 'Central de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.341802', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2416, 'Centralina', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.342707', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2417, 'Chacara', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.343615', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2418, 'Chale', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.344519', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2419, 'Chapada do Norte', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.345402', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2420, 'Chapada Gaucha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.346221', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2421, 'Chiador', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.347172', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2422, 'Cipotanea', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.348109', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2423, 'Claraval', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.349067', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2424, 'Claro dos Pocoes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.349954', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2425, 'Claudio', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.350815', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2426, 'Coimbra', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.351681', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2427, 'Coluna', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.352366', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2428, 'Comendador Gomes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.353256', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2429, 'Comercinho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.354197', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2430, 'Conceicao da Aparecida', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.355049', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2433, 'Conceicao das Pedras', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.357787', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2432, 'Conceicao das Alagoas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.356889', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2434, 'Conceicao de Ipanema', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.358793', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2435, 'Conceicao do Mato Dentro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.35965', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2436, 'Conceicao do Para', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.360602', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2437, 'Conceicao do Rio Verde', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.367362', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2438, 'Conceicao dos Ouros', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.368535', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2439, 'Conego Marinho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.369512', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2440, 'Confins', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.370463', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2441, 'Congonhal', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.371375', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2442, 'Congonhas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.372194', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2443, 'Congonhas do Norte', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.37302', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2444, 'Conquista', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.373929', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2445, 'Conselheiro Lafaiete', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.374849', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2446, 'Conselheiro Pena', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.375761', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2447, 'Consolacao', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.376643', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2448, 'Contagem', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.377562', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2449, 'Coqueiral', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.37849', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2450, 'Coracao de Jesus', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.379263', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2451, 'Cordisburgo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.380177', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2452, 'Cordislandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.381011', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2453, 'Corinto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.381868', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2454, 'Coroaci', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.38272', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2455, 'Coromandel', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.38355', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2456, 'Coronel Fabriciano', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.384524', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2457, 'Coronel Murta', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.385391', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2458, 'Coronel Pacheco', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.386312', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2459, 'Coronel Xavier Chaves', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.387358', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2460, 'Corrego Danta', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.388301', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2461, 'Corrego do Bom Jesus', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.389213', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2462, 'Corrego Fundo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.390263', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2463, 'Corrego Novo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.391202', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2464, 'Couto de Magalhaes de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.392311', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2465, 'Crisolita', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.393212', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2466, 'Cristais', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.394167', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2467, 'Cristalia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.394971', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2468, 'Cristiano Otoni', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.395888', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2469, 'Cristina', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.396852', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2470, 'Crucilandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.397656', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2471, 'Cruzeiro da Fortaleza', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.398422', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2472, 'Cruzilia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.399226', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2473, 'Cuparaque', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.400152', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2474, 'Curral de Dentro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.401352', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2475, 'Curvelo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.41163', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2476, 'Datas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.412738', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2477, 'Delfim Moreira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.413631', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2478, 'Delfinopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.414454', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2479, 'Delta', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.415301', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2480, 'Descoberto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.416181', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2481, 'Desterro de Entre Rios', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.417061', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2482, 'Desterro do Melo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.417919', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2483, 'Diamantina', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.418797', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2484, 'Diogo de Vasconcelos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.41969', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2485, 'Dionisio', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.420606', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2486, 'Divinesia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.421506', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2487, 'Divino', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.422311', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2488, 'Divino das Laranjeiras', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.423584', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2489, 'Divinolandia de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.424526', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2490, 'Divinopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.425468', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2491, 'Divisa Alegre', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.426294', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2492, 'Divisa Nova', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.427201', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2493, 'Divisopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.428217', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2494, 'Dom Bosco', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.429142', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2495, 'Dom Cavati', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.430042', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2496, 'Dom Joaquim', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.430968', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2497, 'Dom Silverio', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.43188', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2498, 'Dom Vicoso', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.432759', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2499, 'Dona Eusebia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.433829', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2500, 'Dores de Campos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.434737', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2501, 'Dores de Guanhaes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.435545', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2502, 'Dores do Indaia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.436568', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2503, 'Dores do Turvo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.437482', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2504, 'Doresopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.438283', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2505, 'Douradoquara', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.439165', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2506, 'Durande', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.439988', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2507, 'Eloi Mendes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.440884', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2508, 'Engenheiro Caldas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.441795', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2509, 'Engenheiro Navarro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.442634', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2510, 'Entre Folhas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.44354', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2511, 'Entre Rios de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.444453', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2512, 'Ervalia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.445278', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2513, 'Esmeraldas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.451797', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2514, 'Espera Feliz', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.452981', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2515, 'Espinosa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.453778', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2516, 'Espirito Santo do Dourado', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.454654', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2517, 'Estiva', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.4555', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2518, 'Estrela Dalva', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.456458', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2519, 'Estrela do Indaia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.457559', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2520, 'Estrela do Sul', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.458485', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2521, 'Eugenopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.459407', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2522, 'Ewbank da Camara', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.460227', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2523, 'Extrema', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.461085', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2524, 'Fama', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.461955', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2525, 'Faria Lemos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.462875', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2526, 'Felicio dos Santos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.463927', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2965, 'Sao Goncalo do Rio Preto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.947525', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2527, 'Felisburgo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.464686', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2528, 'Felixlandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.465613', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2529, 'Fernandes Tourinho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.46651', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2530, 'Ferros', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.467262', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2531, 'Fervedouro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.468075', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2532, 'Florestal', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.469065', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2533, 'Formiga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.469915', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2534, 'Formoso', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.470866', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2535, 'Fortaleza de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.4718', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2536, 'Fortuna de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.472649', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2537, 'Francisco Badaro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.47366', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2538, 'Francisco Dumont', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.474555', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2539, 'Francisco Sa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.47544', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2540, 'Franciscopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.476315', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2541, 'Frei Gaspar', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.477184', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2542, 'Frei Inocencio', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.478085', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2543, 'Frei Lagonegro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.478996', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2544, 'Fronteira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.479756', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2545, 'Fronteira dos Vales', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.480618', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2546, 'Fruta de Leite', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.481494', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2547, 'Frutal', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.482274', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2548, 'Funilandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.483177', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2549, 'Galileia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.484093', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2550, 'Gameleiras', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.484955', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2551, 'Glaucilandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.485777', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2552, 'Goiabeira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.493322', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2553, 'Goiana', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.494496', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2554, 'Goncalves', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.49536', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2555, 'Gonzaga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.496231', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2556, 'Gouveia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.497133', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2557, 'Governador Valadares', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.498098', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2558, 'Grao Mogol', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.498957', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2559, 'Grupiara', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.499849', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2560, 'Guanhaes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.500653', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2561, 'Guape', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.501713', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2562, 'Guaraciaba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.502633', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2563, 'Guaraciama', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.503502', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2564, 'Guaranesia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.504369', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2565, 'Guarani', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.505195', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2566, 'Guarara', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.506059', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2567, 'Guarda-mor', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.506895', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2568, 'Guaxupe', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.507726', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2569, 'Guidoval', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.508808', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2570, 'Guimarania', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.509736', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2571, 'Guiricema', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.510664', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2572, 'Gurinhata', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.51156', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2573, 'Heliodora', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.512439', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2574, 'Iapu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.513288', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2575, 'Ibertioga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.514211', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2576, 'Ibia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.515149', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2577, 'Ibiai', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.515973', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2578, 'Ibiracatu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.516767', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2579, 'Ibiraci', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.51756', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2580, 'Ibirite', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.518486', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2581, 'Ibitiura de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.519415', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2582, 'Ibituruna', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.520237', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2583, 'Icarai de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.521141', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2584, 'Igarape', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.522171', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2585, 'Igaratinga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.523975', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2586, 'Iguatama', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.524916', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2587, 'Ijaci', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.525818', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2588, 'Ilicinea', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.526807', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2589, 'Imbe de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.527566', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2590, 'Inconfidentes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.534284', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2591, 'Indaiabira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.535355', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2592, 'Indianopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.536141', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2593, 'Ingai', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.53695', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2594, 'Inhapim', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.537926', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2595, 'Inhauma', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.538866', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2596, 'Inimutaba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.539693', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2597, 'Ipaba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.540615', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2598, 'Ipanema', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.541477', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2599, 'Ipatinga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.542301', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2600, 'Ipiacu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.543088', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2601, 'Ipuiuna', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.544006', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2602, 'Irai de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.544877', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2603, 'Itabira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.545641', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2604, 'Itabirinha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.546423', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2605, 'Itabirito', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.547264', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2606, 'Itacambira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.54826', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2607, 'Itacarambi', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.549333', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2608, 'Itaguara', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.550259', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2609, 'Itaipe', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.551156', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2610, 'Itajuba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.552041', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2611, 'Itamarandiba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.55291', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2612, 'Itamarati de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.553968', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2613, 'Itambacuri', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.554843', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2614, 'Itambe do Mato Dentro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.555903', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2615, 'Itamogi', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.556785', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2616, 'Itamonte', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.557679', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2617, 'Itanhandu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.558486', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2618, 'Itanhomi', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.559343', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2619, 'Itaobim', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.560182', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2620, 'Itapagipe', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.561129', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2621, 'Itapecerica', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.562045', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2622, 'Itapeva', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.562886', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2623, 'Itatiaiucu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.56382', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2624, 'Itau de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.564738', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2625, 'Itauna', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.565631', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2626, 'Itaverava', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.566539', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2627, 'Itinga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.567443', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2628, 'Itueta', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.574206', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2629, 'Ituiutaba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.575462', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2630, 'Itumirim', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.576278', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2631, 'Iturama', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.577299', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2632, 'Itutinga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.578215', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2633, 'Jaboticatubas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.579155', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2634, 'Jacinto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.579934', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2635, 'Jacui', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.580977', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2636, 'Jacutinga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.581851', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2637, 'Jaguaracu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.582674', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2638, 'Jaiba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.583605', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2639, 'Jampruca', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.584486', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2640, 'Janauba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.585356', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2641, 'Januaria', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.586257', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2642, 'Japaraiba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.587138', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2643, 'Japonvar', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.58822', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2644, 'Jeceaba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.589312', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2645, 'Jenipapo de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.590255', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2646, 'Jequeri', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.591033', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2647, 'Jequitai', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.592039', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2648, 'Jequitiba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.592846', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2649, 'Jequitinhonha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.593621', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2650, 'Jesuania', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.594594', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2651, 'Joaima', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.595575', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2652, 'Joanesia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.596474', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2653, 'Joao Monlevade', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.597362', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2654, 'Joao Pinheiro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.59822', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2655, 'Joaquim Felicio', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.599054', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2656, 'Jordania', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.600016', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2657, 'Jose Goncalves de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.600945', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2658, 'Jose Raydan', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.602108', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2659, 'Josenopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.603016', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2768, 'Nova Uniao', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.723765', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2660, 'Juatuba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.604047', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2661, 'Juiz de Fora', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.604952', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2662, 'Juramento', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.605847', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2663, 'Juruaia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.606705', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2664, 'Juvenilia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.607706', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2665, 'Ladainha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.614724', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2666, 'Lagamar', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.615844', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2667, 'Lagoa da Prata', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.616813', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2668, 'Lagoa dos Patos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.617738', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2669, 'Lagoa Dourada', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.618698', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2670, 'Lagoa Formosa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.619622', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2671, 'Lagoa Grande', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.620559', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2672, 'Lagoa Santa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.621608', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2673, 'Lajinha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.622616', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2674, 'Lambari', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.623675', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2675, 'Lamim', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.624505', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2676, 'Laranjal', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.625461', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2677, 'Lassance', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.626399', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2678, 'Lavras', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.62728', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2679, 'Leandro Ferreira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.6282', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2680, 'Leme do Prado', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.629003', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2681, 'Leopoldina', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.629801', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2682, 'Liberdade', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.630694', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2683, 'Lima Duarte', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.631701', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2684, 'Limeira do Oeste', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.632595', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2685, 'Lontra', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.633499', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2686, 'Luisburgo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.634802', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2687, 'Luislandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.635773', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2688, 'Luminarias', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.636597', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2689, 'Luz', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.637763', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2690, 'Machacalis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.638736', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2691, 'Machado', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.639667', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2692, 'Madre de Deus de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.640612', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2693, 'Malacacheta', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.641441', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2694, 'Mamonas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.642344', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2695, 'Manga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.643242', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2696, 'Manhuacu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.644213', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2697, 'Manhumirim', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.64516', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2698, 'Mantena', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.646202', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2700, 'Maravilhas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.647968', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2699, 'Mar de Espanha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.647012', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2701, 'Maria da Fe', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.655614', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2702, 'Mariana', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.656908', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2703, 'Marilac', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.65784', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2704, 'Mario Campos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.658689', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2705, 'Maripa de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.65953', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2706, 'Marlieria', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.66046', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2707, 'Marmelopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.661483', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2708, 'Martinho Campos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.662437', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2709, 'Martins Soares', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.663486', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2710, 'Mata Verde', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.664361', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2711, 'Materlandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.665305', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2712, 'Mateus Leme', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.666284', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2714, 'Matias Barbosa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.668037', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2715, 'Matias Cardoso', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.668913', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2716, 'Matipo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.669963', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2717, 'Mato Verde', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.670864', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2718, 'Matozinhos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.671823', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2719, 'Matutina', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.672635', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2720, 'Medeiros', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.673506', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2721, 'Medina', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.674315', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2722, 'Mendes Pimentel', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.675195', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2723, 'Merces', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.676123', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2724, 'Mesquita', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.677029', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2725, 'Minas Novas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.677866', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2726, 'Minduri', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.67889', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2727, 'Mirabela', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.680059', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2728, 'Miradouro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.681017', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2729, 'Mirai', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.681974', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2730, 'Miravania', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.682921', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2731, 'Moeda', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.683889', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2732, 'Moema', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.684839', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2733, 'Monjolos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.685732', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2734, 'Monsenhor Paulo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.686645', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2735, 'Montalvania', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.687406', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2736, 'Monte Alegre de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.688289', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2737, 'Monte Azul', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.689257', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2738, 'Monte Belo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.696044', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2739, 'Monte Carmelo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.697125', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2740, 'Monte Formoso', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.698007', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2741, 'Monte Santo de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.699102', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2743, 'Montes Claros', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.700683', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2742, 'Monte Siao', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.699867', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2744, 'Montezuma', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.701663', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2745, 'Morada Nova de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.702366', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2746, 'Morro da Garca', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.703301', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2747, 'Morro do Pilar', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.70427', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2748, 'Munhoz', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.705223', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2749, 'Muriae', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.706065', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2750, 'Mutum', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.706975', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2751, 'Muzambinho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.707858', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2752, 'Nacip Raydan', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.70873', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2753, 'Nanuque', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.709584', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2754, 'Naque', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.710678', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2755, 'Natalandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.711561', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2756, 'Natercia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.712473', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2757, 'Nazareno', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.71354', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2758, 'Nepomuceno', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.714525', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2759, 'Ninheira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.715406', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2760, 'Nova Belem', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.716339', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2761, 'Nova Era', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.71725', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2762, 'Nova Lima', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.718111', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2763, 'Nova Modica', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.719056', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2764, 'Nova Ponte', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.720149', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2765, 'Nova Porteirinha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.721149', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2766, 'Nova Resende', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.722075', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2767, 'Nova Serrana', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.7229', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2769, 'Novo Cruzeiro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.724744', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2770, 'Novo Oriente de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.725723', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2771, 'Novorizonte', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.726657', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2772, 'Olaria', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.727589', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2774, 'Olimpio Noronha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.729493', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2775, 'Oliveira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.740384', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2776, 'Oliveira Fortes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.74145', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2777, 'Onca de Pitangui', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.742313', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2778, 'Oratorios', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.7431', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2779, 'Orizania', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.743935', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2780, 'Ouro Branco', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.744933', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2781, 'Ouro Fino', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.745729', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2782, 'Ouro Preto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.746597', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2783, 'Ouro Verde de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.747426', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2784, 'Padre Carvalho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.748246', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2785, 'Padre Paraiso', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.749321', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2787, 'Paineiras', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.75118', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2788, 'Pains', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.752016', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2786, 'Pai Pedro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.750259', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2789, 'Paiva', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.753119', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2790, 'Palma', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.754061', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2791, 'Palmopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.755117', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2792, 'Papagaios', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.75607', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2794, 'Paracatu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.757955', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2793, 'Para de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.756968', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2795, 'Paraguacu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.758826', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2796, 'Paraisopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.759698', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2797, 'Paraopeba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.76053', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2801, 'Passabem', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.764189', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2798, 'Passa Quatro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.761404', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2799, 'Passa Tempo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.762299', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2802, 'Passos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.765124', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2803, 'Patis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.766075', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2804, 'Patos de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.766987', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2805, 'Patrocinio', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.767808', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2806, 'Patrocinio do Muriae', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.768792', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2807, 'Paula Candido', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.769602', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2808, 'Paulistas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.770548', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2809, 'Pavao', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.771502', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2810, 'Pecanha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.772442', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2811, 'Pedra Azul', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.773367', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2812, 'Pedra Bonita', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.774198', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2813, 'Pedra do Anta', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.781051', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2814, 'Pedra do Indaia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.782165', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2815, 'Pedra Dourada', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.783151', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2816, 'Pedralva', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.784071', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2817, 'Pedras de Maria da Cruz', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.784969', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2818, 'Pedrinopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.785949', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2819, 'Pedro Leopoldo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.786904', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2820, 'Pedro Teixeira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.787893', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2821, 'Pequeri', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.788918', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2822, 'Pequi', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.789785', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2823, 'Perdigao', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.790748', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2824, 'Perdizes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.791688', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2825, 'Perdoes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.792564', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2826, 'Periquito', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.793428', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2827, 'Pescador', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.79428', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2828, 'Piau', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.795255', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2829, 'Piedade de Caratinga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.796196', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2830, 'Piedade de Ponte Nova', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.797037', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2831, 'Piedade do Rio Grande', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.797938', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2832, 'Piedade dos Gerais', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.798806', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2833, 'Pimenta', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.799797', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2835, 'Pintopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.801687', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2836, 'Piracema', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.802868', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2837, 'Pirajuba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.803785', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2838, 'Piranga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.804725', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2839, 'Pirangucu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.805698', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2840, 'Piranguinho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.806615', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2841, 'Pirapetinga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.807535', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2842, 'Pirapora', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.80837', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2843, 'Pirauba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.809281', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2844, 'Pitangui', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.810255', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2845, 'Piumhi', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.811233', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2846, 'Planura', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.812132', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2847, 'Poco Fundo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.813128', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2848, 'Pocos de Caldas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.814049', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2849, 'Pocrane', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.814882', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2850, 'Pompeu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.822131', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2851, 'Ponte Nova', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.823253', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2852, 'Ponto Chique', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.824088', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2853, 'Ponto dos Volantes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.825103', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2854, 'Porteirinha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.82606', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2855, 'Porto Firme', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.827004', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2856, 'Pote', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.828002', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2857, 'Pouso Alegre', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.828959', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2858, 'Pouso Alto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.830054', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2859, 'Prados', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.830956', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2860, 'Prata', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.831842', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2861, 'Pratapolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.832742', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2862, 'Pratinha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.833628', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2863, 'Presidente Bernardes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.834501', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2864, 'Presidente Juscelino', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.836256', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2865, 'Presidente Kubitschek', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.837166', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2866, 'Presidente Olegario', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.838125', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2265, 'Alto Jequitiba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.182618', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2867, 'Prudente de Morais', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.839006', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2868, 'Quartel Geral', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.839868', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2869, 'Queluzito', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.840797', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2870, 'Raposos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.84164', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2871, 'Raul Soares', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.842576', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2872, 'Recreio', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.843754', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2873, 'Reduto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.844654', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2874, 'Resende Costa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.845628', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2875, 'Resplendor', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.846633', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2876, 'Ressaquinha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.847458', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2877, 'Riachinho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.848378', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2878, 'Riacho dos Machados', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.849254', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2879, 'Ribeirao das Neves', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.850149', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2880, 'Ribeirao Vermelho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.851048', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2881, 'Rio Acima', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.852061', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2882, 'Rio Casca', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.852976', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2884, 'Rio Doce', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.854683', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2883, 'Rio do Prado', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.853875', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2885, 'Rio Espera', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.855684', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2886, 'Rio Manso', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.856476', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2887, 'Rio Novo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.863208', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2888, 'Rio Paranaiba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.86423', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2889, 'Rio Pardo de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.865113', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2890, 'Rio Piracicaba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.866003', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2891, 'Rio Pomba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.866718', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2892, 'Rio Preto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.86757', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2893, 'Rio Vermelho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.868466', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2894, 'Ritapolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.86965', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2895, 'Rochedo de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.870574', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2896, 'Rodeiro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.87147', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2897, 'Romaria', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.872334', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2898, 'Rosario da Limeira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.873188', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2899, 'Rubelita', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.873986', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2900, 'Rubim', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.874865', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2901, 'Sabara', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.875998', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2902, 'Sabinopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.876908', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2903, 'Sacramento', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.877892', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2904, 'Salinas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.878715', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2905, 'Salto da Divisa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.87963', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2906, 'Santa Barbara', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.880788', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2907, 'Santa Barbara do Leste', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.881713', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2908, 'Santa Barbara do Monte Verde', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.882576', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2909, 'Santa Barbara do Tugurio', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.883499', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2910, 'Santa Cruz de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.884331', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2911, 'Santa Cruz de Salinas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.885373', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2912, 'Santa Cruz do Escalvado', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.886231', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2913, 'Santa Efigenia de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.887023', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2914, 'Santa Fe de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.887823', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2915, 'Santa Helena de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.888613', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2916, 'Santa Juliana', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.889436', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2917, 'Santa Luzia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.890286', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2918, 'Santa Margarida', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.891179', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2919, 'Santa Maria de Itabira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.892071', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2920, 'Santa Maria do Salto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.893033', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2921, 'Santa Maria do Suacui', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.893934', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2930, 'Santana da Vargem', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.90782', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2931, 'Santana de Cataguases', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.908562', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2932, 'Santana de Pirapama', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.909396', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2933, 'Santana do Deserto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.91025', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2934, 'Santana do Garambeu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.911172', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2935, 'Santana do Jacare', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.912087', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2936, 'Santana do Manhuacu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.912919', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2937, 'Santana do Paraiso', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.913893', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2938, 'Santana do Riacho', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.914701', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2939, 'Santana dos Montes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.915635', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2922, 'Santa Rita de Caldas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.894802', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2924, 'Santa Rita de Jacutinga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.896554', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2925, 'Santa Rita de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.90317', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2923, 'Santa Rita de Ibitipoca', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.895661', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2926, 'Santa Rita do Itueto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.904334', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2927, 'Santa Rita do Sapucai', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.905188', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2928, 'Santa Rosa da Serra', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.906002', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2929, 'Santa Vitoria', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.906897', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2940, 'Santo Antonio do Amparo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.916561', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2941, 'Santo Antonio do Aventureiro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.917522', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2942, 'Santo Antonio do Grama', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.918259', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2943, 'Santo Antonio do Itambe', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.919652', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2944, 'Santo Antonio do Jacinto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.920493', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2945, 'Santo Antonio do Monte', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.921488', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2946, 'Santo Antonio do Retiro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.922448', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2947, 'Santo Antonio do Rio Abaixo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.923338', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2948, 'Santo Hipolito', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.924169', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2949, 'Santos Dumont', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.925463', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2950, 'Sao Bento Abade', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.926405', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2951, 'Sao Bras do Suacui', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.927261', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2952, 'Sao Domingos das Dores', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.928137', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2953, 'Sao Domingos do Prata', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.928974', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2954, 'Sao Felix de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.929859', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2955, 'Sao Francisco', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.930685', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2956, 'Sao Francisco de Paula', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.931488', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2957, 'Sao Francisco de Sales', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.932267', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2958, 'Sao Francisco do Gloria', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.933213', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2959, 'Sao Geraldo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.934103', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2960, 'Sao Geraldo da Piedade', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.935011', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2961, 'Sao Geraldo do Baixio', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.935934', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2962, 'Sao Goncalo do Abaete', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.936778', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2963, 'Sao Goncalo do Para', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.944008', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2964, 'Sao Goncalo do Rio Abaixo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.945446', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2966, 'Sao Goncalo do Sapucai', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.948415', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2967, 'Sao Gotardo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.949358', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2968, 'Sao Joao Batista do Gloria', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.950284', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2969, 'Sao Joao da Lagoa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.951373', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2970, 'Sao Joao da Mata', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.952414', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2971, 'Sao Joao da Ponte', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.95334', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2972, 'Sao Joao das Missoes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.954242', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2973, 'Sao Joao Del Rei', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.955094', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2974, 'Sao Joao do Manhuacu', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.955927', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2975, 'Sao Joao do Manteninha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.956767', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2976, 'Sao Joao do Oriente', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.957553', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2977, 'Sao Joao do Pacui', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.958462', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2978, 'Sao Joao do Paraiso', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.959259', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2979, 'Sao Joao Evangelista', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.960178', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2980, 'Sao Joao Nepomuceno', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.961059', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2981, 'Sao Joaquim de Bicas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.962029', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2982, 'Sao Jose da Barra', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.962922', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2983, 'Sao Jose da Lapa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.963826', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2984, 'Sao Jose da Safira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.964717', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2985, 'Sao Jose da Varginha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.965573', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2986, 'Sao Jose do Alegre', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.966464', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2987, 'Sao Jose do Divino', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.967302', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2988, 'Sao Jose do Goiabal', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.968161', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2989, 'Sao Jose do Jacuri', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.969054', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2990, 'Sao Jose do Mantimento', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.970124', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2991, 'Sao Lourenco', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.97104', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2992, 'Sao Miguel do Anta', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.971941', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2993, 'Sao Pedro da Uniao', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.972841', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2995, 'Sao Pedro dos Ferros', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.974488', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2994, 'Sao Pedro do Suacui', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.973711', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2996, 'Sao Romao', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.975409', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2997, 'Sao Roque de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.976377', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2998, 'Sao Sebastiao da Bela Vista', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.977178', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2999, 'Sao Sebastiao da Vargem Alegre', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.97811', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3000, 'Sao Sebastiao do Anta', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.984627', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3001, 'Sao Sebastiao do Maranhao', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.985785', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3002, 'Sao Sebastiao do Oeste', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.986709', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3003, 'Sao Sebastiao do Paraiso', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.987623', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3004, 'Sao Sebastiao do Rio Preto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.988553', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3005, 'Sao Sebastiao do Rio Verde', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.989525', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3007, 'Sao Tiago', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.991371', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3008, 'Sao Tomas de Aquino', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.992485', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3006, 'Sao Thome das Letras', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.990503', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3009, 'Sao Vicente de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.993316', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3010, 'Sapucai-mirim', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.994126', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3011, 'Sardoa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.995033', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3012, 'Sarzedo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.995979', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3033, 'Setubinha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.014708', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3014, 'Senador Amaral', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.997785', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3015, 'Senador Cortes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.998572', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3016, 'Senador Firmino', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.999432', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3017, 'Senador Jose Bento', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.000242', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3018, 'Senador Modestino Goncalves', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.001181', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3019, 'Senhora de Oliveira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.002238', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3020, 'Senhora do Porto', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.003123', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3021, 'Senhora dos Remedios', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.003942', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3022, 'Sericita', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.004806', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3023, 'Seritinga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.00583', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3024, 'Serra Azul de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.006724', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3025, 'Serra da Saudade', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.007597', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3027, 'Serra dos Aimores', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.00936', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3026, 'Serra do Salitre', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.008494', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3028, 'Serrania', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.010257', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3029, 'Serranopolis de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.011126', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3030, 'Serranos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.011947', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3031, 'Serro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.012745', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3032, 'Sete Lagoas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.013654', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3034, 'Silveirania', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.015627', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3035, 'Silvianopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.016489', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3036, 'Simao Pereira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.017459', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3037, 'Simonesia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.018331', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3038, 'Sobralia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.024929', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3039, 'Soledade de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.026211', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3040, 'Tabuleiro', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.027116', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3041, 'Taiobeiras', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.027909', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3042, 'Taparuba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.028691', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3043, 'Tapira', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.029455', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3044, 'Tapirai', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.030502', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3045, 'Taquaracu de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.031405', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3046, 'Tarumirim', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.032341', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3047, 'Teixeiras', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.033084', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3048, 'Teofilo Otoni', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.034005', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3049, 'Timoteo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.034877', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3050, 'Tiradentes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.035717', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3051, 'Tiros', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.036438', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3052, 'Tocantins', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.037378', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3054, 'Toledo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.039162', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3055, 'Tombos', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.040058', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3056, 'Tres Coracoes', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.040906', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3057, 'Tres Marias', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.0418', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3058, 'Tres Pontas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.042593', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3059, 'Tumiritinga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.043498', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3060, 'Tupaciguara', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.044437', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3061, 'Turmalina', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.045367', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3062, 'Turvolandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.04633', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3063, 'Uba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.047362', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3064, 'Ubai', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.048359', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3065, 'Ubaporanga', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.049243', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3066, 'Uberaba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.050224', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3067, 'Uberlandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.051156', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3068, 'Umburatiba', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.052078', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3069, 'Unai', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.052956', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3070, 'Uniao de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.05387', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3071, 'Uruana de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.054766', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3072, 'Urucania', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.055651', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3073, 'Urucuia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.056552', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3074, 'Vargem Alegre', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.057453', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3075, 'Vargem Bonita', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.058481', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3076, 'Vargem Grande do Rio Pardo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.05921', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3077, 'Varginha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.065668', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3078, 'Varjao de Minas', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.066741', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3079, 'Varzea da Palma', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.067629', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3080, 'Varzelandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.068499', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3081, 'Vazante', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.069738', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3082, 'Verdelandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.070607', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3083, 'Veredinha', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.071486', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3084, 'Verissimo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.072355', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3085, 'Vermelho Novo', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.073251', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3086, 'Vespasiano', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.074104', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3087, 'Vicosa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.074933', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3088, 'Vieiras', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.075846', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (2713, 'Mathias Lobato', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:36.667155', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3089, 'Virgem da Lapa', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.076853', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3090, 'Virginia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.077734', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3091, 'Virginopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.078589', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3092, 'Virgolandia', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.079515', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3093, 'Visconde do Rio Branco', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.080291', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3094, 'Volta Grande', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.081204', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3095, 'Wenceslau Braz', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.081973', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3096, 'Afonso Claudio', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.082886', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3098, 'Aguia Branca', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.084678', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3097, 'Agua Doce do Norte', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.08375', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3099, 'Alegre', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.085605', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3100, 'Alfredo Chaves', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.086469', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3101, 'Alto Rio Novo', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.087312', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3102, 'Anchieta', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.088204', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3103, 'Apiaca', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.089062', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3104, 'Aracruz', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.089943', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3105, 'Atilio Vivacqua', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.09086', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3106, 'Baixo Guandu', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.091737', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3107, 'Barra de Sao Francisco', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.092835', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3108, 'Boa Esperanca', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.093704', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3109, 'Bom Jesus do Norte', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.094622', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3110, 'Brejetuba', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.095495', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3111, 'Cachoeiro de Itapemirim', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.096312', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3112, 'Cariacica', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.097169', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3113, 'Castelo', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.09809', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3114, 'Colatina', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.099011', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3115, 'Conceicao da Barra', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.105545', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3116, 'Conceicao do Castelo', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.106749', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3117, 'Divino de Sao Lourenco', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.107684', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3118, 'Domingos Martins', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.108581', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3119, 'Dores do Rio Preto', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.109452', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3120, 'Ecoporanga', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.110394', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3121, 'Fundao', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.111308', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3122, 'Governador Lindenberg', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.112208', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3123, 'Guacui', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.113153', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3124, 'Guarapari', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.11402', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3125, 'Ibatiba', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.11507', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3126, 'Ibiracu', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.115945', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3127, 'Ibitirama', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.116851', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3128, 'Iconha', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.117854', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3129, 'Irupi', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.118674', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3130, 'Itaguacu', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.119498', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3131, 'Itapemirim', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.120273', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3132, 'Itarana', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.12108', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3133, 'Iuna', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.122057', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3134, 'Jaguare', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.122973', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3135, 'Jeronimo Monteiro', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.123854', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3136, 'Joao Neiva', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.124735', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3137, 'Laranja da Terra', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.125741', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3138, 'Linhares', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.126641', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3139, 'Mantenopolis', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.127556', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3140, 'Marataizes', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.128435', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3141, 'Marechal Floriano', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.129304', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3142, 'Marilandia', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.130149', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3143, 'Mimoso do Sul', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.131032', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3144, 'Montanha', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.131767', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3145, 'Mucurici', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.132669', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3146, 'Muniz Freire', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.133579', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3147, 'Muqui', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.13436', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3148, 'Nova Venecia', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.135185', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3149, 'Pancas', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.136062', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3150, 'Pedro Canario', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.137029', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3151, 'Pinheiros', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.13779', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3152, 'Piuma', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.138726', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3153, 'Ponto Belo', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.139504', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3154, 'Presidente Kennedy', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.146339', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3155, 'Rio Bananal', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.150463', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3156, 'Rio Novo do Sul', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.151418', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3157, 'Santa Leopoldina', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.152323', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3158, 'Santa Maria de Jetiba', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.153183', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3159, 'Santa Teresa', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.154075', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3160, 'Sao Domingos do Norte', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.154905', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3161, 'Sao Gabriel da Palha', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.15581', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3162, 'Sao Jose do Calcado', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.156713', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3163, 'Sao Mateus', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.157706', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3164, 'Sao Roque do Canaa', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.158648', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3165, 'Serra', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.159594', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3166, 'Sooretama', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.160485', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3167, 'Vargem Alta', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.161405', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3168, 'Venda Nova do Imigrante', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.162222', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3169, 'Viana', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.163119', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3170, 'Vila Pavao', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.164134', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3171, 'Vila Valerio', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.165005', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3172, 'Vila Velha', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.165861', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3173, 'Vitoria', 'ES', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.166749', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3174, 'Angra dos Reis', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.16759', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3175, 'Aperibe', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.168353', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3176, 'Araruama', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.169167', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3177, 'Areal', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.170131', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3178, 'Armacao dos Buzios', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.171024', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3179, 'Arraial do Cabo', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.171933', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3180, 'Barra do Pirai', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.172817', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3181, 'Barra Mansa', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.173722', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3182, 'Belford Roxo', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.174593', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3183, 'Bom Jardim', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.175369', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3184, 'Bom Jesus do Itabapoana', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.17623', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3185, 'Cabo Frio', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.177146', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3186, 'Cachoeiras de Macacu', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.178064', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3187, 'Cambuci', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.178988', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3190, 'Carapebus', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.188539', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3194, 'Comendador Levy Gasparian', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.192154', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3188, 'Campos dos Goytacazes', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.17996', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3189, 'Cantagalo', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.187376', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3191, 'Cardoso Moreira', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.189489', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3192, 'Carmo', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.190376', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3193, 'Casimiro de Abreu', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.191224', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3195, 'Conceicao de Macabu', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.193182', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3196, 'Cordeiro', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.194114', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3197, 'Duas Barras', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.195152', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3198, 'Duque de Caxias', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.195978', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3199, 'Engenheiro Paulo de Frontin', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.197016', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3200, 'Guapimirim', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.197975', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3201, 'Iguaba Grande', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.198896', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3202, 'Itaborai', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.199823', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3203, 'Itaguai', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.200615', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3204, 'Italva', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.201573', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3205, 'Itaocara', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.202472', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3206, 'Itaperuna', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.203303', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3207, 'Itatiaia', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.204383', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3208, 'Japeri', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.20529', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3209, 'Laje do Muriae', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.206148', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3210, 'Macae', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.207034', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3211, 'Macuco', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.207887', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3212, 'Mage', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.208742', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3213, 'Mangaratiba', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.209642', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3214, 'Marica', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.210561', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3215, 'Mendes', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.211426', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3216, 'Mesquita', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.212248', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3217, 'Miguel Pereira', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.21322', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3218, 'Miracema', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.214025', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3219, 'Natividade', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.214987', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3220, 'Nilopolis', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.215631', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3221, 'Niteroi', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.216575', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3222, 'Nova Friburgo', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.217505', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3223, 'Nova Iguacu', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.218374', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3224, 'Paracambi', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.219241', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3225, 'Paraiba do Sul', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.22011', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3227, 'Paty do Alferes', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.227898', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3228, 'Petropolis', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.22905', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3229, 'Pinheiral', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.229964', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3230, 'Pirai', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.230972', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3231, 'Porciuncula', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.231958', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3232, 'Porto Real', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.232847', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3233, 'Quatis', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.233751', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3234, 'Queimados', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.234722', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3235, 'Quissama', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.235676', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3236, 'Resende', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.236633', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3237, 'Rio Bonito', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.238008', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3238, 'Rio Claro', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.238923', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3239, 'Rio das Flores', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.239799', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3240, 'Rio das Ostras', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.24067', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3241, 'Rio de Janeiro', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.241514', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3242, 'Santa Maria Madalena', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.242392', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3243, 'Santo Antonio de Padua', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.24326', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3245, 'Sao Francisco de Itabapoana', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.244999', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3244, 'Sao Fidelis', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.244209', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3246, 'Sao Goncalo', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.245904', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3247, 'Sao Joao da Barra', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.24683', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3248, 'Sao Joao de Meriti', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.24777', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3249, 'Sao Jose de Uba', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.248945', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3250, 'Sao Jose do Vale do Rio Preto', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.249825', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3251, 'Sao Pedro da Aldeia', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.250587', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3252, 'Sao Sebastiao do Alto', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.251419', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3253, 'Sapucaia', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.252236', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3254, 'Saquarema', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.253149', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3255, 'Seropedica', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.254076', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3256, 'Silva Jardim', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.254876', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3257, 'Sumidouro', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.255796', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3258, 'Tangua', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.256693', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3259, 'Teresopolis', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.257579', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3261, 'Tres Rios', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.259558', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3262, 'Valenca', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.260357', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3263, 'Varre-sai', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.261201', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3264, 'Vassouras', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.262061', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3265, 'Volta Redonda', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.268581', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3266, 'Adamantina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.269835', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3267, 'Adolfo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.27087', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3268, 'Aguai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.27173', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3269, 'Aguas da Prata', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.272445', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3270, 'Aguas de Lindoia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.273402', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3271, 'Aguas de Santa Barbara', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.274253', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3272, 'Aguas de Sao Pedro', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.275125', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3273, 'Agudos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.276017', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3274, 'Alambari', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.276922', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3275, 'Alfredo Marcondes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.277864', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3276, 'Altair', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.278774', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3277, 'Altinopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.279605', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3278, 'Alto Alegre', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.280491', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3279, 'Aluminio', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.281409', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3280, 'Alvares Florence', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.282369', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3281, 'Alvares Machado', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.283238', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3282, 'Alvaro de Carvalho', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.284169', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3283, 'Alvinlandia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.285077', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3284, 'Americana', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.286013', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3285, 'Americo Brasiliense', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.286803', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3286, 'Americo de Campos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.287738', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3287, 'Amparo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.288607', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3288, 'Analandia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.2895', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3289, 'Andradina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.290456', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3290, 'Angatuba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.291244', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3291, 'Anhembi', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.29216', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3292, 'Anhumas', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.293119', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3293, 'Aparecida', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.293914', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3294, 'Aparecida D''oeste', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.294812', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3295, 'Apiai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.295701', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3296, 'Aracariguama', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.29661', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3297, 'Aracatuba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.297483', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3298, 'Aracoiaba da Serra', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.298305', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3299, 'Aramina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.299187', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3300, 'Arandu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.299986', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3301, 'Arapei', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.300898', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3302, 'Araraquara', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.301802', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3303, 'Araras', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.308817', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3304, 'Arco-iris', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.31001', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3305, 'Arealva', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.311055', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3306, 'Areias', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.31192', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3307, 'Areiopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.312751', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3308, 'Ariranha', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.313577', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3309, 'Artur Nogueira', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.314489', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3310, 'Aruja', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.315495', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3311, 'Aspasia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.316308', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3312, 'Assis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.317358', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3313, 'Atibaia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.318277', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3314, 'Auriflama', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.319244', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3315, 'Avai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.320115', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3316, 'Avanhandava', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.320988', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3317, 'Avare', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.321877', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3318, 'Bady Bassitt', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.322788', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3319, 'Balbinos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.32373', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3320, 'Balsamo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.324586', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3321, 'Bananal', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.325482', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3322, 'Barao de Antonina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.326512', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3323, 'Barbosa', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.327365', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3324, 'Bariri', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.328252', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3325, 'Barra Bonita', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.329113', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3326, 'Barra do Chapeu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.329955', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3327, 'Barra do Turvo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.330965', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3328, 'Barretos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.331935', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3329, 'Barrinha', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.332765', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3330, 'Barueri', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.333592', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3331, 'Bastos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.334547', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3332, 'Batatais', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.33538', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3333, 'Bauru', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.336251', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3334, 'Bebedouro', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.337171', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3335, 'Bento de Abreu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.338264', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3336, 'Bernardino de Campos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.339179', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3337, 'Bertioga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.340015', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3338, 'Bilac', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.340826', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3339, 'Birigui', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.341697', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3340, 'Biritiba-mirim', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.342549', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3341, 'Boa Esperanca do Sul', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.350287', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3342, 'Bocaina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.351429', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3343, 'Bofete', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.352408', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3344, 'Boituva', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.353564', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3345, 'Bom Jesus dos Perdoes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.354421', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3346, 'Bom Sucesso de Itarare', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.355449', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3347, 'Bora', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.356379', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3348, 'Boraceia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.357481', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3349, 'Borborema', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.358426', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3350, 'Borebi', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.359296', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3351, 'Botucatu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.360376', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3352, 'Braganca Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.361423', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3353, 'Brauna', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.362273', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3354, 'Brejo Alegre', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.363155', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3355, 'Brodowski', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.364124', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3356, 'Brotas', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.365052', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3357, 'Buri', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.366004', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3358, 'Buritama', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.366945', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3359, 'Buritizal', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.367895', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3360, 'Cabralia Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.368816', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3361, 'Cabreuva', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.369719', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3362, 'Cacapava', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.370627', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3363, 'Cachoeira Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.371763', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3364, 'Caconde', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.372711', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3365, 'Cafelandia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.373562', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3366, 'Caiabu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.374476', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3367, 'Caieiras', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.375453', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3368, 'Caiua', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.37635', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3369, 'Cajamar', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.377277', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3370, 'Cajati', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.378209', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3371, 'Cajobi', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.379165', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3372, 'Cajuru', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.380188', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3373, 'Campina do Monte Alegre', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.381138', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3374, 'Campinas', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.381967', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3375, 'Campo Limpo Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.382892', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3376, 'Campos do Jordao', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.384015', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3377, 'Campos Novos Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.390894', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3378, 'Cananeia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.392104', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3379, 'Canas', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.393199', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3380, 'Candido Mota', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.394055', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3381, 'Candido Rodrigues', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.39493', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3382, 'Canitar', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.395858', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3383, 'Capao Bonito', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.39675', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3384, 'Capela do Alto', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.397713', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3385, 'Capivari', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.398691', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3386, 'Caraguatatuba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.399692', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3387, 'Carapicuiba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.400634', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3388, 'Cardoso', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.401562', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3389, 'Casa Branca', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.40251', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3390, 'Cassia dos Coqueiros', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.403415', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3391, 'Castilho', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.4044', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3392, 'Catanduva', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.405192', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3393, 'Catigua', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.406069', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3394, 'Cedral', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.407007', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3395, 'Cerqueira Cesar', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.407879', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3396, 'Cerquilho', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.408712', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3397, 'Cesario Lange', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.409578', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3398, 'Charqueada', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.410493', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3400, 'Clementina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.412407', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3401, 'Colina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.413332', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3402, 'Colombia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.41435', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3403, 'Conchal', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.415259', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3404, 'Conchas', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.416408', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3405, 'Cordeiropolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.417364', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3406, 'Coroados', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.418209', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3407, 'Coronel Macedo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.41912', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3408, 'Corumbatai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.420001', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3409, 'Cosmopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.420964', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3410, 'Cosmorama', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.421879', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3411, 'Cotia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.422822', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3412, 'Cravinhos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.423659', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3413, 'Cristais Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.424565', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3414, 'Cruzalia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.433202', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3415, 'Cruzeiro', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.43419', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3416, 'Cubatao', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.435124', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3417, 'Cunha', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.436005', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3418, 'Descalvado', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.436909', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3419, 'Diadema', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.43802', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3420, 'Dirce Reis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.438961', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3421, 'Divinolandia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.439881', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3422, 'Dobrada', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.44092', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3423, 'Dois Corregos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.441834', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3424, 'Dolcinopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.442609', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3425, 'Dourado', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.443543', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3426, 'Dracena', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.444476', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3427, 'Duartina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.445394', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3428, 'Dumont', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.44637', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3429, 'Echapora', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.447249', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3430, 'Eldorado', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.448152', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3431, 'Elias Fausto', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.449197', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3432, 'Elisiario', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.450013', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3433, 'Embauba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.450854', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3435, 'Embu-guacu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.452864', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3436, 'Emilianopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.453877', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3437, 'Engenheiro Coelho', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.454824', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3438, 'Espirito Santo do Pinhal', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.455702', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3439, 'Espirito Santo do Turvo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.456596', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3442, 'Estrela D''oeste', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.464626', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3441, 'Estrela do Norte', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.463187', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3443, 'Euclides da Cunha Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.465815', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3444, 'Fartura', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.467149', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3446, 'Fernandopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.474339', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3445, 'Fernando Prestes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.468296', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3447, 'Fernao', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.475403', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3448, 'Ferraz de Vasconcelos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.476418', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3449, 'Flora Rica', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.477443', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3450, 'Floreal', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.478415', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3451, 'Florida Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.479622', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3452, 'Florinia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.480544', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3453, 'Franca', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.481469', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3454, 'Francisco Morato', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.482394', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3455, 'Franco da Rocha', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.483499', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3456, 'Gabriel Monteiro', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.484411', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3457, 'Galia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.485277', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3458, 'Garca', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.486137', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3459, 'Gastao Vidigal', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.487262', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3460, 'Gaviao Peixoto', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.488275', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3461, 'General Salgado', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.489182', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3462, 'Getulina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.490105', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3463, 'Glicerio', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.491081', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3464, 'Guaicara', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.49205', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3465, 'Guaimbe', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.492981', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3466, 'Guaira', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.493861', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3467, 'Guapiacu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.494824', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3468, 'Guapiara', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.495711', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3469, 'Guara', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.49662', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3470, 'Guaracai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.497498', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3471, 'Guaraci', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.498609', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3472, 'Guarani D''oeste', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.499582', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3473, 'Guaranta', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.500522', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3474, 'Guararapes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.501478', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3475, 'Guararema', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.502457', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3476, 'Guaratingueta', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.503375', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3477, 'Guarei', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.504252', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3478, 'Guariba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.50542', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3479, 'Guaruja', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.506355', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3480, 'Guarulhos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.50736', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3481, 'Guatapara', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.514491', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3482, 'Guzolandia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.51563', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3483, 'Herculandia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.516787', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3484, 'Holambra', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.517506', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3485, 'Hortolandia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.518326', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3486, 'Iacanga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.519603', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3487, 'Iacri', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.520661', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3488, 'Iaras', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.521549', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3489, 'Ibate', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.522424', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3490, 'Ibira', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.52329', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3491, 'Ibirarema', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.524224', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3492, 'Ibitinga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.525141', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3493, 'Ibiuna', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.526048', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3494, 'Icem', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.526892', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3495, 'Iepe', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.527707', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3496, 'Igaracu do Tiete', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.528553', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3497, 'Igarapava', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.5295', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3498, 'Igarata', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.530465', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3499, 'Iguape', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.531632', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3502, 'Ilhabela', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.534591', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3500, 'Ilha Comprida', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.532647', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3501, 'Ilha Solteira', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.533656', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3503, 'Indaiatuba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.53556', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3504, 'Indiana', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.536463', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3505, 'Indiapora', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.537406', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3506, 'Inubia Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.538346', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3507, 'Ipaussu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.539122', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3508, 'Ipero', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.540114', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3509, 'Ipeuna', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.54106', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3510, 'Ipigua', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.542009', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3511, 'Iporanga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.542934', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3512, 'Ipua', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.543761', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3513, 'Iracemapolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.544853', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3514, 'Irapua', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.545807', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3515, 'Irapuru', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.546727', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3516, 'Itabera', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.54776', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3517, 'Itai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.555415', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3518, 'Itajobi', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.556639', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3519, 'Itaju', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.557538', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3520, 'Itanhaem', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.558368', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3521, 'Itaoca', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.559349', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3522, 'Itapecerica da Serra', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.560304', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3523, 'Itapetininga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.561226', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3524, 'Itapeva', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.562042', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3525, 'Itapevi', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.563', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3526, 'Itapira', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.564035', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3527, 'Itapirapua Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.564976', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3528, 'Itapolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.565875', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3529, 'Itaporanga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.566665', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3530, 'Itapui', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.567469', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3531, 'Itapura', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.568248', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3532, 'Itaquaquecetuba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.569268', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3533, 'Itarare', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.570327', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3534, 'Itariri', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.571116', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3535, 'Itatiba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.572068', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3536, 'Itatinga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.572867', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3537, 'Itirapina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.57366', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3538, 'Itirapua', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.574547', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3539, 'Itobi', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.57546', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3540, 'Itu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.576321', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3541, 'Itupeva', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.577536', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3542, 'Ituverava', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.578426', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3543, 'Jaborandi', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.579392', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3544, 'Jaboticabal', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.58031', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3545, 'Jacarei', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.581242', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3546, 'Jaci', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.582181', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3547, 'Jacupiranga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.583183', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3548, 'Jaguariuna', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.583988', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3549, 'Jales', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.584901', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3550, 'Jambeiro', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.585854', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3551, 'Jandira', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.586757', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3552, 'Jardinopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.587586', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3553, 'Jarinu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.588515', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3554, 'Jau', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.589433', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3555, 'Jeriquara', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.590483', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3556, 'Joanopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.596351', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3557, 'Joao Ramalho', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.597603', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3558, 'Jose Bonifacio', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.59875', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3559, 'Julio Mesquita', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.599726', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3560, 'Jumirim', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.600794', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3561, 'Jundiai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.601706', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3562, 'Junqueiropolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.602591', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3563, 'Juquia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.603635', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3564, 'Juquitiba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.604582', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3565, 'Lagoinha', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.605474', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3566, 'Laranjal Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.607194', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3567, 'Lavinia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.608188', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3568, 'Lavrinhas', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.60912', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3569, 'Leme', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.609957', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3570, 'Lencois Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.611063', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3571, 'Limeira', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.612034', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3572, 'Lindoia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.613045', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3573, 'Lins', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.613865', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3574, 'Lorena', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.61467', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3575, 'Lourdes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.615605', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3576, 'Louveira', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.616624', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3577, 'Lucelia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.617438', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3578, 'Lucianopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.618341', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3579, 'Luis Antonio', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.619193', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3580, 'Luiziania', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.620134', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3581, 'Lupercio', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.621094', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3582, 'Lutecia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.62201', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3583, 'Macatuba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.622926', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3584, 'Macaubal', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.623778', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3585, 'Macedonia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.624723', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3586, 'Magda', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.625616', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3587, 'Mairinque', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.62654', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3588, 'Mairipora', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.627638', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3589, 'Manduri', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.628439', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3590, 'Maraba Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.629383', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3591, 'Maracai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.636541', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3592, 'Marapoama', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.63785', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3593, 'Mariapolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.638856', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3594, 'Marilia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.639554', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3595, 'Marinopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.640522', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3596, 'Martinopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.641428', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3597, 'Matao', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.642269', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3598, 'Maua', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.643236', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3599, 'Mendonca', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.644256', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3600, 'Meridiano', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.645169', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3601, 'Mesopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.64605', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3602, 'Miguelopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.646934', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3603, 'Mineiros do Tiete', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.647811', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3605, 'Miracatu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.649539', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3604, 'Mira Estrela', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.648659', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3606, 'Mirandopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.650507', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3607, 'Mirante do Paranapanema', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.651428', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3608, 'Mirassol', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.652283', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3609, 'Mirassolandia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.653107', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3610, 'Mococa', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.65403', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3611, 'Mogi das Cruzes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.654934', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3612, 'Mogi Guacu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.655912', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3614, 'Mombuca', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.65768', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3615, 'Moncoes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.658653', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3616, 'Mongagua', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.6595', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3617, 'Monte Alegre do Sul', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.66052', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3618, 'Monte Alto', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.661636', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3619, 'Monte Aprazivel', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.662504', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3620, 'Monte Azul Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.663455', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3621, 'Monte Castelo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.664378', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3623, 'Monteiro Lobato', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.66621', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3622, 'Monte Mor', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.665291', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3624, 'Morro Agudo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.667129', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3625, 'Morungaba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.6681', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3626, 'Motuca', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.669012', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3627, 'Murutinga do Sul', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.669991', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3628, 'Nantes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.677087', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3629, 'Narandiba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.678371', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3630, 'Natividade da Serra', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.6794', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3631, 'Nazare Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.680367', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3632, 'Neves Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.681221', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3633, 'Nhandeara', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.682247', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3634, 'Nipoa', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.683209', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3635, 'Nova Alianca', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.684071', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3636, 'Nova Campina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.685019', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3637, 'Nova Canaa Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.685923', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3638, 'Nova Castilho', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.68688', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3639, 'Nova Europa', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.687744', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3640, 'Nova Granada', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.688615', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3641, 'Nova Guataporanga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.689453', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3642, 'Nova Independencia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.69033', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3645, 'Novais', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.693025', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3643, 'Nova Luzitania', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.69125', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3644, 'Nova Odessa', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.692148', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3646, 'Novo Horizonte', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.693881', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3647, 'Nuporanga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.694756', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3648, 'Ocaucu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.695695', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3649, 'Oleo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.696598', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3650, 'Olimpia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.697503', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3651, 'Onda Verde', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.698381', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3652, 'Oriente', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.699328', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3653, 'Orindiuva', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.700226', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3654, 'Orlandia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.70113', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3655, 'Osasco', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.702113', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3656, 'Oscar Bressane', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.703017', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3657, 'Osvaldo Cruz', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.703902', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3658, 'Ourinhos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.704848', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3660, 'Ouroeste', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.706649', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3659, 'Ouro Verde', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.705842', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3661, 'Pacaembu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.707503', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3662, 'Palestina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.708316', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3663, 'Palmares Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.7091', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3664, 'Palmeira D''oeste', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.709909', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3665, 'Palmital', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.710909', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3666, 'Panorama', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.71165', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3667, 'Paraguacu Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.7191', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3668, 'Paraibuna', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.720228', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3669, 'Paraiso', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.721111', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3670, 'Paranapanema', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.722043', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3671, 'Paranapua', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.72293', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3672, 'Parapua', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.723768', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3673, 'Pardinho', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.72461', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3674, 'Pariquera-acu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.725544', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3675, 'Parisi', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.726416', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3676, 'Patrocinio Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.727324', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3677, 'Pauliceia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.728179', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3678, 'Paulinia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.729059', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3679, 'Paulistania', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.730037', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3680, 'Paulo de Faria', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.730894', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3681, 'Pederneiras', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.731757', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3682, 'Pedra Bela', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.732587', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3683, 'Pedranopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.733429', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3684, 'Pedregulho', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.73431', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3685, 'Pedreira', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.735221', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3686, 'Pedrinhas Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.736151', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3687, 'Pedro de Toledo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.737085', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3688, 'Penapolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.738028', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3689, 'Pereira Barreto', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.738983', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3690, 'Pereiras', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.73982', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3691, 'Peruibe', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.740635', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3692, 'Piacatu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.741532', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3693, 'Piedade', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.742468', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3694, 'Pilar do Sul', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.743483', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3695, 'Pindamonhangaba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.744333', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3696, 'Pindorama', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.745185', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3697, 'Pinhalzinho', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.746103', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3698, 'Piquerobi', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.747239', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3699, 'Piquete', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.748177', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3700, 'Piracaia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.749108', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3701, 'Piracicaba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.750017', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3702, 'Piraju', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.751064', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3703, 'Pirajui', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.752015', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3704, 'Pirangi', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.759139', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3705, 'Pirapora do Bom Jesus', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.760398', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3706, 'Pirapozinho', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.761455', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3707, 'Pirassununga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.762332', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3708, 'Piratininga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.76325', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3709, 'Pitangueiras', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.764242', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3710, 'Planalto', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.76523', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3711, 'Platina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.766168', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3712, 'Poa', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.767481', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3713, 'Poloni', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.768419', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3714, 'Pompeia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.769298', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3715, 'Pongai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.770243', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3716, 'Pontal', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.771057', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3717, 'Pontalinda', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.772236', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3718, 'Pontes Gestal', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.77305', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3719, 'Populina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.773915', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3720, 'Porangaba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.774851', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3721, 'Porto Feliz', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.77596', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3722, 'Porto Ferreira', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.77695', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3723, 'Potim', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.777852', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3724, 'Potirendaba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.778757', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3725, 'Pracinha', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.779736', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3726, 'Pradopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.780653', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3727, 'Praia Grande', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.781557', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3728, 'Pratania', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.782464', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3729, 'Presidente Alves', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.783493', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3730, 'Presidente Bernardes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.784379', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3731, 'Presidente Epitacio', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.785224', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3732, 'Presidente Prudente', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.786107', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3733, 'Presidente Venceslau', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.786904', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3734, 'Promissao', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.787815', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3735, 'Quadra', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.788698', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3736, 'Quata', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.789628', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3737, 'Queiroz', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.790503', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3738, 'Queluz', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.791388', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3739, 'Quintana', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.792194', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3740, 'Rafard', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.799849', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3741, 'Rancharia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.801147', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3742, 'Redencao da Serra', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.802051', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3743, 'Regente Feijo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.802929', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3744, 'Reginopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.80391', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3745, 'Registro', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.804743', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3746, 'Restinga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.80577', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3747, 'Ribeira', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.806596', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3748, 'Ribeirao Bonito', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.807499', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3749, 'Ribeirao Branco', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.808385', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3750, 'Ribeirao Corrente', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.809327', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3751, 'Ribeirao do Sul', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.810148', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3752, 'Ribeirao dos Indios', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.811033', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3753, 'Ribeirao Grande', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.811878', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3754, 'Ribeirao Pires', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.812751', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3755, 'Ribeirao Preto', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.813744', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3763, 'Riversul', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.821112', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3756, 'Rifaina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.814689', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3757, 'Rincao', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.815604', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3758, 'Rinopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.81658', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3759, 'Rio Claro', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.817501', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3760, 'Rio das Pedras', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.8183', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3761, 'Rio Grande da Serra', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.819205', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3762, 'Riolandia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.820129', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3764, 'Rosana', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.822033', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3765, 'Roseira', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.822953', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3766, 'Rubiacea', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.823779', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3767, 'Rubineia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.824722', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3768, 'Sabino', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.825716', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3769, 'Sagres', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.826657', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3770, 'Sales', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.827569', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3771, 'Sales Oliveira', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.8286', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3772, 'Salesopolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.829388', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3773, 'Salmourao', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.830267', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3774, 'Saltinho', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.831174', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3775, 'Salto', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.832063', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3776, 'Salto de Pirapora', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.832983', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3777, 'Salto Grande', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.833872', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3778, 'Sandovalina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.841128', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3779, 'Santa Adelia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.842526', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3780, 'Santa Albertina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.843562', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3781, 'Santa Barbara D''oeste', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.844486', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3782, 'Santa Branca', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.845468', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3783, 'Santa Clara D''oeste', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.846438', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3784, 'Santa Cruz da Conceicao', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.847281', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3785, 'Santa Cruz da Esperanca', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.848235', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3786, 'Santa Cruz das Palmeiras', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.849206', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3787, 'Santa Cruz do Rio Pardo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.850133', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3788, 'Santa Ernestina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.851253', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3789, 'Santa Fe do Sul', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.852223', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3790, 'Santa Gertrudes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.853156', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3791, 'Santa Isabel', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.854113', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3792, 'Santa Lucia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.854982', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3793, 'Santa Maria da Serra', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.85605', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3794, 'Santa Mercedes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.857003', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3799, 'Santana da Ponte Pensa', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.861535', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3800, 'Santana de Parnaiba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.862612', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3796, 'Santa Rita D''oeste', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.85865', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3795, 'Santa Rita do Passa Quatro', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.857824', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3797, 'Santa Rosa de Viterbo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.859396', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3798, 'Santa Salete', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.860312', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3801, 'Santo Anastacio', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.863652', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3802, 'Santo Andre', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.864564', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3803, 'Santo Antonio da Alegria', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.865523', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3804, 'Santo Antonio de Posse', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.866439', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3805, 'Santo Antonio do Aracangua', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.867468', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3806, 'Santo Antonio do Jardim', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.868427', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3807, 'Santo Antonio do Pinhal', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.869308', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3808, 'Santo Expedito', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.870137', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3809, 'Santopolis do Aguapei', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.871076', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3810, 'Santos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.872026', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3811, 'Sao Bento do Sapucai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.873071', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3812, 'Sao Bernardo do Campo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.873885', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3813, 'Sao Caetano do Sul', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.874902', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3814, 'Sao Carlos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.882174', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3815, 'Sao Francisco', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.883328', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3816, 'Sao Joao da Boa Vista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.884221', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3817, 'Sao Joao das Duas Pontes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.8851', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3818, 'Sao Joao de Iracema', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.885978', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3819, 'Sao Joao do Pau D''alho', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.886912', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3820, 'Sao Joaquim da Barra', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.88779', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3821, 'Sao Jose da Bela Vista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.888824', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3822, 'Sao Jose do Barreiro', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.889708', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3823, 'Sao Jose do Rio Pardo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.890643', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3824, 'Sao Jose do Rio Preto', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.891636', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3825, 'Sao Jose dos Campos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.892511', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3826, 'Sao Lourenco da Serra', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.893511', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3827, 'Sao Luis do Paraitinga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.89439', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3828, 'Sao Manuel', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.89529', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3829, 'Sao Miguel Arcanjo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.89607', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3830, 'Sao Paulo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.897057', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3831, 'Sao Pedro', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.898029', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3832, 'Sao Pedro do Turvo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.898933', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3833, 'Sao Roque', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.899785', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3834, 'Sao Sebastiao', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.900715', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3835, 'Sao Sebastiao da Grama', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.901548', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3836, 'Sao Simao', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.902471', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3837, 'Sao Vicente', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.903454', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3838, 'Sarapui', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.904302', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3839, 'Sarutaia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.905087', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3840, 'Sebastianopolis do Sul', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.906039', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3841, 'Serra Azul', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.907223', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3843, 'Serrana', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.908962', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3842, 'Serra Negra', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.907989', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3844, 'Sertaozinho', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.909863', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3845, 'Sete Barras', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.910813', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3846, 'Severinia', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.911767', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3847, 'Silveiras', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.912684', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3848, 'Socorro', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.913618', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3849, 'Sorocaba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.914527', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3850, 'Sud Mennucci', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.915419', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3851, 'Sumare', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.923764', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3853, 'Suzano', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.925611', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3852, 'Suzanapolis', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.924737', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3854, 'Tabapua', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.926641', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3855, 'Tabatinga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.92753', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3856, 'Taboao da Serra', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.928379', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3857, 'Taciba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.929364', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3858, 'Taguai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.930327', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3859, 'Taiacu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.931198', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3860, 'Taiuva', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.932199', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3861, 'Tambau', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.933029', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3862, 'Tanabi', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.933885', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3863, 'Tapirai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.934819', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3864, 'Tapiratiba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.935627', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3865, 'Taquaral', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.936569', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3866, 'Taquaritinga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.937462', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3867, 'Taquarituba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.938413', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3868, 'Taquarivai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.939268', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3869, 'Tarabai', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.940097', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3870, 'Taruma', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.941071', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3871, 'Tatui', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.942017', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3872, 'Taubate', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.942943', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3873, 'Tejupa', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.94383', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3874, 'Teodoro Sampaio', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.944695', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3875, 'Terra Roxa', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.945558', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3876, 'Tiete', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.946495', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3877, 'Timburi', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.94729', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3878, 'Torre de Pedra', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.948168', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3879, 'Torrinha', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.949077', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3880, 'Trabiju', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.949993', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3881, 'Tremembe', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.950947', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3882, 'Tres Fronteiras', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.951742', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3883, 'Tuiuti', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.952496', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3884, 'Tupa', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.953395', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3885, 'Tupi Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.954217', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3886, 'Turiuba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.955145', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3887, 'Turmalina', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.956025', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3888, 'Ubarana', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.957522', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3889, 'Ubatuba', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.964282', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3890, 'Ubirajara', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.965379', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3891, 'Uchoa', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.966314', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3892, 'Uniao Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.967227', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3893, 'Urania', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.968222', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3894, 'Uru', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.969163', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3895, 'Urupes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.970073', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3896, 'Valentim Gentil', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.970972', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3897, 'Valinhos', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.971951', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3898, 'Valparaiso', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.972883', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3899, 'Vargem', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.974064', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3900, 'Vargem Grande do Sul', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.974954', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3901, 'Vargem Grande Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.976387', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3902, 'Varzea Paulista', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.97738', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3903, 'Vera Cruz', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.97827', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3904, 'Vinhedo', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.979112', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3905, 'Viradouro', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.980046', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3906, 'Vista Alegre do Alto', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.980934', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3907, 'Vitoria Brasil', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.981804', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3908, 'Votorantim', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.982726', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3909, 'Votuporanga', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.983575', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3910, 'Zacarias', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.984592', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3399, 'Chavantes', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.411516', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3440, 'Estiva Gerbi', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.459826', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3911, 'Abatia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.985397', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3912, 'Adrianopolis', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.986287', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3913, 'Agudos do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.987196', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3914, 'Almirante Tamandare', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.988188', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3915, 'Altamira do Parana', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.989098', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3919, 'Altonia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.992748', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3917, 'Alto Parana', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.990938', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3918, 'Alto Piquiri', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.991839', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3920, 'Alvorada do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.99372', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3921, 'Amapora', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.99467', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3922, 'Ampere', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.995648', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3923, 'Anahy', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.996625', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3924, 'Andira', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.997681', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3925, 'Angulo', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.004728', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3926, 'Antonina', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.005854', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3927, 'Antonio Olinto', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.007012', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3928, 'Apucarana', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.007903', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3929, 'Arapongas', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.008811', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3930, 'Arapoti', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.009634', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3931, 'Arapua', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.010641', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3932, 'Araruna', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.011512', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3933, 'Araucaria', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.012356', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3934, 'Ariranha do Ivai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.013245', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3935, 'Assai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.014083', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3936, 'Assis Chateaubriand', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.014967', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3937, 'Astorga', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.015824', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3938, 'Atalaia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.016716', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3939, 'Balsa Nova', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.017615', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3940, 'Bandeirantes', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.018653', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3941, 'Barbosa Ferraz', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.019459', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3943, 'Barracao', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.021205', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3942, 'Barra do Jacare', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.020318', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3945, 'Bela Vista do Paraiso', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.023032', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3946, 'Bituruna', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.023906', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3947, 'Boa Esperanca', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.02483', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3948, 'Boa Esperanca do Iguacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.025742', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3949, 'Boa Ventura de Sao Roque', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.026662', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3950, 'Boa Vista da Aparecida', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.027576', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3951, 'Bocaiuva do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.028487', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3952, 'Bom Jesus do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.02933', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3953, 'Bom Sucesso', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.030115', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3954, 'Bom Sucesso do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.031027', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3955, 'Borrazopolis', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.031843', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3956, 'Braganey', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.032806', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3957, 'Brasilandia do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.033978', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3958, 'Cafeara', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.034819', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3959, 'Cafelandia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.03574', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3960, 'Cafezal do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.036649', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3961, 'California', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.037542', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3962, 'Cambara', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.038936', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3963, 'Cambe', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.045765', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3964, 'Cambira', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.047133', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3965, 'Campina da Lagoa', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.04815', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3966, 'Campina do Simao', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.049097', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3967, 'Campina Grande do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.050115', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3968, 'Campo Bonito', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.051104', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3969, 'Campo do Tenente', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.05197', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3970, 'Campo Largo', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.053224', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3971, 'Campo Magro', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.054079', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3972, 'Campo Mourao', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.054986', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3973, 'Candido de Abreu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.055886', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3974, 'Candoi', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.056861', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3975, 'Cantagalo', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.057749', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3976, 'Capanema', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.05867', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3977, 'Capitao Leonidas Marques', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.059635', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3978, 'Carambei', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.060504', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3979, 'Carlopolis', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.061386', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3980, 'Cascavel', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.062316', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3981, 'Castro', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.063137', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3982, 'Catanduvas', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.064188', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3983, 'Centenario do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.065187', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3984, 'Cerro Azul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.066246', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3985, 'Ceu Azul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.06723', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3986, 'Chopinzinho', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.068245', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3987, 'Cianorte', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.069317', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3988, 'Cidade Gaucha', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.070245', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3989, 'Clevelandia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.071239', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3990, 'Colombo', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.072161', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3991, 'Colorado', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.073279', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3992, 'Congonhinhas', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.074223', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3993, 'Conselheiro Mairinck', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.075146', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3994, 'Contenda', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.07629', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3995, 'Corbelia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.077225', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3996, 'Cornelio Procopio', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.078202', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3997, 'Coronel Domingos Soares', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.079407', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3998, 'Coronel Vivida', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.086559', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3999, 'Corumbatai do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.087675', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4001, 'Cruzeiro do Iguacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.089408', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4002, 'Cruzeiro do Oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.090379', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4003, 'Cruzeiro do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.09129', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4000, 'Cruz Machado', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.088592', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4004, 'Cruzmaltina', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.092294', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4005, 'Curitiba', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.093188', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4006, 'Curiuva', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.094161', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4007, 'Diamante do Norte', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.095041', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4008, 'Diamante do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.096391', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4009, 'Diamante D''oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.097438', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4010, 'Dois Vizinhos', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.098274', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4011, 'Douradina', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.099183', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4012, 'Doutor Camargo', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.100098', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4014, 'Eneas Marques', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.10187', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4015, 'Engenheiro Beltrao', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.102709', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4017, 'Esperanca Nova', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.104368', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4016, 'Entre Rios do Oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.103512', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4018, 'Espigao Alto do Iguacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.105422', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4019, 'Farol', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.106399', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4020, 'Faxinal', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.107374', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4021, 'Fazenda Rio Grande', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.108241', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4022, 'Fenix', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.109288', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4023, 'Fernandes Pinheiro', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.110161', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4024, 'Figueira', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.111065', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4026, 'Florai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.112881', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4025, 'Flor da Serra do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.111977', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4027, 'Floresta', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.113867', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4028, 'Florestopolis', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.114779', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4029, 'Florida', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.115752', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4030, 'Formosa do Oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.116721', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4031, 'Foz do Iguacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.117707', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4033, 'Francisco Alves', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.119613', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4034, 'Francisco Beltrao', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.120558', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4032, 'Foz do Jordao', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.118639', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4035, 'General Carneiro', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.127423', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4036, 'Godoy Moreira', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.128645', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4038, 'Goioxim', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.13055', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4039, 'Grandes Rios', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.131638', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4040, 'Guaira', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.13242', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4041, 'Guairaca', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.133372', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4042, 'Guamiranga', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.134252', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4043, 'Guapirama', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.135191', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4044, 'Guaporema', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.136151', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4045, 'Guaraci', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.137079', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4046, 'Guaraniacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.138006', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4047, 'Guarapuava', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.138945', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4048, 'Guaraquecaba', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.139847', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4049, 'Guaratuba', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.140817', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4050, 'Honorio Serpa', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.141648', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4051, 'Ibaiti', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.142752', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4052, 'Ibema', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.143584', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4053, 'Ibipora', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.14439', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4054, 'Icaraima', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.145266', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4055, 'Iguaracu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.146086', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4056, 'Iguatu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.146981', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4057, 'Imbau', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.147856', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4058, 'Imbituva', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.148856', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4059, 'Inacio Martins', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.149748', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4060, 'Inaja', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.150609', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4061, 'Indianopolis', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.151462', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4062, 'Ipiranga', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.15233', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4063, 'Ipora', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.153244', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4064, 'Iracema do Oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.154171', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4065, 'Irati', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.155067', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4066, 'Iretama', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.155943', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4067, 'Itaguaje', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.156929', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4068, 'Itaipulandia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.157878', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4069, 'Itambaraca', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.158813', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4070, 'Itambe', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.159654', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4071, 'Itapejara D''oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.160601', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4072, 'Itaperucu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.161482', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4073, 'Itauna do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.162479', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4074, 'Ivai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.173191', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4075, 'Ivaipora', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.174405', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4076, 'Ivate', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.175489', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4077, 'Ivatuba', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.176411', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4078, 'Jaboti', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.177343', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4079, 'Jacarezinho', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.178223', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4080, 'Jaguapita', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.17908', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4081, 'Jaguariaiva', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.179969', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4082, 'Jandaia do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.180921', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4083, 'Janiopolis', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.181768', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4084, 'Japira', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.182695', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4085, 'Japura', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.183595', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4086, 'Jardim Alegre', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.184551', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4087, 'Jardim Olinda', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.185484', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4088, 'Jataizinho', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.186508', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4089, 'Jesuitas', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.187505', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4090, 'Joaquim Tavora', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.188472', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4091, 'Jundiai do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.189369', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4092, 'Juranda', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.190237', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4093, 'Jussara', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.191189', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4094, 'Kalore', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.192042', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4095, 'Lapa', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.192994', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4096, 'Laranjal', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.193967', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4097, 'Laranjeiras do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.194892', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4098, 'Leopolis', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.195946', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4099, 'Lidianopolis', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.196969', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4100, 'Lindoeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.197979', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4101, 'Loanda', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.198786', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4102, 'Lobato', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.199695', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4103, 'Londrina', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.200588', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4104, 'Luiziana', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.2014', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4105, 'Lunardelli', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.202191', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4106, 'Lupionopolis', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.203083', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4107, 'Mallet', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.204071', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4108, 'Mambore', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.205131', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4109, 'Mandaguacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.206396', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4110, 'Mandaguari', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.207255', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4111, 'Mandirituba', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.213506', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4112, 'Manfrinopolis', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.214574', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4113, 'Mangueirinha', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.21538', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4114, 'Manoel Ribas', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.216194', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4115, 'Marechal Candido Rondon', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.217021', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4116, 'Maria Helena', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.217924', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4117, 'Marialva', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.218808', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4118, 'Marilandia do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.219675', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4119, 'Marilena', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.221127', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4120, 'Mariluz', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.22202', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4121, 'Maringa', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.222938', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4122, 'Mariopolis', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.223854', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4123, 'Maripa', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.224672', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4124, 'Marmeleiro', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.22564', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4125, 'Marquinho', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.22658', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4126, 'Marumbi', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.227421', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4127, 'Matelandia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.228228', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4128, 'Matinhos', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.229194', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4129, 'Mato Rico', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.230144', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4130, 'Maua da Serra', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.231029', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4131, 'Medianeira', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.232254', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4132, 'Mercedes', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.233069', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4133, 'Mirador', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.233941', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4134, 'Miraselva', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.234818', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4135, 'Missal', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.23558', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4136, 'Moreira Sales', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.236433', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4137, 'Morretes', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.237286', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4138, 'Munhoz de Melo', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.238297', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4139, 'Nossa Senhora das Gracas', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.239216', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4140, 'Nova Alianca do Ivai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.240118', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4141, 'Nova America da Colina', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.240981', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4142, 'Nova Aurora', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.24191', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4143, 'Nova Cantu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.242841', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4144, 'Nova Esperanca', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.243604', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4145, 'Nova Esperanca do Sudoeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.244503', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4146, 'Nova Fatima', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.24551', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4147, 'Nova Laranjeiras', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.246408', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4148, 'Nova Londrina', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.247175', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4149, 'Nova Olimpia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.254111', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4151, 'Nova Santa Barbara', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.256208', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4152, 'Nova Santa Rosa', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.257126', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4150, 'Nova Prata do Iguacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.255272', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4153, 'Nova Tebas', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.258244', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4154, 'Novo Itacolomi', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.259008', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4155, 'Ortigueira', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.259923', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4156, 'Ourizona', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.260801', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4157, 'Ouro Verde do Oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.261512', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4158, 'Paicandu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.262398', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4159, 'Palmas', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.263241', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4160, 'Palmeira', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.264126', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4161, 'Palmital', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.264963', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4162, 'Palotina', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.265805', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4163, 'Paraiso do Norte', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.266633', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4164, 'Paranacity', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.267515', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4165, 'Paranagua', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.268404', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4166, 'Paranapoema', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.269214', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4167, 'Paranavai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.270026', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4168, 'Pato Bragado', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.27079', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4169, 'Pato Branco', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.271724', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4170, 'Paula Freitas', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.272627', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4171, 'Paulo Frontin', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.273639', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4172, 'Peabiru', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.274646', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4173, 'Perobal', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.275641', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4174, 'Perola', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.276605', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4175, 'Perola D''oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.277426', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4176, 'Pien', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.278261', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4177, 'Pinhais', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.279077', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4179, 'Pinhalao', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.280779', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4178, 'Pinhal de Sao Bento', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.279898', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4180, 'Pinhao', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.281602', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4181, 'Pirai do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.282487', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4182, 'Piraquara', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.283295', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4183, 'Pitanga', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.2841', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4184, 'Pitangueiras', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.285074', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4185, 'Planaltina do Parana', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.28605', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4186, 'Planalto', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.286973', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4187, 'Ponta Grossa', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.287832', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4188, 'Pontal do Parana', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.294545', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4189, 'Porecatu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.295833', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4190, 'Porto Amazonas', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.296693', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4191, 'Porto Barreiro', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.297591', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4192, 'Porto Rico', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.298581', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4193, 'Porto Vitoria', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.299373', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4194, 'Prado Ferreira', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.300209', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4195, 'Pranchita', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.301016', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4196, 'Presidente Castelo Branco', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.301937', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4197, 'Primeiro de Maio', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.30282', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4198, 'Prudentopolis', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.303849', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4199, 'Quarto Centenario', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.304786', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4200, 'Quatigua', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.305711', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4201, 'Quatro Barras', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.306515', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4202, 'Quatro Pontes', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.307399', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4203, 'Quedas do Iguacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.308241', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4204, 'Querencia do Norte', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.309072', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4205, 'Quinta do Sol', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.31021', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4206, 'Quitandinha', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.311014', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4207, 'Ramilandia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.3117', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4208, 'Rancho Alegre', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.312592', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4209, 'Rancho Alegre D''oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.313489', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4210, 'Realeza', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.314376', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4211, 'Reboucas', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.315317', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4212, 'Renascenca', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.316337', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4213, 'Reserva', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.317368', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4214, 'Reserva do Iguacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.318231', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4215, 'Ribeirao Claro', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.31911', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4216, 'Ribeirao do Pinhal', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.319989', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4217, 'Rio Azul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.320821', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4218, 'Rio Bom', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.32181', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4219, 'Rio Bonito do Iguacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.322764', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4220, 'Rio Branco do Ivai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.323713', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4221, 'Rio Branco do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.324646', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4222, 'Rio Negro', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.325554', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4223, 'Rolandia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.326432', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4224, 'Roncador', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.327306', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4225, 'Rondon', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.328245', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4226, 'Rosario do Ivai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.338376', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4227, 'Sabaudia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.339508', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4228, 'Salgado Filho', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.34043', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4229, 'Salto do Itarare', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.341281', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4230, 'Salto do Lontra', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.342375', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4231, 'Santa Amelia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.343545', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4232, 'Santa Cecilia do Pavao', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.344438', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4233, 'Santa Cruz de Monte Castelo', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.345319', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4234, 'Santa Fe', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.346188', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4235, 'Santa Helena', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.347091', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4236, 'Santa Ines', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.347973', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4237, 'Santa Isabel do Ivai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.348934', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4238, 'Santa Izabel do Oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.349861', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4239, 'Santa Lucia', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.350735', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4240, 'Santa Maria do Oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.351637', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4241, 'Santa Mariana', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.352468', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4242, 'Santa Monica', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.353319', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4245, 'Santana do Itarare', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.355964', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4243, 'Santa Tereza do Oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.35425', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4244, 'Santa Terezinha de Itaipu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.355024', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4246, 'Santo Antonio da Platina', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.356885', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4247, 'Santo Antonio do Caiua', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.357831', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4248, 'Santo Antonio do Paraiso', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.358771', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4249, 'Santo Antonio do Sudoeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.359666', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4250, 'Santo Inacio', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.360623', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4251, 'Sao Carlos do Ivai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.361502', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4252, 'Sao Jeronimo da Serra', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.362324', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4253, 'Sao Joao', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.363192', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4254, 'Sao Joao do Caiua', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.364281', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4255, 'Sao Joao do Ivai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.365215', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4256, 'Sao Joao do Triunfo', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.366215', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4259, 'Sao Jorge D''oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.368953', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4257, 'Sao Jorge do Ivai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.367092', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4258, 'Sao Jorge do Patrocinio', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.368034', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4260, 'Sao Jose da Boa Vista', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.369834', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4261, 'Sao Jose das Palmeiras', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.370542', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4262, 'Sao Jose dos Pinhais', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.371509', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4263, 'Sao Manoel do Parana', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.372312', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4264, 'Sao Mateus do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.37923', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4265, 'Sao Miguel do Iguacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.380624', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4266, 'Sao Pedro do Iguacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.381553', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4267, 'Sao Pedro do Ivai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.382512', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4268, 'Sao Pedro do Parana', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.383505', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4269, 'Sao Sebastiao da Amoreira', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.384423', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4270, 'Sao Tome', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.38532', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4271, 'Sapopema', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.386212', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4272, 'Sarandi', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.38714', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4273, 'Saudade do Iguacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.388048', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4274, 'Senges', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.388983', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4275, 'Serranopolis do Iguacu', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.389954', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4276, 'Sertaneja', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.390851', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4277, 'Sertanopolis', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.391827', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4278, 'Siqueira Campos', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.392833', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4279, 'Sulina', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.393627', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4280, 'Tamarana', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.394497', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4281, 'Tamboara', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.395464', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4282, 'Tapejara', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.396622', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4283, 'Tapira', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.397553', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4284, 'Teixeira Soares', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.398411', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4285, 'Telemaco Borba', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.399685', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4286, 'Terra Boa', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.400592', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4287, 'Terra Rica', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.401465', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4288, 'Terra Roxa', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.402543', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4289, 'Tibagi', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.403763', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4290, 'Tijucas do Sul', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.404751', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4291, 'Toledo', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.405658', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4292, 'Tomazina', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.406592', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4293, 'Tres Barras do Parana', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.407465', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4294, 'Tunas do Parana', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.408366', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4295, 'Tuneiras do Oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.409234', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4296, 'Tupassi', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.41021', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4297, 'Turvo', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.410984', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4298, 'Ubirata', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.411853', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4299, 'Umuarama', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.412765', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4300, 'Uniao da Vitoria', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.413578', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4301, 'Uniflor', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.42009', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4302, 'Urai', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.421232', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4308, 'Wenceslau Braz', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.426895', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4303, 'Ventania', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.422122', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4304, 'Vera Cruz do Oeste', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.422901', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4305, 'Vere', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.423951', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (3916, 'Alto Paraiso', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.99001', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4013, 'Doutor Ulysses', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.100967', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4306, 'Virmond', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.424896', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4307, 'Vitorino', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.425982', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4309, 'Xambre', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.427805', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4310, 'Abdon Batista', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.428638', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4311, 'Abelardo Luz', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.429547', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4312, 'Agrolandia', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.430478', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4313, 'Agronomica', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.431358', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4314, 'Agua Doce', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.43226', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4315, 'Aguas de Chapeco', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.433055', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4316, 'Aguas Frias', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.43394', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4317, 'Aguas Mornas', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.434905', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4318, 'Alfredo Wagner', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.435771', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4319, 'Alto Bela Vista', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.43669', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4320, 'Anchieta', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.43753', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4321, 'Angelina', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.43846', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4322, 'Anita Garibaldi', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.439314', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4323, 'Anitapolis', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.440162', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4324, 'Antonio Carlos', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.440943', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4325, 'Apiuna', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.441712', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4326, 'Arabuta', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.442617', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4327, 'Araquari', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.44364', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4328, 'Ararangua', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.444439', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4329, 'Armazem', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.445254', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4330, 'Arroio Trinta', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.446176', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4331, 'Arvoredo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.447106', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4332, 'Ascurra', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.44797', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4333, 'Atalanta', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.448887', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4334, 'Aurora', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.449795', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4335, 'Balneario Arroio do Silva', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.450698', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4337, 'Balneario Camboriu', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.45249', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4336, 'Balneario Barra do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.451594', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4338, 'Balneario Gaivota', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.453461', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4339, 'Bandeirante', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.460344', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4340, 'Barra Bonita', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.461537', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4341, 'Barra Velha', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.462448', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4342, 'Bela Vista do Toldo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.463399', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4343, 'Belmonte', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.464282', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4344, 'Benedito Novo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.465195', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4345, 'Biguacu', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.466322', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4346, 'Blumenau', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.467185', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4347, 'Bocaina do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.468115', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4352, 'Bombinhas', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.472717', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4348, 'Bom Jardim da Serra', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.469091', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4349, 'Bom Jesus', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.469971', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4350, 'Bom Jesus do Oeste', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.470938', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4351, 'Bom Retiro', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.471851', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4353, 'Botuvera', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.473586', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4354, 'Braco do Norte', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.474511', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4355, 'Braco do Trombudo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.47539', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4356, 'Brunopolis', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.476535', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4357, 'Brusque', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.477593', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4358, 'Cacador', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.478494', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4359, 'Caibi', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.479391', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4360, 'Calmon', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.480305', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4361, 'Camboriu', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.481266', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4368, 'Capao Alto', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.488426', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4362, 'Campo Alegre', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.482024', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4363, 'Campo Belo do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.483299', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4364, 'Campo Ere', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.484528', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4365, 'Campos Novos', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.48539', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4366, 'Canelinha', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.486284', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4367, 'Canoinhas', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.487206', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4369, 'Capinzal', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.489197', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4370, 'Capivari de Baixo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.490106', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4371, 'Catanduvas', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.491025', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4372, 'Caxambu do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.491954', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4373, 'Celso Ramos', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.492847', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4374, 'Cerro Negro', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.493856', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4375, 'Chapadao do Lageado', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.500523', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4376, 'Chapeco', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.501768', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4377, 'Cocal do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.502784', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4378, 'Concordia', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.50375', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4379, 'Cordilheira Alta', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.504637', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4380, 'Coronel Freitas', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.50575', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4381, 'Coronel Martins', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.506666', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4383, 'Corupa', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.508452', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4382, 'Correia Pinto', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.507531', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4384, 'Criciuma', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.509451', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4385, 'Cunha Pora', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.510481', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4386, 'Cunhatai', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.511334', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4387, 'Curitibanos', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.512194', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4388, 'Descanso', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.513047', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4389, 'Dionisio Cerqueira', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.513922', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4390, 'Dona Emma', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.514778', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4391, 'Doutor Pedrinho', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.515649', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4392, 'Entre Rios', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.516534', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4393, 'Ermo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.517512', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4394, 'Erval Velho', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.518414', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4395, 'Faxinal dos Guedes', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.519319', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4396, 'Flor do Sertao', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.520213', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4397, 'Florianopolis', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.521114', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4398, 'Formosa do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.522109', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4399, 'Forquilhinha', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.523012', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4400, 'Fraiburgo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.523979', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4401, 'Frei Rogerio', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.524846', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4402, 'Galvao', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.525743', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4403, 'Garopaba', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.526646', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4404, 'Garuva', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.527531', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4405, 'Gaspar', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.528459', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4406, 'Governador Celso Ramos', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.529386', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4407, 'Grao Para', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.530212', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4408, 'Gravatal', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.531116', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4409, 'Guabiruba', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.53194', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4410, 'Guaraciaba', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.532863', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4411, 'Guaramirim', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.533779', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4412, 'Guaruja do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.535074', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4413, 'Guatambu', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.541376', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4414, 'Herval D''oeste', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.542596', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4415, 'Ibiam', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.543705', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4416, 'Ibicare', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.544411', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4417, 'Ibirama', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.54531', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4418, 'Icara', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.546167', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4419, 'Ilhota', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.546952', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4420, 'Imarui', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.547891', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4421, 'Imbituba', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.548745', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4422, 'Imbuia', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.549615', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4423, 'Indaial', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.550745', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4424, 'Iomere', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.551707', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4425, 'Ipira', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.552628', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4426, 'Ipora do Oeste', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.553489', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4427, 'Ipuacu', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.554353', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4428, 'Ipumirim', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.555764', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4429, 'Iraceminha', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.556864', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4430, 'Irani', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.557716', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4431, 'Irati', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.558657', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4432, 'Irineopolis', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.559588', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4433, 'Ita', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.56052', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4434, 'Itaiopolis', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.5614', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4435, 'Itajai', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.562258', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4436, 'Itapema', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.563129', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4437, 'Itapiranga', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.564104', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4438, 'Itapoa', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.565082', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4439, 'Ituporanga', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.566056', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4440, 'Jabora', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.566836', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4441, 'Jacinto Machado', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.567842', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4442, 'Jaguaruna', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.568806', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4443, 'Jaragua do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.569621', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4444, 'Jardinopolis', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.570517', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4445, 'Joacaba', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.571308', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4446, 'Joinville', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.572209', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4447, 'Jose Boiteux', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.573179', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4448, 'Jupia', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.574057', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4449, 'Lacerdopolis', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.574936', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4450, 'Lages', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.581911', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4451, 'Laguna', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.583305', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4452, 'Lajeado Grande', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.584135', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4453, 'Laurentino', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.584973', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4454, 'Lauro Muller', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.585797', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4455, 'Lebon Regis', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.586737', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4456, 'Leoberto Leal', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.587727', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4457, 'Lindoia do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.589095', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4458, 'Lontras', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.590019', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4459, 'Luiz Alves', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.590917', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4460, 'Luzerna', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.591816', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4461, 'Macieira', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.592688', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4462, 'Mafra', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.593594', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4463, 'Major Gercino', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.594511', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4464, 'Major Vieira', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.595378', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4465, 'Maracaja', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.59623', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4466, 'Maravilha', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.597301', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4467, 'Marema', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.598234', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4468, 'Massaranduba', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.59912', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4469, 'Matos Costa', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.600611', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4470, 'Meleiro', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.601584', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4471, 'Mirim Doce', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.602525', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4472, 'Modelo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.603369', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4473, 'Mondai', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.604263', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4474, 'Monte Carlo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.605228', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4475, 'Monte Castelo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.606147', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4476, 'Morro da Fumaca', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.607036', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4477, 'Morro Grande', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.607994', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4478, 'Navegantes', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.608914', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4479, 'Nova Erechim', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.60984', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4480, 'Nova Itaberaba', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.610808', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4481, 'Nova Trento', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.611579', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4482, 'Nova Veneza', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.612402', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4483, 'Novo Horizonte', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.61326', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4484, 'Orleans', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.614203', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4485, 'Otacilio Costa', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.615091', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4486, 'Ouro', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.615915', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4487, 'Ouro Verde', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.622292', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4488, 'Paial', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.624172', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4489, 'Painel', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.625092', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4490, 'Palhoca', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.625997', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4491, 'Palma Sola', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.626836', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4492, 'Palmeira', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.627753', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4493, 'Palmitos', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.628577', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4494, 'Papanduva', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.629483', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4495, 'Paraiso', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.630489', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4496, 'Passo de Torres', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.631393', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4497, 'Passos Maia', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.632217', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4498, 'Paulo Lopes', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.633094', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4499, 'Pedras Grandes', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.634126', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4500, 'Penha', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.635075', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4501, 'Peritiba', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.635905', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4502, 'Petrolandia', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.636576', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4503, 'Picarras', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.637358', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4504, 'Pinhalzinho', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.638178', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4505, 'Pinheiro Preto', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.639052', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4506, 'Piratuba', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.640027', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4507, 'Planalto Alegre', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.640907', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4508, 'Pomerode', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.641749', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4509, 'Ponte Alta', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.642696', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4510, 'Ponte Alta do Norte', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.643679', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4511, 'Ponte Serrada', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.644826', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4512, 'Porto Belo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.645727', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4513, 'Porto Uniao', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.646532', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4514, 'Pouso Redondo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.647333', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4515, 'Praia Grande', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.648213', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4516, 'Presidente Castello Branco', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.64913', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4517, 'Presidente Getulio', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.650041', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4518, 'Presidente Nereu', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.650912', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4519, 'Princesa', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.651836', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4520, 'Quilombo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.65283', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4521, 'Rancho Queimado', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.65372', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4522, 'Rio das Antas', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.654634', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4523, 'Rio do Campo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.65549', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4524, 'Rio do Oeste', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.656406', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4526, 'Rio dos Cedros', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.664346', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4525, 'Rio do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.663037', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4527, 'Rio Fortuna', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.665268', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4528, 'Rio Negrinho', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.666145', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4529, 'Rio Rufino', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.667136', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4530, 'Riqueza', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.667883', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4531, 'Rodeio', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.668722', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4532, 'Romelandia', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.669664', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4533, 'Salete', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.670537', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4534, 'Saltinho', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.671426', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4535, 'Salto Veloso', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.672315', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4536, 'Sangao', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.67311', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4537, 'Santa Cecilia', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.674081', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4538, 'Santa Helena', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.674964', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4539, 'Santa Rosa de Lima', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.675907', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4540, 'Santa Rosa do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.676772', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4541, 'Santa Terezinha', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.677855', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4542, 'Santa Terezinha do Progresso', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.678617', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4543, 'Santiago do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.679531', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4544, 'Santo Amaro da Imperatriz', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.680401', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4546, 'Sao Bernardino', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.682107', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4545, 'Sao Bento do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.681233', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4547, 'Sao Bonifacio', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.683118', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4548, 'Sao Carlos', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.683978', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4549, 'Sao Cristovao do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.684896', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4550, 'Sao Domingos', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.685665', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4551, 'Sao Francisco do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.686536', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4554, 'Sao Joao do Oeste', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.689546', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4552, 'Sao Joao Batista', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.687673', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4553, 'Sao Joao do Itaperiu', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.688602', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4555, 'Sao Joao do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.690449', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4556, 'Sao Joaquim', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.691291', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4557, 'Sao Jose', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.692211', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4558, 'Sao Jose do Cedro', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.693112', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4559, 'Sao Jose do Cerrito', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.694047', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4560, 'Sao Lourenco do Oeste', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.694964', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4561, 'Sao Ludgero', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.695892', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4562, 'Sao Martinho', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.696805', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4563, 'Sao Miguel da Boa Vista', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.704183', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4564, 'Sao Miguel do Oeste', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.705337', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4565, 'Sao Pedro de Alcantara', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.706219', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4566, 'Saudades', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.707271', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4567, 'Schroeder', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.708028', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4568, 'Seara', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.70891', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4569, 'Serra Alta', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.709735', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4570, 'Sideropolis', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.710532', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4571, 'Sombrio', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.711816', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4572, 'Sul Brasil', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.712836', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4573, 'Taio', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.713717', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4574, 'Tangara', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.714564', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4575, 'Tigrinhos', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.715422', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4576, 'Tijucas', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.716342', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4577, 'Timbe do Sul', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.717364', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4578, 'Timbo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.718247', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4579, 'Timbo Grande', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.719183', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4580, 'Tres Barras', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.720092', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4581, 'Treviso', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.720922', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4582, 'Treze de Maio', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.72182', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4583, 'Treze Tilias', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.723155', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4584, 'Trombudo Central', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.724091', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4585, 'Tubarao', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.725008', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4586, 'Tunapolis', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.725919', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4587, 'Turvo', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.726812', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4588, 'Uniao do Oeste', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.727766', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4589, 'Urubici', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.728589', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4590, 'Urupema', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.729355', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4591, 'Urussanga', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.730223', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4592, 'Vargeao', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.731004', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4593, 'Vargem', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.73178', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4594, 'Vargem Bonita', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.732992', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4595, 'Vidal Ramos', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.734534', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4596, 'Videira', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.735701', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4597, 'Vitor Meireles', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.736573', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4598, 'Witmarsum', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.73748', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4599, 'Xanxere', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.738315', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4600, 'Xavantina', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.744776', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4601, 'Xaxim', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.745932', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4602, 'Zortea', 'SC', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.746831', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4603, 'Acegua', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.747752', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4604, 'Agua Santa', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.748623', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4605, 'Agudo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.749535', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4606, 'Ajuricaba', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.750335', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4607, 'Alecrim', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.751293', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4608, 'Alegrete', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.75216', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4609, 'Alegria', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.752979', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4610, 'Almirante Tamandare do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.75392', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4611, 'Alpestre', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.754809', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4612, 'Alto Alegre', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.755767', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4613, 'Alto Feliz', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.756681', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4614, 'Alvorada', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.75756', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4615, 'Amaral Ferrador', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.758517', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4616, 'Ametista do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.759328', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4617, 'Andre da Rocha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.760208', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4618, 'Anta Gorda', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.760999', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4619, 'Antonio Prado', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.76193', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4620, 'Arambare', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.763109', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4621, 'Ararica', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.76479', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4622, 'Aratiba', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.765569', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4623, 'Arroio do Meio', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.766691', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4625, 'Arroio do Sal', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.768531', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4624, 'Arroio do Padre', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.767588', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4627, 'Arroio dos Ratos', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.770348', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4626, 'Arroio do Tigre', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.769457', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4628, 'Arroio Grande', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.771225', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4629, 'Arvorezinha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.772101', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4630, 'Augusto Pestana', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.772977', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4631, 'Aurea', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.773902', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4632, 'Bage', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.774733', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4633, 'Balneario Pinhal', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.775604', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4634, 'Barao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.776395', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4635, 'Barao de Cotegipe', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.777163', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4636, 'Barao do Triunfo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.778243', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4642, 'Barracao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.789888', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4637, 'Barra do Guarita', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.784613', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4638, 'Barra do Quarai', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.786135', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4639, 'Barra do Ribeiro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.787083', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4640, 'Barra do Rio Azul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.787963', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4641, 'Barra Funda', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.788957', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4643, 'Barros Cassal', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.790848', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4644, 'Benjamin Constant do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.791749', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4645, 'Bento Goncalves', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.792666', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4646, 'Boa Vista das Missoes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.793467', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4647, 'Boa Vista do Burica', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.794351', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4648, 'Boa Vista do Cadeado', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.795209', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4649, 'Boa Vista do Incra', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.79609', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4650, 'Boa Vista do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.796974', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4651, 'Bom Jesus', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.797947', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4652, 'Bom Principio', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.799093', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4653, 'Bom Progresso', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.80005', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4654, 'Bom Retiro do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.800999', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4655, 'Boqueirao do Leao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.801898', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4656, 'Bossoroca', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.802916', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4657, 'Bozano', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.803916', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4658, 'Braga', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.804862', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4659, 'Brochier', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.805735', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4660, 'Butia', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.806615', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4661, 'Cacapava do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.807519', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4662, 'Cacequi', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.808337', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4663, 'Cachoeira do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.809202', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4664, 'Cachoeirinha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.810127', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4665, 'Cacique Doble', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.811004', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4666, 'Caibate', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.812204', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4667, 'Caicara', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.813081', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4668, 'Camaqua', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.813986', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4669, 'Camargo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.814864', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4670, 'Cambara do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.815791', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4671, 'Campestre da Serra', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.816669', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4672, 'Campina das Missoes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.817629', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4673, 'Campinas do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.818566', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4674, 'Campo Bom', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.819422', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4675, 'Campo Novo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.825975', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4676, 'Campos Borges', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.827145', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4677, 'Candelaria', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.828029', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4678, 'Candido Godoi', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.828872', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4679, 'Candiota', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.829693', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4680, 'Canela', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.830636', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4681, 'Cangucu', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.831498', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4682, 'Canoas', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.8323', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4683, 'Canudos do Vale', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.833266', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4684, 'Capao Bonito do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.834669', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4685, 'Capao da Canoa', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.835592', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4686, 'Capao do Cipo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.836576', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4687, 'Capao do Leao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.83748', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4690, 'Capivari do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.840285', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4688, 'Capela de Santana', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.838512', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4689, 'Capitao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.839442', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4692, 'Carazinho', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.842067', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4691, 'Caraa', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.841208', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4693, 'Carlos Barbosa', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.842932', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4694, 'Carlos Gomes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.843835', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4695, 'Casca', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.844744', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4696, 'Caseiros', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.845669', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4697, 'Catuipe', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.846536', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4698, 'Caxias do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.847409', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4699, 'Centenario', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.848283', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4700, 'Cerrito', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.849096', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4701, 'Cerro Branco', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.849907', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4702, 'Cerro Grande', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.850689', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4703, 'Cerro Grande do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.851567', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4704, 'Cerro Largo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.852471', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4705, 'Chapada', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.853292', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4706, 'Charqueadas', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.854176', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4707, 'Charrua', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.855027', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4708, 'Chiapeta', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.85595', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4709, 'Chui', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.856725', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4710, 'Chuvisca', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.857603', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4711, 'Cidreira', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.85851', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4712, 'Ciriaco', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.859474', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4713, 'Colinas', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.866184', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4714, 'Colorado', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.86748', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4715, 'Condor', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.868275', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4716, 'Constantina', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.869145', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4717, 'Coqueiro Baixo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.870084', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4718, 'Coqueiros do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.87097', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4719, 'Coronel Barros', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.871889', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4720, 'Coronel Bicaco', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.872786', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4721, 'Coronel Pilar', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.873768', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4722, 'Cotipora', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.874553', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4723, 'Coxilha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.875317', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4724, 'Crissiumal', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.876204', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4725, 'Cristal', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.877062', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4726, 'Cristal do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.877944', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4727, 'Cruz Alta', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.879136', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4728, 'Cruzaltense', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.88005', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4729, 'Cruzeiro do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.880928', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4730, 'David Canabarro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.881777', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4731, 'Derrubadas', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.882651', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4732, 'Dezesseis de Novembro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.883767', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4733, 'Dilermando de Aguiar', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.884831', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4734, 'Dois Irmaos', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.885678', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4735, 'Dois Irmaos das Missoes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.886822', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4736, 'Dois Lajeados', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.887804', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4737, 'Dom Feliciano', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.889073', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4739, 'Dom Pedro de Alcantara', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.891631', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4738, 'Dom Pedrito', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.890589', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4740, 'Dona Francisca', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.892557', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4741, 'Doutor Mauricio Cardoso', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.893417', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4742, 'Doutor Ricardo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.894387', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4743, 'Eldorado do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.895258', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4744, 'Encantado', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.896204', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4745, 'Encruzilhada do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.89707', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4746, 'Engenho Velho', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.898021', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4748, 'Entre-ijuis', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.899999', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4747, 'Entre Rios do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.899076', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4749, 'Erebango', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.906919', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4750, 'Erechim', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.908132', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4751, 'Ernestina', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.909116', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4793, 'Herval', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.952112', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4752, 'Erval Grande', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.910038', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4753, 'Erval Seco', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.910899', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4754, 'Esmeralda', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.91172', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4755, 'Esperanca do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.912737', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4756, 'Espumoso', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.913602', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4757, 'Estacao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.914491', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4758, 'Estancia Velha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.915345', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4759, 'Esteio', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.916206', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4760, 'Estrela', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.917135', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4761, 'Estrela Velha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.918019', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4762, 'Eugenio de Castro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.918923', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4763, 'Fagundes Varela', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.919878', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4764, 'Farroupilha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.920693', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4765, 'Faxinal do Soturno', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.92163', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4766, 'Faxinalzinho', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.922524', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4767, 'Fazenda Vilanova', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.923302', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4768, 'Feliz', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.924228', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4769, 'Flores da Cunha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.925172', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4770, 'Floriano Peixoto', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.926129', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4771, 'Fontoura Xavier', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.927051', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4772, 'Formigueiro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.928008', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4773, 'Forquetinha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.928929', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4774, 'Fortaleza dos Valos', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.929825', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4775, 'Frederico Westphalen', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.93063', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4776, 'Garibaldi', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.931355', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4777, 'Garruchos', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.932182', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4778, 'Gaurama', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.933069', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4779, 'General Camara', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.934026', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4780, 'Gentil', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.934915', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4781, 'Getulio Vargas', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.935839', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4782, 'Girua', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.936719', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4783, 'Glorinha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.937632', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4784, 'Gramado', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.938533', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4785, 'Gramado dos Loureiros', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.939344', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4786, 'Gramado Xavier', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.940203', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4787, 'Gravatai', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.941029', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4788, 'Guabiju', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.947441', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4789, 'Guaiba', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.9486', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4790, 'Guapore', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.949507', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4791, 'Guarani das Missoes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.950373', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4792, 'Harmonia', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.951225', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4794, 'Herveiras', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.953031', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4795, 'Horizontina', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.953898', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4796, 'Hulha Negra', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.954845', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4797, 'Humaita', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.955805', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4798, 'Ibarama', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.95672', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4799, 'Ibiaca', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.957546', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4800, 'Ibiraiaras', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.958417', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4801, 'Ibirapuita', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.959294', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4802, 'Ibiruba', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.96032', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4803, 'Igrejinha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.96119', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4804, 'Ijui', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.96206', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4805, 'Ilopolis', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.962987', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4806, 'Imbe', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.963785', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4807, 'Imigrante', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.965082', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4808, 'Independencia', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.96594', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4809, 'Inhacora', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.966873', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4810, 'Ipe', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.967679', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4811, 'Ipiranga do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.968588', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4812, 'Irai', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.969396', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4813, 'Itaara', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.970351', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4814, 'Itacurubi', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.971294', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4815, 'Itapuca', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.972165', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4816, 'Itaqui', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.973061', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4817, 'Itati', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.974002', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4818, 'Itatiba do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.974873', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4819, 'Ivora', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.975784', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4820, 'Ivoti', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.976642', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4821, 'Jaboticaba', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.977503', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4822, 'Jacuizinho', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.978423', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4823, 'Jacutinga', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.979538', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4824, 'Jaguarao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.980338', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4825, 'Jaguari', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.981152', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4826, 'Jaquirana', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.987939', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4827, 'Jari', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.989393', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4828, 'Joia', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.990672', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4829, 'Julio de Castilhos', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.991636', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4830, 'Lagoa Bonita do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.992696', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4833, 'Lagoao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.995228', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4831, 'Lagoa dos Tres Cantos', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.993546', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4832, 'Lagoa Vermelha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.99444', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4834, 'Lajeado', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.996115', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4835, 'Lajeado do Bugre', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.996989', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4836, 'Lavras do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.998102', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4837, 'Liberato Salzano', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.999038', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4838, 'Lindolfo Collor', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:38.999932', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4839, 'Linha Nova', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.00075', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4841, 'Machadinho', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.002707', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4840, 'Macambara', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.001806', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4842, 'Mampituba', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.003651', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4843, 'Manoel Viana', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.004534', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4844, 'Maquine', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.005502', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4845, 'Marata', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.006454', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4846, 'Marau', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.007402', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4847, 'Marcelino Ramos', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.008247', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4848, 'Mariana Pimentel', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.009044', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4849, 'Mariano Moro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.009911', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4850, 'Marques de Souza', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.010831', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4851, 'Mata', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.011716', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4852, 'Mato Castelhano', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.012915', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4853, 'Mato Leitao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.013882', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4854, 'Mato Queimado', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.014734', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4934, 'Progresso', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.101105', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4855, 'Maximiliano de Almeida', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.01553', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4856, 'Minas do Leao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.016287', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4857, 'Miraguai', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.017159', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4858, 'Montauri', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.018117', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4859, 'Monte Alegre dos Campos', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.018991', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4860, 'Monte Belo do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.019902', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4861, 'Montenegro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.020835', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4862, 'Mormaco', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.02173', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4863, 'Morrinhos do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.028527', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4864, 'Morro Redondo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.02965', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4865, 'Morro Reuter', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.030692', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4866, 'Mostardas', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.032073', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4867, 'Mucum', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.033021', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4868, 'Muitos Capoes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.033894', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4869, 'Muliterno', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.03487', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4870, 'Nao-me-toque', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.035708', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4871, 'Nicolau Vergueiro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.036634', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4872, 'Nonoai', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.037482', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4873, 'Nova Alvorada', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.038493', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4874, 'Nova Araca', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.039364', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4875, 'Nova Bassano', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.040191', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4876, 'Nova Boa Vista', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.041367', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4877, 'Nova Brescia', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.042406', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4878, 'Nova Candelaria', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.043243', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4879, 'Nova Esperanca do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.044148', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4880, 'Nova Hartz', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.044942', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4881, 'Nova Padua', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.045858', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4882, 'Nova Palma', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.04664', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4883, 'Nova Petropolis', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.047523', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4884, 'Nova Prata', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.04839', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4885, 'Nova Ramada', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.049254', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4886, 'Nova Roma do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.050199', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4887, 'Nova Santa Rita', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.051107', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4889, 'Novo Cabrais', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.052834', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4890, 'Novo Hamburgo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.053668', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4891, 'Novo Machado', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.054539', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4892, 'Novo Tiradentes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.055463', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4893, 'Novo Xingu', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.056358', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4888, 'Novo Barreiro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.052035', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4894, 'Osorio', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.057633', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4895, 'Paim Filho', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.058522', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4896, 'Palmares do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.0594', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4897, 'Palmeira das Missoes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.06019', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4898, 'Palmitinho', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.061164', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4899, 'Panambi', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.062045', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4900, 'Pantano Grande', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.062725', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4901, 'Parai', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.069617', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4902, 'Paraiso do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.07061', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4903, 'Pareci Novo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.07147', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4904, 'Parobe', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.072404', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4905, 'Passa Sete', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.073291', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4906, 'Passo do Sobrado', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.074185', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4907, 'Passo Fundo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.075119', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4908, 'Paulo Bento', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.076016', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4909, 'Paverama', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.076943', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4910, 'Pedras Altas', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.077899', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4911, 'Pedro Osorio', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.078764', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4912, 'Pejucara', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.08024', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4913, 'Pelotas', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.081029', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4914, 'Picada Cafe', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.082336', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4915, 'Pinhal', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.083171', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4916, 'Pinhal da Serra', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.083953', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4917, 'Pinhal Grande', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.084872', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4918, 'Pinheirinho do Vale', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.08576', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4919, 'Pinheiro Machado', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.086681', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4920, 'Pirapo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.087579', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4921, 'Piratini', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.088495', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4922, 'Planalto', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.089514', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4923, 'Poco das Antas', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.090675', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4924, 'Pontao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.091762', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4925, 'Ponte Preta', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.092594', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4926, 'Portao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.093566', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4927, 'Porto Alegre', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.094539', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4928, 'Porto Lucena', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.095462', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4929, 'Porto Maua', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.09633', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4930, 'Porto Vera Cruz', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.097306', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4931, 'Porto Xavier', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.098217', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4932, 'Pouso Novo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.099245', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4933, 'Presidente Lucena', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.10017', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4935, 'Protasio Alves', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.102143', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4936, 'Putinga', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.103128', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4937, 'Quarai', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.10406', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4938, 'Quatro Irmaos', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.110644', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4939, 'Quevedos', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.111825', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4940, 'Quinze de Novembro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.112857', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4941, 'Redentora', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.113697', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4942, 'Relvado', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.114655', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4943, 'Restinga Seca', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.115499', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4944, 'Rio dos Indios', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.116294', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4945, 'Rio Grande', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.117266', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4946, 'Rio Pardo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.118179', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4947, 'Riozinho', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.119135', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4948, 'Roca Sales', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.119995', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4949, 'Rodeio Bonito', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.120924', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4950, 'Rolador', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.121849', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4951, 'Rolante', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.122777', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4952, 'Ronda Alta', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.123656', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4953, 'Rondinha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.124514', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4954, 'Roque Gonzales', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.125383', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4955, 'Rosario do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.126163', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4956, 'Sagrada Familia', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.127151', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4957, 'Saldanha Marinho', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.128127', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4958, 'Salto do Jacui', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.129107', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4959, 'Salvador das Missoes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.13005', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4960, 'Salvador do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.130968', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4961, 'Sananduva', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.131942', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4962, 'Santa Barbara do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.132733', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4963, 'Santa Cecilia do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.133677', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4964, 'Santa Clara do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.134621', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4965, 'Santa Cruz do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.135859', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4967, 'Santa Maria', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.137745', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4968, 'Santa Maria do Herval', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.138656', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4966, 'Santa Margarida do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.136798', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4972, 'Santana da Boa Vista', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.142334', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4973, 'Santana do Livramento', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.143302', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4969, 'Santa Rosa', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.139651', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4970, 'Santa Tereza', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.140575', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4971, 'Santa Vitoria do Palmar', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.141428', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4974, 'Santiago', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.144184', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4975, 'Santo Angelo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.150861', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4978, 'Santo Antonio do Palma', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.153811', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4976, 'Santo Antonio da Patrulha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.151967', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4977, 'Santo Antonio das Missoes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.152911', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4979, 'Santo Antonio do Planalto', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.154666', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4980, 'Santo Augusto', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.155574', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4981, 'Santo Cristo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.156456', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4982, 'Santo Expedito do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.157362', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4983, 'Sao Borja', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.158226', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4984, 'Sao Domingos do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.159172', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4985, 'Sao Francisco de Assis', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.160002', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4986, 'Sao Francisco de Paula', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.160916', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4987, 'Sao Gabriel', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.161758', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4988, 'Sao Jeronimo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.162555', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4989, 'Sao Joao da Urtiga', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.163489', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4990, 'Sao Joao do Polesine', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.164452', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4991, 'Sao Jorge', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.165471', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4992, 'Sao Jose das Missoes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.166514', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4993, 'Sao Jose do Herval', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.167402', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4994, 'Sao Jose do Hortencio', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.168302', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4995, 'Sao Jose do Inhacora', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.169448', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4996, 'Sao Jose do Norte', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.170483', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4997, 'Sao Jose do Ouro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.171355', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4998, 'Sao Jose do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.172279', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (4999, 'Sao Jose dos Ausentes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.173227', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5000, 'Sao Leopoldo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.174112', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5001, 'Sao Lourenco do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.175066', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5002, 'Sao Luiz Gonzaga', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.176058', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5003, 'Sao Marcos', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.176959', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5004, 'Sao Martinho', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.177897', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5005, 'Sao Martinho da Serra', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.178867', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5006, 'Sao Miguel das Missoes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.17986', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5007, 'Sao Nicolau', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.180803', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5008, 'Sao Paulo das Missoes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.181651', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5009, 'Sao Pedro da Serra', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.18264', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5010, 'Sao Pedro das Missoes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.183578', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5011, 'Sao Pedro do Butia', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.184568', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5012, 'Sao Pedro do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.191638', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5013, 'Sao Sebastiao do Cai', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.192927', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5014, 'Sao Sepe', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.193953', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5015, 'Sao Valentim', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.194793', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5016, 'Sao Valentim do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.195665', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5017, 'Sao Valerio do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.196491', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5018, 'Sao Vendelino', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.197532', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5019, 'Sao Vicente do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.198462', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5020, 'Sapiranga', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.199365', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5021, 'Sapucaia do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.200245', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5022, 'Sarandi', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.201335', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5023, 'Seberi', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.202194', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5024, 'Sede Nova', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.203247', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5025, 'Segredo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.204153', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5026, 'Selbach', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.205013', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5027, 'Senador Salgado Filho', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.205893', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5028, 'Sentinela do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.206792', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5029, 'Serafina Correa', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.207836', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5030, 'Serio', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.208802', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5031, 'Sertao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.209619', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5032, 'Sertao Santana', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.210595', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5033, 'Sete de Setembro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.211625', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5034, 'Severiano de Almeida', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.21262', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5035, 'Silveira Martins', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.213555', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5036, 'Sinimbu', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.21458', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5037, 'Sobradinho', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.215477', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5038, 'Soledade', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.216332', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5039, 'Tabai', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.21724', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5040, 'Tapejara', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.218094', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5041, 'Tapera', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.219034', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5042, 'Tapes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.219964', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5043, 'Taquara', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.220879', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5044, 'Taquari', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.221862', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5045, 'Taquarucu do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.222788', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5046, 'Tavares', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.223707', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5047, 'Tenente Portela', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.225347', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5048, 'Terra de Areia', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.232849', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5049, 'Teutonia', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.234121', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5050, 'Tio Hugo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.235123', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5051, 'Tiradentes do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.23607', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5052, 'Toropi', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.236996', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5053, 'Torres', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.237913', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5054, 'Tramandai', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.23885', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5055, 'Travesseiro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.239806', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5056, 'Tres Arroios', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.240805', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5057, 'Tres Cachoeiras', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.241777', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5058, 'Tres Coroas', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.242724', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5059, 'Tres de Maio', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.243769', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5060, 'Tres Forquilhas', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.244655', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5061, 'Tres Palmeiras', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.245532', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5062, 'Tres Passos', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.246606', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5063, 'Trindade do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.247562', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5064, 'Triunfo', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.248414', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5065, 'Tucunduva', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.249233', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5066, 'Tunas', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.250107', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5067, 'Tupanci do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.250953', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5068, 'Tupancireta', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.251821', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5069, 'Tupandi', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.252708', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5070, 'Tuparendi', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.253578', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5071, 'Turucu', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.254432', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5072, 'Ubiretama', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.255333', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5073, 'Uniao da Serra', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.256245', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5074, 'Unistalda', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.257204', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5075, 'Uruguaiana', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.258629', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5076, 'Vacaria', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.259601', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5079, 'Vale Verde', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.262431', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5077, 'Vale do Sol', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.260531', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5078, 'Vale Real', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.261524', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5080, 'Vanini', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.263447', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5081, 'Venancio Aires', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.264406', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5082, 'Vera Cruz', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.265345', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5083, 'Veranopolis', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.26647', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5084, 'Vespasiano Correa', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.273349', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5085, 'Viadutos', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.274527', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5086, 'Viamao', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.275464', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5087, 'Vicente Dutra', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.276287', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5088, 'Victor Graeff', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.27728', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5089, 'Vila Flores', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.278305', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5090, 'Vila Langaro', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.279156', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5091, 'Vila Maria', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.280109', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5092, 'Vila Nova do Sul', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.281043', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5093, 'Vista Alegre', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.281928', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5094, 'Vista Alegre do Prata', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.282888', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5095, 'Vista Gaucha', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.283856', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5096, 'Vitoria das Missoes', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.284731', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5097, 'Westfalia', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.285646', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5098, 'Xangri-la', 'RS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.286521', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5099, 'Agua Clara', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.287518', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5100, 'Alcinopolis', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.288446', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5101, 'Amambai', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.289301', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5102, 'Anastacio', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.290239', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5103, 'Anaurilandia', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.291232', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5104, 'Angelica', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.292032', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5105, 'Antonio Joao', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.293133', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5106, 'Aparecida do Taboado', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.294053', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5107, 'Aquidauana', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.294884', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5108, 'Aral Moreira', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.29572', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5109, 'Bandeirantes', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.296713', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5110, 'Bataguassu', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.29763', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5112, 'Bela Vista', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.299542', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5113, 'Bodoquena', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.300463', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5114, 'Bonito', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.301372', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5115, 'Brasilandia', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.302327', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5116, 'Caarapo', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.303136', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5117, 'Camapua', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.304018', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5118, 'Campo Grande', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.30485', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5119, 'Caracol', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.305697', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5120, 'Cassilandia', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.306539', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5121, 'Chapadao do Sul', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.313766', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5122, 'Corguinho', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.314832', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5123, 'Coronel Sapucaia', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.315886', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5124, 'Corumba', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.316677', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5125, 'Costa Rica', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.317565', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5126, 'Coxim', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.318438', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5127, 'Deodapolis', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.319156', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5128, 'Dois Irmaos do Buriti', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.320079', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5129, 'Douradina', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.320958', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5130, 'Dourados', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.321841', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5131, 'Eldorado', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.322753', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5132, 'Fatima do Sul', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.323883', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5133, 'Figueirao', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.324801', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5134, 'Gloria de Dourados', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.325637', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5135, 'Guia Lopes da Laguna', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.326641', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5136, 'Iguatemi', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.327619', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5137, 'Inocencia', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.328612', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5138, 'Itapora', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.329508', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5139, 'Itaquirai', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.33029', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5140, 'Ivinhema', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.331111', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5141, 'Japora', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.332023', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5142, 'Jaraguari', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.332947', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5143, 'Jardim', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.333891', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5144, 'Jatei', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.334815', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5145, 'Juti', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.335804', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5146, 'Ladario', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.336612', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5147, 'Laguna Carapa', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.337536', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5148, 'Maracaju', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.338444', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5149, 'Miranda', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.33931', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5150, 'Mundo Novo', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.340178', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5151, 'Navirai', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.341075', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5152, 'Nioaque', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.341888', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5153, 'Nova Alvorada do Sul', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.342697', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5154, 'Nova Andradina', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.343615', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5155, 'Novo Horizonte do Sul', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.344527', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5156, 'Paranaiba', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.345447', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5157, 'Paranhos', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.346394', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5158, 'Pedro Gomes', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.347493', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5159, 'Ponta Pora', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.35418', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5160, 'Porto Murtinho', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.355395', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5161, 'Ribas do Rio Pardo', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.356263', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5162, 'Rio Brilhante', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.357159', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5163, 'Rio Negro', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.358428', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5164, 'Rio Verde de Mato Grosso', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.359236', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5165, 'Rochedo', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.360185', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5166, 'Santa Rita do Pardo', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.360982', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5167, 'Sao Gabriel do Oeste', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.362003', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5169, 'Sete Quedas', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.363971', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5168, 'Selviria', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.362991', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5170, 'Sidrolandia', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.364965', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5171, 'Sonora', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.366069', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5172, 'Tacuru', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.366911', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5173, 'Taquarussu', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.368294', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5174, 'Terenos', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.369444', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5175, 'Tres Lagoas', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.370315', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5176, 'Vicentina', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.371201', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5177, 'Acorizal', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.372079', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5178, 'Agua Boa', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.372947', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5179, 'Alta Floresta', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.373825', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5180, 'Alto Araguaia', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.374753', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5181, 'Alto Boa Vista', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.375625', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5182, 'Alto Garcas', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.376478', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5183, 'Alto Paraguai', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.37727', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5184, 'Alto Taquari', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.378248', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5185, 'Apiacas', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.379176', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5186, 'Araguaiana', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.380109', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5187, 'Araguainha', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.381101', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5188, 'Araputanga', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.382033', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5189, 'Arenapolis', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.383142', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5190, 'Aripuana', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.383975', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5191, 'Barao de Melgaco', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.384902', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5192, 'Barra do Bugres', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.385821', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5193, 'Barra do Garcas', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.386784', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5194, 'Bom Jesus do Araguaia', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.387912', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5195, 'Brasnorte', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.395783', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5196, 'Caceres', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.396886', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5197, 'Campinapolis', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.397801', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5198, 'Campo Novo do Parecis', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.398624', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5199, 'Campo Verde', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.399594', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5200, 'Campos de Julio', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.400449', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5201, 'Canabrava do Norte', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.401301', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5202, 'Canarana', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.402031', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5203, 'Carlinda', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.403458', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5204, 'Castanheira', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.404495', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5205, 'Chapada dos Guimaraes', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.405573', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5206, 'Claudia', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.406653', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5207, 'Cocalinho', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.407608', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5208, 'Colider', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.408507', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5209, 'Colniza', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.409412', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5210, 'Comodoro', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.410397', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5211, 'Confresa', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.411332', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5212, 'Conquista D''oeste', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.412235', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5213, 'Cotriguacu', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.413221', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5214, 'Cuiaba', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.414149', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5216, 'Denise', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.416081', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5217, 'Diamantino', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.417014', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5218, 'Dom Aquino', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.417947', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5219, 'Feliz Natal', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.418926', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5220, 'Figueiropolis D''oeste', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.419849', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5221, 'Gaucha do Norte', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.4207', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5222, 'General Carneiro', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.421639', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5223, 'Gloria D''oeste', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.422532', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5224, 'Guaranta do Norte', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.423784', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5225, 'Guiratinga', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.424887', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5226, 'Indiavai', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.425733', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5227, 'Ipiranga do Norte', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.426779', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5228, 'Itanhanga', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.427777', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5229, 'Itauba', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.42877', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5230, 'Itiquira', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.429726', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5231, 'Jaciara', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.436354', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5232, 'Jangada', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.437631', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5233, 'Jauru', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.438623', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5234, 'Juara', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.439558', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5235, 'Juina', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.440473', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5236, 'Juruena', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.441383', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5237, 'Juscimeira', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.442317', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5238, 'Lambari D''oeste', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.443327', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5239, 'Lucas do Rio Verde', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.444223', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5240, 'Luciara', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.445157', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5316, 'Vila Bela da Santissima Trindade', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.528916', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5241, 'Marcelandia', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.446077', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5242, 'Matupa', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.447134', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5243, 'Mirassol D''oeste', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.448029', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5244, 'Nobres', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.448969', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5245, 'Nortelandia', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.449889', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5246, 'Nossa Senhora do Livramento', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.450756', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5247, 'Nova Bandeirantes', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.451561', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5256, 'Nova Nazare', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.459757', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5251, 'Nova Lacerda', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.455047', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5258, 'Nova Santa Helena', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.461782', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5248, 'Nova Brasilandia', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.452363', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5249, 'Nova Canaa do Norte', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.453308', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5255, 'Nova Mutum', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.458788', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5257, 'Nova Olimpia', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.460794', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5259, 'Nova Ubirata', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.462711', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5260, 'Nova Xavantina', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.463694', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5262, 'Novo Mundo', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.465458', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5261, 'Novo Horizonte do Norte', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.464598', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5264, 'Novo Sao Joaquim', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.467249', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5265, 'Paranaita', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.468084', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5266, 'Paranatinga', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.469197', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5263, 'Novo Santo Antonio', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.466329', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5267, 'Pedra Preta', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.470265', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5268, 'Peixoto de Azevedo', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.471267', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5269, 'Planalto da Serra', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.477744', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5270, 'Pocone', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.478832', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5271, 'Pontal do Araguaia', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.479747', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5272, 'Ponte Branca', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.480811', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5273, 'Pontes e Lacerda', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.481784', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5274, 'Porto Alegre do Norte', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.482693', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5275, 'Porto dos Gauchos', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.483624', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5276, 'Porto Esperidiao', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.484579', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5277, 'Porto Estrela', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.485413', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5279, 'Primavera do Leste', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.487239', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5280, 'Querencia', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.48811', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5300, 'Sao Jose dos Quatro Marcos', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.506858', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5281, 'Reserva do Cabacal', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.489033', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5282, 'Ribeirao Cascalheira', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.489983', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5283, 'Ribeiraozinho', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.490955', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5284, 'Rio Branco', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.491842', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5289, 'Santa Carmem', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.496894', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5293, 'Santo Afonso', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.50045', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5297, 'Sao Jose do Povo', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.504015', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5298, 'Sao Jose do Rio Claro', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.504954', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5299, 'Sao Jose do Xingu', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.505931', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5301, 'Sao Pedro da Cipa', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.507799', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5285, 'Rondolandia', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.492869', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5286, 'Rondonopolis', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.493854', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5287, 'Rosario Oeste', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.494826', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5290, 'Santa Cruz do Xingu', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.497687', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5288, 'Salto do Ceu', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.495786', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5291, 'Santa Rita do Trivelato', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.498595', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5292, 'Santa Terezinha', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.499475', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5294, 'Santo Antonio do Leste', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.50133', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5295, 'Santo Antonio do Leverger', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.502127', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5296, 'Sao Felix do Araguaia', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.503103', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5302, 'Sapezal', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.508718', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5303, 'Serra Nova Dourada', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.509707', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5304, 'Sinop', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.510666', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5305, 'Sorriso', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.51148', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5306, 'Tabapora', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.51804', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5307, 'Tangara da Serra', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.51929', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5308, 'Tapurah', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.520225', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5309, 'Terra Nova do Norte', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.521047', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5310, 'Tesouro', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.521974', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5311, 'Torixoreu', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.52294', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5312, 'Uniao do Sul', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.523883', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5313, 'Vale de Sao Domingos', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.524972', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5314, 'Varzea Grande', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.526086', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5315, 'Vera', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.526999', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5317, 'Vila Rica', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.530101', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5250, 'Nova Guarita', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.45418', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5252, 'Nova Marilandia', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.455908', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5253, 'Nova Maringa', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.456789', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5254, 'Nova Monte Verde', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.457859', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5318, 'Abadia de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.531009', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5319, 'Abadiania', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.53199', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5320, 'Acreuna', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.532886', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5321, 'Adelandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.533668', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5322, 'Agua Fria de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.534826', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5323, 'Agua Limpa', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.535749', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5324, 'Aguas Lindas de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.53668', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5325, 'Alexania', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.537739', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5326, 'Aloandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.53862', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5327, 'Alto Horizonte', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.539517', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5328, 'Alto Paraiso de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.540454', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5329, 'Alvorada do Norte', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.541418', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5330, 'Amaralina', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.542313', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5331, 'Americano do Brasil', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.543192', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5332, 'Amorinopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.544118', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5333, 'Anapolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.544995', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5334, 'Anhanguera', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.545877', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5335, 'Anicuns', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.54685', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5336, 'Aparecida de Goiania', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.547789', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5337, 'Aparecida do Rio Doce', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.548635', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5338, 'Apore', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.549452', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5339, 'Aracu', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.550511', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5340, 'Aragarcas', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.551456', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5341, 'Aragoiania', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.558409', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5342, 'Araguapaz', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.559799', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5343, 'Arenopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.5608', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5344, 'Aruana', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.561736', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5345, 'Aurilandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.562641', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5346, 'Avelinopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.563516', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5347, 'Baliza', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.564819', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5348, 'Barro Alto', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.56604', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5349, 'Bela Vista de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.566961', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5350, 'Bom Jardim de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.567928', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5351, 'Bom Jesus de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.568869', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5352, 'Bonfinopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.569784', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5353, 'Bonopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.570757', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5354, 'Brazabrantes', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.571611', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5355, 'Britania', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.572486', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5356, 'Buriti Alegre', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.57334', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5357, 'Buriti de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.57425', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5358, 'Buritinopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.575213', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5359, 'Cabeceiras', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.57613', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5360, 'Cachoeira Alta', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.577058', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5361, 'Cachoeira de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.577887', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5362, 'Cachoeira Dourada', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.578836', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5363, 'Cacu', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.579767', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5364, 'Caiaponia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.580695', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5365, 'Caldas Novas', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.581988', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5366, 'Caldazinha', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.582914', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5367, 'Campestre de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.583775', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5368, 'Campinacu', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.584712', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5369, 'Campinorte', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.585668', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5370, 'Campo Alegre de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.586525', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5371, 'Campo Limpo de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.587364', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5372, 'Campos Belos', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.588237', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5373, 'Campos Verdes', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.589202', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5374, 'Carmo do Rio Verde', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.590143', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5375, 'Castelandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.591002', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5376, 'Catalao', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.592188', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5377, 'Caturai', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.603004', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5378, 'Cavalcante', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.604319', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5379, 'Ceres', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.605372', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5380, 'Cezarina', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.606325', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5381, 'Chapadao do Ceu', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.607336', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5382, 'Cidade Ocidental', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.608275', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5383, 'Cocalzinho de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.609119', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5384, 'Colinas do Sul', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.609959', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5385, 'Corrego do Ouro', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.610872', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5386, 'Corumba de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.611794', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5387, 'Corumbaiba', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.612763', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5388, 'Cristalina', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.613699', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5389, 'Cristianopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.614727', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5390, 'Crixas', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.615553', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5391, 'Crominia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.616462', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5392, 'Cumari', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.61735', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5393, 'Damianopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.618249', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5394, 'Damolandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.619199', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5395, 'Davinopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.620154', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5396, 'Diorama', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.621073', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5398, 'Doverlandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.623068', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5399, 'Edealina', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.623962', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5400, 'Edeia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.624932', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5401, 'Estrela do Norte', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.625947', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5402, 'Faina', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.626774', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5403, 'Fazenda Nova', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.627692', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5404, 'Firminopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.628612', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5405, 'Flores de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.629589', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5406, 'Formosa', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.630429', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5407, 'Formoso', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.631268', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5408, 'Gameleira de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.632204', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5397, 'Divinopolis de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.622032', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5409, 'Goianapolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.633039', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5410, 'Goiandira', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.633983', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5411, 'Goianesia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.634918', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5412, 'Goiania', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.635858', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5413, 'Goianira', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.636781', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5414, 'Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.643396', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5415, 'Goiatuba', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.644646', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5416, 'Gouvelandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.645672', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5417, 'Guapo', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.646555', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5418, 'Guaraita', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.647553', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5419, 'Guarani de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.648866', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5420, 'Guarinos', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.649863', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5421, 'Heitorai', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.650692', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5422, 'Hidrolandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.651434', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5423, 'Hidrolina', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.65227', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5424, 'Iaciara', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.653174', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5425, 'Inaciolandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.654174', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5426, 'Indiara', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.655008', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5427, 'Inhumas', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.655851', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5428, 'Ipameri', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.656848', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5429, 'Ipiranga de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.657863', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5430, 'Ipora', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.658736', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5431, 'Israelandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.659837', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5432, 'Itaberai', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.660714', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5433, 'Itaguari', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.66169', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5434, 'Itaguaru', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.662571', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5435, 'Itaja', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.663372', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5436, 'Itapaci', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.664184', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5437, 'Itapirapua', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.665155', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5438, 'Itapuranga', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.666064', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5439, 'Itaruma', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.666945', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5440, 'Itaucu', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.667766', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5441, 'Itumbiara', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.668731', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5442, 'Ivolandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.669617', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5443, 'Jandaia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.670602', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5444, 'Jaragua', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.671381', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5445, 'Jatai', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.672203', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5446, 'Jaupaci', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.673077', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5447, 'Jesupolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.67413', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5448, 'Joviania', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.675038', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5449, 'Jussara', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.675958', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5450, 'Lagoa Santa', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.676927', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5451, 'Leopoldo de Bulhoes', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.687916', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5452, 'Luziania', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.689054', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5453, 'Mairipotaba', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.689933', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5454, 'Mambai', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.69083', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5455, 'Mara Rosa', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.691716', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5456, 'Marzagao', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.692635', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5457, 'Matrincha', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.693504', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5458, 'Maurilandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.694336', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5459, 'Mimoso de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.695216', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5460, 'Minacu', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.696172', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5461, 'Mineiros', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.697089', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5462, 'Moipora', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.698025', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5463, 'Monte Alegre de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.69892', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5464, 'Montes Claros de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.699882', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5465, 'Montividiu', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.700799', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5466, 'Montividiu do Norte', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.701715', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5467, 'Morrinhos', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.702638', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5468, 'Morro Agudo de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.703663', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5469, 'Mossamedes', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.704418', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5470, 'Mozarlandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.705276', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5471, 'Mundo Novo', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.706025', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5472, 'Mutunopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.706843', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5473, 'Nazario', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.707701', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5474, 'Neropolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.708646', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5475, 'Niquelandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.709625', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5476, 'Nova America', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.710551', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5477, 'Nova Aurora', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.711502', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5478, 'Nova Crixas', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.712452', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5479, 'Nova Gloria', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.713407', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5480, 'Nova Iguacu de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.714282', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5481, 'Nova Roma', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.715252', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5482, 'Nova Veneza', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.716088', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5483, 'Novo Brasil', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.717048', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5484, 'Novo Gama', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.71804', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5485, 'Novo Planalto', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.718969', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5486, 'Orizona', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.71987', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5487, 'Ouro Verde de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.720782', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5488, 'Ouvidor', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.721647', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5489, 'Padre Bernardo', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.730377', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5490, 'Palestina de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.731494', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5491, 'Palmeiras de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.732416', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5492, 'Palmelo', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.733286', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5493, 'Palminopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.734292', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5494, 'Panama', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.735177', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5495, 'Paranaiguara', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.736027', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5496, 'Parauna', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.736912', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5497, 'Perolandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.738016', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5498, 'Petrolina de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.738872', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5499, 'Pilar de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.739682', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5500, 'Piracanjuba', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.740598', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5501, 'Piranhas', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.741497', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5502, 'Pirenopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.742364', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5503, 'Pires do Rio', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.743286', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5504, 'Planaltina', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.744194', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5505, 'Pontalina', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.745138', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5506, 'Porangatu', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.746057', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5507, 'Porteirao', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.746977', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5508, 'Portelandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.747798', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5509, 'Posse', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.74865', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5510, 'Professor Jamil', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.749443', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5511, 'Quirinopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:37.606333', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5512, 'Rialma', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:34.339363', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5513, 'Rianapolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.527984', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5514, 'Rio Quente', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.750281', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5515, 'Rio Verde', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.75147', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5516, 'Rubiataba', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.752375', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5517, 'Sanclerlandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.75327', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5518, 'Santa Barbara de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.754126', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5519, 'Santa Cruz de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.754942', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5520, 'Santa Fe de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.755933', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5521, 'Santa Helena de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.756965', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5522, 'Santa Isabel', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.757965', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5523, 'Santa Rita do Araguaia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.758958', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5524, 'Santa Rita do Novo Destino', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.759916', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5525, 'Santa Rosa de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.760746', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5526, 'Santa Tereza de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.76171', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5527, 'Santa Terezinha de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.762654', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5528, 'Santo Antonio da Barra', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.763614', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5529, 'Santo Antonio de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.764441', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5530, 'Santo Antonio do Descoberto', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.771458', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5531, 'Sao Domingos', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.77252', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5532, 'Sao Francisco de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.773455', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5534, 'Sao Joao D''alianca', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.775239', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5533, 'Sao Joao da Parauna', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.774354', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5535, 'Sao Luis de Montes Belos', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.77614', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5536, 'Sao Luiz do Norte', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.776981', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5537, 'Sao Miguel do Araguaia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.777896', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5538, 'Sao Miguel do Passa Quatro', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.778808', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5539, 'Sao Patricio', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.779725', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5540, 'Sao Simao', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.780665', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5541, 'Senador Canedo', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.7816', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5542, 'Serranopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.78277', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5543, 'Silvania', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.783748', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5544, 'Simolandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.784751', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5545, 'Sitio D''abadia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.785701', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5546, 'Taquaral de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.786631', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5547, 'Teresina de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.787611', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5548, 'Terezopolis de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.788494', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5549, 'Tres Ranchos', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.789421', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5550, 'Trindade', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.790358', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5551, 'Trombas', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.791247', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5552, 'Turvania', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.792226', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5553, 'Turvelandia', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.793204', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5554, 'Uirapuru', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.794106', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5555, 'Uruacu', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.795058', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5556, 'Uruana', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.796026', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5557, 'Urutai', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.796933', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5558, 'Valparaiso de Goias', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.797818', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5559, 'Varjao', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.798714', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5560, 'Vianopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.799587', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5561, 'Vicentinopolis', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.800364', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5562, 'Vila Boa', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.801199', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5563, 'Vila Propicio', 'GO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.802078', 'I');
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idsis_rev, data_rev, origem_gravacao, idpes_cad, idsis_cad, data_cad, operacao) VALUES (5564, 'Brasilia', 'DF', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, NULL, '2017-08-15 09:09:43.077347', 'M', 1, 9, '2010-01-06 18:30:39.80332', 'I');


--
-- Data for Name: pessoa; Type: TABLE DATA; Schema: historico; Owner: postgres
--



--
-- Data for Name: socio; Type: TABLE DATA; Schema: historico; Owner: postgres
--



SET search_path = modules, pg_catalog;

--
-- Data for Name: area_conhecimento; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Name: area_conhecimento_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('area_conhecimento_id_seq', 2, true);


--
-- Data for Name: auditoria; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Data for Name: auditoria_geral; Type: TABLE DATA; Schema: modules; Owner: ieducar
--



--
-- Data for Name: calendario_turma; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Data for Name: componente_curricular; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Data for Name: componente_curricular_ano_escolar; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Name: componente_curricular_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('componente_curricular_id_seq', 2, true);


--
-- Data for Name: componente_curricular_turma; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Data for Name: docente_licenciatura; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Name: docente_licenciatura_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('docente_licenciatura_id_seq', 1, false);


--
-- Data for Name: educacenso_cod_aluno; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Data for Name: educacenso_cod_docente; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Data for Name: educacenso_cod_escola; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Data for Name: educacenso_cod_turma; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Data for Name: educacenso_curso_superior; Type: TABLE DATA; Schema: modules; Owner: postgres
--

INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (2, '143F01', 'Formação de professor de creche', 1, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (3, '143F02', 'Formação de professor de educação infantil', 1, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (4, '143F03', 'Formação de professor de pré-escola', 1, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (5, '144F01', 'Formação de professor das séries finais do ensino fundamental', 1, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (6, '144F02', 'Formação de professor das séries iniciais do ensino fundamental', 1, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (7, '144F03', 'Formação de professor de alfabetização', 1, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (8, '144F04', 'Formação de professor de educação especial', 1, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (9, '144F05', 'Formação de professor de educação infantil e séries iniciais do ensino fundamental', 1, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (10, '144F06', 'Formação de professor do ensino fundamental', 1, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (11, '144F07', 'Formação de professor do ensino médio', 1, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (12, '144F08', 'Formação de professor de jovens e adultos', 1, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (13, '144F11', 'Formação de professor para a educação básica', 1, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (14, '144N01', 'Normal superior', 1, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (18, '145F07', 'Formação de professor de estudos sociais', 1, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (23, '145F13', 'Formação de professor de língua estrangeira', 1, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (25, '145F16', 'Formação de professor de português e língua estrangeira', 1, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (29, '145F25', 'Formação de professor em ciências sociais', 1, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (30, '146A01', 'Formação de professor de disciplinas profissionais - AMBIENTE, SAÚDE E SEGURANÇA', 1, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (31, '146E01', 'Formação de professor de disciplinas profissionais - APOIO EDUCACIONAL', 1, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (33, '146G01', 'Formação de professor de disciplinas profissionais - GESTÃO E NEGÓCIOS', 1, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (34, '146C01', 'Formação de professor de disciplinas profissionais - INFORMAÇÃO E COMUNICAÇÃO', 1, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (35, '146I01', 'Formação de professor de disciplinas profissionais - INFRA-ESTRUTURA', 1, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (36, '146D01', 'Formação de professor de disciplinas profissionais - PRODUÇÃO CULTURAL E DESIGN', 1, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (37, '146N01', 'Formação de professor de disciplinas profissionais - RECURSOS NATURAIS', 1, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (39, '212999', 'Música e artes cênicas', 2, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (40, '213999', 'Técnicas audiovisuais e produção de mídia', 2, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (41, '214999', 'Design e estilismo', 2, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (42, '215999', 'Artesanato', 2, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (44, '220L01', 'Letras', 2, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (45, '220P01', 'Letras português', 2, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (46, '220E01', 'Letras línguas estrangeiras', 2, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (48, '221999', 'Religião e teologia', 2, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (52, '226999', 'Filosofia e ética', 2, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (53, '312999', 'Sociologia e estudos culturais', 3, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (55, '313999', 'Ciência política e educação cívica', 3, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (57, '321999', 'Jornalismo e reportagem', 3, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (58, '322999', 'Biblioteconomia, informação, arquivos', 3, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (59, '341999', 'Vendas em atacado e varejo', 3, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (60, '342999', 'Marketing e publicidade', 3, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (61, '343F01', 'Finanças, bancos, seguros', 3, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (62, '344999', 'Contabilidade e tributação', 3, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (63, '345999', 'Gerenciamento e administração', 3, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (64, '346999', 'Secretariado e trabalhos de escritório', 3, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (65, '347V01', 'Vida profissional', 3, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (67, '420C01', 'Ciências', 4, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (68, '421B01', 'Biofísica', 4, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (69, '421B02', 'Biologia', 4, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (71, '421B09', 'Bioquímica', 4, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (74, '443999', 'Ciências da terra', 4, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (75, '443G04', 'Geografia', 4, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (77, '443P01', 'Paleontologia', 4, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (20, '145F09', 'Formação de professor de física', 1, 1, '2010-09-20 11:45:07.078', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (81, '520999', 'Engenharia e profissões de engenharia', 5, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (82, '520D01', 'Desenho industrial', 5, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (83, '521999', 'Engenharia mecânica e metalurgia (trabalhos com metais)', 5, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (84, '522999', 'Eletricidade e energia', 5, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (85, '523999', 'Eletrônica e automação', 5, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (88, '524999', 'Química e engenharia de processos', 5, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (89, '524E02', 'Engenharia de biotecnologia', 5, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (91, '525999', 'Veículos a motor, construção naval e aeronáutica', 5, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (92, '540F01', 'Fabricação e processamento', 5, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (93, '541P04', 'Processamento de alimentos e bebidas', 5, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (94, '542999', 'Têxteis, roupas, calçados, couros', 5, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (95, '543999', 'Materiais (madeira, papel, plástico, vidro)', 5, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (98, '582999', 'Engenharia civil e de construção', 5, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (99, '621999', 'Produção agrícola e pecuária', 6, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (101, '624999', 'Recursos pesqueiros', 6, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (102, '641999', 'Veterinária', 6, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (104, '813E01', 'Educação física', 7, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (106, '723999', 'Enfermagem e atenção primária (assistência básica)', 7, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (108, '726999', 'Terapia e reabilitação', 7, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (113, '762999', 'Serviço social e orientação', 7, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (114, '811999', 'Hotelaria, restaurantes  e serviços de alimentação', 8, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (115, '812999', 'Viagens, turismo e lazer', 8, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (116, '813E01', 'Esportes', 8, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (117, '814C01', 'Ciências domésticas', 8, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (118, '815999', 'Serviços de beleza', 8, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (119, '840999', 'Transportes e serviços', 8, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (120, '850999', 'Proteção ambiental e saneamento', 8, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (121, '861999', 'Proteção de pessoas e de propriedades', 8, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (122, '862999', 'Saúde e segurança do trabalho', 8, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (123, '863999', 'Setor militar e de defesa', 8, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (124, '999999', 'Outro curso de formação superior', 9, 1, '2010-09-20 11:45:07.078', NULL, NULL);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (147, '213C07', 'Carnaval', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (96, '544M02', 'Mineração e extração', 5, 1, '2010-09-20 11:45:07.078', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (125, '142A01', 'Processos Escolares', 1, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (141, '212C02', 'Produção cênica', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (145, '213A05', 'Produção audiovisual', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (146, '213C06', 'Design gráfico', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (148, '213F01', 'Fotografia', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (149, '213P02', 'Produção multimídia', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (150, '213P03', 'Produção fonográfica', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (151, '213P05', 'Produção publicitária', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (152, '213P07', 'Produção Cultural', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (153, '214D02', 'Design de moda', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (155, '214D06', 'Design de Interiores', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (157, '214P01', 'Design de produto', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (158, '215C02', 'Conservação e restauro', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (159, '215F01', 'Fabricação de Instrumentos Musicais', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (162, '223C01', 'Comunicação assistiva', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (165, '225M02', 'Museografia', 2, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (177, '340N02', 'Comércio exterior', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (178, '341N01', 'Negócios imobiliários', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (179, '342C01', 'Comunicação institucional', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (180, '342M02', 'Marketing', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (183, '343S01', 'Gestão de Seguros', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (186, '345A02', 'Gestão de cooperativas', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (187, '345A07', 'Gestão hospitalar', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (188, '345A10', 'Gestão pública', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (189, '345C01', 'Processos gerenciais', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (190, '345G09', 'Gestão de recursos humanos', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (191, '345G10', 'Gestão da qualidade', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (192, '345G13', 'Logística', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (193, '345G16', 'Gestão comercial', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (194, '345G17', 'Gestão financeira', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (195, '345G26', 'Gestão de segurança privada', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (196, '346S01', 'Secretariado', 3, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (198, '421B12', 'Biotecnologia', 4, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (200, '422S01', 'Saneamento ambiental', 4, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (209, '481A01', 'Redes de computadores', 4, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (210, '481B01', 'Banco de dados', 4, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (211, '481T01', 'Gestão da tecnologia da informação', 4, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (212, '481T02', 'Jogos Digitais', 4, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (213, '482U01', 'Sistemas para internet', 4, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (214, '483S01', 'Análise e desenvolvimento de sistemas / Segurança da informação', 4, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (216, '520A01', 'Automação industrial', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (221, '520G01', 'Geoprocessamento', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (222, '520M01', 'Manutenção industrial', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (223, '520P02', 'Gestão da produção industrial', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (224, '520T01', 'Gestão de telecomunicações', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (227, '521M03', 'Mecânica de precisão', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (228, '521T02', 'Processos metalúrgicos', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (229, '521T03', 'Fabricação mecânica', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (230, '522D02', 'Sistemas elétricos', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (232, '522E08', 'Sistemas de energia', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (233, '522R01', 'Refrigeração/Aquecimento', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (234, '522T02', 'Eletrotécnica industrial', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (240, '523M01', 'Sistemas biomédicos', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (241, '523S03', 'Sistemas eletrônicos', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (242, '523T01', 'Redes de telecomunicações / Sistemas de telecomunicações', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (243, '523T04', 'Mecatrônica industrial', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (244, '523T05', 'Telemática', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (245, '523T06', 'Eletrônica industrial', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (248, '524T03', 'Processos químicos', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (249, '524T04', 'Biocombustíveis', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (250, '525A01', 'Mecanização Agrícola', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (251, '525C04', 'Construção naval', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (255, '525M01', 'Manutenção de aeronaves', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (256, '525S01', 'Sistemas Automotivos', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (257, '540F02', 'Produção Joalheira/Design de jóias e gemas', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (258, '540F03', 'Produção Gráfica', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (260, '541I02', 'Laticínios', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (261, '541P05', 'Processamento de Carnes', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (262, '541P09', 'Viticultura e Enologia', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (263, '541T01', 'Alimentos', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (264, '541T02', 'Produção Sucroalcooleira', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (265, '541T03', 'Produção de Cachaça', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (266, '542B01', 'Bioenergia', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (268, '542I01', 'Produção de vestuário', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (269, '542I02', 'Produção têxtil', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (270, '543C01', 'Cerâmica', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (271, '543F03', 'Produção moveleira', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (272, '543F05', 'Papel e celulose', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (273, '543P06', 'Polímeros', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (275, '544E05', 'Petróleo e gás', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (277, '544R01', 'Rochas ornamentais', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (278, '544T01', 'Tecnologia de Mineração', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (279, '582A01', 'Obras hidráulicas', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (280, '582A02', 'Agrimensura', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (281, '582C05', 'Construção de Edifícios', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (284, '582M02', 'Material de construção', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (285, '582O01', 'Controle de obras', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (286, '582T04', 'Estradas', 5, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (287, '621A03', 'Agroindústria', 6, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (289, '621A06', 'Agroecologia', 6, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (291, '621M02', 'Produção Agrícola', 6, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (292, '621T01', 'Irrigação e Drenagem', 6, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (293, '621T03', 'Agronegócio', 6, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (294, '621T04', 'Cafeicultura', 6, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (295, '621T05', 'Produção de Grãos', 6, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (297, '622H01', 'Horticultura', 6, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (298, '623S01', 'Silvicultura', 6, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (299, '624A01', 'Aqüicultura', 6, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (301, '624T01', 'Produção Pesqueira', 6, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (305, '721O02', 'Oftálmica', 7, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (307, '725T06', 'Radiologia', 7, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (308, '726O01', 'Óptica e Optometria', 7, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (312, '811G01', 'Gastronomia', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (313, '811H02', 'Hotelaria', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (314, '811H03', 'Hotelaria Hospitalar', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (315, '812E01', 'Eventos', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (316, '812P01', 'Gestão de Turismo', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (318, '813F02', 'Futebol', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (319, '813G02', 'Gestão desportiva e de lazer', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (321, '815E01', 'Estética e Cosmética', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (322, '840A01', 'Pilotagem profissional de aeronaves', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (325, '840N02', 'Sistemas de navegação fluvial', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (326, '840S01', 'Gestão portuária', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (327, '840S02', 'Transporte aéreo', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (328, '840T02', 'Transporte terrestre', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (329, '850G01', 'Processos ambientais / Gestão ambiental', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (330, '861S02', 'Segurança no trânsito / Segurança pública', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (331, '861S03', 'Serviços penais', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (332, '862S01', 'Segurança no trabalho', 8, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (338, '999992', 'Outro curso de formação superior', 9, 1, '2015-06-30 21:47:05.352523', NULL, 1);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (15, '145F01', 'Formação de professor de biologia', 1, 1, '2010-09-20 11:45:07.078', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (16, '145F02', 'Formação de professor de ciências', 1, 1, '2010-09-20 11:45:07.078', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (17, '145F05', 'Formação de professor de educação religiosa', 1, 1, '2010-09-20 11:45:07.078', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (19, '145F08', 'Formação de professor de filosofia', 1, 1, '2010-09-20 11:45:07.078', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (21, '145F10', 'Formação de professor de geografia', 1, 1, '2010-09-20 11:45:07.078', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (22, '145F11', 'Formação de professor de história', 1, 1, '2010-09-20 11:45:07.078', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (24, '145F15', 'Formação de professor de português', 1, 1, '2010-09-20 11:45:07.078', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (26, '145F18', 'Formação de professor de matemática', 1, 1, '2010-09-20 11:45:07.078', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (27, '145F21', 'Formação de professor de química', 1, 1, '2010-09-20 11:45:07.078', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (28, '145F24', 'Formação de professor de sociologia', 1, 1, '2010-09-20 11:45:07.078', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (32, '146P01', 'Formação de professor de disciplinas profissionais - CONTROLE E PROCESSOS INDUSTRIAIS', 1, 1, '2010-09-20 11:45:07.078', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (126, '142P01', 'Pedagogia', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (127, '144F12', 'Licenciatura Interdisciplinar em Ciências Humanas', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (128, '144F13', 'Licenciatura Intercultural Indígena', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (129, '145F14', 'Letras - Língua Estrangeira', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (130, '145F17', 'Letras - Língua Portuguesa e Estrangeira', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (131, '145F28', 'Libras', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (132, '146F02', 'Licenciatura Interdisciplinar em Artes (Educação Artística', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (133, '146F04', 'Artes Visuais', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (134, '146F05', 'Informática', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (135, '146F07', 'Dança', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (136, '146F09', 'Licenciatura Interdisciplinar em Educação no Campo', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (137, '146F15', 'Educação Física', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (138, '146F20', 'Música', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (139, '146F22', 'Teatro', 1, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (203, '443C01', 'Ciência da Terra', 4, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (336, '999990', 'Outro curso de formação superior', 9, 1, '2015-06-30 21:47:05.352523', NULL, 2);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (1, '142C01', 'Ciências da educação', 1, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (38, '210A01', 'Artes', 2, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (43, '220H01', 'Humanidades', 2, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (47, '220L03', 'Letras português e línguas estrangeiras', 2, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (49, '225A01', 'Arqueologia', 2, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (50, '225H01', 'História', 2, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (51, '225M01', 'Museologia', 2, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (54, '311P02', 'Psicologia', 3, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (56, '314E02', 'Economia', 3, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (66, '380D01', 'Direito', 3, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (70, '421B07', 'Biomedicina', 4, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (72, '441F01', 'Física', 4, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (73, '442Q01', 'Química', 4, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (76, '443M01', 'Meteorologia', 4, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (78, '461M01', 'Matemática', 4, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (79, '462E01', 'Estatística', 4, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (80, '481C01', 'Ciência da computação', 4, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (86, '523E04', 'Engenharia de computação', 5, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (87, '523E04', 'Engenharia de redes de comunicação', 5, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (90, '524E06', 'Engenharia nuclear', 5, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (97, '581A05', 'Arquitetura e urbanismo', 5, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (100, '623E01', 'Engenharia florestal - silvicultura', 6, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (103, '720S01', 'Saúde', 7, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (105, '721M01', 'Medicina', 7, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (107, '724O01', 'Odontologia', 7, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (109, '726F01', 'Fisioterapia', 7, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (110, '726F03', 'Fonoaudiologia', 7, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (111, '726N02', 'Nutrição', 7, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (112, '727F01', 'Farmácia', 7, 1, '2010-09-20 11:45:07.078', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (140, '211A02', 'Artes Visuais', 2, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (142, '212D01', 'Dança', 2, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (143, '212M02', 'Música', 2, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (144, '212T01', 'Teatro', 2, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (154, '214D05', 'Design', 2, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (156, '214M01', 'Moda', 2, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (160, '221T01', 'Teologia', 2, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (161, '222L01', 'Letras - Língua Estrangeira', 2, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (163, '223L01', 'Letras - Língua Portuguesa', 2, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (164, '223L02', 'Libras', 2, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (166, '226F01', 'Filosofia', 2, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (167, '310C02', 'Ciências Sociais', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (168, '312A01', 'Antropologia', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (169, '313C01', 'Ciência política', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (170, '313R01', 'Relações Internacionais', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (171, '321C01', 'Cinema e Audiovisual', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (172, '321C02', 'Comunicação Social (Área Geral', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (173, '321J01', 'Jornalismo', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (174, '321R01', '"Radio, TV, Internet', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (175, '322A01', 'Arquivologia', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (176, '322B01', 'Biblioteconomia', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (181, '342P02', 'Publicidade e Propaganda', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (182, '342R01', 'Relações Públicas', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (184, '344C02', 'Ciências Contábeis', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (185, '345A01', 'Administração', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (197, '346S03', 'Secretariado Executivo', 3, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (199, '421C01', 'Ciências Biológicas', 4, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (201, '440C01', 'Bacharelado Interdisciplinar em Ciência e Tecnologia', 4, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (202, '441R01', 'Física Medica e Radioterapia', 4, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (204, '443G03', 'Geofísica', 4, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (205, '443G05', 'Geografia', 4, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (206, '443G06', 'Geologia', 4, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (207, '443O01', 'Oceanografia', 4, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (208, '462C01', 'Ciências Atuariais', 4, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (215, '483S02', 'Sistemas de Informação', 4, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (217, '520E01', 'Engenharia', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (218, '520E04', 'Engenharia de Materiais', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (219, '520E05', 'Engenharia de Produção', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (220, '520E09', 'Engenharia Ambiental e Sanitária', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (225, '521E05', 'Engenharia Mecânica', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (226, '521E06', 'Engenharia Metalúrgica', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (231, '522E06', 'Engenharia Elétrica', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (235, '523B01', 'Engenharia Biomédica', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (236, '523E09', 'Engenharia Eletrônica', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (237, '523E10', 'Engenharia mecatrônica', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (238, '523E11', 'Engenharia de Controle e Automação', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (239, '523E12', 'Engenharia de Telecomunicações', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (246, '524E01', 'Engenharia de Bioprocessos', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (247, '524E07', 'Engenharia Química', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (252, '525E04', 'Engenharia Aeronáutica', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (253, '525E05', 'Engenharia automotiva', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (254, '525E08', 'Engenharia Naval', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (259, '541E01', 'Engenharia de Alimentos', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (267, '542E03', 'Engenharia Têxtil', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (274, '544E01', 'Engenharia de Minas', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (276, '544E07', 'Engenharia de Petróleo', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (282, '582E02', 'Engenharia Cartográfica e de Agrimensura', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (283, '582E03', 'Engenharia Civil', 5, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (288, '621A04', 'Agronomia', 6, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (290, '621E03', 'Engenharia Agrícola', 6, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (296, '621Z01', 'Zootecnia', 6, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (300, '624E01', 'Engenharia de Pesca', 6, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (302, '641M01', 'Medicina Veterinária', 6, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (303, '720E01', 'Educação Física', 7, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (304, '720N01', 'Naturologia', 7, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (306, '723E01', 'Enfermagem', 7, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (309, '726Q01', 'Quiropraxia', 7, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (310, '726T01', 'Terapia Ocupacional', 7, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (311, '762S01', 'Serviço Social', 7, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (317, '812T01', 'Turismo', 8, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (320, '814E02', 'Economia doméstica', 8, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (323, '840C04', 'Ciências Aeronáuticas', 8, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (324, '840C05', 'Ciências Navais', 8, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (333, '863C01', 'Ciências Militares', 8, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (334, '863C02', 'Ciências da Logística', 8, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (335, '863F01', 'Formação Militar', 8, 1, '2015-06-30 21:47:05.352523', NULL, 3);
INSERT INTO educacenso_curso_superior (id, curso_id, nome, classe_id, user_id, created_at, updated_at, grau_academico) VALUES (337, '999991', 'Outro curso de formação superior', 9, 1, '2015-06-30 21:47:05.352523', NULL, 3);


--
-- Name: educacenso_curso_superior_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('educacenso_curso_superior_id_seq', 338, true);


--
-- Data for Name: educacenso_ies; Type: TABLE DATA; Schema: modules; Owner: postgres
--

INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (616, 776, 'FACULDADE DE CIENCIAS CONTABEIS DE JEQUIE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (848, 1116, 'FACULDADE CAICARAS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1319, 1614, 'FACULDADE ASTORGA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1390, 1685, 'FACULDADE BARDDAL DE CIENCIAS CONTABEIS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1484, 1779, 'FACULDADE AIEC', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1531, 1826, 'FACULDADE DE DIREITO DE LEOPOLDINA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1607, 1902, 'FACULDADE SANTO AGOSTINHO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1672, 1967, 'FACULDADE DO VALE DO ITAPECURU', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2178, 2474, 'FACULDADE MARIA MILZA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2458, 2754, 'FACULDADE SAO PAULO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2916, 3213, 'AFIMA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3299, 3600, 'FACULDADE DO LITORAL PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3508, 3810, 'NUCLEO DE CIENCIAS FIORAVANTI DI PIERO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3858, 4166, 'CENTRO DE ENSINO SUPERIOR DE UBERABA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4627, 4950, 'FACULDADE AUM', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4825, 5151, 'FACULDADE DE DIREITO (NOME FICTÍCIO APENAS PARA FINS DE CADASTRAMENTO E OBTENÇÃO DE SENHA)', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4836, 5162, 'FACULDADE COMUNITARIA DO PLANALTO CENTRAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5180, 5506, 'TESTE MEC', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5683, 15833, 'FACULDADE 2001', 4, 2, 'PE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1, 1, 'UNIVERSIDADE FEDERAL DE MATO GROSSO', 1, 1, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2, 2, 'UNIVERSIDADE DE BRASILIA', 1, 1, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3, 3, 'UNIVERSIDADE FEDERAL DE SERGIPE', 1, 1, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4, 4, 'UNIVERSIDADE FEDERAL DO AMAZONAS', 1, 1, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5, 5, 'UNIVERSIDADE FEDERAL DO PIAUI', 1, 1, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (6, 6, 'UNIVERSIDADE FEDERAL DE OURO PRETO', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (7, 7, 'UNIVERSIDADE FEDERAL DE SAO CARLOS', 1, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (8, 8, 'UNIVERSIDADE FEDERAL DE VICOSA', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (9, 9, 'UNIVERSIDADE ESTADUAL DE LONDRINA', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (10, 10, 'PONTIFICIA UNIVERSIDADE CATOLICA DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (11, 11, 'UNIVERSIDADE CATOLICA DE PERNAMBUCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (12, 12, 'UNIVERSIDADE FEDERAL DO RIO GRANDE', 1, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (13, 13, 'UNIVERSIDADE DE CAXIAS DO SUL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (14, 14, 'UNIVERSIDADE DO VALE DO RIO DOS SINOS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (15, 15, 'UNIVERSIDADE CATOLICA DE PETROPOLIS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (16, 16, 'UNIVERSIDADE GAMA FILHO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (17, 17, 'UNIVERSIDADE FEDERAL DE UBERLANDIA', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (18, 18, 'UNIVERSIDADE CATOLICA DE PELOTAS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (19, 19, 'PONTIFICIA UNIVERSIDADE CATOLICA DE CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (20, 20, 'UNIVERSIDADE DE PASSO FUNDO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (21, 21, 'PONTIFICIA UNIVERSIDADE CATOLICA DO RIO GRANDE DO SUL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (22, 22, 'UNIVERSIDADE PRESBITERIANA MACKENZIE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (23, 23, 'UNIVERSIDADE FEEVALE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (24, 24, 'UNIVERSIDADE ESTADUAL DE SANTA CRUZ', 2, 1, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (25, 26, 'ESCOLA NACIONAL DE CIENCIAS ESTATISTICAS', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (26, 27, 'UNIVERSIDADE VALE DO RIO VERDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (27, 29, 'UNIVERSIDADE ESTADUAL DO CEARA', 2, 1, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (28, 30, 'UNIVERSIDADE JOSE DO ROSARIO VELLANO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (29, 31, 'CENTRO DE EDUCACAO TECNICA DA UTRAMIG', 2, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (30, 32, 'UNIVERSIDADE ESTADUAL DE CIENCIAS DA SAUDE DE ALAGOAS UNCISAL', 2, 1, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (31, 33, 'FACULDADE DE TECNOLOGIA DE SOROCABA', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (32, 34, 'FACULDADE DE TECNOLOGIA DE SAO PAULO', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (33, 35, 'FACULDADE DE TECNOLOGIA DE AMERICANA', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (34, 36, 'FACULDADE DE TECNOLOGIA RUBENS LARA', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (35, 37, 'FACULDADE DE TECNOLOGIA DE JAHU', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (36, 38, 'UNIVERSIDADE DO ESTADO DO PARA', 2, 1, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (37, 39, 'INSTITUTO DE TECNOLOGIA DA AMAZONIA', 2, 1, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (38, 40, 'UNIVERSIDADE DO ESTADO DA BAHIA', 2, 1, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (39, 41, 'FACULDADE ESTADUAL DE EDUCACAO FISICA DE JACAREZINHO', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (40, 42, 'FACULDADE ESTADUAL DE DIREITO DO NORTE PIONEIRO', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (41, 43, 'FUNDACAO UNIVERSIDADE DO ESTADO DE SANTA CATARINA', 2, 1, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (42, 44, 'FACULDADE DE ENGENHARIA CIVIL DE ITAJUBA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (43, 45, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE ITAJUBA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (44, 46, 'FACULDADE ESTADUAL DE CIENCIAS ECONOMICAS DE APUCARANA', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (45, 47, 'UNIVERSIDADE ESTADUAL DE GOIAS', 2, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (46, 54, 'UNIVERSIDADE ESTADUAL DE CAMPINAS', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (47, 55, 'UNIVERSIDADE DE SAO PAULO', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (48, 56, 'UNIVERSIDADE ESTADUAL PAULISTA JULIO DE MESQUITA FILHO', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (49, 57, 'UNIVERSIDADE ESTADUAL DE MARINGA', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (50, 58, 'FACULDADE DE DIREITO DE SAO BERNARDO DO CAMPO', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (51, 59, 'FACULDADE DE DIREITO DE FRANCA', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (52, 60, 'CENTRO UNIVERSITARIO DE FRANCA', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (53, 61, 'ESCOLA SUPERIOR DE EDUCACAO FISICA DE AVARE', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (54, 62, 'FACULDADE DE CIENCIAS E LETRAS DE AVARE', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (55, 63, 'FACULDADE DE CIENCIAS DE BARRETOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (56, 64, 'FACULDADE DE ENGENHARIA DE BARRETOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (57, 65, 'FACULDADE DE ODONTOLOGIA DE BARRETOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (58, 66, 'FACULDADE DE DIREITO E ADMINISTRACAO DE BARRETOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (59, 67, 'ESCOLA DE ENGENHARIA DE PIRACICABA', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (60, 68, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE PENAPOLIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (61, 71, 'UNIVERSIDADE DO ESTADO DO RIO GRANDE DO NORTE', 2, 1, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (62, 72, 'FACULDADE DE FORMACAO DE PROFESSORES DA MATA SUL', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (63, 73, 'CENTRO DE ENSINO SUPERIOR DE ARCOVERDE', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (64, 74, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE SAO JOSE DO RIO PARDO', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (65, 75, 'FACULDADE ESTADUAL DE EDUCACAO CIENCIAS E LETRAS DE PARANAVAI', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (66, 76, 'UNIVERSIDADE REGIONAL DE BLUMENAU', 3, 1, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (67, 77, 'FACULDADE DA REGIAO DOS LAGOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (68, 78, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE ALEGRE', 3, 1, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (69, 79, 'INSTITUTO MUNICIPAL DE ENSINO SUPERIOR DE CATANDUVA', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (70, 80, 'CENTRO UNIVERSITARIO PARA O DESENVOLVIMENTO DO ALTO VALE DO ITAJAI', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (71, 81, 'UNIVERSIDADE DA REGIAO DE JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (72, 82, 'UNIVERSIDADE DO OESTE DE SANTA CATARINA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (73, 83, 'UNIVERSIDADE DO VALE DO ITAJAI', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (74, 84, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE MACAE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (75, 85, 'FACULDADE DE FILOSOFIA DE ITAPERUNA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (76, 86, 'FACULDADE DE CIENCIAS HUMANAS E SOCIAIS PADRE HUMBERTO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (77, 87, 'CENTRO UNIVERSITARIO DE BRUSQUE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (78, 88, 'FACULDADE DE FORMACAO DE PROFESSORES DE PENEDO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (79, 89, 'FUNDACAO FACULDADES LUIZ MENEGHEL', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (80, 90, 'ESCOLA SUPERIOR DE EDUCACAO CIENCIAS E LETRAS DE RIO VERDE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (81, 91, 'ESCOLA SUPERIOR DE CIENCIAS AGRARIAS DE RIO VERDE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (82, 92, 'ESCOLA SUPERIOR CIENCIAS HUMANAS E EXATAS DE RIO VERDE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (83, 93, 'FACULDADE DE MEDICINA DE JUNDIAI', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (84, 94, 'ESCOLA SUPERIOR DE EDUCACAO FISICA DE JUNDIAI', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (85, 95, 'UNIVERSIDADE ESTADUAL DO VALE DO ACARAU', 2, 1, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (86, 96, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS PROFESSOR JOSE AUGUSTO VIEIRA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (87, 97, 'ESCOLA SUPERIOR DE AGRICULTURA E CIENCIAS DE MACHADO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (88, 98, 'FACULDADE DE ADMINISTRACAO E FINANCAS DE MACHADO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (89, 99, 'FACULDADE DE DIREITO DE CONSELHEIRO LAFAIETE', 3, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (90, 100, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE ARAXA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (91, 101, 'FACULDADE DE CIENCIAS GERENCIAIS DO ALTO PARANAIBA', 3, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (92, 102, 'FACULDADE DE DIREITO DO ALTO PARANAIBA', 3, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (93, 103, 'FACULDADE DE FILOSOFIA, CIENCIAS E LETRAS DE ARAGUARI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (94, 104, 'FACULDADE DE CIENCIAS ECONOMICAS DE PATOS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (95, 105, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE PATOS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (96, 106, 'FACULDADE DE EDUCACAO DE PATOS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (97, 107, 'UNIVERSIDADE FEDERAL DE SAO JOAO DEL REI', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (98, 108, 'ESCOLA SUPERIOR DE EDUCACAO FISICA E TECNICAS DESPORTIVAS DE ANDRADINA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (99, 109, 'FACULDADES INTEGRADAS RUI BARBOSA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (100, 110, 'FACULDADE DE DIREITO DE SETE LAGOAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (101, 111, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE SETE LAGOAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (102, 122, 'FACULDADE DE ENGENHARIA DE AGRIMENSURA DE ARARAQUARA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (103, 123, 'FACULDADE DE ENGENHARIA CIVIL DE ARARAQUARA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (104, 124, 'CENTRO UNIVERSITARIO DE ARARAQUARA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (105, 125, 'CENTRO UNIVERSITARIO DE ARARAS  ', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (106, 126, 'INSTITUTO NACIONAL DE TELECOMUNICACOES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (107, 127, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DE ATIBAIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (108, 128, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE TEOFILO OTONI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (109, 129, 'FACULDADE DE DIREITO DE TEOFILO OTONI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (110, 130, 'FACULDADE DE ADMINISTRACAO DE TEOFILO OTONI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (111, 131, 'FACULDADE DE EDUCACAO FISICA DE BARRA BONITA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (112, 132, 'FACULDADE DE EDUCACAO ANTONIO AUGUSTO REIS NEVES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (113, 133, 'FACULDADE DE CIENCIAS CONTABEIS DE BARRETOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (114, 134, 'FACULDADE DE TECNOLOGIA E PROCESSAMENTO DE DADOS BARRETOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (115, 135, 'CENTRO UNIVERSITARIO CLARETIANO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (116, 136, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE BEBEDOURO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (117, 137, 'UNIVERSIDADE DO SAGRADO CORACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (118, 138, 'CENTRO UNIVERSITARIO BARAO DE MAUA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (119, 139, 'FACULDADE DE CIENCIAS ECONOMICAS DO TRIANGULO MINEIRO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (120, 140, 'UNIVERSIDADE SEVERINO SOMBRA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (121, 141, 'FACULDADE DE DIREITO DE VARGINHA FADIVA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (122, 142, 'CENTRO UNIVERSITARIO DO TRIANGULO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (123, 143, 'UNIVERSIDADE DE UBERABA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (124, 144, 'FACULDADE DE CIENCIAS HUMANAS DE OLINDA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (125, 145, 'FACULDADE DE CIENCIAS HUMANAS E SOCIAIS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (126, 146, 'CENTRO UNIVERSITARIO DE RIO PRETO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (127, 149, 'FACULDADE DE MEDICINA DE SAO JOSE DO RIO PRETO', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (128, 150, 'UNIVERSIDADE DE SOROCABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (129, 151, 'ESCOLA DE ADMINISTRACAO DE EMPRESAS DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (130, 152, 'FACULDADE DE CIENCIAS CONTABEIS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (131, 158, 'CONSERVATORIO BRASILEIRO DE MUSICA CENTRO UNIVERSITARIO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (132, 159, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE CARUARU', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (133, 160, 'FACULDADE FRASSINETTI DO RECIFE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (134, 161, 'CENTRO UNIVERSITARIO ASSUNCAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (135, 162, 'CENTRO UNIVERSITARIO BELAS ARTES DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (136, 163, 'UNIVERSIDADE ESTACIO DE SA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (137, 165, 'UNIVERSIDADE VEIGA DE ALMEIDA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (138, 166, 'FAI CENTRO DE ENSINO SUPERIOR EM GESTAO, TECNOLOGIA E EDUCACAO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (139, 167, 'UNIVERSIDADE METODISTA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (140, 170, 'FACULDADES DA FUNDACAO DE ENSINO DE MOCOCA', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (141, 171, 'FACULDADE DE DIREITO DO SUL DE MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (142, 172, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS EUGENIO PACELLI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (143, 173, 'FACULDADE DE CIENCIAS MEDICAS DR JOSE ANTONIO GARCIA COUTINHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (144, 174, 'INSTITUTO SUPERIOR DE ESTUDOS SOCIAIS CLOVIS BEVILACQUA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (145, 176, 'UNIVERSIDADE CASTELO BRANCO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (146, 177, 'FACULDADE DE CIENCIAS ECONOMICAS E DE ADMINISTRACAO DE EMPRESAS DE SAO JOSE DO RIO PRETO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (147, 178, 'FACULDADE DE ENGENHARIA DE SAO JOSE DO RIO PRETO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (148, 179, 'FACULDADE DE ARQUITETURA E URBANISMO DE SAO JOSE DO RIO PRETO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (149, 180, 'FACULDADE DE DIREITO DE CARUARU', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (150, 181, 'FACULDADE DE ODONTOLOGIA DE CARUARU', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (151, 190, 'ESCOLA DE MEDICINA SOUZA MARQUES DA FUNDACAO TECNICO EDUCACIONAL SOUZA MARQUES', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (152, 191, 'FACULDADE DE CIENCIAS CONTABEIS E DE ADMINISTRACAO DE EMPRESAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (153, 192, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS SOUZA MARQUES', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (154, 193, 'FACULDADE DE ENGENHARIA SOUZA MARQUES', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (155, 194, 'ESCOLA DE ENFERMAGEM DA FUNDACAO TECNICO EDUCACIONAL SOUZA MARQUES', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (156, 195, 'FACULDADE MORAES JUNIOR MACKENZIE RIO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (157, 197, 'FACULDADE DE EDUCACAO SUPERIOR DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (158, 198, 'CENTRO UNIVERSITARIO DA CIDADE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (159, 199, 'FACULDADE SAO LUIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (160, 200, 'FACULDADE CASPER LIBERO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (161, 201, 'FACULDADE BRASILEIRA DE CIENCIAS JURIDICAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (162, 202, 'FACULDADE DE ECONOMIA E FINANCAS DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (163, 203, 'UNIVERSIDADE SAO JUDAS TADEU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (164, 206, 'CENTRO UNIVERSITARIO ITALOBRASILEIRO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (165, 207, 'CENTRO UNIVERSITARIO MOURA LACERDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (166, 208, 'UNIVERSIDADE DE RIBEIRAO PRETO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (167, 210, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE SANTO ANDRE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (168, 211, 'FACULDADE DE CIENCIAS ECONOMICAS E ADMINISTRATIVAS DE SANTO ANDRE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (169, 212, 'FACULDADE DE FILOSOFIA DE CAMPO GRANDE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (170, 213, 'CENTRO UNIVERSITARIO FECAP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (171, 214, 'FACULDADE DE ENGENHARIA DE MINAS GERAIS FEAMIG', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (172, 215, 'UNIVERSIDADE DO GRANDE ABC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (173, 216, 'CENTRO UNIVERSITARIO METODISTA IZABELA HENDRIX', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (174, 217, 'CENTRO UNIVERSITARIO DAS FACULDADES ASSOCIADAS DE ENSINO FAE', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (175, 218, 'FACULDADE DE FILOSOFIA, CIENCIAS E LETRAS DE DUQUE DE CAXIAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (176, 219, 'FACULDADE DE EDUCACAO CIENCIAS E ARTES DOM BOSCO DE MONTE APRAZIVEL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (177, 220, 'FACULDADE SAO JUDAS TADEU', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (178, 221, 'UNIVERSIDADE CRUZEIRO DO SUL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (179, 222, 'CENTRO UNIVERSITARIO DE VOTUPORANGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (180, 223, 'FACULDADE DE EDUCACAO FISICA DE SANTO ANDRE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (181, 224, 'FACULDADE DE MEDICINA DO ABC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (182, 225, 'INSTITUTO DE ENSINO SUPERIOR SANTO ANDRE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (183, 226, 'CENTRO UNIVERSITARIO LUSIADA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (184, 227, 'UNIVERSIDADE CATOLICA DE SANTOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (185, 228, 'FACULDADE DE ENGENHARIA INDUSTRIAL DE SAO BERNARDO DO CAMPO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (186, 229, 'ESCOLA SUPERIOR DE ADMINISTRACAO DE NEGOCIOS DE SAO BERNARDO DO CAMPO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (187, 230, 'ESCOLA SUPERIOR DE ADMINISTRACAO DE NEGOCIOS DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (188, 231, 'FACULDADE DE SAO BERNARDO DO CAMPO FASB', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (189, 234, 'FACULDADES OSWALDO CRUZ', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (190, 236, 'FACULDADE DE CIENCIAS CONTABEIS E ADMINISTRATIVAS DE SAO JOAO DA BOA VISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (191, 237, 'FACULDADE DE DIREITO DE SAO JOAO DA BOA VISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (192, 238, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE SAO JOAO DA BOA VISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (193, 239, 'FACULDADE DE MEDICINA VETERINARIA OCTAVIO BASTOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (194, 240, 'UNIVERSIDADE SANTA URSULA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (195, 241, 'FACULDADE DE ENGENHARIA QUIMICA DE LORENA', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (196, 242, 'CENTRO UNIVERSITARIO ANHANGUERA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (197, 243, 'FACULDADE DO CLUBE NAUTICO MOGIANO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (198, 244, 'CENTRO UNIVERSITARIO FIEO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (199, 245, 'FACULDADE DE ADMINISTRACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (200, 254, 'CENTRO UNIVERSITARIO CAPITAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (201, 255, 'FACULDADE DE ENGENHARIA E AGRIMENSURA DE PIRASSUNUNGA FEAP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (202, 256, 'FACULDADE DE FILOSOFIA, CIENCIAS E LETRAS DE PIRAJU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (203, 257, 'FACULDADE DE ADMINISTRACAO E CIENCIAS CONTABEIS LUZWELL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (204, 263, 'FACULDADES INTEGRADAS CAMPOS SALLES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (205, 264, 'UNIVERSIDADE SAO MARCOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (206, 265, 'FACULDADES INTEGRADAS DE OURINHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (207, 266, 'UNIVERSIDADE METODISTA DE PIRACICABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (208, 267, 'FACULDADES INTEGRADAS ESPIRITO SANTENSES', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (209, 268, 'FACULDADE DE DIREITO DA ALTA PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (210, 269, 'FACULDADE FACCAT', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (211, 270, 'FACULDADES ESEFAP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (212, 271, 'UNIVERSIDADE DO OESTE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (213, 273, 'ESCOLA DE ENGENHARIA INDUSTRIAL DE SAO JOSE DOS CAMPOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (214, 274, 'FACULDADE DE CIENCIAS APLICADAS DE SAO JOSE DOS CAMPOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (215, 275, 'UNIVERSIDADE DO VALE DO PARAIBA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (216, 276, 'FACULDADE DE DIREITO DE SOROCABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (217, 277, 'CENTRO UNIVERSITARIO AUGUSTO MOTTA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (218, 278, 'FACULDADES INTEGRADAS SIMONSEN', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (219, 279, 'FACULDADES INTEGRADAS HELIO ALONSO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (220, 280, 'FACULDADE DE DIREITO DO OESTE DE MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (221, 281, 'CONSERVATORIO DRAMATICO MUSICAL SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (222, 282, 'FACULDADE DE CIENCIAS ADMINISTRATIVAS E CONTABEIS COSTA BRAGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (223, 283, 'FACULDADE DE EDUCACAO COSTA BRAGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (224, 284, 'FACULDADE DE MEDICINA DE ITAJUBA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (225, 288, 'FACULDADE DE DIREITO DO VALE DO RIO DOCE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (226, 289, 'FACULDADE DE EDUCACAO DE JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (227, 290, 'FACULDADE DE DIREITO DE JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (228, 291, 'FACULDADE DE PSICOLOGIA DE JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (229, 292, 'FACULDADE DE CIENCIAS DA SAUDE DE JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (230, 293, 'FACULDADE DE CIENCIAS E TECNOLOGIA DE JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (231, 294, 'FACULDADE TRES DE MAIO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (232, 295, 'UNIVERSIDADE DE SANTA CRUZ DO SUL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (233, 296, 'UNIVERSIDADE DA REGIAO DA CAMPANHA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (234, 297, 'FACULDADE DE CIENCIAS CONTABEIS E ADMINISTRATIVAS SAO JUDAS TADEU', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (235, 298, 'UNIVERSIDADE NORTE DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (236, 299, 'FACULDADE DE JANDAIA DO SUL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (237, 300, 'FACULDADE DE FILOSOFIA, CIENCIAS E LETRAS DE FORMIGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (238, 301, 'ESCOLA DE BIBLIOTECONOMIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (239, 302, 'FACULDADE DE CIENCIAS ECONOMICAS, ADMINISTRATIVAS E CONTABEIS DE DIVINOPOLIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (240, 303, 'FACULDADE DE FILOSOFIA, CIENCIAS E LETRAS DE CATAGUASES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (241, 304, 'FACULDADE DE CIENCIAS CONTABEIS DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (242, 307, 'FACULDADE DE MEDICINA DE BARBACENA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (243, 308, 'UNIVERSIDADE PRESIDENTE ANTONIO CARLOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (244, 316, 'UNIVERSIDADE NOVE DE JULHO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (245, 317, 'FACULDADES INTEGRADAS ALCANTARA MACHADO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (246, 318, 'FACULDADE DE ARTES ALCANTARA MACHADO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (247, 319, 'UNIVERSIDADE CAMILO CASTELO BRANCO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (248, 320, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE TATUI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (249, 321, 'FACULDADE DE DESENHO DE TATUI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (250, 322, 'UNIVERSIDADE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (251, 328, 'FACULDADE DE CIENCIAS JURIDICAS E SOCIAIS VIANNA JUNIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (252, 329, 'ESCOLA SUPERIOR DE AGRONOMIA DE PARAGUACU PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (253, 330, 'UNIVERSIDADE IGUACU', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (254, 332, 'ESCOLA DE ENGENHARIA DE LINS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (255, 333, 'FACULDADE DE INFORMATICA DE LINS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (256, 334, 'FACULDADE DE SERVICO SOCIAL DE LINS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (257, 335, 'FACULDADE DE EDUCACAO E CIENCIAS PINHEIRENSE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (258, 336, 'FACULDADE MACHADO SOBRINHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (259, 337, 'CENTRO DE ENSINO SUPERIOR DE JUIZ DE FORA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (260, 338, 'PONTIFICIA UNIVERSIDADE CATOLICA DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (261, 339, 'FACULDADE SANTA EMILIA DE RODAT', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (262, 343, 'CENTRO UNIVERSITARIO NEWTON PAIVA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (263, 344, 'CENTRO UNIVERSITARIO UNA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (264, 345, 'ESCOLA DE ENGENHARIA KENNEDY', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (265, 346, 'INSTITUTO SUPERIOR DE CIENCIAS APLICADAS ISCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (266, 349, 'CENTRO UNIVERSITARIO DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (267, 351, 'FACULDADE DE CIENCIAS MEDICAS DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (268, 352, 'CENTRO UNIVERSITARIO DE JOAO PESSOA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (269, 353, 'FACULDADE EVANGELICA DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (270, 355, 'UNIVERSIDADE TUIUTI DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (271, 359, 'ESCOLA SUPERIOR DE EDUCACAO FISICA DE MUZAMBINHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (272, 360, 'CENTRO UNIVERSITARIO PAULISTANO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (273, 361, 'FACULDADE PAULISTA DE SERVICO SOCIAL DE SAO CAETANO DO SUL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (274, 362, 'FACULDADE PAULISTA DE SERVICO SOCIAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (275, 363, 'FACULDADE MOZARTEUM DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (276, 364, 'FACULDADE DE CIENCIAS CONTABEIS DE PONTE NOVA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (277, 367, 'UNIVERSIDADE ESTADUAL DE MONTES CLAROS', 2, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (278, 368, 'FACULDADE DE EDUCACAO FISICA DA ASSOCIACAO CRISTA DE MOCOS DE SOROCABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (279, 369, 'FACULDADE AUXILIUM DE FILOSOFIA CIENCIAS E LETRAS DE LINS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (280, 370, 'FACULDADE PAULISTA DE ARTES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (281, 371, 'FACULDADE DE MUSICA CARLOS GOMES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (282, 372, 'FACULDADE DE BIBLIOTECONOMIA E CIENCIA DA INFORMACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (283, 373, 'ESCOLA DE SOCIOLOGIA E POLITICA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (284, 374, 'CENTRO UNIVERSITARIO DAS FACULDADES METROPOLITANAS UNIDAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (285, 375, 'UNIVERSIDADE DE SANTO AMARO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (286, 376, 'CENTRO UNIVERSITARIO ANHANGUERA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (287, 377, 'FACULDADE DE EDUCACAO PADRE ANCHIETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (288, 378, 'FACULDADE DE DIREITO PADRE ANCHIETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (289, 379, 'FACULDADE DE CIENCIAS E LETRAS PADRE ANCHIETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (290, 380, 'FACULDADE DE CIENCIAS ECONOMICAS, CONTABEIS E DE ADM DE EMPRESAS PADRE ANCHIETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (291, 381, 'FACULDADE DE PSICOLOGIA PADRE ANCHIETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (292, 382, 'FACULDADE DE TECNOLOGIA PADRE ANCHIETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (293, 383, 'UNIVERSIDADE DA AMAZONIA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (294, 384, 'CENTRO UNIVERSITARIO DE ANAPOLIS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (295, 385, 'UNIVERSIDADE SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (296, 386, 'CENTRO UNIVERSITARIO DE GOIAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (297, 387, 'UNIVERSIDADE CATOLICA DOM BOSCO', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (298, 388, 'FACULDADE DE CIENCIAS CONTABEIS E ATUARIAIS DA ALTA NOROESTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (299, 389, 'FACULDADE DE CIENCIAS ADMINISTRATIVAS E CONTABEIS DE LINS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (300, 390, 'FACULDADE DE EDUCACAO FISICA DE LINS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (301, 391, 'FACULDADE DE TECNOLOGIA DA ALTA NOROESTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (302, 395, 'FACULDADE DE CIENCIAS CONTABEIS DE LUCELIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (303, 396, 'FACULDADE RUY BARBOSA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (304, 397, 'FACULDADE RUY BARBOSA DE TECNOLOGIA EM PROCESSAMENTO DE DADOS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (305, 398, 'UNIVERSIDADE TIRADENTES', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (306, 399, 'ESCOLA DE ENGENHARIA DE AGRIMENSURA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (307, 400, 'FACULDADE DE DIREITO DE OLINDA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (308, 401, 'CENTRO DE ESTUDOS SUPERIORES BARROS MELO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (309, 402, 'CENTRO UNIVERSITARIO DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (310, 403, 'UNIVERSIDADE CATOLICA DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (311, 404, 'FACULDADES INTEGRADAS DA UPIS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (312, 405, 'FOCCA FACULDADE DE OLINDA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (313, 408, 'ESCOLA SUPERIOR DE RELACOES PUBLICAS', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (314, 409, 'UNIVERSIDADE DE PERNAMBUCO', 2, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (315, 410, 'FACULDADE DE CIENCIAS HUMANAS ESUDA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (316, 413, 'FACULDADE PORTOALEGRENSE DE EDUCACAO, CIENCIAS E LETRAS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (317, 414, 'FACULDADE PORTOALEGRENSE DE CIENCIAS CONTABEIS E ADMINISTRATIVAS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (318, 415, 'FACULDADE DE CIENCIAS MEDICAS DA SANTA CASA SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (319, 416, 'FACULDADE DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (320, 417, 'UNIVERSIDADE CIDADE DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (321, 420, 'UNIVERSIDADE DE MARILIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (322, 421, 'FACULDADE ESTADUAL DE CIENCIAS E LETRAS DE CAMPO MOURAO', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (323, 423, 'UNIVERSIDADE REGIONAL INTEGRADA DO ALTO URUGUAI E DAS MISSOES', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (324, 424, 'FACULDADE DE CIENCIAS CONTABEIS E ADMINISTRATIVAS DE SANTA ROSA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (325, 425, 'FACULDADE DE EDUCACAO ARTISTICA DE SANTA ROSA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (326, 426, 'CENTRO UNIVERSITARIO FRANCISCANO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (327, 428, 'FACULDADE DE CIENCIAS CONTABEIS E DE ADMINISTRACAO DE MARILIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (328, 429, 'FACULDADE DE DIREITO DE MARILIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (329, 430, 'CENTRO UNIVERSITARIO FILADELFIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (330, 431, 'FACULDADE DE MEDICINA DE MARILIA', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (331, 432, 'FACULDADE PARANAENSE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (332, 433, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE PALMAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (333, 434, 'FACULDADE SANTA MARCELINA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (334, 435, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS SANTA MARCELINA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (335, 436, 'FACULDADE DE CIENCIAS DA SAUDE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (336, 437, 'UNIVERSIDADE PARANAENSE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (337, 438, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE ITUVERAVA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (338, 439, 'FACULDADE DOUTOR FRANCISCO MAEDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (339, 440, 'FACULDADE DE DIREITO DE ITU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (340, 441, 'UNIVERSIDADE DO CONTESTADO', 3, 1, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (341, 442, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE ITARARE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (342, 443, 'FACULDADE DE CIENCIAS CONTABEIS E ADMINISTRATIVAS DE ITARARE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (343, 446, 'UNIVERSIDADE DE CRUZ ALTA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (344, 447, 'FACULDADE CATOLICA DE CIENCIAS ECONOMICAS DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (345, 448, 'CENTRO UNIVERSITARIO RITTER DOS REIS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (346, 449, 'UNIVERSIDADE LUTERANA DO BRASIL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (347, 450, 'CENTRO UNIVERSITARIO LUTERANO DE JIPARANA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (348, 451, 'CENTRO UNIVERSITARIO LUTERANO DE SANTAREM', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (349, 452, 'CENTRO UNIVERSITARIO LUTERANO DE MANAUS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (350, 453, 'CENTRO UNIVERSITARIO LUTERANO DE PALMAS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (351, 454, 'FACULDADE CAMAQUENSE DE CIENCIAS CONTABEIS E ADMINISTRATIVAS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (352, 455, 'FACULDADE DE FORMACAO DE PROFESSORES E ESPECIALISTAS DE EDUCACAO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (353, 456, 'CENTRO UNIVERSITARIO SANT´ANNA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (354, 457, 'UNIVERSIDADE BANDEIRANTE ANHANGUERA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (355, 458, 'UNIVERSIDADE IBIRAPUERA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (356, 459, 'FACULDADE RENASCENCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (357, 460, 'FACULDADE DE ARTES PLASTICAS DA FUNDACAO ARMANDO ALVARES PENTEADO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (358, 461, 'FACULDADE DE ADMINISTRACAO DA FUNDACAO ARMANDO ALVARES PENTEADO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (359, 462, 'FACULDADE DE ENGENHARIA DA FUNDACAO ARMANDO ALVARES PENTEADO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (360, 463, 'FACULDADE DE COMUNICACAO E MARKETING DA FUNDACAO ARMANDO ALVARES PENTEADO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (361, 464, 'FACULDADE DE ECONOMIA DA FUNDACAO ARMANDO ALVARES PENTEADO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (362, 465, 'FACULDADE DE COMPUTACAO E INFORMATICA DA FUNDACAO ARMANDO ALVARES PENTEADO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (363, 466, 'UNIVERSIDADE ANHEMBI MORUMBI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (364, 467, 'FACULDADE DE CIENCIAS CONTABEIS DE ITAPETININGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (365, 468, 'FACULDADE DE FILOSOFIA, CIENCIAS E LETRAS DE ITAPETININGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (366, 469, 'ABEU FACULDADES INTEGRADAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (367, 470, 'FACULDADE DE ODONTOLOGIA DE NOVA FRIBURGO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (368, 472, 'UNIVERSIDADE DO GRANDE RIO PROFESSOR JOSE DE SOUZA HERDY', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (369, 473, 'FACULDADE DE CIENCIAS ECONOMICAS, ADMINISTRATIVAS E DA COMPUTACAO DOM BOSCO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (370, 474, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DOM BOSCO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (371, 475, 'FACULDADE DE MEDICINA DE PETROPOLIS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (372, 480, 'CENTRO UNIVERSITARIO SERRA DOS ORGAOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (373, 481, 'UNIVERSIDADE GUARULHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (374, 482, 'UNIVERSIDADE DO EXTREMO SUL CATARINENSE', 3, 1, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (375, 483, 'CENTRO UNIVERSITARIO METROPOLITANO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (376, 486, 'FACULDADE DE FORMACAO DE PROFESSORES DE ARAPIRACA', 2, 1, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (377, 487, 'FACULDADE DE ADMINISTRACAO, CIENCIAS CONTABEIS, JURIDICAS E SOCIAIS DO ESTADO DE ALAGOAS', 2, 1, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (378, 488, 'ESCOLA SUPERIOR DE CIENCIAS HUMANAS FISICAS E BIOLOGICAS DO SERTAO', 2, 1, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (379, 489, 'CENTRO UNIVERSITARIO DE VOLTA REDONDA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (380, 490, 'CENTRO DE ENSINO SUPERIOR DE VALENCA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (381, 491, 'FACULDADE DE EDUCACAO CIENCIAS E LETRAS DON DOMENICO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (382, 492, 'FACULDADE DE ADMINISTRACAO CIENCIAS ECON E CONTABEIS DE GUARATINGUETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (383, 493, 'FACULDADE DE EDUCACAO DE GUARATINGUETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (384, 494, 'UNIVERSIDADE DO SUL DE SANTA CATARINA', 3, 1, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (385, 495, 'FACULDADE DE CIENCIAS E LETRAS DE BRAGANCA PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (386, 496, 'UNIVERSIDADE DE FRANCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (387, 498, 'ESCOLA SUPERIOR DE EDUCACAO FISICA E DESPORTOS DE CATANDUVA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (388, 499, 'FACULDADE DE DIREITO E ADMINISTRACAO CATANDUVA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (389, 500, 'FACULDADE DE MEDICINA DE CATANDUVA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (390, 501, 'ESCOLA SUPERIOR DE CIENCIAS DA SANTA CASA DE MISERICORDIA DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (391, 502, 'CENTRO UNIVERSITARIO MONTE SERRAT', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (392, 503, 'FACULDADE DE DIREITO DE CAMPOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (393, 504, 'FACULDADE DE ODONTOLOGIA DE CAMPOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (394, 505, 'FACULDADE DE FILOSOFIA DE CAMPOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (395, 506, 'FACULDADE DE MEDICINA DE CAMPOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (396, 507, 'FACULDADE TRIANGULO MINEIRO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (397, 508, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DO SUL DE MINAS   FACESM', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (398, 509, 'FACULDADES INTEGRADAS DE CRUZEIRO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (399, 510, 'ESCOLA DE ENFERMAGEM WENCESLAU BRAZ', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (400, 511, 'FACULDADE DE FILOSOFIA, CIENCIAS E LETRAS DE GUAXUPE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (401, 512, 'FACULDADE DE CIENCIAS ADMINISTRATIVAS ECONOMICAS E CONTABEIS DE GUAXUPE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (402, 513, 'UNIVERSIDADE VALE DO RIO DOCE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (403, 514, 'CENTRO UNIVERSITARIO DE BARRA MANSA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (404, 515, 'CENTRO UNIVERSITARIO ANHANGUERA DE NITEROI', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (405, 516, 'CENTRO UNIVERSITARIO MOACYR SREDER BASTOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (406, 517, 'FACULDADE DE EDUCACAO SAO LUIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (407, 518, 'CENTRO UNIVERSITARIO DO DISTRITO FEDERAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (408, 519, 'UNIVERSIDADE CATOLICA DO SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (409, 521, 'UNIVERSIDADE DE MOGI DAS CRUZES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (410, 522, 'CENTRO UNIVERSITARIO CELSO LISBOA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (411, 524, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE OURO FINO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (412, 526, 'UNIVERSIDADE BRAZ CUBAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (413, 527, 'PONTIFICIA UNIVERSIDADE CATOLICA DE GOIAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (414, 528, 'PONTIFICIA UNIVERSIDADE CATOLICA DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (415, 530, 'FACULDADE DE MUSICA DO ESPIRITO SANTO', 2, 1, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (416, 531, 'FACULDADE DE FORMACAO DE PROFESSORES DE VITORIA DE SANTO ANTAO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (417, 532, 'UNIVERSIDADE REGIONAL DO NOROESTE DO ESTADO DO RIO GRANDE DO SUL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (418, 533, 'FACULDADES INTEGRADAS DE ITAPETININGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (419, 534, 'ESCOLA BAHIANA DE MEDICINA E SAUDE PUBLICA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (420, 535, 'CENTRO UNIVERSITARIO DE MANDAGUARI UNIMAN', 3, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (421, 543, 'FACULDADE DE CIENCIAS DA FUNDACAO INSTITUTO TECNOLOGICO DE OSASCO', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (422, 544, 'FACULDADE DE CIENCIAS HUMANAS DE ITABIRA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (423, 545, 'FACULDADE DE CIENCIAS ADMINISTRATIVAS E CONTABEIS DE ITABIRA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (424, 546, 'PONTIFICIA UNIVERSIDADE CATOLICA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (425, 547, 'UNIVERSIDADE DO ESTADO DO RIO DE JANEIRO', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (426, 548, 'UNIVERSIDADE FEDERAL DO MARANHAO', 1, 1, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (427, 549, 'UNIVERSIDADE FEDERAL DO ACRE', 1, 1, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (428, 550, 'UNIVERSIDADE ESTADUAL DA PARAIBA', 2, 1, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (429, 552, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (430, 553, 'FACULDADE DE CIENCIAS ADMINISTRATIVAS DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (431, 554, 'FACULDADE DE FILOSOFIA, CIENCIAS E LETRAS DE BOA ESPERANCA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (432, 555, 'UNIVERSIDADE DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (433, 556, 'CONSERVATORIO DE MUSICA DE NITEROI', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (434, 557, 'ESCOLA DE MUSICA E BELAS ARTES DO PARANA', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (435, 558, 'FACULDADE DE ARTES DO PARANA', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (436, 568, 'UNIVERSIDADE ESTADUAL DO MARANHAO', 2, 1, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (437, 569, 'UNIVERSIDADE FEDERAL DO PARA', 1, 1, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (438, 570, 'UNIVERSIDADE FEDERAL DO RIO GRANDE DO NORTE', 1, 1, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (439, 571, 'UNIVERSIDADE FEDERAL DO PARANA', 1, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (440, 572, 'UNIVERSIDADE FEDERAL FLUMINENSE', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (441, 573, 'UNIVERSIDADE FEDERAL DO ESPIRITO SANTO', 1, 1, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (442, 574, 'UNIVERSIDADE FEDERAL RURAL DO RIO DE JANEIRO', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (443, 575, 'UNIVERSIDADE FEDERAL DE MINAS GERAIS', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (444, 576, 'UNIVERSIDADE FEDERAL DE JUIZ DE FORA', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (445, 577, 'UNIVERSIDADE FEDERAL DE ALAGOAS', 1, 1, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (446, 578, 'UNIVERSIDADE FEDERAL DA BAHIA', 1, 1, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (447, 579, 'UNIVERSIDADE FEDERAL DA PARAIBA', 1, 1, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (448, 580, 'UNIVERSIDADE FEDERAL DE PERNAMBUCO', 1, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (449, 581, 'UNIVERSIDADE FEDERAL DO RIO GRANDE DO SUL', 1, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (450, 582, 'UNIVERSIDADE FEDERAL DE SANTA MARIA', 1, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (451, 583, 'UNIVERSIDADE FEDERAL DO CEARA', 1, 1, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (452, 584, 'UNIVERSIDADE FEDERAL DE GOIAS', 1, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (453, 585, 'UNIVERSIDADE FEDERAL DE SANTA CATARINA', 1, 1, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (454, 586, 'UNIVERSIDADE FEDERAL DO RIO DE JANEIRO', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (455, 587, 'UNIVERSIDADE FEDERAL RURAL DE PERNAMBUCO', 1, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (456, 588, 'UNIVERSIDADE TECNOLOGICA FEDERAL DO PARANA', 1, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (457, 589, 'UNIVERSIDADE FEDERAL RURAL DO SEMIARIDO', 1, 1, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (458, 590, 'UNIVERSIDADE FEDERAL RURAL DA AMAZONIA', 1, 1, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (459, 591, 'UNIVERSIDADE FEDERAL DE SAO PAULO', 1, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (460, 592, 'UNIVERSIDADE FEDERAL DE LAVRAS', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (461, 593, 'CENTRO FEDERAL DE EDUCACAO TECNOLOGICA CELSO SUCKOW DA FONSECA', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (462, 594, 'CENTRO FEDERAL DE EDUCACAO TECNOLOGICA DE MINAS GERAIS', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (463, 595, 'UNIVERSIDADE FEDERAL DE ALFENAS', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (464, 596, 'UNIVERSIDADE FEDERAL DOS VALES DO JEQUITINHONHA E MUCURI', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (465, 597, 'UNIVERSIDADE FEDERAL DO TRIANGULO MINEIRO', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (466, 598, 'UNIVERSIDADE FEDERAL DE ITAJUBA UNIFEI', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (467, 599, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DA BAHIA', 1, 1, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (468, 600, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO MARANHAO', 1, 1, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (469, 601, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO RIO GRANDE DO SUL', 1, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (470, 602, 'INSTITUTO TECNOLOGICO DE AERONAUTICA', 1, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (471, 605, 'UNIVERSIDADE MUNICIPAL DE SAO CAETANO DO SUL', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (472, 606, 'FACULDADE DE DIREITO DE CACHOEIRO DO ITAPEMIRIM', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (473, 607, 'FACULDADE DE CIENCIAS CONTABEIS E ADMINISTRATIVAS DE CACHOEIRO DO ITAPEMIRIM', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (474, 608, 'ESCOLA SUPERIOR DE CRUZEIRO "PREFEITO HAMILTON VIEIRA MENDES"', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (475, 609, 'UNIVERSIDADE ESTADUAL DO OESTE DO PARANA', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (476, 610, 'CENTRO UNIVERSITARIO METODISTA BENNETT', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (477, 614, 'FACULDADE DE FILOSOFIA SANTA DOROTEIA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (478, 615, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS PROFESSORA NAIR FORTES ABU MERHY', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (479, 616, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE GUARULHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (480, 617, 'FACULDADE DE ENFERMAGEM E OBSTETRICIA DE GUARULHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (481, 618, 'FACULDADE DE FISIOTERAPIA DE GUARULHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (482, 621, 'CENTRO UNIVERSITARIO CESMAC', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (483, 622, 'FACULDADES INTEGRADAS SILVA E SOUZA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1070, 1360, 'FACULDADE SAO GABRIEL', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (484, 623, 'FACULDADES DE FILOSOFIA CIENCIAS E LETRAS DE SANTA CRUZ DO RIO PARDO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (485, 624, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS CARLOS QUEIROZ', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (486, 625, 'FACULDADE CENECISTA DE CAPIVARI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (487, 626, 'FACULDADE CENECISTA DE OSORIO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (488, 627, 'FACULDADE CENECISTA DE VARGINHA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (489, 629, 'FACULDADE CENECISTA DE VITORIA FACEV', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (490, 630, 'FACULDADE CENECISTA DE CIENCIAS ADMINISTRATIVAS DE OSORIO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (491, 631, 'CENTRO DE ENSINO SUPERIOR CENECISTA DE FARROUPILHA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (492, 632, 'FACULDADE DE CIENCIAS ECONOMICAS, ADMINISTRATIVAS E CONTABEIS DE SAO SEBASTIAO DO PARAISO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (493, 633, 'INSTITUTO MILITAR DE ENGENHARIA', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (494, 634, 'UNIVERSIDADE FEDERAL DE PELOTAS', 1, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (495, 636, 'ESCOLA SUPERIOR DE PROPAGANDA E MARKETING', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (496, 637, 'FACULDADE DE ENGENHARIA SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (497, 638, 'FACULDADE DE DIREITO MILTON CAMPOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (498, 639, 'FACULDADE DE DESENHO INDUSTRIAL DE MAUA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (499, 640, 'FACULDADES INTEGRADAS MARIA THEREZA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (500, 641, 'CENTRO UNIVERSITARIO LA SALLE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (501, 645, 'CENTRO UNIVERSITARIO DE JARAGUA DO SUL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (502, 646, 'FACULDADES ASSOCIADAS DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (503, 647, 'FACULDADE DE ENFERMAGEM LUIZA DE MARILLAC', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (504, 648, 'FACULDADES ASSOCIADAS DE UBERABA FAZU', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (505, 649, 'CENTRO UNIVERSITARIO DE UNIAO DA VITORIA', 3, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (506, 650, 'FACULDADE DE CIENCIAS CONTABEIS E ADMINISTRATIVAS DE AVARE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (507, 651, 'FACULDADE DE ADMINISTRACAO DE GOVERNADOR VALADARES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (508, 652, 'FACULDADE SANTA CECILIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (509, 657, 'FACULDADE DE FORMACAO DE PROFESSORES DE SERRA TALHADA', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (510, 659, 'FACULDADE DE CIENCIAS HUMANAS DO SUL PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (511, 660, 'FACULDADE METODISTA DO SUL PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (512, 661, 'FACULDADE PIO DECIMO', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (513, 662, 'FACULDADES INTEGRADAS CORACAO DE JESUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (514, 663, 'UNIVERSIDADE SALGADO DE OLIVEIRA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (515, 664, 'UNIVERSIDADE VILA VELHA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (516, 665, 'UNIVERSIDADE DE TAUBATE', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (517, 666, 'UNIVERSIDADE ESTADUAL DE FEIRA DE SANTANA', 2, 1, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (518, 667, 'FACULDADES INTEGRADAS DE JACAREPAGUA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (519, 668, 'CENTRO UNIVERSITARIO DE ENSINO SUPERIOR DO AMAZONAS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (520, 669, 'UNIVERSIDADE NILTON LINS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (521, 670, 'UNIVERSIDADE SAO FRANCISCO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (522, 671, 'UNIVERSIDADE ANHANGUERA UNIDERP', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (523, 672, 'FACULDADE DE ENGENHARIA DE SOROCABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (524, 673, 'CENTRO UNIVERSITARIO DA GRANDE DOURADOS', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (525, 674, 'CENTRO DE ENSINO SUPERIOR DO VALE SAO FRANCISCO', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (526, 677, 'FACULDADE DE REABILITACAO DA ASCE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (527, 678, 'FACULDADE DE ODONTOLOGIA DO PLANALTO CENTRAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (528, 679, 'FACULDADE DE REABILITACAO DO PLANALTO CENTRAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (529, 680, 'FACULDADES INTEGRADAS DE PEDRO LEOPOLDO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (530, 681, 'FACULDADES INTEGRADAS ANGLOAMERICANO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (531, 682, 'FACULDADE DO NOROESTE DE MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (532, 683, 'FACULDADE DE CIENCIAS ECONOMICAS DE COLATINA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (533, 684, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE COLATINA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (534, 685, 'FACULDADE DE FORMACAO DE PROFESSORES DE BELO JARDIM', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (535, 686, 'FACULDADE DE CIENCIAS APLICADAS DE LIMOEIRO', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (536, 687, 'FACULDADE ESTADUAL DE FILOSOFIA CIENCIAS LETRAS UNIAO DA VITORIA', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (537, 688, 'UNIVERSIDADE ESTADUAL DO SUDOESTE DA BAHIA', 2, 1, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (538, 689, 'FACULDADE DE NUTRICAO E FONOAUDIOLOGIA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (539, 690, 'FACULDADE DE CIENCIAS CONTABEIS E ADMINISTRATIVAS DE TAQUARA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (540, 691, 'FACULDADE DE EDUCACAO DE TAQUARA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (541, 692, 'FACULDADE DE CIENCIAS APLICADAS E SOCIAIS DE PETROLINA', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (542, 693, 'UNIVERSIDADE FEDERAL DO ESTADO DO RIO DE JANEIRO', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (543, 694, 'UNIVERSIDADE FEDERAL DE MATO GROSSO DO SUL', 1, 1, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (544, 695, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE ITUMBIARA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (545, 696, 'FACULDADE DE CIENCIAS AGRARIAS DE ITUMBIARA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (546, 697, 'FACULDADE DE ADMINISTRACAO DE EMPRESAS DE ITUMBIARA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (547, 699, 'FUNDACAO UNIVERSIDADE FEDERAL DE RONDONIA', 1, 1, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (548, 700, 'FACULDADE DE EDUCACAO DE ITABORAI', 3, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (549, 701, 'FACULDADE DE CIENCIAS DA ADMINISTRACAO DE GARANHUNS', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (550, 702, 'FACULDADE DE FORMACAO DE PROFESSORES DE GOIANA', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (551, 703, 'FACULDADE DE FORMACAO DE PROFESSORES DE ARARIPINA', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (552, 704, 'FACULDADE DE CIENCIAS AGRARIAS DE ARARIPINA', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (553, 705, 'FACULDADE SAO JOSE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (554, 706, 'FACULDADE DE ARTES DULCINA DE MORAES', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (555, 707, 'CENTRO UNIVERSITARIO CENTRAL PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (556, 708, 'INSTITUTO DE CIENCIAS SOCIAIS APLICADAS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (557, 709, 'INSTITUTO DE CIENCIAS EXATAS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (558, 710, 'FACULDADE BETHENCOURT DA SILVA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (559, 711, 'FACULDADES REUNIDAS DE ADMINISTRACAO CIENCIAS CONTABEIS E ECONOMICAS DE PALMAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (560, 712, 'CENTRO UNIVERSITARIO HERMINIO DA SILVEIRA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (561, 713, 'ESCOLA SUPERIOR DE ESTATISTICA DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (562, 714, 'FACULDADE ESTADUAL DE FILOSOFIA CIENCIAS E LETRAS DE CORNELIO PROCOPIO', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (563, 715, 'FAE CENTRO UNIVERSITARIO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (564, 716, 'FACULDADES INTEGRADAS DE BOTUCATU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (565, 717, 'FUNDACAO UNIVERSIDADE FEDERAL DE CIENCIAS DA SAUDE DE PORTO ALEGRE', 1, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (566, 718, 'UNIVERSIDADE POTIGUAR', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (567, 719, 'UNIVERSIDADE DO ESTADO DE MATO GROSSO', 2, 1, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (568, 720, 'FACULDADE DE CIENCIAS HUMANAS E SOCIAIS APLICADAS DO CABO DE SANTO AGOSTINHO', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (569, 721, 'FACULDADE DE EDUCACAO DE ASSIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (570, 722, 'ESCOLA DE EDUCACAO FISICA DE ASSIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (571, 723, 'FACULDADE DE ADMINISTRACAO DE ASSIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (572, 724, 'CENTRO UNIVERSITARIO FACEX', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (573, 725, 'FACULDADE ESTADUAL DE FILOSOFIA, CIENCIAS E LETRAS DE PARANAGUA', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (574, 726, 'FACULDADE ESTADUAL DE FILOSOFIA CIENCIAS E LETRAS DE JACAREZINHO', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (575, 727, 'FACULDADE DE FILOSOFIA, CIENCIAS E LETRAS DO ALTO SAO FRANCISCO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (576, 728, 'FACULDADE DE CIENCIAS HUMANAS DE CURVELO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (577, 729, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE PRESIDENTE VENCESLAU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (578, 730, 'UNIVERSIDADE ESTADUAL DE PONTA GROSSA', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (579, 734, 'FACULDADES INTEGRADAS MARIA IMACULADA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (580, 736, 'FACULDADE PITAGORAS DE LINHARES', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (581, 737, 'CENTRO UNIVERSITARIO SAO CAMILO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (582, 738, 'FACULDADES INTEGRADAS TERESA D´AVILA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (583, 739, 'CENTRO UNIVERSITARIO SAO CAMILO ESPIRITO SANTO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (584, 740, 'FACULDADE DE CIENCIAS HUMANAS DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (585, 741, 'ESCOLA SUPERIOR DE SECRETARIADO DE PERNAMBUCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (586, 742, 'FACULDADE DE ARQUITETURA E URBANISMO DE PERNAMBUCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (587, 743, 'ESCOLA SUPERIOR DE ENSINO HELENA ANTIPOFF', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (588, 744, 'FACULDADE DE EDUCACAO E CIENCIAS HUMANAS DE ANICUNS', 3, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (589, 745, 'INSTITUTO MUNICIPAL DE ENSINO SUPERIOR DE SAO MANUEL', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (590, 746, 'UNIVERSIDADE REGIONAL DO CARIRI', 2, 1, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (591, 747, 'FACULDADE DE CIENCIAS HUMANAS DE IVAIPORA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (592, 749, 'CENTRO DE ENSINO SUPERIOR DO VALE DO PARNAIBA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (593, 750, 'CENTRO UNIVERSITARIO UNIRG', 3, 1, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (594, 751, 'FACULDADE DA ILHA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (595, 752, 'FACULDADE DE PARA DE MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (596, 753, 'FACULDADE DE CIENCIAS HUMANAS DO SERTAO CENTRAL', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (597, 754, 'CENTRO DE ENSINO SUPERIOR DE CATALAO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (598, 755, 'CENTRO DE ENSINO SUPERIOR DE JATAI', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (599, 756, 'UNIVERSIDADE ESTADUAL DO PIAUI', 2, 1, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (600, 757, 'FACULDADES INTEGRADAS DO TAPAJOS', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (601, 758, 'FACULDADE BRASILEIRA DE RECURSOS HUMANOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (602, 759, 'FACULDADE DE CIENCIAS MEDICAS E PARAMEDICAS FLUMINENSE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (603, 760, 'FACULDADE DE CIENCIAS HUMANAS DE PERNAMBUCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (604, 761, 'FACULDADES SPEI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (605, 762, 'FACULDADES INTEGRADAS DE FATIMA DO SUL', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (606, 763, 'INSTITUTO UNIFICADO DE ENSINO SUPERIOR OBJETIVO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (607, 764, 'FACULDADE PINHEIRO GUIMARAES', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (608, 767, 'INSTITUTO SUPERIOR DE INFORMATICA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (609, 768, 'FACULDADE DE ADMINISTRACAO DE NOVA ANDRADINA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (610, 769, 'FACULDADES INTEGRADAS DE NAVIRAI', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (611, 770, 'FACULDADE DE EDUCACAO DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (612, 771, 'FACULDADE MARIA AUGUSTA RIBEIRO DAHER', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (613, 773, 'FACULDADE DE ADMINISTRACAO E CIENCIAS CONTABEIS DE LINHARES', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (614, 774, 'FACULDADE ALVORADA DE INFORMATICA E PROCESSAMENTO DE DADOS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (615, 775, 'FACULDADE ALVORADA DE EDUCACAO FISICA E DESPORTO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (617, 777, 'FACULDADE DE EDUCACAO THEREZA PORTO MARQUES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (618, 778, 'FACULDADE DE TECNOLOGIA DE JACAREI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (619, 779, 'FACULDADE DE PONTA PORA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (620, 780, 'UNIVERSIDADE DE CUIABA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (621, 781, 'FACULDADE ANHANGUERA DE RONDONOPOLIS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (622, 782, 'FACULDADE CUIABANA DE EDUCACAO E LETRAS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (623, 783, 'FACULDADE MATOGROSSENSE DE CIENCIAS CONTABEIS E ADMINISTRATIVA DE CUIABA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (624, 785, 'FACULDADE DE EDUCACAO DE TANGARA DA SERRA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (625, 788, 'FACULDADE DE RONDONIA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (626, 789, 'UNIVERSIDADE FEDERAL DE RORAIMA', 1, 1, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (627, 790, 'FACULDADE DE ENFERMAGEM DO HOSPITAL ISRAELITA ALBERT EINSTEIN', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (628, 791, 'FACULDADE SENAC DE TURISMO E HOTELARIA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (629, 792, 'CENTRO UNIVERSITARIO DO ESTADO DO PARA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (630, 793, 'CENTRO UNIVERSITARIO ESTACIO RADIAL DE SAO PAULO ESTACIO UNIRADIAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (631, 794, 'CENTRO UNIVERSITARIO DE VARZEA GRANDE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (632, 795, 'FACULDADES INTEGRADAS DE DIAMANTINO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (633, 796, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DO VALE DO SAO LOURENCO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (634, 797, 'FACULDADE AVEC DE VILHENA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (635, 798, 'FACULDADES INTEGRADAS DE ARACRUZ', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (636, 799, 'FACULDADE LEONARDO DA VINCI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (637, 800, 'FACULDADE DE EDUCACAO FISICA MONTENEGRO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (638, 801, 'FACULDADE MONTENEGRO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (639, 802, 'CENTRO UNIVERSITARIO CARIOCA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (640, 803, 'FACULDADE INTERACAO AMERICANA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (641, 809, 'FACULDADE DE DIREITO E CIENCIAS SOCIAIS DO LESTE DE MINAS FADILESTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (642, 810, 'CENTRO TECNICO EDUCACIONAL SUPERIOR DO OESTE PARANAENSE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (643, 811, 'FACULDADES INTEGRADAS DE CASSILANDIA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (644, 817, 'FACULDADE BATISTA CARIOCA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (645, 818, 'FACULDADE DE ADMINISTRACAO DE MINEIROS', 3, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (646, 819, 'FACULDADE DE AGRONOMIA DE MINEIROS', 3, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (647, 820, 'FACULDADE DE CIENCIAS DA COMPUTACAO DE MINEIROS', 3, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (648, 821, 'FACULDADE DE PEDAGOGIA DE MINEIROS', 3, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (649, 822, 'ESCOLA SUPERIOR DE ESTUDOS EMPRESARIAIS E INFORMATICA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (650, 823, 'UNIVERSIDADE DO CEUMA UNICEUMA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (651, 824, 'FACULDADE DE FILOSOFIA E CIENCIAS HUMANAS DE GOIATUBA', 3, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (652, 825, 'FACULDADE PRESBITERIANA GAMMON', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (653, 826, 'CENTRO UNIVERSITARIO DE DESENVOLVIMENTO DO CENTRO OESTE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (654, 827, 'FACULDADES UNIDAS DO VALE DO ARAGUAIA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (655, 828, 'FACULDADE DE SAO LOURENCO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (656, 829, 'UNIVERSIDADE DO TOCANTINS', 2, 1, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (657, 830, 'UNIVERSIDADE FEDERAL DO AMAPA', 1, 1, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (658, 831, 'FACULDADE DE CIENCIAS HUMANAS DO VALE DO RIO GRANDE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (659, 832, 'FACULDADE ARQUIDIOCESANA DE CURVELO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (660, 833, 'FACULDADES INTEGRADAS DE ARIQUEMES', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (661, 834, 'FACULDADE VARZEAGRANDENSE DE CIENCIAS HUMANAS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (662, 835, 'FACULDADE VARZEAGRANDENSE DE COMUNICACAO SOCIAL', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (663, 837, 'FACULDADE DE CIENCIAS HUMANAS DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (664, 838, 'FACULDADE DE CIENCIAS TECNOLOGICAS DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (665, 839, 'FACULDADE VITORIANA DE CIENCIAS CONTABEIS', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (666, 840, 'FACULDADE VITORIANA DE TECNOLOGIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (667, 841, 'FACULDADE DE TURISMO GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (668, 843, 'FACULDADE DE CIENCIAS E TECNOLOGIA DE BIRIGUI', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (669, 844, 'FACULDADE DE AGRONOMIA E ENGENHARIA FLORESTAL DE GARCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (670, 845, 'FACULDADE DA FUNDACAO EDUCACIONAL ARACATUBA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (671, 846, 'FACULDADE DE ADMINISTRACAO DE TERESINA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (672, 847, 'FACULDADE PIAUIENSE DE PROCESSAMENTO DE DADOS', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (673, 848, 'FACULDADE PARAIBANA DE PROCESSAMENTO DE DADOS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (674, 849, 'FACULDADE JESUITA DE FILOSOFIA E TEOLOGIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (675, 850, 'FACULDADE PRIMUS DE INFORMATICA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (676, 851, 'FACULDADE DE TECNOLOGIA EM PROCESSAMENTO DE DADOS DO LITORAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (677, 852, 'FACULDADE DE INFORMATICA E ADMINISTRACAO PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (678, 859, 'FACULDADE REGIONAL SANTA CRUZ DE CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (679, 860, 'FACULDADE DE CIENCIAS SOCIAIS DE ARAUCARIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (680, 861, 'CENTRO DE ENSINO SUPERIOR DO AMAPA', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (681, 862, 'FACULDADE ESTACIO DE SA DE CAMPO GRANDE', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (682, 864, 'FACULDADE DE DIREITO DE VARZEA GRANDE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (683, 866, 'FACULDADE DE INFORMATICA DE CUIABA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (684, 867, 'FACULDADE DE EDUCACAO CIENCIAS E LETRAS DE PONTA PORA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (685, 873, 'FACULDADES UNIFICADAS DE FOZ DO IGUACU', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (686, 874, 'FACULDADE DE ESTUDOS SOCIAIS APLICADOS DE VIANA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (687, 875, 'FACULDADE DE ESTUDOS SOCIAIS DE BARRA DO GARCAS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (688, 876, 'FACULDADE DE TECNOLOGIA DO VALE DO ARAGUAIA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (689, 877, 'FACULDADE DE ECONOMIA E PROCESSAMENTO DE DADOS DE FOZ DO IGUACU', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (690, 878, 'CENTRO UNIVERSITARIO DO LESTE DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (691, 880, 'FACULDADE DE CIENCIAS E TECNOLOGIA DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (692, 881, 'INSTITUTO MUNICIPAL DE ENSINO SUPERIOR DE ASSIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (693, 882, 'INSTITUTO MUNICIPAL DE ENSINO SUPERIOR DE BEBEDOURO VICTORIO CARDASSI', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (694, 886, 'FACULDADE DE HORTOLANDIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (695, 887, 'FACULDADE CHRISTUS', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (696, 888, 'FACULDADE BANDEIRANTES DE CIENCIAS EXATAS E HUMANAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (697, 890, 'ESCOLA DE GOVERNO PROFESSOR PAULO NEVES DE CARVALHO', 2, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (698, 891, 'FACULDADE ANHANGUERA DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (699, 896, 'ESCOLA SUPERIOR DE TURISMO E HOTELARIA FLORIANOPOLIS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (700, 897, 'UNIAO DAS ESCOLAS SUPERIORES DO VALE DO IVAI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (701, 898, 'FACULDADE DE CIENCIAS ECONOMICAS E ADMINISTRATIVAS SANTA RITA DE CASSIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (702, 899, 'FACULDADES INTEGRADAS DE RIO VERDE', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (703, 900, 'FACULDADE DE CIENCIAS ADMINISTRATIVAS E DE TECNOLOGIA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (704, 903, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (705, 904, 'FACULDADE DE PROCESSAMENTO DE DADOS DE JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (706, 905, 'FACULDADE ESCOLA PAULISTA DE DIREITO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (707, 906, 'FACULDADE DE EDUCACAO E CIENCIAS GERENCIAIS DE SUMARE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (708, 907, 'FACULDADE DE EDUCACAO E CIENCIAS GERENCIAIS DE INDAIATUBA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (709, 908, 'FACULDADE ALAGOANA DE ADMINISTRACAO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (710, 909, 'FACULDADE DE BELFORD ROXO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (711, 910, 'FACULDADE SANTA LUCIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (712, 911, 'FACULDADES UNIDAS DE ITUMBIARA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (713, 912, 'FACULDADE COMPACTO DE CIENCIAS GERENCIAIS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (714, 913, 'FACULDADES INTEGRADAS DE PARANAIBA FIPAR', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (715, 914, 'FACULDADE PARANAENSE DE ADMINISTRACAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (716, 915, 'FACULDADE DE ADMINISTRACAO DE FATIMA DO SUL', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (717, 916, 'FACULDADE DE CIENCIAS, SAUDE, EXATAS E JURIDICAS DE TERESINA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (718, 917, 'FACULDADE DE CIENCIAS CONTABEIS DE NAVIRAI', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (719, 918, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DE CASCAVEL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (720, 922, 'FACULDADE REGES DE DRACENA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (721, 923, 'FACULDADE DE ADMINISTRACAO E CIENCIAS CONTABEIS DE SAO ROQUE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (722, 924, 'FACULDADE INTERLAGOS DE EDUCACAO E CULTURA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (723, 925, 'FACULDADE DE CIENCIAS GERENCIAIS DE VILHENA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (724, 926, 'CENTRO UNIVERSITARIO ANHANGUERA DE CAMPO GRANDE', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (725, 927, 'CENTRO DE ESTUDOS SUPERIORES DA AMAZONIA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (726, 929, 'INSTITUTO MANAUARA DE ENSINO SUPERIOR', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (727, 930, 'FACULDADE DE EDUCACAO DE ALTA FLORESTA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (728, 934, 'FACULDADE SAO CARLOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (729, 935, 'FACULDADE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (730, 939, 'FACULDADE CATOLICA DE ANAPOLIS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (731, 940, 'FACULDADES MAGSUL', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (732, 941, 'FACULDADE DE EDUCACAO DE PORTO VELHO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (733, 944, 'ESCOLA SUPERIOR DE PROPAGANDA E MARKETING DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (734, 945, 'INSTITUTO DE CIENCIAS SOCIAIS E HUMANAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (735, 950, 'UNIAO DE ENSINO SUPERIOR DE NOVA MUTUM', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (736, 951, 'FACULDADES INTEGRADAS DE COXIM', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (737, 952, 'UNIVERSIDADE SANTA CECILIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (738, 953, 'UNIVERSIDADE METROPOLITANA DE SANTOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (739, 954, 'FACULDADE DE CIENCIAS AGRO AMBIENTAIS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (740, 955, 'FACULDADE DE FILOSOFIA NOSSA SENHORA IMACULADA CONCEICAO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (741, 959, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (742, 960, 'FACULDADE DE CIENCIAS CONTABEIS DE ALTA FLORESTA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (743, 961, 'FACULDADE GARCIA SILVEIRA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (744, 966, 'FACULDADE DE TURISMO SANTOS DUMONT', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (745, 967, 'FACULDADE DE TECNOLOGIA DE TAQUARITINGA', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (746, 968, 'FACULDADE DE TECNOLOGIA EM PROCESSAMENTO DE DADOS DE ANDRADINA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (747, 969, 'FACULDADE DE TURISMO FORMIGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (748, 970, 'FACULDADE DE SERVICO SOCIAL DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (749, 971, 'FACULDADE DE TECNOLOGIA E CIENCIAS DE CONSELHEIRO LAFAIETE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (750, 973, 'FACULDADE DE LUCELIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (751, 975, 'FACULDADE DE FISIOTERAPIA DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (752, 976, 'FACULDADES INTEGRADAS DE PONTA PORA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (753, 977, 'FACULDADE SAO CAMILO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (754, 980, 'FACULDADE DE ADMINISTRACAO DE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (755, 983, 'FACULDADE PRUDENTE DE MORAES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (756, 984, 'FACULDADE DE EDUCACAO DE IVAIPORA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (757, 985, 'FACULDADE DE CIENCIAS E EDUCACAO DE RUBIATABA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (758, 986, 'FACULDADE DE EDUCACAO E CULTURA MONTESSORI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (759, 988, 'FACULDADE DE COMUNICACAO SOCIAL TAMOIOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (760, 989, 'ESCOLA SUPERIOR EM MEIO AMBIENTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (761, 990, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DE CONGONHAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (762, 991, 'FACULDADE SENAICETIQT', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (763, 994, 'FACULDADE DE DUQUE DE CAXIAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (764, 997, 'CENTRO UNIVERSITARIO DE BAURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (765, 998, 'FACULDADE DE SERVICO SOCIAL DE BAURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (766, 999, 'FACULDADE DE DIREITO DE BAURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (767, 1001, 'FACULDADE DE CIENCIAS ECONOMICAS E ADMINISTRATIVAS DE PRESIDENTE PRUDENTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (768, 1002, 'FACULDADE DE DIREITO DE PRESIDENTE PRUDENTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (769, 1003, 'FACULDADE DE SERVICO SOCIAL PRESIDENTE PRUDENTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (770, 1012, 'FACULDADE DE FORMACAO DE PROFESSORES DE AFOGADOS DA INGAZEIRA', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (771, 1013, 'FACULDADE SUDOESTE PAULISTANO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (772, 1014, 'INSTITUTO SUPERIOR E CENTRO EDUCACIONAL LUTERANO BOM JESUS IELUSC', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (773, 1015, 'FACULDADE DE CIENCIAS CONTABEIS MACHADO DE ASSIS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (774, 1016, 'FACULDADE DE CIENCIAS HUMANAS DO VALE DO PIRANGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (775, 1017, 'FACULDADE STEFANINI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (776, 1019, 'FACULDADE DE CIENCIAS E TECNOLOGIA DE UNAI FACTU', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (777, 1021, 'FACULDADE DE CIENCIAS DE TIMBAUBA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (778, 1027, 'UNIVERSIDADE ESTADUAL DO NORTE FLUMINENSE DARCY RIBEIRO', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (779, 1028, 'UNIVERSIDADE ESTADUAL DE MATO GROSSO DO SUL', 2, 1, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (780, 1030, 'FACULDADE DE ECONOMIA E FINANCAS IBMEC', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (781, 1031, 'FACULDADE ANDRE DA SILVEIRA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (782, 1032, 'CENTRO UNIVERSITARIO SALESIANO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (783, 1034, 'UNIAO DE ESCOLAS SUPERIORES DA FUNESO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (784, 1036, 'UNIVERSIDADE DO ESTADO DE MINAS GERAIS', 2, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (785, 1038, 'FACULDADES INTEGRADAS DE TRES LAGOAS', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (786, 1040, 'FACULDADES DE VALINHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (787, 1041, 'CENTRO UNIVERSITARIO UNIVATES', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (788, 1042, 'UNIVERSIDADE POSITIVO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (789, 1043, 'CENTRO UNIVERSITARIO HERMINIO OMETTO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (790, 1045, 'CENTRO UNIVERSITARIO ANHANGUERA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (791, 1046, 'UNIAO DAS FACULDADES DOS GRANDES LAGOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (792, 1047, 'FACULDADE TECNOLOGICA PORTO ALEGRENSE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (793, 1048, 'FACULDADE CAMPOS ELISEOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (794, 1049, 'INSTITUTO DE ENSINO SUPERIOR FUCAPI', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (795, 1051, 'FACULDADE DE CIENCIAS CONTABEIS MACEIO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (796, 1052, 'FACULDADE ADVENTISTA DE ADMINISTRACAO DO NORDESTE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (797, 1053, 'FACULDADE DE TECNOLOGIA E CIENCIAS DE FEIRA DE SANTANA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (798, 1054, 'ESCOLA BAHIANA DE ADMINISTRACAO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (799, 1055, 'FACULDADE MAURICIO DE NASSAU DE SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (800, 1058, 'CENTRO UNIVERSITARIO ESTACIO DA BAHIA ESTACIO FIB', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (801, 1059, 'FACULDADE LOURENCO FILHO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (802, 1060, 'CENTRO UNIVERSITARIO DO INSTITUTO DE EDUCACAO SUPERIOR DE BRASILIA IESB', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (803, 1061, 'FACULDADE PLANALTO DE ADMINISTRACAO E CIENCIAS ECONOMICAS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (804, 1063, 'FACULDADE COMUNITARIA DE VILA VELHA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (805, 1064, 'FACULDADE COMUNITARIA DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (806, 1065, 'FACULDADE DE CIENCIAS ECONOMICAS E ADMINISTRATIVAS DE VILA VELHA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (807, 1066, 'INSTITUTO DE ENSINO E PESQUISA OBJETIVO', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (808, 1067, 'FACULDADE DE JUSSARA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (809, 1068, 'FACULDADE ALDETE MARIA ALVES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (810, 1069, 'CENTRO REGIONAL DE ESTUDOS EM CIENCIAS HUMANAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (811, 1070, 'INSTITUTO DE ENSINO SUPERIOR CENECISTA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (812, 1071, 'INSTITUTO DE ENSINO SUPERIOR DA FUNLEC', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (813, 1072, 'FACULDADE AFIRMATIVO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (814, 1075, 'INSTITUTO DE EDUCACAO SUPERIOR DA PARAIBA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (815, 1076, 'FACULDADE DE FILOSOFIA, CIENCIAS E LETRAS DE CAJAZEIRAS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (816, 1077, 'FACULDADE ESTACIO DO RECIFE ESTACIO FIR', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (817, 1078, 'FACULDADE INTEGRADO DE CAMPO MOURAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (818, 1079, 'FACULDADE MARINGA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (819, 1080, 'FACULDADE ARTHUR SA EARP NETO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (820, 1081, 'FACULDADE DE ENGENHARIA DE RESENDE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (821, 1082, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO RIO GRANDE DO NORTE', 1, 1, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (822, 1084, 'FACULDADE CENECISTA DE BENTO GONCALVES', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (823, 1085, 'FACULDADE METODISTA DE SANTA MARIA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (824, 1086, 'FACULDADE DE EDUCACAO DE COLORADO DO OESTE', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (825, 1087, 'FACULDADES INTEGRADAS APARICIO CARVALHO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (826, 1088, 'FACULDADE DE DESENHO INDUSTRIAL DE JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (827, 1089, 'CENTRO DE EDUCACAO SUPERIOR UNICA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (828, 1090, 'FACULDADE SAO LUIS DE FRANCA', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (829, 1091, 'FACULDADE DE PEDAGOGIA DE VARGEM GRANDE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (830, 1092, 'FACULDADES INTEGRADAS DE BAURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (831, 1093, 'FACULDADE DE CIENCIAS JURIDICAS E GERENCIAIS DE GARCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (832, 1095, 'FACULDADE DE ADMINISTRACAO E NEGOCIOS DE MONTE ALTO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (833, 1096, 'FACULDADE DE PRESIDENTE EPITACIO FAPE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (834, 1097, 'FACULDADES INTEGRADAS DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (835, 1099, 'FACULDADE DE EDUCACAO E CIENCIAS GERENCIAIS DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (836, 1100, 'FACULDADE CARLOS DRUMMOND DE ANDRADE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (837, 1101, 'FACULDADE ADVENTISTA DE CIENCIAS DA SAUDE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (838, 1102, 'FACULDADE DE INFORMATICA MARILIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (839, 1103, 'FACULDADE DE ADMINISTRACAO SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (840, 1104, 'FACULDADE DE COMUNICACAO SOCIAL DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (841, 1107, 'CENTRO UNIVERSITARIO ESTACIO DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (842, 1108, 'FACULDADE DE CIENCIAS GERENCIAIS COTIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (843, 1111, 'FACULDADE DE TURISMO DOMUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (844, 1112, 'FACULDADE DE RELACOES INTERNACIONAIS DOMUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (845, 1113, 'CENTRO UNIVERSITARIO EURO AMERICANO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (846, 1114, 'FACULDADE DE CIENCIAS JURIDICAS E SOCIAIS APLICADAS RIO BRANCO FIRB', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (847, 1115, 'FACULDADE SANTA TEREZINHA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (849, 1117, 'FACULDADE SENAC DE COMUNICACAO E ARTES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (850, 1118, 'UNIAO DAS ESCOLAS DO GRUPO FAIMI DE EDUCACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (851, 1119, 'FACULDADE PLANALTO DE FILOSOFIA, CIENCIAS E LETRAS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (852, 1120, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA FLUMINENSE', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (853, 1122, 'FACULDADE REGES DE OSVALDO CRUZ', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (854, 1123, 'INSTITUTO DE EDUCACAO SUPERIOR UNYAHNA DE SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (855, 1124, 'INSTITUTO DE EDUCACAO SUPERIOR UNYAHNA DE BARREIRAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (856, 1125, 'FACULDADES INTEGRADAS ESPIRITA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (857, 1126, 'UNIVERSIDADE ESTADUAL DO CENTRO OESTE', 2, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (858, 1128, 'UNIVERSIDADE DE ITAUNA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (859, 1129, 'CENTRO UNIVERSITARIO DO NORTE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (860, 1130, 'FACULDADE METODISTA DE CIENCIAS HUMANAS E EXATAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (861, 1131, 'FACULDADE SANTO AGOSTINHO', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (862, 1132, 'FACULDADE DE CIENCIA DA COMPUTACAO DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (863, 1134, 'FACULDADE EVANGELICA LUTERANA MARTINUS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (864, 1135, 'FACULDADE PLANALTO DE CIENCIA DA COMPUTACAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (865, 1136, 'FACULDADE DE CIENCIAS HUMANAS E SOCIAIS DE IGARASSU', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (866, 1137, 'CENTRO DE ENSINO SUPERIOR HEROIS DE JENIPAPO', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (867, 1138, 'CENTRO DE EDUCACAO SUPERIOR DE BLUMENAU', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (868, 1139, 'FACULDADE DE ESTUDOS ADMINISTRATIVOS DE MINAS GERAIS FEADMG', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (869, 1140, 'FACULDADE DE CIENCIAS HUMANAS E SOCIAIS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (870, 1141, 'FACULDADE GAMA E SOUZA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (871, 1142, 'FACULDADES INTEGRADAS DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (872, 1143, 'FACULDADE DE CIENCIAS DE TIMBAUBA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (873, 1144, 'FACULDADE DE CIENCIAS HUMANAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (874, 1145, 'FACULDADE DE CIENCIAS AGRARIAS DO PLANALTO CENTRAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (875, 1147, 'FACULDADE RUY BARBOSA DE PSICOLOGIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (876, 1149, 'CENTRO UNIVERSITARIO NOSSA SENHORA DO PATROCINIO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (877, 1150, 'FACULDADE SENAI DE TECNOLOGIA GRAFICA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (878, 1151, 'FACULDADE DE ADMINISTRACAO E NEGOCIOS DE SERGIPE', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (879, 1152, 'INSTITUTO SUL BRASIL DE ENSINO SUPERIOR', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (880, 1153, 'UNIVERSIDADE CANDIDO MENDES', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (881, 1155, 'FACULDADE SALESIANA DE SANTA TERESA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (882, 1156, 'FACULDADE CENECISTA DE ITABORAI', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (883, 1157, 'ESCOLA SUPERIOR SAO FRANCISCO DE ASSIS', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (884, 1158, 'FACULDADE RUY BARBOSA DE CIENCIA DA COMPUTACAO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (885, 1159, 'CENTRO DE ENSINO SUPERIOR DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (886, 1160, 'FACULDADE CAMBURY', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (887, 1161, 'INSPER INSTITUTO DE ENSINO E PESQUISA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (888, 1162, 'FACULDADE DE ALTA FLORESTA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (889, 1163, 'FACULDADE DE CIENCIA DA COMPUTACAO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (890, 1164, 'FACULDADE VARZEAGRANDENSE DE ADMINISTRACAO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (891, 1166, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DA PARAIBA', 1, 1, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (892, 1168, 'FACULDADE DE ANALISE DE SISTEMAS DE INFORMACAO DOMUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (893, 1169, 'FACULDADE SENAC DE MODA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (894, 1170, 'FACULDADE METROPOLITANA DE CAMACARI', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (895, 1171, 'FACULDADE DE LETRAS MARILIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (896, 1172, 'FACULDADE AD 1', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (897, 1173, 'FACULDADE ANHANGUERA DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (898, 1174, 'FACULDADE DE SABARA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (899, 1175, 'FACULDADES RIOGRANDENSES', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (900, 1176, 'FACULDADE DE ANGRA DOS REIS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (901, 1177, 'ESCOLA SUPERIOR DE CIENCIAS AGRARIAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (902, 1179, 'ESCOLA SUPERIOR DE CIENCIAS DA SAUDE DE RIO VERDE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (903, 1180, 'FACULDADE BARDDAL DE LETRAS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (904, 1181, 'FACULDADE BRASILIA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (905, 1182, 'INSTITUTO DE ENSINO SUPERIOR DE AMERICANA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (906, 1183, 'INSTITUTO SAO JOSE DOS CAMPOS DE ENSINO SUPERIOR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (907, 1184, 'CENTRO DE CIENCIAS DA SAUDE DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (908, 1185, 'CENTRO UNIVERSITARIO JORGE AMADO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (909, 1186, 'FACULDADE DE TURISMO E HOTELARIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (910, 1187, 'CENTRO UNIVERSITARIO MODULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (911, 1189, 'UNIVERSIDADE DO PLANALTO CATARINENSE', 3, 1, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (912, 1190, 'FACULDADE INTEGRAL CANTAREIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (913, 1191, 'INSTITUTO DE ENSINO SUPERIOR DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (914, 1192, 'FACULDADE DE CIENCIAS DA SAUDE DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (915, 1194, 'FACULDADE DE TECNOLOGIA DE PONTA PORA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (916, 1195, 'FACULDADE SENAI DE TECNOLOGIA MECATRONICA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (917, 1196, 'CENTRO UNIVERSITARIO DE MARINGA UNICESUMAR', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (918, 1197, 'FACULDADE DE TURISMO AEMARJ', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (919, 1198, 'FACULDADE DE CIENCIAS SOCIAIS E APLICADAS DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (920, 1200, 'INSTITUTO BRASILIENSE DE TECNOLOGIA E CIENCIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (921, 1201, 'FACULDADE DE ADMINISTRACAO MILTON CAMPOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (922, 1202, 'FACULDADE SANTA RITA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (923, 1203, 'FACULDADE DE ECONOMIA DE OURO FINO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (924, 1204, 'FACULDADE DE AMAMBAI', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (925, 1205, 'FACULDADE EDUCACIONAL DA LAPA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (926, 1206, 'FACULDADE ADVENTISTA DE FISIOTERAPIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (927, 1207, 'FACULDADE DE ADMINISTRACAO GERAL', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (928, 1208, 'FAL ESTACIO FACULDADE ESTACIO DE NATAL', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (929, 1209, 'FACULDADE DE ADMINISTRACAO DE EMPRESAS DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (930, 1210, 'FACULDADE DE CIENCIAS DA COMUNICACAO DE TAQUARA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (931, 1211, 'INSTITUTO DE ENSINO SUPERIOR DE SOROCABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (932, 1212, 'FACULDADE DE CIENCIAS CONTABEIS DE ASSIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (933, 1213, 'FACULDADE FLEMING', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (934, 1215, 'FACULDADE ANGLOLATINO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (935, 1217, 'CENTRO DE TECNOLOGIA EM AUTOMACAO DE INFORMATICA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (936, 1219, 'INSTITUTO ITAPETININGANO DE ENSINO SUPERIOR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (937, 1220, 'INSTITUTO MATAO DE ENSINO SUPERIOR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (938, 1221, 'FACULDADE GAMMON', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (939, 1222, 'FACULDADE SENAC DE CIENCIAS EXATAS E TECNOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (940, 1223, 'FACULDADE RADIAL JABAQUARA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (941, 1224, 'CENTRO UNIVERSITARIO DE JALES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (942, 1225, 'CENTRO UNIVERSITARIO AMPARENSE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (943, 1226, 'INSTITUTO DE ENSINO SUPERIOR DO ACRE', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (944, 1227, 'FACULDADE SAO FRANCISCO DE BARREIRAS FASB', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (945, 1228, 'FACULDADE DE TECNOLOGIA EMPRESARIAL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (946, 1229, 'INSTITUTO DE ENSINO SUPERIOR DO NORDESTE', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (947, 1230, 'CENTRO REGIONAL UNIVERSITARIO DE ESPIRITO SANTO DO PINHAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (948, 1231, 'INSTITUTO CENECISTA DE ENSINO SUPERIOR DE SANTO ANGELO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (949, 1232, 'CENTRO UNIVERSITARIO CAMPOS DE ANDRADE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (950, 1233, 'CENTRO UNIVERSITARIO CANDIDO RONDON', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (951, 1234, 'FACULDADE METROPOLITANA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (952, 1235, 'ESCOLA DE EDUCACAO SUPERIOR IPITANGA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (953, 1236, 'ESCOLA POLITECNICA IPITANGA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (954, 1237, 'FACULDADE NOSSA SENHORA APARECIDA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (955, 1238, 'FACULDADE DE CIENCIAS CONTABEIS DO PLANALTO CENTRAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (956, 1239, 'FACULDADE PADRAO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (957, 1240, 'FACULDADE DE ESTUDOS SOCIAIS DO ESPIRITO SANTO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (958, 1241, 'FACULDADE ESPIRITO SANTENSE DE ENSINO TECNOLOGICO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (959, 1243, 'FACULDADE COMUNITARIA DE ADMINISTRACAO DA SERRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (960, 1244, 'FACULDADE BRASILEIRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (961, 1245, 'FACULDADE DE CASTELO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (962, 1246, 'FACULDADE CANDIDO MENDES DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (963, 1247, 'FACULDADE DE CIENCIAS CONTABEIS DE NOVA ANDRADINA FACINAN', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (964, 1248, 'FACULDADE DE PEDAGOGIA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (965, 1249, 'FACULDADE DE EDUCACAO DE COSTA RICA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (966, 1252, 'FACULDADE PROMOVE DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (967, 1253, 'FACULDADE METODISTA GRANBERY', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (968, 1254, 'FACULDADE DE ADMINISTRACAO DE ITABIRITO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (969, 1255, 'FACULDADE BOA VIAGEM', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (970, 1256, 'FACULDADE DOM BOSCO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (971, 1257, 'FACULDADE DE ADMINISTRACAO, CIENCIAS, EDUCACAO E LETRAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (972, 1258, 'FACULDADE DE CIENCIAS APLICADAS DE CASCAVEL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (973, 1259, 'FACULDADE NOBEL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (974, 1260, 'FACULDADE OPET', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (975, 1261, 'FACULDADE ADVENTISTA DE CIENCIAS CONTABEIS DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (976, 1262, 'FACULDADE ADVENTISTA DE EDUCACAO DO NORDESTE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (977, 1263, 'FACULDADE BEZERRA DE ARAUJO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (978, 1264, 'CENTRO UNIVERSITARIO DO RIO GRANDE DO NORTE', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (979, 1265, 'FACULDADE DE PROCESSAMENTO DE DADOS DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (980, 1266, 'FACULDADES INTEGRADAS URUBUPUNGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (981, 1267, 'INSTITUTO DE ENSINO SUPERIOR DA GRANDE FLORIANOPOLIS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (982, 1270, 'CENTRO UNIVERSITARIO UNISEB', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (983, 1271, 'FACULDADE DE COMUNICACAO SOCIAL DOMUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (984, 1272, 'FACULDADE SANT´ANNA DE SALTO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (985, 1273, 'FACULDADE CAMPO LIMPO PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (986, 1274, 'FACULDADE DE EDUCACAO DOMUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (987, 1275, 'FACULDADE DO GUARUJA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (988, 1276, 'INSTITUTO TAUBATE DE ENSINO SUPERIOR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (989, 1277, 'FACULDADE DE INFORMATICA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (990, 1278, 'FACULDADE ADVENTISTA DE EDUCACAO E CIENCIAS HUMANAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (991, 1279, 'FACULDADE DE ITAPOLIS FACITA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (992, 1280, 'FACULDADE ESTACIO COTIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (993, 1281, 'FACULDADE DE CIENCIAS SOCIAIS E AGRARIAS DE ITAPEVA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (994, 1283, 'INSTITUTO MANCHESTER PAULISTA DE ENSINO SUPERIOR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (995, 1285, 'INSTITUTO DE ENSINO SUPERIOR DE MAIRIPORA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (996, 1286, 'FACULDADE SENAI DE TECNOLOGIA AMBIENTAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (997, 1287, 'FACULDADE DE CIENCIAS GERENCIAIS DO PLANALTO CENTRAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (998, 1288, 'FACULDADE INDEPENDENTE BUTANTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (999, 1289, 'FACULDADE DE DIREITO DA FUNDACAO ARMANDO ALVARES PENTEADO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1000, 1290, 'FACULDADE ALVARES DE AZEVEDO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1001, 1291, 'FACULDADE DO NORTE PIONEIRO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1002, 1292, 'FACULDADES ADAMANTINENSES INTEGRADAS', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1003, 1293, 'INSTITUTO DE ENSINO SUPERIOR DO OESTE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1004, 1294, 'FACULDADE DAS AMERICAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1005, 1295, 'FACULDADE MORUMBI SUL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1006, 1296, 'ESCOLA SUPERIOR DE MARKETING', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1007, 1297, 'FACULDADE DOURADOS', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1008, 1298, 'FACULDADE ESTACIO DE ALAGOAS ESTACIO FAL', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1009, 1299, 'FACULDADES INTEGRADAS DE FERNANDOPOLIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1010, 1300, 'INSTITUTO TAQUARITINGUENSE DE ENSINO SUPERIOR DR. ARISTIDES DE CARVALHO SCHLOBACH', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1011, 1301, 'INSTITUTO MATONENSE MUNICIPAL DE ENSINO SUPERIOR', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1012, 1302, 'FACULDADE BATISTA BRASILEIRA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1013, 1303, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA GOIANO', 1, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1014, 1304, 'FACULDADES INTEGRADAS DE RIBEIRAO PIRES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1015, 1305, 'FACULDADE DE CIENCIAS JURIDICAS, GERENCIAIS E EDUCACAO DE SINOP', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1016, 1306, 'FACULDADE DE CIENCIAS CONTABEIS DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1017, 1307, 'FACULDADE DE CIENCIAS HUMANAS DE GARCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1018, 1308, 'FACULDADE NOVO MILENIO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1019, 1309, 'FACULDADE JESUS MARIA JOSE', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1020, 1310, 'FACULDADE DE AMERICANA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1021, 1311, 'TREVISAN ESCOLA SUPERIOR DE NEGOCIOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1022, 1312, 'FACULDADES INTEGRADAS DE RONDONOPOLIS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1023, 1313, 'FACULDADE UNIDA DE SUZANO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1024, 1314, 'INSTITUTO DE ENSINO SUPERIOR JOAO ALFREDO DE ANDRADE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1025, 1315, 'FACULDADE DE EDUCACAO DA SERRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1026, 1316, 'FACULDADE DA TERRA DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1027, 1317, 'FACULDADE SUDOESTE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1028, 1318, 'FACULDADE JUVENCIO TERRA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1029, 1319, 'FACULDADE TECSOMA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1030, 1320, 'FACULDADE DE EDUCACAO FISICA DO LITORAL NORTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1031, 1321, 'FACULDADE DE CIENCIAS ADMINISTRATIVAS E CONTABEIS DA ZONA NORTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1032, 1322, 'FACULDADE EDUVALE DE AVARE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1033, 1323, 'FACULDADE TANCREDO NEVES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1034, 1324, 'FACULDADE DE INFORMATICA LEMOS DE CASTRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1035, 1325, 'FACULDADE DE APUCARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1036, 1326, 'FACULDADE CAPIXABA DA SERRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1037, 1327, 'ESCOLA SUPERIOR DE PROPAGANDA E MARKETING DE PORTO ALEGRE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1038, 1328, 'FACULDADE DE COMUNICACAO E TURISMO DE OLINDA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1039, 1329, 'FACULDADE DE ADMINISTRACAO DE DIADEMA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1040, 1330, 'FACULDADE COTEMIG', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1041, 1331, 'FACULDADE HOYLER DE COMUNICACAO SOCIAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1042, 1332, 'FACULDADE DE COMUNICACAO SOCIAL DE HORTOLANDIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1043, 1333, 'FACULDADE CECAP DO LAGO NORTE', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1044, 1334, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS FACISA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1045, 1335, 'INSTITUTO DE ENSINO SUPERIOR THATHI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1046, 1336, 'FACULDADE ASSIS GURGACZ', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1047, 1337, 'FACULDADE MATER DEI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1048, 1338, 'FACULDADE DE EDUCACAO DE PORTO VELHO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1049, 1339, 'FACULDADE DE CIENCIAS ADMINISTRATIVAS DE PARANAIBA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1050, 1340, 'FACULDADE DE CIENCIAS GERENCIAIS DE SETE LAGOAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1051, 1341, 'FACULDADE DE ARQUITETURA E URBANISMO DO PLANALTO CENTRAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1052, 1342, 'FACULDADE COMUNITARIA DE PEDAGOGIA DA SERRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1053, 1343, 'FACULDADE DE EDUCACAO DA TERRA DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1054, 1344, 'FACULDADE BORGES DE MENDONCA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1055, 1345, 'FACULDADE ANHANGUERA DE OSASCO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1056, 1346, 'FACULDADE BATISTA DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1057, 1347, 'FACULDADE ADVENTISTA DE ADMINISTRACAO DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1058, 1348, 'FACULDADE BATISTA DE ADMINISTRACAO E INFORMATICA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1059, 1349, 'FACULDADE DE CIENCIAS ECONOMICAS DE AFONSO CLAUDIO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1060, 1350, 'FACULDADE DO VALE DO JAGUARIBE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1061, 1351, 'CENTRO UNIVERSITARIO TUPY', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1062, 1352, 'FACULDADE ADVENTISTA DE EDUCACAO FISICA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1063, 1353, 'INSTITUTO DE ENSINO SUPERIOR DE GARCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1064, 1354, 'FACULDADE DE CIENCIA DE ADMINISTRACAO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1065, 1355, 'FACULDADES INTEGRADAS DE JAHU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1066, 1356, 'FACULDADES INTEGRADAS DE SANTA FE DO SUL', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1067, 1357, 'INSTITUTO SUPERIOR DE EDUCACAO DO RIO DE JANEIRO', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1068, 1358, 'FACULDADE DE PEDAGOGIA DE AFONSO CLAUDIO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1069, 1359, 'FACULDADE CAPIXABA DE NOVA VENECIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1071, 1361, 'FACULDADE DOM ORIONE', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1072, 1362, 'FACULDADE UBAENSE OZANAM COELHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1073, 1363, 'FACULDADE VISCONDE DE CAIRU', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1074, 1364, 'FACULDADE DE TECNOLOGIA E CIENCIAS DE VITORIA DA CONQUISTA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1075, 1365, 'CENTRO UNIVERSITARIO ADVENTISTA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1076, 1366, 'FACULDADE BARDDAL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1077, 1367, 'FACULDADE DE CIENCIA DA COMPUTACAO DE FORMIGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1078, 1368, 'FACULDADE DE CIENCIAS CONTABEIS DE BOM DESPACHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1079, 1369, 'FACULDADE SENAC DE TURISMO E HOTELARIA DE AGUAS DE SAO PEDRO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1080, 1370, 'FACULDADE SENAC DE TURISMO E HOTELARIA DE CAMPOS DO JORDAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1081, 1371, 'FACULDADE DE MIRANDOPOLIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1082, 1372, 'FACULDADE SENAC DE EDUCACAO AMBIENTAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1083, 1373, 'FACULDADE CASA BRANCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1084, 1374, 'FACULDADE DE CIENCIAS SOCIAIS DE GUARANTA DO NORTE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1085, 1375, 'FACULDADE CATOLICA RAINHA DA PAZ DE ARAPUTANGA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1086, 1376, 'FACULDADE COMPACTO DE EDUCACAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1087, 1377, 'FACULDADE DE CIENCIA E TECNOLOGIA DO PLANALTO CENTRAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1088, 1378, 'FACULDADE ASSEMBLEIANA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1089, 1379, 'FACULDADES INTEGRADAS SAO PEDRO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1090, 1380, 'FACULDADE DE DOMINGOS MARTINS', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1091, 1381, 'FACULDADE MARTHA FALCAO', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1092, 1382, 'FACULDADES EST', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1093, 1383, 'FACULDADE JOSE LACERDA FILHO DE CIENCIAS APLICADAS', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1094, 1384, 'FACULDADE SANTA HELENA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1095, 1385, 'FACULDADES INTEGRADAS IPEP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1096, 1386, 'FACULDADE ESAMC CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1097, 1387, 'FACULDADE OCTOGONO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1098, 1388, 'FACULDADE SUMARE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1099, 1389, 'FACULDADE TORRICELLI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1100, 1390, 'FACULDADE ELITE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1101, 1394, 'FACULDADE CASTRO ALVES', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1102, 1395, 'FACULDADE DE CALDAS NOVAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1103, 1396, 'CENTRO UNIVERSITARIO DINAMICA DAS CATARATAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1104, 1397, 'FACULDADE OESTE MINEIRA DE INFORMATICA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1105, 1398, 'FACULDADE DE DIREITO DOS CAMPOS GERAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1106, 1399, 'FACULDADE UNISSA DE SARANDI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1107, 1400, 'FACULDADE METROPOLITANA DE CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1108, 1401, 'FACULDADE ADELMAR ROSADO', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1109, 1402, 'INSTITUTO DE CIENCIAS SOCIAIS E HUMANAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1110, 1403, 'FACULDADE DE PIMENTA BUENO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1111, 1404, 'FACULDADE DE PIRACANJUBA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1112, 1405, 'FACULDADE DE CIENCIAS CONTABEIS DE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1113, 1406, 'FACULDADE DE ENGENHARIA E TECNOLOGIA DO INSTITUTO MAIRIPORA DE ENSINO SUPERIOR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1114, 1407, 'FACULDADE DE ECONOMIA E ADMINISTRACAO DOMUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1115, 1408, 'FACULDADE DE SANTO ANDRE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1116, 1409, 'FACULDADE DO CENTRO LESTE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1117, 1410, 'AREA1   FACULDADE DE CIENCIA E TECNOLOGIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1118, 1411, 'FACULDADE DOIS DE JULHO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1119, 1412, 'FACULDADE ANHAGUERA DE JUNDIAI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1120, 1413, 'FACULDADE DE PRIMAVERA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1121, 1414, 'FACULDADE SAO LUCAS', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1122, 1415, 'FACULDADE MAGISTER', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1123, 1416, 'FACULDADE GRANDE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1124, 1417, 'FACULDADE CENECISTA DE CAMPO LARGO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1125, 1418, 'CENTRO UNIVERSITARIO TOLEDO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1126, 1419, 'CENTRO UNIVERSITARIO CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1127, 1420, 'FACULDADES DE DRACENA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1128, 1422, 'CENTRO UNIVERSITARIO DO NORTE', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1129, 1423, 'FACULDADE IDEAL', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1130, 1424, 'FACULDADE PIO XII', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1131, 1425, 'FACULDADE EVOLUTIVO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1132, 1426, 'INSTITUTO LUTERANO DE ENSINO SUPERIOR DE ITUMBIARA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1133, 1427, 'FACULDADE DA SERRA GAUCHA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1134, 1428, 'INSTITUTO DE ENSINO SUPERIOR PLANALTO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1135, 1429, 'FACULDADE BATISTA DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1136, 1430, 'FACULDADE INGA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1137, 1431, 'FACULDADE PIRATININGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1138, 1432, 'FACULDADE BERTIOGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1139, 1433, 'FACULDADE ORIGENES LESSA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1140, 1434, 'INSTITUTO DE ENSINO SUPERIOR DE ITAPIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1141, 1435, 'FACULDADE DE VILA VELHA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1142, 1436, 'ESCOLA SUPERIOR BATISTA DO AMAZONAS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1143, 1437, 'ESCOLA SUPERIOR DE TECNOLOGIA E EDUCACAO DE RIO CLARO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1144, 1438, 'FACULDADE DE ADMINISTRACAO DE EMPRESAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1145, 1439, 'FACULDADE DE CIENCIAS ECONOMICAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1146, 1440, 'INSTITUTO APHONSIANO DE ENSINO SUPERIOR', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1147, 1441, 'FACULDADE DE TECNOLOGIA DO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1148, 1442, 'FACULDADE DE DIREITO DE TANGARA DA SERRA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1149, 1443, 'FACULDADE NACIONAL', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1150, 1444, 'FACULDADES INTEGRADAS EINSTEIN DE LIMEIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1151, 1445, 'CENTRO UNIVERSITARIO DO INSTITUTO MAUA DE TECNOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1152, 1446, 'CENTRO UNIVERSITARIO PLANALTO DO DISTRITO FEDERAL UNIPLAN', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1153, 1447, 'FACULDADE DE DIREITO DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1154, 1448, 'FACULDADE DO CENTRO EDUCACIONAL DE NITEROI', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1155, 1449, 'FACULDADE DE EDUCACAO, ADMINISTRACAO E TECNOLOGIA DE IBAITI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1156, 1450, 'CENTRO UNIVERSITARIO DO CERRADO PATROCINIO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1157, 1451, 'FACULDADES INTEGRADAS DE SAO CARLOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1158, 1452, 'FACULDADE ATENAS MARANHENSE', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1159, 1453, 'FACULDADE DO NORTE DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1160, 1454, 'FACULDADE SALESIANA DO NORDESTE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1161, 1455, 'FACULDADE SANTISSIMO SACRAMENTO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1162, 1456, 'FACULDADE ANHANGUERA DE SERTAOZINHO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1163, 1457, 'FACULDADE ESTACIO EURO PANAMERICANA DE HUMANIDADES E TECNOLOGIAS ESTACIO EUROPAN', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1164, 1458, 'FACULDADE DO NORTE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1165, 1459, 'FACULDADE DE CIENCIAS HUMANAS E SOCIAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1166, 1460, 'FACULDADE DE CIENCIAS SOCIAIS E APLICADAS DO COMPLEXO DE ENSINO SUPERIOR DO BRASIL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1167, 1461, 'FACULDADE DE TECNOLOGIA E CIENCIAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1168, 1462, 'INSTITUTO PARAIBANO DE ENSINO RENOVADO', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1169, 1463, 'FACULDADE ALFACASTELO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1170, 1464, 'HSM ESCOLA SUPERIOR DE ADMINISTRACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1171, 1465, 'FACULDADE DE RIBEIRAO PRETO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1172, 1466, 'INSTITUTO DE ENSINO SUPERIOR DE ALPHAVILLE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1173, 1467, 'FACULDADE CENECISTA DE VILA VELHA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1174, 1468, 'FACULDADE ESAMC UBERLANDIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1175, 1469, 'FACULDADE DE CIENCIAS SOCIAIS DE FLORIANOPOLIS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1176, 1470, 'FACULDADE CAMOES', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1177, 1471, 'INSTITUTO DE ENSINO SUPERIOR DE LINHARES', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1178, 1472, 'CENTRO UNIVERSITARIO LEONARDO DA VINCI', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1179, 1473, 'FACULDADE DE ADMINISTRACAO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1180, 1474, 'FACULDADE DE EDUCACAO DE ATIBAIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1181, 1475, 'FACULDADE DE CIENCIAS ECONOMICAS DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1182, 1476, 'FACULDADES INTEGRADAS INTERAMERICANAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1183, 1477, 'FACULDADE MICHELANGELO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1184, 1478, 'FACULDADE ANHANGUERA DE SAO BERNARDO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1185, 1479, 'FACULDADES INTEGRADAS TIBIRICA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1186, 1480, 'FACULDADE DE LETRAS DOMUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1187, 1481, 'FACULDADE DE ADMINISTRACAO DE FLORIANOPOLIS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1188, 1482, 'FACULDADE DE CIENCIAS ECONOMICAS VIANNA JUNIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1189, 1483, 'FACULDADE DE CIENCIAS ECONOMICAS DE EUNAPOLIS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1190, 1484, 'FACULDADE IBMEC', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1191, 1485, 'FACULDADE DE ENFERMAGEM DE CATANDUVA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1192, 1486, 'FACULDADE ESTACIO DE SA DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1193, 1487, 'FACULDADE DOM BOSCO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1194, 1488, 'FACULDADE PARAISO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1195, 1489, 'FACULDADE DE SELVIRIA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1196, 1490, 'FACULDADE DE JAGUARIUNA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1197, 1491, 'CENTRO UNIVERSITARIO INTERNACIONAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1198, 1492, 'FACULDADE PITAGORAS DE UBERLANDIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1199, 1493, 'FACULDADE ALVES FARIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1200, 1494, 'FACULDADE CATOLICA SALESIANA DO ESPIRITO SANTO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1201, 1495, 'FACULDADE UNIAO DE QUEDAS DO IGUACU', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1202, 1496, 'FACULDADE ESTACIO DE SA DE VILA VELHA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1203, 1497, 'FACULDADE DE ADMINISTRACAO DE SANTA CRUZ DO RIO PARDO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1204, 1498, 'INSTITUTO DE ENSINO SUPERIOR E FORMACAO AVANCADA DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1205, 1499, 'FACULDADE ANHANGUERA DE TABOAO DA SERRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1206, 1500, 'FACULDADE DE ENSINO SUPERIOR DE SAO MIGUEL DO IGUACU', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1207, 1501, 'FACULDADE LATINO AMERICANA DE EDUCACAO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1208, 1502, 'FACULDADE PITAGORAS DE JUNDIAI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1209, 1503, 'FACULDADE DOUTOR LEOCADIO JOSE CORREIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1210, 1504, 'FACULDADE MAURICIO DE NASSAU DE MACEIO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1211, 1505, 'FACULDADE DE MEDICINA VETERINARIA E ZOOTECNIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1212, 1506, 'INSTITUTO CENECISTA FAYAL DE ENSINO SUPERIOR', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1213, 1507, 'FACULDADE PROJECAO DE CEILANDIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1214, 1508, 'FACULDADE METROPOLITANA DE MARINGA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1215, 1509, 'FACULDADE ESTACIO DE SA DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1216, 1510, 'FACULDADE ESTACIO DE SA DE SANTA CATARINA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1217, 1511, 'FACULDADE DE ENFERMAGEM DOS CAMPOS GERAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1218, 1512, 'FACULDADE DE CIENCIA DA EDUCACAO DE LAGES', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1219, 1513, 'INSTITUTO DE CIENCIAS JURIDICAS E SOCIAIS PROFESSOR CAMILLO FILHO', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1220, 1514, 'FACULDADE VALE DO CRICARE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1221, 1515, 'FACULDADE DE EDUCACAO DE PORTO VELHO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1222, 1516, 'FACULDADE DE VINHEDO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1223, 1517, 'FACULDADE NOVO ATENEU DE GUARAPUAVA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1224, 1518, 'FACULDADE SANTA TEREZINHA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1225, 1519, 'FACULDADE DE PATO BRANCO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1226, 1520, 'FACULDADE FIA DE ADMINISTRACAO E NEGOCIOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1227, 1521, 'INSTITUTO DE ESTUDOS SUPERIORES DA AMAZONIA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1228, 1522, 'FACULDADE DE EDUCACAO DE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1229, 1523, 'FACULDADE DE DIREITO FRANCISCO BELTRAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1230, 1524, 'FACULDADES INTEGRADAS OLGA METTIG', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1231, 1525, 'FACULDADE DE CIENCIAS CONTABEIS DE AFONSO CLAUDIO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1232, 1526, 'FACULDADE DE TECNOLOGIA SENAI ANTOINE SKAF', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1233, 1527, 'FACULDADE TAMOIOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1234, 1528, 'FACULDADE DE CIENCIAS HUMANAS SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1235, 1529, 'FACULDADE DE EDUCACAO FISICA DE AMERICANA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1236, 1530, 'FACULDADE CENECISTA DE JOINVILLE FACE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1237, 1531, 'FACULDADE DE ENFERMAGEM DO PLANALTO CENTRAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1238, 1532, 'FACULDADE DE FILOSOFIA, CIENCIAS E LETRAS NOSSA SENHORA APARECIDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1239, 1533, 'FACULDADE DE COMUNICACAO SOCIAL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1240, 1534, 'FACULDADE DE CIENCIAS, LETRAS E EDUCACAO DO NOROESTE DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1241, 1535, 'FACULDADE SAO JUDAS TADEU DE PINHAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1242, 1536, 'FACULDADE DE TELEMACO BORBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1243, 1537, 'FACULDADE EXPONENCIAL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1244, 1538, 'FACULDADE PROJECAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1245, 1539, 'FACULDADE ITALO BRASILEIRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1246, 1540, 'INSTITUTO DE ENSINO SUPERIOR DE RONDONIA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1247, 1541, 'FACULDADE FLAMINGO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1248, 1542, 'CENTRO UNIVERSITARIO GERALDO DI BIASE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1249, 1543, 'FACULDADE DE DIREITO DE LINHARES', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1250, 1544, 'FACULDADE DECISAO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1251, 1545, 'INSTITUTO DE EDUCACAO SUPERIOR DE BOITUVA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1252, 1546, 'FACULDADE DE EDUCACAO SAO FRANCISCO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1253, 1547, 'FACULDADE DE MEDICINA ESTACIO DE JUAZEIRO DO NORTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1254, 1548, 'FACULDADE DE CAMPO GRANDE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1255, 1549, 'FACULDADE PALAS ATENA DE CHOPINZINHO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1256, 1550, 'FACULDADE DE EDUCACAO FISICA DE FOZ DO IGUACU', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1257, 1551, 'FACULDADE FRANCO BRASILEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1258, 1552, 'FACULDADE PIAUIENSE', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1259, 1553, 'FACULDADE DE ODONTOLOGIA DE SAO JOSE DO RIO PRETO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1260, 1554, 'FACULDADES INTEGRADAS DO VALE DO RIBEIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1261, 1555, 'FACULDADE DE DIREITO DE GUARAPUAVA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1262, 1556, 'FACULDADE SETE DE SETEMBRO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1263, 1557, 'UNIVERSIDADE FUMEC', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1264, 1558, 'FACULDADE COMUNITARIA DE JOAO MONLEVADE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1265, 1559, 'CENTRO UNIVERSITARIO DO ESPIRITO SANTO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1266, 1561, 'FACULDADE ESAMC SOROCABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1267, 1562, 'FACULDADE DE ILHA SOLTEIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1268, 1563, 'CENTRO UNIVERSITARIO DA FACULDADE DE SAUDE, CIENCIAS HUMANAS E TECNOLOGICAS DO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1269, 1564, 'FACULDADE SUL FLUMINENSE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1270, 1565, 'FACULDADE UNIME DE CIENCIAS JURIDICAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1271, 1566, 'FACULDADE DE CIENCIAS GERENCIAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1272, 1567, 'FACULDADE VIZINHANCA VALE DO IGUACU', 3, 1, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1273, 1568, 'FACULDADES INTEGRADAS DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1274, 1569, 'FACULDADES INTEGRADAS DE ARARAQUARA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1275, 1570, 'FACULDADE DE CIENCIAS CONTABEIS DE POMBAL', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1276, 1571, 'FACULDADE UNIME DE CIENCIAS SOCIAIS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1277, 1572, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1278, 1573, 'FACULDADE ALFREDO NASSER', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1279, 1574, 'FACULDADE EDUCACIONAL DE MEDIANEIRA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1280, 1575, 'CENTRO UNIVERSITARIO DO PLANALTO DE ARAXA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1281, 1576, 'INSTITUTO DE ENSINO SUPERIOR BLAURO CARDOSO DE MATTOS', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1282, 1577, 'FACULDADE INTERMUNICIPAL DO NOROESTE DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1283, 1578, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA SULRIOGRANDENSE', 1, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1284, 1579, 'FACULDADE DE CIENCIAS SOCIAIS DE IBIRACU', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1285, 1580, 'FACULDADE DE CIENCIAS E EDUCACAO SENA AIRES', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1286, 1581, 'FACULDADE DA CIDADE DE SANTA LUZIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1287, 1582, 'FACULDADE DECISAO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1288, 1583, 'FACULDADE DE TECNOLOGIA DE INDAIATUBA', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1289, 1584, 'FACULDADE DE TECNOLOGIA DE GUARATINGUETA', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1290, 1585, 'FACULDADE ENERGIA DE ADMINISTRACAO E NEGOCIOS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1291, 1586, 'UNIVERSIDADE DO VALE DO SAPUCAI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1292, 1587, 'FACULDADES INTEGRADAS DE TANGARA DA SERRA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1293, 1588, 'FACULDADE PITAGORAS DE TURISMO E HOTELARIA DE MONTES CLAROS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1294, 1589, 'FACULDADE DE CASCAVEL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1295, 1590, 'FACULDADE ESTACIO DE SAO LUIS', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1296, 1591, 'FACULDADE SEAMA', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1297, 1592, 'FACULDADE DE ODONTOLOGIA DE MANAUS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1298, 1593, 'FACULDADE DE PEDAGOGIA DE EUNAPOLIS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1299, 1594, 'FACULDADE DE LETRAS DA INSTITUICAO DE ENSINO SUPERIOR DE GOIAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1300, 1595, 'FACULDADE DE LETRAS UNIAO DE ENSINO SUPERIOR CERTO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1301, 1596, 'FACULDADE DE CIENCIAS E EDUCACAO DO ESPIRITO SANTO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1302, 1597, 'FACULDADE SANTA FE', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1303, 1598, 'FACULDADE POLITECNICA DE UBERLANDIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1304, 1599, 'INSTITUTO DE ENSINO SUPERIOR PRESIDENTE TANCREDO DE ALMEIDA NEVES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1305, 1600, 'INSTITUTO DE CIENCIAS DA SAUDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1306, 1601, 'FACULDADE CIDADE DE COROMANDEL', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1307, 1602, 'FACULDADE DE CIENCIAS GERENCIAIS DO OESTE DE MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1308, 1603, 'FACULDADE DE COMUNICACAO SOCIAL DO OESTE DE MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1309, 1604, 'FACULDADE MAGNUN DE EDUCACAO FISICA E ESPORTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1310, 1605, 'FACULDADE DE ADMINISTRACAO DE NOVA ANDRADINA FANOVA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1311, 1606, 'FACULDADES INTEGRADAS DE CASSILANDIA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1312, 1607, 'FACULDADE LUTERANA SAO MARCOS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1313, 1608, 'FACULDADE DE INFORMATICA DE PATOS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1314, 1609, 'FACULDADE DOS CERRADOS PIAUIENSES', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1315, 1610, 'FACULDADE DAS ATIVIDADES EMPRESARIAIS DE TERESINA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1316, 1611, 'FACULDADE EDUCACIONAL DE ARAPOTI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1317, 1612, 'FACULDADE SUL BRASIL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1318, 1613, 'FACULDADE ADVENTISTA PARANAENSE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1320, 1615, 'INSTITUTO SUPERIOR DO LITORAL DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1321, 1616, 'FACULDADE ANGEL VIANNA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1322, 1617, 'FACULDADE DE CIENCIAS ECONOMICAS DA REGIAO CARBONIFERA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1323, 1618, 'INSTITUTO BLUMENAUENSE DE ENSINO SUPERIOR', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1324, 1619, 'FACULDADE ERNESTO RISCALI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1325, 1620, 'FACULDADE SANTA RITA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1326, 1621, 'FACULDADE NETWORK', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1327, 1622, 'FACULDADE DO INTERIOR PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1328, 1623, 'FACULDADE DE CIENCIAS AGRARIAS DE ANDRADINA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1329, 1624, 'FACULDADE MARECHAL RONDON', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1330, 1625, 'FACULDADE REUNIDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1331, 1626, 'CENTRO DE TECNOLOGIA E CIENCIA CETEC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1332, 1627, 'FACULDADE DE EDUCACAO DE MONTE ALTO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1333, 1628, 'FACULDADE DE CIENCIAS HUMANAS DE AGUAI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1334, 1629, 'INSTITUTO DE ENSINO SUPERIOR AQUIDAUANENSE', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1335, 1630, 'FACULDADE ITABIRANA DE DESENVOLVIMENTO DAS CIENCIAS E TECNOLOGIAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1336, 1631, 'FACULDADE PITAGORAS DE FISIOTERAPIA DE MONTES CLAROS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1337, 1632, 'FACULDADE PITAGORAS DE LONDRINA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1338, 1633, 'CENTRO FEDERAL DE EDUCACAO TECNOLOGICA DE CUIABA', 1, 1, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1339, 1634, 'FACULDADE COMUNITARIA DA SERRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1340, 1635, 'FACULDADE DE CIENCIAS DA SAUDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1341, 1636, 'CASTELLI ESCOLA SUPERIOR DE HOTELARIA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1342, 1637, 'FACULDADE DE CIENCIAS JURIDICAS E SOCIAIS DE MACEIO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1343, 1638, 'FACULDADE DO AMAZONAS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1344, 1639, 'FACULDADE HELIO ROCHA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1345, 1640, 'FACULDADE DE CIENCIAS HUMANAS E SOCIAIS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1346, 1641, 'FACULDADE SOCIAL DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1347, 1642, 'FACULDADE DE TECNOLOGIA E CIENCIAS DE ITABUNA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1348, 1643, 'FACULDADE ANISIO TEIXEIRA DE FEIRA DE SANTANA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1349, 1644, 'FACULDADE UNIME DE EDUCACAO E COMUNICACAO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1350, 1645, 'FACULDADE DE TECNOLOGIA E CIENCIAS DE JEQUIE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1351, 1646, 'FACULDADE DE EDUCACAO CIENCIAS E LETRAS DE PARAISO', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1352, 1647, 'FACULDADE DE ENSINO E CULTURA DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1353, 1648, 'FACULDADE COMPACTO DE COMUNICACAO SOCIAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1354, 1649, 'FACULDADE DE COMUNICACAO DA SERRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1355, 1650, 'FACULDADE J. SIMOES ENSINO SUPERIOR', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1356, 1651, 'FACULDADE DE EDUCACAO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1357, 1652, 'FACULDADE DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1358, 1653, 'FACULDADE DE CIENCIA E EDUCACAO DO CAPARAO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1359, 1654, 'INSTITUTO DE ENSINO SUPERIOR DE NOVA VENECIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1360, 1655, 'FACULDADE CENECISTA DE SETE LAGOAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1361, 1656, 'INSTITUTO DE ENSINO SUPERIOR DE TERESINA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1362, 1657, 'FACULDADE EDUCACIONAL DE DOIS VIZINHOS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1363, 1658, 'FACULDADE INTEGRADA DA GRANDE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1364, 1659, 'FACULDADE ESTACIO DE SA DE OURINHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1365, 1660, 'FACULDADE DE CIENCIAS SOCIAIS E TECNOLOGICAS FACITEC', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1366, 1661, 'FACULDADE PROJECAO DE SOBRADINHO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1367, 1662, 'FACULDADE COMUNITARIA DE ADMINISTRACAO E EDUCACAO DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1368, 1663, 'FACULDADE ARAGUAIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1369, 1664, 'FACULDADE DA SAUDE E ECOLOGIA HUMANA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1370, 1665, 'FACULDADE KENNEDY', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1371, 1666, 'FACULDADE NOVOS HORIZONTES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1372, 1667, 'FACULDADE INTERNACIONAL DE CIENCIAS EMPRESARIAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1373, 1668, 'FACULDADE DE NEGOCIOS DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1374, 1669, 'INSTITUTO METROPOLITANO DE ENSINO SUPERIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1375, 1670, 'FACULDADE ASA DE BRUMADINHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1376, 1671, 'FACULDADE DE ENSINO UNIFICADO DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1377, 1672, 'INSTITUTO ESPERANCA DE ENSINO SUPERIOR', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1378, 1673, 'FACULDADE DE AGRONOMIA DE POMBAL', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1379, 1674, 'INSTITUTO SALESIANO DE FILOSOFIA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1380, 1675, 'FACULDADE METROPOLITANA DA GRANDE RECIFE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1381, 1676, 'FACULDADE SAO MIGUEL', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1382, 1677, 'FACULDADE DE ENSINO SUPERIOR DO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1383, 1678, 'FACULDADE DE CIENCIAS DE WENCESLAU BRAZ', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1384, 1679, 'FACULDADE DE CAMPINA GRANDE DO SUL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1385, 1680, 'FACULDADE DE CIENCIAS E TECNOLOGIA MATER CHRISTI', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1386, 1681, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS IBMEC', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1387, 1682, 'FACULDADE SALESIANA MARIA AUXILIADORA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1388, 1683, 'FACULDADE PIAUIENSE', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1389, 1684, 'FACULDADE DE RORAIMA', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1391, 1686, 'FACULDADE BARDDAL DE ARTES APLICADAS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1392, 1687, 'FACULDADE IDEPE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1393, 1688, 'FACULDADE SENAC DE EDUCACAO EM SAUDE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1394, 1689, 'FACULDADE SANTA IZILDINHA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1395, 1690, 'FACULDADE DE SAO VICENTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1396, 1691, 'FACULDADE PRAXIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1397, 1692, 'ESCOLA SUPERIOR DE TECNOLOGIA E EDUCACAO DE PORTO FERREIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1398, 1693, 'FACULDADE ITANHAEM', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1399, 1694, 'ESCOLA SUPERIOR DE CRICIUMA ESUCRI', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1400, 1695, 'FACULDADE DE EDUCACAO DE BOM DESPACHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1401, 1696, 'FACULDADE CENTRAL DE CRISTALINA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1402, 1697, 'FACULDADE ESCRITOR OSMAN DA COSTA LINS', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1403, 1698, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DO CESCARELI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1404, 1699, 'FACULDADE DE EDUCACAO DE JARU', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1405, 1700, 'FACULDADE PROMOVE DE SETE LAGOAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1406, 1701, 'FACULDADE MACHADO DE ASSIS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1407, 1702, 'ESTACIO ATUAL FACULDADE ESTACIO DA AMAZONIA', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1408, 1703, 'INSTITUTO DE ENSINO SUPERIOR DE RIO VERDE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1409, 1704, 'FACULDADE DE ADMINISTRACAO DO ALTO VALE DO RIO TUBARAO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1410, 1705, 'FACULDADE DE EDUCACAO DO ALTO VALE DO RIO TUBARAO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1411, 1706, 'FACULDADE DE INFORMATICA DO RECIFE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1412, 1707, 'FACULDADE DE CIENCIAS CONTABEIS DE RECIFE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1413, 1708, 'INSTITUTO PERNAMBUCANO DE ENSINO SUPERIOR', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1414, 1709, 'FACULDADE INTEGRADA DE PERNAMBUCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1415, 1710, 'FACULDADE DE NEGOCIOS E TECNOLOGIAS DA INFORMACAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1416, 1711, 'FACULDADE DE PRESIDENTE PRUDENTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1417, 1712, 'FACULDADE DE CIENCIAS E TECNOLOGIA DE TERESINA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1418, 1713, 'FACULDADE DE TECNOLOGIA DE SAO VICENTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1419, 1714, 'ESCOLA SUPERIOR DE GESTAO COMERCIAL E MARKETING', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1420, 1715, 'FACULDADE DO SUL DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1421, 1716, 'FACULDADE UNIAO DAS AMERICAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1422, 1717, 'FACULDADE DE IMPERATRIZ', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1423, 1718, 'FACULDADE NOBRE DE FEIRA DE SANTANA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1424, 1719, 'FACULDADE DE ADMINISTRACAO DE CAMPOS GERAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1425, 1720, 'FACULDADE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1426, 1721, 'FACULDADE DE VICOSA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1427, 1722, 'FACULDADE DE PORTO VELHO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1428, 1723, 'ESCOLA SUPERIOR DE ADMINISTRACAO E GESTAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1429, 1724, 'FACULDADE DE GUARARAPES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1430, 1725, 'FACULDADE XV DE AGOSTO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1431, 1726, 'FACULDADE SANTA AMELIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1432, 1727, 'FACULDADE DE CARIACICA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1433, 1728, 'FACULDADE INTERAMERICANA DE PORTO VELHO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1434, 1729, 'FACULDADE DE ODONTOLOGIA DOS CAMPOS GERAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1435, 1730, 'FACULDADE NORTE CAPIXABA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1436, 1731, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1437, 1732, 'FACULDADE GENNARI E PEARTREE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1438, 1733, 'FACULDADE DE ENSINO SUPERIOR DE MARECHAL CANDIDO RONDON', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1439, 1734, 'FACULDADE INTEGRAL DIFERENCIAL', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1440, 1735, 'FACULDADE DE CIENCIAS APLICADAS DOUTOR LEAO SAMPAIO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1441, 1736, 'CENTRO UNIVERSITARIO LA SALLE DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1442, 1737, 'FACULDADE DE INFORMATICA DE TAQUARA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1443, 1738, 'INSTITUTO LUTERANO DE ENSINO SUPERIOR DE PORTO VELHO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1444, 1739, 'IMP DE ENSINO SUPERIOR IMP', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1445, 1740, 'FACULDADE DE TECNOLOGIA RADIAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1446, 1741, 'FACULDADE DE TECNOLOGIA INTERAMERICA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1447, 1742, 'FACULDADE DE TECNOLOGIA CARLOS DRUMMOND DE ANDRADE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1596, 1891, 'FACULDADE SARTRE COC', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1448, 1743, 'FACULDADE DE TECNOLOGIA OSWALDO CRUZ', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1449, 1744, 'FACULDADE DE TECNOLOGIA OPET', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1450, 1745, 'FACULDADE DE TECNOLOGIA ALVARES DE AZEVEDO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1451, 1746, 'FACULDADE DE TECNOLOGIA DAS AMERICAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1452, 1747, 'FACULDADE DE TECNOLOGIA FLAMINGO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1453, 1748, 'FACULDADE DE TECNOLOGIA MARIO DE ANDRADE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1454, 1749, 'FACULDADE LUSOBRASILEIRA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1455, 1750, 'UNIDADE DE ENSINO SUPERIOR EXPOENTE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1456, 1751, 'FACULDADE DE DESIGN GRAFICO', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1457, 1752, 'FACULDADE AUTONOMA DE DIREITO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1458, 1753, 'FACULDADE DE ENFERMAGEM NOVA ESPERANCA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1459, 1754, 'INSTITUTO SUPERIOR DE EDUCACAO DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1460, 1755, 'FACULDADE EQUIPE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1461, 1756, 'FACULDADE ASSOCIADA BRASIL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1462, 1757, 'ESCOLA SUPERIOR DE ADMINISTRACAO, MARKETING E COMUNICACAO DE GOIANIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1463, 1758, 'FACULDADE INDEPENDENTE DO NORDESTE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1464, 1759, 'FACULDADE PADRE JOAO BAGOZZI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1465, 1760, 'FACULDADE DE PEDAGOGIA DE VITORIA DE SANTO ANTAO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1466, 1761, 'FACULDADE BRASILEIRA DE GESTAO E NEGOCIOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1467, 1762, 'FACULDADE DE TECNOLOGIA E NEGOCIOS CARLOS DRUMMOND DE ANDRADE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1468, 1763, 'FACULDADE DE TECNOLOGIA SENAI CHAPECO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1469, 1764, 'FACULDADE DE EDUCACAO REGIONAL SERRANA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1470, 1765, 'FACULDADE DE JOSE BONIFACIO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1471, 1766, 'FACULDADE ESPIRITO SANTENSE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1472, 1767, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1473, 1768, 'FACULDADE REGIONAL SERRANA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1474, 1769, 'FACULDADE DE TURISMO DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1475, 1770, 'FACULDADE DE CIENCIAS EXATAS E TECNOLOGICAS DA INSTITUICAO DE ENSINO SUPERIOR DE GOIAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1476, 1771, 'FACULDADE SANTA MARIA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1477, 1772, 'FACULDADE NORDESTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1478, 1773, 'FACULDADE DE ITAPIRANGA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1479, 1774, 'FACULDADE EDUCACIONAL DE PONTA GROSSA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1480, 1775, 'FACULDADE DO VALE DO IPOJUCA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1481, 1776, 'FACULDADE DE TECNOLOGIA PROF. LUIZ ROSA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1482, 1777, 'FACULDADE METROPOLITANA DE GUARAMIRIM', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1483, 1778, 'FACULDADE DE EDUCACAO, CIENCIAS E LETRAS SAO JUDAS TADEU', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1485, 1780, 'FACULDADE HORIZONTINA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1486, 1781, 'FACULDADE INTESP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1487, 1782, 'FACULDADE DE ARTES, CIENCIAS E TECNOLOGIAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1488, 1783, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1489, 1784, 'FACULDADE ANHANGUERA DE SAO CAETANO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1490, 1785, 'FACULDADE DE COLIDER', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1491, 1786, 'INSTITUTO MACHADENSE DE ENSINO SUPERIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1492, 1787, 'INSTITUTO DE ENSINO SUPERIOR DE JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1493, 1788, 'FACULDADE DE ADMINISTRACAO E ARTES DE LIMEIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1494, 1789, 'FACULDADE CATUAI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1495, 1790, 'INSTITUTO SUPERIOR DE EDUCACAO DO SUL DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1496, 1791, 'FACULDADE DE CIENCIAS EXATAS E TECNOLOGICAS DA UNIAO DE ENSINO SUPERIOR CERTO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1497, 1792, 'FACULDADE DE EDUCACAO DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1498, 1793, 'FACULDADE DE CIENCIAS EXATAS E TECNOLOGICAS DE UNIAO DA VITORIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1499, 1794, 'FACULDADE DE CIENCIAS HUMANAS DE UNIAO DA VITORIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1500, 1795, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DE UNIAO DA VITORIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1501, 1796, 'FACULDADE DE MATEMATICA DA INSTITUICAO DE ENSINO SUPERIOR DE GOIAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1502, 1797, 'FACULDADE NORTE PARANAENSE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1503, 1798, 'FACULDADE EDUCACIONAL DE CORNELIO PROCOPIO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1504, 1799, 'FACULDADE BRASILIA DE TECNOLOGIA, CIENCIAS E EDUCACAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1505, 1800, 'FACULDADE DE REALEZA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1506, 1801, 'FACULDADE DOM BOSCO DE UBIRATA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1507, 1802, 'FACULDADE DE CIENCIAS DA SAUDE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1508, 1803, 'FACULDADE DE TECNOLOGIA E CIENCIAS DE PERNAMBUCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1509, 1804, 'FACULDADE DE MAUA FAMA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1510, 1805, 'FACULDADE DOS GUARARAPES', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1511, 1806, 'FACULDADE FERNAO DIAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1512, 1807, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO CEARA', 1, 1, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1513, 1808, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO ESPIRITO SANTO', 1, 1, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1514, 1809, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DE PERNAMBUCO', 1, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1515, 1810, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DE SAO PAULO', 1, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1516, 1811, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DE GOIAS', 1, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1517, 1812, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO AMAZONAS', 1, 1, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1518, 1813, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO PARA', 1, 1, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1519, 1814, 'FACULDADE DE CIENCIAS SOCIAIS E APLICADAS DE DIAMANTINO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1520, 1815, 'FACULDADE DO INSTITUTO BRASIL', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1521, 1816, 'INSTITUTO DE ENSINO SUPERIOR DE BAURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1522, 1817, 'FACULDADE ESTACIO DE CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1523, 1818, 'FACULDADE PITAGORAS DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1524, 1819, 'FACULDADE FARIAS BRITO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1525, 1820, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO PIAUI', 1, 1, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1526, 1821, 'FACULDADE LIONS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1527, 1822, 'FACULDADE SULAMERICANA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1528, 1823, 'INSTITUTO DE ENSINO SUPERIOR DO AMAPA', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1529, 1824, 'FACULDADE DE CIENCIAS CONTABEIS DE ITABIRITO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1530, 1825, 'FACULDADE DE ESTUDOS SUPERIORES DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1532, 1827, 'FACULDADE LUTERANA DE TEOLOGIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1533, 1828, 'ESCOLA DA CIDADE FACULDADE DE ARQUITETURA E URBANISMO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1534, 1829, 'FACULDADE DE TECNOLOGIA UIRAPURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1535, 1830, 'FACULDADE ANHANGUERA DE PASSO FUNDO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1536, 1831, 'FACULDADE CENTRO PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1537, 1832, 'FACULDADE DE JABOTICABAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1538, 1833, 'FACULDADE DE ARUJA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1539, 1834, 'FACULDADE DE AGUDOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1540, 1835, 'FACULDADE INTEGRADA DE ENSINO SUPERIOR DE COLINAS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1541, 1836, 'CENTRO UNIVERSITARIO FUNDACAO DE ENSINO OCTAVIO BASTOS   FEOB', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1542, 1837, 'ESCOLA DE ESTUDOS SUPERIORES DE VICOSA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1543, 1838, 'FACULDADES INTEGRADAS RIO BRANCO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1544, 1839, 'FACULDADES INTEGRADAS DE VARZEA GRANDE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1545, 1840, 'FACULDADE CASTELO BRANCO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1546, 1841, 'FACULDADES INTEGRADAS ANTONIO EUFRASIO DE TOLEDO DE PRESIDENTE PRUDENTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1547, 1842, 'FACULDADES INTEGRADAS MACHADO DE ASSIS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1548, 1843, 'FACULDADE DE ADMINISTRACAO DE CAMPO BELO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1549, 1844, 'FACULDADES INTEGRADAS STELLA MARIS DE ANDRADINA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1550, 1845, 'FEFISA FACULDADES INTEGRADAS DE SANTO ANDRE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1551, 1846, 'CENTRO UNIVERSITARIO DE LINS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1552, 1847, 'FACULDADE ATENAS MARANHENSE DE IMPERATRIZ', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1553, 1848, 'FACULDADE CENECISTA DE SANTA TEREZINHA DE ITAIPU', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1554, 1849, 'FACULDADE DE DIREITO DE MOGI MIRIM', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1555, 1850, 'FACULDADE ALVORADA DE TECNOLOGIA E EDUCACAO DE MARINGA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1556, 1851, 'ESCOLA BRASILEIRA DE ADMINISTRACAO PUBLICA E DE EMPRESAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1557, 1852, 'FACULDADE SABERES', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1558, 1853, 'FACULDADE DE TECNOLOGIA IBTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1559, 1854, 'FACULDADES INTEGRADAS CLARETIANAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1560, 1855, 'CENTRO UNIVERSITARIO CATOLICO DO SUDOESTE DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1561, 1856, 'FACULDADE DO NORTE NOVO DE APUCARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1562, 1857, 'FACULDADE DEHONIANA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1563, 1858, 'FACULDADE INTEGRADA EUCLIDES FERNANDES', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1564, 1859, 'INSTITUTO SUPERIOR DE EDUCACAO UIRAPURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1565, 1860, 'FACULDADE DE CIENCIAS GERENCIAIS PADRE ARNALDO JANSSEN', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1566, 1861, 'FACULDADE DE DIREITO DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1567, 1862, 'FACULDADE DA REGIAO SERRANA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1568, 1863, 'FACULDADE DE MANTENA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1569, 1864, 'FACULDADE DE ADMINISTRACAO DA ASSOCIACAO BRASILIENSE DE EDUCACAO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1570, 1865, 'INSTITUTO SUPERIOR DE EDUCACAO ALVORADA PLUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1571, 1866, 'FACULDADE DE CIENCIAS EMPRESARIAIS E ESTUDOS COSTEIROS DE NATAL', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1572, 1867, 'FACULDADE DE CIENCIAS GERENCIAIS DE SANTOS DUMONT', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1573, 1868, 'INSTITUTO SUPERIOR DE EDUCACAO DE SANTOS DUMONT', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1574, 1869, 'CENTRO UNIVERSITARIO DE ITAJUBA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1575, 1870, 'FACULDADES INTEGRADAS REGIONAIS DE AVARE', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1576, 1871, 'FACULDADE DE MEDICINA DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1577, 1872, 'FACULDADES INTEGRADAS SANTA CRUZ DE CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1578, 1873, 'FACULDADE MERCURIO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1579, 1874, 'FACULDADE DE TECNOLOGIA DE OURINHOS', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1580, 1875, 'FACULDADE DE FILOSOFIA, CIENCIAS E LETRAS DE IBITINGA', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1581, 1876, 'FACULDADE MUNICIPAL PROFESSOR FRANCO MONTORO DE MOGI GUACU', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1582, 1877, 'FACULDADE ATUAL', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1583, 1878, 'CENTRO UNIVERSITARIO DA FUNDACAO EDUCACIONAL INACIANA PE SABOIA DE MEDEIROS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1584, 1879, 'FACULDADE EDUCACIONAL DE ARAUCARIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1585, 1880, 'FACULDADE CASA DO ESTUDANTE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1586, 1881, 'FACULDADE DA ESCADA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1587, 1882, 'FACULDADE DE ASSUNTOS ACADEMICOS E CIENTIFICOS MONSENHOR EDISSON VIEIRA LICIO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1588, 1883, 'FACULDADE DE CIENCIAS AGRARIAS E DA SAUDE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1589, 1884, 'FACULDADE RANCHARIENSE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1590, 1885, 'UNIDADE DE ENSINO SUPERIOR DOM BOSCO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1591, 1886, 'FACULDADE DE MONTE ALTO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1592, 1887, 'FACULDADE DE DIREITO DA SERRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1593, 1888, 'FACULDADE DE SAUDE TECSOMA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1594, 1889, 'FACULDADE HOYLER DE LETRAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1595, 1890, 'FACULDADE AVILA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1597, 1892, 'FACULDADE ENIAC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1598, 1893, 'FACULDADE REGIONAL DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1599, 1894, 'FACULDADE EUROPEIA DE ADMINISTRACAO E MARKETING', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1600, 1895, 'CENTRO UNIVERSITARIO CHRISTUS', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1601, 1896, 'FACULDADE DE TURISMO DE NOVA ANDRADINA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1602, 1897, 'FACULDADE DE LETRAS DE NOVA ANDRADINA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1603, 1898, 'FACULDADE DO LITORAL SUL PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1604, 1899, 'FACULDADE DO NOROESTE PARANAENSE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1605, 1900, 'FACULDADE ANCHIETA DE ENSINO SUPERIOR DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1606, 1901, 'FACULDADE CATOLICA DE UBERLANDIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1608, 1903, 'FACULDADE CRISTO REI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1609, 1904, 'FACULDADE SAO CAMILO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1610, 1905, 'FACULDADE SANTA ADAME', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1611, 1906, 'INSTITUTO DE ENSINO SUPERIOR MATERDEI', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1612, 1907, 'FACULDADE EDUCACIONAL DE COLOMBO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1613, 1908, 'ESCOLA DE ENSINO SUPERIOR FABRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1614, 1909, 'FACULDADE PEREIRA DE FREITAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1615, 1910, 'FACULDADE MAURICIO DE NASSAU DE LAURO FREITAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1616, 1911, 'FACULDADE CENTROOESTE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1617, 1912, 'INSTITUTO SUPERIOR DE EDUCACAO JAPI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1618, 1913, 'FACULDADE DE MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1619, 1914, 'FACULDADE PITAGORAS DE ENFERMAGEM DE MONTES CLAROS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1620, 1915, 'FACULDADE DE EDUCACAO SILVA SERPA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1621, 1916, 'INSTITUTO SUPERIOR DE EDUCACAO PITAGORAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1622, 1917, 'FACULDADE DE CIENCIAS BIOMEDICAS DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1623, 1918, 'FACULDADE CAPIVARI', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1624, 1919, 'FACULDADE DE CIENCIAS EXATAS E TECNOLOGICAS SANTO AGOSTINHO FACET', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1625, 1920, 'FACULDADE DE FARMACIA DO PLANALTO CENTRAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1626, 1921, 'FACULDADE DE SAO BENTO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1627, 1922, 'ESCOLA SUPERIOR DE FISIOTERAPIA ESUFI', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1628, 1923, 'FACULDADE DE DIREITO PADRE ARNALDO JANSSEN', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1629, 1924, 'FACULDADE DO NORTE PIONEIRO DE JACAREZINHO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1630, 1925, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS SANTO AGOSTINHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1631, 1926, 'FACULDADE DE ADMINISTRACAO DE CATAGUASES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1632, 1927, 'FACULDADES INTEGRADAS DO VALE DO IGUACU', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1633, 1928, 'FACULDADE CENECISTA ILHA DO GOVERNADOR', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1634, 1929, 'FACULDADE DE CIENCIAS CONTABEIS FACICONT', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1635, 1930, 'INSTITUTO SUPERIOR DE EDUCACAO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1636, 1931, 'INSTITUTO DE ENSINO SUPERIOR FRANCISCANO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1637, 1932, 'FACULDADE PALOTINA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1638, 1933, 'FACULDADE BIRIGUI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1639, 1934, 'FACULDADE SINOP', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1640, 1935, 'FACULDADE SAO PAULO DE SANTOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1641, 1936, 'FACULDADE LA SALLE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1642, 1937, 'FACULDADE EVANGELICA DE SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1643, 1938, 'FACULDADE GLOBAL DE UMUARAMA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1644, 1939, 'INSTITUTO DE ENSINO SUPERIOR DE LONDRINA INESUL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1645, 1940, 'FACULDADE DE NOVA SERRANA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1646, 1941, 'FACULDADE CUIABA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1647, 1942, 'FACULDADE DE COMUNICACAO SOCIAL DE FLORIANOPOLIS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1648, 1943, 'FACULDADE SERRANA DE ENSINO SUPERIOR', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1649, 1944, 'FACULDADE DE TECNOLOGIA IBRATEC', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1650, 1945, 'FACULDADE DE SORRISO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1651, 1946, 'FACULDADE LEGALE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1652, 1947, 'FACULDADE DE ENGENHARIA DE TAQUARA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1653, 1948, 'FACULDADE DE ENSINO SUPERIOR DA PARAIBA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1654, 1949, 'FACULDADE DE PAULINIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1655, 1950, 'FACULDADE DE ORLANDIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1656, 1951, 'INSTITUTO DE EDUCACAO E ENSINO SUPERIOR DE SAMAMBAIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1657, 1952, 'FACULDADE DE CIENCIAS JURIDICAS E SOCIAIS APLICADAS DO ARAGUAIA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1658, 1953, 'FACULDADE DE CIENCIAS BIOLOGICAS E DA SAUDE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1659, 1954, 'FACULDADE DE ECONOMIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1660, 1955, 'FACULDADE DE CIENCIAS HUMANAS DE LAGES', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1661, 1956, 'INSTITUTO BATISTA DE ENSINO SUPERIOR DE ALAGOAS', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1662, 1957, 'FACULDADE DE TECNOLOGIA SENAI JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1663, 1958, 'FACULDADE DE TECNOLOGIA SENAI BLUMENAU', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1664, 1959, 'FACULDADE DE CIENCIAS JURIDICAS DO PLANALTO CENTRAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1665, 1960, 'FACULDADE DE MEDICINA DO PLANALTO CENTRAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1666, 1961, 'INSTITUTO TECNOLOGICO E DAS CIENCIAS SOCIAIS APLICADAS E DA SAUDE DO CENTRO EDUC. N. SRª AUXILIADORA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1667, 1962, 'INSTITUTO SUPERIOR DE EDUCACAO DO CENTRO EDUCACIONAL NOSSA SENHORA AUXILIADORA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1668, 1963, 'FACULDADE DE FISIOTERAPIA DOS CAMPOS GERAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1669, 1964, 'FACULDADE DE TECNOLOGIA EM HOTELARIA, GASTRONOMIA E TURISMO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1670, 1965, 'FACULDADE DE TECNOLOGIA DE ALAGOAS', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1671, 1966, 'FACULDADE ALBERT EINSTEIN', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1673, 1968, 'FACULDADE ATLANTICO', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1674, 1969, 'FACULDADE DOS IMIGRANTES FAI', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1675, 1970, 'FACULDADE DO ESPIRITO SANTO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1676, 1971, 'FACULDADE DE TECNOLOGIA MORUMBI SUL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1677, 1972, 'FACULDADE TIJUCUSSU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1678, 1973, 'INSTITUTO SUPERIOR DE EDUCACAO ORIGENES LESSA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1679, 1974, 'INSTITUTO SUPERIOR DE EDUCACAO DE CAXIAS', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1680, 1975, 'FACULDADE DE CIENCIAS AGRARIAS DOS CAMPOS GERAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1681, 1976, 'INSTITUTO SUPERIOR DE EDUCACAO DE LINHARES', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1682, 1977, 'CENTRO DE ESTUDOS SUPERIORES APRENDIZ', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1683, 1978, 'FACULDADE METROPOLITANA DA GRANDE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1684, 1979, 'INSTITUTO SUPERIOR DE EDUCACAO CENECISTA DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1685, 1980, 'FACULDADE SINERGIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1686, 1981, 'FACULDADE MILLENNIUM', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1687, 1982, 'FACULDADE DE COMUNICACAO SOCIAL DE PATOS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1688, 1983, 'FACULDADE DE CIENCIAS E DA SAUDE DE PATOS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1689, 1984, 'FACULDADE DE CIENCIAS GERENCIAIS DE MANHUACU', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1690, 1985, 'FACULDADE COMUNITARIA DE CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1691, 1986, 'FACULDADE ESTACIO DE SA DE JUIZ DE FORA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1692, 1987, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DEPUTADO JOSE LAVIOLA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1693, 1988, 'FACULDADE AVANTIS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1694, 1989, 'INSTITUTO SUPERIOR DE EDUCACAO AVANTIS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1695, 1990, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1696, 1991, 'FACULDADE JOAO PAULO PRIMEIRO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1697, 1992, 'INSTITUTO DE ENSINO SUPERIOR DE PIEDADE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1698, 1993, 'FACULDADE DE CIENCIAS HUMANAS E DA SAUDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1699, 1994, 'INSTITUTO DE ENSINO SUPERIOR DE DOURADOS', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1700, 1995, 'FACULDADE DE MEDICINA NOVA ESPERANCA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1701, 1996, 'INSTITUTO CUIABA DE ENSINO E CULTURA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1702, 1997, 'INSTITUTO DE ENSINO SUPERIOR DE ARIPUANA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1703, 1998, 'INSTITUTO SUPERIOR DE EDUCACAO ELVIRA DAYRELL', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1704, 1999, 'JOHN KNOX', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1705, 2000, 'FACULDADE TATUAPE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1706, 2001, 'SEMINARIO ADVENTISTA LATINOAMERICANO DE TEOLOGIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1707, 2002, 'INSTITUTO SUPERIOR DE EDUCACAO DIVINO SALVADOR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1708, 2003, 'FACULADE TEOLOGICA SINAL', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1709, 2004, 'FACULDADE DE DIREITO PRESIDENTE CASTELO BRANCO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1710, 2005, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DE SINOP', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1711, 2006, 'INSTITUTO SUPERIOR DE EDUCACAO DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1712, 2007, 'FACULDADE DE CIENCIAS EXATAS E TECNOLOGICAS DO BRASIL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1713, 2008, 'INSTITUTO SUPERIOR DE EDUCACAO DE SAO GOTARDO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1714, 2009, 'FACULDADE DE TAQUARITINGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1715, 2010, 'FACULDADE ESAMC SOROCABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1716, 2011, 'INSTITUTO NACIONAL DE EDUCACAO DE PORTO SEGURO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1717, 2012, 'INSTITUTO SUPERIOR DE EDUCACAO DE PESQUEIRA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1718, 2013, 'INSTITUTO SUPERIOR DE EDUCACAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1719, 2014, 'FACULDADE SETELAGOANA DE CIENCIAS GERENCIAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1720, 2015, 'INSTITUTO SANTO TOMAS DE AQUINO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1721, 2016, 'LOGOS FACULDADE', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1722, 2017, 'FACULDADES DE ALTA FLORESTA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1723, 2018, 'FACULDADE EVOLUCAO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1724, 2019, 'INSTITUTO SUPERIOR DE EDUCACAO DE SALGUEIRO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1725, 2020, 'INSTITUTO DE EDUCACAO SUPERIOR EUROBRAS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1726, 2021, 'FACULDADE JK   UNIDADE II   GAMA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1727, 2022, 'FACULDADE DE ROLIM DE MOURA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1728, 2023, 'FACULDADE DE GUANAMBI', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1729, 2024, 'INSTITUTO SUPERIOR DE EDUCACAO DAS CLARETIANAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1730, 2025, 'INSTITUTO SUPERIOR DE EDUCACAO CARLI GIOVANNI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1731, 2026, 'INSTITUTO SUPERIOR DE EDUCACAO BRASIL', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1732, 2027, 'FACULDADE DE CAMPINA GRANDE', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1733, 2028, 'FALCUDADE DE CIENCIAS ECONOMICAS CONTABEIS E ADMINISTRATIVAS DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1734, 2029, 'INSTITUTO SUPERIOR DE EDUCACAO DE MARECHAL CANDIDO RONDON', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1735, 2030, 'INSTITUTO SUPERIOR DE EDUCACAO CAMPO LIMPO PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1736, 2031, 'FACULDADE DE EDUCACAO DE PRESIDENTE MEDICI', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1737, 2032, 'FACULDADE DE PEDAGOGIA E FORMACAO DE NORMALISTAS DE ARAGUAINA', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1738, 2033, 'INSTITUTO SUPERIOR DE EDUCACAO DE FLORESTA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1739, 2034, 'FACULDADE DE CIENCIAS CONTABEIS DE ARAGUAINA', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1740, 2035, 'UNIAO LATINOAMERICADA DE TECNOLOGIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1741, 2036, 'FACULDADE ESTACIO DO PARA ESTACIO FAP', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1742, 2037, 'FACULDADE UNIME DE CIENCIAS EXATAS E TECNOLOGICAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1743, 2038, 'INSTITUTO DE EDUCACAO SUPERIOR VALE DO MEARIM', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1744, 2039, 'FACULDADE CIDADE LUZ', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1745, 2040, 'FACULDADE DO FUTURO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1746, 2041, 'FACULDADE SUDAMERICA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1747, 2042, 'FACULDADE FIGUEIREDO COSTA FIC', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1748, 2043, 'FACULDADE VALE DO SALGADO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1749, 2044, 'INSTITUTO SUPERIOR DE EDUCACAO VALE DO SALGADO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1750, 2045, 'FACULDADE AMADEUS', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1751, 2046, 'INSTITUTO SUPERIOR DE EDUCACAO AMADEUS', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1752, 2047, 'FACULDADE DE PSICOLOGIA DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1753, 2048, 'FACULDADE DE CIENCIAS E TECNOLOGIA DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1754, 2049, 'INSTITUTO DE ESTUDOS SUPERIORES DO MARANHAO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1755, 2050, 'ESCOLA SUPERIOR DE GESTAO E CIENCIAS DA SAUDE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1756, 2051, 'FACULDADE INTERFUTURA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1757, 2052, 'FACULDADE DE DIREITO DE LAGES', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1758, 2053, 'FACULDADE PARA O DESENVOLVIMENTO DE PERNAMBUCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1759, 2054, 'FACULDADE DE EDUCACAO DE NOVA ANDRADINA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1760, 2055, 'FACULDADE ARAUCARIA DO SUDOESTE DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1761, 2056, 'FACULDADE DA ALTA PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1762, 2057, 'FACULDADE DE MOGI GUACU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1763, 2058, 'FACULDADE METROPOLITANA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1764, 2059, 'FACULDADE DE EDUCACAO E CIENCIAS DE TAGUATINGA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1765, 2060, 'FACULDADE PADRE SEVERIANO LTDA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1766, 2061, 'FACULDADE DE FORMACAO DE PROFESSORES DE ARAPIRACA', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1767, 2062, 'INSTITUTO SUPERIOR DE EDUCACAO CENECISTA DE VARGINHA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1768, 2063, 'INSTITUTO NOSSA SENHORA APARECIDA DE EDUCACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1769, 2064, 'FACULDADE METROPOLITANA DE SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1770, 2065, 'FACULDADE DE FILOSOFIA E TEOLOGIA DE ALAGOAS', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1771, 2066, 'FACULDADE LEONARDO DA VINCI', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1772, 2067, 'FACULDADE DE CIENCIAS EMPRESARIAIS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1773, 2068, 'FACULDADE DE CASTILHO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1774, 2069, 'FACULDADE DE TEOLOGIA E CIENCIAS HUMANAS', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1775, 2070, 'FACULDADE DE CIENCIAS SOCIAIS AMORIL', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1776, 2071, 'FACULDADE TEOLOGICA BATISTA DO BRASIL', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1777, 2072, 'FACULDADE DE DESENVOLVIMENTO SUSTENTAVEL DE CRUZEIRO DO SUL', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1778, 2073, 'INSTITUTO SUPERIOR DE EDUCACAO PADRAO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1779, 2074, 'INSTITUTO EDUCACIONAL SAO JOAO DA ESOCIA DE ENSINO SUPERIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1780, 2075, 'INSTITUTO DE ENSINO SUPERIOR DE ALAGOAS', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1781, 2076, 'FACULDADE REGIONAL DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1782, 2077, 'FACULDADE ANGLOAMERICANO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1783, 2078, 'FACULDADE DE CIENCIAS HUMANAS E SOCIAIS DE JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1784, 2079, 'FACULDADE DE ITAITUBA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1785, 2080, 'FACULDADE UNIVERSICA DE FILOSOFIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1786, 2081, 'FACULDADE DE CIENCIAS GERENCIAS DE PEDREIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1787, 2082, 'FACULDADE DE CIENCIAS MEDICAS DA PARAIBA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1788, 2083, 'FACULDADE DE IBITINGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1789, 2084, 'FACULDADE CENECISTA DE NOVA PETROPOLIS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1790, 2085, 'INSTITUTO BAIANO DE ENSINO SUPERIOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1791, 2086, 'INSTITUTO DE ENSINO SUPERIOR DE FOZ DO IGUACU', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1792, 2087, 'FACULDADE MARECHAL RONDON', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1793, 2088, 'INSTITUTO SUPERIOR DE EDUCACAO SANTO AGOSTINHO DE TERESINA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1794, 2089, 'FACULDADE CENECISTA DE MOSSORO', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1795, 2090, 'FACULDADE DE TURISMO DE CONGONHAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1796, 2091, 'INSTITUTO SUPERIOR DE EDUCACAO PRO SABER', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1797, 2092, 'FACULDADE DOM PEDRO II', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1798, 2093, 'FACULDADE GREGOR MENDEL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1799, 2094, 'FACULDADE DE ENSINO A', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1800, 2095, 'INSITUTO SUPERIOR DE JACAREI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1801, 2096, 'FACULDADE COMUNITARIA DE MANHUACU', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1802, 2097, 'ESCOLA SUPERIOR DE GUARARAPES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1803, 2098, 'FACULDADE KURIOS', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1804, 2099, 'INSTITUTO DE ENSINO PESQUISA E EXTENSAO DO BRASIL OESTE', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1805, 2100, 'FACULDADE DE LETRAS DO SERRO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1806, 2101, 'FACULDADE ASCENSAO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1807, 2102, 'FACULDADE DE AURIFLAMA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1808, 2103, 'FACULDADE E CENTRO DE ENSINO DE LONDRINA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1809, 2104, 'FACULDADE DE TEOLOGIA DE HOKEMAH', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1810, 2105, 'FACULDADE ADVENTISTA DE INFORMATICA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1811, 2106, 'FACULDADE DE VICOSA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1812, 2107, 'FACULDADE IBTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1813, 2108, 'FACULDADE DE DIREITO DA SEDES', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1814, 2109, 'FACULDADE JOAO PESSOA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1815, 2110, 'FACULDADE DOM CESAR', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1816, 2111, 'INSTITUTO SUPERIOR DE TEOLOGIA APLICADA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1817, 2112, 'FACULDADE METODISTA DE BIRIGUI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1818, 2113, 'FACULDADE DOM BOSCO DE PORTO ALEGRE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1819, 2114, 'FACULDADE DE TEOLOGIA FILADELFIA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1820, 2115, 'FACULDADE JOAO PAULO II', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1821, 2116, 'FACULDADE IGUAPENSE SANTO AUGUSTO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1822, 2117, 'FACULDADE DE CIENCIA E TECNOLOGIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1823, 2118, 'INSTITUTO DE EDUCACAO SUPERIOR GUAIANAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1824, 2119, 'FACULDADE GUARARAPES', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1825, 2120, 'INSTITUTO DE FILOSOFIA E DE TEOLOGIA PAULO VI', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1826, 2121, 'FACULDADE DE INFORMATICA DE PEDREIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1827, 2122, 'FACULDADE ESTACIO DE SERGIPE ESTACIO FASE', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1828, 2123, 'FACULDADE MAX PLANCK', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1829, 2124, 'FACULDADE CALAFIORI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1830, 2125, 'FACULDADE DE EDUCACAO DE UBERLANDIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1831, 2126, 'ESCOLA DE DIREITO DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1832, 2127, 'FACULDADE BATISTA DE EDUCACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1833, 2128, 'ESCOLA DE DIREITO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1834, 2129, 'ESCOLA DE ECONOMIA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1835, 2130, 'FACULDADE EVANGELICA DE TEOLOGIA DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1836, 2131, 'FACULDADE FAPAN', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1837, 2132, 'FACULDADE BARAO DO RIO BRANCO', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1838, 2133, 'FACULDADE DE CIENCIAS, EDUCACAO E TEOLOGIA DO NORTE DO BRASIL', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1839, 2134, 'FACULDADE DA IGREJA MINISTERIO FAMA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1840, 2135, 'FACULDADE CATOLICA RAINHA DO SERTAO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1841, 2136, 'INSTITUTO DE JUINA DE ENSINO SUPERIOR', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1842, 2137, 'FACULDADE SAO MARCOS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1843, 2138, 'INSTITUTO SUPERIOR DE EDUCACAO DIVINO SALVADOR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1844, 2139, 'FACULDADE DE INFORMATICA DE PARANAIBA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1845, 2140, 'INSTITUTO SUPERIOR DE EDUCACAO NOSSA SENHORA DE LOURDES', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1846, 2141, 'FACULDADE TEOLOGICA BATISTA DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1847, 2142, 'FACULDADE MULTIEDUCATIVA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1848, 2143, 'INSTITUTO SUPERIOR DE EDUCACAO DE DUQUE DE CAXIAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1849, 2144, 'FACULDADE ECOPORANGA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1850, 2145, 'FACULDADE INFORIUM DE TECNOLOGIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1851, 2146, 'FACULDADE DO ACRE', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1852, 2147, 'FACULDADE METROPOLITANA DE MANAUS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1853, 2148, 'FACULDADE DE PALMAS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1854, 2149, 'FACULDADE MATO GROSSO DO SUL', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1855, 2150, 'FACULDADE DO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1856, 2151, 'INSTITUTO SUPERIOR DE EDUCACAO BERLAAR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1857, 2152, 'FACULDADE DE ADMINISTRACAO E TECNOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1858, 2153, 'FACULDADE DE DIREITO DE MACAE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1859, 2154, 'INSTITUTO SUPERIOR DE CIENCIAS HUMANAS E SOCIAIS ANISIO TEIXEIRA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1860, 2155, 'FACULDADE DE CIENCIAS SOCIAIS E DA SAUDE DE CATAGUASES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1861, 2156, 'FACULDADE SAO TOMAS DE AQUINO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1862, 2157, 'INSTITUTO SUPERIOR DE EDUCACAO SANT´ANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1863, 2158, 'FACULDADE SANTA MARIA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1864, 2160, 'FACULDADE SANTANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1865, 2161, 'FACULDADE TEOLOGICA DE VALENCA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1866, 2162, 'INSTITUTO METROPOLITANO DE ENSINO SUPERIOR DE VESPASIANO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1867, 2163, 'INSTITUTO SUPERIOR DE EDUCACAO EUGENIO GOMES', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1868, 2164, 'FACULDADE PANAMERICANA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1869, 2165, 'FACULDADE FOZ DO IGUACU', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1870, 2166, 'INSTITUTO DE EDUCACAO E CULTURA INTEGRADA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1871, 2167, 'FACULDADE DE EDUCACAO E CIENCIAS GERENCIAIS DE SALTO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1872, 2168, 'FACULDADE CAMPO GRANDE', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1873, 2169, 'FACULDADE CENECISTA DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1874, 2170, 'FACULDADE DE MATEMATICA JESUS MARIA JOSE', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1875, 2171, 'INSTITUTO BELO HORIZONTE DE ENSINO SUPERIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1876, 2172, 'FACULDADE CENECISTA DE TRES RIOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1877, 2173, 'FACULDADE GUAIANAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1878, 2174, 'FACULDADE DE SANTA CATARINA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1879, 2175, 'FACULDADE METROPOLITANA DE BLUMENAU', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1880, 2176, 'FACULDADE DE CIENCIAS BIOMEDICAS DE COLATINA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1881, 2177, 'INSTITUTO PAULISTA DE ENSINO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1882, 2178, 'FACULDADE CENECISTA DE MACAE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1883, 2179, 'FACULDADE DE TURISMO DO ESTADO DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1884, 2180, 'RATIO FACULDADE TEOLOGICA E FILOSOFICA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1885, 2181, 'INSTITUTO SUPERIOR DE EDUCACAO CENECISTA DE CAPIVARI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1886, 2182, 'FACULDADE BATISTA IDA NELSON', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1887, 2183, 'CENTRO UNIVERSITARIO FUNDACAO SANTO ANDRE', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1888, 2184, 'FACULDADE CENECISTA NOSSA SENHORA DOS ANJOS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1889, 2185, 'FACULDADE DE NUTRICAO DOS CAMPOS GERAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1890, 2186, 'FACULDADE SALESIANA DOM BOSCO', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1891, 2187, 'FACULDADE DE CIENCIAS GERENCIAIS DE VALINHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1892, 2188, 'INSTITUTO SUPERIOR DE EDUCACAO NOSSA SENHORA DE SION', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1893, 2189, 'FACULDADE DO MARANHAO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1894, 2190, 'FACULDADE JULIO CAMPOS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1895, 2191, 'FACULDADE ANHANGUERA DE PELOTAS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1896, 2192, 'INSTITUTO SUPERIOR DE EDUCACAO IVOTI', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1897, 2193, 'INSTITUTO SUPERIOR DE EDUCACAO IDEAL', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1898, 2194, 'FACULDADE ANHANGUERA DO RIO GRANDE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1899, 2195, 'FACULDADE DE CIENCIAS GERENCIAIS DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1900, 2196, 'FACULDADE DE INFORMATICA E TECNOLOGIAS VARZEA GRANDENSE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1901, 2197, 'FACULDADE VILLAS BOAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1902, 2198, 'FACULDADE MONTEIRO LOBATO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1903, 2199, 'FACULDADE DE EDUCACAO E TEOLOGIA DO BRASIL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1904, 2200, 'FACULDADE VALE DO GORUTUBA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1905, 2201, 'FACULDADE ALPHA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1906, 2202, 'INSTITUTO SUPERIOR DE EDUCACAO DE GUARATUBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1907, 2203, 'FACULDADE DE EDUCACAO ANCHIETA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1908, 2204, 'FACULDADE CATARINENSE DOM BOSCO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1909, 2205, 'FACULDADE DE TUPI PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1910, 2206, 'FACULDADE FAE SAO JOSE DOS PINHAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1911, 2207, 'FACULDADE SAO JUDAS TADEU', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1912, 2208, 'FACULDADE LUIS DE CAMOES', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1913, 2209, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1914, 2210, 'FACULDADE GARAVELO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1915, 2211, 'INSTITUTO SUPERIOR DE EDUCACAO CENECISTA DE FARROUPILHA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1916, 2212, 'FACULDADE UNIDADE DAS AMERICAS', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1917, 2213, 'FACULDADE DE CIENCIAS JURIDICAS E SOCIAIS DE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1918, 2214, 'FACULDADE DE ENGENHARIA DA TERRA DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1919, 2215, 'FACULDADE DE TEOLOGIA DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1920, 2216, 'INSTITUTO SUPERIOR DE EDUCACAO DE IUNA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1921, 2217, 'FACULDADE DE CIENCIAS GERENCIAIS DE IUNA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1922, 2218, 'FACULDADE DE CIENCIAS EXATAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1923, 2219, 'FACULDADE MUNDO MODERNO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1924, 2220, 'FACULDADE COMUNITARIA DE JUIZ DE FORA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1925, 2221, 'FACULDADE MADEIRA MAMORE', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1926, 2222, 'FACULDADE SETE DE SETEMBRO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1927, 2223, 'FACULDADE DE CIENCIAS SOCIAIS E DA SAUDE DE TEOFILO OTONI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1928, 2224, 'FACULDADES INTEGRADAS DE IMPERATRIZ', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1929, 2225, 'INSTITUTO SUPERIOR DE FORMACAO DE PROFESSORES', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1930, 2226, 'FACULDADE DE CIENCIAS DA SAUDE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1931, 2227, 'FACULDADE DE CIENCIAS BIOLOGICAS JK', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1932, 2228, 'FACULDADE DA SAUDE HUMANA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1933, 2229, 'FACULDADE VICTOR HUGO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1934, 2230, 'FACULDADE DE ADMINISTRACAO JK', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1935, 2231, 'FACULDADE DE COMUNICACAO SOCIAL JK', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1936, 2232, 'FACULDADE DE ADMINISTRACAO E MARKETING DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1937, 2233, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1938, 2234, 'FACULDADE DE PEDAGOGIA DE BETIM', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1939, 2235, 'FACULDADE TEOLOGICA DAS ASSEMBLEIAS DE DEUS EM SANTOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1940, 2236, 'ESCOLA SUPERIOR DE ADMINISTRACAO MARKETING E COMUNICACAO DE SAO BERNARDO DO CAMPO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1941, 2237, 'FACULDADE TEOLOGICA BATISTA EQUATORIAL', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1942, 2238, 'FACULDADE DE PSICOLOGIA DOS CAMPOS GERAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1943, 2239, 'FACULDADE DE DIREITO DE VILHA VELHA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1944, 2240, 'FACULDADE DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1945, 2241, 'FACULDADE DO SUDESTE MINEIRO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1946, 2242, 'FACULDADE DO RECIFE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1947, 2243, 'FACULDADE PARAIBANA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1948, 2244, 'FACULDADE DA CIDADE DE MACEIO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1949, 2245, 'FACULDADE DO ESPIRITO SANTO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1950, 2246, 'FACULDADE METROPOLITANA DE CIENCIAS E TECNOLOGIA', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1951, 2247, 'FACULDADE DOTTORI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1952, 2248, 'FACULDADE SERGIPANA', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1953, 2249, 'FACULDADE LOGOS EM ARACAJU', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1954, 2250, 'INSTITUTO SANTO TOMAS DE AQUINO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1955, 2251, 'FACULDADE DE POMPEIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1956, 2252, 'FACULDADE DE CIENCIA DA EDUCACAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1957, 2253, 'FACULDADE DE DIREITO DE PRIMAVERA DO LESTE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1958, 2254, 'FACULDADE DE CIENCIAS GERENCIAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1959, 2255, 'INSTITUTO DE ENSINO SUPERIOR DO AMAZONAS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1960, 2256, 'FACULDADE OBOE II', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1961, 2257, 'FACULDADE DIADEMA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1962, 2258, 'FACULDADE DE PRIMEIRO MUNDO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1963, 2259, 'INSTITUTO SUPERIOR EDUCACAO LEONARDO DA VINCI', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1964, 2260, 'FACULDADE DE TECNOLOGIA IESVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1965, 2261, 'FACULDADE DE CIENCIAS HUMANAS E DA SAUDE DE TAQUARA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1966, 2262, 'INSTITUTO DE EDUCACAO NORMAL SUPERIOR DE PIMENTA BUENO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1967, 2263, 'FACULDADE SANTO ANTONIO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1968, 2264, 'FACULDADE DE COMUNICACAO PITAGORAS UNIDADE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1969, 2265, 'FACULDADE DE CIENCIAS SOCIAIS E APLICADAS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1970, 2266, 'FACULDADE CAMBURY DE FORMOSA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1971, 2267, 'FACULDADE DE SAUDE DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1972, 2268, 'FACULDADE DE TEOLOGIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1973, 2269, 'INSTITUTO SUPERIOR DE EDUCACAO LUMINI', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1974, 2270, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DE EXTREMA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1975, 2271, 'FACULDADE PITAGORAS DE IPATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1976, 2272, 'FACULDADE DE PSICOLOGIA DE LAGES', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1977, 2273, 'INSTITUTO SUPERIOR DE EDUCACAO DO ALTO SAO FRANCISCO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1978, 2274, 'FACULDADE CIDADANIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1979, 2275, 'FACULDADE DE DIREITO SANTO AGOSTINHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1980, 2276, 'FACULDADE DE DIREITO DE VALINHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1981, 2277, 'INSTITUTO SUPERIOR DE EDUCACAO CENECISTA DE UNAI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1982, 2278, 'FACULDADE IGARATA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1983, 2279, 'FACULDADE INTEGRADA METROPOLITANA DE CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1984, 2280, 'FACULDADE SUPERIOR DE RIBAS DO RIO PARDO', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1985, 2281, 'FACULDADE DE FILOSOFIA SAO BOAVENTURA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1986, 2282, 'FACULDADE DE CAFELANDIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1987, 2283, 'FACULDADE SAO JOSE DA COSTA VERDE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1988, 2284, 'FACULDADE DE FILOSOFIA CENCIAS E LETRAS DE FAXINAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1989, 2285, 'FACULDADE DE PEDAGOGIA DE DORES DO INDAIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1990, 2286, 'FACULDADE DE BOM JESUS', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1991, 2287, 'ESCOLA SUPERIOR DE TEOLOGIA E ESPIRITUALIDADE FRANCISCANA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1992, 2288, 'FACULDADE ALMEIDA RODRIGUES', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1993, 2289, 'FACULDADE UNIAO CULTURAL DO ESTADO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1994, 2290, 'FACULDADE DE EDUCACAO CIENCIAS E HUMANIDADES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1995, 2291, 'INSTITUTO SUPERIOR DE EDUCACAO DE BEBEDOURO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1996, 2292, 'INSTITUTO DE EDUCACAO NORMAL SUPERIOR', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1997, 2293, 'FACULDADE DE CIENCIAS HUMANAS, BIOLOGICAS E DA SAUDE', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1998, 2294, 'FACULDADE DE CIENCIAS APLICADAS DA REGIAO CENTRO SUL DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (1999, 2295, 'INSTITUTO MEDICENSE DE EDUCACAO SUPERIOR', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2000, 2296, 'FACULDADE DE LETRAS DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2001, 2297, 'FACULDADE DE DIREITO DE SANTA MARIA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2002, 2298, 'ESCOLA SUPERIOR DE DIREITO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2003, 2299, 'FACULDADE ESPECIAL DE EDUCACAO E CULTURA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2004, 2300, 'INSTITUTO DE EDUCACAO SUPERIOR DE ROLIM DE MOURA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2005, 2301, 'FACULDADE FIDELIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2006, 2302, 'FACULDADE PORTO SEGURO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2007, 2303, 'FACULDADE CIMO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2008, 2304, 'INSTITUTO DE ENSINO SUPERIOR DA FUNLEC DE BONITO', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2009, 2305, 'FACULDADE DE DIREITO DE PATOS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2010, 2306, 'FACULDADE RIO BRANCO DO SUL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2011, 2307, 'INSTITUTO SUPERIOR DE EDUCACAO DE ITABIRA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2012, 2308, 'FACULDADE GEREMARIO DANTAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2013, 2309, 'FACULDADE NOVO MILENIO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2014, 2310, 'FACULDADE DA REGIAO DOS VALES', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2015, 2311, 'FACULDADE DE CIENCIAS JURIDICAS PROFESSOR ALBERTO DEODATO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2016, 2312, 'FACULDADE LUTERANA RUI BARBOSA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2017, 2313, 'FACULDADE DE TEOLOGIA DE BOA VISTA', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2018, 2314, 'INSTITUTO DE ENSINO SUPERIOR TECNOLOGICO DE LONDRINA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2019, 2315, 'FACULDADE CEARENSE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2020, 2316, 'INSTITUTO NACIONAL DE DESENVOLVIMENTO DO ENSINO SUPERIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2021, 2317, 'FACULDADE DO DESCOBRIMENTO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2022, 2318, 'FACULDADE DOM BOSCO DE NOVA AURORA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2023, 2319, 'ESCOLA SUPERIOR DE EDUCACAO CORPORATIVA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2024, 2320, 'INSTITUTO SUPERIOR DE EDUCACAO ATENEU', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2025, 2321, 'FACULDADE INESP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2026, 2322, 'FACULDADE ATENEU', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2027, 2323, 'FACULDADE DA AMAZONIA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2028, 2324, 'FACULDADE UNIAO BANDEIRANTE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2029, 2325, 'INSTITUTO SUPERIOR DE EDUCACAO DA AMAZONIA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2030, 2326, 'FACULDADE NOVO MILENIO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2031, 2327, 'FACULDADE SERRANA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2032, 2328, 'FACULDADE ITEANA DE BOTUCATU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2033, 2329, 'FACULDADE BATISTA DO NORDESTE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2034, 2330, 'FACULDADE CANDIDO RONDON   FCR', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2035, 2331, 'ESCOLA SUPERIOR DE TEOLOGIA E FILOSOFIA DO BRASIL', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2036, 2332, 'FACULDADE CORPORATIVA CESPI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2037, 2333, 'FACULDADE DE TEOLOGIA MOKITI OKADA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2038, 2334, 'FACULDADE CENECISTA DE RIO DAS OSTRAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2039, 2335, 'FACULDADE JOAQUIM MACHADO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2040, 2336, 'FACULDADE MONTES BELOS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2041, 2337, 'INSTITUTO SUPERIOR DE EDUCACAO DE MONTES BELOS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2042, 2338, 'INSTITUTO BRASILEIRO DE ESTUDOS TRIBUTARIOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2043, 2339, 'FACULDADE INTERNACIONAL DE HOTELARIA E TURISMO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2044, 2340, 'FACULDE ALPHAVILLE DE CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2045, 2341, 'FACULDADE DA ALDEIA DE CARAPICUIBA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2046, 2342, 'INSTITUTO SUPERIOR DE EDUCACAO CERES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2047, 2343, 'FACULDADE DA AMAZONIA OCIDENTAL', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2048, 2344, 'FACULDADE ITEANA DE IBITINGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2049, 2345, 'FACULDADE SETE DE SETEMBRO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2050, 2346, 'INSTITUTO SUPERIOR DE FILOSOFIA BERTHIER', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2051, 2347, 'FACULDADE GENNARI PEARTREE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2052, 2348, 'INSTITUICAO DE ENSINO SAO FRANCISCO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2053, 2349, 'DINAMICO FACULDADE DE FLORIANO LTDA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2054, 2350, 'ESCOLA SUPERIOR MADRE CELESTE', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2055, 2351, 'FACULDADE ESPIRITO SANTENSE DE CIENCIAS JURIDICAS', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2056, 2352, 'INSTITUTO DE EDUCACAO SUPERIOR PIO XII', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2057, 2353, 'FACULDADE DE ADMINISTRACAO DO CENTRO EDUCACIONAL DE SANTOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2058, 2354, 'INSTITUTO SUPERIOR DE EDUCACAO DO BRASIL', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2059, 2355, 'FACULDADE ANHANGUERA DE MATAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2060, 2356, 'FACULDADE PAN AMERICANA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2061, 2357, 'FACULDADE DE CIENCIAS BIOLOGICAS E DA SAUDE DO CESCARELLI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2062, 2358, 'INSTITUTO SUPERIOR DE EDUCACAO DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2063, 2359, 'INSTITUTO SUPERIOR DE EDUCACAO NOVO MILENIO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2064, 2360, 'INSTITUTO SUPERIOR DE EDUCACAO MESTRE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2065, 2361, 'FACULDADE PADRAO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2066, 2362, 'FACULDADE DE CIENCIAS MEDICAS DE CAMPINA GRANDE', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2067, 2363, 'FACULDADE NOVO MILENIO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2068, 2364, 'FACULDADE DE ADMINISTRACAO DE EMPRESAS DE PARAISO DO TOCANTINS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2069, 2365, 'FACULDADE CATOLICA DO TOCANTINS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2070, 2366, 'FACULDADE DE SISTEMAS DE INFORMACAO DE PARAISO DO TOCANTINS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2071, 2367, 'INSTITUTO SUPERIOR DE EDUCACAO NOVO MILENIO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2072, 2368, 'FACULDADE DE ODONTOLOGIA SAO LEOPOLDO MANDIC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2073, 2369, 'INSTITUTO DE ENSINO SUPERIOR SANTO ANTONIO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2074, 2370, 'INSTITUTO SUPERIOR DE EDUCACAO NOVO MILENIO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2075, 2371, 'INSTITUTO DE EDUCACAO SUPERIOR SAO FRANCISCO DE ASSIS DE TEOFILO OTONI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2076, 2372, 'INSTITUTO DE CIENCIAS GERENCIAIS DE BRASILIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2077, 2373, 'FACULDADES RESENDE DE FREITAS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2078, 2374, 'FACULDADES INTEGRADAS CONTEMPORANEAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2079, 2375, 'FACULDADE VIZCAYA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2080, 2376, 'INSTITUTO SUPERIOR DE EDUCACAO DE BRASILIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2081, 2377, 'INSTITUTO SUPERIOR DE EDUCACAO CENECISTA PRESIDENTE KENNEDY', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2082, 2378, 'FACULDADE DE ADMINISTRACAO DE CAMPINA VERDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2083, 2379, 'INSTITUTO SUPERIOR DE EDUCACAO DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2084, 2380, 'FACULDADE ESTACIO DO AMAPA ESTACIO FAMAP', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2085, 2381, 'INSTITUTO DE ENSINO E CULTURA DE DOURADOS', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2086, 2382, 'INSTITUTO SUPERIOR DE EDUCACAO DE TEOFILO OTONI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2087, 2383, 'FACULDADE MERIDIONAL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2088, 2384, 'FACULDADE INTEGRADA DO BRASIL', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2089, 2385, 'INSTITUTO SUPERIOR DE EDUCACAO NOVO MILENIO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2090, 2386, 'FACULDADE SUL RIOGRANDENSE', 1, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2091, 2387, 'FACULDADES INTEGRADAS POSIVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2092, 2388, 'FACULDADE NOVO MILENIO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2093, 2389, 'FACULDADE DE FILOSOFIA E TEOLOGIA PAULO VI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2094, 2390, 'INSTITUTO BRUSQUENSE DE ENSINO SUPERIOR', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2095, 2391, 'INSTITUTO SUPERIOR DE EDUCACAO NOVO MILENIO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2096, 2392, 'INSTITUTO SUPERIOR DE EDUCACAO DE SAO FRANCISCO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2097, 2393, 'FACULDADE MARISTA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2098, 2394, 'FACULDADE DE INFORMATICA DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2099, 2395, 'FACULDADE DE CAMPO VERDE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2100, 2396, 'INSTITUTO DE EDUCACAO SUPEIOR DO SERTAO EM PAO DE ACUCAR', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2101, 2397, 'FACULDADE FUCAPE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2102, 2398, 'FACULDADE CANDIDO RONDON DE CAMPO VERDE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2103, 2399, 'FACULDADE DE SOROCABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2104, 2400, 'FACULDADE DOM BOSCO DE MARINGA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2105, 2401, 'INSTITUTO SUPERIOR DE EDUCACAO DE CAMPO BELO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2106, 2402, 'FACULDADE CIDADE DO SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2107, 2403, 'FACULDADE SALESIANA DE PINDAMONHANGABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2108, 2404, 'FACULDADES INTEGRADAS DE FILOSOFIA E CIENCIAS DO PLANALTO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2109, 2405, 'INSTITUTO SUPERIOR DE EDUCACAO DE SANTA LUZIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2110, 2406, 'FACULDADE DE GESTAO E EMPREENDEDORISMO', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2111, 2407, 'FACULDADES INTEGRADAS FACVEST', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2112, 2408, 'FACULDADE ESAMC SANTOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2113, 2409, 'FACULDADE ASCES', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2114, 2410, 'FACULDADE CEARENSE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2115, 2411, 'FACULDADE DA CIDADE DO NATAL', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2116, 2412, 'FACULDADE ECONOROESTE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2117, 2413, 'FACULDADE DE ENSINO SUPERIOR DE FLORIANO', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2118, 2414, 'INSTITUTO SUPERIOR DE EDUCACAO IESDE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2119, 2415, 'FACULDADE BOM JESUS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2120, 2416, 'INSTITUTO SUPERIOR DE EDUCACAO DE BOTUCATU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2121, 2417, 'INSTITUTO SUPERIOR DE EDUCACAO METROPOLITANO DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2122, 2418, 'FACULDADES INTEGRADAS DO RECONCAVO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2123, 2419, 'FACITALGO FACULDADE DE CIENCIAS E TECNOLOGIA DE AGUAS LINDAS DE GOIAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2124, 2420, 'FACULDADE PARANAENSE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2125, 2421, 'INSTITUTO DE ENSINO SUPERIOR', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2126, 2422, 'FACULDADE DE FILOSOFIA LETRAS E ARTES DE MONTES CLAROS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2127, 2423, 'FACULDADE DE CIENCIA E TECNOLOGIA DE MONTES CLAROS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2128, 2424, 'FACULDADE DE SISTEMA DE INFORMACAO DE MARABA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2129, 2425, 'FACULDADE DE JIPARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2130, 2426, 'FACULDADE INTEGRADA BRASIL AMAZONIA FIBRA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2131, 2427, 'FACULDADE DE CIENCIAS GERENCIAIS DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2132, 2428, 'FACULDADE DE CIENCIAS E TECNOLOGIAS DE CAMPOS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2133, 2429, 'INSTITUTO SUPERIOR DE EDUCACAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2134, 2430, 'FACULDADE CATOLICA ORTODOXA SEDES SAPIENTIAM', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2135, 2431, 'FACULDADE ESTACIO MONTESSORI DE IBIUNA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2136, 2432, 'FACULDADE ALPHAVILLE DE JUNDIAI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2137, 2433, 'INSTITUTO SUPERIOR DE EDUCACAO PORTO SEGURO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2138, 2434, 'FACULDADE AMERICA LATINA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2139, 2435, 'FACULDADE DE CIENCIAS CONTABEIS LUIZ MENDES', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2140, 2436, 'FACULDADE TAHIRIH', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2141, 2437, 'FACULDADE PITAGORAS DE TEIXEIRA DE FREITAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2142, 2438, 'INSTITUTO TEOLOGICO PASTORAL DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2143, 2439, 'FACULDADE OCIDEMNTE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2144, 2440, 'FACULDADE CIDADE DE JOAO PINHEIRO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2145, 2441, 'INSTITUTO SUPERIOR DE EDUCACAO AUXILIUM', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2146, 2442, 'FACULDADE DE CIENCIAS BIOMEDICAS DO ESPIRITO SANTO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2147, 2443, 'FACULDADE PROMOVE DE JANAUBA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2148, 2444, 'FACULDADE JOAO CALVINO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2149, 2445, 'FACULDADE PADRAO', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2150, 2446, 'INSTITUTO SUPERIOR DE EDUCACAO PADRAO', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2151, 2447, 'INSTITUTO EDUCACIONAL DE CASTRO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2152, 2448, 'INSTITUTO SUPERIOR DE EDUCACAO DE JANUARIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2153, 2449, 'INSTITUTO MATO GROSSO DE EDUCACAO E CULTURA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2154, 2450, 'FACULDADE PROMOVE DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2155, 2451, 'FACULDADES INTEGRADAS IPIRANGA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2156, 2452, 'INSTITUTO BRASILEIRO DE ENSINO SUPERIOR PROFISSIONALIZANTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2157, 2453, 'FACULDADE BRASIL CENTRAL', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2158, 2454, 'FACULDADE MAFRENSE DE TURISMO E CIENCIAS HUMANAS DE TERESINA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2159, 2455, 'FACULDADE CASTRO ALVES', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2160, 2456, 'FACULDADE DE ADMINISTRACAO DE CHAPADAO DO SUL', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2161, 2457, 'FACULDADE ISAAC NEWTON', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2162, 2458, 'CENTRO UNIFICADO DE ENSINO SUPERIOR DE PERNAMBUCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2163, 2459, 'FACULDADE DE ESTUDOS AVANCADOS DO PARA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2164, 2460, 'FACULDADE ESTACIO DE NATAL', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2165, 2461, 'FACULDADE CBES', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2166, 2462, 'FACULDADE SAO LUIS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2167, 2463, 'FACULDADE ALVES FARIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2168, 2464, 'INSTITUTO SUPERIOR DE EDUCACAO ATENEU', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2169, 2465, 'FACULDADE DE DIREITO PROFESSOR DAMASIO DE JESUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2170, 2466, 'FACUDADE IEDUCARE FIED', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2171, 2467, 'FACULDADE NACIONAL DO NORTE DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2172, 2468, 'INSTITUTO TEOLOGICO FRANCISCANO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2173, 2469, 'INSTITUTO MACAPAENSE DE ENSINO SUPERIOR', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2174, 2470, 'INSTITUTO SALVADOR DE ENSINO E CULTURA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2175, 2471, 'INTITUTO SUPERIOR DE EDUCACAO DE BLUMENAU', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2176, 2472, 'FACULDADE DE EDUCACAO CIENCIA E TECNOLOGIA 2001', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2177, 2473, 'INSTITUTO BRASILEIRO DE ADMINISTRACAO BIM', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2179, 2475, 'FACULDADE ARQUIDIOCESANA DE MARIANA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2180, 2476, 'FACULDADE FENIX DE BAURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2181, 2477, 'FACULDADE DE ADMINISTRACAO DE MARIANA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2182, 2478, 'FACULDADE DE INTEGRACAO DO ENSINO SUPERIOR DO CONE SUL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2183, 2479, 'FACULDADE LATINO AMERICANA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2184, 2480, 'INSTITUTO SUPERIOR DE EDUCACAO DE ITAPOLIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2185, 2481, 'ESCOLA BRASILEIRA DE FORMACAO EMPRESARIAL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2186, 2482, 'FACULDADE DE CIENCIAS HUMANAS E APLICADAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2187, 2483, 'INSTITUTO SUPERIOR DE EDUCACAO INTEGRAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2188, 2484, 'FACULDADE PROCESSUS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2189, 2485, 'FACULDADE CATOLICA DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2190, 2486, 'FACULDADE LEONARDO DA VINCI', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2191, 2487, 'FACULDADE EXIMIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2192, 2488, 'FACULDADE ANGLICANA DE ERECHIM', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2193, 2489, 'INSTITUTO SUPERIOR DE EDUCACAOBRASIL CENTRAL', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2194, 2490, 'INSTITUTO SUPERIOR DE ENSINO DO LITORAL CATARINENSE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2195, 2491, 'INSTITUTO SUPERIOR DE EDUCACAO DO CECAP', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2196, 2492, 'INSTITUTO SUPERIOR DE EDUCACAO A DISTANCIA DE BRASILIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2197, 2493, 'INSTITUTO SUPERIOR DE EDUCACAO A DISTANCIA DE MONTES CLAROS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2198, 2494, 'FACULDADE DE PINDAMONHANGABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2199, 2495, 'INSTITUTO DE PESQUISA GRANDE VITORIA IPGV FACULDADE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2200, 2496, 'INSTITUTO MACHADO DE ASSIS DE EDUCACAO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2201, 2497, 'FACULDADE ATENEU', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2202, 2498, 'FACULDADE DE MULTIPLAS CIENCIAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2203, 2499, 'FACULDADE APOIO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2204, 2500, 'FACULDADE EINSTEIN', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2205, 2501, 'FACULDADE ESTACIO DE SA DE GOIAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2206, 2502, 'FACULDADE ARINOS DE ADMINISTRACAO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2207, 2503, 'FACULDADE DE INTEGRACAO NACIONAL LEDA JESUINO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2208, 2504, 'FACULDADE DIVINOPOLIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2209, 2505, 'FACULDADE DE ARTE E DESIGN', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2210, 2506, 'INSTITUTO SUPERIOR DE EDUCACAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2211, 2507, 'FACULDADE DE TECNOLOGIA E CIENCIAS DE SANTO ANTONIO DE JESUS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2212, 2508, 'INSTITUTO SUPERIOR DE EDUCACAO SANTO AGOSTINHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2213, 2509, 'FACULDADE DE MEDICINA TRADICIONAL DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2214, 2510, 'FACULDADES MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2215, 2511, 'FACULDADE DE DIREITO UNIDADE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2216, 2512, 'INSTITUTO SUPERIOR DE EDUCACAO CUIABANO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2217, 2513, 'FACULDADE ARTHUR THOMAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2218, 2514, 'INSTITUTO NATALENSE DE EDUCACAO SUPERIOR', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2219, 2515, 'FACULDADE ERUDITA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2220, 2516, 'INSTITUTO SUPERIOR DE EDUCACAO SANTA RITA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2221, 2517, 'FACULDADE DE ESTUDOS SOCIAIS E GESTAO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2222, 2518, 'FACULDADE INTENSIVA DE PEDAGOGIA E FILOSOFIA DE ILHEUS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2223, 2519, 'FACULDADE DE INFORMATICA E TECNOLOGIA TERRANOVENSE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2224, 2520, 'INSTITUTO DE EDUCACAO SUPERIOR TERRANOVENSE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2225, 2521, 'INSTITUTO SUPERIOR DE EDUCACAO DO SUL DO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2226, 2522, 'INSTITUTO MARISTA SUPERIOR DE EDUCACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2227, 2523, 'FACULDADE BONDESPACHENSE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2228, 2524, 'FACULDADE DE ENGENHARIA DA ITAJUBA TECNOPOLIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2229, 2525, 'FACULDADE PAULISTA DE CIENCIAS APLICADAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2230, 2526, 'INSTITUTO SUPERIOR DE EDUCACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2231, 2527, 'INSTITUTO SUPERIOR DE EDUCACAO DE JACAREI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2232, 2528, 'INSTITUTO SUPERIOR DE EDUCACAO MAE DE DEUS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2233, 2529, 'INSTITUTO SUPERIOR DE EDUCACAO DE IGUAPE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2234, 2530, 'FACULDADE DE CIENCIAS DE GUARULHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2235, 2531, 'INSTITUTO SUPERIOR DE EDUCACAO PROFESSORA LUCIA DANTAS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2236, 2532, 'FACULDADE DO SUDESTE GOIANO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2237, 2533, 'FACULDADE REGIONAL BARUERI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2238, 2534, 'FACULDADE METROPOLITANA DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2239, 2535, 'FACULDADE DOS INCONFIDENTES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2240, 2536, 'FACULDADE RORAIMENSE DE ENSINO SUPERIOR', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2241, 2537, 'FACULDADE SAO GERALDO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2242, 2538, 'FACULDADE VENDA NOVA DO IMIGRANTE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2243, 2539, 'FACULDADE EVANGELICA DO MEIO NORTE', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2244, 2540, 'INSTITUTO DE ENSINO SUPERIOR DE CAMAPUA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2245, 2541, 'ESCOLA SUPERIOR DE TECNOLOGIA E EDUCACAO DE ARARAQUARA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2246, 2542, 'FACULDADE CENECISTA DE QUEIMADOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2247, 2543, 'FACULDADE DA CHAPADA DOS GUIMARAES', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2248, 2544, 'INSTITUTO SUPERIOR DE EDUCACAO PROFESSORA VILMA MONTEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2249, 2545, 'FACULDADE CENECISTA DE PARACAMBI', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2250, 2546, 'FACULDADE DE CIENCIAS JURIDICAS E SOCIAIS DE VIANNA JUNIOR DE MURIARE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2251, 2547, 'FACULDADE MAGNUM DE FORMACAO DE PROFESSORES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2252, 2548, 'FACULDADE DE TEOLOGIA, FILOSOFIA E CIENCIAS HUMANAS GAMALIEL', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2253, 2549, 'FACULDADE PAULISTA DE EDUCACAO E COMUNICACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2254, 2550, 'FACULDADE SEPAM', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2255, 2551, 'FACULDADE CENECISTA ITAGUAI', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2256, 2552, 'INSTITUTO SUPERIOR DE CIENCIAS DA SAUDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2257, 2553, 'INSTITUTO DE EDUCACAO SUPERIOR UNYAHNA LUIS EDUARDO MAGALHAES', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2258, 2554, 'FACULDADE DE EDUCACAO SANTA TEREZINHA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2259, 2555, 'FACULDADE DE EDUCACAO DE UBERABA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2260, 2556, 'FIAMFAAM CENTRO UNIVERSITARIO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2261, 2557, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DE PENEDO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2262, 2558, 'FACULDADE DE DIREITO DE VILA VELHA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2263, 2559, 'INSTITUTO SUPERIOR DE EDUCACAO DAS FACULDADES DE VALINHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2264, 2560, 'FACULDADE DE ENSINO SUPERIOR DA CIDADE DE FEIRA DE SANTANA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2265, 2561, 'FACULDADE DE CIENCIAS ADMINISTRATIVAS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2266, 2562, 'FACULDADE JOSE LACERDA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2267, 2563, 'INSTITUTO SUPERIOR DE EDUCACAO PADRE JOAO BAGOZZI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2268, 2564, 'UNIVERSIDADE FEDERAL DE CAMPINA GRANDE', 1, 1, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2269, 2565, 'ABEU   CENTRO UNIVERSITARIO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2270, 2566, 'INSTITUTO DE ENSINO SUPERIOR DE OLINDA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2271, 2567, 'ESCOLA SUPERIOR DE CIENCIAS HUMANAS E ECONOMICAS', 2, 1, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2272, 2568, 'FACULDADE ZACARIAS DE GOES', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2273, 2569, 'FACULDADE DE TECNOLOGIA FAESA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2274, 2570, 'FACULDADE DE CIENCIAS EDUCACIONAIS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2275, 2571, 'FACULDADE REDENTOR', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2276, 2572, 'FACULDADE REGIONAL DE FILOSOFIA, CIENCIAS E LETRAS DE CANDEIAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2277, 2573, 'FACULDADE TEOLOGICA SUL AMERICANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2278, 2574, 'INSTITUTO SUPERIOR DE EDUCACAO DAS FACULDADES INTEGRADAS MODULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2279, 2575, 'FACULDADES INTEGRADAS SOARES DE OLIVEIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2280, 2576, 'FACULDADES PITAGORAS UNIDADE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2281, 2577, 'INSTITUTO SUPERIOR DE MUSICA DE SAO LEOPOLDO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2282, 2578, 'FACULDADE DE TEOLOGIA CARDEAL EUGENIO SALES', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2283, 2579, 'FACULDADE ATENAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2284, 2580, 'INSTITUTO SUPERIOR DE EDUCACAO PAULO MARTINS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2285, 2581, 'FACULDADE SAO SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2286, 2582, 'FACULDADE DE ENSINO SUPERIOR DO CENTRO DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2287, 2583, 'FACULDADE RIBEIRA DO POMBAL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2288, 2584, 'FACULDADE DO SUDOESTE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2289, 2585, 'FACULDADE DE FISIOTERAPIA DE PATOS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2290, 2586, 'INSTITUTO SUPERIOR DE EDUCACAO ITALO BRASILEIRO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2291, 2587, 'FACULDADE CANDIDO MENDES DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2292, 2588, 'FALCULDADE MERCATOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2293, 2589, 'FACULDADE DE BROTAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2294, 2590, 'FACULDADE DE CIENCIA DA COMPUTACAO E INFORMATICA SILVA SERPA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2295, 2591, 'ESCOLA BRASILEIRA DE ECONOMIA E FINANCAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2296, 2592, 'FACULDADE PRESBITERIANA 15 DE NOVEMBRO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2297, 2593, 'FACULDADE DE JUAZEIRO DO NORTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2298, 2594, 'FACULDADE TEOLOGICA BATISTA ANA WOLLERMAN', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2299, 2595, 'FACULDADES COSTA BRAGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2300, 2596, 'INSTITUTO SUPERIOR DE EDUCACAO DON DOMENICO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2301, 2597, 'FACULDADE DE CIENCIAS DA SAUDE DA VITORIA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2302, 2598, 'FACULDADE PENSAR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2303, 2599, 'FACULDADE DE EDUCACAO E CIENCIAS HUMANAS NOVA FLORIDA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2304, 2600, 'FACULDADE DE CIENCIAS DA ADMINISTRACAO DA VITORIA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2305, 2601, 'FACULDADE DE CIENCIAS FILOSOFIA E LETRAS HAKAY', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2306, 2602, 'INSTITUTO SUPERIOR DE EDUCACAO BALAO VERMELHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2307, 2603, 'FACULDADE DE ODONTOLOGIA DOS GUARARAPES', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2308, 2604, 'FACULDADE TEOLOGICA BATISTA DE PERNAMBUCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2309, 2605, 'FACULDADE DE CIENCIAS ECONOMICAS DE TUBARAO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2310, 2606, 'FACULDADE AFIRMATIVO DE CAMPO MOURAO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2311, 2607, 'FACULDADE PADRE ANTONIO VIEIRA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2312, 2608, 'INSTITUTO SUPERIOR DE EDUCACAO DE LAVRAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2313, 2609, 'INSTITUTO SUPERIOR DE EDUCACAO DE TUPI PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2314, 2610, 'FACULDADE DE JACAREI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2315, 2611, 'FACULDADE DE ENSINO SUPERIOR DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2316, 2612, 'INSTITUTO SUPERIOR DE EDUCACAO MONTES CLAROS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2317, 2613, 'Faculdade Meta', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2318, 2614, 'FACULDADE EMMANUEL KANT', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2319, 2615, 'FACULDADE INCONFIDENCIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2320, 2616, 'FACULDADE SANTO ANTONIO DE PADUA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2321, 2617, 'FACULDADE SAO BENTO DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2322, 2618, 'FACULDADE DOMINGOS SAVIO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2323, 2619, 'FACULDADE DE DIREITO DE ITABIRA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2324, 2620, 'FACULDADE DE AMPERE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2325, 2621, 'INSTITUTO SUPERIOR DE EDUCACAO DOMINGOS SAVIO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2326, 2622, 'INSTITUTO SUPERIOR DE EDUCACAO DA SERRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2327, 2623, 'FACULDADE DO TAPAJOS', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2328, 2624, 'FACULDADE DO LITORAL PARANAENSE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2329, 2625, 'FACULDADE DE TECNOLOGIA IBTA SAO JOSE DOS CAMPOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2330, 2626, 'FACULDADE DE COMUNICACAO SOCIAL SANTA EFIGENIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2331, 2627, 'FACULDADE JOAO XXIII', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2332, 2628, 'INSTITUTO DE EDUCACAO SUPERIOR ACADEMUS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2333, 2629, 'FACULDADE DE CIENCIAS CONTABEIS E DE ADMINISTRACAO DO VALE DO JURUENA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2334, 2630, 'INSTITUTO SUPERIOR DE EDUCACAO DO VALE DO JURUENA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2335, 2631, 'INSTITUTO DE EDUCACAO SUPERIOR', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2336, 2632, 'FACULDADES INTEGRADAS DO EXTREMO SUL DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2337, 2633, 'INSTITUTO DE EDUCACAO E TECNOLOGIAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2338, 2634, 'INSTITUTO EDUCACIONAL DALTON CUNHA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2339, 2635, 'INSTITUTO SUPERIOR DE EDUCACAO JK', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2340, 2636, 'FACULDADE DINAMICA DO VALE DO PIRANGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2341, 2637, 'FACULDADE BOM JESUS DE SIQUEIRA CAMPOS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2342, 2638, 'INSTITUTO DE CIENCIAS E EDUCACAO DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2343, 2639, 'FACULDADE DE TECNOLOGIA SENAI CONCORDIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2344, 2640, 'FACULDADE COMUNITARIA DE SAUDE DA SERRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2345, 2641, 'FACULDADE TEOLOGICA BATISTA FLUMINENSE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2346, 2642, 'FACULDADE SAO VICENTE', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2347, 2643, 'INSTITUTO SUPERIOR DE CIENCIAS E TECNOLOGIA DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2348, 2644, 'INSTITUTO DE EDUCACAO SUPERIOR DO TAPAJOS', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2349, 2645, 'INSTITUTO DE ENSINO SUPERIOR DO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2350, 2646, 'FACULDADE REGIONAL IPIRANGA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2351, 2647, 'FACULDADE INTEGRADA DE SANTA MARIA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2352, 2648, 'FACULDADE SUL MINEIRA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2353, 2649, 'FACULDADE DE CIENCIAS JURIDICAS DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2354, 2650, 'INSTITUTO DE ENSINO SUPERIOR DE ARIQUEMES', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2355, 2651, 'FACULDADE TAMANDARE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2356, 2652, 'FACULDADE UNIDA DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2357, 2653, 'FACULDADE PIEMONTE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2358, 2654, 'FACULDADE DE ENSINO TECNOLOGICO DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2359, 2655, 'FACULDADE DE CIENCIAS ADMINISTRATIVAS SOCIAIS E DA SAUDE DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2360, 2656, 'FACULDADE SANTA CATARINA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2361, 2657, 'FACULDADE ADOLFO CAMINHA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2362, 2658, 'FACULDADE AMEC TRABUCO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2363, 2659, 'FACULDADE DO VALE DO PARNAIBA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2364, 2660, 'FACULDADE PHENIX DE CIENCIAS HUMANAS E SOCIAIS DO BRASIL', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2365, 2661, 'INSTITUTO DE ENSINO SUPERIOR DE BARREIRAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2366, 2662, 'INSTITUTO SUPERIOR DE ENSINO PAULA CANDIDO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2367, 2663, 'FACULDADE DE ODONTOLOGIA ARGEMIRO FIGUEIREDO', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2368, 2664, 'INSTITUTO DE ENSINO SUPERIOR DO VALE DO PARNAIBA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2369, 2665, 'FACULDADE DE TECNOLOGIA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2370, 2666, 'FACULDADE INTEGRADA DE BRUSQUE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2371, 2667, 'INSTITUTO SUPERIOR PAULO FREIRE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2372, 2668, 'FACULDADE TEOLOGICA DO SUDOESTE GOIANO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2373, 2669, 'FACULDADE CANDIDO MENDES DO ESPIRITO SANTO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2374, 2670, 'INSTITUTO DE EDUCACAO SUPERIOR ACREANO EUCLIDES DA CUNHA', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2375, 2671, 'FACULDADE DE CIENCIAS HUMANAS E PSICOLOGICAS EUCLIDES DA CUNHA', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2376, 2672, 'FACULDADE HUGO DE SAO VITOR', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2377, 2673, 'INSTITUTO SUPERIOR DE EDUCACAO AVILA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2378, 2674, 'INSTITUTO DE ENSINO SUPERIOR UNILLUZ', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2379, 2675, 'INSTITUTO SUPERIOR DE EDUCACAO LATINO AMERICANO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2380, 2676, 'FACULDADE LA SALLE', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2381, 2677, 'INSTITUTO SUPERIOR DE EDUCACAO SAO JUDAS TADEU', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2382, 2678, 'FACULDADE DE COMPUTACAO E INFORMATICA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2383, 2679, 'FACULDADE DE CIENCIA DA COMPUTACAO DE JUIZ DE FORA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2384, 2680, 'FACULDADE DE COMPUTACAO DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2385, 2681, 'FACULDADE DE ENGENHARIA CIVIL DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2386, 2682, 'FACULDADE DE CIENCIAS DA SAUDE DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2387, 2683, 'FACULDADE DE CIENCIAS DA COMPUTACAO DE CATAGUASES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2388, 2684, 'FACULDADE DE CIENCIAS GERENCIAIS DE LEOPOLDINA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2389, 2685, 'FACULDADE DELTA DE ENSINO SUPERIOR', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2390, 2686, 'FACULDADE SANTA IZILDINHA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2391, 2687, 'FACULDADE DOM ALBERTO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2392, 2688, 'FACULDADE INESP INSTITUTO NACIONAL DE ENSINO E PESQUISA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2393, 2689, 'FACULDADE CARLOS LOBO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2394, 2690, 'FACULDADES INTEGRADAS LOGOS FILOGOS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2395, 2691, 'FACULDADE ASSOCIADA DA BAHIA FAB', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2396, 2692, 'FACULDADE AVILA DE CIENCIAS HUMANAS E EXATAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2397, 2693, 'FACULDADES INTEGRADAS DO TRIANGULO MINEIRO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2398, 2694, 'FACULDADE VALE DO ARAGUAIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2399, 2695, 'FACULDADE DO CENTROOESTE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2400, 2696, 'INSUBA INSTITUTO SUPERIOR DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2401, 2697, 'INSTITUTO SUPERIOR DE EDUCACAO DE AMELIA RODRIGUES', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2402, 2698, 'INSTITUTO SUPERIOR DE EDUCACAO VALE DO ARAGUAIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2403, 2699, 'INSTITUTO DE ENSINO SUPERIOR AVANT GARDE', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2404, 2700, 'FACULDADE UNIPOLI', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2405, 2701, 'FACULDADE DE ORLANDIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2406, 2702, 'FACULDADE DE CIENCIAS JURIDICAS DE PARAISO DO TOCANTINS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2407, 2703, 'FACULDADE SENAC MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2408, 2704, 'INSTITUTO SUPERIOR DE EDUCACAO DO INSTITUTO METODISTA UNIAO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2409, 2705, 'FACULDADE DE EDUCACAO E CIENCIAS HUMANAS NOVA FLORIDA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2410, 2706, 'FACULDADE EUROPEU', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2411, 2707, 'INSTITUTO SUPERIOR DE EDUCACAO PROFESSOR EDGARDO BEZERRA DA ROCHA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2412, 2708, 'INSTITUTO SUPERIOR DE CIENCIAS HUMANAS E FILOSOFIA LA SALLE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2413, 2709, 'INSTITUTO DE ENSINO SUPERIOR NOVO HORIZONTE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2414, 2710, 'INSTITUTO SUPERIOR DE EDUCACAO RANCHARIENSE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2415, 2711, 'FACULDADE DE ADMINISTRACAO DE EMPRESAS DE CAJAMAR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2416, 2712, 'FACULDADE DE SISTEMAS DE INFORMACAO DE CAJAMAR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2417, 2713, 'INSTITUTO NORMAL SUPERIOR DE CAJAMAR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2418, 2714, 'FACULDADE DE ENFERMAGEM E OBSTETRICIA DE CAJAMAR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2419, 2715, 'FACULDADE DE CIENCIAS HUMANAS DE PONTE NOVA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2420, 2716, 'FACULDADE COTEMGE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2421, 2717, 'FACULDADE DE CIENCIAS JURIDICAS VISCONDE DE CAIRU', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2422, 2718, 'INSTITUTO SUPERIOR DE EDUCACAO DO NORTE', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2423, 2719, 'FACULDADE DE DIREITO OSWALDO CRUZ', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2424, 2720, 'FACULDADE AUGUSTO MAIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2425, 2721, 'FACULDADE IMPACTA DE TECNOLOGIA DA INFORMACAO FITI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2426, 2722, 'FACULDADE CATOLICA DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2427, 2723, 'FACULDADE MARISTA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2428, 2724, 'INSTITUTO DE ENSINO SUPERIOR DO SUL DO MARANHAO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2429, 2725, 'INSTITUTO SUPERIOR DE EDUCACAO DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2430, 2726, 'ESCOLA SUPERIOR DE ADMINISTRACAO DE EMPRESAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2431, 2727, 'FACULDADE DO RIO GRANDE DO NORTE', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2432, 2728, 'FACULDADE DE CIENCIAS JURIDICAS E SOCIAIS MAX', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2433, 2729, 'FACULDADE DE PSICOLOGIA MAX', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2434, 2730, 'FACULDADE UNIDA DA PARAIBA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2435, 2731, 'ESCOLA SUPERIOR DE COMPUTACAO E TECNOLOGIAS DA INFORMACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2436, 2732, 'FACULDADE UNIDAS DO ENTORNO GOIAS DF UNIENTORNO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2437, 2733, 'FACULDADE TEOLOGICA ALPHA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2438, 2734, 'FACULDADE DE CIENCIAS DA SAUDE DE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2439, 2735, 'FACULDADE DE CIENCIAS DA COMPUTACAO DE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2440, 2736, 'INSTITUTO TECNOLOGICO DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2441, 2737, 'FACULDADE DE CIENCIAS DA INFORMACAO DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2442, 2738, 'INSTITUTO SUPERIOR DE EDUCACAO DE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2443, 2739, 'FACULDADE CASTILHENSE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2444, 2740, 'FACULDADE DO VALE DO JAGUARIBE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2445, 2741, 'FACULDADE CATOLICA DOM ORIONE', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2446, 2742, 'FACULDADE DE EDUCACAO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2447, 2743, 'FACULDADE DE CIENCIA DA COMPUTACAO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2448, 2744, 'INSTITUTO SUPERIOR DE EDUCACAO VERA CRUZ', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2449, 2745, 'ESCOLA SUPERIOR DA AMAZONIA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2450, 2746, 'INSTITUTO DE ENSINO SUPERIOR ETAPA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2451, 2747, 'FACULDADE EUROPEU DO CEARA FEC', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2452, 2748, 'FACULDADE LATO SENSU DO BRASIL', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2453, 2749, 'INSTITUTO DE CIENCIAS JURIDICAS PITAGORAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2454, 2750, 'FACULDADE DE TECNOLOGIA SENAI LUZERNA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2455, 2751, 'INSTITUTO SUPERIOR DE EDUCACAO DE RIBEIRA DO POMBAL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2456, 2752, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS PROFESSORA VILMA MONTEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2457, 2753, 'FACULDADE DE CIENCIAS EDUCACIONAIS DE CAPIM GROSSO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2459, 2755, 'FACULDADE DO VALE DO ITAJAI MIRIM', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2460, 2756, 'FACULDADE ANHANGUERA DE VALPARAISO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2461, 2757, 'FACULDADE JK ADMINISTRACAO DE VALPARAISO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2462, 2758, 'INSTITUTO SUPERIOR DE EDUCACAO PROFESSOR PAULO ALBINO PIMENTEL', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2463, 2759, 'FACULDADE PROFESSOR PAULO ALBINO PIMENTEL', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2464, 2760, 'ESCOLA SUPERIOR DE TECNOLOGIA DA INFORMACAO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2465, 2761, 'FACULDADE DO SERTAO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2466, 2762, 'INSTITUTO ISAAC NEWTON', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2467, 2763, 'FACULDADE DE CIENCIAS GERENCIAIS DE SAO GOTARDO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2468, 2764, 'INSTITUTO DE ENSINO SUPERIOR DE OURO FINO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2469, 2765, 'INSTITUTO DE CIENCIAS RELIGIOSAS LUMEN CHRISTI', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2470, 2766, 'FACULDADE EMPRESARIAL DE CHAPECO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2471, 2767, 'INSTITUTO SUPERIOR DE EDUCACAO DA AIMORES M G', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2472, 2768, 'INSTITUTO SUPERIOR DE EDUCACAO FACREFI', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2473, 2769, 'FAVE FACULDADE DE ADMINISTRACAO DE VESPASIANO LTDA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2474, 2770, 'FACULDADE UNIDA DE CAMPINAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2475, 2771, 'CENTRO DE ENSINO SUPERIOR DE ILHEUS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2476, 2772, 'INSTITUTO SUPERIOR DE EDUCACAO MANHUMIRIM', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2477, 2773, 'FACULDADE DE MACAPA', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2478, 2774, 'CENTRO UNIVERSITARIO UNIFAFIBE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2479, 2775, 'FACULDADES INTEGRADAS DESEMBARGADOR SAVIO BRANDAO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2480, 2776, 'FACULDADES INTEGRADAS NORTE CAPIXABA FANORTE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2481, 2777, 'INSTITUTO DE ENSINO SUPERIOR SANTA MARIA DE ASSIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2482, 2778, 'INSTITUTO SUPERIOR ESPECIAL DE EDUCACAO DE PERNAMBUCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2483, 2779, 'FACULDADE DE INFORMATICA DE OURO PRETO DO OESTE', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2484, 2780, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DA ALTA NOROESTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2485, 2781, 'FACULDADE DE CIENCIAS DA SAUDE DA ALTA NOROESTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2486, 2782, 'INSTITUTO SUPERIOR DE EDUCACAO AFONSO LINARES PRADO', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2487, 2783, 'FACULDADE DE TECNOLOGIA DO NORDESTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2488, 2784, 'FACULDADE FAE BLUMENAU', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2489, 2785, 'ESCOLA SUPERIOR DE EDUCACAO CONTINUADA', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2490, 2786, 'INSTITUTO DE EDUCACAO SUPERIOR E TECNOLOGICA PROF FRANBRAN', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2491, 2787, 'FACULDADES PEQUENO PRINCIPE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2492, 2788, 'FACULDADE DE CIENCIAS AMBIENTAIS DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2493, 2789, 'FACULDADE JOINVILLE DE ENSINO E CULTURA FAJEC', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2494, 2790, 'FACULDADE FRANCISCANA DE ENSINO SUPERIOR FAFRES', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2495, 2791, 'FACULDADE DE CIENCIAS AGRARIAS E EXATAS DE PRIMAVERA DO LESTE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2496, 2792, 'FACULDADE DE CIENCIAS SOCIAIS E EDUCACAO FACE', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2497, 2793, 'FACULDADE UNIAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2498, 2794, 'FACULDADE DE CIENCIAS SOCIAIS E HUMANAS SOBRAL PINTO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2499, 2795, 'FACULDADE SAO FRANCISCO DE ASSIS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2500, 2796, 'FACULDADE DE IPORA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2501, 2797, 'FACULDADE DO LITORAL SUL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2502, 2798, 'FAESP FACULDADE DE ENSINO SUPERIOR DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2503, 2799, 'FANEESP FACULDADE NACIONAL DE EDUCACAO E ENSINO SUPERIOR DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2504, 2800, 'FACULDADE DE ITABUNA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2505, 2801, 'INSTITUTO GUARANTA DE EDUCACAO SUPERIOR', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2506, 2802, 'FACULDADE DE CIENCIAS AGRARIAS DE GUARANTA DO NORTE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2507, 2803, 'FACULDADE CETESI', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2508, 2804, 'FACULDADE CCAA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2509, 2805, 'FACULDADE MODELO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2510, 2806, 'FACULDADE EVANGELICA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2511, 2807, 'FACULDADE CENTRO CAPE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2512, 2808, 'FACULDADES ITECNE DE CASCAVEL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2513, 2809, 'INSTITUTO DE ENSINO SUPERIOR DE UBERLANDIA IESU', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2514, 2810, 'INSTITUTO SUPERIOR DE EDUCACAO ANISIO TEIXEIRA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2515, 2811, 'FACULDADE PAULUS DE TECNOLOGIA E COMUNICACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2516, 2812, 'FACULDADE DO SUDESTE BRASILEIRO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2517, 2813, 'INSTITUTO SUPERIOR DE EDUCACAO CAPIMGROSSENSE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2518, 2814, 'FACULDADE SAO SEBASTIAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2519, 2815, 'FACULDADE VALE DO RIBEIRA FVR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2520, 2816, 'FACULDADE SANTO AGOSTINHO FSA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2521, 2817, 'FACULDADE DE IUNA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2522, 2818, 'FACULDADE DE VETERINARIA DE VESPASIANO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2523, 2819, 'FACULDADE ANGELO VASCONCELOS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2524, 2820, 'FACULDADE PITAGORAS DE MONTES CLAROS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2525, 2821, 'FACULDADE IDC', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2526, 2822, 'FACULDADE DE ENGENHARIA FLORESTAL DE IBIRACU', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2527, 2823, 'FACULDADE DE ENGENHARIA AGRICOLA DE IBIRACU', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2528, 2824, 'FACULDADE DE ENGENHARIA AGRONOMICA DE IBIRACU', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2529, 2825, 'FACULDADE DO SISTEMA FINDES', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2530, 2826, 'FACULDADE NOSSA SENHORA DE FATIMA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2531, 2827, 'FACULDADE EVANGELICA DO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2532, 2828, 'FACULDADE ITABIRANA DE SAUDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2533, 2829, 'INSTITUTO SUPERIOR DE EDUCACAO E FILOSOFIA DE TERESINA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2534, 2830, 'FACULDADE ADVENTISTA DE CIENCIAS DA SAUDE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2535, 2831, 'FACULDADE DOM BOSCO DE GOIOERE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2536, 2832, 'INSTITUTO SUPERIOR DE EDUCACAO PROGRAMUS', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2537, 2833, 'FACULDADE ON LINE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2538, 2834, 'INSTITUTO SUPERIOR DE PSICOLOGIA DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2539, 2835, 'CENTRO UNIVERSITARIO MAURICIO DE NASSAU', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2540, 2836, 'FACULDADE SUL DA AMERICA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2541, 2837, 'INSTITUTO SUPERIOR DE EDUCACAO SUL DA AMERICA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2542, 2838, 'FASES FACULDADE SOTEROPOLITANA DE ENSINO SUPERIOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2543, 2839, 'INSTITUTO METODISTA SUPERIOR DE EDUCACAO DA AMAZONIA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2544, 2840, 'FACULDADE METODISTA DE TEOLOGIA E CIENCIAS HUMANAS DA AMAZONIA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2545, 2841, 'FACULDADE PARANAPANEMA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2546, 2842, 'FACULDADE DE MEDICINA MACHADO DE ASSIS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2547, 2843, 'FACULDADE DE CIENCIAS MEDICAS E DA SAUDE DE JUIZ DE FORA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2548, 2844, 'FACULDADE SALESIANA DOM BOSCO DE PIRACICABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2549, 2845, 'FACULDADE REINALDO RAMOS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2550, 2846, 'FACULDADE DE TEOLOGIA UMBANDISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2551, 2847, 'INSTITUTO SUPERIOR DE EDUCACAO DO PARANAPANEMA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2552, 2848, 'FACULDADE DE NOVO PROGRESSO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2553, 2849, 'ESCOLA SUPERIOR DOM HELDER CAMARA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2554, 2850, 'FACULDADE DE FEIRA DE SANTANA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2555, 2851, 'FACULDADE SANTA PAULINA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2556, 2852, 'FACULDADE DE GESTAO E NEGOCIOS DO ALTO URUGUAI', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2557, 2853, 'FACULDADE PITAGORAS DE TECNOLOGIA DE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2558, 2854, 'FACULDADE CONHECER', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2559, 2855, 'FACULDADE SAO FRANCISCO DE ASSIS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2560, 2856, 'FACULDADE DE TECNOLOGIA QUASAR', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2561, 2857, 'INSTITUTO CIENTIFICO DA PARAIBA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2562, 2858, 'INSTITUTO DE SAUDE ALEXANDER FLEMING', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2563, 2859, 'FACULDADE DE BELEM', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2564, 2860, 'FACULDADE CEAQ', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2565, 2861, 'FACULDADE DE ITAPETININGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2566, 2862, 'FACULDADE DE DIREITO PRESIDENTE TANCREDO NEVES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2567, 2863, 'FACULDADE DE ADMINISTRACAO DE PETROLINA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2568, 2864, 'FACULDADE DE DIREITO DE PETROLINA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2569, 2865, 'FACULDADE DE CIENCIAS SOCIAIS DE RECIFE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2570, 2866, 'FACULDADE DE CIENCIAS JURIDICAS DE RECIFE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2571, 2867, 'FACULDADE DE DIREITO DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2572, 2868, 'FACULDADE DE ADMINISTRACAO DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2573, 2869, 'FACULDADE DE CIENCIAS SOCIAIS ADAO DE ALMEIDA E SILVA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2574, 2870, 'FACULDADE SERRA DO CARMO', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2575, 2871, 'INSTITUTO SUPERIOR DE EDUCACAO SERRA DO CARMO', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2576, 2872, 'FACULDADE DE CIENCIAS AGRARIAS RENATO AZEREDO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2577, 2873, 'FACULDADE DE SISTEMAS DE INFORMACAO DE SAO SEBASTIAO DO PARAISO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2578, 2874, 'FACULDADE DE DIREITO DE SAO SEBASTIAO DO PARAISO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2579, 2875, 'FACULDADE INDIGENA DA AMAZONIA', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2580, 2876, 'FACULDADE UNISSA DE SARANDI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2581, 2877, 'FACULDADE UNISSA DE EDUCACAO TECNOLOGICA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2582, 2878, 'INSTITUTO SUPERIOR DE EDUCACAO DE CAIEIRAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2583, 2879, 'FACULDADE METROPOLITANA DE CAIEIRAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2584, 2880, 'INSTITUTO SUPERIOR DE EDUCACAO DE TIJUCUSSU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2585, 2881, 'INSTITUTO SUPERIOR DE EDUCACAO DO SENAC SP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2586, 2882, 'FACULDADE SAO JOSE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2587, 2883, 'FACULDADE EDUVALE DE PARANAPANEMA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2588, 2884, 'INSTITUTO SUPERIOR DE EDUCACAO BOM JESUS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2589, 2885, 'FACULDADE SAO CAMILO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2590, 2886, 'FACULDADE ZUMBI DOS PALMARES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2591, 2887, 'FACULDADE EDUVALE DE PIRAJU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2592, 2888, 'UNIVERSIDADE DE GOIAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2593, 2889, 'UNIVERSIDADE PARA O DESENVOLVIMENTO DA AMAZONIA', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2594, 2890, 'UNIVERSIDADE DE INTEGRACAO BRASILEIRA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2595, 2891, 'FACULDADE BARAO DE PIRATININGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2596, 2892, 'FACULDADE DE PALMARES FAPAL', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2597, 2893, 'INSTITUTO SUPERIOR DE EDUCACAO DOS PALMARES', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2598, 2894, 'FACULDADE INTEGRAL DE SANTA HELENA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2599, 2895, 'FACULDADE DE EDUCACAO E TECNOLOGIA DA REGIAO MISSIONEIRA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2600, 2896, 'FACULDADE SATC', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2601, 2897, 'FACULDADE JK', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2602, 2899, 'FACULDADES CAICARAS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2603, 2900, 'INSTITUTO TECNOLOGICO REGIONAL', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2604, 2901, 'INSTITUTO SUPERIOR DE EDUCACAO DO MEDIO NORTE MATO GROSSENSE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2605, 2902, 'FACULDADE DO MEDIO NORTE MATO GROSSENSE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2606, 2903, 'FACULDADE CONCORDIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2607, 2904, 'FACULDADE JK GUARA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2608, 2905, 'FACULDADE BRASILEIRA DE PEDAGOGIA UNIBRA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2609, 2906, 'FACULDADE NACIONAL', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2610, 2907, 'FACULDADE BRASILEIRA DE NANUQUE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2611, 2908, 'FACULDADE NATALENSE DE ENSINO E CULTURA', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2612, 2909, 'FACULDADE DO ESTADO DO MARANHAO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2613, 2910, 'FACULDADE VERDE NORTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2614, 2911, 'FACULDADE PAN AMAZONIA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2615, 2912, 'FACULDADE MARIA MILZA CAMPUS FACTAE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2616, 2913, 'FACULDADE DO VALE DO PARAGUACU', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2617, 2914, 'INSTITUTO ABUCHAIM', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2618, 2915, 'FACULDADE CIDADE DE PATOS DE MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2619, 2916, 'INSTITUTO DE EDUCACAO SUPERIOR DE SERGIPE ISES', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2620, 2917, 'FACULDADE BRASIL NORTE', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2621, 2918, 'FACULDADE DE ENSINO SUPERIOR DA AMAZONIA REUNIDA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2622, 2919, 'FACULDADE SAO JOSE DE RIBAMAR', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2623, 2920, 'INSTITUTO DE ENSINO SUPERIOR CATTA PRETA E DIAMANTINO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2624, 2921, 'INSTITUTO SUPERIOR DE EDUCACAO DA AMAZONIA REUNIDA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2625, 2922, 'INSTITUTO SUPERIOR DE EDUCACAO DE BARRETOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2626, 2923, 'FACULDADE TABIRENSE DE ENFERMAGEM', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2627, 2924, 'INSTITUTO SUPERIOR DE EDUCACAO CENECISTA DE BUTIA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2628, 2925, 'INSTITUTO SUPERIOR DE EDUCACAO DE CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2629, 2926, 'FACULDADE BRASIL CENTRAL', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2630, 2927, 'FACULDADE DEL REY', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2631, 2928, 'FACULDADE HOLISTICA DE CIENCIAS HUMANAS FHCH', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2632, 2929, 'FACULDADE DE MILAGRES CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2633, 2930, 'FACULDADE DE SARANDI', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2634, 2931, 'FACULDADE RIO GRANDE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2635, 2932, 'FACULDADE PELOTENSE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2636, 2933, 'FACULDADE TIMONENSE', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2637, 2934, 'FACULDADE DE ADMINISTRACAO E ECONOMIA DE JOINVILLE FAEJ', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2638, 2935, 'FACULDADE DE TALENTOS HUMANOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2639, 2936, 'INSTITUTO DE EDUCACAO SUPERIOR MARISTA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2640, 2937, 'FACULDADE METROPOLITANA DO PARA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2641, 2938, 'FACULDADE DE EDUCACAO DE BARCARENA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2642, 2939, 'INSTITUTO SUPERIOR DE EDUCACAO TORRICELLI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2643, 2940, 'FACULDADE CENECISTA DE CACHOEIRAS DE MACACU', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2644, 2941, 'INSTITUTO SUPERIOR DE TEOLOGIA E PASTORAL DE BONFIM', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2645, 2942, 'INSTITUTO SUPERIOR DE EDUCACAO FRANCISCANO NOSSA SENHORA DE FATIMA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2646, 2943, 'INSTITUTO SUPERIOR DE EDUCACAO PIRAMIDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2647, 2944, 'FACULDADE DO SUL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2648, 2945, 'FACULDADE DA ASSOCIACAO BRASILIENSE DE EDUCACAO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2649, 2946, 'FACULDADE DE ARQUITETURA E URBANISMO DO DISTRITO FEDERAL FAU DF', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2650, 2947, 'FACULDADE DAS AMERICAS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2651, 2948, 'REAL FACULDADE DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2652, 2949, 'FACULDADE DO BAIXO PARNAIBA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2653, 2950, 'FACULDADE DE DESENVOLVIMENTO DO RIO GRANDE DO SUL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2654, 2951, 'INSTITUTO SUPERIOR DE EDUCACAO DE MORRO AGUDO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2655, 2952, 'FACULDADES DO SUL FASUL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2656, 2953, 'INSTITUTO SUPERIOR DE EDUCACAO DA CIDADE DO NATAL', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2657, 2954, 'FACULDADE SUL CAPIXABA UNISUL', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2658, 2955, 'FACULDADE DE CIENCIAS HUMANAS BIOLOGICAS E DA SAUDE DO LESTE MATOGROSSENSE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2659, 2956, 'FACULDADE DE CIENCIAS JURIDICAS SOCIAIS E TECNOLOGICA FACITE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2660, 2957, 'FACULDADE DE CIENCIAS EXATAS E AGRARIAS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2661, 2958, 'FACULDADE DE CIENCIAS BIOLOGICAS HUMANAS E SAUDE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2662, 2959, 'FACULDADE DE CIENCIAS AGRARIAS E EXATAS DO LESTE MATOGROSSENSE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2663, 2960, 'FACULDADE SANTOS DUMONT', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2664, 2961, 'FACULDADE DO PANTANAL MATOGROSSENSE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2665, 2962, 'FACULDADE DE CIENCIAS SOCIAIS DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2666, 2963, 'FACULDADE DE CIENCIAS SOCIAIS DE PETROLINA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2667, 2964, 'FACULDADE PROJECAO DO GUARA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2668, 2965, 'FACULDADE MOKITI OKADA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2669, 2966, 'INSTITUTO SUPERIOR DE EDUCACAO HELIO MAGDALENA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2670, 2967, 'INSTITUTO SUPERIOR DE EDUCACAO PEDRO II', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2671, 2968, 'FACULDADE NOVA ESPERANCA DE NUTRICAO', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2672, 2969, 'INSTITUTO SUPERIOR DE EDUCACAO OCIDENTE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2673, 2970, 'FACULDADE INTEGRAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2674, 2971, 'FACULDADE BARRETOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2675, 2972, 'FACULDADE CHAPADINHENSE DE EDUCACAO CIENCIAS E TECNOLOGIA FACHAP', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2676, 2973, 'FACULDADE DE CIENCIAS HUMANAS E BIOLOGICAS E DA SAUDE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2677, 2974, 'FACULDADE DE CIENCIAS JURIDICAS E SOCIAIS APLICADAS DE PRIMAVERA DO LESTE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2678, 2975, 'FACULDADE JK GUARA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2679, 2976, 'INSTITUTO SUPERIOR DE EDUCACAO DA FATEB', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2680, 2977, 'FACULDADES INTEGRADAS DE CIENCIAS E BIOTECNOLOGIA FICEB', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2681, 2978, 'FACUDADE DE ODONTOLOGIA MARIO DE OLIVEIRA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2682, 2979, 'FACULDADE SUL ESPIRITO SANTENSE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2683, 2980, 'FACULDADE SENAC CEARA DE ADMINISTRACAO E COMERCIO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2684, 2981, 'FACULDADE SAO VICENTE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2685, 2982, 'FACULDADE VICTOR HUGO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2686, 2983, 'FACULDADE SAO VICENTE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2687, 2984, 'FACULDADE ABRAHAN LINCON', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2688, 2985, 'FACULDADE MERIDIONAL DO MARANHAO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2689, 2986, 'INSTITUTO DE FILOSOFIA E CIENCIAS HUMANAS DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2690, 2987, 'FACULDADE DE ODONTOLOGIA ALFEU GOMES DE OLIVEIRA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2691, 2988, 'INSTITUTO SUPERIOR DE EDUCACAO FENIX DE BAURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2692, 2989, 'IBESS INSTITUTO BRASILEIRO DE EDUCACAO SUED E SUSEJ LTDA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2693, 2990, 'FACULDADES DE ADMINISTRACAO DO SUL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2694, 2991, 'FACULDADE DE SAPEACU', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2695, 2992, 'FACULDADE DO SUDESTE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2696, 2993, 'FACULDADE DE CIENCIAS BIOLOGICAS E DA SAUDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2697, 2994, 'INSTITUTO SUPERIOR UNIFELI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2698, 2995, 'INSTITUTO SUPERIOR DE EDUCACAO LUTERANO DE PORTO VELHO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2699, 2996, 'FACULDADE SOTEROPOLITANA DE DIREITO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2700, 2997, 'FACULDADE DE COMUNICACAO E INFORMACAO DO CENTRO OESTE COMUNICO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2701, 2998, 'FACULDADES SESI AMAZONAS FASESI', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2702, 2999, 'INSTITUTO SUPERIOR DE EDUCACAO CENECISTA DE RONDONOPOLIS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2703, 3000, 'FACULDADE CENECISTA DE SINOP', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2704, 3001, 'FACULDADE CENECISTA DE RONDONOPOLIS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2705, 3002, 'FACULDADE DE CIENCIAS DA SAUDE NOSSA SENHORA DAS MERCES DE MONTES CLAROS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2706, 3003, 'INSTITUTO SUPERIOR DE EDUCACAO JUSCELINO KUBITSCHEK', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2707, 3004, 'INSTITUTO DE ENSINO SUPERIOR SANTA CECILIA', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2708, 3005, 'FACULDADE SEM FRONTEIRAS FASEF', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2709, 3006, 'INSTITUTO SUPERIOR DE EDUCACAO MILTON CAMPOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2710, 3007, 'FACULDADE DO INSTITUTO NACIONAL DE POSGRADUACAO DE CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2711, 3008, 'FACULDADE DO INSTITUTO NACIONAL DE POSGRADUACAO DE SAO JOSE DOS CAMPOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2712, 3009, 'INSTITUTO DE ENSINO SUPERIOR APIAI ISA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2713, 3010, 'FACULDADE DE CIENCIAS HUMANAS DE RONDONIA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2714, 3011, 'FACULDADE PROF MIGUEL ANGELO DA SILVA SANTOS', 3, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2715, 3012, 'FAJOPA FACULDADE JOAO PAULO II', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2716, 3013, 'INSTITUTO SUPERIOR DE EDUCACAO CIDADANIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2717, 3014, 'FACULDADE DE FARMACIA DOS CAMPOS GERAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2718, 3015, 'INSTITUTO DE EDUCACAO SUPERIOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2719, 3016, 'FACULDADE DE ENFERMAGEM JOSE RODRIGUES DA SILVA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2720, 3017, 'INSTITUTO SUPERIOR DE EDUCACAO UNIPLAM', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2721, 3018, 'FACULDADE METROPOLITANA DE CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2722, 3019, 'INSTITUTO DE EDUCACAO SUPERIOR ANAMELIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2723, 3020, 'FACULDADE SANTA RITA DE CASSIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2724, 3021, 'INSTITUTO SUPERIOR DE EDUCACAO SANTA RITA DE CASSIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2725, 3022, 'FACULDADE DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2726, 3023, 'FACULDADES INTEGRADAS ATLANTICA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2727, 3024, 'FACULDADES INTEGRADAS DE ENSINO SUPERIOR DO ESTADO DO PARA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2728, 3025, 'INSTITUTO PRESBITERIANO DE EDUCACAO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2729, 3026, 'FACULDADE DO PLANALTO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2730, 3027, 'FACULDADE DE CIENCIAS EDUCACIONAIS E SISTEMAS INTEGRADOS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2731, 3028, 'FACULDADE REUNIDAS DO LITORAL DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2732, 3029, 'FACULDADE DA AMAZONIA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2733, 3030, 'INSTITUTO SUPERIOR DE EDUCACAO EDUVALE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2734, 3031, 'FACULDADE ALPHA', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2735, 3032, 'FACULDADE SANTA MARIA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2736, 3033, 'FACULDADE DE FEIRA DE SANTANA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2737, 3034, 'FACULDADE DELTA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2738, 3035, 'FACULDADE BARBOSA CASTILHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2739, 3036, 'LIBERTAS INSTITUTO SUPERIOR DE CIENCIAS JURIDICAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2740, 3037, 'FACULDADE DE IBIUNA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2741, 3038, 'INSTITUTO SUPERIOR DE EDUCACAO LIONS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2742, 3039, 'FACULDADE VASCONCELLOS & SOUZA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2743, 3040, 'FACULDADE VALE DO JEQUITINHONHA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2744, 3041, 'FACULDADE FILADELFIA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2745, 3042, 'CHRISTUS FACULDADE DO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2746, 3043, 'ABEU FACULDADE DE SAO JOAO DE MERITI', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2747, 3044, 'ABEU FACULDADE VILAR DOS TELES', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2748, 3045, 'ABEU FACULDADE DE QUEIMADOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2749, 3046, 'INSTITUTO SUPERIOR DE EDUCACAO ISE', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2750, 3047, 'FACULDADE POLIVALENTE FACIP', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2751, 3048, 'INSTITUTO SUPERIOR DE EDUCACAO DO INSTITUTO PORTO ALEGRE DA IGREJA METODISTA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2752, 3049, 'INSTITUTO ODONTOLOGICO DO PARANA ODONS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2753, 3050, 'FACULDADE DE TEOLOGIA DA ASSEMBLEIA DE DEUS FATEAD', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2754, 3051, 'FACULDADE TEOLOGICA DE CIENCIAS HUMANAS E SOCIAIS LOGOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2755, 3052, 'FACULDADE EDUCARE', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2756, 3053, 'FACULDADE DE ODONTOLOGIA PRO PARA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2757, 3054, 'FACULDADE DE CIENCIAS E TECNOLOGIA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2758, 3055, 'INSTITUTO SUPERIOR DE EDUCACAO DE RONDONIA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2759, 3056, 'ESCOLA SUPERIOR OSWALDO CRUZ', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2760, 3057, 'INSTITUTO DE ENSINO SUPERIOR SAGRADA FAMILIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2761, 3058, 'INSTITUTO SUPERIOR DE EDUCACAO SAGRADA FAMILIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2762, 3059, 'INSTITUTO DE ENSINO SUPERIOR DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2763, 3060, 'INSTITUTO DE ENSINO SUPERIOR DE ARAUCARIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2764, 3061, 'INSTITUTO SUPERIOR DE EDUCACAO DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2765, 3062, 'FACULDADE COMERCIAL DE SERRINHA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2766, 3063, 'FAECO FACULDADE EDUCACIONAL COSTA OESTE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2767, 3064, 'FACULDADE DE CIENCIAS EXATAS E AGRARIAS DE RORAIMA', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2768, 3065, 'INSTITUTO SUPERIOR DE EDUCACAO DE ARAUCARIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2769, 3066, 'FACULDADE INTERAMERICANA DE BELEM', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2770, 3067, 'FACULDADE ROTHSCHILD DE EDUCACAO SUPERIOR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2771, 3068, 'FACULDADE DE TEOLOGIA E CIENCIAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2772, 3069, 'INSTITUTO DE EDUCACAO SUPERIOR DE ALAGOAS NO LITORAL NORTE', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2773, 3070, 'FACULDADE DE BELA VISTA DE GOIAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2774, 3071, 'INSTITUTO DE EDUCACAO SUPERIOR UNYAHNA DE SERRINHA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2775, 3072, 'INSTITUTO DE EDUCACAO SUPERIOR UNYAHNA DE JACOBINA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2776, 3073, 'INSTITUTO DE EDUCACAO SUPERIOR UNYAHNA DE CRUZ DAS ALMAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2777, 3074, 'FACULDADE DO EXTREMO SUL DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2778, 3075, 'INSTITUTO DE EDUCACAO SUPERIOR UNYAHNA DE ALAGOINHAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2779, 3076, 'FACULDADE DE SAUDE IPITANGA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2780, 3077, 'FACULDADE METROPOLITANA DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2781, 3078, 'INSTITUTO SUPERIOR DE EDUCACAO FRUTALENSE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2782, 3079, 'INSTITUTO DE ENSINO SUPERIOR ALTERNATIVO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2783, 3080, 'FACULDADE DE ARTE E DESIGN BERLIM BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2784, 3081, 'FACULDADE ITALIANA DE TECNOLOGIA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2785, 3082, 'FACULDADE 2 DE JULHO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2786, 3083, 'FACULDADE INTEGRADA UNIVERACRUZ DE GUANAMBI', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2787, 3084, 'FACULDADE MARQUES DE POMBAL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2788, 3085, 'FACULDADE EVANGELICA LUZ E VIDA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2789, 3086, 'FACULDADE DA MODA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2790, 3087, 'CHRISTUS INSTITUTO SUPERIOR DE EDUCACAO', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2791, 3088, 'FACULDADE UNIDAS SUL BAHIA FUSBA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2792, 3089, 'FACULDADE CAICARAS DE TAGUATINGA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2793, 3090, 'INSTITUTO SUPERIOR NORMAL AURELINA PALMEIRA', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2794, 3091, 'CENTRO DE ENSINO LEIDE TORRES', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2795, 3092, 'FACULDADE DE BEM ESTAR SOCIAL E SAUDE DE ITAPECERICA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2796, 3093, 'FACULDADE DE ENFERMAGEM JOAO FRANCISCO DA SILVA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2797, 3094, 'FACULDADE DE DIREITO DESEMBARGADOR AFFONSO TEIXEIRA LAGES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2798, 3095, 'FACULDADE DE CIENCIAS AGRARIAS DOM ORIONE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2799, 3096, 'FACULDADE DE AGRONOMIA MANOEL ANTONIO DA SILVA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2800, 3097, 'FACULDADE DE DIREITO AFONSO PENA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2801, 3098, 'INSTITUTO SUPERIOR DE EDUCACAO SAO JUDAS TADEU', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2802, 3099, 'FACULDADE INTERNACIONAL DA PARAIBA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2803, 3100, 'FACULDADE INTEGRADA UNIVERACRUZ DE BOM JESUS DA LAPA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2804, 3101, 'FACULDADE INTEGRADA UNIVERACRUZ DE ALAGOINHAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2805, 3102, 'FACULDADE INTEGRADA UNIVERACRUZ DE CAMPO FORMOSO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2806, 3103, 'FACULDADE INTEGRADA UNIVERACRUZ DE BRUMADO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2807, 3104, 'FACULDADE INTEGRADA UNIVERACRUZ DE JEQUIE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2808, 3105, 'FACULDADE INTEGRADA UNIVERACRUZ DE JACOBINA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2809, 3106, 'FACULDADE INTEGRADA UNIVERACRUZ DE ITAMARAJU', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2810, 3107, 'FACULDADE BENEMERITA EDUCADORA UNIVERACRUZ DE PAULO AFONSO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2811, 3108, 'FACULDADE INTEGRADA UNIVERACRUZ DE ITABUNA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2812, 3109, 'FACULDADE ITEGRADA UNIVERACRUZ DE VALENCA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2813, 3110, 'FACULDADE ITEGRADA UNIVERACRUZ DE CAMACARI', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2814, 3111, 'FACULDADE INTEGRADA UNIVERACRUZ DE BARREIRAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2815, 3112, 'FACULDADE INTEGRADA UNIVERACRUZ DE RIBEIRA DO POMBAL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2816, 3113, 'FACULDADE INTEGRADA UNIVERACRUZ DE PILAO ARCADO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2817, 3114, 'FACULDADE INTEGRADA UNIVERACRUZ DE VITORIA DA CONQUISTA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2818, 3115, 'INSTITUTO SUPERIOR DE EDUCACAO SANTO AGOSTINHO DE PIRAPORA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2819, 3116, 'FACULDADE SANTO AGOSTINHO DE PIRAPORA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2820, 3117, 'FACULDADE DE SAUDE E DESENVOLVIMENTO HUMANO SANTO AGOSTINHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2821, 3118, 'FALCUDADE INTEGRADA UNIVERACRUZ DE BARRA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2822, 3119, 'FACULDADE INTEGRADA UNIVERACRUZ DE DIAS D AVILA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2823, 3120, 'FACULDADE INTEGRADA UNIVERACRUZ DE CANDEIAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2824, 3121, 'FACULDADE INTEGRADA UNIVERACRUZ DE SERRINHA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2825, 3122, 'FACULDADE INTEGRADA UNIVERACRUZ SIMOES FILHO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2826, 3123, 'FACULDADE INTEGRADA UNIVERACRUZ DE SANTA MARIA DA VITORIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2827, 3124, 'FACULDADE DO DISTRITO FEDERAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2828, 3125, 'FACULDADE INTEGRADA UNIVERACRUZ DE PORTO SEGURO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2829, 3126, 'FACULDADE INTEGRADA UNIVERACRUZ DE SENHOR DO BONFIM', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2830, 3127, 'FACULDADE INTEGRADA UNIVERACRUZ DE IRECE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2831, 3128, 'FACULDADE INTEGRADA UNIVERACRUZ DE LAURO DE FREITAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2832, 3129, 'FACULDADE INTEGRADA UNIVERACRUZ DE ILHEUS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2833, 3130, 'FACULDADE INTEGRADA UNIVERACRUZ DE FEIRA DE SANTANA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2834, 3131, 'FACULDADE INTEGRADA UNIVERACRUZ DE EUNAPOLIS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2835, 3132, 'FACULDADE INEGRADA UNIVERACRUZ DE EUCLIDES DA CUNHA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2836, 3133, 'FACULDADE INTEGRADA UNIVERACRUZ DE JUAZEIRO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2837, 3134, 'FACULDADE INTEGRADA UNIVERACRUZ DE ITABERABA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2838, 3135, 'FACULDADE INTEGRADA UNIVERACRUZ DE TEIXEIRA DE FREITAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2839, 3136, 'FACULDADES INTEGRADA UNIVERACRUZ DE IPIRA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2840, 3137, 'FACULDADE INTEGRADA UNIVERACRUZ DE SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2841, 3138, 'FACULDADE DINAMICA DE ITAIPULANDIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2842, 3139, 'INSTITUTO DE SUPERIOR DE EDUCACAO FRANCISCO AGUIAR', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2843, 3140, 'FACULDADE ZEUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2844, 3141, 'FACVALE FACULDADE DO VALE DO JACUIPE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2845, 3142, 'INSTITUTO SUPERIOR DE EDUCACAO EDEM', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2846, 3143, 'FACULDADE DO VAREJO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2847, 3144, 'FACULDADE AGUAS LINDAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2848, 3145, 'FACULDADE DE DIREITO SAO JUDAS TADEU DE PORTO ALEGRE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2849, 3146, 'FACULDADE DE ODONTOLOGIA DO RECIFE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2850, 3147, 'FACULDADE DE DIREITO DE PORTO ALEGRE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2851, 3148, 'FACULDADE ANCHIETA DO RECIFE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2852, 3149, 'FACULDADE PITAGORAS DE DIVINOPOLIS FPD', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2853, 3150, 'INSTITUTO SUPERIOR DE EDUCACAO DA FACULDADE DE CIENCIAS E LETRAS DE ARARAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2854, 3151, 'UNIVERSIDADE COMUNITARIA DA REGIAO DE CHAPECO', 3, 1, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2855, 3152, 'INSTITUTO SUPERIOR DE EDUCACAO SANTA RITA DO SAPUCAI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2856, 3153, 'INSTITUTO SUPERIOR DE EDUCACAO CANTAREIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2857, 3154, 'FACULDADE DE TECNOLOGIA SENAI RIO DO SUL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2858, 3155, 'FACULDADE DE TECNOLOGIA SENAI JARAGUA DO SUL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2859, 3156, 'FACULDADE DE TECNOLOGIA SENAI BRUSQUE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2860, 3157, 'INSTITUTO SUPERIOR DE EDUCACAO ALMEIDA RODRIGUES', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2861, 3158, 'INSTITUTO SUPERIOR DE EDUCACAO ANGLOAMERICANO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2862, 3159, 'FACULDADE DE TECNOLOGIA SENAI FLORIANOPOLIS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2863, 3160, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DE ALAGOAS', 1, 1, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2864, 3161, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO SERTAO PERNAMBUCANO', 1, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2865, 3162, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DE SANTA CATARINA', 1, 1, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2866, 3163, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO RIO DE JANEIRO', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2867, 3164, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DE MATO GROSSO', 1, 1, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2868, 3165, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO TRIANGULO MINEIRO', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2869, 3166, 'INSTITUTO SUPERIOR DE EDUCACAO DE IBIUNA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2870, 3167, 'FACULDADE DE TECNOLOGIA ESTACIO DE SA DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2871, 3168, 'FACULDADE DE TECNOLOGIA ESTACIO DE SA DE JUIZ DE FORA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2872, 3169, 'FACULDADE DE TECNOLOGIA IBTA CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2873, 3170, 'FACULDADES INTEGRADAS ASSOCIACAO DE ENSINO DE SANTA CATARINA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2874, 3171, 'FACULDADE EQUIPE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2875, 3172, 'UNIVERSIDADE DO ESTADO DO AMAZONAS', 2, 1, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2876, 3173, 'FACULDADE DE TECNOLOGIA DO COMERCIO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2877, 3174, 'INSTITUTO SUPERIOR DE EDUCACAO DE VINHEDO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2878, 3175, 'INSTITUTO SUPERIOR DE EDUCACAO DE TAQUARA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2879, 3176, 'INSTITUTO SUPERIOR DE EDUCACAO EQUIPE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2880, 3177, 'FACULDADE DE ADMINISTRACAO DA FESPSP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2881, 3178, 'INSTITUTO DE EDUCACAO SUPERIOR DE BARUERI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2882, 3179, 'FACULDADE DA CIDADE DE SAO GONCALO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2883, 3180, 'INSTITUTO SUPERIOR DE EDUCACAO UNIAO DAS AMERICAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2884, 3181, 'FACULDADE DE DIREITO DE BOA VISTA', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2885, 3182, 'CENTRO DE ENSINO SUPERIOR ARCANJO MIKAEL DE ARAPIRACA', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2886, 3183, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DE SERGIPE', 1, 1, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2887, 3184, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DE RORAIMA', 1, 1, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2888, 3185, 'CENTRO FEDERAL DE EDUCACAO TECNOLOGICA DE SAO VICENTE DO SUL', 1, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2889, 3186, 'FACULDADE DE SAO ROQUE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2890, 3187, 'INSTITUTO SUPERIOR DE EDUCACAO CORACAO DE JESUS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2891, 3188, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO NORTE DE MINAS GERAIS', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2892, 3189, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DE MINAS GERAIS', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2893, 3190, 'INSTITUTO SUPERIOR DE EDUCACAO DE GARCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2894, 3191, 'INSTITUTO SUPERIOR DE EDUCACAO DE SANTA CATARINA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2895, 3192, 'INSTITUTO SUPERIOR DE EDUCACAO DE CAJAZEIRAS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2896, 3193, 'FACULDADES INTEGRADAS DOS CAMPOS GERAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2897, 3194, 'FACULDADE DE MINAS BH', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2898, 3195, 'FACULDADE VILA RICA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2899, 3196, 'FACULDADE PONTES E LACERDA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2900, 3197, 'FACULDADES DO PARECIS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2901, 3198, 'FACULDADE DE CIENCIAS HUMANAS DE IVAIPORA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2902, 3199, 'FANESF FACULDADE NACIONAL DE ENSINO SUPERIOR DA FAZENDA RIO GRANDE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2903, 3200, 'FANPINHAIS FACULDADE NACIONAL DE PINHAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2904, 3201, 'FACULDADE DE EDUCACAO E ENSINO SUPERIOR DO ABRANCHES', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2905, 3202, 'FACULDADES AUGUSTUS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2906, 3203, 'INSTITUTO SUPERIOR DE EDUCACAO ALBERT EINSTEIN', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2907, 3204, 'FACULDADE DE QUATRO MARCOS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2908, 3205, 'FACULDADE DE CIENCIAS BIOLOGICAS E DA SAUDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2909, 3206, 'INSTITUTO DO SABER', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2910, 3207, 'FACULDADES DE CAFELANDIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2911, 3208, 'FACULDADE AMERICA DO SUL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2912, 3209, 'FACULDADE DE ARACATUBA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2913, 3210, 'INSTITUTO EDUCACIONAL EVANGELICO DE ARAPONGAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2914, 3211, 'FACDIPAR FACULDADE DE DIREITO DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2915, 3212, 'INSTITUTO SUPERIOR DE FILOSOFIA BERTHIER', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2917, 3214, 'FACULDADE EUROPEU DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2918, 3215, 'FACULDADE ENTRE RIOS DO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2919, 3216, 'FACULDADE DE CIENCIAS DA BAHIA FACIBA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2920, 3217, 'FACULDADE DE ENSINO SUPERIOR DO BRASIL', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2921, 3218, 'FACULDADE DE CIENCIAS DA SAUDE DE PORTO ALEGRE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2922, 3219, 'FACULDADE EVANGELICA DE INDAIATUBA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2923, 3220, 'INSTITUTO NACIONAL DE EDUCACAO SUPERIOR DE EDUCACAO E CULTURA INESC', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2924, 3221, 'FACULDADE DE ODONTOLOGIA DE MACAPA', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2925, 3222, 'FACULDADE DE ODONTOLOGIA DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2926, 3223, 'ESCOLA SUPERIOR DE CIENCIAS DA SAUDE', 2, 1, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2927, 3224, 'FACULDADE DE FARMACIA E BIOQUIMICA', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2928, 3225, 'FACULDADE DE ENFERMAGEM', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2929, 3226, 'FACULDADE DE MEDICINA', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2930, 3227, 'FACULDADE DE SISTEMA DE INFORMACAO', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2931, 3228, 'FACULDADE DE ADMINISTRACAO', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2932, 3229, 'FACULDADE DE TURISMO DE DUQUE DE CAXIAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2933, 3230, 'FACULDADE LUIZ EDUARDO MAGALHAES', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2934, 3231, 'INSTITUTO SUPERIOR DE EDUCACAO PADRE ANCHIETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2935, 3232, 'FACULDADE IGUACU', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2936, 3233, 'FACULDADE AMERICA DO SUL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2937, 3234, 'URN FACULDADE DE ALAGOINHAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2938, 3235, 'INSTITUTO SUPERIOR DE EDUCACAO JOAO PAULO PRIMEIRO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2939, 3236, 'INSITUTO DE TEOLOGIA DA DIOCESE DE SANTO ANDRE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2940, 3237, 'FACULDADE SENAC DE ADMINISTRACAO E NEGOCIOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2941, 3238, 'FACULDADE DE ODONTOLOGIA', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2942, 3239, 'INSTITUTO DE DESENVOLVIMENTO EDUCACIONAL SUL CATARINENSE S C LTDA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2943, 3240, 'INSTITUTO SUPERIOR DE EDUCACAO DE JUIZ DE FORA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2944, 3241, 'FACULDADE NACIONAL DE EDUCACAO E ENSINO SUPERIOR DO BRASIL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2945, 3242, 'FACULDADE DE TECNOLOGIA E GESTAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2946, 3243, 'FACULDADE NACIONAL CAMPO LARGO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2947, 3244, 'FACULDADE DE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2948, 3245, 'FACULDADE DE SENADOR CANEDO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2949, 3246, 'FACULDADE DE LINHARES', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2950, 3247, 'FACULDADE VITORIA DO ESPIRITO SANTO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2951, 3248, 'FACULDADE DE DOMINGOS MARTINS', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2952, 3249, 'FACULDADE PADRAO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2953, 3250, 'FACULDADE DE MORRINHOS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2954, 3251, 'FACULDADE DE VILA VELHA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2955, 3252, 'FACULDADE QUIRINOPOLIS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2956, 3253, 'FACULDADE COSTA ESMERALDA ITAPEMA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2957, 3254, 'FACULDADE DE EDUCACAO E TEOLOGIA VIVA FATEV', 1, 1, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2958, 3255, 'FACULDADE INPG', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2959, 3256, 'INSTITUTO SUPERIOR DE ECOLOGIA HUMANA E DESENVOLVIMENTO SUSTENTAVEL ISEDS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2960, 3257, 'FAESSF FACULDADE DE ENSINO SUPERIOR SANTA FELICIDADE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2961, 3258, 'FACULDADE DE DIREITO DE RESENDE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2962, 3259, 'FACULDADES DO ICESP', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2963, 3260, 'FACULDADE PRINCESA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2964, 3261, 'FACULDADE DE EDUCACAO E ENSINO SUPERIOR INTEGRAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2965, 3262, 'FACULDADE DOM BOSCO DE GUARANIACU', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2966, 3263, 'FACULDADE YVERDUN BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2967, 3265, 'FACULDADE BATISTA IDA NELSON', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2968, 3266, 'UNIDADE VOCACIONAL CIDADES UVC', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2969, 3267, 'FACULDADE TADEU ARGOLO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2970, 3268, 'FACULDADE MADRE THAIS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2971, 3269, 'FACULDADE DE JUAZEIRO DO NORTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2972, 3270, 'FACULDADE SAO BENTO DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2973, 3271, 'FACULDADE QUASAR', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2974, 3272, 'FACULDADE DE DIREITO DE PETROLINA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2975, 3273, 'FACULDADE DO RECIFE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2976, 3274, 'FACULDADE PSICOLOGIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2977, 3275, 'FACULDADE JURIDICA DE SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2978, 3276, 'FACULDADE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2979, 3277, 'FACULDADE DE TECNOLOGIA PREVE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2980, 3278, 'FACULDADE DE TECNOLOGIA MARTINUS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2981, 3279, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO SUDESTE DE MINAS GERAIS', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2982, 3280, 'FACULDADE SAO JOSE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2983, 3281, 'FACULDADE DO DESENVOLVIMENTO DE FEIRA DE SANTANA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2984, 3282, 'FACULDADE PONTAL DO PARANAPANEMA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2985, 3283, 'INSTITUTO BRASILEIRO DE ZOOTECNOLOGIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2986, 3284, 'ESCOLA SUPERIOR DE ADMINISTRACAO E NEGOCIOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2987, 3285, 'FACULDADE SANTO ANTONIO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2988, 3286, 'FACULDADE DE MARABA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2989, 3287, 'FACULDADE DA ASSEDIPA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2990, 3288, 'FACULDADE GENESIS FAGEN', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2991, 3289, 'FACULDADE DE CIENCIAS ADMINISTRATIVAS E CONTABEIS COSTA BRAGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2992, 3290, 'INSTITUTO SUPERIOR DE EDUCACAO DOS INCONFIDENTES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2993, 3291, 'FACULDADE DUARTE COELHO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2994, 3292, 'INSTITUTO SUPERIOR DE EDUCACAO DE CAETE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2995, 3293, 'FACULDADE DE TECNOLOGIA DIAMANTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2996, 3294, 'FACULDADE DE TECNOLOGIA ENIACFAPI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2997, 3295, 'FACULDADE DE TECNOLOGIA SENAC FLORIANOPOLIS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2998, 3296, 'FACULDADE DE TECNOLOGIA SENAC RIO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (2999, 3297, 'CENTRO DE EDUCACAO TECNOLOGICA CHRISTUS', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3000, 3298, 'FACULDADE DE TECNOLOGIA CAMOES', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3001, 3299, 'FACULDADE DE TECNOLOGIA INFORMATICA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3002, 3300, 'FACULDADE DE TECNOLOGIA MICHEL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3003, 3301, 'FACULDADE DE TECNOLOGIA MAGISTER', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3004, 3302, 'FACULDADE DE JUNQUEIROPOLIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3005, 3303, 'FACULDADES INTEGRADAS MATOGROSSENSES DE CIENCIAS SOCIAIS E HUMANAS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3006, 3304, 'FACULDADES INTEGRADAS DE PATOS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3007, 3305, 'FACULDADE PITAGORAS DE PSICOLOGIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3008, 3306, 'FACULDADE DE TECNOLOGIA IPUC', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3009, 3307, 'FACULDADE INED DE RIO CLARO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3010, 3308, 'FACULDADE DE TECNOLOGIA TERMOMECANICA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3011, 3309, 'FACULDADE DE TECNOLOGIA INTERNACIONAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3012, 3310, 'FACULDADE DE TECNOLOGIA DA AMAZONIA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3013, 3311, 'FACULDADE DE TECNOLOGIA SAO FRANCISCO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3014, 3312, 'CENTRO FEDERAL DE EDUCACAO TECNOLOGICA DE RIO VERDE', 1, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3015, 3313, 'CENTRO FEDERAL DE EDUCACAO TECNOLOGICA DE BAMBUI', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3016, 3314, 'FACULDADE DE CIENCIAS GERENCIAIS DA FUNCEC', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3017, 3315, 'INSTITUTO SUPERIOR DE EDUCACAO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3018, 3316, 'FACULDADE SUDOESTE PAULISTANO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3019, 3317, 'FACULDADE MASTER', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3020, 3318, 'FACULDADE MASTER', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3021, 3319, 'FACULDADE DE ENSINO SUPERIOR DE CATALAO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3022, 3320, 'INSTITUTO DE TELEMARKETING E SERVICO AO CLIENTE LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3023, 3321, 'FACIVALE FACULDADE INTERNACIONAL DO VALE DO IVAI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3024, 3322, 'FACULDADE POLITECNICA DE ATIBAIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3025, 3323, 'INSTITUTO DE EDUCACAO E ENSINO SUPERIOR DE CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3026, 3324, 'FACULDADE TALENTI', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3027, 3325, 'FACULDADE COMUNITARIA DE CONTAGEM', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3028, 3326, 'CENTRO SUPERIOR DE ESTUDOS JURIDICOS CARLOS DRUMMOND DE ANDRADE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3029, 3327, 'UNIPONTE FACULDADE DA MEIA PONTE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3030, 3328, 'CENTRO DE ESTUDOS SUPERIORES EM CIENCIAS DA SAUDE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3031, 3329, 'FACULDADE DE DIREITO DE PARA DE MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3032, 3330, 'INSTITUTO DE LINGUA PORTUGUESA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3033, 3331, 'FAMOL FACULDADE MONTEIRO LOBATO', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3034, 3332, 'FACULDADE DE TECNOLOGIA SENAC RIO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3035, 3333, 'FACULDADE DE TECNOLOGIA TECBRASIL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3036, 3334, 'FACULDADE DE TECNOLOGIA SAO GONCALO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3037, 3335, 'FACULDADE DE CIENCIAS E LETRAS DO NOROESTE DO PARANA FACIP', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3038, 3336, 'UNIVERSIDADE ESTADUAL DO RIO GRANDE DO SUL', 2, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3039, 3337, 'FACULDADE DE TECNOLOGIA DE TERESINA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3040, 3338, 'INSTITUTO SUPERIOR DE EDUCACAO GETULIO VARGAS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3041, 3339, 'FACULDADE DE GETULIO VARGAS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3042, 3340, 'FACULDADE DE PAULISTA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3043, 3341, 'FACULDADES DE ALTO ARAGUAIA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3044, 3342, 'FACULDADE EVANGELICA DE CIENCIA FILOSOFICA E TEOLOGICA DO MARANHAO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3045, 3343, 'FACULDADES DO PARECIS FACCIS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3046, 3344, 'FACULDADE REGIONAL DE IRECE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3047, 3345, 'FACULDADE YVERDON DE GOIANIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3048, 3346, 'FACULDADE YVERDON', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3049, 3347, 'FACULDADE REGIONAL DE RIBEIRA DO POMBAL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3050, 3348, 'FACULDADE REGIONAL DE SERRINHA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3051, 3349, 'FACULDADE REGIONAL METROPOLITANA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3052, 3350, 'FACULDADE REGIONAL DE ALAGOINHAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3053, 3351, 'INSTITUTO SUPERIOR DO NOROESTE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3054, 3352, 'FACULDADE REGIONAL DE SANTO AMARO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3055, 3353, 'FACULDADE RECON BAHIA EMPRESARIAL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3056, 3354, 'FACULDADE REGIONAL DE ILHEUS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3057, 3355, 'FACULDADE REGIONAL DE SAO FELIX', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3058, 3356, 'INSTITUTO TEOLOGICO DE SANTA CATARINA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3059, 3357, 'FACULDADE DO SERTAO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3060, 3358, 'FACULDADE CIENTIFICA DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3061, 3359, 'FESC FACULDADE DO EXTREMO SUL CATARINENSE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3062, 3360, 'INSTITUTO DE EDUCACAO SUPERIOR PRESIDENTE KENNEDY CENTRO DE FORMACAO DE PROFISSIONAIS DE EDUCACAO', 2, 1, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3063, 3361, 'INSTITUTO SUPERIOR DE EDUCACAO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3064, 3362, 'INSTITUTO DE CIENCIAS HUMANAS E SOCIAIS APLICADAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3065, 3363, 'FACULDADE GUARAI', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3066, 3364, 'FACULDADE DE ENFERMAGEM DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3067, 3365, 'FACULDADE SAO FRANCISCO DE JUAZEIRO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3068, 3366, 'FACULDADE DE CIENCIAS GERENCIAIS DE OLIVEIRA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3069, 3367, 'INSTITUTO SUPERIOR DE EDUCACAO DE OLIVEIRA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3070, 3368, 'CENTRO UNIVERSITARIO DO SUL DE MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3071, 3369, 'FACULDADE DE CIENCIAS HUMANAS E SOCIAIS GEREMARIO DANTAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3072, 3370, 'ESCOLA DOMINICANA DE TEOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3073, 3371, 'CENTRO UNIVERSITARIO DE PATOS DE MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3074, 3372, 'CENTRO UNIVERSITARIO DE LAVRAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3075, 3373, 'INSTITUTO SUPERIOR DE EDUCACAO DE FORMIGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3076, 3374, 'FACULDADE PAUL SABATIER DE EDUCACAO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3077, 3375, 'INSTITUTO DE ENSINO SUPERIOR MULTIPLO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3078, 3376, 'FACULDADE DE TEOLOGIA INTEGRADA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3079, 3377, 'FACULDADE MONTESSORIANO DE SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3080, 3378, 'FACULDADE CENECISTA DE RECIFE', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3081, 3379, 'INSTITUTO DE EDUCACAO SUPERIOR SERRANO IESSER', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3082, 3380, 'FACULDADE MISSIONEIRA DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3083, 3381, 'UNITEC FACULDADE TECNOLOGICA E CIENTIFICA DE UNAI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3084, 3382, 'ESCOLA SUPERIOR DE ENFERMAGEM E PEDAGOGIA MARIA PASTOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3085, 3383, 'INSTITUTO SUPERIOR DE EDUCACAO SAGRA ISAGRA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3086, 3384, 'FACULDADE SAGRA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3087, 3385, 'FACULDADE DE DIREITO PROFESSOR PEDRO ALEIXO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3088, 3386, 'FACULDADE DE ADMINISTRACAO DE EMPRESAS UNITECH', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3089, 3387, 'FACULDADE NACIONAL DE JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3090, 3388, 'FACULDADE PARAISO DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3091, 3389, 'FACULDADE RAIZES', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3092, 3390, 'FACULDADE DE DIREITO DO ICESP', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3093, 3391, 'INSTITUTO SUPERIOR DE EDUCACAO NOVA VIDA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3094, 3392, 'FACULDADE DA ACADEMIA BRASILEIRA DE EDUCACAO E CULTURA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3095, 3393, 'FACULDADE DE ENSINO SUPERIOR DOM BOSCO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3096, 3394, 'FACULDADE VALE DO IPIRANGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3097, 3395, 'FACULDADE EDUCIONAL SUL PARANAENSE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3098, 3396, 'FACULDADE LS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3099, 3397, 'FACULDADE BOAS NOVAS DE CIENCIAS TEOLOGICAS, SOCIAIS E BIOTECNOLOGICAS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3100, 3398, 'FACULDADE DE CIENCIAS DO ESTADO DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3101, 3399, 'FACULDADE DE TUBARAO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3102, 3400, 'FACULDADE DE SAUDE DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3103, 3401, 'FACULDADE DE ITAPECERICA DA SERRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3104, 3402, 'FACULDADE ANGLICANA DE NEGOCIOS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3105, 3403, 'INSTITUTO SUPERIOR DE EDUCACAO RUI BARBOSA ISURB', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3106, 3404, 'FACULDADE DE FILOSOFIA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3107, 3405, 'FACULDADE RUI BARBOSA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3108, 3406, 'FACULDADE CANDIDO RONDON', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3109, 3407, 'IESEMA INSTITUTO SUPERIOR DE EDUCACAO DA MATA ALAGOANA', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3110, 3408, 'FACULDADE AMAZONIA DE RORAIMA', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3111, 3409, 'FACULDADE DE CIENCIAS DA SAUDE CRISTO REI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3112, 3410, 'INSTITUTO DE EDUCACAO SUPERIOR FATEV', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3113, 3411, 'FACULDADE ECA DE QUEIROS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3114, 3412, 'FACULDADE DO INTERIOR PAULISTA DE TANABI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3115, 3413, 'ISEMP INSTITUTO SUPERIOR DE EDUCACAO DA MATA PERNAMBUCANA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3116, 3414, 'FACULDADE DO ENTORNO DE BRASILIA FAEB', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3117, 3415, 'FACULDADE DE TECNOLOGIA DE CAXIAS DO SUL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3118, 3416, 'FACULDADE JK DO GAMA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3119, 3417, 'FACULDADE DO CENTRO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3120, 3418, 'FACULDADE VALE DO CARIRI', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3121, 3419, 'FACULDADE CHROMOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3122, 3420, 'INSTITUTO SUPERIOR DE EDUCACAO DE CAMPOS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3123, 3421, 'FACULDADE DE MANDAGUACU', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3124, 3422, 'FACULDADE TEOLOGICA DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3125, 3423, 'FACULDADE DE ADMINISTRACAO DE NOVO PROGRESSO', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3126, 3424, 'FACULDADE DE LAGES', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3127, 3425, 'FACETE FACULDADE DE ARTES CIENCIAS E TECNOLOGIAS DE EUNAPOLIS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3128, 3426, 'ESCOLA SUPERIOR DE CIENCIAS TRADICIONAIS E AMBIENTAIS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3129, 3427, 'FACULDADE JOSE AUGUSTO VIEIRA', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3130, 3428, 'FACULDADE ALFA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3131, 3429, 'FACULDADE RIO DAS CONTAS FAC RIO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3132, 3430, 'FACULDADE UBERLANDENSE DE NUCLEOS INTEGRADOS DE ENSINO, SERVICO SOCIAL E APRENDIZAGEM', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3133, 3431, 'FACULDADE DO SERIDO', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3134, 3432, 'FACULDADES INTEGRADAS DE CIENCIAS HUMANAS, SAUDE E EDUCACAO DE GUARULHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3135, 3433, 'INSTITUTO SUPERIOR DE EDUCACAO INTERLAGOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3136, 3434, 'FACULDADE DE SAUDE IBITURUNA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3137, 3435, 'INSTITUTO SUPERIOR DE EDUCACAO NORTE MINEIRO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3138, 3436, 'FACULDADE DE ARARAQUARA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3139, 3437, 'FACULDADE DO LITORAL CATARINENSE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3140, 3438, 'FACULDADE MASTER DE PALMAS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3141, 3439, 'FACULDADE MASTER DE PARAUAPEBAS', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3142, 3440, 'FACULDADE MASTER DE SANTAREM', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3143, 3441, 'FACULDADE MASTER DE MARABA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3144, 3442, 'INSTITUTO DE ENSINO ALVARES DE AZEVEDO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3145, 3443, 'FACULDADE INEDI', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3146, 3444, 'FACULDADE DE CIENCIAS BIOLOGICAS E SOCIAIS APLICADAS JEFFERSON JORGE SALOMAO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3147, 3445, 'FACULDADE JOAO DO VALE', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3148, 3446, 'INSTITUTO SUPERIOR DE EDUCACAO JOAO DO VALE', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3149, 3447, 'FACULDADES SANTAMARIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3150, 3448, 'INSTITUTO SUPERIOR DE EDUCACAO IBITURUNA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3151, 3449, 'TRECSON FACULDADE DE CIENCIAS SOCIAIS APLICADAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3152, 3450, 'FACULDADES MASTER', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3153, 3451, 'INSTITUTO SUPERIOR DE EDUCACAO DO LITORAL CATARINENSE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3154, 3453, 'FACULDADE JUSCELINO KUBTSCHEK GUARA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3155, 3454, 'FACULDADES LEONEL AGUIAR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3156, 3455, 'FACULDADE DE EDUCACAO EXPOVEST', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3157, 3456, 'FACULDADE POLITECNICA DE CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3158, 3457, 'FESC FACULDADE DO EXTREMO SUL CATARINENSE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3159, 3458, 'ACADEMIA TEOLOGICA DA GRACA DE DEUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3160, 3459, 'INSTITUTO DE ENSINO SUPERIOR E PESQUISA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3161, 3460, 'INSTITUTO SUPERIOR DE ENSINO E PESQUISA DE ITUIUTABA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3162, 3461, 'FACULDADE DE FILOSOFIA DE PASSOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3163, 3462, 'FACULDADE DE ENFERMAGEM DE PASSOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3164, 3463, 'FACULDADE DE DIREITO DE PASSOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3165, 3464, 'FACULDADE DE ENGENHARIA DE PASSOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3166, 3465, 'FACULDADE DE INFORMATICA DE PASSOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3167, 3466, 'FACULDADE DE SERVICO SOCIAL DE PASSOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3168, 3467, 'FACULDADE DE NUTRICAO DA FUNDACAO DE ENSINO SUPERIOR DE PASSOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3169, 3468, 'FACULDADE DE ENGENHARIA DO TRIANGULO MINEIRO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3170, 3469, 'FACULDADE DE ADMINISTRACAO DE PASSOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3171, 3470, 'FACULDADE EDUCACAO FISICA DE PASSOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3172, 3471, 'FACULDADE DE MODA DE PASSOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3173, 3472, 'INSTITUTO SUPERIOR DE EDUCACAO DE PASSOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3174, 3473, 'FACULDADE DE FILOSOFIA, CIENCIAS E LETRAS DE CARANGOLA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3175, 3474, 'FACULDADE DE CIENCIAS EXATAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3176, 3475, 'INSTITUTO SUPERIOR DE EDUCACAO DE CARANGOLA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3177, 3476, 'FACULDADE DE FILOSOFIA E LETRAS DE DIAMANTINA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3178, 3477, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS NOSSA SENHORA DE SION', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3179, 3478, 'FACULDADE DE CIENCIAS EXATAS E HUMANAS DA CAMPANHA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3180, 3479, 'INSTITUTO SUPERIOR DE EDUCACAO NOSSA SENHORA DE SION', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3181, 3480, 'FACULDADE DE CIENCIAS JURIDICAS DE DIAMANTINA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3182, 3481, 'INSTITUTO SUPERIOR DE EDUCACAO DE DIAMANTINA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3183, 3482, 'INSTITUTO SUPERIOR DE EDUCACAO DE DIVINOPOLIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3184, 3483, 'INSTITUTO SUPERIOR DE EDUCACAO DE CLAUDIO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3185, 3484, 'FACULDADE DE CIENCIAS GERENCIAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3186, 3485, 'INSTITUTO SUPERIOR DE EDUCACAO DO ALTO SAO FRANCISCO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3187, 3486, 'INSTITUTO SUPERIOR DE EDUCACAO DE ITUIUTABA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3188, 3487, 'FACULDADE SENACRS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3189, 3488, 'CENTRO DE ENSINO SUPERIOR DE CONSELHEIRO LAFAIETE', 3, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3190, 3489, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DE CONSELHEIRO LAFAIETE', 3, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3191, 3490, 'FACULDADE DE ENGENHARIA ELETRICA DE CONSELHEIRO LAFAIETE', 3, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3192, 3491, 'FACULDADE EVANGELICA DO BRASIL FAEB', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3193, 3492, 'FACULDADE DE DIREITO DO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3194, 3493, 'FACULDADE PROJETO DIDATICO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3195, 3494, 'FACULDADE GUAJARAENSE DE EDUCACAO E CULTURA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3196, 3495, 'FACULDADE PINHALZINHO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3197, 3496, 'INSTITUTO NACIONAL DE DESENVOLVIMENTO HUMANO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3198, 3497, 'FACULDADE BRASILIENSE DE DIREITO FADIR', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3199, 3498, 'FACULDADE DE ARTES TECNOLOGIA E NEGOCIOS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3200, 3499, 'INSTITUTO BOLSA DE VALORES', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3201, 3500, 'FACULDADE DO SERTAO BAIANO FASB', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3202, 3501, 'FACULDADE DE ADMINISTRACAO DE SANTO ANTONIO DO MONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3203, 3502, 'FACULDADE DA FRONTEIRA FAF', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3204, 3503, 'FACUDADE DA CIENCIA DA SAUDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3205, 3504, 'ESCOLA DE ENSINO SUPERIOR DE BRASILANDIA DE MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3206, 3505, 'INSTITUTO SUPERIOR DE EDUCACAO DE JACUTINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3207, 3506, 'FACULDADE DE CIENCIAS EDUCACIONAIS DE SERGIPE', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3208, 3507, 'FACULDADE DE ADMINISTRACAO DE EMPRESAS IBRAFEM', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3209, 3508, 'FACULDADE SANTO ANTONIO DE QUEIMADAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3210, 3509, 'FACULDADE VICENTINA FAVI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3211, 3510, 'UNASP FACULDADE DO SERVIDOR PUBLICO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3212, 3511, 'FACULDADES COMUNITARIA UNIDAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3213, 3512, 'ILES INSTITUTO LOGOS DE EDUCACAO E ENSINO SUPERIOR', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3214, 3513, 'FACULDADE DE PRESIDENTE VENCESLAU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3215, 3514, 'FACULDADE DE CIENCIAS GERENCIAIS ALVES FORTES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3216, 3515, 'FACULDADES INTEGRADAS DA VITORIA DE SANTO ANTAO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3217, 3516, 'FACULDADE DE CIENCIAS DA SAUDE ARCHIMEDES THEODORO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3218, 3517, 'FACULDADE IEGS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3219, 3518, 'FACULDADE JANGADA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3220, 3519, 'FACULDADE DE CIENCAS GERENCIAIS DO ALTO PARAOPEBA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3221, 3520, 'INSTITUTO DE EDUCACAO SUPERIOR SANTA MARIA IESSAM', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3222, 3521, 'FACULDADE EXPOENTE DE EDUCACAO E PESQUISA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3223, 3522, 'FACULDADE CATOLICA DE POUSO ALEGRE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3224, 3523, 'FACULDADE DE DIREITO DA FUNDACAO ESCOLA SUPERIOR DO MINISTERIO PUBLICO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3225, 3524, 'UNIBUSINESS FACULDADE INTERNACIONAL DE EDUCACAO E GERENCIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3226, 3525, 'FACULDADE EVANGELICA DE TECNOLOGIA, CIENCIAS E BIOTECNOLOGIA DA CGADB', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3227, 3526, 'INSTITUTO DE ENSINO SUPERIOR MIGUEL DE CERVANTES', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3228, 3527, 'FACULDADE CATOLICA DOM AQUINO DE CUIABA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3229, 3528, 'FACULDADES CATOLICAS DE FRANCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3230, 3529, 'CENTRO UNIVERSITARIO EURIPEDES DE MARILIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3231, 3530, 'FACULDADE DE NANUQUE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3232, 3531, 'FACULDADE CACHOEIRO DE ITAPEMIRIM', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3233, 3532, 'FACULDADE DO OESTE CATARINENSE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3234, 3533, 'FACULDADE CERES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3235, 3534, 'FACULDADE BRASILEIRA DE ENSINO SUPERIOR E TECNOLOGIA FABEST', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3236, 3535, 'FACULDADE PAULISTA DE CIENCIAS FARMACEUTICAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3237, 3536, 'FACULDADE DE TEOLOGIA EVANGELICA EM CURITIBA FATEV', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3238, 3537, 'INSTITUTO BRASILEIRO DE MODA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3239, 3538, 'FACULDADES INTEGRADAS SEVIGNE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3240, 3539, 'FACULDADE SANTA LUCIA MOGI GUACU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3241, 3540, 'UNIAO DE FACULDADES DE ADMINISTRACAO PUBLICA UNIFAP', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3242, 3541, 'FACULDADE ANGLICANA DE TAPEJARA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3243, 3542, 'INSTITUTO DE ENSINO SUPERIOR DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3244, 3543, 'FACULDADE NOVO HAMBURGO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3245, 3544, 'FACULDADE DE FISIOTERAPIA MACHADO DE ASSIS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3246, 3546, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE BARRA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3247, 3547, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE ITABUNA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3248, 3548, 'FACULDADE SUICA DE HOTELARIA DE JOINVILLE S A', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3249, 3549, 'FACULDADE NACIONAL SENIOR', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3250, 3550, 'FACULDADE SAO FRANCISCO DE CAJAZEIRAS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3251, 3551, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE BARREIRAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3252, 3552, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE TEIXEIRA DE FREITAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3253, 3553, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE VALENCA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3254, 3554, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE JACOBINA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3255, 3555, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE ALAGOINHAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3256, 3556, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3257, 3557, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE IRECE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3258, 3558, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE IPIRA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3259, 3559, 'FACULDADE DE PORANGATU', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3260, 3560, 'FACULDADE DE CIENCIAS DA SAUDE DE CAMPINA GRANDE', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3261, 3561, 'FACULDADE SANTA RITA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3262, 3562, 'FACULDADE DE ODONTOLOGIA RORAIMA', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3263, 3563, 'FACULDADE DE ODONTOLOGIA RIO BRANCO', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3264, 3564, 'FACULDADE MORENENSE DE EDUCACAO FAM', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3265, 3565, 'FACULDADE MORENENSE DE EDUCACAO FAM', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3266, 3566, 'FACULDADE PAULO FREIRE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3267, 3567, 'FMV FACULDADE METROPOLITANA DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3268, 3568, 'FACULDADE DE DESENVOLVIMENTO E INTEGRACAO REGIONAL', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3269, 3569, 'INSTITUTO SUPERIOR DE EDUCACAO DE MANHUACU', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3270, 3570, 'FACULDADE DE CIENCIAS E EDUCACAO DE SAO SIMAO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3271, 3571, 'FACULDADE DOS INCONFIDENTES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3272, 3572, 'FACULDADE DE DIREITO DA ACADEMIA BRASILEIRA DE CIENCIAS JURIDICAS E SOCIAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3273, 3573, 'FACULDADE TEOLOGICA BATISTA DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3274, 3574, 'UNIAO DE FACULDADES DE PARAISO UNIFAP', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3275, 3575, 'FACULDADE ATIVA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3276, 3576, 'FACULDADE DE ENSINO SUPERIOR DO LITORAL SUL FASUL', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3277, 3577, 'FACULDADE DE ALTOS ESTUDOS DA BAHIA FAE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3278, 3578, 'FACULDADE DE CIENCIAS FARMACEUTICAS DO PANTANAL', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3279, 3579, 'INSTITUTO LUTERANO DE EDUCACAO SUPERIOR DO PARECIS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3280, 3580, 'FACULDADE DE EDUCACAO CIENCIAS SOCIAIS E DA SAUDE SESI TO', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3281, 3581, 'FACULDADE DE ENSINO TECNOLOGICO FILADELFIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3282, 3582, 'FACULDADE PORTO CALVO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3283, 3583, 'ESCOLAS SUPERIORES DE ADMINISTRACAO GEOGRAFIA E CURSO NORMAL SUPERIOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3284, 3584, 'INSTITUTO SUPERIOR DE EDUCACAO SANTA CRUZ', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3285, 3585, 'FACULDADE SANTA CRUZ', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3286, 3586, 'FACULDADE OXFORD DO BRASIL', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3287, 3587, 'FACULDADE DIOCESANA SAO JOSE', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3288, 3588, 'FACULDADE DOM PEDRO II', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3289, 3589, 'FACULDADE TEOREMA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3290, 3590, 'FACULDADE DE ENFERMAGEM SAO VICENTE DE PAULA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3291, 3591, 'INSTITUTO SUPERIOR DE EDUCACAO DE MACAPARANA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3292, 3593, 'FACULDADE DE CHAPECO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3293, 3594, 'FACULDADE DE CIENCIA, TECNOLOGIA E EDUCACAO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3294, 3595, 'INSTITUTO SUPERIOR DE EDUCACAO DE SANTA MARIA DA VITORIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3295, 3596, 'FACULDADE AMERICA LATINA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3296, 3597, 'FACULDADE DE ENSINO SUPERIOR DE SANTA CRUZ DO CAPIBARIBE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3297, 3598, 'FACULDADE DE IRATI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3298, 3599, 'FACULDADE DE ITAPEMA FAI', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3300, 3601, 'FACULDADE DE TAPEJARA FATAP', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3301, 3602, 'FACULDADES INTEGRADAS DO BRASIL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3302, 3603, 'FACULDADE ANHANGUERA DE GUARULHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3303, 3604, 'INSTITUTO SUPERIOR DE EDUCACAO DE CARIACICA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3304, 3605, 'FACULDADE DE CIENCIAS COMUNICACOES E TECNOLOGIAS DE PESQUEIRA FACCIP', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3305, 3606, 'INSTITUTO SUPERIOR DE EDUCACAO PRESBITERIANO VALE DO TOCANTINS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3306, 3607, 'ESCOLA SUPERIOR ASSOCIADA DE GOIANIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3307, 3608, 'INSTITUTO SUPERIOR DE EDUCACAO DE LONDRINA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3308, 3609, 'FACULDADES INTEGRADAS IPITANGA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3309, 3610, 'FACULDADES INTEGRADAS PROMOVE DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3310, 3611, 'FACULDADES INTEGRADAS DA UNIAO DE ENSINO SUPERIOR CERTO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3311, 3612, 'FACULDADE ANHANGUERA DE VALINHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3312, 3613, 'FACULDADES INTEGRADAS IESGO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3313, 3614, 'ESCOLA SUPERIOR DE CIENCIAS SOCIAIS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3314, 3615, 'FACULDADE PERNAMBUCANA DE SAUDE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3315, 3616, 'FACULDADES PHD', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3316, 3617, 'FACULDADE DE CIENCIAS HUMANAS E EXATAS DO SERTAO DO SAO FRANCISCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3317, 3618, 'FACULDADE MARIO SCHENBERG', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3318, 3619, 'UNESC UNIAO DAS ESCOLAS SUPERIORES DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3319, 3620, 'ESCOLA INTERNACIONAL DE ADMINISTRACAO E NEGOCIOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3320, 3621, 'INSTITUTO DE ENSINO SUPERIOR DE GARCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3321, 3622, 'INSTITUTO DE ENSINO SUPERIOR DE GARCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3322, 3623, 'FACULDADE DE CIENCIAS DA BAHIA FACIBA NOME ALTERADO POR SOLICITACAO DO MEC', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3323, 3624, 'PUC MINAS ARCOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3324, 3625, 'FACULDADE CATOLICA NOSSA SENHORA DAS VITORIAS', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3325, 3626, 'FACULDADE BRASILEIRA DE EDUCACAO E NEGOCIOS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3326, 3627, 'FACULDADE DE TECNOLOGIA BARAO DO RIO BRANCO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3327, 3628, 'FACULDADADE TEOLOGICA REFORMADA FTR', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3328, 3629, 'FACULDADADE TEOLOGICA REFORMADA FTR', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3329, 3630, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE PAULO AFONSO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3330, 3631, 'FACULDADE DAMAS DA INSTRUCAO CRISTA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3331, 3632, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE ITABERABA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3332, 3633, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE CAMPO FORMOSO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3333, 3634, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE BOM JESUS DA LAPA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3334, 3635, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE SANTA MARIA DA VITORIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3335, 3636, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE SENHOR DO BONFIM', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3336, 3637, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE RIBEIRA DO POMBAL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3337, 3638, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE ILHEUS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3338, 3639, 'FACULDADE DE DIREITO DO INSTITUTO DE ENSINO SUPERIOR DO CIRCUITO DO OURO FDINESO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3339, 3640, 'FACULDADE DE CIENCIAS ECONOMICAS DE JEQUIE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3340, 3641, 'CENTRO UNIVERSITARIO DA FUNDACAO EDUCACIONAL DE BARRETOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3341, 3642, 'FACULDADE INTEGRADA DE PERNAMBUCO SURUBIM FACIPE SURUBIM', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3342, 3643, 'FACULDADE CATOLICA NOSSA SENHORA DAS NEVES', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3343, 3644, 'FACULDADE CATOLICA SANTA TERESINHA', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3344, 3645, 'FACULDADE CATOLICA SANTA TERESINHA CADASTRADA INDEVIDAMENTE', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3345, 3646, 'FACULDADE DE TECNOLOGIA DE OURO FINO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3346, 3647, 'FACULDADE DE TECNOLOGIA MARISTA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3347, 3648, 'FACULDADE ANHANGUERA DE CUIABA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3348, 3649, 'FACULDADE CIDADE VERDE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3349, 3650, 'INSTITUTO SUPERIOR DE EDUCACAO GREGORIANO ISEG', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3350, 3651, 'FACULDADE DAS AGUAS QUENTES FAQ', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3351, 3652, 'FACULDADE PRESBITERIANA SAMUEL GRAHAM', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3352, 3653, 'FACULDADE PRESBITERIANA SAMUEL GRAHAM', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3353, 3654, 'FACULDADE DE CIENCIAS COMUNICACOES E TECNOLOGIAS DE FLORESTA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3354, 3655, 'FACULDADE DE JANAUBA FAJAN', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3355, 3656, 'FACULDADE NOVA TRINDADE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3356, 3657, 'FACULDADE DE COMPUTACAO DE MONTES CLAROS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3357, 3658, 'FACULDADE UIRAPURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3358, 3659, 'FACULDADE DE CIENCIAS COMUNICACAO E TECNOLOGIA DE SALGUEIRO FACTS', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3359, 3660, 'INSTITUTO SUPERIOR DE EDUCACAO DE SALGUEIRO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3360, 3662, 'FACULDADE EVANGELICA LOGOS', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3361, 3663, 'FACULDADE EVANGELICA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3362, 3664, 'INSTITUTO SUPERIOR DE EDUCACAO DE VARGEM GRANDE DO SUL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3363, 3665, 'FACULDADE DE JOACABA FJ', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3364, 3666, 'FACULDADE DE ADMINISTRACAO DA AERONAUTCA', 1, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3365, 3667, 'FACULDADE FILADELFIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3366, 3668, 'FACULDADE DE ENFERMAGEM E ADMINISTRACAO DE JATAI FEAJ', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3367, 3669, 'FACULDADE DOM LUIS DE ORLEANS E BRAGANCA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3368, 3670, 'FACULDADE DE CRICIUMA FACRI', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3369, 3671, 'FACULDADE INTERDISCIPLINAR DE BLUMENAU', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3370, 3672, 'FACULDADE DE CAMPOS NOVOS FACAN', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3371, 3673, 'FACULDADE PREMIER', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3372, 3674, 'INSTITUTO NORMAL SUPERIOR FBV', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3373, 3675, 'SINAL FACULDADE DE TEOLOGIA E FILOSOFIA', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3374, 3676, 'FACULDADE DE TECNOLOGIA DO VALE DO RIBEIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3375, 3677, 'FACULDADE DE TECNOLOGIA DE ALTA PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3376, 3678, 'FACULDADE DE TECNOLOGIA DO VALE DO ITAJAI', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3377, 3679, 'INSTITUTO DE ENSINO SUPERIOR DE GARCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3378, 3680, 'FACULDADE DE TECNOLOGIA DARCY RIBEIRO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3379, 3681, 'FACULDADES DE GARANHUNS', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3380, 3682, 'INSTITUTO SUPERIOR DE EDUCACAO DO MUNICIPIO DE ITAPERUNA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3381, 3683, 'FACULDADE UNILAGOS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3382, 3684, 'FUNDACAO DE ENSINO SUPERIOR DE CLEVELANDIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3383, 3685, 'FACULDADE DA POLI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3384, 3686, 'FADITU FACULDADE DE DIREITO DE ITU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3385, 3687, 'FACULDADES INTEGRADAS DE JACAREI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3386, 3688, 'FACULDADES INTEGRADAS DO VALE DO IVAI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3387, 3689, 'FACULDADE PEDRO JULIAO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3388, 3690, 'FACULDADE PEDRO II', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3389, 3691, 'FACULDADE DE TECNOLOGIA TUPY DE SAO BENTO DO SUL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3390, 3692, 'FACULDADE DE TECNOLOGIA IPEP DE CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3391, 3693, 'FACULDADE DE TECNOLOGIA IPEP DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3392, 3694, 'FACULDADE DE TECNOLOGIA ESTACIO DE SA DE SANTA CATARINA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3393, 3695, 'FACULDADE DE TECNOLOGIA ESTACIO DE SA DE OURINHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3394, 3696, 'FACULDADE DE TECNOLOGIA DE JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3395, 3697, 'FACULDADE DE TECNOLOGIA SAINT PASTOUS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3396, 3698, 'PORTAL FACULDADES', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3397, 3699, 'FACULDADE ECOAR', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3398, 3700, 'FACULDADE DE CIENCIAS JURIDICAS DE PORTO VELHO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3399, 3701, 'FACULDADE DE CIENCIAS GERENCIAIS DE TEOFILO OTONI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3400, 3702, 'FACULDADES ELO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3401, 3703, 'INSTITUTO SUPERIOR DE ADMINISTRACAO E NEGOCIOS DE CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3402, 3704, 'FACULDADE DO ALTO PARNAIBA FAP', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3403, 3705, 'FACULDADE KHALIL LTDA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3404, 3706, 'FACULDADE REGIONAL DE POJUCA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3405, 3707, 'FACULDADE INTEGRADAS DO MORENO FIAM', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3406, 3708, 'FACULDADE INTEGRAL DO RIO GRANDE DO NORTE', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3407, 3709, 'INSTUTO DE ENSINO SUPERIOR SAO LUCAS', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3408, 3710, 'ESCOLA SUPERIOR NACIONAL DE SEGUROS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3409, 3711, 'FACULDADE CENTRAL DE CRISTALINA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3410, 3712, 'FACULDADE VITORIA', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3411, 3713, 'INSTITUTO DE TEOLOGIA E PASTORAL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3412, 3714, 'INSTITUTO TATUIANO DE ENSINO SUPERIOR ITES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3413, 3715, 'FACULDADE METROPOLITANA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3414, 3716, 'FACULDADE CIENCIAS DA VIDA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3415, 3717, 'FACULDADE CULTURAL ANJAGUNA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3416, 3718, 'FACULDADE DE CIENCIAS HUMANAS JULIO GOMES', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3417, 3719, 'FACULDADE DE CORACAO DE JESUS FADECOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3418, 3720, 'FACULDADE PORTO REAL', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3419, 3721, 'FACULDADE OLIVEIRA TELLES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3420, 3722, 'FACULDADE DE CIENCIAS MEDICAS INTEGRADAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3421, 3723, 'FACULDADE NACIONAL POLICURSOS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3422, 3724, 'FACULDADE MARANHENSE SAO JOSE DOS COCAIS', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3423, 3725, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE ITAMARAJU', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3424, 3726, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE JEQUIE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3425, 3727, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE EUCLIDES DA CUNHA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3426, 3728, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE FEIRA DE SANTANA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3427, 3729, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE GUANAMBI', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3428, 3730, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE CAMACARI', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3429, 3731, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE BRUMADO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3430, 3732, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE VITORIA DA CONQUISTA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3431, 3733, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE JUAZEIRO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3432, 3734, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE SERRINHA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3433, 3735, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE EUNAPOLIS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3434, 3736, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE PILAO ARCADO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3435, 3737, 'FACULDADE INTEGRADA DE ADMINISTRACAO PUBLICA DE PORTO SEGURO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3436, 3738, 'FACULDADE DE EDUCACAO CIENCIAS E LETRAS DO NOROESTE DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3437, 3739, 'FACULDADE ASSOCIACAO HOSPITALAR DE ILHA SOLTEIRA FACISA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3438, 3740, 'FACULDADE DE MEDICINA DE BOTUCATU', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3439, 3741, 'FACULDADE DE EDUCACAO DE BACABAL FEBAC', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3440, 3742, 'FACULDADES DE CIENCIAS E TECNOLOGIA DA AMAZONIA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3441, 3743, 'FACULDADE DE TECNOLOGIA SAO FRANCISCO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3442, 3744, 'FACULDADE CETEP', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3443, 3745, 'INSTITUTO SUPERIOR SEJA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3444, 3746, 'FACULDADE PAULISTA DE PESQUISA E ENSINO SUPERIOR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3445, 3747, 'FACULDADE METROPOLITANA DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3446, 3748, 'FACULDADE DE TECNOLOGIA THEREZA PORTO MARQUES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3447, 3749, 'FACULDADE DE TECNOLOGIA BRASILIA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3448, 3750, 'FACULDADE DE TECNOLOGIA DO PARA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3449, 3751, 'FACULDADE DE TECNOLOGIA DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3450, 3752, 'FACULDADE DE TECNOLOGIA CONTEC', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3451, 3753, 'FACULDADES INTEGRADAS DOM PEDRO II', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3452, 3754, 'FACULDADES INTEGRADAS ADVENTISTAS DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3453, 3755, 'FACULDADE EM AUTOCONHECIMENTO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3454, 3756, 'FACULDADE DE ALMENARA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3455, 3757, 'FACULDADE SERRA DA MESA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3456, 3758, 'FACULDADE SOCIESC', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3457, 3759, 'INSTITUTO SUPERIOR TUPY DE SAO BENTO DO SUL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3458, 3760, 'FACULDADE ITABORAI', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3459, 3761, 'FACULDADE MONSENHOR JOSE SINFRONIO', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3460, 3762, 'FACULDADE DE TECNOLOGIA MILENIO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3461, 3763, 'FACULDADE DO INTERIOR PAULISTA DE TANABI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3462, 3764, 'CENTRO DE EDUCACAO SUPERIOR DE POUSO ALEGRE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3463, 3765, 'FACULDADE SANTO AGOSTINHO DE SANTA VITORIA FASAV', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3464, 3766, 'INSTITUTO SUPERIOR DE EDUCACAO SANTO AGOSTINHO DE SANTA VITORIA ISAV', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3465, 3767, 'FACULDADE DE EDUCACAO CIENCIAS E TECNOLOGIA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3466, 3768, 'FACULDADE IBGEN INSTITUTO BRASILEIRO DE GESTAO DE NEGOCIOS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3467, 3769, 'FACULDADE MADRE TEREZA', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3468, 3770, 'FACULDADE TEOLOGICA BATISTA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3469, 3771, 'FACULDADE DE TURISMO E ADMINISTRACAO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3470, 3772, 'FACULDADE DE TECNOLOGIA PASTOR DOHMS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3471, 3773, 'FACULDADE PAULIPOLITANA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3472, 3774, 'FACULDADE SAO TOMAZ DE AQUINO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3473, 3775, 'INSTITUTO UVB.BR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3474, 3776, 'INSTITUTO DE ENSINO SUPERIOR DE MATO GROSSO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3475, 3777, 'FACULDADE CURITIBANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3476, 3778, 'FACULDADE DE ARACAJU', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3477, 3779, 'FACULDADE ESTACIO DE SANTO ANDRE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3478, 3780, 'FACULDADE DE TECNOLOGIA IMPACTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3479, 3781, 'FACULDADE DE TECNOLOGIA DE JARAGUA DO SUL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3480, 3782, 'FACULDADE DE TECNOLOGIA CACHOEIRO DE ITAPEMIRIM', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3481, 3783, 'FACULDADE PARAENSE DE ENSINO', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3482, 3784, 'INSTITUTO DE ENSINO SUPERIOR DO RIO GRANDE DO NORTE', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3483, 3785, 'INSTITUTO MARANHENSE DE ENSINO E CULTURA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3484, 3786, 'FACULDADE DE ENSINO DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3485, 3787, 'FACULDADE DE ENSINO SUPERIOR DA AMAZONIA', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3486, 3788, 'FACULDADE JUIZ DE FORA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3487, 3789, 'FACULDADE EVANGELICA DE GOIANESIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3488, 3790, 'FACULDADE DE TECNOLOGIA ENSITEC', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3489, 3791, 'FACULDADE DE MEDICINA DO VALE DO ACO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3490, 3792, 'FACULDADE DE TECNOLOGIA DO ITAJAIMIRIM', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3491, 3793, 'FACULDADE FRUTAL', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3492, 3794, 'FACULDADE DE TECNOLOGIA DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3493, 3795, 'CENTRO DE EDUCACAO SUPERIOR TECNOLOGICA DA TERRA PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3494, 3796, 'CENTRO DE ENSINO SUPERIOR DO ESTADO DO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3495, 3797, 'FACULDADE GUAIRACA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3496, 3798, 'FACULDADE DE TEOLOGIA DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3497, 3799, 'INSTITUTO SUPERIOR DE EDUCACAO E CIENCIAS DA SAUDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3498, 3800, 'INSTITUTO DE EDUCACAO E CULTURA VALE DO IPANEMA', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3499, 3801, 'CENTRO UNIVERSIT[ARIO ZEN', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3500, 3802, 'CENTRO DE EDUCACAO TECNOLOGICA DO INTERIOR PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3501, 3803, 'FACULDADE JAUENSE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3502, 3804, 'FACULDADE SENAC PORTO ALEGRE FSPOA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3503, 3805, 'FACULDADE DE TECNOLOGIA DA PARAIBA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3504, 3806, 'FACULDADE DE TECNOLOGIA DE RORAIMA', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3505, 3807, 'FACULDADE DE TECNOLOGIA IAPEC', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3506, 3808, 'FACULDADE DE ENSINO FACTUAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3507, 3809, 'INSTITUTO SUPERIOR DE EDUCACAO TEOLOGICA DO AMAZONAS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3509, 3811, 'CENTRO DE ESTUDOS EM NEGOCIOS INTERNACIONAIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3510, 3812, 'FACULDADES PARA O DESENVOLVIMENTO SUSTENTAVEL DO SUL DA BAHIA FADESB', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3511, 3813, 'FATECE FACULDADES DE TECNOLOGIA CIENCIAS E EDUCACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3512, 3814, 'FACULDADE PLANALTO DO BRASIL FPB', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3513, 3815, 'FACULDADE DE DIREITO DE ALTA FLORESTA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3514, 3816, 'FACULDADE SANTA MARIA GORETTI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3515, 3817, 'FACULDADE MAURICIO DE NASSAU DE JOAO PESSOA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3516, 3818, 'FACULDADES EQUIPE LTDA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3517, 3819, 'FACULDADE DE ADMINISTRACAO DE EMPRESAS E GESTAO PUBLICA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3518, 3820, 'FACULDADE PETRONIO PORTELA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3519, 3821, 'FACULDADE SAO BOAVENTURA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3520, 3822, 'INSTITUTO DE EDUCACAO SUPERIOR DE POUSO ALEGRE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3521, 3823, 'INSTITUTO DE EDUCACAO SUPERIOR DE POUSO ALEGRE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3522, 3824, 'FACULDADE JOSE CANDIDO DE MELO CARVALHO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3523, 3825, 'FACULDADE CATOLICA RIO PRETENSE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3524, 3826, 'FACULDADE VASCO DA GAMA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3525, 3827, 'ESCOLA SUPERIOR DE CIENCIAS COMERCIAIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3526, 3828, 'INSTITUTO SUPERIOR DE EDUCACAO DE TUPA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3527, 3829, 'CENTRO DE EDUCACAO SUPERIOR TECNOLOGICA DA TERRA PAULISTA CETERRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3528, 3830, 'INSTITUTO CENTRO DE ENSINO TECNOLOGICO SOBRAL', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3529, 3831, 'FACULDADE DE CIENCIAS CONTABEIS', 3, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3530, 3832, 'FACULDADE DE ZOOTECNIA', 3, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3531, 3833, 'FACULDADE DE ENGENHARIA FLORESTAL', 3, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3532, 3834, 'FACULDADE SANTA LUCIA PIRACICABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3533, 3835, 'UNIVERSIDADE VIRTUAL DO ESTADO DO MARANHAO', 2, 1, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3534, 3836, 'UNIVERSIDADE PAULISTA UNIP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3535, 3837, 'FACULDADE DE TECNOLOGIA MODULO PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3536, 3838, 'FACULDADE DE TECNOLOGIA DO UNIUOL', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3537, 3839, 'FACULDADE DE TECNOLOGIA NOVO RUMO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3538, 3840, 'CENTRO UNIVERSITARIO FACVEST', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3539, 3841, 'FACULDADE PITAGORAS DE ADMINISTRACAO SUPERIOR DE CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3540, 3842, 'FACULDADE METROPOLITANA DE VITORIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3541, 3843, 'FACULDADE CANDIDO MENDES DE ARARUAMA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3542, 3844, 'ESCOLA SUPERIOR DE CASTANHAL', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3543, 3845, 'FACULDADE TAQUARITUBA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3544, 3846, 'FACULDADE DE CIENCIAS E CULTURA DA LIBERDADE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3545, 3847, 'FACULDADE BAIANA DE DIREITO E GESTAO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3546, 3848, 'FACULDADE GABRIELA GONCALVES', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3547, 3849, 'FUNDACAO UNIVERSIDADE FEDERAL DO TOCANTINS', 1, 1, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3548, 3850, 'FACULDADE CONTEMPORANEA UNC SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3549, 3851, 'FACULDADE DO RECONCAVO UNR CRUZ DAS ALMAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3550, 3852, 'FACULDADE DO RECONCAVO UNR CONCEICAO DO ALMEIDA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3551, 3853, 'FACULDADE MAURICIO DE NASSAU DE NATAL', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3552, 3854, 'FACULDADE DAS AGUAS EMENDADAS FAE', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3553, 3855, 'FACULDADES INTERNACIONAIS SAN MARTIN DO BRASIL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3554, 3856, 'FACULDADE DE SANTO ANASTACIO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3555, 3857, 'FACULDADE GAUDIUM', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3556, 3858, 'FACULDADE TOBIAS BARRETO DE MENEZES FATOB', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3557, 3859, 'INSTITUTO SUPERIOR DE EDUCACAO TECNOLOGICA DO NORTE FLUMINENSE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3558, 3860, 'FACULDADE TRIUNFO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3559, 3861, 'FACULDADE DE TECNOLOGIA E NEGOCIOS CONTEMPORANEO FATEC', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3560, 3862, 'FACULDADE LUCIANO FEIJAO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3561, 3863, 'FACULDADE COOPERATIVA DE GOIANIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3562, 3864, 'FACULDADE REGIONAL DE ALAGOINHAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3563, 3865, 'FACULDADES INTEGRADAS PADRE HUMBERTO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3564, 3866, 'FACULDADE BRASILEIRA DE EDUCACAO E CULTURA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3565, 3867, 'FACULDADE MAUA DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3566, 3868, 'INSTITUTO DE EDUCACAO SUPERIOR DO ALTO PARANAIBA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3567, 3869, 'INSTITUTO FLORENCE DE ENSINO SUPERIOR', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3568, 3870, 'INSTITUTO DE ESTUDOS DE NEGOCIOS INTERNACIONAIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3569, 3871, 'ESCOLA DE ADMINISTRACAO FAZENDARIA', 1, 1, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3570, 3872, 'FACULDADE DE TECNOLOGIA SAO CARLOS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3571, 3873, 'FACULDADE DE TECNOLOGIA DE BRUMADO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3572, 3874, 'FACULDADE PROJECAO DE PLANALTINA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3573, 3875, 'CENTRO UNIVERSITARIO DA FUNDACAO EDUCACIONAL GUAXUPE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3574, 3876, 'AVM   FACULDADE INTEGRADA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3575, 3877, 'FACULDADE BRASIL CENTRAL', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3576, 3878, 'FACULDADE DECISION DE NEGOCIOS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3577, 3879, 'FACULDADE MAURICIO DE NASSAU DE CAMPINA GRANDE', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3578, 3880, 'INSTITUTO SOCIAL DE EDUCACAO', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3579, 3881, 'FACULDADE DE INTEGRACAO DO SERTAO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3580, 3882, 'INSTITUTO DE ENSINO SUPERIOR DE FORMACAO PROFISSIONAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3581, 3883, 'FACULDADE EVANGELICA LOGOS FAEL', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3582, 3884, 'CESB CENTRO DE EDUCACAO SUPERIOR DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3583, 3885, 'FACULDADES INTEGRADAS DA TERRA PAULISTA FATERRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3584, 3886, 'FACULDADE AGUA BOA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3585, 3887, 'FACULDADE DE CIENCIAS JURIDICAS E GERENCIAIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3586, 3888, 'ESCOLA SUPERIOR DE ADMINISTRACAO E NEGOCIOS DE CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3587, 3889, 'FACULDADE DE IGARAPAVA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3588, 3890, 'FACULDADE MARQUES GUIMARAES', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3589, 3891, 'SOCIEDADE EDUCACIONAL ALBERTI TOLENTINO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3590, 3892, 'FACULDADE DE CIENCIAS SOCIAIS J G MELO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3591, 3894, 'UNIESP UNIAO DAS INSTITUICOES EDUCACIONAIS DO ESTADO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3592, 3895, 'INSTITUTO DE EDUCACAO SUPERIOR ALBERTI TOLENTINO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3593, 3896, 'FACULDADE MUNDIAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3594, 3897, 'FACULDADE BUSCA VIDA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3595, 3898, 'SLCSA FACULDADE SANTA INES', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3596, 3899, 'FACULDADE DE RIBEIRAO DAS NEVES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3597, 3901, 'FACULDADES PROEDUC', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3598, 3902, 'FUNDACAO ESCOLA DO MINISTERIO PUBLICO DO ESTADO DO PARANA FEMPAR', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3599, 3903, 'INFAMILIA INSTITUTO BRASILEIRO DE SAUDE DA FAMILIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3600, 3904, 'FACULDADE DE CIENCIAS GERENCIAIS DE CATAGUASES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3601, 3905, 'FACULDADE DE DIREITO DOCTUM DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3602, 3906, 'FACULDADE DE CIENCIAS AGRARIAS E DA TERRA DE TEOFILO OTONI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3603, 3907, 'FACULDADE DE SAPIRANGA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3604, 3908, 'FACOM FACULDADE COMUNITARIA DO BRASIL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3605, 3909, 'ISTITUTO DE ENSINO SUPERIOR PARAENSE', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3606, 3910, 'INSTITUTO SUPERIOR DE EDUCACAO DE CATAGUASES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3607, 3911, 'FACULDADE DE TECNOLOGIA OXFORD DO BRASIL', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3608, 3912, 'FACULDADE SUDOESTE PAULISTA BOTUCATU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3609, 3913, 'FACULDADE SUDOESTE PAULISTA TAQUARITUBA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3610, 3914, 'INSTITUTO SUPERIOR DE EDUCACAO DO VALE DO CAPIBARIBE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3611, 3915, 'INSTITUTO SUPERIOR DE EDUCACAO CARLOS JOEL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3612, 3916, 'FACULDADE DE CIENCIAS JURIDICAS E SOCIAIS DO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3613, 3917, 'FACULDADE DE MERCADO AMPLO FAMA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3614, 3918, 'FACULDADE INTEGRADA EM CIENCIAS HUMANAS', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3615, 3919, 'FACULDADE NOSSA SENHORA DO BOM CONSELHO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3616, 3920, 'FACULDADE DE TECNOLOGIA SENAI ROBERTO MANGE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3617, 3921, 'FACULDADE ARNALDO HORACIO FERREIRA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3618, 3922, 'FACULDADE ARNALDO HORACIO FERREIRA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3619, 3923, 'FACULDADE SAO FRANCISCO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3620, 3924, 'FACULDADE DE IBIRACU', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3621, 3925, 'FACULDADE DE TEOLOGIA DO BRASIL FATEB', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3622, 3926, 'FACULDADE DE FILOSOFIA CIENCIAS E LETRAS DO ALTO SAO FRANCISCO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3623, 3927, 'FACULDADE DE CACERES', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3624, 3928, 'FAESB FACULDADE DE ENSINO SUPERIOR DO BRASIL', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3625, 3929, 'FACULDADES UNIDAS DE SETE LAGOAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3626, 3930, 'INSTITUTO DE EDUCACAO SUPERIOR RAIMUNDO SA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3627, 3931, 'FACULDADE PRESBITERIANA ARMSTRONG', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3628, 3932, 'FACULDADE DE EDUCACAO E TECNOLOGIA DE ITANHEM', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3629, 3933, 'FACULDADE METODO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3630, 3934, 'FACULDADE DA SAUDE', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3631, 3935, 'FACULDADE DE EDUCACAO TEOLOGICA DO DISTRITO FEDERAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3632, 3936, 'FACULDADE ANHANGUERA DE LIMEIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3633, 3937, 'FACULDADE ANHANGUERA DE INDAIATUBA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3634, 3938, 'FACULDADE DO NORTE DO MATO GROSSO DO SUL FANOR', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3635, 3939, 'FACULDADE ALIANCA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3636, 3940, 'FACULDADE DE ENSINO SUPERIOR SANTA BARBARA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3637, 3941, 'FACULDADE COMUNITARIA DE SANTA BARBARA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3638, 3942, 'FACULDADE COMUNITARIA DE BAURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3639, 3943, 'FASC TB FACULDADES ASSOCIADAS DE SC DE TUBARAO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3640, 3944, 'FACULDADE DE CIENCIAS DA SAUDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3641, 3945, 'INSTITUTO DE EDUCACAO EXECUTIVA CATHO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3642, 3946, 'FACULDADE DE TECNOLOGIA SENAC TUBARAO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3643, 3947, 'FACULDADE DE TECNOLOGIA SENAC CHAPECO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3644, 3948, 'FACULDADE DE TECNOLOGIA SENAC BLUMENAU', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3645, 3949, 'CENTRO DE EDUCACAO SUPERIOR TECNOLOGICA DA TERRA PAULISTA CETERRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3646, 3950, 'CENTRO DE CIENCIAS ETECNOLOGIA DETERESINA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3647, 3951, 'FACULDADE DE TECNOLOGIA LUIZ ADELAR SCHEUER', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3648, 3952, 'FACULDADE VILAVELHENSE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3649, 3953, 'FACULDADE DE ODONTOLOGIA', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3650, 3954, 'FACULDADE DE CIENCIAS JURIDICAS E GERENCIAIS DE OLIVEIRA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3651, 3955, 'FACULDADES INTEGRADAS DE CATAGUASES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3652, 3956, 'ASSOCIACAO EDUCACIONAL CENTRAL DE CRISTALINA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3653, 3957, 'INSTITUTO SUPERIOR DE EDUCACAO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3654, 3958, 'FACULDADE TECNOLOGICA DE MARILIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3655, 3959, 'FACULDADE TECNOLOGICA AMERICA DO SUL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3656, 3960, 'FACULDADE TECNOLOGICA DE BIRIGUI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3657, 3961, 'FACULDADE DE TECNOLOGIA SANTA RITA DE CASSIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3658, 3962, 'FACULDADE DE TECNOLOGIA SENAI CIMATEC', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3659, 3963, 'INSTITUTO SUPERIOR DE EDUCACAO CARLOS CHAGAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3660, 3964, 'FACULDADE DE TECNOLOGIA PADRE ANCHIETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3661, 3965, 'FACULDADE DE TECNOLOGIA ENG. MARCELO SILVA GUIMARAES', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3662, 3966, 'CENTRO UNIVERSITARIO DE CARATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3663, 3967, 'INSTITUTO SUPERIOR DE EDUCACAO DE RORAIMA', 2, 1, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3664, 3968, 'INSTITUTO SUPERIOR DE EDUCACAO DE RORAINOPOLIS', 2, 1, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3665, 3969, 'INSTITUTO SUPERIOR DE SEGURANCA E CIDADANIA DE RORAIMA', 2, 1, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3666, 3970, 'INSTITUTO SUPERIOR DE EDUCACAO DE PARAISOPOLIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3667, 3971, 'INSTITUTO DE ENSINO SUPERIOR DE PORTO NACIONAL', 3, 1, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3668, 3972, 'CENTRO SUPERIOR DE ENSINO E PESQUISA DE MACHADO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3669, 3973, 'FACULDADE DE TECNOLOGIA BANDEIRANTES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3670, 3974, 'UNIVERSIDADE DE RIO VERDE', 3, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3671, 3975, 'FACULDADE SAO FRANCISCO DE PIUMHI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3672, 3976, 'INSTITUTO SUPERIOR DE CIENCIAS HUMANAS E SOCIAIS APLICADAS DE ABAETE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3673, 3977, 'FACULDADE DE TECNOLOGIA DO AMAPA', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3674, 3978, 'FACULDADE DE TECNOLOGIA PENTAGONO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3675, 3979, 'FACULDADE DE BAURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3676, 3980, 'FACULDADE JK BRASILIA UNIDADE PLANO PILOTO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3677, 3981, 'FACULDADE DE TECNOLOGIA INTEGRAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3678, 3982, 'FACULDADE DE TECNOLOGIA FAMEG FAMETEC', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3679, 3983, 'CENTRO UNIVERSITARIO DE FORMIGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3680, 3984, 'FUNDACAO UNIVERSIDADE FEDERAL DO VALE DO SAO FRANCISCO', 1, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3681, 3985, 'CENTRO UNIVERSITARIO SENAC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3682, 3986, 'INSTITUTO SUPERIOR DE EDUCACAO DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3683, 3987, 'FACULDADE UNIAO DE GOYAZES', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3684, 3988, 'FACULDADE UNIAO DE GOYAZES', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3685, 3989, 'FACULDADE DE TECNOLOGIA DE JOAO PESSOA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3686, 3990, 'FACULDADE DE TECNOLOGIA ANCHIETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3687, 3991, 'FACULDADE DE TECNOLOGIA SAO MATEUS', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3688, 3992, 'FACULDADE JK ASA NORTE', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3689, 3993, 'FACULDADE DE TECNOLOGIA CETEP', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3690, 3994, 'FACULDADE DE TECNOLOGIA LATINO AMERICANO DE ANAPOLIS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3691, 3995, 'FACULDADE EVANGELICA CRISTO REI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3692, 3996, 'FACULDADE SENAC PERNAMBUCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3693, 3997, 'FACULDADES DE JI PARANA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3694, 3998, 'INSTITUTO INFNET RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3695, 3999, 'CENTRO DE ENSINO SUPERIOR TECNOLOGICO DO INTERIOR PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3696, 4000, 'FACULDADE DE ENSINO SUPERIOR DO INTERIOR PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3697, 4001, 'FACULDADE DE ENSINO SUPERIOR DE UBERLANDIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3698, 4002, 'INSTITUTO DE ENSINO SUPERIOR DA PARAIBA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3699, 4003, 'FACULDADE CENTRO OESTE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3700, 4004, 'FACULDADE CENECISTA DE ITUBERA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3701, 4005, 'FACULDADE CENECISTA DE SENHOR DO BONFIM', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3702, 4006, 'FACULDADE DE TECNOLOGIA SENAC PELOTAS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3703, 4007, 'FATECE FACULDADE DE TECNOLOGIA, CIENCIAS E EDUCACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3704, 4008, 'FACULDADE DE TECNOLOGIA SENAC PASSO FUNDO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3705, 4009, 'FACULDADE DE TECNOLOGIA ESTACIO DE CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3706, 4010, 'CENTRO UNIVERSITARIO METODISTA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3707, 4011, 'UNI DORINHA FACULDADE DE CIENCIAS E TECNOLOGIA DE DORINHA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3708, 4012, 'UNI METROPOLITANA; FACULDADES DE CIENCIAS HUMANAS E DE BIOTECNOLOGIA DA SAUDE', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3709, 4013, 'FACULDADE ANHANGUERA DE RIO CLARO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3710, 4014, 'FACULDADE ASSOCIADA PAULISTA FAP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3711, 4015, 'FACULDADE DE TECNOLOGIA IBTA RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3712, 4016, 'INSTITUTO NACIONAL DE EDUCACAO DE SURDOS', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3713, 4017, 'CENTRO UNIVERSITARIO PADRE ANCHIETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3714, 4018, 'FACULDADE GAT DE GESTAO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3715, 4019, 'CENTRO DE EDUCACAO TECNOLOGIA RUI BARBOSA CETERB', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3716, 4020, 'FACULDADE DE TECNOLOGIA DE BOTUCATU', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3717, 4021, 'FACULDADE DE TECNOLOGIA DE GARCA', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3718, 4022, 'FACULDADE DE TECNOLOGIA DE JUNDIAI', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3719, 4023, 'FACULDADE DE TECNOLOGIA DE MAUA', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3720, 4024, 'FACULDADE DE TECNOLOGIA DE MOCOCA', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3721, 4025, 'FACULDADE DE TECNOLOGIA DE SAO JOSE DO RIO PRETO', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3722, 4026, 'FACULDADE DE TECNOLOGIA ZONA LESTE', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3723, 4027, 'INSTITUTO SUPERIOR DE ENSINO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3724, 4028, 'FACULDADE DE ITAPECERICA DA SERRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3725, 4029, 'FACULDADE POLITEC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3726, 4030, 'CENTRO UNIVERSITARIO FLUMINENSE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3727, 4031, 'INSTITUTO DE ENSINO SUPERIOR PROFESSORA ALMEIDA CESPMA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3728, 4032, 'FACULDADE DE CIENCIAS E TECNOLOGIA DE PAULISTA FACIT', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3729, 4033, 'FACULDADE DE TECNOLOGIA FABRAI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3730, 4034, 'ASSOCIACAO EDUCACIONAL', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3731, 4035, 'FACULDADE MAUA FAMA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3732, 4036, 'FACULDADE DE TECNOLOGIA DE CATALAO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3733, 4037, 'FACULDADE DE TECNOLOGIA INTENSIVA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3734, 4038, 'FACULDADE DE TECNOLOGIA CONSULTIME', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3735, 4039, 'FACULDADE UNILIVRE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3736, 4040, 'ESCOLA AGROTECNICA FEDERAL DE UBERLANDIA', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3737, 4041, 'FACULDADE DE IRARA FAIR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3738, 4042, 'FACULDADE DO MEIO AMBIENTE E DE TECNOLOGIA DE NEGOCIOS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3739, 4043, 'FACULDADE TECNOLOGIA EDUVALE AVARE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3740, 4044, 'FACULDADE TECNOLOGIA EXPERT', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3741, 4045, 'FACULDADE DE TECNOLOGIA TUPY CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3742, 4046, 'ESCOLA FIEMG DE LIDERES EMPRESARIAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3743, 4047, 'FACULDADE TECNOLOGIA IBTA BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3744, 4048, 'FCC FACULDADE CATOLICA DO CARIRI', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3745, 4049, 'FACULDADE TEOLOGICA DA ASSEMBLEIA DE DEUS EM CURITIBA FATADC', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3746, 4050, 'FAESP FACULDADE DE ENSINO SUPERIOR E PROFISSIONALIZANTE', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3747, 4051, 'FACULDADE SILVIO ROMERO', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3748, 4052, 'INSTITUTO BONDESPACHENSE PRESIDENTE ANTONIO CARLOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3749, 4053, 'CENTRO DE EDUCACAO SUPERIOR BARNABITA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3750, 4054, 'INSTITUTO UNIFICADO DE ENSINO SUPERIOR OBJETIVO IUESO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3751, 4055, 'INSTITUTO BIBLICO DAS ASSEMBLEIAS DE DEUS DO ESTADO DO PARANA IBADEP', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3752, 4057, 'FACISA FACULDADE DE CIENCIA DA SAUDE', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3753, 4058, 'FACULDADE IPE', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3754, 4059, 'FACULDADE DE CIENCIAS GERENCIAIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3755, 4060, 'CENTRO DE EDUCACAO TECNOLOGICA CENECISTA DE RIO NEGRINHO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3756, 4061, 'FACULDADE DE TECNOLOGIA DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3757, 4062, 'FACULDADE ATHENIENSSE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3758, 4064, 'FACULDADE DE TECNOLOGIA FAMA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3759, 4065, 'FACULDADE DE TECNOLOGIA DO INSTITUTO BANDEIRANTE DE EDUCACAO E CULTURA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3760, 4066, 'FACULDADE BATISTA DO ESTADO DO RIO DE JANEIRO FABERJ', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3761, 4067, 'FACIT FACULDADE INDEPENDENTE DE ITAPETINGA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3762, 4068, 'FACULDADE ICESP', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3763, 4069, 'FACULDADE HORIZONTES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3764, 4070, 'ESCOLA AGROTECNICA FEDERAL DE SALINAS', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3765, 4071, 'ESCOLA AGROTECNICA FEDERAL DE INCONFIDENTES', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3766, 4072, 'ESCOLA AGROTECNICA FEDERAL DE IGUATU', 1, 1, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3767, 4073, 'FACULDADE DE TECNOLOGIA IPIRANGA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3768, 4074, 'FACULDADE DELTA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3769, 4076, 'FACULDADE DE TECNOLOGIA PREVE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3770, 4077, 'FACULDADE DE TECNOLOGIA DE GRAVATAI', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3771, 4078, 'FACULDADE METROPOLITANA DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3772, 4079, 'FACULDADE TECNOLOGICA INAP', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3773, 4080, 'FACULDADE DE PRUDENTOPOLIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3774, 4081, 'FATEG FACULDADE DE TECNOLOGIA GALVAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3775, 4082, 'IBEC INSTITUTO BRASILEIRO DE EDUCACAO SUPERIOR CONTINUADA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3776, 4083, 'MATEC CENTRO DE ENSINO TECNOLOGICO DO MARANHAO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3777, 4084, 'INSTITUTO DE ENSINO SUPERIOR DOS MILITARES', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3778, 4085, 'FACULDADE ANCHIETA DE EDUCACAO A DISTANCIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3779, 4086, 'FACULDADE DE TECNOLOGIA JARDIM', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3780, 4087, 'FACULDADE DE EDUCACAO TECNOLOGICA FET DA CDL DE SOBRAL', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3781, 4088, 'FACULDADE DE TECNOLOGIA DO INSTITUTO EDUCACIONAL PROFISSIONALIZANTE DE JALES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3782, 4089, 'FACULDADE DE SIDROLANDIA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3783, 4090, 'FACULDADE DE ROSEIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3784, 4091, 'FACULDADE DE TECNOLOGIA AD1', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3785, 4092, 'FACULDADE DE TECNOLOGIA PEDRO ROGERIO GARCIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3786, 4093, 'FACULDADE DE TECNOLOGIA DE CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3787, 4094, 'FACULDADE ESTACIO DA PARAIBA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3788, 4095, 'FACULDADE DE TECNOLOGIA EQUIPE DARWIN', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3789, 4096, 'FACULDADE DE TECNOLOGIA TECBRASIL UNIDADE PORTO ALEGRE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3790, 4097, 'FACULDADE DE TECNOLOGIA TECBRASIL UNIDADE BENTO GONCALVES', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3791, 4098, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA FARROUPILHA', 1, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3792, 4099, 'ESCOLA AGROTECNICA FEDERAL DE BARBACENA', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3793, 4100, 'FACULDADE DE TECNOLOGIA SENAI ITALO BOLOGNA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3794, 4101, 'FACULDADE DE TECNOLOGIA SENAI DE DESENVOLVIMENTO GERENCIAL', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3795, 4102, 'FACULDADE DE TECNOLOGIA IBRATEC DE MACEIO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3796, 4103, 'FACULDADE METROPOLITANA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3797, 4104, 'ESCOLA SUPERIOR DE ENGENHARIA E GESTAO DE SAO PAULO ESEG', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3798, 4105, 'FACULDADES COSTA BRAGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3799, 4106, 'FAQ FACULDADE QUINZE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3800, 4107, 'FACULDADE DE TECNOLOGIA SENAI PORTO ALEGRE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3801, 4108, 'INSTITUTO CATOLICO DE ESTUDOS SUPERIORES DO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3802, 4109, 'FACULDADE DE SAUDE E MEDICINA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3803, 4110, 'FACULDADE DE CIENCIAS GERENCIAIS DE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3804, 4111, 'ESCOLA SUPERIOR DE ADMINISTRACAO MARKETING E COMUNICACAO DE FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3805, 4112, 'FACULDADE TECNOLOGICA FILADELFIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3806, 4113, 'FACULDADE DE CERES', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3807, 4114, 'FACULDADE TEOLOGICA CRISTA DO BRASIL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3808, 4116, 'FACULDADE MAURICIO DE NASSAU JABOATAO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3809, 4117, 'FACULDADE MAURICIO DE NASSAU MACEIO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3810, 4118, 'FACULDADE JOAQUIM NABUCO PAULISTA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3811, 4119, 'FACULDADE MAURICIO DE NASSAU GARANHUNS', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3812, 4120, 'FACULDADE MAURICIO DE NASSAU CARUARU', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3813, 4121, 'FACULDADE TOBIAS BARRETO', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3814, 4122, 'CENTRO DE EDUCACAO TECNOCNOLOGICA RUI BARBOSA CETRB', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3815, 4123, 'FACULDADE JATAIENSE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3816, 4124, 'FACULDADE DOM HEITOR SALES', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3817, 4125, 'FACULDADE BATISTA IDA NELSON', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3818, 4126, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS E DE TECNOLOGIAS DE AGUA BOA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3819, 4127, 'ISEF INSTITUTO SUPERIOR DE EDUCACAO CENECISTA DE FARROUPILHA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3820, 4128, 'INSTITUTO DE EDUCACAO SUPERIOR DO PIAUI IESPI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3821, 4129, 'FACULDADE JOSE DE ANCHIETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3822, 4130, 'FACULDADE DE TECNOLOGIA DE CIENCIAS HOLISTICAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3823, 4131, 'FACULDADE DO DELTA DO PARNAIBA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3824, 4132, 'FACULDADE DE COLORADO FAC', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3825, 4133, 'FACULDADE DE EDUCACAO TECNOLOGICA SANTA GEMA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3826, 4134, 'INEJ INSTITUTO NACIONAL DE ESTUDOS JURIDICOS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3827, 4135, 'FACULDADE MAURICIO DE NASSAU MANAUS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3828, 4136, 'FACULDADE CANDIDO RONDON DE RONDONOPOLIS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3829, 4137, 'INSTITUTO EVANGELICO SUPERIOR DE EDUCACAO CRISTO REI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3830, 4138, 'FACULDADE ANHANGUERA DE SANTA BARBARA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3831, 4139, 'FACULDADE COMUNITARIA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3832, 4140, 'FACULDADE COMUNITARIA DE SAO JOSE DOS CAMPOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3833, 4141, 'FACULDADE ANHANGUERA DE TAUBATE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3834, 4142, 'FACULDADE UNIAO DE EDUCADORES E ESTUDANTES DO ENSINO SUPERIOR DE BRASILIA UNESB', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3835, 4143, 'FACULDADE EVANGELICA SHALOM', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3836, 4144, 'FACULDADE INTEGRADA GAMALIEL', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3837, 4145, 'CENTRO NACIONAL DE EDUCACAO A DISTANCIA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3838, 4146, 'FACULDADE DE CIENCIAS JURIDICAS DE ALAGOAS', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3839, 4147, 'FACULDADE TEOLOGICA DE UBERLANDIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3840, 4148, 'FACULDADE DE TECNOLOGIA SENAI SAO JOSE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3841, 4149, 'FACULDADE DE TECNOLOGIA SENAI ITAJAI', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3842, 4150, 'FACULDADE DE TECNOLOGIA DE PIRACICABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3843, 4151, 'FACULDADE BOAVENTURA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3844, 4152, 'FACULDADE MAURICIO DE NASSAU JOAO PESSOA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3845, 4153, 'FACULDADE JOAQUIM NABUCO RECIFE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3846, 4154, 'FACULDADE MAURICIO DE NASSAU CAMPINA GRANDE', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3847, 4155, 'FACULDADE JOAQUIM NABUCO CAMARAGIBE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3848, 4156, 'FACULDADE TECNOLOGICA DE SOORETAMA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3849, 4157, 'FACULDADE METROPOLITANA DE RIO DO SUL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3850, 4158, 'FACULDADE EVANGELICA DO MEARIM', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3851, 4159, 'FACULDADE PIRATININGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3852, 4160, 'FACULDADE DE TECNOLOGIA DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3853, 4161, 'INSTITUTO DE ENSINO SUPERIOR CAETANO VELOSO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3854, 4162, 'FACULDADE DE TECNOLOGIA SENAC GOIAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3855, 4163, 'CENTRO UNIVERSITARIO BARRIGA VERDE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3856, 4164, 'FACULDADE EXODUS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3857, 4165, 'FACULDADE POTENCIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3859, 4167, 'INSTITUTO DE ENSINO SUPERIOR DA FUPESP', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3860, 4168, 'INSTITUTO DE ENSINO SUPERIOR DO TOCANTINS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3861, 4169, 'FACULDADE NOSSA CIDADE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3862, 4170, 'FACULDADE INTEGRADA SAO PEDRO', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3863, 4171, 'ISAG INSTITUTO SUPERIOR DE ADMINISTRACAO E GESTAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3864, 4172, 'CENTRO DE ENSINO SUPERIOR DO SERVIDOR PUBLICO MARANHENSE CESPMA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3865, 4173, 'FACULDADE JK DE TECNOLOGIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3866, 4174, 'FACULDADE DE ADMINISTRACAO DE EMPRESAS DE ENERGIA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3867, 4175, 'INSTITUTO UNIFICADO EUROPEU DO BRASIL IUNEBRASIL', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3868, 4176, 'FACULDADE DE MARILIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3869, 4177, 'FACULDADE DE TECNOLOGIA DE SANTA MARIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3870, 4178, 'FACULDADE EVILASIO FORMIGA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3871, 4179, 'FACULDADE NAZARENA DO BRASIL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3872, 4180, 'FACULDADE HERRERO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3873, 4182, 'FACULDADE PRESBITERIANA SIMONTON IPES', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3874, 4183, 'FACULDADE PRESBITERIANA SIMONTON DE SAPEZAL IPES', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3875, 4184, 'INSTITUTO SUPERIOR DE EDUCACAO DE SERRANA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3876, 4185, 'FACULDADE PERUIBE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3877, 4187, 'ISEFAJIPA INSTITUTO SUPERIOR DE EDUCACAO DE JI PARANA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3878, 4188, 'FACULDADE IAPEDEM ANAMACO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3879, 4189, 'INSTITUTO DE EDUCACAO SUPERIOR SAO JUDAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3880, 4190, 'UNIFOS UNIVERSO DE FORMACAO TECNICA E SUPERIOR', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3881, 4191, 'INSTITUTO SUPERIOR METROPOLITANA ISUME', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3882, 4192, 'FACULDADE METROPOLITANA DE TERESINA FAMET', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3883, 4193, 'INSTITUTO SUPERIOR DE EDUCACAO DO BRASIL ISEB', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3884, 4194, 'FACULDADE DO ALTO TIETE FAAT', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3885, 4195, 'FACULDADE PROFETA ABRAAO FAPA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3886, 4196, 'INSTITUTO BRASILEIRO ACADEMICO SOCIAL DE PESQUISAS E ENSINO IBRASPE', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3887, 4197, 'FACULDADE ALIANCA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3888, 4198, 'FACULDADE MINEIRENSE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3889, 4199, 'FACULDADE DE TECNOLOGIA ROGACIONISTA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3890, 4200, 'FACULDADE DE COMUNICACAO SOCIAL DE PASSOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3891, 4201, 'FACULDADE DE ENSINO SUPERIOR DO NORDESTE', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3892, 4202, 'FACULDADE ALFA FAAL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3893, 4203, 'FACULDADE ABERTA DO BRASIL UNIABRA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3894, 4204, 'FACULDADE DE TECNOLOGIA INED   UNIDADE IPATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3895, 4205, 'ESCOLA SUPERIOR DO MINISTERIO PUBLICO DA UNIAO ESMPU', 1, 1, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3896, 4206, 'INSTITUTO DE ENSINO SUPERIOR DE TAGUATINGA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3897, 4207, 'NAP ODONTO SC LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3898, 4208, 'FACULDADE DE TECNOLOGIA MONTEIRO LOBATO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3899, 4209, 'FACULDADE DE TECNOLOGIA CESAR LATTES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3900, 4210, 'ESCOLA SUPERIOR DE ADMINISTRACAO, MARKETING E COMUNICACAO DO MORUMBI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3901, 4211, 'ESCOLA SUPERIOR DE ADMINISTRACAO, MARKETING E COMUNICACAO DE PERDIZES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3902, 4212, 'FACULDADE DE TECNOLOGIA DE POUSO ALEGRE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3903, 4213, 'FACULDADE DE CACAPAVA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3904, 4214, 'INSTITUTO SUPERIOR PAULO FREIRE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3905, 4215, 'FACULDADE DE SAO JOSE DOS CAMPOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3906, 4216, 'INSTITUTO MOINHOS DE VENTO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3907, 4217, 'FACULDADE DE TECNOLOGIA INSTITUTO POLITECNICO DO PARANA UNIDADE CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3908, 4218, 'FACULDADE PEDRO LEOPOLDO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3909, 4219, 'INSTITUTO SUPERIOR DE EDUCACAO PROFESSORA NAIR FORTES ABUMERHY', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3910, 4220, 'FACULDADE DE CIENCIAS GERENCIAIS DE BICAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3911, 4221, 'INSTITUTO SUPERIOR DE EDUCACAO DE BICAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3912, 4222, 'INSTITUTO SUPERIOR DE EDUCACAO DE MATIAS BARBOSA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3913, 4223, 'FACULDADE SANTOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3914, 4224, 'FACULDADE DE ITAPECIRICA FACITA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3915, 4225, 'FACULDADE DE TECNOLOGIA LUIZ ADELAR SCHEUER', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3916, 4227, 'FACULDADE DE TECNOLOGIA SENAC PASSO FUNDO PASSO FUNDO RS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3917, 4228, 'INSTITUTO DE EDUCACAO SUPERIOR MISSOES', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3918, 4229, 'FACULDADE PARANTINGA FAP', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3919, 4230, 'FACULDADE TECNOLOGICA UNIVERSAL DE FORMACAO TECNICA E SUPERIOR', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3920, 4233, 'INSTITUTO METROPOLITANO DE ENSINO SUPERIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3921, 4234, 'SOCIEDADE EVOLUCAO DE TECNOLOGIA E EDUCACAO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3922, 4235, 'FACULDADE TRIANGULO MINEIRO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3923, 4236, 'FACULDADES INTEGRADAS DE SERRANA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3924, 4237, 'CENTRO FEDERAL DE EDUCACAO TECNOLOGICA DO AMAZONAS', 1, 1, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3925, 4239, 'FACULDADE ACAO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3926, 4241, 'FACULDADE DE CIENCIAS HUMANAS SOCIAIS E TECNOLOGICAS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3927, 4243, 'FACULDADE DE CIENCIAS GERENCIAIS DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3928, 4244, 'FACULDADE DE TECNOLOGIA ENSITEC', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3929, 4245, 'FACULDADE DE TECNOLOGIA DA AMAZONIA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3930, 4246, 'PROGRAMA DE POS GRADUACAO LATO SENSU DA FUNDACAO UNIMED', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3931, 4247, 'FACULDADE DE CIENCIAS HUMANAS E SOCIAIS SAO PAULO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3932, 4248, 'INSTITUTO DE ENSINO PESQUISA E POS GRADUACAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3933, 4249, 'FACULDADE DE CIENCIAS DE ALAGOAS FACAL', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3934, 4250, 'FACULDADE DE CIENCIAS GERENCIAIS ALVES FORTES (JUIZ DE FORA)', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3935, 4251, 'FACULDADE PITAGORAS DE TECNOLOGIA DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3936, 4252, 'FACULDADE DE TECNOLOGIA EXPOENTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3937, 4253, 'ESCOLA AGROTECNICA FEDERAL DE CONCORDIA', 1, 1, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3938, 4254, 'FACULDADES INTEGRADAS DA TERRA DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3939, 4255, 'FACULDADES INTEGRADAS DE CACOAL', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3940, 4256, 'FACULDADES INTEGRADAS PITAGORAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3941, 4257, 'INSTITUTO DE FILOSOFIA E TEOLOGIA DE GOIAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3942, 4258, 'FACULDADE PURIFICACAO LTDA', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3943, 4259, 'FACULDADE DE INHUMAS FACMAIS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3944, 4260, 'FACULDADE DE TECNOLOGIA DE SAO LEOPOLDO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3945, 4261, 'FACULDADE DE TECNOLOGIA DE PORTO ALEGRE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3946, 4262, 'FACULDADE DE TECNOLOGIA IDESC', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3947, 4263, 'FACULDADE ESPIRITA RAMATIS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3948, 4264, 'INSTITUTO FIGUEIREDO DE EDUCACAO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3949, 4265, 'UNEPPSI UNIDADE DE ENSINO E PESQUISA EM PSICOLOGIA E PSICANALISE', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3950, 4266, 'INSTITUTO GUERRA BIAGI INGB', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3951, 4267, 'INSTITUTO SUPERIOR DE EDUCACAO DA AMERICA LATINA ISAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3952, 4268, 'FACULDADE ISAG', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3953, 4269, 'SOCIEDADE BRASILEIRA DE EDUCACAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3954, 4270, 'FACULDADE LIBERTAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3955, 4271, 'INSTITUTO SUPERIOR EM CIENCIAS DA HUMANIDADE', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3956, 4272, 'INSTITUTO MODAL LTDA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3957, 4273, 'INSTITUTO SUPERIOR DE EDUCACAO SEESB', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3958, 4274, 'INSTITUTO TEOLOGICO DA ASSEMBLEIA DE DEUS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3959, 4275, 'INSTITUTO DE ENSINO E PESQUISA EM ADMINISTRACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3960, 4276, 'IETEC', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3961, 4277, 'FACULDADE LITERATUS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3962, 4278, 'FACULDADE INTEGRADA SANTA RITA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3963, 4279, 'FACULDADE DE TECNOLOGIA INSTITUTO POLITECNICO DO PARANA UNIDADE GUARAPUAVA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3964, 4280, 'FACULDADE INTEGRADA CIDADE DE PATOS DE MINAS LTDA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3965, 4281, 'FACULDADE AMBIENTAL DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3966, 4282, 'FACULDADE PARA O DESENVOLVIMENTO DO ESTADO DE SAO PAULO FADESP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3967, 4283, 'FACULDADE IASOCIAL', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3968, 4284, 'FACULDADE SAO FRANCISCO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3969, 4285, 'FUNDACAO INSTITUTO DE ADMINISTRACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3970, 4286, 'FACULDADE PRATA FAP', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3971, 4287, 'FACULDADE DE CIENCIAS HUMANAS E SOCIAIS DO XINGU E AMAZONIA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3972, 4288, 'UNIED TECNOLOGIA EDUCACIONAL', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3973, 4289, 'FACULDADE DO VALE ELVIRA DAYRELL FAVED', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3974, 4290, 'FACULDADE DE ARTES INTEGRADAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3975, 4291, 'IEMS INSTITUTO EDUCACIONAL MORADA DA SERRA DO MUNICIPIO DE CUIABA MT', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3976, 4292, 'ITECSS INSTITUTO TIRADENTES DE EDUCACAO EM CIENCIAS SOCIAIS E DA SAUDE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3977, 4293, 'FACULDADE INTEGRACAO TIETE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3978, 4294, 'FACULDADE DE TECNOLOGIA SENAC JARAGUA DO SUL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3979, 4295, 'FACULDADE DE TECNOLOGIA SENAI CETIND', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3980, 4296, 'INSTITUTO BRASILEIRO DE CIENCIAS CRIMINAIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3981, 4297, 'CENTRO DE ESTUDOS PROF JOSE BELMIRO DE CASTRO MOREIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3982, 4298, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3983, 4299, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA RS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3984, 4300, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECCAO PARAIBA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3985, 4301, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL ABO DF', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3986, 4302, 'ASSOCIACAO CATARINENSE DE ODONTOLOGIA ESPECIALIZADA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3987, 4303, 'SOCIEDADE DOS CIRURGIOES DENTISTAS DE PERNAMBUCO ABO PE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3988, 4304, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL DA ABO RO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3989, 4305, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA ES RVV', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3990, 4306, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL DA ASSOCIACAO BRASILEIRA DE ODONTOLOGIA REGIONAL POUSO ALEGRE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3991, 4307, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECAO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3992, 4308, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECCAO AMAPA', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3993, 4309, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECAO TOCANTINS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3994, 4310, 'UNIS MG', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3995, 4311, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL ABO AL', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3996, 4312, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAO PAULO REGIONAL CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3997, 4313, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAOPAULO REGIONAL BIRIGUI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3998, 4314, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAO PAULO REGIONAL LINS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (3999, 4315, 'FACULDADE DE TEOLOGIA E CIENCIAS DA RELIGIAO', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4000, 4316, 'FACULDADE DE TECNOLOGIA SANTOS DUMONT', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4001, 4317, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4002, 4318, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAO PAULO REGIONAL BAURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4003, 4319, 'CAP ABORJ CENTRO DE APERFEICOAMENTO PROFISSIONAL DA ABO RJ', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4004, 4320, 'ESCOLA DE POS GRADUACAO ASSOCIACAO BRASILEIRA DE ODONTOLOGIA REGIONAL DE CASCAVEL PR', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4005, 4321, 'IETEC INSTITUTO DE CIENCIA E TECNOLOGIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4006, 4322, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4007, 4323, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA REGIONAL CARIRI', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4008, 4324, 'FACULDADE GONZAGA DE PELOTAS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4009, 4325, 'EAP ABO MURIAE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4010, 4326, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL ASSOCIACAO BRASILEIRA DE ODONTOLOGIA REGIONAL JUIZ DE FORA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4011, 4327, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4012, 4328, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4013, 4329, 'FACULDADE DO CENTRO EDUCACIONAL MINEIRO FACEM', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4014, 4330, 'FACULDADE DE TECNOLOGIA AMERICA DO SUL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4015, 4331, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAO PAULO REGIONAL ARACATUBA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4016, 4332, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAO PAULO REGIONAL GUARULHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4017, 4333, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAO PAULO REGIONAL ARARAQUARA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4018, 4334, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAO PAULO REGIONAL SERTAOZINHO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4019, 4335, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAO PAULO REGIONAL SAO JOSE DOS CAMPOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4020, 4336, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAO PAULO REGIONAL RIBEIRAO PRETO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4021, 4337, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAO PAULO REGIONAL PRESIDENTE PRUDENTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4022, 4338, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAO PAULO REGIONAL CATANDUVA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4023, 4339, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAO PAULO REGIONAL VALE DO PARAIBA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4024, 4340, 'FACULDADE DE ENSINO SUPERIOR DE VALENCA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4025, 4341, 'ASSOCIACAO MARINGAENSE DE ODONTOLOGIA AMO ABO REGIONAL MARINGA PR', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4026, 4342, 'FACULDADE STAR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4027, 4343, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL DA ABO MS', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4028, 4344, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL DA ABO PI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4029, 4345, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL DA ABO BA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4030, 4346, 'FACULDADE DE ENSINO SUPERIOR DE MIGUEL ALVES', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4031, 4347, 'FACULDADE SERRA DOS PIRINEUS DE EDUCACAO DE CIENCIAS APLICADAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4032, 4348, 'FACULDADE DE COMUNICACAO TECNOLOGIA E CIENCIA FACTEC', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4033, 4349, 'ABO REGIONAL SETE LAGOAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4034, 4350, 'E A B ASSOCIACAO BRASILEIRA DE ODOTOLOGIA RJ D DE CAXIAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4035, 4351, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECAO SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4036, 4352, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA REGIONAL OSASCO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4037, 4353, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SAO PAULO REGIONAL ABC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4038, 4354, 'AFISVEC', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4039, 4355, 'FACULDADE DE TECNOLOGIA DE PALMAS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4040, 4356, 'FACULDADE DE CIENCIAS SOCIAIS DOS PALMARES', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4041, 4357, 'FACULDADE DE TECNOLOGIA ALVARES DE AZEVEDO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4114, 4432, 'FACULDADE GERACAO POSITIVA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4042, 4358, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO SUL DE MINAS GERAIS', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4043, 4359, 'ESCOLA AGROTECNICA FEDERAL DE SATUBA', 1, 1, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4044, 4360, 'ESCOLA AGROTECNICA FEDERAL DE MACHADO', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4045, 4361, 'FACULDADE DE CIENCIAS GERENCIAIS DE SANTA LUZIA MG FAGESA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4046, 4362, 'FACULDADE PITAGORAS DE BETIM', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4047, 4363, 'INSTITUTO SANTA MONICA DE ESTUDOS E PESQUISAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4048, 4364, 'FACULDADE QUASAR', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4049, 4365, 'FABS FACULDADE DE BOM SUCESSO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4050, 4366, 'EAP ESCOLA DE APERFEICOAMENTO PROFISSIONAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4051, 4367, 'FACULDADE TERRA NORDESTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4052, 4368, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4053, 4369, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL EAP ABO RN', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4054, 4370, 'SANTA CASA DE MISERICORDIA DE PONTA GROSSA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4055, 4371, 'FACULDADE PADRE ANCHIETA DE CAJAMAR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4056, 4372, 'U E P UNIDADE DE ENSINO PROFISSIONAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4057, 4373, 'FACULDADE DE EDUCACAO CIENCIA E TECNOLOGIA DE REDENCAO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4058, 4374, 'CURSO DE TEOLOGIA E PASTORAL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4059, 4375, 'UNC SALVADOR UNIDADE AVANCADA DE POS GRADUACAO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4060, 4376, 'IBEG POS GRADUACAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4061, 4377, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL EAP', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4062, 4378, 'NUCLEO DE ESTUDOS ORTODONTICOS MBT BRASIL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4063, 4379, 'ASSOCIACAO DE CIRURGIOES DENTISTAS DO ESTADO DE SAO PAULO', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4064, 4380, 'CENTRO DE QUALIFICACAO ODONTOLOGICA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4065, 4381, 'ACADEMIA NORTE RIO GRANDENSE DE ODONTOLOGIA', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4066, 4382, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA REGIONAL PETROPOLIS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4067, 4383, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECCAO DE GOIAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4068, 4384, 'CESVIA FACULDADE DE VIAMAO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4069, 4386, 'ESAB ESCOLA SUPERIOR ABERTA DO BRASIL', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4070, 4387, 'NETT ODONTO NUCLEO DE ESPECIALIZACAO TREINAMENTO E TRATAMENTO ODONTOLOGICO S C LTDA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4071, 4388, 'IPEC INSTITUTO PAULISTA DE EDUCACAO CONTINUADA LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4072, 4389, 'FACULDADE INTEGRADA CARAJAS DE MARABA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4073, 4390, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL DA ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECCAO SERGIPE', 2, 1, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4074, 4391, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4075, 4392, 'FATEC DE CONTAGEM', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4076, 4393, 'INSTITUTO SUPERIOR DE CIENCIAS DO COMPORTAMENTO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4077, 4394, 'FACULDADE DE EDUCACAO FISICA DE ARAGUAINA', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4078, 4395, 'FACULDADE DE DIREITO DE ARAGUAINA', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4079, 4396, 'FACULDADES INTEGRADAS DE MINEIROS', 3, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4080, 4397, 'ESCOLA SUPERIOR DE ENSINO DA SEICHO NO IE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4081, 4398, 'INSTITUTO SUPERIOR DE EDUCACAO DE GOIANA', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4082, 4399, 'FACULDADE DE BALSAS', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4083, 4400, 'INSTITUTO DE ESTUDOS DA SAUDE POS GRADUACAO EM CIENCIAS DA SAUDE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4084, 4401, 'FACULDADE DE APIAI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4085, 4403, 'FACULDADE DA ACADEMIA MEMORIAL DE ENSINO SUPERIOR DE PERNAMBUCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4086, 4404, 'INSTITUTO SEDES SAPIENTIAE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4087, 4405, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA REGIONAL DE FOZ DO IGUACU', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4088, 4406, 'ASSOCIACAO BRAS DE ODONTO SEC DE GOIAS SUB SEC DE JATAI', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4089, 4407, 'FACULDADE DE ENSINO SUPERIOR DA TERRA PAULISTA FATERRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4090, 4408, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL ABO RN REGIONAL MOSSORO', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4091, 4409, 'ASSOCIACAO INSTITUTO DE FOMENTO EDUCACIONAL FENIX', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4092, 4410, 'CRDA POS GRADUACOES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4093, 4411, 'FACULDADE PANAMERICANA DE JIPARANA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4094, 4412, 'FACULDADE VALE DO ARAGUAIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4095, 4413, 'ASSOCIACAO VITA CARE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4096, 4414, 'INSTITUTO SUPERIOR DE EDUCACAO VALE DO ARAGUAIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4097, 4415, 'FSD FACULDADE SAO DOMINGOS', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4098, 4416, 'FACULDADE JK   UNIDADE I   GAMA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4099, 4417, 'FACULDADE DE ENFERMAGEM DE BELO JARDIM', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4100, 4418, 'FACULDADE SAO BERNARDO', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4101, 4419, 'INSTITUTO DE PESQUISA E ENSINO EM SAUDE ANIMAL IPESA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4102, 4420, 'FACULDADES INTEGRADAS BARROS MELO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4103, 4421, 'FACULDADE DE TECNOLOGIA SENAI BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4104, 4422, 'FACULDADE DE TECNOLOGIA DO ABC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4105, 4423, 'FACULDADE ADVENTISTA DE ENFERMAGEM DO NORDESTE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4106, 4424, 'LIBERTAS CLINICA ESCOLA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4107, 4425, 'FACULDADE CORPO MENTE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4108, 4426, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA REGIONAL ANAPOLIS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4109, 4427, 'FACULDADE DAS CIENCIAS MULTIPLAS E DO MEIOAMBIENTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4110, 4428, 'FACULDADE PROFESSOR MIGUEL ANGELO DA SILVA SANTOS', 3, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4111, 4429, 'FACULDADE UNIGRAN CAPITAL', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4112, 4430, 'ITAL INSTITUTO DE TECNOLOGIA DE ALIMENTOS', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4113, 4431, 'FACULDADE DE ENFERMAGEM NOVA ESPERANCA DE MOSSORO FACENERN', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4115, 4433, 'FAWEST FACULDADE WESTPHALIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4116, 4434, 'INSTITUTO DE DIREITO ROMEU FELIPE BACELLAR', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4117, 4435, 'FACULDADE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4118, 4436, 'FACULDADE BIG MASTER', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4119, 4437, 'CENTRO ODONTOLOGICO DE APERFEICOAMENTO PROFISSIONAL', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4120, 4438, 'ACADEMIA BRASILEIRA DE DIREITO CONSTITUCIONAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4121, 4439, 'COOENSINO COOPERATIVA DE ENSINO UNIVERSAL DOIS MIL', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4122, 4440, 'FACULDADE DE MEDICINA NOVA ESPERANCA DE NATAL FAMENE RN', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4123, 4441, 'SISTEMA EDUCACIONAL SUPERIOR UNIVERSITARIO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4124, 4442, 'ESCOLA SUPERIOR PAULISTA DE ADMINISTRACAO ESPA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4125, 4443, 'FACULDADE RIO CLARO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4126, 4444, 'CBPEX POS GRADUACAO', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4127, 4445, 'FACULDADE MEDIANEIRA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4128, 4446, 'FACULDADE CIDADE DE GUANHAES FACIG', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4129, 4447, 'SOCIEDADE BRASILEIRA DE DIREITO PUBLICO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4130, 4448, 'SOCIEDADE BRASILEIRA DE DIREITO PUBLICO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4131, 4449, 'FACULDADE DE TECNOLOGIA DO NORTE DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4132, 4450, 'FACULDADE METROPOLITANA DA AMAZONIA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4133, 4451, 'FACULDADE TEOLOGICA E EDUCACIONAL AGAPE COMUNITARIA FATEAC', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4134, 4452, 'FACULDADE METROPOLITANA DE MARABA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4135, 4454, 'FACULDADE PITAGORAS DE NOVA LIMA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4136, 4455, 'GESTOS GRUPO DE ESTUDOS ORTODONTICOS E SERVICOS S C LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4137, 4456, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4138, 4457, 'INSTITUTO SUPERIOR DE EDUCACAO DE ITAPECIRICA DA SERRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4139, 4458, 'INSTITUTO DE ENSINO SUPERIOR DE MACEIO IESMA', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4140, 4459, 'INEES INSTITUTO DE EDUCACAO E ESPECIALIZACAO SUPERIOR', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4141, 4460, 'FACULDADE DOM PEDRO II DE TECNOLOGIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4142, 4461, 'FACULDADE DE TECNOLOGIA SENAI CESAR RODRIGUES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4143, 4462, 'ESCOLA DE GESTAO E CONTROLE FRANCISCO JURUENA', 2, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4144, 4463, 'GRUPO DE ESTUDO ODONTOLOGICO E SERVICOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4145, 4464, 'FACULDADE LAGEANA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4146, 4465, 'CENTRO ODONTOLOGICO DE ESTUDOS E PESQUISAS COESP', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4147, 4466, 'CENTRO DE ESTUDOS PROF DIRCEU VIEIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4148, 4467, 'IACE INSTITUTO AVANCADO DE CIENCIAS E EDUCACAO', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4149, 4468, 'INSTITUTO APICE DE ENSINO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4150, 4469, 'FACULDADE HEXAGONO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4151, 4470, 'TVALLE ASSESSORIA E TREINAMENTO EDUCACIONAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4152, 4471, 'FACULDADE DE TECNOLOGIA POLITEC', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4153, 4472, 'CESDE BRASIL INTELIGENCIA EDUCACIONAL', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4154, 4473, 'FACULDADE DE TECNOLOGIA ACCTIVA DE CIENCIA E TECNOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4155, 4474, 'ESCOLA PAULISTANA DE ODONTOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4156, 4475, 'ESCOLA CAPIXABA DE ODONTOLOGIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4157, 4476, 'ESCOLA PAULISTA DE ODONTOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4158, 4477, 'ENSINO A DISTANCIA SLMANDIC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4159, 4478, 'ESCOLA BRASILIENSE DE ODONTOLOGIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4160, 4479, 'ESCOLA CHAPECOENSE DE ODONTOLOGIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4161, 4480, 'ESCOLA CAMBORIU DE ODONTOLOGIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4162, 4481, 'ESCOLA FLUMINENSE DE ODONTOLOGIA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4163, 4482, 'ESCOLA DO NORDESTE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4164, 4483, 'ESCOLA CEARENSE DE ODONTOLOGIA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4165, 4484, 'CENTRO DE PESQUISAS ODONTOLOGICAS SAO LEOPOLDO MANDIC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4166, 4485, 'ESCOLA FORENSE DE ODONTOLOGIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4167, 4486, 'ESCOLA MINEIRA DE ODONTOLOGIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4168, 4487, 'SOBRACURSOS CURSOS DE POS GRADUACAO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4169, 4488, 'ESCOLA METROPOLITANA DE ODONTOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4170, 4489, 'ESCOLA SANTISTA DE ODONTOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4171, 4490, 'FACULDADE SENADOR CANEDO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4172, 4491, 'FACULDADE TECNOLOGICA ITAI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4173, 4492, 'FACULDADE PASCHOAL DANTAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4174, 4493, 'FACULDADE DE TECNOLOGIA CERTUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4175, 4494, 'COORDENADORIA DE ENSINO A DISTANCIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4176, 4495, 'FACULDADE ANHANGUERA JARAGUA DO SUL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4177, 4496, 'FACULDADE DE TECNOLOGIA DO VALE DO IVAI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4178, 4497, 'WP CENTRO DE PSICOTERAPIA COGNITIVO COMPORTAMENTAL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4179, 4498, 'CENTRO DE ENSINO TEORICO TECNICO DE TRANSITO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4180, 4499, 'CENTRO DE ENSINO TEORICO TECNICO DE TRANSITO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4181, 4500, 'FACULDADE DE TECNOLOGIA EM SAUDE DO PARA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4182, 4501, 'FACULDADE DE TECNOLOGIA ALTO TIETE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4183, 4502, 'FACULDADES INTEGRADAS CAMPOGRANDENSES', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4184, 4503, 'UNIVERSIDADE FEDERAL DO RECONCAVO DA BAHIA', 1, 1, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4185, 4504, 'FUNDACAO UNIVERSIDADE FEDERAL DA GRANDE DOURADOS', 1, 1, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4186, 4505, 'FACULDADE FACISA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4187, 4506, 'CEFE CENTRO DE ESTUDOS DE FISIOLOGIA DO EXERCICIO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4188, 4507, 'INSTITUTO SUPERIOR XAVIER CORDEIRO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4189, 4508, 'FACULDADE DE ENSINO SUPERIOR DE FLORIANO PI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4190, 4509, 'INSTITUTO SUL BRASILEIRO DE ENSINO SUPERIOR INSBES', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4191, 4510, 'FASOMA FACULDADE SOLUCAO MARANHENSE LTDA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4192, 4511, 'IPPEO INSTITUTO PARANAENSE DE PESQUISA E ENSINO EM ODONTOLOGIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4193, 4512, 'FACULDADE AGUIAS DO DIREITO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4194, 4513, 'FATEB', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4195, 4514, 'ESCOLA SUPERIOR DA MAGISTRATURA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4196, 4515, 'ABO REGIONAL DE TAGUATINGA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4197, 4516, 'INSTITUTO CHIAVENATO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4198, 4517, 'FACULDADE DE EDUCACAO DE CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4199, 4518, 'FACULDADE REGIONAL PALMITOS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4200, 4519, 'OPEG FACULDADE DE TECNOLOGIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4201, 4520, 'FACULDADE CENACAP', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4202, 4521, 'FACULDADE DE CIENCIAS APLICADAS DE ITAPEVA FACITA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4203, 4522, 'CENTRO UNIVERSITARIO CATOLICO SALESIANO AUXILIUM', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4204, 4523, 'FACULDADE DO INSTITUTO EDUCACIONAL PROFISSIONALIZANTE DE JALES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4205, 4524, 'INSTITUTO TECNOLOGICO DE AVALIACAO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4206, 4525, 'FACULDADE TECNOLOGICA DE EXCELENCIA EDUCACIONAL DO RIO GRANDE DO NORTE', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4207, 4526, 'FACULDADES INTEGRADAS LAVOISIER', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4208, 4527, 'FACULDADE DE URUACU', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4209, 4528, 'IBEXP INSTITUTO BRASILEIRO DE EXECUTIVOS PROFISSIONAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4210, 4530, 'FACULDADE INTEGRADA TIRADENTES', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4211, 4531, 'FACULDADE ADVENTISTA DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4212, 4532, 'FACULDADE DE TECNOLOGIA SENAI CAMPO GRANDE', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4213, 4533, 'FACULDADE SAO FRANCISCO DA PARAIBA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4214, 4534, 'FACULDADE HERRERO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4215, 4535, 'FACULDADE DA AMAZONIA FAMA', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4216, 4536, 'IPEO MT', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4217, 4537, 'INSTITUTO SUPERIOR DE EDUCACAO DO MARANHAO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4218, 4538, 'FACULDADE PARQUE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4219, 4539, 'FACULDADE DE TEOLOGIA E CIENCIAS HUMANAS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4220, 4540, 'FACULDADES CONE SUL', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4221, 4541, 'CENTRO BAIANO DE ESTUDOS ODONTOLOGICOS CEBEO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4222, 4542, 'INSTITUTO BIOSFERA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4223, 4543, 'FACULDADE DE EDUCACAO E ESTUDOS SUPERIORES DE AREIA FAESA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4224, 4544, 'FACULDADE LIDER', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4225, 4545, 'FACULDADE PARANATINGA FAP', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4226, 4546, 'FACULDADE METODISTA UNIAO URUGUAIANA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4227, 4547, 'CENTRO DE ESTUDOS E APERFEICOAMENTO PROFISSIONAL', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4228, 4548, 'CAP CENTRO DE APERFEICOAMENTO PROFISSIONAL', 3, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4229, 4550, 'INSTITUTO DE ENSINO PEDAGOGOS ASSOCIADOS INESPA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4230, 4551, 'FACULDADES ASSOC DE MONACO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4231, 4552, 'FACULDADE ECUMENICA LAYRA DE ALTO PARAISO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4232, 4553, 'FACULDADE MERIDIONAL', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4233, 4554, 'FUNDACAO CARDIOVASCULAR SAO FRANCISCO DE ASSIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4234, 4555, 'INSTITUTO DE EDUCACAO A DISTANCIA NORTE FLUMINENSE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4235, 4556, 'FACULDADE EVOLUCAO DE CIENCIAS E TECNOLOGIA FECET', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4236, 4557, 'CLINICA INTEGRADA DE ODONTOLOGIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4237, 4558, 'FACULDADE CENECISTA DE ALTA FLORESTA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4238, 4559, 'INSTITUTO SUPERIOR LAGEANO DE EDUCACAO A DISTANCIA ISLED', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4239, 4560, 'FACULDADE DE SENHOR DO BOMFIM', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4240, 4561, 'FACULDADE SANTO ANTONIO DE QUEIMADAS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4241, 4562, 'FACULDADE LUZ DE GUARABIRA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4242, 4563, 'FACULDADE DE TECNOLOGIA DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4243, 4564, 'FACULDADE SANTA RITA DE CASSIA FASARC', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4244, 4565, 'INSTITUTO EDUCACIONAL SEMINARIO PAULOPOLITANO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4245, 4566, 'ESTACIO FATERN FACULDADE ESTACIO DO RIO GRANDE DO NORTE', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4246, 4567, 'FACULDADE CENTRO MATOGROSSENSE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4247, 4568, 'FACULDADE ECA DE QUEIROZ SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4248, 4569, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL DA APCD REGIONAL TAUBATE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4249, 4570, 'FACULDADE DE TEOLOGIA DE SELVIRIA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4250, 4571, 'INSTITUTO IPESP', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4251, 4572, 'FACULDADE DE TEOLOGIA E EDUCACAO DE MINAS GERAIS FATEMIG', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4252, 4573, 'IBTEC INSTITUTO BRASILEIRO DE TECNOLOGIA E CIENCIAS', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4253, 4574, 'FACULDADE JACQUES COUSTEAU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4254, 4575, 'INSTITUTO DE CIENCIAS DO TRABALHO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4255, 4576, 'CENTRO DE ENSINO SUPERIOR LEOPOLDINENSE ALBERT EINSTEIN', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4256, 4577, 'ISAE FGV PARANA INSTITUTO SUPERIOR DE ADMINISTRACAO E ECONOMIA DO PARANA FUNDACAO GETULIO VARGAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4257, 4578, 'FACULDADE CARLOS CHAGAS FILHO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4258, 4579, 'FACULDADE DO SUDESTE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4259, 4580, 'FACULDADE REUNIDA DE ILHA SOLTEIRA MESMO QUE 1625', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4260, 4581, 'CENTRO LUMEN DE EXTENSAO E POS GRAFUACAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4261, 4582, 'FACULDADE CENTRO SUL DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4262, 4583, 'FACULDADE PITAGORAS DE ITABUNA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4263, 4584, 'FACULDADE DE TECNOLOGIA MACHADO DE ASSIS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4264, 4585, 'ESCOLA SUPERIOR DA MAGISTRATURA DE PERNAMBUCO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4265, 4586, 'FACULDADE DO NORTE GOIANO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4266, 4587, 'FACULDADE UNIVERSAL DE FORMACAO TECNOLOGICA E SUPERIOR UNIFOS', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4267, 4588, 'FACULDADE APOGEU', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4268, 4589, 'FACULDADE DE DIREITO DO DISTRITO FEDERAL FDDF', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4269, 4590, 'FACULDADE DE TECNOLOGIA FATEP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4270, 4592, 'FACULDADE DE OURO PRETO DO OESTE', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4271, 4593, 'CENTRO EURO AMERICANO DE GESTAO E HOSPITALIDADE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4272, 4594, 'FACULDADE CATOLICA DE RONDONIA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4273, 4595, 'DEPARTAMENTO DE APERFEICOAMENTO PROFISSIONAL DAP', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4274, 4596, 'FACULDADE REGES DE RIBEIRAO PRETO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4275, 4597, 'FACULDADE DE CIENCIAS GERENCIAIS EM VOTUPORANGA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4276, 4598, 'FACULDADE DE CIENCIAS GERENCIAIS BARAO DE JUNDIAI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4277, 4599, 'INSTITUTO EL SHADDAY DE TEOLOGIA E MISSOES', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4278, 4600, 'FACULDADE DE TECNOLOGIA DE MACAPA FATEMA', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4279, 4601, 'FACULDADE TECNOLOGICA CRISTO REI', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4280, 4602, 'FUNDACAO ESCOLA SUPERIOR DO MPDFT', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4281, 4603, 'INSTITUTO DE TECNOLOGIA EM SAUDE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4282, 4604, 'FWM FACULDADE TEOLOGICA E APOLOGETICA DR WALTER MARTIN', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4283, 4605, 'FACULDADE DE ENSINO SUPERIOR KM 125', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4284, 4606, 'FACULDADE DE TECNOLOGIA CONTEC UNIDADE DE CARAPINA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4285, 4607, 'ESCOLA SUPERIOR KLYMUS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4286, 4608, 'FACULDADE 2001', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4287, 4609, 'FATESP FACULDADE TEOLOGICA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4288, 4610, 'FACULDADE DE TECNOLOGIA ASSESSORITEC', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4289, 4611, 'FACULDADE PLANALTO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4290, 4612, 'ISEBES INSTITUTO BETH SHALOM', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4291, 4613, 'FACULDADE DE EDUCACAO E MEIO AMBIENTE', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4292, 4614, 'FACULDADE APROVACAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4293, 4615, 'ACADEMIA DE GESTAO FISCAL', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4294, 4616, 'FACULDADE ANHANGUERA DE CAXIAS DO SUL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4295, 4617, 'ATAME POS GRADUACAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4296, 4618, 'E A P ESCOLA DE APERFEICOAMENTO PROFISSIONAL ABO RJ REGIONAL DUQUE DE CAXIAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4297, 4619, 'SINDICATO DOS ODONTOLOGISTAS DO ESTADO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4298, 4620, 'FACULDADE EVANGELICA CEILANDIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4299, 4621, 'FACULDADE EVANGELICA AGUAS CLARAS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4300, 4622, 'FACULDADE EVANGELICA TAGUATINGA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4301, 4623, 'FACULDADE LATINO AMERICANA DE TEOLOGIA INTEGRAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4302, 4624, 'FACULDADE DE ODONTOLOGIA', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4303, 4625, 'A C CONSULTING LTDA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4304, 4626, 'FACIDER II', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4305, 4627, 'SAO JUDAS FACULDADES INTEGRADAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4306, 4628, 'ESCOLA SUPERIOR VERBO JURIDICO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4307, 4629, 'FACULDADE DE TECNOLOGIA FUNDETEC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4308, 4630, 'FACULDADE DE TECNOLOGIA TECMED', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4309, 4631, 'FACULDADE ANGLOAMERICANO DE JOAO PESSOA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4310, 4632, 'FACULDADE ANGLOAMERICANO DE CAXIAS DO SUL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4311, 4633, 'FACULDADE ANGLOAMERICANO DE PASSO FUNDO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4312, 4634, 'ESCOLA AGROTECNICA FEDERAL DE ALEGRE', 1, 1, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4313, 4635, 'FACULDADE INTEGRADO DA COMCAM', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4314, 4636, 'FACULDADES INTEGRADAS INTERAMERICANAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4315, 4637, 'FACULDADE DE RELACOES INTERNACIONAIS SERGIO VIEIRA DE MELLO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4316, 4638, 'FACULDADE TEOLOGICA BATISTA EQUATORIAL', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4317, 4639, 'FACULDADE IJUI', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4318, 4640, 'ESCOLA DE TERAPIA MANUAL E POSTURAL S S LTDDA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4319, 4641, 'UNIDIDATICO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4320, 4642, 'FACULDADE UNIREAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4321, 4643, 'INSTITUTO SAO PAULO DE ESTUDOS SUPERIORES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4322, 4644, 'UNIEXODOS FACULDADE DE TECNOLOGIA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4323, 4645, 'INSTITUTO BRASILEIRO DE CHI KUNG E TERAPIAS AFINS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4324, 4646, 'IPG INSTITUTO DE POS GRADUACAO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4325, 4647, 'FACULDADE DE REABILITACAO DO PLANALTO CENTRAL FARPLAC', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4326, 4648, 'DEPARTAMENTO DE ENSINO E CULTURA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4327, 4649, 'JRK ESCOLA DE POS GRADUACAO EM ODONTOLOGIA LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4328, 4650, 'FACULDADE DA AMAZONIA', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4329, 4651, 'FACULDADES ANDEF', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4330, 4652, 'FACULDADE ANHANGUERA DE SAO JOSE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4331, 4653, 'FACULDADE COMUNITARIA DE GUARATINGUETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4332, 4654, 'FACULDADE COMUNITARIA DE BAURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4333, 4655, 'FACULDADE ANHANGUERA DE SOROCABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4334, 4656, 'FACULDADE ANHANGUERA DE PIRACICABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4335, 4657, 'FACULDADE DE EDUCACAO E ENSINO SUPERIOR TECNOLOGICO FAEST', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4336, 4658, '3158 INSTITUTO SUPERIOR DE EDUCACAO ANGLO AMERICANO DE FOZ DO IGUACU ISEAAFI', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4337, 4659, 'FACULDADE DE TEOLOGIA EDUCACAO E CIENCIAS FATEC', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4338, 4660, 'UNIPESSOA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4339, 4661, 'FACULDADE DE AGRONEGOCIO PARAISO DO NORTE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4340, 4662, 'INSTITUTO LATINO AMERICANO DE PESQUISA E ENSINO ODONTOLOGICO ILAPEO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4341, 4663, 'NAP INSTITUTO DE ENSINO SUPERIOR LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4342, 4664, 'FAEPO NUCLEO DE POS GRADUACAO E PESQUISA EM ODONTOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4343, 4665, 'SOCIEDADE DE EDUCACAO E CULTURA CAICARAS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4344, 4666, 'FACULDADE DE RONDONIA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4345, 4667, 'FACULDADE RIO SONO', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4346, 4668, 'FACULDADE COMUNITARIA DE SUMARE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4347, 4669, 'FACULDADE DELTA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4348, 4670, 'FACULDADE DE ENSINO SUPERIOR E TECNOLOGIA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4349, 4671, 'IOCP CEPOS CENTRO DE ESTUDOS E POS GRADUACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4350, 4672, 'FACULDADE EMPREENDEDORA AURORA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4351, 4673, 'ESCOLA SUPERIOR DE TEOLOGIA E FILOSOFIA DO BRASIL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4352, 4674, 'FACULDADE PORTO DAS AGUAS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4353, 4675, 'JUSPODIVM', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4354, 4676, 'SENAI DENDEZEIROS', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4355, 4677, 'UNIVERSIDADE JOSE DO ROSARIO VELLANO UNIFENAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4356, 4678, 'INSTITUTO DE DERMATOLOGIA MEDICINA E CIRURGIA ESTETICA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4357, 4679, 'FESPPAR FACULDADE EDUCACIONAL DE PINHAIS DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4358, 4680, 'FEPPAR FACULDADE EDUCACIONAL DE PIRAQUARA DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4359, 4681, 'FACULDADE CENTRO PAULISTANO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4360, 4682, 'FACULDADE INTEGRADA BRASILEIRA RENASCENCA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4361, 4683, 'PROJECTO CENTRO CULTURAL E DE FORMACAO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4362, 4684, 'BUSINESS SCHOOL CEDEPE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4363, 4685, 'FACULDADES INTEGRADAS PLURAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4364, 4686, 'FACULDADE SAO BASILIO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4365, 4687, 'FACULDADE DE TEOLOGIA BRASILEIRA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4366, 4688, 'FACULDADE DE DIREITO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4367, 4689, 'INSTITUTO DE ENSINO SUPERIOR PASSIONISTA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4368, 4690, 'FACULDADE DE EDUCACAO SUPERIOR E TEOLOGICA MARANHENSE', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4369, 4691, 'INSTITUTO PARANAENSE DE PESQUISA DESENVOLVIMENTO E POS GRADUACAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4370, 4692, 'FACULDADE VITORIO BONACIN', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4371, 4693, 'FACULDADE DE TECNOLOGIA DE NOVA ANDRADINA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4372, 4694, 'FACULDADE DE TEOLOGIA E CIENCIAS DA EDUCACAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4373, 4695, 'UB FACULDADE TECNOLOGICA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4374, 4696, 'FASE FACULDADE DE TECNOLOGIA DO AMAZONAS', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4375, 4697, 'MOUSE COM CURSOS PROFISSIONALIZANTES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4376, 4698, 'TECNOLOGIA RADIOLOGICA E RADIOTERAPICA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4377, 4699, 'FACULDADE NOROESTE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4378, 4700, 'FACULDADE NOVA ROMA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4379, 4701, 'FACULDADE CATOLICA DE CAMPINA GRANDE', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4380, 4702, 'FACULDADE DE TECNOLOGIA GESTAO & MARKETING', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4381, 4703, 'INSTITUTO D ENSINO SUPERIOR CASTRO ALVES', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4382, 4704, 'FACULDADE PONTE SERRADA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4383, 4705, 'FACULDADE UNIECO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4384, 4706, 'FACULDADE WELLINGTON', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4385, 4707, 'NUCLEO DE EDUCACAO CONTINUADA NEC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4386, 4708, 'FACULDADE SINOPENSE DE ENSINO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4387, 4709, 'IRMANDADE DA SANTA CASA DE MISERICORDIA DE PORTO ALEGRE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4388, 4710, 'INSTITUTO CABRERA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4389, 4711, 'UNIDADE DE ENSINO SUPERIOR DE APUCARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4390, 4712, 'FACULDADES CASA DO SABER', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4391, 4713, 'ASSOCIACAO DE ENSINO SUPERIOR EDUCARE EDUCARE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4392, 4714, 'FACULDADE DE ENSINO REGIONAL ALTERNATIVA', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4393, 4715, 'BRIGADA AMBIENTAL DO MUNICIPIO DE SAO PEDRO DA ALDEIA', 3, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4394, 4716, 'FACULDADE DE MEDICINA DE MARABA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4395, 4717, 'INSTITUTO SUPERIOR DE EDUCACAO SANTA MARIA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4396, 4718, 'FACULDADE DE TECNOLOGIA SANTA MARIA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4397, 4719, 'FACULDADE DE TECNOLOGIA IJUI', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4398, 4720, 'IBREAS INSTITUTO BRASILEIRO DE ESTUDOS AVANCADOS EM SAUDE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4399, 4721, 'ESCOLA DOMINICANA DE TEOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4400, 4722, 'FACULDADES INTEGRADAS VIANNA JUNIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4401, 4723, 'ACADEMIA NACIONAL DE POLICIA', 1, 1, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4402, 4724, 'FACULDADE DE CIENCIAS HUMANAS DE CRUZEIRO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4403, 4725, 'FACULDADE DE TECNOLOGIA EGIDIO JOSE DA SILVA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4404, 4726, 'FACULDADE EQUIPE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4405, 4727, 'FACULDADE DE EDUCACAO CIENCIA E TECNOLOGIA EM CAMOCIM', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4406, 4728, 'FACULDADE CENECISTA DE QUISSAMA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4407, 4729, 'FACULDADE CENECISTA DE RIO BONITO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4408, 4730, 'FACULDADE LUSIADA DE JI PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4409, 4731, 'FACULDADE MESSIANICA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4410, 4732, 'FACULDADE DE TECNOLOGIA SENAC DF', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4411, 4733, 'VITA CARE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4412, 4734, 'FACULDADES INTEGRADAS EDUCAR BRASIL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4413, 4735, 'FACULDADE ATENAS MARANHENSE FAMA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4414, 4736, 'MORAES BASTOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4415, 4737, 'FAMEM FACULDADE DO MEDIO MEARIM', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4416, 4738, 'INSTITUTO BIODELTA DE ENSINO E PESQUISA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4417, 4739, 'FACULDADE PRESBITERIANA AUGUSTO GALVAO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4418, 4740, 'FACULDADE DE PATROCINIO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4419, 4741, 'FACULDADE CENECISTA DE MARICA FACMAR', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4420, 4742, 'FACULDADE SANTA EMILIA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4421, 4743, 'FACULDADE DE EDUCACAO INTEGRADA E TECNOLOGIA FACEI', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4422, 4744, 'FACULDADE LITERATUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4423, 4745, 'FACULDADE LITORANEA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4424, 4746, 'FACULDADE CATOLICA DO CARIRI', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4425, 4747, 'FACULDADE REGIONAL DE RIACHAO DO JACUIPE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4426, 4748, 'FACULDADE DE TECNOLOGIA DE SANTA CATARINA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4427, 4749, 'FACULDADE ACCTIVA DE CIENCIA E TECNOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4428, 4750, 'FACULDADE SER', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4429, 4751, 'FACULDADE DE TECNOLOGIA E CIENCIAS DO NORTE DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4430, 4752, 'FACULDADE NOTARIAL E REGISTRAL DO BRASIL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4431, 4753, 'FACILETEC FACULDADES DE CIENCIAS LETRAS E DE TECNOLOGIA DE TURMALINA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4432, 4754, 'FACULDADES INTEGRADAS LUSO BRASILEIRA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4433, 4755, 'AMADO ASSOCIADOS IRH S C LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4434, 4756, 'CENTRO UNIVERSITARIO MUNICIPAL DE SAO JOSE', 3, 1, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4435, 4757, 'MASTER FACE CLINICA ODONTOLOGICA LTDA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4436, 4758, 'FACULDADE DE BAIXO GUANDU', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4437, 4759, 'FACULDADE DE ITAPEMIRIM', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4438, 4760, 'INSTITUTO DE ENSINO SUPERIOR BRASILIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4439, 4761, 'CETAO CENTRO DE ESTUDOS TREINAMENTO E APERFEICOAMENTO EM ODONTOLOGIA S C LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4440, 4762, 'FACULDADE IGUACUANO LEONARDO CARIELO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4441, 4763, 'FATERJ FACULDADE TEOLOGICA EVANGELICA DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4442, 4764, 'ESCOLA DE SAUDE PUBLICA DR JORGE DAVID NASSER', 2, 1, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4443, 4765, 'FACULDADE DE TECNOLOGIA ALFA DE UMUARAMA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4444, 4766, 'FACULDADE UNA DE CONTAGEM', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4445, 4767, 'FACULDADE QUALITAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4446, 4768, 'INSTITUTO DE CIENCIAS GERENCIAIS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4447, 4769, 'FACULDADES EMPREZA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4448, 4770, 'J G MELO CURSOS DE ESPECIALIZACAO EDUCACIONAL', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4449, 4771, 'FACULDADE BI CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4450, 4772, 'FACULDADE BI SOCIAL QUARESMA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4451, 4773, 'FACULDADE IBS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4452, 4774, 'INSTITUTO ELO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4453, 4775, 'ESCOLA DE APERFEICOAMENTO E FORMACAO PROFISSIONAL PROF PAULO SERODIO MELLO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4454, 4776, 'FACULDADE COMUNITARIA DE UBA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4455, 4777, 'FACULDADE KENNEDY DE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4456, 4778, 'FACULDADE CENECISTA DE TEUTONIA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4457, 4779, 'INSTITUTO NACIONAL DE PESQUISAS DA AMAZONIA INPA', 1, 1, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4458, 4780, 'FACISA UNAI FACULDADE DE CIENCIAS DA SAUDE DE UNAI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4459, 4781, 'FACULDADE DE COMUNICACAO TECNOLOGIA E TURISMO DE OLINDA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4460, 4782, 'FACULDADE DE TECNOLOGIA OXFORD', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4461, 4783, 'LIBERTAS CLINICA ESCOLA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4462, 4784, 'FACULDADE CDL', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4463, 4785, 'INSTITUTO FEDERAL DE EDUCACAO CIENCIA E TECNOLOGIA DE RONDONIA', 1, 1, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4464, 4786, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO TOCANTINS', 1, 1, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4465, 4787, 'ESCOLA AGROTECNICA FEDERAL DE SAO JOAO EVANGELISTA', 1, 1, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4466, 4788, 'INSTITUTO CENTRO DE ENSINO TECNOLOGICO CARIRI', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4467, 4789, 'INSTITUTO CENTRO DE ENSINO TECNOLOGICO LIMOEIRO DO NORTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4468, 4790, 'FACULDADE DE TECNOLOGIA CENTEC SOBRAL', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4469, 4791, 'FACULDADE DE TECNOLOGIA CENTEC CARIRI', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4470, 4792, 'FACULDADE DE TECNOLOGIA CENTEC LIMOEIRO DO NORTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4471, 4793, 'FACULDADES INTEGRADAS DE ITARARE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4472, 4794, 'ESCOLA SUPERIOR DE ENGENHARIA E GESTAO DE VALINHOS ESEG', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4473, 4795, 'FACREI FACULDADE CRISTO REI', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4474, 4796, 'FACULDADE DE CIENCIAS APLICADAS DE CAMARAGIBE FAC', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4475, 4797, 'GOVERNADOR PAULO MALUF', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4476, 4798, 'FCS FACULDADE DE CIENCIAS DA SAUDE', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4477, 4799, 'CENTRO ODONTOLOGICO PIO XII', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4478, 4800, 'FACULDADE DE TECNOLOGIA CENECISTA DE RIO NEGRINHO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4479, 4801, 'FACULDADE LITERATUS JAU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4480, 4802, 'FACULDADE LITERATUS PIRACICABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4481, 4803, 'FACULDADE SENAI DE TECNOLOGIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4482, 4804, 'SECONE SERVICOS DE CONSULTORIA EDUCACIONAL', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4483, 4805, 'FACULDADE AMBIENTALISTA COMUNITARIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4484, 4806, 'INSTITUTO DE EDUCACAO COELHONETENSE', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4485, 4807, 'INSTITUTO SUPERIOR DE ODONTOLOGIA ISO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4486, 4808, 'FACULDADE ATHENEU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4487, 4809, 'INSTITUTO SUPERIOR DE EDUCACAO JK VALPARAISO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4488, 4810, 'FACULDADE ANTONIO MENEGHETTI', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4489, 4811, 'FACULDADE SENAI DE TECNOLOGIA ROBERTO SIMONSEN', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4490, 4812, 'FACULDADE SENAI DE TECNOLOGIA ROBERTO MANGE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4491, 4813, 'FACULDADE SENAI DE TECNOLOGIA GASPAR RICARDO JUNIOR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4492, 4814, 'FACULDADE DE TECNOLOGIA SENAI FELIX GUISARD', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4493, 4815, 'FACULDADE DE TECNOLOGIA SENAI NADIR DIAS DE FIGUEIREDO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4494, 4816, 'FACULDADE SENAI DE TECNOLOGIA SUICO BRASILEIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4495, 4817, 'FACULDADE DE TECNOLOGIA SENAI ANCHIETA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4496, 4818, 'FACULDADE SENAI DE TECNOLOGIA HORACIO AUGUSTO DA SILVEIRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4497, 4819, 'FACULDADE DE TECNOLOGIA SENAI MARIANO FERRAZ', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4498, 4820, 'FACULDADE DE TECNOLOGIA SENAI ANTONIO ADOLPHO LOBBE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4499, 4821, 'FACULDADE DE CIENCIAS GERENCIAIS E EMPREENDEDORISMO FACIGE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4500, 4822, 'FACULDADE DE TEOLOGIA BATISTA BETEL FTBB', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4501, 4823, 'FACULDADE DE TECNOLOGIA EVOLUCAO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4502, 4824, 'INSTITUTO LABORATIVA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4503, 4825, 'FACULDADE DE CIENCIAS E TECNOLOGIA DO MARANHAO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4504, 4826, 'FACULDADE ANHANGUERA DE CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4505, 4827, 'CENTRO AVANCADO DE ENSINOEDUCACAO E CULTURA CAEEC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4506, 4828, 'FACULDADE DE TECNOLOGIA CAMPIUOL', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4507, 4829, 'ESCOLA SUPERIOR DE ARTES CELIA HELENA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4508, 4830, 'SEMINARIO MAIOR IMACULADO CORACAO DE MARIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4509, 4831, 'FACULDADE DE TECNOLOGIA DE SAO JOSE DOS CAMPOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4510, 4832, 'FACULDADE POLITECNICA DE TAUBATE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4511, 4833, 'FACULDADE DE TECNOLOGIA DE VALENCA FACTIVA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4512, 4834, 'INSTITUTO DE EDUCACAO MORUMBI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4513, 4836, 'FACULDADE DE EDUCACAO ACRIANA EUCLIDES DA CUNHA', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4514, 4837, 'FACULDADE IESPLAC', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4515, 4838, 'INSTITUTO SUPERIOR DE EDUCACAO MONTEIRO LOBATO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4516, 4839, 'FACULDADE DE CIENCIAS LETRAS E ARTES LUIZA DE MARILLAC', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4517, 4840, 'HD HEALTH DENTAL ENSINO ODONTOLOGICOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4518, 4841, 'FACULDADE WITTENBERG', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4519, 4842, 'INSTITUTO RACINE EDITORA INDUSTRIAL E SERVICOS LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4520, 4843, 'INSTITUTO DE TEOLOGIA PASTORAL E ENSINO SUPERIOR DA AMAZONIA ITEPES', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4521, 4844, 'FTC EAD FACULDADE DE TECNOLOGIA E CIENCIAS ENSINO A DISTANCIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4522, 4845, 'FACULDADE DA IGREJA MIISTERIO FAMA FAIFA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4523, 4846, 'FACULDADE VERTICE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4524, 4847, 'FACULDADE DIOCESANA DE MOSSORO', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4525, 4848, 'FACULDADE OBOE FACO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4526, 4849, 'FACULDADE DE CIENCIAS HUMANAS, ECONOMICAS E DA SAUDE DE ARAGUAINA', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4527, 4850, 'MUSEU DE ASTRONOMIA E CIENCIAS AFINS MAST', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4528, 4851, 'FACULDADE E INSTITUTO SUPERIOR TECNOLOGICO E EDUCACIONAL FATEC PARACATU', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4529, 4852, 'FACULDADE E INSTITUTO SUPERIOR TECNOLOGICO E EDUCACIONAL FATEC PATOS DE MINAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4530, 4853, 'FACULDADE E INSTITUTO SUPERIOR TECNOLOGICO E EDUCACIONAL FATEC UBERABA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4531, 4854, 'FACULDADE RADIAL CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4532, 4855, 'FACULDADE DO CENTRO DO RIO GRANDE DO SUL FACERGS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4533, 4856, 'FACULDADE DE ADMINISTRACAO CIENCIAS HUMANAS E SOCIAIS BOM JESUS GO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4534, 4857, 'IEST INSTITUTO DE EDUCACAO SUPERIOR DE TAGUATINGA SOCIEDADE SIMPLES', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4535, 4858, 'ESCOLA SUPERIOR DE SAUDE DE ARCOVERDE', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4536, 4859, 'FACULDADE DE TECNOLOGIA FAESA UNIDADE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4537, 4860, 'CENTRO BRASILEIRO DE EXCELENCIA EM POS GRADUACAO NA SAUDE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4538, 4861, 'FACULDADE PITAGORAS DE POUSO ALEGRE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4539, 4862, 'FACULDADE PITAGORAS DE JUIZ DE FORA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4540, 4863, 'FACULDADE PITAGORAS DE POCOS DE CALDAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4541, 4864, 'FACULDADE PITAGORAS DE GOVERNADOR VALADARES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4542, 4865, 'FACULDADE PITAGORAS DE SAO LUIZ', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4543, 4866, 'FACULDADE PITAGORAS DE CONTAGEM', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4544, 4867, 'FACULDADE PITAGORAS DE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4545, 4868, 'FACULDADE HSM', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4546, 4869, 'FACULDADE DE TECNOLOGIA PITAGOTAS UNIDADE LONDRINA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4547, 4870, 'FACULDADE DE SOBRAL FASOL', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4548, 4871, 'FACULDADE INTEGRADAS DO MEORENO EM CARUARU FIAMCA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4549, 4872, 'FACULDADE ETNIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4550, 4873, 'FACULDADE DE TECNOLOGIA DE TAUBATE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4551, 4874, 'INSTITUTO DE EDUCACAO E CULTURA DO OESTE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4552, 4875, 'FACULDADES INTEGRADAS CIRCUITO DAS AGUAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4553, 4876, 'FACULDADE TECNOLOGICA GERACAO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4554, 4877, 'FACULDADE MESSEJANA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4555, 4878, 'FACULDADE ANHANGUERA DE ITAPECERICA DA SERRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4556, 4879, 'FUNDACAO PARA O DESENVOLVIMENTO CIENTIFICO E TECNOLOGICO DA ODONTOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4557, 4880, 'FACULDADE DE DIREITO DE GUARANTA DO NORTE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4558, 4881, 'FACULDADE VILAVELHENSE', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4559, 4882, 'FACULDADE DE IBIRACU', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4560, 4883, 'FACULDADE DE MEDICINA DE MINAS GERAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4561, 4884, 'FACULDADE ATENAS MARANHENSE DE IMPERATRIZ MA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4562, 4885, 'FACULDADE PORTO SEGURO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4563, 4886, 'INSTITUTO SUPERIOR DE EDUCACAO PORTO SEGURO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4564, 4887, 'FACULDADE DO CIRCUITO DAS AGUAS PAULISTA FAC AP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4565, 4888, 'CURSO NACIONAL DE ATUALIZACAO EM NUTROLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4566, 4889, 'FACULDADE DE CONCHAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4567, 4890, 'FACULDADE DO FUTURO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4568, 4891, 'FACULDADE DE TEOLOGIA INTEGRADA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4569, 4892, 'FUNDACAO DE ADMINISTRACAO E PESQUISA ECONOMICO SOCIAL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4570, 4893, 'FACULDADE DE GESTAO E TECNOLOGIA ASSUMPCAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4571, 4894, 'INSTITUTO DE ENSINO E PESQUISA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4572, 4895, 'ESCOLA DE APERFEICOAMENTO PROFISSIONAL ABO REGIONAL DE UBERLANDIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4573, 4896, 'INSTITUTO FLEURY', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4574, 4897, 'PROCEAD PROMOTORA DE CURSOS LTDA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4575, 4898, 'FACULDADE DE EDUCACAO E ARTES SAO GERALDO', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4576, 4899, 'FACULDADE DE CIENCIAS MEDICAS DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4577, 4900, 'FACULDADE VALE DO OURO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4578, 4901, 'FACULDADE FASIPE', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4579, 4902, 'FACULDADE BATISTA PIONEIRA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4580, 4903, 'FACULDADE MONITOR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4581, 4904, 'FACULDADE SENAI DE TECNOLOGIA " EUVALDO LODI "', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4582, 4905, 'FACULDADE SENAI DE TECNOLOGIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4583, 4906, 'FACULDADE SENAI DE TECNOLOGIA MARCELINO CORRADI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4584, 4907, 'FACULDADE SENAI DE TECNOLOGIA "JOSE FAGUNDES NETTO "', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4585, 4908, 'FACULDADE SENAI DE TECNOLOGIA DE UBERLANDIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4586, 4909, 'FACULDADE SENAI DE TECNOLOGIA " FIDELIS REIS "', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4587, 4910, 'FACULDADE DO TRABALHO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4588, 4911, 'CEPAEM CENTRO PARANAENSE DE ESTUDOS MEDICOS LTDA', 4, 2, 'AC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4589, 4912, 'FACULDADE EXPOENTE', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4590, 4913, 'FACULDADE SAO VICENTE DE LAVRAS', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4591, 4914, 'SENSU CONSULTORIA ORGANIZACIONAL LTDA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4592, 4915, 'FACULDADE DE CASTANHAL', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4593, 4916, 'FACULDADE CATOLICA DO SUL DO MARANHAO CASUMA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4594, 4917, 'ESCOLA SUPERIOR DE ADMINISTRACAO, MARKETING E COMUNICACAO DE PIRACICABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4595, 4918, 'FACULDADE CENECISTA DE JARDIM DO SERIDO', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4596, 4919, 'FACULDADE UNIPROCESSUS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4597, 4920, 'FACULDADE DO ENSINO SUPERIOR DO MUNICIPIO DE LINHARES', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4598, 4921, 'FACULDADE DE ALMIRANTE TAMANDARE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4599, 4922, 'FACULDADE INTEGRADA DAS CATARATAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4600, 4923, 'INSTITUTO SABER', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4601, 4924, 'CENTRO DE ESTUDOS AVANCADOS DA CONSERVACAO INTEGRADA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4602, 4925, 'FUNDACAO UNIVERSIDADE FEDERAL DO ABC', 1, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4603, 4926, 'FACULDADE DE TECNOLOGIA DE PRAIA GRANDE', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4604, 4927, 'INSTITUTO SUPERIOR DE CIENCIAS DA SAUDE VERDE NORTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4605, 4928, 'INSTITUTO SUPERIOR DE CIENCIAS SOCIAIS APLICADAS VERDE NORTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4606, 4929, 'CESUC CENTRO DE ENSINO SUPERIOR DE CUIABA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4607, 4930, 'FACULDADE DE SAUDE DE PAULISTA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4608, 4931, 'INSTITUTO SUPERIOR DE EDUCACAO CECAP', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4609, 4932, 'IES CEAJUFE INSTITUICAO DE ENSINO SUPERIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4610, 4933, 'FACULDADE POLITECNICA DE ALAGOAS', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4611, 4934, 'FACULDADE DE ENSINO SUPERIOR DE CIENCIAS HUMANAS', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4612, 4935, 'FACULDADE DO TRABALHO DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4613, 4936, 'INSTITUTO AGORA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4614, 4937, 'INSTITUTO LOGOS DE EDUCACAO SUPERIOR', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4615, 4938, 'FACULDADE CLARETIANA DE TEOLOGIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4616, 4939, 'FACULDADE 2 DE JULHO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4617, 4940, 'CENTRO DE ESTUDOS PESQUISAS E POS GRADUACAO EM ODONTOLOGIA CEPPO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4618, 4941, 'FACULDADES INTEGRADAS DE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4619, 4942, 'FAEME FACULDADE EVANGELICA DO MEIO NORTE DE MARITUBA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4620, 4943, 'ESCOLA SUPERIOR DE ADMINISTRACAO E GESTAO DA BAIXADA SANTISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4621, 4944, 'DENTAL PRESS CENTRO DE PESQUISA E POS GRADUACAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4622, 4945, 'FACULDADE INTERNACIONAL DO DELTA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4623, 4946, 'FACULDADE DE AGRONOMIA E EDUCACAO TECNOLOGICA DE SOORETAMA FAETES', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4624, 4947, 'FACULDADE VITORIA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4625, 4948, 'FACULDADES DAS AGUAS QUENTES', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4626, 4949, 'FCA FACULDADE CIRCUITO DAS AGUAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4628, 4951, 'FACULDADE ABERTA DE CIENCIAS MODERNAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4629, 4952, 'FACULDADE TEOLOGICA SULBRASILEIRA FATESUL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4630, 4953, 'CENTRO DE ESTUDOS E PESQUISAS EM ORTODONTIA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4631, 4954, 'ESCOLA DE ENSINO SUPERIOR ALTERNATIVO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4632, 4956, 'ESCOLA PAULISTA DA MAGISTRATURA', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4633, 4957, 'FACULDADE BRASILEIRA DE CULTURA E EDUCACAO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4634, 4958, 'FACULDADE CORPORATIVA CESPI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4635, 4959, 'FACULDADE PITAGORAS DE FEIRA DE SANTANA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4636, 4960, 'FACULDADE DE TECNOLOGIA LAGOA DA PAMPULHA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4637, 4961, 'FACULDADE INTEGRADA DE ARAGUATINS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4638, 4962, 'CENTRO UNIVERSITARIO DE SETE LAGOAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4639, 4963, 'FACULDADE PRESBITERIANA MACKENZIE', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4640, 4964, 'FACULDADE DE CIENCIAS E TECNOLOGIA DO MARANHAO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4641, 4965, 'FACULDADE VEZ DO MESTRE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4642, 4967, 'ESCOLA SUPERIOR DE DIREITO MUNICIPAL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4643, 4969, 'FACULDADE ITOP', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4644, 4970, 'FACULDADE FLORES DA CUNHA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4645, 4971, 'CENTRO DE ESTUDOS E TECNICAS ODONTOLOGICAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4646, 4972, 'FACULDADE ALFREDO NASSER DE REMANSO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4647, 4973, 'FACULDADE SENAI DE TECNOLOGIA DE POCOS DE CALDAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4648, 4974, 'INSTITUTO CATARINENSE DE ESTUDOS AVANCADOS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4649, 4975, 'FACULDADE OBOE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4650, 4976, 'INSTITUTO DE ESTUDOS SUPERIORES DO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4651, 4977, 'FACULDADE DE TECNOLOGIA APOENA FTA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4652, 4978, 'ALPHA SMILE CENTRO CURSOS PESQUISAS ODON COM LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4653, 4979, 'FACULDADE DE LAVRAS DA MANGABEIRA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4654, 4980, 'CLIVO POS GRADUACAO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4655, 4981, 'FACULDADE UNICESP SAUDE', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4656, 4982, 'FACULDADE METROPOLITANA DO PLANALTO NORTE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4657, 4983, 'FACULDADE DE SAO JOSE DOS CAMPOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4658, 4984, 'ASSOCIACAO DE ENSINO SUPERIOR BARAO DE JUNDIAI AESB', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4659, 4985, 'FACULDADE PARA O DESENVOLVIMENTO SUSTENTAVEL DO NORDESTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4660, 4986, 'CENTRO UNIVERSITARIO DA TERRA PAULISTA UNITERRA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4661, 4987, 'ESCOLA SUPERIOR DE APERFEICOAMENTO PROFISSIONAL', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4662, 4988, 'FACULDADE DE TECNOLOGIA INED DE IPATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4663, 4989, 'CITE CENTRO INTEGRADO DE TERAPIAS ENERGETICAS', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4664, 4990, 'INSTITUTO DE DESENVOLVIMENTO TECNOLOGICO DO CENTRO OESTE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4665, 4991, 'FACULDADE DE TECNOLOGIA FAMEG FAMETEC', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4666, 4992, 'FACULDADE DE TECNOLOGIA CENTEC SERTAO CENTRAL', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4667, 4993, 'FACULDADE DE TECNOLOGIA DO IBRATE FAITEC', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4668, 4994, 'FACULDADE LOURENCO FILHO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4669, 4995, 'FACULDADE CRUZ AZUL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4670, 4996, 'FACULDADE TECNOLOGICA DO ESTADO DO ESPIRITO SANTO FATEES', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4671, 4997, 'FACULDADE DO AGRESTE SETENTRIONAL DE PERNAMBUCO FASPE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4672, 4998, 'FACULDADE DE TECNOLOGIA INESUL DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4673, 4999, 'FACULDADE INTEGRADO DO MARANHAO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4674, 5000, 'FACULDADE ESTACAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4675, 5001, 'CENTRO UNIVERSITARIO AUTONOMO DO BRASIL UNIBRASIL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4676, 5002, 'SINDICATO DOS PROFESSORES DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4677, 5003, 'FACULDADE DE CIENCIAS MEDICAS DO PARA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4678, 5004, 'ABO SECAO CEARA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4679, 5005, 'CEUNI COMPLEXO EDUCACIONAL UNICIDADE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4680, 5006, 'FACULDADE REDENTOR DE CAMPOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4681, 5007, 'FACULDADE ORTODOXA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4682, 5008, 'FACULDADE DO MEDIO PARNAIBA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4683, 5009, 'FACULDADE DO AMAZONAS FAMA', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4684, 5010, 'FACULDADE DENIZARD RIVAIL', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4685, 5011, 'FACULDADE BATISTA DO CARIRI', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4686, 5012, 'FACULDADE RELIGARE PIAUIENSE', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4687, 5013, 'CENTRO UNIVERSITARIO ESTADUAL DA ZONA OESTE', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4688, 5014, 'CENTRO TECNOLOGICO UNIVERSITARIO DO ESTADO DO RIO DE JANEIRO', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4689, 5015, 'INSTITUTO SUPERIOR DE TECNOLOGIA EM HORTICULTURA', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4690, 5016, 'FACULDADE DE EDUCACAO TECNOLOGICA DO ESTADO DO RIO DE JANEIRO FAETERJ', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4691, 5017, 'FACULDADE DE EDUCACAO TECNOLOGICA DO ESTADO DO RIO DE JANEIRO FAETERJ', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4692, 5018, 'INSTITUTO SUPERIOR DE EDUCACAO PROFESSOR ALDO MUYLAERT', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4693, 5019, 'INSTITUTO SUPERIOR DE EDUCACAO DA ZONA OESTE', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4694, 5020, 'FACULDADE DE EDUCACAO TECNOLOGICA DO ESTADO DO RIO DE JANEIRO FAETERJ', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4695, 5021, 'FACULDADE DE EDUCACAO TECNOLOGICA DO ESTADO DO RIO DE JANEIRO FAETERJ', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4696, 5022, 'FACULDADES INTEGRADAS PREVE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4697, 5023, 'FACULDADE SANTO AUGUSTO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4698, 5024, 'ESCOLA AGROTECNICA FEDERAL DE SERTAO', 1, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4699, 5025, 'FACULDADE DE EDUCACAO SAO BRAZ', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4700, 5026, 'UNIRATI INSTITUICAO DE ENSINO SUPERIOR IRATI S C LTDA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4701, 5027, 'FAPETRO FACULDADE DE PETROLEO E GAS LTDA', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4702, 5028, 'IBEFIN INSTITUTO BRASILEIRO DE ESTUDOS EM FINANCAS E NEGOCIOS', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4703, 5029, 'FAMA FACULDADE DE MARABA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4704, 5030, 'FACULDADE DE FILOSOFIA E CIENCIAS DO PLANALTO FAFICIP', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4705, 5031, 'ESCOLA SUPERIOR NACIONAL DE SEGUROS DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4706, 5032, 'ILAPE POS GRADUACAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4707, 5033, 'FACULDADE PRISMA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4708, 5034, 'EDUCC EDUCACAO PROF CAP E CONSULTORIA LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4709, 5035, 'FACULDADE DA FUNDACAO UNIVERSITARIA DE CARDIOLOGIA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4710, 5036, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA CATARINENSE', 1, 1, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4711, 5037, 'FUNDACAO DE APOIO AO INSTITUTO DE PESQUISAS TECNOLOGICAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4712, 5038, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS DE MARABA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4713, 5039, 'FACULDADE DE PSICOLOGIA FUNFARME', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4714, 5040, 'FACULDADE BAHIANA DE ENGENHARIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4715, 5041, 'ITEP INSTITUTO DE TECNOLOGIA ENSINO E PESQUISA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4716, 5042, 'SEMINARIO NACIONAL ITEJ', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4717, 5043, 'INSTITUTO SUPERIOR DE EDUCACAO DE CARAPICUIBA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4718, 5044, 'FACULDADE DE DIREITO DE GARANHUNS', 3, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4719, 5045, 'FACULDADE DE TECNOLOGIA PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4720, 5046, 'FACULDADE POLIS DAS ARTES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4721, 5047, 'FACULDADE DO INTERIOR PAULISTA FIP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4722, 5048, 'FACULDADE DE TEOLOGIA DE SAO PAULO DA IGREJA PRESBITERIANA INDEPENDENTE DO BRASIL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4723, 5049, 'INSTITUTO DE ENSINO SUPERIOR SAO FRANCISO DE ASSIS DE TEOFILO OTONI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4724, 5050, 'FACULDADE ARAUTOS DO EVANGELHO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4725, 5051, 'FACULDADE DE EDUCACAO TECNOLOGICA DO ESTADO DO RIO DE JANEIRO FAETERJ', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4726, 5052, 'FACULDADE DE EDUCACAO TECNOLOGICA DO ESTADO DO RIO DE JANEIRO FAETERJ', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4727, 5053, 'FACULDADE DE EDUCACAO TECNOLOGICA DO ESTADO DO RIO DE JANEIRO', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4728, 5054, 'INSTITUTO SUPERIOR DE EDUCACAO DO SERTAO DO PAJEU', 2, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4729, 5055, 'INSTITUTO LOBO PARA O DESENVOLVIMENTO DA EDUCACAO DA CIENCIA E DA TECNOLOGIA NAO IES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4730, 5056, 'FACULDADE DE TECNOLOGIA UNIBRATEC MACEIO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4731, 5057, 'FACULDADE SAO VICENTE DE PAULO FASVIP', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4732, 5058, 'FACULDADE DE TECNOLOGIA PEDRO ROGERIO GARCIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4733, 5059, 'INSTITUTO DO CORACAO DO DISTRITO FEDERAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4734, 5060, 'FACULDADE DE TECNOLOGIA DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4735, 5061, 'FACULDADE NATAL FN', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4736, 5062, 'FACULDADE DE PIRACICABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4737, 5063, 'FACULDADE DE TECNOLOGIA INED UNIDADE TIMOTEO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4738, 5064, 'CENTRO DE FORMACAO TREINAMENTO E APERFEICOAMENTO', 1, 1, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4739, 5065, 'FACULDADE CONSULTIME DO ESPIRITO SANTO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4740, 5066, 'FACULDADE PITAGORAS DE TECNOLOGIA DE CONTAGEM', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4741, 5067, 'FACULDADE PITAGORAS DE UBERLANDIA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4742, 5068, 'FACEAR FACULDADE EDUCACIONAL ARAUCARIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4743, 5069, 'FACULDADE PADRAO DE PORANGATU', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4744, 5070, 'FACULDADE DE MEDICINA CARLOS CHAGAS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4745, 5071, 'FACULDADE NORTE CAPIXABA DE SAO MATEUS FAMAT', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4746, 5072, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECAO MARANHAO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4747, 5073, 'FACULDADE PITAGORAS DE DIVINOPOLIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4748, 5074, 'INSTITUTO EDUCACIONAL DE ENSINO SUPERIOR FACLESTE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4749, 5075, 'ESCOLA AGROTECNICA FEDERAL DE CACERES', 1, 1, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4750, 5076, 'BRAZIL GLOBAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4751, 5077, 'UNIVERSIDADE ESTADUAL DE RORAIMA', 2, 1, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4752, 5078, 'UNIPED', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4753, 5079, 'FACULDADE EDUCACIONAL DE MATELANDIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4754, 5080, 'CETEC LAGOS CENTRO DE CAPACITACAO TECNOLOGICA DA REGIAO DOS LAGOS LTDA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4755, 5081, 'DIFERENCIAL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4756, 5082, 'FUNETEC', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4757, 5083, '1344 ESCOLA SUPERIOR DE HOTELARIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4758, 5084, 'FACIAC FACULDADE DE CIENCIAS APLICADAS DE CATANDUVAS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4759, 5085, 'FACULDADE REGIONAL DE TIMBO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4760, 5086, 'ESAMC ESCOLA SUPERIOR DE ADMINISTRACAO MARKETING E COMUNICACAO DE MACEIO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4761, 5087, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECAO DISTRITO FEDERAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4762, 5088, 'IBRAFA CENTRO DE ESTUDOS EM SAUDE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4763, 5089, 'FACULDADE DE TECNOLOGIA APOENA FTA', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4764, 5090, 'FACULDADE DO PROFESSOR', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4765, 5091, 'INSTITUTO DE ESTUDOS SUPERIORES E POS GRADUACAO IESP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4766, 5092, 'UNIVALE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4767, 5093, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECCAO DO ESTADO DO RIO GRANDE DO NORTE', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4768, 5094, 'FACULDADE EVOLUCAO ALTO OESTE POTIGUAR', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4769, 5095, 'FIESU FACULDADE INTERNACIONAL DE ENSINO SUPERIOR', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4770, 5096, 'ESCOLA AGROTECNICA FEDERAL DE ARAGUATINS', 1, 1, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4771, 5097, 'FACULDADE VALE DOS CARAJAS', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4772, 5098, 'FACULDADE CELEIRO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4773, 5099, 'FACULDADE DE TECNOLOGIA DE SAO BERNARDO DO CAMPO', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4774, 5100, 'FACULDADE MACHADINHO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4775, 5101, 'FACULDADE CENTRO OESTE DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4776, 5102, 'INSTITUTO NACIONAL DE ENSINO AVANCADO LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4777, 5103, 'IEP INSTITUTO DE ESTUDOS PREVIDENCIARIOS', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4778, 5104, 'ESAD ESCOLA DE ADMINISTRACAO E NEGOCIOS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4779, 5105, 'FACULDADE INTERNACIONAL SIGNORELLI', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4780, 5106, 'INSTITUTO DE GESTAO EDUCACIONAL SIGNORELLI', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4781, 5107, 'FACULDADE SOGIPA DE EDUCACAO FISICA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4782, 5108, 'ASSOCIACAO INSTITUTO SAPIENTIAE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4783, 5109, 'ESCOLA SUPERIOR DE TERAPIA INTEGRAL', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4784, 5110, 'FAINP FACULDADE DE INTEGRACAO DO NOROESTE PARANAENSE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4785, 5111, 'INSTITUTO DE ENSINO E PESQUISA E POS GRADUACAO EM EDUCACAO E SAUDE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4786, 5112, 'FACULDADE UNIAO ARARUAMA DE ENSINO SS LTDA.', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4787, 5113, 'FACULDADE UNIMAC', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4788, 5114, 'INSTITUTO DE PESQUISAS EDUCACIONAIS PRAXIS LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4789, 5115, 'FACULDADE EXPANSAO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4790, 5116, 'FACULDADE EVOLUCAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4791, 5117, 'INSTITUTO DE EDUCACAO SUPERIOR DE SAO LOURENCO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4792, 5118, 'FACULDADE OMEGA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4793, 5119, 'FACULDADES MATISSE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4794, 5120, 'FACULDADE DINAMICA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4795, 5121, 'SEMINARIO BAIANO DE TEOLOGIA SEBATE', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4796, 5122, 'INSTITUTO CIMAN DE EDUCACAO E ENSINO SUPERIOR', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4797, 5123, 'ESCOLA DA MAGISTRATURA DO ESTADO DO RIO DE JANEIRO', 2, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4798, 5124, 'FACULDADE FACMIL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4799, 5125, 'INSTITUTO DE ENSINO E PESQUISA EM ODONTOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4800, 5126, 'ESCOLA BRASILEIRA DE MEDICINA CHINESA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4801, 5127, 'FACULDADE SOCIAL DE SAO PAULO FASSP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4802, 5128, 'FACULDADE SANTO ANDRE FASA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4803, 5129, 'ESCOLA AGROTECNICA FEDERAL DE CERES', 1, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4804, 5130, 'CEDEFACE CENTRO DE PESQUISA E POS GRADUACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4805, 5131, 'FACULDADE DE TECNOLOGIA SENAC CACADOR', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4806, 5132, 'FACULDADE SENAC CONCORDIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4807, 5133, 'FACULDADE DE TECNOLOGIA SENAC SAO MIGUEL DO OESTE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4808, 5134, 'FACULDADE SENAC CRICIUMA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4809, 5135, 'CENTRO UNIVERSITARIO DE RIO PRETO UNIRP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4810, 5136, 'FACULDADE SAO BOAVENTURA DE EDUCACAO CONTINUADA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4811, 5137, 'FATEC FACULDADE DE TEOLOGIA E CIENCIAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4812, 5138, 'INSTITUTO DELMIRENSE DE INSINO SUPERIOR', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4813, 5139, 'FACULDADE SANTA MARIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4814, 5140, 'IPEO MT', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4815, 5141, 'ESCOLA AGROTECNICA FEDERAL ANTONIO JOSE TEIXEIRA', 1, 1, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4816, 5142, 'FACULDADES TECNOLOGICAS DA SERRA GAUCHA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4817, 5143, 'FACULDADE LUTERANA DE TEOLOGIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4818, 5144, 'UNIAO METROPOLITANA DE EDUCACAO E CULTURA S C LTDA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4819, 5145, 'SOCIEDADE DE ENSINO SUPERIOR CEDRO S S LTDA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4820, 5146, 'FACULDADE PETROLINA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4821, 5147, 'ACADEMIA CEARENSE DE ODONTOLOGIA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4822, 5148, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECAO BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4823, 5149, 'ESCOLA SUPERIOR DE GESTAO E CIENCIAS DA SAUDE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4824, 5150, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4826, 5152, 'ESCOLA DA ADVOCACIA GERAL DA UNIAO', 1, 1, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4827, 5153, 'CENTRO DE POS GRADUACAO ILADEM', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4828, 5154, 'ASSSOCIACAO BRASILEIRA DE ODONTOLOGIA SECAO ALAGOAS', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4829, 5155, 'ABO REGIONAL UMUARAMA PR', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4830, 5156, 'UNIVERSIDADE CAMILO CASTELO BRANCO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4831, 5157, 'FACULDADES TECNOLOGICAS DA SERRA GAUCHA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4832, 5158, 'FACULDADE MARECHAL CANDIDO RONDON FAMAR', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4833, 5159, 'CENTRO AVANCADO DE ORTODONTIA PAULO PICANCO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4834, 5160, 'FACULDADE COMUNITARIA DE PINDAMONHANGABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4835, 5161, 'FACULDADE COMUNITARIA DE AMERICANA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4837, 5163, 'FACULDADE COMUNITARIA DE RIBEIRAO PRETO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4838, 5164, 'FACULDADE COMUNITARIA DE OSASCO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4839, 5165, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECAO RIO GRANDE DO SU8L', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4840, 5166, 'FACULDADE DE CIENCIAS DA SAUDE HIPOCRATES', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4841, 5167, 'FACULDADE DOMINGOS OLIMPIO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4842, 5168, 'ESCOLA AGROTECNICA FEDERAL DE CATU', 1, 1, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4843, 5169, 'UNICETREX POS GRADUACAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4844, 5170, 'UNIVERCAPANEMA FACULDADES DE LETRAS CIENCIAS TECNOLOGIA E DE BIOTECNOLOGIA DA SAUDE DE CAPANEMA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4845, 5171, 'GRUPO DO RIO DE JANEIRO DE ESTUDOS DE ORTODONTIA PELA TECNICA DO STRAIGHT WIRE DE ANDREWS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4846, 5172, 'FACULDADE DE TECNOLOGIA CENTEC SAO GONCALO DO AMARANTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4847, 5173, 'FACULDADE DE TECNOLOGIA DE PIRASSUNUNGA FATEPI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4848, 5174, 'BRAZILIAN BUSINESS SCHOOL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4849, 5175, 'FACULDADE IDAAM', 4, 2, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4850, 5176, 'FACULDADE DE DIREITO VALE DO ASSU', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4851, 5177, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECAO MS', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4852, 5178, 'MIRANDA E CARVALHO INSTITUTO DE PESQUISA POS GRADUACAO E SERVICOS EM ODONTOLOGIA LTDA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4853, 5179, 'FACULDADE SAINT PAUL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4854, 5180, 'FACULDADE DO POVO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4855, 5181, 'FACULDADE MOGIANA DO ESTADO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4856, 5182, 'IRMANDADE DA SANTA CASA DE MISERICORDIA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4857, 5183, 'INSTITUTO TECNOLOGICO DE ENSINO SUPERIOR BANDEIRANTES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4858, 5184, 'FACULDADE DE CIENCIAS E TECNOLOGIA DA BAHIA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4859, 5185, 'FACULDADE DO INSTITUTO NACIONAL DE POS GRADUACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4860, 5186, 'FACULDADE DINAMICA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4861, 5187, 'FAEJA FACULDADE ALBERT EINSTEIN DE JACIARA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4862, 5188, 'EXPANSAO GESTAO EM EDUCACAO E EVENTOS', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4863, 5189, 'FACULDADE BAIANA DE DIREITO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4864, 5190, 'INSTITUTO CATUAI DE ENSINO SUPERIOR', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4865, 5191, 'FAMAC FACULDADE DE MACHADINHO DO OESTE', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4866, 5192, 'CENTES CENTRO TECNOLOGICO DE ENSINO SUPERIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4867, 5193, 'FEIT FACULDADE DE ENGENHARIA E INOVACAO TECNOLOGICA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4868, 5194, 'ESCOLA SUPERIOR DE TEOLOGIA E ESPIRITUALIDADE FRANCISCANA ESTEF', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4869, 5195, 'FACULDADE DO VALE DO PAJEU', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4870, 5196, 'INSTITUTO NOSSA SENHORA DO PILAR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4871, 5197, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECCAO PIAUI', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4872, 5198, 'UNIBRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4873, 5199, 'CENTRO AVANCADO DE ENSINOEDUCACAO E CULTURA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4874, 5200, 'FACULDADE DE TECNOLOGIA INED UNIDADE BETIM', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4875, 5201, 'FACULDADE DE TECNOLOGIA INED UNIDADE BARREIRO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4876, 5202, 'FACULDADE INDEPENDENCIA FAI', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4877, 5203, 'FACULDADE MONTESSORIANO DE SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4878, 5204, 'INSTITUTO SUPERIOR DE EDUCACAO ANTONINO FREIRE ISEAF', 2, 1, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4879, 5205, 'INSTITUTO DE EDUCACAO SUPERIOR SUL BRASILEIRO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4880, 5206, 'IMEN INSTITUTO DE METABOLISMO E NUTRICAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4881, 5207, 'ATUALIZA POS GRADUACAO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4882, 5208, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECAO ESPIRITO SANTO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4883, 5209, 'INSTITUTO DE POS GRADUACAO DO PETROLEO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4884, 5210, 'FATESMA FACULDADE DE TECNOLOGIA SANTA MARIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4885, 5211, 'INSTITUTO SUPERIOR ISAG DE FORMACAO CONTINUADA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4886, 5212, 'COMISSAO CIENTIFICA SPP', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4887, 5213, 'INSTITUTO FISIOMAR', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4888, 5214, 'CENTRO DE ESTUDOS ODONTOLOGICOS DO IPSEMG', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4889, 5215, 'FACULDADES INTEGRADAS PADRE ALBINO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4890, 5216, 'FACULDADE ANHANGUERA DE EDUCACAO, CIENCIAS E TECNOLOGIA DE SOROCABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4891, 5217, 'FACULDADES INTEGRADAS PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4892, 5218, 'FACULDADE DE TECNOLOGIA PROFESSOR WALDOMIRO MAY', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4893, 5219, 'INSTITUTO SUPERIOR DE ENSINO EM FONOAUDIOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4894, 5220, 'INSTITUTO DE POSGRADUACAO E ATUALIZACAO EM ODONTOLOGIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4895, 5221, 'FUNDACAO ANTARES DE ENSINO SUPERIOR POS GRADUACAO PESQUISA E EXTENSAO', 1, 1, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4896, 5222, 'ESCOLA AGROTECNICA FEDERAL DE SOUSA', 1, 1, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4897, 5223, 'COORDENACAO GERAL DE EDUCACAO DA ANDIMA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4898, 5224, 'CENTRO DE POS GRADUACAO ESTUDOS PESQUISA E EXTENSAO INSPIRAR', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4899, 5225, 'IMEO INSTITUTO MINEIRO DE ESTUDOS ODONTOLOGICOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4900, 5226, 'IMEO INSTITUTO MINEIRO DE ESTUDOS ODONTOLOGICOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4901, 5227, 'SEPAI SERVICO DE PSICANALISE EM ATENCAO A INFANCIA COORDENACAO DE ASSUNTOS EDUCACIONAIS CAE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4902, 5228, 'FACULDADE RAIMUNDO MARINHO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4903, 5229, 'IPDR INSTITUTO DE POS GRADUACAO DAVID ROCHA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4904, 5230, 'INSTITUTO PRISMA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4905, 5231, 'LFG ESCOLA NACIONAL DE ESPECIALIZACAO LFG ENESP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4906, 5232, 'INSTITUTO TOCANTINENSE DE EDUCACAO A DISTANCIA', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4907, 5233, 'FUNDACAO DE APOIO A PESQUISA E ESTUDO NA AREA DE SAUDE FAPES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4908, 5234, 'FASS SISTEMA DE ENSINO A DISTANCIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4909, 5235, 'FACULDADE DE TECNOLOGIA IBRATEC', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4910, 5236, 'CENTRO DE ESTUDOS SUPERIORES DA FUNDACOR', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4911, 5237, 'INSTITUTO SUPERIOR DE FORMACAO CONTINUADA DOUGLAS ANDREANI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4912, 5238, 'INSTITUTO SAPIENTIA DE EDUCACAO SUPERIOR ISES', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4913, 5239, 'SBAC CENTRO DE POS GRADUACAO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4914, 5240, 'ASSOCIACAO BRASILEIRA DE ODONTOLOGIA SECCAO DO PARANA REGIONAL DE PONTA GROSSA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4915, 5241, 'MUSEU PARAENSE EMILIO GOELDI', 1, 1, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4916, 5242, 'UNIVERSIDADE ESTADUAL DE ALAGOAS UNEAL', 2, 1, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4917, 5243, 'FACULDADE DE CIENCIAS JURIDICAS DE SANTOS DUMONT', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4918, 5244, 'ASSOCIACAO DOS GESTORES DE CONHECIMENTO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4919, 5245, 'SOCIEDADE DE HIPNOSE MEDICA DO ESTADO DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4920, 5246, 'CENTRO DE ESTUDOS AVANCADOS EM SAUDE UNIMAGEM', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4921, 5247, 'INAPOS INSTITUTO NACIONAL DE ENSINO SUPERIOR E POS GRADUACAO PADRE GERVASIO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4922, 5248, 'INAPOS INSTITUTO NACIONAL DE ENSINO SUPERIOR E POS GRADUACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4923, 5249, 'V F LIMA CURSOS AVANCADOS', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4924, 5250, 'FACULDADE EVOLUTIVO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4925, 5251, 'INAPOS INSTITUTO NACIONAL DE ENSINO SUPERIOR E POS GRADUACAO PADRE GERVASIO', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5000, 5326, 'CIODONTO POS GRADUACAO SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4926, 5252, 'INAPOS INSTITUTO NACIONAL DE ENSINO SUPERIOR E POS GRADUACAO PADRE GERVASIO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4927, 5253, 'INAPOS INSTITUTO NACIONAL DE ENSINO SUPERIOR E POS GRADUACAO PADRE GERVASIO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4928, 5254, 'INSTITUTO SUPERIOR DE ODONTOLOGIA FACIAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4929, 5255, 'FACULDADE REGIONAL DE RIBEIRA DO POMBAL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4930, 5256, 'CENTRO DE ENSINO ESPECIAL SUPERIOR E PROFISSIONALIZANTE', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4931, 5257, 'APROBATUM CENTRO NACIONAL DE QUALIFICACAO DE PESSOAL LTDA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4932, 5258, 'INSTITUTO SUPERIOR ORTHODONTIC INTERNACIONAL', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4933, 5259, 'AGRICULTURA TROPICAL E SUBTROPICAL', 2, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4934, 5260, 'FACULDADE DE CRUZEIRO DO OESTE FACO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4935, 5261, 'CENTRO DE EDUCACAO DO HEMOCENTRO DE RIBEIRAO PRETO CEDUC HRP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4936, 5262, 'INSTITUICAO DE ENSINO UNIORKA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4937, 5263, 'CEU CENTRO DE EXTENSAO UNIVERSITARIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4938, 5264, 'INSTITUTO SUPERIOR DO MINISTERIO PUBLICO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4939, 5265, 'FACULDADE METROPOLITANA SAO CARLOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4940, 5266, 'INSTITUTO DE EDUCACAO SECULO XXI LTDA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4941, 5267, 'INSTITUTO EFICAZ CURSOS PROFISSIONALIZANTES DE MARINGA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4942, 5268, 'FACULDADE DE SAO JOAQUIM DA BARRA LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4943, 5269, 'FACULDADE CRISTA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4944, 5270, 'ESCOLA NACIONAL DE SAUDE PUBLICA ENSP', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4945, 5271, 'ESCOLA NACIONAL DE SAUDE PUBLICA', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4946, 5272, 'INSTITUTO DE POS GRADUACAO PIO XII', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4947, 5273, 'FACULDADE SANTA CRUZ', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4948, 5274, 'INSTITUTO SUPERIOR CULTURAL BRASILEIRO ISCB', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4949, 5275, 'FACULDADE DE CIENCIAS GERENCIAIS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4950, 5276, 'FACULDADE COMUNITARIA DE CARANGOLA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4951, 5277, 'FACULDADE FORTIUM', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4952, 5278, 'FACULDADE ATUAL', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4953, 5279, 'CRDA POS GRADUACOES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4954, 5280, 'FACULDADE DE EDUCACAO SUPERIOR COELHONETENSE', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4955, 5281, 'FACULDADE DE EDUCACAO CIENCIA E TECNOLOGIA DO VALE DO ACARAU', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4956, 5282, 'CENTRO DE ESTUDOS DE PESSOAL', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4957, 5283, 'HD ENSINOS ODONTOLOGICOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4958, 5284, 'FACULDADE PARA O ENSINO DAS CIENCIAS JURIDICAS INDEPENDENTEMENTE DE DISTANCIA FECJID', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4959, 5285, 'FACULDADES INTEGRADAS DE TAQUARA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4960, 5286, 'INSTITUTO DE CIENCIAS SOCIAIS E ECONOMICAS LTDA', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4961, 5287, 'NEO NUCLEO DE ESTUDOS ODONTOLOGICOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4962, 5288, 'FACULDADE ANHANGUERA DE RIBEIRAO PRETO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4963, 5289, 'FACULDADE DE DIREITO DO ESTADO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4964, 5290, 'FACULDADE DE CIENCIAS E TECNOLOGIA DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4965, 5291, 'FACULDADE ARAUTOS DO EVANGELHO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4966, 5292, 'FACULDADE VIPACS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4967, 5293, 'FACULDADE ANHANGUERA DE SUMARE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4968, 5294, 'FACULDADE DINAMICA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4969, 5295, 'CEPEO CENTRO DE ENSINO E PESQUISA EM ODONTOLOGIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4970, 5296, 'ESCOLA DA VILA ESPECIALIZACAO PEDAGOGICA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4971, 5297, 'ESCOLA NACIONAL DE ACUPUNTURA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4972, 5298, 'FACULDADE METAFISICA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4973, 5299, 'FACULDADE NOVO ATENEU DE GUARAPUAVA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4974, 5300, 'FAKCEN', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4975, 5301, 'FACULDADE RAIZES', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4976, 5302, 'IDEAL POS GRADUACAO S S LTDA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4977, 5303, 'FACULDADE ANHANGUERA DE DOURADOS', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4978, 5304, 'FACULDADE DE ENFERMAGEM DE SAO SEBASTIAO DO PARAISO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4979, 5305, 'FACULDADE DE CIENCIAS SOCIAIS APLICADAS E HUMANAS DE GARANHUNS', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4980, 5306, 'INSTITUTO SUPERIOR DE CIENCIAS AGRARIAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4981, 5307, 'FASES FACULDADE SHALOM DE ENSINO SUPERIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4982, 5308, 'IM T INSTUTO MUNDO TRABALHO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4983, 5309, 'CEPRENO CENTRO DE ESTUDOS PAULISTA DE REABILITACAO NEUROCLUSAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4984, 5310, 'FACULDADE CIMAN', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4985, 5311, 'FACULDADE GABARITO', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4986, 5312, 'FACULDADES ATIBAIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4987, 5313, 'FACULDADES UNIFICADAS DE CATAGUASES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4988, 5314, 'FACULDADES UNIFICADAS DE GUARAPARI', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4989, 5315, 'FACULDADES UNIFICADAS DE IUNA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4990, 5316, 'FACULDADES UNIFICADAS DE LEOPOLDINA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4991, 5317, 'FACULDADE PORTOALEGRENSE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4992, 5318, 'FACULDADE GUILHERME GUIMBALA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4993, 5319, 'INSTITUTO DE POS GRADUACAO AURELIO BUARQUE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4994, 5320, 'ESCOLA SUPERIOR DE ENSINO ANISIO TEIXEIRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4995, 5321, 'FESMIP', 2, 1, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4996, 5322, 'FUNDACAO UNIVERSIDADE FEDERAL DO PAMPA UNIPAMPA', 1, 1, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4997, 5323, 'INSTITUTO DE EDUCACAO SUPERIOR OLIVEIRAS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4998, 5324, 'CIODONTO POS GRADUACAO SANTOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (4999, 5325, 'CIODONTO POS GRADUACAO SAO JOSE DOS CAMPOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5001, 5327, 'CIODONTO POS GRADUACAO SAO PAULO I', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5002, 5328, 'CIODONTO POS GRADUACAO SERTAOZINHO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5003, 5329, 'CIODONTO POS GRADUACAO BELO HORIZONTE II', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5004, 5330, 'CIODONTO POS GRADUACAO ITAJAI', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5005, 5331, 'CIODONTO POS GRADUACAO RIO DE JANEIRO III', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5006, 5332, 'CIODONTO POS GRADUACAO VITORIA II', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5007, 5333, 'CIODONTO POS GRADUACAO VITORIA I', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5008, 5334, 'CIODONTO POS GRADUACAO ERECHIM', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5009, 5335, 'CIODONTO POS GRADUACAO FEIRA DE SANTANA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5010, 5336, 'CIODONTO POS GRADUACAO PORTO VELHO', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5011, 5337, 'CIODONTO POS GRADUACAO PORTO ALEGRE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5012, 5338, 'CIODONTO POS GRADUACAO RECIFE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5013, 5339, 'CIODONTO POGRADUACAO CUIABA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5014, 5340, 'CIODONTO POGRADUACAO CAMPO GRANDE', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5015, 5341, 'CIODONTO POS GRADUACAO MARINGA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5016, 5342, 'CIODONTO POS GRADUACAO PASSO FUNDO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5017, 5343, 'CIODONTO POS GRADUACAO FLORIANOPOLIS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5018, 5344, 'CIODONTO POS GRADUACAO GOIANIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5019, 5345, 'CIODONTO POS GRADUACAO GUARULHOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5020, 5346, 'CIODONTO POS GRADUACAO JOINVILLE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5021, 5347, 'CIODONTO POS GRADUACAO MACAPA', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5022, 5348, 'CIODONTO POS GRADUACAO RIO DE JANEIRO I', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5023, 5349, 'CIODONTO POS GRADUACAO BELO HORIZONTE I', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5024, 5350, 'CIODONTO POS GRADUACAO CURITIBA I', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5025, 5351, 'FACULDADE DE TECNOLOGIA INSTITUTO POLITECNICO DO PARANA UNIDADE GUARAPUAVA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5026, 5352, 'FACULDADE DE CIENCIAS E TECNOLOGIA DE NATAL', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5027, 5353, 'FACULDADE DE TECNOLOGIA BANDEIRANTES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5028, 5354, 'FACULDADE CAL DE ARTES CENICAS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5029, 5355, 'FACULDADE DE CIENCIAS E DESENVOLVIMENTO DO VALE DO CAPIBARIBE', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5030, 5356, 'FACULDADE FLUMINENSE DE ENGENHARIA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5031, 5357, 'FACULDADE DE CIENCIAS APLICADAS E TECNOLOGICAS DO LITORAL SUL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5032, 5358, 'FACULDADE INTEGRADO DE IMPERATRIZ', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5033, 5359, 'FACULDADE PAULO SETUBAL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5034, 5360, 'FACULDADE PADRE ANCHIETA DE VARZEA PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5035, 5361, 'FACULDADE PITAGORAS DE VOTORANTIM', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5036, 5362, 'FACULDADE SERIGY', 4, 2, 'SE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5037, 5363, 'INPET INSTITUTO NACIONAL DE PESQUISAS E ESTUDOS TRIBUTARIOS S S LTDA', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5038, 5364, 'FACULDADE ESPECIALIZADA NA AREA DE SAUDE DO RIO GRANDE DO SUL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5039, 5365, 'INSTITUTO TAQUARITINGUENSE DE ENSINO SUPERIOR DOUTOR ARISTIDES DE CARVALHO SCHLOBACH', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5040, 5366, 'CEOSP CENTRO DE ESTUDOS ODONTOLOGICOS SMILEPREV', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5041, 5367, 'CIODONTO POS GRADUACAO JOAO PESSOA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5042, 5368, 'CIODONTO POS GRADUACAO RIO DE JANEIRO II', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5043, 5369, 'FACULDADES INTEGRADAS ASMEC', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5044, 5370, 'FACULDADES UNIFICADAS DE TEOFILO OTONI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5045, 5371, 'CEFAC POS GRADUACAO EM SAUDE E EDUCACAO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5046, 5372, 'FACULDADE DE RONDONIA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5047, 5373, 'INSTITUTO NACIONAL DE ENSINO SUPERIOR E POS GRADUACAO PADRE GERVASIO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5048, 5374, 'FACULDADE BRASILEIRA DE ESTUDOS AVANCADOS FABEA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5049, 5375, 'ESCOLA SUPERIOR DE AVIACAO CIVIL', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5050, 5376, 'FACULDADE UNIESP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5051, 5377, 'INSTITUTO INTEGRAL DE PESQUISA E ENSINO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5052, 5378, 'INSTITUTO DE MEDICINA TROPICAL', 2, 1, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5053, 5379, 'INSTITUTO PAULISTA DE ESTUDOS SISTEMICOS IPES', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5054, 5380, 'INSTITUTO DE CRIMINOLOGIA E POLITICA CRIMINAL ICPC', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5055, 5381, 'NCD NUTROCLINICA CURSOS A DISTANCIA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5056, 5382, 'FACULDADE DE PINDAMONHANGABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5057, 5383, 'AFIP ASSOCIACAO FUNDO DE INCENTIVO A PSICOFARMACOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5058, 5384, 'IEN INSTITUTO SUPERIOR DE ENSINO DE NEUROPSICOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5059, 5385, 'FACULDADE DO INSTITUTO DE EDUCACAO EM NEGOCIOS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5060, 5386, 'FACULDADES IBDI CAMBORIU', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5061, 5387, 'FACULDADE IMPACTA DE TECNOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5062, 5388, 'FACULDADES UNIVERSITAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5063, 5389, 'INSTITUTO HELIOPOLIS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5064, 5390, 'FACULDADE METROPOLITANA SAO CARLOS BJI', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5065, 5391, 'THUM INSTITUTO DE POS GRADUACAO E BIOPESQUISAS LTDA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5066, 5392, 'INSTITUTO DE PESQUISA E ENSINO ODONTOLOGICO LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5067, 5393, 'INSTITUTO SOBRAIMO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5068, 5394, 'INSTITUTO DE ENSINO SUPERIOR INTEGRADOIESI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5069, 5395, 'INSTITUTO DE ENSINO SUPERIOR MICHELANGELO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5070, 5396, 'INSTITUTO SUPERIOR DA ASSOCIACAO FLUMINENSE DE AMPARO AOS CEGOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5071, 5397, 'FACULDADE DE EDUCACAO E CULTURA DE VILHENA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5072, 5398, 'FACULDADE SUPERIOR DE ENSINO QUALIFICADO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5073, 5399, 'FACULDADE METROPOLITANA DE EDUCACAO E CULTURA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5074, 5400, 'FACULDADE FAMA DE SAO LUIS', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5075, 5401, 'INSTITUTO SUPERIOR DE ENSINO E PESQUISA SAO RAFAEL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5076, 5402, 'FUNDACAO JOAQUIM NABUCO', 1, 1, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5077, 5403, 'FACULDADES OPET', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5078, 5404, 'INSTITUTO BRASILEIRO DE THERAPIAS E ENSINO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5079, 5405, 'ARCA INSTITUTO DE POS GRADUACAO E SERVICOS EM ODONTOLOGIA LTDA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5080, 5406, 'INSTITUTO ORAL ESTHETIC DE POS GRADUACAO E APERFEICOAMENTO EM ODONTOLOGIA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5081, 5407, 'SISTEMA EDUCACIONAL CORPORATIVO', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5082, 5408, 'INSTITUTO BRASILEIRO DE POS GRADUACAO IBPG', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5083, 5409, 'ASSOCIACAO BRASILEIRA DE CIRURGIOES DENTISTAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5084, 5410, 'ASSOCIACAO BRASILEIRA DE CIRURGIOES DENTISTAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5085, 5411, 'ASSOCIACAO PAULISTA DE CIRURGIOES DENTISTAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5086, 5412, 'CENTRO DE DESENVOLVIMENTO CIENTIFICO EM SAUDE', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5087, 5413, 'FACULDADE DOTTORI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5088, 5414, 'ASSOCIACAO PAULISTA DE CIRURGIOES DENTISTAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5089, 5415, 'FACULDADES UNIDAS DE PESQUISA CIENCIAS E SAUDE LTDA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5090, 5416, 'FACULDADE METROPOLITANA DE LAGES', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5091, 5417, 'FACULDADE LA SALLE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5092, 5418, 'FACULDADE IBMEC DISTRITO FEDERAL', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5093, 5419, 'FACULDADE EVANGELICA DE TAGUATINGA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5094, 5420, 'FACULDADE DE TECNOLOGIA IBDI BLU', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5095, 5421, 'FACULDADE DE TECNOLOGIA IBDI', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5096, 5422, 'FACULDADE DE TECNOLOGIA SENAI CUIABA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5097, 5423, 'GANEP GRUPO DE NUTRICAO HUMANA LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5098, 5424, 'INSTITUTO LEGISLATIVO BRASILEIRO', 1, 1, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5099, 5425, 'FACULDADE DE TECNOLOGIA EM SAUDE CIEPH', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5100, 5426, 'IMES INSTITUTO MINEIRO DE EDUCACAO SUPERIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5101, 5427, 'FCETM FACULDADE DE CIENCIAS ECONOMICAS DO TRIANGULO MINEIRO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5102, 5428, 'FACULDADE ILAPE', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5103, 5429, 'INSTITUTO SUPERIOR DE ENSINO DE ACREDITACAO E QUALIDADE EM SAUDE ISAQS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5104, 5430, 'FACULDADE DE TECNOLOGIA DE MINAS GERAIS FATEMIG', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5105, 5431, 'CEOSP CENTRO DE ENSINO ODONTOLOGICO SMILE PREV LTDA', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5106, 5432, 'SOCIEDADE EDUCACIONAL RIOGRANDENSE LTDA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5107, 5433, 'INSTITUTO BRASILEIRO DA FORMACAO E DO EMPREGO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5108, 5434, 'CENTRO HERMES DE EDUCACAO SUPERIOR', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5109, 5435, 'FACULDADE DE TECNOLOGIA DO TRANSPORTE', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5110, 5436, 'FACULDADE DO PROFESSOR', 4, 2, 'AP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5111, 5437, 'FACULDADE PASSIONISTA DE EDUCACAO DE CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5112, 5438, 'FACULDADE DE TECNOLOGIA DE ENSINO SUPERIOR', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5113, 5439, 'FACULDADES INTEGRADAS DA UNIAO EDUCACIONAL DO PLANALTO CENTRAL FACIPLAC', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5114, 5440, 'FACULDADE SEAC', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5115, 5441, 'POS GRADUACAO IREI', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5116, 5442, 'FACULADE DE CIENCIAS JURIDICAS DE NOVA LIMA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5117, 5443, 'FACULDADE ANDREAS PALLADIO ARTES CIENCIAS', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5118, 5444, 'FACULDADE DE EDUCACAO, TECNOLOGIA E ADMINISTRACAO DE CAARAPO', 4, 2, 'MS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5119, 5445, 'FACULDADE DE TECNOLOGIA SAINT PAUL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5120, 5446, 'FACULDADE NOBREGA', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5121, 5447, 'FACULDADE PARA O DESENVOLVIMENTO DO SUDESTE TOCANTINENSE', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5122, 5448, 'FACULDADE DE TECNOLOGIA FOCUS', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5123, 5449, 'FACULDADE DE TECNOLOGIA DO NORTE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5124, 5450, 'FAT FUNDACAO DE APOIO A TECNOLOGIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5125, 5451, 'FACULDADE ANHANGUERA DE BAURU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5126, 5452, 'EVOLUIR', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5127, 5453, 'INSTITUTO DE POS GRADUACAO EM CIENCIAS DA SAUDE IZAMAR MILIDIU DA SILVA LTDA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5128, 5454, 'FACULDADES GESTAO BRASIL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5129, 5455, 'FACULDADE PORTO ALEGRENSE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5130, 5456, 'INSTITUTO DE ENSINO SUPERIOR DA AMAZONIA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5131, 5457, 'INSTITUTO SUPERIOR DE EDUCACAO DA SERRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5132, 5458, 'ESCOLA DO MINISTERIO PUBLICO DE MARINGA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5133, 5459, 'FACULDADE DE PEDAGOGIA DA SERRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5134, 5460, 'ESCOLA DO MINISTERIO PUBLICO DE CURITIBA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5135, 5461, 'ESCOLA DO MINISTERIO PUBLICO DE LONDRINA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5136, 5462, 'FACULDADE DE CIENCIAS DA SAUDE DA SERRA', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5137, 5463, 'INSTITUTO SUPERIOR DA ASSOCIACAO FLUMINENSE DE AMPARO AOS CEGOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5138, 5464, 'ETHOSFARMA INSTITUTO DE ENSINO', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5139, 5465, 'CONTEMPORANEO INSTITUTO DE PSICANALISE E TRANSDISCIPLINARIDADE', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5140, 5466, 'FACULDADE DE CIENCIAS JURIDICAS DE AIMORES', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5141, 5467, 'INSTITUTO BENJAMIN CONSTANT', 1, 1, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5142, 5468, 'ESCOLA EXISTENCIAL OTAVIO DE OLIVEIRA BRASIL', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5143, 5469, 'INEPAD ESCOLA DE NEGOCIOS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5144, 5470, 'INSTITUTO SIGNOS DE EDUCACAO S S LTDA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5145, 5471, 'FACULDADE RIBEIRA DO POMBAL', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5146, 5472, 'PROCESSUS FACULDADE DE DIREITO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5147, 5473, 'FACULDADE DE CIENCIA, TECNOLOGIA E EDUCACAO', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5148, 5474, 'ESCOLA DE ULTRA SONOGRAFIA E RECICLAGEM MEDICA RIBEIRAO PRETO EURP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5149, 5475, 'INSTITUTO ANISIO TEIXEIRA', 2, 1, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5150, 5476, 'EXCELLENCE BUSSINESS SCHOOL', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5151, 5477, 'COLEGIO BRASILEIRO DE CIENCIAS MEDICAS', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5152, 5478, 'INSTITUTO SUPERIOR DE EDUCACAO IRENE DA CUNHA COSTA', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5153, 5479, 'SOCIEDADE PAULISTA DE ORTODONTIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5154, 5480, 'SEITON CURSOS', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5155, 5481, 'CLINICA DE IMAGENOLOGIA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5156, 5482, 'FEMPERJ FUNDACAO ESCOLA SUPERIOR DO MINISTERIO PUBLICO DO ESTADO DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5157, 5483, 'INSTITUTO DE PESQUISAS E EXPERIMENTOS EM ODONTOLOGIA DO PIAUI LTDA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5158, 5484, 'FACULDADE DE EDUCACAO E CULTURA DE JI PARANA', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5159, 5485, 'FACULDADE DE TECNOLOGIA DIAGRAMA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5160, 5486, 'FACULDADE INSPIRAR', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5161, 5487, 'FACULDADE DE TECNOLOGIA ALTO MEDIO SAO FRANCISCO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5162, 5488, 'FACULDADE AURELIO DA ESTANCIA TURISTICA DE EMBU', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5163, 5489, 'FACULDADE FAMA DE IMPERATRIZ', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5164, 5490, 'FACULDADE DE MEDICINA DR PAULO PRATA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5165, 5491, 'FACULDADE DO INSTITUTO ATLAS DE CIENCIA E TECNOLOGIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5166, 5492, 'FACULDADE DE MEDICINA E DE ENFERMAGEM NOVA ESPERANCA DE NATAL', 4, 2, 'RN', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5167, 5493, 'FACULDADE DE TECNOLOGIA SENAI PAULO DE TARSO', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5168, 5494, 'INSTITUTO JOSE ELIAS TAJRA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5169, 5495, 'FACULDADE MAURICIO DE NASSAU FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5170, 5496, 'FACULDADE MAURICIO DE NASSAU CABO', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5171, 5497, 'FACULDADE DE TECNOLOGIA DO ISTITUTO EUROPEO DI DESIGN', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5172, 5498, 'FACULDADE ORACULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5173, 5499, 'FACULDADE EDUCACIONAL DE FRANCISCO BELTRAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5174, 5500, 'FACULDADE ANGLOAMERICANO DE CHAPECO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5175, 5501, 'FACULDADES COC DE GOIANIA', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5176, 5502, 'FACULDADES COC DE MACEIO', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5177, 5503, 'FACULDADES COC DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5178, 5504, 'FACULDADE UNIAO DE CAMPO MOURAO', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5179, 5505, 'INSTITUTO HAHNEMANNIANO DO BRASIL', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5181, 5507, 'CIODONTO POS GRADUACAO TERESINA', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5182, 5508, 'CIODONTO POS GRADUACAO FORTALEZA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5183, 5509, 'CENTRO DE ENSINO REABILITACAO E TRATAMENTO ODONTOLOGICO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5184, 5510, 'FACULDADE DE TECNOLOGIA DE ALAGOAS', 4, 2, 'AL', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5185, 5511, 'FACULDADE CAMPO REAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5186, 5512, 'INSTITUTO NACIONAL DE PESQUISAS DA AMAZONIA', 1, 1, 'AM', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5187, 5513, 'CENTRO DE ESTUDOS E APERFEICOAMENTO ORTODONTICO PROFESSOR CARLOS TELLES CEAO CT', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5188, 5514, 'CIODONTO POS GRADUACAO BELEM', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5189, 5515, 'INSTITUTO SUPERIOR MENDES DE ALMEIDA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5190, 5516, 'INSTITUTO DE POS GRADUACAO MEDICA DO RIO DE JANEIRO LTDA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5191, 5517, 'INSTITUTO SOCRATES GUANAES ISG', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5192, 5518, 'FACULDADE GUARAPUAVA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5193, 5519, 'IPE POS GRADUACAO LATO SENSU', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5194, 5520, 'FACULDADE CATHEDRAL', 4, 2, 'RR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5195, 5521, 'FACULDADE DE CIENCIAS E TECNOLOGIA DO VALE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5196, 5522, 'FACULDADE ANHANGUERA DE PINDAMONHANGABA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5197, 5523, 'FACULDADE DE TECNOLOGIA TECBRASIL UNIDADE NOVO HAMBURGO', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5198, 5524, 'FACULDADE DE EDUCACAO E CULTURA DE BURITIS', 4, 2, 'RO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5199, 5525, 'FACULDADE DE TECNOLOGIA LOURENCO FILHO', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5200, 5526, 'FACULDADE DE TECNOLOGIA E DESENVOLVIMENTO DE COMPETENCIAS', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5201, 5527, 'FACULDADE DE GOIANIA UNIDADE 1', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5202, 5528, 'FACULDADE METROPOLITANA DE ANAPOLIS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5203, 5529, 'FACULDADE SAO FRANCISCO', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5204, 5530, 'ESCOLA DE DIREITO DE BRASILIA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5205, 5531, 'FACULDADE INTERATIVA DE TECNOLOGIA E CIENCIAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5206, 5532, 'FACULDADE DE TECNOLOGIA FINACI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5207, 5533, 'FACULDADE DE CIENCIAS CONTABEIS E ADMINISTRATIVAS DE CACHOEIRO DE ITAPEMIRIM', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5208, 5534, 'DINAMICO FACULDADE DE FLORIANO', 4, 2, 'PI', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5209, 5535, 'INSTITUTO UNIVERSAL DE MARKETING EM AGRIBUSINESS UMA', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5210, 5536, 'FACULDADE DE TECNOLOGIA INED UNIDADE VENDA NOVA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5211, 5537, 'FACULDADES VALE DO CARANGOLA FAVALE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5212, 5538, 'GANEP NUTRICAO HUMANA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5213, 5539, 'FACULDADE DO CENTRO DO PARANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5214, 5540, 'FACULDADE DE MUSICA SOUZA LIMA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5215, 5541, 'FACULDADE DE TECNOLOGIA SENAC MINAS UNIDADE MONTES CLAROS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5216, 5542, 'GANEP NUTRICAO HUMANA', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5217, 5543, 'GANEP NUTRICAO HUMANA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5218, 5544, 'FACULDADE PRESIDENTE ANTONIO CARLOS', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5219, 5545, 'FACULDADE IPANEMA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5220, 5546, 'FACULDADE PRINCESA DO OESTE', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5221, 5547, 'FACULDADE DE MATO GROSSO', 4, 2, 'MT', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5222, 5548, 'FACULDADE VILLA LOBOS DO CONE LESTE PAULISTA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5223, 5549, 'IPOG INSTITUTO DE POS GRADUACAO E GRADUACAO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5224, 5550, 'FACULDADE ANHANGUERA DE ANAPOLIS', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5225, 5551, 'INSTITUTO MUNICIPAL DE ENSINO SUPERIOR DE ASSIS', 3, 1, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5226, 5552, 'FACULDADE DE TECNOLOGIA IBRATEC DE JOAO PESSOA', 4, 2, 'PB', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5227, 5553, 'UNIVERSIDADE HOLISTICA INTERNACIONAL', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5228, 5554, 'FUNDACAO DE APOIO CEFET RJ', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5229, 5555, 'FACULDADE ANHANGUERA DE JACAREI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5230, 5556, 'FACULDADE DO ENSINO DO ESTADO DO PARA', 4, 2, 'PA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5231, 5557, 'FACULDADE DE ENFERMAGEM DO HOSPITAL ISRAELITA ALBERT EINSTEIN', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5232, 5558, 'INSTITUTO DE POS GRADUACAO NIVALDO NUERNBERG', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5233, 5559, 'FACULDADE DE ENGENHARIA DE MINAS GERAIS FEAMIG', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5234, 5560, 'CENTRO DE APRENDIZAGEM E DESENVOLVIMENTO PROFISSIONAL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5235, 5561, 'ANGIOX', 4, 2, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5236, 5562, 'FUNDACAO INSTITUTO DE PESQUISAS CONTABEIS ATUARIAIS E FINANCEIRAS FIPECAFI', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5237, 5563, 'SINDICATO DOS ODONTOLOGISTAS DO ESTADO DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5238, 5564, 'FACULDADE DOM BOSCO DE CAPITAO LEONIDAS MARQUES', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5239, 5565, 'FACULDADE INTEGRADO DO RIO GRANDE DO SUL', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5240, 5566, 'FACULDADE DE TECNOLOGIA NORTE FLUMINENSE', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5241, 5567, 'INSTITUTO DE ENSINO SUPERIOR FRANCISCANO', 4, 2, 'MA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5242, 5568, 'PRAETORIUM INSTITUTO DE ENSINO PESQUISA E ATIVIDADES DE EXTENSAO EM DIREITO LTDA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5243, 5569, 'PRO RIM INSTITUTO DE EDUCACAO E PESQUISA EM SAUDE', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5244, 5570, 'FUNDACAO GIRAMUNDO', 1, 1, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5245, 5571, 'ADVANCE CURSOS DE POS GRADUCAO', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5246, 5572, 'INSTITUTO DE ENSINO PESQUISA E EXTENSAO', 4, 2, 'GO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5247, 5573, 'CENTRO DE PESQUISA E QUALIFICACAO TECNOLOGICA', 4, 2, 'CE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5248, 5574, 'FACULDADE DE TECNOLOGIA DE IPATINGA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5249, 5575, 'FACULDADE SAO MARCOS FASAMAR', 4, 2, 'TO', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5250, 5576, 'FUNDACAO ESCOLA NACIONAL DE ADMINISTRACAO PUBLICA', 1, 1, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5251, 5577, 'FACULDADE MAX PLANCK', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5252, 5578, 'ASSOCIACAO BRASILEIRA DE NUTROLOGIA ABRAN', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5253, 5579, 'ESCOLA RIOPRETENSE DE ACUPUNTURA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5254, 5580, 'FACULDADE DE MEDICINA DE GARANHUNS', 4, 2, 'PE', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5255, 5581, 'CENTRO DE ESTUDOS DE CIENCIAS ODONTOLOGICAS IPIRANGA CECOI', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5256, 5582, 'CURSOS SUI JURIS', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5257, 5583, 'FACULDADE IGUAPENSE SANTO AUGUSTO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5258, 5584, 'PANAMERICANA FACULDADE DE ARTE E DESIGN', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5259, 5585, 'FACULDADE DE TECNOLOGIA SENAC MINAS UNIDADE BELO HORIZONTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5260, 5586, 'FACULDADE DE TECNOLOGIA SENAC MINAS UNIDADE BARBACENA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5261, 5587, 'CENTRO DE POS GRADUACAO DA FUNDACAO ESCOLA DE ADMINISTRACAO DA UFBA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5262, 5588, 'CENTRO DE POS GRADUACAO DA FUNDACAO ESCOLA DE ADMINISTRACAO DA UFBA', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5263, 5589, 'INSTITUTO CAPITAL HUMANO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5264, 5590, 'ESCOLA DE SOCIOLOGIA E POLITICA DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5265, 5591, 'FACULDADES INTEGRADAS CAMOES', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5266, 5592, 'FACULDADES INTEGRADAS DO NORTE DE MINAS FUNORTE', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5267, 5593, 'FACULDADE ADVENTISTA DE HORTOLANDIA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5268, 5594, 'FEMPTEC FUNDACAO DE EMPREENDIMENTOS PESQ E DESENV INST CIENT E TECNOL DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5269, 5595, 'FACULDADE DE FILOSOFIA DE PASSOS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5270, 5596, 'FACULDADE EVANGELICA DE SALVADOR', 4, 2, 'BA', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5271, 5597, 'INSTITUTO CHIAVENATO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5272, 5598, 'INSTITUTO DENTALIS ENSINO E PESQUISA LTDA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5273, 5599, 'LIBERTAS FACULDADES INTEGRADAS', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5274, 5600, 'FACULDADES INTEGRADAS SAO JUDAS TADEU', 4, 2, 'RS', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5275, 5601, 'FUNDACAO GORCEIX', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5276, 5602, 'ESCOLA SUPERIOR NEREU RAMOS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5277, 5603, 'HERNANDEZ ASSOCIADOS CONSULTORIA E TREINAMENTO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5278, 5604, 'PROFIS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5279, 5605, 'CENTRO DE ODONTOLOGIA E POS GRADUACAO SAO DOMINGOS LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5280, 5606, 'FACULDADE DE DIREITO DAMASIO DE JESUS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5281, 5607, 'CENTRO DE ESTUDOS MONTESSORIANOS MENINO JESUS', 4, 2, 'SC', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5282, 5608, 'CEU CENTRO DE ESPECIALIZACAO UNIED', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5283, 5609, 'FUNDACAO DE ESTUDOS AGRARIOS LUIZ DE QUEIROZ', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5284, 5610, 'UNIVERSITAS PAULO FREIRE UNIFREIRE', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5285, 5611, 'UNISAOPAULO UNIVERSIDADES IN COMPANY DE SAO PAULO', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5286, 5612, 'ASSOCIACAO INSTITUTO ANCHIETA DE ENSINO E PESQUISA', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5287, 5613, 'ASSOCIACAO DE ENSINO DE CAMBE', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5288, 5614, 'CAD CENTRO DE IDIOMAS E DESENVOLVIMENTO PROFISSIONAL LTDA', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5289, 5615, 'AFARP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5290, 5616, 'ASSOCIACAO PAULISTA CIRURGIOES DENTISTAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5291, 5617, 'GAPO GRUPO DE APOIO A PESQUISA ODONTOLOGICA', 4, 2, 'MG', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5292, 5618, 'ASSOCIACAO DE ASSISTENCIA A CRIANCA DEFICIENTE AACD', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5293, 5619, 'ASSOCIACAO ODONTOLOGICA DE RIBEIRAO PRETO AORP', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5294, 5620, 'NAZARE UNIVERSIDADE DA LUZ', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5295, 5621, 'ACOES SOCIAIS EM SAUDE BUCAL E CIDADANIA B B INSTITUTO B B', 1, 1, 'ES', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5296, 5622, 'ORDEM DOS ECONOMISTAS DO BRASIL', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5297, 5623, 'ASSOCIACAO DOS CIRURGIOES DENTISTAS DE CAMPINAS', 4, 2, 'SP', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5298, 5624, 'FACULDADE PARANAPANEMA', 4, 2, 'PR', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5299, 5625, 'SOCIEDADE BRASILEIRA DE OFTALMOLOGIA', 4, 2, 'RJ', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5300, 5626, 'UNIVERSA ESCOLA DE GESTAO', 4, 2, 'DF', 1, '2010-09-20 11:44:14.453', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5302, 5627, 'FACULDADE DE TECNOLOGIA DE PRESIDENTE PRUDENTE', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5303, 5633, 'FACULDADE DE TECNOLOGIA DE BRAGANCA PAULISTA', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5304, 5663, 'FACULDADE DE VARGEM GRANDE PAULISTA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5305, 5664, 'FACULDADE DE CIENCIAS HUMANAS E SOCIAIS DE ARARIPINA FACISA', 3, 1, 'PE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5306, 5668, 'FACULDADE ANHANGUERA DE JOINVILLE', 4, 2, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5307, 5669, 'FACULDADE DE TECNOLOGIA DE SAO JOSE DOS CAMPOS', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5308, 5670, 'FACULDADES UNIDAS DO VALE DO ARAGUAIA', 4, 2, 'MT', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5309, 5671, 'CENTRO UNIVERSITARIO SAO JOSE DE ITAPERUNA', 4, 2, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5310, 5701, 'UNIVERSIDADE DO ESTADO DO AMAPA', 2, 1, 'AP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5311, 5706, 'FACULDADE MUNICIPAL DE PALHOCA', 3, 1, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5312, 6490, 'FACULDADE DE TECNOLOGIA DE MAUA', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5313, 10009, 'FAMAC FACULDADE DE MACHADINHO DO OESTE', 4, 2, 'RO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5314, 10016, 'FACULDADE OBOE   FACO', 4, 2, 'CE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5315, 10020, 'INSTITUTO LOGOS DE EDUCACAO SUPERIOR', 4, 2, 'AL', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5316, 10058, 'FACULDADE DE TECNOLOGIA DE VALENCA', 4, 2, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5317, 10059, 'FACULDADE DE TECNOLOGIA DE ENSINO SUPERIOR FATEC', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5318, 10071, 'FACULDADE DE TEOLOGIA E CIENCIAS HUMANAS', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5319, 10116, 'FACULDADE DE TECNOLOGIA SENAI CUIABA', 4, 2, 'MT', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5753, 10251, 'FACULDADE ORTODOXA', 4, 2, 'MT', 1, '2016-07-08 14:18:30.302088', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5320, 10323, 'FACULDADE DE TECNOLOGIA BANDEIRANTES', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5321, 10349, 'FACULDADE DE TECNOLOGIA IPPEO', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5322, 10385, 'INSTITUTO SAO PAULO DE ESTUDOS SUPERIORES', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5323, 10418, 'FACULDADE HSM', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5324, 10588, 'FACULDADE LIDER', 4, 2, 'PE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5325, 10613, 'FACULDADE DE SAUDE DE PAULISTA', 4, 2, 'PE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5326, 10685, 'FACULDADE NORTE CAPIXABA DE SAO MATEUS', 4, 2, 'ES', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5327, 10836, 'FACULDADE UNIAO ARARUAMA DE ENSINO S/S Ltda.', 4, 2, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5328, 10846, 'FACULDADE DINAMICA', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5329, 10923, 'FACULDADE DE TECNOLOGIA DO TRANSPORTE', 4, 2, 'DF', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5330, 10929, 'FACULDADE SANTO ANDRE', 4, 2, 'RO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5331, 10950, 'FACULDADE MARECHAL CANDIDO RONDON', 4, 2, 'RO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5332, 11007, 'FACULDADE CENTRO OESTE', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5333, 11289, 'ESCOLA SUPERIOR NACIONAL DE SEGUROS DE SAO PAULO', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5334, 11308, 'FACULDADE ANHANGUERA DE SUMARE', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5335, 11376, 'FACULDADE VILLALOBOS DO CONELESTE PAULISTA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5336, 11428, 'FACULDADE DE TECNOLOGIA ALTO MEDIO SAO FRANCISCO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5337, 11429, 'FACULDADE ESPECIALIZADA NA AREA DE SAUDE DO RIO GRANDE DO SUL', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5338, 11544, 'FACULDADE METROPOLITANA DE ANAPOLIS', 4, 2, 'GO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5339, 11563, 'FACULDADE DE TECNOLOGIA DA SERRA GAUCHA CAXIAS DO SUL', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5340, 11584, 'FACULDADE CAL DE ARTES CENICAS', 4, 2, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5341, 11586, 'FACULDADES NETWORK   CAMPUS SUMARE', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5342, 11593, 'FACULDADE DE TECNOLOGIA DE MACAPA', 4, 2, 'AP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5343, 11604, 'FACULDADE ANGLOAMERICANO DE CHAPECO', 4, 2, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5344, 11645, 'FACULDADE DE EDUCACAO E CULTURA DE VILHENA', 4, 2, 'RO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5345, 11750, 'FACULDADE PITAGORAS DE VOTORANTIM SOROCABA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5346, 11751, 'FACULDADE PITAGORAS DE TECNOLOGIA DE BETIM', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5347, 11752, 'FACULDADE IDEAL PAULISTA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5348, 11807, 'FACULDADE DE TECNOLOGIA DO ISTITUTO EUROPEO DI DESIGN', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5349, 11817, 'FACULDADE DO POVO', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5350, 11818, 'FACULDADE DE TECNOLOGIA INSPIRAR', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5351, 11841, 'FACULDADE EVOLUCAO ALTO OESTE POTIGUAR', 4, 2, 'RN', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5352, 11860, 'INSTITUTO NACIONAL DE ENSINO SUPERIOR E POSGRADUACAO PADRE GERVASIO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5353, 11861, 'FACULDADE DE CIENCIAS APLICADAS E TECNOLOGICAS DO LITORAL SUL', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5354, 11895, 'FACULDADE EVANGELICA DE TAGUATINGA', 4, 2, 'DF', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5355, 11902, 'FACULDADE DE TECNOLOGIA E DESENVOLVIMENTO DE COMPETENCIAS', 4, 2, 'PA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5356, 11951, 'FACULDADE DO SERTAO BAIANO', 4, 2, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5357, 12005, 'FACULDADE DE TECNOLOGIA INED   UNIDADE VENDA NOVA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5358, 12052, 'FACULDADE DE TECNOLOGIA SENAI PAULO DE TARSO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5359, 12136, 'FACULDADE DE TECNOLOGIA DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5360, 12189, 'FACULDADE PRISMA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5361, 12229, 'FACULDADE DE TECNOLOGIA FAESA VILA VELHA', 4, 2, 'ES', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5362, 12247, 'ESCOLA DE DIREITO DE BRASILIA', 4, 2, 'DF', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5363, 12249, 'FACULDADE PADRE ANCHIETA DE VARZEA PAULISTA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5364, 12268, 'FACULDADE DE TECNOLOGIA DE CRUZEIRO DO OESTE', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5365, 12338, 'FACULDADE DE TECNOLOGIA LA SALLE ESTRELA', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5366, 12346, 'FACULDADE METROPOLITANA SAO CARLOS', 4, 2, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5367, 12415, 'FACULDADES COC DE MACEIO', 4, 2, 'AL', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5368, 12416, 'FACULDADE BRASILIENSE DE NEGOCIOS', 4, 2, 'DF', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5369, 12421, 'FACULDADES COC DE SAO PAULO', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5370, 12430, 'FACULDADE METROPOLITANA SAO CARLOS BJI', 4, 2, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5371, 12522, 'FACULDADE MOGIANA DO ESTADO DE SAO PAULO', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5372, 12523, 'FACULDADE DE TECNOLOGIA DA SERRA GAUCHA BENTO CONCALVES', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5373, 12547, 'FACITEN FACULDADE DE CIENCIAS E TECNOLOGIAS DE NATAL', 4, 2, 'RN', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5374, 12594, 'FACULDADE DE NEGOCIOS', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5375, 12597, 'FACULDADE PASSIONISTA DE EDUCACAO DE CURITIBA', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5376, 12601, 'FACULDADE BRASILEIRA DE ESTUDOS AVANCADOS', 4, 2, 'MA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5377, 12611, 'FACULDADE DE MUSICA SOUZA LIMA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5378, 12620, 'FACULDADE DE TECNOLOGIA DE SETE LAGOAS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5379, 12625, 'ESCOLA SUPERIOR DE AVIACAO CIVIL', 4, 2, 'PB', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5380, 12661, 'FACULDADE DE TECNOLOGIA SAINT PAUL', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5381, 12723, 'FACULDADE DE TECNOLOGIA FINACI', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5382, 12735, 'FACULDADE DE CIÊNCIAS HUMANAS E SOCIAIS DO XINGU E AMAZÔNIA', 4, 2, 'PA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5383, 12748, 'FACULDADE DE EDUCACAO, TECNOLOGIA E ADMINISTRACAO DE CAARAPO', 4, 2, 'MS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5384, 12749, 'FACULDADES UNIDAS DE PESQUISA, CIENCIAS E SAUDE LTDA', 4, 2, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5385, 12754, 'FACULDADE CRISTA DE CURITIBA', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5386, 12758, 'FACULDADE DE EDUCACAO E CULTURA DE PORTO VELHO', 4, 2, 'RO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5387, 12766, 'FACULDADE UNIAO DE CAMPO MOURAO', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5388, 12772, 'FACULDADE DE TECNOLOGIA SENAC MINAS UNIDADE BELO HORIZONTE', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5389, 12784, 'FACULDADE DE TECNOLOGIA TECBRASIL UNIDADE NOVO HAMBURGO', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5390, 12791, 'FACULDADE ANHANGUERA DE PINDAMONHANGABA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5391, 12803, 'FACULDADE IBMEC DISTRITO FEDERAL', 4, 2, 'DF', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5392, 12829, 'FACULDADE EXITO', 4, 2, 'GO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5393, 12847, 'FACULDADE EDUCACIONAL DE FRANCISCO BELTRAO', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5394, 12848, 'FACULDADE DE TECNOLOGIA SENAC MINAS UNIDADE BARBACENA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5395, 12869, 'FACULDADES JOAO PAULO II', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5754, 12899, 'FACULDADE METROPOLITANA DO VALE DO AÇO', 4, 2, 'MG', 1, '2016-07-08 14:18:30.304431', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5396, 12916, 'IPOG INSTITUTO DE POSGRADUACAO & GRADUACAO', 4, 2, 'GO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5397, 12922, 'FACULDADE DE TECNOLOGIA E CIENCIAS DA BAHIA', 4, 2, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5398, 12923, 'FACULDADE DE TECNOLOGIA IPANEMA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5399, 12928, 'FACULDADE BRASIL CENTRAL', 4, 2, 'GO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5400, 12946, 'FACULDADE DE MATO GROSSO', 4, 2, 'MT', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5401, 13014, 'FACULDADE DE TEOLOGIA DA ARQUIDIOCESE DE BRASILIA', 4, 2, 'DF', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5402, 13034, 'FACULDADE SHALOM DE ENSINO SUPERIOR', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5403, 13073, 'FACULDADE DE TECNOOLOGIA AEROTD', 4, 2, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5404, 13106, 'FACULDADE DE TECNOLOGIA LOURENCO FILHO', 4, 2, 'CE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5405, 13133, 'FACULDADE DE GOIANIA UNIDADE 1', 4, 2, 'GO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5406, 13238, 'INSTITUTO BRASILEIRO DE EDUCACAO SUPERIOR CONTINUADA', 4, 2, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5407, 13300, 'FACULDADE ADJETIVO CETEP', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5408, 13359, 'FACULDADE ANGLOAMERICANO DE BAGE', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5409, 13417, 'FACULDADE PRINCESA DO OESTE', 4, 2, 'CE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5410, 13452, 'FACULDADE DE TECNOLOGIA FUNDACAO UNIVERSITARIA DE CARDIOLOGIA', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5411, 13467, 'FACULDADE DE TECNOLOGIA EM SAUDE CIEPH', 4, 2, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5412, 13476, 'FACULDADE SAO BASILIO MAGNO', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5413, 13481, 'FACULDADES INTEGRADAS RIO BRANCO GRANJA VIANNA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5414, 13484, 'FACULDADE EUROPEIA DE VITORIA', 4, 2, 'ES', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5415, 13486, 'FACULDADE FACTUM', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5416, 13488, 'FACULDADE SEQUENCIAL', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5417, 13498, 'FACULDADE DE TECNOLOGIA DE BARRETOS', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5418, 13527, 'FACULDADE CANCAO NOVA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5419, 13538, 'FACULDADE CARAGUA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5420, 13620, 'FACULDADE ANHANGUERA DE PORTO ALEGRE', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5421, 13625, 'FACULDADE DE TECNOLOGIA NOVA PALHOCA', 4, 2, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5422, 13631, 'FACULDADE SAO FIDELIS', 4, 2, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5423, 13643, 'FACULDADES EVANGELICAS INTEGRADAS CANTARES DE SALOMAO', 4, 2, 'MT', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5424, 13648, 'FACULDADE SAO MARCOS', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5425, 13657, 'FACULDADE DE TECNOLOGIA ATENEU', 4, 2, 'CE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5426, 13663, 'FACULDADE ISEIB DE BETIM', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5427, 13666, 'FACULDADE DE DIREITO DE CONTAGEM', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5428, 13674, 'FACULDADE DE TECNOLOGIA SENAI TELEMACO BORBA', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5429, 13677, 'FACULDADE DE TECNOLOGIA SENAI CIC', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5430, 13684, 'FACULDADE PITAGORAS DE CONTAGEM', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5431, 13695, 'ESCOLA DE MATEMATICA APLICADA', 4, 2, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5432, 13696, 'FACULDADE PRESIDENTE JK', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5433, 13716, 'FACULDADE DE TECNOLOGIA GAP', 4, 2, 'GO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5434, 13717, 'FACULDADES FUTURAO', 4, 2, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5435, 13724, 'PANAMERICANA FACULDADE DE ARTE E DESIGN', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5755, 13728, 'FACULDADE DOS CARAJÁS', 4, 2, 'PA', 1, '2016-07-08 14:18:30.304915', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5436, 13735, 'FACULDADE DE TECNOLOGIA, CAPACITACAO E GESTAO INTEGRAL', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5437, 13743, 'FACULDADE PITAGORAS DE GOVERNADOR VALADARES', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5438, 13749, 'FACULDADE EDUCACIONAL ARAUCARIA', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5439, 13758, 'ESCOLA DE ADMINISTRACAO DE BRASILIA', 4, 2, 'DF', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5756, 13764, 'FACULDADE DE TECNOLOGIA DE AMPÉRE', 4, 2, 'PR', 1, '2016-07-08 14:18:30.305397', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5440, 13775, 'FACULDADE DE TECNOLOGIA IBRATE', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5441, 13782, 'FACULDADE DE SANTA CRUZ DA BAHIA', 4, 2, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5442, 13783, 'FACULDADES UNIDAS FEIRA DE SANTANA', 4, 2, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5443, 13784, 'FACULDADE DO PLANALTO CENTRAL', 4, 2, 'GO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5444, 13792, 'INSTITUICAO DE ENSINO SUPERIOR DE CACOAL', 4, 2, 'RO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5445, 13796, 'FACULDADE DE PORTO FELIZ', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5446, 13809, 'FACULDADE SANTO AGOSTINHO DE SETE LAGOAS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5447, 13811, 'TREVISAN ESCOLA SUPERIOR DE NEGOCIOS', 4, 2, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5448, 13812, 'ESCOLA SUPERIOR ABERTA DO BRASIL', 4, 2, 'ES', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5449, 13818, 'FACULDADE LA SALLE CAXIAS', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5450, 13828, 'FACULDADE ISEIB DE BELO HORIZONTE', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5451, 13832, 'FACULDADE SAGRADA FAMILIA', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5452, 13845, 'ESCOLA DIEESE DE CIENCIAS DO TRABALHO', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5453, 13856, 'FACULDADE FACCENTRO', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5454, 13865, 'FACULDADE DE TECNOLOGIA ITEPA', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5455, 13873, 'FACULDADE FINOM DE PATOS DE MINAS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5456, 13878, 'FATEC FACULDADE SENAI DE TECNOLOGIA', 4, 2, 'ES', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5457, 13883, 'FACULDADE MURIALDO', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5458, 13889, 'FACULDADE ITAPURANGA', 4, 2, 'GO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5459, 13890, 'FACULDADE DE TECNOLOGIA BSGU', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5460, 13897, 'FACULDADE LABORO', 4, 2, 'MA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5461, 13903, 'FACULDADE DE CIENCIAS GERENCIAIS DE SANTOS DUMONT', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5462, 13938, 'FACULDADE DE MARILIA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5463, 13944, 'FACULDADE DE ADMINISTRACAO E NEGOCIOS', 4, 2, 'AL', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5464, 13971, 'INSTITUTO DE ENSINO SUPERIOR INTEGRADO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5465, 13982, 'FACULDADE MAURICIO DE NASSAU DE BELEM', 4, 2, 'PA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5466, 14002, 'FACULDADE CEDEPE', 4, 2, 'PE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5467, 14005, 'INSTITUTO SUPERIOR DE CIENCIAS HUMANAS E SOCIAIS APLICADAS DE ABAETE', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5468, 14027, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE MATOZINHOS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5469, 14028, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE BETIM', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5470, 14029, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE AIMORES', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5471, 14032, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE BELO HORIZONTE', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5472, 14069, 'FACULDADE DE TECNOLOGIA PORTO SUL', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5473, 14090, 'FACULDADE BETIM', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5474, 14095, 'FACULDADE DE TECNOLOGIA FUTURO', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5475, 14097, 'FACULDADE REFIDIM', 4, 2, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5476, 14098, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE ALMENARA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5477, 14101, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE BAEPENDI', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5478, 14114, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE MUTUM', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5479, 14115, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE PONTE NOVA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5480, 14117, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE PIRANGUINHO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5481, 14118, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE RAUL SOARES', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5482, 14119, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE SAO FRANCISCO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5483, 14121, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE SAO JOAO NEPOMUCENO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5484, 14122, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE BELO ORIENTE', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5485, 14123, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE BOM SUCESSO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5486, 14124, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE BURITIS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5487, 14125, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE CAMPOS ALTOS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5488, 14126, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE SAO LOURENCO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5489, 14127, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE CAMPO BELO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5490, 14128, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE VAZANTE', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5491, 14129, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE CURVELO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5492, 14130, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE VARZEA DA PALMA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5493, 14131, 'Falculdade Presidente AntOnio Carlos de Divisa Alegre', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5494, 14132, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE ITANHANDU', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5495, 14133, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE LAMBARI', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5496, 14134, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE ABRE CAMPO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5497, 14135, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE SAO GOTARDO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5498, 14147, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE BARAO DE COCAIS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5499, 14148, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE MARIANA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5500, 14149, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE BOCAIUVA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5501, 14150, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE MONTES CLAROS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5502, 14151, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE NOVA LIMA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5503, 14152, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE PIUMHI', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5504, 14153, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE PORTEIRINHA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5505, 14155, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE SABARA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5506, 14156, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE TEOFILO OTONI', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5507, 14157, 'FACULDADE DE EDUCACAO E ESTUDOS SOCIAIS DE UBERLANDIA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5757, 14158, 'FACULDADE DE TECNOLOGIA DE NOVO CABRAIS', 4, 2, 'RS', 1, '2016-07-08 14:18:30.305869', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5508, 14159, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE CARMO DO PARANAIBA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5509, 14160, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE CARMOPOLIS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5510, 14161, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE CONTAGEM', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5713, 17224, 'FACULDADE CESMAC DO SERTAO', 4, 2, 'AL', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5511, 14162, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE GOVERNADOR VALADARES', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5512, 14163, 'FACULDADE DE EDUCACAO E ESTUDOS SOCIAIS DE GOVERNADOR VALADARES', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5513, 14165, 'FACULDADE TRES PONTAS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5514, 14166, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE ITABIRA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5515, 14169, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE ITAMBACURI', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5516, 14170, 'FACULADE PRESIDENTE ANTONIO CARLOS DE NEPOMUCENO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5517, 14171, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE PERDOES', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5518, 14172, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE POTE', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5519, 14173, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE RIBEIRAO DAS NEVES', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5520, 14174, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE SAO GONCALO DO RIO ABAIXO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5521, 14181, 'FACULDADE DE TECNOLOGIA DO COOPERATIVISMO', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5522, 14183, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE SAO JOAO DEL REI', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5523, 14189, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE MARIANA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5524, 14192, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE NANUQUE', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5525, 14194, 'FACULDADE DE TEOLOGIA E CIÊNCIAS', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5526, 14201, 'INSTITUTO SUPERIOR DE CIENCIAS AGRARIAS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5527, 14204, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE ARCOS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5528, 14205, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE BAMBUI', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5529, 14206, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE ELOI MENDES', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5530, 14207, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE JUATUBA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5531, 14208, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE LAGOA DOS PATOS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5532, 14209, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE LAGOA SANTA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5533, 14210, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE MARIA DA FE', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5534, 14211, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE NAZARENO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5535, 14212, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE SAO ROMAO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5536, 14213, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE SETUBINHA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5537, 14214, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE ALVARENGA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5538, 14215, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE BARROSO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5539, 14216, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE DIVINO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5540, 14217, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE LADAINHA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5541, 14218, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE LUMINARIAS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5542, 14219, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE LIBERDADE', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5543, 14220, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE PIRAUBA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5544, 14221, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE SAO DOMINGOS DO PRATA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5545, 14222, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE SENHORA DOS REMEDIOS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5546, 14223, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE CENTRAL DE MINAS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5547, 14224, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE CONCEICAO DAS ALAGOAS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5548, 14225, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE FELIXLANDIA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5549, 14226, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE JABOTICATUBAS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5550, 14227, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE RECREIO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5551, 14228, 'FACULDADE PRESIDENTE ANTONIO CARLOS RIO NOVO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5552, 14229, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE SAO VICENTE DE MINAS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5553, 14230, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE TOCANTINS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5554, 14231, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE URUANA DE MINAS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5555, 14232, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE VESPASIANO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5556, 14236, 'FACULDADE DE CIENCIAS GERENCIAIS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5557, 14237, 'INSTITUTO SUPERIOR DE EDUCACAO DE CLAUDIO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5558, 14241, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE ANDRE DA SILVEIRA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5559, 14242, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE TIMOTEO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5560, 14243, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE ITABIRITO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5561, 14244, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE MONTE CARMELO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5562, 14245, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE CAMPINA VERDE', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5563, 14246, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE UBERABA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5564, 14247, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE TUPACIGUARA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5565, 14248, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE UBERLANDIA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5566, 14249, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE CONGONHAS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5567, 14258, 'INSTITUTO SUPERIOR DE ENSINO E PESQUISA DE CAMBUI', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5568, 14261, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE CONSELHEIRO PENA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5569, 14263, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE ITAJUBA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5570, 14288, 'FACULDADE CATOLICA DE SANTA CATARINA', 4, 2, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5571, 14297, 'FACULDADE DE TECNOLOGIA INTENSIVA DE PARNAIBA', 4, 2, 'PI', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5572, 14313, 'NOVA FACULDADE', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5573, 14321, 'FACULDADE MAURICIO DE NASSAU DE FORTALEZA', 4, 2, 'CE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5574, 14326, 'FACULDADE DE TECNOLOGIA INSAEOS', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5575, 14342, 'FACULDADE REDENTOR DE CAMPOS', 4, 2, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5576, 14367, 'FACULDADE EFICAZ', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5577, 14401, 'FACULDADE DE TECNOLOGIA PORTO DAS MONCOES', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5578, 14403, 'FACULDADE CESUMAR', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5579, 14408, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DE BRASILIA', 1, 1, 'DF', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5580, 14412, 'FACULDADE DE TECNOLOGIA SENAI PERNAMBUCO', 4, 2, 'PE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5581, 14429, 'FACULDADE PITAGORAS DE MACEIO', 4, 2, 'AL', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5582, 14509, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA BAIANO', 1, 1, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5583, 14609, 'FACULDADE DE TECNOLOGIA SENAI CONDE JOSE VICENTE DE AZEVEDO', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5584, 14622, 'FACULDADES INTEGRADAS DE SERGIPE', 4, 2, 'SE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5585, 14715, 'FACULDADE PIAGET', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5586, 14717, 'FACULDADE MAURICIO DE NASSAU DE CARUARU', 4, 2, 'PE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5758, 14718, 'FACULDADE PARANÁ', 4, 2, 'PR', 1, '2016-07-08 14:18:30.306382', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5587, 14724, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO PARANA', 1, 1, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5588, 14727, 'FACULDADE PROGRESSO', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5589, 14782, 'FACULDADE DE TECNOLOGIA SENAI CASCAVEL', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5590, 14783, 'FACULDADE DE TECNOLOGIA SENAI TOLEDO', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5591, 14784, 'FACULDADE DE TECNOLOGIA SENAI CURITIBA', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5592, 14785, 'FACULDADE DE TECNOLOGIA SENAI MARINGA', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5593, 14786, 'FACULDADE DE TECNOLOGIA SENAI LONDRINA', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5594, 14858, 'FACULDADE DE TECNOLOGIA FRANCISCO MORATO', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5595, 14860, 'FACULDADE TECNOLOGICA DENTAL CEEO', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5596, 14869, 'FACULDADE DE TECNOLOGIA DO IPE', 4, 2, 'MT', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5597, 14878, 'TREVISAN ESCOLA SUPERIOR DE NEGOCIOS', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5598, 14879, 'FACULDADE DOURADO', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5599, 14882, 'FACULDADE HORIZONTE', 4, 2, 'DF', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5600, 14890, 'FACULDADE PRAIA GRANDE', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5601, 14892, 'FACULDADE DE CIENCIAS DA SAUDE DE BARRETOS DR. PAULO PRATA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5602, 14901, 'FACULDADE INTEGRADA CARAJAS', 4, 2, 'PA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5603, 14914, 'FACULDADE TEOLOGICA EVANGELICA DO RIO DE JANEIRO', 4, 2, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5604, 14927, 'FACULDADE SAO GABRIEL DA PALHA', 4, 2, 'ES', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5605, 14947, 'FACULDADE DE CIENCIAS DO TOCANTINS', 4, 2, 'TO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5606, 14951, 'FACULDADE DE ENGENHARIA E INOVACAO TECNICO PROFISSI', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5607, 14961, 'FACULDADE DE TECNOLOGIA EM SAUDE IAHCS', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5608, 14969, 'FACULDADE DE TECNOLOGIA EM SAÚDE', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5609, 14975, 'FACULDADE DO NORDESTE DA BAHIA', 4, 2, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5610, 14996, 'FACULDADE DE GESTAO E NEGOCIOS DE SALVADOR', 4, 2, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5611, 15001, 'UNIVERSIDADE FEDERAL DA INTEGRACAO LATINO AMERICANA', 1, 1, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5612, 15015, 'UNIVERSIDADE ESTADUAL DO NORTE DO PARANA', 2, 1, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5613, 15032, 'UNIVERSIDADE ALTO VALE DO RIO DO PEIXE', 3, 1, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5614, 15059, 'UNIVERSIDADE FEDERAL DO OESTE DO PARA', 1, 1, 'PA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5615, 15079, 'FACULDADE MASTER DE PARAUAPEBAS FAMAP', 4, 2, 'PA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5616, 15121, 'UNIVERSIDADE FEDERAL DA FRONTEIRA SUL', 1, 1, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5617, 15133, 'FACULDADE JARDINS', 4, 2, 'SE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5618, 15173, 'FACULDADE DE JARAGUA', 4, 2, 'GO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5619, 15236, 'FACULDADE DE TECNOLOGIA ALCIDES MAYA', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5620, 15272, 'FACULDADE DE TECNOLOGIA, EDUCACAO SUPERIOR E PROFISSIONAL', 4, 2, 'PI', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5621, 15280, 'FACULDADE BRASILEIRA DE ENSINO, PESQUISA E EXTENSAO', 4, 2, 'PB', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5622, 15351, 'FACULDADE IDEAU', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5623, 15355, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE BOM DESPACHO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5624, 15357, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE UBA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5625, 15382, 'FACULDADE NOROESTE DO MATO GROSSO', 4, 2, 'MT', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5626, 15383, 'FACULDADE PARA O DESENVOLVIMENTO SUSTENTÁVEL DA AMAZÔNIA', 4, 2, 'PA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5627, 15401, 'FACULDADE FIPECAFI', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5628, 15410, 'FACULDADE DE CIENCIAS HUMANAS E SOCIAIS DE SERRA TALHADA', 3, 1, 'PE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5629, 15428, 'FACULDADE DOM HEITOR SALES', 4, 2, 'RN', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5630, 15433, 'FACULDADE SEDAC', 4, 2, 'MT', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5631, 15445, 'FACULDADE METROPOLITANA DE CURITIBA', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5632, 15447, 'CENTRO UNIVERSITARIO PRESIDENTE ANTONIO CARLOS DE BARBACENA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5633, 15448, 'CENTRO UNIVERSITARIO PRESIDENTE ANTONIO CARLOS JUIZ DE FORA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5634, 15449, 'CENTRO UNIVERSITARIO PRESIDENTE ANTONIO CARLOS DE ARAGUARI', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5635, 15450, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE IPATINGA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5636, 15451, 'FACULDADE DE DIREITO DE IPATINGA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5637, 15452, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE BOM DESPACHO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5638, 15453, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE CONSELHEIRO LAFAIETE', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5639, 15467, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE VISCONDE DO RIO BRANCO', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5640, 15468, 'FACULDADE PRESIDENTE ANTONIO CARLOS DE LEOPOLDINA', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5641, 15497, 'UNIVERSIDADE DA INTEGRACAO INTERNACIONAL DA LUSOFONIA AFROBRASILEIRA', 1, 1, 'CE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5759, 15500, 'Faculdade Lusocapixaba', 4, 2, 'ES', 1, '2016-07-08 14:18:30.306888', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5642, 15501, 'FACULDADE DE TECNOLOGIA SENAI ROBERTO SIMONSEN', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5643, 15502, 'FACULDADE DE TECNOLOGIA SENAI SUICOBRASILEIRA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5644, 15504, 'FACULDADE IRECE', 4, 2, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5645, 15507, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO ACRE', 1, 1, 'AC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5646, 15508, 'INSTITUTO GALILEO DE ENSINO SUPERIOR', 4, 2, 'PI', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5647, 15518, 'FACUDADE DE MORRINHOS', 4, 2, 'GO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5648, 15520, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DE MATO GROSSO DO SUL', 1, 1, 'MS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5714, 17226, 'FACULDADE CESMAC DO AGRESTE', 4, 2, 'AL', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5649, 15521, 'FACULDADE CATOLICA DE SAO JOSE DOS CAMPOS', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5650, 15522, 'INSTITUTO FEDERAL DE EDUCACAO, CIENCIA E TECNOLOGIA DO AMAPA', 1, 1, 'AP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5651, 15526, 'FACULDADE DE GESTAO E NEGOCIOS DE FORTALEZA', 4, 2, 'CE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5760, 15562, 'Faculdade Batista do Cariri', 4, 2, 'CE', 1, '2016-07-08 14:18:30.307361', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5652, 15576, 'FACULDADE DE TECNOLOGIA DE MOGI DAS CRUZES', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5653, 15581, 'FACULDADE DE TECNOLOGIA DE SAO JOSE DOS CAMPOS JESSEN VIDAL', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5654, 15585, 'FACULDADE DE TECNOLOGIA SANTO ANDRE', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5655, 15639, 'FACULDADE DE TECNOLOGIA DE ITAQUAQUECETUBA', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5656, 15669, 'FACULDADE DE CIENCIAS EXATAS DE GARANHUNS', 3, 1, 'PE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5657, 15680, 'FATEC CRUZEIRO PROF. WALDOMIRO MAY', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5658, 15682, 'FACULDADE DE TECNOLOGIA DE PIRACICABA', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5659, 15687, 'FACULDADE DE TECNOLOGIA DE PINDAMONHANGABA', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5660, 15688, 'FACULDADE DE TECONOLOGIA DA ZONA SUL', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5661, 15689, 'FACULDADE DE TECNOLOGIA DE BAURU', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5662, 15693, 'FACULDADE DE TECNOLOGIA DE ITAPETININGA PROF.ANTONIO BELIZANDRO BARBOSA REZENDE', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5663, 15695, 'FACULDADE DE TECNOLOGIA DOM AMAURY CASTANHO', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5664, 15696, 'FACULDADE DE TECNOLOGIA DE SERTAOZINHO', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5665, 15697, 'FACULDADE DE TECNOLOGIA DE ARACATUBA', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5666, 15704, 'FACULDADE DE TECNOLOGIA DE CAPAO BONITO', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5667, 15708, 'FACULDADE DE TECNOLOGIA DR. THOMAZ NOVELINO', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5668, 15709, 'FACULDADE DE TECNOLOGIA DE OSASCO PREFEITO HIRANT SANAZAR', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5669, 15714, 'FATEC ARTHUR AZEVEDO MOGI MIRIM', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5670, 15715, 'FACULDADE DE TECNOLOGIA DE LINS', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5671, 15716, 'CENTRO EDUCACIONAL EM AERONAUTICA', 2, 1, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5672, 15745, 'FACULDADE DE TECNOLOGIA DE SAO CAETANO DO SUL', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5673, 15746, 'FACULDADE DE TECNOLOGIA DO IPIRANGA', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5674, 15752, 'FACULDADE DE TECNOLOGIA DE GUARULHOS', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5675, 15753, 'FACULDADE DE TECNOLOGIA DE JABOTICABAL', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5676, 15757, 'FACULDADE DE TECNOLOGIA DE BARUERI', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5677, 15769, 'FACULDADE DE TECNOLOGIA DE JALES', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5678, 15775, 'FACULDADE DE TECNOLOGIA PROFESSOR FERNANDO AMARAL DE ALMEIDA PRADO', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5679, 15777, 'FACULDADE SUDOESTE PAULISTAITAPETININGA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5680, 15784, 'FACULDADE DE TECNOLOGIA ESTUDANTE RAFAEL ALMEIDA CAMARINHA MARILIA', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5681, 15793, 'FACULDADE DE TECNOLOGIA DE SAO SEBASTIAO', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5682, 15803, 'FACULDADE DE TECNOLOGIA DE TATUI PROF. WILSON ROBERTO RIBEIRO DE CAMARGO', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5684, 15839, 'FACULDADE MOTIVA', 4, 2, 'PB', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5685, 15859, 'FACULDADE CATOLICA PAULISTA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5686, 15873, 'FACULDADE ITAQUA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5687, 15894, 'SOBRESP - FACULDADE DE CIENCIAS DA SAUDE', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5688, 15980, 'FACULDADE GAUCHA', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5689, 16037, 'INSTITUTO SUPERIOR DE CIENCIAS POLICIAIS', 2, 1, 'DF', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5690, 16194, 'FACULDADE GRAN TIETE', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5691, 16395, 'FACULDADE DE TECNOLOGIA DE CARAPICUIBA', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5692, 16410, 'FACULDADE DE TECNOLOGIA DE CATANDUVA', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5693, 16453, 'FACULDADE DE TECNOLOGIA APOENA', 4, 2, 'CE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5694, 16502, 'FACULDADE PESTALOZZI DE FRANCA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5695, 16525, 'FACULDADE DUARTE COELHO', 4, 2, 'PE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5696, 16543, 'FACULDADE METROPOLITANA DO ESTADO DE SÃO PAULO', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5761, 16602, 'FACULDADE DE EDUCAÇÃO ELIÂ', 4, 2, 'PA', 1, '2016-07-08 14:18:30.307841', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5697, 16728, 'FACULDADE DE CIENCIAS HUMANAS, ECONOMICAS E DA SAUDE', 4, 2, 'TO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5698, 16759, 'FACULDADE DO BICO DO PAPAGAIO', 4, 2, 'TO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5699, 16781, 'FACULDADE RIO SONO', 4, 2, 'TO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5762, 16782, 'Faculdade Mário Quintana', 4, 2, 'RS', 1, '2016-07-08 14:18:30.308305', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5763, 16849, 'Faculdade Modal', 4, 2, 'MG', 1, '2016-07-08 14:18:30.308763', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5700, 16864, 'FACULDADE CULTURA INGLESA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5701, 16881, 'FACULDADE PARA O DESENVOLVIMENTO DO SUDESTE TOCANTINENSE', 4, 2, 'TO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5702, 16894, 'FACULDADE DEVRY DE SÃO LUÍS', 4, 2, 'MA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5703, 16898, 'FACULDADE DE EDUCAÇÃO E TECNOLOGIA DA AMAZÔNIA', 4, 2, 'PA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5704, 16901, 'INSTITUTO EDUCATIE', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5705, 16914, 'FACULDADE LEONARDO DA VINCI SANTA CATARINA', 4, 2, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5764, 16918, 'FACULDADE CATÓLICA DE FEIRA DE SANTANA', 4, 2, 'BA', 1, '2016-07-08 14:18:30.309234', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5706, 16934, 'FACULDADE MELIES DE TECNOLOGIA ', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5707, 16943, 'FACULDADE TALLES DE MILETO', 4, 2, 'RN', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5765, 16948, 'Faculdade 28 de Agosto de Ensino e Pesquisa', 4, 2, 'SP', 1, '2016-07-08 14:18:30.309712', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5708, 16967, 'FACULDADE SENAI DE TECNOLOGIA', 4, 2, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5709, 17014, 'CENTRO SUPERIOR DE ESTUDOS JURIDICOS CARLOS DRUMMOND DE ANDRADE', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5766, 17025, 'Faculdade de Educação Superior de Paragominas', 4, 2, 'PA', 1, '2016-07-08 14:18:30.310355', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5767, 17091, 'Faculdade de Negócios do Recife', 4, 2, 'PE', 1, '2016-07-08 14:18:30.310892', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5768, 17115, 'FACULDADE DA UNIÃO DE ENSINO E PESQUISA INTEGRADA', 4, 2, 'PB', 1, '2016-07-08 14:18:30.311408', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5769, 17118, 'Faculdade do Norte de Mato Grosso', 4, 2, 'MT', 1, '2016-07-08 14:18:30.311934', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5710, 17138, 'CENTRO UNIVERSITARIO CATOLICA DE SANTA CATARINA EM JOINVILLE', 4, 2, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5711, 17165, 'FACULDADE UNILAGOS', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5712, 17200, 'FACULDADE BRASILEIRA DE TRIBUTAÇÃO', 4, 2, 'RS', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5715, 17269, 'INSTITUTO SUPERIOR DE INOVAÇÃO E TECNOLOGIA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5716, 17277, 'FACULDADE DE TECNOLOGIA SENAC CRICIUMA', 4, 2, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5717, 17284, 'FACULDADE DE TECNOLOGIA INESUL DO MARANHAO', 4, 2, 'MA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5718, 17288, 'FACULDADE TEOLÓGICA BETÂNIA', 4, 2, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5770, 17289, 'Faculdade de Teologia de Caratinga Uriel de Almeida Leitão', 4, 2, 'MG', 1, '2016-07-08 14:18:30.31245', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5719, 17291, 'FACULDADE ANTONIO PROPICIO AGUIAR FRANCO', 3, 1, 'TO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5720, 17322, 'FACULDADE INTEGRADA DE ARAGUATINS', 3, 1, 'TO', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5721, 17326, 'FACULDADE GIANNA BERETTA', 4, 2, 'MA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5771, 17348, 'Faculdade de Tecnologia dos Inconfidentes', 4, 2, 'MG', 1, '2016-07-08 14:18:30.31299', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5772, 17355, 'Faculdade de Educação em Ciências da Saúde', 4, 2, 'SP', 1, '2016-07-08 14:18:30.313468', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5773, 17382, 'Faculdade Ietec', 4, 2, 'MG', 1, '2016-07-08 14:18:30.313964', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5774, 17394, 'Faculdade Alencarina de Sobral', 4, 2, 'CE', 1, '2016-07-08 14:18:30.314436', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5775, 17400, 'Faculdade Menino Deus', 4, 2, 'RS', 1, '2016-07-08 14:18:30.314901', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5722, 17401, 'FACULDADE DE TECNOLOGIA CNA', 4, 2, 'DF', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5776, 17403, 'FACULDADE ARI DE SÁ', 4, 2, 'CE', 1, '2016-07-08 14:18:30.315443', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5777, 17420, 'FACULDADE CESUMAR DE PONTA GROSSA', 4, 2, 'PR', 1, '2016-07-08 14:18:30.315974', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5723, 17433, 'FACULDADE SANTO AGOSTINHO DE VITÓRIA DA CONQUISTA', 4, 2, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5778, 17460, 'FACULDADE Profissional', 4, 2, 'PR', 1, '2016-07-08 14:18:30.316482', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5724, 17498, 'FACULDADE DE SAÚDE SANTO AGOSTINHO DE VITÓRIA DA CONQUISTA', 4, 2, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5725, 17516, 'FACULDADE DE TECNOLOGIA DO SENAI HORACIO AUGUSTO DA SILVEIRA', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5726, 17542, 'FACULDADE COMUNITARIA DE GUARAPARI', 4, 2, 'ES', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5779, 17558, 'Faculdade Santo André', 4, 2, 'RO', 1, '2016-07-08 14:18:30.31701', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5780, 17563, 'FACULDADE COESP', 4, 2, 'PB', 1, '2016-07-08 14:18:30.317484', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5781, 17565, 'FACULDADE DE CIÊNCIAS HUMANAS,EXATAS E DA SAÚDE DO PIAUÍ', 4, 2, 'PI', 1, '2016-07-08 14:18:30.317941', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5782, 17590, 'Faculdade ISAE BRASIL', 4, 2, 'PR', 1, '2016-07-08 14:18:30.318405', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5783, 17593, 'Faculdade de Botucatu', 4, 2, 'SP', 1, '2016-07-08 14:18:30.318861', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5784, 17598, 'FACULDADE PROF. WLADEMIR DOS SANTOS', 4, 2, 'SP', 1, '2016-07-08 14:18:30.319285', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5785, 17608, 'Faculdade de Educação Paulistana', 4, 2, 'SP', 1, '2016-07-08 14:18:30.319743', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5786, 17622, 'Faculdade Talles de Mileto - Sede Dragão do Mar', 4, 2, 'CE', 1, '2016-07-08 14:18:30.320402', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5787, 17628, 'Faculdade do Maciço do Baturité', 4, 2, 'CE', 1, '2016-07-08 14:18:30.321051', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5727, 17631, 'FACULDADE SENAI DE TECNOLOGIA DE POCOS DE CALDAS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5728, 17633, 'CENTRO DE EDUCACAO SUPERIOR DA FOZ DO ITAJAI CESFI', 2, 1, 'SC', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5788, 17662, 'Faculdade Galileu', 4, 2, 'SP', 1, '2016-07-08 14:18:30.321547', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5789, 17670, 'Faculdade de Quixeramobim', 4, 2, 'CE', 1, '2016-07-08 14:18:30.322035', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5790, 17672, 'INSTITUTO DE DIREITO PÚBLICO DE SÃO PAULO', 4, 2, 'SP', 1, '2016-07-08 14:18:30.322504', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5791, 17674, 'Faculdade de Educação de São Mateus', 4, 2, 'MA', 1, '2016-07-08 14:18:30.323067', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5729, 17690, 'FACULDADE DE TECNOLOGIA SENAI ROBERTO MANGE', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5730, 17691, 'FACULDADE DE TECNOLOGIA SENAI GASPAR RICARDO JUNIOR', 4, 2, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5792, 17701, 'FAP-FACULDADE DE PINHEIROS', 4, 2, 'ES', 1, '2016-07-08 14:18:30.323623', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5793, 17731, 'FACULDADE SESI-SP DE EDUCAÇÃO', 4, 2, 'SP', 1, '2016-07-08 14:18:30.324139', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5794, 17749, 'Faculdade América', 4, 2, 'ES', 1, '2016-07-08 14:18:30.324655', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5795, 17763, 'Faculdade SENAI de João Pessoa', 4, 2, 'PB', 1, '2016-07-08 14:18:30.325166', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5731, 17775, 'FACULDADE DE CIENCIAS DA SAUDE DE SERRA TALHADA', 3, 1, 'PE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5796, 17816, 'FACULDADE MAURÍCIO DE NASSAU DE FEIRA DE SANTANA', 4, 2, 'BA', 1, '2016-07-08 14:18:30.325665', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5797, 17828, 'Faculdade do Centro Leste - Cariacica', 4, 2, 'ES', 1, '2016-07-08 14:18:30.326154', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5798, 17831, 'Faculdade de Tecnologia e Negócios de Catalão', 4, 2, 'GO', 1, '2016-07-08 14:18:30.326683', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5799, 17850, 'FACULDADE TECNOLÓGICA SANTANNA', 4, 2, 'SP', 1, '2016-07-08 14:18:30.327206', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5800, 17854, 'FACULDADE CAPITAL FEDERAL', 4, 2, 'SP', 1, '2016-07-08 14:18:30.327744', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5732, 17942, 'FACULDADE DE TECNOLOGIA DO TATUAPE', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5733, 17952, 'FACULDADE DE TECNOLOGIA DE JACAREI', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5734, 17953, 'FACULDADE DE TECNOLOGIA DE POMPEIA SHUNJI NISHIMURA', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5735, 17977, 'FACULDADE DE TECNOLOGIA DE ITAQUERA', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5801, 18010, 'Faculdade Estácio de Cuiabá', 4, 2, 'MT', 1, '2016-07-08 14:18:30.328253', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5802, 18019, 'Faculdade do Educador', 4, 2, 'SP', 1, '2016-07-08 14:18:30.328747', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5803, 18023, 'FACULDADE MAURÍCIO DE NASSAU DE PETROLINA', 4, 2, 'PE', 1, '2016-07-08 14:18:30.329266', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5736, 18049, 'FACULDADE DE TECNOLOGIA DE TAUBATE', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5737, 18065, 'CISNE - FACULDADE DE QUIXADÁ', 4, 2, 'CE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5804, 18067, 'CISNE - Faculdade Tecnológica de Quixadá', 4, 2, 'CE', 1, '2016-07-08 14:18:30.329795', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5805, 18075, 'FACULDADE MAURÍCIO DE NASSAU DE JABOATÃO DOS GUARARAPES', 4, 2, 'PE', 1, '2016-07-08 14:18:30.330491', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5738, 18099, 'FACULDADE DE TECNOLOGIA DE DIADEMA LUIGI PAPAIZ', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5806, 18114, 'Faculdade Fasipe Mato Grosso', 4, 2, 'MT', 1, '2016-07-08 14:18:30.331224', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5807, 18133, 'Faculdade Unida de Campinas Goiânia - FACUNICAMPS GOIÂNIA', 4, 2, 'GO', 1, '2016-07-08 14:18:30.331864', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5808, 18165, 'Fundação Universidade Virtual do Estado de São Paulo', 2, 1, 'SP', 1, '2016-07-08 14:18:30.332461', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5809, 18257, 'FACULDADE SÄO JOSÉ', 4, 2, 'SC', 1, '2016-07-08 14:18:30.333078', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5810, 18288, 'Faculdade Latino-americana', 4, 2, 'SP', 1, '2016-07-08 14:18:30.333668', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5739, 18440, 'UNIVERSIDADE FEDERAL DO SUL E SUDESTE DO PARA', 1, 1, 'PA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5740, 18492, 'UNIVERSIDADE ESTADUAL DO PARANÁ', 2, 1, 'PR', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5741, 18506, 'UNIVERSIDADE FEDERAL DO OESTE DA BAHIA', 1, 1, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5742, 18759, 'UNIVERSIDADE FEDERAL DO CARIRI', 1, 1, 'CE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5743, 18812, 'UNIVERSIDADE FEDERAL DO SUL DA BAHIA', 1, 1, 'BA', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5744, 18817, 'FACULDADE DE TECNOLOGIA DE SÃO ROQUE', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5745, 18874, 'FACULDADE RAIMUNDO MARINHO DE PENEDO', 4, 2, 'AL', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5746, 19337, 'FACULDADE PARA O DESENVOLVIMENTO SUSTENTÁVEL DO NORDESTE', 4, 2, 'CE', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5811, 19500, 'Faculdade de Tecnologia de São Carlos', 2, 1, 'SP', 1, '2016-07-08 14:18:30.334248', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5747, 19501, 'FACULDADE DE TECNOLOGIA SEBRAE', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5812, 19501, 'FACULDADE DE TECNOLOGIA SEBRAE', 2, 1, 'SP', 1, '2016-07-08 14:18:30.334732', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5748, 19512, 'INSTITUTO MASTER DE ENSINO PRESIDENTE ANTÔNIO CARLOS', 4, 2, 'MG', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5813, 19512, 'INSTITUTO MASTER DE ENSINO PRESIDENTE ANTÔNIO CARLOS', 4, 2, 'MG', 1, '2016-07-08 14:18:30.335189', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5814, 19578, 'Faculdade de Tecnologia de Cotia', 2, 1, 'SP', 1, '2016-07-08 14:18:30.335677', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5749, 19588, 'FACULDADE DE EDUCAÇÃO TECNOLÓGICA DO ESTADO DO RIO DE JANEIRO', 2, 1, 'RJ', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5815, 19588, 'FACULDADE DE EDUCAÇÃO TECNOLÓGICA DO ESTADO DO RIO DE JANEIRO', 2, 1, 'RJ', 1, '2016-07-08 14:18:30.336104', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5750, 19739, 'FACULDADE DE TECNOLOGIA DE CAMPINAS', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5816, 19739, 'FACULDADE DE TECNOLOGIA DE CAMPINAS', 2, 1, 'SP', 1, '2016-07-08 14:18:30.336569', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5817, 19862, 'Faculdade de Tecnologia de Bebedouro', 2, 1, 'SP', 1, '2016-07-08 14:18:30.337011', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5751, 19863, 'FACULDADE DE TECNOLOGIA DE ASSIS', 2, 1, 'SP', 1, '2015-06-30 21:47:05.334581', '2015-06-30 21:47:05.334581');
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5818, 20478, 'Faculdade de Tecnologia de Santana de Parnaíba', 2, 1, 'SP', 1, '2016-07-08 14:18:30.33749', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5819, 21095, 'Academia Militar das Agulhas Negras', 3, 1, 'RJ', 1, '2016-07-08 14:18:30.337997', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5820, 21206, 'Escola de Educação Física do Exército', 3, 1, 'RJ', 1, '2016-07-08 14:18:30.338552', NULL);
INSERT INTO educacenso_ies (id, ies_id, nome, dependencia_administrativa_id, tipo_instituicao_id, uf, user_id, created_at, updated_at) VALUES (5301, 9999999, 'INSTITUICAO NAO CADASTRADA', 4, 2, NULL, 1, '2010-09-20 11:44:14.453', NULL);


--
-- Name: educacenso_ies_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('educacenso_ies_id_seq', 5820, true);


--
-- Data for Name: empresa_transporte_escolar; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Name: empresa_transporte_escolar_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('empresa_transporte_escolar_seq', 1, false);


--
-- Data for Name: etapas_curso_educacenso; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Data for Name: etapas_educacenso; Type: TABLE DATA; Schema: modules; Owner: postgres
--

INSERT INTO etapas_educacenso (id, nome) VALUES (1, 'Educação Infantil - Creche (0 a 3 anos)');
INSERT INTO etapas_educacenso (id, nome) VALUES (2, 'Educação Infantil - Pré-escola (4 a 5 anos)');
INSERT INTO etapas_educacenso (id, nome) VALUES (3, 'Ensino Fundamental 8 anos');
INSERT INTO etapas_educacenso (id, nome) VALUES (4, 'Ensino Fundamental 9 anos');
INSERT INTO etapas_educacenso (id, nome) VALUES (5, 'Ensino médio - Médio');
INSERT INTO etapas_educacenso (id, nome) VALUES (6, 'Ensino médio - Integrado');
INSERT INTO etapas_educacenso (id, nome) VALUES (7, 'Ensino médio - Normal/Magistério');
INSERT INTO etapas_educacenso (id, nome) VALUES (8, 'Ensino médio - Educação profissional');
INSERT INTO etapas_educacenso (id, nome) VALUES (9, 'EJA - Ensino fundamental');
INSERT INTO etapas_educacenso (id, nome) VALUES (10, 'EJA - Ensino médio');
INSERT INTO etapas_educacenso (id, nome) VALUES (11, 'EJA - Ensino fundamental - Projovem (urbano)');


--
-- Data for Name: falta_aluno; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Name: falta_aluno_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('falta_aluno_id_seq', 2, true);


--
-- Data for Name: falta_componente_curricular; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Name: falta_componente_curricular_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('falta_componente_curricular_id_seq', 1, true);


--
-- Data for Name: falta_geral; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Name: falta_geral_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('falta_geral_id_seq', 1, false);


--
-- Data for Name: ficha_medica_aluno; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Data for Name: formula_media; Type: TABLE DATA; Schema: modules; Owner: postgres
--

INSERT INTO formula_media (id, instituicao_id, nome, formula_media, tipo_formula, substitui_menor_nota_rc) VALUES (1, 1, 'Média aritmética', 'Se / Et', 1, 0);
INSERT INTO formula_media (id, instituicao_id, nome, formula_media, tipo_formula, substitui_menor_nota_rc) VALUES (2, 1, 'Média recuperação ponderada', '(Rc * 0.4) + (Se / Et * 0.6)', 2, 0);


--
-- Name: formula_media_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('formula_media_id_seq', 2, true);


--
-- Data for Name: itinerario_transporte_escolar; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Name: itinerario_transporte_escolar_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('itinerario_transporte_escolar_seq', 1, false);


--
-- Data for Name: lingua_indigena_educacenso; Type: TABLE DATA; Schema: modules; Owner: postgres
--

INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (30, 'Boróro');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (244, 'Umutína');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (42, 'Guató');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (12, 'Apinayé');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (251, 'Canela');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (252, 'Kanéla Apaniekra/Canela Apaniekrã');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (205, 'Kanéla Rankocamekra/ Canela Ramkokamekrã');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (253, 'Gavião Krikatêjê/ Gavião Krinkatejé');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (254, 'Gavião Parkatêjê/ Guató Parakatejé/ Gavião do Pará');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (240, 'Gavião Pukobiyé/ Gavião Pukobié');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (255, 'Krahô/ Crao, Kraô');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (256, 'Krao Kanela');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (223, 'Kreje/ Krenjé');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (224, 'Krikatí/ Krinkatí');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (257, 'Kokuiregatêjê/ Kokuiregatejje');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (258, 'Timbira');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (235, 'Kaingáng');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (221, 'Mebengokré (Kayapó)');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (86, 'Mentuktíre, Txukahamae (Kayapó)');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (220, 'Kayapó');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (81, 'Gorotire (Kayapó)');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (82, 'Kararaô (Kayapó)');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (83, 'Kokraimoro (Kayapó)');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (84, 'Kubenkrngkegn (Kayapó)');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (85, 'Menkrangnoti (Kayapó)');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (87, 'Xikrin (Kayapó)');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (132, 'Panará, Krenakarôre/ Kren-akarôre');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (150, 'Suyá, Kisêdjê/ Kisedjê');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (241, 'Tapayúna');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (259, 'Xacriabá/ Xakriabá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (5, 'Xavánte/ Xavante');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (6, 'Xerénte');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (188, 'Xokléng');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (260, 'Jê (não específico)');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (63, 'Karajá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (50, 'Javaé');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (185, 'Xambioá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (92, 'Krenák');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (107, 'Maxakalí');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (261, 'Pataxó');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (262, 'Pataxó Hã Hã Hãe/ Pataxó Há-Há-Há');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (129, 'Ofayé');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (142, 'Canoeiros/ Rikbaktsá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (192, 'Fulni-ô/ Yathê');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (65, 'Karitiána');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (23, 'Awetí');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (51, 'Jurúna/ Yudjá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (187, 'Xipáya');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (106, 'Mawé');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (200, 'Arara do Aripuana/ Arara do Aripuanã');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (19, 'Aruá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (31, 'Cinta Larga/ Cinta-Larga');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (36, 'Gavião (Ikõro, Digüt), Gavião de Rondônia/ Ikolen');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (197, 'Zoró');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (263, 'Salamãy');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (236, 'Suruí de Rondônia');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (111, 'Mondé, Tupí-Mondé');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (112, 'Mundurukú');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (96, 'Kuruáya');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (141, 'Puruborá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (66, 'Arara de Rondônia/ Káro');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (264, 'Ramaráma');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (265, 'Urucú/ Urucu');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (198, 'Akuntsú');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (99, 'Makuráp');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (110, 'Sakurabiat/ Kampé');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (171, 'Tuparí');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (2, 'Ajuru/ Wayoro, Ajurú');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (7, 'Amanayé');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (11, 'Apiaká');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (17, 'Araweté');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (20, 'Asuriní do Tocantins');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (237, 'Parakanã');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (4, 'Suruí do Pará/ Suruí do Tocantins/ Aikewara');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (21, 'Asuriní do Xingu');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (22, 'Ava-Canoeiro/ Avá-Canoeiro, Avá, Canoeiro');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (37, 'Guajá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (266, 'Guaraní');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (38, 'Guaraní Kaiowá/ Guarani Kayová');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (39, 'Guaraní Mbyá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (40, 'Guaraní Nhandéva');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (52, 'Kaapor/ Urubu, Kaapór');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (267, 'Lingua De Sinais Kaapor/ Língua de Sinais Urubu-Kaapór');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (59, 'Kamayurá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (199, 'Amondáwa');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (208, 'Diahói/ Diahui');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (215, 'Júma/ Juma');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (219, 'Karipúna');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (268, 'Kawahíb');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (238, 'Parintintín');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (243, 'Tenharím/ Tenharim');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (76, 'Uru-Eu-Wau-Wau/ Uruewawau');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (80, 'Kayabí');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (90, 'Kokáma');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (204, 'Kambéba');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (126, 'Lingua Geral Amazônica, Nheengatu');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (151, 'Tapirapé');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (211, 'Guajajára');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (155, 'Tembé');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (269, 'Turiwára');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (183, 'Wayampí/ Oyampi');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (186, 'Xetá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (196, 'Zoé');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (270, 'Tupí-Guaraní');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (250, 'Tupí, Tupi Antigo');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (13, 'Apurinã');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (60, 'Ashanínka/ Axanínka');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (26, 'Baníwa/ Tapiira Tapuya, Kawa Tapuya');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (226, 'Kuripáko');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (29, 'Baré');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (145, 'Enawenê-Nawê');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (271, 'Kaixána/ Kayuisiana');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (222, 'Kinikináu, Kinikinawa');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (272, 'Machinéri');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (273, 'Mawayána');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (109, 'Mehináku');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (131, 'Palikúr');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (133, 'Paresí');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (152, 'Tariána');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (156, 'Teréna');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (179, 'Wapixána');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (180, 'Warekéna');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (182, 'Wauja/ Waurá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (193, 'Yawalapití');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (274, 'Aruák');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (10, 'Apalaí');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (201, 'Arara do Pará, Arara do Xingu');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (24, 'Bakairí');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (35, 'Galibí do Oiapoque, Galibí (Karíña)');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (43, 'Hixkaryána');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (173, 'Ikpeng/ Ikpéng');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (45, 'Ingarikó');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (58, 'Kalapálo');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (94, 'Kuikúro');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (103, 'Matipú');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (116, 'Nahukwá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (275, 'Naravúte');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (276, 'Kaxuyána/ Kahyána, Warikyána');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (277, 'Xikuyána/ Sikiyána');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (100, 'Makuxí');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (218, 'Kapon Patamóna/ Kapon Ptamóna');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (153, 'Taulipáng');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (167, 'Tiriyó/ Tarona');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (177, 'Wái Wái/ Waiwái');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (176, 'Waimirí-Atroarí');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (184, 'Wayána');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (108, 'Yekuána, Mayongong, Makiritáre,');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (278, 'Karib');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (15, 'Arara do Acre, Shawãdawa');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (68, 'Katukína do Acre');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (77, 'Kaxararí');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (78, 'Kaxinawá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (91, 'Korúbo');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (279, 'Kulína Páno');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (102, 'Marúbo');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (104, 'Matís');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (105, 'Matsés');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (389, 'Maya');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (128, 'Nukiní');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (140, 'Poyanáwa');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (246, 'Shanenáwa/ Xanenáwa, Xawanawa');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (49, 'Yamináwa');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (194, 'Yawanawá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (280, 'Pano');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (14, 'Arapáso');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (28, 'Bará');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (203, 'Barasána');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (33, 'Desána');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (64, 'Karapanã');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (178, 'Wanána/ Guanána');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (93, 'Kubéo, Kubewa');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (281, 'Makúna, Yebá-masã');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (282, 'Siriáno/ Suriana, Suriána');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (234, 'Tukáno / Miriti-Tapuia');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (172, 'Tuyúca / Tuyuca');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (216, 'Yurutí, Juriti');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (138, 'Piratapúya');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (283, 'Arawá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (25, 'Banawá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (32, 'Dení');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (284, 'Himarimã/ Hi-merimã, Mirimã, Himarimá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (285, 'Jamamadí-Kanamanti/ Jamamadí');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (48, 'Jarawára');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (95, 'Kulína Madijá/ Kulina, Kulína Madihá (Madija)');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (136, 'Paumarí');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (148, 'Zuruwahá, Suruahá (Zuruahá)');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (61, 'Kanamarí');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (69, 'Katukína');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (174, 'Tsohom Djapa/ Tsohondjapá (Tsohom Djapa)');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (67, 'Katawixí');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (34, 'Dâw');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (286, 'Hup, Húpda, Maku, Yuhupde, Yuhúp');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (115, 'Nadëb');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (287, 'Alaketesú');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (288, 'Alantesú');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (289, 'Hahaintesú');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (290, 'Halotesú');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (291, 'Kithaulú');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (231, 'Mandúka/ Nambikwára do Campo');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (292, 'Sararé');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (300, 'Sawentesú');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (301, 'Waikisú');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (302, 'Wakalitesú');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (303, 'Wasusú');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (228, 'Lakondê');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (229, 'Latundê');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (120, 'Negarotê/ Negarote');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (230, 'Mamaindê');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (242, 'Tawandê');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (143, 'Sabanê');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (304, 'Nambikwára');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (225, 'Kujubím');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (305, 'Miguelénho/ Migueleno, Miguelenho');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (130, 'Oro Win');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (168, 'Torá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (175, 'Urupá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (245, 'Pakaá Nóva/Migueleno, Miguelenho');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (306, 'Txapakúra');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (127, 'Ninám');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (146, 'Sanumá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (190, 'Yanomám/ Yanonmán');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (191, 'Yanomámi');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (307, 'Bóra');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (233, 'Miránha');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (53, 'Kadiwéu');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (308, 'Guaikurú');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (113, 'Múra');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (137, 'Pirahã');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (206, 'Chamakóko/ Samúko, Chamacoco');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (207, 'Chiquitáno/ Chiquito');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (18, 'Arikapú/ Jabutí');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (47, 'Djeoromitxí/ Jabotí/ Jabutí');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (309, 'Witóto');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (1, 'Aikaná/ Aikanã');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (46, 'Irántxe');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (114, 'Mynky/ Mynký, Meky, Menky, Menki');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (227, 'Kwazá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (62, 'Kanoé/ Kanoê');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (157, 'Tikúna');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (169, 'Trumái');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (135, 'Galibí Marwórno/ Galibi Marworno');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (134, 'Karipúna do Amapá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (310, 'Acona/ Akona');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (311, 'Aimoré');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (312, 'Anacé');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (313, 'Apolima - Arara');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (314, 'Arana');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (315, 'Arapiun');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (316, 'Arikén');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (317, 'Arikose');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (318, 'Atikum');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (319, 'Awi');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (320, 'Baenã');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (321, 'Borari');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (322, 'Botocudo');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (323, 'Catokin (Katukína)');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (324, 'Charrúa/ Charrua');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (325, 'Coiupanka');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (326, 'Guara');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (327, 'Guarino');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (328, 'Guaru');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (329, 'Isse');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (330, 'Jaricuna');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (331, 'Jeripancó/ Jeripankó');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (332, 'Kaete');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (333, 'Kaimbé');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (334, 'Kalabassa');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (335, 'Kalankó');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (336, 'Kamba/ Kámba');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (337, 'Kambiwá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (338, 'Kambiwá Pipipã');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (339, 'Kanindé');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (340, 'Kantaruré');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (341, 'Kapinawá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (342, 'Karapoto/ Karapotó');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (343, 'Karijo');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (344, 'Kariri/ Karirí');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (345, 'Kariri - Xocó/ Karirí-Xocó');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (346, 'Kaxixó');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (347, 'Kayuisiana -(Kaixána)');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (348, 'Kiriri');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (349, 'Kueskue');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (350, 'Manao/ Manáo');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (351, 'Maragua');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (352, 'Maytapu');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (353, 'Mucurim');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (354, 'Nawa/ Náwa');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (355, 'Paiaku');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (356, 'Pankará');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (357, 'Pankararé');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (358, 'Pankararú/ Pankarú');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (359, 'Pankararú - Kalanko');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (360, 'Pankararú - Karuazu');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (361, 'Pankaru');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (362, 'Patxôhã/ Patxoha');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (363, 'Paumelenho');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (364, 'Piri-Piri/ Pirí-Pirí');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (365, 'Pitaguari/ Pitaguarí');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (366, 'Potiguara/ Potiguára');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (367, 'Puri/ Purí');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (368, 'Sapará/ Sapara');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (369, 'Tabajara');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (370, 'Tapajós');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (371, 'Tapeba');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (372, 'Tapiuns/ Tapiun');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (373, 'Tapuía/ Tapúya');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (374, 'Tingui Botó/ Tinguí-Botó');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (375, 'Tremembé');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (376, 'Truká');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (377, 'Tumbalalá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (378, 'Tupinambá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (379, 'Tupinambaraná');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (380, 'Tupiniquim');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (381, 'Tuxá');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (382, 'Waira');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (383, 'Waiána-Apalaí');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (384, 'Wajuju/ Wajujú');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (385, 'Wassú (Wasusú)');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (386, 'Xocó');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (387, 'Xucuru/ Xukurú');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (388, 'Xucuru - Kariri/ Xukurú-Karirí');
INSERT INTO lingua_indigena_educacenso (id, lingua) VALUES (999, 'Outras Linguas Indigenas');


--
-- Data for Name: media_geral; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Data for Name: moradia_aluno; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Data for Name: motorista; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Name: motorista_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('motorista_seq', 1, false);


--
-- Data for Name: nota_aluno; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Name: nota_aluno_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('nota_aluno_id_seq', 2, true);


--
-- Data for Name: nota_componente_curricular; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Name: nota_componente_curricular_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('nota_componente_curricular_id_seq', 1, true);


--
-- Data for Name: nota_componente_curricular_media; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Data for Name: nota_exame; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Data for Name: nota_geral; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Name: nota_geral_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('nota_geral_id_seq', 958638, false);


--
-- Data for Name: parecer_aluno; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Name: parecer_aluno_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('parecer_aluno_id_seq', 1, false);


--
-- Data for Name: parecer_componente_curricular; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Name: parecer_componente_curricular_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('parecer_componente_curricular_id_seq', 1, false);


--
-- Data for Name: parecer_geral; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Name: parecer_geral_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('parecer_geral_id_seq', 1, false);


--
-- Data for Name: pessoa_transporte; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Name: pessoa_transporte_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('pessoa_transporte_seq', 1, false);


--
-- Data for Name: ponto_transporte_escolar; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Name: ponto_transporte_escolar_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('ponto_transporte_escolar_seq', 1, false);


--
-- Data for Name: professor_turma; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Data for Name: professor_turma_disciplina; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Name: professor_turma_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('professor_turma_id_seq', 1, false);


--
-- Data for Name: regra_avaliacao; Type: TABLE DATA; Schema: modules; Owner: postgres
--

INSERT INTO regra_avaliacao (id, instituicao_id, formula_media_id, formula_recuperacao_id, tabela_arredondamento_id, nome, tipo_nota, tipo_progressao, media, porcentagem_presenca, parecer_descritivo, tipo_presenca, media_recuperacao, tipo_recuperacao_paralela, media_recuperacao_paralela, nota_maxima_geral, nota_maxima_exame_final, qtd_casas_decimais, nota_geral_por_etapa, qtd_disciplinas_dependencia, aprova_media_disciplina, reprovacao_automatica, definir_componente_etapa, qtd_matriculas_dependencia, nota_minima_geral, tabela_arredondamento_id_conceitual) VALUES (1, 1, 1, 2, 1, 'Regra de avaliação quantitativa', 1, 2, 6.000, 75.000, 0, 2, 6.000, 0, NULL, 10, 10, 2, 0, 0, 0, 0, 0, 0, 0, NULL);
INSERT INTO regra_avaliacao (id, instituicao_id, formula_media_id, formula_recuperacao_id, tabela_arredondamento_id, nome, tipo_nota, tipo_progressao, media, porcentagem_presenca, parecer_descritivo, tipo_presenca, media_recuperacao, tipo_recuperacao_paralela, media_recuperacao_paralela, nota_maxima_geral, nota_maxima_exame_final, qtd_casas_decimais, nota_geral_por_etapa, qtd_disciplinas_dependencia, aprova_media_disciplina, reprovacao_automatica, definir_componente_etapa, qtd_matriculas_dependencia, nota_minima_geral, tabela_arredondamento_id_conceitual) VALUES (2, 1, 1, NULL, 2, 'Regra de avaliação qualitativa', 2, 1, 6.000, 80.000, 0, 2, 6.000, 0, NULL, 10, 10, 5, 0, 0, 0, 0, 0, 0, 0, NULL);


--
-- Name: regra_avaliacao_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('regra_avaliacao_id_seq', 2, true);


--
-- Data for Name: regra_avaliacao_recuperacao; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Name: regra_avaliacao_recuperacao_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('regra_avaliacao_recuperacao_id_seq', 1, false);


--
-- Data for Name: rota_transporte_escolar; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Name: rota_transporte_escolar_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('rota_transporte_escolar_seq', 1, false);


--
-- Data for Name: tabela_arredondamento; Type: TABLE DATA; Schema: modules; Owner: postgres
--

INSERT INTO tabela_arredondamento (id, instituicao_id, nome, tipo_nota) VALUES (1, 1, 'Tabela padrão de notas numéricas', 1);
INSERT INTO tabela_arredondamento (id, instituicao_id, nome, tipo_nota) VALUES (2, 1, 'Tabela padrão de notas conceituais', 2);


--
-- Name: tabela_arredondamento_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('tabela_arredondamento_id_seq', 2, true);


--
-- Data for Name: tabela_arredondamento_valor; Type: TABLE DATA; Schema: modules; Owner: postgres
--

INSERT INTO tabela_arredondamento_valor (id, tabela_arredondamento_id, nome, descricao, valor_minimo, valor_maximo, casa_decimal_exata, acao) VALUES (22, 2, 'E', 'Insuficiente', 0.000, 1.900, NULL, NULL);
INSERT INTO tabela_arredondamento_valor (id, tabela_arredondamento_id, nome, descricao, valor_minimo, valor_maximo, casa_decimal_exata, acao) VALUES (23, 2, 'D', 'Irregular', 2.000, 4.900, NULL, NULL);
INSERT INTO tabela_arredondamento_valor (id, tabela_arredondamento_id, nome, descricao, valor_minimo, valor_maximo, casa_decimal_exata, acao) VALUES (24, 2, 'C', 'Bom', 5.000, 6.900, NULL, NULL);
INSERT INTO tabela_arredondamento_valor (id, tabela_arredondamento_id, nome, descricao, valor_minimo, valor_maximo, casa_decimal_exata, acao) VALUES (25, 2, 'B', 'Muito bom', 7.000, 8.900, NULL, NULL);
INSERT INTO tabela_arredondamento_valor (id, tabela_arredondamento_id, nome, descricao, valor_minimo, valor_maximo, casa_decimal_exata, acao) VALUES (26, 2, 'A', 'Excelente', 9.000, 10.000, NULL, NULL);
INSERT INTO tabela_arredondamento_valor (id, tabela_arredondamento_id, nome, descricao, valor_minimo, valor_maximo, casa_decimal_exata, acao) VALUES (1, 1, '0', NULL, 0.000, 0.400, NULL, NULL);
INSERT INTO tabela_arredondamento_valor (id, tabela_arredondamento_id, nome, descricao, valor_minimo, valor_maximo, casa_decimal_exata, acao) VALUES (2, 1, '0.5', NULL, 0.500, 0.900, NULL, NULL);
INSERT INTO tabela_arredondamento_valor (id, tabela_arredondamento_id, nome, descricao, valor_minimo, valor_maximo, casa_decimal_exata, acao) VALUES (3, 1, '1', NULL, 1.000, 1.400, NULL, NULL);
INSERT INTO tabela_arredondamento_valor (id, tabela_arredondamento_id, nome, descricao, valor_minimo, valor_maximo, casa_decimal_exata, acao) VALUES (4, 1, '1.5', NULL, 1.500, 1.900, NULL, NULL);
INSERT INTO tabela_arredondamento_valor (id, tabela_arredondamento_id, nome, descricao, valor_minimo, valor_maximo, casa_decimal_exata, acao) VALUES (5, 1, '2', NULL, 2.000, 2.400, NULL, NULL);
INSERT INTO tabela_arredondamento_valor (id, tabela_arredondamento_id, nome, descricao, valor_minimo, valor_maximo, casa_decimal_exata, acao) VALUES (6, 1, '2.5', NULL, 2.500, 2.900, NULL, NULL);
INSERT INTO tabela_arredondamento_valor (id, tabela_arredondamento_id, nome, descricao, valor_minimo, valor_maximo, casa_decimal_exata, acao) VALUES (7, 1, '3', NULL, 3.000, 3.400, NULL, NULL);
INSERT INTO tabela_arredondamento_valor (id, tabela_arredondamento_id, nome, descricao, valor_minimo, valor_maximo, casa_decimal_exata, acao) VALUES (8, 1, '3.5', NULL, 3.500, 3.900, NULL, NULL);
INSERT INTO tabela_arredondamento_valor (id, tabela_arredondamento_id, nome, descricao, valor_minimo, valor_maximo, casa_decimal_exata, acao) VALUES (9, 1, '4', NULL, 4.000, 4.000, NULL, NULL);
INSERT INTO tabela_arredondamento_valor (id, tabela_arredondamento_id, nome, descricao, valor_minimo, valor_maximo, casa_decimal_exata, acao) VALUES (10, 1, '4.5', NULL, 4.500, 4.900, NULL, NULL);
INSERT INTO tabela_arredondamento_valor (id, tabela_arredondamento_id, nome, descricao, valor_minimo, valor_maximo, casa_decimal_exata, acao) VALUES (11, 1, '5', NULL, 5.000, 5.400, NULL, NULL);
INSERT INTO tabela_arredondamento_valor (id, tabela_arredondamento_id, nome, descricao, valor_minimo, valor_maximo, casa_decimal_exata, acao) VALUES (12, 1, '5.5', NULL, 5.500, 5.900, NULL, NULL);
INSERT INTO tabela_arredondamento_valor (id, tabela_arredondamento_id, nome, descricao, valor_minimo, valor_maximo, casa_decimal_exata, acao) VALUES (13, 1, '6', NULL, 6.000, 6.400, NULL, NULL);
INSERT INTO tabela_arredondamento_valor (id, tabela_arredondamento_id, nome, descricao, valor_minimo, valor_maximo, casa_decimal_exata, acao) VALUES (14, 1, '6.5', NULL, 6.500, 6.900, NULL, NULL);
INSERT INTO tabela_arredondamento_valor (id, tabela_arredondamento_id, nome, descricao, valor_minimo, valor_maximo, casa_decimal_exata, acao) VALUES (15, 1, '7', NULL, 7.000, 7.400, NULL, NULL);
INSERT INTO tabela_arredondamento_valor (id, tabela_arredondamento_id, nome, descricao, valor_minimo, valor_maximo, casa_decimal_exata, acao) VALUES (16, 1, '7.5', NULL, 7.500, 7.900, NULL, NULL);
INSERT INTO tabela_arredondamento_valor (id, tabela_arredondamento_id, nome, descricao, valor_minimo, valor_maximo, casa_decimal_exata, acao) VALUES (17, 1, '8', NULL, 8.000, 8.400, NULL, NULL);
INSERT INTO tabela_arredondamento_valor (id, tabela_arredondamento_id, nome, descricao, valor_minimo, valor_maximo, casa_decimal_exata, acao) VALUES (18, 1, '8.5', NULL, 8.500, 8.900, NULL, NULL);
INSERT INTO tabela_arredondamento_valor (id, tabela_arredondamento_id, nome, descricao, valor_minimo, valor_maximo, casa_decimal_exata, acao) VALUES (19, 1, '9', NULL, 9.000, 9.400, NULL, NULL);
INSERT INTO tabela_arredondamento_valor (id, tabela_arredondamento_id, nome, descricao, valor_minimo, valor_maximo, casa_decimal_exata, acao) VALUES (20, 1, '9.5', NULL, 9.500, 9.900, NULL, NULL);
INSERT INTO tabela_arredondamento_valor (id, tabela_arredondamento_id, nome, descricao, valor_minimo, valor_maximo, casa_decimal_exata, acao) VALUES (21, 1, '10', NULL, 9.900, 10.000, NULL, NULL);


--
-- Name: tabela_arredondamento_valor_id_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('tabela_arredondamento_valor_id_seq', 26, true);


--
-- Data for Name: tipo_veiculo; Type: TABLE DATA; Schema: modules; Owner: postgres
--

INSERT INTO tipo_veiculo (cod_tipo_veiculo, descricao) VALUES (1, 'Vans/Kombis');
INSERT INTO tipo_veiculo (cod_tipo_veiculo, descricao) VALUES (2, 'Microônibus');
INSERT INTO tipo_veiculo (cod_tipo_veiculo, descricao) VALUES (3, 'Ônibus');
INSERT INTO tipo_veiculo (cod_tipo_veiculo, descricao) VALUES (4, 'Bicicleta');
INSERT INTO tipo_veiculo (cod_tipo_veiculo, descricao) VALUES (5, 'Tração Animal');
INSERT INTO tipo_veiculo (cod_tipo_veiculo, descricao) VALUES (6, 'Outro');
INSERT INTO tipo_veiculo (cod_tipo_veiculo, descricao) VALUES (7, 'Capacidade de até 5 Alunos');
INSERT INTO tipo_veiculo (cod_tipo_veiculo, descricao) VALUES (8, 'Capacidade entre 5 a 15 Alunos');
INSERT INTO tipo_veiculo (cod_tipo_veiculo, descricao) VALUES (9, 'Capacidade entre 15 a 35 Alunos');
INSERT INTO tipo_veiculo (cod_tipo_veiculo, descricao) VALUES (10, 'Capacidade acima de 35 Alunos');
INSERT INTO tipo_veiculo (cod_tipo_veiculo, descricao) VALUES (11, 'Trem/Metrô');


--
-- Name: tipo_veiculo_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('tipo_veiculo_seq', 1, false);


--
-- Data for Name: transporte_aluno; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Data for Name: uniforme_aluno; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Data for Name: veiculo; Type: TABLE DATA; Schema: modules; Owner: postgres
--



--
-- Name: veiculo_seq; Type: SEQUENCE SET; Schema: modules; Owner: postgres
--

SELECT pg_catalog.setval('veiculo_seq', 1, false);


SET search_path = pmiacoes, pg_catalog;

--
-- Data for Name: acao_governo; Type: TABLE DATA; Schema: pmiacoes; Owner: postgres
--



--
-- Data for Name: acao_governo_arquivo; Type: TABLE DATA; Schema: pmiacoes; Owner: postgres
--



--
-- Name: acao_governo_arquivo_cod_acao_governo_arquivo_seq; Type: SEQUENCE SET; Schema: pmiacoes; Owner: postgres
--

SELECT pg_catalog.setval('acao_governo_arquivo_cod_acao_governo_arquivo_seq', 1, false);


--
-- Data for Name: acao_governo_categoria; Type: TABLE DATA; Schema: pmiacoes; Owner: postgres
--



--
-- Name: acao_governo_cod_acao_governo_seq; Type: SEQUENCE SET; Schema: pmiacoes; Owner: postgres
--

SELECT pg_catalog.setval('acao_governo_cod_acao_governo_seq', 1, false);


--
-- Data for Name: acao_governo_foto; Type: TABLE DATA; Schema: pmiacoes; Owner: postgres
--



--
-- Name: acao_governo_foto_cod_acao_governo_foto_seq; Type: SEQUENCE SET; Schema: pmiacoes; Owner: postgres
--

SELECT pg_catalog.setval('acao_governo_foto_cod_acao_governo_foto_seq', 1, false);


--
-- Data for Name: acao_governo_foto_portal; Type: TABLE DATA; Schema: pmiacoes; Owner: postgres
--



--
-- Data for Name: acao_governo_noticia; Type: TABLE DATA; Schema: pmiacoes; Owner: postgres
--



--
-- Data for Name: acao_governo_setor; Type: TABLE DATA; Schema: pmiacoes; Owner: postgres
--



--
-- Data for Name: categoria; Type: TABLE DATA; Schema: pmiacoes; Owner: postgres
--



--
-- Name: categoria_cod_categoria_seq; Type: SEQUENCE SET; Schema: pmiacoes; Owner: postgres
--

SELECT pg_catalog.setval('categoria_cod_categoria_seq', 1, false);


--
-- Data for Name: secretaria_responsavel; Type: TABLE DATA; Schema: pmiacoes; Owner: postgres
--



SET search_path = pmicontrolesis, pg_catalog;

--
-- Data for Name: acontecimento; Type: TABLE DATA; Schema: pmicontrolesis; Owner: postgres
--



--
-- Name: acontecimento_cod_acontecimento_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: postgres
--

SELECT pg_catalog.setval('acontecimento_cod_acontecimento_seq', 1, false);


--
-- Data for Name: artigo; Type: TABLE DATA; Schema: pmicontrolesis; Owner: postgres
--



--
-- Name: artigo_cod_artigo_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: postgres
--

SELECT pg_catalog.setval('artigo_cod_artigo_seq', 1, false);


--
-- Data for Name: foto_evento; Type: TABLE DATA; Schema: pmicontrolesis; Owner: postgres
--



--
-- Name: foto_evento_cod_foto_evento_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: postgres
--

SELECT pg_catalog.setval('foto_evento_cod_foto_evento_seq', 1, false);


--
-- Data for Name: foto_vinc; Type: TABLE DATA; Schema: pmicontrolesis; Owner: postgres
--



--
-- Name: foto_vinc_cod_foto_vinc_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: postgres
--

SELECT pg_catalog.setval('foto_vinc_cod_foto_vinc_seq', 1, false);


--
-- Data for Name: itinerario; Type: TABLE DATA; Schema: pmicontrolesis; Owner: postgres
--



--
-- Name: itinerario_cod_itinerario_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: postgres
--

SELECT pg_catalog.setval('itinerario_cod_itinerario_seq', 1, false);


--
-- Data for Name: menu; Type: TABLE DATA; Schema: pmicontrolesis; Owner: postgres
--

INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (4624, 335, NULL, 'Super usuário', 4, 'otopic_su_lst.php', '_self', 1, 7, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21122, NULL, NULL, 'Cadastros', 1, NULL, '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (9998851, 9998851, 999910, 'Auditoria geral', 0, 'educar_auditoria_geral_lst.php', '_self', 1, 18, 192, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21125, NULL, NULL, 'Administrativo', 4, NULL, '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21126, NULL, NULL, 'Relatórios', 5, NULL, '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21127, NULL, NULL, 'Documentos', 6, NULL, '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999614, NULL, NULL, 'Relatórios', 3, NULL, '_self', 1, 16, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (20710, NULL, NULL, 'Cadastros', 1, NULL, '_self', 1, 17, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (20712, NULL, NULL, 'Relatórios', 3, NULL, '_self', 1, 17, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999400, NULL, 21127, 'Atestados', 0, NULL, '_self', 1, 15, 17, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999302, NULL, 21126, 'Servidores', 0, NULL, '_self', 1, 15, 37, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (9998858, 9998858, 999910, 'Backups', 1, 'educar_backup_lst.php', '_self', 4, 18, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (9998848, NULL, NULL, 'Importações', 1, NULL, '_self', 1, 22, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (9998849, 9998849, 9998848, 'Importação educacenso', 0, 'educar_importacao_educacenso.php', '_self', 1, 22, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (9998859, 9998859, 21150, 'Componentes da série', 0, 'educar_componentes_serie_lst.php', '_self', 1, 15, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (9998854, NULL, 999913, 'Servidores', 3, NULL, '_self', 1, 19, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21179, NULL, 21126, 'Relação de alunos annes - qtd', 0, NULL, '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21200, 567, 21162, 'Prédios', 0, 'educar_infra_predio_lst.php', '_self', 1, 15, 147, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21171, NULL, 999917, 'Alunos', 0, NULL, '_self', 1, 15, 62, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21210, 581, 21171, 'Tipos de benefício', 0, 'educar_aluno_beneficio_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21153, 634, 999912, 'Funções', 1, 'educar_funcao_lst.php', '_self', 1, 19, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21223, 678, 999934, 'Tipos de cor ou raça', 0, 'educar_raca_lst.php', '_self', 1, 20, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21174, 575, 999918, 'Tipos de transferência', 0, 'educar_transferencia_tipo_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21173, 580, 999918, 'Tipos de ocorrência disciplinar', 0, 'educar_tipo_ocorrencia_disciplinar_lst.php', '_self', 1, 15, 194, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21226, NULL, 999917, 'Regras de avaliação', 2, NULL, '_self', 1, 15, 195, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21170, 631, 999934, 'Tipos de deficiência', 0, 'educar_deficiencia_lst.php', '_self', 1, 20, 142, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21219, 579, 999934, 'Tipos de religião', 0, 'educar_religiao_lst.php', '_self', 1, 20, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21160, 845, 21124, 'Rematrícula automática', 1, 'educar_avancar_mod_cad.php', '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21144, 659, 21124, 'Enturmações em lote', 2, 'educar_matriculas_turma_lst.php', '_self', 1, 15, 145, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (20711, NULL, NULL, 'Movimentações', 2, NULL, '_self', 1, 17, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21235, 21235, 20710, 'Empresas', 0, 'transporte_empresa_lst.php', '_self', 1, 17, 192, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21236, 21236, 20710, 'Motoristas', 0, 'transporte_motorista_lst.php', '_self', 1, 17, 192, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21237, 21237, 20710, 'Veículos', 0, 'transporte_veiculo_lst.php', '_self', 1, 17, 192, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21238, 21238, 20710, 'Pontos', 0, 'transporte_ponto_lst.php', '_self', 1, 17, 192, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21239, 21239, 20710, 'Rotas', 0, 'transporte_rota_lst.php', '_self', 1, 17, 192, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21240, 21240, 20711, 'Usuários de transporte', 0, 'transporte_pessoa_lst.php', '_self', 1, 17, 192, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21221, 572, 21162, 'Tipos de ambiente', 0, 'educar_infra_comodo_funcao_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21250, 21250, 21171, 'Tipos de projeto', 0, 'educar_projeto_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999800, NULL, 21127, 'Documentos CBAL', 7, NULL, '_self', 1, 15, 21, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21245, 950, 999918, 'Tipos de abandono', 0, 'educar_abandono_tipo_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999613, 999613, 999921, 'Históricos escolares', 1, 'module/HistoricoEscolar/processamento', '_self', 1, 15, 192, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21207, 574, 21122, 'Infraestrutura', 5, 'educar_infra_predio_comodo_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21152, 642, 999920, 'Faltas e notas', 0, 'module/Avaliacao/diario', '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999303, NULL, 21126, 'Indicadores', 6, NULL, '_self', 1, 15, 24, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21244, NULL, 20711, 'Processos', 0, NULL, '_self', 1, 17, 192, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21246, 21246, 21244, 'C&oacute;pia de rotas', 0, 'transporte_copia_rotas.php', '_self', 1, 17, 192, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999811, NULL, 21127, 'Declarações', 0, NULL, '_self', 1, 15, 21, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (626, 950, NULL, 'Alterar datas de entrada/saída de matrículas', 0, '', '_self', 1, 7, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (627, 950, NULL, 'Cancelar matrícula', 0, '', '_self', 1, 7, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21145, 21145, 999920, 'Ocorrências disciplinares', 0, 'educar_matricula_ocorrencia_disciplinar_cad.php', '_self', 1, 15, 192, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999831, NULL, NULL, 'Documentos', 4, NULL, '_self', 1, 16, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (630, 950, NULL, 'Alterar média final do aluno e situação (para regras de avaliação manuais)', 0, '', '_self', 1, 7, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999849, 950, NULL, 'Permitir lançamento de notas/faltas fora do período de bloqueio por etapa', 0, '', '_self', 1, 7, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999852, NULL, 21122, 'Bloqueio do ano letivo', 0, NULL, '_self', 1, 15, 19, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999850, NULL, 21127, 'Termos', 0, NULL, '_self', 1, 15, 19, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999858, NULL, 21126, 'Quantitativos', 0, NULL, '_self', 1, 15, 17, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999867, 999867, 999866, 'Categoria de obras', 0, 'educar_categoria_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21130, 635, 999911, 'Servidores', 2, 'educar_servidor_lst.php', '_self', 1, 19, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21195, 946, 21122, 'Componentes curriculares', 8, 'educar_componente_curricular_lst.php', '_self', 1, 15, 192, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999827, NULL, 21126, 'Gerenciais', 0, NULL, '_self', 1, 15, 17, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999861, NULL, 21127, 'Fichas', 8, NULL, '_self', 1, 15, 19, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999878, 950, NULL, 'Permitir editar endereço no cadastro de pessoa física', 0, '', '_self', 1, 7, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (15858, NULL, NULL, 'Cadastros', 1, NULL, '_self', 1, 16, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999900, 594, 15858, 'Tipos', 1, NULL, '_self', 1, 16, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999901, 594, 999900, 'Obras', 1, NULL, '_self', 1, 16, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999866, 598, 999901, 'Categorias', 0, 'educar_categoria_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (15877, 592, 999901, 'Assuntos', 0, 'educar_acervo_assunto_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (15881, 594, 999901, 'Autores', 0, 'educar_acervo_autor_lst.php', '_self', 1, 16, 141, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (15882, 593, 999901, 'Coleções', 0, 'educar_acervo_colecao_lst.php', '_self', 1, 16, 119, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (15883, 595, 999901, 'Editoras', 0, 'educar_acervo_editora_lst.php', '_self', 1, 16, 176, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (15884, 590, 999901, 'Idiomas', 0, 'educar_acervo_idioma_lst.php', '_self', 1, 16, 26, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (15889, 608, 999901, 'Fontes', 0, 'educar_fonte_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999903, 594, 999900, 'Exemplares', 3, NULL, '_self', 1, 16, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (15885, 597, 999903, 'Tipos de exemplar', 1, 'educar_exemplar_tipo_lst.php', '_self', 1, 16, 177, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (15891, 602, 999903, 'Tipos de situação de exemplar', 2, 'educar_situacao_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (15887, 600, 999903, 'Motivos de baixa', 3, 'educar_motivo_baixa_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999904, 594, 999900, 'Clientes', 4, NULL, '_self', 1, 16, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (15886, 596, 999904, 'Tipos de cliente', 1, 'educar_cliente_tipo_lst.php', '_self', 1, 16, 62, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (15888, 607, 999904, 'Motivos de suspensão', 2, 'educar_motivo_suspensao_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (15880, 591, 15858, 'Bibliotecas', 2, 'educar_biblioteca_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (15890, 629, 15858, 'Configurações', 2, 'educar_biblioteca_dados_lst.php', '_self', 1, 16, 143, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (15878, 598, 15858, 'Obras', 3, 'educar_acervo_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (15879, 606, 15858, 'Exemplares', 4, 'educar_exemplar_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (15892, 603, 15858, 'Clientes', 5, 'educar_cliente_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (15869, 609, 15859, 'Reservas', 1, 'educar_reservas_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (15894, 610, 15859, 'Empréstimos', 2, 'module/Biblioteca/emprestimo', '_self', 1, 16, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (15895, 628, 15859, 'Devoluções', 3, 'educar_exemplar_devolucao_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (15893, 622, 15859, 'Dívidas', 4, 'educar_pagamento_multa_lst.php', '_self', 1, 16, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999905, 594, 999614, 'Cadastrais', 1, NULL, '_self', 1, 16, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (15859, NULL, NULL, 'Movimentações', 2, NULL, '_self', 1, 16, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999906, 594, 999614, 'Movimentações', 2, NULL, '_self', 1, 16, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999907, 594, 999831, 'Comprovantes', 3, NULL, '_self', 1, 16, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999908, NULL, NULL, 'Permissões', 1, NULL, '_self', 1, 18, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (554, 554, 999908, 'Tipos de usuário', 3, 'educar_tipo_usuario_lst.php   ', '_self', 1, 18, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (555, 555, 999908, 'Usuários', 3, 'educar_usuario_lst.php', '_self', 1, 18, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999909, NULL, NULL, 'Configurações', 2, NULL, '_self', 1, 18, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999873, 999873, 999909, 'Configurações gerais', 3, 'educar_configuracoes_gerais.php', '_self', 1, 18, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999910, NULL, NULL, 'Ferramentas', 3, NULL, '_self', 1, 18, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999869, 999869, 999910, 'Exportação de usuários', 1, 'educar_exportacao_usuarios.php', '_self', 1, 18, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (644, 644, 999910, 'Atualização de matrículas', 2, 'module/Avaliacao/Promocao', '_self', 1, 18, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999911, NULL, NULL, 'Cadastros', 1, NULL, '_self', 1, 19, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999912, NULL, 999911, 'Tipos', 1, NULL, '_self', 1, 19, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21146, 632, 999912, 'Escolaridade', 2, 'educar_escolaridade_lst.php', '_self', 1, 19, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21156, 829, 999912, 'Categoria ou níveis', 3, 'educar_categoria_nivel_lst.php', '_self', 1, 19, 20, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21151, 633, 999912, 'Motivos de afastamento', 4, 'educar_motivo_afastamento_lst.php', '_self', 1, 19, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21137, 641, 999911, 'Quadros de horários', 3, 'educar_quadro_horario_lst.php', '_self', 1, 19, 105, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999913, NULL, NULL, 'Relatórios', 2, NULL, '_self', 1, 19, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999914, NULL, 999913, 'Cadastrais', 1, NULL, '_self', 1, 19, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999915, NULL, 999913, 'Indicadores', 2, NULL, '_self', 1, 19, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999916, NULL, NULL, 'Documentos', 3, NULL, '_self', 1, 19, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999917, NULL, 21122, 'Tipos', 1, NULL, '_self', 1, 15, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999918, NULL, 999917, 'Matrículas', 2, NULL, '_self', 1, 15, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21228, 948, 21226, 'Fórmulas de cálculo de média', 0, 'module/FormulaMedia/index', '_self', 1, 15, 198, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21229, 949, 21226, 'Tabelas de arredondamento', 0, 'module/TabelaArredondamento/index', '_self', 1, 15, 199, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999919, NULL, 999917, 'Componentes curriculares', 3, NULL, '_self', 1, 15, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21206, 945, 999919, 'Áreas de conhecimento', 0, 'module/AreaConhecimento/index', '_self', 1, 15, 189, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21213, 577, 999919, 'Tipos de dispensa', 0, 'educar_tipo_dispensa_lst.php', '_self', 1, 15, 193, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21140, NULL, 999917, 'Cursos', 4, NULL, '_self', 1, 15, 20, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21208, 573, 21140, 'Tipos de habilitação', 0, 'educar_habilitacao_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21220, 568, 21140, 'Tipos de regime', 0, 'educar_tipo_regime_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21222, 558, 21140, 'Tipos de ensino', 0, 'educar_tipo_ensino_lst.php', '_self', 1, 15, 124, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21224, 571, 21140, 'Tipos de nível ensino', 0, 'educar_nivel_ensino_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21161, NULL, 999917, 'Escolas', 5, NULL, '_self', 1, 15, 91, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21211, 562, 21161, 'Tipos de localização', 0, 'educar_escola_localizacao_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21218, 647, 21161, 'Tipos de rede de ensino', 0, 'educar_escola_rede_ensino_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21159, 584, 21161, 'Tipos de módulos', 0, 'educar_modulo_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21150, NULL, 999917, 'Séries', 6, NULL, '_self', 1, 15, 37, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21157, 587, 21150, 'Sequências de enturmação', 0, 'educar_sequencia_serie_lst.php', '_self', 1, 15, 145, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21165, NULL, 999917, 'Turmas', 7, NULL, '_self', 1, 15, 141, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21215, 570, 21165, 'Tipos de turma', 0, 'educar_turma_tipo_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21162, NULL, 999917, 'Infraestrutura', 8, NULL, '_self', 1, 15, 108, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21169, NULL, 999917, 'Calendários', 9, NULL, '_self', 1, 15, 104, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21209, 576, 21169, 'Tipos de evento do calendário', 0, 'educar_calendario_dia_motivo_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21205, 578, 21122, 'Alunos', 2, 'educar_aluno_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21198, 561, 21122, 'Escolas', 3, 'educar_escola_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21128, 559, 21122, 'Instituição', 4, 'educar_instituicao_lst.php', '_self', 1, 15, 26, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21199, 620, 21122, 'Calendários', 6, 'educar_calendario_ano_letivo_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21227, 947, 21122, 'Regras de avaliação', 7, 'module/RegraAvaliacao/index', '_self', 1, 15, 197, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21124, NULL, NULL, 'Movimentações', 2, NULL, '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999920, NULL, NULL, 'Lançamentos', 3, NULL, '_self', 1, 15, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999921, NULL, NULL, 'Processos', 4, NULL, '_self', 1, 15, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21202, 566, 21122, 'Cursos', 10, 'educar_curso_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21201, 583, 21122, 'Séries', 11, 'educar_serie_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21216, 585, 21122, 'Séries da escola', 12, 'educar_escola_serie_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21197, 586, 21122, 'Turmas', 13, 'educar_turma_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999301, NULL, 21126, 'Movimentações', 2, NULL, '_self', 1, 15, 31, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999922, NULL, 21126, 'Lançamentos', 3, NULL, '_self', 1, 15, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999300, NULL, 21126, 'Cadastrais', 4, NULL, '_self', 1, 15, 20, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999923, NULL, 21126, 'Matrículas', 5, NULL, '_self', 1, 15, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999924, NULL, 21126, 'Vagas', 7, NULL, '_self', 1, 15, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999450, NULL, 21127, 'Boletins', 2, NULL, '_self', 1, 15, 19, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999925, NULL, 21127, 'Resultados', 3, NULL, '_self', 1, 15, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999600, NULL, 21127, 'Carteiras', 4, NULL, '_self', 1, 15, 20, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999807, NULL, 21127, 'Certificados', 5, NULL, '_self', 1, 15, 25, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999865, 999861, 21127, 'Documentação padrão', 6, 'DocumentacaoPadrao.php', '_self', 1, 15, 21, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999460, NULL, 21127, 'Históricos', 9, NULL, '_self', 1, 15, 25, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999500, NULL, 21127, 'Registros', 10, NULL, '_self', 1, 15, 36, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999926, NULL, NULL, 'Ferramentas', 7, NULL, '_self', 1, 15, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999927, NULL, 999926, 'Unificações', 1, NULL, '_self', 1, 15, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999847, 999847, 999927, 'Unificação de alunos', 0, 'educar_unifica_aluno.php', '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21253, 21253, 999928, 'Vagas por série/ano', 2, 'educar_serie_vaga_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (21251, 21251, 999928, 'Bloqueio do ano letivo', 0, 'educar_bloqueio_ano_letivo_lst.php', '_self', 1, 15, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999848, 999848, 999928, 'Bloqueio de lançamento de notas e faltas', 0, 'educar_bloqueio_lancamento_faltas_notas_lst.php', '_self', 1, 16, 192, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999929, NULL, NULL, 'Cadastros', 1, NULL, '_self', 1, 20, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (43, 43, 999929, 'Pessoas físicas', 1, 'atendidos_lst.php', '_self', 1, 20, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (41, 41, 999929, 'Pessoas jurídicas', 2, 'empresas_lst.php', '_self', 1, 20, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999930, NULL, NULL, 'Cadastros', 1, NULL, '_self', 1, 21, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (753, 753, 999930, 'Países', 1, 'public_pais_lst.php', '_self', 1, 21, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (754, 754, 999930, 'Estados', 2, 'public_uf_lst.php', '_self', 1, 21, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (755, 755, 999930, 'Municípios', 3, 'public_municipio_lst.php', '_self', 1, 21, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (759, 759, 999930, 'Distritos', 4, 'public_distrito_lst.php', '_self', 1, 21, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (760, 760, 999930, 'Setores', 5, 'public_setor_lst.php', '_self', 1, 21, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (756, 756, 999930, 'Bairros', 6, 'public_bairro_lst.php', '_self', 1, 21, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (757, 757, 999930, 'Logradouros', 7, 'public_logradouro_lst.php', '_self', 1, 21, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (758, 758, 999930, 'CEP', 8, 'urbano_cep_logradouro_lst.php', '_self', 1, 21, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999931, NULL, NULL, 'Ferramentas', 1, NULL, '_self', 1, 21, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999932, NULL, NULL, 'Exportações', 1, NULL, '_self', 1, 22, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (761, 761, 999931, 'Unificação de bairros', 1, 'educar_unifica_bairro.php', '_self', 1, 21, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (762, 762, 999931, 'Unificação de logradouros', 2, 'educar_unifica_logradouro.php', '_self', 1, 21, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (846, 846, 999932, '1ª fase - Matrícula inicial', 1, 'educar_exportacao_educacenso.php', '_self', 1, 22, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (9998845, 9998845, 999932, '2ª fase - Situação final', 1, 'educar_exportacao_educacenso.php?fase2=1', '_self', 1, 22, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999934, NULL, 999929, 'Tipos', 0, NULL, '_self', 1, 20, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (9998846, NULL, NULL, 'Documentos', 4, NULL, '_self', 1, 17, 1, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (9998847, NULL, 20712, 'Cadastrais', 1, NULL, '_self', 1, 17, NULL, NULL);
INSERT INTO menu (cod_menu, ref_cod_menu_submenu, ref_cod_menu_pai, tt_menu, ord_menu, caminho, alvo, suprime_menu, ref_cod_tutormenu, ref_cod_ico, tipo_menu) VALUES (999928, NULL, 999926, 'Parâmetros', 2, NULL, '_self', 1, 15, NULL, NULL);
--
-- Name: menu_cod_menu_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: postgres
--

SELECT pg_catalog.setval('menu_cod_menu_seq', 20709, true);


--
-- Data for Name: menu_portal; Type: TABLE DATA; Schema: pmicontrolesis; Owner: postgres
--



--
-- Name: menu_portal_cod_menu_portal_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: postgres
--

SELECT pg_catalog.setval('menu_portal_cod_menu_portal_seq', 1, false);


--
-- Data for Name: portais; Type: TABLE DATA; Schema: pmicontrolesis; Owner: postgres
--



--
-- Name: portais_cod_portais_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: postgres
--

SELECT pg_catalog.setval('portais_cod_portais_seq', 1, false);


--
-- Data for Name: servicos; Type: TABLE DATA; Schema: pmicontrolesis; Owner: postgres
--



--
-- Name: servicos_cod_servicos_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: postgres
--

SELECT pg_catalog.setval('servicos_cod_servicos_seq', 1, false);


--
-- Data for Name: sistema; Type: TABLE DATA; Schema: pmicontrolesis; Owner: postgres
--



--
-- Name: sistema_cod_sistema_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: postgres
--

SELECT pg_catalog.setval('sistema_cod_sistema_seq', 1, false);


--
-- Data for Name: submenu_portal; Type: TABLE DATA; Schema: pmicontrolesis; Owner: postgres
--



--
-- Name: submenu_portal_cod_submenu_portal_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: postgres
--

SELECT pg_catalog.setval('submenu_portal_cod_submenu_portal_seq', 1, false);


--
-- Data for Name: telefones; Type: TABLE DATA; Schema: pmicontrolesis; Owner: postgres
--



--
-- Name: telefones_cod_telefones_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: postgres
--

SELECT pg_catalog.setval('telefones_cod_telefones_seq', 1, false);


--
-- Data for Name: tipo_acontecimento; Type: TABLE DATA; Schema: pmicontrolesis; Owner: postgres
--



--
-- Name: tipo_acontecimento_cod_tipo_acontecimento_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: postgres
--

SELECT pg_catalog.setval('tipo_acontecimento_cod_tipo_acontecimento_seq', 1, false);


--
-- Data for Name: topo_portal; Type: TABLE DATA; Schema: pmicontrolesis; Owner: postgres
--



--
-- Name: topo_portal_cod_topo_portal_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: postgres
--

SELECT pg_catalog.setval('topo_portal_cod_topo_portal_seq', 1, false);


--
-- Data for Name: tutormenu; Type: TABLE DATA; Schema: pmicontrolesis; Owner: postgres
--

INSERT INTO tutormenu (cod_tutormenu, nm_tutormenu) VALUES (7, 'i-Pauta');
INSERT INTO tutormenu (cod_tutormenu, nm_tutormenu) VALUES (15, 'i-Educar');
INSERT INTO tutormenu (cod_tutormenu, nm_tutormenu) VALUES (16, 'i-Educar Biblioteca');
INSERT INTO tutormenu (cod_tutormenu, nm_tutormenu) VALUES (17, 'Transporte Escolar');
INSERT INTO tutormenu (cod_tutormenu, nm_tutormenu) VALUES (18, 'Configurações');
INSERT INTO tutormenu (cod_tutormenu, nm_tutormenu) VALUES (19, 'Servidores');
INSERT INTO tutormenu (cod_tutormenu, nm_tutormenu) VALUES (20, 'Pessoas');
INSERT INTO tutormenu (cod_tutormenu, nm_tutormenu) VALUES (21, 'Endereçamento');
INSERT INTO tutormenu (cod_tutormenu, nm_tutormenu) VALUES (22, 'Educacenso');


--
-- Name: tutormenu_cod_tutormenu_seq; Type: SEQUENCE SET; Schema: pmicontrolesis; Owner: postgres
--

SELECT pg_catalog.setval('tutormenu_cod_tutormenu_seq', 16, true);


SET search_path = pmidrh, pg_catalog;

--
-- Data for Name: diaria; Type: TABLE DATA; Schema: pmidrh; Owner: postgres
--



--
-- Name: diaria_cod_diaria_seq; Type: SEQUENCE SET; Schema: pmidrh; Owner: postgres
--

SELECT pg_catalog.setval('diaria_cod_diaria_seq', 1, false);


--
-- Data for Name: diaria_grupo; Type: TABLE DATA; Schema: pmidrh; Owner: postgres
--



--
-- Name: diaria_grupo_cod_diaria_grupo_seq; Type: SEQUENCE SET; Schema: pmidrh; Owner: postgres
--

SELECT pg_catalog.setval('diaria_grupo_cod_diaria_grupo_seq', 1, false);


--
-- Data for Name: diaria_valores; Type: TABLE DATA; Schema: pmidrh; Owner: postgres
--



--
-- Name: diaria_valores_cod_diaria_valores_seq; Type: SEQUENCE SET; Schema: pmidrh; Owner: postgres
--

SELECT pg_catalog.setval('diaria_valores_cod_diaria_valores_seq', 1, false);


--
-- Data for Name: setor; Type: TABLE DATA; Schema: pmidrh; Owner: postgres
--



--
-- Name: setor_cod_setor_seq; Type: SEQUENCE SET; Schema: pmidrh; Owner: postgres
--

SELECT pg_catalog.setval('setor_cod_setor_seq', 1, false);


SET search_path = pmieducar, pg_catalog;

--
-- Data for Name: abandono_tipo; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--

INSERT INTO abandono_tipo (cod_abandono_tipo, ref_cod_instituicao, ref_usuario_exc, ref_usuario_cad, nome, data_cadastro, data_exclusao, ativo) VALUES (1, 1, NULL, 1, 'Desistência', '2014-07-18 10:40:06.877894', NULL, 1);
INSERT INTO abandono_tipo (cod_abandono_tipo, ref_cod_instituicao, ref_usuario_exc, ref_usuario_cad, nome, data_cadastro, data_exclusao, ativo) VALUES (2, 1, NULL, 1, 'Falecimento', '2014-07-18 10:40:06.877894', NULL, 1);


--
-- Name: abandono_tipo_cod_abandono_tipo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('abandono_tipo_cod_abandono_tipo_seq', 2, true);


--
-- Data for Name: acervo; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: acervo_acervo_assunto; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: acervo_acervo_autor; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: acervo_assunto; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: acervo_assunto_cod_acervo_assunto_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('acervo_assunto_cod_acervo_assunto_seq', 1, false);


--
-- Data for Name: acervo_autor; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: acervo_autor_cod_acervo_autor_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('acervo_autor_cod_acervo_autor_seq', 1, false);


--
-- Name: acervo_cod_acervo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('acervo_cod_acervo_seq', 1, false);


--
-- Data for Name: acervo_colecao; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: acervo_colecao_cod_acervo_colecao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('acervo_colecao_cod_acervo_colecao_seq', 1, false);


--
-- Data for Name: acervo_editora; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: acervo_editora_cod_acervo_editora_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('acervo_editora_cod_acervo_editora_seq', 1, false);


--
-- Data for Name: acervo_idioma; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: acervo_idioma_cod_acervo_idioma_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('acervo_idioma_cod_acervo_idioma_seq', 1, false);


--
-- Data for Name: aluno; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: aluno_aluno_beneficio; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: aluno_beneficio; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: aluno_beneficio_cod_aluno_beneficio_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('aluno_beneficio_cod_aluno_beneficio_seq', 1, false);


--
-- Name: aluno_cod_aluno_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('aluno_cod_aluno_seq', 2, true);


--
-- Data for Name: aluno_historico_altura_peso; Type: TABLE DATA; Schema: pmieducar; Owner: ieducar
--



--
-- Data for Name: ano_letivo_modulo; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: auditoria_falta_componente_dispensa; Type: TABLE DATA; Schema: pmieducar; Owner: ieducar
--



--
-- Name: auditoria_falta_componente_dispensa_id_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: ieducar
--

SELECT pg_catalog.setval('auditoria_falta_componente_dispensa_id_seq', 1, false);


--
-- Data for Name: auditoria_nota_dispensa; Type: TABLE DATA; Schema: pmieducar; Owner: ieducar
--



--
-- Name: auditoria_nota_dispensa_id_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: ieducar
--

SELECT pg_catalog.setval('auditoria_nota_dispensa_id_seq', 1, false);


--
-- Data for Name: avaliacao_desempenho; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: backup; Type: TABLE DATA; Schema: pmieducar; Owner: ieducar
--

INSERT INTO backup (id, caminho, data_backup) VALUES (1, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/07/ieducar_pre_populado_2017-07-28_03-01-57.backup', '2017-07-28 03:02:23.494584');
INSERT INTO backup (id, caminho, data_backup) VALUES (2, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/07/ieducar_pre_populado_2017-07-29_03-02-00.backup', '2017-07-29 03:02:22.737667');
INSERT INTO backup (id, caminho, data_backup) VALUES (3, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/07/ieducar_pre_populado_2017-07-30_03-01-59.backup', '2017-07-30 03:02:22.113648');
INSERT INTO backup (id, caminho, data_backup) VALUES (4, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/07/ieducar_pre_populado_2017-07-31_03-02-13.backup', '2017-07-31 03:02:46.400935');
INSERT INTO backup (id, caminho, data_backup) VALUES (5, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-01_03-01-54.backup', '2017-08-01 03:02:17.811867');
INSERT INTO backup (id, caminho, data_backup) VALUES (6, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-02_03-02-04.backup', '2017-08-02 03:02:29.798116');
INSERT INTO backup (id, caminho, data_backup) VALUES (7, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-03_03-01-39.backup', '2017-08-03 03:02:01.014928');
INSERT INTO backup (id, caminho, data_backup) VALUES (8, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-04_03-01-41.backup', '2017-08-04 03:02:07.566392');
INSERT INTO backup (id, caminho, data_backup) VALUES (9, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-05_03-01-40.backup', '2017-08-05 03:02:00.206656');
INSERT INTO backup (id, caminho, data_backup) VALUES (10, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-06_03-01-40.backup', '2017-08-06 03:02:03.311046');
INSERT INTO backup (id, caminho, data_backup) VALUES (11, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-07_03-01-36.backup', '2017-08-07 03:01:57.392421');
INSERT INTO backup (id, caminho, data_backup) VALUES (12, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-08_03-01-59.backup', '2017-08-08 03:02:23.249248');
INSERT INTO backup (id, caminho, data_backup) VALUES (13, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-09_03-01-49.backup', '2017-08-09 03:02:10.233715');
INSERT INTO backup (id, caminho, data_backup) VALUES (14, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-10_03-01-54.backup', '2017-08-10 03:02:18.152567');
INSERT INTO backup (id, caminho, data_backup) VALUES (15, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-11_03-01-55.backup', '2017-08-11 03:02:19.450144');
INSERT INTO backup (id, caminho, data_backup) VALUES (16, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-12_03-02-04.backup', '2017-08-12 03:02:25.533138');
INSERT INTO backup (id, caminho, data_backup) VALUES (17, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-13_03-02-02.backup', '2017-08-13 03:02:24.515186');
INSERT INTO backup (id, caminho, data_backup) VALUES (18, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-14_03-02-16.backup', '2017-08-14 03:02:41.231002');
INSERT INTO backup (id, caminho, data_backup) VALUES (19, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-15_03-02-06.backup', '2017-08-15 03:02:25.955715');
INSERT INTO backup (id, caminho, data_backup) VALUES (20, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-16_03-01-59.backup', '2017-08-16 03:02:25.089404');
INSERT INTO backup (id, caminho, data_backup) VALUES (21, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-17_03-02-06.backup', '2017-08-17 03:02:26.208922');
INSERT INTO backup (id, caminho, data_backup) VALUES (22, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-18_03-02-04.backup', '2017-08-18 03:02:30.936968');
INSERT INTO backup (id, caminho, data_backup) VALUES (23, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-19_03-02-15.backup', '2017-08-19 03:02:42.610698');
INSERT INTO backup (id, caminho, data_backup) VALUES (24, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-20_03-02-10.backup', '2017-08-20 03:02:36.450591');
INSERT INTO backup (id, caminho, data_backup) VALUES (25, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-21_03-02-15.backup', '2017-08-21 03:02:38.34101');
INSERT INTO backup (id, caminho, data_backup) VALUES (26, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-22_03-02-01.backup', '2017-08-22 03:02:25.083576');
INSERT INTO backup (id, caminho, data_backup) VALUES (27, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-23_03-02-15.backup', '2017-08-23 03:02:40.462951');
INSERT INTO backup (id, caminho, data_backup) VALUES (28, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-24_03-01-56.backup', '2017-08-24 03:02:20.418753');
INSERT INTO backup (id, caminho, data_backup) VALUES (29, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-25_03-02-02.backup', '2017-08-25 03:02:23.37275');
INSERT INTO backup (id, caminho, data_backup) VALUES (30, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-26_03-02-07.backup', '2017-08-26 03:02:26.273794');
INSERT INTO backup (id, caminho, data_backup) VALUES (31, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-27_03-02-14.backup', '2017-08-27 03:02:42.352425');
INSERT INTO backup (id, caminho, data_backup) VALUES (32, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-28_03-02-07.backup', '2017-08-28 03:02:30.444604');
INSERT INTO backup (id, caminho, data_backup) VALUES (33, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-29_03-02-07.backup', '2017-08-29 03:02:40.909664');
INSERT INTO backup (id, caminho, data_backup) VALUES (34, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-30_03-01-58.backup', '2017-08-30 03:02:20.217261');
INSERT INTO backup (id, caminho, data_backup) VALUES (35, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/08/ieducar_pre_populado_2017-08-31_03-02-17.backup', '2017-08-31 03:02:44.751316');
INSERT INTO backup (id, caminho, data_backup) VALUES (36, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-01_03-01-58.backup', '2017-09-01 03:02:19.512299');
INSERT INTO backup (id, caminho, data_backup) VALUES (37, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-02_03-01-58.backup', '2017-09-02 03:02:22.451082');
INSERT INTO backup (id, caminho, data_backup) VALUES (38, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-03_03-02-03.backup', '2017-09-03 03:02:25.604336');
INSERT INTO backup (id, caminho, data_backup) VALUES (39, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-04_03-02-18.backup', '2017-09-04 03:02:39.121908');
INSERT INTO backup (id, caminho, data_backup) VALUES (40, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-05_03-02-08.backup', '2017-09-05 03:02:30.111405');
INSERT INTO backup (id, caminho, data_backup) VALUES (41, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-06_03-01-50.backup', '2017-09-06 03:02:07.929335');
INSERT INTO backup (id, caminho, data_backup) VALUES (42, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-07_03-01-49.backup', '2017-09-07 03:02:09.785153');
INSERT INTO backup (id, caminho, data_backup) VALUES (43, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-08_03-02-04.backup', '2017-09-08 03:02:27.611416');
INSERT INTO backup (id, caminho, data_backup) VALUES (44, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-09_03-01-52.backup', '2017-09-09 03:02:12.233375');
INSERT INTO backup (id, caminho, data_backup) VALUES (45, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-10_03-01-51.backup', '2017-09-10 03:02:11.865372');
INSERT INTO backup (id, caminho, data_backup) VALUES (46, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-11_03-02-01.backup', '2017-09-11 03:02:18.306083');
INSERT INTO backup (id, caminho, data_backup) VALUES (47, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-12_03-02-13.backup', '2017-09-12 03:03:08.992889');
INSERT INTO backup (id, caminho, data_backup) VALUES (48, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-13_03-01-56.backup', '2017-09-13 03:02:18.667826');
INSERT INTO backup (id, caminho, data_backup) VALUES (49, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-14_03-02-10.backup', '2017-09-14 03:02:34.435978');
INSERT INTO backup (id, caminho, data_backup) VALUES (50, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-15_03-02-14.backup', '2017-09-15 03:02:39.700655');
INSERT INTO backup (id, caminho, data_backup) VALUES (51, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-16_03-02-09.backup', '2017-09-16 03:02:34.229662');
INSERT INTO backup (id, caminho, data_backup) VALUES (52, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-17_03-02-10.backup', '2017-09-17 03:02:35.38535');
INSERT INTO backup (id, caminho, data_backup) VALUES (53, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-18_03-02-02.backup', '2017-09-18 03:02:28.89003');
INSERT INTO backup (id, caminho, data_backup) VALUES (54, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-19_03-02-10.backup', '2017-09-19 03:02:31.849672');
INSERT INTO backup (id, caminho, data_backup) VALUES (55, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-20_03-01-58.backup', '2017-09-20 03:02:21.660694');
INSERT INTO backup (id, caminho, data_backup) VALUES (56, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-21_03-01-50.backup', '2017-09-21 03:02:15.565692');
INSERT INTO backup (id, caminho, data_backup) VALUES (57, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-22_03-01-59.backup', '2017-09-22 03:02:30.991737');
INSERT INTO backup (id, caminho, data_backup) VALUES (58, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-23_03-02-02.backup', '2017-09-23 03:02:25.126327');
INSERT INTO backup (id, caminho, data_backup) VALUES (59, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-24_03-01-59.backup', '2017-09-24 03:02:21.857708');
INSERT INTO backup (id, caminho, data_backup) VALUES (60, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-25_03-02-04.backup', '2017-09-25 03:02:27.570748');
INSERT INTO backup (id, caminho, data_backup) VALUES (61, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-26_03-02-00.backup', '2017-09-26 03:02:23.366468');
INSERT INTO backup (id, caminho, data_backup) VALUES (62, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-27_03-02-00.backup', '2017-09-27 03:02:26.635454');
INSERT INTO backup (id, caminho, data_backup) VALUES (63, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-28_03-01-54.backup', '2017-09-28 03:02:14.026364');
INSERT INTO backup (id, caminho, data_backup) VALUES (64, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-29_03-01-52.backup', '2017-09-29 03:02:19.97997');
INSERT INTO backup (id, caminho, data_backup) VALUES (65, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/09/ieducar_pre_populado_2017-09-30_03-01-57.backup', '2017-09-30 03:02:21.900492');
INSERT INTO backup (id, caminho, data_backup) VALUES (66, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-01_03-01-51.backup', '2017-10-01 03:02:17.665634');
INSERT INTO backup (id, caminho, data_backup) VALUES (67, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-02_03-02-01.backup', '2017-10-02 03:02:24.303286');
INSERT INTO backup (id, caminho, data_backup) VALUES (68, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-03_03-02-02.backup', '2017-10-03 03:02:27.402866');
INSERT INTO backup (id, caminho, data_backup) VALUES (69, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-04_03-02-13.backup', '2017-10-04 03:02:41.595197');
INSERT INTO backup (id, caminho, data_backup) VALUES (70, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-05_03-02-02.backup', '2017-10-05 03:02:24.172258');
INSERT INTO backup (id, caminho, data_backup) VALUES (71, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-06_03-02-05.backup', '2017-10-06 03:02:27.721378');
INSERT INTO backup (id, caminho, data_backup) VALUES (72, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-07_03-02-07.backup', '2017-10-07 03:02:33.449141');
INSERT INTO backup (id, caminho, data_backup) VALUES (73, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-08_03-02-11.backup', '2017-10-08 03:02:38.703066');
INSERT INTO backup (id, caminho, data_backup) VALUES (74, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-09_03-02-05.backup', '2017-10-09 03:02:30.46673');
INSERT INTO backup (id, caminho, data_backup) VALUES (75, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-10_03-02-07.backup', '2017-10-10 03:02:34.837989');
INSERT INTO backup (id, caminho, data_backup) VALUES (76, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-11_03-01-58.backup', '2017-10-11 03:02:23.912013');
INSERT INTO backup (id, caminho, data_backup) VALUES (77, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-12_03-01-57.backup', '2017-10-12 03:02:25.470964');
INSERT INTO backup (id, caminho, data_backup) VALUES (78, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-13_03-01-51.backup', '2017-10-13 03:02:11.61887');
INSERT INTO backup (id, caminho, data_backup) VALUES (79, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-14_03-01-58.backup', '2017-10-14 03:02:23.090849');
INSERT INTO backup (id, caminho, data_backup) VALUES (80, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-15_03-02-00.backup', '2017-10-15 03:02:22.670513');
INSERT INTO backup (id, caminho, data_backup) VALUES (81, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-16_03-01-56.backup', '2017-10-16 03:02:16.454784');
INSERT INTO backup (id, caminho, data_backup) VALUES (82, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-17_03-02-40.backup', '2017-10-17 03:03:03.445548');
INSERT INTO backup (id, caminho, data_backup) VALUES (83, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-18_03-01-54.backup', '2017-10-18 03:02:17.886933');
INSERT INTO backup (id, caminho, data_backup) VALUES (84, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-19_03-01-41.backup', '2017-10-19 03:02:02.106792');
INSERT INTO backup (id, caminho, data_backup) VALUES (85, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-20_03-02-17.backup', '2017-10-20 03:02:41.16369');
INSERT INTO backup (id, caminho, data_backup) VALUES (86, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-21_03-01-57.backup', '2017-10-21 03:02:17.79921');
INSERT INTO backup (id, caminho, data_backup) VALUES (87, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-22_03-01-59.backup', '2017-10-22 03:02:19.006087');
INSERT INTO backup (id, caminho, data_backup) VALUES (88, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-23_03-02-08.backup', '2017-10-23 03:02:28.23388');
INSERT INTO backup (id, caminho, data_backup) VALUES (89, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-24_03-02-00.backup', '2017-10-24 03:02:27.883077');
INSERT INTO backup (id, caminho, data_backup) VALUES (90, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-25_03-02-11.backup', '2017-10-25 03:02:31.777695');
INSERT INTO backup (id, caminho, data_backup) VALUES (91, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-26_03-02-14.backup', '2017-10-26 03:02:43.624362');
INSERT INTO backup (id, caminho, data_backup) VALUES (92, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-27_03-01-50.backup', '2017-10-27 03:02:19.433938');
INSERT INTO backup (id, caminho, data_backup) VALUES (93, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-28_03-01-57.backup', '2017-10-28 03:02:18.583897');
INSERT INTO backup (id, caminho, data_backup) VALUES (94, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-29_03-01-57.backup', '2017-10-29 03:02:15.546706');
INSERT INTO backup (id, caminho, data_backup) VALUES (95, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-30_03-01-49.backup', '2017-10-30 03:02:10.650243');
INSERT INTO backup (id, caminho, data_backup) VALUES (96, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/10/ieducar_pre_populado_2017-10-31_03-02-01.backup', '2017-10-31 03:02:30.769319');
INSERT INTO backup (id, caminho, data_backup) VALUES (97, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-01_03-01-57.backup', '2017-11-01 03:02:18.232342');
INSERT INTO backup (id, caminho, data_backup) VALUES (98, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-02_03-03-00.backup', '2017-11-02 03:03:41.399728');
INSERT INTO backup (id, caminho, data_backup) VALUES (99, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-03_03-02-05.backup', '2017-11-03 03:02:33.711542');
INSERT INTO backup (id, caminho, data_backup) VALUES (100, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-04_03-02-32.backup', '2017-11-04 03:03:05.092581');
INSERT INTO backup (id, caminho, data_backup) VALUES (101, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-05_03-02-25.backup', '2017-11-05 03:02:52.076044');
INSERT INTO backup (id, caminho, data_backup) VALUES (102, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-06_03-02-29.backup', '2017-11-06 03:02:59.016983');
INSERT INTO backup (id, caminho, data_backup) VALUES (103, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-07_03-02-07.backup', '2017-11-07 03:02:39.940655');
INSERT INTO backup (id, caminho, data_backup) VALUES (104, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-08_03-02-09.backup', '2017-11-08 03:02:42.180328');
INSERT INTO backup (id, caminho, data_backup) VALUES (105, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-09_03-02-03.backup', '2017-11-09 03:02:28.007138');
INSERT INTO backup (id, caminho, data_backup) VALUES (106, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-10_03-01-33.backup', '2017-11-10 03:01:56.542047');
INSERT INTO backup (id, caminho, data_backup) VALUES (107, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-11_03-01-54.backup', '2017-11-11 03:02:15.375696');
INSERT INTO backup (id, caminho, data_backup) VALUES (108, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-12_03-01-46.backup', '2017-11-12 03:02:17.185005');
INSERT INTO backup (id, caminho, data_backup) VALUES (109, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-13_03-01-44.backup', '2017-11-13 03:02:07.757993');
INSERT INTO backup (id, caminho, data_backup) VALUES (110, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-14_03-01-46.backup', '2017-11-14 03:02:14.074166');
INSERT INTO backup (id, caminho, data_backup) VALUES (111, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-15_03-01-50.backup', '2017-11-15 03:02:17.432019');
INSERT INTO backup (id, caminho, data_backup) VALUES (112, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-16_03-01-51.backup', '2017-11-16 03:02:16.888379');
INSERT INTO backup (id, caminho, data_backup) VALUES (113, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-17_03-01-56.backup', '2017-11-17 03:02:23.852404');
INSERT INTO backup (id, caminho, data_backup) VALUES (114, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-18_03-01-57.backup', '2017-11-18 03:02:22.853078');
INSERT INTO backup (id, caminho, data_backup) VALUES (115, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-19_03-01-45.backup', '2017-11-19 03:02:09.277979');
INSERT INTO backup (id, caminho, data_backup) VALUES (116, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-20_03-01-53.backup', '2017-11-20 03:02:18.576052');
INSERT INTO backup (id, caminho, data_backup) VALUES (117, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-21_03-01-55.backup', '2017-11-21 03:02:19.780649');
INSERT INTO backup (id, caminho, data_backup) VALUES (118, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-22_03-01-11.backup', '2017-11-22 03:01:37.863005');
INSERT INTO backup (id, caminho, data_backup) VALUES (119, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-23_03-03-04.backup', '2017-11-23 03:03:35.914205');
INSERT INTO backup (id, caminho, data_backup) VALUES (120, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-24_03-01-54.backup', '2017-11-24 03:02:23.862641');
INSERT INTO backup (id, caminho, data_backup) VALUES (121, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-25_03-01-51.backup', '2017-11-25 03:02:25.163622');
INSERT INTO backup (id, caminho, data_backup) VALUES (122, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-26_03-02-52.backup', '2017-11-26 03:03:20.314632');
INSERT INTO backup (id, caminho, data_backup) VALUES (123, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-27_03-01-55.backup', '2017-11-27 03:02:20.906006');
INSERT INTO backup (id, caminho, data_backup) VALUES (124, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-28_03-02-04.backup', '2017-11-28 03:02:25.117951');
INSERT INTO backup (id, caminho, data_backup) VALUES (125, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-29_03-01-39.backup', '2017-11-29 03:02:09.400795');
INSERT INTO backup (id, caminho, data_backup) VALUES (126, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/11/ieducar_pre_populado_2017-11-30_03-15-08.backup', '2017-11-30 03:16:02.262673');
INSERT INTO backup (id, caminho, data_backup) VALUES (127, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-01_03-01-51.backup', '2017-12-01 03:02:07.058599');
INSERT INTO backup (id, caminho, data_backup) VALUES (128, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-02_03-01-43.backup', '2017-12-02 03:02:02.774472');
INSERT INTO backup (id, caminho, data_backup) VALUES (129, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-03_03-01-50.backup', '2017-12-03 03:02:16.656903');
INSERT INTO backup (id, caminho, data_backup) VALUES (130, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-04_03-01-37.backup', '2017-12-04 03:02:03.916439');
INSERT INTO backup (id, caminho, data_backup) VALUES (131, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-05_03-01-38.backup', '2017-12-05 03:02:01.261207');
INSERT INTO backup (id, caminho, data_backup) VALUES (132, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-06_03-01-38.backup', '2017-12-06 03:01:59.354158');
INSERT INTO backup (id, caminho, data_backup) VALUES (133, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-07_03-01-32.backup', '2017-12-07 03:01:44.993236');
INSERT INTO backup (id, caminho, data_backup) VALUES (134, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-08_03-02-16.backup', '2017-12-08 03:02:33.350603');
INSERT INTO backup (id, caminho, data_backup) VALUES (135, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-09_03-01-57.backup', '2017-12-09 03:02:27.195024');
INSERT INTO backup (id, caminho, data_backup) VALUES (136, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-10_03-01-55.backup', '2017-12-10 03:02:15.839506');
INSERT INTO backup (id, caminho, data_backup) VALUES (137, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-11_03-01-50.backup', '2017-12-11 03:02:09.07906');
INSERT INTO backup (id, caminho, data_backup) VALUES (138, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-12_03-01-34.backup', '2017-12-12 03:01:52.506361');
INSERT INTO backup (id, caminho, data_backup) VALUES (139, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-13_03-01-46.backup', '2017-12-13 03:02:06.040887');
INSERT INTO backup (id, caminho, data_backup) VALUES (140, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-14_03-01-48.backup', '2017-12-14 03:02:07.634797');
INSERT INTO backup (id, caminho, data_backup) VALUES (141, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-15_03-01-54.backup', '2017-12-15 03:02:11.481136');
INSERT INTO backup (id, caminho, data_backup) VALUES (142, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-16_03-01-40.backup', '2017-12-16 03:02:03.777132');
INSERT INTO backup (id, caminho, data_backup) VALUES (143, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-17_03-01-53.backup', '2017-12-17 03:02:17.69098');
INSERT INTO backup (id, caminho, data_backup) VALUES (144, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-18_03-01-47.backup', '2017-12-18 03:02:13.062243');
INSERT INTO backup (id, caminho, data_backup) VALUES (145, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-19_03-01-55.backup', '2017-12-19 03:02:20.213328');
INSERT INTO backup (id, caminho, data_backup) VALUES (146, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-20_03-02-47.backup', '2017-12-20 03:03:17.802251');
INSERT INTO backup (id, caminho, data_backup) VALUES (147, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-21_03-01-51.backup', '2017-12-21 03:02:12.271007');
INSERT INTO backup (id, caminho, data_backup) VALUES (148, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-22_03-01-52.backup', '2017-12-22 03:02:14.747901');
INSERT INTO backup (id, caminho, data_backup) VALUES (149, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-23_03-01-53.backup', '2017-12-23 03:02:15.520008');
INSERT INTO backup (id, caminho, data_backup) VALUES (150, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-24_03-01-37.backup', '2017-12-24 03:02:04.98179');
INSERT INTO backup (id, caminho, data_backup) VALUES (151, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-25_03-01-39.backup', '2017-12-25 03:02:15.379474');
INSERT INTO backup (id, caminho, data_backup) VALUES (152, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-26_03-01-47.backup', '2017-12-26 03:02:13.713621');
INSERT INTO backup (id, caminho, data_backup) VALUES (153, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-27_03-01-39.backup', '2017-12-27 03:01:54.444998');
INSERT INTO backup (id, caminho, data_backup) VALUES (154, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-28_03-00-42.backup', '2017-12-28 03:01:13.093336');
INSERT INTO backup (id, caminho, data_backup) VALUES (155, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-29_03-01-07.backup', '2017-12-29 03:01:19.935801');
INSERT INTO backup (id, caminho, data_backup) VALUES (156, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-30_03-03-19.backup', '2017-12-30 03:03:47.169712');
INSERT INTO backup (id, caminho, data_backup) VALUES (157, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2017/12/ieducar_pre_populado_2017-12-31_03-02-10.backup', '2017-12-31 03:02:34.758227');
INSERT INTO backup (id, caminho, data_backup) VALUES (158, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-01_03-02-14.backup', '2018-01-01 03:02:40.812045');
INSERT INTO backup (id, caminho, data_backup) VALUES (159, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-02_03-02-07.backup', '2018-01-02 03:02:28.19197');
INSERT INTO backup (id, caminho, data_backup) VALUES (160, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-03_03-01-57.backup', '2018-01-03 03:02:13.135697');
INSERT INTO backup (id, caminho, data_backup) VALUES (161, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-04_03-00-45.backup', '2018-01-04 03:01:00.06465');
INSERT INTO backup (id, caminho, data_backup) VALUES (162, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-05_03-01-27.backup', '2018-01-05 03:01:46.738377');
INSERT INTO backup (id, caminho, data_backup) VALUES (163, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-06_03-00-48.backup', '2018-01-06 03:01:02.207831');
INSERT INTO backup (id, caminho, data_backup) VALUES (164, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-07_03-00-41.backup', '2018-01-07 03:00:52.425043');
INSERT INTO backup (id, caminho, data_backup) VALUES (165, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-08_03-01-25.backup', '2018-01-08 03:01:43.260496');
INSERT INTO backup (id, caminho, data_backup) VALUES (166, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-09_03-00-45.backup', '2018-01-09 03:01:04.002541');
INSERT INTO backup (id, caminho, data_backup) VALUES (167, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-10_03-00-49.backup', '2018-01-10 03:01:10.805381');
INSERT INTO backup (id, caminho, data_backup) VALUES (168, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-11_03-04-50.backup', '2018-01-11 03:05:42.306857');
INSERT INTO backup (id, caminho, data_backup) VALUES (169, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-12_03-01-57.backup', '2018-01-12 03:02:21.067395');
INSERT INTO backup (id, caminho, data_backup) VALUES (170, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-13_03-02-08.backup', '2018-01-13 03:02:35.124785');
INSERT INTO backup (id, caminho, data_backup) VALUES (171, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-14_03-02-27.backup', '2018-01-14 03:02:52.748563');
INSERT INTO backup (id, caminho, data_backup) VALUES (172, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-15_03-01-58.backup', '2018-01-15 03:02:24.48067');
INSERT INTO backup (id, caminho, data_backup) VALUES (173, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-16_03-01-46.backup', '2018-01-16 03:02:11.724163');
INSERT INTO backup (id, caminho, data_backup) VALUES (174, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-17_03-01-39.backup', '2018-01-17 03:01:57.651104');
INSERT INTO backup (id, caminho, data_backup) VALUES (175, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-18_03-01-49.backup', '2018-01-18 03:02:15.442958');
INSERT INTO backup (id, caminho, data_backup) VALUES (176, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-19_03-01-36.backup', '2018-01-19 03:02:04.381735');
INSERT INTO backup (id, caminho, data_backup) VALUES (177, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-20_03-01-40.backup', '2018-01-20 03:02:00.732719');
INSERT INTO backup (id, caminho, data_backup) VALUES (178, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-21_03-01-38.backup', '2018-01-21 03:02:01.731199');
INSERT INTO backup (id, caminho, data_backup) VALUES (179, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-22_03-01-33.backup', '2018-01-22 03:01:54.671287');
INSERT INTO backup (id, caminho, data_backup) VALUES (180, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-23_03-01-45.backup', '2018-01-23 03:02:02.04368');
INSERT INTO backup (id, caminho, data_backup) VALUES (181, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-24_03-18-37.backup', '2018-01-24 03:18:48.106534');
INSERT INTO backup (id, caminho, data_backup) VALUES (182, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-25_03-18-40.backup', '2018-01-25 03:18:50.740288');
INSERT INTO backup (id, caminho, data_backup) VALUES (183, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-26_03-18-38.backup', '2018-01-26 03:18:48.979649');
INSERT INTO backup (id, caminho, data_backup) VALUES (184, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-27_03-18-39.backup', '2018-01-27 03:18:48.522538');
INSERT INTO backup (id, caminho, data_backup) VALUES (185, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-28_03-18-36.backup', '2018-01-28 03:18:46.150181');
INSERT INTO backup (id, caminho, data_backup) VALUES (186, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-29_03-18-36.backup', '2018-01-29 03:18:48.960549');
INSERT INTO backup (id, caminho, data_backup) VALUES (187, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-30_03-18-36.backup', '2018-01-30 03:18:48.060504');
INSERT INTO backup (id, caminho, data_backup) VALUES (188, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/01/ieducar_pre_populado_2018-01-31_03-18-36.backup', '2018-01-31 03:18:47.64061');
INSERT INTO backup (id, caminho, data_backup) VALUES (189, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-01_03-18-37.backup', '2018-02-01 03:18:48.183625');
INSERT INTO backup (id, caminho, data_backup) VALUES (190, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-02_03-18-37.backup', '2018-02-02 03:18:48.658581');
INSERT INTO backup (id, caminho, data_backup) VALUES (191, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-03_03-18-40.backup', '2018-02-03 03:18:51.329829');
INSERT INTO backup (id, caminho, data_backup) VALUES (192, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-04_03-18-36.backup', '2018-02-04 03:18:47.841284');
INSERT INTO backup (id, caminho, data_backup) VALUES (193, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-05_03-18-39.backup', '2018-02-05 03:18:51.899691');
INSERT INTO backup (id, caminho, data_backup) VALUES (194, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-06_03-18-35.backup', '2018-02-06 03:18:46.103406');
INSERT INTO backup (id, caminho, data_backup) VALUES (195, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-07_03-18-38.backup', '2018-02-07 03:18:48.726103');
INSERT INTO backup (id, caminho, data_backup) VALUES (196, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-08_03-18-35.backup', '2018-02-08 03:18:46.004462');
INSERT INTO backup (id, caminho, data_backup) VALUES (197, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-09_03-18-35.backup', '2018-02-09 03:18:46.43811');
INSERT INTO backup (id, caminho, data_backup) VALUES (198, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-10_03-18-35.backup', '2018-02-10 03:18:45.692617');
INSERT INTO backup (id, caminho, data_backup) VALUES (199, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-11_03-18-35.backup', '2018-02-11 03:18:45.602062');
INSERT INTO backup (id, caminho, data_backup) VALUES (200, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-12_03-18-36.backup', '2018-02-12 03:18:46.164986');
INSERT INTO backup (id, caminho, data_backup) VALUES (201, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-13_03-18-34.backup', '2018-02-13 03:18:45.633627');
INSERT INTO backup (id, caminho, data_backup) VALUES (202, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-14_03-18-35.backup', '2018-02-14 03:18:45.790231');
INSERT INTO backup (id, caminho, data_backup) VALUES (203, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-15_03-18-33.backup', '2018-02-15 03:18:44.129354');
INSERT INTO backup (id, caminho, data_backup) VALUES (204, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-16_03-18-34.backup', '2018-02-16 03:18:45.184663');
INSERT INTO backup (id, caminho, data_backup) VALUES (205, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-17_03-18-38.backup', '2018-02-17 03:18:48.021263');
INSERT INTO backup (id, caminho, data_backup) VALUES (206, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-18_03-18-35.backup', '2018-02-18 03:18:45.656582');
INSERT INTO backup (id, caminho, data_backup) VALUES (207, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-19_03-18-35.backup', '2018-02-19 03:18:46.254113');
INSERT INTO backup (id, caminho, data_backup) VALUES (208, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-20_03-18-34.backup', '2018-02-20 03:18:44.210724');
INSERT INTO backup (id, caminho, data_backup) VALUES (209, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-21_03-18-35.backup', '2018-02-21 03:18:44.975107');
INSERT INTO backup (id, caminho, data_backup) VALUES (210, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-22_03-18-34.backup', '2018-02-22 03:18:45.235314');
INSERT INTO backup (id, caminho, data_backup) VALUES (211, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-23_03-18-35.backup', '2018-02-23 03:18:45.820392');
INSERT INTO backup (id, caminho, data_backup) VALUES (212, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-24_03-18-37.backup', '2018-02-24 03:18:47.477228');
INSERT INTO backup (id, caminho, data_backup) VALUES (213, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-25_03-18-36.backup', '2018-02-25 03:18:46.758077');
INSERT INTO backup (id, caminho, data_backup) VALUES (214, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-26_03-18-36.backup', '2018-02-26 03:18:46.333283');
INSERT INTO backup (id, caminho, data_backup) VALUES (215, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-27_03-18-36.backup', '2018-02-27 03:18:47.535309');
INSERT INTO backup (id, caminho, data_backup) VALUES (216, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/02/ieducar_pre_populado_2018-02-28_03-18-35.backup', '2018-02-28 03:18:46.058214');
INSERT INTO backup (id, caminho, data_backup) VALUES (217, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-01_03-18-35.backup', '2018-03-01 03:18:46.617894');
INSERT INTO backup (id, caminho, data_backup) VALUES (218, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-02_03-18-35.backup', '2018-03-02 03:18:45.085072');
INSERT INTO backup (id, caminho, data_backup) VALUES (219, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-03_03-18-35.backup', '2018-03-03 03:18:45.953686');
INSERT INTO backup (id, caminho, data_backup) VALUES (220, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-04_03-18-37.backup', '2018-03-04 03:18:46.614478');
INSERT INTO backup (id, caminho, data_backup) VALUES (221, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-05_03-18-37.backup', '2018-03-05 03:18:47.749563');
INSERT INTO backup (id, caminho, data_backup) VALUES (222, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-06_03-18-35.backup', '2018-03-06 03:18:46.404599');
INSERT INTO backup (id, caminho, data_backup) VALUES (223, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-07_03-18-35.backup', '2018-03-07 03:18:46.221971');
INSERT INTO backup (id, caminho, data_backup) VALUES (224, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-08_03-18-35.backup', '2018-03-08 03:18:44.934023');
INSERT INTO backup (id, caminho, data_backup) VALUES (225, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-09_03-18-34.backup', '2018-03-09 03:18:43.991153');
INSERT INTO backup (id, caminho, data_backup) VALUES (226, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-10_03-18-36.backup', '2018-03-10 03:18:46.063866');
INSERT INTO backup (id, caminho, data_backup) VALUES (227, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-11_03-18-35.backup', '2018-03-11 03:18:45.573358');
INSERT INTO backup (id, caminho, data_backup) VALUES (228, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-12_03-18-35.backup', '2018-03-12 03:18:46.305183');
INSERT INTO backup (id, caminho, data_backup) VALUES (229, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-13_03-20-10.backup', '2018-03-13 03:20:19.01923');
INSERT INTO backup (id, caminho, data_backup) VALUES (230, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-14_03-18-35.backup', '2018-03-14 03:18:45.706341');
INSERT INTO backup (id, caminho, data_backup) VALUES (231, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-15_03-18-34.backup', '2018-03-15 03:18:45.071549');
INSERT INTO backup (id, caminho, data_backup) VALUES (232, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-16_03-18-34.backup', '2018-03-16 03:18:44.913407');
INSERT INTO backup (id, caminho, data_backup) VALUES (233, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-17_03-18-34.backup', '2018-03-17 03:18:44.471153');
INSERT INTO backup (id, caminho, data_backup) VALUES (234, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-18_03-18-35.backup', '2018-03-18 03:18:47.146139');
INSERT INTO backup (id, caminho, data_backup) VALUES (235, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-19_03-18-35.backup', '2018-03-19 03:18:45.664928');
INSERT INTO backup (id, caminho, data_backup) VALUES (236, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-20_03-18-35.backup', '2018-03-20 03:18:45.712465');
INSERT INTO backup (id, caminho, data_backup) VALUES (237, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-21_03-18-42.backup', '2018-03-21 03:18:51.542749');
INSERT INTO backup (id, caminho, data_backup) VALUES (238, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-22_03-18-34.backup', '2018-03-22 03:18:45.258026');
INSERT INTO backup (id, caminho, data_backup) VALUES (239, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-23_03-18-35.backup', '2018-03-23 03:18:45.624248');
INSERT INTO backup (id, caminho, data_backup) VALUES (240, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-24_03-18-35.backup', '2018-03-24 03:18:45.031888');
INSERT INTO backup (id, caminho, data_backup) VALUES (241, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-25_03-18-34.backup', '2018-03-25 03:18:44.495077');
INSERT INTO backup (id, caminho, data_backup) VALUES (242, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-26_03-18-36.backup', '2018-03-26 03:18:46.329799');
INSERT INTO backup (id, caminho, data_backup) VALUES (243, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-27_03-18-35.backup', '2018-03-27 03:18:45.03986');
INSERT INTO backup (id, caminho, data_backup) VALUES (244, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-28_03-18-35.backup', '2018-03-28 03:18:45.960443');
INSERT INTO backup (id, caminho, data_backup) VALUES (245, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-29_03-18-34.backup', '2018-03-29 03:18:44.956622');
INSERT INTO backup (id, caminho, data_backup) VALUES (246, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-30_03-18-36.backup', '2018-03-30 03:18:46.231917');
INSERT INTO backup (id, caminho, data_backup) VALUES (247, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/03/ieducar_pre_populado_2018-03-31_03-18-34.backup', '2018-03-31 03:18:45.172706');
INSERT INTO backup (id, caminho, data_backup) VALUES (248, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/04/ieducar_pre_populado_2018-04-01_03-18-36.backup', '2018-04-01 03:18:46.999485');
INSERT INTO backup (id, caminho, data_backup) VALUES (249, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/04/ieducar_pre_populado_2018-04-02_03-18-34.backup', '2018-04-02 03:18:44.717166');
INSERT INTO backup (id, caminho, data_backup) VALUES (250, 'https://s3-us-west-2.amazonaws.com/portabilis2/private/backups/bases/ieducar/2018/04/ieducar_pre_populado_2018-04-03_03-18-35.backup', '2018-04-03 03:18:45.897407');


--
-- Name: backup_id_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: ieducar
--

SELECT pg_catalog.setval('backup_id_seq', 250, true);


--
-- Data for Name: biblioteca; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: biblioteca_cod_biblioteca_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('biblioteca_cod_biblioteca_seq', 1, false);


--
-- Data for Name: biblioteca_dia; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: biblioteca_feriados; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: biblioteca_feriados_cod_feriado_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('biblioteca_feriados_cod_feriado_seq', 1, false);


--
-- Data for Name: biblioteca_usuario; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: bloqueio_ano_letivo; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: bloqueio_lancamento_faltas_notas; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: calendario_ano_letivo; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: calendario_ano_letivo_cod_calendario_ano_letivo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('calendario_ano_letivo_cod_calendario_ano_letivo_seq', 1, false);


--
-- Data for Name: calendario_anotacao; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: calendario_anotacao_cod_calendario_anotacao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('calendario_anotacao_cod_calendario_anotacao_seq', 1, false);


--
-- Data for Name: calendario_dia; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: calendario_dia_anotacao; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: calendario_dia_motivo; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: calendario_dia_motivo_cod_calendario_dia_motivo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('calendario_dia_motivo_cod_calendario_dia_motivo_seq', 1, false);


--
-- Data for Name: candidato_reserva_vaga; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: candidato_reserva_vaga_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('candidato_reserva_vaga_seq', 1, false);


--
-- Data for Name: categoria_nivel; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: categoria_nivel_cod_categoria_nivel_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('categoria_nivel_cod_categoria_nivel_seq', 1, false);


--
-- Data for Name: categoria_obra; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: categoria_obra_id_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('categoria_obra_id_seq', 1, false);


--
-- Data for Name: cliente; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: cliente_cod_cliente_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('cliente_cod_cliente_seq', 1, false);


--
-- Data for Name: cliente_suspensao; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: cliente_tipo; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: cliente_tipo_cliente; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: cliente_tipo_cod_cliente_tipo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('cliente_tipo_cod_cliente_tipo_seq', 1, false);


--
-- Data for Name: cliente_tipo_exemplar_tipo; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: coffebreak_tipo; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: coffebreak_tipo_cod_coffebreak_tipo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('coffebreak_tipo_cod_coffebreak_tipo_seq', 1, false);


--
-- Data for Name: configuracoes_gerais; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--

INSERT INTO configuracoes_gerais (ref_cod_instituicao, permite_relacionamento_posvendas, url_novo_educacao) VALUES (1, 1, NULL);


--
-- Data for Name: curso; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: curso_cod_curso_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('curso_cod_curso_seq', 1, true);


--
-- Data for Name: disciplina; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: disciplina_cod_disciplina_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('disciplina_cod_disciplina_seq', 1, false);


--
-- Data for Name: disciplina_dependencia; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: disciplina_serie; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: disciplina_topico; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: disciplina_topico_cod_disciplina_topico_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('disciplina_topico_cod_disciplina_topico_seq', 1, false);


--
-- Data for Name: dispensa_disciplina; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: dispensa_etapa; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: distribuicao_uniforme; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: distribuicao_uniforme_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('distribuicao_uniforme_seq', 1, false);


--
-- Data for Name: escola; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: escola_ano_letivo; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--

--
-- Name: escola_cod_escola_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('escola_cod_escola_seq', 1, true);


--
-- Data for Name: escola_complemento; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: escola_curso; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: escola_localizacao; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--

INSERT INTO escola_localizacao (cod_escola_localizacao, ref_usuario_exc, ref_usuario_cad, nm_localizacao, data_cadastro, data_exclusao, ativo, ref_cod_instituicao) VALUES (1, NULL, 1, 'Urbana', '2010-12-22 17:08:47.218', NULL, 1, 1);
INSERT INTO escola_localizacao (cod_escola_localizacao, ref_usuario_exc, ref_usuario_cad, nm_localizacao, data_cadastro, data_exclusao, ativo, ref_cod_instituicao) VALUES (2, NULL, 1, 'Rural', '2010-12-22 17:08:50.812', NULL, 1, 1);


--
-- Name: escola_localizacao_cod_escola_localizacao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('escola_localizacao_cod_escola_localizacao_seq', 1, true);


--
-- Data for Name: escola_rede_ensino; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: escola_rede_ensino_cod_escola_rede_ensino_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('escola_rede_ensino_cod_escola_rede_ensino_seq', 1, true);


--
-- Data for Name: escola_serie; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: escola_serie_disciplina; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: escola_usuario; Type: TABLE DATA; Schema: pmieducar; Owner: ieducar
--



--
-- Name: escola_usuario_id_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: ieducar
--

SELECT pg_catalog.setval('escola_usuario_id_seq', 1, false);


--
-- Data for Name: exemplar; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: exemplar_cod_exemplar_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('exemplar_cod_exemplar_seq', 1, false);


--
-- Data for Name: exemplar_emprestimo; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: exemplar_emprestimo_cod_emprestimo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('exemplar_emprestimo_cod_emprestimo_seq', 1, false);


--
-- Data for Name: exemplar_tipo; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: exemplar_tipo_cod_exemplar_tipo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('exemplar_tipo_cod_exemplar_tipo_seq', 1, false);


--
-- Data for Name: falta_aluno; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: falta_aluno_cod_falta_aluno_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('falta_aluno_cod_falta_aluno_seq', 1, false);


--
-- Data for Name: falta_atraso; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: falta_atraso_cod_falta_atraso_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('falta_atraso_cod_falta_atraso_seq', 1, false);


--
-- Data for Name: falta_atraso_compensado; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: falta_atraso_compensado_cod_compensado_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('falta_atraso_compensado_cod_compensado_seq', 1, false);


--
-- Data for Name: faltas; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: faltas_sequencial_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('faltas_sequencial_seq', 1, false);


--
-- Data for Name: fonte; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: fonte_cod_fonte_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('fonte_cod_fonte_seq', 1, false);


--
-- Data for Name: funcao; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: funcao_cod_funcao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('funcao_cod_funcao_seq', 1, false);


--
-- Data for Name: habilitacao; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: habilitacao_cod_habilitacao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('habilitacao_cod_habilitacao_seq', 1, false);


--
-- Data for Name: habilitacao_curso; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: historico_disciplinas; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: historico_educar; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--

ALTER TABLE historico_educar DISABLE TRIGGER ALL;

INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999101,1,0,1)', '2010-09-02 11:14:32.625', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999103,1,0,1)', '2010-09-02 11:14:56.531', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999104,1,0,1)', '2010-09-02 11:15:23.484', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999200,1,0,1)', '2010-09-02 11:15:45.937', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999102,1,0,1)', '2010-09-02 11:16:10.546', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999100,1,0,1)', '2010-09-02 11:16:31.671', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999201,1,0,1)', '2010-09-02 11:17:04.531', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999202,1,0,1)', '2010-09-02 11:17:24.25', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999203,1,0,1)', '2010-09-02 11:17:49.14', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999204,1,0,1)', '2010-09-02 11:18:11.921', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('instituicao', '(1,,1,RUA,SC,88900000,Araranguá,Centro,"Rua Dr. Virgulino de Queiróz",200,Centro,"Prefeitura Municipal de Araranguá",48,35210956,"2010-01-04 08:00:00","2010-09-02 12:52:50.312",1,"Prefeitura Municipal de Araranguá")', '2010-09-02 12:52:50.312', 0);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999105,1,0,1)', '2010-10-19 18:04:02.701', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999106,1,0,1)', '2010-12-07 08:14:17.562', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999205,1,0,1)', '2010-12-07 08:14:38.171', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('escola_localizacao', '(1,,1,Urbana,"2010-12-22 17:08:47.218",,1,1)', '2010-12-22 17:08:47.218', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('escola_localizacao', '(2,,1,Rural,"2010-12-22 17:08:50.812",,1,1)', '2010-12-22 17:08:50.812', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999501,1,0,1)', '2011-07-22 11:14:45.057', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999502,1,0,1)', '2011-07-22 11:14:45.057', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999503,1,0,1)', '2011-07-22 11:14:45.057', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999504,1,0,1)', '2011-07-22 11:14:45.057', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999505,1,0,1)', '2011-07-22 11:14:45.057', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999506,1,0,1)', '2011-07-22 11:14:45.057', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999505,1,0,1)', '2011-07-22 11:15:06.578', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999507,1,0,1)', '2011-07-22 11:15:06.578', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999506,1,0,1)', '2011-07-22 11:15:06.578', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999200,1,0,1)', '2011-07-22 11:15:06.578', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999215,1,0,1)', '2011-07-22 11:15:06.578', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999216,1,0,1)', '2011-07-22 11:15:32.193', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999107,1,0,1)', '2011-07-22 11:15:32.193', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999217,1,0,1)', '2011-07-22 11:15:32.193', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999601,1,0,1)', '2011-07-22 11:16:01.977', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999602,1,0,1)', '2011-07-22 11:16:01.977', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,643,1,0,1)', '2011-07-22 11:16:28.456', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,644,1,0,1)', '2011-07-22 11:16:28.456', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999218,1,0,1)', '2011-07-22 11:16:45.716', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999219,1,0,1)', '2011-07-22 11:17:46.858', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999108,1,0,1)', '2011-07-22 11:17:46.858', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999109,1,0,1)', '2011-07-22 11:18:26.994', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999220,1,0,1)', '2011-07-22 11:18:48.767', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999221,1,0,1)', '2011-07-22 11:19:07.215', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999224,1,0,1)', '2011-07-22 11:19:28.688', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999206,1,0,1)', '2011-07-22 11:19:45.069', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999605,1,0,1)', '2011-07-22 11:19:45.069', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('instituicao', '(1,,1,RUA,SC,88820000,Modelópolis,Centro,"Rua João Paulo Segundo",2011,Centro,"Secretaria de Educação e Cultura",48,99999999,"2010-01-04 08:00:00","2011-07-22 11:24:02.914",1,"Prefeitura Municipal de Modelópolis")', '2011-07-22 11:24:02.914', 0);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999606,1,0,1)', '2011-11-19 11:36:58.50777', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999607,1,0,1)', '2011-11-19 11:36:58.50777', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999610,1,0,1)', '2011-11-19 11:37:32.304272', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999611,1,0,1)', '2011-11-19 11:37:32.304272', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999608,1,0,1)', '2011-11-19 11:37:52.570095', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999609,1,0,1)', '2011-11-19 11:37:52.570095', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999612,1,0,1)', '2011-11-19 11:38:15.408076', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999613,1,0,1)', '2012-06-22 16:27:11.94276', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999615,1,0,1)', '2012-06-22 16:31:36.620354', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999616,1,0,1)', '2012-06-22 16:31:36.620354', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999617,1,0,1)', '2012-06-22 16:31:36.620354', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999618,1,0,1)', '2012-06-22 16:31:36.620354', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999619,1,0,1)', '2012-06-22 16:31:36.620354', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999620,1,0,1)', '2012-06-22 16:31:36.620354', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999621,1,0,1)', '2012-06-22 16:31:36.620354', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999622,1,0,1)', '2012-06-22 16:31:36.620354', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999612,1,0,1)', '2014-01-07 19:02:23.592375', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,950,1,1,1)', '2014-07-18 10:40:06.877894', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,554,1,1,1)', '2014-12-02 14:39:24.548014', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999814,1,1,1)', '2014-12-08 10:19:18.276064', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,644,1,1,1)', '2014-12-09 11:52:03.368718', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,21247,1,0,1)', '2015-01-15 20:29:28.137685', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,21246,1,0,1)', '2015-01-27 09:15:05.808245', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,21248,1,1,1)', '2015-02-04 14:05:17.895103', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,626,1,1,1)', '2015-02-17 11:51:44.947342', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,21249,1,0,1)', '2015-02-17 11:51:44.971294', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999815,1,1,1)', '2015-02-20 16:26:31.739166', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999816,1,1,1)', '2015-03-03 18:19:48.689871', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,627,1,1,1)', '2015-04-02 09:59:41.187518', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,21252,1,1,1)', '2015-04-06 13:56:29.435332', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999819,1,0,1)', '2015-06-15 23:58:27.676051', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999820,1,0,1)', '2015-06-30 22:14:58.625444', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999821,1,1,1)', '2015-06-30 22:14:58.639629', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999822,1,1,1)', '2015-06-30 22:14:58.64117', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999823,1,0,1)', '2015-07-17 09:51:19.440927', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999824,1,1,1)', '2015-07-20 09:34:48.277355', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999825,1,0,1)', '2015-08-02 22:14:35.724936', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999826,1,0,1)', '2015-08-02 22:14:35.728868', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999829,1,0,1)', '2015-08-17 18:31:19.930622', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999828,1,0,1)', '2015-08-26 15:35:27.060486', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999830,1,0,1)', '2015-08-31 23:55:01.077127', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999832,1,0,1)', '2015-08-31 23:55:01.087613', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999233,1,1,1)', '2015-09-17 17:04:57.188296', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999833,1,1,1)', '2015-09-20 22:44:29.226121', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999834,1,0,1)', '2015-09-20 22:44:29.235057', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999509,1,1,1)', '2015-09-21 14:27:45.310515', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999612,1,1,1)', '2015-09-21 14:59:55.052653', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999840,1,1,1)', '2015-10-01 11:27:32.978085', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999841,1,1,1)', '2015-10-17 17:50:11.414165', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999842,1,1,1)', '2015-10-17 17:50:11.423287', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999843,1,0,1)', '2015-10-30 20:54:01.523043', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999844,1,1,1)', '2015-10-30 20:54:01.538511', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999845,1,1,1)', '2015-10-30 20:54:01.540008', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999846,1,1,1)', '2015-12-02 02:10:44.263456', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999847,1,1,1)', '2015-12-02 02:10:44.311096', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,630,1,1,1)', '2015-12-02 02:10:44.337394', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999848,1,1,1)', '2016-01-13 15:23:23.393198', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999849,1,1,1)', '2016-01-13 15:23:23.454429', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999851,1,1,1)', '2016-01-13 15:23:23.487376', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999853,1,1,1)', '2016-01-13 15:23:23.489167', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999854,1,1,1)', '2016-01-25 10:26:29.732882', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999855,1,1,1)', '2016-02-07 17:25:00.024842', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999856,1,1,1)', '2016-03-18 18:05:31.806589', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999857,1,1,1)', '2016-03-28 09:29:10.763154', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999859,1,0,1)', '2016-04-04 08:35:02.498838', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999860,1,0,1)', '2016-04-11 08:27:48.534095', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999862,1,1,1)', '2016-04-25 08:20:16.356346', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999863,1,1,1)', '2016-05-09 09:08:29.088534', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999861,1,1,1)', '2016-05-16 21:36:23.877159', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999864,1,1,1)', '2016-05-24 08:35:28.524312', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('instituicao', '(1,,1,RUA,SC,88820000,Modelópolis,Centro,"Rua João Paulo Segundo",2011,Centro,"Secretaria de Educação e Cultura",48,99999999,"2010-01-04 08:00:00","2011-07-22 11:24:02.914",1,"Prefeitura Municipal de Modelópolis",,,,,,,,,,,,,,f,f,,,t)', '2016-05-30 17:39:48.708257', 0);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999867,1,1,1)', '2016-05-30 17:39:48.784145', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999869,1,1,1)', '2016-06-28 18:52:27.037308', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,846,1,1,1)', '2016-07-06 09:20:26.571425', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999870,1,1,1)', '2016-07-26 10:37:12.045714', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999871,1,1,1)', '2016-08-08 08:52:12.013263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999872,1,1,1)', '2016-08-17 09:12:15.490281', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999873,1,1,1)', '2016-08-29 16:31:21.220176', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999874,1,1,1)', '2016-09-01 14:47:45.937241', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999876,1,1,1)', '2016-09-20 09:02:28.590762', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999876,1,1,1)', '2016-09-20 09:16:49.810644', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999877,1,1,1)', '2016-09-28 09:32:19.795068', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,0,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,43,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,41,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,155,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,157,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,475,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,753,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,754,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,945,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,755,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,756,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,757,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,758,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,335,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,829,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,568,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,569,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,561,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,570,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,558,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,562,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,571,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,563,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,566,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,567,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,576,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,573,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,575,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,577,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,578,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,579,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,559,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,580,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,581,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,583,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,631,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,585,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,586,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,587,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,620,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,624,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,584,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,632,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,759,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,633,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,634,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,635,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,946,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,641,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,647,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,659,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,678,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,845,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,592,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,594,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,603,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,590,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,591,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,593,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,595,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,596,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,597,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,606,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,600,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,602,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,598,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,607,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,608,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,609,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,622,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,625,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,628,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,629,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,947,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,948,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,949,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,341,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,343,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,345,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,610,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,21234,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,21235,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,21236,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,21237,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,21238,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,21239,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,21240,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,21241,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,642,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999801,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999802,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999803,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999804,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,21242,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999219,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999220,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999221,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999222,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999223,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999810,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999812,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999225,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999226,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999227,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999508,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999229,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,21243,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999231,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999110,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999232,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,21250,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,21251,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,572,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,574,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999228,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999234,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999235,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999236,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999651,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999652,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,760,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999237,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999654,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,555,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999603,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999238,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999806,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999239,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999808,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999809,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999805,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999224,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999813,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,761,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,762,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,639,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999218,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999817,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999818,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999244,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,21253,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999230,1,1,1)', '2016-09-28 15:12:44.946263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999878,1,1,1)', '2016-10-07 09:04:33.61113', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999879,1,1,1)', '2016-10-27 11:05:43.98123', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999881,1,1,1)', '2016-10-28 16:24:09.345619', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999882,1,1,1)', '2016-11-28 11:40:37.02263', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999883,1,1,1)', '2016-12-06 15:19:24.825213', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999884,1,1,1)', '2016-12-13 17:56:28.840356', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999887,1,1,1)', '2017-02-01 09:32:10.717784', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999886,1,1,1)', '2017-02-01 10:11:39.180167', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999889,1,1,1)', '2017-02-20 10:09:07.375952', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('instituicao', '(1,,1,RUA,SC,88820000,Modelópolis,Centro,"Rua João Paulo Segundo",2011,Centro,"Secretaria de Educação e Cultura",48,99999999,"2010-01-04 08:00:00","2011-07-22 11:24:02.914",1,"Prefeitura Municipal de Modelópolis",,,,,,,,,,,,,,f,f,,,t,,,,f)', '2017-03-07 17:02:47.491663', 0);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999890,1,1,1)', '2017-03-31 17:09:44.931441', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999832,1,1,1)', '2017-04-01 05:19:04.547169', 0);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999820,1,1,1)', '2017-04-01 05:19:04.670125', 0);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999860,1,1,1)', '2017-04-01 05:19:04.670125', 0);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999874,1,1,1)', '2017-04-01 05:19:04.670125', 0);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,21145,1,1,1)', '2017-04-01 05:19:04.681312', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999859,1,1,1)', '2017-04-01 05:19:04.772938', 0);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,9998850,1,1,1)', '2017-04-18 18:07:20.652225', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,999891,1,1,1)', '2017-05-08 12:28:43.743157', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,9998851,1,1,1)', '2017-05-12 14:42:44.398162', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,9998852,1,1,1)', '2017-06-21 17:54:01.945054', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,9998853,1,1,1)', '2017-06-26 15:42:20.388422', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,9998858,1,1,1)', '2017-07-27 09:36:50.350403', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,9998849,1,1,1)', '2017-08-15 09:09:43.025897', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,9998859,1,1,1)', '2017-09-13 15:43:50.215045', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,9998860,1,1,1)', '2017-11-28 07:48:08.788494', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,9998857,1,1,1)', '2017-12-01 15:32:09.672494', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,9998855,1,1,1)', '2017-12-01 15:32:09.739552', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,9998862,1,1,1)', '2017-12-13 09:00:26.781581', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,9998865,1,1,1)', '2018-03-05 11:19:39.9654', 1);
INSERT INTO historico_educar (tabela, alteracao, data, insercao) VALUES ('menu_tipo_usuario', '(1,9998866,1,1,1)', '2018-03-16 09:22:27.083225', 1);

ALTER TABLE historico_educar ENABLE TRIGGER ALL;
--
-- Data for Name: historico_escolar; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: historico_grade_curso; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--

INSERT INTO historico_grade_curso (id, descricao_etapa, created_at, updated_at, quantidade_etapas, ativo) VALUES (1, 'Série', '1990-12-30 00:00:00', NULL, 8, 1);
INSERT INTO historico_grade_curso (id, descricao_etapa, created_at, updated_at, quantidade_etapas, ativo) VALUES (2, 'Ano', '1990-12-30 00:00:00', NULL, 9, 1);
INSERT INTO historico_grade_curso (id, descricao_etapa, created_at, updated_at, quantidade_etapas, ativo) VALUES (3, 'EJA', '2017-01-04 14:48:26.233581', NULL, NULL, 1);


--
-- Name: historico_grade_curso_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('historico_grade_curso_seq', 3, false);


--
-- Data for Name: infra_comodo_funcao; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: infra_comodo_funcao_cod_infra_comodo_funcao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('infra_comodo_funcao_cod_infra_comodo_funcao_seq', 1, true);


--
-- Data for Name: infra_predio; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: infra_predio_cod_infra_predio_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('infra_predio_cod_infra_predio_seq', 1, true);


--
-- Data for Name: infra_predio_comodo; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: infra_predio_comodo_cod_infra_predio_comodo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('infra_predio_comodo_cod_infra_predio_comodo_seq', 1, true);


--
-- Data for Name: instituicao; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--

INSERT INTO instituicao (cod_instituicao, ref_usuario_exc, ref_usuario_cad, ref_idtlog, ref_sigla_uf, cep, cidade, bairro, logradouro, numero, complemento, nm_responsavel, ddd_telefone, telefone, data_cadastro, data_exclusao, ativo, nm_instituicao, data_base_remanejamento, data_base_transferencia, controlar_espaco_utilizacao_aluno, percentagem_maxima_ocupacao_salas, quantidade_alunos_metro_quadrado, exigir_vinculo_turma_professor, gerar_historico_transferencia, matricula_apenas_bairro_escola, restringir_historico_escolar, coordenador_transporte, restringir_multiplas_enturmacoes, permissao_filtro_abandono_transferencia, data_base_matricula, multiplas_reserva_vaga, reserva_integral_somente_com_renda, data_expiracao_reserva_vaga, data_fechamento, componente_curricular_turma, reprova_dependencia_ano_concluinte, controlar_posicao_historicos, data_educacenso, bloqueia_matricula_serie_nao_seguinte, permitir_carga_horaria, exigir_dados_socioeconomicos, altera_atestado_para_declaracao) VALUES (1, NULL, 1, 'RUA', 'SC', 88820000, 'Modelópolis', 'Centro', 'Rua João Paulo Segundo', 2011, 'Centro', 'Secretaria de Educação e Cultura', 48, 99999999, '2010-01-04 08:00:00', '2011-07-22 11:24:02.914', 1, 'Prefeitura Municipal de Modelópolis', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, false, false, NULL, NULL, true, NULL, NULL, NULL, false, false, false, NULL);


--
-- Name: instituicao_cod_instituicao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('instituicao_cod_instituicao_seq', 1, true);


--
-- Data for Name: instituicao_documentacao; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: instituicao_documentacao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('instituicao_documentacao_seq', 2, false);


--
-- Data for Name: material_didatico; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: material_didatico_cod_material_didatico_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('material_didatico_cod_material_didatico_seq', 1, false);


--
-- Data for Name: material_tipo; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: material_tipo_cod_material_tipo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('material_tipo_cod_material_tipo_seq', 1, false);


--
-- Data for Name: matricula; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: matricula_cod_matricula_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('matricula_cod_matricula_seq', 2, true);


--
-- Data for Name: matricula_excessao; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: matricula_excessao_cod_aluno_excessao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('matricula_excessao_cod_aluno_excessao_seq', 1, false);


--
-- Data for Name: matricula_ocorrencia_disciplinar; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: matricula_turma; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: menu_tipo_usuario; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--
ALTER TABLE menu_tipo_usuario DISABLE TRIGGER ALL;

INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 999613, 1, 0, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 950, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 554, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 644, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 21246, 1, 0, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 626, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 627, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 999848, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 999847, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 630, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 999849, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 999861, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 999867, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 999869, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 846, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 999873, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 0, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 43, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 41, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 155, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 157, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 475, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 753, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 754, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 945, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 755, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 756, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 757, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 758, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 335, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 829, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 568, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 569, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 561, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 570, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 558, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 562, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 571, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 563, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 566, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 567, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 576, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 573, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 575, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 577, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 578, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 579, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 559, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 580, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 581, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 583, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 631, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 585, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 586, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 587, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 620, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 624, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 584, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 632, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 759, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 633, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 634, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 635, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 946, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 641, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 647, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 659, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 678, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 845, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 592, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 594, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 603, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 590, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 591, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 593, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 595, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 596, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 597, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 606, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 600, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 602, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 598, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 607, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 608, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 609, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 622, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 625, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 628, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 629, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 947, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 948, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 949, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 341, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 343, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 345, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 610, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 21234, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 21235, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 21236, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 21237, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 21238, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 21239, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 21240, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 642, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 21250, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 21251, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 572, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 574, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 760, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 555, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 761, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 762, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 21253, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 999878, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 21145, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 9998851, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 9998858, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 9998849, 1, 1, 1);
INSERT INTO menu_tipo_usuario (ref_cod_tipo_usuario, ref_cod_menu_submenu, cadastra, visualiza, exclui) VALUES (1, 9998859, 1, 1, 1);

ALTER TABLE menu_tipo_usuario ENABLE TRIGGER ALL;


--
-- Data for Name: modulo; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--


--
-- Name: modulo_cod_modulo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('modulo_cod_modulo_seq', 1, true);


--
-- Data for Name: motivo_afastamento; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: motivo_afastamento_cod_motivo_afastamento_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('motivo_afastamento_cod_motivo_afastamento_seq', 1, false);


--
-- Data for Name: motivo_baixa; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: motivo_baixa_cod_motivo_baixa_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('motivo_baixa_cod_motivo_baixa_seq', 1, false);


--
-- Data for Name: motivo_suspensao; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: motivo_suspensao_cod_motivo_suspensao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('motivo_suspensao_cod_motivo_suspensao_seq', 1, false);


--
-- Data for Name: nivel; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: nivel_cod_nivel_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('nivel_cod_nivel_seq', 1, false);


--
-- Data for Name: nivel_ensino; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: nivel_ensino_cod_nivel_ensino_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('nivel_ensino_cod_nivel_ensino_seq', 1, true);


--
-- Data for Name: nota_aluno; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: nota_aluno_cod_nota_aluno_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('nota_aluno_cod_nota_aluno_seq', 1, false);


--
-- Name: ocorrencia_disciplinar_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('ocorrencia_disciplinar_seq', 1, false);


--
-- Data for Name: operador; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: operador_cod_operador_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('operador_cod_operador_seq', 1, false);


--
-- Data for Name: pagamento_multa; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: pagamento_multa_cod_pagamento_multa_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('pagamento_multa_cod_pagamento_multa_seq', 1, false);


--
-- Data for Name: pre_requisito; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: pre_requisito_cod_pre_requisito_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('pre_requisito_cod_pre_requisito_seq', 1, false);


--
-- Data for Name: projeto; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: projeto_aluno; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: projeto_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('projeto_seq', 1, false);


--
-- Data for Name: quadro_horario; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: quadro_horario_cod_quadro_horario_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('quadro_horario_cod_quadro_horario_seq', 1, false);


--
-- Data for Name: quadro_horario_horarios; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: quadro_horario_horarios_aux; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: quantidade_reserva_externa; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: relacao_categoria_acervo; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: religiao; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: religiao_cod_religiao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('religiao_cod_religiao_seq', 1, false);


--
-- Data for Name: reserva_vaga; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: reserva_vaga_cod_reserva_vaga_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('reserva_vaga_cod_reserva_vaga_seq', 1, false);


--
-- Data for Name: reservas; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: reservas_cod_reserva_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('reservas_cod_reserva_seq', 1, false);


--
-- Data for Name: sequencia_serie; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: serie; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: serie_cod_serie_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('serie_cod_serie_seq', 2, true);


--
-- Data for Name: serie_pre_requisito; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: serie_vaga; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: servidor; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: servidor_afastamento; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: servidor_alocacao; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: servidor_alocacao_cod_servidor_alocacao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('servidor_alocacao_cod_servidor_alocacao_seq', 1, false);


--
-- Data for Name: servidor_curso; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: servidor_curso_cod_servidor_curso_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('servidor_curso_cod_servidor_curso_seq', 1, false);


--
-- Data for Name: servidor_curso_ministra; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: servidor_disciplina; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: servidor_formacao; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: servidor_formacao_cod_formacao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('servidor_formacao_cod_formacao_seq', 1, false);


--
-- Data for Name: servidor_funcao; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: servidor_funcao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('servidor_funcao_seq', 1, false);


--
-- Data for Name: servidor_titulo_concurso; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: servidor_titulo_concurso_cod_servidor_titulo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('servidor_titulo_concurso_cod_servidor_titulo_seq', 1, false);


--
-- Data for Name: situacao; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: situacao_cod_situacao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('situacao_cod_situacao_seq', 1, false);


--
-- Data for Name: subnivel; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: subnivel_cod_subnivel_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('subnivel_cod_subnivel_seq', 1, false);


--
-- Data for Name: tipo_autor; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--

INSERT INTO tipo_autor (codigo, tipo_autor) VALUES (1, 'Autor');
INSERT INTO tipo_autor (codigo, tipo_autor) VALUES (2, 'Evento');
INSERT INTO tipo_autor (codigo, tipo_autor) VALUES (3, 'Entidade coletiva');
INSERT INTO tipo_autor (codigo, tipo_autor) VALUES (4, 'Anônimo');


--
-- Data for Name: tipo_avaliacao; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: tipo_avaliacao_cod_tipo_avaliacao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('tipo_avaliacao_cod_tipo_avaliacao_seq', 1, false);


--
-- Data for Name: tipo_avaliacao_valores; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: tipo_dispensa; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: tipo_dispensa_cod_tipo_dispensa_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('tipo_dispensa_cod_tipo_dispensa_seq', 1, false);


--
-- Data for Name: tipo_ensino; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: tipo_ensino_cod_tipo_ensino_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('tipo_ensino_cod_tipo_ensino_seq', 1, true);


--
-- Data for Name: tipo_ocorrencia_disciplinar; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: tipo_ocorrencia_disciplinar_cod_tipo_ocorrencia_disciplinar_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('tipo_ocorrencia_disciplinar_cod_tipo_ocorrencia_disciplinar_seq', 1, false);


--
-- Data for Name: tipo_regime; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: tipo_regime_cod_tipo_regime_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('tipo_regime_cod_tipo_regime_seq', 1, false);


--
-- Data for Name: tipo_usuario; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--

INSERT INTO tipo_usuario (cod_tipo_usuario, ref_funcionario_cad, ref_funcionario_exc, nm_tipo, descricao, nivel, data_cadastro, data_exclusao, ativo) VALUES (1, 1, NULL, 'Administrador', '', 1, '2010-01-06 18:30:33.204604', NULL, 1);


--
-- Name: tipo_usuario_cod_tipo_usuario_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('tipo_usuario_cod_tipo_usuario_seq', 3, true);


--
-- Data for Name: transferencia_solicitacao; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: transferencia_solicitacao_cod_transferencia_solicitacao_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('transferencia_solicitacao_cod_transferencia_solicitacao_seq', 1, false);


--
-- Data for Name: transferencia_tipo; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: transferencia_tipo_cod_transferencia_tipo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('transferencia_tipo_cod_transferencia_tipo_seq', 1, false);


--
-- Data for Name: turma; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: turma_cod_turma_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('turma_cod_turma_seq', 2, true);


--
-- Data for Name: turma_dia_semana; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: turma_modulo; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Data for Name: turma_tipo; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--



--
-- Name: turma_tipo_cod_turma_tipo_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('turma_tipo_cod_turma_tipo_seq', 1, true);


--
-- Data for Name: turma_turno; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--

INSERT INTO turma_turno (id, nome, ativo) VALUES (1, 'Matutino', 1);
INSERT INTO turma_turno (id, nome, ativo) VALUES (2, 'Vespertino', 1);
INSERT INTO turma_turno (id, nome, ativo) VALUES (3, 'Noturno', 1);
INSERT INTO turma_turno (id, nome, ativo) VALUES (4, 'Integral', 1);


--
-- Name: turma_turno_id_seq; Type: SEQUENCE SET; Schema: pmieducar; Owner: postgres
--

SELECT pg_catalog.setval('turma_turno_id_seq', 1, false);


--
-- Data for Name: usuario; Type: TABLE DATA; Schema: pmieducar; Owner: postgres
--

INSERT INTO usuario (cod_usuario, ref_cod_instituicao, ref_funcionario_cad, ref_funcionario_exc, ref_cod_tipo_usuario, data_cadastro, data_exclusao, ativo) VALUES (1, NULL, 1, NULL, 1, '2010-01-06 18:30:33.207458', NULL, 1);


SET search_path = pmiotopic, pg_catalog;

--
-- Data for Name: funcionario_su; Type: TABLE DATA; Schema: pmiotopic; Owner: postgres
--



--
-- Data for Name: grupomoderador; Type: TABLE DATA; Schema: pmiotopic; Owner: postgres
--



--
-- Data for Name: grupopessoa; Type: TABLE DATA; Schema: pmiotopic; Owner: postgres
--



--
-- Data for Name: grupos; Type: TABLE DATA; Schema: pmiotopic; Owner: postgres
--



--
-- Name: grupos_cod_grupos_seq; Type: SEQUENCE SET; Schema: pmiotopic; Owner: postgres
--

SELECT pg_catalog.setval('grupos_cod_grupos_seq', 1, false);


--
-- Data for Name: notas; Type: TABLE DATA; Schema: pmiotopic; Owner: postgres
--



--
-- Data for Name: participante; Type: TABLE DATA; Schema: pmiotopic; Owner: postgres
--



--
-- Data for Name: reuniao; Type: TABLE DATA; Schema: pmiotopic; Owner: postgres
--



--
-- Name: reuniao_cod_reuniao_seq; Type: SEQUENCE SET; Schema: pmiotopic; Owner: postgres
--

SELECT pg_catalog.setval('reuniao_cod_reuniao_seq', 1, false);


--
-- Data for Name: topico; Type: TABLE DATA; Schema: pmiotopic; Owner: postgres
--



--
-- Name: topico_cod_topico_seq; Type: SEQUENCE SET; Schema: pmiotopic; Owner: postgres
--

SELECT pg_catalog.setval('topico_cod_topico_seq', 1, false);


--
-- Data for Name: topicoreuniao; Type: TABLE DATA; Schema: pmiotopic; Owner: postgres
--



SET search_path = portal, pg_catalog;

--
-- Data for Name: acesso; Type: TABLE DATA; Schema: portal; Owner: postgres
--

INSERT INTO acesso (cod_acesso, data_hora, ip_externo, ip_interno, cod_pessoa, obs, sucesso) VALUES (7, '2010-09-02 11:47:17.859', '127.0.0.1', 'NULL', 1, NULL, true);
INSERT INTO acesso (cod_acesso, data_hora, ip_externo, ip_interno, cod_pessoa, obs, sucesso) VALUES (8, '2010-09-02 11:50:43.687', '127.0.0.1', 'NULL', 1, NULL, false);
INSERT INTO acesso (cod_acesso, data_hora, ip_externo, ip_interno, cod_pessoa, obs, sucesso) VALUES (9, '2010-09-02 11:50:47.609', '127.0.0.1', 'NULL', 1, NULL, true);
INSERT INTO acesso (cod_acesso, data_hora, ip_externo, ip_interno, cod_pessoa, obs, sucesso) VALUES (10, '2010-09-02 11:53:28.468', '127.0.0.1', 'NULL', 1, NULL, true);
INSERT INTO acesso (cod_acesso, data_hora, ip_externo, ip_interno, cod_pessoa, obs, sucesso) VALUES (11, '2010-09-02 12:23:18.812', '127.0.0.1', 'NULL', 1, NULL, true);
INSERT INTO acesso (cod_acesso, data_hora, ip_externo, ip_interno, cod_pessoa, obs, sucesso) VALUES (12, '2010-09-02 12:28:51.859', '127.0.0.1', 'NULL', 1, NULL, true);
INSERT INTO acesso (cod_acesso, data_hora, ip_externo, ip_interno, cod_pessoa, obs, sucesso) VALUES (13, '2010-09-02 12:49:37.968', '127.0.0.1', 'NULL', 1, NULL, true);
INSERT INTO acesso (cod_acesso, data_hora, ip_externo, ip_interno, cod_pessoa, obs, sucesso) VALUES (14, '2010-12-07 09:13:31.125', '127.0.0.1', 'NULL', 1, NULL, true);
INSERT INTO acesso (cod_acesso, data_hora, ip_externo, ip_interno, cod_pessoa, obs, sucesso) VALUES (15, '2011-07-22 11:22:25.009', '::1', 'NULL', 1, NULL, true);
INSERT INTO acesso (cod_acesso, data_hora, ip_externo, ip_interno, cod_pessoa, obs, sucesso) VALUES (16, '2011-07-23 09:47:39.552', '::1', 'NULL', 1, NULL, false);
INSERT INTO acesso (cod_acesso, data_hora, ip_externo, ip_interno, cod_pessoa, obs, sucesso) VALUES (17, '2011-07-25 09:25:36.956', '::1', 'NULL', 1, NULL, false);
INSERT INTO acesso (cod_acesso, data_hora, ip_externo, ip_interno, cod_pessoa, obs, sucesso) VALUES (18, '2011-07-25 09:25:43.212', '::1', 'NULL', 1, NULL, true);
INSERT INTO acesso (cod_acesso, data_hora, ip_externo, ip_interno, cod_pessoa, obs, sucesso) VALUES (19, '2014-01-07 19:10:31.47822', '127.0.0.1', 'NULL', 1, NULL, true);


--
-- Name: acesso_cod_acesso_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('acesso_cod_acesso_seq', 19, true);


--
-- Data for Name: agenda; Type: TABLE DATA; Schema: portal; Owner: postgres
--

INSERT INTO agenda (cod_agenda, ref_ref_cod_pessoa_exc, ref_ref_cod_pessoa_cad, nm_agenda, publica, envia_alerta, data_cad, data_edicao, ref_ref_cod_pessoa_own) VALUES (1, NULL, 1, 'Administrador', 0, 0, '2010-01-06 18:33:11.021729', NULL, 1);


--
-- Name: agenda_cod_agenda_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('agenda_cod_agenda_seq', 1, true);


--
-- Data for Name: agenda_compromisso; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Data for Name: agenda_pref; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Name: agenda_pref_cod_comp_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('agenda_pref_cod_comp_seq', 1, false);


--
-- Data for Name: agenda_responsavel; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Data for Name: compras_editais_editais; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Name: compras_editais_editais_cod_compras_editais_editais_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('compras_editais_editais_cod_compras_editais_editais_seq', 1, false);


--
-- Data for Name: compras_editais_editais_empresas; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Data for Name: compras_editais_empresa; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Name: compras_editais_empresa_cod_compras_editais_empresa_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('compras_editais_empresa_cod_compras_editais_empresa_seq', 1, false);


--
-- Data for Name: compras_final_pregao; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Name: compras_final_pregao_cod_compras_final_pregao_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('compras_final_pregao_cod_compras_final_pregao_seq', 1, false);


--
-- Data for Name: compras_funcionarios; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Data for Name: compras_licitacoes; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Name: compras_licitacoes_cod_compras_licitacoes_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('compras_licitacoes_cod_compras_licitacoes_seq', 1, false);


--
-- Data for Name: compras_modalidade; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Name: compras_modalidade_cod_compras_modalidade_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('compras_modalidade_cod_compras_modalidade_seq', 1, false);


--
-- Data for Name: compras_pregao_execucao; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Name: compras_pregao_execucao_cod_compras_pregao_execucao_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('compras_pregao_execucao_cod_compras_pregao_execucao_seq', 1, false);


--
-- Data for Name: compras_prestacao_contas; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Name: compras_prestacao_contas_cod_compras_prestacao_contas_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('compras_prestacao_contas_cod_compras_prestacao_contas_seq', 1, false);


--
-- Data for Name: foto_portal; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Name: foto_portal_cod_foto_portal_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('foto_portal_cod_foto_portal_seq', 1, false);


--
-- Data for Name: foto_secao; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Name: foto_secao_cod_foto_secao_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('foto_secao_cod_foto_secao_seq', 1, false);


--
-- Data for Name: funcionario; Type: TABLE DATA; Schema: portal; Owner: postgres
--

INSERT INTO funcionario (ref_cod_pessoa_fj, matricula, senha, ativo, ref_sec, ramal, sequencial, opcao_menu, ref_cod_setor, ref_cod_funcionario_vinculo, tempo_expira_senha, tempo_expira_conta, data_troca_senha, data_reativa_conta, ref_ref_cod_pessoa_fj, proibido, ref_cod_setor_new, matricula_new, matricula_permanente, tipo_menu, ip_logado, data_login, email, status_token, matricula_interna, receber_novidades, atualizou_cadastro) VALUES (1, 'admin', '25f9e794323b453885f5181f1b624d0b', 1, NULL, NULL, '1  ', '1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, 0, 1, '172.17.0.1', '2018-04-04 14:50:46.587163', 'admin@ieducar.com.br', NULL, NULL, NULL, NULL);


--
-- Data for Name: funcionario_vinculo; Type: TABLE DATA; Schema: portal; Owner: postgres
--

INSERT INTO funcionario_vinculo (cod_funcionario_vinculo, nm_vinculo) VALUES (3, 'Efetivo');
INSERT INTO funcionario_vinculo (cod_funcionario_vinculo, nm_vinculo) VALUES (4, 'Contratado');
INSERT INTO funcionario_vinculo (cod_funcionario_vinculo, nm_vinculo) VALUES (5, 'Comissionado');
INSERT INTO funcionario_vinculo (cod_funcionario_vinculo, nm_vinculo) VALUES (6, 'Estagiário');


--
-- Name: funcionario_vinculo_cod_funcionario_vinculo_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('funcionario_vinculo_cod_funcionario_vinculo_seq', 1, false);


--
-- Data for Name: imagem; Type: TABLE DATA; Schema: portal; Owner: postgres
--

INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (168, 6, 'logo_itajai.jpg', NULL, 'jpg', NULL, NULL, '2010-01-06 18:30:33.210952', 1, '2010-01-06 18:30:33.210952', 1);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (34, 1, 'letra_p.gif', 'letra_p', 'gif', NULL, NULL, '2010-01-06 18:30:33.212276', 1, '2010-01-06 18:30:33.212276', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (35, 1, 'letra_q.gif', 'letra_q', 'gif', NULL, NULL, '2010-01-06 18:30:33.212947', 1, '2010-01-06 18:30:33.212947', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (36, 1, 'letra_r.gif', 'letra_r', 'gif', NULL, NULL, '2010-01-06 18:30:33.213685', 1, '2010-01-06 18:30:33.213685', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (37, 1, 'letra_s.gif', 'letra_s', 'gif', NULL, NULL, '2010-01-06 18:30:33.214582', 1, '2010-01-06 18:30:33.214582', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (38, 1, 'letra_t.gif', 'letra_t', 'gif', NULL, NULL, '2010-01-06 18:30:33.215327', 1, '2010-01-06 18:30:33.215327', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (39, 1, 'letra_v.gif', 'letra_v', 'gif', NULL, NULL, '2010-01-06 18:30:33.215968', 1, '2010-01-06 18:30:33.215968', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (40, 1, 'letra_x.gif', 'letra_x', 'gif', NULL, NULL, '2010-01-06 18:30:33.217264', 1, '2010-01-06 18:30:33.217264', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (41, 1, 'letra_w.gif', 'letra_w', 'gif', NULL, NULL, '2010-01-06 18:30:33.218576', 1, '2010-01-06 18:30:33.218576', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (42, 1, 'letra_y.gif', 'letra_y', 'gif', NULL, NULL, '2010-01-06 18:30:33.219314', 1, '2010-01-06 18:30:33.219314', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (43, 1, 'letra_z.gif', 'letra_z', 'gif', NULL, NULL, '2010-01-06 18:30:33.220045', 1, '2010-01-06 18:30:33.220045', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (44, 1, 'letra_u.gif', 'letra_u', 'gif', NULL, NULL, '2010-01-06 18:30:33.220895', 1, '2010-01-06 18:30:33.220895', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (88, 1, 'letra_j.gif', 'letra_j', 'gif', NULL, NULL, '2010-01-06 18:30:33.221765', 1, '2010-01-06 18:30:33.221765', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (89, 1, 'letra_l.gif', 'letra_l', 'gif', NULL, NULL, '2010-01-06 18:30:33.222529', 1, '2010-01-06 18:30:33.222529', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (1, 1, 'transp.gif', 'Transp', '   ', NULL, NULL, '2010-01-06 18:30:33.223478', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (48, 1, 'email.gif', 'contato', 'gif', NULL, NULL, '2010-01-06 18:30:33.224205', 1, '2010-01-06 18:30:33.224205', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (53, 1, 'informacoes.gif', 'informacoes', 'gif', NULL, NULL, '2010-01-06 18:30:33.22499', 1, '2010-01-06 18:30:33.22499', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (56, 1, 'visualizar.gif', 'visualizar', 'gif', NULL, NULL, '2010-01-06 18:30:33.225714', 1, '2010-01-06 18:30:33.225714', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (57, 1, 'novo.gif', 'novo', 'gif', NULL, NULL, '2010-01-06 18:30:33.226447', 1, '2010-01-06 18:30:33.226447', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (59, 1, 'lista.gif', 'lista', 'gif', NULL, NULL, '2010-01-06 18:30:33.227236', 1, '2010-01-06 18:30:33.227236', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (73, 1, 'baixa.gif', 'baixaa', 'gif', NULL, NULL, '2010-01-06 18:30:33.228131', 1, '2010-01-06 18:30:33.228131', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (75, 1, 'carrinho.gif', 'compras', 'gif', NULL, NULL, '2010-01-06 18:30:33.228917', 1, '2010-01-06 18:30:33.228917', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (83, 1, 'retorno.gif', 'retorno', 'gif', NULL, NULL, '2010-01-06 18:30:33.229765', 1, '2010-01-06 18:30:33.229765', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (85, 1, 'saida2.gif', 'saida', 'gif', NULL, NULL, '2010-01-06 18:30:33.230583', 1, '2010-01-06 18:30:33.230583', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (86, 1, 'entrada2.gif', 'entrada', 'gif', NULL, NULL, '2010-01-06 18:30:33.231266', 1, '2010-01-06 18:30:33.231266', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (87, 1, 'seta_cima.gif', 'seta up', 'gif', NULL, NULL, '2010-01-06 18:30:33.232073', 1, '2010-01-06 18:30:33.232073', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (66, 1, 'seta_left.gif', 'seta_left', 'gif', NULL, NULL, '2010-01-06 18:30:33.233148', 1, '2010-01-06 18:30:33.233148', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (67, 1, 'seta_right.gif', 'seta_right', 'gif', NULL, NULL, '2010-01-06 18:30:33.23387', 1, '2010-01-06 18:30:33.23387', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (68, 1, 'seta_up.gif', 'seta_up', 'gif', NULL, NULL, '2010-01-06 18:30:33.234652', 1, '2010-01-06 18:30:33.234652', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (78, 1, 'retorno.gif', 'devolucao', 'gif', NULL, NULL, '2010-01-06 18:30:33.235447', 1, '2010-01-06 18:30:33.235447', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (65, 1, 'seta_down.gif', 'seta_down', 'gif', NULL, NULL, '2010-01-06 18:30:33.236358', 1, '2010-01-06 18:30:33.236358', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (81, 1, 'excluirrr.gif', 'excluirrr', 'gif', NULL, NULL, '2010-01-06 18:30:33.243287', 1, '2010-01-06 18:30:33.243287', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (47, 1, 'check.gif', 'check', 'gif', NULL, NULL, '2010-01-06 18:30:33.244293', 1, '2010-01-06 18:30:33.244293', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (90, 1, 'incluir.gif', 'incluir', 'gif', NULL, NULL, '2010-01-06 18:30:33.245064', 1, '2010-01-06 18:30:33.245064', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (92, 1, 'interrogacao.gif', 'interrogacao', 'gif', NULL, NULL, '2010-01-06 18:30:33.245821', 1, '2010-01-06 18:30:33.245821', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (93, 1, 'exclamacao2.gif', 'exclamacao', 'gif', NULL, NULL, '2010-01-06 18:30:33.246548', 1, '2010-01-06 18:30:33.246548', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (102, 1, 'computador.gif', 'computador', 'gif', NULL, NULL, '2010-01-06 18:30:33.247294', 1, '2010-01-06 18:30:33.247294', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (103, 1, 'duvida.gif', 'duvida', 'gif', NULL, NULL, '2010-01-06 18:30:33.248058', 1, '2010-01-06 18:30:33.248058', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (144, 1, 'libera.gif', 'libera', 'gif', NULL, NULL, '2010-01-06 18:30:33.24885', 1, '2010-01-06 18:30:33.24885', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (145, 1, 'libera2.gif', 'libera', 'gif', NULL, NULL, '2010-01-06 18:30:33.249808', 1, '2010-01-06 18:30:33.249808', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (128, 1, 'lixeira.gif', 'lixeira', 'gif', NULL, NULL, '2010-01-06 18:30:33.250597', 1, '2010-01-06 18:30:33.250597', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (58, 1, 'opcoes.gif', 'opcoes', 'gif', NULL, NULL, '2010-01-06 18:30:33.25141', 1, '2010-01-06 18:30:33.25141', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (141, 1, 'candidatos.gif', 'candidatos', 'gif', NULL, NULL, '2010-01-06 18:30:33.252109', 1, '2010-01-06 18:30:33.252109', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (153, 1, 'calculadora.gif', 'calculadora', '   ', NULL, NULL, '2010-01-06 18:30:33.2529', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (154, 1, 'cifrao.gif', 'cifrao', '   ', NULL, NULL, '2010-01-06 18:30:33.25364', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (61, 1, 'pasta.gif', 'pasta', 'gif', NULL, NULL, '2010-01-06 18:30:33.254267', 1, '2010-01-06 18:30:33.254267', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (55, 1, 'cadeado.gif', 'cadeado', 'gif', NULL, NULL, '2010-01-06 18:30:33.255231', 1, '2010-01-06 18:30:33.255231', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (127, 1, 'vaievolta.gif', 'vaievolta', 'gif', NULL, NULL, '2010-01-06 18:30:33.255966', 1, '2010-01-06 18:30:33.255966', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (155, 1, 'familia.gif', 'familia', '   ', NULL, NULL, '2010-01-06 18:30:33.256764', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (156, 1, 'back.png', 'back', '   ', NULL, NULL, '2010-01-06 18:30:33.257578', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (104, 1, 'adenda.gif', 'agenda', '   ', NULL, NULL, '2010-01-06 18:30:33.25846', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (105, 1, 'relogio.gif', 'relogio', '   ', NULL, NULL, '2010-01-06 18:30:33.259269', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (106, 1, 'ark.gif', 'caixa', '   ', NULL, NULL, '2010-01-06 18:30:33.260283', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (107, 1, 'download_manager.gif', 'download', '   ', NULL, NULL, '2010-01-06 18:30:33.261117', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (108, 1, 'file-manager.gif', 'arquivo', '   ', NULL, NULL, '2010-01-06 18:30:33.261834', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (109, 1, 'filetypes.gif', 'balao', '   ', NULL, NULL, '2010-01-06 18:30:33.262552', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (110, 1, 'kate.gif', 'escrito', '   ', NULL, NULL, '2010-01-06 18:30:33.263297', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (112, 1, 'kfm_home.gif', 'sainhaa', '   ', NULL, NULL, '2010-01-06 18:30:33.264072', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (113, 1, 'ktip.gif', 'computerr', '   ', NULL, NULL, '2010-01-06 18:30:33.264791', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (114, 1, 'mycomputer.gif', 'computer', '   ', NULL, NULL, '2010-01-06 18:30:33.265575', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (115, 1, 'package_application.gif', 'lista', '   ', NULL, NULL, '2010-01-06 18:30:33.266321', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (116, 1, 'package_settings.gif', 'ferramentas', '   ', NULL, NULL, '2010-01-06 18:30:33.267047', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (117, 1, 'password.gif', 'senha', '   ', NULL, NULL, '2010-01-06 18:30:33.267829', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (118, 1, 'personal.gif', 'pessoas', '   ', NULL, NULL, '2010-01-06 18:30:33.26854', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (119, 1, 'window_list.gif', 'lista', '   ', NULL, NULL, '2010-01-06 18:30:33.269227', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (120, 1, 'yast_partitioner.gif', 'grafico', '   ', NULL, NULL, '2010-01-06 18:30:33.270037', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (121, 1, 'rede.gif', 'rede', '   ', NULL, NULL, '2010-01-06 18:30:33.270759', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (122, 1, 'lista.gif', 'lista', '   ', NULL, NULL, '2010-01-06 18:30:33.271427', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (123, 1, 'baixarr.gif', 'baixar', '   ', NULL, NULL, '2010-01-06 18:30:33.272206', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (124, 1, 'escrever.gif', 'escrever', '   ', NULL, NULL, '2010-01-06 18:30:33.272964', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (125, 1, 'identify.gif', 'identidade', '   ', NULL, NULL, '2010-01-06 18:30:33.273944', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (126, 1, 'importante.gif', 'importante', '   ', NULL, NULL, '2010-01-06 18:30:33.274716', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (111, 1, 'kdmconfig.gif', 'usuarios', '   ', NULL, NULL, '2010-01-06 18:30:33.275502', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (137, 1, 'personal2.gif', 'pessoa', '   ', NULL, NULL, '2010-01-06 18:30:33.276424', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (138, 1, 'email.gif', 'email', '   ', NULL, NULL, '2010-01-06 18:30:33.277051', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (139, 1, 'email2.gif', 'email', '   ', NULL, NULL, '2010-01-06 18:30:33.27937', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (140, 1, 'email3.gif', 'email', '   ', NULL, NULL, '2010-01-06 18:30:33.285052', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (142, 1, 'deficientes.gif', 'deficientes', '   ', NULL, NULL, '2010-01-06 18:30:33.285921', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (143, 1, 'areas.gif', 'areas', '   ', NULL, NULL, '2010-01-06 18:30:33.286602', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (146, 1, 'encaminhamento.gif', 'encaminhamento', '   ', NULL, NULL, '2010-01-06 18:30:33.287388', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (147, 1, 'empresa.gif', 'empresa', '   ', NULL, NULL, '2010-01-06 18:30:33.28876', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (148, 1, 'supergrupo.gif', 'supergrupo', '   ', NULL, NULL, '2010-01-06 18:30:33.28957', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (17, 1, 'letra_a.gif', 'letra_a', 'gif', NULL, NULL, '2010-01-06 18:30:33.290308', 1, '2010-01-06 18:30:33.290308', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (91, 1, 'endereco.gif', 'endereco', 'gif', NULL, NULL, '2010-01-06 18:30:33.290989', 1, '2010-01-06 18:30:33.290989', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (19, 1, 'letra_b.gif', 'letra_b', 'gif', NULL, NULL, '2010-01-06 18:30:33.291675', 1, '2010-01-06 18:30:33.291675', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (20, 1, 'letra_c.gif', 'letra_c', 'gif', NULL, NULL, '2010-01-06 18:30:33.292368', 1, '2010-01-06 18:30:33.292368', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (21, 1, 'letra_d.gif', 'letra_d', 'gif', NULL, NULL, '2010-01-06 18:30:33.292959', 1, '2010-01-06 18:30:33.292959', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (22, 1, 'letra_e.gif', 'letra_e', 'gif', NULL, NULL, '2010-01-06 18:30:33.293817', 1, '2010-01-06 18:30:33.293817', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (23, 1, 'letra_f.gif', 'letra_f', 'gif', NULL, NULL, '2010-01-06 18:30:33.29459', 1, '2010-01-06 18:30:33.29459', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (24, 1, 'letra_g.gif', 'letra_g', 'gif', NULL, NULL, '2010-01-06 18:30:33.295332', 1, '2010-01-06 18:30:33.295332', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (25, 1, 'letra_h.gif', 'letra_h', 'gif', NULL, NULL, '2010-01-06 18:30:33.296129', 1, '2010-01-06 18:30:33.296129', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (26, 1, 'letra_i.gif', 'letra_i', 'gif', NULL, NULL, '2010-01-06 18:30:33.296846', 1, '2010-01-06 18:30:33.296846', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (29, 1, 'letra_k.gif', 'letra_k', 'gif', NULL, NULL, '2010-01-06 18:30:33.297747', 1, '2010-01-06 18:30:33.297747', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (31, 1, 'letra_m.gif', 'letra_m', 'gif', NULL, NULL, '2010-01-06 18:30:33.29847', 1, '2010-01-06 18:30:33.29847', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (32, 1, 'letra_n.gif', 'letra_n', 'gif', NULL, NULL, '2010-01-06 18:30:33.299169', 1, '2010-01-06 18:30:33.299169', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (33, 1, 'letra_o.gif', 'letra_o', 'gif', NULL, NULL, '2010-01-06 18:30:33.300006', 1, '2010-01-06 18:30:33.300006', NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (50, 1, 'grafico.gif', 'grafico', 'gif', NULL, NULL, '2010-01-06 18:30:33.300741', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (176, 1, 'escreve.gif', 'escrever', 'gif', NULL, NULL, '2010-01-06 18:30:33.301622', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (177, 1, 'livro.gif', 'livro', 'gif', NULL, NULL, '2010-01-06 18:30:33.302345', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (178, 1, 'sineta.gif', 'sineta', 'gif', NULL, NULL, '2010-01-06 18:30:33.303075', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (179, 1, 'check2.gif', 'check2', 'gif', NULL, NULL, '2010-01-06 18:30:33.303917', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (180, 1, 'geral.gif', 'Geral', 'gif', NULL, NULL, '2010-01-06 18:30:33.304703', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (62, 1, 'pessoa.gif', 'pessoa', 'gif', NULL, NULL, '2010-01-06 18:30:33.305518', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (63, 1, 'print.gif', 'impressao', 'gif', NULL, NULL, '2010-01-06 18:30:33.306231', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (70, 1, 'seta_baixo.gif', 'seta2_down', 'gif', NULL, NULL, '2010-01-06 18:30:33.30705', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (74, 1, 'check.gif', 'check', '   ', NULL, NULL, '2010-01-06 18:30:33.307829', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (80, 1, 'entrada_rel.gif', 'entrada_rel', '   ', NULL, NULL, '2010-01-06 18:30:33.308521', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (82, 1, 'grafico2.gif', 'grafico', '   ', NULL, NULL, '2010-01-06 18:30:33.30934', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (84, 1, 'saida_rel.gif', 'saida_rel', '   ', NULL, NULL, '2010-01-06 18:30:33.310113', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (181, 1, 'carp.jpg', 'carp', 'jpg', NULL, NULL, '2010-01-06 18:30:33.310825', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (182, 1, 'money.gif', 'money', 'gif', NULL, NULL, '2010-01-06 18:30:33.311631', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (183, 1, 'reload.jpg', 'reload', 'jpg', NULL, NULL, '2010-01-06 18:30:33.31248', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (185, 1, 'porca2.jpg', 'porca2', 'jpg', NULL, NULL, '2010-01-06 18:30:33.313215', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (186, 1, 'agua.gif', 'agua', 'gif', NULL, NULL, '2010-01-06 18:30:33.314081', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (187, 1, 'book.png', 'FAMFAMFAM iconset: book.png', 'png', 16, 16, '2010-01-06 18:30:33.314939', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (188, 1, 'book_add.png', 'FAMFAMFAM iconset: book_add.png', 'png', 16, 16, '2010-01-06 18:30:33.3157', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (189, 1, 'book_go.png', 'FAMFAMFAM iconset: book_go.png', 'png', 16, 16, '2010-01-06 18:30:33.316407', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (190, 1, 'layout.png', 'FAMFAMFAM iconset: layout.png', 'png', 16, 16, '2010-01-06 18:30:33.317136', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (191, 1, 'layout_add.png', 'FAMFAMFAM iconset: layout_add.png', 'png', 16, 16, '2010-01-06 18:30:33.317976', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (192, 1, 'layout_content.png', 'FAMFAMFAM iconset: layout_content.png', 'png', 16, 16, '2010-01-06 18:30:33.31861', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (193, 1, 'book_previous.png', 'FAMFAMFAM iconset: book_previous.png', 'png', 16, 16, '2010-01-06 18:30:33.325564', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (194, 1, 'book_error.png', 'FAMFAMFAM iconset: book_error.png', 'png', 16, 16, '2010-01-06 18:30:33.326664', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (195, 1, 'cog.png', 'FAMFAMFAM iconset: cog.png', 'png', 16, 16, '2010-01-06 18:30:33.327682', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (196, 1, 'cog_add.png', 'FAMFAMFAM iconset: cog_add.png', 'png', 16, 16, '2010-01-06 18:30:33.328624', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (197, 1, 'cog_go.png', 'FAMFAMFAM iconset: cog_go.png', 'png', 16, 16, '2010-01-06 18:30:33.329282', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (198, 1, 'calculator.png', 'FAMFAMFAM iconset: calculator.png', 'png', 16, 16, '2010-01-06 18:30:33.330079', 1, NULL, NULL);
INSERT INTO imagem (cod_imagem, ref_cod_imagem_tipo, caminho, nm_imagem, extensao, altura, largura, data_cadastro, ref_cod_pessoa_cad, data_exclusao, ref_cod_pessoa_exc) VALUES (199, 1, 'calendar_link.png', 'FAMFAMFAM iconset: calendar_link.png', 'png', 16, 16, '2010-01-06 18:30:33.330581', 1, NULL, NULL);


--
-- Name: imagem_cod_imagem_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('imagem_cod_imagem_seq', 186, true);


--
-- Data for Name: imagem_tipo; Type: TABLE DATA; Schema: portal; Owner: postgres
--

INSERT INTO imagem_tipo (cod_imagem_tipo, nm_tipo) VALUES (1, 'Icone');
INSERT INTO imagem_tipo (cod_imagem_tipo, nm_tipo) VALUES (6, 'Acervo');


--
-- Name: imagem_tipo_cod_imagem_tipo_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('imagem_tipo_cod_imagem_tipo_seq', 6, true);


--
-- Name: intranet_segur_permissao_nega_cod_intranet_segur_permissao__seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('intranet_segur_permissao_nega_cod_intranet_segur_permissao__seq', 1, false);


--
-- Data for Name: intranet_segur_permissao_negada; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Data for Name: jor_arquivo; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Data for Name: jor_edicao; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Name: jor_edicao_cod_jor_edicao_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('jor_edicao_cod_jor_edicao_seq', 1, false);


--
-- Data for Name: mailling_email; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Name: mailling_email_cod_mailling_email_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('mailling_email_cod_mailling_email_seq', 1, false);


--
-- Data for Name: mailling_email_conteudo; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Name: mailling_email_conteudo_cod_mailling_email_conteudo_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('mailling_email_conteudo_cod_mailling_email_conteudo_seq', 1, false);


--
-- Data for Name: mailling_fila_envio; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Name: mailling_fila_envio_cod_mailling_fila_envio_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('mailling_fila_envio_cod_mailling_fila_envio_seq', 1, false);


--
-- Data for Name: mailling_grupo; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Name: mailling_grupo_cod_mailling_grupo_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('mailling_grupo_cod_mailling_grupo_seq', 1, false);


--
-- Data for Name: mailling_grupo_email; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Data for Name: mailling_historico; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Name: mailling_historico_cod_mailling_historico_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('mailling_historico_cod_mailling_historico_seq', 1, false);


--
-- Data for Name: menu_funcionario; Type: TABLE DATA; Schema: portal; Owner: postgres
--

ALTER TABLE menu_funcionario DISABLE TRIGGER ALL;

INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 0, 0, 0);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 0, 0, 21246);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 0, 0, 335);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 0, 0, 41);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 0, 0, 43);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 0, 0, 753);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 0, 0, 754);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 0, 0, 755);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 0, 0, 756);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 0, 0, 757);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 0, 0, 758);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 554);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 555);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 578);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 624);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 581);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 620);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 576);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 829);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 946);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 566);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 574);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 631);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 659);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 561);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 562);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 585);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 632);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 642);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 572);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 634);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 948);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 573);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 559);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 569);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 633);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 584);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 571);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 567);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 641);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 678);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 647);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 947);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 579);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 845);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 587);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 635);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 583);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 949);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 577);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 558);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 563);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 580);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 568);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 575);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 586);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 570);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 945);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 625);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 592);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 594);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 591);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 603);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 593);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 629);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 628);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 622);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 595);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 610);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 606);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 608);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 590);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 600);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 607);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 598);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 609);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 602);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 596);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 597);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 0, 0, 345);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 0, 0, 343);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 0, 0, 341);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 0, 0, 999613);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 950);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 21235);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 21236);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 21237);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 21238);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 21239);
INSERT INTO menu_funcionario (ref_ref_cod_pessoa_fj, cadastra, exclui, ref_cod_menu_submenu) VALUES (1, 1, 1, 21240);

ALTER TABLE menu_funcionario ENABLE TRIGGER ALL;
--
-- Data for Name: menu_menu; Type: TABLE DATA; Schema: portal; Owner: postgres
--

INSERT INTO menu_menu (cod_menu_menu, nm_menu, title, ref_cod_menu_pai, caminho, ord_menu, ativo, icon_class) VALUES (1, 'Todos', '', NULL, '#', 9999, false, NULL);
INSERT INTO menu_menu (cod_menu_menu, nm_menu, title, ref_cod_menu_pai, caminho, ord_menu, ativo, icon_class) VALUES (23, 'Principal', '', NULL, '#', 9999, false, NULL);
INSERT INTO menu_menu (cod_menu_menu, nm_menu, title, ref_cod_menu_pai, caminho, ord_menu, ativo, icon_class) VALUES (38, 'i-Pauta', '', NULL, '#', 9999, false, NULL);
INSERT INTO menu_menu (cod_menu_menu, nm_menu, title, ref_cod_menu_pai, caminho, ord_menu, ativo, icon_class) VALUES (56, 'i-Educar - Controle', NULL, NULL, '#', 9999, false, NULL);
INSERT INTO menu_menu (cod_menu_menu, nm_menu, title, ref_cod_menu_pai, caminho, ord_menu, ativo, icon_class) VALUES (5, 'Agenda', 'Agendas', NULL, '#', 9999, false, NULL);
INSERT INTO menu_menu (cod_menu_menu, nm_menu, title, ref_cod_menu_pai, caminho, ord_menu, ativo, icon_class) VALUES (68, 'Endereçamento', '', NULL, '/intranet/educar_enderecamento_index.php', 2, true, 'fa-map');
INSERT INTO menu_menu (cod_menu_menu, nm_menu, title, ref_cod_menu_pai, caminho, ord_menu, ativo, icon_class) VALUES (7, 'Pessoas', 'Pessoas Físicas e Jurídicas', NULL, '/intranet/educar_pessoas_index.php', 3, true, 'fa-user');
INSERT INTO menu_menu (cod_menu_menu, nm_menu, title, ref_cod_menu_pai, caminho, ord_menu, ativo, icon_class) VALUES (55, 'Escola', NULL, NULL, '/intranet/educar_index.php', 4, true, 'fa-leanpub');
INSERT INTO menu_menu (cod_menu_menu, nm_menu, title, ref_cod_menu_pai, caminho, ord_menu, ativo, icon_class) VALUES (69, 'Transporte escolar', NULL, NULL, '/intranet/educar_transporte_escolar_index.php', 7, true, 'fa-bus');
INSERT INTO menu_menu (cod_menu_menu, nm_menu, title, ref_cod_menu_pai, caminho, ord_menu, ativo, icon_class) VALUES (57, 'Biblioteca', NULL, NULL, '/intranet/educar_biblioteca_index.php', 8, true, 'fa-book');
INSERT INTO menu_menu (cod_menu_menu, nm_menu, title, ref_cod_menu_pai, caminho, ord_menu, ativo, icon_class) VALUES (25, 'Configurações', 'Sistemas do RH', NULL, '/intranet/educar_configuracoes_index.php', 9, true, 'fa-gear');
INSERT INTO menu_menu (cod_menu_menu, nm_menu, title, ref_cod_menu_pai, caminho, ord_menu, ativo, icon_class) VALUES (70, 'Educacenso', NULL, NULL, '/intranet/educar_educacenso_index.php', 6, true, 'fa-bar-chart');
INSERT INTO menu_menu (cod_menu_menu, nm_menu, title, ref_cod_menu_pai, caminho, ord_menu, ativo, icon_class) VALUES (71, 'Servidores', '', NULL, '/intranet/educar_servidores_index.php', 5, true, 'fa-users');


--
-- Name: menu_menu_cod_menu_menu_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('menu_menu_cod_menu_menu_seq', 68, true);


--
-- Data for Name: menu_submenu; Type: TABLE DATA; Schema: portal; Owner: postgres
--

INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (0, 1, 0, 'Super usuário', '', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (155, 23, 2, 'Minha agenda', 'agenda.php', '', 2);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (157, 23, 2, 'Minhas conexões', 'conexoes_lst.php', 'Minhas Conexões', 2);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (475, 23, 2, 'Preferências', 'opcao_menu_lst.php', '', 2);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (335, 38, 2, 'Super usuário ', 'otopic_su_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (569, 55, 2, 'Material didático', 'educar_material_didatico_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (21235, 69, 2, 'Empresas do transporte', 'transporte_empresa_lst.php', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (21236, 69, 2, 'Motoristas do transporte', 'transporte_motorista_lst.php', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (563, 55, 2, 'Tipo material didático', 'educar_material_tipo_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (21237, 69, 2, 'Veículos do transporte', 'transporte_veiculo_lst.php', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (559, 55, 2, 'Instituição', 'educar_instituicao_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (9998851, 25, 2, 'Auditoria geral', 'educar_auditoria_geral_lst.php', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (9998858, 25, 2, 'Backups', 'educar_backup_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (624, 55, 2, 'Apresentação', 'educar_index.php', '', 2);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (946, 55, 2, 'Componentes curriculares', 'educar_componente_curricular_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (9998849, 70, 2, 'Importação educacenso', 'educar_importacao_educacenso.php', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (845, 55, 2, 'Rematrícula automática', 'educar_avancar_mod_cad.php', 'Rematrícula Automática', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (9998859, 55, 2, 'Componentes da série', 'educar_componentes_serie_lst.php', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (606, 57, 2, 'Exemplares', 'educar_exemplar_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (602, 57, 2, 'Situação', 'educar_situacao_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (598, 57, 2, 'Obras', 'educar_acervo_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (625, 57, 2, 'Apresentação', 'educar_biblioteca_index.php', '', 2);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (947, 55, 2, 'Regras de avaliação', 'module/RegraAvaliacao/index', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (949, 55, 2, 'Tabelas de arredondamento de nota', 'module/TabelaArredondamento/index', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (341, 5, 2, 'Agendas', 'agenda_responsavel.php', NULL, 2);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (343, 5, 2, 'Agenda admin', 'agenda_admin_lst.php', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (345, 5, 2, 'Agenda pessoal', 'agenda.php', 'Agenda pessoal', 2);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (21234, 69, 2, 'Apresentação', 'transporte_index.php', NULL, 2);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (634, 71, 2, 'Funções do servidor', 'educar_funcao_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (632, 71, 2, 'Escolaridade do servidor', 'educar_escolaridade_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (829, 71, 2, 'Categoria ou níveis do servidor', 'educar_categoria_nivel_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (633, 71, 2, 'Motivos de afastamento do servidor', 'educar_motivo_afastamento_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (635, 71, 2, 'Servidores', 'educar_servidor_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (641, 71, 2, 'Quadros de horários', 'educar_quadro_horario_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (948, 55, 2, 'Fórmulas de cálculo de média', 'module/FormulaMedia/index', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (577, 55, 2, 'Tipos de dispensa da disciplina', 'educar_tipo_dispensa_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (43, 7, 2, 'Pessoas físicas', 'atendidos_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (41, 7, 2, 'Pessoas jurídicas', 'empresas_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (753, 68, 2, 'Países', 'public_pais_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (754, 68, 2, 'Estados', 'public_uf_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (755, 68, 2, 'Municípios', 'public_municipio_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (759, 68, 2, 'Distritos', 'public_distrito_lst.php', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (756, 68, 2, 'Bairros', 'public_bairro_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (757, 68, 2, 'Logradouros', 'public_logradouro_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (758, 68, 2, 'CEP', 'urbano_cep_logradouro_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (581, 55, 2, 'Tipos de benefício do aluno', 'educar_aluno_beneficio_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (575, 55, 2, 'Tipos de transferência da matrícula', 'educar_transferencia_tipo_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (580, 55, 2, 'Tipos de ocorrência disciplinar da matrícula', 'educar_tipo_ocorrencia_disciplinar_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (945, 55, 2, 'Áreas de conhecimento da disciplina', 'module/AreaConhecimento/index', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (573, 55, 2, 'Tipos de habilitação do curso', 'educar_habilitacao_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (568, 55, 2, 'Tipos de regime do curso', 'educar_tipo_regime_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (558, 55, 2, 'Tipos de ensino do curso', 'educar_tipo_ensino_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (571, 55, 2, 'Tipos de nível ensino do curso', 'educar_nivel_ensino_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (562, 55, 2, 'Tipos de localização da escola', 'educar_escola_localizacao_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (584, 55, 2, 'Tipos de módulos da escola', 'educar_modulo_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (659, 55, 2, 'Enturmações em lote', 'educar_matriculas_turma_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (678, 7, 2, 'Tipos de cor ou raça da pessoa', 'educar_raca_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (631, 7, 2, 'Tipos de deficiência da pessoa', 'educar_deficiencia_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (579, 7, 2, 'Tipos de religião da pessoa', 'educar_religiao_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (21240, 69, 2, 'Usuários de transporte', 'transporte_pessoa_lst.php', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (21238, 69, 2, 'Rotas do transporte', 'transporte_rota_lst.php', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (21239, 69, 2, 'Pontos do transporte', 'transporte_ponto_lst.php', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (21251, 55, 2, 'Bloqueio do ano letivo', 'educar_bloqueio_ano_letivo_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (642, 55, 2, 'Lançamento de faltas e notas', 'module/Avaliacao/diario', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (21250, 55, 2, 'Tipos de projeto do aluno', 'educar_projeto_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (950, 55, 2, 'Tipos de abandono da matrícula', 'educar_abandono_tipo_lst.php', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (572, 55, 2, 'Tipos de ambiente da escola', 'educar_infra_comodo_funcao_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (574, 55, 2, 'Infraestrutura da escola', 'educar_infra_predio_comodo_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (21246, 69, 2, 'Cópia de rotas do transporte', 'transporte_copia_rotas.php', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (761, 68, 2, 'Unificação de bairros', 'educar_unifica_bairro.php', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (762, 68, 2, 'Unificação de logradouros', 'educar_unifica_logradouro.php', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (626, 55, 0, 'Alterar datas de entrada/saída de matrículas', '', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (627, 55, 0, 'Cancelar matrícula', '', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (21253, 55, 2, 'Vagas por série/ano', 'educar_serie_vaga_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (999847, 55, 2, 'Unificação de alunos', 'educar_unifica_aluno.php', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (630, 55, 0, 'Alterar média final do aluno e situação (para regras de avaliação manuais)', '', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (999849, 55, 0, 'Permitir lançamento de notas/faltas fora do período de bloqueio por etapa', '', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (554, 25, 2, 'Tipos de usuário', 'educar_tipo_usuario_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (555, 25, 2, 'Usuários', 'educar_usuario_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (644, 25, 2, 'Atualização de matrículas', 'module/Avaliacao/Promocao', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (760, 68, 2, 'Setores', 'public_setor_lst.php', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (999873, 25, 2, 'Configurações gerais', 'educar_configuracoes_gerais.php', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (999878, 55, 0, 'Permitir editar endereço no cadastro de pessoa física', '', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (592, 57, 2, 'Assuntos de obras', 'educar_acervo_assunto_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (594, 57, 2, 'Autores de obras', 'educar_acervo_autor_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (593, 57, 2, 'Coleções de obras', 'educar_acervo_colecao_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (595, 57, 2, 'Editoras de obras', 'educar_acervo_editora_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (590, 57, 2, 'Idiomas de obras', 'educar_acervo_idioma_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (608, 57, 2, 'Fontes de obras', 'educar_fonte_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (597, 57, 2, 'Tipos de exemplar', 'educar_exemplar_tipo_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (15891, 57, 2, 'Tipos de situação de exemplar', 'educar_situacao_lst.php', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (600, 57, 2, 'Motivos de baixa do exemplar', 'educar_motivo_baixa_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (596, 57, 2, 'Tipos de cliente', 'educar_cliente_tipo_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (607, 57, 2, 'Motivos de suspensão do cliente', 'educar_motivo_suspensao_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (591, 57, 2, 'Bibliotecas', 'educar_biblioteca_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (603, 57, 2, 'Clientes', 'educar_cliente_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (629, 57, 2, 'Configurações de bibliotecas', 'educar_biblioteca_dados_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (609, 57, 2, 'Reservas de exemplares', 'educar_reservas_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (610, 57, 2, 'Empréstimos de exemplares', 'module/Biblioteca/emprestimo', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (628, 57, 2, 'Devoluções de exemplares', 'educar_exemplar_devolucao_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (622, 57, 2, 'Dívidas de exemplares', 'educar_pagamento_multa_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (999869, 25, 2, 'Exportação de usuários', 'educar_exportacao_usuarios.php', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (587, 55, 2, 'Sequências de enturmação', 'educar_sequencia_serie_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (570, 55, 2, 'Tipos de turma', 'educar_turma_tipo_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (567, 55, 2, 'Prédios da escola', 'educar_infra_predio_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (576, 55, 2, 'Tipos de evento do calendário', 'educar_calendario_dia_motivo_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (561, 55, 2, 'Escolas', 'educar_escola_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (566, 55, 2, 'Cursos', 'educar_curso_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (578, 55, 2, 'Alunos', 'educar_aluno_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (647, 55, 2, 'Tipos de rede de ensino da escola', 'educar_escola_rede_ensino_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (999867, 57, 2, 'Categorias de obras', 'educar_categoria_lst.php', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (846, 70, 2, 'Exportação do educacenso - 1ª fase', 'educar_exportacao_educacenso.php', NULL, 2);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (9998845, 70, 2, 'Exportação do educacenso - 2ª fase', 'educar_exportacao_educacenso.php?fase2=1', NULL, 2);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (999861, 55, 2, 'Documentação padrão', 'DocumentacaoPadrao.php', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (583, 55, 2, 'Séries', 'educar_serie_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (586, 55, 2, 'Turmas', 'educar_turma_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (620, 55, 2, 'Calendários', 'educar_calendario_ano_letivo_lst.php', '', 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (21145, 55, 2, 'Lançamento de ocorrências disciplinares', 'educar_matricula_ocorrencia_disciplinar_cad.php', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (999613, 55, 2, 'Processamento de históricos escolares', 'module/HistoricoEscolar/processamento', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (999848, 55, 2, 'Bloqueio de lançamento de notas e faltas', 'educar_bloqueio_lancamento_faltas_notas_lst.php', NULL, 3);
INSERT INTO menu_submenu (cod_menu_submenu, ref_cod_menu_menu, cod_sistema, nm_submenu, arquivo, title, nivel) VALUES (585, 55, 2, 'Séries da escola', 'educar_escola_serie_lst.php', '', 3);


--
-- Name: menu_submenu_cod_menu_submenu_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('menu_submenu_cod_menu_submenu_seq', 944, true);


--
-- Data for Name: not_portal; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Name: not_portal_cod_not_portal_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('not_portal_cod_not_portal_seq', 1, false);


--
-- Data for Name: not_portal_tipo; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Data for Name: not_tipo; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Name: not_tipo_cod_not_tipo_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('not_tipo_cod_not_tipo_seq', 1, false);


--
-- Data for Name: not_vinc_portal; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Data for Name: notificacao; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Name: notificacao_cod_notificacao_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('notificacao_cod_notificacao_seq', 1, false);


--
-- Data for Name: pessoa_atividade; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Name: pessoa_atividade_cod_pessoa_atividade_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('pessoa_atividade_cod_pessoa_atividade_seq', 1, false);


--
-- Data for Name: pessoa_fj; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Name: pessoa_fj_cod_pessoa_fj_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('pessoa_fj_cod_pessoa_fj_seq', 1, false);


--
-- Data for Name: pessoa_fj_pessoa_atividade; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Data for Name: pessoa_ramo_atividade; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Name: pessoa_ramo_atividade_cod_ramo_atividade_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('pessoa_ramo_atividade_cod_ramo_atividade_seq', 1, false);


--
-- Name: portal_banner_cod_portal_banner_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('portal_banner_cod_portal_banner_seq', 1, false);


--
-- Data for Name: portal_concurso; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Name: portal_concurso_cod_portal_concurso_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('portal_concurso_cod_portal_concurso_seq', 1, false);


--
-- Data for Name: sistema; Type: TABLE DATA; Schema: portal; Owner: postgres
--



--
-- Name: sistema_cod_sistema_seq; Type: SEQUENCE SET; Schema: portal; Owner: postgres
--

SELECT pg_catalog.setval('sistema_cod_sistema_seq', 1, false);


SET search_path = public, pg_catalog;

--
-- Data for Name: bairro; Type: TABLE DATA; Schema: public; Owner: postgres
--



--
-- Data for Name: bairro_regiao; Type: TABLE DATA; Schema: public; Owner: postgres
--



--
-- Name: bloqueio_lancamento_faltas_notas_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('bloqueio_lancamento_faltas_notas_seq', 1, false);


--
-- Data for Name: changelog; Type: TABLE DATA; Schema: public; Owner: postgres
--

INSERT INTO changelog (change_number, delta_set, start_dt, complete_dt, applied_by, description) VALUES (2, 'Main', '2010-01-06 18:30:33.677103', '2010-01-06 18:30:33.677103', 'dbdeploy', '2_popula_dados_basicos.sql');
INSERT INTO changelog (change_number, delta_set, start_dt, complete_dt, applied_by, description) VALUES (1, 'Main', '2010-01-06 18:30:33.678547', '2010-01-06 18:30:33.678547', 'dbdeploy', '1_cria_schema_inicial.sql');
INSERT INTO changelog (change_number, delta_set, start_dt, complete_dt, applied_by, description) VALUES (3, 'Main', '2010-01-06 18:30:33.67913', '2010-01-06 18:30:33.67913', 'dbdeploy', '3_corrige_sequences.sql');
INSERT INTO changelog (change_number, delta_set, start_dt, complete_dt, applied_by, description) VALUES (4, 'Main', '2010-01-06 18:30:33.679899', '2010-01-06 18:30:33.679899', 'dbdeploy', '4_permissoes_usuario_tipo_biblioteca.sql');
INSERT INTO changelog (change_number, delta_set, start_dt, complete_dt, applied_by, description) VALUES (5, 'Main', '2010-01-06 18:30:33.680667', '2010-01-06 18:30:33.680667', 'dbdeploy', '5_corrige_triggers_constrainst.sql');
INSERT INTO changelog (change_number, delta_set, start_dt, complete_dt, applied_by, description) VALUES (6, 'Main', '2010-01-06 18:30:33.681269', '2010-01-06 18:30:33.681269', 'dbdeploy', '6_cria_schema_modules.sql');
INSERT INTO changelog (change_number, delta_set, start_dt, complete_dt, applied_by, description) VALUES (7, 'Main', '2010-01-06 18:30:33.682013', '2010-01-06 18:30:33.682013', 'dbdeploy', '7_cria_tabelas_modulo_regra_avaliacao.sql');
INSERT INTO changelog (change_number, delta_set, start_dt, complete_dt, applied_by, description) VALUES (8, 'Main', '2010-01-06 18:30:33.682883', '2010-01-06 18:30:33.682883', 'dbdeploy', '8_remove_campos_pmieducar_serie.sql');
INSERT INTO changelog (change_number, delta_set, start_dt, complete_dt, applied_by, description) VALUES (9, 'Main', '2010-01-06 18:30:33.68371', '2010-01-06 18:30:33.68371', 'dbdeploy', '9_atualiza_foreign_key_de_pmieducar_escola_serie_disciplina.sql');
INSERT INTO changelog (change_number, delta_set, start_dt, complete_dt, applied_by, description) VALUES (10, 'Main', '2010-01-06 18:30:33.693854', '2010-01-06 18:30:33.693854', 'dbdeploy', '10_remove_campos_pmieducar_curso.sql');
INSERT INTO changelog (change_number, delta_set, start_dt, complete_dt, applied_by, description) VALUES (11, 'Main', '2010-01-06 18:30:33.694934', '2010-01-06 18:30:33.694934', 'dbdeploy', '11_adiciona_foreign_key_entre_pmieducar_serie_e_modules_regra_avaliacao.sql');
INSERT INTO changelog (change_number, delta_set, start_dt, complete_dt, applied_by, description) VALUES (12, 'Main', '2010-01-06 18:30:33.695678', '2010-01-06 18:30:33.695678', 'dbdeploy', '12_cria_tabelas_modulo_avaliacao.sql');
INSERT INTO changelog (change_number, delta_set, start_dt, complete_dt, applied_by, description) VALUES (13, 'Main', '2010-01-06 18:30:33.696349', '2010-01-06 18:30:33.696349', 'dbdeploy', '13_adiciona_campo_carga_horaria_pmieducar_escola_serie_disciplina_modules_componente_curricular_ano_escolar');
INSERT INTO changelog (change_number, delta_set, start_dt, complete_dt, applied_by, description) VALUES (14, 'Main', '2010-01-06 18:30:33.697086', '2010-01-06 18:30:33.697086', 'dbdeploy', '14_adiciona_campo_etapa_modules_nota_componente_curricular_media.sql');
INSERT INTO changelog (change_number, delta_set, start_dt, complete_dt, applied_by, description) VALUES (15, 'Main', '2010-01-06 18:30:33.697897', '2010-01-06 18:30:33.697897', 'dbdeploy', '15_atualiza_foreign_key_modules_falta_geral.sql');
INSERT INTO changelog (change_number, delta_set, start_dt, complete_dt, applied_by, description) VALUES (16, 'Main', '2010-01-06 18:30:33.698535', '2010-01-06 18:30:33.698535', 'dbdeploy', '16_permissoes_para_modules_e_correcao_menus.sql');


--
-- Data for Name: distrito; Type: TABLE DATA; Schema: public; Owner: postgres
--

INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1, NULL, 1, 'Alta Floresta D''oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.699228', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2, NULL, 2, 'Alto Alegre dos Parecis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.700901', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3, NULL, 3, 'Alto Paraiso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.701715', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4, NULL, 4, 'Alvorada D''oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.70262', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5, NULL, 5, 'Ariquemes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.703562', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (6, NULL, 6, 'Buritis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.704461', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (7, NULL, 7, 'Cabixi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.7053', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (8, NULL, 8, 'Cacaulandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.706175', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (9, NULL, 9, 'Cacoal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.707047', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (10, NULL, 10, 'Campo Novo de Rondonia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.70796', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (11, NULL, 11, 'Candeias do Jamari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.708884', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (12, NULL, 12, 'Castanheiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.709859', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (13, NULL, 13, 'Cerejeiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.711055', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (14, NULL, 14, 'Chupinguaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.711993', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (15, NULL, 15, 'Colorado do Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.712932', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (16, NULL, 16, 'Corumbiara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.713842', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (17, NULL, 17, 'Costa Marques', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.714738', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (18, NULL, 18, 'Cujubim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.715723', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (19, NULL, 19, 'Espigao D''oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.716704', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (20, NULL, 20, 'Governador Jorge Teixeira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.717717', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (21, NULL, 21, 'Guajara-mirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.718803', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (22, NULL, 22, 'Itapua do Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.719743', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (23, NULL, 23, 'Jaru', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.720746', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (24, NULL, 24, 'Ji-parana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.721775', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (25, NULL, 25, 'Machadinho D''oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.722776', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (26, NULL, 26, 'Ministro Andreazza', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.723813', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (27, NULL, 27, 'Mirante da Serra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.725075', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (28, NULL, 28, 'Monte Negro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.731957', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (29, NULL, 29, 'Nova Brasilandia D''oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.73323', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (30, NULL, 30, 'Nova Mamore', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.734184', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (31, NULL, 31, 'Nova Uniao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.735123', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (32, NULL, 32, 'Novo Horizonte do Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.73613', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (33, NULL, 33, 'Ouro Preto do Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.737108', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (34, NULL, 34, 'Parecis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.738213', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (35, NULL, 35, 'Pimenta Bueno', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.73925', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (36, NULL, 36, 'Pimenteiras do Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.740233', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (37, NULL, 37, 'Porto Velho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.741221', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (38, NULL, 38, 'Presidente Medici', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.742117', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (39, NULL, 39, 'Primavera de Rondonia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.743068', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (40, NULL, 40, 'Rio Crespo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.744066', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (41, NULL, 41, 'Rolim de Moura', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.745017', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (42, NULL, 42, 'Santa Luzia D''oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.745909', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (43, NULL, 43, 'Sao Felipe D Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.747041', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (44, NULL, 44, 'Sao Francisco do Guapore', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.747752', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (45, NULL, 45, 'Sao Miguel do Guapore', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.748533', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (46, NULL, 46, 'Seringueiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.749422', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (47, NULL, 47, 'Teixeiropolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.750356', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (48, NULL, 48, 'Theobroma', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.751289', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (49, NULL, 49, 'Urupa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.752266', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (50, NULL, 50, 'Vale do Anari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.753153', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (51, NULL, 51, 'Vale do Paraiso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.754014', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (52, NULL, 52, 'Vilhena', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.754961', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (53, NULL, 53, 'Acrelandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.756206', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (54, NULL, 54, 'Assis Brasil', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.757065', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (55, NULL, 55, 'Brasileia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.757891', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (56, NULL, 56, 'Bujari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.758909', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (57, NULL, 57, 'Capixaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.759844', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (58, NULL, 58, 'Cruzeiro do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.760768', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (59, NULL, 59, 'Epitaciolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.761618', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (60, NULL, 60, 'Feijo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.762592', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (61, NULL, 61, 'Jordao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.763501', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (62, NULL, 62, 'Mancio Lima', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.764379', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (63, NULL, 63, 'Manoel Urbano', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.765356', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (64, NULL, 64, 'Marechal Thaumaturgo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.772448', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (65, NULL, 65, 'Placido de Castro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.77356', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (66, NULL, 66, 'Porto Acre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.774455', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (67, NULL, 67, 'Porto Walter', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.775372', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (68, NULL, 68, 'Rio Branco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.776144', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (69, NULL, 69, 'Rodrigues Alves', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.777086', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (70, NULL, 70, 'Santa Rosa do Purus', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.778157', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (71, NULL, 71, 'Sena Madureira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.779501', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (72, NULL, 72, 'Senador Guiomard', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.780338', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (73, NULL, 73, 'Tarauaca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.781279', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (74, NULL, 74, 'Xapuri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.782326', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (75, NULL, 75, 'Alvaraes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.783307', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (76, NULL, 76, 'Amatura', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.78444', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (77, NULL, 77, 'Anama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.785298', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (78, NULL, 78, 'Anori', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.7862', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (79, NULL, 79, 'Apui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.787062', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (80, NULL, 80, 'Atalaia do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.787924', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (81, NULL, 81, 'Autazes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.788882', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (82, NULL, 82, 'Barcelos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.789694', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (83, NULL, 83, 'Barreirinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.790558', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (84, NULL, 84, 'Benjamin Constant', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.791396', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (85, NULL, 85, 'Beruri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.792246', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (86, NULL, 86, 'Boa Vista do Ramos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.793161', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (87, NULL, 87, 'Boca do Acre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.794181', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (88, NULL, 88, 'Borba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.795002', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (89, NULL, 89, 'Caapiranga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.795793', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (90, NULL, 90, 'Canutama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.796734', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (91, NULL, 91, 'Carauari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.797699', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (92, NULL, 92, 'Careiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.798687', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (93, NULL, 93, 'Careiro da Varzea', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.799621', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (94, NULL, 94, 'Coari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.800826', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (95, NULL, 95, 'Codajas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.801802', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (96, NULL, 96, 'Eirunepe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.802748', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (97, NULL, 97, 'Envira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.803632', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (98, NULL, 98, 'Fonte Boa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.804528', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (99, NULL, 99, 'Guajara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.805459', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (100, NULL, 100, 'Humaita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.806293', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (101, NULL, 101, 'Ipixuna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.813076', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (102, NULL, 102, 'Iranduba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.814239', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (103, NULL, 103, 'Itamarati', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.815178', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (104, NULL, 104, 'Itapiranga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.816065', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (105, NULL, 105, 'Japura', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.81715', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (106, NULL, 106, 'Jurua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.818091', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (107, NULL, 107, 'Jutai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.819038', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (108, NULL, 108, 'Labrea', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.820032', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (109, NULL, 109, 'Manacapuru', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.820907', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (110, NULL, 110, 'Manaquiri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.821753', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (111, NULL, 111, 'Manaus', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.822972', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (112, NULL, 112, 'Manicore', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.823952', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (113, NULL, 113, 'Maraa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.824889', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (114, NULL, 114, 'Maues', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.825835', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (115, NULL, 115, 'Nhamunda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.826766', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (116, NULL, 116, 'Nova Olinda do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.827685', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (117, NULL, 117, 'Novo Airao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.828719', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (118, NULL, 118, 'Novo Aripuana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.829683', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (119, NULL, 119, 'Parintins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.830562', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (120, NULL, 120, 'Pauini', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.83138', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (121, NULL, 121, 'Presidente Figueiredo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.832207', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (122, NULL, 122, 'Rio Preto da Eva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.833161', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (123, NULL, 123, 'Santa Isabel do Rio Negro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.834228', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (124, NULL, 124, 'Santo Antonio do Ica', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.835121', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (125, NULL, 125, 'Sao Gabriel da Cachoeira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.836046', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (126, NULL, 126, 'Sao Paulo de Olivenca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.836988', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (127, NULL, 127, 'Sao Sebastiao do Uatuma', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.837813', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (128, NULL, 128, 'Silves', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.838766', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (129, NULL, 129, 'Tabatinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.839732', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (130, NULL, 130, 'Tapaua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.840639', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (131, NULL, 131, 'Tefe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.841614', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (132, NULL, 132, 'Tonantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.842553', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (133, NULL, 133, 'Uarini', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.843379', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (134, NULL, 134, 'Urucara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.844178', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (135, NULL, 135, 'Urucurituba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.845408', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (136, NULL, 136, 'Alto Alegre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.846512', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (137, NULL, 137, 'Amajari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.853924', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (138, NULL, 138, 'Boa Vista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.855192', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (139, NULL, 139, 'Bonfim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.856157', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (140, NULL, 140, 'Canta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.856972', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (141, NULL, 141, 'Caracarai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.857888', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (142, NULL, 142, 'Caroebe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.858888', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (143, NULL, 143, 'Iracema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.859891', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (144, NULL, 144, 'Mucajai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.860859', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (145, NULL, 145, 'Normandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.861807', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (146, NULL, 146, 'Pacaraima', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.862761', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (147, NULL, 147, 'Rorainopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.86373', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (148, NULL, 148, 'Sao Joao da Baliza', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.864648', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (149, NULL, 149, 'Sao Luiz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.865518', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (150, NULL, 150, 'Uiramuta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.866386', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (151, NULL, 151, 'Abaetetuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.867591', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (152, NULL, 152, 'Abel Figueiredo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.868448', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (153, NULL, 153, 'Acara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.869342', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (154, NULL, 154, 'Afua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.87027', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (155, NULL, 155, 'Agua Azul do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.871096', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (156, NULL, 156, 'Alenquer', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.872038', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (157, NULL, 157, 'Almeirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.872959', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (158, NULL, 158, 'Altamira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.873993', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (159, NULL, 159, 'Anajas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.874868', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (160, NULL, 160, 'Ananindeua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.875805', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (161, NULL, 161, 'Anapu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.87672', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (162, NULL, 162, 'Augusto Correa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.877656', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (163, NULL, 163, 'Aurora do Para', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.878762', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (164, NULL, 164, 'Aveiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.879577', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (165, NULL, 165, 'Bagre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.88047', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (166, NULL, 166, 'Baiao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.881428', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (167, NULL, 167, 'Bannach', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.882419', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (168, NULL, 168, 'Barcarena', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.883321', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (169, NULL, 169, 'Belem', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.884275', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (170, NULL, 170, 'Belterra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.885225', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (171, NULL, 171, 'Benevides', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.886172', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (172, NULL, 172, 'Bom Jesus do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.887134', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (173, NULL, 173, 'Bonito', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.894617', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (174, NULL, 174, 'Braganca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.895728', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (175, NULL, 175, 'Brasil Novo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.896566', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (176, NULL, 176, 'Brejo Grande do Araguaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.897635', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (177, NULL, 177, 'Breu Branco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.898564', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (178, NULL, 178, 'Breves', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.899242', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (179, NULL, 179, 'Bujaru', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.900159', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (180, NULL, 180, 'Cachoeira do Arari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.901094', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (181, NULL, 181, 'Cachoeira do Piria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.902107', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (182, NULL, 182, 'Cameta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.903016', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (183, NULL, 183, 'Canaa dos Carajas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.903963', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (184, NULL, 184, 'Capanema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.904782', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (185, NULL, 185, 'Capitao Poco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.905681', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (186, NULL, 186, 'Castanhal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.906554', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (187, NULL, 187, 'Chaves', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.907603', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (188, NULL, 188, 'Colares', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.908482', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (189, NULL, 189, 'Conceicao do Araguaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.909368', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (190, NULL, 190, 'Concordia do Para', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.910192', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (191, NULL, 191, 'Cumaru do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.911121', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (192, NULL, 192, 'Curionopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.912262', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (193, NULL, 193, 'Curralinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.913215', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (194, NULL, 194, 'Curua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.914119', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (195, NULL, 195, 'Curuca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.915017', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (196, NULL, 196, 'Dom Eliseu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.91602', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (197, NULL, 197, 'Eldorado dos Carajas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.917067', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (198, NULL, 198, 'Faro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.91806', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (199, NULL, 199, 'Floresta do Araguaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.918982', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (200, NULL, 200, 'Garrafao do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.919913', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (201, NULL, 201, 'Goianesia do Para', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.92081', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (202, NULL, 202, 'Gurupa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.921711', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (203, NULL, 203, 'Igarape-acu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.922705', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (204, NULL, 204, 'Igarape-miri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.92357', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (205, NULL, 205, 'Inhangapi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.924586', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (206, NULL, 206, 'Ipixuna do Para', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.9256', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (207, NULL, 207, 'Irituia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.926608', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (208, NULL, 208, 'Itaituba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.92776', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (209, NULL, 209, 'Itupiranga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.928737', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (210, NULL, 210, 'Jacareacanga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.936088', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (211, NULL, 211, 'Jacunda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.937324', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (212, NULL, 212, 'Juruti', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.938243', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (213, NULL, 213, 'Limoeiro do Ajuru', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.939321', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (214, NULL, 214, 'Mae do Rio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.940188', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (215, NULL, 215, 'Magalhaes Barata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.941158', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (216, NULL, 216, 'Maraba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.942124', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (217, NULL, 217, 'Maracana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.943021', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (218, NULL, 218, 'Marapanim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.943981', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (219, NULL, 219, 'Marituba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.944811', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (220, NULL, 220, 'Medicilandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.945759', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (221, NULL, 221, 'Melgaco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.946559', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (222, NULL, 222, 'Mocajuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.947482', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (223, NULL, 223, 'Moju', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.948244', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (224, NULL, 224, 'Monte Alegre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.949614', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (225, NULL, 225, 'Muana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.950555', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (226, NULL, 226, 'Nova Esperanca do Piria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.9514', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (227, NULL, 227, 'Nova Ipixuna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.952304', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (228, NULL, 228, 'Nova Timboteua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.953216', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (229, NULL, 229, 'Novo Progresso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.954085', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (230, NULL, 230, 'Novo Repartimento', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.955006', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (231, NULL, 231, 'Obidos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.95593', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (232, NULL, 232, 'Oeiras do Para', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.956865', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (233, NULL, 233, 'Oriximina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.957786', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (234, NULL, 234, 'Ourem', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.958709', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (235, NULL, 235, 'Ourilandia do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.959504', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (236, NULL, 236, 'Pacaja', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.960374', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (237, NULL, 237, 'Palestina do Para', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.96127', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (238, NULL, 238, 'Paragominas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.962164', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (239, NULL, 239, 'Parauapebas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.963118', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (240, NULL, 240, 'Pau D''arco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.963912', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (241, NULL, 241, 'Peixe-boi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.964888', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (242, NULL, 242, 'Picarra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.965834', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (243, NULL, 243, 'Placas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.966852', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (244, NULL, 244, 'Ponta de Pedras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.968025', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (245, NULL, 245, 'Portel', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.969061', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (246, NULL, 246, 'Porto de Moz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.970034', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (247, NULL, 247, 'Prainha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.978985', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (248, NULL, 248, 'Primavera', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.980101', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (249, NULL, 249, 'Quatipuru', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.981208', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (250, NULL, 250, 'Redencao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.982118', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (251, NULL, 251, 'Rio Maria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.983216', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (252, NULL, 252, 'Rondon do Para', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.984434', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (253, NULL, 253, 'Ruropolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.985502', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (254, NULL, 254, 'Salinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.986493', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (255, NULL, 255, 'Salvaterra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.987353', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (256, NULL, 256, 'Santa Barbara do Para', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.988251', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (257, NULL, 257, 'Santa Cruz do Arari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.989048', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (258, NULL, 258, 'Santa Isabel do Para', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.990198', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (259, NULL, 259, 'Santa Luzia do Para', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.991128', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (260, NULL, 260, 'Santa Maria das Barreiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.991911', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (261, NULL, 261, 'Santa Maria do Para', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.992886', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (262, NULL, 262, 'Santana do Araguaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.993845', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (263, NULL, 263, 'Santarem', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.994763', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (264, NULL, 264, 'Santarem Novo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.995664', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (265, NULL, 265, 'Santo Antonio do Taua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.996463', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (266, NULL, 266, 'Sao Caetano de Odivelas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.997262', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (267, NULL, 267, 'Sao Domingos do Araguaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.998092', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (268, NULL, 268, 'Sao Domingos do Capim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.999037', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (269, NULL, 269, 'Sao Felix do Xingu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:33.999952', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (270, NULL, 270, 'Sao Francisco do Para', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.001019', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (271, NULL, 271, 'Sao Geraldo do Araguaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.001861', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (272, NULL, 272, 'Sao Joao da Ponta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.002762', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (273, NULL, 273, 'Sao Joao de Pirabas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.003681', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (274, NULL, 274, 'Sao Joao do Araguaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.004606', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (275, NULL, 275, 'Sao Miguel do Guama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.005566', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (276, NULL, 276, 'Sao Sebastiao da Boa Vista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.006395', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (277, NULL, 277, 'Sapucaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.007271', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (278, NULL, 278, 'Senador Jose Porfirio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.008163', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (279, NULL, 279, 'Soure', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.009091', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (280, NULL, 280, 'Tailandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.010067', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (281, NULL, 281, 'Terra Alta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.01103', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (282, NULL, 282, 'Terra Santa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.012083', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (283, NULL, 283, 'Tome-acu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.012862', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (284, NULL, 284, 'Tracuateua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.020208', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (285, NULL, 285, 'Trairao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.021367', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (286, NULL, 286, 'Tucuma', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.022234', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (287, NULL, 287, 'Tucurui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.023243', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (288, NULL, 288, 'Ulianopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.024129', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (289, NULL, 289, 'Uruara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.024966', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (290, NULL, 290, 'Vigia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.025883', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (291, NULL, 291, 'Viseu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.026802', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (292, NULL, 292, 'Vitoria do Xingu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.027745', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (293, NULL, 293, 'Xinguara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.028653', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (294, NULL, 294, 'Amapa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.029605', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (295, NULL, 295, 'Calcoene', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.030519', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (296, NULL, 296, 'Cutias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.031457', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (297, NULL, 297, 'Ferreira Gomes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.032313', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (298, NULL, 298, 'Itaubal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.033162', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (299, NULL, 299, 'Laranjal do Jari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.034147', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (300, NULL, 300, 'Macapa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.035017', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (301, NULL, 301, 'Mazagao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.036028', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (302, NULL, 302, 'Oiapoque', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.036905', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (303, NULL, 303, 'Pedra Branca do Amapari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.037751', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (304, NULL, 304, 'Porto Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.038704', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (305, NULL, 305, 'Pracuuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.039594', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (306, NULL, 306, 'Santana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.040511', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (307, NULL, 307, 'Serra do Navio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.041419', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (308, NULL, 308, 'Tartarugalzinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.042303', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (309, NULL, 309, 'Vitoria do Jari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.043135', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (310, NULL, 310, 'Abreulandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.044063', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (311, NULL, 311, 'Aguiarnopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.045079', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (312, NULL, 312, 'Alianca do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.04621', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (313, NULL, 313, 'Almas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.047192', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (314, NULL, 314, 'Alvorada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.048146', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (315, NULL, 315, 'Ananas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.049117', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (316, NULL, 316, 'Angico', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.050076', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (317, NULL, 317, 'Aparecida do Rio Negro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.050987', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (318, NULL, 318, 'Aragominas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.051903', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (319, NULL, 319, 'Araguacema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.052846', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (320, NULL, 320, 'Araguacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.053962', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (321, NULL, 321, 'Araguaina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.061617', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (322, NULL, 322, 'Araguana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.062755', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (323, NULL, 323, 'Araguatins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.063685', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (324, NULL, 324, 'Arapoema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.064569', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (325, NULL, 325, 'Arraias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.06559', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (326, NULL, 326, 'Augustinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.066518', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (327, NULL, 327, 'Aurora do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.067488', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (328, NULL, 328, 'Axixa do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.06855', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (329, NULL, 329, 'Babaculandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.069459', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (330, NULL, 330, 'Bandeirantes do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.070302', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (331, NULL, 331, 'Barra do Ouro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.071172', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (332, NULL, 332, 'Barrolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.072056', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (333, NULL, 333, 'Bernardo Sayao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.072885', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (334, NULL, 334, 'Bom Jesus do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.073818', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (335, NULL, 335, 'Brasilandia do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.074694', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (336, NULL, 336, 'Brejinho de Nazare', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.075521', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (337, NULL, 337, 'Buriti do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.076484', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (338, NULL, 338, 'Cachoeirinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.077361', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (339, NULL, 339, 'Campos Lindos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.078201', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (340, NULL, 340, 'Cariri do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.079159', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (341, NULL, 341, 'Carmolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.079958', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (342, NULL, 342, 'Carrasco Bonito', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.081026', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (343, NULL, 343, 'Caseara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.082012', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (344, NULL, 344, 'Centenario', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.082934', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (345, NULL, 345, 'Chapada da Natividade', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.083733', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (346, NULL, 346, 'Chapada de Areia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.084657', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (347, NULL, 347, 'Colinas do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.085702', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (348, NULL, 348, 'Colmeia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.086822', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (349, NULL, 349, 'Combinado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.087767', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (350, NULL, 350, 'Conceicao do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.088722', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (351, NULL, 351, 'Couto de Magalhaes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.089684', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (352, NULL, 352, 'Cristalandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.090779', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (353, NULL, 353, 'Crixas do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.091635', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (354, NULL, 354, 'Darcinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.092435', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (355, NULL, 355, 'Dianopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.093325', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (356, NULL, 356, 'Divinopolis do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.094239', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (357, NULL, 357, 'Dois Irmaos do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.09535', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (358, NULL, 358, 'Duere', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.102276', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (359, NULL, 359, 'Esperantina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.103367', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (360, NULL, 360, 'Fatima', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.104253', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (361, NULL, 361, 'Figueiropolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.105111', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (362, NULL, 362, 'Filadelfia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.106031', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (363, NULL, 363, 'Formoso do Araguaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.106844', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (364, NULL, 364, 'Fortaleza do Tabocao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.107791', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (365, NULL, 365, 'Goianorte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.108687', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (366, NULL, 366, 'Goiatins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.10958', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (367, NULL, 367, 'Guarai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.110381', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (368, NULL, 368, 'Gurupi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.111293', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (369, NULL, 369, 'Ipueiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.112298', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (370, NULL, 370, 'Itacaja', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.113135', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (371, NULL, 371, 'Itaguatins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.113912', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (372, NULL, 372, 'Itapiratins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.1149', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (373, NULL, 373, 'Itapora do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.11572', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (374, NULL, 374, 'Jau do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.116488', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (375, NULL, 375, 'Juarina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.117396', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (376, NULL, 376, 'Lagoa da Confusao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.11813', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (377, NULL, 377, 'Lagoa do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.118825', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (378, NULL, 378, 'Lajeado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.119873', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (379, NULL, 379, 'Lavandeira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.120739', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (380, NULL, 380, 'Lizarda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.121597', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (381, NULL, 381, 'Luzinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.122538', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (382, NULL, 382, 'Marianopolis do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.123445', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (383, NULL, 383, 'Mateiros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.124297', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (384, NULL, 384, 'Maurilandia do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.125143', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (385, NULL, 385, 'Miracema do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.125927', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (386, NULL, 386, 'Miranorte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.126827', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (387, NULL, 387, 'Monte do Carmo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.127756', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (388, NULL, 388, 'Monte Santo do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.128688', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (389, NULL, 389, 'Muricilandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.129605', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (390, NULL, 390, 'Natividade', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.13038', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (391, NULL, 391, 'Nazare', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.131401', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (392, NULL, 392, 'Nova Olinda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.132322', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (393, NULL, 393, 'Nova Rosalandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.133154', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (394, NULL, 394, 'Novo Acordo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.134133', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (395, NULL, 395, 'Novo Alegre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.135242', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (396, NULL, 396, 'Novo Jardim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.13607', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (397, NULL, 397, 'Oliveira de Fatima', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.143376', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (398, NULL, 398, 'Palmas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.144446', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (399, NULL, 399, 'Palmeirante', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.145386', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (400, NULL, 400, 'Palmeiras do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.146676', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (401, NULL, 401, 'Palmeiropolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.14756', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (402, NULL, 402, 'Paraiso do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.148448', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (403, NULL, 403, 'Parana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.149167', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (404, NULL, 404, 'Pau D''arco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.150069', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (405, NULL, 405, 'Pedro Afonso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.151063', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (406, NULL, 406, 'Peixe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.151996', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (407, NULL, 407, 'Pequizeiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.152856', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (408, NULL, 408, 'Pindorama do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.153748', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (409, NULL, 409, 'Piraque', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.154606', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (410, NULL, 410, 'Pium', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.155474', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (411, NULL, 411, 'Ponte Alta do Bom Jesus', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.156408', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (412, NULL, 412, 'Ponte Alta do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.157673', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (413, NULL, 413, 'Porto Alegre do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.158647', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (414, NULL, 414, 'Porto Nacional', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.159639', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (415, NULL, 415, 'Praia Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.160437', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (416, NULL, 416, 'Presidente Kennedy', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.16134', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (417, NULL, 417, 'Pugmil', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.16224', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (418, NULL, 418, 'Recursolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.163175', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (419, NULL, 419, 'Riachinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.164096', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (420, NULL, 420, 'Rio da Conceicao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.164921', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (421, NULL, 421, 'Rio dos Bois', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.165967', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (422, NULL, 422, 'Rio Sono', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.166949', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (423, NULL, 423, 'Sampaio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.167811', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (424, NULL, 424, 'Sandolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.168809', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (425, NULL, 425, 'Santa Fe do Araguaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.169817', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (426, NULL, 426, 'Santa Maria do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.170766', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (427, NULL, 427, 'Santa Rita do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.171677', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (428, NULL, 428, 'Santa Rosa do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.172572', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (429, NULL, 429, 'Santa Tereza do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.173518', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (430, NULL, 430, 'Santa Terezinha do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.174352', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (431, NULL, 431, 'Sao Bento do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.17523', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (432, NULL, 432, 'Sao Felix do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.176102', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (433, NULL, 433, 'Sao Miguel do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.177106', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (434, NULL, 434, 'Sao Salvador do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.18496', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (435, NULL, 435, 'Sao Sebastiao do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.186102', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (436, NULL, 436, 'Sao Valerio da Natividade', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.187014', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (437, NULL, 437, 'Silvanopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.187777', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (438, NULL, 438, 'Sitio Novo do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.188758', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (439, NULL, 439, 'Sucupira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.189661', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (440, NULL, 440, 'Taguatinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.190463', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (441, NULL, 441, 'Taipas do Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.191273', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (442, NULL, 442, 'Talisma', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.192128', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (443, NULL, 443, 'Tocantinia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.193041', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (444, NULL, 444, 'Tocantinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.19396', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (445, NULL, 445, 'Tupirama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.194937', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (446, NULL, 446, 'Tupiratins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.195867', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (447, NULL, 447, 'Wanderlandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.196689', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (448, NULL, 448, 'Xambioa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.197644', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (449, NULL, 449, 'Acailandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.198538', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (450, NULL, 450, 'Afonso Cunha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.199462', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (451, NULL, 451, 'Agua Doce do Maranhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.200279', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (452, NULL, 452, 'Alcantara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.201164', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (453, NULL, 453, 'Aldeias Altas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.202176', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (454, NULL, 454, 'Altamira do Maranhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.203261', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (455, NULL, 455, 'Alto Alegre do Maranhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.204215', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (456, NULL, 456, 'Alto Alegre do Pindare', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.205089', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (457, NULL, 457, 'Alto Parnaiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.206158', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (458, NULL, 458, 'Amapa do Maranhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.20716', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (459, NULL, 459, 'Amarante do Maranhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.208081', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (460, NULL, 460, 'Anajatuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.208976', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (461, NULL, 461, 'Anapurus', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.209855', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (462, NULL, 462, 'Apicum-acu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.210782', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (463, NULL, 463, 'Araguana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.211696', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (464, NULL, 464, 'Araioses', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.212717', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (465, NULL, 465, 'Arame', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.21353', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (466, NULL, 466, 'Arari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.214388', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (467, NULL, 467, 'Axixa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.215297', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (468, NULL, 468, 'Bacabal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.21624', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (469, NULL, 469, 'Bacabeira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.217163', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (470, NULL, 470, 'Bacuri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.218068', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (471, NULL, 471, 'Bacurituba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.218906', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (472, NULL, 472, 'Balsas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.226511', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (473, NULL, 473, 'Barao de Grajau', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.227641', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (474, NULL, 474, 'Barra do Corda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.228529', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (475, NULL, 475, 'Barreirinhas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.22946', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (476, NULL, 476, 'Bela Vista do Maranhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.230349', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (477, NULL, 477, 'Belagua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.231267', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (478, NULL, 478, 'Benedito Leite', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.232219', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (479, NULL, 479, 'Bequimao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.233065', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (480, NULL, 480, 'Bernardo do Mearim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.23398', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (481, NULL, 481, 'Boa Vista do Gurupi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.234892', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (482, NULL, 482, 'Bom Jardim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.235799', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (483, NULL, 483, 'Bom Jesus das Selvas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.236707', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (484, NULL, 484, 'Bom Lugar', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.237544', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (485, NULL, 485, 'Brejo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.238393', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (486, NULL, 486, 'Brejo de Areia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.23924', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (487, NULL, 487, 'Buriti', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.240212', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (488, NULL, 488, 'Buriti Bravo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.24103', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (489, NULL, 489, 'Buriticupu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.241945', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (490, NULL, 490, 'Buritirana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.242839', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (491, NULL, 491, 'Cachoeira Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.243731', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (492, NULL, 492, 'Cajapio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.244628', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (493, NULL, 493, 'Cajari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.245516', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (494, NULL, 494, 'Campestre do Maranhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.246481', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (495, NULL, 495, 'Candido Mendes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.247331', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (496, NULL, 496, 'Cantanhede', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.248243', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (497, NULL, 497, 'Capinzal do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.249166', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (498, NULL, 498, 'Carolina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.250112', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (499, NULL, 499, 'Carutapera', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.251005', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (500, NULL, 500, 'Caxias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.251858', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (501, NULL, 501, 'Cedral', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.252814', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (502, NULL, 502, 'Central do Maranhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.253724', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (503, NULL, 503, 'Centro do Guilherme', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.254702', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (504, NULL, 504, 'Centro Novo do Maranhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.255559', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (505, NULL, 505, 'Chapadinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.256472', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (506, NULL, 506, 'Cidelandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.257495', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (507, NULL, 507, 'Codo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.258325', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (508, NULL, 508, 'Coelho Neto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.259107', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (509, NULL, 509, 'Colinas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.259977', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (510, NULL, 510, 'Conceicao do Lago-acu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.267016', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (511, NULL, 511, 'Coroata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.268195', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (512, NULL, 512, 'Cururupu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.269164', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (513, NULL, 513, 'Davinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.270095', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (514, NULL, 514, 'Dom Pedro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.271002', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (515, NULL, 515, 'Duque Bacelar', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.271929', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (516, NULL, 516, 'Esperantinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.27286', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (517, NULL, 517, 'Estreito', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.273795', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (518, NULL, 518, 'Feira Nova do Maranhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.274839', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (519, NULL, 519, 'Fernando Falcao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.275832', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (520, NULL, 520, 'Formosa da Serra Negra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.276788', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (521, NULL, 521, 'Fortaleza dos Nogueiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.27762', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (522, NULL, 522, 'Fortuna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.278459', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (523, NULL, 523, 'Godofredo Viana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.279542', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (524, NULL, 524, 'Goncalves Dias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.280371', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (525, NULL, 525, 'Governador Archer', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.281277', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (526, NULL, 526, 'Governador Edison Lobao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.282223', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (527, NULL, 527, 'Governador Eugenio Barros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.283125', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (528, NULL, 528, 'Governador Luiz Rocha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.283974', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (529, NULL, 529, 'Governador Newton Bello', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.284782', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (530, NULL, 530, 'Governador Nunes Freire', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.285675', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (531, NULL, 531, 'Graca Aranha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.286846', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (532, NULL, 532, 'Grajau', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.287677', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (533, NULL, 533, 'Guimaraes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.288667', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (534, NULL, 534, 'Humberto de Campos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.289578', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (535, NULL, 535, 'Icatu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.290557', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (536, NULL, 536, 'Igarape do Meio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.291496', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (537, NULL, 537, 'Igarape Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.2924', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (538, NULL, 538, 'Imperatriz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.293262', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (539, NULL, 539, 'Itaipava do Grajau', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.294094', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (540, NULL, 540, 'Itapecuru Mirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.295124', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (541, NULL, 541, 'Itinga do Maranhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.296028', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (542, NULL, 542, 'Jatoba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.296978', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (543, NULL, 543, 'Jenipapo dos Vieiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.29789', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (544, NULL, 544, 'Joao Lisboa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.298837', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (545, NULL, 545, 'Joselandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.299813', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (546, NULL, 546, 'Junco do Maranhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.300907', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (547, NULL, 547, 'Lago da Pedra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.302071', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (548, NULL, 548, 'Lago do Junco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.307903', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (549, NULL, 549, 'Lago dos Rodrigues', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.309158', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (550, NULL, 550, 'Lago Verde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.310138', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (551, NULL, 551, 'Lagoa do Mato', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.311156', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (552, NULL, 552, 'Lagoa Grande do Maranhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.312133', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (553, NULL, 553, 'Lajeado Novo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.313052', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (554, NULL, 554, 'Lima Campos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.313916', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (555, NULL, 555, 'Loreto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.31479', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (556, NULL, 556, 'Luis Domingues', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.315685', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (557, NULL, 557, 'Magalhaes de Almeida', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.316626', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (558, NULL, 558, 'Maracacume', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.317519', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (559, NULL, 559, 'Maraja do Sena', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.318381', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (560, NULL, 560, 'Maranhaozinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.319219', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (561, NULL, 561, 'Mata Roma', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.320109', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (562, NULL, 562, 'Matinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.320966', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (563, NULL, 563, 'Matoes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.321907', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (564, NULL, 564, 'Matoes do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.32282', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (565, NULL, 565, 'Milagres do Maranhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.32375', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (566, NULL, 566, 'Mirador', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.324883', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (567, NULL, 567, 'Miranda do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.325801', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (568, NULL, 568, 'Mirinzal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.326849', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (569, NULL, 569, 'Moncao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.327637', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (570, NULL, 570, 'Montes Altos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.328569', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (571, NULL, 571, 'Morros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.329367', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (572, NULL, 572, 'Nina Rodrigues', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.330692', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (573, NULL, 573, 'Nova Colinas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.332095', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (574, NULL, 574, 'Nova Iorque', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.333022', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (575, NULL, 575, 'Nova Olinda do Maranhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.333932', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (576, NULL, 576, 'Olho D''agua das Cunhas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.334867', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (577, NULL, 577, 'Olinda Nova do Maranhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.335779', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (578, NULL, 578, 'Paco do Lumiar', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.33655', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (579, NULL, 579, 'Palmeirandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.337518', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (580, NULL, 580, 'Paraibano', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.338445', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (581, NULL, 581, 'Parnarama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.340223', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (582, NULL, 582, 'Passagem Franca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.341359', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (583, NULL, 583, 'Pastos Bons', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.342182', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (584, NULL, 584, 'Paulino Neves', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.352812', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (585, NULL, 585, 'Paulo Ramos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.353828', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (586, NULL, 586, 'Pedreiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.354689', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (587, NULL, 587, 'Pedro do Rosario', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.355564', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (588, NULL, 588, 'Penalva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.356425', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (589, NULL, 589, 'Peri Mirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.357303', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (590, NULL, 590, 'Peritoro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.358268', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (591, NULL, 591, 'Pindare Mirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.359225', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (592, NULL, 592, 'Pinheiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.360105', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (593, NULL, 593, 'Pio Xii', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.361003', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (594, NULL, 594, 'Pirapemas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.361829', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (595, NULL, 595, 'Pocao de Pedras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.362741', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (596, NULL, 596, 'Porto Franco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.363626', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (597, NULL, 597, 'Porto Rico do Maranhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.364534', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (598, NULL, 598, 'Presidente Dutra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.365368', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (599, NULL, 599, 'Presidente Juscelino', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.366202', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (600, NULL, 600, 'Presidente Medici', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.367133', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (601, NULL, 601, 'Presidente Sarney', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.368047', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (602, NULL, 602, 'Presidente Vargas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.368937', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (603, NULL, 603, 'Primeira Cruz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.369823', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (604, NULL, 604, 'Raposa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.370771', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (605, NULL, 605, 'Riachao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.371655', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (606, NULL, 606, 'Ribamar Fiquene', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.372579', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (607, NULL, 607, 'Rosario', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.373524', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (608, NULL, 608, 'Sambaiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.374298', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (609, NULL, 609, 'Santa Filomena do Maranhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.375097', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (610, NULL, 610, 'Santa Helena', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.376', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (611, NULL, 611, 'Santa Ines', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.376926', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (612, NULL, 612, 'Santa Luzia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.37791', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (613, NULL, 613, 'Santa Luzia do Parua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.378894', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (614, NULL, 614, 'Santa Quiteria do Maranhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.379769', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (615, NULL, 615, 'Santa Rita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.380996', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (616, NULL, 616, 'Santana do Maranhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.381789', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (617, NULL, 617, 'Santo Amaro do Maranhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.382757', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (618, NULL, 618, 'Santo Antonio dos Lopes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.38365', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (619, NULL, 619, 'Sao Benedito do Rio Preto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.384567', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (620, NULL, 620, 'Sao Bento', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.385444', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (621, NULL, 621, 'Sao Bernardo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.386272', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (622, NULL, 622, 'Sao Domingos do Azeitao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.388381', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (623, NULL, 623, 'Sao Domingos do Maranhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.395118', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (624, NULL, 624, 'Sao Felix de Balsas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.39616', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (625, NULL, 625, 'Sao Francisco do Brejao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.397025', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (626, NULL, 626, 'Sao Francisco do Maranhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.398044', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (627, NULL, 627, 'Sao Joao Batista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.39892', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (628, NULL, 628, 'Sao Joao do Caru', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.399745', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (629, NULL, 629, 'Sao Joao do Paraiso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.400816', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (630, NULL, 630, 'Sao Joao do Soter', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.401759', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (631, NULL, 631, 'Sao Joao dos Patos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.402956', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (632, NULL, 632, 'Sao Jose de Ribamar', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.403809', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (633, NULL, 633, 'Sao Jose dos Basilios', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.404643', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (634, NULL, 634, 'Sao Luis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.405647', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (635, NULL, 635, 'Sao Luis Gonzaga do Maranhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.40646', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (636, NULL, 636, 'Sao Mateus do Maranhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.407324', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (637, NULL, 637, 'Sao Pedro da Agua Branca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.408245', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (638, NULL, 638, 'Sao Pedro dos Crentes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.409364', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (639, NULL, 639, 'Sao Raimundo das Mangabeiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.410289', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (640, NULL, 640, 'Sao Raimundo do Doca Bezerra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.411219', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (641, NULL, 641, 'Sao Roberto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.412187', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (642, NULL, 642, 'Sao Vicente Ferrer', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.413132', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (643, NULL, 643, 'Satubinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.414213', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (644, NULL, 644, 'Senador Alexandre Costa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.41502', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (645, NULL, 645, 'Senador La Rocque', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.416003', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (646, NULL, 646, 'Serrano do Maranhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.416907', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (647, NULL, 647, 'Sitio Novo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.417788', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (648, NULL, 648, 'Sucupira do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.418657', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (649, NULL, 649, 'Sucupira do Riachao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.419524', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (650, NULL, 650, 'Tasso Fragoso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.420459', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (651, NULL, 651, 'Timbiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.421346', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (652, NULL, 652, 'Timon', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.422227', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (653, NULL, 653, 'Trizidela do Vale', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.4231', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (654, NULL, 654, 'Tufilandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.424033', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (655, NULL, 655, 'Tuntum', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.425218', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (656, NULL, 656, 'Turiacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.426154', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (657, NULL, 657, 'Turilandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.426947', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (658, NULL, 658, 'Tutoia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.427726', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (659, NULL, 659, 'Urbano Santos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.428556', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (660, NULL, 660, 'Vargem Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.435067', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (661, NULL, 661, 'Viana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.436627', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (662, NULL, 662, 'Vila Nova dos Martirios', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.43748', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (663, NULL, 663, 'Vitoria do Mearim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.438392', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (664, NULL, 664, 'Vitorino Freire', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.439218', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (665, NULL, 665, 'Ze Doca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.440175', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (666, NULL, 666, 'Acaua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.441086', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (667, NULL, 667, 'Agricolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.44202', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (668, NULL, 668, 'Agua Branca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.443259', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (669, NULL, 669, 'Alagoinha do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.444215', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (670, NULL, 670, 'Alegrete do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.445155', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (671, NULL, 671, 'Alto Longa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.446035', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (672, NULL, 672, 'Altos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.446996', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (673, NULL, 673, 'Alvorada do Gurgueia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.447826', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (674, NULL, 674, 'Amarante', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.448565', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (675, NULL, 675, 'Angical do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.449534', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (676, NULL, 676, 'Anisio de Abreu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.450473', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (677, NULL, 677, 'Antonio Almeida', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.451325', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (678, NULL, 678, 'Aroazes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.452206', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (679, NULL, 679, 'Aroeira do Itaim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.453076', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (680, NULL, 680, 'Arraial', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.453937', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (681, NULL, 681, 'Assuncao do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.454994', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (682, NULL, 682, 'Avelino Lopes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.455933', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (683, NULL, 683, 'Baixa Grande do Ribeiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.456842', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (684, NULL, 684, 'Barra D Alcantara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.457797', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (685, NULL, 685, 'Barras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.458843', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (686, NULL, 686, 'Barreiras do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.460085', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (687, NULL, 687, 'Barro Duro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.461037', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (688, NULL, 688, 'Batalha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.461931', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (689, NULL, 689, 'Bela Vista do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.462988', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (690, NULL, 690, 'Belem do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.463815', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (691, NULL, 691, 'Beneditinos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.464727', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (692, NULL, 692, 'Bertolinia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.465651', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (693, NULL, 693, 'Betania do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.466532', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (694, NULL, 694, 'Boa Hora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.467333', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (695, NULL, 695, 'Bocaina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.468202', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (696, NULL, 696, 'Bom Jesus', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.469091', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (697, NULL, 697, 'Bom Principio do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.476209', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (698, NULL, 698, 'Bonfim do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.477453', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (699, NULL, 699, 'Boqueirao do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.478284', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (700, NULL, 700, 'Brasileira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.479141', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (701, NULL, 701, 'Brejo do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.479943', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (702, NULL, 702, 'Buriti dos Lopes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.481156', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (703, NULL, 703, 'Buriti dos Montes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.481975', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (704, NULL, 704, 'Cabeceiras do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.482873', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (705, NULL, 705, 'Cajazeiras do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.483761', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (706, NULL, 706, 'Cajueiro da Praia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.484708', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (707, NULL, 707, 'Caldeirao Grande do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.485653', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (708, NULL, 708, 'Campinas do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.4866', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (709, NULL, 709, 'Campo Alegre do Fidalgo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.487558', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (710, NULL, 710, 'Campo Grande do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.488623', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (711, NULL, 711, 'Campo Largo do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.489554', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (712, NULL, 712, 'Campo Maior', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.490426', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (713, NULL, 713, 'Canavieira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.491345', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (714, NULL, 714, 'Canto do Buriti', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.492473', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (715, NULL, 715, 'Capitao de Campos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.493449', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (716, NULL, 716, 'Capitao Gervasio Oliveira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.49426', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (717, NULL, 717, 'Caracol', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.495011', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (718, NULL, 718, 'Caraubas do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.495894', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (719, NULL, 719, 'Caridade do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.496798', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (720, NULL, 720, 'Castelo do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.49769', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (721, NULL, 721, 'Caxingo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.498551', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (722, NULL, 722, 'Cocal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.49945', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (723, NULL, 723, 'Cocal de Telha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.500365', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (724, NULL, 724, 'Cocal dos Alves', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.501178', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (725, NULL, 725, 'Coivaras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.50203', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (726, NULL, 726, 'Colonia do Gurgueia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.502948', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (727, NULL, 727, 'Colonia do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.503724', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (728, NULL, 728, 'Conceicao do Caninde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.504605', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (729, NULL, 729, 'Coronel Jose Dias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.50551', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (730, NULL, 730, 'Corrente', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.506368', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (731, NULL, 731, 'Cristalandia do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.507245', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (732, NULL, 732, 'Cristino Castro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.508161', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (733, NULL, 733, 'Curimata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.509093', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (734, NULL, 734, 'Currais', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.509915', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (735, NULL, 735, 'Curral Novo do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.516478', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (736, NULL, 736, 'Curralinhos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.517649', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (737, NULL, 737, 'Demerval Lobao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.518747', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (738, NULL, 738, 'Dirceu Arcoverde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.519566', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (739, NULL, 739, 'Dom Expedito Lopes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.520463', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (740, NULL, 740, 'Dom Inocencio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.521277', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (741, NULL, 741, 'Domingos Mourao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.522', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (742, NULL, 742, 'Elesbao Veloso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.522894', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (743, NULL, 743, 'Eliseu Martins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.52379', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (744, NULL, 744, 'Esperantina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.524652', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (745, NULL, 745, 'Fartura do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.526063', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (746, NULL, 746, 'Flores do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.527005', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (747, NULL, 747, 'Floresta do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.527865', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (748, NULL, 748, 'Floriano', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.528733', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (749, NULL, 749, 'Francinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.529749', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (750, NULL, 750, 'Francisco Ayres', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.530678', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (751, NULL, 751, 'Francisco Macedo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.531546', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (752, NULL, 752, 'Francisco Santos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.532468', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (753, NULL, 753, 'Fronteiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.533279', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (754, NULL, 754, 'Geminiano', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.534092', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (755, NULL, 755, 'Gilbues', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.535027', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (756, NULL, 756, 'Guadalupe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.535945', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (757, NULL, 757, 'Guaribas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.536987', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (758, NULL, 758, 'Hugo Napoleao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.53787', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (759, NULL, 759, 'Ilha Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.538744', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (760, NULL, 760, 'Inhuma', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.539664', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (761, NULL, 761, 'Ipiranga do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.540631', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (762, NULL, 762, 'Isaias Coelho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.541589', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (763, NULL, 763, 'Itainopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.54226', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (764, NULL, 764, 'Itaueira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.543208', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (765, NULL, 765, 'Jacobina do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.544013', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (766, NULL, 766, 'Jaicos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.544932', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (767, NULL, 767, 'Jardim do Mulato', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.545843', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (768, NULL, 768, 'Jatoba do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.546727', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (769, NULL, 769, 'Jerumenha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.547582', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (770, NULL, 770, 'Joao Costa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.548411', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (771, NULL, 771, 'Joaquim Pires', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.549224', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (772, NULL, 772, 'Joca Marques', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.550172', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (773, NULL, 773, 'Jose de Freitas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.557', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (774, NULL, 774, 'Juazeiro do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.558345', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (775, NULL, 775, 'Julio Borges', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.559238', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (776, NULL, 776, 'Jurema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.560161', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (777, NULL, 777, 'Lagoa Alegre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.561061', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (778, NULL, 778, 'Lagoa de Sao Francisco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.562032', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (779, NULL, 779, 'Lagoa do Barro do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.56292', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (780, NULL, 780, 'Lagoa do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.56385', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (781, NULL, 781, 'Lagoa do Sitio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.56476', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (782, NULL, 782, 'Lagoinha do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.565646', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (783, NULL, 783, 'Landri Sales', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.566526', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (784, NULL, 784, 'Luis Correia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.567389', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (785, NULL, 785, 'Luzilandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.568333', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (786, NULL, 786, 'Madeiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.569282', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (787, NULL, 787, 'Manoel Emidio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.57028', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (788, NULL, 788, 'Marcolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.571109', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (789, NULL, 789, 'Marcos Parente', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.571924', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (790, NULL, 790, 'Massape do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.572792', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (791, NULL, 791, 'Matias Olimpio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.573727', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (792, NULL, 792, 'Miguel Alves', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.574699', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (793, NULL, 793, 'Miguel Leao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.575592', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (794, NULL, 794, 'Milton Brandao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.576731', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (795, NULL, 795, 'Monsenhor Gil', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.577659', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (796, NULL, 796, 'Monsenhor Hipolito', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.578489', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (797, NULL, 797, 'Monte Alegre do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.579329', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (798, NULL, 798, 'Morro Cabeca No Tempo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.580308', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (799, NULL, 799, 'Morro do Chapeu do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.581572', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (800, NULL, 800, 'Murici dos Portelas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.582369', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (801, NULL, 801, 'Nazare do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.583261', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (802, NULL, 802, 'Nazária', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.584181', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (803, NULL, 803, 'Nossa Senhora de Nazare', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.585035', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (804, NULL, 804, 'Nossa Senhora dos Remedios', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.585913', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (805, NULL, 805, 'Nova Santa Rita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.58681', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (806, NULL, 806, 'Novo Oriente do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.587703', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (807, NULL, 807, 'Novo Santo Antonio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.588561', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (808, NULL, 808, 'Oeiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.58949', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (809, NULL, 809, 'Olho D Agua do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.590304', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (810, NULL, 810, 'Padre Marcos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.591217', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (811, NULL, 811, 'Paes Landim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.592557', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (812, NULL, 812, 'Pajeu do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.598809', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (813, NULL, 813, 'Palmeira do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.599731', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (814, NULL, 814, 'Palmeirais', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.600651', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (815, NULL, 815, 'Paqueta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.601586', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (816, NULL, 816, 'Parnagua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.603105', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (817, NULL, 817, 'Parnaiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.603974', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (818, NULL, 818, 'Passagem Franca do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.604851', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (819, NULL, 819, 'Patos do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.605756', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (820, NULL, 820, 'Pau D''arco do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.606727', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (821, NULL, 821, 'Paulistana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.607612', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (822, NULL, 822, 'Pavussu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.608647', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (823, NULL, 823, 'Pedro Ii', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.609674', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (824, NULL, 824, 'Pedro Laurentino', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.610587', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (825, NULL, 825, 'Picos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.611502', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (826, NULL, 826, 'Pimenteiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.61237', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (827, NULL, 827, 'Pio Ix', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.61325', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (828, NULL, 828, 'Piracuruca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.6142', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (829, NULL, 829, 'Piripiri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.615071', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (830, NULL, 830, 'Porto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.616029', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (831, NULL, 831, 'Porto Alegre do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.617018', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (832, NULL, 832, 'Prata do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.617877', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (833, NULL, 833, 'Queimada Nova', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.618689', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (834, NULL, 834, 'Redencao do Gurgueia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.619662', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (835, NULL, 835, 'Regeneracao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.620619', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (836, NULL, 836, 'Riacho Frio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.621548', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (837, NULL, 837, 'Ribeira do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.62253', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (838, NULL, 838, 'Ribeiro Goncalves', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.623518', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (839, NULL, 839, 'Rio Grande do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.624477', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (840, NULL, 840, 'Santa Cruz do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.625541', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (841, NULL, 841, 'Santa Cruz dos Milagres', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.626406', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (842, NULL, 842, 'Santa Filomena', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.627271', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (843, NULL, 843, 'Santa Luz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.628246', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (844, NULL, 844, 'Santa Rosa do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.629172', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (845, NULL, 845, 'Santana do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.630097', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (846, NULL, 846, 'Santo Antonio de Lisboa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.630983', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (847, NULL, 847, 'Santo Antonio dos Milagres', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.631953', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (848, NULL, 848, 'Santo Inacio do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.638737', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (849, NULL, 849, 'Sao Braz do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.640018', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (850, NULL, 850, 'Sao Felix do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.641003', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (851, NULL, 851, 'Sao Francisco de Assis do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.641974', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (852, NULL, 852, 'Sao Francisco do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.642905', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (853, NULL, 853, 'Sao Goncalo do Gurgueia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.643859', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (854, NULL, 854, 'Sao Goncalo do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.644778', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (855, NULL, 855, 'Sao Joao da Canabrava', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.645729', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (856, NULL, 856, 'Sao Joao da Fronteira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.646746', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (857, NULL, 857, 'Sao Joao da Serra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.64776', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (858, NULL, 858, 'Sao Joao da Varjota', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.648584', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (859, NULL, 859, 'Sao Joao do Arraial', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.649445', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (860, NULL, 860, 'Sao Joao do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.65029', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (861, NULL, 861, 'Sao Jose do Divino', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.65123', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (862, NULL, 862, 'Sao Jose do Peixe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.652159', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (863, NULL, 863, 'Sao Jose do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.653052', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (864, NULL, 864, 'Sao Juliao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.654041', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (865, NULL, 865, 'Sao Lourenco do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.654978', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (866, NULL, 866, 'Sao Luis do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.655997', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (867, NULL, 867, 'Sao Miguel da Baixa Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.656848', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (868, NULL, 868, 'Sao Miguel do Fidalgo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.657708', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (869, NULL, 869, 'Sao Miguel do Tapuio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.658591', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (870, NULL, 870, 'Sao Pedro do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.659708', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (871, NULL, 871, 'Sao Raimundo Nonato', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.660725', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (872, NULL, 872, 'Sebastiao Barros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.661633', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (873, NULL, 873, 'Sebastiao Leal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.662743', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (874, NULL, 874, 'Sigefredo Pacheco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.663614', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (875, NULL, 875, 'Simoes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.664475', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (876, NULL, 876, 'Simplicio Mendes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.665361', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (877, NULL, 877, 'Socorro do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.666288', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (878, NULL, 878, 'Sussuapara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.667165', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (879, NULL, 879, 'Tamboril do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.668103', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (880, NULL, 880, 'Tanque do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.669016', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (881, NULL, 881, 'Teresina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.670074', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (882, NULL, 882, 'Uniao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.670865', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (883, NULL, 883, 'Urucui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.671796', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (884, NULL, 884, 'Valenca do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.67261', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (885, NULL, 885, 'Varzea Branca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.679609', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (886, NULL, 886, 'Varzea Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.680844', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (887, NULL, 887, 'Vera Mendes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.681873', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (888, NULL, 888, 'Vila Nova do Piaui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.68279', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (889, NULL, 889, 'Wall Ferraz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.683613', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (890, NULL, 890, 'Abaiara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.684498', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (891, NULL, 891, 'Acarape', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.685459', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (892, NULL, 892, 'Acarau', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.686316', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (893, NULL, 893, 'Acopiara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.687319', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (894, NULL, 894, 'Aiuaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.688458', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (895, NULL, 895, 'Alcantaras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.68946', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (896, NULL, 896, 'Altaneira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.690345', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (897, NULL, 897, 'Alto Santo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.691214', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (898, NULL, 898, 'Amontada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.692091', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (899, NULL, 899, 'Antonina do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.693258', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (900, NULL, 900, 'Apuiares', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.69425', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (901, NULL, 901, 'Aquiraz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.695167', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (902, NULL, 902, 'Aracati', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.69614', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (903, NULL, 903, 'Aracoiaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.69696', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (904, NULL, 904, 'Ararenda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.697861', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (905, NULL, 905, 'Araripe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.698832', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (906, NULL, 906, 'Aratuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.69974', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (907, NULL, 907, 'Arneiroz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.700663', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (908, NULL, 908, 'Assare', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.701591', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (909, NULL, 909, 'Aurora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.702351', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (910, NULL, 910, 'Baixio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.703411', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (911, NULL, 911, 'Banabuiu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.704293', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (912, NULL, 912, 'Barbalha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.705191', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (913, NULL, 913, 'Barreira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.706139', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (914, NULL, 914, 'Barro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.707138', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (915, NULL, 915, 'Barroquinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.708104', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (916, NULL, 916, 'Baturite', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.70905', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (917, NULL, 917, 'Beberibe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.71002', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (918, NULL, 918, 'Bela Cruz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.710898', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (919, NULL, 919, 'Boa Viagem', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.711755', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (920, NULL, 920, 'Brejo Santo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.712556', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (921, NULL, 921, 'Camocim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.713478', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (922, NULL, 922, 'Campos Sales', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.720078', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (923, NULL, 923, 'Caninde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.721176', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (924, NULL, 924, 'Capistrano', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.722137', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (925, NULL, 925, 'Caridade', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.723051', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (926, NULL, 926, 'Carire', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.724031', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (927, NULL, 927, 'Caririacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.725002', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (928, NULL, 928, 'Carius', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.72603', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (929, NULL, 929, 'Carnaubal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.726882', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (930, NULL, 930, 'Cascavel', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.72791', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (931, NULL, 931, 'Catarina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.728846', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (932, NULL, 932, 'Catunda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.72975', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (933, NULL, 933, 'Caucaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.73058', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (934, NULL, 934, 'Cedro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.731508', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (935, NULL, 935, 'Chaval', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.732465', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (936, NULL, 936, 'Choro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.733347', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (937, NULL, 937, 'Chorozinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.734151', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (938, NULL, 938, 'Coreau', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.735038', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (939, NULL, 939, 'Crateus', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.735982', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (940, NULL, 940, 'Crato', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.736982', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (941, NULL, 941, 'Croata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.73788', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (942, NULL, 942, 'Cruz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.738764', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (943, NULL, 943, 'Deputado Irapuan Pinheiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.739701', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (944, NULL, 944, 'Erere', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.740766', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (945, NULL, 945, 'Eusebio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.741714', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (946, NULL, 946, 'Farias Brito', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.742725', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (947, NULL, 947, 'Forquilha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.743617', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (948, NULL, 948, 'Fortaleza', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.744504', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (949, NULL, 949, 'Fortim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.74536', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (950, NULL, 950, 'Frecheirinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.7463', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (951, NULL, 951, 'General Sampaio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.747206', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (952, NULL, 952, 'Graca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.748217', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (953, NULL, 953, 'Granja', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.74904', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (954, NULL, 954, 'Granjeiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.749942', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (955, NULL, 955, 'Groairas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.750947', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (956, NULL, 956, 'Guaiuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.751904', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (957, NULL, 957, 'Guaraciaba do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.752745', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (958, NULL, 958, 'Guaramiranga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.753708', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (959, NULL, 959, 'Hidrolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.760735', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (960, NULL, 960, 'Horizonte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.761924', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (961, NULL, 961, 'Ibaretama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.762867', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (962, NULL, 962, 'Ibiapina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.763788', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (963, NULL, 963, 'Ibicuitinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.764672', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (964, NULL, 964, 'Icapui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.765576', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (965, NULL, 965, 'Ico', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.76682', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (966, NULL, 966, 'Iguatu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.767721', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (967, NULL, 967, 'Independencia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.768666', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (968, NULL, 968, 'Ipaporanga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.769582', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (969, NULL, 969, 'Ipaumirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.770486', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (970, NULL, 970, 'Ipu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.771489', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (971, NULL, 971, 'Ipueiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.772507', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (972, NULL, 972, 'Iracema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.773512', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (973, NULL, 973, 'Iraucuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.774468', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (974, NULL, 974, 'Itaicaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.77543', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (975, NULL, 975, 'Itaitinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.77631', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (976, NULL, 976, 'Itapage', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.777235', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (977, NULL, 977, 'Itapipoca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.778328', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (978, NULL, 978, 'Itapiuna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.779217', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (979, NULL, 979, 'Itarema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.780134', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (980, NULL, 980, 'Itatira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.781004', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (981, NULL, 981, 'Jaguaretama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.781931', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (982, NULL, 982, 'Jaguaribara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.782755', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (983, NULL, 983, 'Jaguaribe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.783553', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (984, NULL, 984, 'Jaguaruana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.784418', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (985, NULL, 985, 'Jardim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.785258', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (986, NULL, 986, 'Jati', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.786168', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (987, NULL, 987, 'Jijoca de Jericoacoara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.787039', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (988, NULL, 988, 'Juazeiro do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.787963', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (989, NULL, 989, 'Jucas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.788883', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (990, NULL, 990, 'Lavras da Mangabeira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.789684', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (991, NULL, 991, 'Limoeiro do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.790614', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (992, NULL, 992, 'Madalena', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.791485', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (993, NULL, 993, 'Maracanau', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.79239', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (994, NULL, 994, 'Maranguape', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.793456', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (995, NULL, 995, 'Marco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.794381', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (996, NULL, 996, 'Martinopole', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.801277', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (997, NULL, 997, 'Massape', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.802543', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (998, NULL, 998, 'Mauriti', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.805558', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (999, NULL, 999, 'Meruoca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.806559', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1000, NULL, 1000, 'Milagres', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.80731', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1001, NULL, 1001, 'Milha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.808353', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1002, NULL, 1002, 'Miraima', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.809236', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1003, NULL, 1003, 'Missao Velha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.810299', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1004, NULL, 1004, 'Mombaca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.811154', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1005, NULL, 1005, 'Monsenhor Tabosa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.81203', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1006, NULL, 1006, 'Morada Nova', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.812903', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1007, NULL, 1007, 'Moraujo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.81377', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1008, NULL, 1008, 'Morrinhos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.814722', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1009, NULL, 1009, 'Mucambo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.815781', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1010, NULL, 1010, 'Mulungu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.816724', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1011, NULL, 1011, 'Nova Olinda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.817636', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1012, NULL, 1012, 'Nova Russas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.81856', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1013, NULL, 1013, 'Novo Oriente', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.819509', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1014, NULL, 1014, 'Ocara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.820449', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1015, NULL, 1015, 'Oros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.821307', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1016, NULL, 1016, 'Pacajus', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.822177', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1017, NULL, 1017, 'Pacatuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.823119', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1018, NULL, 1018, 'Pacoti', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.823944', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1019, NULL, 1019, 'Pacuja', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.824879', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1020, NULL, 1020, 'Palhano', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.825848', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1021, NULL, 1021, 'Palmacia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.826961', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1022, NULL, 1022, 'Paracuru', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.827911', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1023, NULL, 1023, 'Paraipaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.828797', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1024, NULL, 1024, 'Parambu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.829733', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1025, NULL, 1025, 'Paramoti', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.830639', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1026, NULL, 1026, 'Pedra Branca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.831545', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1027, NULL, 1027, 'Penaforte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.832489', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1028, NULL, 1028, 'Pentecoste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.83333', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1029, NULL, 1029, 'Pereiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.834139', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1030, NULL, 1030, 'Pindoretama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.835062', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1031, NULL, 1031, 'Piquet Carneiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.842709', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1032, NULL, 1032, 'Pires Ferreira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.843807', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1033, NULL, 1033, 'Poranga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.844903', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1034, NULL, 1034, 'Porteiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.846084', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1035, NULL, 1035, 'Potengi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.847051', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1036, NULL, 1036, 'Potiretama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.848016', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1037, NULL, 1037, 'Quiterianopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.849214', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1038, NULL, 1038, 'Quixada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.850112', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1039, NULL, 1039, 'Quixelo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.851035', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1040, NULL, 1040, 'Quixeramobim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.851966', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1041, NULL, 1041, 'Quixere', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.852901', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1042, NULL, 1042, 'Redencao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.853907', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1043, NULL, 1043, 'Reriutaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.855028', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1044, NULL, 1044, 'Russas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.85597', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1045, NULL, 1045, 'Saboeiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.856853', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1046, NULL, 1046, 'Salitre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.857981', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1047, NULL, 1047, 'Santa Quiteria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.858908', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1048, NULL, 1048, 'Santana do Acarau', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.85981', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1049, NULL, 1049, 'Santana do Cariri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.860708', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1050, NULL, 1050, 'Sao Benedito', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.861601', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1051, NULL, 1051, 'Sao Goncalo do Amarante', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.862529', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1052, NULL, 1052, 'Sao Joao do Jaguaribe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.863447', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1053, NULL, 1053, 'Sao Luis do Curu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.864358', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1054, NULL, 1054, 'Senador Pompeu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.865343', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1055, NULL, 1055, 'Senador Sa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.866271', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1056, NULL, 1056, 'Sobral', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.86725', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1057, NULL, 1057, 'Solonopole', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.868244', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1058, NULL, 1058, 'Tabuleiro do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.869195', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1059, NULL, 1059, 'Tamboril', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.87011', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1060, NULL, 1060, 'Tarrafas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.871112', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1061, NULL, 1061, 'Taua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.872086', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1062, NULL, 1062, 'Tejucuoca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.873195', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1063, NULL, 1063, 'Tiangua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.874116', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1064, NULL, 1064, 'Trairi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.875052', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1065, NULL, 1065, 'Tururu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.875935', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1066, NULL, 1066, 'Ubajara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.883523', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1067, NULL, 1067, 'Umari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.884695', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1068, NULL, 1068, 'Umirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.885677', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1069, NULL, 1069, 'Uruburetama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.886516', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1070, NULL, 1070, 'Uruoca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.887569', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1071, NULL, 1071, 'Varjota', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.88856', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1072, NULL, 1072, 'Varzea Alegre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.889456', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1073, NULL, 1073, 'Vicosa do Ceara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.890355', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1074, NULL, 1074, 'Acari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.891402', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1075, NULL, 1075, 'Acu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.892249', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1076, NULL, 1076, 'Afonso Bezerra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.893143', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1077, NULL, 1077, 'Agua Nova', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.894078', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1078, NULL, 1078, 'Alexandria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.895039', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1079, NULL, 1079, 'Almino Afonso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.895926', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1080, NULL, 1080, 'Alto do Rodrigues', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.896798', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1081, NULL, 1081, 'Angicos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.897649', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1082, NULL, 1082, 'Antonio Martins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.898468', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1083, NULL, 1083, 'Apodi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.899511', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1084, NULL, 1084, 'Areia Branca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.900457', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1085, NULL, 1085, 'Ares', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.901317', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1086, NULL, 1086, 'Augusto Severo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.902303', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1087, NULL, 1087, 'Baia Formosa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.903218', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1088, NULL, 1088, 'Barauna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.904292', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1089, NULL, 1089, 'Barcelona', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.905211', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1090, NULL, 1090, 'Bento Fernandes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.906199', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1091, NULL, 1091, 'Bodo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.907136', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1092, NULL, 1092, 'Bom Jesus', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.908193', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1093, NULL, 1093, 'Brejinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.909163', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1094, NULL, 1094, 'Caicara do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.910096', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1095, NULL, 1095, 'Caicara do Rio do Vento', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.911027', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1096, NULL, 1096, 'Caico', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.911823', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1097, NULL, 1097, 'Campo Redondo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.912823', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1098, NULL, 1098, 'Canguaretama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.913613', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1099, NULL, 1099, 'Caraubas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.914478', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1100, NULL, 1100, 'Carnauba dos Dantas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.915516', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1101, NULL, 1101, 'Carnaubais', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.916333', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1102, NULL, 1102, 'Ceara-mirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.917214', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1103, NULL, 1103, 'Cerro Cora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.924082', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1104, NULL, 1104, 'Coronel Ezequiel', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.925293', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1105, NULL, 1105, 'Coronel Joao Pessoa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.926424', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1106, NULL, 1106, 'Cruzeta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.927437', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1107, NULL, 1107, 'Currais Novos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.928357', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1108, NULL, 1108, 'Doutor Severiano', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.92922', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1109, NULL, 1109, 'Encanto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.930124', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1110, NULL, 1110, 'Equador', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.930949', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1111, NULL, 1111, 'Espirito Santo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.93187', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1112, NULL, 1112, 'Extremoz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.93282', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1113, NULL, 1113, 'Felipe Guerra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.933753', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1114, NULL, 1114, 'Fernando Pedroza', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.934712', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1115, NULL, 1115, 'Florania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.935678', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1116, NULL, 1116, 'Francisco Dantas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.936647', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1117, NULL, 1117, 'Frutuoso Gomes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.93762', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1118, NULL, 1118, 'Galinhos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.938502', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1119, NULL, 1119, 'Goianinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.939453', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1120, NULL, 1120, 'Governador Dix-sept Rosado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.940328', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1121, NULL, 1121, 'Grossos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.941151', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1122, NULL, 1122, 'Guamare', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.942246', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1123, NULL, 1123, 'Ielmo Marinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.943257', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1124, NULL, 1124, 'Ipanguacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.944128', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1125, NULL, 1125, 'Ipueira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.945019', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1126, NULL, 1126, 'Itaja', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.946076', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1127, NULL, 1127, 'Itau', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.946989', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1128, NULL, 1128, 'Jacana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.947875', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1129, NULL, 1129, 'Jandaira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.948829', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1130, NULL, 1130, 'Janduis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.949781', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1131, NULL, 1131, 'Januario Cicco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.950601', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1132, NULL, 1132, 'Japi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.951564', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1133, NULL, 1133, 'Jardim de Angicos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.952483', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1134, NULL, 1134, 'Jardim de Piranhas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.953409', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1135, NULL, 1135, 'Jardim do Serido', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.954238', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1136, NULL, 1136, 'Joao Camara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.955149', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1137, NULL, 1137, 'Joao Dias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.956075', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1138, NULL, 1138, 'Jose da Penha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.957006', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1139, NULL, 1139, 'Jucurutu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.957905', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1140, NULL, 1140, 'Jundia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.958828', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1141, NULL, 1141, 'Lagoa D''anta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.965134', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1142, NULL, 1142, 'Lagoa de Pedras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.966233', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1143, NULL, 1143, 'Lagoa de Velhos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.967108', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1144, NULL, 1144, 'Lagoa Nova', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.96806', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1145, NULL, 1145, 'Lagoa Salgada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.968966', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1146, NULL, 1146, 'Lajes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.96988', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1147, NULL, 1147, 'Lajes Pintadas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.970916', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1148, NULL, 1148, 'Lucrecia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.971944', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1149, NULL, 1149, 'Luis Gomes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.973018', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1150, NULL, 1150, 'Macaiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.973955', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1151, NULL, 1151, 'Macau', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.974833', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1152, NULL, 1152, 'Major Sales', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.975688', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1153, NULL, 1153, 'Marcelino Vieira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.976567', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1154, NULL, 1154, 'Martins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.977442', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1155, NULL, 1155, 'Maxaranguape', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.978517', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1156, NULL, 1156, 'Messias Targino', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.979498', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1157, NULL, 1157, 'Montanhas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.980416', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1158, NULL, 1158, 'Monte Alegre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.981295', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1159, NULL, 1159, 'Monte das Gameleiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.982178', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1160, NULL, 1160, 'Mossoro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.983168', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1161, NULL, 1161, 'Natal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.98404', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1162, NULL, 1162, 'Nisia Floresta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.984957', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1163, NULL, 1163, 'Nova Cruz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.98583', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1164, NULL, 1164, 'Olho-d''agua do Borges', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.986796', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1165, NULL, 1165, 'Ouro Branco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.987717', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1166, NULL, 1166, 'Parana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.988598', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1167, NULL, 1167, 'Parau', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.989498', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1168, NULL, 1168, 'Parazinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.990437', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1169, NULL, 1169, 'Parelhas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.99129', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1170, NULL, 1170, 'Parnamirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.992169', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1171, NULL, 1171, 'Passa e Fica', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.99297', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1172, NULL, 1172, 'Passagem', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.994099', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1173, NULL, 1173, 'Patu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.994899', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1174, NULL, 1174, 'Pau dos Ferros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.995778', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1175, NULL, 1175, 'Pedra Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.996685', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1176, NULL, 1176, 'Pedra Preta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.997564', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1177, NULL, 1177, 'Pedro Avelino', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.998571', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1178, NULL, 1178, 'Pedro Velho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.005427', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1179, NULL, 1179, 'Pendencias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.00655', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1180, NULL, 1180, 'Piloes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.007471', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1181, NULL, 1181, 'Poco Branco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.00834', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1182, NULL, 1182, 'Portalegre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.009265', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1183, NULL, 1183, 'Porto do Mangue', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.010181', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1184, NULL, 1184, 'Presidente Juscelino', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.010971', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1185, NULL, 1185, 'Pureza', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.012', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1186, NULL, 1186, 'Rafael Fernandes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.012814', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1187, NULL, 1187, 'Rafael Godeiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.013633', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1188, NULL, 1188, 'Riacho da Cruz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.014532', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1189, NULL, 1189, 'Riacho de Santana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.015533', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1190, NULL, 1190, 'Riachuelo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.016688', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1191, NULL, 1191, 'Rio do Fogo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.017658', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1192, NULL, 1192, 'Rodolfo Fernandes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.018555', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1193, NULL, 1193, 'Ruy Barbosa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.019556', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1194, NULL, 1194, 'Santa Cruz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.020402', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1195, NULL, 1195, 'Santa Maria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.021445', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1196, NULL, 1196, 'Santana do Matos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.022177', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1197, NULL, 1197, 'Santana do Serido', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.023022', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1198, NULL, 1198, 'Santo Antonio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.023864', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1199, NULL, 1199, 'Sao Bento do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.024666', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1200, NULL, 1200, 'Sao Bento do Trairi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.025598', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1201, NULL, 1201, 'Sao Fernando', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.026479', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1202, NULL, 1202, 'Sao Francisco do Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.027777', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1203, NULL, 1203, 'Sao Goncalo do Amarante', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.028644', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1204, NULL, 1204, 'Sao Joao do Sabugi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.029513', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1205, NULL, 1205, 'Sao Jose de Mipibu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.03041', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1206, NULL, 1206, 'Sao Jose do Campestre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.031271', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1207, NULL, 1207, 'Sao Jose do Serido', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.032197', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1208, NULL, 1208, 'Sao Miguel', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.03317', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1209, NULL, 1209, 'Sao Miguel do Gostoso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.034112', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1210, NULL, 1210, 'Sao Paulo do Potengi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.035023', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1211, NULL, 1211, 'Sao Pedro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.035951', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1212, NULL, 1212, 'Sao Rafael', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.03703', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1213, NULL, 1213, 'Sao Tome', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.037977', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1214, NULL, 1214, 'Sao Vicente', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.039135', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1215, NULL, 1215, 'Senador Eloi de Souza', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.045963', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1216, NULL, 1216, 'Senador Georgino Avelino', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.047205', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1217, NULL, 1217, 'Serra de Sao Bento', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.048251', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1218, NULL, 1218, 'Serra do Mel', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.049257', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1219, NULL, 1219, 'Serra Negra do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.050121', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1220, NULL, 1220, 'Serrinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.051006', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1221, NULL, 1221, 'Serrinha dos Pintos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.052384', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1222, NULL, 1222, 'Severiano Melo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.053323', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1223, NULL, 1223, 'Sitio Novo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.05422', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1224, NULL, 1224, 'Taboleiro Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.055116', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1225, NULL, 1225, 'Taipu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.055992', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1226, NULL, 1226, 'Tangara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.056821', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1227, NULL, 1227, 'Tenente Ananias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.057772', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1228, NULL, 1228, 'Tenente Laurentino Cruz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.058756', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1229, NULL, 1229, 'Tibau', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.059823', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1230, NULL, 1230, 'Tibau do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.061144', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1231, NULL, 1231, 'Timbauba dos Batistas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.062201', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1232, NULL, 1232, 'Touros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.063184', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1233, NULL, 1233, 'Triunfo Potiguar', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.064106', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1234, NULL, 1234, 'Umarizal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.065006', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1235, NULL, 1235, 'Upanema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.065955', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1236, NULL, 1236, 'Varzea', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.066769', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1237, NULL, 1237, 'Venha-ver', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.067688', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1238, NULL, 1238, 'Vera Cruz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.068614', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1239, NULL, 1239, 'Vicosa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.069524', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1240, NULL, 1240, 'Vila Flor', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.070393', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1241, NULL, 1241, 'Agua Branca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.071439', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1242, NULL, 1242, 'Aguiar', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.072434', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1243, NULL, 1243, 'Alagoa Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.073282', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1244, NULL, 1244, 'Alagoa Nova', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.074227', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1245, NULL, 1245, 'Alagoinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.075158', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1246, NULL, 1246, 'Alcantil', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.076009', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1247, NULL, 1247, 'Algodao de Jandaira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.076841', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1248, NULL, 1248, 'Alhandra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.07777', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1249, NULL, 1249, 'Amparo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.078587', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1250, NULL, 1250, 'Aparecida', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.079657', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1251, NULL, 1251, 'Aracagi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.086461', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1252, NULL, 1252, 'Arara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.087625', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1253, NULL, 1253, 'Araruna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.088977', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1254, NULL, 1254, 'Areia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.089891', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1255, NULL, 1255, 'Areia de Baraunas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.090763', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1256, NULL, 1256, 'Areial', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.09166', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1257, NULL, 1257, 'Aroeiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.092651', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1258, NULL, 1258, 'Assuncao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.093528', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1259, NULL, 1259, 'Baia da Traicao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.094762', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1260, NULL, 1260, 'Bananeiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.0956', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1261, NULL, 1261, 'Barauna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.096454', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1262, NULL, 1262, 'Barra de Santa Rosa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.097433', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1263, NULL, 1263, 'Barra de Santana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.098328', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1264, NULL, 1264, 'Barra de Sao Miguel', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.099207', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1265, NULL, 1265, 'Bayeux', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.100233', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1266, NULL, 1266, 'Belem', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.101175', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1267, NULL, 1267, 'Belem do Brejo do Cruz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.102014', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1268, NULL, 1268, 'Bernardino Batista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.102935', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1269, NULL, 1269, 'Boa Ventura', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.10377', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1270, NULL, 1270, 'Boa Vista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.104778', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1271, NULL, 1271, 'Bom Jesus', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.105776', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1272, NULL, 1272, 'Bom Sucesso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.106763', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1273, NULL, 1273, 'Bonito de Santa Fe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.107652', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1274, NULL, 1274, 'Boqueirao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.108561', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1275, NULL, 1275, 'Borborema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.109233', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1276, NULL, 1276, 'Brejo do Cruz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.110176', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1277, NULL, 1277, 'Brejo dos Santos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.111091', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1278, NULL, 1278, 'Caapora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.112052', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1279, NULL, 1279, 'Cabaceiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.112919', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1280, NULL, 1280, 'Cabedelo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.113819', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1281, NULL, 1281, 'Cachoeira dos Indios', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.114792', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1282, NULL, 1282, 'Cacimba de Areia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.115622', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1283, NULL, 1283, 'Cacimba de Dentro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.116562', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1284, NULL, 1284, 'Cacimbas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.117359', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1285, NULL, 1285, 'Caicara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.118234', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1286, NULL, 1286, 'Cajazeiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.119142', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1287, NULL, 1287, 'Cajazeirinhas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.120118', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1288, NULL, 1288, 'Caldas Brandao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.126902', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1289, NULL, 1289, 'Camalau', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.128216', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1290, NULL, 1290, 'Campina Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.129109', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1291, NULL, 1291, 'Campo de Santana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.13001', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1292, NULL, 1292, 'Capim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.130913', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1293, NULL, 1293, 'Caraubas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.131989', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1294, NULL, 1294, 'Carrapateira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.132966', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1295, NULL, 1295, 'Casserengue', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.133895', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1296, NULL, 1296, 'Catingueira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.134819', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1297, NULL, 1297, 'Catole do Rocha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.135839', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1298, NULL, 1298, 'Caturite', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.136857', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1299, NULL, 1299, 'Conceicao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.137768', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1300, NULL, 1300, 'Condado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.138687', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1301, NULL, 1301, 'Conde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.139541', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1302, NULL, 1302, 'Congo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.140593', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1303, NULL, 1303, 'Coremas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.141567', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1304, NULL, 1304, 'Coxixola', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.142408', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1305, NULL, 1305, 'Cruz do Espirito Santo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.143316', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1306, NULL, 1306, 'Cubati', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.144275', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1307, NULL, 1307, 'Cuite', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.145159', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1308, NULL, 1308, 'Cuite de Mamanguape', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.146038', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1309, NULL, 1309, 'Cuitegi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.146933', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1310, NULL, 1310, 'Curral de Cima', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.147807', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1311, NULL, 1311, 'Curral Velho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.14869', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1312, NULL, 1312, 'Damiao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.149547', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1313, NULL, 1313, 'Desterro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.150441', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1314, NULL, 1314, 'Diamante', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.151433', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1315, NULL, 1315, 'Dona Ines', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.152276', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1316, NULL, 1316, 'Duas Estradas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.153226', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1317, NULL, 1317, 'Emas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.154106', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1318, NULL, 1318, 'Esperanca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.154937', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1319, NULL, 1319, 'Fagundes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.15573', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1320, NULL, 1320, 'Frei Martinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.156702', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1321, NULL, 1321, 'Gado Bravo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.157619', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1322, NULL, 1322, 'Guarabira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.158561', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1323, NULL, 1323, 'Gurinhem', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.159521', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1324, NULL, 1324, 'Gurjao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.160604', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1325, NULL, 1325, 'Ibiara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.168082', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1326, NULL, 1326, 'Igaracy', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.169184', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1327, NULL, 1327, 'Imaculada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.170197', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1328, NULL, 1328, 'Inga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.171029', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1329, NULL, 1329, 'Itabaiana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.172174', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1330, NULL, 1330, 'Itaporanga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.173123', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1331, NULL, 1331, 'Itapororoca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.174094', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1332, NULL, 1332, 'Itatuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.174905', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1333, NULL, 1333, 'Jacarau', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.175971', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1334, NULL, 1334, 'Jerico', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.176834', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1335, NULL, 1335, 'Joao Pessoa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.177745', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1336, NULL, 1336, 'Juarez Tavora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.178614', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1337, NULL, 1337, 'Juazeirinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.179447', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1338, NULL, 1338, 'Junco do Serido', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.180365', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1339, NULL, 1339, 'Juripiranga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.181348', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1340, NULL, 1340, 'Juru', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.182217', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1341, NULL, 1341, 'Lagoa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.183149', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1342, NULL, 1342, 'Lagoa de Dentro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.184115', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1343, NULL, 1343, 'Lagoa Seca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.185256', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1344, NULL, 1344, 'Lastro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.186203', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1345, NULL, 1345, 'Livramento', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.187139', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1346, NULL, 1346, 'Logradouro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.18807', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1347, NULL, 1347, 'Lucena', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.188966', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1348, NULL, 1348, 'Mae D''agua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.189872', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1349, NULL, 1349, 'Malta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.190783', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1350, NULL, 1350, 'Mamanguape', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.191714', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1351, NULL, 1351, 'Manaira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.192634', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1352, NULL, 1352, 'Marcacao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.193573', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1353, NULL, 1353, 'Mari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.194537', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1354, NULL, 1354, 'Marizopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.195373', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1355, NULL, 1355, 'Massaranduba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.196294', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1356, NULL, 1356, 'Mataraca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.197125', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1357, NULL, 1357, 'Matinhas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.198047', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1358, NULL, 1358, 'Mato Grosso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.198975', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1359, NULL, 1359, 'Matureia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.199965', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1360, NULL, 1360, 'Mogeiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.200795', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1361, NULL, 1361, 'Montadas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.201784', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1362, NULL, 1362, 'Monte Horebe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.209441', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1363, NULL, 1363, 'Monteiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.210611', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1364, NULL, 1364, 'Mulungu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.21166', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1365, NULL, 1365, 'Natuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.212408', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1366, NULL, 1366, 'Nazarezinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.213326', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1367, NULL, 1367, 'Nova Floresta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.214238', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1368, NULL, 1368, 'Nova Olinda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.215124', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1369, NULL, 1369, 'Nova Palmeira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.215985', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1370, NULL, 1370, 'Olho D''agua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.216966', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1371, NULL, 1371, 'Olivedos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.217879', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1372, NULL, 1372, 'Ouro Velho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.218822', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1373, NULL, 1373, 'Parari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.219627', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1374, NULL, 1374, 'Passagem', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.220662', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1375, NULL, 1375, 'Patos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.22147', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1376, NULL, 1376, 'Paulista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.222548', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1377, NULL, 1377, 'Pedra Branca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.223486', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1378, NULL, 1378, 'Pedra Lavrada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.224321', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1379, NULL, 1379, 'Pedras de Fogo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.225261', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1380, NULL, 1380, 'Pedro Regis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.226144', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1381, NULL, 1381, 'Pianco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.22712', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1382, NULL, 1382, 'Picui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.228008', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1383, NULL, 1383, 'Pilar', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.228887', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1384, NULL, 1384, 'Piloes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.230081', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1385, NULL, 1385, 'Piloezinhos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.230945', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1386, NULL, 1386, 'Pirpirituba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.231857', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1387, NULL, 1387, 'Pitimbu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.232742', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1388, NULL, 1388, 'Pocinhos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.233566', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1389, NULL, 1389, 'Poco Dantas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.234628', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1390, NULL, 1390, 'Poco de Jose de Moura', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.235532', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1391, NULL, 1391, 'Pombal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.236417', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1392, NULL, 1392, 'Prata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.23723', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1393, NULL, 1393, 'Princesa Isabel', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.238127', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1394, NULL, 1394, 'Puxinana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.238929', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1395, NULL, 1395, 'Queimadas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.239764', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1396, NULL, 1396, 'Quixaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.240693', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1397, NULL, 1397, 'Remigio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.241454', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1398, NULL, 1398, 'Riachao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.242406', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1399, NULL, 1399, 'Riachao do Bacamarte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.243145', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1400, NULL, 1400, 'Riachao do Poco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.249788', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1401, NULL, 1401, 'Riacho de Santo Antonio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.250952', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1402, NULL, 1402, 'Riacho dos Cavalos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.252411', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1403, NULL, 1403, 'Rio Tinto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.253304', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1404, NULL, 1404, 'Salgadinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.25416', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1405, NULL, 1405, 'Salgado de Sao Felix', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.255117', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1406, NULL, 1406, 'Santa Cecilia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.256209', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1407, NULL, 1407, 'Santa Cruz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.25718', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1408, NULL, 1408, 'Santa Helena', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.258032', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1409, NULL, 1409, 'Santa Ines', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.258871', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1410, NULL, 1410, 'Santa Luzia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.25973', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1411, NULL, 1411, 'Santa Rita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.260598', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1412, NULL, 1412, 'Santa Teresinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.261849', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1413, NULL, 1413, 'Santana de Mangueira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.262825', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1414, NULL, 1414, 'Santana dos Garrotes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.263649', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1415, NULL, 1415, 'Santarem', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.264592', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1416, NULL, 1416, 'Santo Andre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.265495', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1417, NULL, 1417, 'Sao Bentinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.266426', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1418, NULL, 1418, 'Sao Bento', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.26724', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5513, NULL, 5513, 'Rianapolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.527984', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1419, NULL, 1419, 'Sao Domingos de Pombal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.26811', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1420, NULL, 1420, 'Sao Domingos do Cariri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.269057', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1421, NULL, 1421, 'Sao Francisco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.269946', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1422, NULL, 1422, 'Sao Joao do Cariri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.270871', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1423, NULL, 1423, 'Sao Joao do Rio do Peixe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.271743', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1424, NULL, 1424, 'Sao Joao do Tigre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.272737', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1425, NULL, 1425, 'Sao Jose da Lagoa Tapada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.273614', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1426, NULL, 1426, 'Sao Jose de Caiana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.274688', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1427, NULL, 1427, 'Sao Jose de Espinharas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.27563', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1428, NULL, 1428, 'Sao Jose de Piranhas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.276506', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1429, NULL, 1429, 'Sao Jose de Princesa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.277443', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1430, NULL, 1430, 'Sao Jose do Bonfim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.278377', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1431, NULL, 1431, 'Sao Jose do Brejo do Cruz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.279212', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1432, NULL, 1432, 'Sao Jose do Sabugi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.280095', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1433, NULL, 1433, 'Sao Jose dos Cordeiros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.280958', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1434, NULL, 1434, 'Sao Jose dos Ramos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.281823', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1435, NULL, 1435, 'Sao Mamede', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.282705', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1436, NULL, 1436, 'Sao Miguel de Taipu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.283547', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1437, NULL, 1437, 'Sao Sebastiao de Lagoa de Roca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.290398', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1438, NULL, 1438, 'Sao Sebastiao do Umbuzeiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.291562', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1439, NULL, 1439, 'Sao Vicente do Serido', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.292442', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1440, NULL, 1440, 'Sape', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.293434', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1441, NULL, 1441, 'Serra Branca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.294291', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1442, NULL, 1442, 'Serra da Raiz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.295204', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1443, NULL, 1443, 'Serra Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.29615', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1444, NULL, 1444, 'Serra Redonda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.296925', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1445, NULL, 1445, 'Serraria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.297727', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1446, NULL, 1446, 'Sertaozinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.298636', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1447, NULL, 1447, 'Sobrado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.299495', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1448, NULL, 1448, 'Solanea', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.300403', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1449, NULL, 1449, 'Soledade', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.301233', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1450, NULL, 1450, 'Sossego', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.302085', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1451, NULL, 1451, 'Sousa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.302975', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1452, NULL, 1452, 'Sume', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.303766', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1453, NULL, 1453, 'Taperoa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.304635', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1454, NULL, 1454, 'Tavares', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.305527', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1455, NULL, 1455, 'Teixeira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.306383', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1456, NULL, 1456, 'Tenorio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.3074', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1457, NULL, 1457, 'Triunfo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.308232', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1458, NULL, 1458, 'Uirauna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.309099', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1459, NULL, 1459, 'Umbuzeiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.309848', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1460, NULL, 1460, 'Varzea', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.310707', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1461, NULL, 1461, 'Vieiropolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.311518', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1462, NULL, 1462, 'Vista Serrana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.312486', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1463, NULL, 1463, 'Zabele', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.31346', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1464, NULL, 1464, 'Abreu e Lima', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.314455', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1465, NULL, 1465, 'Afogados da Ingazeira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.315369', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1466, NULL, 1466, 'Afranio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.316283', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1467, NULL, 1467, 'Agrestina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.317184', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1468, NULL, 1468, 'Agua Preta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.318148', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1469, NULL, 1469, 'Aguas Belas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.319228', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1470, NULL, 1470, 'Alagoinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.320145', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1471, NULL, 1471, 'Alianca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.32101', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1472, NULL, 1472, 'Altinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.321895', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1473, NULL, 1473, 'Amaraji', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.322767', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1474, NULL, 1474, 'Angelim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.32367', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1475, NULL, 1475, 'Aracoiaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.324482', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1476, NULL, 1476, 'Araripina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.330102', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1477, NULL, 1477, 'Arcoverde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.331269', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1478, NULL, 1478, 'Barra de Guabiraba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.332372', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1479, NULL, 1479, 'Barreiros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.333472', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1480, NULL, 1480, 'Belem de Maria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.334393', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1481, NULL, 1481, 'Belem de Sao Francisco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.335218', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1482, NULL, 1482, 'Belo Jardim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.336241', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1483, NULL, 1483, 'Betania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.337129', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1484, NULL, 1484, 'Bezerros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.338076', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1485, NULL, 1485, 'Bodoco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.338907', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1486, NULL, 1486, 'Bom Conselho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.339929', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1487, NULL, 1487, 'Bom Jardim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.340936', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1488, NULL, 1488, 'Bonito', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.34216', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1489, NULL, 1489, 'Brejao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.343086', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1490, NULL, 1490, 'Brejinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.344037', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1491, NULL, 1491, 'Brejo da Madre de Deus', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.344934', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1492, NULL, 1492, 'Buenos Aires', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.345842', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1493, NULL, 1493, 'Buique', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.346767', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1494, NULL, 1494, 'Cabo de Santo Agostinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.347774', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1495, NULL, 1495, 'Cabrobo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.348738', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1496, NULL, 1496, 'Cachoeirinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.349556', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1497, NULL, 1497, 'Caetes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.350314', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1498, NULL, 1498, 'Calcado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.351203', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1499, NULL, 1499, 'Calumbi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.35222', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1500, NULL, 1500, 'Camaragibe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.352986', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1501, NULL, 1501, 'Camocim de Sao Felix', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.35396', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1502, NULL, 1502, 'Camutanga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.35491', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1503, NULL, 1503, 'Canhotinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.355843', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1504, NULL, 1504, 'Capoeiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.356719', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1505, NULL, 1505, 'Carnaiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.357596', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1506, NULL, 1506, 'Carnaubeira da Penha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.358502', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1507, NULL, 1507, 'Carpina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.359433', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1508, NULL, 1508, 'Caruaru', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.360254', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1509, NULL, 1509, 'Casinhas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.361206', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1510, NULL, 1510, 'Catende', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.362152', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1511, NULL, 1511, 'Cedro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.363201', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1512, NULL, 1512, 'Cha de Alegria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.364172', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1513, NULL, 1513, 'Cha Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.364895', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1514, NULL, 1514, 'Condado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.365661', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1515, NULL, 1515, 'Correntes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.366715', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1516, NULL, 1516, 'Cortes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.376836', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1517, NULL, 1517, 'Cumaru', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.377881', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1518, NULL, 1518, 'Cupira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.378741', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1519, NULL, 1519, 'Custodia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.379657', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1520, NULL, 1520, 'Dormentes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.380527', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1521, NULL, 1521, 'Escada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.381407', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1522, NULL, 1522, 'Exu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.382617', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1523, NULL, 1523, 'Feira Nova', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.383472', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1524, NULL, 1524, 'Fernando de Noronha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.384317', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1525, NULL, 1525, 'Ferreiros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.3852', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1526, NULL, 1526, 'Flores', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.386058', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1527, NULL, 1527, 'Floresta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.386923', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1528, NULL, 1528, 'Frei Miguelinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.387844', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1529, NULL, 1529, 'Gameleira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.388718', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1530, NULL, 1530, 'Garanhuns', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.389733', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1531, NULL, 1531, 'Gloria do Goita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.390524', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1532, NULL, 1532, 'Goiana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.391405', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1533, NULL, 1533, 'Granito', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.392255', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1534, NULL, 1534, 'Gravata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.393148', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1535, NULL, 1535, 'Iati', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.394064', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1536, NULL, 1536, 'Ibimirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.394992', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1537, NULL, 1537, 'Ibirajuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.395927', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1538, NULL, 1538, 'Igarassu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.396835', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1539, NULL, 1539, 'Iguaraci', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.397826', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1540, NULL, 1540, 'Inaja', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.398738', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1541, NULL, 1541, 'Ingazeira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.399746', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1542, NULL, 1542, 'Ipojuca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.400727', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1543, NULL, 1543, 'Ipubi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.401708', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1544, NULL, 1544, 'Itacuruba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.402642', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1545, NULL, 1545, 'Itaiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.403569', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1546, NULL, 1546, 'Itamaraca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.404483', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1547, NULL, 1547, 'Itambe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.405413', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1548, NULL, 1548, 'Itapetim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.40621', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1549, NULL, 1549, 'Itapissuma', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.407134', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1550, NULL, 1550, 'Itaquitinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.408047', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1551, NULL, 1551, 'Jaboatao dos Guararapes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.408818', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1552, NULL, 1552, 'Jaqueira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.409756', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1553, NULL, 1553, 'Jatauba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.410498', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1554, NULL, 1554, 'Jatoba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.411876', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1555, NULL, 1555, 'Joao Alfredo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.417932', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1556, NULL, 1556, 'Joaquim Nabuco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.419099', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1557, NULL, 1557, 'Jucati', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.420118', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1558, NULL, 1558, 'Jupi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.421181', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1559, NULL, 1559, 'Jurema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.422125', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1560, NULL, 1560, 'Lagoa do Carro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.423115', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1561, NULL, 1561, 'Lagoa do Itaenga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.424018', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1562, NULL, 1562, 'Lagoa do Ouro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.424996', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1563, NULL, 1563, 'Lagoa dos Gatos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.425859', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1564, NULL, 1564, 'Lagoa Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.42668', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1565, NULL, 1565, 'Lajedo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.427665', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1566, NULL, 1566, 'Limoeiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.428572', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1567, NULL, 1567, 'Macaparana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.429473', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1568, NULL, 1568, 'Machados', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.430395', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1569, NULL, 1569, 'Manari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.431315', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1570, NULL, 1570, 'Maraial', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.432227', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1571, NULL, 1571, 'Mirandiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.433144', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1572, NULL, 1572, 'Moreilandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.434075', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1573, NULL, 1573, 'Moreno', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.434923', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1574, NULL, 1574, 'Nazare da Mata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.435804', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1575, NULL, 1575, 'Olinda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.436674', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1576, NULL, 1576, 'Orobo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.437566', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1577, NULL, 1577, 'Oroco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.438497', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1578, NULL, 1578, 'Ouricuri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.439384', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1579, NULL, 1579, 'Palmares', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.44018', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1580, NULL, 1580, 'Palmeirina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.441107', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1581, NULL, 1581, 'Panelas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.442238', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1582, NULL, 1582, 'Paranatama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.443039', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1583, NULL, 1583, 'Parnamirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.44394', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1584, NULL, 1584, 'Passira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.444874', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1585, NULL, 1585, 'Paudalho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.445746', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1586, NULL, 1586, 'Paulista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.446509', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1587, NULL, 1587, 'Pedra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.447374', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1588, NULL, 1588, 'Pesqueira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.448217', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1589, NULL, 1589, 'Petrolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.449198', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1590, NULL, 1590, 'Petrolina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.450099', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1591, NULL, 1591, 'Pocao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.451059', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1592, NULL, 1592, 'Pombos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.458158', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1593, NULL, 1593, 'Primavera', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.459513', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1594, NULL, 1594, 'Quipapa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.460461', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1595, NULL, 1595, 'Quixaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.461303', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1596, NULL, 1596, 'Recife', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.462202', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1597, NULL, 1597, 'Riacho das Almas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.463132', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1598, NULL, 1598, 'Ribeirao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.464166', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1599, NULL, 1599, 'Rio Formoso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.46508', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1600, NULL, 1600, 'Saire', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.466141', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1601, NULL, 1601, 'Salgadinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.467057', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1602, NULL, 1602, 'Salgueiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.467963', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1603, NULL, 1603, 'Saloa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.468887', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1604, NULL, 1604, 'Sanharo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.469786', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1605, NULL, 1605, 'Santa Cruz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.470673', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1606, NULL, 1606, 'Santa Cruz da Baixa Verde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.471456', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1607, NULL, 1607, 'Santa Cruz do Capibaribe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.47243', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1608, NULL, 1608, 'Santa Filomena', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.473203', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1609, NULL, 1609, 'Santa Maria da Boa Vista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.474049', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1610, NULL, 1610, 'Santa Maria do Cambuca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.474981', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1611, NULL, 1611, 'Santa Terezinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.475798', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1612, NULL, 1612, 'Sao Benedito do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.47664', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1613, NULL, 1613, 'Sao Bento do Una', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.477417', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1614, NULL, 1614, 'Sao Caitano', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.478275', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1615, NULL, 1615, 'Sao Joao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.479132', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1616, NULL, 1616, 'Sao Joaquim do Monte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.479973', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1617, NULL, 1617, 'Sao Jose da Coroa Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.48086', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1618, NULL, 1618, 'Sao Jose do Belmonte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.481801', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1619, NULL, 1619, 'Sao Jose do Egito', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.482835', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1620, NULL, 1620, 'Sao Lourenco da Mata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.48371', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1621, NULL, 1621, 'Sao Vicente Ferrer', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.484603', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1622, NULL, 1622, 'Serra Talhada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.485455', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1623, NULL, 1623, 'Serrita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.486433', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1624, NULL, 1624, 'Sertania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.487232', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1625, NULL, 1625, 'Sirinhaem', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.48815', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1626, NULL, 1626, 'Solidao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.489012', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1627, NULL, 1627, 'Surubim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.489863', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1628, NULL, 1628, 'Tabira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.490792', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1629, NULL, 1629, 'Tacaimbo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.491684', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1630, NULL, 1630, 'Tacaratu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.492321', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1631, NULL, 1631, 'Tamandare', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.49933', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1632, NULL, 1632, 'Taquaritinga do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.500598', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1633, NULL, 1633, 'Terezinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.501611', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1634, NULL, 1634, 'Terra Nova', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.502516', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1635, NULL, 1635, 'Timbauba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.503375', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1636, NULL, 1636, 'Toritama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.504224', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1637, NULL, 1637, 'Tracunhaem', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.505121', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1638, NULL, 1638, 'Trindade', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.505974', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1639, NULL, 1639, 'Triunfo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.506916', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1640, NULL, 1640, 'Tupanatinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.507922', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1641, NULL, 1641, 'Tuparetama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.508899', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1642, NULL, 1642, 'Venturosa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.509757', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1643, NULL, 1643, 'Verdejante', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.510673', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1644, NULL, 1644, 'Vertente do Lerio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.511529', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1645, NULL, 1645, 'Vertentes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.512415', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1646, NULL, 1646, 'Vicencia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.513303', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1647, NULL, 1647, 'Vitoria de Santo Antao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.51418', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1648, NULL, 1648, 'Xexeu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.515121', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1649, NULL, 1649, 'Agua Branca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.515958', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1650, NULL, 1650, 'Anadia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.516876', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1651, NULL, 1651, 'Arapiraca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.517813', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1652, NULL, 1652, 'Atalaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.518801', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1653, NULL, 1653, 'Barra de Santo Antonio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.519858', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1654, NULL, 1654, 'Barra de Sao Miguel', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.520772', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1655, NULL, 1655, 'Batalha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.521655', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1656, NULL, 1656, 'Belem', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.522539', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1657, NULL, 1657, 'Belo Monte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.523412', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1658, NULL, 1658, 'Boca da Mata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.524257', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1659, NULL, 1659, 'Branquinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.525049', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1660, NULL, 1660, 'Cacimbinhas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.525871', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1661, NULL, 1661, 'Cajueiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.526778', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1662, NULL, 1662, 'Campestre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.527574', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1663, NULL, 1663, 'Campo Alegre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.528462', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1664, NULL, 1664, 'Campo Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.529366', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1665, NULL, 1665, 'Canapi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.5303', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1666, NULL, 1666, 'Capela', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.531062', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1667, NULL, 1667, 'Carneiros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.531967', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1668, NULL, 1668, 'Cha Preta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.532762', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1669, NULL, 1669, 'Coite do Noia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.53981', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1670, NULL, 1670, 'Colonia Leopoldina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.540909', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1671, NULL, 1671, 'Coqueiro Seco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.541931', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1672, NULL, 1672, 'Coruripe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.542806', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1673, NULL, 1673, 'Craibas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.543615', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1674, NULL, 1674, 'Delmiro Gouveia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.544416', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1675, NULL, 1675, 'Dois Riachos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.545079', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1676, NULL, 1676, 'Estrela de Alagoas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.545943', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1677, NULL, 1677, 'Feira Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.546837', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1678, NULL, 1678, 'Feliz Deserto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.547708', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1679, NULL, 1679, 'Flexeiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.54858', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1680, NULL, 1680, 'Girau do Ponciano', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.549416', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1681, NULL, 1681, 'Ibateguara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.550297', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1682, NULL, 1682, 'Igaci', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.551161', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1683, NULL, 1683, 'Igreja Nova', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.552215', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1684, NULL, 1684, 'Inhapi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.553518', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1685, NULL, 1685, 'Jacare dos Homens', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.554435', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1686, NULL, 1686, 'Jacuipe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.555236', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1687, NULL, 1687, 'Japaratinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.556108', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1688, NULL, 1688, 'Jaramataia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.556965', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1689, NULL, 1689, 'Jequia da Praia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.557886', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1690, NULL, 1690, 'Joaquim Gomes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.558773', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1691, NULL, 1691, 'Jundia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.55955', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1692, NULL, 1692, 'Junqueiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.560447', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1693, NULL, 1693, 'Lagoa da Canoa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.561361', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1694, NULL, 1694, 'Limoeiro de Anadia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.562239', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1695, NULL, 1695, 'Maceio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.563152', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1696, NULL, 1696, 'Major Isidoro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.564162', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1697, NULL, 1697, 'Mar Vermelho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.56511', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1698, NULL, 1698, 'Maragogi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.566063', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1699, NULL, 1699, 'Maravilha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.566937', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1700, NULL, 1700, 'Marechal Deodoro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.56783', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1701, NULL, 1701, 'Maribondo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.568607', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1702, NULL, 1702, 'Mata Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.569485', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1703, NULL, 1703, 'Matriz de Camaragibe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.570409', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1704, NULL, 1704, 'Messias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.57126', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1705, NULL, 1705, 'Minador do Negrao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.572177', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1706, NULL, 1706, 'Monteiropolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.573135', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1707, NULL, 1707, 'Murici', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.579953', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1708, NULL, 1708, 'Novo Lino', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.58127', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1709, NULL, 1709, 'Olho D''agua das Flores', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.582212', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1710, NULL, 1710, 'Olho D''agua do Casado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.583111', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1711, NULL, 1711, 'Olho D''agua Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.583997', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1712, NULL, 1712, 'Olivenca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.584857', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1713, NULL, 1713, 'Ouro Branco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.585722', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1714, NULL, 1714, 'Palestina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.58684', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1715, NULL, 1715, 'Palmeira dos Indios', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.587745', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1716, NULL, 1716, 'Pao de Acucar', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.58866', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1717, NULL, 1717, 'Pariconha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.589445', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1718, NULL, 1718, 'Paripueira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.590225', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1719, NULL, 1719, 'Passo de Camaragibe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.59101', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1720, NULL, 1720, 'Paulo Jacinto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.591854', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1721, NULL, 1721, 'Penedo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.592907', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1722, NULL, 1722, 'Piacabucu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.593907', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1723, NULL, 1723, 'Pilar', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.594781', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1724, NULL, 1724, 'Pindoba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.595808', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1725, NULL, 1725, 'Piranhas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.596659', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1726, NULL, 1726, 'Poco das Trincheiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.597518', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1727, NULL, 1727, 'Porto Calvo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.598531', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1728, NULL, 1728, 'Porto de Pedras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.599515', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5514, NULL, 5514, 'Rio Quente', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.750281', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1729, NULL, 1729, 'Porto Real do Colegio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.600386', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1730, NULL, 1730, 'Quebrangulo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.601248', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1731, NULL, 1731, 'Rio Largo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.602118', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1732, NULL, 1732, 'Roteiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.602974', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1733, NULL, 1733, 'Santa Luzia do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.60384', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1734, NULL, 1734, 'Santana do Ipanema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.604666', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1735, NULL, 1735, 'Santana do Mundau', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.605464', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1736, NULL, 1736, 'Sao Bras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.60638', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1737, NULL, 1737, 'Sao Jose da Laje', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.607218', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1738, NULL, 1738, 'Sao Jose da Tapera', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.608123', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1739, NULL, 1739, 'Sao Luis do Quitunde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.609231', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1740, NULL, 1740, 'Sao Miguel dos Campos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.610109', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1741, NULL, 1741, 'Sao Miguel dos Milagres', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.610971', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1742, NULL, 1742, 'Sao Sebastiao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.611868', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1743, NULL, 1743, 'Satuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.612769', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1744, NULL, 1744, 'Senador Rui Palmeira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.61364', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1745, NULL, 1745, 'Tanque D''arca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.621045', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1746, NULL, 1746, 'Taquarana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.622171', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1747, NULL, 1747, 'Teotonio Vilela', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.623156', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1748, NULL, 1748, 'Traipu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.624182', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1749, NULL, 1749, 'Uniao dos Palmares', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.625153', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1750, NULL, 1750, 'Vicosa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.626119', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1751, NULL, 1751, 'Amparo de Sao Francisco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.626967', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1752, NULL, 1752, 'Aquidaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.627865', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1753, NULL, 1753, 'Aracaju', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.628811', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1754, NULL, 1754, 'Araua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.629694', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1755, NULL, 1755, 'Areia Branca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.630578', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1756, NULL, 1756, 'Barra dos Coqueiros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.631545', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1757, NULL, 1757, 'Boquim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.632563', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1758, NULL, 1758, 'Brejo Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.633428', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1759, NULL, 1759, 'Campo do Brito', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.63429', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1760, NULL, 1760, 'Canhoba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.635169', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1761, NULL, 1761, 'Caninde de Sao Francisco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.636006', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1762, NULL, 1762, 'Capela', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.636835', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1763, NULL, 1763, 'Carira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.637698', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1764, NULL, 1764, 'Carmopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.638589', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1765, NULL, 1765, 'Cedro de Sao Joao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.639453', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1766, NULL, 1766, 'Cristinapolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.640358', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1767, NULL, 1767, 'Cumbe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.641238', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1768, NULL, 1768, 'Divina Pastora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.642203', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1769, NULL, 1769, 'Estancia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.642975', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1770, NULL, 1770, 'Feira Nova', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.643769', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1771, NULL, 1771, 'Frei Paulo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.64469', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1772, NULL, 1772, 'Gararu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.645572', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1773, NULL, 1773, 'General Maynard', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.646491', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1774, NULL, 1774, 'Gracho Cardoso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.64737', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1775, NULL, 1775, 'Ilha das Flores', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.648183', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1776, NULL, 1776, 'Indiaroba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.649012', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1777, NULL, 1777, 'Itabaiana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.649896', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1778, NULL, 1778, 'Itabaianinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.650772', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1779, NULL, 1779, 'Itabi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.651642', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1780, NULL, 1780, 'Itaporanga D''ajuda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.652555', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1781, NULL, 1781, 'Japaratuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.653348', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1782, NULL, 1782, 'Japoata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.654107', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1783, NULL, 1783, 'Lagarto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.654821', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1784, NULL, 1784, 'Laranjeiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.655682', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1785, NULL, 1785, 'Macambira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.661933', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1786, NULL, 1786, 'Malhada dos Bois', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.663166', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1787, NULL, 1787, 'Malhador', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.664217', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1788, NULL, 1788, 'Maruim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.665029', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1789, NULL, 1789, 'Moita Bonita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.665899', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1790, NULL, 1790, 'Monte Alegre de Sergipe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.666702', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1791, NULL, 1791, 'Muribeca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.667607', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1792, NULL, 1792, 'Neopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.668505', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1793, NULL, 1793, 'Nossa Senhora Aparecida', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.66942', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1794, NULL, 1794, 'Nossa Senhora da Gloria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.670251', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1795, NULL, 1795, 'Nossa Senhora das Dores', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.671045', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1796, NULL, 1796, 'Nossa Senhora de Lourdes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.671969', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1797, NULL, 1797, 'Nossa Senhora do Socorro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.672835', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1798, NULL, 1798, 'Pacatuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.673744', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1799, NULL, 1799, 'Pedra Mole', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.674638', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1800, NULL, 1800, 'Pedrinhas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.675565', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1801, NULL, 1801, 'Pinhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.676278', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1802, NULL, 1802, 'Pirambu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.677143', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1803, NULL, 1803, 'Poco Redondo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.67807', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1804, NULL, 1804, 'Poco Verde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.678996', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1805, NULL, 1805, 'Porto da Folha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.679867', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1806, NULL, 1806, 'Propria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.680723', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1807, NULL, 1807, 'Riachao do Dantas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.68163', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1808, NULL, 1808, 'Riachuelo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.68251', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1809, NULL, 1809, 'Ribeiropolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.683399', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1810, NULL, 1810, 'Rosario do Catete', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.684327', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1811, NULL, 1811, 'Salgado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.685208', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1812, NULL, 1812, 'Santa Luzia do Itanhy', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.686053', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1813, NULL, 1813, 'Santa Rosa de Lima', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.687431', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1814, NULL, 1814, 'Santana do Sao Francisco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.688243', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1815, NULL, 1815, 'Santo Amaro das Brotas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.689158', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1816, NULL, 1816, 'Sao Cristovao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.690023', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1817, NULL, 1817, 'Sao Domingos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.690888', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1818, NULL, 1818, 'Sao Francisco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.691767', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1819, NULL, 1819, 'Sao Miguel do Aleixo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.692583', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1820, NULL, 1820, 'Simao Dias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.693538', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1821, NULL, 1821, 'Siriri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.694316', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1822, NULL, 1822, 'Telha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.695302', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1823, NULL, 1823, 'Tobias Barreto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.696176', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1824, NULL, 1824, 'Tomar do Geru', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.703912', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1825, NULL, 1825, 'Umbauba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.704998', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1826, NULL, 1826, 'Abaira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.705862', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1827, NULL, 1827, 'Abare', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.706776', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1828, NULL, 1828, 'Acajutiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.707772', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1829, NULL, 1829, 'Adustina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.708678', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1830, NULL, 1830, 'Agua Fria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.709564', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1831, NULL, 1831, 'Aiquara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.710453', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1832, NULL, 1832, 'Alagoinhas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.711342', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1833, NULL, 1833, 'Alcobaca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.712309', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1834, NULL, 1834, 'Almadina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.713183', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1835, NULL, 1835, 'Amargosa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.714102', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1836, NULL, 1836, 'Amelia Rodrigues', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.714937', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1837, NULL, 1837, 'America Dourada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.715822', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1838, NULL, 1838, 'Anage', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.716687', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1839, NULL, 1839, 'Andarai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.717527', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1840, NULL, 1840, 'Andorinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.718396', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1841, NULL, 1841, 'Angical', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.719204', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1842, NULL, 1842, 'Anguera', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.720208', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1843, NULL, 1843, 'Antas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.720988', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1844, NULL, 1844, 'Antonio Cardoso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.721872', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1845, NULL, 1845, 'Antonio Goncalves', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.72283', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1846, NULL, 1846, 'Apora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.723737', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1847, NULL, 1847, 'Apuarema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.72468', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1848, NULL, 1848, 'Aracas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.725609', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1849, NULL, 1849, 'Aracatu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.72638', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1850, NULL, 1850, 'Araci', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.727157', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1851, NULL, 1851, 'Aramari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.727919', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1852, NULL, 1852, 'Arataca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.728798', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1853, NULL, 1853, 'Aratuipe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.729676', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1854, NULL, 1854, 'Aurelino Leal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.730623', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1855, NULL, 1855, 'Baianopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.731629', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1856, NULL, 1856, 'Baixa Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.732415', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1857, NULL, 1857, 'Banzae', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.733268', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1858, NULL, 1858, 'Barra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.734163', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1859, NULL, 1859, 'Barra da Estiva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.735027', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1860, NULL, 1860, 'Barra do Choca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.735986', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1861, NULL, 1861, 'Barra do Mendes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.736784', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1862, NULL, 1862, 'Barra do Rocha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.737614', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1863, NULL, 1863, 'Barreiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.743632', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1864, NULL, 1864, 'Barro Alto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.745185', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1865, NULL, 1865, 'Barrocas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.746183', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1866, NULL, 1866, 'Belmonte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.747082', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1867, NULL, 1867, 'Belo Campo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.747989', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1868, NULL, 1868, 'Biritinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.748862', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1869, NULL, 1869, 'Boa Nova', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.749789', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1870, NULL, 1870, 'Boa Vista do Tupim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.750607', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1871, NULL, 1871, 'Bom Jesus da Lapa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.7516', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1872, NULL, 1872, 'Bom Jesus da Serra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.752527', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1873, NULL, 1873, 'Boninal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.753467', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1874, NULL, 1874, 'Bonito', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.754333', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1875, NULL, 1875, 'Boquira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.755177', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1876, NULL, 1876, 'Botupora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.756099', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1877, NULL, 1877, 'Brejoes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.756961', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1878, NULL, 1878, 'Brejolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.757913', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1879, NULL, 1879, 'Brotas de Macaubas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.758779', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1880, NULL, 1880, 'Brumado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.759633', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1881, NULL, 1881, 'Buerarema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.760497', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1882, NULL, 1882, 'Buritirama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.761353', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1883, NULL, 1883, 'Caatiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.762303', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1884, NULL, 1884, 'Cabaceiras do Paraguacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.763755', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1885, NULL, 1885, 'Cachoeira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.764694', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1886, NULL, 1886, 'Cacule', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.765572', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1887, NULL, 1887, 'Caem', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.766486', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1888, NULL, 1888, 'Caetanos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.767347', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1889, NULL, 1889, 'Caetite', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.768201', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1890, NULL, 1890, 'Cafarnaum', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.769048', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1891, NULL, 1891, 'Cairu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.769993', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1892, NULL, 1892, 'Caldeirao Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.770885', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1893, NULL, 1893, 'Camacan', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.771855', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1894, NULL, 1894, 'Camacari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.772719', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1895, NULL, 1895, 'Camamu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.773477', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1896, NULL, 1896, 'Campo Alegre de Lourdes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.774295', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1897, NULL, 1897, 'Campo Formoso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.775204', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1898, NULL, 1898, 'Canapolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.776195', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1899, NULL, 1899, 'Canarana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.776955', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1900, NULL, 1900, 'Canavieiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.777826', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1901, NULL, 1901, 'Candeal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.778621', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1902, NULL, 1902, 'Candeias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.785654', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1903, NULL, 1903, 'Candiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.786875', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1904, NULL, 1904, 'Candido Sales', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.787762', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1905, NULL, 1905, 'Cansancao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.788735', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1906, NULL, 1906, 'Canudos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.789648', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1907, NULL, 1907, 'Capela do Alto Alegre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.790552', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1908, NULL, 1908, 'Capim Grosso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.791373', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1909, NULL, 1909, 'Caraibas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.792368', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1910, NULL, 1910, 'Caravelas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.793239', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1911, NULL, 1911, 'Cardeal da Silva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.794153', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1912, NULL, 1912, 'Carinhanha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.795076', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1913, NULL, 1913, 'Casa Nova', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.796126', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1914, NULL, 1914, 'Castro Alves', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.797062', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1915, NULL, 1915, 'Catolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.797944', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1916, NULL, 1916, 'Catu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.798905', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1917, NULL, 1917, 'Caturama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.799835', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1918, NULL, 1918, 'Central', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.800762', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1919, NULL, 1919, 'Chorrocho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.801673', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1920, NULL, 1920, 'Cicero Dantas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.80256', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1921, NULL, 1921, 'Cipo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.803435', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1922, NULL, 1922, 'Coaraci', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.804362', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1923, NULL, 1923, 'Cocos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.805142', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1924, NULL, 1924, 'Conceicao da Feira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.806049', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1925, NULL, 1925, 'Conceicao do Almeida', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.80693', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1926, NULL, 1926, 'Conceicao do Coite', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.807792', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1927, NULL, 1927, 'Conceicao do Jacuipe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.808715', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1928, NULL, 1928, 'Conde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.809636', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1929, NULL, 1929, 'Condeuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.810398', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1930, NULL, 1930, 'Contendas do Sincora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.811224', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1931, NULL, 1931, 'Coracao de Maria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.812079', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1932, NULL, 1932, 'Cordeiros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.812982', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1933, NULL, 1933, 'Coribe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.81392', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1934, NULL, 1934, 'Coronel Joao Sa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.814844', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1935, NULL, 1935, 'Correntina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.815785', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1936, NULL, 1936, 'Cotegipe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.816686', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1937, NULL, 1937, 'Cravolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.817527', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1938, NULL, 1938, 'Crisopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.818343', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1939, NULL, 1939, 'Cristopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.819171', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1940, NULL, 1940, 'Cruz das Almas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.826554', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1941, NULL, 1941, 'Curaca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.827636', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1942, NULL, 1942, 'Dario Meira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.829405', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1943, NULL, 1943, 'Dias D''avila', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.830489', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1944, NULL, 1944, 'Dom Basilio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.831352', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1945, NULL, 1945, 'Dom Macedo Costa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.83241', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1946, NULL, 1946, 'Elisio Medrado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.833251', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1947, NULL, 1947, 'Encruzilhada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.83412', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1948, NULL, 1948, 'Entre Rios', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.835064', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1949, NULL, 1949, 'Erico Cardoso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.835874', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1950, NULL, 1950, 'Esplanada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.836741', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1951, NULL, 1951, 'Euclides da Cunha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.837646', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1952, NULL, 1952, 'Eunapolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.838519', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1953, NULL, 1953, 'Fatima', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.839335', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1954, NULL, 1954, 'Feira da Mata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.840193', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1955, NULL, 1955, 'Feira de Santana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.841117', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1956, NULL, 1956, 'Filadelfia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.842011', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1957, NULL, 1957, 'Firmino Alves', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.842944', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1958, NULL, 1958, 'Floresta Azul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.843755', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1959, NULL, 1959, 'Formosa do Rio Preto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.844635', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1960, NULL, 1960, 'Gandu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.845544', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1961, NULL, 1961, 'Gaviao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.846441', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1962, NULL, 1962, 'Gentio do Ouro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.847284', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1963, NULL, 1963, 'Gloria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.84819', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1964, NULL, 1964, 'Gongogi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.84909', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1965, NULL, 1965, 'Governador Lomanto Junior', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.849918', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1966, NULL, 1966, 'Governador Mangabeira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.850857', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1967, NULL, 1967, 'Guajeru', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.85184', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1968, NULL, 1968, 'Guanambi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.852748', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1969, NULL, 1969, 'Guaratinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.853646', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1970, NULL, 1970, 'Heliopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.854517', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1971, NULL, 1971, 'Iacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.855462', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1972, NULL, 1972, 'Ibiassuce', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.856356', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1973, NULL, 1973, 'Ibicarai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.857175', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1974, NULL, 1974, 'Ibicoara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.858076', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1975, NULL, 1975, 'Ibicui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.858999', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1976, NULL, 1976, 'Ibipeba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.859993', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1977, NULL, 1977, 'Ibipitanga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.867007', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1978, NULL, 1978, 'Ibiquera', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.868154', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1979, NULL, 1979, 'Ibirapitanga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.869284', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1980, NULL, 1980, 'Ibirapua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.870219', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1981, NULL, 1981, 'Ibirataia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.871155', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1982, NULL, 1982, 'Ibitiara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.872193', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1983, NULL, 1983, 'Ibitita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.873038', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1984, NULL, 1984, 'Ibotirama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.873833', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1985, NULL, 1985, 'Ichu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.874719', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1986, NULL, 1986, 'Igapora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.875578', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1987, NULL, 1987, 'Igrapiuna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.876442', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1988, NULL, 1988, 'Iguai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.877337', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1989, NULL, 1989, 'Ilheus', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.878226', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1990, NULL, 1990, 'Inhambupe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.87915', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1991, NULL, 1991, 'Ipecaeta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.880071', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1992, NULL, 1992, 'Ipiau', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.880952', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1993, NULL, 1993, 'Ipira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.881831', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1994, NULL, 1994, 'Ipupiara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.882705', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1995, NULL, 1995, 'Irajuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.883566', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1996, NULL, 1996, 'Iramaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.88439', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1997, NULL, 1997, 'Iraquara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.885298', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1998, NULL, 1998, 'Irara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.886211', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (1999, NULL, 1999, 'Irece', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.887131', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2000, NULL, 2000, 'Itabela', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.88815', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2001, NULL, 2001, 'Itaberaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.888959', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2002, NULL, 2002, 'Itabuna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.889845', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2003, NULL, 2003, 'Itacare', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.890749', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2004, NULL, 2004, 'Itaete', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.891611', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2005, NULL, 2005, 'Itagi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.892478', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2006, NULL, 2006, 'Itagiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.893317', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2007, NULL, 2007, 'Itagimirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.894412', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2008, NULL, 2008, 'Itaguacu da Bahia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.895374', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2009, NULL, 2009, 'Itaju do Colonia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.896523', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2010, NULL, 2010, 'Itajuipe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.897461', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2011, NULL, 2011, 'Itamaraju', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.898265', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2012, NULL, 2012, 'Itamari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.89943', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2013, NULL, 2013, 'Itambe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.900314', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2014, NULL, 2014, 'Itanagra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.901209', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2015, NULL, 2015, 'Itanhem', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.902022', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2016, NULL, 2016, 'Itaparica', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.906287', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2017, NULL, 2017, 'Itape', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.909995', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2018, NULL, 2018, 'Itapebi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.911146', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2019, NULL, 2019, 'Itapetinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.911973', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2020, NULL, 2020, 'Itapicuru', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.913016', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2021, NULL, 2021, 'Itapitanga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.913895', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2022, NULL, 2022, 'Itaquara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.914769', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2023, NULL, 2023, 'Itarantim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.915654', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2024, NULL, 2024, 'Itatim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.916552', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2025, NULL, 2025, 'Itirucu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.917472', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2026, NULL, 2026, 'Itiuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.918303', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2027, NULL, 2027, 'Itororo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.919192', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2028, NULL, 2028, 'Ituacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.920019', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2029, NULL, 2029, 'Itubera', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.920842', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2030, NULL, 2030, 'Iuiu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.921738', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2031, NULL, 2031, 'Jaborandi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.922718', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2032, NULL, 2032, 'Jacaraci', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.923539', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2033, NULL, 2033, 'Jacobina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.92442', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2034, NULL, 2034, 'Jaguaquara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.925284', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2035, NULL, 2035, 'Jaguarari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.926186', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2036, NULL, 2036, 'Jaguaripe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.927091', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2037, NULL, 2037, 'Jandaira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.928038', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2038, NULL, 2038, 'Jequie', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.928884', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2039, NULL, 2039, 'Jeremoabo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.929851', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2040, NULL, 2040, 'Jiquirica', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.930853', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2041, NULL, 2041, 'Jitauna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.93178', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2042, NULL, 2042, 'Joao Dourado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.932709', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2043, NULL, 2043, 'Juazeiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.933661', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2044, NULL, 2044, 'Jucurucu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.934595', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2045, NULL, 2045, 'Jussara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.935594', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2046, NULL, 2046, 'Jussari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.93641', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2047, NULL, 2047, 'Jussiape', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.937255', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2048, NULL, 2048, 'Lafaiete Coutinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.938148', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2049, NULL, 2049, 'Lagoa Real', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.938963', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2050, NULL, 2050, 'Laje', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.939756', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2051, NULL, 2051, 'Lajedao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.940684', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2052, NULL, 2052, 'Lajedinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.941599', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2053, NULL, 2053, 'Lajedo do Tabocal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.942474', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2054, NULL, 2054, 'Lamarao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.943451', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2055, NULL, 2055, 'Lapao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.947684', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2056, NULL, 2056, 'Lauro de Freitas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.951579', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2057, NULL, 2057, 'Lencois', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.952621', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2058, NULL, 2058, 'Licinio de Almeida', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.953576', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2059, NULL, 2059, 'Livramento de Nossa Senhora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.954557', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2060, NULL, 2060, 'Luis Eduardo Magalhaes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.955329', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2061, NULL, 2061, 'Macajuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.956202', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2062, NULL, 2062, 'Macarani', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.957096', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2063, NULL, 2063, 'Macaubas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.957889', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2064, NULL, 2064, 'Macurure', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.958774', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2065, NULL, 2065, 'Madre de Deus', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.959587', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2066, NULL, 2066, 'Maetinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.960638', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2067, NULL, 2067, 'Maiquinique', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.962121', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2068, NULL, 2068, 'Mairi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.963012', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2069, NULL, 2069, 'Malhada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.963901', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2070, NULL, 2070, 'Malhada de Pedras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.964883', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2071, NULL, 2071, 'Manoel Vitorino', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.966277', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2072, NULL, 2072, 'Mansidao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.967204', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2073, NULL, 2073, 'Maracas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.968095', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2074, NULL, 2074, 'Maragogipe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.968973', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2075, NULL, 2075, 'Marau', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.969912', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2076, NULL, 2076, 'Marcionilio Souza', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.970761', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2077, NULL, 2077, 'Mascote', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.971642', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2078, NULL, 2078, 'Mata de Sao Joao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.972526', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2079, NULL, 2079, 'Matina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.973388', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2080, NULL, 2080, 'Medeiros Neto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.974232', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2081, NULL, 2081, 'Miguel Calmon', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.975182', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2082, NULL, 2082, 'Milagres', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.976164', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2083, NULL, 2083, 'Mirangaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.977016', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2084, NULL, 2084, 'Mirante', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.977772', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2085, NULL, 2085, 'Monte Santo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.978653', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2086, NULL, 2086, 'Morpara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.979569', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2087, NULL, 2087, 'Morro do Chapeu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.980474', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2088, NULL, 2088, 'Mortugaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.981328', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2089, NULL, 2089, 'Mucuge', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.982184', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2090, NULL, 2090, 'Mucuri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.982993', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2091, NULL, 2091, 'Mulungu do Morro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.983851', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2092, NULL, 2092, 'Mundo Novo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.984848', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2093, NULL, 2093, 'Muniz Ferreira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.996997', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2094, NULL, 2094, 'Muquem de Sao Francisco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.998112', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2095, NULL, 2095, 'Muritiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.999036', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2096, NULL, 2096, 'Mutuipe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:35.999876', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2097, NULL, 2097, 'Nazare', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.000716', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2098, NULL, 2098, 'Nilo Pecanha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.001605', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2099, NULL, 2099, 'Nordestina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.002445', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2100, NULL, 2100, 'Nova Canaa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.003325', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2101, NULL, 2101, 'Nova Fatima', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.004235', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2102, NULL, 2102, 'Nova Ibia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.005107', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2103, NULL, 2103, 'Nova Itarana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.006013', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2104, NULL, 2104, 'Nova Redencao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.006882', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2105, NULL, 2105, 'Nova Soure', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.007768', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2106, NULL, 2106, 'Nova Vicosa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.008715', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2107, NULL, 2107, 'Novo Horizonte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.009609', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2108, NULL, 2108, 'Novo Triunfo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.01077', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2109, NULL, 2109, 'Olindina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.011563', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2110, NULL, 2110, 'Oliveira dos Brejinhos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.012481', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2111, NULL, 2111, 'Ouricangas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.013345', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2112, NULL, 2112, 'Ourolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.014162', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2113, NULL, 2113, 'Palmas de Monte Alto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.015029', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2114, NULL, 2114, 'Palmeiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.015951', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2115, NULL, 2115, 'Paramirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.016875', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2116, NULL, 2116, 'Paratinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.017719', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2117, NULL, 2117, 'Paripiranga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.018511', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2118, NULL, 2118, 'Pau Brasil', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.019288', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2119, NULL, 2119, 'Paulo Afonso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.020202', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2120, NULL, 2120, 'Pe de Serra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.021133', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2121, NULL, 2121, 'Pedrao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.022051', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2122, NULL, 2122, 'Pedro Alexandre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.022977', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2123, NULL, 2123, 'Piata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.023897', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2124, NULL, 2124, 'Pilao Arcado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.024776', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2125, NULL, 2125, 'Pindai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.025676', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2126, NULL, 2126, 'Pindobacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.026444', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2127, NULL, 2127, 'Pintadas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.027298', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2128, NULL, 2128, 'Pirai do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.028163', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2129, NULL, 2129, 'Piripa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.028991', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2130, NULL, 2130, 'Piritiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.02981', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2131, NULL, 2131, 'Planaltino', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.030618', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2132, NULL, 2132, 'Planalto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.037238', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2133, NULL, 2133, 'Pocoes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.038394', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2134, NULL, 2134, 'Pojuca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.039305', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2135, NULL, 2135, 'Ponto Novo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.040288', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2136, NULL, 2136, 'Porto Seguro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.041156', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2137, NULL, 2137, 'Potiragua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.042018', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2138, NULL, 2138, 'Prado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.042931', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2139, NULL, 2139, 'Presidente Dutra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.04386', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2140, NULL, 2140, 'Presidente Janio Quadros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.044678', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2141, NULL, 2141, 'Presidente Tancredo Neves', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.045568', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2142, NULL, 2142, 'Queimadas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.046592', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2143, NULL, 2143, 'Quijingue', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.047491', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2144, NULL, 2144, 'Quixabeira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.04839', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2145, NULL, 2145, 'Rafael Jambeiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.049242', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2146, NULL, 2146, 'Remanso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.050108', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2147, NULL, 2147, 'Retirolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.051116', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2148, NULL, 2148, 'Riachao das Neves', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.051964', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2149, NULL, 2149, 'Riachao do Jacuipe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.052816', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2150, NULL, 2150, 'Riacho de Santana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.053696', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2151, NULL, 2151, 'Ribeira do Amparo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.054615', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2152, NULL, 2152, 'Ribeira do Pombal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.055463', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2153, NULL, 2153, 'Ribeirao do Largo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.05629', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2154, NULL, 2154, 'Rio de Contas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.057205', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2155, NULL, 2155, 'Rio do Antonio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.058091', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2156, NULL, 2156, 'Rio do Pires', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.059061', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2157, NULL, 2157, 'Rio Real', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.0599', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2158, NULL, 2158, 'Rodelas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.060828', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2159, NULL, 2159, 'Ruy Barbosa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.061686', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2160, NULL, 2160, 'Salinas da Margarida', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.062613', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2161, NULL, 2161, 'Salvador', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.063432', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2162, NULL, 2162, 'Santa Barbara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.064199', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2163, NULL, 2163, 'Santa Brigida', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.065113', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2164, NULL, 2164, 'Santa Cruz Cabralia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.066096', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2165, NULL, 2165, 'Santa Cruz da Vitoria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.066868', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2166, NULL, 2166, 'Santa Ines', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.067781', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2167, NULL, 2167, 'Santa Luzia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.068555', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2168, NULL, 2168, 'Santa Maria da Vitoria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.069542', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2169, NULL, 2169, 'Santa Rita de Cassia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.070478', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2170, NULL, 2170, 'Santa Teresinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.071319', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2171, NULL, 2171, 'Santaluz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.081182', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2172, NULL, 2172, 'Santana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.082258', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2173, NULL, 2173, 'Santanopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.083118', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2174, NULL, 2174, 'Santo Amaro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.083992', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2175, NULL, 2175, 'Santo Antonio de Jesus', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.084795', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2176, NULL, 2176, 'Santo Estevao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.085639', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2177, NULL, 2177, 'Sao Desiderio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.086513', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2178, NULL, 2178, 'Sao Domingos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.087428', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2179, NULL, 2179, 'Sao Felipe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.088306', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2180, NULL, 2180, 'Sao Felix', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.089086', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2181, NULL, 2181, 'Sao Felix do Coribe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.089995', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2182, NULL, 2182, 'Sao Francisco do Conde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.09092', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2183, NULL, 2183, 'Sao Gabriel', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.091797', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2184, NULL, 2184, 'Sao Goncalo dos Campos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.092756', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2185, NULL, 2185, 'Sao Jose da Vitoria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.093833', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2186, NULL, 2186, 'Sao Jose do Jacuipe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.094768', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2187, NULL, 2187, 'Sao Miguel das Matas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.095662', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2188, NULL, 2188, 'Sao Sebastiao do Passe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.096542', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2189, NULL, 2189, 'Sapeacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.09736', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2190, NULL, 2190, 'Satiro Dias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.09819', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2191, NULL, 2191, 'Saubara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.099108', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2192, NULL, 2192, 'Saude', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.100012', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2193, NULL, 2193, 'Seabra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.100826', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2194, NULL, 2194, 'Sebastiao Laranjeiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.101718', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2195, NULL, 2195, 'Senhor do Bonfim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.102614', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2196, NULL, 2196, 'Sento Se', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.103547', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2197, NULL, 2197, 'Serra do Ramalho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.10448', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2198, NULL, 2198, 'Serra Dourada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.105375', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2199, NULL, 2199, 'Serra Preta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.106273', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2200, NULL, 2200, 'Serrinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.107175', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2201, NULL, 2201, 'Serrolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.108078', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2202, NULL, 2202, 'Simoes Filho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.108929', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2203, NULL, 2203, 'Sitio do Mato', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.109993', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2204, NULL, 2204, 'Sitio do Quinto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.11146', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2205, NULL, 2205, 'Sobradinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.112381', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2206, NULL, 2206, 'Souto Soares', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.113153', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2207, NULL, 2207, 'Tabocas do Brejo Velho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.113976', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2208, NULL, 2208, 'Tanhacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.114785', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2209, NULL, 2209, 'Tanque Novo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.121459', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2210, NULL, 2210, 'Tanquinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.122594', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2211, NULL, 2211, 'Taperoa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.123519', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2212, NULL, 2212, 'Tapiramuta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.124406', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2213, NULL, 2213, 'Teixeira de Freitas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.125229', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2214, NULL, 2214, 'Teodoro Sampaio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.126164', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2215, NULL, 2215, 'Teofilandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.127128', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2216, NULL, 2216, 'Teolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.128089', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2217, NULL, 2217, 'Terra Nova', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.129228', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2218, NULL, 2218, 'Tremedal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.130582', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2219, NULL, 2219, 'Tucano', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.132366', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2220, NULL, 2220, 'Uaua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.133639', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2221, NULL, 2221, 'Ubaira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.134487', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2222, NULL, 2222, 'Ubaitaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.135357', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2223, NULL, 2223, 'Ubata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.136179', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2224, NULL, 2224, 'Uibai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.136978', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2225, NULL, 2225, 'Umburanas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.137875', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2226, NULL, 2226, 'Una', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.138736', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2227, NULL, 2227, 'Urandi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.139603', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2228, NULL, 2228, 'Urucuca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.14047', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2229, NULL, 2229, 'Utinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.14136', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2230, NULL, 2230, 'Valenca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.142211', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2231, NULL, 2231, 'Valente', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.143101', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2232, NULL, 2232, 'Varzea da Roca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.144044', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2233, NULL, 2233, 'Varzea do Poco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.145026', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2234, NULL, 2234, 'Varzea Nova', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.145932', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2235, NULL, 2235, 'Varzedo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.146908', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2236, NULL, 2236, 'Vera Cruz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.147866', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2237, NULL, 2237, 'Vereda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.148738', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2238, NULL, 2238, 'Vitoria da Conquista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.149664', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2239, NULL, 2239, 'Wagner', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.150535', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2240, NULL, 2240, 'Wanderley', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.151529', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2241, NULL, 2241, 'Wenceslau Guimaraes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.152442', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2242, NULL, 2242, 'Xique-xique', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.153258', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2243, NULL, 2243, 'Abadia dos Dourados', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.154189', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2244, NULL, 2244, 'Abaete', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.155248', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2245, NULL, 2245, 'Abre Campo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.158797', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2246, NULL, 2246, 'Acaiaca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.164872', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2247, NULL, 2247, 'Acucena', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.166041', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2248, NULL, 2248, 'Agua Boa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.166914', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2249, NULL, 2249, 'Agua Comprida', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.167694', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2250, NULL, 2250, 'Aguanil', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.168652', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2251, NULL, 2251, 'Aguas Formosas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.169451', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2252, NULL, 2252, 'Aguas Vermelhas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.170365', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2253, NULL, 2253, 'Aimores', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.171249', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2254, NULL, 2254, 'Aiuruoca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.172198', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2255, NULL, 2255, 'Alagoa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.17309', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2256, NULL, 2256, 'Albertina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.174065', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2257, NULL, 2257, 'Alem Paraiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.175052', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2258, NULL, 2258, 'Alfenas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.176142', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2259, NULL, 2259, 'Alfredo Vasconcelos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.177086', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2260, NULL, 2260, 'Almenara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.17799', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2261, NULL, 2261, 'Alpercata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.178942', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2262, NULL, 2262, 'Alpinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.179848', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2263, NULL, 2263, 'Alterosa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.180759', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2264, NULL, 2264, 'Alto Caparao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.181657', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2265, NULL, 2265, 'Alto Jequitiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.182618', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2266, NULL, 2266, 'Alto Rio Doce', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.183515', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2267, NULL, 2267, 'Alvarenga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.184402', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2268, NULL, 2268, 'Alvinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.185229', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2269, NULL, 2269, 'Alvorada de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.186152', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2270, NULL, 2270, 'Amparo do Serra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.187321', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2271, NULL, 2271, 'Andradas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.188228', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2272, NULL, 2272, 'Andrelandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.189253', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2273, NULL, 2273, 'Angelandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.190148', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2274, NULL, 2274, 'Antonio Carlos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.19103', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2275, NULL, 2275, 'Antonio Dias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.191859', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2276, NULL, 2276, 'Antonio Prado de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.192799', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2277, NULL, 2277, 'Aracai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.193762', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2278, NULL, 2278, 'Aracitaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.194635', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2279, NULL, 2279, 'Aracuai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.195558', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2280, NULL, 2280, 'Araguari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.196367', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2281, NULL, 2281, 'Arantina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.197243', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2282, NULL, 2282, 'Araponga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.198178', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2283, NULL, 2283, 'Arapora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.203217', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2284, NULL, 2284, 'Arapua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.205244', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2285, NULL, 2285, 'Araujos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.206219', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2286, NULL, 2286, 'Araxa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.207117', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2287, NULL, 2287, 'Arceburgo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.207902', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2288, NULL, 2288, 'Arcos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.208814', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2289, NULL, 2289, 'Areado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.209723', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2290, NULL, 2290, 'Argirita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.210605', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2291, NULL, 2291, 'Aricanduva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.211483', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2292, NULL, 2292, 'Arinos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.212377', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2293, NULL, 2293, 'Astolfo Dutra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.213327', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2294, NULL, 2294, 'Ataleia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.214154', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2295, NULL, 2295, 'Augusto de Lima', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.21493', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2296, NULL, 2296, 'Baependi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.215936', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2297, NULL, 2297, 'Baldim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.216871', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2298, NULL, 2298, 'Bambui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.217768', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2299, NULL, 2299, 'Bandeira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.218649', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2300, NULL, 2300, 'Bandeira do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.219508', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2301, NULL, 2301, 'Barao de Cocais', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.220377', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2302, NULL, 2302, 'Barao de Monte Alto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.221268', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2303, NULL, 2303, 'Barbacena', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.222198', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2304, NULL, 2304, 'Barra Longa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.223036', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2305, NULL, 2305, 'Barroso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.22391', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2306, NULL, 2306, 'Bela Vista de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.224974', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2307, NULL, 2307, 'Belmiro Braga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.225963', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2308, NULL, 2308, 'Belo Horizonte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.227024', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2309, NULL, 2309, 'Belo Oriente', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.227973', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2310, NULL, 2310, 'Belo Vale', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.228893', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2311, NULL, 2311, 'Berilo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.229677', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2312, NULL, 2312, 'Berizal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.230571', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2313, NULL, 2313, 'Bertopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.23149', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2314, NULL, 2314, 'Betim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.232321', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2315, NULL, 2315, 'Bias Fortes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.233321', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2316, NULL, 2316, 'Bicas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.23414', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2317, NULL, 2317, 'Biquinhas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.234928', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2318, NULL, 2318, 'Boa Esperanca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.235855', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2319, NULL, 2319, 'Bocaina de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.236779', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2320, NULL, 2320, 'Bocaiuva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.23773', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2321, NULL, 2321, 'Bom Despacho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.23865', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2322, NULL, 2322, 'Bom Jardim de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.239378', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2323, NULL, 2323, 'Bom Jesus da Penha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.245946', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2324, NULL, 2324, 'Bom Jesus do Amparo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.246959', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2325, NULL, 2325, 'Bom Jesus do Galho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.247908', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2326, NULL, 2326, 'Bom Repouso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.248786', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2327, NULL, 2327, 'Bom Sucesso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.249675', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2328, NULL, 2328, 'Bonfim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.250542', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2329, NULL, 2329, 'Bonfinopolis de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.251343', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2330, NULL, 2330, 'Bonito de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.252162', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2331, NULL, 2331, 'Borda da Mata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.253039', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2332, NULL, 2332, 'Botelhos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.253931', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2333, NULL, 2333, 'Botumirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.254856', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2334, NULL, 2334, 'Bras Pires', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.255745', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2335, NULL, 2335, 'Brasilandia de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.256563', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2336, NULL, 2336, 'Brasilia de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.257427', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2337, NULL, 2337, 'Brasopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.258428', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2338, NULL, 2338, 'Braunas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.259273', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2339, NULL, 2339, 'Brumadinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.260042', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2340, NULL, 2340, 'Bueno Brandao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.260966', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2341, NULL, 2341, 'Buenopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.261895', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2342, NULL, 2342, 'Bugre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.262933', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2343, NULL, 2343, 'Buritis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.263793', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2344, NULL, 2344, 'Buritizeiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.264812', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2345, NULL, 2345, 'Cabeceira Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.265722', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2346, NULL, 2346, 'Cabo Verde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.266748', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2347, NULL, 2347, 'Cachoeira da Prata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.267638', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2348, NULL, 2348, 'Cachoeira de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.268607', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2349, NULL, 2349, 'Cachoeira de Pajeu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.269483', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2350, NULL, 2350, 'Cachoeira Dourada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.270382', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2351, NULL, 2351, 'Caetanopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.271481', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2352, NULL, 2352, 'Caete', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.272398', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2353, NULL, 2353, 'Caiana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.273259', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2354, NULL, 2354, 'Cajuri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.274121', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2355, NULL, 2355, 'Caldas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.275028', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2356, NULL, 2356, 'Camacho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.275929', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2357, NULL, 2357, 'Camanducaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.27681', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2358, NULL, 2358, 'Cambui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.277738', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2359, NULL, 2359, 'Cambuquira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.278606', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2360, NULL, 2360, 'Campanario', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.279653', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2361, NULL, 2361, 'Campanha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.28044', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2362, NULL, 2362, 'Campestre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.286607', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2363, NULL, 2363, 'Campina Verde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.287827', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2364, NULL, 2364, 'Campo Azul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.288775', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2365, NULL, 2365, 'Campo Belo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.289665', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2366, NULL, 2366, 'Campo do Meio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.290592', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2367, NULL, 2367, 'Campo Florido', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.291403', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2368, NULL, 2368, 'Campos Altos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.292443', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2369, NULL, 2369, 'Campos Gerais', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.293274', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2370, NULL, 2370, 'Cana Verde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.294208', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2371, NULL, 2371, 'Canaa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.295135', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2372, NULL, 2372, 'Canapolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.296192', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2373, NULL, 2373, 'Candeias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.297115', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2374, NULL, 2374, 'Cantagalo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.297958', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2375, NULL, 2375, 'Caparao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.298869', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2376, NULL, 2376, 'Capela Nova', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.299725', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2377, NULL, 2377, 'Capelinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.300742', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2378, NULL, 2378, 'Capetinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.301628', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2379, NULL, 2379, 'Capim Branco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.302484', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2380, NULL, 2380, 'Capinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.303332', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2381, NULL, 2381, 'Capitao Andrade', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.304204', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2382, NULL, 2382, 'Capitao Eneas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.304996', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2383, NULL, 2383, 'Capitolio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.305772', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2384, NULL, 2384, 'Caputira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.306769', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2385, NULL, 2385, 'Carai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.307704', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2386, NULL, 2386, 'Caranaiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.308589', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2387, NULL, 2387, 'Carandai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.309503', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2388, NULL, 2388, 'Carangola', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.310414', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2389, NULL, 2389, 'Caratinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.311411', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2390, NULL, 2390, 'Carbonita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.312275', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2391, NULL, 2391, 'Careacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.313165', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2392, NULL, 2392, 'Carlos Chagas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.313963', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2393, NULL, 2393, 'Carmesia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.31478', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2394, NULL, 2394, 'Carmo da Cachoeira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.31565', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2395, NULL, 2395, 'Carmo da Mata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.316547', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2396, NULL, 2396, 'Carmo de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.317444', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2397, NULL, 2397, 'Carmo do Cajuru', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.318302', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2398, NULL, 2398, 'Carmo do Paranaiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.319164', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2399, NULL, 2399, 'Carmo do Rio Claro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.320006', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2400, NULL, 2400, 'Carmopolis de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.326946', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2401, NULL, 2401, 'Carneirinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.328069', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2402, NULL, 2402, 'Carrancas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.328901', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2403, NULL, 2403, 'Carvalhopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.329932', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2404, NULL, 2404, 'Carvalhos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.33101', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2405, NULL, 2405, 'Casa Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.331982', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2406, NULL, 2406, 'Cascalho Rico', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.333627', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2407, NULL, 2407, 'Cassia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.334661', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2408, NULL, 2408, 'Cataguases', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.335576', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2409, NULL, 2409, 'Catas Altas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.336441', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2410, NULL, 2410, 'Catas Altas da Noruega', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.337408', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2411, NULL, 2411, 'Catuji', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.338303', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2412, NULL, 2412, 'Catuti', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.339177', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2413, NULL, 2413, 'Caxambu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.340022', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2414, NULL, 2414, 'Cedro do Abaete', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.3409', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2415, NULL, 2415, 'Central de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.341802', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2416, NULL, 2416, 'Centralina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.342707', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2417, NULL, 2417, 'Chacara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.343615', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2418, NULL, 2418, 'Chale', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.344519', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2419, NULL, 2419, 'Chapada do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.345402', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2420, NULL, 2420, 'Chapada Gaucha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.346221', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2421, NULL, 2421, 'Chiador', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.347172', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2422, NULL, 2422, 'Cipotanea', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.348109', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2423, NULL, 2423, 'Claraval', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.349067', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2424, NULL, 2424, 'Claro dos Pocoes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.349954', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2425, NULL, 2425, 'Claudio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.350815', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2426, NULL, 2426, 'Coimbra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.351681', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2427, NULL, 2427, 'Coluna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.352366', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2428, NULL, 2428, 'Comendador Gomes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.353256', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2429, NULL, 2429, 'Comercinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.354197', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2430, NULL, 2430, 'Conceicao da Aparecida', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.355049', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2431, NULL, 2431, 'Conceicao da Barra de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.356084', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2432, NULL, 2432, 'Conceicao das Alagoas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.356889', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2433, NULL, 2433, 'Conceicao das Pedras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.357787', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2434, NULL, 2434, 'Conceicao de Ipanema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.358793', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2435, NULL, 2435, 'Conceicao do Mato Dentro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.35965', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2436, NULL, 2436, 'Conceicao do Para', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.360602', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2437, NULL, 2437, 'Conceicao do Rio Verde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.367362', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2438, NULL, 2438, 'Conceicao dos Ouros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.368535', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2439, NULL, 2439, 'Conego Marinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.369512', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2440, NULL, 2440, 'Confins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.370463', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2441, NULL, 2441, 'Congonhal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.371375', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2442, NULL, 2442, 'Congonhas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.372194', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2443, NULL, 2443, 'Congonhas do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.37302', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2444, NULL, 2444, 'Conquista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.373929', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2445, NULL, 2445, 'Conselheiro Lafaiete', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.374849', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2446, NULL, 2446, 'Conselheiro Pena', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.375761', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2447, NULL, 2447, 'Consolacao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.376643', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2448, NULL, 2448, 'Contagem', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.377562', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2449, NULL, 2449, 'Coqueiral', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.37849', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2450, NULL, 2450, 'Coracao de Jesus', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.379263', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2451, NULL, 2451, 'Cordisburgo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.380177', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2452, NULL, 2452, 'Cordislandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.381011', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2453, NULL, 2453, 'Corinto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.381868', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2454, NULL, 2454, 'Coroaci', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.38272', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2455, NULL, 2455, 'Coromandel', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.38355', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2456, NULL, 2456, 'Coronel Fabriciano', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.384524', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2457, NULL, 2457, 'Coronel Murta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.385391', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2458, NULL, 2458, 'Coronel Pacheco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.386312', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2459, NULL, 2459, 'Coronel Xavier Chaves', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.387358', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2460, NULL, 2460, 'Corrego Danta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.388301', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2461, NULL, 2461, 'Corrego do Bom Jesus', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.389213', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2462, NULL, 2462, 'Corrego Fundo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.390263', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2463, NULL, 2463, 'Corrego Novo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.391202', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2464, NULL, 2464, 'Couto de Magalhaes de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.392311', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2465, NULL, 2465, 'Crisolita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.393212', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2466, NULL, 2466, 'Cristais', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.394167', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2467, NULL, 2467, 'Cristalia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.394971', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2468, NULL, 2468, 'Cristiano Otoni', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.395888', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2469, NULL, 2469, 'Cristina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.396852', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2470, NULL, 2470, 'Crucilandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.397656', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2471, NULL, 2471, 'Cruzeiro da Fortaleza', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.398422', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2472, NULL, 2472, 'Cruzilia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.399226', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2473, NULL, 2473, 'Cuparaque', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.400152', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2474, NULL, 2474, 'Curral de Dentro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.401352', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2475, NULL, 2475, 'Curvelo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.41163', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2476, NULL, 2476, 'Datas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.412738', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2477, NULL, 2477, 'Delfim Moreira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.413631', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2478, NULL, 2478, 'Delfinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.414454', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2479, NULL, 2479, 'Delta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.415301', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2480, NULL, 2480, 'Descoberto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.416181', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2481, NULL, 2481, 'Desterro de Entre Rios', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.417061', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2482, NULL, 2482, 'Desterro do Melo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.417919', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2483, NULL, 2483, 'Diamantina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.418797', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2484, NULL, 2484, 'Diogo de Vasconcelos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.41969', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2485, NULL, 2485, 'Dionisio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.420606', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2486, NULL, 2486, 'Divinesia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.421506', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2487, NULL, 2487, 'Divino', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.422311', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2488, NULL, 2488, 'Divino das Laranjeiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.423584', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2489, NULL, 2489, 'Divinolandia de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.424526', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2490, NULL, 2490, 'Divinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.425468', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2491, NULL, 2491, 'Divisa Alegre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.426294', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2492, NULL, 2492, 'Divisa Nova', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.427201', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2493, NULL, 2493, 'Divisopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.428217', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2494, NULL, 2494, 'Dom Bosco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.429142', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2495, NULL, 2495, 'Dom Cavati', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.430042', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2496, NULL, 2496, 'Dom Joaquim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.430968', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2497, NULL, 2497, 'Dom Silverio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.43188', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2498, NULL, 2498, 'Dom Vicoso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.432759', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2499, NULL, 2499, 'Dona Eusebia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.433829', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2500, NULL, 2500, 'Dores de Campos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.434737', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2501, NULL, 2501, 'Dores de Guanhaes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.435545', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2502, NULL, 2502, 'Dores do Indaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.436568', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2503, NULL, 2503, 'Dores do Turvo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.437482', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2504, NULL, 2504, 'Doresopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.438283', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2505, NULL, 2505, 'Douradoquara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.439165', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2506, NULL, 2506, 'Durande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.439988', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2507, NULL, 2507, 'Eloi Mendes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.440884', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2508, NULL, 2508, 'Engenheiro Caldas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.441795', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2509, NULL, 2509, 'Engenheiro Navarro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.442634', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2510, NULL, 2510, 'Entre Folhas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.44354', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2511, NULL, 2511, 'Entre Rios de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.444453', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2512, NULL, 2512, 'Ervalia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.445278', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2513, NULL, 2513, 'Esmeraldas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.451797', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2514, NULL, 2514, 'Espera Feliz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.452981', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2515, NULL, 2515, 'Espinosa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.453778', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2516, NULL, 2516, 'Espirito Santo do Dourado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.454654', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2517, NULL, 2517, 'Estiva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.4555', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2518, NULL, 2518, 'Estrela Dalva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.456458', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2519, NULL, 2519, 'Estrela do Indaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.457559', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2520, NULL, 2520, 'Estrela do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.458485', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2521, NULL, 2521, 'Eugenopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.459407', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2522, NULL, 2522, 'Ewbank da Camara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.460227', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2523, NULL, 2523, 'Extrema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.461085', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2524, NULL, 2524, 'Fama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.461955', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2525, NULL, 2525, 'Faria Lemos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.462875', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2526, NULL, 2526, 'Felicio dos Santos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.463927', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2527, NULL, 2527, 'Felisburgo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.464686', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2528, NULL, 2528, 'Felixlandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.465613', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2529, NULL, 2529, 'Fernandes Tourinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.46651', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2530, NULL, 2530, 'Ferros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.467262', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2531, NULL, 2531, 'Fervedouro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.468075', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2532, NULL, 2532, 'Florestal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.469065', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2533, NULL, 2533, 'Formiga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.469915', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2534, NULL, 2534, 'Formoso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.470866', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2535, NULL, 2535, 'Fortaleza de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.4718', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2536, NULL, 2536, 'Fortuna de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.472649', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2537, NULL, 2537, 'Francisco Badaro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.47366', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2538, NULL, 2538, 'Francisco Dumont', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.474555', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2539, NULL, 2539, 'Francisco Sa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.47544', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2540, NULL, 2540, 'Franciscopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.476315', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2541, NULL, 2541, 'Frei Gaspar', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.477184', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2542, NULL, 2542, 'Frei Inocencio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.478085', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2543, NULL, 2543, 'Frei Lagonegro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.478996', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2544, NULL, 2544, 'Fronteira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.479756', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2545, NULL, 2545, 'Fronteira dos Vales', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.480618', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2546, NULL, 2546, 'Fruta de Leite', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.481494', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2547, NULL, 2547, 'Frutal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.482274', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2548, NULL, 2548, 'Funilandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.483177', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2549, NULL, 2549, 'Galileia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.484093', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2550, NULL, 2550, 'Gameleiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.484955', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2551, NULL, 2551, 'Glaucilandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.485777', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2552, NULL, 2552, 'Goiabeira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.493322', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2553, NULL, 2553, 'Goiana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.494496', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2554, NULL, 2554, 'Goncalves', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.49536', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2555, NULL, 2555, 'Gonzaga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.496231', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2556, NULL, 2556, 'Gouveia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.497133', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2557, NULL, 2557, 'Governador Valadares', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.498098', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2558, NULL, 2558, 'Grao Mogol', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.498957', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2559, NULL, 2559, 'Grupiara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.499849', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2560, NULL, 2560, 'Guanhaes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.500653', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2561, NULL, 2561, 'Guape', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.501713', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2562, NULL, 2562, 'Guaraciaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.502633', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2563, NULL, 2563, 'Guaraciama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.503502', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2564, NULL, 2564, 'Guaranesia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.504369', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2565, NULL, 2565, 'Guarani', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.505195', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2566, NULL, 2566, 'Guarara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.506059', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2567, NULL, 2567, 'Guarda-mor', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.506895', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2568, NULL, 2568, 'Guaxupe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.507726', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2569, NULL, 2569, 'Guidoval', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.508808', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2570, NULL, 2570, 'Guimarania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.509736', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2571, NULL, 2571, 'Guiricema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.510664', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2572, NULL, 2572, 'Gurinhata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.51156', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2573, NULL, 2573, 'Heliodora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.512439', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2574, NULL, 2574, 'Iapu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.513288', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2575, NULL, 2575, 'Ibertioga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.514211', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2576, NULL, 2576, 'Ibia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.515149', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2577, NULL, 2577, 'Ibiai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.515973', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2578, NULL, 2578, 'Ibiracatu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.516767', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2579, NULL, 2579, 'Ibiraci', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.51756', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2580, NULL, 2580, 'Ibirite', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.518486', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2581, NULL, 2581, 'Ibitiura de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.519415', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2582, NULL, 2582, 'Ibituruna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.520237', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2583, NULL, 2583, 'Icarai de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.521141', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2584, NULL, 2584, 'Igarape', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.522171', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2585, NULL, 2585, 'Igaratinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.523975', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2586, NULL, 2586, 'Iguatama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.524916', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2587, NULL, 2587, 'Ijaci', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.525818', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2588, NULL, 2588, 'Ilicinea', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.526807', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2589, NULL, 2589, 'Imbe de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.527566', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2590, NULL, 2590, 'Inconfidentes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.534284', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2591, NULL, 2591, 'Indaiabira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.535355', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2592, NULL, 2592, 'Indianopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.536141', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2593, NULL, 2593, 'Ingai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.53695', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2594, NULL, 2594, 'Inhapim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.537926', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2595, NULL, 2595, 'Inhauma', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.538866', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2596, NULL, 2596, 'Inimutaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.539693', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2597, NULL, 2597, 'Ipaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.540615', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2598, NULL, 2598, 'Ipanema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.541477', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2599, NULL, 2599, 'Ipatinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.542301', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2600, NULL, 2600, 'Ipiacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.543088', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2601, NULL, 2601, 'Ipuiuna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.544006', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2602, NULL, 2602, 'Irai de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.544877', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2603, NULL, 2603, 'Itabira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.545641', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2604, NULL, 2604, 'Itabirinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.546423', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2605, NULL, 2605, 'Itabirito', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.547264', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2606, NULL, 2606, 'Itacambira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.54826', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2607, NULL, 2607, 'Itacarambi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.549333', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2608, NULL, 2608, 'Itaguara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.550259', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2609, NULL, 2609, 'Itaipe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.551156', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2610, NULL, 2610, 'Itajuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.552041', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2611, NULL, 2611, 'Itamarandiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.55291', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2612, NULL, 2612, 'Itamarati de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.553968', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2613, NULL, 2613, 'Itambacuri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.554843', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2614, NULL, 2614, 'Itambe do Mato Dentro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.555903', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2615, NULL, 2615, 'Itamogi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.556785', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2616, NULL, 2616, 'Itamonte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.557679', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2617, NULL, 2617, 'Itanhandu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.558486', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2618, NULL, 2618, 'Itanhomi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.559343', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2619, NULL, 2619, 'Itaobim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.560182', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2620, NULL, 2620, 'Itapagipe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.561129', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2621, NULL, 2621, 'Itapecerica', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.562045', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2622, NULL, 2622, 'Itapeva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.562886', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2623, NULL, 2623, 'Itatiaiucu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.56382', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2624, NULL, 2624, 'Itau de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.564738', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2625, NULL, 2625, 'Itauna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.565631', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2626, NULL, 2626, 'Itaverava', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.566539', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2627, NULL, 2627, 'Itinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.567443', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2628, NULL, 2628, 'Itueta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.574206', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2629, NULL, 2629, 'Ituiutaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.575462', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2630, NULL, 2630, 'Itumirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.576278', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2631, NULL, 2631, 'Iturama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.577299', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2632, NULL, 2632, 'Itutinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.578215', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2633, NULL, 2633, 'Jaboticatubas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.579155', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2634, NULL, 2634, 'Jacinto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.579934', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2635, NULL, 2635, 'Jacui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.580977', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2636, NULL, 2636, 'Jacutinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.581851', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2637, NULL, 2637, 'Jaguaracu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.582674', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2638, NULL, 2638, 'Jaiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.583605', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2639, NULL, 2639, 'Jampruca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.584486', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2640, NULL, 2640, 'Janauba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.585356', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2641, NULL, 2641, 'Januaria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.586257', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2642, NULL, 2642, 'Japaraiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.587138', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2643, NULL, 2643, 'Japonvar', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.58822', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2644, NULL, 2644, 'Jeceaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.589312', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2645, NULL, 2645, 'Jenipapo de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.590255', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2646, NULL, 2646, 'Jequeri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.591033', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2647, NULL, 2647, 'Jequitai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.592039', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2648, NULL, 2648, 'Jequitiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.592846', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2649, NULL, 2649, 'Jequitinhonha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.593621', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2650, NULL, 2650, 'Jesuania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.594594', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2651, NULL, 2651, 'Joaima', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.595575', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2652, NULL, 2652, 'Joanesia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.596474', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2653, NULL, 2653, 'Joao Monlevade', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.597362', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2654, NULL, 2654, 'Joao Pinheiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.59822', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2655, NULL, 2655, 'Joaquim Felicio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.599054', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2656, NULL, 2656, 'Jordania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.600016', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2657, NULL, 2657, 'Jose Goncalves de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.600945', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2658, NULL, 2658, 'Jose Raydan', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.602108', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2659, NULL, 2659, 'Josenopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.603016', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2660, NULL, 2660, 'Juatuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.604047', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2661, NULL, 2661, 'Juiz de Fora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.604952', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2662, NULL, 2662, 'Juramento', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.605847', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2663, NULL, 2663, 'Juruaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.606705', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2664, NULL, 2664, 'Juvenilia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.607706', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2665, NULL, 2665, 'Ladainha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.614724', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2666, NULL, 2666, 'Lagamar', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.615844', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2667, NULL, 2667, 'Lagoa da Prata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.616813', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2668, NULL, 2668, 'Lagoa dos Patos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.617738', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2669, NULL, 2669, 'Lagoa Dourada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.618698', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2670, NULL, 2670, 'Lagoa Formosa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.619622', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2671, NULL, 2671, 'Lagoa Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.620559', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2672, NULL, 2672, 'Lagoa Santa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.621608', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2673, NULL, 2673, 'Lajinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.622616', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2674, NULL, 2674, 'Lambari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.623675', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2675, NULL, 2675, 'Lamim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.624505', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2676, NULL, 2676, 'Laranjal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.625461', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2677, NULL, 2677, 'Lassance', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.626399', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2678, NULL, 2678, 'Lavras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.62728', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2679, NULL, 2679, 'Leandro Ferreira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.6282', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2680, NULL, 2680, 'Leme do Prado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.629003', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2681, NULL, 2681, 'Leopoldina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.629801', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2682, NULL, 2682, 'Liberdade', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.630694', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2683, NULL, 2683, 'Lima Duarte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.631701', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2684, NULL, 2684, 'Limeira do Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.632595', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2685, NULL, 2685, 'Lontra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.633499', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2686, NULL, 2686, 'Luisburgo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.634802', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2687, NULL, 2687, 'Luislandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.635773', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2688, NULL, 2688, 'Luminarias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.636597', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2689, NULL, 2689, 'Luz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.637763', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2690, NULL, 2690, 'Machacalis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.638736', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2691, NULL, 2691, 'Machado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.639667', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2692, NULL, 2692, 'Madre de Deus de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.640612', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2693, NULL, 2693, 'Malacacheta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.641441', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2694, NULL, 2694, 'Mamonas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.642344', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2695, NULL, 2695, 'Manga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.643242', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2696, NULL, 2696, 'Manhuacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.644213', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2697, NULL, 2697, 'Manhumirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.64516', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2698, NULL, 2698, 'Mantena', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.646202', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2699, NULL, 2699, 'Mar de Espanha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.647012', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2700, NULL, 2700, 'Maravilhas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.647968', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2701, NULL, 2701, 'Maria da Fe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.655614', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2702, NULL, 2702, 'Mariana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.656908', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2703, NULL, 2703, 'Marilac', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.65784', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2704, NULL, 2704, 'Mario Campos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.658689', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2705, NULL, 2705, 'Maripa de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.65953', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2706, NULL, 2706, 'Marlieria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.66046', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2707, NULL, 2707, 'Marmelopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.661483', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2708, NULL, 2708, 'Martinho Campos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.662437', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2709, NULL, 2709, 'Martins Soares', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.663486', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2710, NULL, 2710, 'Mata Verde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.664361', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2711, NULL, 2711, 'Materlandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.665305', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2712, NULL, 2712, 'Mateus Leme', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.666284', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2713, NULL, 2713, 'Mathias Lobato', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.667155', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2714, NULL, 2714, 'Matias Barbosa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.668037', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2715, NULL, 2715, 'Matias Cardoso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.668913', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2716, NULL, 2716, 'Matipo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.669963', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2717, NULL, 2717, 'Mato Verde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.670864', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2718, NULL, 2718, 'Matozinhos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.671823', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2719, NULL, 2719, 'Matutina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.672635', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2720, NULL, 2720, 'Medeiros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.673506', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2721, NULL, 2721, 'Medina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.674315', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2722, NULL, 2722, 'Mendes Pimentel', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.675195', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2723, NULL, 2723, 'Merces', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.676123', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2724, NULL, 2724, 'Mesquita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.677029', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2725, NULL, 2725, 'Minas Novas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.677866', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2726, NULL, 2726, 'Minduri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.67889', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2727, NULL, 2727, 'Mirabela', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.680059', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2728, NULL, 2728, 'Miradouro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.681017', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2729, NULL, 2729, 'Mirai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.681974', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2730, NULL, 2730, 'Miravania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.682921', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2731, NULL, 2731, 'Moeda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.683889', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2732, NULL, 2732, 'Moema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.684839', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2733, NULL, 2733, 'Monjolos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.685732', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2734, NULL, 2734, 'Monsenhor Paulo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.686645', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2735, NULL, 2735, 'Montalvania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.687406', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2736, NULL, 2736, 'Monte Alegre de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.688289', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2737, NULL, 2737, 'Monte Azul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.689257', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2738, NULL, 2738, 'Monte Belo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.696044', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2739, NULL, 2739, 'Monte Carmelo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.697125', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2740, NULL, 2740, 'Monte Formoso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.698007', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2741, NULL, 2741, 'Monte Santo de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.699102', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2742, NULL, 2742, 'Monte Siao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.699867', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2743, NULL, 2743, 'Montes Claros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.700683', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2744, NULL, 2744, 'Montezuma', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.701663', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2745, NULL, 2745, 'Morada Nova de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.702366', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2746, NULL, 2746, 'Morro da Garca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.703301', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2747, NULL, 2747, 'Morro do Pilar', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.70427', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2748, NULL, 2748, 'Munhoz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.705223', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2749, NULL, 2749, 'Muriae', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.706065', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2750, NULL, 2750, 'Mutum', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.706975', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2751, NULL, 2751, 'Muzambinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.707858', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2752, NULL, 2752, 'Nacip Raydan', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.70873', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2753, NULL, 2753, 'Nanuque', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.709584', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2754, NULL, 2754, 'Naque', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.710678', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2755, NULL, 2755, 'Natalandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.711561', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2756, NULL, 2756, 'Natercia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.712473', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2757, NULL, 2757, 'Nazareno', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.71354', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2758, NULL, 2758, 'Nepomuceno', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.714525', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2759, NULL, 2759, 'Ninheira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.715406', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2760, NULL, 2760, 'Nova Belem', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.716339', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2761, NULL, 2761, 'Nova Era', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.71725', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2762, NULL, 2762, 'Nova Lima', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.718111', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2763, NULL, 2763, 'Nova Modica', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.719056', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2764, NULL, 2764, 'Nova Ponte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.720149', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2765, NULL, 2765, 'Nova Porteirinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.721149', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2766, NULL, 2766, 'Nova Resende', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.722075', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2767, NULL, 2767, 'Nova Serrana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.7229', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2768, NULL, 2768, 'Nova Uniao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.723765', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2769, NULL, 2769, 'Novo Cruzeiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.724744', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2770, NULL, 2770, 'Novo Oriente de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.725723', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2771, NULL, 2771, 'Novorizonte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.726657', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2772, NULL, 2772, 'Olaria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.727589', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2773, NULL, 2773, 'Olhos-d Agua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.728505', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2774, NULL, 2774, 'Olimpio Noronha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.729493', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2775, NULL, 2775, 'Oliveira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.740384', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2776, NULL, 2776, 'Oliveira Fortes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.74145', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2777, NULL, 2777, 'Onca de Pitangui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.742313', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2778, NULL, 2778, 'Oratorios', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.7431', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2779, NULL, 2779, 'Orizania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.743935', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2780, NULL, 2780, 'Ouro Branco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.744933', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2781, NULL, 2781, 'Ouro Fino', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.745729', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2782, NULL, 2782, 'Ouro Preto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.746597', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2783, NULL, 2783, 'Ouro Verde de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.747426', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2784, NULL, 2784, 'Padre Carvalho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.748246', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2785, NULL, 2785, 'Padre Paraiso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.749321', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2786, NULL, 2786, 'Pai Pedro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.750259', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2787, NULL, 2787, 'Paineiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.75118', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2788, NULL, 2788, 'Pains', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.752016', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2789, NULL, 2789, 'Paiva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.753119', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2790, NULL, 2790, 'Palma', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.754061', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2791, NULL, 2791, 'Palmopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.755117', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2792, NULL, 2792, 'Papagaios', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.75607', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2793, NULL, 2793, 'Para de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.756968', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2794, NULL, 2794, 'Paracatu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.757955', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2795, NULL, 2795, 'Paraguacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.758826', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2796, NULL, 2796, 'Paraisopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.759698', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2797, NULL, 2797, 'Paraopeba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.76053', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2798, NULL, 2798, 'Passa Quatro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.761404', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2799, NULL, 2799, 'Passa Tempo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.762299', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2800, NULL, 2800, 'Passa Vinte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.763219', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2801, NULL, 2801, 'Passabem', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.764189', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2802, NULL, 2802, 'Passos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.765124', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2803, NULL, 2803, 'Patis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.766075', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2804, NULL, 2804, 'Patos de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.766987', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2805, NULL, 2805, 'Patrocinio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.767808', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2806, NULL, 2806, 'Patrocinio do Muriae', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.768792', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2807, NULL, 2807, 'Paula Candido', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.769602', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2808, NULL, 2808, 'Paulistas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.770548', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2809, NULL, 2809, 'Pavao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.771502', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2810, NULL, 2810, 'Pecanha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.772442', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2811, NULL, 2811, 'Pedra Azul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.773367', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2812, NULL, 2812, 'Pedra Bonita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.774198', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2813, NULL, 2813, 'Pedra do Anta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.781051', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2814, NULL, 2814, 'Pedra do Indaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.782165', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2815, NULL, 2815, 'Pedra Dourada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.783151', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2816, NULL, 2816, 'Pedralva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.784071', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2817, NULL, 2817, 'Pedras de Maria da Cruz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.784969', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2818, NULL, 2818, 'Pedrinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.785949', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2819, NULL, 2819, 'Pedro Leopoldo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.786904', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2820, NULL, 2820, 'Pedro Teixeira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.787893', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2821, NULL, 2821, 'Pequeri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.788918', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2822, NULL, 2822, 'Pequi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.789785', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2823, NULL, 2823, 'Perdigao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.790748', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2824, NULL, 2824, 'Perdizes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.791688', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2825, NULL, 2825, 'Perdoes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.792564', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2826, NULL, 2826, 'Periquito', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.793428', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2827, NULL, 2827, 'Pescador', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.79428', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2828, NULL, 2828, 'Piau', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.795255', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2829, NULL, 2829, 'Piedade de Caratinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.796196', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2830, NULL, 2830, 'Piedade de Ponte Nova', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.797037', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2831, NULL, 2831, 'Piedade do Rio Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.797938', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2832, NULL, 2832, 'Piedade dos Gerais', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.798806', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2833, NULL, 2833, 'Pimenta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.799797', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2834, NULL, 2834, 'Pingo D Agua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.80073', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2835, NULL, 2835, 'Pintopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.801687', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2836, NULL, 2836, 'Piracema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.802868', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2837, NULL, 2837, 'Pirajuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.803785', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2838, NULL, 2838, 'Piranga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.804725', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2839, NULL, 2839, 'Pirangucu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.805698', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2840, NULL, 2840, 'Piranguinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.806615', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2841, NULL, 2841, 'Pirapetinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.807535', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2842, NULL, 2842, 'Pirapora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.80837', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2843, NULL, 2843, 'Pirauba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.809281', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2844, NULL, 2844, 'Pitangui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.810255', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2845, NULL, 2845, 'Piumhi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.811233', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2846, NULL, 2846, 'Planura', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.812132', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2847, NULL, 2847, 'Poco Fundo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.813128', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2848, NULL, 2848, 'Pocos de Caldas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.814049', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2849, NULL, 2849, 'Pocrane', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.814882', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2850, NULL, 2850, 'Pompeu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.822131', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2851, NULL, 2851, 'Ponte Nova', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.823253', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2852, NULL, 2852, 'Ponto Chique', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.824088', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2853, NULL, 2853, 'Ponto dos Volantes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.825103', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2854, NULL, 2854, 'Porteirinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.82606', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2855, NULL, 2855, 'Porto Firme', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.827004', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2856, NULL, 2856, 'Pote', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.828002', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2857, NULL, 2857, 'Pouso Alegre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.828959', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2858, NULL, 2858, 'Pouso Alto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.830054', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2859, NULL, 2859, 'Prados', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.830956', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2860, NULL, 2860, 'Prata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.831842', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2861, NULL, 2861, 'Pratapolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.832742', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2862, NULL, 2862, 'Pratinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.833628', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2863, NULL, 2863, 'Presidente Bernardes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.834501', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2864, NULL, 2864, 'Presidente Juscelino', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.836256', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2865, NULL, 2865, 'Presidente Kubitschek', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.837166', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2866, NULL, 2866, 'Presidente Olegario', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.838125', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2867, NULL, 2867, 'Prudente de Morais', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.839006', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2868, NULL, 2868, 'Quartel Geral', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.839868', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2869, NULL, 2869, 'Queluzito', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.840797', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2870, NULL, 2870, 'Raposos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.84164', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2871, NULL, 2871, 'Raul Soares', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.842576', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2872, NULL, 2872, 'Recreio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.843754', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2873, NULL, 2873, 'Reduto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.844654', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2874, NULL, 2874, 'Resende Costa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.845628', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2875, NULL, 2875, 'Resplendor', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.846633', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2876, NULL, 2876, 'Ressaquinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.847458', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2877, NULL, 2877, 'Riachinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.848378', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2878, NULL, 2878, 'Riacho dos Machados', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.849254', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2879, NULL, 2879, 'Ribeirao das Neves', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.850149', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2880, NULL, 2880, 'Ribeirao Vermelho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.851048', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2881, NULL, 2881, 'Rio Acima', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.852061', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2882, NULL, 2882, 'Rio Casca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.852976', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2883, NULL, 2883, 'Rio do Prado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.853875', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2884, NULL, 2884, 'Rio Doce', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.854683', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2885, NULL, 2885, 'Rio Espera', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.855684', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2886, NULL, 2886, 'Rio Manso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.856476', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2887, NULL, 2887, 'Rio Novo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.863208', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2888, NULL, 2888, 'Rio Paranaiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.86423', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2889, NULL, 2889, 'Rio Pardo de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.865113', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2890, NULL, 2890, 'Rio Piracicaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.866003', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2891, NULL, 2891, 'Rio Pomba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.866718', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2892, NULL, 2892, 'Rio Preto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.86757', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2893, NULL, 2893, 'Rio Vermelho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.868466', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2894, NULL, 2894, 'Ritapolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.86965', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2895, NULL, 2895, 'Rochedo de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.870574', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2896, NULL, 2896, 'Rodeiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.87147', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2897, NULL, 2897, 'Romaria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.872334', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2898, NULL, 2898, 'Rosario da Limeira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.873188', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2899, NULL, 2899, 'Rubelita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.873986', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2900, NULL, 2900, 'Rubim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.874865', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2901, NULL, 2901, 'Sabara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.875998', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2902, NULL, 2902, 'Sabinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.876908', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2903, NULL, 2903, 'Sacramento', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.877892', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2904, NULL, 2904, 'Salinas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.878715', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2905, NULL, 2905, 'Salto da Divisa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.87963', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2906, NULL, 2906, 'Santa Barbara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.880788', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2907, NULL, 2907, 'Santa Barbara do Leste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.881713', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2908, NULL, 2908, 'Santa Barbara do Monte Verde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.882576', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2909, NULL, 2909, 'Santa Barbara do Tugurio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.883499', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2910, NULL, 2910, 'Santa Cruz de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.884331', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2911, NULL, 2911, 'Santa Cruz de Salinas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.885373', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2912, NULL, 2912, 'Santa Cruz do Escalvado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.886231', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2913, NULL, 2913, 'Santa Efigenia de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.887023', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2914, NULL, 2914, 'Santa Fe de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.887823', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2915, NULL, 2915, 'Santa Helena de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.888613', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2916, NULL, 2916, 'Santa Juliana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.889436', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2917, NULL, 2917, 'Santa Luzia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.890286', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2918, NULL, 2918, 'Santa Margarida', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.891179', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2919, NULL, 2919, 'Santa Maria de Itabira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.892071', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2920, NULL, 2920, 'Santa Maria do Salto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.893033', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2921, NULL, 2921, 'Santa Maria do Suacui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.893934', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2922, NULL, 2922, 'Santa Rita de Caldas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.894802', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2923, NULL, 2923, 'Santa Rita de Ibitipoca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.895661', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2924, NULL, 2924, 'Santa Rita de Jacutinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.896554', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2925, NULL, 2925, 'Santa Rita de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.90317', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2926, NULL, 2926, 'Santa Rita do Itueto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.904334', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2927, NULL, 2927, 'Santa Rita do Sapucai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.905188', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2928, NULL, 2928, 'Santa Rosa da Serra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.906002', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2929, NULL, 2929, 'Santa Vitoria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.906897', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2930, NULL, 2930, 'Santana da Vargem', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.90782', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2931, NULL, 2931, 'Santana de Cataguases', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.908562', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2932, NULL, 2932, 'Santana de Pirapama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.909396', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2933, NULL, 2933, 'Santana do Deserto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.91025', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2934, NULL, 2934, 'Santana do Garambeu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.911172', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2935, NULL, 2935, 'Santana do Jacare', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.912087', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2936, NULL, 2936, 'Santana do Manhuacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.912919', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2937, NULL, 2937, 'Santana do Paraiso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.913893', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2938, NULL, 2938, 'Santana do Riacho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.914701', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2939, NULL, 2939, 'Santana dos Montes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.915635', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2940, NULL, 2940, 'Santo Antonio do Amparo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.916561', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2941, NULL, 2941, 'Santo Antonio do Aventureiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.917522', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2942, NULL, 2942, 'Santo Antonio do Grama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.918259', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2943, NULL, 2943, 'Santo Antonio do Itambe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.919652', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2944, NULL, 2944, 'Santo Antonio do Jacinto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.920493', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2945, NULL, 2945, 'Santo Antonio do Monte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.921488', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2946, NULL, 2946, 'Santo Antonio do Retiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.922448', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2947, NULL, 2947, 'Santo Antonio do Rio Abaixo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.923338', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2948, NULL, 2948, 'Santo Hipolito', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.924169', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2949, NULL, 2949, 'Santos Dumont', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.925463', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2950, NULL, 2950, 'Sao Bento Abade', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.926405', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2951, NULL, 2951, 'Sao Bras do Suacui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.927261', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2952, NULL, 2952, 'Sao Domingos das Dores', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.928137', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2953, NULL, 2953, 'Sao Domingos do Prata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.928974', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2954, NULL, 2954, 'Sao Felix de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.929859', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2955, NULL, 2955, 'Sao Francisco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.930685', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2956, NULL, 2956, 'Sao Francisco de Paula', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.931488', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2957, NULL, 2957, 'Sao Francisco de Sales', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.932267', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2958, NULL, 2958, 'Sao Francisco do Gloria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.933213', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2959, NULL, 2959, 'Sao Geraldo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.934103', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2960, NULL, 2960, 'Sao Geraldo da Piedade', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.935011', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2961, NULL, 2961, 'Sao Geraldo do Baixio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.935934', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2962, NULL, 2962, 'Sao Goncalo do Abaete', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.936778', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2963, NULL, 2963, 'Sao Goncalo do Para', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.944008', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2964, NULL, 2964, 'Sao Goncalo do Rio Abaixo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.945446', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2965, NULL, 2965, 'Sao Goncalo do Rio Preto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.947525', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2966, NULL, 2966, 'Sao Goncalo do Sapucai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.948415', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2967, NULL, 2967, 'Sao Gotardo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.949358', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2968, NULL, 2968, 'Sao Joao Batista do Gloria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.950284', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2969, NULL, 2969, 'Sao Joao da Lagoa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.951373', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2970, NULL, 2970, 'Sao Joao da Mata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.952414', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2971, NULL, 2971, 'Sao Joao da Ponte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.95334', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2972, NULL, 2972, 'Sao Joao das Missoes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.954242', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2973, NULL, 2973, 'Sao Joao Del Rei', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.955094', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2974, NULL, 2974, 'Sao Joao do Manhuacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.955927', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2975, NULL, 2975, 'Sao Joao do Manteninha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.956767', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2976, NULL, 2976, 'Sao Joao do Oriente', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.957553', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2977, NULL, 2977, 'Sao Joao do Pacui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.958462', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2978, NULL, 2978, 'Sao Joao do Paraiso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.959259', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2979, NULL, 2979, 'Sao Joao Evangelista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.960178', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2980, NULL, 2980, 'Sao Joao Nepomuceno', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.961059', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2981, NULL, 2981, 'Sao Joaquim de Bicas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.962029', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2982, NULL, 2982, 'Sao Jose da Barra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.962922', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2983, NULL, 2983, 'Sao Jose da Lapa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.963826', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2984, NULL, 2984, 'Sao Jose da Safira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.964717', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2985, NULL, 2985, 'Sao Jose da Varginha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.965573', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2986, NULL, 2986, 'Sao Jose do Alegre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.966464', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2987, NULL, 2987, 'Sao Jose do Divino', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.967302', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2988, NULL, 2988, 'Sao Jose do Goiabal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.968161', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2989, NULL, 2989, 'Sao Jose do Jacuri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.969054', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2990, NULL, 2990, 'Sao Jose do Mantimento', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.970124', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2991, NULL, 2991, 'Sao Lourenco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.97104', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2992, NULL, 2992, 'Sao Miguel do Anta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.971941', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2993, NULL, 2993, 'Sao Pedro da Uniao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.972841', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2994, NULL, 2994, 'Sao Pedro do Suacui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.973711', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2995, NULL, 2995, 'Sao Pedro dos Ferros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.974488', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2996, NULL, 2996, 'Sao Romao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.975409', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2997, NULL, 2997, 'Sao Roque de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.976377', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2998, NULL, 2998, 'Sao Sebastiao da Bela Vista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.977178', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (2999, NULL, 2999, 'Sao Sebastiao da Vargem Alegre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.97811', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3000, NULL, 3000, 'Sao Sebastiao do Anta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.984627', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3001, NULL, 3001, 'Sao Sebastiao do Maranhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.985785', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3002, NULL, 3002, 'Sao Sebastiao do Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.986709', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3003, NULL, 3003, 'Sao Sebastiao do Paraiso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.987623', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3004, NULL, 3004, 'Sao Sebastiao do Rio Preto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.988553', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3005, NULL, 3005, 'Sao Sebastiao do Rio Verde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.989525', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3006, NULL, 3006, 'Sao Thome das Letras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.990503', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3007, NULL, 3007, 'Sao Tiago', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.991371', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3008, NULL, 3008, 'Sao Tomas de Aquino', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.992485', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3009, NULL, 3009, 'Sao Vicente de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.993316', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3010, NULL, 3010, 'Sapucai-mirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.994126', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3011, NULL, 3011, 'Sardoa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.995033', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3012, NULL, 3012, 'Sarzedo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.995979', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3013, NULL, 3013, 'Sem Peixe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.996865', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3014, NULL, 3014, 'Senador Amaral', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.997785', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3015, NULL, 3015, 'Senador Cortes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.998572', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3016, NULL, 3016, 'Senador Firmino', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:36.999432', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3017, NULL, 3017, 'Senador Jose Bento', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.000242', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3018, NULL, 3018, 'Senador Modestino Goncalves', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.001181', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3019, NULL, 3019, 'Senhora de Oliveira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.002238', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3020, NULL, 3020, 'Senhora do Porto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.003123', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3021, NULL, 3021, 'Senhora dos Remedios', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.003942', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3022, NULL, 3022, 'Sericita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.004806', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3023, NULL, 3023, 'Seritinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.00583', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3024, NULL, 3024, 'Serra Azul de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.006724', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3025, NULL, 3025, 'Serra da Saudade', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.007597', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3026, NULL, 3026, 'Serra do Salitre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.008494', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3027, NULL, 3027, 'Serra dos Aimores', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.00936', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3028, NULL, 3028, 'Serrania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.010257', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3029, NULL, 3029, 'Serranopolis de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.011126', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3030, NULL, 3030, 'Serranos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.011947', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3031, NULL, 3031, 'Serro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.012745', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3032, NULL, 3032, 'Sete Lagoas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.013654', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3033, NULL, 3033, 'Setubinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.014708', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3034, NULL, 3034, 'Silveirania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.015627', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3035, NULL, 3035, 'Silvianopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.016489', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3036, NULL, 3036, 'Simao Pereira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.017459', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3037, NULL, 3037, 'Simonesia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.018331', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3038, NULL, 3038, 'Sobralia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.024929', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3039, NULL, 3039, 'Soledade de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.026211', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3040, NULL, 3040, 'Tabuleiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.027116', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3041, NULL, 3041, 'Taiobeiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.027909', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3042, NULL, 3042, 'Taparuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.028691', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3043, NULL, 3043, 'Tapira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.029455', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3044, NULL, 3044, 'Tapirai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.030502', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3045, NULL, 3045, 'Taquaracu de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.031405', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3046, NULL, 3046, 'Tarumirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.032341', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3047, NULL, 3047, 'Teixeiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.033084', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3048, NULL, 3048, 'Teofilo Otoni', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.034005', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3049, NULL, 3049, 'Timoteo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.034877', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3050, NULL, 3050, 'Tiradentes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.035717', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3051, NULL, 3051, 'Tiros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.036438', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3052, NULL, 3052, 'Tocantins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.037378', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3053, NULL, 3053, 'Tocos do Mogi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.038237', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3054, NULL, 3054, 'Toledo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.039162', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3055, NULL, 3055, 'Tombos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.040058', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3056, NULL, 3056, 'Tres Coracoes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.040906', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3057, NULL, 3057, 'Tres Marias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.0418', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3058, NULL, 3058, 'Tres Pontas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.042593', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3059, NULL, 3059, 'Tumiritinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.043498', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3060, NULL, 3060, 'Tupaciguara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.044437', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3061, NULL, 3061, 'Turmalina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.045367', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3062, NULL, 3062, 'Turvolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.04633', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3063, NULL, 3063, 'Uba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.047362', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3064, NULL, 3064, 'Ubai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.048359', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3065, NULL, 3065, 'Ubaporanga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.049243', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3066, NULL, 3066, 'Uberaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.050224', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3067, NULL, 3067, 'Uberlandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.051156', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3068, NULL, 3068, 'Umburatiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.052078', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3069, NULL, 3069, 'Unai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.052956', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3070, NULL, 3070, 'Uniao de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.05387', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3071, NULL, 3071, 'Uruana de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.054766', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3072, NULL, 3072, 'Urucania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.055651', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3073, NULL, 3073, 'Urucuia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.056552', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3074, NULL, 3074, 'Vargem Alegre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.057453', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3075, NULL, 3075, 'Vargem Bonita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.058481', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3076, NULL, 3076, 'Vargem Grande do Rio Pardo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.05921', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3077, NULL, 3077, 'Varginha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.065668', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3078, NULL, 3078, 'Varjao de Minas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.066741', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3079, NULL, 3079, 'Varzea da Palma', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.067629', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3080, NULL, 3080, 'Varzelandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.068499', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3081, NULL, 3081, 'Vazante', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.069738', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3082, NULL, 3082, 'Verdelandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.070607', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3083, NULL, 3083, 'Veredinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.071486', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3084, NULL, 3084, 'Verissimo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.072355', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3085, NULL, 3085, 'Vermelho Novo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.073251', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3086, NULL, 3086, 'Vespasiano', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.074104', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3087, NULL, 3087, 'Vicosa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.074933', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3088, NULL, 3088, 'Vieiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.075846', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3089, NULL, 3089, 'Virgem da Lapa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.076853', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3090, NULL, 3090, 'Virginia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.077734', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3091, NULL, 3091, 'Virginopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.078589', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3092, NULL, 3092, 'Virgolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.079515', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3093, NULL, 3093, 'Visconde do Rio Branco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.080291', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3094, NULL, 3094, 'Volta Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.081204', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3095, NULL, 3095, 'Wenceslau Braz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.081973', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3096, NULL, 3096, 'Afonso Claudio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.082886', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3097, NULL, 3097, 'Agua Doce do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.08375', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3098, NULL, 3098, 'Aguia Branca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.084678', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3099, NULL, 3099, 'Alegre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.085605', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3100, NULL, 3100, 'Alfredo Chaves', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.086469', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3101, NULL, 3101, 'Alto Rio Novo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.087312', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3102, NULL, 3102, 'Anchieta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.088204', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3103, NULL, 3103, 'Apiaca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.089062', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3104, NULL, 3104, 'Aracruz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.089943', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3105, NULL, 3105, 'Atilio Vivacqua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.09086', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3106, NULL, 3106, 'Baixo Guandu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.091737', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3107, NULL, 3107, 'Barra de Sao Francisco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.092835', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3108, NULL, 3108, 'Boa Esperanca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.093704', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3109, NULL, 3109, 'Bom Jesus do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.094622', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3110, NULL, 3110, 'Brejetuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.095495', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3111, NULL, 3111, 'Cachoeiro de Itapemirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.096312', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3112, NULL, 3112, 'Cariacica', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.097169', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3113, NULL, 3113, 'Castelo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.09809', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3114, NULL, 3114, 'Colatina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.099011', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3115, NULL, 3115, 'Conceicao da Barra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.105545', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3116, NULL, 3116, 'Conceicao do Castelo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.106749', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3117, NULL, 3117, 'Divino de Sao Lourenco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.107684', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3118, NULL, 3118, 'Domingos Martins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.108581', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3119, NULL, 3119, 'Dores do Rio Preto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.109452', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3120, NULL, 3120, 'Ecoporanga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.110394', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3121, NULL, 3121, 'Fundao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.111308', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3122, NULL, 3122, 'Governador Lindenberg', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.112208', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3123, NULL, 3123, 'Guacui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.113153', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3124, NULL, 3124, 'Guarapari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.11402', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3125, NULL, 3125, 'Ibatiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.11507', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3126, NULL, 3126, 'Ibiracu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.115945', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3127, NULL, 3127, 'Ibitirama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.116851', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3128, NULL, 3128, 'Iconha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.117854', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3129, NULL, 3129, 'Irupi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.118674', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3130, NULL, 3130, 'Itaguacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.119498', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3131, NULL, 3131, 'Itapemirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.120273', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3132, NULL, 3132, 'Itarana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.12108', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3133, NULL, 3133, 'Iuna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.122057', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3134, NULL, 3134, 'Jaguare', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.122973', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3135, NULL, 3135, 'Jeronimo Monteiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.123854', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3136, NULL, 3136, 'Joao Neiva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.124735', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3137, NULL, 3137, 'Laranja da Terra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.125741', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3138, NULL, 3138, 'Linhares', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.126641', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3139, NULL, 3139, 'Mantenopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.127556', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3140, NULL, 3140, 'Marataizes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.128435', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3141, NULL, 3141, 'Marechal Floriano', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.129304', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3142, NULL, 3142, 'Marilandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.130149', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3143, NULL, 3143, 'Mimoso do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.131032', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3144, NULL, 3144, 'Montanha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.131767', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3145, NULL, 3145, 'Mucurici', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.132669', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3146, NULL, 3146, 'Muniz Freire', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.133579', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3147, NULL, 3147, 'Muqui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.13436', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3148, NULL, 3148, 'Nova Venecia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.135185', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3149, NULL, 3149, 'Pancas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.136062', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3150, NULL, 3150, 'Pedro Canario', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.137029', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3151, NULL, 3151, 'Pinheiros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.13779', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3152, NULL, 3152, 'Piuma', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.138726', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3153, NULL, 3153, 'Ponto Belo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.139504', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3154, NULL, 3154, 'Presidente Kennedy', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.146339', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3155, NULL, 3155, 'Rio Bananal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.150463', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3156, NULL, 3156, 'Rio Novo do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.151418', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3157, NULL, 3157, 'Santa Leopoldina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.152323', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3158, NULL, 3158, 'Santa Maria de Jetiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.153183', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3159, NULL, 3159, 'Santa Teresa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.154075', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3160, NULL, 3160, 'Sao Domingos do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.154905', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3161, NULL, 3161, 'Sao Gabriel da Palha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.15581', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3162, NULL, 3162, 'Sao Jose do Calcado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.156713', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3163, NULL, 3163, 'Sao Mateus', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.157706', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3164, NULL, 3164, 'Sao Roque do Canaa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.158648', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3165, NULL, 3165, 'Serra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.159594', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3166, NULL, 3166, 'Sooretama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.160485', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3167, NULL, 3167, 'Vargem Alta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.161405', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3168, NULL, 3168, 'Venda Nova do Imigrante', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.162222', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3169, NULL, 3169, 'Viana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.163119', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3170, NULL, 3170, 'Vila Pavao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.164134', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3171, NULL, 3171, 'Vila Valerio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.165005', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3172, NULL, 3172, 'Vila Velha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.165861', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3173, NULL, 3173, 'Vitoria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.166749', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3174, NULL, 3174, 'Angra dos Reis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.16759', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3175, NULL, 3175, 'Aperibe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.168353', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3176, NULL, 3176, 'Araruama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.169167', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3177, NULL, 3177, 'Areal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.170131', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3178, NULL, 3178, 'Armacao dos Buzios', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.171024', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3179, NULL, 3179, 'Arraial do Cabo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.171933', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3180, NULL, 3180, 'Barra do Pirai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.172817', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3181, NULL, 3181, 'Barra Mansa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.173722', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3182, NULL, 3182, 'Belford Roxo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.174593', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3183, NULL, 3183, 'Bom Jardim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.175369', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3184, NULL, 3184, 'Bom Jesus do Itabapoana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.17623', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3185, NULL, 3185, 'Cabo Frio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.177146', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3186, NULL, 3186, 'Cachoeiras de Macacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.178064', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3187, NULL, 3187, 'Cambuci', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.178988', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3188, NULL, 3188, 'Campos dos Goytacazes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.17996', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3189, NULL, 3189, 'Cantagalo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.187376', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3190, NULL, 3190, 'Carapebus', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.188539', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3191, NULL, 3191, 'Cardoso Moreira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.189489', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3192, NULL, 3192, 'Carmo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.190376', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3193, NULL, 3193, 'Casimiro de Abreu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.191224', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3194, NULL, 3194, 'Comendador Levy Gasparian', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.192154', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3195, NULL, 3195, 'Conceicao de Macabu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.193182', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3196, NULL, 3196, 'Cordeiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.194114', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3197, NULL, 3197, 'Duas Barras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.195152', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3198, NULL, 3198, 'Duque de Caxias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.195978', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3199, NULL, 3199, 'Engenheiro Paulo de Frontin', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.197016', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3200, NULL, 3200, 'Guapimirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.197975', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3201, NULL, 3201, 'Iguaba Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.198896', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3202, NULL, 3202, 'Itaborai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.199823', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3203, NULL, 3203, 'Itaguai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.200615', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3204, NULL, 3204, 'Italva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.201573', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3205, NULL, 3205, 'Itaocara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.202472', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3206, NULL, 3206, 'Itaperuna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.203303', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3207, NULL, 3207, 'Itatiaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.204383', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3208, NULL, 3208, 'Japeri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.20529', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3209, NULL, 3209, 'Laje do Muriae', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.206148', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3210, NULL, 3210, 'Macae', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.207034', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3211, NULL, 3211, 'Macuco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.207887', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3212, NULL, 3212, 'Mage', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.208742', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3213, NULL, 3213, 'Mangaratiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.209642', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3214, NULL, 3214, 'Marica', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.210561', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3215, NULL, 3215, 'Mendes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.211426', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3216, NULL, 3216, 'Mesquita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.212248', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3217, NULL, 3217, 'Miguel Pereira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.21322', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3218, NULL, 3218, 'Miracema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.214025', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3219, NULL, 3219, 'Natividade', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.214987', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3220, NULL, 3220, 'Nilopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.215631', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3221, NULL, 3221, 'Niteroi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.216575', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3222, NULL, 3222, 'Nova Friburgo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.217505', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3223, NULL, 3223, 'Nova Iguacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.218374', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3224, NULL, 3224, 'Paracambi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.219241', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3225, NULL, 3225, 'Paraiba do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.22011', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3226, NULL, 3226, 'Parati', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.221078', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3227, NULL, 3227, 'Paty do Alferes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.227898', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3228, NULL, 3228, 'Petropolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.22905', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3229, NULL, 3229, 'Pinheiral', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.229964', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3230, NULL, 3230, 'Pirai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.230972', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3231, NULL, 3231, 'Porciuncula', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.231958', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3232, NULL, 3232, 'Porto Real', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.232847', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3233, NULL, 3233, 'Quatis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.233751', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3234, NULL, 3234, 'Queimados', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.234722', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3235, NULL, 3235, 'Quissama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.235676', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3236, NULL, 3236, 'Resende', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.236633', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3237, NULL, 3237, 'Rio Bonito', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.238008', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3238, NULL, 3238, 'Rio Claro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.238923', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3239, NULL, 3239, 'Rio das Flores', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.239799', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3240, NULL, 3240, 'Rio das Ostras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.24067', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3241, NULL, 3241, 'Rio de Janeiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.241514', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3242, NULL, 3242, 'Santa Maria Madalena', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.242392', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3243, NULL, 3243, 'Santo Antonio de Padua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.24326', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3244, NULL, 3244, 'Sao Fidelis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.244209', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3245, NULL, 3245, 'Sao Francisco de Itabapoana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.244999', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3246, NULL, 3246, 'Sao Goncalo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.245904', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3247, NULL, 3247, 'Sao Joao da Barra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.24683', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3248, NULL, 3248, 'Sao Joao de Meriti', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.24777', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3249, NULL, 3249, 'Sao Jose de Uba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.248945', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3250, NULL, 3250, 'Sao Jose do Vale do Rio Preto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.249825', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3251, NULL, 3251, 'Sao Pedro da Aldeia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.250587', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3252, NULL, 3252, 'Sao Sebastiao do Alto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.251419', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3253, NULL, 3253, 'Sapucaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.252236', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3254, NULL, 3254, 'Saquarema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.253149', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3255, NULL, 3255, 'Seropedica', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.254076', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3256, NULL, 3256, 'Silva Jardim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.254876', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3257, NULL, 3257, 'Sumidouro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.255796', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3258, NULL, 3258, 'Tangua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.256693', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3259, NULL, 3259, 'Teresopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.257579', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3260, NULL, 3260, 'Trajano de Morais', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.258533', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3261, NULL, 3261, 'Tres Rios', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.259558', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3262, NULL, 3262, 'Valenca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.260357', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3263, NULL, 3263, 'Varre-sai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.261201', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3264, NULL, 3264, 'Vassouras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.262061', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3265, NULL, 3265, 'Volta Redonda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.268581', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3266, NULL, 3266, 'Adamantina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.269835', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3267, NULL, 3267, 'Adolfo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.27087', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3268, NULL, 3268, 'Aguai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.27173', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3269, NULL, 3269, 'Aguas da Prata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.272445', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3270, NULL, 3270, 'Aguas de Lindoia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.273402', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3271, NULL, 3271, 'Aguas de Santa Barbara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.274253', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3272, NULL, 3272, 'Aguas de Sao Pedro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.275125', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3273, NULL, 3273, 'Agudos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.276017', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3274, NULL, 3274, 'Alambari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.276922', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3275, NULL, 3275, 'Alfredo Marcondes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.277864', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3276, NULL, 3276, 'Altair', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.278774', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3277, NULL, 3277, 'Altinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.279605', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3278, NULL, 3278, 'Alto Alegre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.280491', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3279, NULL, 3279, 'Aluminio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.281409', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3280, NULL, 3280, 'Alvares Florence', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.282369', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3281, NULL, 3281, 'Alvares Machado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.283238', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3282, NULL, 3282, 'Alvaro de Carvalho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.284169', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3283, NULL, 3283, 'Alvinlandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.285077', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3284, NULL, 3284, 'Americana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.286013', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3285, NULL, 3285, 'Americo Brasiliense', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.286803', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3286, NULL, 3286, 'Americo de Campos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.287738', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3287, NULL, 3287, 'Amparo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.288607', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3288, NULL, 3288, 'Analandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.2895', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3289, NULL, 3289, 'Andradina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.290456', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3290, NULL, 3290, 'Angatuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.291244', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3291, NULL, 3291, 'Anhembi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.29216', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3292, NULL, 3292, 'Anhumas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.293119', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3293, NULL, 3293, 'Aparecida', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.293914', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3294, NULL, 3294, 'Aparecida D''oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.294812', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3295, NULL, 3295, 'Apiai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.295701', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3296, NULL, 3296, 'Aracariguama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.29661', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3297, NULL, 3297, 'Aracatuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.297483', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3298, NULL, 3298, 'Aracoiaba da Serra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.298305', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3299, NULL, 3299, 'Aramina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.299187', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3300, NULL, 3300, 'Arandu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.299986', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3301, NULL, 3301, 'Arapei', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.300898', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3302, NULL, 3302, 'Araraquara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.301802', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3303, NULL, 3303, 'Araras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.308817', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3304, NULL, 3304, 'Arco-iris', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.31001', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3305, NULL, 3305, 'Arealva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.311055', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3306, NULL, 3306, 'Areias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.31192', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3307, NULL, 3307, 'Areiopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.312751', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3308, NULL, 3308, 'Ariranha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.313577', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3309, NULL, 3309, 'Artur Nogueira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.314489', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3310, NULL, 3310, 'Aruja', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.315495', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3311, NULL, 3311, 'Aspasia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.316308', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3312, NULL, 3312, 'Assis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.317358', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3313, NULL, 3313, 'Atibaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.318277', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3314, NULL, 3314, 'Auriflama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.319244', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3315, NULL, 3315, 'Avai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.320115', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3316, NULL, 3316, 'Avanhandava', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.320988', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3317, NULL, 3317, 'Avare', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.321877', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3318, NULL, 3318, 'Bady Bassitt', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.322788', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3319, NULL, 3319, 'Balbinos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.32373', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3320, NULL, 3320, 'Balsamo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.324586', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3321, NULL, 3321, 'Bananal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.325482', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3322, NULL, 3322, 'Barao de Antonina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.326512', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3323, NULL, 3323, 'Barbosa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.327365', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3324, NULL, 3324, 'Bariri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.328252', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3325, NULL, 3325, 'Barra Bonita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.329113', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3326, NULL, 3326, 'Barra do Chapeu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.329955', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3327, NULL, 3327, 'Barra do Turvo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.330965', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3328, NULL, 3328, 'Barretos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.331935', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3329, NULL, 3329, 'Barrinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.332765', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3330, NULL, 3330, 'Barueri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.333592', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3331, NULL, 3331, 'Bastos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.334547', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3332, NULL, 3332, 'Batatais', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.33538', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3333, NULL, 3333, 'Bauru', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.336251', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3334, NULL, 3334, 'Bebedouro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.337171', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3335, NULL, 3335, 'Bento de Abreu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.338264', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3336, NULL, 3336, 'Bernardino de Campos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.339179', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3337, NULL, 3337, 'Bertioga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.340015', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3338, NULL, 3338, 'Bilac', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.340826', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3339, NULL, 3339, 'Birigui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.341697', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3340, NULL, 3340, 'Biritiba-mirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.342549', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3341, NULL, 3341, 'Boa Esperanca do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.350287', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3342, NULL, 3342, 'Bocaina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.351429', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3343, NULL, 3343, 'Bofete', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.352408', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3344, NULL, 3344, 'Boituva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.353564', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3345, NULL, 3345, 'Bom Jesus dos Perdoes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.354421', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3346, NULL, 3346, 'Bom Sucesso de Itarare', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.355449', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3347, NULL, 3347, 'Bora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.356379', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3348, NULL, 3348, 'Boraceia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.357481', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3349, NULL, 3349, 'Borborema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.358426', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3350, NULL, 3350, 'Borebi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.359296', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3351, NULL, 3351, 'Botucatu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.360376', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3352, NULL, 3352, 'Braganca Paulista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.361423', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3353, NULL, 3353, 'Brauna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.362273', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3354, NULL, 3354, 'Brejo Alegre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.363155', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3355, NULL, 3355, 'Brodowski', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.364124', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3356, NULL, 3356, 'Brotas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.365052', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3357, NULL, 3357, 'Buri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.366004', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3358, NULL, 3358, 'Buritama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.366945', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3359, NULL, 3359, 'Buritizal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.367895', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3360, NULL, 3360, 'Cabralia Paulista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.368816', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3361, NULL, 3361, 'Cabreuva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.369719', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3362, NULL, 3362, 'Cacapava', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.370627', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3363, NULL, 3363, 'Cachoeira Paulista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.371763', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3364, NULL, 3364, 'Caconde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.372711', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3365, NULL, 3365, 'Cafelandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.373562', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3366, NULL, 3366, 'Caiabu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.374476', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3367, NULL, 3367, 'Caieiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.375453', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3368, NULL, 3368, 'Caiua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.37635', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3369, NULL, 3369, 'Cajamar', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.377277', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3370, NULL, 3370, 'Cajati', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.378209', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3371, NULL, 3371, 'Cajobi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.379165', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3372, NULL, 3372, 'Cajuru', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.380188', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3373, NULL, 3373, 'Campina do Monte Alegre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.381138', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3374, NULL, 3374, 'Campinas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.381967', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3375, NULL, 3375, 'Campo Limpo Paulista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.382892', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3376, NULL, 3376, 'Campos do Jordao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.384015', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3377, NULL, 3377, 'Campos Novos Paulista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.390894', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3378, NULL, 3378, 'Cananeia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.392104', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3379, NULL, 3379, 'Canas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.393199', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3380, NULL, 3380, 'Candido Mota', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.394055', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3381, NULL, 3381, 'Candido Rodrigues', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.39493', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3382, NULL, 3382, 'Canitar', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.395858', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3383, NULL, 3383, 'Capao Bonito', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.39675', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3384, NULL, 3384, 'Capela do Alto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.397713', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3385, NULL, 3385, 'Capivari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.398691', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3386, NULL, 3386, 'Caraguatatuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.399692', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3387, NULL, 3387, 'Carapicuiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.400634', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3388, NULL, 3388, 'Cardoso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.401562', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3389, NULL, 3389, 'Casa Branca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.40251', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3390, NULL, 3390, 'Cassia dos Coqueiros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.403415', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3391, NULL, 3391, 'Castilho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.4044', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3392, NULL, 3392, 'Catanduva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.405192', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3393, NULL, 3393, 'Catigua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.406069', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3394, NULL, 3394, 'Cedral', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.407007', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3395, NULL, 3395, 'Cerqueira Cesar', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.407879', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3396, NULL, 3396, 'Cerquilho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.408712', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3397, NULL, 3397, 'Cesario Lange', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.409578', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3398, NULL, 3398, 'Charqueada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.410493', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3399, NULL, 3399, 'Chavantes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.411516', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3400, NULL, 3400, 'Clementina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.412407', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3401, NULL, 3401, 'Colina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.413332', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3402, NULL, 3402, 'Colombia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.41435', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3403, NULL, 3403, 'Conchal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.415259', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3404, NULL, 3404, 'Conchas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.416408', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3405, NULL, 3405, 'Cordeiropolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.417364', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3406, NULL, 3406, 'Coroados', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.418209', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3407, NULL, 3407, 'Coronel Macedo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.41912', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3408, NULL, 3408, 'Corumbatai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.420001', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3409, NULL, 3409, 'Cosmopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.420964', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3410, NULL, 3410, 'Cosmorama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.421879', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3411, NULL, 3411, 'Cotia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.422822', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3412, NULL, 3412, 'Cravinhos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.423659', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3413, NULL, 3413, 'Cristais Paulista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.424565', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3414, NULL, 3414, 'Cruzalia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.433202', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3415, NULL, 3415, 'Cruzeiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.43419', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3416, NULL, 3416, 'Cubatao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.435124', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3417, NULL, 3417, 'Cunha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.436005', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3418, NULL, 3418, 'Descalvado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.436909', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3419, NULL, 3419, 'Diadema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.43802', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3420, NULL, 3420, 'Dirce Reis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.438961', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3421, NULL, 3421, 'Divinolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.439881', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3422, NULL, 3422, 'Dobrada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.44092', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3423, NULL, 3423, 'Dois Corregos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.441834', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3424, NULL, 3424, 'Dolcinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.442609', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3425, NULL, 3425, 'Dourado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.443543', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3426, NULL, 3426, 'Dracena', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.444476', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3427, NULL, 3427, 'Duartina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.445394', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3428, NULL, 3428, 'Dumont', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.44637', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3429, NULL, 3429, 'Echapora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.447249', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3430, NULL, 3430, 'Eldorado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.448152', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3431, NULL, 3431, 'Elias Fausto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.449197', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3432, NULL, 3432, 'Elisiario', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.450013', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3433, NULL, 3433, 'Embauba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.450854', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3434, NULL, 3434, 'Embu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.451765', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3435, NULL, 3435, 'Embu-guacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.452864', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3436, NULL, 3436, 'Emilianopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.453877', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3437, NULL, 3437, 'Engenheiro Coelho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.454824', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3438, NULL, 3438, 'Espirito Santo do Pinhal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.455702', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3439, NULL, 3439, 'Espirito Santo do Turvo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.456596', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3440, NULL, 3440, 'Estiva Gerbi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.459826', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3441, NULL, 3441, 'Estrela do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.463187', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3442, NULL, 3442, 'Estrela D''oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.464626', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3443, NULL, 3443, 'Euclides da Cunha Paulista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.465815', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3444, NULL, 3444, 'Fartura', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.467149', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3445, NULL, 3445, 'Fernando Prestes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.468296', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3446, NULL, 3446, 'Fernandopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.474339', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3447, NULL, 3447, 'Fernao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.475403', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3448, NULL, 3448, 'Ferraz de Vasconcelos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.476418', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3449, NULL, 3449, 'Flora Rica', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.477443', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3450, NULL, 3450, 'Floreal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.478415', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3451, NULL, 3451, 'Florida Paulista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.479622', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3452, NULL, 3452, 'Florinia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.480544', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3453, NULL, 3453, 'Franca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.481469', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3454, NULL, 3454, 'Francisco Morato', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.482394', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3455, NULL, 3455, 'Franco da Rocha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.483499', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3456, NULL, 3456, 'Gabriel Monteiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.484411', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3457, NULL, 3457, 'Galia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.485277', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3458, NULL, 3458, 'Garca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.486137', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3459, NULL, 3459, 'Gastao Vidigal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.487262', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3460, NULL, 3460, 'Gaviao Peixoto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.488275', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3461, NULL, 3461, 'General Salgado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.489182', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3462, NULL, 3462, 'Getulina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.490105', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3463, NULL, 3463, 'Glicerio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.491081', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3464, NULL, 3464, 'Guaicara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.49205', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3465, NULL, 3465, 'Guaimbe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.492981', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3466, NULL, 3466, 'Guaira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.493861', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3467, NULL, 3467, 'Guapiacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.494824', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3468, NULL, 3468, 'Guapiara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.495711', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3469, NULL, 3469, 'Guara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.49662', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3470, NULL, 3470, 'Guaracai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.497498', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3471, NULL, 3471, 'Guaraci', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.498609', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3472, NULL, 3472, 'Guarani D''oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.499582', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3473, NULL, 3473, 'Guaranta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.500522', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3474, NULL, 3474, 'Guararapes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.501478', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3475, NULL, 3475, 'Guararema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.502457', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3476, NULL, 3476, 'Guaratingueta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.503375', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3477, NULL, 3477, 'Guarei', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.504252', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3478, NULL, 3478, 'Guariba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.50542', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3479, NULL, 3479, 'Guaruja', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.506355', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3480, NULL, 3480, 'Guarulhos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.50736', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3481, NULL, 3481, 'Guatapara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.514491', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3482, NULL, 3482, 'Guzolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.51563', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3483, NULL, 3483, 'Herculandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.516787', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3484, NULL, 3484, 'Holambra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.517506', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3485, NULL, 3485, 'Hortolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.518326', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3486, NULL, 3486, 'Iacanga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.519603', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3487, NULL, 3487, 'Iacri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.520661', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3488, NULL, 3488, 'Iaras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.521549', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3489, NULL, 3489, 'Ibate', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.522424', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3490, NULL, 3490, 'Ibira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.52329', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3491, NULL, 3491, 'Ibirarema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.524224', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3492, NULL, 3492, 'Ibitinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.525141', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3493, NULL, 3493, 'Ibiuna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.526048', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3494, NULL, 3494, 'Icem', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.526892', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3495, NULL, 3495, 'Iepe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.527707', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3496, NULL, 3496, 'Igaracu do Tiete', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.528553', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3497, NULL, 3497, 'Igarapava', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.5295', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3498, NULL, 3498, 'Igarata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.530465', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3499, NULL, 3499, 'Iguape', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.531632', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3500, NULL, 3500, 'Ilha Comprida', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.532647', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3501, NULL, 3501, 'Ilha Solteira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.533656', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3502, NULL, 3502, 'Ilhabela', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.534591', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3503, NULL, 3503, 'Indaiatuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.53556', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3504, NULL, 3504, 'Indiana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.536463', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3505, NULL, 3505, 'Indiapora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.537406', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3506, NULL, 3506, 'Inubia Paulista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.538346', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3507, NULL, 3507, 'Ipaussu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.539122', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3508, NULL, 3508, 'Ipero', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.540114', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3509, NULL, 3509, 'Ipeuna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.54106', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3510, NULL, 3510, 'Ipigua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.542009', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3511, NULL, 3511, 'Iporanga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.542934', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3512, NULL, 3512, 'Ipua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.543761', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3513, NULL, 3513, 'Iracemapolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.544853', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3514, NULL, 3514, 'Irapua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.545807', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3515, NULL, 3515, 'Irapuru', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.546727', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3516, NULL, 3516, 'Itabera', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.54776', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3517, NULL, 3517, 'Itai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.555415', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3518, NULL, 3518, 'Itajobi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.556639', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3519, NULL, 3519, 'Itaju', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.557538', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3520, NULL, 3520, 'Itanhaem', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.558368', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3521, NULL, 3521, 'Itaoca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.559349', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3522, NULL, 3522, 'Itapecerica da Serra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.560304', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3523, NULL, 3523, 'Itapetininga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.561226', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3524, NULL, 3524, 'Itapeva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.562042', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3525, NULL, 3525, 'Itapevi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.563', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3526, NULL, 3526, 'Itapira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.564035', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3527, NULL, 3527, 'Itapirapua Paulista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.564976', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3528, NULL, 3528, 'Itapolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.565875', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3529, NULL, 3529, 'Itaporanga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.566665', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3530, NULL, 3530, 'Itapui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.567469', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3531, NULL, 3531, 'Itapura', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.568248', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3532, NULL, 3532, 'Itaquaquecetuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.569268', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3533, NULL, 3533, 'Itarare', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.570327', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3534, NULL, 3534, 'Itariri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.571116', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3535, NULL, 3535, 'Itatiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.572068', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3536, NULL, 3536, 'Itatinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.572867', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3537, NULL, 3537, 'Itirapina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.57366', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3538, NULL, 3538, 'Itirapua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.574547', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3539, NULL, 3539, 'Itobi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.57546', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3540, NULL, 3540, 'Itu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.576321', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3541, NULL, 3541, 'Itupeva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.577536', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3542, NULL, 3542, 'Ituverava', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.578426', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3543, NULL, 3543, 'Jaborandi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.579392', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3544, NULL, 3544, 'Jaboticabal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.58031', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3545, NULL, 3545, 'Jacarei', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.581242', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3546, NULL, 3546, 'Jaci', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.582181', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3547, NULL, 3547, 'Jacupiranga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.583183', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3548, NULL, 3548, 'Jaguariuna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.583988', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3549, NULL, 3549, 'Jales', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.584901', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3550, NULL, 3550, 'Jambeiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.585854', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3551, NULL, 3551, 'Jandira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.586757', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3552, NULL, 3552, 'Jardinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.587586', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3553, NULL, 3553, 'Jarinu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.588515', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3554, NULL, 3554, 'Jau', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.589433', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3555, NULL, 3555, 'Jeriquara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.590483', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3556, NULL, 3556, 'Joanopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.596351', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3557, NULL, 3557, 'Joao Ramalho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.597603', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3558, NULL, 3558, 'Jose Bonifacio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.59875', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3559, NULL, 3559, 'Julio Mesquita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.599726', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3560, NULL, 3560, 'Jumirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.600794', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3561, NULL, 3561, 'Jundiai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.601706', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3562, NULL, 3562, 'Junqueiropolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.602591', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3563, NULL, 3563, 'Juquia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.603635', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3564, NULL, 3564, 'Juquitiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.604582', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3565, NULL, 3565, 'Lagoinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.605474', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3566, NULL, 3566, 'Laranjal Paulista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.607194', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3567, NULL, 3567, 'Lavinia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.608188', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3568, NULL, 3568, 'Lavrinhas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.60912', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3569, NULL, 3569, 'Leme', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.609957', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3570, NULL, 3570, 'Lencois Paulista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.611063', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3571, NULL, 3571, 'Limeira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.612034', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3572, NULL, 3572, 'Lindoia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.613045', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3573, NULL, 3573, 'Lins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.613865', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3574, NULL, 3574, 'Lorena', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.61467', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3575, NULL, 3575, 'Lourdes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.615605', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3576, NULL, 3576, 'Louveira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.616624', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3577, NULL, 3577, 'Lucelia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.617438', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3578, NULL, 3578, 'Lucianopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.618341', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3579, NULL, 3579, 'Luis Antonio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.619193', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3580, NULL, 3580, 'Luiziania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.620134', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3581, NULL, 3581, 'Lupercio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.621094', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3582, NULL, 3582, 'Lutecia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.62201', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3583, NULL, 3583, 'Macatuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.622926', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3584, NULL, 3584, 'Macaubal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.623778', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3585, NULL, 3585, 'Macedonia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.624723', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3586, NULL, 3586, 'Magda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.625616', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3587, NULL, 3587, 'Mairinque', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.62654', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3588, NULL, 3588, 'Mairipora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.627638', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3589, NULL, 3589, 'Manduri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.628439', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3590, NULL, 3590, 'Maraba Paulista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.629383', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3591, NULL, 3591, 'Maracai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.636541', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3592, NULL, 3592, 'Marapoama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.63785', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3593, NULL, 3593, 'Mariapolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.638856', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3594, NULL, 3594, 'Marilia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.639554', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3595, NULL, 3595, 'Marinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.640522', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3596, NULL, 3596, 'Martinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.641428', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3597, NULL, 3597, 'Matao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.642269', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3598, NULL, 3598, 'Maua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.643236', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3599, NULL, 3599, 'Mendonca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.644256', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3600, NULL, 3600, 'Meridiano', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.645169', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3601, NULL, 3601, 'Mesopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.64605', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3602, NULL, 3602, 'Miguelopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.646934', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3603, NULL, 3603, 'Mineiros do Tiete', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.647811', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3604, NULL, 3604, 'Mira Estrela', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.648659', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3605, NULL, 3605, 'Miracatu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.649539', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3606, NULL, 3606, 'Mirandopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.650507', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3607, NULL, 3607, 'Mirante do Paranapanema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.651428', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3608, NULL, 3608, 'Mirassol', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.652283', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3609, NULL, 3609, 'Mirassolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.653107', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3610, NULL, 3610, 'Mococa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.65403', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3611, NULL, 3611, 'Mogi das Cruzes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.654934', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3612, NULL, 3612, 'Mogi Guacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.655912', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3613, NULL, 3613, 'Mogi Mirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.656906', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3614, NULL, 3614, 'Mombuca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.65768', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3615, NULL, 3615, 'Moncoes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.658653', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3616, NULL, 3616, 'Mongagua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.6595', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3617, NULL, 3617, 'Monte Alegre do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.66052', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3618, NULL, 3618, 'Monte Alto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.661636', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3619, NULL, 3619, 'Monte Aprazivel', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.662504', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3620, NULL, 3620, 'Monte Azul Paulista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.663455', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3621, NULL, 3621, 'Monte Castelo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.664378', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3622, NULL, 3622, 'Monte Mor', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.665291', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3623, NULL, 3623, 'Monteiro Lobato', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.66621', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3624, NULL, 3624, 'Morro Agudo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.667129', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3625, NULL, 3625, 'Morungaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.6681', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3626, NULL, 3626, 'Motuca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.669012', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3627, NULL, 3627, 'Murutinga do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.669991', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3628, NULL, 3628, 'Nantes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.677087', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3629, NULL, 3629, 'Narandiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.678371', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3630, NULL, 3630, 'Natividade da Serra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.6794', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3631, NULL, 3631, 'Nazare Paulista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.680367', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3632, NULL, 3632, 'Neves Paulista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.681221', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3633, NULL, 3633, 'Nhandeara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.682247', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3634, NULL, 3634, 'Nipoa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.683209', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3635, NULL, 3635, 'Nova Alianca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.684071', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3636, NULL, 3636, 'Nova Campina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.685019', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3637, NULL, 3637, 'Nova Canaa Paulista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.685923', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3638, NULL, 3638, 'Nova Castilho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.68688', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3639, NULL, 3639, 'Nova Europa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.687744', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3640, NULL, 3640, 'Nova Granada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.688615', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3641, NULL, 3641, 'Nova Guataporanga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.689453', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3642, NULL, 3642, 'Nova Independencia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.69033', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3643, NULL, 3643, 'Nova Luzitania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.69125', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3644, NULL, 3644, 'Nova Odessa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.692148', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3645, NULL, 3645, 'Novais', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.693025', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3646, NULL, 3646, 'Novo Horizonte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.693881', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3647, NULL, 3647, 'Nuporanga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.694756', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3648, NULL, 3648, 'Ocaucu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.695695', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3649, NULL, 3649, 'Oleo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.696598', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3650, NULL, 3650, 'Olimpia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.697503', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3651, NULL, 3651, 'Onda Verde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.698381', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3652, NULL, 3652, 'Oriente', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.699328', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3653, NULL, 3653, 'Orindiuva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.700226', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3654, NULL, 3654, 'Orlandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.70113', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3655, NULL, 3655, 'Osasco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.702113', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3656, NULL, 3656, 'Oscar Bressane', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.703017', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3657, NULL, 3657, 'Osvaldo Cruz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.703902', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3658, NULL, 3658, 'Ourinhos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.704848', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3659, NULL, 3659, 'Ouro Verde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.705842', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3660, NULL, 3660, 'Ouroeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.706649', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3661, NULL, 3661, 'Pacaembu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.707503', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3662, NULL, 3662, 'Palestina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.708316', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3663, NULL, 3663, 'Palmares Paulista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.7091', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3664, NULL, 3664, 'Palmeira D''oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.709909', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3665, NULL, 3665, 'Palmital', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.710909', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3666, NULL, 3666, 'Panorama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.71165', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3667, NULL, 3667, 'Paraguacu Paulista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.7191', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3668, NULL, 3668, 'Paraibuna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.720228', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3669, NULL, 3669, 'Paraiso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.721111', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3670, NULL, 3670, 'Paranapanema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.722043', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3671, NULL, 3671, 'Paranapua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.72293', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3672, NULL, 3672, 'Parapua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.723768', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3673, NULL, 3673, 'Pardinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.72461', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3674, NULL, 3674, 'Pariquera-acu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.725544', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3675, NULL, 3675, 'Parisi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.726416', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3676, NULL, 3676, 'Patrocinio Paulista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.727324', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3677, NULL, 3677, 'Pauliceia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.728179', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3678, NULL, 3678, 'Paulinia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.729059', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3679, NULL, 3679, 'Paulistania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.730037', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3680, NULL, 3680, 'Paulo de Faria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.730894', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3681, NULL, 3681, 'Pederneiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.731757', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3682, NULL, 3682, 'Pedra Bela', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.732587', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3683, NULL, 3683, 'Pedranopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.733429', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3684, NULL, 3684, 'Pedregulho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.73431', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3685, NULL, 3685, 'Pedreira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.735221', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3686, NULL, 3686, 'Pedrinhas Paulista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.736151', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3687, NULL, 3687, 'Pedro de Toledo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.737085', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3688, NULL, 3688, 'Penapolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.738028', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3689, NULL, 3689, 'Pereira Barreto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.738983', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3690, NULL, 3690, 'Pereiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.73982', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3691, NULL, 3691, 'Peruibe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.740635', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3692, NULL, 3692, 'Piacatu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.741532', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3693, NULL, 3693, 'Piedade', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.742468', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3694, NULL, 3694, 'Pilar do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.743483', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3695, NULL, 3695, 'Pindamonhangaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.744333', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3696, NULL, 3696, 'Pindorama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.745185', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3697, NULL, 3697, 'Pinhalzinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.746103', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3698, NULL, 3698, 'Piquerobi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.747239', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3699, NULL, 3699, 'Piquete', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.748177', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3700, NULL, 3700, 'Piracaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.749108', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3701, NULL, 3701, 'Piracicaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.750017', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3702, NULL, 3702, 'Piraju', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.751064', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3703, NULL, 3703, 'Pirajui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.752015', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3704, NULL, 3704, 'Pirangi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.759139', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3705, NULL, 3705, 'Pirapora do Bom Jesus', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.760398', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3706, NULL, 3706, 'Pirapozinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.761455', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3707, NULL, 3707, 'Pirassununga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.762332', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3708, NULL, 3708, 'Piratininga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.76325', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3709, NULL, 3709, 'Pitangueiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.764242', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3710, NULL, 3710, 'Planalto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.76523', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3711, NULL, 3711, 'Platina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.766168', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3712, NULL, 3712, 'Poa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.767481', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3713, NULL, 3713, 'Poloni', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.768419', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3714, NULL, 3714, 'Pompeia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.769298', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3715, NULL, 3715, 'Pongai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.770243', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3716, NULL, 3716, 'Pontal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.771057', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3717, NULL, 3717, 'Pontalinda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.772236', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3718, NULL, 3718, 'Pontes Gestal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.77305', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3719, NULL, 3719, 'Populina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.773915', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3720, NULL, 3720, 'Porangaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.774851', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3721, NULL, 3721, 'Porto Feliz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.77596', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3722, NULL, 3722, 'Porto Ferreira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.77695', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3723, NULL, 3723, 'Potim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.777852', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3724, NULL, 3724, 'Potirendaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.778757', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3725, NULL, 3725, 'Pracinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.779736', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3726, NULL, 3726, 'Pradopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.780653', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3727, NULL, 3727, 'Praia Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.781557', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3728, NULL, 3728, 'Pratania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.782464', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3729, NULL, 3729, 'Presidente Alves', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.783493', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3730, NULL, 3730, 'Presidente Bernardes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.784379', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3731, NULL, 3731, 'Presidente Epitacio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.785224', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3732, NULL, 3732, 'Presidente Prudente', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.786107', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3733, NULL, 3733, 'Presidente Venceslau', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.786904', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3734, NULL, 3734, 'Promissao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.787815', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3735, NULL, 3735, 'Quadra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.788698', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3736, NULL, 3736, 'Quata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.789628', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3737, NULL, 3737, 'Queiroz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.790503', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3738, NULL, 3738, 'Queluz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.791388', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3739, NULL, 3739, 'Quintana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.792194', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3740, NULL, 3740, 'Rafard', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.799849', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3741, NULL, 3741, 'Rancharia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.801147', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3742, NULL, 3742, 'Redencao da Serra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.802051', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3743, NULL, 3743, 'Regente Feijo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.802929', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3744, NULL, 3744, 'Reginopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.80391', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3745, NULL, 3745, 'Registro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.804743', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3746, NULL, 3746, 'Restinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.80577', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3747, NULL, 3747, 'Ribeira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.806596', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3748, NULL, 3748, 'Ribeirao Bonito', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.807499', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3749, NULL, 3749, 'Ribeirao Branco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.808385', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3750, NULL, 3750, 'Ribeirao Corrente', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.809327', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3751, NULL, 3751, 'Ribeirao do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.810148', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3752, NULL, 3752, 'Ribeirao dos Indios', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.811033', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3753, NULL, 3753, 'Ribeirao Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.811878', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3754, NULL, 3754, 'Ribeirao Pires', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.812751', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3755, NULL, 3755, 'Ribeirao Preto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.813744', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3756, NULL, 3756, 'Rifaina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.814689', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3757, NULL, 3757, 'Rincao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.815604', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3758, NULL, 3758, 'Rinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.81658', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3759, NULL, 3759, 'Rio Claro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.817501', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3760, NULL, 3760, 'Rio das Pedras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.8183', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3761, NULL, 3761, 'Rio Grande da Serra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.819205', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3762, NULL, 3762, 'Riolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.820129', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3763, NULL, 3763, 'Riversul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.821112', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3764, NULL, 3764, 'Rosana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.822033', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3765, NULL, 3765, 'Roseira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.822953', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3766, NULL, 3766, 'Rubiacea', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.823779', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3767, NULL, 3767, 'Rubineia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.824722', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3768, NULL, 3768, 'Sabino', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.825716', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3769, NULL, 3769, 'Sagres', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.826657', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3770, NULL, 3770, 'Sales', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.827569', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3771, NULL, 3771, 'Sales Oliveira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.8286', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3772, NULL, 3772, 'Salesopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.829388', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3773, NULL, 3773, 'Salmourao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.830267', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3774, NULL, 3774, 'Saltinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.831174', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3775, NULL, 3775, 'Salto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.832063', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3776, NULL, 3776, 'Salto de Pirapora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.832983', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3777, NULL, 3777, 'Salto Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.833872', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3778, NULL, 3778, 'Sandovalina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.841128', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3779, NULL, 3779, 'Santa Adelia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.842526', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3780, NULL, 3780, 'Santa Albertina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.843562', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3781, NULL, 3781, 'Santa Barbara D''oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.844486', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3782, NULL, 3782, 'Santa Branca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.845468', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3783, NULL, 3783, 'Santa Clara D''oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.846438', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3784, NULL, 3784, 'Santa Cruz da Conceicao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.847281', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3785, NULL, 3785, 'Santa Cruz da Esperanca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.848235', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3786, NULL, 3786, 'Santa Cruz das Palmeiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.849206', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3787, NULL, 3787, 'Santa Cruz do Rio Pardo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.850133', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3788, NULL, 3788, 'Santa Ernestina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.851253', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3789, NULL, 3789, 'Santa Fe do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.852223', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3790, NULL, 3790, 'Santa Gertrudes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.853156', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3791, NULL, 3791, 'Santa Isabel', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.854113', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3792, NULL, 3792, 'Santa Lucia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.854982', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3793, NULL, 3793, 'Santa Maria da Serra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.85605', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3794, NULL, 3794, 'Santa Mercedes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.857003', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3795, NULL, 3795, 'Santa Rita do Passa Quatro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.857824', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3796, NULL, 3796, 'Santa Rita D''oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.85865', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3797, NULL, 3797, 'Santa Rosa de Viterbo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.859396', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3798, NULL, 3798, 'Santa Salete', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.860312', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3799, NULL, 3799, 'Santana da Ponte Pensa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.861535', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3800, NULL, 3800, 'Santana de Parnaiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.862612', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3801, NULL, 3801, 'Santo Anastacio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.863652', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3802, NULL, 3802, 'Santo Andre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.864564', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3803, NULL, 3803, 'Santo Antonio da Alegria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.865523', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3804, NULL, 3804, 'Santo Antonio de Posse', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.866439', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3805, NULL, 3805, 'Santo Antonio do Aracangua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.867468', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3806, NULL, 3806, 'Santo Antonio do Jardim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.868427', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3807, NULL, 3807, 'Santo Antonio do Pinhal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.869308', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3808, NULL, 3808, 'Santo Expedito', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.870137', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3809, NULL, 3809, 'Santopolis do Aguapei', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.871076', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3810, NULL, 3810, 'Santos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.872026', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3811, NULL, 3811, 'Sao Bento do Sapucai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.873071', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3812, NULL, 3812, 'Sao Bernardo do Campo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.873885', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3813, NULL, 3813, 'Sao Caetano do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.874902', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3814, NULL, 3814, 'Sao Carlos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.882174', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3815, NULL, 3815, 'Sao Francisco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.883328', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3816, NULL, 3816, 'Sao Joao da Boa Vista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.884221', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3817, NULL, 3817, 'Sao Joao das Duas Pontes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.8851', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3818, NULL, 3818, 'Sao Joao de Iracema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.885978', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3819, NULL, 3819, 'Sao Joao do Pau D''alho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.886912', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3820, NULL, 3820, 'Sao Joaquim da Barra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.88779', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3821, NULL, 3821, 'Sao Jose da Bela Vista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.888824', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3822, NULL, 3822, 'Sao Jose do Barreiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.889708', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3823, NULL, 3823, 'Sao Jose do Rio Pardo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.890643', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3824, NULL, 3824, 'Sao Jose do Rio Preto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.891636', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3825, NULL, 3825, 'Sao Jose dos Campos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.892511', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3826, NULL, 3826, 'Sao Lourenco da Serra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.893511', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3827, NULL, 3827, 'Sao Luis do Paraitinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.89439', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3828, NULL, 3828, 'Sao Manuel', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.89529', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3829, NULL, 3829, 'Sao Miguel Arcanjo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.89607', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3830, NULL, 3830, 'Sao Paulo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.897057', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3831, NULL, 3831, 'Sao Pedro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.898029', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3832, NULL, 3832, 'Sao Pedro do Turvo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.898933', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3833, NULL, 3833, 'Sao Roque', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.899785', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3834, NULL, 3834, 'Sao Sebastiao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.900715', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3835, NULL, 3835, 'Sao Sebastiao da Grama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.901548', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3836, NULL, 3836, 'Sao Simao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.902471', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3837, NULL, 3837, 'Sao Vicente', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.903454', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3838, NULL, 3838, 'Sarapui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.904302', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3839, NULL, 3839, 'Sarutaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.905087', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3840, NULL, 3840, 'Sebastianopolis do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.906039', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3841, NULL, 3841, 'Serra Azul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.907223', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3842, NULL, 3842, 'Serra Negra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.907989', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3843, NULL, 3843, 'Serrana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.908962', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3844, NULL, 3844, 'Sertaozinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.909863', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3845, NULL, 3845, 'Sete Barras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.910813', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3846, NULL, 3846, 'Severinia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.911767', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3847, NULL, 3847, 'Silveiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.912684', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3848, NULL, 3848, 'Socorro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.913618', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3849, NULL, 3849, 'Sorocaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.914527', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3850, NULL, 3850, 'Sud Mennucci', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.915419', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3851, NULL, 3851, 'Sumare', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.923764', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3852, NULL, 3852, 'Suzanapolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.924737', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3853, NULL, 3853, 'Suzano', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.925611', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3854, NULL, 3854, 'Tabapua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.926641', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3855, NULL, 3855, 'Tabatinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.92753', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3856, NULL, 3856, 'Taboao da Serra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.928379', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3857, NULL, 3857, 'Taciba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.929364', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3858, NULL, 3858, 'Taguai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.930327', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3859, NULL, 3859, 'Taiacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.931198', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3860, NULL, 3860, 'Taiuva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.932199', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3861, NULL, 3861, 'Tambau', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.933029', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3862, NULL, 3862, 'Tanabi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.933885', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3863, NULL, 3863, 'Tapirai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.934819', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3864, NULL, 3864, 'Tapiratiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.935627', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3865, NULL, 3865, 'Taquaral', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.936569', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3866, NULL, 3866, 'Taquaritinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.937462', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3867, NULL, 3867, 'Taquarituba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.938413', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3868, NULL, 3868, 'Taquarivai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.939268', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3869, NULL, 3869, 'Tarabai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.940097', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3870, NULL, 3870, 'Taruma', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.941071', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3871, NULL, 3871, 'Tatui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.942017', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3872, NULL, 3872, 'Taubate', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.942943', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3873, NULL, 3873, 'Tejupa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.94383', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3874, NULL, 3874, 'Teodoro Sampaio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.944695', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3875, NULL, 3875, 'Terra Roxa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.945558', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3876, NULL, 3876, 'Tiete', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.946495', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3877, NULL, 3877, 'Timburi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.94729', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3878, NULL, 3878, 'Torre de Pedra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.948168', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3879, NULL, 3879, 'Torrinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.949077', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3880, NULL, 3880, 'Trabiju', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.949993', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3881, NULL, 3881, 'Tremembe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.950947', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3882, NULL, 3882, 'Tres Fronteiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.951742', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3883, NULL, 3883, 'Tuiuti', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.952496', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3884, NULL, 3884, 'Tupa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.953395', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3885, NULL, 3885, 'Tupi Paulista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.954217', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3886, NULL, 3886, 'Turiuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.955145', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3887, NULL, 3887, 'Turmalina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.956025', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3888, NULL, 3888, 'Ubarana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.957522', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3889, NULL, 3889, 'Ubatuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.964282', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3890, NULL, 3890, 'Ubirajara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.965379', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3891, NULL, 3891, 'Uchoa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.966314', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3892, NULL, 3892, 'Uniao Paulista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.967227', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3893, NULL, 3893, 'Urania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.968222', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3894, NULL, 3894, 'Uru', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.969163', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3895, NULL, 3895, 'Urupes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.970073', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3896, NULL, 3896, 'Valentim Gentil', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.970972', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3897, NULL, 3897, 'Valinhos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.971951', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3898, NULL, 3898, 'Valparaiso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.972883', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3899, NULL, 3899, 'Vargem', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.974064', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3900, NULL, 3900, 'Vargem Grande do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.974954', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3901, NULL, 3901, 'Vargem Grande Paulista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.976387', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3902, NULL, 3902, 'Varzea Paulista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.97738', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3903, NULL, 3903, 'Vera Cruz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.97827', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3904, NULL, 3904, 'Vinhedo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.979112', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3905, NULL, 3905, 'Viradouro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.980046', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3906, NULL, 3906, 'Vista Alegre do Alto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.980934', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3907, NULL, 3907, 'Vitoria Brasil', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.981804', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3908, NULL, 3908, 'Votorantim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.982726', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3909, NULL, 3909, 'Votuporanga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.983575', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3910, NULL, 3910, 'Zacarias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.984592', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3911, NULL, 3911, 'Abatia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.985397', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3912, NULL, 3912, 'Adrianopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.986287', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3913, NULL, 3913, 'Agudos do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.987196', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3914, NULL, 3914, 'Almirante Tamandare', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.988188', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3915, NULL, 3915, 'Altamira do Parana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.989098', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3916, NULL, 3916, 'Alto Paraiso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.99001', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3917, NULL, 3917, 'Alto Parana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.990938', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3918, NULL, 3918, 'Alto Piquiri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.991839', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3919, NULL, 3919, 'Altonia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.992748', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3920, NULL, 3920, 'Alvorada do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.99372', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3921, NULL, 3921, 'Amapora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.99467', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3922, NULL, 3922, 'Ampere', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.995648', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3923, NULL, 3923, 'Anahy', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.996625', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3924, NULL, 3924, 'Andira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.997681', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3925, NULL, 3925, 'Angulo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.004728', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3926, NULL, 3926, 'Antonina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.005854', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3927, NULL, 3927, 'Antonio Olinto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.007012', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3928, NULL, 3928, 'Apucarana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.007903', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3929, NULL, 3929, 'Arapongas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.008811', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3930, NULL, 3930, 'Arapoti', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.009634', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3931, NULL, 3931, 'Arapua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.010641', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3932, NULL, 3932, 'Araruna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.011512', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3933, NULL, 3933, 'Araucaria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.012356', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3934, NULL, 3934, 'Ariranha do Ivai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.013245', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3935, NULL, 3935, 'Assai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.014083', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3936, NULL, 3936, 'Assis Chateaubriand', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.014967', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3937, NULL, 3937, 'Astorga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.015824', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3938, NULL, 3938, 'Atalaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.016716', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3939, NULL, 3939, 'Balsa Nova', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.017615', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3940, NULL, 3940, 'Bandeirantes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.018653', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3941, NULL, 3941, 'Barbosa Ferraz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.019459', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3942, NULL, 3942, 'Barra do Jacare', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.020318', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3943, NULL, 3943, 'Barracao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.021205', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3944, NULL, 3944, 'Bela Vista do Caroba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.022147', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3945, NULL, 3945, 'Bela Vista do Paraiso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.023032', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3946, NULL, 3946, 'Bituruna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.023906', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3947, NULL, 3947, 'Boa Esperanca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.02483', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3948, NULL, 3948, 'Boa Esperanca do Iguacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.025742', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3949, NULL, 3949, 'Boa Ventura de Sao Roque', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.026662', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3950, NULL, 3950, 'Boa Vista da Aparecida', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.027576', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3951, NULL, 3951, 'Bocaiuva do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.028487', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3952, NULL, 3952, 'Bom Jesus do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.02933', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3953, NULL, 3953, 'Bom Sucesso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.030115', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3954, NULL, 3954, 'Bom Sucesso do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.031027', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3955, NULL, 3955, 'Borrazopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.031843', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3956, NULL, 3956, 'Braganey', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.032806', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3957, NULL, 3957, 'Brasilandia do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.033978', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3958, NULL, 3958, 'Cafeara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.034819', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3959, NULL, 3959, 'Cafelandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.03574', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3960, NULL, 3960, 'Cafezal do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.036649', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3961, NULL, 3961, 'California', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.037542', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3962, NULL, 3962, 'Cambara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.038936', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3963, NULL, 3963, 'Cambe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.045765', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3964, NULL, 3964, 'Cambira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.047133', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3965, NULL, 3965, 'Campina da Lagoa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.04815', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3966, NULL, 3966, 'Campina do Simao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.049097', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3967, NULL, 3967, 'Campina Grande do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.050115', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3968, NULL, 3968, 'Campo Bonito', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.051104', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3969, NULL, 3969, 'Campo do Tenente', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.05197', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3970, NULL, 3970, 'Campo Largo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.053224', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3971, NULL, 3971, 'Campo Magro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.054079', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3972, NULL, 3972, 'Campo Mourao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.054986', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3973, NULL, 3973, 'Candido de Abreu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.055886', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3974, NULL, 3974, 'Candoi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.056861', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3975, NULL, 3975, 'Cantagalo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.057749', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3976, NULL, 3976, 'Capanema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.05867', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3977, NULL, 3977, 'Capitao Leonidas Marques', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.059635', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3978, NULL, 3978, 'Carambei', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.060504', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3979, NULL, 3979, 'Carlopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.061386', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3980, NULL, 3980, 'Cascavel', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.062316', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3981, NULL, 3981, 'Castro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.063137', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3982, NULL, 3982, 'Catanduvas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.064188', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3983, NULL, 3983, 'Centenario do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.065187', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3984, NULL, 3984, 'Cerro Azul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.066246', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3985, NULL, 3985, 'Ceu Azul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.06723', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3986, NULL, 3986, 'Chopinzinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.068245', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3987, NULL, 3987, 'Cianorte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.069317', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3988, NULL, 3988, 'Cidade Gaucha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.070245', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3989, NULL, 3989, 'Clevelandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.071239', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3990, NULL, 3990, 'Colombo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.072161', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3991, NULL, 3991, 'Colorado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.073279', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3992, NULL, 3992, 'Congonhinhas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.074223', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3993, NULL, 3993, 'Conselheiro Mairinck', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.075146', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3994, NULL, 3994, 'Contenda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.07629', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3995, NULL, 3995, 'Corbelia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.077225', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3996, NULL, 3996, 'Cornelio Procopio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.078202', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3997, NULL, 3997, 'Coronel Domingos Soares', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.079407', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3998, NULL, 3998, 'Coronel Vivida', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.086559', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (3999, NULL, 3999, 'Corumbatai do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.087675', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4000, NULL, 4000, 'Cruz Machado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.088592', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4001, NULL, 4001, 'Cruzeiro do Iguacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.089408', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4002, NULL, 4002, 'Cruzeiro do Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.090379', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4003, NULL, 4003, 'Cruzeiro do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.09129', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4004, NULL, 4004, 'Cruzmaltina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.092294', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4005, NULL, 4005, 'Curitiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.093188', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4006, NULL, 4006, 'Curiuva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.094161', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4007, NULL, 4007, 'Diamante do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.095041', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4008, NULL, 4008, 'Diamante do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.096391', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4009, NULL, 4009, 'Diamante D''oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.097438', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4010, NULL, 4010, 'Dois Vizinhos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.098274', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4011, NULL, 4011, 'Douradina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.099183', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4012, NULL, 4012, 'Doutor Camargo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.100098', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4013, NULL, 4013, 'Doutor Ulysses', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.100967', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4014, NULL, 4014, 'Eneas Marques', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.10187', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4015, NULL, 4015, 'Engenheiro Beltrao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.102709', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4016, NULL, 4016, 'Entre Rios do Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.103512', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4017, NULL, 4017, 'Esperanca Nova', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.104368', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4018, NULL, 4018, 'Espigao Alto do Iguacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.105422', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4019, NULL, 4019, 'Farol', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.106399', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4020, NULL, 4020, 'Faxinal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.107374', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4021, NULL, 4021, 'Fazenda Rio Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.108241', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4022, NULL, 4022, 'Fenix', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.109288', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4023, NULL, 4023, 'Fernandes Pinheiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.110161', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4024, NULL, 4024, 'Figueira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.111065', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4025, NULL, 4025, 'Flor da Serra do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.111977', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4026, NULL, 4026, 'Florai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.112881', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4027, NULL, 4027, 'Floresta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.113867', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4028, NULL, 4028, 'Florestopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.114779', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4029, NULL, 4029, 'Florida', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.115752', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4030, NULL, 4030, 'Formosa do Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.116721', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4031, NULL, 4031, 'Foz do Iguacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.117707', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4032, NULL, 4032, 'Foz do Jordao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.118639', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4033, NULL, 4033, 'Francisco Alves', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.119613', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4034, NULL, 4034, 'Francisco Beltrao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.120558', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4035, NULL, 4035, 'General Carneiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.127423', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4036, NULL, 4036, 'Godoy Moreira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.128645', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4037, NULL, 4037, 'Goio-ere', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.129581', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4038, NULL, 4038, 'Goioxim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.13055', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4039, NULL, 4039, 'Grandes Rios', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.131638', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4040, NULL, 4040, 'Guaira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.13242', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4041, NULL, 4041, 'Guairaca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.133372', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4042, NULL, 4042, 'Guamiranga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.134252', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4043, NULL, 4043, 'Guapirama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.135191', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4044, NULL, 4044, 'Guaporema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.136151', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4045, NULL, 4045, 'Guaraci', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.137079', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4046, NULL, 4046, 'Guaraniacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.138006', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4047, NULL, 4047, 'Guarapuava', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.138945', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4048, NULL, 4048, 'Guaraquecaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.139847', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4049, NULL, 4049, 'Guaratuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.140817', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4050, NULL, 4050, 'Honorio Serpa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.141648', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4051, NULL, 4051, 'Ibaiti', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.142752', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4052, NULL, 4052, 'Ibema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.143584', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4053, NULL, 4053, 'Ibipora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.14439', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4054, NULL, 4054, 'Icaraima', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.145266', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4055, NULL, 4055, 'Iguaracu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.146086', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4056, NULL, 4056, 'Iguatu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.146981', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4057, NULL, 4057, 'Imbau', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.147856', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4058, NULL, 4058, 'Imbituva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.148856', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4059, NULL, 4059, 'Inacio Martins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.149748', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4060, NULL, 4060, 'Inaja', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.150609', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4061, NULL, 4061, 'Indianopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.151462', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4062, NULL, 4062, 'Ipiranga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.15233', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4063, NULL, 4063, 'Ipora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.153244', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4064, NULL, 4064, 'Iracema do Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.154171', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4065, NULL, 4065, 'Irati', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.155067', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4066, NULL, 4066, 'Iretama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.155943', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4067, NULL, 4067, 'Itaguaje', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.156929', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4068, NULL, 4068, 'Itaipulandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.157878', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4069, NULL, 4069, 'Itambaraca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.158813', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4070, NULL, 4070, 'Itambe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.159654', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4071, NULL, 4071, 'Itapejara D''oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.160601', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4072, NULL, 4072, 'Itaperucu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.161482', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4073, NULL, 4073, 'Itauna do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.162479', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4074, NULL, 4074, 'Ivai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.173191', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4075, NULL, 4075, 'Ivaipora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.174405', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4076, NULL, 4076, 'Ivate', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.175489', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4077, NULL, 4077, 'Ivatuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.176411', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4078, NULL, 4078, 'Jaboti', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.177343', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4079, NULL, 4079, 'Jacarezinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.178223', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4080, NULL, 4080, 'Jaguapita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.17908', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4081, NULL, 4081, 'Jaguariaiva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.179969', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4082, NULL, 4082, 'Jandaia do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.180921', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4083, NULL, 4083, 'Janiopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.181768', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4084, NULL, 4084, 'Japira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.182695', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4085, NULL, 4085, 'Japura', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.183595', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4086, NULL, 4086, 'Jardim Alegre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.184551', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4087, NULL, 4087, 'Jardim Olinda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.185484', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4088, NULL, 4088, 'Jataizinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.186508', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4089, NULL, 4089, 'Jesuitas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.187505', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4090, NULL, 4090, 'Joaquim Tavora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.188472', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4091, NULL, 4091, 'Jundiai do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.189369', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4092, NULL, 4092, 'Juranda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.190237', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4093, NULL, 4093, 'Jussara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.191189', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4094, NULL, 4094, 'Kalore', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.192042', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4095, NULL, 4095, 'Lapa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.192994', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4096, NULL, 4096, 'Laranjal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.193967', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4097, NULL, 4097, 'Laranjeiras do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.194892', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4098, NULL, 4098, 'Leopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.195946', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4099, NULL, 4099, 'Lidianopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.196969', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4100, NULL, 4100, 'Lindoeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.197979', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4101, NULL, 4101, 'Loanda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.198786', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4102, NULL, 4102, 'Lobato', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.199695', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4103, NULL, 4103, 'Londrina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.200588', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4104, NULL, 4104, 'Luiziana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.2014', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4105, NULL, 4105, 'Lunardelli', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.202191', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4106, NULL, 4106, 'Lupionopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.203083', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4107, NULL, 4107, 'Mallet', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.204071', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4108, NULL, 4108, 'Mambore', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.205131', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4109, NULL, 4109, 'Mandaguacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.206396', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4110, NULL, 4110, 'Mandaguari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.207255', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4111, NULL, 4111, 'Mandirituba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.213506', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4112, NULL, 4112, 'Manfrinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.214574', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4113, NULL, 4113, 'Mangueirinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.21538', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4114, NULL, 4114, 'Manoel Ribas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.216194', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4115, NULL, 4115, 'Marechal Candido Rondon', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.217021', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4116, NULL, 4116, 'Maria Helena', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.217924', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4117, NULL, 4117, 'Marialva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.218808', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4118, NULL, 4118, 'Marilandia do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.219675', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4119, NULL, 4119, 'Marilena', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.221127', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4120, NULL, 4120, 'Mariluz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.22202', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4121, NULL, 4121, 'Maringa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.222938', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4122, NULL, 4122, 'Mariopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.223854', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4123, NULL, 4123, 'Maripa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.224672', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4124, NULL, 4124, 'Marmeleiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.22564', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4125, NULL, 4125, 'Marquinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.22658', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4126, NULL, 4126, 'Marumbi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.227421', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4127, NULL, 4127, 'Matelandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.228228', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4128, NULL, 4128, 'Matinhos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.229194', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4129, NULL, 4129, 'Mato Rico', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.230144', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4130, NULL, 4130, 'Maua da Serra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.231029', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4131, NULL, 4131, 'Medianeira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.232254', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4132, NULL, 4132, 'Mercedes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.233069', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4133, NULL, 4133, 'Mirador', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.233941', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4134, NULL, 4134, 'Miraselva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.234818', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4135, NULL, 4135, 'Missal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.23558', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4136, NULL, 4136, 'Moreira Sales', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.236433', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4137, NULL, 4137, 'Morretes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.237286', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4138, NULL, 4138, 'Munhoz de Melo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.238297', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4139, NULL, 4139, 'Nossa Senhora das Gracas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.239216', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4140, NULL, 4140, 'Nova Alianca do Ivai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.240118', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4141, NULL, 4141, 'Nova America da Colina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.240981', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4142, NULL, 4142, 'Nova Aurora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.24191', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4143, NULL, 4143, 'Nova Cantu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.242841', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4144, NULL, 4144, 'Nova Esperanca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.243604', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4145, NULL, 4145, 'Nova Esperanca do Sudoeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.244503', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4146, NULL, 4146, 'Nova Fatima', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.24551', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4147, NULL, 4147, 'Nova Laranjeiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.246408', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4148, NULL, 4148, 'Nova Londrina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.247175', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4149, NULL, 4149, 'Nova Olimpia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.254111', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4150, NULL, 4150, 'Nova Prata do Iguacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.255272', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4151, NULL, 4151, 'Nova Santa Barbara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.256208', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4152, NULL, 4152, 'Nova Santa Rosa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.257126', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4153, NULL, 4153, 'Nova Tebas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.258244', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4154, NULL, 4154, 'Novo Itacolomi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.259008', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4155, NULL, 4155, 'Ortigueira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.259923', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4156, NULL, 4156, 'Ourizona', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.260801', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4157, NULL, 4157, 'Ouro Verde do Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.261512', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4158, NULL, 4158, 'Paicandu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.262398', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4159, NULL, 4159, 'Palmas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.263241', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4160, NULL, 4160, 'Palmeira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.264126', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4161, NULL, 4161, 'Palmital', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.264963', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4162, NULL, 4162, 'Palotina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.265805', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4163, NULL, 4163, 'Paraiso do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.266633', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4164, NULL, 4164, 'Paranacity', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.267515', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4165, NULL, 4165, 'Paranagua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.268404', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4166, NULL, 4166, 'Paranapoema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.269214', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4167, NULL, 4167, 'Paranavai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.270026', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4168, NULL, 4168, 'Pato Bragado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.27079', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4169, NULL, 4169, 'Pato Branco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.271724', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4170, NULL, 4170, 'Paula Freitas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.272627', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4171, NULL, 4171, 'Paulo Frontin', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.273639', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4172, NULL, 4172, 'Peabiru', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.274646', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4173, NULL, 4173, 'Perobal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.275641', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4174, NULL, 4174, 'Perola', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.276605', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4175, NULL, 4175, 'Perola D''oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.277426', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4176, NULL, 4176, 'Pien', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.278261', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4177, NULL, 4177, 'Pinhais', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.279077', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4178, NULL, 4178, 'Pinhal de Sao Bento', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.279898', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4179, NULL, 4179, 'Pinhalao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.280779', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4180, NULL, 4180, 'Pinhao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.281602', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4181, NULL, 4181, 'Pirai do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.282487', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4182, NULL, 4182, 'Piraquara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.283295', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4183, NULL, 4183, 'Pitanga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.2841', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4184, NULL, 4184, 'Pitangueiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.285074', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4185, NULL, 4185, 'Planaltina do Parana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.28605', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4186, NULL, 4186, 'Planalto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.286973', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4187, NULL, 4187, 'Ponta Grossa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.287832', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4188, NULL, 4188, 'Pontal do Parana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.294545', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4189, NULL, 4189, 'Porecatu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.295833', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4190, NULL, 4190, 'Porto Amazonas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.296693', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4191, NULL, 4191, 'Porto Barreiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.297591', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4192, NULL, 4192, 'Porto Rico', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.298581', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4193, NULL, 4193, 'Porto Vitoria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.299373', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4194, NULL, 4194, 'Prado Ferreira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.300209', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4195, NULL, 4195, 'Pranchita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.301016', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4196, NULL, 4196, 'Presidente Castelo Branco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.301937', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4197, NULL, 4197, 'Primeiro de Maio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.30282', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4198, NULL, 4198, 'Prudentopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.303849', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4199, NULL, 4199, 'Quarto Centenario', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.304786', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4200, NULL, 4200, 'Quatigua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.305711', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4201, NULL, 4201, 'Quatro Barras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.306515', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4202, NULL, 4202, 'Quatro Pontes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.307399', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4203, NULL, 4203, 'Quedas do Iguacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.308241', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4204, NULL, 4204, 'Querencia do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.309072', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4205, NULL, 4205, 'Quinta do Sol', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.31021', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4206, NULL, 4206, 'Quitandinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.311014', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4207, NULL, 4207, 'Ramilandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.3117', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4208, NULL, 4208, 'Rancho Alegre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.312592', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4209, NULL, 4209, 'Rancho Alegre D''oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.313489', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4210, NULL, 4210, 'Realeza', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.314376', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4211, NULL, 4211, 'Reboucas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.315317', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4212, NULL, 4212, 'Renascenca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.316337', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4213, NULL, 4213, 'Reserva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.317368', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4214, NULL, 4214, 'Reserva do Iguacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.318231', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4215, NULL, 4215, 'Ribeirao Claro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.31911', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4216, NULL, 4216, 'Ribeirao do Pinhal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.319989', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4217, NULL, 4217, 'Rio Azul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.320821', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4218, NULL, 4218, 'Rio Bom', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.32181', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4219, NULL, 4219, 'Rio Bonito do Iguacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.322764', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4220, NULL, 4220, 'Rio Branco do Ivai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.323713', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4221, NULL, 4221, 'Rio Branco do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.324646', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4222, NULL, 4222, 'Rio Negro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.325554', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4223, NULL, 4223, 'Rolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.326432', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4224, NULL, 4224, 'Roncador', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.327306', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4225, NULL, 4225, 'Rondon', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.328245', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4226, NULL, 4226, 'Rosario do Ivai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.338376', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4227, NULL, 4227, 'Sabaudia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.339508', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4228, NULL, 4228, 'Salgado Filho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.34043', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4229, NULL, 4229, 'Salto do Itarare', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.341281', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4230, NULL, 4230, 'Salto do Lontra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.342375', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4231, NULL, 4231, 'Santa Amelia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.343545', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4232, NULL, 4232, 'Santa Cecilia do Pavao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.344438', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4233, NULL, 4233, 'Santa Cruz de Monte Castelo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.345319', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4234, NULL, 4234, 'Santa Fe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.346188', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4235, NULL, 4235, 'Santa Helena', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.347091', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4236, NULL, 4236, 'Santa Ines', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.347973', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4237, NULL, 4237, 'Santa Isabel do Ivai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.348934', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4238, NULL, 4238, 'Santa Izabel do Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.349861', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4239, NULL, 4239, 'Santa Lucia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.350735', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4240, NULL, 4240, 'Santa Maria do Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.351637', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4241, NULL, 4241, 'Santa Mariana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.352468', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4242, NULL, 4242, 'Santa Monica', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.353319', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4243, NULL, 4243, 'Santa Tereza do Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.35425', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4244, NULL, 4244, 'Santa Terezinha de Itaipu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.355024', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4245, NULL, 4245, 'Santana do Itarare', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.355964', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4246, NULL, 4246, 'Santo Antonio da Platina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.356885', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4247, NULL, 4247, 'Santo Antonio do Caiua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.357831', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4248, NULL, 4248, 'Santo Antonio do Paraiso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.358771', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4249, NULL, 4249, 'Santo Antonio do Sudoeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.359666', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4250, NULL, 4250, 'Santo Inacio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.360623', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4251, NULL, 4251, 'Sao Carlos do Ivai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.361502', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4252, NULL, 4252, 'Sao Jeronimo da Serra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.362324', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4253, NULL, 4253, 'Sao Joao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.363192', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4254, NULL, 4254, 'Sao Joao do Caiua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.364281', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4255, NULL, 4255, 'Sao Joao do Ivai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.365215', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4256, NULL, 4256, 'Sao Joao do Triunfo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.366215', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4257, NULL, 4257, 'Sao Jorge do Ivai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.367092', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4258, NULL, 4258, 'Sao Jorge do Patrocinio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.368034', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4259, NULL, 4259, 'Sao Jorge D''oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.368953', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4260, NULL, 4260, 'Sao Jose da Boa Vista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.369834', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4261, NULL, 4261, 'Sao Jose das Palmeiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.370542', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4262, NULL, 4262, 'Sao Jose dos Pinhais', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.371509', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4263, NULL, 4263, 'Sao Manoel do Parana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.372312', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4264, NULL, 4264, 'Sao Mateus do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.37923', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4265, NULL, 4265, 'Sao Miguel do Iguacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.380624', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4266, NULL, 4266, 'Sao Pedro do Iguacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.381553', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4267, NULL, 4267, 'Sao Pedro do Ivai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.382512', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4268, NULL, 4268, 'Sao Pedro do Parana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.383505', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4269, NULL, 4269, 'Sao Sebastiao da Amoreira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.384423', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4270, NULL, 4270, 'Sao Tome', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.38532', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4271, NULL, 4271, 'Sapopema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.386212', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4272, NULL, 4272, 'Sarandi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.38714', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4273, NULL, 4273, 'Saudade do Iguacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.388048', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4274, NULL, 4274, 'Senges', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.388983', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4275, NULL, 4275, 'Serranopolis do Iguacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.389954', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4276, NULL, 4276, 'Sertaneja', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.390851', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4277, NULL, 4277, 'Sertanopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.391827', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4278, NULL, 4278, 'Siqueira Campos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.392833', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4279, NULL, 4279, 'Sulina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.393627', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4280, NULL, 4280, 'Tamarana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.394497', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4281, NULL, 4281, 'Tamboara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.395464', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4282, NULL, 4282, 'Tapejara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.396622', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4283, NULL, 4283, 'Tapira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.397553', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4284, NULL, 4284, 'Teixeira Soares', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.398411', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4285, NULL, 4285, 'Telemaco Borba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.399685', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4286, NULL, 4286, 'Terra Boa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.400592', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4287, NULL, 4287, 'Terra Rica', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.401465', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4288, NULL, 4288, 'Terra Roxa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.402543', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4289, NULL, 4289, 'Tibagi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.403763', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4290, NULL, 4290, 'Tijucas do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.404751', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4291, NULL, 4291, 'Toledo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.405658', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4292, NULL, 4292, 'Tomazina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.406592', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4293, NULL, 4293, 'Tres Barras do Parana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.407465', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4294, NULL, 4294, 'Tunas do Parana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.408366', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4295, NULL, 4295, 'Tuneiras do Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.409234', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4296, NULL, 4296, 'Tupassi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.41021', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4297, NULL, 4297, 'Turvo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.410984', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4298, NULL, 4298, 'Ubirata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.411853', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4299, NULL, 4299, 'Umuarama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.412765', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4300, NULL, 4300, 'Uniao da Vitoria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.413578', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4301, NULL, 4301, 'Uniflor', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.42009', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4302, NULL, 4302, 'Urai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.421232', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4303, NULL, 4303, 'Ventania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.422122', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4304, NULL, 4304, 'Vera Cruz do Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.422901', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4305, NULL, 4305, 'Vere', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.423951', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4306, NULL, 4306, 'Virmond', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.424896', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4307, NULL, 4307, 'Vitorino', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.425982', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4308, NULL, 4308, 'Wenceslau Braz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.426895', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4309, NULL, 4309, 'Xambre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.427805', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4310, NULL, 4310, 'Abdon Batista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.428638', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4311, NULL, 4311, 'Abelardo Luz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.429547', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4312, NULL, 4312, 'Agrolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.430478', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4313, NULL, 4313, 'Agronomica', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.431358', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4314, NULL, 4314, 'Agua Doce', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.43226', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4315, NULL, 4315, 'Aguas de Chapeco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.433055', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4316, NULL, 4316, 'Aguas Frias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.43394', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4317, NULL, 4317, 'Aguas Mornas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.434905', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4318, NULL, 4318, 'Alfredo Wagner', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.435771', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4319, NULL, 4319, 'Alto Bela Vista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.43669', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4320, NULL, 4320, 'Anchieta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.43753', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4321, NULL, 4321, 'Angelina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.43846', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4322, NULL, 4322, 'Anita Garibaldi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.439314', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4323, NULL, 4323, 'Anitapolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.440162', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4324, NULL, 4324, 'Antonio Carlos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.440943', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4325, NULL, 4325, 'Apiuna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.441712', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4326, NULL, 4326, 'Arabuta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.442617', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4327, NULL, 4327, 'Araquari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.44364', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4328, NULL, 4328, 'Ararangua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.444439', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4329, NULL, 4329, 'Armazem', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.445254', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4330, NULL, 4330, 'Arroio Trinta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.446176', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4331, NULL, 4331, 'Arvoredo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.447106', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4332, NULL, 4332, 'Ascurra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.44797', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4333, NULL, 4333, 'Atalanta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.448887', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4334, NULL, 4334, 'Aurora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.449795', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4335, NULL, 4335, 'Balneario Arroio do Silva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.450698', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4336, NULL, 4336, 'Balneario Barra do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.451594', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4337, NULL, 4337, 'Balneario Camboriu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.45249', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4338, NULL, 4338, 'Balneario Gaivota', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.453461', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4339, NULL, 4339, 'Bandeirante', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.460344', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4340, NULL, 4340, 'Barra Bonita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.461537', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4341, NULL, 4341, 'Barra Velha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.462448', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4342, NULL, 4342, 'Bela Vista do Toldo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.463399', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4343, NULL, 4343, 'Belmonte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.464282', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4344, NULL, 4344, 'Benedito Novo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.465195', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4345, NULL, 4345, 'Biguacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.466322', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4346, NULL, 4346, 'Blumenau', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.467185', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4347, NULL, 4347, 'Bocaina do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.468115', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4348, NULL, 4348, 'Bom Jardim da Serra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.469091', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4349, NULL, 4349, 'Bom Jesus', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.469971', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4350, NULL, 4350, 'Bom Jesus do Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.470938', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4351, NULL, 4351, 'Bom Retiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.471851', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4352, NULL, 4352, 'Bombinhas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.472717', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4353, NULL, 4353, 'Botuvera', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.473586', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4354, NULL, 4354, 'Braco do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.474511', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4355, NULL, 4355, 'Braco do Trombudo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.47539', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4356, NULL, 4356, 'Brunopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.476535', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4357, NULL, 4357, 'Brusque', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.477593', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4358, NULL, 4358, 'Cacador', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.478494', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4359, NULL, 4359, 'Caibi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.479391', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4360, NULL, 4360, 'Calmon', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.480305', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4361, NULL, 4361, 'Camboriu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.481266', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4362, NULL, 4362, 'Campo Alegre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.482024', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4363, NULL, 4363, 'Campo Belo do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.483299', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4364, NULL, 4364, 'Campo Ere', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.484528', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4365, NULL, 4365, 'Campos Novos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.48539', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4366, NULL, 4366, 'Canelinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.486284', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4367, NULL, 4367, 'Canoinhas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.487206', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4368, NULL, 4368, 'Capao Alto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.488426', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4369, NULL, 4369, 'Capinzal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.489197', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4370, NULL, 4370, 'Capivari de Baixo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.490106', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4371, NULL, 4371, 'Catanduvas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.491025', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4372, NULL, 4372, 'Caxambu do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.491954', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4373, NULL, 4373, 'Celso Ramos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.492847', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4374, NULL, 4374, 'Cerro Negro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.493856', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4375, NULL, 4375, 'Chapadao do Lageado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.500523', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4376, NULL, 4376, 'Chapeco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.501768', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4377, NULL, 4377, 'Cocal do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.502784', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4378, NULL, 4378, 'Concordia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.50375', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4379, NULL, 4379, 'Cordilheira Alta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.504637', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4380, NULL, 4380, 'Coronel Freitas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.50575', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4381, NULL, 4381, 'Coronel Martins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.506666', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4382, NULL, 4382, 'Correia Pinto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.507531', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4383, NULL, 4383, 'Corupa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.508452', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4384, NULL, 4384, 'Criciuma', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.509451', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4385, NULL, 4385, 'Cunha Pora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.510481', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4386, NULL, 4386, 'Cunhatai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.511334', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4387, NULL, 4387, 'Curitibanos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.512194', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4388, NULL, 4388, 'Descanso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.513047', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4389, NULL, 4389, 'Dionisio Cerqueira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.513922', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4390, NULL, 4390, 'Dona Emma', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.514778', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4391, NULL, 4391, 'Doutor Pedrinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.515649', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4392, NULL, 4392, 'Entre Rios', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.516534', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4393, NULL, 4393, 'Ermo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.517512', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4394, NULL, 4394, 'Erval Velho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.518414', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4395, NULL, 4395, 'Faxinal dos Guedes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.519319', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4396, NULL, 4396, 'Flor do Sertao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.520213', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4397, NULL, 4397, 'Florianopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.521114', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4398, NULL, 4398, 'Formosa do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.522109', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4399, NULL, 4399, 'Forquilhinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.523012', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4400, NULL, 4400, 'Fraiburgo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.523979', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4401, NULL, 4401, 'Frei Rogerio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.524846', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4402, NULL, 4402, 'Galvao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.525743', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4403, NULL, 4403, 'Garopaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.526646', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4404, NULL, 4404, 'Garuva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.527531', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4405, NULL, 4405, 'Gaspar', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.528459', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4406, NULL, 4406, 'Governador Celso Ramos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.529386', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4407, NULL, 4407, 'Grao Para', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.530212', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4408, NULL, 4408, 'Gravatal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.531116', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4409, NULL, 4409, 'Guabiruba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.53194', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4410, NULL, 4410, 'Guaraciaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.532863', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4411, NULL, 4411, 'Guaramirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.533779', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4412, NULL, 4412, 'Guaruja do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.535074', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4413, NULL, 4413, 'Guatambu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.541376', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4414, NULL, 4414, 'Herval D''oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.542596', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4415, NULL, 4415, 'Ibiam', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.543705', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4416, NULL, 4416, 'Ibicare', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.544411', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4417, NULL, 4417, 'Ibirama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.54531', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4418, NULL, 4418, 'Icara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.546167', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4419, NULL, 4419, 'Ilhota', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.546952', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4420, NULL, 4420, 'Imarui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.547891', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4421, NULL, 4421, 'Imbituba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.548745', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4422, NULL, 4422, 'Imbuia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.549615', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4423, NULL, 4423, 'Indaial', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.550745', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4424, NULL, 4424, 'Iomere', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.551707', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4425, NULL, 4425, 'Ipira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.552628', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4426, NULL, 4426, 'Ipora do Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.553489', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4427, NULL, 4427, 'Ipuacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.554353', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4428, NULL, 4428, 'Ipumirim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.555764', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4429, NULL, 4429, 'Iraceminha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.556864', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4430, NULL, 4430, 'Irani', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.557716', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4431, NULL, 4431, 'Irati', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.558657', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4432, NULL, 4432, 'Irineopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.559588', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4433, NULL, 4433, 'Ita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.56052', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4434, NULL, 4434, 'Itaiopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.5614', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4435, NULL, 4435, 'Itajai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.562258', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4436, NULL, 4436, 'Itapema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.563129', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4437, NULL, 4437, 'Itapiranga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.564104', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4438, NULL, 4438, 'Itapoa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.565082', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4439, NULL, 4439, 'Ituporanga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.566056', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4440, NULL, 4440, 'Jabora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.566836', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4441, NULL, 4441, 'Jacinto Machado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.567842', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4442, NULL, 4442, 'Jaguaruna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.568806', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4443, NULL, 4443, 'Jaragua do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.569621', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4444, NULL, 4444, 'Jardinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.570517', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4445, NULL, 4445, 'Joacaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.571308', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4446, NULL, 4446, 'Joinville', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.572209', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4447, NULL, 4447, 'Jose Boiteux', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.573179', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4448, NULL, 4448, 'Jupia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.574057', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4449, NULL, 4449, 'Lacerdopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.574936', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4450, NULL, 4450, 'Lages', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.581911', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4451, NULL, 4451, 'Laguna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.583305', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4452, NULL, 4452, 'Lajeado Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.584135', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4453, NULL, 4453, 'Laurentino', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.584973', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4454, NULL, 4454, 'Lauro Muller', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.585797', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4455, NULL, 4455, 'Lebon Regis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.586737', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4456, NULL, 4456, 'Leoberto Leal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.587727', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4457, NULL, 4457, 'Lindoia do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.589095', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4458, NULL, 4458, 'Lontras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.590019', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4459, NULL, 4459, 'Luiz Alves', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.590917', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4460, NULL, 4460, 'Luzerna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.591816', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4461, NULL, 4461, 'Macieira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.592688', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4462, NULL, 4462, 'Mafra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.593594', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4463, NULL, 4463, 'Major Gercino', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.594511', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4464, NULL, 4464, 'Major Vieira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.595378', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4465, NULL, 4465, 'Maracaja', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.59623', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4466, NULL, 4466, 'Maravilha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.597301', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4467, NULL, 4467, 'Marema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.598234', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4468, NULL, 4468, 'Massaranduba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.59912', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4469, NULL, 4469, 'Matos Costa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.600611', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4470, NULL, 4470, 'Meleiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.601584', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4471, NULL, 4471, 'Mirim Doce', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.602525', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4472, NULL, 4472, 'Modelo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.603369', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4473, NULL, 4473, 'Mondai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.604263', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4474, NULL, 4474, 'Monte Carlo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.605228', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4475, NULL, 4475, 'Monte Castelo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.606147', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4476, NULL, 4476, 'Morro da Fumaca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.607036', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4477, NULL, 4477, 'Morro Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.607994', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4478, NULL, 4478, 'Navegantes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.608914', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4479, NULL, 4479, 'Nova Erechim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.60984', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4480, NULL, 4480, 'Nova Itaberaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.610808', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4481, NULL, 4481, 'Nova Trento', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.611579', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4482, NULL, 4482, 'Nova Veneza', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.612402', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4483, NULL, 4483, 'Novo Horizonte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.61326', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4484, NULL, 4484, 'Orleans', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.614203', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4485, NULL, 4485, 'Otacilio Costa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.615091', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4486, NULL, 4486, 'Ouro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.615915', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4487, NULL, 4487, 'Ouro Verde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.622292', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4488, NULL, 4488, 'Paial', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.624172', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4489, NULL, 4489, 'Painel', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.625092', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4490, NULL, 4490, 'Palhoca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.625997', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4491, NULL, 4491, 'Palma Sola', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.626836', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4492, NULL, 4492, 'Palmeira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.627753', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4493, NULL, 4493, 'Palmitos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.628577', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4494, NULL, 4494, 'Papanduva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.629483', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4495, NULL, 4495, 'Paraiso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.630489', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4496, NULL, 4496, 'Passo de Torres', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.631393', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4497, NULL, 4497, 'Passos Maia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.632217', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4498, NULL, 4498, 'Paulo Lopes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.633094', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4499, NULL, 4499, 'Pedras Grandes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.634126', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4500, NULL, 4500, 'Penha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.635075', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4501, NULL, 4501, 'Peritiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.635905', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4502, NULL, 4502, 'Petrolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.636576', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4503, NULL, 4503, 'Picarras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.637358', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4504, NULL, 4504, 'Pinhalzinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.638178', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4505, NULL, 4505, 'Pinheiro Preto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.639052', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4506, NULL, 4506, 'Piratuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.640027', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4507, NULL, 4507, 'Planalto Alegre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.640907', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4508, NULL, 4508, 'Pomerode', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.641749', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4509, NULL, 4509, 'Ponte Alta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.642696', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4510, NULL, 4510, 'Ponte Alta do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.643679', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4511, NULL, 4511, 'Ponte Serrada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.644826', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4512, NULL, 4512, 'Porto Belo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.645727', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4513, NULL, 4513, 'Porto Uniao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.646532', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4514, NULL, 4514, 'Pouso Redondo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.647333', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4515, NULL, 4515, 'Praia Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.648213', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4516, NULL, 4516, 'Presidente Castello Branco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.64913', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4517, NULL, 4517, 'Presidente Getulio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.650041', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4518, NULL, 4518, 'Presidente Nereu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.650912', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4519, NULL, 4519, 'Princesa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.651836', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4520, NULL, 4520, 'Quilombo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.65283', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4521, NULL, 4521, 'Rancho Queimado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.65372', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4522, NULL, 4522, 'Rio das Antas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.654634', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4523, NULL, 4523, 'Rio do Campo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.65549', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4524, NULL, 4524, 'Rio do Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.656406', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4525, NULL, 4525, 'Rio do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.663037', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4526, NULL, 4526, 'Rio dos Cedros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.664346', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4527, NULL, 4527, 'Rio Fortuna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.665268', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4528, NULL, 4528, 'Rio Negrinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.666145', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4529, NULL, 4529, 'Rio Rufino', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.667136', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4530, NULL, 4530, 'Riqueza', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.667883', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4531, NULL, 4531, 'Rodeio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.668722', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4532, NULL, 4532, 'Romelandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.669664', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4533, NULL, 4533, 'Salete', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.670537', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4534, NULL, 4534, 'Saltinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.671426', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4535, NULL, 4535, 'Salto Veloso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.672315', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4536, NULL, 4536, 'Sangao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.67311', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4537, NULL, 4537, 'Santa Cecilia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.674081', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4538, NULL, 4538, 'Santa Helena', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.674964', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4539, NULL, 4539, 'Santa Rosa de Lima', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.675907', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4540, NULL, 4540, 'Santa Rosa do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.676772', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4541, NULL, 4541, 'Santa Terezinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.677855', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4542, NULL, 4542, 'Santa Terezinha do Progresso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.678617', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4543, NULL, 4543, 'Santiago do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.679531', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4544, NULL, 4544, 'Santo Amaro da Imperatriz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.680401', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4545, NULL, 4545, 'Sao Bento do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.681233', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4546, NULL, 4546, 'Sao Bernardino', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.682107', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4547, NULL, 4547, 'Sao Bonifacio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.683118', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4548, NULL, 4548, 'Sao Carlos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.683978', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4549, NULL, 4549, 'Sao Cristovao do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.684896', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4550, NULL, 4550, 'Sao Domingos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.685665', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4551, NULL, 4551, 'Sao Francisco do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.686536', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4552, NULL, 4552, 'Sao Joao Batista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.687673', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4553, NULL, 4553, 'Sao Joao do Itaperiu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.688602', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4554, NULL, 4554, 'Sao Joao do Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.689546', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4555, NULL, 4555, 'Sao Joao do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.690449', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4556, NULL, 4556, 'Sao Joaquim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.691291', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4557, NULL, 4557, 'Sao Jose', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.692211', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4558, NULL, 4558, 'Sao Jose do Cedro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.693112', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4559, NULL, 4559, 'Sao Jose do Cerrito', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.694047', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4560, NULL, 4560, 'Sao Lourenco do Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.694964', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4561, NULL, 4561, 'Sao Ludgero', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.695892', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4562, NULL, 4562, 'Sao Martinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.696805', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4563, NULL, 4563, 'Sao Miguel da Boa Vista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.704183', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4564, NULL, 4564, 'Sao Miguel do Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.705337', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4565, NULL, 4565, 'Sao Pedro de Alcantara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.706219', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4566, NULL, 4566, 'Saudades', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.707271', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4567, NULL, 4567, 'Schroeder', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.708028', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4568, NULL, 4568, 'Seara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.70891', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4569, NULL, 4569, 'Serra Alta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.709735', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4570, NULL, 4570, 'Sideropolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.710532', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4571, NULL, 4571, 'Sombrio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.711816', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4572, NULL, 4572, 'Sul Brasil', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.712836', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4573, NULL, 4573, 'Taio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.713717', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4574, NULL, 4574, 'Tangara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.714564', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4575, NULL, 4575, 'Tigrinhos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.715422', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4576, NULL, 4576, 'Tijucas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.716342', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4577, NULL, 4577, 'Timbe do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.717364', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4578, NULL, 4578, 'Timbo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.718247', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4579, NULL, 4579, 'Timbo Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.719183', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4580, NULL, 4580, 'Tres Barras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.720092', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4581, NULL, 4581, 'Treviso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.720922', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4582, NULL, 4582, 'Treze de Maio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.72182', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4583, NULL, 4583, 'Treze Tilias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.723155', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4584, NULL, 4584, 'Trombudo Central', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.724091', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4585, NULL, 4585, 'Tubarao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.725008', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4586, NULL, 4586, 'Tunapolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.725919', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4587, NULL, 4587, 'Turvo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.726812', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4588, NULL, 4588, 'Uniao do Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.727766', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4589, NULL, 4589, 'Urubici', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.728589', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4590, NULL, 4590, 'Urupema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.729355', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4591, NULL, 4591, 'Urussanga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.730223', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4592, NULL, 4592, 'Vargeao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.731004', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4593, NULL, 4593, 'Vargem', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.73178', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4594, NULL, 4594, 'Vargem Bonita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.732992', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4595, NULL, 4595, 'Vidal Ramos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.734534', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4596, NULL, 4596, 'Videira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.735701', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4597, NULL, 4597, 'Vitor Meireles', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.736573', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4598, NULL, 4598, 'Witmarsum', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.73748', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4599, NULL, 4599, 'Xanxere', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.738315', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4600, NULL, 4600, 'Xavantina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.744776', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4601, NULL, 4601, 'Xaxim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.745932', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4602, NULL, 4602, 'Zortea', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.746831', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4603, NULL, 4603, 'Acegua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.747752', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4604, NULL, 4604, 'Agua Santa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.748623', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4605, NULL, 4605, 'Agudo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.749535', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4606, NULL, 4606, 'Ajuricaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.750335', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4607, NULL, 4607, 'Alecrim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.751293', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4608, NULL, 4608, 'Alegrete', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.75216', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4609, NULL, 4609, 'Alegria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.752979', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4610, NULL, 4610, 'Almirante Tamandare do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.75392', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4611, NULL, 4611, 'Alpestre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.754809', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4612, NULL, 4612, 'Alto Alegre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.755767', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4613, NULL, 4613, 'Alto Feliz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.756681', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4614, NULL, 4614, 'Alvorada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.75756', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4615, NULL, 4615, 'Amaral Ferrador', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.758517', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4616, NULL, 4616, 'Ametista do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.759328', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4617, NULL, 4617, 'Andre da Rocha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.760208', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4618, NULL, 4618, 'Anta Gorda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.760999', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4619, NULL, 4619, 'Antonio Prado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.76193', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4620, NULL, 4620, 'Arambare', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.763109', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4621, NULL, 4621, 'Ararica', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.76479', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4622, NULL, 4622, 'Aratiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.765569', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4623, NULL, 4623, 'Arroio do Meio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.766691', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4624, NULL, 4624, 'Arroio do Padre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.767588', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4625, NULL, 4625, 'Arroio do Sal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.768531', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4626, NULL, 4626, 'Arroio do Tigre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.769457', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4627, NULL, 4627, 'Arroio dos Ratos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.770348', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4628, NULL, 4628, 'Arroio Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.771225', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4629, NULL, 4629, 'Arvorezinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.772101', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4630, NULL, 4630, 'Augusto Pestana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.772977', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4631, NULL, 4631, 'Aurea', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.773902', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4632, NULL, 4632, 'Bage', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.774733', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4633, NULL, 4633, 'Balneario Pinhal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.775604', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4634, NULL, 4634, 'Barao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.776395', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4635, NULL, 4635, 'Barao de Cotegipe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.777163', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4636, NULL, 4636, 'Barao do Triunfo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.778243', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4637, NULL, 4637, 'Barra do Guarita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.784613', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4638, NULL, 4638, 'Barra do Quarai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.786135', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4639, NULL, 4639, 'Barra do Ribeiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.787083', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4640, NULL, 4640, 'Barra do Rio Azul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.787963', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4641, NULL, 4641, 'Barra Funda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.788957', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4642, NULL, 4642, 'Barracao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.789888', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4643, NULL, 4643, 'Barros Cassal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.790848', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4644, NULL, 4644, 'Benjamin Constant do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.791749', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4645, NULL, 4645, 'Bento Goncalves', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.792666', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4646, NULL, 4646, 'Boa Vista das Missoes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.793467', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5515, NULL, 5515, 'Rio Verde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.75147', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4647, NULL, 4647, 'Boa Vista do Burica', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.794351', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4648, NULL, 4648, 'Boa Vista do Cadeado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.795209', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4649, NULL, 4649, 'Boa Vista do Incra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.79609', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4650, NULL, 4650, 'Boa Vista do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.796974', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4651, NULL, 4651, 'Bom Jesus', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.797947', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4652, NULL, 4652, 'Bom Principio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.799093', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4653, NULL, 4653, 'Bom Progresso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.80005', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4654, NULL, 4654, 'Bom Retiro do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.800999', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4655, NULL, 4655, 'Boqueirao do Leao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.801898', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4656, NULL, 4656, 'Bossoroca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.802916', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4657, NULL, 4657, 'Bozano', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.803916', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4658, NULL, 4658, 'Braga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.804862', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4659, NULL, 4659, 'Brochier', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.805735', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4660, NULL, 4660, 'Butia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.806615', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4661, NULL, 4661, 'Cacapava do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.807519', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4662, NULL, 4662, 'Cacequi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.808337', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4663, NULL, 4663, 'Cachoeira do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.809202', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4664, NULL, 4664, 'Cachoeirinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.810127', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4665, NULL, 4665, 'Cacique Doble', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.811004', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4666, NULL, 4666, 'Caibate', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.812204', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4667, NULL, 4667, 'Caicara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.813081', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4668, NULL, 4668, 'Camaqua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.813986', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4669, NULL, 4669, 'Camargo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.814864', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4670, NULL, 4670, 'Cambara do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.815791', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4671, NULL, 4671, 'Campestre da Serra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.816669', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4672, NULL, 4672, 'Campina das Missoes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.817629', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4673, NULL, 4673, 'Campinas do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.818566', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4674, NULL, 4674, 'Campo Bom', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.819422', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4675, NULL, 4675, 'Campo Novo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.825975', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4676, NULL, 4676, 'Campos Borges', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.827145', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4677, NULL, 4677, 'Candelaria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.828029', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4678, NULL, 4678, 'Candido Godoi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.828872', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4679, NULL, 4679, 'Candiota', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.829693', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4680, NULL, 4680, 'Canela', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.830636', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4681, NULL, 4681, 'Cangucu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.831498', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4682, NULL, 4682, 'Canoas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.8323', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4683, NULL, 4683, 'Canudos do Vale', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.833266', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4684, NULL, 4684, 'Capao Bonito do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.834669', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4685, NULL, 4685, 'Capao da Canoa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.835592', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4686, NULL, 4686, 'Capao do Cipo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.836576', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4687, NULL, 4687, 'Capao do Leao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.83748', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4688, NULL, 4688, 'Capela de Santana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.838512', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4689, NULL, 4689, 'Capitao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.839442', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4690, NULL, 4690, 'Capivari do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.840285', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4691, NULL, 4691, 'Caraa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.841208', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4692, NULL, 4692, 'Carazinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.842067', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4693, NULL, 4693, 'Carlos Barbosa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.842932', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4694, NULL, 4694, 'Carlos Gomes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.843835', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4695, NULL, 4695, 'Casca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.844744', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4696, NULL, 4696, 'Caseiros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.845669', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4697, NULL, 4697, 'Catuipe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.846536', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4698, NULL, 4698, 'Caxias do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.847409', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4699, NULL, 4699, 'Centenario', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.848283', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4700, NULL, 4700, 'Cerrito', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.849096', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4701, NULL, 4701, 'Cerro Branco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.849907', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4702, NULL, 4702, 'Cerro Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.850689', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4703, NULL, 4703, 'Cerro Grande do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.851567', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4704, NULL, 4704, 'Cerro Largo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.852471', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4705, NULL, 4705, 'Chapada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.853292', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4706, NULL, 4706, 'Charqueadas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.854176', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4707, NULL, 4707, 'Charrua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.855027', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4708, NULL, 4708, 'Chiapeta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.85595', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4709, NULL, 4709, 'Chui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.856725', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4710, NULL, 4710, 'Chuvisca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.857603', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4711, NULL, 4711, 'Cidreira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.85851', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4712, NULL, 4712, 'Ciriaco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.859474', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4713, NULL, 4713, 'Colinas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.866184', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4714, NULL, 4714, 'Colorado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.86748', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4715, NULL, 4715, 'Condor', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.868275', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4716, NULL, 4716, 'Constantina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.869145', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4717, NULL, 4717, 'Coqueiro Baixo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.870084', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4718, NULL, 4718, 'Coqueiros do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.87097', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4719, NULL, 4719, 'Coronel Barros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.871889', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4720, NULL, 4720, 'Coronel Bicaco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.872786', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4721, NULL, 4721, 'Coronel Pilar', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.873768', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4722, NULL, 4722, 'Cotipora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.874553', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4723, NULL, 4723, 'Coxilha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.875317', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4724, NULL, 4724, 'Crissiumal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.876204', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4725, NULL, 4725, 'Cristal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.877062', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4726, NULL, 4726, 'Cristal do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.877944', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4727, NULL, 4727, 'Cruz Alta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.879136', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4728, NULL, 4728, 'Cruzaltense', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.88005', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4729, NULL, 4729, 'Cruzeiro do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.880928', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4730, NULL, 4730, 'David Canabarro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.881777', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4731, NULL, 4731, 'Derrubadas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.882651', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4732, NULL, 4732, 'Dezesseis de Novembro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.883767', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4733, NULL, 4733, 'Dilermando de Aguiar', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.884831', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4734, NULL, 4734, 'Dois Irmaos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.885678', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4735, NULL, 4735, 'Dois Irmaos das Missoes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.886822', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4736, NULL, 4736, 'Dois Lajeados', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.887804', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4737, NULL, 4737, 'Dom Feliciano', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.889073', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4738, NULL, 4738, 'Dom Pedrito', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.890589', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4739, NULL, 4739, 'Dom Pedro de Alcantara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.891631', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4740, NULL, 4740, 'Dona Francisca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.892557', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4741, NULL, 4741, 'Doutor Mauricio Cardoso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.893417', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4742, NULL, 4742, 'Doutor Ricardo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.894387', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4743, NULL, 4743, 'Eldorado do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.895258', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4744, NULL, 4744, 'Encantado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.896204', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4745, NULL, 4745, 'Encruzilhada do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.89707', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4746, NULL, 4746, 'Engenho Velho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.898021', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4747, NULL, 4747, 'Entre Rios do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.899076', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4748, NULL, 4748, 'Entre-ijuis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.899999', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4749, NULL, 4749, 'Erebango', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.906919', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4750, NULL, 4750, 'Erechim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.908132', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4751, NULL, 4751, 'Ernestina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.909116', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4752, NULL, 4752, 'Erval Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.910038', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4753, NULL, 4753, 'Erval Seco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.910899', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4754, NULL, 4754, 'Esmeralda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.91172', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4755, NULL, 4755, 'Esperanca do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.912737', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4756, NULL, 4756, 'Espumoso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.913602', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4757, NULL, 4757, 'Estacao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.914491', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4758, NULL, 4758, 'Estancia Velha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.915345', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4759, NULL, 4759, 'Esteio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.916206', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4760, NULL, 4760, 'Estrela', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.917135', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4761, NULL, 4761, 'Estrela Velha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.918019', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4762, NULL, 4762, 'Eugenio de Castro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.918923', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4763, NULL, 4763, 'Fagundes Varela', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.919878', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4764, NULL, 4764, 'Farroupilha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.920693', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4765, NULL, 4765, 'Faxinal do Soturno', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.92163', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4766, NULL, 4766, 'Faxinalzinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.922524', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4767, NULL, 4767, 'Fazenda Vilanova', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.923302', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4768, NULL, 4768, 'Feliz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.924228', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4769, NULL, 4769, 'Flores da Cunha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.925172', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4770, NULL, 4770, 'Floriano Peixoto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.926129', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4771, NULL, 4771, 'Fontoura Xavier', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.927051', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4772, NULL, 4772, 'Formigueiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.928008', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4773, NULL, 4773, 'Forquetinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.928929', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4774, NULL, 4774, 'Fortaleza dos Valos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.929825', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4775, NULL, 4775, 'Frederico Westphalen', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.93063', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4776, NULL, 4776, 'Garibaldi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.931355', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4777, NULL, 4777, 'Garruchos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.932182', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4778, NULL, 4778, 'Gaurama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.933069', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4779, NULL, 4779, 'General Camara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.934026', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4780, NULL, 4780, 'Gentil', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.934915', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4781, NULL, 4781, 'Getulio Vargas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.935839', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4782, NULL, 4782, 'Girua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.936719', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4783, NULL, 4783, 'Glorinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.937632', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4784, NULL, 4784, 'Gramado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.938533', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4785, NULL, 4785, 'Gramado dos Loureiros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.939344', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4786, NULL, 4786, 'Gramado Xavier', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.940203', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4787, NULL, 4787, 'Gravatai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.941029', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4788, NULL, 4788, 'Guabiju', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.947441', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4789, NULL, 4789, 'Guaiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.9486', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4790, NULL, 4790, 'Guapore', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.949507', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4791, NULL, 4791, 'Guarani das Missoes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.950373', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4792, NULL, 4792, 'Harmonia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.951225', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4793, NULL, 4793, 'Herval', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.952112', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4794, NULL, 4794, 'Herveiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.953031', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4795, NULL, 4795, 'Horizontina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.953898', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4796, NULL, 4796, 'Hulha Negra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.954845', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4797, NULL, 4797, 'Humaita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.955805', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4798, NULL, 4798, 'Ibarama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.95672', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4799, NULL, 4799, 'Ibiaca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.957546', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4800, NULL, 4800, 'Ibiraiaras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.958417', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4801, NULL, 4801, 'Ibirapuita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.959294', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4802, NULL, 4802, 'Ibiruba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.96032', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4803, NULL, 4803, 'Igrejinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.96119', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4804, NULL, 4804, 'Ijui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.96206', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4805, NULL, 4805, 'Ilopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.962987', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4806, NULL, 4806, 'Imbe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.963785', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4807, NULL, 4807, 'Imigrante', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.965082', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4808, NULL, 4808, 'Independencia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.96594', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4809, NULL, 4809, 'Inhacora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.966873', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4810, NULL, 4810, 'Ipe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.967679', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4811, NULL, 4811, 'Ipiranga do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.968588', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4812, NULL, 4812, 'Irai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.969396', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4813, NULL, 4813, 'Itaara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.970351', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4814, NULL, 4814, 'Itacurubi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.971294', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4815, NULL, 4815, 'Itapuca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.972165', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4816, NULL, 4816, 'Itaqui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.973061', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4817, NULL, 4817, 'Itati', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.974002', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4818, NULL, 4818, 'Itatiba do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.974873', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4819, NULL, 4819, 'Ivora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.975784', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4820, NULL, 4820, 'Ivoti', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.976642', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4821, NULL, 4821, 'Jaboticaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.977503', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4822, NULL, 4822, 'Jacuizinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.978423', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4823, NULL, 4823, 'Jacutinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.979538', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4824, NULL, 4824, 'Jaguarao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.980338', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4825, NULL, 4825, 'Jaguari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.981152', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4826, NULL, 4826, 'Jaquirana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.987939', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4827, NULL, 4827, 'Jari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.989393', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4828, NULL, 4828, 'Joia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.990672', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4829, NULL, 4829, 'Julio de Castilhos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.991636', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4830, NULL, 4830, 'Lagoa Bonita do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.992696', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4831, NULL, 4831, 'Lagoa dos Tres Cantos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.993546', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4832, NULL, 4832, 'Lagoa Vermelha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.99444', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4833, NULL, 4833, 'Lagoao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.995228', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4834, NULL, 4834, 'Lajeado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.996115', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4835, NULL, 4835, 'Lajeado do Bugre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.996989', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4836, NULL, 4836, 'Lavras do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.998102', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4837, NULL, 4837, 'Liberato Salzano', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.999038', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4838, NULL, 4838, 'Lindolfo Collor', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:38.999932', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4839, NULL, 4839, 'Linha Nova', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.00075', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4840, NULL, 4840, 'Macambara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.001806', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4841, NULL, 4841, 'Machadinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.002707', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4842, NULL, 4842, 'Mampituba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.003651', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4843, NULL, 4843, 'Manoel Viana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.004534', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4844, NULL, 4844, 'Maquine', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.005502', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4845, NULL, 4845, 'Marata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.006454', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4846, NULL, 4846, 'Marau', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.007402', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4847, NULL, 4847, 'Marcelino Ramos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.008247', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4848, NULL, 4848, 'Mariana Pimentel', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.009044', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4849, NULL, 4849, 'Mariano Moro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.009911', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4850, NULL, 4850, 'Marques de Souza', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.010831', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4851, NULL, 4851, 'Mata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.011716', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4852, NULL, 4852, 'Mato Castelhano', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.012915', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4853, NULL, 4853, 'Mato Leitao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.013882', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4854, NULL, 4854, 'Mato Queimado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.014734', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4855, NULL, 4855, 'Maximiliano de Almeida', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.01553', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4856, NULL, 4856, 'Minas do Leao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.016287', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4857, NULL, 4857, 'Miraguai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.017159', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4858, NULL, 4858, 'Montauri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.018117', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4859, NULL, 4859, 'Monte Alegre dos Campos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.018991', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4860, NULL, 4860, 'Monte Belo do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.019902', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4861, NULL, 4861, 'Montenegro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.020835', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4862, NULL, 4862, 'Mormaco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.02173', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4863, NULL, 4863, 'Morrinhos do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.028527', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4864, NULL, 4864, 'Morro Redondo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.02965', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4865, NULL, 4865, 'Morro Reuter', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.030692', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4866, NULL, 4866, 'Mostardas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.032073', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4867, NULL, 4867, 'Mucum', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.033021', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4868, NULL, 4868, 'Muitos Capoes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.033894', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4869, NULL, 4869, 'Muliterno', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.03487', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4870, NULL, 4870, 'Nao-me-toque', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.035708', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4871, NULL, 4871, 'Nicolau Vergueiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.036634', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4872, NULL, 4872, 'Nonoai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.037482', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4873, NULL, 4873, 'Nova Alvorada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.038493', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4874, NULL, 4874, 'Nova Araca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.039364', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4875, NULL, 4875, 'Nova Bassano', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.040191', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4876, NULL, 4876, 'Nova Boa Vista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.041367', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4877, NULL, 4877, 'Nova Brescia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.042406', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4878, NULL, 4878, 'Nova Candelaria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.043243', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4879, NULL, 4879, 'Nova Esperanca do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.044148', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4880, NULL, 4880, 'Nova Hartz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.044942', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4881, NULL, 4881, 'Nova Padua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.045858', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4882, NULL, 4882, 'Nova Palma', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.04664', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4883, NULL, 4883, 'Nova Petropolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.047523', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4884, NULL, 4884, 'Nova Prata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.04839', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4885, NULL, 4885, 'Nova Ramada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.049254', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4886, NULL, 4886, 'Nova Roma do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.050199', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4887, NULL, 4887, 'Nova Santa Rita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.051107', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4888, NULL, 4888, 'Novo Barreiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.052035', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4889, NULL, 4889, 'Novo Cabrais', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.052834', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4890, NULL, 4890, 'Novo Hamburgo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.053668', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4891, NULL, 4891, 'Novo Machado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.054539', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4892, NULL, 4892, 'Novo Tiradentes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.055463', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4893, NULL, 4893, 'Novo Xingu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.056358', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4894, NULL, 4894, 'Osorio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.057633', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4895, NULL, 4895, 'Paim Filho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.058522', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4896, NULL, 4896, 'Palmares do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.0594', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4897, NULL, 4897, 'Palmeira das Missoes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.06019', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4898, NULL, 4898, 'Palmitinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.061164', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4899, NULL, 4899, 'Panambi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.062045', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4900, NULL, 4900, 'Pantano Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.062725', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4901, NULL, 4901, 'Parai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.069617', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4902, NULL, 4902, 'Paraiso do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.07061', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4903, NULL, 4903, 'Pareci Novo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.07147', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4904, NULL, 4904, 'Parobe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.072404', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4905, NULL, 4905, 'Passa Sete', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.073291', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4906, NULL, 4906, 'Passo do Sobrado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.074185', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4907, NULL, 4907, 'Passo Fundo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.075119', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4908, NULL, 4908, 'Paulo Bento', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.076016', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4909, NULL, 4909, 'Paverama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.076943', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4910, NULL, 4910, 'Pedras Altas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.077899', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4911, NULL, 4911, 'Pedro Osorio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.078764', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4912, NULL, 4912, 'Pejucara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.08024', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4913, NULL, 4913, 'Pelotas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.081029', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4914, NULL, 4914, 'Picada Cafe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.082336', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4915, NULL, 4915, 'Pinhal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.083171', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4916, NULL, 4916, 'Pinhal da Serra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.083953', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4917, NULL, 4917, 'Pinhal Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.084872', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4918, NULL, 4918, 'Pinheirinho do Vale', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.08576', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4919, NULL, 4919, 'Pinheiro Machado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.086681', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4920, NULL, 4920, 'Pirapo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.087579', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4921, NULL, 4921, 'Piratini', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.088495', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4922, NULL, 4922, 'Planalto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.089514', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4923, NULL, 4923, 'Poco das Antas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.090675', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4924, NULL, 4924, 'Pontao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.091762', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4925, NULL, 4925, 'Ponte Preta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.092594', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4926, NULL, 4926, 'Portao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.093566', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4927, NULL, 4927, 'Porto Alegre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.094539', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4928, NULL, 4928, 'Porto Lucena', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.095462', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4929, NULL, 4929, 'Porto Maua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.09633', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4930, NULL, 4930, 'Porto Vera Cruz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.097306', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4931, NULL, 4931, 'Porto Xavier', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.098217', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4932, NULL, 4932, 'Pouso Novo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.099245', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4933, NULL, 4933, 'Presidente Lucena', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.10017', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4934, NULL, 4934, 'Progresso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.101105', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4935, NULL, 4935, 'Protasio Alves', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.102143', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4936, NULL, 4936, 'Putinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.103128', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4937, NULL, 4937, 'Quarai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.10406', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4938, NULL, 4938, 'Quatro Irmaos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.110644', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4939, NULL, 4939, 'Quevedos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.111825', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4940, NULL, 4940, 'Quinze de Novembro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.112857', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4941, NULL, 4941, 'Redentora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.113697', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4942, NULL, 4942, 'Relvado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.114655', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4943, NULL, 4943, 'Restinga Seca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.115499', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4944, NULL, 4944, 'Rio dos Indios', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.116294', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4945, NULL, 4945, 'Rio Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.117266', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4946, NULL, 4946, 'Rio Pardo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.118179', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4947, NULL, 4947, 'Riozinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.119135', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4948, NULL, 4948, 'Roca Sales', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.119995', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4949, NULL, 4949, 'Rodeio Bonito', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.120924', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4950, NULL, 4950, 'Rolador', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.121849', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4951, NULL, 4951, 'Rolante', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.122777', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4952, NULL, 4952, 'Ronda Alta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.123656', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4953, NULL, 4953, 'Rondinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.124514', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4954, NULL, 4954, 'Roque Gonzales', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.125383', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4955, NULL, 4955, 'Rosario do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.126163', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4956, NULL, 4956, 'Sagrada Familia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.127151', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4957, NULL, 4957, 'Saldanha Marinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.128127', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4958, NULL, 4958, 'Salto do Jacui', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.129107', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4959, NULL, 4959, 'Salvador das Missoes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.13005', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4960, NULL, 4960, 'Salvador do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.130968', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4961, NULL, 4961, 'Sananduva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.131942', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4962, NULL, 4962, 'Santa Barbara do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.132733', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4963, NULL, 4963, 'Santa Cecilia do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.133677', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4964, NULL, 4964, 'Santa Clara do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.134621', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4965, NULL, 4965, 'Santa Cruz do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.135859', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4966, NULL, 4966, 'Santa Margarida do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.136798', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4967, NULL, 4967, 'Santa Maria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.137745', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4968, NULL, 4968, 'Santa Maria do Herval', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.138656', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4969, NULL, 4969, 'Santa Rosa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.139651', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4970, NULL, 4970, 'Santa Tereza', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.140575', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4971, NULL, 4971, 'Santa Vitoria do Palmar', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.141428', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4972, NULL, 4972, 'Santana da Boa Vista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.142334', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4973, NULL, 4973, 'Santana do Livramento', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.143302', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4974, NULL, 4974, 'Santiago', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.144184', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4975, NULL, 4975, 'Santo Angelo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.150861', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4976, NULL, 4976, 'Santo Antonio da Patrulha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.151967', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4977, NULL, 4977, 'Santo Antonio das Missoes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.152911', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4978, NULL, 4978, 'Santo Antonio do Palma', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.153811', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4979, NULL, 4979, 'Santo Antonio do Planalto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.154666', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4980, NULL, 4980, 'Santo Augusto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.155574', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4981, NULL, 4981, 'Santo Cristo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.156456', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4982, NULL, 4982, 'Santo Expedito do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.157362', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4983, NULL, 4983, 'Sao Borja', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.158226', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4984, NULL, 4984, 'Sao Domingos do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.159172', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4985, NULL, 4985, 'Sao Francisco de Assis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.160002', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4986, NULL, 4986, 'Sao Francisco de Paula', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.160916', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4987, NULL, 4987, 'Sao Gabriel', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.161758', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4988, NULL, 4988, 'Sao Jeronimo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.162555', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4989, NULL, 4989, 'Sao Joao da Urtiga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.163489', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4990, NULL, 4990, 'Sao Joao do Polesine', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.164452', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4991, NULL, 4991, 'Sao Jorge', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.165471', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4992, NULL, 4992, 'Sao Jose das Missoes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.166514', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4993, NULL, 4993, 'Sao Jose do Herval', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.167402', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4994, NULL, 4994, 'Sao Jose do Hortencio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.168302', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4995, NULL, 4995, 'Sao Jose do Inhacora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.169448', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4996, NULL, 4996, 'Sao Jose do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.170483', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4997, NULL, 4997, 'Sao Jose do Ouro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.171355', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4998, NULL, 4998, 'Sao Jose do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.172279', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (4999, NULL, 4999, 'Sao Jose dos Ausentes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.173227', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5000, NULL, 5000, 'Sao Leopoldo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.174112', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5001, NULL, 5001, 'Sao Lourenco do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.175066', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5002, NULL, 5002, 'Sao Luiz Gonzaga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.176058', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5003, NULL, 5003, 'Sao Marcos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.176959', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5004, NULL, 5004, 'Sao Martinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.177897', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5005, NULL, 5005, 'Sao Martinho da Serra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.178867', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5006, NULL, 5006, 'Sao Miguel das Missoes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.17986', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5007, NULL, 5007, 'Sao Nicolau', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.180803', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5008, NULL, 5008, 'Sao Paulo das Missoes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.181651', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5009, NULL, 5009, 'Sao Pedro da Serra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.18264', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5010, NULL, 5010, 'Sao Pedro das Missoes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.183578', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5011, NULL, 5011, 'Sao Pedro do Butia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.184568', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5012, NULL, 5012, 'Sao Pedro do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.191638', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5013, NULL, 5013, 'Sao Sebastiao do Cai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.192927', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5014, NULL, 5014, 'Sao Sepe', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.193953', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5015, NULL, 5015, 'Sao Valentim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.194793', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5016, NULL, 5016, 'Sao Valentim do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.195665', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5017, NULL, 5017, 'Sao Valerio do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.196491', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5018, NULL, 5018, 'Sao Vendelino', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.197532', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5019, NULL, 5019, 'Sao Vicente do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.198462', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5020, NULL, 5020, 'Sapiranga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.199365', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5021, NULL, 5021, 'Sapucaia do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.200245', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5022, NULL, 5022, 'Sarandi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.201335', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5023, NULL, 5023, 'Seberi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.202194', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5024, NULL, 5024, 'Sede Nova', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.203247', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5025, NULL, 5025, 'Segredo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.204153', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5026, NULL, 5026, 'Selbach', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.205013', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5027, NULL, 5027, 'Senador Salgado Filho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.205893', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5028, NULL, 5028, 'Sentinela do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.206792', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5029, NULL, 5029, 'Serafina Correa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.207836', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5030, NULL, 5030, 'Serio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.208802', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5031, NULL, 5031, 'Sertao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.209619', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5032, NULL, 5032, 'Sertao Santana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.210595', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5033, NULL, 5033, 'Sete de Setembro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.211625', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5034, NULL, 5034, 'Severiano de Almeida', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.21262', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5035, NULL, 5035, 'Silveira Martins', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.213555', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5036, NULL, 5036, 'Sinimbu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.21458', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5037, NULL, 5037, 'Sobradinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.215477', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5038, NULL, 5038, 'Soledade', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.216332', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5039, NULL, 5039, 'Tabai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.21724', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5040, NULL, 5040, 'Tapejara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.218094', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5041, NULL, 5041, 'Tapera', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.219034', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5042, NULL, 5042, 'Tapes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.219964', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5043, NULL, 5043, 'Taquara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.220879', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5044, NULL, 5044, 'Taquari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.221862', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5045, NULL, 5045, 'Taquarucu do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.222788', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5046, NULL, 5046, 'Tavares', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.223707', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5047, NULL, 5047, 'Tenente Portela', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.225347', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5048, NULL, 5048, 'Terra de Areia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.232849', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5049, NULL, 5049, 'Teutonia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.234121', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5050, NULL, 5050, 'Tio Hugo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.235123', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5051, NULL, 5051, 'Tiradentes do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.23607', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5052, NULL, 5052, 'Toropi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.236996', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5053, NULL, 5053, 'Torres', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.237913', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5054, NULL, 5054, 'Tramandai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.23885', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5055, NULL, 5055, 'Travesseiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.239806', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5056, NULL, 5056, 'Tres Arroios', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.240805', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5057, NULL, 5057, 'Tres Cachoeiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.241777', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5058, NULL, 5058, 'Tres Coroas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.242724', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5059, NULL, 5059, 'Tres de Maio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.243769', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5060, NULL, 5060, 'Tres Forquilhas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.244655', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5061, NULL, 5061, 'Tres Palmeiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.245532', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5062, NULL, 5062, 'Tres Passos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.246606', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5063, NULL, 5063, 'Trindade do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.247562', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5064, NULL, 5064, 'Triunfo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.248414', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5065, NULL, 5065, 'Tucunduva', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.249233', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5066, NULL, 5066, 'Tunas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.250107', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5067, NULL, 5067, 'Tupanci do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.250953', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5068, NULL, 5068, 'Tupancireta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.251821', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5069, NULL, 5069, 'Tupandi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.252708', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5070, NULL, 5070, 'Tuparendi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.253578', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5071, NULL, 5071, 'Turucu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.254432', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5072, NULL, 5072, 'Ubiretama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.255333', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5073, NULL, 5073, 'Uniao da Serra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.256245', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5074, NULL, 5074, 'Unistalda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.257204', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5075, NULL, 5075, 'Uruguaiana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.258629', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5076, NULL, 5076, 'Vacaria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.259601', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5077, NULL, 5077, 'Vale do Sol', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.260531', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5078, NULL, 5078, 'Vale Real', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.261524', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5079, NULL, 5079, 'Vale Verde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.262431', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5080, NULL, 5080, 'Vanini', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.263447', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5081, NULL, 5081, 'Venancio Aires', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.264406', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5082, NULL, 5082, 'Vera Cruz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.265345', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5083, NULL, 5083, 'Veranopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.26647', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5084, NULL, 5084, 'Vespasiano Correa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.273349', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5085, NULL, 5085, 'Viadutos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.274527', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5086, NULL, 5086, 'Viamao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.275464', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5087, NULL, 5087, 'Vicente Dutra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.276287', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5088, NULL, 5088, 'Victor Graeff', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.27728', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5089, NULL, 5089, 'Vila Flores', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.278305', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5090, NULL, 5090, 'Vila Langaro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.279156', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5091, NULL, 5091, 'Vila Maria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.280109', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5092, NULL, 5092, 'Vila Nova do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.281043', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5093, NULL, 5093, 'Vista Alegre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.281928', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5094, NULL, 5094, 'Vista Alegre do Prata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.282888', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5095, NULL, 5095, 'Vista Gaucha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.283856', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5096, NULL, 5096, 'Vitoria das Missoes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.284731', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5097, NULL, 5097, 'Westfalia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.285646', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5098, NULL, 5098, 'Xangri-la', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.286521', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5099, NULL, 5099, 'Agua Clara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.287518', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5100, NULL, 5100, 'Alcinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.288446', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5101, NULL, 5101, 'Amambai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.289301', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5102, NULL, 5102, 'Anastacio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.290239', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5103, NULL, 5103, 'Anaurilandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.291232', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5104, NULL, 5104, 'Angelica', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.292032', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5105, NULL, 5105, 'Antonio Joao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.293133', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5106, NULL, 5106, 'Aparecida do Taboado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.294053', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5107, NULL, 5107, 'Aquidauana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.294884', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5108, NULL, 5108, 'Aral Moreira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.29572', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5109, NULL, 5109, 'Bandeirantes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.296713', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5110, NULL, 5110, 'Bataguassu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.29763', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5111, NULL, 5111, 'Bataipora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.298595', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5112, NULL, 5112, 'Bela Vista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.299542', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5113, NULL, 5113, 'Bodoquena', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.300463', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5114, NULL, 5114, 'Bonito', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.301372', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5115, NULL, 5115, 'Brasilandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.302327', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5116, NULL, 5116, 'Caarapo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.303136', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5117, NULL, 5117, 'Camapua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.304018', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5118, NULL, 5118, 'Campo Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.30485', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5119, NULL, 5119, 'Caracol', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.305697', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5120, NULL, 5120, 'Cassilandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.306539', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5121, NULL, 5121, 'Chapadao do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.313766', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5122, NULL, 5122, 'Corguinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.314832', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5123, NULL, 5123, 'Coronel Sapucaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.315886', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5124, NULL, 5124, 'Corumba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.316677', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5125, NULL, 5125, 'Costa Rica', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.317565', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5126, NULL, 5126, 'Coxim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.318438', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5127, NULL, 5127, 'Deodapolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.319156', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5128, NULL, 5128, 'Dois Irmaos do Buriti', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.320079', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5129, NULL, 5129, 'Douradina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.320958', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5130, NULL, 5130, 'Dourados', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.321841', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5131, NULL, 5131, 'Eldorado', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.322753', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5132, NULL, 5132, 'Fatima do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.323883', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5133, NULL, 5133, 'Figueirao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.324801', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5134, NULL, 5134, 'Gloria de Dourados', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.325637', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5135, NULL, 5135, 'Guia Lopes da Laguna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.326641', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5136, NULL, 5136, 'Iguatemi', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.327619', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5137, NULL, 5137, 'Inocencia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.328612', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5138, NULL, 5138, 'Itapora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.329508', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5139, NULL, 5139, 'Itaquirai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.33029', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5140, NULL, 5140, 'Ivinhema', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.331111', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5141, NULL, 5141, 'Japora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.332023', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5142, NULL, 5142, 'Jaraguari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.332947', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5143, NULL, 5143, 'Jardim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.333891', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5144, NULL, 5144, 'Jatei', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.334815', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5145, NULL, 5145, 'Juti', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.335804', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5146, NULL, 5146, 'Ladario', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.336612', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5147, NULL, 5147, 'Laguna Carapa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.337536', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5148, NULL, 5148, 'Maracaju', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.338444', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5149, NULL, 5149, 'Miranda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.33931', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5150, NULL, 5150, 'Mundo Novo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.340178', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5151, NULL, 5151, 'Navirai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.341075', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5152, NULL, 5152, 'Nioaque', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.341888', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5153, NULL, 5153, 'Nova Alvorada do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.342697', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5154, NULL, 5154, 'Nova Andradina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.343615', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5155, NULL, 5155, 'Novo Horizonte do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.344527', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5156, NULL, 5156, 'Paranaiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.345447', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5157, NULL, 5157, 'Paranhos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.346394', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5158, NULL, 5158, 'Pedro Gomes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.347493', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5159, NULL, 5159, 'Ponta Pora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.35418', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5160, NULL, 5160, 'Porto Murtinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.355395', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5161, NULL, 5161, 'Ribas do Rio Pardo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.356263', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5162, NULL, 5162, 'Rio Brilhante', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.357159', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5163, NULL, 5163, 'Rio Negro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.358428', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5164, NULL, 5164, 'Rio Verde de Mato Grosso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.359236', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5165, NULL, 5165, 'Rochedo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.360185', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5166, NULL, 5166, 'Santa Rita do Pardo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.360982', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5167, NULL, 5167, 'Sao Gabriel do Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.362003', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5168, NULL, 5168, 'Selviria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.362991', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5169, NULL, 5169, 'Sete Quedas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.363971', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5170, NULL, 5170, 'Sidrolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.364965', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5171, NULL, 5171, 'Sonora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.366069', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5172, NULL, 5172, 'Tacuru', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.366911', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5173, NULL, 5173, 'Taquarussu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.368294', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5174, NULL, 5174, 'Terenos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.369444', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5175, NULL, 5175, 'Tres Lagoas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.370315', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5176, NULL, 5176, 'Vicentina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.371201', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5177, NULL, 5177, 'Acorizal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.372079', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5178, NULL, 5178, 'Agua Boa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.372947', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5179, NULL, 5179, 'Alta Floresta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.373825', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5180, NULL, 5180, 'Alto Araguaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.374753', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5181, NULL, 5181, 'Alto Boa Vista', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.375625', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5182, NULL, 5182, 'Alto Garcas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.376478', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5183, NULL, 5183, 'Alto Paraguai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.37727', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5184, NULL, 5184, 'Alto Taquari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.378248', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5185, NULL, 5185, 'Apiacas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.379176', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5186, NULL, 5186, 'Araguaiana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.380109', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5187, NULL, 5187, 'Araguainha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.381101', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5188, NULL, 5188, 'Araputanga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.382033', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5189, NULL, 5189, 'Arenapolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.383142', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5190, NULL, 5190, 'Aripuana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.383975', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5191, NULL, 5191, 'Barao de Melgaco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.384902', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5192, NULL, 5192, 'Barra do Bugres', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.385821', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5193, NULL, 5193, 'Barra do Garcas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.386784', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5194, NULL, 5194, 'Bom Jesus do Araguaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.387912', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5195, NULL, 5195, 'Brasnorte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.395783', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5196, NULL, 5196, 'Caceres', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.396886', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5197, NULL, 5197, 'Campinapolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.397801', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5198, NULL, 5198, 'Campo Novo do Parecis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.398624', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5199, NULL, 5199, 'Campo Verde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.399594', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5200, NULL, 5200, 'Campos de Julio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.400449', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5201, NULL, 5201, 'Canabrava do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.401301', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5202, NULL, 5202, 'Canarana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.402031', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5203, NULL, 5203, 'Carlinda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.403458', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5204, NULL, 5204, 'Castanheira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.404495', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5205, NULL, 5205, 'Chapada dos Guimaraes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.405573', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5206, NULL, 5206, 'Claudia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.406653', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5207, NULL, 5207, 'Cocalinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.407608', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5208, NULL, 5208, 'Colider', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.408507', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5209, NULL, 5209, 'Colniza', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.409412', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5210, NULL, 5210, 'Comodoro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.410397', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5211, NULL, 5211, 'Confresa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.411332', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5212, NULL, 5212, 'Conquista D''oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.412235', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5213, NULL, 5213, 'Cotriguacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.413221', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5214, NULL, 5214, 'Cuiaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.414149', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5215, NULL, 5215, 'Cuverlandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.415073', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5216, NULL, 5216, 'Denise', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.416081', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5217, NULL, 5217, 'Diamantino', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.417014', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5218, NULL, 5218, 'Dom Aquino', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.417947', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5219, NULL, 5219, 'Feliz Natal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.418926', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5220, NULL, 5220, 'Figueiropolis D''oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.419849', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5221, NULL, 5221, 'Gaucha do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.4207', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5222, NULL, 5222, 'General Carneiro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.421639', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5223, NULL, 5223, 'Gloria D''oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.422532', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5224, NULL, 5224, 'Guaranta do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.423784', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5225, NULL, 5225, 'Guiratinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.424887', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5226, NULL, 5226, 'Indiavai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.425733', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5227, NULL, 5227, 'Ipiranga do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.426779', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5228, NULL, 5228, 'Itanhanga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.427777', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5229, NULL, 5229, 'Itauba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.42877', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5230, NULL, 5230, 'Itiquira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.429726', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5231, NULL, 5231, 'Jaciara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.436354', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5232, NULL, 5232, 'Jangada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.437631', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5233, NULL, 5233, 'Jauru', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.438623', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5234, NULL, 5234, 'Juara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.439558', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5235, NULL, 5235, 'Juina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.440473', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5236, NULL, 5236, 'Juruena', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.441383', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5237, NULL, 5237, 'Juscimeira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.442317', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5238, NULL, 5238, 'Lambari D''oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.443327', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5239, NULL, 5239, 'Lucas do Rio Verde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.444223', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5240, NULL, 5240, 'Luciara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.445157', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5241, NULL, 5241, 'Marcelandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.446077', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5242, NULL, 5242, 'Matupa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.447134', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5243, NULL, 5243, 'Mirassol D''oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.448029', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5244, NULL, 5244, 'Nobres', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.448969', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5245, NULL, 5245, 'Nortelandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.449889', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5246, NULL, 5246, 'Nossa Senhora do Livramento', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.450756', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5247, NULL, 5247, 'Nova Bandeirantes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.451561', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5248, NULL, 5248, 'Nova Brasilandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.452363', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5249, NULL, 5249, 'Nova Canaa do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.453308', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5250, NULL, 5250, 'Nova Guarita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.45418', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5251, NULL, 5251, 'Nova Lacerda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.455047', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5252, NULL, 5252, 'Nova Marilandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.455908', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5253, NULL, 5253, 'Nova Maringa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.456789', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5254, NULL, 5254, 'Nova Monte Verde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.457859', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5255, NULL, 5255, 'Nova Mutum', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.458788', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5256, NULL, 5256, 'Nova Nazare', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.459757', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5257, NULL, 5257, 'Nova Olimpia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.460794', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5258, NULL, 5258, 'Nova Santa Helena', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.461782', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5259, NULL, 5259, 'Nova Ubirata', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.462711', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5260, NULL, 5260, 'Nova Xavantina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.463694', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5261, NULL, 5261, 'Novo Horizonte do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.464598', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5262, NULL, 5262, 'Novo Mundo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.465458', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5263, NULL, 5263, 'Novo Santo Antonio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.466329', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5264, NULL, 5264, 'Novo Sao Joaquim', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.467249', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5265, NULL, 5265, 'Paranaita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.468084', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5266, NULL, 5266, 'Paranatinga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.469197', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5267, NULL, 5267, 'Pedra Preta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.470265', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5268, NULL, 5268, 'Peixoto de Azevedo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.471267', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5269, NULL, 5269, 'Planalto da Serra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.477744', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5270, NULL, 5270, 'Pocone', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.478832', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5271, NULL, 5271, 'Pontal do Araguaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.479747', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5272, NULL, 5272, 'Ponte Branca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.480811', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5273, NULL, 5273, 'Pontes e Lacerda', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.481784', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5274, NULL, 5274, 'Porto Alegre do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.482693', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5275, NULL, 5275, 'Porto dos Gauchos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.483624', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5276, NULL, 5276, 'Porto Esperidiao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.484579', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5277, NULL, 5277, 'Porto Estrela', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.485413', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5278, NULL, 5278, 'Poxoreo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.486341', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5279, NULL, 5279, 'Primavera do Leste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.487239', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5280, NULL, 5280, 'Querencia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.48811', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5281, NULL, 5281, 'Reserva do Cabacal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.489033', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5282, NULL, 5282, 'Ribeirao Cascalheira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.489983', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5283, NULL, 5283, 'Ribeiraozinho', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.490955', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5284, NULL, 5284, 'Rio Branco', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.491842', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5285, NULL, 5285, 'Rondolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.492869', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5286, NULL, 5286, 'Rondonopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.493854', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5287, NULL, 5287, 'Rosario Oeste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.494826', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5288, NULL, 5288, 'Salto do Ceu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.495786', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5289, NULL, 5289, 'Santa Carmem', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.496894', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5290, NULL, 5290, 'Santa Cruz do Xingu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.497687', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5291, NULL, 5291, 'Santa Rita do Trivelato', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.498595', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5292, NULL, 5292, 'Santa Terezinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.499475', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5293, NULL, 5293, 'Santo Afonso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.50045', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5294, NULL, 5294, 'Santo Antonio do Leste', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.50133', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5295, NULL, 5295, 'Santo Antonio do Leverger', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.502127', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5296, NULL, 5296, 'Sao Felix do Araguaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.503103', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5297, NULL, 5297, 'Sao Jose do Povo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.504015', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5298, NULL, 5298, 'Sao Jose do Rio Claro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.504954', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5299, NULL, 5299, 'Sao Jose do Xingu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.505931', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5300, NULL, 5300, 'Sao Jose dos Quatro Marcos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.506858', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5301, NULL, 5301, 'Sao Pedro da Cipa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.507799', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5302, NULL, 5302, 'Sapezal', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.508718', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5303, NULL, 5303, 'Serra Nova Dourada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.509707', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5304, NULL, 5304, 'Sinop', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.510666', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5305, NULL, 5305, 'Sorriso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.51148', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5306, NULL, 5306, 'Tabapora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.51804', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5307, NULL, 5307, 'Tangara da Serra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.51929', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5308, NULL, 5308, 'Tapurah', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.520225', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5309, NULL, 5309, 'Terra Nova do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.521047', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5310, NULL, 5310, 'Tesouro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.521974', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5311, NULL, 5311, 'Torixoreu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.52294', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5312, NULL, 5312, 'Uniao do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.523883', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5313, NULL, 5313, 'Vale de Sao Domingos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.524972', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5314, NULL, 5314, 'Varzea Grande', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.526086', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5315, NULL, 5315, 'Vera', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.526999', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5316, NULL, 5316, 'Vila Bela da Santissima Trindade', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.528916', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5317, NULL, 5317, 'Vila Rica', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.530101', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5318, NULL, 5318, 'Abadia de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.531009', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5319, NULL, 5319, 'Abadiania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.53199', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5320, NULL, 5320, 'Acreuna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.532886', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5321, NULL, 5321, 'Adelandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.533668', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5322, NULL, 5322, 'Agua Fria de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.534826', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5323, NULL, 5323, 'Agua Limpa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.535749', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5324, NULL, 5324, 'Aguas Lindas de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.53668', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5325, NULL, 5325, 'Alexania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.537739', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5326, NULL, 5326, 'Aloandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.53862', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5327, NULL, 5327, 'Alto Horizonte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.539517', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5328, NULL, 5328, 'Alto Paraiso de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.540454', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5329, NULL, 5329, 'Alvorada do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.541418', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5330, NULL, 5330, 'Amaralina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.542313', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5331, NULL, 5331, 'Americano do Brasil', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.543192', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5332, NULL, 5332, 'Amorinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.544118', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5333, NULL, 5333, 'Anapolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.544995', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5334, NULL, 5334, 'Anhanguera', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.545877', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5335, NULL, 5335, 'Anicuns', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.54685', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5336, NULL, 5336, 'Aparecida de Goiania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.547789', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5337, NULL, 5337, 'Aparecida do Rio Doce', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.548635', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5338, NULL, 5338, 'Apore', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.549452', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5339, NULL, 5339, 'Aracu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.550511', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5340, NULL, 5340, 'Aragarcas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.551456', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5341, NULL, 5341, 'Aragoiania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.558409', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5342, NULL, 5342, 'Araguapaz', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.559799', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5343, NULL, 5343, 'Arenopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.5608', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5344, NULL, 5344, 'Aruana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.561736', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5345, NULL, 5345, 'Aurilandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.562641', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5346, NULL, 5346, 'Avelinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.563516', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5347, NULL, 5347, 'Baliza', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.564819', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5348, NULL, 5348, 'Barro Alto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.56604', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5349, NULL, 5349, 'Bela Vista de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.566961', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5350, NULL, 5350, 'Bom Jardim de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.567928', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5351, NULL, 5351, 'Bom Jesus de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.568869', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5352, NULL, 5352, 'Bonfinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.569784', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5353, NULL, 5353, 'Bonopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.570757', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5354, NULL, 5354, 'Brazabrantes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.571611', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5355, NULL, 5355, 'Britania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.572486', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5356, NULL, 5356, 'Buriti Alegre', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.57334', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5357, NULL, 5357, 'Buriti de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.57425', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5358, NULL, 5358, 'Buritinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.575213', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5359, NULL, 5359, 'Cabeceiras', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.57613', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5360, NULL, 5360, 'Cachoeira Alta', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.577058', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5361, NULL, 5361, 'Cachoeira de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.577887', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5362, NULL, 5362, 'Cachoeira Dourada', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.578836', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5363, NULL, 5363, 'Cacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.579767', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5364, NULL, 5364, 'Caiaponia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.580695', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5365, NULL, 5365, 'Caldas Novas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.581988', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5366, NULL, 5366, 'Caldazinha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.582914', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5367, NULL, 5367, 'Campestre de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.583775', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5368, NULL, 5368, 'Campinacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.584712', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5369, NULL, 5369, 'Campinorte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.585668', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5370, NULL, 5370, 'Campo Alegre de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.586525', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5371, NULL, 5371, 'Campo Limpo de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.587364', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5372, NULL, 5372, 'Campos Belos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.588237', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5373, NULL, 5373, 'Campos Verdes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.589202', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5374, NULL, 5374, 'Carmo do Rio Verde', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.590143', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5375, NULL, 5375, 'Castelandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.591002', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5376, NULL, 5376, 'Catalao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.592188', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5377, NULL, 5377, 'Caturai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.603004', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5378, NULL, 5378, 'Cavalcante', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.604319', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5379, NULL, 5379, 'Ceres', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.605372', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5380, NULL, 5380, 'Cezarina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.606325', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5381, NULL, 5381, 'Chapadao do Ceu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.607336', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5382, NULL, 5382, 'Cidade Ocidental', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.608275', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5383, NULL, 5383, 'Cocalzinho de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.609119', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5384, NULL, 5384, 'Colinas do Sul', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.609959', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5385, NULL, 5385, 'Corrego do Ouro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.610872', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5386, NULL, 5386, 'Corumba de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.611794', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5387, NULL, 5387, 'Corumbaiba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.612763', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5388, NULL, 5388, 'Cristalina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.613699', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5389, NULL, 5389, 'Cristianopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.614727', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5390, NULL, 5390, 'Crixas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.615553', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5391, NULL, 5391, 'Crominia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.616462', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5392, NULL, 5392, 'Cumari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.61735', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5393, NULL, 5393, 'Damianopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.618249', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5394, NULL, 5394, 'Damolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.619199', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5395, NULL, 5395, 'Davinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.620154', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5396, NULL, 5396, 'Diorama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.621073', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5397, NULL, 5397, 'Divinopolis de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.622032', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5398, NULL, 5398, 'Doverlandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.623068', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5399, NULL, 5399, 'Edealina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.623962', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5400, NULL, 5400, 'Edeia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.624932', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5401, NULL, 5401, 'Estrela do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.625947', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5402, NULL, 5402, 'Faina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.626774', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5403, NULL, 5403, 'Fazenda Nova', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.627692', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5404, NULL, 5404, 'Firminopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.628612', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5405, NULL, 5405, 'Flores de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.629589', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5406, NULL, 5406, 'Formosa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.630429', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5407, NULL, 5407, 'Formoso', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.631268', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5408, NULL, 5408, 'Gameleira de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.632204', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5409, NULL, 5409, 'Goianapolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.633039', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5410, NULL, 5410, 'Goiandira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.633983', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5411, NULL, 5411, 'Goianesia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.634918', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5412, NULL, 5412, 'Goiania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.635858', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5413, NULL, 5413, 'Goianira', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.636781', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5414, NULL, 5414, 'Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.643396', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5415, NULL, 5415, 'Goiatuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.644646', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5416, NULL, 5416, 'Gouvelandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.645672', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5417, NULL, 5417, 'Guapo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.646555', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5418, NULL, 5418, 'Guaraita', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.647553', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5419, NULL, 5419, 'Guarani de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.648866', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5420, NULL, 5420, 'Guarinos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.649863', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5421, NULL, 5421, 'Heitorai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.650692', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5422, NULL, 5422, 'Hidrolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.651434', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5423, NULL, 5423, 'Hidrolina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.65227', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5424, NULL, 5424, 'Iaciara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.653174', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5425, NULL, 5425, 'Inaciolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.654174', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5426, NULL, 5426, 'Indiara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.655008', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5427, NULL, 5427, 'Inhumas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.655851', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5428, NULL, 5428, 'Ipameri', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.656848', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5429, NULL, 5429, 'Ipiranga de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.657863', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5430, NULL, 5430, 'Ipora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.658736', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5431, NULL, 5431, 'Israelandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.659837', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5432, NULL, 5432, 'Itaberai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.660714', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5433, NULL, 5433, 'Itaguari', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.66169', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5434, NULL, 5434, 'Itaguaru', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.662571', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5435, NULL, 5435, 'Itaja', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.663372', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5436, NULL, 5436, 'Itapaci', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.664184', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5437, NULL, 5437, 'Itapirapua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.665155', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5438, NULL, 5438, 'Itapuranga', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.666064', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5439, NULL, 5439, 'Itaruma', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.666945', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5440, NULL, 5440, 'Itaucu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.667766', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5441, NULL, 5441, 'Itumbiara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.668731', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5442, NULL, 5442, 'Ivolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.669617', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5443, NULL, 5443, 'Jandaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.670602', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5444, NULL, 5444, 'Jaragua', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.671381', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5445, NULL, 5445, 'Jatai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.672203', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5446, NULL, 5446, 'Jaupaci', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.673077', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5447, NULL, 5447, 'Jesupolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.67413', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5448, NULL, 5448, 'Joviania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.675038', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5449, NULL, 5449, 'Jussara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.675958', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5450, NULL, 5450, 'Lagoa Santa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.676927', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5451, NULL, 5451, 'Leopoldo de Bulhoes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.687916', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5452, NULL, 5452, 'Luziania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.689054', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5453, NULL, 5453, 'Mairipotaba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.689933', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5454, NULL, 5454, 'Mambai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.69083', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5455, NULL, 5455, 'Mara Rosa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.691716', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5456, NULL, 5456, 'Marzagao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.692635', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5457, NULL, 5457, 'Matrincha', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.693504', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5458, NULL, 5458, 'Maurilandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.694336', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5459, NULL, 5459, 'Mimoso de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.695216', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5460, NULL, 5460, 'Minacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.696172', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5461, NULL, 5461, 'Mineiros', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.697089', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5462, NULL, 5462, 'Moipora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.698025', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5463, NULL, 5463, 'Monte Alegre de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.69892', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5464, NULL, 5464, 'Montes Claros de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.699882', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5465, NULL, 5465, 'Montividiu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.700799', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5466, NULL, 5466, 'Montividiu do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.701715', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5467, NULL, 5467, 'Morrinhos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.702638', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5468, NULL, 5468, 'Morro Agudo de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.703663', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5469, NULL, 5469, 'Mossamedes', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.704418', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5470, NULL, 5470, 'Mozarlandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.705276', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5471, NULL, 5471, 'Mundo Novo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.706025', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5472, NULL, 5472, 'Mutunopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.706843', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5473, NULL, 5473, 'Nazario', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.707701', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5474, NULL, 5474, 'Neropolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.708646', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5475, NULL, 5475, 'Niquelandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.709625', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5476, NULL, 5476, 'Nova America', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.710551', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5477, NULL, 5477, 'Nova Aurora', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.711502', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5478, NULL, 5478, 'Nova Crixas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.712452', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5479, NULL, 5479, 'Nova Gloria', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.713407', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5480, NULL, 5480, 'Nova Iguacu de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.714282', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5481, NULL, 5481, 'Nova Roma', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.715252', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5482, NULL, 5482, 'Nova Veneza', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.716088', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5483, NULL, 5483, 'Novo Brasil', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.717048', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5484, NULL, 5484, 'Novo Gama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.71804', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5485, NULL, 5485, 'Novo Planalto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.718969', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5486, NULL, 5486, 'Orizona', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.71987', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5487, NULL, 5487, 'Ouro Verde de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.720782', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5488, NULL, 5488, 'Ouvidor', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.721647', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5489, NULL, 5489, 'Padre Bernardo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.730377', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5490, NULL, 5490, 'Palestina de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.731494', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5491, NULL, 5491, 'Palmeiras de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.732416', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5492, NULL, 5492, 'Palmelo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.733286', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5493, NULL, 5493, 'Palminopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.734292', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5494, NULL, 5494, 'Panama', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.735177', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5495, NULL, 5495, 'Paranaiguara', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.736027', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5496, NULL, 5496, 'Parauna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.736912', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5497, NULL, 5497, 'Perolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.738016', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5498, NULL, 5498, 'Petrolina de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.738872', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5499, NULL, 5499, 'Pilar de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.739682', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5500, NULL, 5500, 'Piracanjuba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.740598', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5501, NULL, 5501, 'Piranhas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.741497', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5502, NULL, 5502, 'Pirenopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.742364', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5503, NULL, 5503, 'Pires do Rio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.743286', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5504, NULL, 5504, 'Planaltina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.744194', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5505, NULL, 5505, 'Pontalina', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.745138', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5506, NULL, 5506, 'Porangatu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.746057', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5507, NULL, 5507, 'Porteirao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.746977', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5508, NULL, 5508, 'Portelandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.747798', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5509, NULL, 5509, 'Posse', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.74865', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5510, NULL, 5510, 'Professor Jamil', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.749443', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5511, NULL, 5511, 'Quirinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:37.606333', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5512, NULL, 5512, 'Rialma', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:34.339363', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5516, NULL, 5516, 'Rubiataba', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.752375', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5517, NULL, 5517, 'Sanclerlandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.75327', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5518, NULL, 5518, 'Santa Barbara de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.754126', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5519, NULL, 5519, 'Santa Cruz de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.754942', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5520, NULL, 5520, 'Santa Fe de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.755933', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5521, NULL, 5521, 'Santa Helena de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.756965', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5522, NULL, 5522, 'Santa Isabel', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.757965', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5523, NULL, 5523, 'Santa Rita do Araguaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.758958', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5524, NULL, 5524, 'Santa Rita do Novo Destino', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.759916', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5525, NULL, 5525, 'Santa Rosa de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.760746', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5526, NULL, 5526, 'Santa Tereza de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.76171', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5527, NULL, 5527, 'Santa Terezinha de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.762654', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5528, NULL, 5528, 'Santo Antonio da Barra', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.763614', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5529, NULL, 5529, 'Santo Antonio de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.764441', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5530, NULL, 5530, 'Santo Antonio do Descoberto', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.771458', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5531, NULL, 5531, 'Sao Domingos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.77252', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5532, NULL, 5532, 'Sao Francisco de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.773455', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5533, NULL, 5533, 'Sao Joao da Parauna', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.774354', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5534, NULL, 5534, 'Sao Joao D''alianca', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.775239', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5535, NULL, 5535, 'Sao Luis de Montes Belos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.77614', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5536, NULL, 5536, 'Sao Luiz do Norte', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.776981', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5537, NULL, 5537, 'Sao Miguel do Araguaia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.777896', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5538, NULL, 5538, 'Sao Miguel do Passa Quatro', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.778808', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5539, NULL, 5539, 'Sao Patricio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.779725', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5540, NULL, 5540, 'Sao Simao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.780665', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5541, NULL, 5541, 'Senador Canedo', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.7816', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5542, NULL, 5542, 'Serranopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.78277', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5543, NULL, 5543, 'Silvania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.783748', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5544, NULL, 5544, 'Simolandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.784751', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5545, NULL, 5545, 'Sitio D''abadia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.785701', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5546, NULL, 5546, 'Taquaral de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.786631', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5547, NULL, 5547, 'Teresina de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.787611', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5548, NULL, 5548, 'Terezopolis de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.788494', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5549, NULL, 5549, 'Tres Ranchos', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.789421', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5550, NULL, 5550, 'Trindade', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.790358', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5551, NULL, 5551, 'Trombas', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.791247', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5552, NULL, 5552, 'Turvania', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.792226', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5553, NULL, 5553, 'Turvelandia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.793204', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5554, NULL, 5554, 'Uirapuru', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.794106', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5555, NULL, 5555, 'Uruacu', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.795058', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5556, NULL, 5556, 'Uruana', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.796026', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5557, NULL, 5557, 'Urutai', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.796933', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5558, NULL, 5558, 'Valparaiso de Goias', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.797818', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5559, NULL, 5559, 'Varjao', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.798714', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5560, NULL, 5560, 'Vianopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.799587', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5561, NULL, 5561, 'Vicentinopolis', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.800364', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5562, NULL, 5562, 'Vila Boa', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.801199', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5563, NULL, 5563, 'Vila Propicio', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.802078', 'I', NULL, 9);
INSERT INTO distrito (idmun, geom, iddis, nome, cod_ibge, idpes_rev, data_rev, origem_gravacao, idpes_cad, data_cad, operacao, idsis_rev, idsis_cad) VALUES (5564, NULL, 5564, 'Brasilia', NULL, NULL, NULL, 'M', 1, '2010-01-06 18:30:39.80332', 'I', NULL, 9);


--
-- Data for Name: logradouro; Type: TABLE DATA; Schema: public; Owner: postgres
--



--
-- Data for Name: logradouro_fonetico; Type: TABLE DATA; Schema: public; Owner: postgres
--



--
-- Data for Name: municipio; Type: TABLE DATA; Schema: public; Owner: postgres
--

INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (351, 'Couto de Magalhaes', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.089684', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (436, 'Sao Valerio da Natividade', 'TO', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.187014', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (591, 'Pindare Mirim', 'MA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.359225', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (679, 'Aroeira do Itaim', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.453076', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (802, 'Nazária', 'PI', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.584181', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1291, 'Campo de Santana', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.13001', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1415, 'Santarem', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.264592', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1419, 'Sao Domingos de Pombal', 'PB', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.26811', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1481, 'Belem de Sao Francisco', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.335218', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1546, 'Itamaraca', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.404483', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1561, 'Lagoa do Itaenga', 'PE', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.424018', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1965, 'Governador Lomanto Junior', 'BA', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.849918', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2337, 'Brasopolis', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.258428', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2800, 'Passa Vinte', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.763219', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2834, 'Pingo D Agua', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.80073', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3013, 'Sem Peixe', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.996865', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3053, 'Tocos do Mogi', 'MG', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.038237', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3226, 'Parati', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.221078', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3260, 'Trajano de Morais', 'RJ', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.258533', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3434, 'Embu', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.451765', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3613, 'Mogi Mirim', 'SP', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.656906', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3944, 'Bela Vista do Caroba', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.022147', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4037, 'Goio-ere', 'PR', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.129581', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5111, 'Bataipora', 'MS', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.298595', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5215, 'Cuverlandia', 'MT', NULL, NULL, NULL, NULL, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.415073', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5278, 'Poxoreo', 'MT', NULL, NULL, NULL, 5107008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.486341', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (43, 'Sao Felipe D Oeste', 'RO', NULL, NULL, NULL, 1101484, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.747041', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (197, 'Eldorado dos Carajas', 'PA', NULL, NULL, NULL, 1502954, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.917067', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (258, 'Santa Isabel do Para', 'PA', NULL, NULL, NULL, 150650, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.990198', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (684, 'Barra D Alcantara', 'PI', NULL, NULL, NULL, 2201176, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.457797', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (809, 'Olho D Agua do Piaui', 'PI', NULL, NULL, NULL, 2207108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.590304', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (976, 'Itapage', 'CE', NULL, NULL, NULL, 230630, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.777235', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1184, 'Presidente Juscelino', 'RN', NULL, NULL, NULL, 241030, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.010971', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1539, 'Iguaraci', 'PE', NULL, NULL, NULL, 2606903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.397826', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2773, 'Olhos-d Agua', 'MG', NULL, NULL, NULL, 3145455, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.728505', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1, 'Alta Floresta D''oeste', 'RO', NULL, NULL, NULL, 1100015, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.699228', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5, 'Ariquemes', 'RO', NULL, NULL, NULL, 1100023, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.703562', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (7, 'Cabixi', 'RO', NULL, NULL, NULL, 1100031, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.7053', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (9, 'Cacoal', 'RO', NULL, NULL, NULL, 1100049, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.707047', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (13, 'Cerejeiras', 'RO', NULL, NULL, NULL, 1100056, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.711055', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (15, 'Colorado do Oeste', 'RO', NULL, NULL, NULL, 1100064, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.712932', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (16, 'Corumbiara', 'RO', NULL, NULL, NULL, 1100072, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.713842', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (17, 'Costa Marques', 'RO', NULL, NULL, NULL, 1100080, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.714738', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (19, 'Espigao D''oeste', 'RO', NULL, NULL, NULL, 1100098, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.716704', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (21, 'Guajara-mirim', 'RO', NULL, NULL, NULL, 1100106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.718803', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (23, 'Jaru', 'RO', NULL, NULL, NULL, 1100114, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.720746', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (24, 'Ji-parana', 'RO', NULL, NULL, NULL, 1100122, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.721775', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (25, 'Machadinho D''oeste', 'RO', NULL, NULL, NULL, 1100130, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.722776', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (29, 'Nova Brasilandia D''oeste', 'RO', NULL, NULL, NULL, 1100148, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.73323', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (33, 'Ouro Preto do Oeste', 'RO', NULL, NULL, NULL, 1100155, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.737108', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (35, 'Pimenta Bueno', 'RO', NULL, NULL, NULL, 1100189, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.73925', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (37, 'Porto Velho', 'RO', NULL, NULL, NULL, 1100205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.741221', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (38, 'Presidente Medici', 'RO', NULL, NULL, NULL, 1100254, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.742117', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (40, 'Rio Crespo', 'RO', NULL, NULL, NULL, 1100262, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.744066', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (41, 'Rolim de Moura', 'RO', NULL, NULL, NULL, 1100288, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.745017', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (42, 'Santa Luzia D''oeste', 'RO', NULL, NULL, NULL, 1100296, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.745909', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (52, 'Vilhena', 'RO', NULL, NULL, NULL, 1100304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.754961', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (45, 'Sao Miguel do Guapore', 'RO', NULL, NULL, NULL, 1100320, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.748533', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (30, 'Nova Mamore', 'RO', NULL, NULL, NULL, 1100338, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.734184', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4, 'Alvorada D''oeste', 'RO', NULL, NULL, NULL, 1100346, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.70262', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2, 'Alto Alegre dos Parecis', 'RO', NULL, NULL, NULL, 1100379, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.700901', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3, 'Alto Paraiso', 'RO', NULL, NULL, NULL, 1100403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.701715', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (6, 'Buritis', 'RO', NULL, NULL, NULL, 1100452, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.704461', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (32, 'Novo Horizonte do Oeste', 'RO', NULL, NULL, NULL, 1100502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.73613', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (8, 'Cacaulandia', 'RO', NULL, NULL, NULL, 1100601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.706175', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (10, 'Campo Novo de Rondonia', 'RO', NULL, NULL, NULL, 1100700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.70796', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (11, 'Candeias do Jamari', 'RO', NULL, NULL, NULL, 1100809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.708884', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (12, 'Castanheiras', 'RO', NULL, NULL, NULL, 1100908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.709859', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (14, 'Chupinguaia', 'RO', NULL, NULL, NULL, 1100924, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.711993', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (18, 'Cujubim', 'RO', NULL, NULL, NULL, 1100940, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.715723', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (20, 'Governador Jorge Teixeira', 'RO', NULL, NULL, NULL, 1101005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.717717', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (22, 'Itapua do Oeste', 'RO', NULL, NULL, NULL, 1101104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.719743', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (26, 'Ministro Andreazza', 'RO', NULL, NULL, NULL, 1101203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.723813', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (27, 'Mirante da Serra', 'RO', NULL, NULL, NULL, 1101302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.725075', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (28, 'Monte Negro', 'RO', NULL, NULL, NULL, 1101401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.731957', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (31, 'Nova Uniao', 'RO', NULL, NULL, NULL, 1101435, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.735123', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (34, 'Parecis', 'RO', NULL, NULL, NULL, 1101450, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.738213', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (36, 'Pimenteiras do Oeste', 'RO', NULL, NULL, NULL, 1101468, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.740233', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (39, 'Primavera de Rondonia', 'RO', NULL, NULL, NULL, 1101476, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.743068', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (44, 'Sao Francisco do Guapore', 'RO', NULL, NULL, NULL, 1101492, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.747752', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (46, 'Seringueiras', 'RO', NULL, NULL, NULL, 1101500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.749422', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (47, 'Teixeiropolis', 'RO', NULL, NULL, NULL, 1101559, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.750356', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (48, 'Theobroma', 'RO', NULL, NULL, NULL, 1101609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.751289', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (49, 'Urupa', 'RO', NULL, NULL, NULL, 1101708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.752266', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (50, 'Vale do Anari', 'RO', NULL, NULL, NULL, 1101757, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.753153', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (51, 'Vale do Paraiso', 'RO', NULL, NULL, NULL, 1101807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.754014', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (53, 'Acrelandia', 'AC', NULL, NULL, NULL, 1200013, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.756206', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (54, 'Assis Brasil', 'AC', NULL, NULL, NULL, 1200054, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.757065', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (55, 'Brasileia', 'AC', NULL, NULL, NULL, 1200104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.757891', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (56, 'Bujari', 'AC', NULL, NULL, NULL, 1200138, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.758909', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (57, 'Capixaba', 'AC', NULL, NULL, NULL, 1200179, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.759844', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (58, 'Cruzeiro do Sul', 'AC', NULL, NULL, NULL, 1200203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.760768', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (59, 'Epitaciolandia', 'AC', NULL, NULL, NULL, 1200252, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.761618', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (60, 'Feijo', 'AC', NULL, NULL, NULL, 1200302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.762592', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (61, 'Jordao', 'AC', NULL, NULL, NULL, 1200328, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.763501', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (62, 'Mancio Lima', 'AC', NULL, NULL, NULL, 1200336, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.764379', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (63, 'Manoel Urbano', 'AC', NULL, NULL, NULL, 1200344, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.765356', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (64, 'Marechal Thaumaturgo', 'AC', NULL, NULL, NULL, 1200351, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.772448', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (65, 'Placido de Castro', 'AC', NULL, NULL, NULL, 1200385, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.77356', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (67, 'Porto Walter', 'AC', NULL, NULL, NULL, 1200393, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.775372', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (68, 'Rio Branco', 'AC', NULL, NULL, NULL, 1200401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.776144', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (69, 'Rodrigues Alves', 'AC', NULL, NULL, NULL, 1200427, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.777086', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (70, 'Santa Rosa do Purus', 'AC', NULL, NULL, NULL, 1200435, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.778157', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (72, 'Senador Guiomard', 'AC', NULL, NULL, NULL, 1200450, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.780338', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (71, 'Sena Madureira', 'AC', NULL, NULL, NULL, 1200500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.779501', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (73, 'Tarauaca', 'AC', NULL, NULL, NULL, 1200609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.781279', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (74, 'Xapuri', 'AC', NULL, NULL, NULL, 1200708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.782326', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (66, 'Porto Acre', 'AC', NULL, NULL, NULL, 1200807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.774455', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (75, 'Alvaraes', 'AM', NULL, NULL, NULL, 1300029, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.783307', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (76, 'Amatura', 'AM', NULL, NULL, NULL, 1300060, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.78444', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (77, 'Anama', 'AM', NULL, NULL, NULL, 1300086, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.785298', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (78, 'Anori', 'AM', NULL, NULL, NULL, 1300102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.7862', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (79, 'Apui', 'AM', NULL, NULL, NULL, 1300144, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.787062', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (80, 'Atalaia do Norte', 'AM', NULL, NULL, NULL, 1300201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.787924', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (81, 'Autazes', 'AM', NULL, NULL, NULL, 1300300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.788882', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (82, 'Barcelos', 'AM', NULL, NULL, NULL, 1300409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.789694', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (83, 'Barreirinha', 'AM', NULL, NULL, NULL, 1300508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.790558', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (84, 'Benjamin Constant', 'AM', NULL, NULL, NULL, 1300607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.791396', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (85, 'Beruri', 'AM', NULL, NULL, NULL, 1300631, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.792246', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (86, 'Boa Vista do Ramos', 'AM', NULL, NULL, NULL, 1300680, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.793161', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (87, 'Boca do Acre', 'AM', NULL, NULL, NULL, 1300706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.794181', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (88, 'Borba', 'AM', NULL, NULL, NULL, 1300805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.795002', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (89, 'Caapiranga', 'AM', NULL, NULL, NULL, 1300839, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.795793', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (90, 'Canutama', 'AM', NULL, NULL, NULL, 1300904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.796734', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (91, 'Carauari', 'AM', NULL, NULL, NULL, 1301001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.797699', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (92, 'Careiro', 'AM', NULL, NULL, NULL, 1301100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.798687', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (93, 'Careiro da Varzea', 'AM', NULL, NULL, NULL, 1301159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.799621', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (94, 'Coari', 'AM', NULL, NULL, NULL, 1301209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.800826', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (95, 'Codajas', 'AM', NULL, NULL, NULL, 1301308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.801802', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (96, 'Eirunepe', 'AM', NULL, NULL, NULL, 1301407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.802748', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (97, 'Envira', 'AM', NULL, NULL, NULL, 1301506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.803632', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (98, 'Fonte Boa', 'AM', NULL, NULL, NULL, 1301605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.804528', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (99, 'Guajara', 'AM', NULL, NULL, NULL, 1301654, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.805459', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (100, 'Humaita', 'AM', NULL, NULL, NULL, 1301704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.806293', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (101, 'Ipixuna', 'AM', NULL, NULL, NULL, 1301803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.813076', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (102, 'Iranduba', 'AM', NULL, NULL, NULL, 1301852, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.814239', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (103, 'Itamarati', 'AM', NULL, NULL, NULL, 1301951, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.815178', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (104, 'Itapiranga', 'AM', NULL, NULL, NULL, 1302009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.816065', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (105, 'Japura', 'AM', NULL, NULL, NULL, 1302108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.81715', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (106, 'Jurua', 'AM', NULL, NULL, NULL, 1302207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.818091', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (107, 'Jutai', 'AM', NULL, NULL, NULL, 1302306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.819038', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (108, 'Labrea', 'AM', NULL, NULL, NULL, 1302405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.820032', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (109, 'Manacapuru', 'AM', NULL, NULL, NULL, 1302504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.820907', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (110, 'Manaquiri', 'AM', NULL, NULL, NULL, 1302553, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.821753', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (111, 'Manaus', 'AM', NULL, NULL, NULL, 1302603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.822972', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (112, 'Manicore', 'AM', NULL, NULL, NULL, 1302702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.823952', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (113, 'Maraa', 'AM', NULL, NULL, NULL, 1302801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.824889', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (114, 'Maues', 'AM', NULL, NULL, NULL, 1302900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.825835', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (115, 'Nhamunda', 'AM', NULL, NULL, NULL, 1303007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.826766', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (116, 'Nova Olinda do Norte', 'AM', NULL, NULL, NULL, 1303106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.827685', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (117, 'Novo Airao', 'AM', NULL, NULL, NULL, 1303205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.828719', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (118, 'Novo Aripuana', 'AM', NULL, NULL, NULL, 1303304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.829683', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (119, 'Parintins', 'AM', NULL, NULL, NULL, 1303403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.830562', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (120, 'Pauini', 'AM', NULL, NULL, NULL, 1303502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.83138', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (121, 'Presidente Figueiredo', 'AM', NULL, NULL, NULL, 1303536, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.832207', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (122, 'Rio Preto da Eva', 'AM', NULL, NULL, NULL, 1303569, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.833161', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (123, 'Santa Isabel do Rio Negro', 'AM', NULL, NULL, NULL, 1303601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.834228', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (124, 'Santo Antonio do Ica', 'AM', NULL, NULL, NULL, 1303700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.835121', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (125, 'Sao Gabriel da Cachoeira', 'AM', NULL, NULL, NULL, 1303809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.836046', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (126, 'Sao Paulo de Olivenca', 'AM', NULL, NULL, NULL, 1303908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.836988', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (127, 'Sao Sebastiao do Uatuma', 'AM', NULL, NULL, NULL, 1303957, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.837813', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (128, 'Silves', 'AM', NULL, NULL, NULL, 1304005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.838766', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (129, 'Tabatinga', 'AM', NULL, NULL, NULL, 1304062, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.839732', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (130, 'Tapaua', 'AM', NULL, NULL, NULL, 1304104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.840639', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (131, 'Tefe', 'AM', NULL, NULL, NULL, 1304203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.841614', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (132, 'Tonantins', 'AM', NULL, NULL, NULL, 1304237, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.842553', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (133, 'Uarini', 'AM', NULL, NULL, NULL, 1304260, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.843379', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (134, 'Urucara', 'AM', NULL, NULL, NULL, 1304302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.844178', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (135, 'Urucurituba', 'AM', NULL, NULL, NULL, 1304401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.845408', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (137, 'Amajari', 'RR', NULL, NULL, NULL, 1400027, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.853924', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (136, 'Alto Alegre', 'RR', NULL, NULL, NULL, 1400050, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.846512', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (138, 'Boa Vista', 'RR', NULL, NULL, NULL, 1400100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.855192', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (139, 'Bonfim', 'RR', NULL, NULL, NULL, 1400159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.856157', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (140, 'Canta', 'RR', NULL, NULL, NULL, 1400175, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.856972', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (141, 'Caracarai', 'RR', NULL, NULL, NULL, 1400209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.857888', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (142, 'Caroebe', 'RR', NULL, NULL, NULL, 1400233, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.858888', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (143, 'Iracema', 'RR', NULL, NULL, NULL, 1400282, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.859891', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (144, 'Mucajai', 'RR', NULL, NULL, NULL, 1400308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.860859', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (145, 'Normandia', 'RR', NULL, NULL, NULL, 1400407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.861807', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (146, 'Pacaraima', 'RR', NULL, NULL, NULL, 1400456, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.862761', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (147, 'Rorainopolis', 'RR', NULL, NULL, NULL, 1400472, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.86373', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (148, 'Sao Joao da Baliza', 'RR', NULL, NULL, NULL, 1400506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.864648', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (149, 'Sao Luiz', 'RR', NULL, NULL, NULL, 1400605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.865518', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (150, 'Uiramuta', 'RR', NULL, NULL, NULL, 1400704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.866386', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (151, 'Abaetetuba', 'PA', NULL, NULL, NULL, 1500107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.867591', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (152, 'Abel Figueiredo', 'PA', NULL, NULL, NULL, 1500131, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.868448', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (153, 'Acara', 'PA', NULL, NULL, NULL, 1500206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.869342', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (154, 'Afua', 'PA', NULL, NULL, NULL, 1500305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.87027', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (155, 'Agua Azul do Norte', 'PA', NULL, NULL, NULL, 1500347, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.871096', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (156, 'Alenquer', 'PA', NULL, NULL, NULL, 1500404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.872038', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (157, 'Almeirim', 'PA', NULL, NULL, NULL, 1500503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.872959', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (158, 'Altamira', 'PA', NULL, NULL, NULL, 1500602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.873993', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (159, 'Anajas', 'PA', NULL, NULL, NULL, 1500701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.874868', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (160, 'Ananindeua', 'PA', NULL, NULL, NULL, 1500800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.875805', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (161, 'Anapu', 'PA', NULL, NULL, NULL, 1500859, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.87672', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (162, 'Augusto Correa', 'PA', NULL, NULL, NULL, 1500909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.877656', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (163, 'Aurora do Para', 'PA', NULL, NULL, NULL, 1500958, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.878762', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (164, 'Aveiro', 'PA', NULL, NULL, NULL, 1501006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.879577', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (165, 'Bagre', 'PA', NULL, NULL, NULL, 1501105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.88047', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (166, 'Baiao', 'PA', NULL, NULL, NULL, 1501204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.881428', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (167, 'Bannach', 'PA', NULL, NULL, NULL, 1501253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.882419', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (168, 'Barcarena', 'PA', NULL, NULL, NULL, 1501303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.883321', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (169, 'Belem', 'PA', NULL, NULL, NULL, 1501402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.884275', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (170, 'Belterra', 'PA', NULL, NULL, NULL, 1501451, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.885225', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (171, 'Benevides', 'PA', NULL, NULL, NULL, 1501501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.886172', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (172, 'Bom Jesus do Tocantins', 'PA', NULL, NULL, NULL, 1501576, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.887134', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (173, 'Bonito', 'PA', NULL, NULL, NULL, 1501600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.894617', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (174, 'Braganca', 'PA', NULL, NULL, NULL, 1501709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.895728', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (175, 'Brasil Novo', 'PA', NULL, NULL, NULL, 1501725, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.896566', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (176, 'Brejo Grande do Araguaia', 'PA', NULL, NULL, NULL, 1501758, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.897635', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (177, 'Breu Branco', 'PA', NULL, NULL, NULL, 1501782, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.898564', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (178, 'Breves', 'PA', NULL, NULL, NULL, 1501808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.899242', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (179, 'Bujaru', 'PA', NULL, NULL, NULL, 1501907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.900159', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (181, 'Cachoeira do Piria', 'PA', NULL, NULL, NULL, 1501956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.902107', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (180, 'Cachoeira do Arari', 'PA', NULL, NULL, NULL, 1502004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.901094', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (182, 'Cameta', 'PA', NULL, NULL, NULL, 1502103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.903016', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (183, 'Canaa dos Carajas', 'PA', NULL, NULL, NULL, 1502152, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.903963', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (184, 'Capanema', 'PA', NULL, NULL, NULL, 1502202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.904782', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (185, 'Capitao Poco', 'PA', NULL, NULL, NULL, 1502301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.905681', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (186, 'Castanhal', 'PA', NULL, NULL, NULL, 1502400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.906554', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (187, 'Chaves', 'PA', NULL, NULL, NULL, 1502509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.907603', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (188, 'Colares', 'PA', NULL, NULL, NULL, 1502608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.908482', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (189, 'Conceicao do Araguaia', 'PA', NULL, NULL, NULL, 1502707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.909368', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (190, 'Concordia do Para', 'PA', NULL, NULL, NULL, 1502756, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.910192', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (191, 'Cumaru do Norte', 'PA', NULL, NULL, NULL, 1502764, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.911121', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (192, 'Curionopolis', 'PA', NULL, NULL, NULL, 1502772, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.912262', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (193, 'Curralinho', 'PA', NULL, NULL, NULL, 1502806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.913215', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (194, 'Curua', 'PA', NULL, NULL, NULL, 1502855, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.914119', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (195, 'Curuca', 'PA', NULL, NULL, NULL, 1502905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.915017', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (196, 'Dom Eliseu', 'PA', NULL, NULL, NULL, 1502939, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.91602', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (198, 'Faro', 'PA', NULL, NULL, NULL, 1503002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.91806', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (199, 'Floresta do Araguaia', 'PA', NULL, NULL, NULL, 1503044, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.918982', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (200, 'Garrafao do Norte', 'PA', NULL, NULL, NULL, 1503077, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.919913', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (201, 'Goianesia do Para', 'PA', NULL, NULL, NULL, 1503093, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.92081', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (202, 'Gurupa', 'PA', NULL, NULL, NULL, 1503101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.921711', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (203, 'Igarape-acu', 'PA', NULL, NULL, NULL, 1503200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.922705', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (204, 'Igarape-miri', 'PA', NULL, NULL, NULL, 1503309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.92357', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (205, 'Inhangapi', 'PA', NULL, NULL, NULL, 1503408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.924586', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (206, 'Ipixuna do Para', 'PA', NULL, NULL, NULL, 1503457, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.9256', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (207, 'Irituia', 'PA', NULL, NULL, NULL, 1503507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.926608', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (208, 'Itaituba', 'PA', NULL, NULL, NULL, 1503606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.92776', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (209, 'Itupiranga', 'PA', NULL, NULL, NULL, 1503705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.928737', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (210, 'Jacareacanga', 'PA', NULL, NULL, NULL, 1503754, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.936088', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (211, 'Jacunda', 'PA', NULL, NULL, NULL, 1503804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.937324', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (212, 'Juruti', 'PA', NULL, NULL, NULL, 1503903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.938243', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (213, 'Limoeiro do Ajuru', 'PA', NULL, NULL, NULL, 1504000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.939321', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (214, 'Mae do Rio', 'PA', NULL, NULL, NULL, 1504059, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.940188', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (215, 'Magalhaes Barata', 'PA', NULL, NULL, NULL, 1504109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.941158', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (216, 'Maraba', 'PA', NULL, NULL, NULL, 1504208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.942124', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (217, 'Maracana', 'PA', NULL, NULL, NULL, 1504307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.943021', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (218, 'Marapanim', 'PA', NULL, NULL, NULL, 1504406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.943981', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (219, 'Marituba', 'PA', NULL, NULL, NULL, 1504422, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.944811', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (220, 'Medicilandia', 'PA', NULL, NULL, NULL, 1504455, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.945759', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (221, 'Melgaco', 'PA', NULL, NULL, NULL, 1504505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.946559', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (222, 'Mocajuba', 'PA', NULL, NULL, NULL, 1504604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.947482', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (223, 'Moju', 'PA', NULL, NULL, NULL, 1504703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.948244', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (224, 'Monte Alegre', 'PA', NULL, NULL, NULL, 1504802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.949614', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (225, 'Muana', 'PA', NULL, NULL, NULL, 1504901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.950555', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (226, 'Nova Esperanca do Piria', 'PA', NULL, NULL, NULL, 1504950, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.9514', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (227, 'Nova Ipixuna', 'PA', NULL, NULL, NULL, 1504976, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.952304', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (228, 'Nova Timboteua', 'PA', NULL, NULL, NULL, 1505007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.953216', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (229, 'Novo Progresso', 'PA', NULL, NULL, NULL, 1505031, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.954085', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (230, 'Novo Repartimento', 'PA', NULL, NULL, NULL, 1505064, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.955006', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (231, 'Obidos', 'PA', NULL, NULL, NULL, 1505106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.95593', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (232, 'Oeiras do Para', 'PA', NULL, NULL, NULL, 1505205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.956865', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (233, 'Oriximina', 'PA', NULL, NULL, NULL, 1505304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.957786', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (234, 'Ourem', 'PA', NULL, NULL, NULL, 1505403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.958709', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (235, 'Ourilandia do Norte', 'PA', NULL, NULL, NULL, 1505437, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.959504', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (236, 'Pacaja', 'PA', NULL, NULL, NULL, 1505486, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.960374', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (237, 'Palestina do Para', 'PA', NULL, NULL, NULL, 1505494, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.96127', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (238, 'Paragominas', 'PA', NULL, NULL, NULL, 1505502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.962164', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (239, 'Parauapebas', 'PA', NULL, NULL, NULL, 1505536, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.963118', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (240, 'Pau D''arco', 'PA', NULL, NULL, NULL, 1505551, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.963912', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (241, 'Peixe-boi', 'PA', NULL, NULL, NULL, 1505601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.964888', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (242, 'Picarra', 'PA', NULL, NULL, NULL, 1505635, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.965834', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (243, 'Placas', 'PA', NULL, NULL, NULL, 1505650, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.966852', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (244, 'Ponta de Pedras', 'PA', NULL, NULL, NULL, 1505700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.968025', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (245, 'Portel', 'PA', NULL, NULL, NULL, 1505809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.969061', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (246, 'Porto de Moz', 'PA', NULL, NULL, NULL, 1505908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.970034', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (247, 'Prainha', 'PA', NULL, NULL, NULL, 1506005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.978985', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (248, 'Primavera', 'PA', NULL, NULL, NULL, 1506104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.980101', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (249, 'Quatipuru', 'PA', NULL, NULL, NULL, 1506112, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.981208', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (250, 'Redencao', 'PA', NULL, NULL, NULL, 1506138, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.982118', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (251, 'Rio Maria', 'PA', NULL, NULL, NULL, 1506161, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.983216', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (252, 'Rondon do Para', 'PA', NULL, NULL, NULL, 1506187, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.984434', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (253, 'Ruropolis', 'PA', NULL, NULL, NULL, 1506195, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.985502', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (254, 'Salinopolis', 'PA', NULL, NULL, NULL, 1506203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.986493', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (255, 'Salvaterra', 'PA', NULL, NULL, NULL, 1506302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.987353', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (256, 'Santa Barbara do Para', 'PA', NULL, NULL, NULL, 1506351, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.988251', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (257, 'Santa Cruz do Arari', 'PA', NULL, NULL, NULL, 1506401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.989048', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (259, 'Santa Luzia do Para', 'PA', NULL, NULL, NULL, 1506559, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.991128', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (260, 'Santa Maria das Barreiras', 'PA', NULL, NULL, NULL, 1506583, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.991911', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (261, 'Santa Maria do Para', 'PA', NULL, NULL, NULL, 1506609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.992886', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (262, 'Santana do Araguaia', 'PA', NULL, NULL, NULL, 1506708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.993845', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (263, 'Santarem', 'PA', NULL, NULL, NULL, 1506807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.994763', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (264, 'Santarem Novo', 'PA', NULL, NULL, NULL, 1506906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.995664', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (265, 'Santo Antonio do Taua', 'PA', NULL, NULL, NULL, 1507003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.996463', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (266, 'Sao Caetano de Odivelas', 'PA', NULL, NULL, NULL, 1507102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.997262', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (267, 'Sao Domingos do Araguaia', 'PA', NULL, NULL, NULL, 1507151, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.998092', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (268, 'Sao Domingos do Capim', 'PA', NULL, NULL, NULL, 1507201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.999037', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (269, 'Sao Felix do Xingu', 'PA', NULL, NULL, NULL, 1507300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:33.999952', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (270, 'Sao Francisco do Para', 'PA', NULL, NULL, NULL, 1507409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.001019', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (271, 'Sao Geraldo do Araguaia', 'PA', NULL, NULL, NULL, 1507458, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.001861', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (272, 'Sao Joao da Ponta', 'PA', NULL, NULL, NULL, 1507466, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.002762', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (273, 'Sao Joao de Pirabas', 'PA', NULL, NULL, NULL, 1507474, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.003681', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (274, 'Sao Joao do Araguaia', 'PA', NULL, NULL, NULL, 1507508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.004606', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (275, 'Sao Miguel do Guama', 'PA', NULL, NULL, NULL, 1507607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.005566', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (276, 'Sao Sebastiao da Boa Vista', 'PA', NULL, NULL, NULL, 1507706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.006395', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (277, 'Sapucaia', 'PA', NULL, NULL, NULL, 1507755, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.007271', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (278, 'Senador Jose Porfirio', 'PA', NULL, NULL, NULL, 1507805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.008163', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (279, 'Soure', 'PA', NULL, NULL, NULL, 1507904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.009091', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (280, 'Tailandia', 'PA', NULL, NULL, NULL, 1507953, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.010067', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (281, 'Terra Alta', 'PA', NULL, NULL, NULL, 1507961, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.01103', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (282, 'Terra Santa', 'PA', NULL, NULL, NULL, 1507979, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.012083', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (283, 'Tome-acu', 'PA', NULL, NULL, NULL, 1508001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.012862', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (284, 'Tracuateua', 'PA', NULL, NULL, NULL, 1508035, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.020208', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (285, 'Trairao', 'PA', NULL, NULL, NULL, 1508050, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.021367', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (286, 'Tucuma', 'PA', NULL, NULL, NULL, 1508084, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.022234', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (287, 'Tucurui', 'PA', NULL, NULL, NULL, 1508100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.023243', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (288, 'Ulianopolis', 'PA', NULL, NULL, NULL, 1508126, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.024129', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (289, 'Uruara', 'PA', NULL, NULL, NULL, 1508159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.024966', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (290, 'Vigia', 'PA', NULL, NULL, NULL, 1508209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.025883', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (291, 'Viseu', 'PA', NULL, NULL, NULL, 1508308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.026802', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (292, 'Vitoria do Xingu', 'PA', NULL, NULL, NULL, 1508357, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.027745', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (293, 'Xinguara', 'PA', NULL, NULL, NULL, 1508407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.028653', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (307, 'Serra do Navio', 'AP', NULL, NULL, NULL, 1600055, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.041419', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (294, 'Amapa', 'AP', NULL, NULL, NULL, 1600105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.029605', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (303, 'Pedra Branca do Amapari', 'AP', NULL, NULL, NULL, 1600154, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.037751', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (295, 'Calcoene', 'AP', NULL, NULL, NULL, 1600204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.030519', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (296, 'Cutias', 'AP', NULL, NULL, NULL, 1600212, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.031457', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (297, 'Ferreira Gomes', 'AP', NULL, NULL, NULL, 1600238, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.032313', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (298, 'Itaubal', 'AP', NULL, NULL, NULL, 1600253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.033162', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (299, 'Laranjal do Jari', 'AP', NULL, NULL, NULL, 1600279, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.034147', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (300, 'Macapa', 'AP', NULL, NULL, NULL, 1600303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.035017', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (301, 'Mazagao', 'AP', NULL, NULL, NULL, 1600402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.036028', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (302, 'Oiapoque', 'AP', NULL, NULL, NULL, 1600501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.036905', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (304, 'Porto Grande', 'AP', NULL, NULL, NULL, 1600535, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.038704', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (305, 'Pracuuba', 'AP', NULL, NULL, NULL, 1600550, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.039594', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (306, 'Santana', 'AP', NULL, NULL, NULL, 1600600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.040511', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (308, 'Tartarugalzinho', 'AP', NULL, NULL, NULL, 1600709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.042303', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (309, 'Vitoria do Jari', 'AP', NULL, NULL, NULL, 1600808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.043135', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (310, 'Abreulandia', 'TO', NULL, NULL, NULL, 1700251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.044063', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (311, 'Aguiarnopolis', 'TO', NULL, NULL, NULL, 1700301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.045079', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (312, 'Alianca do Tocantins', 'TO', NULL, NULL, NULL, 1700350, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.04621', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (313, 'Almas', 'TO', NULL, NULL, NULL, 1700400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.047192', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (314, 'Alvorada', 'TO', NULL, NULL, NULL, 1700707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.048146', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (315, 'Ananas', 'TO', NULL, NULL, NULL, 1701002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.049117', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (316, 'Angico', 'TO', NULL, NULL, NULL, 1701051, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.050076', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (317, 'Aparecida do Rio Negro', 'TO', NULL, NULL, NULL, 1701101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.050987', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (318, 'Aragominas', 'TO', NULL, NULL, NULL, 1701309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.051903', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (319, 'Araguacema', 'TO', NULL, NULL, NULL, 1701903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.052846', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (320, 'Araguacu', 'TO', NULL, NULL, NULL, 1702000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.053962', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (321, 'Araguaina', 'TO', NULL, NULL, NULL, 1702109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.061617', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (322, 'Araguana', 'TO', NULL, NULL, NULL, 1702158, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.062755', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (323, 'Araguatins', 'TO', NULL, NULL, NULL, 1702208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.063685', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (324, 'Arapoema', 'TO', NULL, NULL, NULL, 1702307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.064569', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (325, 'Arraias', 'TO', NULL, NULL, NULL, 1702406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.06559', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (326, 'Augustinopolis', 'TO', NULL, NULL, NULL, 1702554, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.066518', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (327, 'Aurora do Tocantins', 'TO', NULL, NULL, NULL, 1702703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.067488', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (328, 'Axixa do Tocantins', 'TO', NULL, NULL, NULL, 1702901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.06855', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (329, 'Babaculandia', 'TO', NULL, NULL, NULL, 1703008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.069459', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (330, 'Bandeirantes do Tocantins', 'TO', NULL, NULL, NULL, 1703057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.070302', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (331, 'Barra do Ouro', 'TO', NULL, NULL, NULL, 1703073, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.071172', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (332, 'Barrolandia', 'TO', NULL, NULL, NULL, 1703107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.072056', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (333, 'Bernardo Sayao', 'TO', NULL, NULL, NULL, 1703206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.072885', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (334, 'Bom Jesus do Tocantins', 'TO', NULL, NULL, NULL, 1703305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.073818', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (335, 'Brasilandia do Tocantins', 'TO', NULL, NULL, NULL, 1703602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.074694', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (336, 'Brejinho de Nazare', 'TO', NULL, NULL, NULL, 1703701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.075521', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (337, 'Buriti do Tocantins', 'TO', NULL, NULL, NULL, 1703800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.076484', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (338, 'Cachoeirinha', 'TO', NULL, NULL, NULL, 1703826, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.077361', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (339, 'Campos Lindos', 'TO', NULL, NULL, NULL, 1703842, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.078201', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (340, 'Cariri do Tocantins', 'TO', NULL, NULL, NULL, 1703867, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.079159', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (341, 'Carmolandia', 'TO', NULL, NULL, NULL, 1703883, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.079958', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (342, 'Carrasco Bonito', 'TO', NULL, NULL, NULL, 1703891, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.081026', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (343, 'Caseara', 'TO', NULL, NULL, NULL, 1703909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.082012', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (344, 'Centenario', 'TO', NULL, NULL, NULL, 1704105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.082934', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (346, 'Chapada de Areia', 'TO', NULL, NULL, NULL, 1704600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.084657', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (345, 'Chapada da Natividade', 'TO', NULL, NULL, NULL, 1705102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.083733', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (347, 'Colinas do Tocantins', 'TO', NULL, NULL, NULL, 1705508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.085702', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (349, 'Combinado', 'TO', NULL, NULL, NULL, 1705557, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.087767', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (350, 'Conceicao do Tocantins', 'TO', NULL, NULL, NULL, 1705607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.088722', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (352, 'Cristalandia', 'TO', NULL, NULL, NULL, 1706100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.090779', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (353, 'Crixas do Tocantins', 'TO', NULL, NULL, NULL, 1706258, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.091635', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (354, 'Darcinopolis', 'TO', NULL, NULL, NULL, 1706506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.092435', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (355, 'Dianopolis', 'TO', NULL, NULL, NULL, 1707009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.093325', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (356, 'Divinopolis do Tocantins', 'TO', NULL, NULL, NULL, 1707108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.094239', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (357, 'Dois Irmaos do Tocantins', 'TO', NULL, NULL, NULL, 1707207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.09535', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (358, 'Duere', 'TO', NULL, NULL, NULL, 1707306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.102276', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (359, 'Esperantina', 'TO', NULL, NULL, NULL, 1707405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.103367', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (360, 'Fatima', 'TO', NULL, NULL, NULL, 1707553, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.104253', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (361, 'Figueiropolis', 'TO', NULL, NULL, NULL, 1707652, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.105111', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (362, 'Filadelfia', 'TO', NULL, NULL, NULL, 1707702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.106031', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (363, 'Formoso do Araguaia', 'TO', NULL, NULL, NULL, 1708205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.106844', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (364, 'Fortaleza do Tabocao', 'TO', NULL, NULL, NULL, 1708254, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.107791', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (365, 'Goianorte', 'TO', NULL, NULL, NULL, 1708304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.108687', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (366, 'Goiatins', 'TO', NULL, NULL, NULL, 1709005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.10958', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (367, 'Guarai', 'TO', NULL, NULL, NULL, 1709302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.110381', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (368, 'Gurupi', 'TO', NULL, NULL, NULL, 1709500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.111293', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (369, 'Ipueiras', 'TO', NULL, NULL, NULL, 1709807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.112298', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (370, 'Itacaja', 'TO', NULL, NULL, NULL, 1710508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.113135', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (371, 'Itaguatins', 'TO', NULL, NULL, NULL, 1710706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.113912', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (372, 'Itapiratins', 'TO', NULL, NULL, NULL, 1710904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.1149', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (373, 'Itapora do Tocantins', 'TO', NULL, NULL, NULL, 1711100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.11572', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (374, 'Jau do Tocantins', 'TO', NULL, NULL, NULL, 1711506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.116488', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (375, 'Juarina', 'TO', NULL, NULL, NULL, 1711803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.117396', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (376, 'Lagoa da Confusao', 'TO', NULL, NULL, NULL, 1711902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.11813', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (377, 'Lagoa do Tocantins', 'TO', NULL, NULL, NULL, 1711951, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.118825', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (378, 'Lajeado', 'TO', NULL, NULL, NULL, 1712009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.119873', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (379, 'Lavandeira', 'TO', NULL, NULL, NULL, 1712157, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.120739', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (380, 'Lizarda', 'TO', NULL, NULL, NULL, 1712405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.121597', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (381, 'Luzinopolis', 'TO', NULL, NULL, NULL, 1712454, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.122538', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (382, 'Marianopolis do Tocantins', 'TO', NULL, NULL, NULL, 1712504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.123445', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (383, 'Mateiros', 'TO', NULL, NULL, NULL, 1712702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.124297', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (384, 'Maurilandia do Tocantins', 'TO', NULL, NULL, NULL, 1712801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.125143', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (385, 'Miracema do Tocantins', 'TO', NULL, NULL, NULL, 1713205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.125927', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (386, 'Miranorte', 'TO', NULL, NULL, NULL, 1713304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.126827', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (387, 'Monte do Carmo', 'TO', NULL, NULL, NULL, 1713601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.127756', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (388, 'Monte Santo do Tocantins', 'TO', NULL, NULL, NULL, 1713700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.128688', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (400, 'Palmeiras do Tocantins', 'TO', NULL, NULL, NULL, 1713809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.146676', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (389, 'Muricilandia', 'TO', NULL, NULL, NULL, 1713957, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.129605', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (390, 'Natividade', 'TO', NULL, NULL, NULL, 1714203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.13038', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (391, 'Nazare', 'TO', NULL, NULL, NULL, 1714302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.131401', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (392, 'Nova Olinda', 'TO', NULL, NULL, NULL, 1714880, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.132322', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (393, 'Nova Rosalandia', 'TO', NULL, NULL, NULL, 1715002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.133154', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (394, 'Novo Acordo', 'TO', NULL, NULL, NULL, 1715101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.134133', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (395, 'Novo Alegre', 'TO', NULL, NULL, NULL, 1715150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.135242', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (396, 'Novo Jardim', 'TO', NULL, NULL, NULL, 1715259, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.13607', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (397, 'Oliveira de Fatima', 'TO', NULL, NULL, NULL, 1715507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.143376', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (399, 'Palmeirante', 'TO', NULL, NULL, NULL, 1715705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.145386', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (401, 'Palmeiropolis', 'TO', NULL, NULL, NULL, 1715754, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.14756', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (402, 'Paraiso do Tocantins', 'TO', NULL, NULL, NULL, 1716109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.148448', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (403, 'Parana', 'TO', NULL, NULL, NULL, 1716208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.149167', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (404, 'Pau D''arco', 'TO', NULL, NULL, NULL, 1716307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.150069', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (405, 'Pedro Afonso', 'TO', NULL, NULL, NULL, 1716505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.151063', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (406, 'Peixe', 'TO', NULL, NULL, NULL, 1716604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.151996', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (407, 'Pequizeiro', 'TO', NULL, NULL, NULL, 1716653, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.152856', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (348, 'Colmeia', 'TO', NULL, NULL, NULL, 1716703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.086822', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (408, 'Pindorama do Tocantins', 'TO', NULL, NULL, NULL, 1717008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.153748', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (409, 'Piraque', 'TO', NULL, NULL, NULL, 1717206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.154606', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (410, 'Pium', 'TO', NULL, NULL, NULL, 1717503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.155474', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (411, 'Ponte Alta do Bom Jesus', 'TO', NULL, NULL, NULL, 1717800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.156408', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (412, 'Ponte Alta do Tocantins', 'TO', NULL, NULL, NULL, 1717909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.157673', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (413, 'Porto Alegre do Tocantins', 'TO', NULL, NULL, NULL, 1718006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.158647', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (414, 'Porto Nacional', 'TO', NULL, NULL, NULL, 1718204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.159639', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (415, 'Praia Norte', 'TO', NULL, NULL, NULL, 1718303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.160437', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (416, 'Presidente Kennedy', 'TO', NULL, NULL, NULL, 1718402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.16134', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (417, 'Pugmil', 'TO', NULL, NULL, NULL, 1718451, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.16224', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (418, 'Recursolandia', 'TO', NULL, NULL, NULL, 1718501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.163175', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (419, 'Riachinho', 'TO', NULL, NULL, NULL, 1718550, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.164096', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (420, 'Rio da Conceicao', 'TO', NULL, NULL, NULL, 1718659, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.164921', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (421, 'Rio dos Bois', 'TO', NULL, NULL, NULL, 1718709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.165967', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (422, 'Rio Sono', 'TO', NULL, NULL, NULL, 1718758, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.166949', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (423, 'Sampaio', 'TO', NULL, NULL, NULL, 1718808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.167811', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (424, 'Sandolandia', 'TO', NULL, NULL, NULL, 1718840, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.168809', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (425, 'Santa Fe do Araguaia', 'TO', NULL, NULL, NULL, 1718865, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.169817', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (426, 'Santa Maria do Tocantins', 'TO', NULL, NULL, NULL, 1718881, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.170766', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (427, 'Santa Rita do Tocantins', 'TO', NULL, NULL, NULL, 1718899, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.171677', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (428, 'Santa Rosa do Tocantins', 'TO', NULL, NULL, NULL, 1718907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.172572', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (429, 'Santa Tereza do Tocantins', 'TO', NULL, NULL, NULL, 1719004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.173518', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (430, 'Santa Terezinha do Tocantins', 'TO', NULL, NULL, NULL, 1720002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.174352', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (431, 'Sao Bento do Tocantins', 'TO', NULL, NULL, NULL, 1720101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.17523', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (432, 'Sao Felix do Tocantins', 'TO', NULL, NULL, NULL, 1720150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.176102', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (433, 'Sao Miguel do Tocantins', 'TO', NULL, NULL, NULL, 1720200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.177106', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (434, 'Sao Salvador do Tocantins', 'TO', NULL, NULL, NULL, 1720259, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.18496', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (435, 'Sao Sebastiao do Tocantins', 'TO', NULL, NULL, NULL, 1720309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.186102', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (437, 'Silvanopolis', 'TO', NULL, NULL, NULL, 1720655, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.187777', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (438, 'Sitio Novo do Tocantins', 'TO', NULL, NULL, NULL, 1720804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.188758', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (439, 'Sucupira', 'TO', NULL, NULL, NULL, 1720853, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.189661', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (440, 'Taguatinga', 'TO', NULL, NULL, NULL, 1720903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.190463', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (441, 'Taipas do Tocantins', 'TO', NULL, NULL, NULL, 1720937, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.191273', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (442, 'Talisma', 'TO', NULL, NULL, NULL, 1720978, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.192128', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (398, 'Palmas', 'TO', NULL, NULL, NULL, 1721000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.144446', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (443, 'Tocantinia', 'TO', NULL, NULL, NULL, 1721109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.193041', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (444, 'Tocantinopolis', 'TO', NULL, NULL, NULL, 1721208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.19396', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (445, 'Tupirama', 'TO', NULL, NULL, NULL, 1721257, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.194937', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (446, 'Tupiratins', 'TO', NULL, NULL, NULL, 1721307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.195867', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (447, 'Wanderlandia', 'TO', NULL, NULL, NULL, 1722081, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.196689', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (448, 'Xambioa', 'TO', NULL, NULL, NULL, 1722107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.197644', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (449, 'Acailandia', 'MA', NULL, NULL, NULL, 2100055, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.198538', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (450, 'Afonso Cunha', 'MA', NULL, NULL, NULL, 2100105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.199462', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (451, 'Agua Doce do Maranhao', 'MA', NULL, NULL, NULL, 2100154, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.200279', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (452, 'Alcantara', 'MA', NULL, NULL, NULL, 2100204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.201164', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (453, 'Aldeias Altas', 'MA', NULL, NULL, NULL, 2100303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.202176', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (454, 'Altamira do Maranhao', 'MA', NULL, NULL, NULL, 2100402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.203261', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (455, 'Alto Alegre do Maranhao', 'MA', NULL, NULL, NULL, 2100436, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.204215', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (456, 'Alto Alegre do Pindare', 'MA', NULL, NULL, NULL, 2100477, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.205089', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (457, 'Alto Parnaiba', 'MA', NULL, NULL, NULL, 2100501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.206158', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (458, 'Amapa do Maranhao', 'MA', NULL, NULL, NULL, 2100550, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.20716', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (459, 'Amarante do Maranhao', 'MA', NULL, NULL, NULL, 2100600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.208081', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (460, 'Anajatuba', 'MA', NULL, NULL, NULL, 2100709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.208976', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (461, 'Anapurus', 'MA', NULL, NULL, NULL, 2100808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.209855', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (462, 'Apicum-acu', 'MA', NULL, NULL, NULL, 2100832, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.210782', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (463, 'Araguana', 'MA', NULL, NULL, NULL, 2100873, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.211696', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (464, 'Araioses', 'MA', NULL, NULL, NULL, 2100907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.212717', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (465, 'Arame', 'MA', NULL, NULL, NULL, 2100956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.21353', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (466, 'Arari', 'MA', NULL, NULL, NULL, 2101004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.214388', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (467, 'Axixa', 'MA', NULL, NULL, NULL, 2101103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.215297', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (468, 'Bacabal', 'MA', NULL, NULL, NULL, 2101202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.21624', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (469, 'Bacabeira', 'MA', NULL, NULL, NULL, 2101251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.217163', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (470, 'Bacuri', 'MA', NULL, NULL, NULL, 2101301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.218068', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (471, 'Bacurituba', 'MA', NULL, NULL, NULL, 2101350, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.218906', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (472, 'Balsas', 'MA', NULL, NULL, NULL, 2101400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.226511', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (473, 'Barao de Grajau', 'MA', NULL, NULL, NULL, 2101509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.227641', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (474, 'Barra do Corda', 'MA', NULL, NULL, NULL, 2101608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.228529', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (475, 'Barreirinhas', 'MA', NULL, NULL, NULL, 2101707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.22946', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (477, 'Belagua', 'MA', NULL, NULL, NULL, 2101731, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.231267', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (476, 'Bela Vista do Maranhao', 'MA', NULL, NULL, NULL, 2101772, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.230349', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (478, 'Benedito Leite', 'MA', NULL, NULL, NULL, 2101806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.232219', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (479, 'Bequimao', 'MA', NULL, NULL, NULL, 2101905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.233065', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (480, 'Bernardo do Mearim', 'MA', NULL, NULL, NULL, 2101939, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.23398', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (481, 'Boa Vista do Gurupi', 'MA', NULL, NULL, NULL, 2101970, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.234892', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (482, 'Bom Jardim', 'MA', NULL, NULL, NULL, 2102002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.235799', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (483, 'Bom Jesus das Selvas', 'MA', NULL, NULL, NULL, 2102036, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.236707', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (484, 'Bom Lugar', 'MA', NULL, NULL, NULL, 2102077, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.237544', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (485, 'Brejo', 'MA', NULL, NULL, NULL, 2102101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.238393', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (486, 'Brejo de Areia', 'MA', NULL, NULL, NULL, 2102150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.23924', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (487, 'Buriti', 'MA', NULL, NULL, NULL, 2102200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.240212', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (488, 'Buriti Bravo', 'MA', NULL, NULL, NULL, 2102309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.24103', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (489, 'Buriticupu', 'MA', NULL, NULL, NULL, 2102325, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.241945', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (490, 'Buritirana', 'MA', NULL, NULL, NULL, 2102358, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.242839', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (491, 'Cachoeira Grande', 'MA', NULL, NULL, NULL, 2102374, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.243731', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (492, 'Cajapio', 'MA', NULL, NULL, NULL, 2102408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.244628', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (493, 'Cajari', 'MA', NULL, NULL, NULL, 2102507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.245516', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (494, 'Campestre do Maranhao', 'MA', NULL, NULL, NULL, 2102556, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.246481', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (495, 'Candido Mendes', 'MA', NULL, NULL, NULL, 2102606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.247331', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (496, 'Cantanhede', 'MA', NULL, NULL, NULL, 2102705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.248243', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (497, 'Capinzal do Norte', 'MA', NULL, NULL, NULL, 2102754, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.249166', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (498, 'Carolina', 'MA', NULL, NULL, NULL, 2102804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.250112', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (499, 'Carutapera', 'MA', NULL, NULL, NULL, 2102903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.251005', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (500, 'Caxias', 'MA', NULL, NULL, NULL, 2103000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.251858', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (501, 'Cedral', 'MA', NULL, NULL, NULL, 2103109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.252814', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (502, 'Central do Maranhao', 'MA', NULL, NULL, NULL, 2103125, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.253724', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (503, 'Centro do Guilherme', 'MA', NULL, NULL, NULL, 2103158, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.254702', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (504, 'Centro Novo do Maranhao', 'MA', NULL, NULL, NULL, 2103174, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.255559', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (505, 'Chapadinha', 'MA', NULL, NULL, NULL, 2103208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.256472', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (506, 'Cidelandia', 'MA', NULL, NULL, NULL, 2103257, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.257495', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (507, 'Codo', 'MA', NULL, NULL, NULL, 2103307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.258325', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (508, 'Coelho Neto', 'MA', NULL, NULL, NULL, 2103406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.259107', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (509, 'Colinas', 'MA', NULL, NULL, NULL, 2103505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.259977', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (510, 'Conceicao do Lago-acu', 'MA', NULL, NULL, NULL, 2103554, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.267016', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (511, 'Coroata', 'MA', NULL, NULL, NULL, 2103604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.268195', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (512, 'Cururupu', 'MA', NULL, NULL, NULL, 2103703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.269164', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (513, 'Davinopolis', 'MA', NULL, NULL, NULL, 2103752, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.270095', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (514, 'Dom Pedro', 'MA', NULL, NULL, NULL, 2103802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.271002', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (515, 'Duque Bacelar', 'MA', NULL, NULL, NULL, 2103901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.271929', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (516, 'Esperantinopolis', 'MA', NULL, NULL, NULL, 2104008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.27286', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (517, 'Estreito', 'MA', NULL, NULL, NULL, 2104057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.273795', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (518, 'Feira Nova do Maranhao', 'MA', NULL, NULL, NULL, 2104073, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.274839', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (519, 'Fernando Falcao', 'MA', NULL, NULL, NULL, 2104081, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.275832', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (520, 'Formosa da Serra Negra', 'MA', NULL, NULL, NULL, 2104099, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.276788', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (521, 'Fortaleza dos Nogueiras', 'MA', NULL, NULL, NULL, 2104107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.27762', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (522, 'Fortuna', 'MA', NULL, NULL, NULL, 2104206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.278459', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (523, 'Godofredo Viana', 'MA', NULL, NULL, NULL, 2104305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.279542', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (524, 'Goncalves Dias', 'MA', NULL, NULL, NULL, 2104404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.280371', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (525, 'Governador Archer', 'MA', NULL, NULL, NULL, 2104503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.281277', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (526, 'Governador Edison Lobao', 'MA', NULL, NULL, NULL, 2104552, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.282223', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (527, 'Governador Eugenio Barros', 'MA', NULL, NULL, NULL, 2104602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.283125', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (528, 'Governador Luiz Rocha', 'MA', NULL, NULL, NULL, 2104628, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.283974', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (529, 'Governador Newton Bello', 'MA', NULL, NULL, NULL, 2104651, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.284782', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (530, 'Governador Nunes Freire', 'MA', NULL, NULL, NULL, 2104677, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.285675', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (531, 'Graca Aranha', 'MA', NULL, NULL, NULL, 2104701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.286846', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (532, 'Grajau', 'MA', NULL, NULL, NULL, 2104800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.287677', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (533, 'Guimaraes', 'MA', NULL, NULL, NULL, 2104909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.288667', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (534, 'Humberto de Campos', 'MA', NULL, NULL, NULL, 2105005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.289578', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (535, 'Icatu', 'MA', NULL, NULL, NULL, 2105104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.290557', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (536, 'Igarape do Meio', 'MA', NULL, NULL, NULL, 2105153, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.291496', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (537, 'Igarape Grande', 'MA', NULL, NULL, NULL, 2105203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.2924', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (538, 'Imperatriz', 'MA', NULL, NULL, NULL, 2105302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.293262', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (539, 'Itaipava do Grajau', 'MA', NULL, NULL, NULL, 2105351, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.294094', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (540, 'Itapecuru Mirim', 'MA', NULL, NULL, NULL, 2105401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.295124', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (541, 'Itinga do Maranhao', 'MA', NULL, NULL, NULL, 2105427, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.296028', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (542, 'Jatoba', 'MA', NULL, NULL, NULL, 2105450, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.296978', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (543, 'Jenipapo dos Vieiras', 'MA', NULL, NULL, NULL, 2105476, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.29789', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (544, 'Joao Lisboa', 'MA', NULL, NULL, NULL, 2105500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.298837', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (545, 'Joselandia', 'MA', NULL, NULL, NULL, 2105609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.299813', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (546, 'Junco do Maranhao', 'MA', NULL, NULL, NULL, 2105658, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.300907', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (547, 'Lago da Pedra', 'MA', NULL, NULL, NULL, 2105708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.302071', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (548, 'Lago do Junco', 'MA', NULL, NULL, NULL, 2105807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.307903', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (550, 'Lago Verde', 'MA', NULL, NULL, NULL, 2105906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.310138', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (551, 'Lagoa do Mato', 'MA', NULL, NULL, NULL, 2105922, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.311156', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (549, 'Lago dos Rodrigues', 'MA', NULL, NULL, NULL, 2105948, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.309158', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (552, 'Lagoa Grande do Maranhao', 'MA', NULL, NULL, NULL, 2105963, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.312133', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (553, 'Lajeado Novo', 'MA', NULL, NULL, NULL, 2105989, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.313052', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (554, 'Lima Campos', 'MA', NULL, NULL, NULL, 2106003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.313916', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (555, 'Loreto', 'MA', NULL, NULL, NULL, 2106102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.31479', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (556, 'Luis Domingues', 'MA', NULL, NULL, NULL, 2106201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.315685', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (557, 'Magalhaes de Almeida', 'MA', NULL, NULL, NULL, 2106300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.316626', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (558, 'Maracacume', 'MA', NULL, NULL, NULL, 2106326, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.317519', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (559, 'Maraja do Sena', 'MA', NULL, NULL, NULL, 2106359, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.318381', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (560, 'Maranhaozinho', 'MA', NULL, NULL, NULL, 2106375, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.319219', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (561, 'Mata Roma', 'MA', NULL, NULL, NULL, 2106409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.320109', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (562, 'Matinha', 'MA', NULL, NULL, NULL, 2106508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.320966', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (563, 'Matoes', 'MA', NULL, NULL, NULL, 2106607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.321907', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (564, 'Matoes do Norte', 'MA', NULL, NULL, NULL, 2106631, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.32282', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (565, 'Milagres do Maranhao', 'MA', NULL, NULL, NULL, 2106672, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.32375', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (566, 'Mirador', 'MA', NULL, NULL, NULL, 2106706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.324883', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (567, 'Miranda do Norte', 'MA', NULL, NULL, NULL, 2106755, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.325801', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (568, 'Mirinzal', 'MA', NULL, NULL, NULL, 2106805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.326849', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (569, 'Moncao', 'MA', NULL, NULL, NULL, 2106904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.327637', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (570, 'Montes Altos', 'MA', NULL, NULL, NULL, 2107001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.328569', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (571, 'Morros', 'MA', NULL, NULL, NULL, 2107100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.329367', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (572, 'Nina Rodrigues', 'MA', NULL, NULL, NULL, 2107209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.330692', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (573, 'Nova Colinas', 'MA', NULL, NULL, NULL, 2107258, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.332095', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (574, 'Nova Iorque', 'MA', NULL, NULL, NULL, 2107308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.333022', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (575, 'Nova Olinda do Maranhao', 'MA', NULL, NULL, NULL, 2107357, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.333932', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (576, 'Olho D''agua das Cunhas', 'MA', NULL, NULL, NULL, 2107407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.334867', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (577, 'Olinda Nova do Maranhao', 'MA', NULL, NULL, NULL, 2107456, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.335779', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (578, 'Paco do Lumiar', 'MA', NULL, NULL, NULL, 2107506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.33655', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (579, 'Palmeirandia', 'MA', NULL, NULL, NULL, 2107605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.337518', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (580, 'Paraibano', 'MA', NULL, NULL, NULL, 2107704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.338445', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (581, 'Parnarama', 'MA', NULL, NULL, NULL, 2107803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.340223', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (582, 'Passagem Franca', 'MA', NULL, NULL, NULL, 2107902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.341359', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (583, 'Pastos Bons', 'MA', NULL, NULL, NULL, 2108009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.342182', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (584, 'Paulino Neves', 'MA', NULL, NULL, NULL, 2108058, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.352812', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (585, 'Paulo Ramos', 'MA', NULL, NULL, NULL, 2108108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.353828', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (586, 'Pedreiras', 'MA', NULL, NULL, NULL, 2108207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.354689', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (587, 'Pedro do Rosario', 'MA', NULL, NULL, NULL, 2108256, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.355564', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (588, 'Penalva', 'MA', NULL, NULL, NULL, 2108306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.356425', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (589, 'Peri Mirim', 'MA', NULL, NULL, NULL, 2108405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.357303', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (590, 'Peritoro', 'MA', NULL, NULL, NULL, 2108454, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.358268', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (592, 'Pinheiro', 'MA', NULL, NULL, NULL, 2108603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.360105', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (593, 'Pio Xii', 'MA', NULL, NULL, NULL, 2108702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.361003', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (594, 'Pirapemas', 'MA', NULL, NULL, NULL, 2108801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.361829', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (595, 'Pocao de Pedras', 'MA', NULL, NULL, NULL, 2108900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.362741', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (596, 'Porto Franco', 'MA', NULL, NULL, NULL, 2109007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.363626', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (597, 'Porto Rico do Maranhao', 'MA', NULL, NULL, NULL, 2109056, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.364534', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (598, 'Presidente Dutra', 'MA', NULL, NULL, NULL, 2109106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.365368', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (599, 'Presidente Juscelino', 'MA', NULL, NULL, NULL, 2109205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.366202', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (600, 'Presidente Medici', 'MA', NULL, NULL, NULL, 2109239, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.367133', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (601, 'Presidente Sarney', 'MA', NULL, NULL, NULL, 2109270, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.368047', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (602, 'Presidente Vargas', 'MA', NULL, NULL, NULL, 2109304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.368937', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (603, 'Primeira Cruz', 'MA', NULL, NULL, NULL, 2109403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.369823', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (604, 'Raposa', 'MA', NULL, NULL, NULL, 2109452, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.370771', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (605, 'Riachao', 'MA', NULL, NULL, NULL, 2109502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.371655', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (606, 'Ribamar Fiquene', 'MA', NULL, NULL, NULL, 2109551, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.372579', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (607, 'Rosario', 'MA', NULL, NULL, NULL, 2109601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.373524', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (608, 'Sambaiba', 'MA', NULL, NULL, NULL, 2109700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.374298', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (609, 'Santa Filomena do Maranhao', 'MA', NULL, NULL, NULL, 2109759, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.375097', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (610, 'Santa Helena', 'MA', NULL, NULL, NULL, 2109809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.376', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (611, 'Santa Ines', 'MA', NULL, NULL, NULL, 2109908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.376926', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (612, 'Santa Luzia', 'MA', NULL, NULL, NULL, 2110005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.37791', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (613, 'Santa Luzia do Parua', 'MA', NULL, NULL, NULL, 2110039, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.378894', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (614, 'Santa Quiteria do Maranhao', 'MA', NULL, NULL, NULL, 2110104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.379769', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (615, 'Santa Rita', 'MA', NULL, NULL, NULL, 2110203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.380996', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (616, 'Santana do Maranhao', 'MA', NULL, NULL, NULL, 2110237, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.381789', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (617, 'Santo Amaro do Maranhao', 'MA', NULL, NULL, NULL, 2110278, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.382757', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (618, 'Santo Antonio dos Lopes', 'MA', NULL, NULL, NULL, 2110302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.38365', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (619, 'Sao Benedito do Rio Preto', 'MA', NULL, NULL, NULL, 2110401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.384567', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (620, 'Sao Bento', 'MA', NULL, NULL, NULL, 2110500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.385444', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (621, 'Sao Bernardo', 'MA', NULL, NULL, NULL, 2110609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.386272', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (622, 'Sao Domingos do Azeitao', 'MA', NULL, NULL, NULL, 2110658, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.388381', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (623, 'Sao Domingos do Maranhao', 'MA', NULL, NULL, NULL, 2110708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.395118', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (624, 'Sao Felix de Balsas', 'MA', NULL, NULL, NULL, 2110807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.39616', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (625, 'Sao Francisco do Brejao', 'MA', NULL, NULL, NULL, 2110856, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.397025', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (626, 'Sao Francisco do Maranhao', 'MA', NULL, NULL, NULL, 2110906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.398044', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (627, 'Sao Joao Batista', 'MA', NULL, NULL, NULL, 2111003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.39892', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (628, 'Sao Joao do Caru', 'MA', NULL, NULL, NULL, 2111029, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.399745', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (629, 'Sao Joao do Paraiso', 'MA', NULL, NULL, NULL, 2111052, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.400816', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (630, 'Sao Joao do Soter', 'MA', NULL, NULL, NULL, 2111078, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.401759', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (631, 'Sao Joao dos Patos', 'MA', NULL, NULL, NULL, 2111102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.402956', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (632, 'Sao Jose de Ribamar', 'MA', NULL, NULL, NULL, 2111201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.403809', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (633, 'Sao Jose dos Basilios', 'MA', NULL, NULL, NULL, 2111250, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.404643', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (634, 'Sao Luis', 'MA', NULL, NULL, NULL, 2111300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.405647', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (635, 'Sao Luis Gonzaga do Maranhao', 'MA', NULL, NULL, NULL, 2111409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.40646', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (636, 'Sao Mateus do Maranhao', 'MA', NULL, NULL, NULL, 2111508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.407324', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (637, 'Sao Pedro da Agua Branca', 'MA', NULL, NULL, NULL, 2111532, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.408245', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (638, 'Sao Pedro dos Crentes', 'MA', NULL, NULL, NULL, 2111573, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.409364', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (639, 'Sao Raimundo das Mangabeiras', 'MA', NULL, NULL, NULL, 2111607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.410289', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (640, 'Sao Raimundo do Doca Bezerra', 'MA', NULL, NULL, NULL, 2111631, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.411219', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (641, 'Sao Roberto', 'MA', NULL, NULL, NULL, 2111672, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.412187', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (642, 'Sao Vicente Ferrer', 'MA', NULL, NULL, NULL, 2111706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.413132', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (643, 'Satubinha', 'MA', NULL, NULL, NULL, 2111722, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.414213', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (644, 'Senador Alexandre Costa', 'MA', NULL, NULL, NULL, 2111748, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.41502', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (645, 'Senador La Rocque', 'MA', NULL, NULL, NULL, 2111763, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.416003', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (646, 'Serrano do Maranhao', 'MA', NULL, NULL, NULL, 2111789, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.416907', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (647, 'Sitio Novo', 'MA', NULL, NULL, NULL, 2111805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.417788', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (648, 'Sucupira do Norte', 'MA', NULL, NULL, NULL, 2111904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.418657', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (649, 'Sucupira do Riachao', 'MA', NULL, NULL, NULL, 2111953, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.419524', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (650, 'Tasso Fragoso', 'MA', NULL, NULL, NULL, 2112001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.420459', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (651, 'Timbiras', 'MA', NULL, NULL, NULL, 2112100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.421346', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (652, 'Timon', 'MA', NULL, NULL, NULL, 2112209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.422227', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (653, 'Trizidela do Vale', 'MA', NULL, NULL, NULL, 2112233, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.4231', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (654, 'Tufilandia', 'MA', NULL, NULL, NULL, 2112274, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.424033', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (655, 'Tuntum', 'MA', NULL, NULL, NULL, 2112308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.425218', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (656, 'Turiacu', 'MA', NULL, NULL, NULL, 2112407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.426154', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (657, 'Turilandia', 'MA', NULL, NULL, NULL, 2112456, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.426947', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (658, 'Tutoia', 'MA', NULL, NULL, NULL, 2112506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.427726', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (659, 'Urbano Santos', 'MA', NULL, NULL, NULL, 2112605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.428556', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (660, 'Vargem Grande', 'MA', NULL, NULL, NULL, 2112704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.435067', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (661, 'Viana', 'MA', NULL, NULL, NULL, 2112803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.436627', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (662, 'Vila Nova dos Martirios', 'MA', NULL, NULL, NULL, 2112852, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.43748', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (663, 'Vitoria do Mearim', 'MA', NULL, NULL, NULL, 2112902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.438392', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (664, 'Vitorino Freire', 'MA', NULL, NULL, NULL, 2113009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.439218', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (665, 'Ze Doca', 'MA', NULL, NULL, NULL, 2114007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.440175', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (666, 'Acaua', 'PI', NULL, NULL, NULL, 2200053, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.441086', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (667, 'Agricolandia', 'PI', NULL, NULL, NULL, 2200103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.44202', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (668, 'Agua Branca', 'PI', NULL, NULL, NULL, 2200202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.443259', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (669, 'Alagoinha do Piaui', 'PI', NULL, NULL, NULL, 2200251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.444215', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (670, 'Alegrete do Piaui', 'PI', NULL, NULL, NULL, 2200277, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.445155', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (671, 'Alto Longa', 'PI', NULL, NULL, NULL, 2200301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.446035', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (672, 'Altos', 'PI', NULL, NULL, NULL, 2200400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.446996', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (673, 'Alvorada do Gurgueia', 'PI', NULL, NULL, NULL, 2200459, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.447826', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (674, 'Amarante', 'PI', NULL, NULL, NULL, 2200509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.448565', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (675, 'Angical do Piaui', 'PI', NULL, NULL, NULL, 2200608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.449534', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (676, 'Anisio de Abreu', 'PI', NULL, NULL, NULL, 2200707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.450473', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (677, 'Antonio Almeida', 'PI', NULL, NULL, NULL, 2200806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.451325', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (678, 'Aroazes', 'PI', NULL, NULL, NULL, 2200905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.452206', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (680, 'Arraial', 'PI', NULL, NULL, NULL, 2201002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.453937', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (681, 'Assuncao do Piaui', 'PI', NULL, NULL, NULL, 2201051, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.454994', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (682, 'Avelino Lopes', 'PI', NULL, NULL, NULL, 2201101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.455933', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (683, 'Baixa Grande do Ribeiro', 'PI', NULL, NULL, NULL, 2201150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.456842', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (685, 'Barras', 'PI', NULL, NULL, NULL, 2201200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.458843', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (686, 'Barreiras do Piaui', 'PI', NULL, NULL, NULL, 2201309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.460085', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (687, 'Barro Duro', 'PI', NULL, NULL, NULL, 2201408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.461037', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (688, 'Batalha', 'PI', NULL, NULL, NULL, 2201507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.461931', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (689, 'Bela Vista do Piaui', 'PI', NULL, NULL, NULL, 2201556, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.462988', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (690, 'Belem do Piaui', 'PI', NULL, NULL, NULL, 2201572, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.463815', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (691, 'Beneditinos', 'PI', NULL, NULL, NULL, 2201606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.464727', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (692, 'Bertolinia', 'PI', NULL, NULL, NULL, 2201705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.465651', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (693, 'Betania do Piaui', 'PI', NULL, NULL, NULL, 2201739, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.466532', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (694, 'Boa Hora', 'PI', NULL, NULL, NULL, 2201770, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.467333', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (695, 'Bocaina', 'PI', NULL, NULL, NULL, 2201804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.468202', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (696, 'Bom Jesus', 'PI', NULL, NULL, NULL, 2201903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.469091', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (697, 'Bom Principio do Piaui', 'PI', NULL, NULL, NULL, 2201919, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.476209', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (698, 'Bonfim do Piaui', 'PI', NULL, NULL, NULL, 2201929, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.477453', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (699, 'Boqueirao do Piaui', 'PI', NULL, NULL, NULL, 2201945, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.478284', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (700, 'Brasileira', 'PI', NULL, NULL, NULL, 2201960, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.479141', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (701, 'Brejo do Piaui', 'PI', NULL, NULL, NULL, 2201988, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.479943', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (702, 'Buriti dos Lopes', 'PI', NULL, NULL, NULL, 2202000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.481156', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (703, 'Buriti dos Montes', 'PI', NULL, NULL, NULL, 2202026, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.481975', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (704, 'Cabeceiras do Piaui', 'PI', NULL, NULL, NULL, 2202059, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.482873', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (705, 'Cajazeiras do Piaui', 'PI', NULL, NULL, NULL, 2202075, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.483761', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (706, 'Cajueiro da Praia', 'PI', NULL, NULL, NULL, 2202083, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.484708', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (707, 'Caldeirao Grande do Piaui', 'PI', NULL, NULL, NULL, 2202091, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.485653', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (708, 'Campinas do Piaui', 'PI', NULL, NULL, NULL, 2202109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.4866', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (709, 'Campo Alegre do Fidalgo', 'PI', NULL, NULL, NULL, 2202117, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.487558', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (710, 'Campo Grande do Piaui', 'PI', NULL, NULL, NULL, 2202133, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.488623', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (711, 'Campo Largo do Piaui', 'PI', NULL, NULL, NULL, 2202174, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.489554', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (712, 'Campo Maior', 'PI', NULL, NULL, NULL, 2202208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.490426', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (713, 'Canavieira', 'PI', NULL, NULL, NULL, 2202251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.491345', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (714, 'Canto do Buriti', 'PI', NULL, NULL, NULL, 2202307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.492473', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (715, 'Capitao de Campos', 'PI', NULL, NULL, NULL, 2202406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.493449', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (716, 'Capitao Gervasio Oliveira', 'PI', NULL, NULL, NULL, 2202455, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.49426', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (717, 'Caracol', 'PI', NULL, NULL, NULL, 2202505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.495011', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (718, 'Caraubas do Piaui', 'PI', NULL, NULL, NULL, 2202539, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.495894', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (719, 'Caridade do Piaui', 'PI', NULL, NULL, NULL, 2202554, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.496798', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (720, 'Castelo do Piaui', 'PI', NULL, NULL, NULL, 2202604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.49769', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (721, 'Caxingo', 'PI', NULL, NULL, NULL, 2202653, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.498551', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (722, 'Cocal', 'PI', NULL, NULL, NULL, 2202703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.49945', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (723, 'Cocal de Telha', 'PI', NULL, NULL, NULL, 2202711, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.500365', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (724, 'Cocal dos Alves', 'PI', NULL, NULL, NULL, 2202729, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.501178', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (725, 'Coivaras', 'PI', NULL, NULL, NULL, 2202737, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.50203', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (726, 'Colonia do Gurgueia', 'PI', NULL, NULL, NULL, 2202752, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.502948', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (727, 'Colonia do Piaui', 'PI', NULL, NULL, NULL, 2202778, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.503724', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (728, 'Conceicao do Caninde', 'PI', NULL, NULL, NULL, 2202802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.504605', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (729, 'Coronel Jose Dias', 'PI', NULL, NULL, NULL, 2202851, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.50551', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (730, 'Corrente', 'PI', NULL, NULL, NULL, 2202901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.506368', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (731, 'Cristalandia do Piaui', 'PI', NULL, NULL, NULL, 2203008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.507245', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (732, 'Cristino Castro', 'PI', NULL, NULL, NULL, 2203107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.508161', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (733, 'Curimata', 'PI', NULL, NULL, NULL, 2203206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.509093', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (734, 'Currais', 'PI', NULL, NULL, NULL, 2203230, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.509915', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (736, 'Curralinhos', 'PI', NULL, NULL, NULL, 2203255, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.517649', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (735, 'Curral Novo do Piaui', 'PI', NULL, NULL, NULL, 2203271, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.516478', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (737, 'Demerval Lobao', 'PI', NULL, NULL, NULL, 2203305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.518747', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (738, 'Dirceu Arcoverde', 'PI', NULL, NULL, NULL, 2203354, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.519566', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (739, 'Dom Expedito Lopes', 'PI', NULL, NULL, NULL, 2203404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.520463', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (741, 'Domingos Mourao', 'PI', NULL, NULL, NULL, 2203420, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.522', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (740, 'Dom Inocencio', 'PI', NULL, NULL, NULL, 2203453, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.521277', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (742, 'Elesbao Veloso', 'PI', NULL, NULL, NULL, 2203503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.522894', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (743, 'Eliseu Martins', 'PI', NULL, NULL, NULL, 2203602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.52379', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (744, 'Esperantina', 'PI', NULL, NULL, NULL, 2203701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.524652', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (745, 'Fartura do Piaui', 'PI', NULL, NULL, NULL, 2203750, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.526063', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (746, 'Flores do Piaui', 'PI', NULL, NULL, NULL, 2203800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.527005', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (747, 'Floresta do Piaui', 'PI', NULL, NULL, NULL, 2203859, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.527865', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (748, 'Floriano', 'PI', NULL, NULL, NULL, 2203909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.528733', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (749, 'Francinopolis', 'PI', NULL, NULL, NULL, 2204006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.529749', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (750, 'Francisco Ayres', 'PI', NULL, NULL, NULL, 2204105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.530678', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (751, 'Francisco Macedo', 'PI', NULL, NULL, NULL, 2204154, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.531546', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (752, 'Francisco Santos', 'PI', NULL, NULL, NULL, 2204204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.532468', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (753, 'Fronteiras', 'PI', NULL, NULL, NULL, 2204303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.533279', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (754, 'Geminiano', 'PI', NULL, NULL, NULL, 2204352, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.534092', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (755, 'Gilbues', 'PI', NULL, NULL, NULL, 2204402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.535027', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (756, 'Guadalupe', 'PI', NULL, NULL, NULL, 2204501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.535945', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (757, 'Guaribas', 'PI', NULL, NULL, NULL, 2204550, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.536987', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (758, 'Hugo Napoleao', 'PI', NULL, NULL, NULL, 2204600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.53787', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (759, 'Ilha Grande', 'PI', NULL, NULL, NULL, 2204659, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.538744', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (760, 'Inhuma', 'PI', NULL, NULL, NULL, 2204709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.539664', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (761, 'Ipiranga do Piaui', 'PI', NULL, NULL, NULL, 2204808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.540631', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (762, 'Isaias Coelho', 'PI', NULL, NULL, NULL, 2204907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.541589', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (763, 'Itainopolis', 'PI', NULL, NULL, NULL, 2205003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.54226', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (764, 'Itaueira', 'PI', NULL, NULL, NULL, 2205102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.543208', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (765, 'Jacobina do Piaui', 'PI', NULL, NULL, NULL, 2205151, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.544013', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (766, 'Jaicos', 'PI', NULL, NULL, NULL, 2205201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.544932', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (767, 'Jardim do Mulato', 'PI', NULL, NULL, NULL, 2205250, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.545843', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (768, 'Jatoba do Piaui', 'PI', NULL, NULL, NULL, 2205276, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.546727', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (769, 'Jerumenha', 'PI', NULL, NULL, NULL, 2205300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.547582', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (770, 'Joao Costa', 'PI', NULL, NULL, NULL, 2205359, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.548411', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (771, 'Joaquim Pires', 'PI', NULL, NULL, NULL, 2205409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.549224', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (772, 'Joca Marques', 'PI', NULL, NULL, NULL, 2205458, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.550172', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (773, 'Jose de Freitas', 'PI', NULL, NULL, NULL, 2205508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.557', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (774, 'Juazeiro do Piaui', 'PI', NULL, NULL, NULL, 2205516, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.558345', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (775, 'Julio Borges', 'PI', NULL, NULL, NULL, 2205524, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.559238', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (776, 'Jurema', 'PI', NULL, NULL, NULL, 2205532, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.560161', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (782, 'Lagoinha do Piaui', 'PI', NULL, NULL, NULL, 2205540, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.565646', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (777, 'Lagoa Alegre', 'PI', NULL, NULL, NULL, 2205557, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.561061', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (779, 'Lagoa do Barro do Piaui', 'PI', NULL, NULL, NULL, 2205565, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.56292', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (778, 'Lagoa de Sao Francisco', 'PI', NULL, NULL, NULL, 2205573, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.562032', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (780, 'Lagoa do Piaui', 'PI', NULL, NULL, NULL, 2205581, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.56385', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (781, 'Lagoa do Sitio', 'PI', NULL, NULL, NULL, 2205599, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.56476', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (783, 'Landri Sales', 'PI', NULL, NULL, NULL, 2205607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.566526', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (784, 'Luis Correia', 'PI', NULL, NULL, NULL, 2205706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.567389', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (785, 'Luzilandia', 'PI', NULL, NULL, NULL, 2205805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.568333', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (786, 'Madeiro', 'PI', NULL, NULL, NULL, 2205854, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.569282', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (787, 'Manoel Emidio', 'PI', NULL, NULL, NULL, 2205904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.57028', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (788, 'Marcolandia', 'PI', NULL, NULL, NULL, 2205953, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.571109', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (789, 'Marcos Parente', 'PI', NULL, NULL, NULL, 2206001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.571924', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (790, 'Massape do Piaui', 'PI', NULL, NULL, NULL, 2206050, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.572792', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (791, 'Matias Olimpio', 'PI', NULL, NULL, NULL, 2206100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.573727', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (792, 'Miguel Alves', 'PI', NULL, NULL, NULL, 2206209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.574699', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (793, 'Miguel Leao', 'PI', NULL, NULL, NULL, 2206308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.575592', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (794, 'Milton Brandao', 'PI', NULL, NULL, NULL, 2206357, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.576731', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (795, 'Monsenhor Gil', 'PI', NULL, NULL, NULL, 2206407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.577659', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (796, 'Monsenhor Hipolito', 'PI', NULL, NULL, NULL, 2206506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.578489', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (797, 'Monte Alegre do Piaui', 'PI', NULL, NULL, NULL, 2206605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.579329', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (798, 'Morro Cabeca No Tempo', 'PI', NULL, NULL, NULL, 2206654, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.580308', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (799, 'Morro do Chapeu do Piaui', 'PI', NULL, NULL, NULL, 2206670, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.581572', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (800, 'Murici dos Portelas', 'PI', NULL, NULL, NULL, 2206696, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.582369', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (801, 'Nazare do Piaui', 'PI', NULL, NULL, NULL, 2206704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.583261', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (803, 'Nossa Senhora de Nazare', 'PI', NULL, NULL, NULL, 2206753, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.585035', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (804, 'Nossa Senhora dos Remedios', 'PI', NULL, NULL, NULL, 2206803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.585913', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (806, 'Novo Oriente do Piaui', 'PI', NULL, NULL, NULL, 2206902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.587703', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (807, 'Novo Santo Antonio', 'PI', NULL, NULL, NULL, 2206951, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.588561', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (808, 'Oeiras', 'PI', NULL, NULL, NULL, 2207009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.58949', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (810, 'Padre Marcos', 'PI', NULL, NULL, NULL, 2207207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.591217', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (811, 'Paes Landim', 'PI', NULL, NULL, NULL, 2207306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.592557', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (812, 'Pajeu do Piaui', 'PI', NULL, NULL, NULL, 2207355, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.598809', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (813, 'Palmeira do Piaui', 'PI', NULL, NULL, NULL, 2207405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.599731', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (814, 'Palmeirais', 'PI', NULL, NULL, NULL, 2207504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.600651', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (815, 'Paqueta', 'PI', NULL, NULL, NULL, 2207553, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.601586', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (816, 'Parnagua', 'PI', NULL, NULL, NULL, 2207603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.603105', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (817, 'Parnaiba', 'PI', NULL, NULL, NULL, 2207702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.603974', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (818, 'Passagem Franca do Piaui', 'PI', NULL, NULL, NULL, 2207751, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.604851', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (819, 'Patos do Piaui', 'PI', NULL, NULL, NULL, 2207777, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.605756', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (820, 'Pau D''arco do Piaui', 'PI', NULL, NULL, NULL, 2207793, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.606727', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (821, 'Paulistana', 'PI', NULL, NULL, NULL, 2207801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.607612', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (822, 'Pavussu', 'PI', NULL, NULL, NULL, 2207850, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.608647', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (823, 'Pedro Ii', 'PI', NULL, NULL, NULL, 2207900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.609674', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (824, 'Pedro Laurentino', 'PI', NULL, NULL, NULL, 2207934, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.610587', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (805, 'Nova Santa Rita', 'PI', NULL, NULL, NULL, 2207959, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.58681', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (825, 'Picos', 'PI', NULL, NULL, NULL, 2208007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.611502', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (826, 'Pimenteiras', 'PI', NULL, NULL, NULL, 2208106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.61237', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (827, 'Pio Ix', 'PI', NULL, NULL, NULL, 2208205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.61325', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (828, 'Piracuruca', 'PI', NULL, NULL, NULL, 2208304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.6142', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (829, 'Piripiri', 'PI', NULL, NULL, NULL, 2208403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.615071', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (830, 'Porto', 'PI', NULL, NULL, NULL, 2208502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.616029', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (831, 'Porto Alegre do Piaui', 'PI', NULL, NULL, NULL, 2208551, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.617018', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (832, 'Prata do Piaui', 'PI', NULL, NULL, NULL, 2208601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.617877', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (833, 'Queimada Nova', 'PI', NULL, NULL, NULL, 2208650, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.618689', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (834, 'Redencao do Gurgueia', 'PI', NULL, NULL, NULL, 2208700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.619662', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (835, 'Regeneracao', 'PI', NULL, NULL, NULL, 2208809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.620619', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (836, 'Riacho Frio', 'PI', NULL, NULL, NULL, 2208858, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.621548', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (837, 'Ribeira do Piaui', 'PI', NULL, NULL, NULL, 2208874, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.62253', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (838, 'Ribeiro Goncalves', 'PI', NULL, NULL, NULL, 2208908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.623518', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (839, 'Rio Grande do Piaui', 'PI', NULL, NULL, NULL, 2209005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.624477', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (840, 'Santa Cruz do Piaui', 'PI', NULL, NULL, NULL, 2209104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.625541', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (841, 'Santa Cruz dos Milagres', 'PI', NULL, NULL, NULL, 2209153, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.626406', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (842, 'Santa Filomena', 'PI', NULL, NULL, NULL, 2209203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.627271', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (843, 'Santa Luz', 'PI', NULL, NULL, NULL, 2209302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.628246', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (845, 'Santana do Piaui', 'PI', NULL, NULL, NULL, 2209351, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.630097', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (844, 'Santa Rosa do Piaui', 'PI', NULL, NULL, NULL, 2209377, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.629172', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (846, 'Santo Antonio de Lisboa', 'PI', NULL, NULL, NULL, 2209401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.630983', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (847, 'Santo Antonio dos Milagres', 'PI', NULL, NULL, NULL, 2209450, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.631953', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (848, 'Santo Inacio do Piaui', 'PI', NULL, NULL, NULL, 2209500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.638737', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (849, 'Sao Braz do Piaui', 'PI', NULL, NULL, NULL, 2209559, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.640018', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (850, 'Sao Felix do Piaui', 'PI', NULL, NULL, NULL, 2209609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.641003', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (851, 'Sao Francisco de Assis do Piaui', 'PI', NULL, NULL, NULL, 2209658, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.641974', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (852, 'Sao Francisco do Piaui', 'PI', NULL, NULL, NULL, 2209708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.642905', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (853, 'Sao Goncalo do Gurgueia', 'PI', NULL, NULL, NULL, 2209757, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.643859', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (854, 'Sao Goncalo do Piaui', 'PI', NULL, NULL, NULL, 2209807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.644778', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (855, 'Sao Joao da Canabrava', 'PI', NULL, NULL, NULL, 2209856, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.645729', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (856, 'Sao Joao da Fronteira', 'PI', NULL, NULL, NULL, 2209872, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.646746', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (857, 'Sao Joao da Serra', 'PI', NULL, NULL, NULL, 2209906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.64776', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (858, 'Sao Joao da Varjota', 'PI', NULL, NULL, NULL, 2209955, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.648584', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (859, 'Sao Joao do Arraial', 'PI', NULL, NULL, NULL, 2209971, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.649445', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (860, 'Sao Joao do Piaui', 'PI', NULL, NULL, NULL, 2210003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.65029', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (861, 'Sao Jose do Divino', 'PI', NULL, NULL, NULL, 2210052, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.65123', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (862, 'Sao Jose do Peixe', 'PI', NULL, NULL, NULL, 2210102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.652159', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (863, 'Sao Jose do Piaui', 'PI', NULL, NULL, NULL, 2210201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.653052', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (864, 'Sao Juliao', 'PI', NULL, NULL, NULL, 2210300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.654041', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (865, 'Sao Lourenco do Piaui', 'PI', NULL, NULL, NULL, 2210359, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.654978', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (866, 'Sao Luis do Piaui', 'PI', NULL, NULL, NULL, 2210375, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.655997', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (867, 'Sao Miguel da Baixa Grande', 'PI', NULL, NULL, NULL, 2210383, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.656848', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (868, 'Sao Miguel do Fidalgo', 'PI', NULL, NULL, NULL, 2210391, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.657708', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (869, 'Sao Miguel do Tapuio', 'PI', NULL, NULL, NULL, 2210409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.658591', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (870, 'Sao Pedro do Piaui', 'PI', NULL, NULL, NULL, 2210508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.659708', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (871, 'Sao Raimundo Nonato', 'PI', NULL, NULL, NULL, 2210607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.660725', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (872, 'Sebastiao Barros', 'PI', NULL, NULL, NULL, 2210623, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.661633', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (873, 'Sebastiao Leal', 'PI', NULL, NULL, NULL, 2210631, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.662743', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (874, 'Sigefredo Pacheco', 'PI', NULL, NULL, NULL, 2210656, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.663614', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (875, 'Simoes', 'PI', NULL, NULL, NULL, 2210706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.664475', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (876, 'Simplicio Mendes', 'PI', NULL, NULL, NULL, 2210805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.665361', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (877, 'Socorro do Piaui', 'PI', NULL, NULL, NULL, 2210904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.666288', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (878, 'Sussuapara', 'PI', NULL, NULL, NULL, 2210938, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.667165', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (879, 'Tamboril do Piaui', 'PI', NULL, NULL, NULL, 2210953, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.668103', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (880, 'Tanque do Piaui', 'PI', NULL, NULL, NULL, 2210979, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.669016', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (881, 'Teresina', 'PI', NULL, NULL, NULL, 2211001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.670074', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (882, 'Uniao', 'PI', NULL, NULL, NULL, 2211100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.670865', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (883, 'Urucui', 'PI', NULL, NULL, NULL, 2211209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.671796', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (884, 'Valenca do Piaui', 'PI', NULL, NULL, NULL, 2211308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.67261', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (885, 'Varzea Branca', 'PI', NULL, NULL, NULL, 2211357, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.679609', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (886, 'Varzea Grande', 'PI', NULL, NULL, NULL, 2211407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.680844', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (887, 'Vera Mendes', 'PI', NULL, NULL, NULL, 2211506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.681873', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (888, 'Vila Nova do Piaui', 'PI', NULL, NULL, NULL, 2211605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.68279', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (889, 'Wall Ferraz', 'PI', NULL, NULL, NULL, 2211704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.683613', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (890, 'Abaiara', 'CE', NULL, NULL, NULL, 2300101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.684498', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (891, 'Acarape', 'CE', NULL, NULL, NULL, 2300150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.685459', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (892, 'Acarau', 'CE', NULL, NULL, NULL, 2300200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.686316', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (893, 'Acopiara', 'CE', NULL, NULL, NULL, 2300309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.687319', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (894, 'Aiuaba', 'CE', NULL, NULL, NULL, 2300408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.688458', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (895, 'Alcantaras', 'CE', NULL, NULL, NULL, 2300507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.68946', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (896, 'Altaneira', 'CE', NULL, NULL, NULL, 2300606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.690345', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (897, 'Alto Santo', 'CE', NULL, NULL, NULL, 2300705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.691214', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (898, 'Amontada', 'CE', NULL, NULL, NULL, 2300754, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.692091', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (899, 'Antonina do Norte', 'CE', NULL, NULL, NULL, 2300804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.693258', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (900, 'Apuiares', 'CE', NULL, NULL, NULL, 2300903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.69425', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (901, 'Aquiraz', 'CE', NULL, NULL, NULL, 2301000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.695167', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (902, 'Aracati', 'CE', NULL, NULL, NULL, 2301109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.69614', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (903, 'Aracoiaba', 'CE', NULL, NULL, NULL, 2301208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.69696', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (904, 'Ararenda', 'CE', NULL, NULL, NULL, 2301257, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.697861', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (905, 'Araripe', 'CE', NULL, NULL, NULL, 2301307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.698832', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (906, 'Aratuba', 'CE', NULL, NULL, NULL, 2301406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.69974', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (907, 'Arneiroz', 'CE', NULL, NULL, NULL, 2301505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.700663', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (908, 'Assare', 'CE', NULL, NULL, NULL, 2301604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.701591', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (909, 'Aurora', 'CE', NULL, NULL, NULL, 2301703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.702351', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (910, 'Baixio', 'CE', NULL, NULL, NULL, 2301802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.703411', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (911, 'Banabuiu', 'CE', NULL, NULL, NULL, 2301851, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.704293', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (912, 'Barbalha', 'CE', NULL, NULL, NULL, 2301901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.705191', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (913, 'Barreira', 'CE', NULL, NULL, NULL, 2301950, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.706139', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (914, 'Barro', 'CE', NULL, NULL, NULL, 2302008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.707138', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (915, 'Barroquinha', 'CE', NULL, NULL, NULL, 2302057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.708104', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (916, 'Baturite', 'CE', NULL, NULL, NULL, 2302107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.70905', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (917, 'Beberibe', 'CE', NULL, NULL, NULL, 2302206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.71002', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (918, 'Bela Cruz', 'CE', NULL, NULL, NULL, 2302305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.710898', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (919, 'Boa Viagem', 'CE', NULL, NULL, NULL, 2302404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.711755', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (920, 'Brejo Santo', 'CE', NULL, NULL, NULL, 2302503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.712556', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (921, 'Camocim', 'CE', NULL, NULL, NULL, 2302602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.713478', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (922, 'Campos Sales', 'CE', NULL, NULL, NULL, 2302701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.720078', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (923, 'Caninde', 'CE', NULL, NULL, NULL, 2302800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.721176', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (924, 'Capistrano', 'CE', NULL, NULL, NULL, 2302909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.722137', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (925, 'Caridade', 'CE', NULL, NULL, NULL, 2303006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.723051', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (926, 'Carire', 'CE', NULL, NULL, NULL, 2303105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.724031', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (927, 'Caririacu', 'CE', NULL, NULL, NULL, 2303204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.725002', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (928, 'Carius', 'CE', NULL, NULL, NULL, 2303303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.72603', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (929, 'Carnaubal', 'CE', NULL, NULL, NULL, 2303402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.726882', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (930, 'Cascavel', 'CE', NULL, NULL, NULL, 2303501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.72791', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (931, 'Catarina', 'CE', NULL, NULL, NULL, 2303600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.728846', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (932, 'Catunda', 'CE', NULL, NULL, NULL, 2303659, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.72975', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (933, 'Caucaia', 'CE', NULL, NULL, NULL, 2303709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.73058', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (934, 'Cedro', 'CE', NULL, NULL, NULL, 2303808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.731508', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (935, 'Chaval', 'CE', NULL, NULL, NULL, 2303907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.732465', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (936, 'Choro', 'CE', NULL, NULL, NULL, 2303931, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.733347', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (937, 'Chorozinho', 'CE', NULL, NULL, NULL, 2303956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.734151', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (938, 'Coreau', 'CE', NULL, NULL, NULL, 2304004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.735038', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (939, 'Crateus', 'CE', NULL, NULL, NULL, 2304103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.735982', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (940, 'Crato', 'CE', NULL, NULL, NULL, 2304202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.736982', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (941, 'Croata', 'CE', NULL, NULL, NULL, 2304236, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.73788', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (942, 'Cruz', 'CE', NULL, NULL, NULL, 2304251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.738764', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (943, 'Deputado Irapuan Pinheiro', 'CE', NULL, NULL, NULL, 2304269, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.739701', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (944, 'Erere', 'CE', NULL, NULL, NULL, 2304277, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.740766', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (945, 'Eusebio', 'CE', NULL, NULL, NULL, 2304285, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.741714', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (946, 'Farias Brito', 'CE', NULL, NULL, NULL, 2304301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.742725', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (947, 'Forquilha', 'CE', NULL, NULL, NULL, 2304350, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.743617', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (948, 'Fortaleza', 'CE', NULL, NULL, NULL, 2304400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.744504', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (949, 'Fortim', 'CE', NULL, NULL, NULL, 2304459, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.74536', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (950, 'Frecheirinha', 'CE', NULL, NULL, NULL, 2304509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.7463', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (951, 'General Sampaio', 'CE', NULL, NULL, NULL, 2304608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.747206', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (952, 'Graca', 'CE', NULL, NULL, NULL, 2304657, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.748217', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (953, 'Granja', 'CE', NULL, NULL, NULL, 2304707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.74904', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (954, 'Granjeiro', 'CE', NULL, NULL, NULL, 2304806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.749942', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (955, 'Groairas', 'CE', NULL, NULL, NULL, 2304905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.750947', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (956, 'Guaiuba', 'CE', NULL, NULL, NULL, 2304954, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.751904', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (957, 'Guaraciaba do Norte', 'CE', NULL, NULL, NULL, 2305001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.752745', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (958, 'Guaramiranga', 'CE', NULL, NULL, NULL, 2305100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.753708', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (959, 'Hidrolandia', 'CE', NULL, NULL, NULL, 2305209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.760735', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (960, 'Horizonte', 'CE', NULL, NULL, NULL, 2305233, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.761924', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (961, 'Ibaretama', 'CE', NULL, NULL, NULL, 2305266, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.762867', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (962, 'Ibiapina', 'CE', NULL, NULL, NULL, 2305308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.763788', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (963, 'Ibicuitinga', 'CE', NULL, NULL, NULL, 2305332, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.764672', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (964, 'Icapui', 'CE', NULL, NULL, NULL, 2305357, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.765576', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (965, 'Ico', 'CE', NULL, NULL, NULL, 2305407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.76682', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (966, 'Iguatu', 'CE', NULL, NULL, NULL, 2305506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.767721', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (967, 'Independencia', 'CE', NULL, NULL, NULL, 2305605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.768666', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (968, 'Ipaporanga', 'CE', NULL, NULL, NULL, 2305654, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.769582', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (969, 'Ipaumirim', 'CE', NULL, NULL, NULL, 2305704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.770486', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (970, 'Ipu', 'CE', NULL, NULL, NULL, 2305803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.771489', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (971, 'Ipueiras', 'CE', NULL, NULL, NULL, 2305902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.772507', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (972, 'Iracema', 'CE', NULL, NULL, NULL, 2306009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.773512', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (973, 'Iraucuba', 'CE', NULL, NULL, NULL, 2306108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.774468', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (974, 'Itaicaba', 'CE', NULL, NULL, NULL, 2306207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.77543', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (975, 'Itaitinga', 'CE', NULL, NULL, NULL, 2306256, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.77631', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (977, 'Itapipoca', 'CE', NULL, NULL, NULL, 2306405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.778328', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (978, 'Itapiuna', 'CE', NULL, NULL, NULL, 2306504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.779217', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (979, 'Itarema', 'CE', NULL, NULL, NULL, 2306553, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.780134', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (980, 'Itatira', 'CE', NULL, NULL, NULL, 2306603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.781004', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (981, 'Jaguaretama', 'CE', NULL, NULL, NULL, 2306702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.781931', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (982, 'Jaguaribara', 'CE', NULL, NULL, NULL, 2306801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.782755', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (983, 'Jaguaribe', 'CE', NULL, NULL, NULL, 2306900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.783553', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (984, 'Jaguaruana', 'CE', NULL, NULL, NULL, 2307007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.784418', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (985, 'Jardim', 'CE', NULL, NULL, NULL, 2307106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.785258', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (986, 'Jati', 'CE', NULL, NULL, NULL, 2307205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.786168', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (987, 'Jijoca de Jericoacoara', 'CE', NULL, NULL, NULL, 2307254, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.787039', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (988, 'Juazeiro do Norte', 'CE', NULL, NULL, NULL, 2307304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.787963', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (989, 'Jucas', 'CE', NULL, NULL, NULL, 2307403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.788883', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (990, 'Lavras da Mangabeira', 'CE', NULL, NULL, NULL, 2307502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.789684', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (991, 'Limoeiro do Norte', 'CE', NULL, NULL, NULL, 2307601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.790614', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (992, 'Madalena', 'CE', NULL, NULL, NULL, 2307635, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.791485', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (993, 'Maracanau', 'CE', NULL, NULL, NULL, 2307650, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.79239', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (994, 'Maranguape', 'CE', NULL, NULL, NULL, 2307700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.793456', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (995, 'Marco', 'CE', NULL, NULL, NULL, 2307809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.794381', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (996, 'Martinopole', 'CE', NULL, NULL, NULL, 2307908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.801277', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (997, 'Massape', 'CE', NULL, NULL, NULL, 2308005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.802543', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (998, 'Mauriti', 'CE', NULL, NULL, NULL, 2308104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.805558', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (999, 'Meruoca', 'CE', NULL, NULL, NULL, 2308203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.806559', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1000, 'Milagres', 'CE', NULL, NULL, NULL, 2308302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.80731', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1001, 'Milha', 'CE', NULL, NULL, NULL, 2308351, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.808353', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1002, 'Miraima', 'CE', NULL, NULL, NULL, 2308377, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.809236', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1003, 'Missao Velha', 'CE', NULL, NULL, NULL, 2308401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.810299', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1004, 'Mombaca', 'CE', NULL, NULL, NULL, 2308500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.811154', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1005, 'Monsenhor Tabosa', 'CE', NULL, NULL, NULL, 2308609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.81203', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1006, 'Morada Nova', 'CE', NULL, NULL, NULL, 2308708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.812903', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1007, 'Moraujo', 'CE', NULL, NULL, NULL, 2308807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.81377', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1008, 'Morrinhos', 'CE', NULL, NULL, NULL, 2308906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.814722', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1009, 'Mucambo', 'CE', NULL, NULL, NULL, 2309003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.815781', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1010, 'Mulungu', 'CE', NULL, NULL, NULL, 2309102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.816724', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1011, 'Nova Olinda', 'CE', NULL, NULL, NULL, 2309201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.817636', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1012, 'Nova Russas', 'CE', NULL, NULL, NULL, 2309300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.81856', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1013, 'Novo Oriente', 'CE', NULL, NULL, NULL, 2309409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.819509', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1014, 'Ocara', 'CE', NULL, NULL, NULL, 2309458, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.820449', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1015, 'Oros', 'CE', NULL, NULL, NULL, 2309508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.821307', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1016, 'Pacajus', 'CE', NULL, NULL, NULL, 2309607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.822177', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1017, 'Pacatuba', 'CE', NULL, NULL, NULL, 2309706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.823119', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1018, 'Pacoti', 'CE', NULL, NULL, NULL, 2309805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.823944', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1019, 'Pacuja', 'CE', NULL, NULL, NULL, 2309904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.824879', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1020, 'Palhano', 'CE', NULL, NULL, NULL, 2310001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.825848', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1021, 'Palmacia', 'CE', NULL, NULL, NULL, 2310100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.826961', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1022, 'Paracuru', 'CE', NULL, NULL, NULL, 2310209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.827911', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1023, 'Paraipaba', 'CE', NULL, NULL, NULL, 2310258, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.828797', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1024, 'Parambu', 'CE', NULL, NULL, NULL, 2310308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.829733', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1025, 'Paramoti', 'CE', NULL, NULL, NULL, 2310407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.830639', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1026, 'Pedra Branca', 'CE', NULL, NULL, NULL, 2310506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.831545', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1027, 'Penaforte', 'CE', NULL, NULL, NULL, 2310605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.832489', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1028, 'Pentecoste', 'CE', NULL, NULL, NULL, 2310704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.83333', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1029, 'Pereiro', 'CE', NULL, NULL, NULL, 2310803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.834139', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1030, 'Pindoretama', 'CE', NULL, NULL, NULL, 2310852, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.835062', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1031, 'Piquet Carneiro', 'CE', NULL, NULL, NULL, 2310902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.842709', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1032, 'Pires Ferreira', 'CE', NULL, NULL, NULL, 2310951, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.843807', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1033, 'Poranga', 'CE', NULL, NULL, NULL, 2311009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.844903', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1034, 'Porteiras', 'CE', NULL, NULL, NULL, 2311108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.846084', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1035, 'Potengi', 'CE', NULL, NULL, NULL, 2311207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.847051', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1036, 'Potiretama', 'CE', NULL, NULL, NULL, 2311231, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.848016', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1037, 'Quiterianopolis', 'CE', NULL, NULL, NULL, 2311264, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.849214', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1038, 'Quixada', 'CE', NULL, NULL, NULL, 2311306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.850112', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1039, 'Quixelo', 'CE', NULL, NULL, NULL, 2311355, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.851035', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1040, 'Quixeramobim', 'CE', NULL, NULL, NULL, 2311405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.851966', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1041, 'Quixere', 'CE', NULL, NULL, NULL, 2311504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.852901', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1042, 'Redencao', 'CE', NULL, NULL, NULL, 2311603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.853907', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1043, 'Reriutaba', 'CE', NULL, NULL, NULL, 2311702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.855028', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1044, 'Russas', 'CE', NULL, NULL, NULL, 2311801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.85597', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1045, 'Saboeiro', 'CE', NULL, NULL, NULL, 2311900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.856853', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1046, 'Salitre', 'CE', NULL, NULL, NULL, 2311959, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.857981', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1048, 'Santana do Acarau', 'CE', NULL, NULL, NULL, 2312007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.85981', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1049, 'Santana do Cariri', 'CE', NULL, NULL, NULL, 2312106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.860708', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1047, 'Santa Quiteria', 'CE', NULL, NULL, NULL, 2312205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.858908', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1050, 'Sao Benedito', 'CE', NULL, NULL, NULL, 2312304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.861601', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1051, 'Sao Goncalo do Amarante', 'CE', NULL, NULL, NULL, 2312403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.862529', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1052, 'Sao Joao do Jaguaribe', 'CE', NULL, NULL, NULL, 2312502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.863447', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1053, 'Sao Luis do Curu', 'CE', NULL, NULL, NULL, 2312601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.864358', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1054, 'Senador Pompeu', 'CE', NULL, NULL, NULL, 2312700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.865343', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1055, 'Senador Sa', 'CE', NULL, NULL, NULL, 2312809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.866271', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1056, 'Sobral', 'CE', NULL, NULL, NULL, 2312908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.86725', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1057, 'Solonopole', 'CE', NULL, NULL, NULL, 2313005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.868244', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1058, 'Tabuleiro do Norte', 'CE', NULL, NULL, NULL, 2313104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.869195', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1059, 'Tamboril', 'CE', NULL, NULL, NULL, 2313203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.87011', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1060, 'Tarrafas', 'CE', NULL, NULL, NULL, 2313252, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.871112', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1061, 'Taua', 'CE', NULL, NULL, NULL, 2313302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.872086', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1062, 'Tejucuoca', 'CE', NULL, NULL, NULL, 2313351, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.873195', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1063, 'Tiangua', 'CE', NULL, NULL, NULL, 2313401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.874116', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1064, 'Trairi', 'CE', NULL, NULL, NULL, 2313500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.875052', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1065, 'Tururu', 'CE', NULL, NULL, NULL, 2313559, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.875935', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1066, 'Ubajara', 'CE', NULL, NULL, NULL, 2313609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.883523', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1067, 'Umari', 'CE', NULL, NULL, NULL, 2313708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.884695', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1068, 'Umirim', 'CE', NULL, NULL, NULL, 2313757, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.885677', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1069, 'Uruburetama', 'CE', NULL, NULL, NULL, 2313807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.886516', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1070, 'Uruoca', 'CE', NULL, NULL, NULL, 2313906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.887569', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1071, 'Varjota', 'CE', NULL, NULL, NULL, 2313955, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.88856', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1072, 'Varzea Alegre', 'CE', NULL, NULL, NULL, 2314003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.889456', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1073, 'Vicosa do Ceara', 'CE', NULL, NULL, NULL, 2314102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.890355', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1074, 'Acari', 'RN', NULL, NULL, NULL, 2400109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.891402', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1075, 'Acu', 'RN', NULL, NULL, NULL, 2400208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.892249', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1076, 'Afonso Bezerra', 'RN', NULL, NULL, NULL, 2400307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.893143', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1077, 'Agua Nova', 'RN', NULL, NULL, NULL, 2400406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.894078', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1078, 'Alexandria', 'RN', NULL, NULL, NULL, 2400505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.895039', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1079, 'Almino Afonso', 'RN', NULL, NULL, NULL, 2400604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.895926', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1080, 'Alto do Rodrigues', 'RN', NULL, NULL, NULL, 2400703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.896798', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1081, 'Angicos', 'RN', NULL, NULL, NULL, 2400802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.897649', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1082, 'Antonio Martins', 'RN', NULL, NULL, NULL, 2400901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.898468', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1083, 'Apodi', 'RN', NULL, NULL, NULL, 2401008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.899511', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1084, 'Areia Branca', 'RN', NULL, NULL, NULL, 2401107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.900457', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1085, 'Ares', 'RN', NULL, NULL, NULL, 2401206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.901317', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1086, 'Augusto Severo', 'RN', NULL, NULL, NULL, 2401305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.902303', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1087, 'Baia Formosa', 'RN', NULL, NULL, NULL, 2401404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.903218', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1088, 'Barauna', 'RN', NULL, NULL, NULL, 2401453, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.904292', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1089, 'Barcelona', 'RN', NULL, NULL, NULL, 2401503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.905211', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1090, 'Bento Fernandes', 'RN', NULL, NULL, NULL, 2401602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.906199', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1091, 'Bodo', 'RN', NULL, NULL, NULL, 2401651, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.907136', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1092, 'Bom Jesus', 'RN', NULL, NULL, NULL, 2401701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.908193', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1093, 'Brejinho', 'RN', NULL, NULL, NULL, 2401800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.909163', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1094, 'Caicara do Norte', 'RN', NULL, NULL, NULL, 2401859, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.910096', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1095, 'Caicara do Rio do Vento', 'RN', NULL, NULL, NULL, 2401909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.911027', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1096, 'Caico', 'RN', NULL, NULL, NULL, 2402006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.911823', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1097, 'Campo Redondo', 'RN', NULL, NULL, NULL, 2402105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.912823', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1098, 'Canguaretama', 'RN', NULL, NULL, NULL, 2402204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.913613', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1099, 'Caraubas', 'RN', NULL, NULL, NULL, 2402303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.914478', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1100, 'Carnauba dos Dantas', 'RN', NULL, NULL, NULL, 2402402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.915516', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1101, 'Carnaubais', 'RN', NULL, NULL, NULL, 2402501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.916333', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1102, 'Ceara-mirim', 'RN', NULL, NULL, NULL, 2402600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.917214', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1103, 'Cerro Cora', 'RN', NULL, NULL, NULL, 2402709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.924082', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1104, 'Coronel Ezequiel', 'RN', NULL, NULL, NULL, 2402808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.925293', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1105, 'Coronel Joao Pessoa', 'RN', NULL, NULL, NULL, 2402907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.926424', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1106, 'Cruzeta', 'RN', NULL, NULL, NULL, 2403004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.927437', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1107, 'Currais Novos', 'RN', NULL, NULL, NULL, 2403103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.928357', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1108, 'Doutor Severiano', 'RN', NULL, NULL, NULL, 2403202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.92922', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1170, 'Parnamirim', 'RN', NULL, NULL, NULL, 2403251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.992169', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1109, 'Encanto', 'RN', NULL, NULL, NULL, 2403301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.930124', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1110, 'Equador', 'RN', NULL, NULL, NULL, 2403400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.930949', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1111, 'Espirito Santo', 'RN', NULL, NULL, NULL, 2403509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.93187', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1112, 'Extremoz', 'RN', NULL, NULL, NULL, 2403608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.93282', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1113, 'Felipe Guerra', 'RN', NULL, NULL, NULL, 2403707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.933753', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1114, 'Fernando Pedroza', 'RN', NULL, NULL, NULL, 2403756, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.934712', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1115, 'Florania', 'RN', NULL, NULL, NULL, 2403806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.935678', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1116, 'Francisco Dantas', 'RN', NULL, NULL, NULL, 2403905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.936647', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1117, 'Frutuoso Gomes', 'RN', NULL, NULL, NULL, 2404002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.93762', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1118, 'Galinhos', 'RN', NULL, NULL, NULL, 2404101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.938502', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1119, 'Goianinha', 'RN', NULL, NULL, NULL, 2404200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.939453', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1120, 'Governador Dix-sept Rosado', 'RN', NULL, NULL, NULL, 2404309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.940328', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1121, 'Grossos', 'RN', NULL, NULL, NULL, 2404408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.941151', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1122, 'Guamare', 'RN', NULL, NULL, NULL, 2404507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.942246', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1123, 'Ielmo Marinho', 'RN', NULL, NULL, NULL, 2404606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.943257', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1124, 'Ipanguacu', 'RN', NULL, NULL, NULL, 2404705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.944128', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1125, 'Ipueira', 'RN', NULL, NULL, NULL, 2404804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.945019', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1126, 'Itaja', 'RN', NULL, NULL, NULL, 2404853, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.946076', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1127, 'Itau', 'RN', NULL, NULL, NULL, 2404903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.946989', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1128, 'Jacana', 'RN', NULL, NULL, NULL, 2405009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.947875', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1129, 'Jandaira', 'RN', NULL, NULL, NULL, 2405108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.948829', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1130, 'Janduis', 'RN', NULL, NULL, NULL, 2405207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.949781', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1131, 'Januario Cicco', 'RN', NULL, NULL, NULL, 2405306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.950601', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1132, 'Japi', 'RN', NULL, NULL, NULL, 2405405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.951564', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1133, 'Jardim de Angicos', 'RN', NULL, NULL, NULL, 2405504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.952483', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1134, 'Jardim de Piranhas', 'RN', NULL, NULL, NULL, 2405603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.953409', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1135, 'Jardim do Serido', 'RN', NULL, NULL, NULL, 2405702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.954238', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1136, 'Joao Camara', 'RN', NULL, NULL, NULL, 2405801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.955149', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1137, 'Joao Dias', 'RN', NULL, NULL, NULL, 2405900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.956075', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1138, 'Jose da Penha', 'RN', NULL, NULL, NULL, 2406007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.957006', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1139, 'Jucurutu', 'RN', NULL, NULL, NULL, 2406106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.957905', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1140, 'Jundia', 'RN', NULL, NULL, NULL, 2406155, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.958828', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1141, 'Lagoa D''anta', 'RN', NULL, NULL, NULL, 2406205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.965134', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1142, 'Lagoa de Pedras', 'RN', NULL, NULL, NULL, 2406304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.966233', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1143, 'Lagoa de Velhos', 'RN', NULL, NULL, NULL, 2406403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.967108', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1144, 'Lagoa Nova', 'RN', NULL, NULL, NULL, 2406502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.96806', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1145, 'Lagoa Salgada', 'RN', NULL, NULL, NULL, 2406601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.968966', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1146, 'Lajes', 'RN', NULL, NULL, NULL, 2406700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.96988', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1147, 'Lajes Pintadas', 'RN', NULL, NULL, NULL, 2406809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.970916', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1148, 'Lucrecia', 'RN', NULL, NULL, NULL, 2406908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.971944', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1149, 'Luis Gomes', 'RN', NULL, NULL, NULL, 2407005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.973018', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1150, 'Macaiba', 'RN', NULL, NULL, NULL, 2407104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.973955', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1151, 'Macau', 'RN', NULL, NULL, NULL, 2407203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.974833', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1152, 'Major Sales', 'RN', NULL, NULL, NULL, 2407252, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.975688', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1153, 'Marcelino Vieira', 'RN', NULL, NULL, NULL, 2407302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.976567', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1154, 'Martins', 'RN', NULL, NULL, NULL, 2407401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.977442', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1155, 'Maxaranguape', 'RN', NULL, NULL, NULL, 2407500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.978517', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1156, 'Messias Targino', 'RN', NULL, NULL, NULL, 2407609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.979498', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1157, 'Montanhas', 'RN', NULL, NULL, NULL, 2407708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.980416', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1158, 'Monte Alegre', 'RN', NULL, NULL, NULL, 2407807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.981295', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1159, 'Monte das Gameleiras', 'RN', NULL, NULL, NULL, 2407906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.982178', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1160, 'Mossoro', 'RN', NULL, NULL, NULL, 2408003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.983168', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1161, 'Natal', 'RN', NULL, NULL, NULL, 2408102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.98404', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1162, 'Nisia Floresta', 'RN', NULL, NULL, NULL, 2408201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.984957', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1163, 'Nova Cruz', 'RN', NULL, NULL, NULL, 2408300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.98583', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1164, 'Olho-d''agua do Borges', 'RN', NULL, NULL, NULL, 2408409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.986796', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1165, 'Ouro Branco', 'RN', NULL, NULL, NULL, 2408508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.987717', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1166, 'Parana', 'RN', NULL, NULL, NULL, 2408607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.988598', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1167, 'Parau', 'RN', NULL, NULL, NULL, 2408706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.989498', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1168, 'Parazinho', 'RN', NULL, NULL, NULL, 2408805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.990437', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1169, 'Parelhas', 'RN', NULL, NULL, NULL, 2408904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.99129', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1191, 'Rio do Fogo', 'RN', NULL, NULL, NULL, 2408953, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.017658', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1171, 'Passa e Fica', 'RN', NULL, NULL, NULL, 2409100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.99297', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1172, 'Passagem', 'RN', NULL, NULL, NULL, 2409209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.994099', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1173, 'Patu', 'RN', NULL, NULL, NULL, 2409308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.994899', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1195, 'Santa Maria', 'RN', NULL, NULL, NULL, 2409332, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.021445', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1174, 'Pau dos Ferros', 'RN', NULL, NULL, NULL, 2409407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.995778', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1175, 'Pedra Grande', 'RN', NULL, NULL, NULL, 2409506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.996685', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1176, 'Pedra Preta', 'RN', NULL, NULL, NULL, 2409605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.997564', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1177, 'Pedro Avelino', 'RN', NULL, NULL, NULL, 2409704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.998571', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1178, 'Pedro Velho', 'RN', NULL, NULL, NULL, 2409803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.005427', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1179, 'Pendencias', 'RN', NULL, NULL, NULL, 2409902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.00655', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1180, 'Piloes', 'RN', NULL, NULL, NULL, 2410009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.007471', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1181, 'Poco Branco', 'RN', NULL, NULL, NULL, 2410108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.00834', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1182, 'Portalegre', 'RN', NULL, NULL, NULL, 2410207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.009265', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1183, 'Porto do Mangue', 'RN', NULL, NULL, NULL, 2410256, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.010181', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1185, 'Pureza', 'RN', NULL, NULL, NULL, 2410405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.012', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1186, 'Rafael Fernandes', 'RN', NULL, NULL, NULL, 2410504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.012814', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1187, 'Rafael Godeiro', 'RN', NULL, NULL, NULL, 2410603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.013633', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1188, 'Riacho da Cruz', 'RN', NULL, NULL, NULL, 2410702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.014532', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1189, 'Riacho de Santana', 'RN', NULL, NULL, NULL, 2410801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.015533', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1190, 'Riachuelo', 'RN', NULL, NULL, NULL, 2410900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.016688', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1192, 'Rodolfo Fernandes', 'RN', NULL, NULL, NULL, 2411007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.018555', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1229, 'Tibau', 'RN', NULL, NULL, NULL, 2411056, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.059823', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1193, 'Ruy Barbosa', 'RN', NULL, NULL, NULL, 2411106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.019556', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1194, 'Santa Cruz', 'RN', NULL, NULL, NULL, 2411205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.020402', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1196, 'Santana do Matos', 'RN', NULL, NULL, NULL, 2411403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.022177', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1197, 'Santana do Serido', 'RN', NULL, NULL, NULL, 2411429, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.023022', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1198, 'Santo Antonio', 'RN', NULL, NULL, NULL, 2411502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.023864', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1199, 'Sao Bento do Norte', 'RN', NULL, NULL, NULL, 2411601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.024666', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1200, 'Sao Bento do Trairi', 'RN', NULL, NULL, NULL, 2411700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.025598', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1201, 'Sao Fernando', 'RN', NULL, NULL, NULL, 2411809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.026479', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1202, 'Sao Francisco do Oeste', 'RN', NULL, NULL, NULL, 2411908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.027777', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1203, 'Sao Goncalo do Amarante', 'RN', NULL, NULL, NULL, 2412005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.028644', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1204, 'Sao Joao do Sabugi', 'RN', NULL, NULL, NULL, 2412104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.029513', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1205, 'Sao Jose de Mipibu', 'RN', NULL, NULL, NULL, 2412203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.03041', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1206, 'Sao Jose do Campestre', 'RN', NULL, NULL, NULL, 2412302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.031271', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1207, 'Sao Jose do Serido', 'RN', NULL, NULL, NULL, 2412401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.032197', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1208, 'Sao Miguel', 'RN', NULL, NULL, NULL, 2412500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.03317', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1209, 'Sao Miguel do Gostoso', 'RN', NULL, NULL, NULL, 2412559, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.034112', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1210, 'Sao Paulo do Potengi', 'RN', NULL, NULL, NULL, 2412609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.035023', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1211, 'Sao Pedro', 'RN', NULL, NULL, NULL, 2412708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.035951', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1212, 'Sao Rafael', 'RN', NULL, NULL, NULL, 2412807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.03703', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1213, 'Sao Tome', 'RN', NULL, NULL, NULL, 2412906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.037977', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1214, 'Sao Vicente', 'RN', NULL, NULL, NULL, 2413003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.039135', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1215, 'Senador Eloi de Souza', 'RN', NULL, NULL, NULL, 2413102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.045963', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1216, 'Senador Georgino Avelino', 'RN', NULL, NULL, NULL, 2413201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.047205', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1217, 'Serra de Sao Bento', 'RN', NULL, NULL, NULL, 2413300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.048251', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1218, 'Serra do Mel', 'RN', NULL, NULL, NULL, 2413359, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.049257', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1219, 'Serra Negra do Norte', 'RN', NULL, NULL, NULL, 2413409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.050121', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1220, 'Serrinha', 'RN', NULL, NULL, NULL, 2413508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.051006', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1221, 'Serrinha dos Pintos', 'RN', NULL, NULL, NULL, 2413557, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.052384', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1222, 'Severiano Melo', 'RN', NULL, NULL, NULL, 2413607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.053323', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1223, 'Sitio Novo', 'RN', NULL, NULL, NULL, 2413706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.05422', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1224, 'Taboleiro Grande', 'RN', NULL, NULL, NULL, 2413805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.055116', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1225, 'Taipu', 'RN', NULL, NULL, NULL, 2413904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.055992', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1226, 'Tangara', 'RN', NULL, NULL, NULL, 2414001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.056821', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1227, 'Tenente Ananias', 'RN', NULL, NULL, NULL, 2414100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.057772', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1228, 'Tenente Laurentino Cruz', 'RN', NULL, NULL, NULL, 2414159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.058756', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1230, 'Tibau do Sul', 'RN', NULL, NULL, NULL, 2414209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.061144', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1231, 'Timbauba dos Batistas', 'RN', NULL, NULL, NULL, 2414308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.062201', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1232, 'Touros', 'RN', NULL, NULL, NULL, 2414407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.063184', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1233, 'Triunfo Potiguar', 'RN', NULL, NULL, NULL, 2414456, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.064106', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1234, 'Umarizal', 'RN', NULL, NULL, NULL, 2414506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.065006', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1235, 'Upanema', 'RN', NULL, NULL, NULL, 2414605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.065955', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1236, 'Varzea', 'RN', NULL, NULL, NULL, 2414704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.066769', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1237, 'Venha-ver', 'RN', NULL, NULL, NULL, 2414753, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.067688', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1238, 'Vera Cruz', 'RN', NULL, NULL, NULL, 2414803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.068614', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1239, 'Vicosa', 'RN', NULL, NULL, NULL, 2414902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.069524', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1240, 'Vila Flor', 'RN', NULL, NULL, NULL, 2415008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.070393', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1241, 'Agua Branca', 'PB', NULL, NULL, NULL, 2500106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.071439', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1242, 'Aguiar', 'PB', NULL, NULL, NULL, 2500205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.072434', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1243, 'Alagoa Grande', 'PB', NULL, NULL, NULL, 2500304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.073282', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1244, 'Alagoa Nova', 'PB', NULL, NULL, NULL, 2500403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.074227', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1245, 'Alagoinha', 'PB', NULL, NULL, NULL, 2500502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.075158', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1246, 'Alcantil', 'PB', NULL, NULL, NULL, 2500536, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.076009', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1247, 'Algodao de Jandaira', 'PB', NULL, NULL, NULL, 2500577, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.076841', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1248, 'Alhandra', 'PB', NULL, NULL, NULL, 2500601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.07777', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1423, 'Sao Joao do Rio do Peixe', 'PB', NULL, NULL, NULL, 2500700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.271743', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1249, 'Amparo', 'PB', NULL, NULL, NULL, 2500734, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.078587', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1250, 'Aparecida', 'PB', NULL, NULL, NULL, 2500775, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.079657', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1251, 'Aracagi', 'PB', NULL, NULL, NULL, 2500809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.086461', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1252, 'Arara', 'PB', NULL, NULL, NULL, 2500908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.087625', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1253, 'Araruna', 'PB', NULL, NULL, NULL, 2501005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.088977', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1254, 'Areia', 'PB', NULL, NULL, NULL, 2501104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.089891', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1255, 'Areia de Baraunas', 'PB', NULL, NULL, NULL, 2501153, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.090763', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1256, 'Areial', 'PB', NULL, NULL, NULL, 2501203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.09166', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1257, 'Aroeiras', 'PB', NULL, NULL, NULL, 2501302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.092651', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1258, 'Assuncao', 'PB', NULL, NULL, NULL, 2501351, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.093528', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1259, 'Baia da Traicao', 'PB', NULL, NULL, NULL, 2501401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.094762', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1260, 'Bananeiras', 'PB', NULL, NULL, NULL, 2501500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.0956', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1261, 'Barauna', 'PB', NULL, NULL, NULL, 2501534, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.096454', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1263, 'Barra de Santana', 'PB', NULL, NULL, NULL, 2501575, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.098328', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1262, 'Barra de Santa Rosa', 'PB', NULL, NULL, NULL, 2501609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.097433', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1264, 'Barra de Sao Miguel', 'PB', NULL, NULL, NULL, 2501708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.099207', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1265, 'Bayeux', 'PB', NULL, NULL, NULL, 2501807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.100233', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1266, 'Belem', 'PB', NULL, NULL, NULL, 2501906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.101175', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1267, 'Belem do Brejo do Cruz', 'PB', NULL, NULL, NULL, 2502003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.102014', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1268, 'Bernardino Batista', 'PB', NULL, NULL, NULL, 2502052, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.102935', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1269, 'Boa Ventura', 'PB', NULL, NULL, NULL, 2502102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.10377', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1270, 'Boa Vista', 'PB', NULL, NULL, NULL, 2502151, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.104778', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1271, 'Bom Jesus', 'PB', NULL, NULL, NULL, 2502201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.105776', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1272, 'Bom Sucesso', 'PB', NULL, NULL, NULL, 2502300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.106763', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1273, 'Bonito de Santa Fe', 'PB', NULL, NULL, NULL, 2502409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.107652', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1274, 'Boqueirao', 'PB', NULL, NULL, NULL, 2502508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.108561', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1326, 'Igaracy', 'PB', NULL, NULL, NULL, 2502607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.169184', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1275, 'Borborema', 'PB', NULL, NULL, NULL, 2502706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.109233', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1276, 'Brejo do Cruz', 'PB', NULL, NULL, NULL, 2502805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.110176', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1277, 'Brejo dos Santos', 'PB', NULL, NULL, NULL, 2502904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.111091', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1278, 'Caapora', 'PB', NULL, NULL, NULL, 2503001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.112052', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1279, 'Cabaceiras', 'PB', NULL, NULL, NULL, 2503100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.112919', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1280, 'Cabedelo', 'PB', NULL, NULL, NULL, 2503209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.113819', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1281, 'Cachoeira dos Indios', 'PB', NULL, NULL, NULL, 2503308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.114792', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1282, 'Cacimba de Areia', 'PB', NULL, NULL, NULL, 2503407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.115622', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1283, 'Cacimba de Dentro', 'PB', NULL, NULL, NULL, 2503506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.116562', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1284, 'Cacimbas', 'PB', NULL, NULL, NULL, 2503555, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.117359', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1285, 'Caicara', 'PB', NULL, NULL, NULL, 2503605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.118234', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1286, 'Cajazeiras', 'PB', NULL, NULL, NULL, 2503704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.119142', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1287, 'Cajazeirinhas', 'PB', NULL, NULL, NULL, 2503753, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.120118', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1288, 'Caldas Brandao', 'PB', NULL, NULL, NULL, 2503803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.126902', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1289, 'Camalau', 'PB', NULL, NULL, NULL, 2503902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.128216', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1290, 'Campina Grande', 'PB', NULL, NULL, NULL, 2504009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.129109', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1292, 'Capim', 'PB', NULL, NULL, NULL, 2504033, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.130913', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1293, 'Caraubas', 'PB', NULL, NULL, NULL, 2504074, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.131989', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1294, 'Carrapateira', 'PB', NULL, NULL, NULL, 2504108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.132966', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1295, 'Casserengue', 'PB', NULL, NULL, NULL, 2504157, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.133895', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1296, 'Catingueira', 'PB', NULL, NULL, NULL, 2504207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.134819', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1297, 'Catole do Rocha', 'PB', NULL, NULL, NULL, 2504306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.135839', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1298, 'Caturite', 'PB', NULL, NULL, NULL, 2504355, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.136857', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1299, 'Conceicao', 'PB', NULL, NULL, NULL, 2504405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.137768', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1300, 'Condado', 'PB', NULL, NULL, NULL, 2504504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.138687', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1301, 'Conde', 'PB', NULL, NULL, NULL, 2504603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.139541', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1302, 'Congo', 'PB', NULL, NULL, NULL, 2504702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.140593', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1303, 'Coremas', 'PB', NULL, NULL, NULL, 2504801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.141567', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1304, 'Coxixola', 'PB', NULL, NULL, NULL, 2504850, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.142408', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1305, 'Cruz do Espirito Santo', 'PB', NULL, NULL, NULL, 2504900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.143316', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1306, 'Cubati', 'PB', NULL, NULL, NULL, 2505006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.144275', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1307, 'Cuite', 'PB', NULL, NULL, NULL, 2505105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.145159', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1309, 'Cuitegi', 'PB', NULL, NULL, NULL, 2505204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.146933', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1308, 'Cuite de Mamanguape', 'PB', NULL, NULL, NULL, 2505238, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.146038', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1310, 'Curral de Cima', 'PB', NULL, NULL, NULL, 2505279, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.147807', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1311, 'Curral Velho', 'PB', NULL, NULL, NULL, 2505303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.14869', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1312, 'Damiao', 'PB', NULL, NULL, NULL, 2505352, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.149547', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1313, 'Desterro', 'PB', NULL, NULL, NULL, 2505402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.150441', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1462, 'Vista Serrana', 'PB', NULL, NULL, NULL, 2505501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.312486', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1314, 'Diamante', 'PB', NULL, NULL, NULL, 2505600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.151433', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1315, 'Dona Ines', 'PB', NULL, NULL, NULL, 2505709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.152276', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1316, 'Duas Estradas', 'PB', NULL, NULL, NULL, 2505808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.153226', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1317, 'Emas', 'PB', NULL, NULL, NULL, 2505907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.154106', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1318, 'Esperanca', 'PB', NULL, NULL, NULL, 2506004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.154937', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1319, 'Fagundes', 'PB', NULL, NULL, NULL, 2506103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.15573', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1320, 'Frei Martinho', 'PB', NULL, NULL, NULL, 2506202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.156702', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1321, 'Gado Bravo', 'PB', NULL, NULL, NULL, 2506251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.157619', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1322, 'Guarabira', 'PB', NULL, NULL, NULL, 2506301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.158561', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1323, 'Gurinhem', 'PB', NULL, NULL, NULL, 2506400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.159521', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1324, 'Gurjao', 'PB', NULL, NULL, NULL, 2506509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.160604', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1325, 'Ibiara', 'PB', NULL, NULL, NULL, 2506608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.168082', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1327, 'Imaculada', 'PB', NULL, NULL, NULL, 2506707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.170197', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1328, 'Inga', 'PB', NULL, NULL, NULL, 2506806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.171029', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1329, 'Itabaiana', 'PB', NULL, NULL, NULL, 2506905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.172174', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1330, 'Itaporanga', 'PB', NULL, NULL, NULL, 2507002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.173123', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1331, 'Itapororoca', 'PB', NULL, NULL, NULL, 2507101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.174094', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1332, 'Itatuba', 'PB', NULL, NULL, NULL, 2507200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.174905', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1333, 'Jacarau', 'PB', NULL, NULL, NULL, 2507309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.175971', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1334, 'Jerico', 'PB', NULL, NULL, NULL, 2507408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.176834', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1335, 'Joao Pessoa', 'PB', NULL, NULL, NULL, 2507507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.177745', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1336, 'Juarez Tavora', 'PB', NULL, NULL, NULL, 2507606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.178614', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1337, 'Juazeirinho', 'PB', NULL, NULL, NULL, 2507705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.179447', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1338, 'Junco do Serido', 'PB', NULL, NULL, NULL, 2507804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.180365', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1339, 'Juripiranga', 'PB', NULL, NULL, NULL, 2507903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.181348', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1340, 'Juru', 'PB', NULL, NULL, NULL, 2508000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.182217', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1341, 'Lagoa', 'PB', NULL, NULL, NULL, 2508109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.183149', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1342, 'Lagoa de Dentro', 'PB', NULL, NULL, NULL, 2508208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.184115', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1343, 'Lagoa Seca', 'PB', NULL, NULL, NULL, 2508307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.185256', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1344, 'Lastro', 'PB', NULL, NULL, NULL, 2508406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.186203', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1345, 'Livramento', 'PB', NULL, NULL, NULL, 2508505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.187139', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1346, 'Logradouro', 'PB', NULL, NULL, NULL, 2508554, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.18807', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1347, 'Lucena', 'PB', NULL, NULL, NULL, 2508604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.188966', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1348, 'Mae D''agua', 'PB', NULL, NULL, NULL, 2508703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.189872', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1349, 'Malta', 'PB', NULL, NULL, NULL, 2508802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.190783', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1350, 'Mamanguape', 'PB', NULL, NULL, NULL, 2508901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.191714', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1351, 'Manaira', 'PB', NULL, NULL, NULL, 2509008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.192634', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1352, 'Marcacao', 'PB', NULL, NULL, NULL, 2509057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.193573', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1353, 'Mari', 'PB', NULL, NULL, NULL, 2509107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.194537', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1354, 'Marizopolis', 'PB', NULL, NULL, NULL, 2509156, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.195373', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1355, 'Massaranduba', 'PB', NULL, NULL, NULL, 2509206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.196294', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1356, 'Mataraca', 'PB', NULL, NULL, NULL, 2509305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.197125', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1357, 'Matinhas', 'PB', NULL, NULL, NULL, 2509339, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.198047', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1358, 'Mato Grosso', 'PB', NULL, NULL, NULL, 2509370, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.198975', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1359, 'Matureia', 'PB', NULL, NULL, NULL, 2509396, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.199965', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1360, 'Mogeiro', 'PB', NULL, NULL, NULL, 2509404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.200795', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1361, 'Montadas', 'PB', NULL, NULL, NULL, 2509503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.201784', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1362, 'Monte Horebe', 'PB', NULL, NULL, NULL, 2509602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.209441', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1363, 'Monteiro', 'PB', NULL, NULL, NULL, 2509701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.210611', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1364, 'Mulungu', 'PB', NULL, NULL, NULL, 2509800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.21166', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1365, 'Natuba', 'PB', NULL, NULL, NULL, 2509909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.212408', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1366, 'Nazarezinho', 'PB', NULL, NULL, NULL, 2510006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.213326', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1367, 'Nova Floresta', 'PB', NULL, NULL, NULL, 2510105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.214238', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1368, 'Nova Olinda', 'PB', NULL, NULL, NULL, 2510204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.215124', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1369, 'Nova Palmeira', 'PB', NULL, NULL, NULL, 2510303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.215985', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1370, 'Olho D''agua', 'PB', NULL, NULL, NULL, 2510402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.216966', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1371, 'Olivedos', 'PB', NULL, NULL, NULL, 2510501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.217879', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1372, 'Ouro Velho', 'PB', NULL, NULL, NULL, 2510600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.218822', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1373, 'Parari', 'PB', NULL, NULL, NULL, 2510659, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.219627', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1374, 'Passagem', 'PB', NULL, NULL, NULL, 2510709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.220662', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1375, 'Patos', 'PB', NULL, NULL, NULL, 2510808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.22147', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1376, 'Paulista', 'PB', NULL, NULL, NULL, 2510907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.222548', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1377, 'Pedra Branca', 'PB', NULL, NULL, NULL, 2511004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.223486', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1378, 'Pedra Lavrada', 'PB', NULL, NULL, NULL, 2511103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.224321', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1379, 'Pedras de Fogo', 'PB', NULL, NULL, NULL, 2511202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.225261', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1381, 'Pianco', 'PB', NULL, NULL, NULL, 2511301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.22712', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1382, 'Picui', 'PB', NULL, NULL, NULL, 2511400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.228008', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1383, 'Pilar', 'PB', NULL, NULL, NULL, 2511509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.228887', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1384, 'Piloes', 'PB', NULL, NULL, NULL, 2511608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.230081', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1385, 'Piloezinhos', 'PB', NULL, NULL, NULL, 2511707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.230945', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1386, 'Pirpirituba', 'PB', NULL, NULL, NULL, 2511806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.231857', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1387, 'Pitimbu', 'PB', NULL, NULL, NULL, 2511905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.232742', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1388, 'Pocinhos', 'PB', NULL, NULL, NULL, 2512002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.233566', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1389, 'Poco Dantas', 'PB', NULL, NULL, NULL, 2512036, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.234628', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1390, 'Poco de Jose de Moura', 'PB', NULL, NULL, NULL, 2512077, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.235532', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1391, 'Pombal', 'PB', NULL, NULL, NULL, 2512101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.236417', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1392, 'Prata', 'PB', NULL, NULL, NULL, 2512200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.23723', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1393, 'Princesa Isabel', 'PB', NULL, NULL, NULL, 2512309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.238127', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1394, 'Puxinana', 'PB', NULL, NULL, NULL, 2512408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.238929', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1395, 'Queimadas', 'PB', NULL, NULL, NULL, 2512507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.239764', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1396, 'Quixaba', 'PB', NULL, NULL, NULL, 2512606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.240693', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1397, 'Remigio', 'PB', NULL, NULL, NULL, 2512705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.241454', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1380, 'Pedro Regis', 'PB', NULL, NULL, NULL, 2512721, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.226144', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1398, 'Riachao', 'PB', NULL, NULL, NULL, 2512747, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.242406', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1399, 'Riachao do Bacamarte', 'PB', NULL, NULL, NULL, 2512754, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.243145', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1400, 'Riachao do Poco', 'PB', NULL, NULL, NULL, 2512762, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.249788', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1401, 'Riacho de Santo Antonio', 'PB', NULL, NULL, NULL, 2512788, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.250952', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1402, 'Riacho dos Cavalos', 'PB', NULL, NULL, NULL, 2512804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.252411', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1403, 'Rio Tinto', 'PB', NULL, NULL, NULL, 2512903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.253304', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1404, 'Salgadinho', 'PB', NULL, NULL, NULL, 2513000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.25416', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1405, 'Salgado de Sao Felix', 'PB', NULL, NULL, NULL, 2513109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.255117', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1406, 'Santa Cecilia', 'PB', NULL, NULL, NULL, 2513158, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.256209', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1407, 'Santa Cruz', 'PB', NULL, NULL, NULL, 2513208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.25718', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1408, 'Santa Helena', 'PB', NULL, NULL, NULL, 2513307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.258032', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1409, 'Santa Ines', 'PB', NULL, NULL, NULL, 2513356, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.258871', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1410, 'Santa Luzia', 'PB', NULL, NULL, NULL, 2513406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.25973', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1413, 'Santana de Mangueira', 'PB', NULL, NULL, NULL, 2513505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.262825', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1414, 'Santana dos Garrotes', 'PB', NULL, NULL, NULL, 2513604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.263649', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1411, 'Santa Rita', 'PB', NULL, NULL, NULL, 2513703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.260598', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1412, 'Santa Teresinha', 'PB', NULL, NULL, NULL, 2513802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.261849', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1416, 'Santo Andre', 'PB', NULL, NULL, NULL, 2513851, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.265495', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1418, 'Sao Bento', 'PB', NULL, NULL, NULL, 2513901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.26724', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1417, 'Sao Bentinho', 'PB', NULL, NULL, NULL, 2513927, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.266426', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1420, 'Sao Domingos do Cariri', 'PB', NULL, NULL, NULL, 2513943, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.269057', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1421, 'Sao Francisco', 'PB', NULL, NULL, NULL, 2513984, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.269946', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1422, 'Sao Joao do Cariri', 'PB', NULL, NULL, NULL, 2514008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.270871', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1424, 'Sao Joao do Tigre', 'PB', NULL, NULL, NULL, 2514107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.272737', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1425, 'Sao Jose da Lagoa Tapada', 'PB', NULL, NULL, NULL, 2514206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.273614', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1426, 'Sao Jose de Caiana', 'PB', NULL, NULL, NULL, 2514305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.274688', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1427, 'Sao Jose de Espinharas', 'PB', NULL, NULL, NULL, 2514404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.27563', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1434, 'Sao Jose dos Ramos', 'PB', NULL, NULL, NULL, 2514453, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.281823', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1428, 'Sao Jose de Piranhas', 'PB', NULL, NULL, NULL, 2514503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.276506', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1429, 'Sao Jose de Princesa', 'PB', NULL, NULL, NULL, 2514552, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.277443', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1430, 'Sao Jose do Bonfim', 'PB', NULL, NULL, NULL, 2514602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.278377', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1431, 'Sao Jose do Brejo do Cruz', 'PB', NULL, NULL, NULL, 2514651, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.279212', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1432, 'Sao Jose do Sabugi', 'PB', NULL, NULL, NULL, 2514701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.280095', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1433, 'Sao Jose dos Cordeiros', 'PB', NULL, NULL, NULL, 2514800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.280958', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1435, 'Sao Mamede', 'PB', NULL, NULL, NULL, 2514909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.282705', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1436, 'Sao Miguel de Taipu', 'PB', NULL, NULL, NULL, 2515005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.283547', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1437, 'Sao Sebastiao de Lagoa de Roca', 'PB', NULL, NULL, NULL, 2515104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.290398', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1438, 'Sao Sebastiao do Umbuzeiro', 'PB', NULL, NULL, NULL, 2515203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.291562', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1440, 'Sape', 'PB', NULL, NULL, NULL, 2515302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.293434', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1439, 'Sao Vicente do Serido', 'PB', NULL, NULL, NULL, 2515401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.292442', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1441, 'Serra Branca', 'PB', NULL, NULL, NULL, 2515500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.294291', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1442, 'Serra da Raiz', 'PB', NULL, NULL, NULL, 2515609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.295204', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1443, 'Serra Grande', 'PB', NULL, NULL, NULL, 2515708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.29615', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1444, 'Serra Redonda', 'PB', NULL, NULL, NULL, 2515807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.296925', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1445, 'Serraria', 'PB', NULL, NULL, NULL, 2515906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.297727', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1446, 'Sertaozinho', 'PB', NULL, NULL, NULL, 2515930, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.298636', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1447, 'Sobrado', 'PB', NULL, NULL, NULL, 2515971, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.299495', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1448, 'Solanea', 'PB', NULL, NULL, NULL, 2516003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.300403', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1449, 'Soledade', 'PB', NULL, NULL, NULL, 2516102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.301233', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1450, 'Sossego', 'PB', NULL, NULL, NULL, 2516151, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.302085', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1451, 'Sousa', 'PB', NULL, NULL, NULL, 2516201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.302975', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1452, 'Sume', 'PB', NULL, NULL, NULL, 2516300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.303766', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1453, 'Taperoa', 'PB', NULL, NULL, NULL, 2516508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.304635', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1454, 'Tavares', 'PB', NULL, NULL, NULL, 2516607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.305527', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1455, 'Teixeira', 'PB', NULL, NULL, NULL, 2516706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.306383', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1456, 'Tenorio', 'PB', NULL, NULL, NULL, 2516755, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.3074', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1457, 'Triunfo', 'PB', NULL, NULL, NULL, 2516805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.308232', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1458, 'Uirauna', 'PB', NULL, NULL, NULL, 2516904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.309099', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1459, 'Umbuzeiro', 'PB', NULL, NULL, NULL, 2517001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.309848', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1460, 'Varzea', 'PB', NULL, NULL, NULL, 2517100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.310707', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1461, 'Vieiropolis', 'PB', NULL, NULL, NULL, 2517209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.311518', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1463, 'Zabele', 'PB', NULL, NULL, NULL, 2517407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.31346', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1464, 'Abreu e Lima', 'PE', NULL, NULL, NULL, 2600054, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.314455', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1465, 'Afogados da Ingazeira', 'PE', NULL, NULL, NULL, 2600104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.315369', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1466, 'Afranio', 'PE', NULL, NULL, NULL, 2600203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.316283', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1467, 'Agrestina', 'PE', NULL, NULL, NULL, 2600302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.317184', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1468, 'Agua Preta', 'PE', NULL, NULL, NULL, 2600401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.318148', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1469, 'Aguas Belas', 'PE', NULL, NULL, NULL, 2600500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.319228', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1470, 'Alagoinha', 'PE', NULL, NULL, NULL, 2600609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.320145', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1471, 'Alianca', 'PE', NULL, NULL, NULL, 2600708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.32101', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1472, 'Altinho', 'PE', NULL, NULL, NULL, 2600807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.321895', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1473, 'Amaraji', 'PE', NULL, NULL, NULL, 2600906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.322767', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1474, 'Angelim', 'PE', NULL, NULL, NULL, 2601003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.32367', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1475, 'Aracoiaba', 'PE', NULL, NULL, NULL, 2601052, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.324482', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1476, 'Araripina', 'PE', NULL, NULL, NULL, 2601102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.330102', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1477, 'Arcoverde', 'PE', NULL, NULL, NULL, 2601201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.331269', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1478, 'Barra de Guabiraba', 'PE', NULL, NULL, NULL, 2601300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.332372', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1479, 'Barreiros', 'PE', NULL, NULL, NULL, 2601409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.333472', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1480, 'Belem de Maria', 'PE', NULL, NULL, NULL, 2601508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.334393', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1482, 'Belo Jardim', 'PE', NULL, NULL, NULL, 2601706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.336241', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1483, 'Betania', 'PE', NULL, NULL, NULL, 2601805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.337129', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1484, 'Bezerros', 'PE', NULL, NULL, NULL, 2601904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.338076', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1485, 'Bodoco', 'PE', NULL, NULL, NULL, 2602001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.338907', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1486, 'Bom Conselho', 'PE', NULL, NULL, NULL, 2602100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.339929', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1487, 'Bom Jardim', 'PE', NULL, NULL, NULL, 2602209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.340936', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1488, 'Bonito', 'PE', NULL, NULL, NULL, 2602308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.34216', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1489, 'Brejao', 'PE', NULL, NULL, NULL, 2602407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.343086', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1490, 'Brejinho', 'PE', NULL, NULL, NULL, 2602506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.344037', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1491, 'Brejo da Madre de Deus', 'PE', NULL, NULL, NULL, 2602605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.344934', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1492, 'Buenos Aires', 'PE', NULL, NULL, NULL, 2602704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.345842', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1493, 'Buique', 'PE', NULL, NULL, NULL, 2602803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.346767', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1494, 'Cabo de Santo Agostinho', 'PE', NULL, NULL, NULL, 2602902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.347774', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1495, 'Cabrobo', 'PE', NULL, NULL, NULL, 2603009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.348738', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1496, 'Cachoeirinha', 'PE', NULL, NULL, NULL, 2603108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.349556', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1497, 'Caetes', 'PE', NULL, NULL, NULL, 2603207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.350314', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1498, 'Calcado', 'PE', NULL, NULL, NULL, 2603306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.351203', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1499, 'Calumbi', 'PE', NULL, NULL, NULL, 2603405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.35222', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1500, 'Camaragibe', 'PE', NULL, NULL, NULL, 2603454, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.352986', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1501, 'Camocim de Sao Felix', 'PE', NULL, NULL, NULL, 2603504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.35396', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1502, 'Camutanga', 'PE', NULL, NULL, NULL, 2603603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.35491', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1503, 'Canhotinho', 'PE', NULL, NULL, NULL, 2603702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.355843', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1504, 'Capoeiras', 'PE', NULL, NULL, NULL, 2603801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.356719', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1505, 'Carnaiba', 'PE', NULL, NULL, NULL, 2603900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.357596', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1506, 'Carnaubeira da Penha', 'PE', NULL, NULL, NULL, 2603926, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.358502', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1507, 'Carpina', 'PE', NULL, NULL, NULL, 2604007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.359433', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1508, 'Caruaru', 'PE', NULL, NULL, NULL, 2604106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.360254', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1509, 'Casinhas', 'PE', NULL, NULL, NULL, 2604155, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.361206', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1510, 'Catende', 'PE', NULL, NULL, NULL, 2604205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.362152', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1511, 'Cedro', 'PE', NULL, NULL, NULL, 2604304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.363201', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1512, 'Cha de Alegria', 'PE', NULL, NULL, NULL, 2604403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.364172', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1513, 'Cha Grande', 'PE', NULL, NULL, NULL, 2604502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.364895', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1514, 'Condado', 'PE', NULL, NULL, NULL, 2604601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.365661', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1515, 'Correntes', 'PE', NULL, NULL, NULL, 2604700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.366715', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1516, 'Cortes', 'PE', NULL, NULL, NULL, 2604809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.376836', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1517, 'Cumaru', 'PE', NULL, NULL, NULL, 2604908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.377881', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1518, 'Cupira', 'PE', NULL, NULL, NULL, 2605004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.378741', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1519, 'Custodia', 'PE', NULL, NULL, NULL, 2605103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.379657', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1520, 'Dormentes', 'PE', NULL, NULL, NULL, 2605152, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.380527', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1521, 'Escada', 'PE', NULL, NULL, NULL, 2605202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.381407', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1522, 'Exu', 'PE', NULL, NULL, NULL, 2605301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.382617', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1523, 'Feira Nova', 'PE', NULL, NULL, NULL, 2605400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.383472', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1524, 'Fernando de Noronha', 'PE', NULL, NULL, NULL, 2605459, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.384317', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1525, 'Ferreiros', 'PE', NULL, NULL, NULL, 2605509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.3852', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1526, 'Flores', 'PE', NULL, NULL, NULL, 2605608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.386058', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1527, 'Floresta', 'PE', NULL, NULL, NULL, 2605707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.386923', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1528, 'Frei Miguelinho', 'PE', NULL, NULL, NULL, 2605806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.387844', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1529, 'Gameleira', 'PE', NULL, NULL, NULL, 2605905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.388718', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1530, 'Garanhuns', 'PE', NULL, NULL, NULL, 2606002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.389733', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1531, 'Gloria do Goita', 'PE', NULL, NULL, NULL, 2606101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.390524', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1532, 'Goiana', 'PE', NULL, NULL, NULL, 2606200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.391405', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1533, 'Granito', 'PE', NULL, NULL, NULL, 2606309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.392255', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1534, 'Gravata', 'PE', NULL, NULL, NULL, 2606408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.393148', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1535, 'Iati', 'PE', NULL, NULL, NULL, 2606507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.394064', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1536, 'Ibimirim', 'PE', NULL, NULL, NULL, 2606606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.394992', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1537, 'Ibirajuba', 'PE', NULL, NULL, NULL, 2606705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.395927', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1538, 'Igarassu', 'PE', NULL, NULL, NULL, 2606804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.396835', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1540, 'Inaja', 'PE', NULL, NULL, NULL, 2607000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.398738', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1541, 'Ingazeira', 'PE', NULL, NULL, NULL, 2607109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.399746', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1542, 'Ipojuca', 'PE', NULL, NULL, NULL, 2607208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.400727', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1543, 'Ipubi', 'PE', NULL, NULL, NULL, 2607307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.401708', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1544, 'Itacuruba', 'PE', NULL, NULL, NULL, 2607406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.402642', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1545, 'Itaiba', 'PE', NULL, NULL, NULL, 2607505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.403569', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1547, 'Itambe', 'PE', NULL, NULL, NULL, 2607653, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.405413', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1548, 'Itapetim', 'PE', NULL, NULL, NULL, 2607703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.40621', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1549, 'Itapissuma', 'PE', NULL, NULL, NULL, 2607752, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.407134', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1550, 'Itaquitinga', 'PE', NULL, NULL, NULL, 2607802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.408047', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1551, 'Jaboatao dos Guararapes', 'PE', NULL, NULL, NULL, 2607901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.408818', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1552, 'Jaqueira', 'PE', NULL, NULL, NULL, 2607950, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.409756', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1553, 'Jatauba', 'PE', NULL, NULL, NULL, 2608008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.410498', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1554, 'Jatoba', 'PE', NULL, NULL, NULL, 2608057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.411876', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1555, 'Joao Alfredo', 'PE', NULL, NULL, NULL, 2608107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.417932', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1556, 'Joaquim Nabuco', 'PE', NULL, NULL, NULL, 2608206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.419099', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1557, 'Jucati', 'PE', NULL, NULL, NULL, 2608255, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.420118', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1558, 'Jupi', 'PE', NULL, NULL, NULL, 2608305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.421181', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1559, 'Jurema', 'PE', NULL, NULL, NULL, 2608404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.422125', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1560, 'Lagoa do Carro', 'PE', NULL, NULL, NULL, 2608453, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.423115', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1562, 'Lagoa do Ouro', 'PE', NULL, NULL, NULL, 2608602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.424996', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1563, 'Lagoa dos Gatos', 'PE', NULL, NULL, NULL, 2608701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.425859', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1564, 'Lagoa Grande', 'PE', NULL, NULL, NULL, 2608750, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.42668', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1565, 'Lajedo', 'PE', NULL, NULL, NULL, 2608800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.427665', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1566, 'Limoeiro', 'PE', NULL, NULL, NULL, 2608909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.428572', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1567, 'Macaparana', 'PE', NULL, NULL, NULL, 2609006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.429473', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1568, 'Machados', 'PE', NULL, NULL, NULL, 2609105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.430395', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1569, 'Manari', 'PE', NULL, NULL, NULL, 2609154, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.431315', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1570, 'Maraial', 'PE', NULL, NULL, NULL, 2609204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.432227', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1571, 'Mirandiba', 'PE', NULL, NULL, NULL, 2609303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.433144', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1573, 'Moreno', 'PE', NULL, NULL, NULL, 2609402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.434923', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1574, 'Nazare da Mata', 'PE', NULL, NULL, NULL, 2609501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.435804', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1575, 'Olinda', 'PE', NULL, NULL, NULL, 2609600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.436674', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1576, 'Orobo', 'PE', NULL, NULL, NULL, 2609709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.437566', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1577, 'Oroco', 'PE', NULL, NULL, NULL, 2609808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.438497', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1578, 'Ouricuri', 'PE', NULL, NULL, NULL, 2609907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.439384', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1579, 'Palmares', 'PE', NULL, NULL, NULL, 2610004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.44018', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1580, 'Palmeirina', 'PE', NULL, NULL, NULL, 2610103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.441107', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1581, 'Panelas', 'PE', NULL, NULL, NULL, 2610202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.442238', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1582, 'Paranatama', 'PE', NULL, NULL, NULL, 2610301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.443039', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1583, 'Parnamirim', 'PE', NULL, NULL, NULL, 2610400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.44394', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1584, 'Passira', 'PE', NULL, NULL, NULL, 2610509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.444874', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1585, 'Paudalho', 'PE', NULL, NULL, NULL, 2610608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.445746', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1586, 'Paulista', 'PE', NULL, NULL, NULL, 2610707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.446509', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1587, 'Pedra', 'PE', NULL, NULL, NULL, 2610806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.447374', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1588, 'Pesqueira', 'PE', NULL, NULL, NULL, 2610905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.448217', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1589, 'Petrolandia', 'PE', NULL, NULL, NULL, 2611002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.449198', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1590, 'Petrolina', 'PE', NULL, NULL, NULL, 2611101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.450099', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1591, 'Pocao', 'PE', NULL, NULL, NULL, 2611200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.451059', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1592, 'Pombos', 'PE', NULL, NULL, NULL, 2611309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.458158', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1593, 'Primavera', 'PE', NULL, NULL, NULL, 2611408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.459513', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1594, 'Quipapa', 'PE', NULL, NULL, NULL, 2611507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.460461', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1595, 'Quixaba', 'PE', NULL, NULL, NULL, 2611533, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.461303', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1596, 'Recife', 'PE', NULL, NULL, NULL, 2611606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.462202', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1597, 'Riacho das Almas', 'PE', NULL, NULL, NULL, 2611705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.463132', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1598, 'Ribeirao', 'PE', NULL, NULL, NULL, 2611804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.464166', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1599, 'Rio Formoso', 'PE', NULL, NULL, NULL, 2611903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.46508', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1600, 'Saire', 'PE', NULL, NULL, NULL, 2612000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.466141', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1601, 'Salgadinho', 'PE', NULL, NULL, NULL, 2612109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.467057', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1602, 'Salgueiro', 'PE', NULL, NULL, NULL, 2612208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.467963', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1603, 'Saloa', 'PE', NULL, NULL, NULL, 2612307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.468887', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1604, 'Sanharo', 'PE', NULL, NULL, NULL, 2612406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.469786', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1605, 'Santa Cruz', 'PE', NULL, NULL, NULL, 2612455, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.470673', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1606, 'Santa Cruz da Baixa Verde', 'PE', NULL, NULL, NULL, 2612471, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.471456', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1607, 'Santa Cruz do Capibaribe', 'PE', NULL, NULL, NULL, 2612505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.47243', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1608, 'Santa Filomena', 'PE', NULL, NULL, NULL, 2612554, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.473203', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1609, 'Santa Maria da Boa Vista', 'PE', NULL, NULL, NULL, 2612604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.474049', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1610, 'Santa Maria do Cambuca', 'PE', NULL, NULL, NULL, 2612703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.474981', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1611, 'Santa Terezinha', 'PE', NULL, NULL, NULL, 2612802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.475798', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1612, 'Sao Benedito do Sul', 'PE', NULL, NULL, NULL, 2612901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.47664', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1613, 'Sao Bento do Una', 'PE', NULL, NULL, NULL, 2613008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.477417', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1614, 'Sao Caitano', 'PE', NULL, NULL, NULL, 2613107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.478275', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1615, 'Sao Joao', 'PE', NULL, NULL, NULL, 2613206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.479132', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1616, 'Sao Joaquim do Monte', 'PE', NULL, NULL, NULL, 2613305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.479973', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1617, 'Sao Jose da Coroa Grande', 'PE', NULL, NULL, NULL, 2613404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.48086', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1618, 'Sao Jose do Belmonte', 'PE', NULL, NULL, NULL, 2613503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.481801', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1619, 'Sao Jose do Egito', 'PE', NULL, NULL, NULL, 2613602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.482835', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1620, 'Sao Lourenco da Mata', 'PE', NULL, NULL, NULL, 2613701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.48371', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1621, 'Sao Vicente Ferrer', 'PE', NULL, NULL, NULL, 2613800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.484603', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1622, 'Serra Talhada', 'PE', NULL, NULL, NULL, 2613909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.485455', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1623, 'Serrita', 'PE', NULL, NULL, NULL, 2614006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.486433', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1624, 'Sertania', 'PE', NULL, NULL, NULL, 2614105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.487232', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1625, 'Sirinhaem', 'PE', NULL, NULL, NULL, 2614204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.48815', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1572, 'Moreilandia', 'PE', NULL, NULL, NULL, 2614303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.434075', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1626, 'Solidao', 'PE', NULL, NULL, NULL, 2614402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.489012', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1627, 'Surubim', 'PE', NULL, NULL, NULL, 2614501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.489863', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1628, 'Tabira', 'PE', NULL, NULL, NULL, 2614600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.490792', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1629, 'Tacaimbo', 'PE', NULL, NULL, NULL, 2614709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.491684', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1630, 'Tacaratu', 'PE', NULL, NULL, NULL, 2614808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.492321', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1631, 'Tamandare', 'PE', NULL, NULL, NULL, 2614857, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.49933', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1632, 'Taquaritinga do Norte', 'PE', NULL, NULL, NULL, 2615003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.500598', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1633, 'Terezinha', 'PE', NULL, NULL, NULL, 2615102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.501611', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1634, 'Terra Nova', 'PE', NULL, NULL, NULL, 2615201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.502516', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1635, 'Timbauba', 'PE', NULL, NULL, NULL, 2615300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.503375', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1636, 'Toritama', 'PE', NULL, NULL, NULL, 2615409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.504224', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1637, 'Tracunhaem', 'PE', NULL, NULL, NULL, 2615508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.505121', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1638, 'Trindade', 'PE', NULL, NULL, NULL, 2615607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.505974', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1639, 'Triunfo', 'PE', NULL, NULL, NULL, 2615706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.506916', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1640, 'Tupanatinga', 'PE', NULL, NULL, NULL, 2615805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.507922', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1641, 'Tuparetama', 'PE', NULL, NULL, NULL, 2615904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.508899', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1642, 'Venturosa', 'PE', NULL, NULL, NULL, 2616001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.509757', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1643, 'Verdejante', 'PE', NULL, NULL, NULL, 2616100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.510673', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1644, 'Vertente do Lerio', 'PE', NULL, NULL, NULL, 2616183, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.511529', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1645, 'Vertentes', 'PE', NULL, NULL, NULL, 2616209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.512415', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1646, 'Vicencia', 'PE', NULL, NULL, NULL, 2616308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.513303', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1647, 'Vitoria de Santo Antao', 'PE', NULL, NULL, NULL, 2616407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.51418', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1648, 'Xexeu', 'PE', NULL, NULL, NULL, 2616506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.515121', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1649, 'Agua Branca', 'AL', NULL, NULL, NULL, 2700102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.515958', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1650, 'Anadia', 'AL', NULL, NULL, NULL, 2700201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.516876', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1651, 'Arapiraca', 'AL', NULL, NULL, NULL, 2700300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.517813', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1652, 'Atalaia', 'AL', NULL, NULL, NULL, 2700409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.518801', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1653, 'Barra de Santo Antonio', 'AL', NULL, NULL, NULL, 2700508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.519858', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1654, 'Barra de Sao Miguel', 'AL', NULL, NULL, NULL, 2700607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.520772', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1655, 'Batalha', 'AL', NULL, NULL, NULL, 2700706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.521655', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1656, 'Belem', 'AL', NULL, NULL, NULL, 2700805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.522539', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1657, 'Belo Monte', 'AL', NULL, NULL, NULL, 2700904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.523412', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1658, 'Boca da Mata', 'AL', NULL, NULL, NULL, 2701001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.524257', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1659, 'Branquinha', 'AL', NULL, NULL, NULL, 2701100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.525049', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1660, 'Cacimbinhas', 'AL', NULL, NULL, NULL, 2701209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.525871', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1661, 'Cajueiro', 'AL', NULL, NULL, NULL, 2701308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.526778', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1662, 'Campestre', 'AL', NULL, NULL, NULL, 2701357, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.527574', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1663, 'Campo Alegre', 'AL', NULL, NULL, NULL, 2701407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.528462', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1664, 'Campo Grande', 'AL', NULL, NULL, NULL, 2701506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.529366', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1665, 'Canapi', 'AL', NULL, NULL, NULL, 2701605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.5303', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1666, 'Capela', 'AL', NULL, NULL, NULL, 2701704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.531062', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1667, 'Carneiros', 'AL', NULL, NULL, NULL, 2701803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.531967', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1668, 'Cha Preta', 'AL', NULL, NULL, NULL, 2701902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.532762', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1669, 'Coite do Noia', 'AL', NULL, NULL, NULL, 2702009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.53981', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1670, 'Colonia Leopoldina', 'AL', NULL, NULL, NULL, 2702108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.540909', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1671, 'Coqueiro Seco', 'AL', NULL, NULL, NULL, 2702207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.541931', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1672, 'Coruripe', 'AL', NULL, NULL, NULL, 2702306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.542806', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1673, 'Craibas', 'AL', NULL, NULL, NULL, 2702355, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.543615', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1674, 'Delmiro Gouveia', 'AL', NULL, NULL, NULL, 2702405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.544416', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1675, 'Dois Riachos', 'AL', NULL, NULL, NULL, 2702504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.545079', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1676, 'Estrela de Alagoas', 'AL', NULL, NULL, NULL, 2702553, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.545943', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1677, 'Feira Grande', 'AL', NULL, NULL, NULL, 2702603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.546837', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1678, 'Feliz Deserto', 'AL', NULL, NULL, NULL, 2702702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.547708', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1679, 'Flexeiras', 'AL', NULL, NULL, NULL, 2702801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.54858', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1680, 'Girau do Ponciano', 'AL', NULL, NULL, NULL, 2702900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.549416', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1681, 'Ibateguara', 'AL', NULL, NULL, NULL, 2703007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.550297', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1682, 'Igaci', 'AL', NULL, NULL, NULL, 2703106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.551161', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1683, 'Igreja Nova', 'AL', NULL, NULL, NULL, 2703205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.552215', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1684, 'Inhapi', 'AL', NULL, NULL, NULL, 2703304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.553518', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1685, 'Jacare dos Homens', 'AL', NULL, NULL, NULL, 2703403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.554435', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1686, 'Jacuipe', 'AL', NULL, NULL, NULL, 2703502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.555236', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1687, 'Japaratinga', 'AL', NULL, NULL, NULL, 2703601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.556108', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1688, 'Jaramataia', 'AL', NULL, NULL, NULL, 2703700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.556965', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1689, 'Jequia da Praia', 'AL', NULL, NULL, NULL, 2703759, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.557886', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1690, 'Joaquim Gomes', 'AL', NULL, NULL, NULL, 2703809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.558773', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1691, 'Jundia', 'AL', NULL, NULL, NULL, 2703908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.55955', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1692, 'Junqueiro', 'AL', NULL, NULL, NULL, 2704005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.560447', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1693, 'Lagoa da Canoa', 'AL', NULL, NULL, NULL, 2704104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.561361', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1694, 'Limoeiro de Anadia', 'AL', NULL, NULL, NULL, 2704203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.562239', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1695, 'Maceio', 'AL', NULL, NULL, NULL, 2704302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.563152', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1696, 'Major Isidoro', 'AL', NULL, NULL, NULL, 2704401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.564162', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1698, 'Maragogi', 'AL', NULL, NULL, NULL, 2704500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.566063', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1699, 'Maravilha', 'AL', NULL, NULL, NULL, 2704609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.566937', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1700, 'Marechal Deodoro', 'AL', NULL, NULL, NULL, 2704708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.56783', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1701, 'Maribondo', 'AL', NULL, NULL, NULL, 2704807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.568607', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1697, 'Mar Vermelho', 'AL', NULL, NULL, NULL, 2704906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.56511', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1702, 'Mata Grande', 'AL', NULL, NULL, NULL, 2705002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.569485', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1703, 'Matriz de Camaragibe', 'AL', NULL, NULL, NULL, 2705101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.570409', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1704, 'Messias', 'AL', NULL, NULL, NULL, 2705200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.57126', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1705, 'Minador do Negrao', 'AL', NULL, NULL, NULL, 2705309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.572177', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1706, 'Monteiropolis', 'AL', NULL, NULL, NULL, 2705408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.573135', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1707, 'Murici', 'AL', NULL, NULL, NULL, 2705507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.579953', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1708, 'Novo Lino', 'AL', NULL, NULL, NULL, 2705606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.58127', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1709, 'Olho D''agua das Flores', 'AL', NULL, NULL, NULL, 2705705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.582212', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1710, 'Olho D''agua do Casado', 'AL', NULL, NULL, NULL, 2705804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.583111', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1711, 'Olho D''agua Grande', 'AL', NULL, NULL, NULL, 2705903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.583997', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1712, 'Olivenca', 'AL', NULL, NULL, NULL, 2706000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.584857', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1713, 'Ouro Branco', 'AL', NULL, NULL, NULL, 2706109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.585722', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1714, 'Palestina', 'AL', NULL, NULL, NULL, 2706208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.58684', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1715, 'Palmeira dos Indios', 'AL', NULL, NULL, NULL, 2706307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.587745', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1716, 'Pao de Acucar', 'AL', NULL, NULL, NULL, 2706406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.58866', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1717, 'Pariconha', 'AL', NULL, NULL, NULL, 2706422, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.589445', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1718, 'Paripueira', 'AL', NULL, NULL, NULL, 2706448, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.590225', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1719, 'Passo de Camaragibe', 'AL', NULL, NULL, NULL, 2706505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.59101', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1720, 'Paulo Jacinto', 'AL', NULL, NULL, NULL, 2706604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.591854', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1721, 'Penedo', 'AL', NULL, NULL, NULL, 2706703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.592907', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1722, 'Piacabucu', 'AL', NULL, NULL, NULL, 2706802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.593907', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1723, 'Pilar', 'AL', NULL, NULL, NULL, 2706901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.594781', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1724, 'Pindoba', 'AL', NULL, NULL, NULL, 2707008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.595808', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1725, 'Piranhas', 'AL', NULL, NULL, NULL, 2707107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.596659', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1726, 'Poco das Trincheiras', 'AL', NULL, NULL, NULL, 2707206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.597518', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1727, 'Porto Calvo', 'AL', NULL, NULL, NULL, 2707305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.598531', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1728, 'Porto de Pedras', 'AL', NULL, NULL, NULL, 2707404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.599515', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1729, 'Porto Real do Colegio', 'AL', NULL, NULL, NULL, 2707503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.600386', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1730, 'Quebrangulo', 'AL', NULL, NULL, NULL, 2707602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.601248', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1731, 'Rio Largo', 'AL', NULL, NULL, NULL, 2707701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.602118', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1732, 'Roteiro', 'AL', NULL, NULL, NULL, 2707800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.602974', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1733, 'Santa Luzia do Norte', 'AL', NULL, NULL, NULL, 2707909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.60384', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1734, 'Santana do Ipanema', 'AL', NULL, NULL, NULL, 2708006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.604666', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1735, 'Santana do Mundau', 'AL', NULL, NULL, NULL, 2708105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.605464', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1736, 'Sao Bras', 'AL', NULL, NULL, NULL, 2708204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.60638', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1737, 'Sao Jose da Laje', 'AL', NULL, NULL, NULL, 2708303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.607218', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1738, 'Sao Jose da Tapera', 'AL', NULL, NULL, NULL, 2708402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.608123', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1739, 'Sao Luis do Quitunde', 'AL', NULL, NULL, NULL, 2708501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.609231', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1740, 'Sao Miguel dos Campos', 'AL', NULL, NULL, NULL, 2708600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.610109', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1741, 'Sao Miguel dos Milagres', 'AL', NULL, NULL, NULL, 2708709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.610971', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1742, 'Sao Sebastiao', 'AL', NULL, NULL, NULL, 2708808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.611868', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1743, 'Satuba', 'AL', NULL, NULL, NULL, 2708907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.612769', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1744, 'Senador Rui Palmeira', 'AL', NULL, NULL, NULL, 2708956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.61364', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1745, 'Tanque D''arca', 'AL', NULL, NULL, NULL, 2709004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.621045', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1746, 'Taquarana', 'AL', NULL, NULL, NULL, 2709103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.622171', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1747, 'Teotonio Vilela', 'AL', NULL, NULL, NULL, 2709152, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.623156', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1748, 'Traipu', 'AL', NULL, NULL, NULL, 2709202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.624182', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1749, 'Uniao dos Palmares', 'AL', NULL, NULL, NULL, 2709301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.625153', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1750, 'Vicosa', 'AL', NULL, NULL, NULL, 2709400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.626119', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1751, 'Amparo de Sao Francisco', 'SE', NULL, NULL, NULL, 2800100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.626967', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1752, 'Aquidaba', 'SE', NULL, NULL, NULL, 2800209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.627865', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1753, 'Aracaju', 'SE', NULL, NULL, NULL, 2800308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.628811', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1754, 'Araua', 'SE', NULL, NULL, NULL, 2800407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.629694', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1755, 'Areia Branca', 'SE', NULL, NULL, NULL, 2800506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.630578', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1756, 'Barra dos Coqueiros', 'SE', NULL, NULL, NULL, 2800605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.631545', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1757, 'Boquim', 'SE', NULL, NULL, NULL, 2800670, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.632563', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1758, 'Brejo Grande', 'SE', NULL, NULL, NULL, 2800704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.633428', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1759, 'Campo do Brito', 'SE', NULL, NULL, NULL, 2801009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.63429', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1760, 'Canhoba', 'SE', NULL, NULL, NULL, 2801108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.635169', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1761, 'Caninde de Sao Francisco', 'SE', NULL, NULL, NULL, 2801207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.636006', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1762, 'Capela', 'SE', NULL, NULL, NULL, 2801306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.636835', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1763, 'Carira', 'SE', NULL, NULL, NULL, 2801405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.637698', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1764, 'Carmopolis', 'SE', NULL, NULL, NULL, 2801504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.638589', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1765, 'Cedro de Sao Joao', 'SE', NULL, NULL, NULL, 2801603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.639453', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1766, 'Cristinapolis', 'SE', NULL, NULL, NULL, 2801702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.640358', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1767, 'Cumbe', 'SE', NULL, NULL, NULL, 2801900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.641238', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1768, 'Divina Pastora', 'SE', NULL, NULL, NULL, 2802007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.642203', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1769, 'Estancia', 'SE', NULL, NULL, NULL, 2802106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.642975', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1770, 'Feira Nova', 'SE', NULL, NULL, NULL, 2802205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.643769', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1771, 'Frei Paulo', 'SE', NULL, NULL, NULL, 2802304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.64469', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1772, 'Gararu', 'SE', NULL, NULL, NULL, 2802403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.645572', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1773, 'General Maynard', 'SE', NULL, NULL, NULL, 2802502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.646491', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1774, 'Gracho Cardoso', 'SE', NULL, NULL, NULL, 2802601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.64737', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1775, 'Ilha das Flores', 'SE', NULL, NULL, NULL, 2802700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.648183', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1776, 'Indiaroba', 'SE', NULL, NULL, NULL, 2802809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.649012', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1777, 'Itabaiana', 'SE', NULL, NULL, NULL, 2802908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.649896', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1778, 'Itabaianinha', 'SE', NULL, NULL, NULL, 2803005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.650772', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1779, 'Itabi', 'SE', NULL, NULL, NULL, 2803104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.651642', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1780, 'Itaporanga D''ajuda', 'SE', NULL, NULL, NULL, 2803203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.652555', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1781, 'Japaratuba', 'SE', NULL, NULL, NULL, 2803302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.653348', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1782, 'Japoata', 'SE', NULL, NULL, NULL, 2803401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.654107', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1783, 'Lagarto', 'SE', NULL, NULL, NULL, 2803500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.654821', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1784, 'Laranjeiras', 'SE', NULL, NULL, NULL, 2803609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.655682', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1785, 'Macambira', 'SE', NULL, NULL, NULL, 2803708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.661933', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1786, 'Malhada dos Bois', 'SE', NULL, NULL, NULL, 2803807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.663166', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1787, 'Malhador', 'SE', NULL, NULL, NULL, 2803906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.664217', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1788, 'Maruim', 'SE', NULL, NULL, NULL, 2804003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.665029', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1789, 'Moita Bonita', 'SE', NULL, NULL, NULL, 2804102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.665899', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1790, 'Monte Alegre de Sergipe', 'SE', NULL, NULL, NULL, 2804201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.666702', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1791, 'Muribeca', 'SE', NULL, NULL, NULL, 2804300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.667607', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1792, 'Neopolis', 'SE', NULL, NULL, NULL, 2804409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.668505', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1793, 'Nossa Senhora Aparecida', 'SE', NULL, NULL, NULL, 2804458, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.66942', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1794, 'Nossa Senhora da Gloria', 'SE', NULL, NULL, NULL, 2804508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.670251', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1795, 'Nossa Senhora das Dores', 'SE', NULL, NULL, NULL, 2804607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.671045', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1796, 'Nossa Senhora de Lourdes', 'SE', NULL, NULL, NULL, 2804706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.671969', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1797, 'Nossa Senhora do Socorro', 'SE', NULL, NULL, NULL, 2804805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.672835', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1798, 'Pacatuba', 'SE', NULL, NULL, NULL, 2804904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.673744', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1799, 'Pedra Mole', 'SE', NULL, NULL, NULL, 2805000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.674638', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1800, 'Pedrinhas', 'SE', NULL, NULL, NULL, 2805109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.675565', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1801, 'Pinhao', 'SE', NULL, NULL, NULL, 2805208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.676278', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1802, 'Pirambu', 'SE', NULL, NULL, NULL, 2805307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.677143', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1803, 'Poco Redondo', 'SE', NULL, NULL, NULL, 2805406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.67807', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1804, 'Poco Verde', 'SE', NULL, NULL, NULL, 2805505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.678996', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1805, 'Porto da Folha', 'SE', NULL, NULL, NULL, 2805604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.679867', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1806, 'Propria', 'SE', NULL, NULL, NULL, 2805703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.680723', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1807, 'Riachao do Dantas', 'SE', NULL, NULL, NULL, 2805802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.68163', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1808, 'Riachuelo', 'SE', NULL, NULL, NULL, 2805901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.68251', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1809, 'Ribeiropolis', 'SE', NULL, NULL, NULL, 2806008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.683399', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1810, 'Rosario do Catete', 'SE', NULL, NULL, NULL, 2806107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.684327', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1811, 'Salgado', 'SE', NULL, NULL, NULL, 2806206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.685208', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1812, 'Santa Luzia do Itanhy', 'SE', NULL, NULL, NULL, 2806305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.686053', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1814, 'Santana do Sao Francisco', 'SE', NULL, NULL, NULL, 2806404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.688243', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1813, 'Santa Rosa de Lima', 'SE', NULL, NULL, NULL, 2806503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.687431', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1815, 'Santo Amaro das Brotas', 'SE', NULL, NULL, NULL, 2806602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.689158', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1816, 'Sao Cristovao', 'SE', NULL, NULL, NULL, 2806701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.690023', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1817, 'Sao Domingos', 'SE', NULL, NULL, NULL, 2806800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.690888', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1818, 'Sao Francisco', 'SE', NULL, NULL, NULL, 2806909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.691767', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1819, 'Sao Miguel do Aleixo', 'SE', NULL, NULL, NULL, 2807006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.692583', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1820, 'Simao Dias', 'SE', NULL, NULL, NULL, 2807105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.693538', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1821, 'Siriri', 'SE', NULL, NULL, NULL, 2807204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.694316', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1822, 'Telha', 'SE', NULL, NULL, NULL, 2807303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.695302', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1823, 'Tobias Barreto', 'SE', NULL, NULL, NULL, 2807402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.696176', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1824, 'Tomar do Geru', 'SE', NULL, NULL, NULL, 2807501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.703912', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1825, 'Umbauba', 'SE', NULL, NULL, NULL, 2807600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.704998', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1826, 'Abaira', 'BA', NULL, NULL, NULL, 2900108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.705862', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1827, 'Abare', 'BA', NULL, NULL, NULL, 2900207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.706776', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1828, 'Acajutiba', 'BA', NULL, NULL, NULL, 2900306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.707772', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1829, 'Adustina', 'BA', NULL, NULL, NULL, 2900355, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.708678', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1830, 'Agua Fria', 'BA', NULL, NULL, NULL, 2900405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.709564', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1949, 'Erico Cardoso', 'BA', NULL, NULL, NULL, 2900504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.835874', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1831, 'Aiquara', 'BA', NULL, NULL, NULL, 2900603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.710453', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1832, 'Alagoinhas', 'BA', NULL, NULL, NULL, 2900702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.711342', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1833, 'Alcobaca', 'BA', NULL, NULL, NULL, 2900801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.712309', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1834, 'Almadina', 'BA', NULL, NULL, NULL, 2900900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.713183', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1835, 'Amargosa', 'BA', NULL, NULL, NULL, 2901007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.714102', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1836, 'Amelia Rodrigues', 'BA', NULL, NULL, NULL, 2901106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.714937', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1837, 'America Dourada', 'BA', NULL, NULL, NULL, 2901155, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.715822', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1838, 'Anage', 'BA', NULL, NULL, NULL, 2901205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.716687', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1839, 'Andarai', 'BA', NULL, NULL, NULL, 2901304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.717527', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1840, 'Andorinha', 'BA', NULL, NULL, NULL, 2901353, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.718396', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1841, 'Angical', 'BA', NULL, NULL, NULL, 2901403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.719204', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1842, 'Anguera', 'BA', NULL, NULL, NULL, 2901502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.720208', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1843, 'Antas', 'BA', NULL, NULL, NULL, 2901601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.720988', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1844, 'Antonio Cardoso', 'BA', NULL, NULL, NULL, 2901700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.721872', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1845, 'Antonio Goncalves', 'BA', NULL, NULL, NULL, 2901809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.72283', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1846, 'Apora', 'BA', NULL, NULL, NULL, 2901908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.723737', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1847, 'Apuarema', 'BA', NULL, NULL, NULL, 2901957, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.72468', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1849, 'Aracatu', 'BA', NULL, NULL, NULL, 2902005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.72638', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1848, 'Aracas', 'BA', NULL, NULL, NULL, 2902054, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.725609', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1850, 'Araci', 'BA', NULL, NULL, NULL, 2902104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.727157', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1851, 'Aramari', 'BA', NULL, NULL, NULL, 2902203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.727919', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1852, 'Arataca', 'BA', NULL, NULL, NULL, 2902252, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.728798', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1853, 'Aratuipe', 'BA', NULL, NULL, NULL, 2902302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.729676', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1854, 'Aurelino Leal', 'BA', NULL, NULL, NULL, 2902401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.730623', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1855, 'Baianopolis', 'BA', NULL, NULL, NULL, 2902500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.731629', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1856, 'Baixa Grande', 'BA', NULL, NULL, NULL, 2902609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.732415', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1857, 'Banzae', 'BA', NULL, NULL, NULL, 2902658, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.733268', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1858, 'Barra', 'BA', NULL, NULL, NULL, 2902708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.734163', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1859, 'Barra da Estiva', 'BA', NULL, NULL, NULL, 2902807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.735027', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1860, 'Barra do Choca', 'BA', NULL, NULL, NULL, 2902906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.735986', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1861, 'Barra do Mendes', 'BA', NULL, NULL, NULL, 2903003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.736784', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1862, 'Barra do Rocha', 'BA', NULL, NULL, NULL, 2903102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.737614', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1863, 'Barreiras', 'BA', NULL, NULL, NULL, 2903201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.743632', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1864, 'Barro Alto', 'BA', NULL, NULL, NULL, 2903235, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.745185', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1865, 'Barrocas', 'BA', NULL, NULL, NULL, 2903276, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.746183', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1866, 'Belmonte', 'BA', NULL, NULL, NULL, 2903409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.747082', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1867, 'Belo Campo', 'BA', NULL, NULL, NULL, 2903508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.747989', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1868, 'Biritinga', 'BA', NULL, NULL, NULL, 2903607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.748862', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1869, 'Boa Nova', 'BA', NULL, NULL, NULL, 2903706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.749789', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1870, 'Boa Vista do Tupim', 'BA', NULL, NULL, NULL, 2903805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.750607', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1871, 'Bom Jesus da Lapa', 'BA', NULL, NULL, NULL, 2903904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.7516', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1872, 'Bom Jesus da Serra', 'BA', NULL, NULL, NULL, 2903953, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.752527', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1873, 'Boninal', 'BA', NULL, NULL, NULL, 2904001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.753467', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1874, 'Bonito', 'BA', NULL, NULL, NULL, 2904050, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.754333', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1875, 'Boquira', 'BA', NULL, NULL, NULL, 2904100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.755177', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1876, 'Botupora', 'BA', NULL, NULL, NULL, 2904209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.756099', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1877, 'Brejoes', 'BA', NULL, NULL, NULL, 2904308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.756961', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1878, 'Brejolandia', 'BA', NULL, NULL, NULL, 2904407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.757913', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1879, 'Brotas de Macaubas', 'BA', NULL, NULL, NULL, 2904506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.758779', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1880, 'Brumado', 'BA', NULL, NULL, NULL, 2904605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.759633', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1881, 'Buerarema', 'BA', NULL, NULL, NULL, 2904704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.760497', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1882, 'Buritirama', 'BA', NULL, NULL, NULL, 2904753, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.761353', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1883, 'Caatiba', 'BA', NULL, NULL, NULL, 2904803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.762303', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1884, 'Cabaceiras do Paraguacu', 'BA', NULL, NULL, NULL, 2904852, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.763755', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1885, 'Cachoeira', 'BA', NULL, NULL, NULL, 2904902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.764694', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1886, 'Cacule', 'BA', NULL, NULL, NULL, 2905008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.765572', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1887, 'Caem', 'BA', NULL, NULL, NULL, 2905107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.766486', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1888, 'Caetanos', 'BA', NULL, NULL, NULL, 2905156, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.767347', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1889, 'Caetite', 'BA', NULL, NULL, NULL, 2905206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.768201', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1890, 'Cafarnaum', 'BA', NULL, NULL, NULL, 2905305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.769048', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1891, 'Cairu', 'BA', NULL, NULL, NULL, 2905404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.769993', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1892, 'Caldeirao Grande', 'BA', NULL, NULL, NULL, 2905503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.770885', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1893, 'Camacan', 'BA', NULL, NULL, NULL, 2905602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.771855', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1894, 'Camacari', 'BA', NULL, NULL, NULL, 2905701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.772719', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1895, 'Camamu', 'BA', NULL, NULL, NULL, 2905800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.773477', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1896, 'Campo Alegre de Lourdes', 'BA', NULL, NULL, NULL, 2905909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.774295', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1897, 'Campo Formoso', 'BA', NULL, NULL, NULL, 2906006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.775204', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1898, 'Canapolis', 'BA', NULL, NULL, NULL, 2906105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.776195', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1899, 'Canarana', 'BA', NULL, NULL, NULL, 2906204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.776955', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1900, 'Canavieiras', 'BA', NULL, NULL, NULL, 2906303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.777826', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1901, 'Candeal', 'BA', NULL, NULL, NULL, 2906402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.778621', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1902, 'Candeias', 'BA', NULL, NULL, NULL, 2906501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.785654', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1903, 'Candiba', 'BA', NULL, NULL, NULL, 2906600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.786875', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1904, 'Candido Sales', 'BA', NULL, NULL, NULL, 2906709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.787762', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1905, 'Cansancao', 'BA', NULL, NULL, NULL, 2906808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.788735', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1906, 'Canudos', 'BA', NULL, NULL, NULL, 2906824, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.789648', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1907, 'Capela do Alto Alegre', 'BA', NULL, NULL, NULL, 2906857, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.790552', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1908, 'Capim Grosso', 'BA', NULL, NULL, NULL, 2906873, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.791373', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1909, 'Caraibas', 'BA', NULL, NULL, NULL, 2906899, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.792368', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1910, 'Caravelas', 'BA', NULL, NULL, NULL, 2906907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.793239', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1911, 'Cardeal da Silva', 'BA', NULL, NULL, NULL, 2907004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.794153', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1912, 'Carinhanha', 'BA', NULL, NULL, NULL, 2907103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.795076', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1913, 'Casa Nova', 'BA', NULL, NULL, NULL, 2907202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.796126', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1914, 'Castro Alves', 'BA', NULL, NULL, NULL, 2907301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.797062', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1915, 'Catolandia', 'BA', NULL, NULL, NULL, 2907400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.797944', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1916, 'Catu', 'BA', NULL, NULL, NULL, 2907509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.798905', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1917, 'Caturama', 'BA', NULL, NULL, NULL, 2907558, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.799835', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1918, 'Central', 'BA', NULL, NULL, NULL, 2907608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.800762', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1919, 'Chorrocho', 'BA', NULL, NULL, NULL, 2907707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.801673', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1920, 'Cicero Dantas', 'BA', NULL, NULL, NULL, 2907806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.80256', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1921, 'Cipo', 'BA', NULL, NULL, NULL, 2907905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.803435', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1922, 'Coaraci', 'BA', NULL, NULL, NULL, 2908002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.804362', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1923, 'Cocos', 'BA', NULL, NULL, NULL, 2908101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.805142', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1924, 'Conceicao da Feira', 'BA', NULL, NULL, NULL, 2908200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.806049', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1925, 'Conceicao do Almeida', 'BA', NULL, NULL, NULL, 2908309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.80693', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1926, 'Conceicao do Coite', 'BA', NULL, NULL, NULL, 2908408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.807792', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1927, 'Conceicao do Jacuipe', 'BA', NULL, NULL, NULL, 2908507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.808715', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1928, 'Conde', 'BA', NULL, NULL, NULL, 2908606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.809636', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1929, 'Condeuba', 'BA', NULL, NULL, NULL, 2908705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.810398', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1930, 'Contendas do Sincora', 'BA', NULL, NULL, NULL, 2908804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.811224', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1931, 'Coracao de Maria', 'BA', NULL, NULL, NULL, 2908903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.812079', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1932, 'Cordeiros', 'BA', NULL, NULL, NULL, 2909000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.812982', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1933, 'Coribe', 'BA', NULL, NULL, NULL, 2909109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.81392', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1934, 'Coronel Joao Sa', 'BA', NULL, NULL, NULL, 2909208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.814844', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1935, 'Correntina', 'BA', NULL, NULL, NULL, 2909307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.815785', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1936, 'Cotegipe', 'BA', NULL, NULL, NULL, 2909406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.816686', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1937, 'Cravolandia', 'BA', NULL, NULL, NULL, 2909505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.817527', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1938, 'Crisopolis', 'BA', NULL, NULL, NULL, 2909604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.818343', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1939, 'Cristopolis', 'BA', NULL, NULL, NULL, 2909703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.819171', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1940, 'Cruz das Almas', 'BA', NULL, NULL, NULL, 2909802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.826554', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1941, 'Curaca', 'BA', NULL, NULL, NULL, 2909901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.827636', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1942, 'Dario Meira', 'BA', NULL, NULL, NULL, 2910008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.829405', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1943, 'Dias D''avila', 'BA', NULL, NULL, NULL, 2910057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.830489', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1944, 'Dom Basilio', 'BA', NULL, NULL, NULL, 2910107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.831352', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1945, 'Dom Macedo Costa', 'BA', NULL, NULL, NULL, 2910206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.83241', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1946, 'Elisio Medrado', 'BA', NULL, NULL, NULL, 2910305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.833251', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1947, 'Encruzilhada', 'BA', NULL, NULL, NULL, 2910404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.83412', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1948, 'Entre Rios', 'BA', NULL, NULL, NULL, 2910503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.835064', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1950, 'Esplanada', 'BA', NULL, NULL, NULL, 2910602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.836741', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1951, 'Euclides da Cunha', 'BA', NULL, NULL, NULL, 2910701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.837646', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1952, 'Eunapolis', 'BA', NULL, NULL, NULL, 2910727, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.838519', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1953, 'Fatima', 'BA', NULL, NULL, NULL, 2910750, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.839335', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1954, 'Feira da Mata', 'BA', NULL, NULL, NULL, 2910776, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.840193', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1955, 'Feira de Santana', 'BA', NULL, NULL, NULL, 2910800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.841117', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1956, 'Filadelfia', 'BA', NULL, NULL, NULL, 2910859, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.842011', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1957, 'Firmino Alves', 'BA', NULL, NULL, NULL, 2910909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.842944', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1958, 'Floresta Azul', 'BA', NULL, NULL, NULL, 2911006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.843755', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1959, 'Formosa do Rio Preto', 'BA', NULL, NULL, NULL, 2911105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.844635', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1960, 'Gandu', 'BA', NULL, NULL, NULL, 2911204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.845544', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1961, 'Gaviao', 'BA', NULL, NULL, NULL, 2911253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.846441', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1962, 'Gentio do Ouro', 'BA', NULL, NULL, NULL, 2911303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.847284', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1963, 'Gloria', 'BA', NULL, NULL, NULL, 2911402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.84819', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1964, 'Gongogi', 'BA', NULL, NULL, NULL, 2911501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.84909', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1966, 'Governador Mangabeira', 'BA', NULL, NULL, NULL, 2911600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.850857', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1967, 'Guajeru', 'BA', NULL, NULL, NULL, 2911659, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.85184', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1968, 'Guanambi', 'BA', NULL, NULL, NULL, 2911709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.852748', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1969, 'Guaratinga', 'BA', NULL, NULL, NULL, 2911808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.853646', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1970, 'Heliopolis', 'BA', NULL, NULL, NULL, 2911857, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.854517', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1971, 'Iacu', 'BA', NULL, NULL, NULL, 2911907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.855462', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1972, 'Ibiassuce', 'BA', NULL, NULL, NULL, 2912004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.856356', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1973, 'Ibicarai', 'BA', NULL, NULL, NULL, 2912103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.857175', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1974, 'Ibicoara', 'BA', NULL, NULL, NULL, 2912202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.858076', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1975, 'Ibicui', 'BA', NULL, NULL, NULL, 2912301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.858999', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1976, 'Ibipeba', 'BA', NULL, NULL, NULL, 2912400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.859993', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1977, 'Ibipitanga', 'BA', NULL, NULL, NULL, 2912509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.867007', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1978, 'Ibiquera', 'BA', NULL, NULL, NULL, 2912608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.868154', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1979, 'Ibirapitanga', 'BA', NULL, NULL, NULL, 2912707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.869284', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1980, 'Ibirapua', 'BA', NULL, NULL, NULL, 2912806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.870219', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1981, 'Ibirataia', 'BA', NULL, NULL, NULL, 2912905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.871155', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1982, 'Ibitiara', 'BA', NULL, NULL, NULL, 2913002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.872193', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1983, 'Ibitita', 'BA', NULL, NULL, NULL, 2913101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.873038', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1984, 'Ibotirama', 'BA', NULL, NULL, NULL, 2913200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.873833', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1985, 'Ichu', 'BA', NULL, NULL, NULL, 2913309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.874719', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1986, 'Igapora', 'BA', NULL, NULL, NULL, 2913408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.875578', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1987, 'Igrapiuna', 'BA', NULL, NULL, NULL, 2913457, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.876442', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1988, 'Iguai', 'BA', NULL, NULL, NULL, 2913507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.877337', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1989, 'Ilheus', 'BA', NULL, NULL, NULL, 2913606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.878226', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1990, 'Inhambupe', 'BA', NULL, NULL, NULL, 2913705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.87915', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1991, 'Ipecaeta', 'BA', NULL, NULL, NULL, 2913804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.880071', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1992, 'Ipiau', 'BA', NULL, NULL, NULL, 2913903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.880952', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1993, 'Ipira', 'BA', NULL, NULL, NULL, 2914000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.881831', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1994, 'Ipupiara', 'BA', NULL, NULL, NULL, 2914109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.882705', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1995, 'Irajuba', 'BA', NULL, NULL, NULL, 2914208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.883566', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1996, 'Iramaia', 'BA', NULL, NULL, NULL, 2914307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.88439', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1997, 'Iraquara', 'BA', NULL, NULL, NULL, 2914406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.885298', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1998, 'Irara', 'BA', NULL, NULL, NULL, 2914505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.886211', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (1999, 'Irece', 'BA', NULL, NULL, NULL, 2914604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.887131', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2000, 'Itabela', 'BA', NULL, NULL, NULL, 2914653, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.88815', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2001, 'Itaberaba', 'BA', NULL, NULL, NULL, 2914703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.888959', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2002, 'Itabuna', 'BA', NULL, NULL, NULL, 2914802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.889845', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2003, 'Itacare', 'BA', NULL, NULL, NULL, 2914901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.890749', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2004, 'Itaete', 'BA', NULL, NULL, NULL, 2915007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.891611', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2005, 'Itagi', 'BA', NULL, NULL, NULL, 2915106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.892478', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2006, 'Itagiba', 'BA', NULL, NULL, NULL, 2915205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.893317', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2007, 'Itagimirim', 'BA', NULL, NULL, NULL, 2915304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.894412', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2008, 'Itaguacu da Bahia', 'BA', NULL, NULL, NULL, 2915353, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.895374', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2009, 'Itaju do Colonia', 'BA', NULL, NULL, NULL, 2915403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.896523', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2010, 'Itajuipe', 'BA', NULL, NULL, NULL, 2915502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.897461', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2011, 'Itamaraju', 'BA', NULL, NULL, NULL, 2915601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.898265', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2012, 'Itamari', 'BA', NULL, NULL, NULL, 2915700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.89943', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2013, 'Itambe', 'BA', NULL, NULL, NULL, 2915809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.900314', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2014, 'Itanagra', 'BA', NULL, NULL, NULL, 2915908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.901209', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2015, 'Itanhem', 'BA', NULL, NULL, NULL, 2916005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.902022', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2016, 'Itaparica', 'BA', NULL, NULL, NULL, 2916104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.906287', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2017, 'Itape', 'BA', NULL, NULL, NULL, 2916203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.909995', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2018, 'Itapebi', 'BA', NULL, NULL, NULL, 2916302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.911146', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2019, 'Itapetinga', 'BA', NULL, NULL, NULL, 2916401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.911973', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2020, 'Itapicuru', 'BA', NULL, NULL, NULL, 2916500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.913016', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2021, 'Itapitanga', 'BA', NULL, NULL, NULL, 2916609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.913895', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2022, 'Itaquara', 'BA', NULL, NULL, NULL, 2916708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.914769', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2023, 'Itarantim', 'BA', NULL, NULL, NULL, 2916807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.915654', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2024, 'Itatim', 'BA', NULL, NULL, NULL, 2916856, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.916552', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2025, 'Itirucu', 'BA', NULL, NULL, NULL, 2916906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.917472', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2026, 'Itiuba', 'BA', NULL, NULL, NULL, 2917003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.918303', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2027, 'Itororo', 'BA', NULL, NULL, NULL, 2917102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.919192', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2028, 'Ituacu', 'BA', NULL, NULL, NULL, 2917201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.920019', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2029, 'Itubera', 'BA', NULL, NULL, NULL, 2917300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.920842', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2030, 'Iuiu', 'BA', NULL, NULL, NULL, 2917334, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.921738', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2031, 'Jaborandi', 'BA', NULL, NULL, NULL, 2917359, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.922718', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2032, 'Jacaraci', 'BA', NULL, NULL, NULL, 2917409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.923539', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2033, 'Jacobina', 'BA', NULL, NULL, NULL, 2917508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.92442', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2034, 'Jaguaquara', 'BA', NULL, NULL, NULL, 2917607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.925284', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2035, 'Jaguarari', 'BA', NULL, NULL, NULL, 2917706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.926186', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2036, 'Jaguaripe', 'BA', NULL, NULL, NULL, 2917805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.927091', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2037, 'Jandaira', 'BA', NULL, NULL, NULL, 2917904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.928038', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2038, 'Jequie', 'BA', NULL, NULL, NULL, 2918001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.928884', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2039, 'Jeremoabo', 'BA', NULL, NULL, NULL, 2918100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.929851', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2040, 'Jiquirica', 'BA', NULL, NULL, NULL, 2918209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.930853', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2041, 'Jitauna', 'BA', NULL, NULL, NULL, 2918308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.93178', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2042, 'Joao Dourado', 'BA', NULL, NULL, NULL, 2918357, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.932709', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2043, 'Juazeiro', 'BA', NULL, NULL, NULL, 2918407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.933661', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2044, 'Jucurucu', 'BA', NULL, NULL, NULL, 2918456, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.934595', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2045, 'Jussara', 'BA', NULL, NULL, NULL, 2918506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.935594', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2046, 'Jussari', 'BA', NULL, NULL, NULL, 2918555, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.93641', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2047, 'Jussiape', 'BA', NULL, NULL, NULL, 2918605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.937255', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2048, 'Lafaiete Coutinho', 'BA', NULL, NULL, NULL, 2918704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.938148', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2049, 'Lagoa Real', 'BA', NULL, NULL, NULL, 2918753, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.938963', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2050, 'Laje', 'BA', NULL, NULL, NULL, 2918803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.939756', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2051, 'Lajedao', 'BA', NULL, NULL, NULL, 2918902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.940684', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2052, 'Lajedinho', 'BA', NULL, NULL, NULL, 2919009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.941599', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2053, 'Lajedo do Tabocal', 'BA', NULL, NULL, NULL, 2919058, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.942474', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2054, 'Lamarao', 'BA', NULL, NULL, NULL, 2919108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.943451', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2055, 'Lapao', 'BA', NULL, NULL, NULL, 2919157, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.947684', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2056, 'Lauro de Freitas', 'BA', NULL, NULL, NULL, 2919207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.951579', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2057, 'Lencois', 'BA', NULL, NULL, NULL, 2919306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.952621', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2058, 'Licinio de Almeida', 'BA', NULL, NULL, NULL, 2919405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.953576', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2059, 'Livramento de Nossa Senhora', 'BA', NULL, NULL, NULL, 2919504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.954557', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2060, 'Luis Eduardo Magalhaes', 'BA', NULL, NULL, NULL, 2919553, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.955329', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2061, 'Macajuba', 'BA', NULL, NULL, NULL, 2919603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.956202', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2062, 'Macarani', 'BA', NULL, NULL, NULL, 2919702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.957096', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2063, 'Macaubas', 'BA', NULL, NULL, NULL, 2919801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.957889', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2064, 'Macurure', 'BA', NULL, NULL, NULL, 2919900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.958774', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2065, 'Madre de Deus', 'BA', NULL, NULL, NULL, 2919926, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.959587', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2066, 'Maetinga', 'BA', NULL, NULL, NULL, 2919959, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.960638', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2067, 'Maiquinique', 'BA', NULL, NULL, NULL, 2920007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.962121', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2068, 'Mairi', 'BA', NULL, NULL, NULL, 2920106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.963012', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2069, 'Malhada', 'BA', NULL, NULL, NULL, 2920205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.963901', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2070, 'Malhada de Pedras', 'BA', NULL, NULL, NULL, 2920304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.964883', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2071, 'Manoel Vitorino', 'BA', NULL, NULL, NULL, 2920403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.966277', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2072, 'Mansidao', 'BA', NULL, NULL, NULL, 2920452, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.967204', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2073, 'Maracas', 'BA', NULL, NULL, NULL, 2920502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.968095', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2074, 'Maragogipe', 'BA', NULL, NULL, NULL, 2920601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.968973', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2075, 'Marau', 'BA', NULL, NULL, NULL, 2920700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.969912', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2076, 'Marcionilio Souza', 'BA', NULL, NULL, NULL, 2920809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.970761', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2077, 'Mascote', 'BA', NULL, NULL, NULL, 2920908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.971642', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2078, 'Mata de Sao Joao', 'BA', NULL, NULL, NULL, 2921005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.972526', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2079, 'Matina', 'BA', NULL, NULL, NULL, 2921054, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.973388', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2080, 'Medeiros Neto', 'BA', NULL, NULL, NULL, 2921104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.974232', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2081, 'Miguel Calmon', 'BA', NULL, NULL, NULL, 2921203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.975182', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2082, 'Milagres', 'BA', NULL, NULL, NULL, 2921302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.976164', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2083, 'Mirangaba', 'BA', NULL, NULL, NULL, 2921401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.977016', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2084, 'Mirante', 'BA', NULL, NULL, NULL, 2921450, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.977772', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2085, 'Monte Santo', 'BA', NULL, NULL, NULL, 2921500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.978653', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2086, 'Morpara', 'BA', NULL, NULL, NULL, 2921609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.979569', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2087, 'Morro do Chapeu', 'BA', NULL, NULL, NULL, 2921708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.980474', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2088, 'Mortugaba', 'BA', NULL, NULL, NULL, 2921807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.981328', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2089, 'Mucuge', 'BA', NULL, NULL, NULL, 2921906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.982184', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2090, 'Mucuri', 'BA', NULL, NULL, NULL, 2922003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.982993', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2091, 'Mulungu do Morro', 'BA', NULL, NULL, NULL, 2922052, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.983851', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2092, 'Mundo Novo', 'BA', NULL, NULL, NULL, 2922102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.984848', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2093, 'Muniz Ferreira', 'BA', NULL, NULL, NULL, 2922201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.996997', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2094, 'Muquem de Sao Francisco', 'BA', NULL, NULL, NULL, 2922250, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.998112', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2095, 'Muritiba', 'BA', NULL, NULL, NULL, 2922300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.999036', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2096, 'Mutuipe', 'BA', NULL, NULL, NULL, 2922409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:35.999876', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2097, 'Nazare', 'BA', NULL, NULL, NULL, 2922508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.000716', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2098, 'Nilo Pecanha', 'BA', NULL, NULL, NULL, 2922607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.001605', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2099, 'Nordestina', 'BA', NULL, NULL, NULL, 2922656, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.002445', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2100, 'Nova Canaa', 'BA', NULL, NULL, NULL, 2922706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.003325', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2101, 'Nova Fatima', 'BA', NULL, NULL, NULL, 2922730, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.004235', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2102, 'Nova Ibia', 'BA', NULL, NULL, NULL, 2922755, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.005107', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2103, 'Nova Itarana', 'BA', NULL, NULL, NULL, 2922805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.006013', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2104, 'Nova Redencao', 'BA', NULL, NULL, NULL, 2922854, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.006882', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2105, 'Nova Soure', 'BA', NULL, NULL, NULL, 2922904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.007768', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2106, 'Nova Vicosa', 'BA', NULL, NULL, NULL, 2923001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.008715', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2107, 'Novo Horizonte', 'BA', NULL, NULL, NULL, 2923035, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.009609', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2108, 'Novo Triunfo', 'BA', NULL, NULL, NULL, 2923050, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.01077', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2109, 'Olindina', 'BA', NULL, NULL, NULL, 2923100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.011563', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2110, 'Oliveira dos Brejinhos', 'BA', NULL, NULL, NULL, 2923209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.012481', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2111, 'Ouricangas', 'BA', NULL, NULL, NULL, 2923308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.013345', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2112, 'Ourolandia', 'BA', NULL, NULL, NULL, 2923357, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.014162', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2113, 'Palmas de Monte Alto', 'BA', NULL, NULL, NULL, 2923407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.015029', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2114, 'Palmeiras', 'BA', NULL, NULL, NULL, 2923506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.015951', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2115, 'Paramirim', 'BA', NULL, NULL, NULL, 2923605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.016875', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2116, 'Paratinga', 'BA', NULL, NULL, NULL, 2923704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.017719', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2117, 'Paripiranga', 'BA', NULL, NULL, NULL, 2923803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.018511', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2118, 'Pau Brasil', 'BA', NULL, NULL, NULL, 2923902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.019288', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2119, 'Paulo Afonso', 'BA', NULL, NULL, NULL, 2924009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.020202', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2120, 'Pe de Serra', 'BA', NULL, NULL, NULL, 2924058, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.021133', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2121, 'Pedrao', 'BA', NULL, NULL, NULL, 2924108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.022051', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2122, 'Pedro Alexandre', 'BA', NULL, NULL, NULL, 2924207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.022977', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2123, 'Piata', 'BA', NULL, NULL, NULL, 2924306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.023897', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2124, 'Pilao Arcado', 'BA', NULL, NULL, NULL, 2924405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.024776', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2125, 'Pindai', 'BA', NULL, NULL, NULL, 2924504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.025676', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2126, 'Pindobacu', 'BA', NULL, NULL, NULL, 2924603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.026444', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2127, 'Pintadas', 'BA', NULL, NULL, NULL, 2924652, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.027298', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2128, 'Pirai do Norte', 'BA', NULL, NULL, NULL, 2924678, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.028163', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2129, 'Piripa', 'BA', NULL, NULL, NULL, 2924702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.028991', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2130, 'Piritiba', 'BA', NULL, NULL, NULL, 2924801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.02981', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2131, 'Planaltino', 'BA', NULL, NULL, NULL, 2924900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.030618', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2132, 'Planalto', 'BA', NULL, NULL, NULL, 2925006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.037238', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2133, 'Pocoes', 'BA', NULL, NULL, NULL, 2925105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.038394', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2134, 'Pojuca', 'BA', NULL, NULL, NULL, 2925204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.039305', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2135, 'Ponto Novo', 'BA', NULL, NULL, NULL, 2925253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.040288', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2136, 'Porto Seguro', 'BA', NULL, NULL, NULL, 2925303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.041156', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2137, 'Potiragua', 'BA', NULL, NULL, NULL, 2925402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.042018', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2138, 'Prado', 'BA', NULL, NULL, NULL, 2925501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.042931', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2139, 'Presidente Dutra', 'BA', NULL, NULL, NULL, 2925600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.04386', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2140, 'Presidente Janio Quadros', 'BA', NULL, NULL, NULL, 2925709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.044678', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2141, 'Presidente Tancredo Neves', 'BA', NULL, NULL, NULL, 2925758, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.045568', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2142, 'Queimadas', 'BA', NULL, NULL, NULL, 2925808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.046592', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2143, 'Quijingue', 'BA', NULL, NULL, NULL, 2925907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.047491', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2144, 'Quixabeira', 'BA', NULL, NULL, NULL, 2925931, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.04839', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2145, 'Rafael Jambeiro', 'BA', NULL, NULL, NULL, 2925956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.049242', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2146, 'Remanso', 'BA', NULL, NULL, NULL, 2926004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.050108', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2147, 'Retirolandia', 'BA', NULL, NULL, NULL, 2926103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.051116', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2148, 'Riachao das Neves', 'BA', NULL, NULL, NULL, 2926202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.051964', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2149, 'Riachao do Jacuipe', 'BA', NULL, NULL, NULL, 2926301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.052816', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2150, 'Riacho de Santana', 'BA', NULL, NULL, NULL, 2926400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.053696', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2151, 'Ribeira do Amparo', 'BA', NULL, NULL, NULL, 2926509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.054615', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2152, 'Ribeira do Pombal', 'BA', NULL, NULL, NULL, 2926608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.055463', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2153, 'Ribeirao do Largo', 'BA', NULL, NULL, NULL, 2926657, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.05629', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2154, 'Rio de Contas', 'BA', NULL, NULL, NULL, 2926707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.057205', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2155, 'Rio do Antonio', 'BA', NULL, NULL, NULL, 2926806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.058091', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2156, 'Rio do Pires', 'BA', NULL, NULL, NULL, 2926905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.059061', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2157, 'Rio Real', 'BA', NULL, NULL, NULL, 2927002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.0599', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2158, 'Rodelas', 'BA', NULL, NULL, NULL, 2927101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.060828', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2159, 'Ruy Barbosa', 'BA', NULL, NULL, NULL, 2927200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.061686', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2160, 'Salinas da Margarida', 'BA', NULL, NULL, NULL, 2927309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.062613', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2161, 'Salvador', 'BA', NULL, NULL, NULL, 2927408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.063432', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2162, 'Santa Barbara', 'BA', NULL, NULL, NULL, 2927507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.064199', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2163, 'Santa Brigida', 'BA', NULL, NULL, NULL, 2927606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.065113', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2164, 'Santa Cruz Cabralia', 'BA', NULL, NULL, NULL, 2927705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.066096', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2165, 'Santa Cruz da Vitoria', 'BA', NULL, NULL, NULL, 2927804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.066868', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2166, 'Santa Ines', 'BA', NULL, NULL, NULL, 2927903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.067781', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2171, 'Santaluz', 'BA', NULL, NULL, NULL, 2928000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.081182', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2167, 'Santa Luzia', 'BA', NULL, NULL, NULL, 2928059, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.068555', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2168, 'Santa Maria da Vitoria', 'BA', NULL, NULL, NULL, 2928109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.069542', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2172, 'Santana', 'BA', NULL, NULL, NULL, 2928208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.082258', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2173, 'Santanopolis', 'BA', NULL, NULL, NULL, 2928307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.083118', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2169, 'Santa Rita de Cassia', 'BA', NULL, NULL, NULL, 2928406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.070478', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2170, 'Santa Teresinha', 'BA', NULL, NULL, NULL, 2928505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.071319', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2174, 'Santo Amaro', 'BA', NULL, NULL, NULL, 2928604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.083992', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2175, 'Santo Antonio de Jesus', 'BA', NULL, NULL, NULL, 2928703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.084795', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2176, 'Santo Estevao', 'BA', NULL, NULL, NULL, 2928802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.085639', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2177, 'Sao Desiderio', 'BA', NULL, NULL, NULL, 2928901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.086513', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2178, 'Sao Domingos', 'BA', NULL, NULL, NULL, 2928950, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.087428', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2180, 'Sao Felix', 'BA', NULL, NULL, NULL, 2929008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.089086', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2181, 'Sao Felix do Coribe', 'BA', NULL, NULL, NULL, 2929057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.089995', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2179, 'Sao Felipe', 'BA', NULL, NULL, NULL, 2929107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.088306', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2182, 'Sao Francisco do Conde', 'BA', NULL, NULL, NULL, 2929206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.09092', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2183, 'Sao Gabriel', 'BA', NULL, NULL, NULL, 2929255, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.091797', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2184, 'Sao Goncalo dos Campos', 'BA', NULL, NULL, NULL, 2929305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.092756', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2185, 'Sao Jose da Vitoria', 'BA', NULL, NULL, NULL, 2929354, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.093833', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2186, 'Sao Jose do Jacuipe', 'BA', NULL, NULL, NULL, 2929370, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.094768', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2187, 'Sao Miguel das Matas', 'BA', NULL, NULL, NULL, 2929404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.095662', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2188, 'Sao Sebastiao do Passe', 'BA', NULL, NULL, NULL, 2929503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.096542', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2189, 'Sapeacu', 'BA', NULL, NULL, NULL, 2929602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.09736', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2190, 'Satiro Dias', 'BA', NULL, NULL, NULL, 2929701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.09819', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2191, 'Saubara', 'BA', NULL, NULL, NULL, 2929750, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.099108', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2192, 'Saude', 'BA', NULL, NULL, NULL, 2929800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.100012', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2193, 'Seabra', 'BA', NULL, NULL, NULL, 2929909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.100826', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2194, 'Sebastiao Laranjeiras', 'BA', NULL, NULL, NULL, 2930006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.101718', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2195, 'Senhor do Bonfim', 'BA', NULL, NULL, NULL, 2930105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.102614', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2197, 'Serra do Ramalho', 'BA', NULL, NULL, NULL, 2930154, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.10448', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2196, 'Sento Se', 'BA', NULL, NULL, NULL, 2930204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.103547', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2198, 'Serra Dourada', 'BA', NULL, NULL, NULL, 2930303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.105375', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2199, 'Serra Preta', 'BA', NULL, NULL, NULL, 2930402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.106273', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2200, 'Serrinha', 'BA', NULL, NULL, NULL, 2930501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.107175', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2201, 'Serrolandia', 'BA', NULL, NULL, NULL, 2930600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.108078', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2202, 'Simoes Filho', 'BA', NULL, NULL, NULL, 2930709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.108929', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2203, 'Sitio do Mato', 'BA', NULL, NULL, NULL, 2930758, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.109993', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2204, 'Sitio do Quinto', 'BA', NULL, NULL, NULL, 2930766, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.11146', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2205, 'Sobradinho', 'BA', NULL, NULL, NULL, 2930774, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.112381', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2206, 'Souto Soares', 'BA', NULL, NULL, NULL, 2930808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.113153', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2207, 'Tabocas do Brejo Velho', 'BA', NULL, NULL, NULL, 2930907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.113976', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2208, 'Tanhacu', 'BA', NULL, NULL, NULL, 2931004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.114785', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2209, 'Tanque Novo', 'BA', NULL, NULL, NULL, 2931053, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.121459', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2210, 'Tanquinho', 'BA', NULL, NULL, NULL, 2931103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.122594', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2211, 'Taperoa', 'BA', NULL, NULL, NULL, 2931202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.123519', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2212, 'Tapiramuta', 'BA', NULL, NULL, NULL, 2931301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.124406', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2213, 'Teixeira de Freitas', 'BA', NULL, NULL, NULL, 2931350, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.125229', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2214, 'Teodoro Sampaio', 'BA', NULL, NULL, NULL, 2931400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.126164', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2215, 'Teofilandia', 'BA', NULL, NULL, NULL, 2931509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.127128', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2216, 'Teolandia', 'BA', NULL, NULL, NULL, 2931608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.128089', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2217, 'Terra Nova', 'BA', NULL, NULL, NULL, 2931707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.129228', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2218, 'Tremedal', 'BA', NULL, NULL, NULL, 2931806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.130582', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2219, 'Tucano', 'BA', NULL, NULL, NULL, 2931905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.132366', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2220, 'Uaua', 'BA', NULL, NULL, NULL, 2932002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.133639', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2221, 'Ubaira', 'BA', NULL, NULL, NULL, 2932101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.134487', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2222, 'Ubaitaba', 'BA', NULL, NULL, NULL, 2932200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.135357', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2223, 'Ubata', 'BA', NULL, NULL, NULL, 2932309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.136179', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2224, 'Uibai', 'BA', NULL, NULL, NULL, 2932408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.136978', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2225, 'Umburanas', 'BA', NULL, NULL, NULL, 2932457, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.137875', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2226, 'Una', 'BA', NULL, NULL, NULL, 2932507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.138736', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2227, 'Urandi', 'BA', NULL, NULL, NULL, 2932606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.139603', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2228, 'Urucuca', 'BA', NULL, NULL, NULL, 2932705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.14047', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2229, 'Utinga', 'BA', NULL, NULL, NULL, 2932804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.14136', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2230, 'Valenca', 'BA', NULL, NULL, NULL, 2932903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.142211', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2231, 'Valente', 'BA', NULL, NULL, NULL, 2933000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.143101', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2232, 'Varzea da Roca', 'BA', NULL, NULL, NULL, 2933059, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.144044', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2233, 'Varzea do Poco', 'BA', NULL, NULL, NULL, 2933109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.145026', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2234, 'Varzea Nova', 'BA', NULL, NULL, NULL, 2933158, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.145932', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2235, 'Varzedo', 'BA', NULL, NULL, NULL, 2933174, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.146908', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2236, 'Vera Cruz', 'BA', NULL, NULL, NULL, 2933208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.147866', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2237, 'Vereda', 'BA', NULL, NULL, NULL, 2933257, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.148738', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2238, 'Vitoria da Conquista', 'BA', NULL, NULL, NULL, 2933307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.149664', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2239, 'Wagner', 'BA', NULL, NULL, NULL, 2933406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.150535', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2240, 'Wanderley', 'BA', NULL, NULL, NULL, 2933455, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.151529', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2241, 'Wenceslau Guimaraes', 'BA', NULL, NULL, NULL, 2933505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.152442', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2242, 'Xique-xique', 'BA', NULL, NULL, NULL, 2933604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.153258', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2243, 'Abadia dos Dourados', 'MG', NULL, NULL, NULL, 3100104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.154189', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2244, 'Abaete', 'MG', NULL, NULL, NULL, 3100203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.155248', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2245, 'Abre Campo', 'MG', NULL, NULL, NULL, 3100302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.158797', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2246, 'Acaiaca', 'MG', NULL, NULL, NULL, 3100401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.164872', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2247, 'Acucena', 'MG', NULL, NULL, NULL, 3100500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.166041', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2248, 'Agua Boa', 'MG', NULL, NULL, NULL, 3100609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.166914', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2249, 'Agua Comprida', 'MG', NULL, NULL, NULL, 3100708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.167694', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2250, 'Aguanil', 'MG', NULL, NULL, NULL, 3100807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.168652', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2251, 'Aguas Formosas', 'MG', NULL, NULL, NULL, 3100906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.169451', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2252, 'Aguas Vermelhas', 'MG', NULL, NULL, NULL, 3101003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.170365', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2253, 'Aimores', 'MG', NULL, NULL, NULL, 3101102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.171249', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2254, 'Aiuruoca', 'MG', NULL, NULL, NULL, 3101201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.172198', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2255, 'Alagoa', 'MG', NULL, NULL, NULL, 3101300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.17309', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2256, 'Albertina', 'MG', NULL, NULL, NULL, 3101409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.174065', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2257, 'Alem Paraiba', 'MG', NULL, NULL, NULL, 3101508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.175052', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2258, 'Alfenas', 'MG', NULL, NULL, NULL, 3101607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.176142', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2259, 'Alfredo Vasconcelos', 'MG', NULL, NULL, NULL, 3101631, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.177086', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2260, 'Almenara', 'MG', NULL, NULL, NULL, 3101706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.17799', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2261, 'Alpercata', 'MG', NULL, NULL, NULL, 3101805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.178942', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2262, 'Alpinopolis', 'MG', NULL, NULL, NULL, 3101904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.179848', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2263, 'Alterosa', 'MG', NULL, NULL, NULL, 3102001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.180759', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2264, 'Alto Caparao', 'MG', NULL, NULL, NULL, 3102050, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.181657', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2266, 'Alto Rio Doce', 'MG', NULL, NULL, NULL, 3102100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.183515', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2267, 'Alvarenga', 'MG', NULL, NULL, NULL, 3102209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.184402', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2268, 'Alvinopolis', 'MG', NULL, NULL, NULL, 3102308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.185229', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2269, 'Alvorada de Minas', 'MG', NULL, NULL, NULL, 3102407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.186152', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2270, 'Amparo do Serra', 'MG', NULL, NULL, NULL, 3102506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.187321', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2271, 'Andradas', 'MG', NULL, NULL, NULL, 3102605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.188228', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2349, 'Cachoeira de Pajeu', 'MG', NULL, NULL, NULL, 3102704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.269483', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2272, 'Andrelandia', 'MG', NULL, NULL, NULL, 3102803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.189253', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2273, 'Angelandia', 'MG', NULL, NULL, NULL, 3102852, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.190148', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2274, 'Antonio Carlos', 'MG', NULL, NULL, NULL, 3102902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.19103', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2275, 'Antonio Dias', 'MG', NULL, NULL, NULL, 3103009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.191859', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2276, 'Antonio Prado de Minas', 'MG', NULL, NULL, NULL, 3103108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.192799', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2277, 'Aracai', 'MG', NULL, NULL, NULL, 3103207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.193762', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2278, 'Aracitaba', 'MG', NULL, NULL, NULL, 3103306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.194635', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2279, 'Aracuai', 'MG', NULL, NULL, NULL, 3103405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.195558', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2280, 'Araguari', 'MG', NULL, NULL, NULL, 3103504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.196367', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2281, 'Arantina', 'MG', NULL, NULL, NULL, 3103603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.197243', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2282, 'Araponga', 'MG', NULL, NULL, NULL, 3103702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.198178', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2283, 'Arapora', 'MG', NULL, NULL, NULL, 3103751, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.203217', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2284, 'Arapua', 'MG', NULL, NULL, NULL, 3103801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.205244', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2285, 'Araujos', 'MG', NULL, NULL, NULL, 3103900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.206219', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2286, 'Araxa', 'MG', NULL, NULL, NULL, 3104007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.207117', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2287, 'Arceburgo', 'MG', NULL, NULL, NULL, 3104106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.207902', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2288, 'Arcos', 'MG', NULL, NULL, NULL, 3104205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.208814', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2289, 'Areado', 'MG', NULL, NULL, NULL, 3104304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.209723', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2290, 'Argirita', 'MG', NULL, NULL, NULL, 3104403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.210605', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2291, 'Aricanduva', 'MG', NULL, NULL, NULL, 3104452, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.211483', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2292, 'Arinos', 'MG', NULL, NULL, NULL, 3104502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.212377', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2293, 'Astolfo Dutra', 'MG', NULL, NULL, NULL, 3104601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.213327', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2294, 'Ataleia', 'MG', NULL, NULL, NULL, 3104700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.214154', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2295, 'Augusto de Lima', 'MG', NULL, NULL, NULL, 3104809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.21493', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2296, 'Baependi', 'MG', NULL, NULL, NULL, 3104908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.215936', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2297, 'Baldim', 'MG', NULL, NULL, NULL, 3105004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.216871', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2298, 'Bambui', 'MG', NULL, NULL, NULL, 3105103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.217768', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2299, 'Bandeira', 'MG', NULL, NULL, NULL, 3105202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.218649', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2300, 'Bandeira do Sul', 'MG', NULL, NULL, NULL, 3105301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.219508', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2301, 'Barao de Cocais', 'MG', NULL, NULL, NULL, 3105400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.220377', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2302, 'Barao de Monte Alto', 'MG', NULL, NULL, NULL, 3105509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.221268', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2303, 'Barbacena', 'MG', NULL, NULL, NULL, 3105608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.222198', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2304, 'Barra Longa', 'MG', NULL, NULL, NULL, 3105707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.223036', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2305, 'Barroso', 'MG', NULL, NULL, NULL, 3105905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.22391', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2306, 'Bela Vista de Minas', 'MG', NULL, NULL, NULL, 3106002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.224974', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2307, 'Belmiro Braga', 'MG', NULL, NULL, NULL, 3106101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.225963', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2308, 'Belo Horizonte', 'MG', NULL, NULL, NULL, 3106200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.227024', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2309, 'Belo Oriente', 'MG', NULL, NULL, NULL, 3106309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.227973', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2310, 'Belo Vale', 'MG', NULL, NULL, NULL, 3106408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.228893', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2311, 'Berilo', 'MG', NULL, NULL, NULL, 3106507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.229677', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2313, 'Bertopolis', 'MG', NULL, NULL, NULL, 3106606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.23149', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2312, 'Berizal', 'MG', NULL, NULL, NULL, 3106655, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.230571', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2314, 'Betim', 'MG', NULL, NULL, NULL, 3106705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.232321', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2315, 'Bias Fortes', 'MG', NULL, NULL, NULL, 3106804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.233321', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2316, 'Bicas', 'MG', NULL, NULL, NULL, 3106903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.23414', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2317, 'Biquinhas', 'MG', NULL, NULL, NULL, 3107000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.234928', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2318, 'Boa Esperanca', 'MG', NULL, NULL, NULL, 3107109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.235855', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2319, 'Bocaina de Minas', 'MG', NULL, NULL, NULL, 3107208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.236779', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2320, 'Bocaiuva', 'MG', NULL, NULL, NULL, 3107307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.23773', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2321, 'Bom Despacho', 'MG', NULL, NULL, NULL, 3107406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.23865', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2322, 'Bom Jardim de Minas', 'MG', NULL, NULL, NULL, 3107505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.239378', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2323, 'Bom Jesus da Penha', 'MG', NULL, NULL, NULL, 3107604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.245946', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2324, 'Bom Jesus do Amparo', 'MG', NULL, NULL, NULL, 3107703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.246959', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2325, 'Bom Jesus do Galho', 'MG', NULL, NULL, NULL, 3107802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.247908', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2326, 'Bom Repouso', 'MG', NULL, NULL, NULL, 3107901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.248786', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2327, 'Bom Sucesso', 'MG', NULL, NULL, NULL, 3108008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.249675', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2328, 'Bonfim', 'MG', NULL, NULL, NULL, 3108107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.250542', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2329, 'Bonfinopolis de Minas', 'MG', NULL, NULL, NULL, 3108206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.251343', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2330, 'Bonito de Minas', 'MG', NULL, NULL, NULL, 3108255, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.252162', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2331, 'Borda da Mata', 'MG', NULL, NULL, NULL, 3108305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.253039', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2332, 'Botelhos', 'MG', NULL, NULL, NULL, 3108404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.253931', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2333, 'Botumirim', 'MG', NULL, NULL, NULL, 3108503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.254856', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2335, 'Brasilandia de Minas', 'MG', NULL, NULL, NULL, 3108552, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.256563', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2336, 'Brasilia de Minas', 'MG', NULL, NULL, NULL, 3108602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.257427', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2334, 'Bras Pires', 'MG', NULL, NULL, NULL, 3108701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.255745', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2338, 'Braunas', 'MG', NULL, NULL, NULL, 3108800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.259273', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2339, 'Brumadinho', 'MG', NULL, NULL, NULL, 3109006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.260042', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2340, 'Bueno Brandao', 'MG', NULL, NULL, NULL, 3109105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.260966', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2341, 'Buenopolis', 'MG', NULL, NULL, NULL, 3109204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.261895', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2342, 'Bugre', 'MG', NULL, NULL, NULL, 3109253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.262933', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2343, 'Buritis', 'MG', NULL, NULL, NULL, 3109303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.263793', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2344, 'Buritizeiro', 'MG', NULL, NULL, NULL, 3109402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.264812', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2345, 'Cabeceira Grande', 'MG', NULL, NULL, NULL, 3109451, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.265722', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2346, 'Cabo Verde', 'MG', NULL, NULL, NULL, 3109501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.266748', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2347, 'Cachoeira da Prata', 'MG', NULL, NULL, NULL, 3109600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.267638', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2348, 'Cachoeira de Minas', 'MG', NULL, NULL, NULL, 3109709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.268607', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2350, 'Cachoeira Dourada', 'MG', NULL, NULL, NULL, 3109808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.270382', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2351, 'Caetanopolis', 'MG', NULL, NULL, NULL, 3109907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.271481', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2352, 'Caete', 'MG', NULL, NULL, NULL, 3110004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.272398', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2353, 'Caiana', 'MG', NULL, NULL, NULL, 3110103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.273259', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2354, 'Cajuri', 'MG', NULL, NULL, NULL, 3110202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.274121', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2355, 'Caldas', 'MG', NULL, NULL, NULL, 3110301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.275028', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2356, 'Camacho', 'MG', NULL, NULL, NULL, 3110400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.275929', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2357, 'Camanducaia', 'MG', NULL, NULL, NULL, 3110509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.27681', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2358, 'Cambui', 'MG', NULL, NULL, NULL, 3110608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.277738', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2359, 'Cambuquira', 'MG', NULL, NULL, NULL, 3110707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.278606', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2360, 'Campanario', 'MG', NULL, NULL, NULL, 3110806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.279653', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2361, 'Campanha', 'MG', NULL, NULL, NULL, 3110905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.28044', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2362, 'Campestre', 'MG', NULL, NULL, NULL, 3111002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.286607', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2363, 'Campina Verde', 'MG', NULL, NULL, NULL, 3111101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.287827', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2364, 'Campo Azul', 'MG', NULL, NULL, NULL, 3111150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.288775', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2365, 'Campo Belo', 'MG', NULL, NULL, NULL, 3111200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.289665', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2366, 'Campo do Meio', 'MG', NULL, NULL, NULL, 3111309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.290592', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2367, 'Campo Florido', 'MG', NULL, NULL, NULL, 3111408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.291403', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2368, 'Campos Altos', 'MG', NULL, NULL, NULL, 3111507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.292443', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2369, 'Campos Gerais', 'MG', NULL, NULL, NULL, 3111606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.293274', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2371, 'Canaa', 'MG', NULL, NULL, NULL, 3111705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.295135', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2372, 'Canapolis', 'MG', NULL, NULL, NULL, 3111804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.296192', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2370, 'Cana Verde', 'MG', NULL, NULL, NULL, 3111903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.294208', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2373, 'Candeias', 'MG', NULL, NULL, NULL, 3112000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.297115', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2374, 'Cantagalo', 'MG', NULL, NULL, NULL, 3112059, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.297958', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2375, 'Caparao', 'MG', NULL, NULL, NULL, 3112109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.298869', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2376, 'Capela Nova', 'MG', NULL, NULL, NULL, 3112208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.299725', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2377, 'Capelinha', 'MG', NULL, NULL, NULL, 3112307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.300742', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2378, 'Capetinga', 'MG', NULL, NULL, NULL, 3112406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.301628', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2379, 'Capim Branco', 'MG', NULL, NULL, NULL, 3112505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.302484', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2380, 'Capinopolis', 'MG', NULL, NULL, NULL, 3112604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.303332', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2381, 'Capitao Andrade', 'MG', NULL, NULL, NULL, 3112653, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.304204', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2382, 'Capitao Eneas', 'MG', NULL, NULL, NULL, 3112703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.304996', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2383, 'Capitolio', 'MG', NULL, NULL, NULL, 3112802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.305772', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2384, 'Caputira', 'MG', NULL, NULL, NULL, 3112901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.306769', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2385, 'Carai', 'MG', NULL, NULL, NULL, 3113008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.307704', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2386, 'Caranaiba', 'MG', NULL, NULL, NULL, 3113107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.308589', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2387, 'Carandai', 'MG', NULL, NULL, NULL, 3113206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.309503', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2388, 'Carangola', 'MG', NULL, NULL, NULL, 3113305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.310414', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2389, 'Caratinga', 'MG', NULL, NULL, NULL, 3113404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.311411', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2390, 'Carbonita', 'MG', NULL, NULL, NULL, 3113503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.312275', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2391, 'Careacu', 'MG', NULL, NULL, NULL, 3113602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.313165', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2392, 'Carlos Chagas', 'MG', NULL, NULL, NULL, 3113701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.313963', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2393, 'Carmesia', 'MG', NULL, NULL, NULL, 3113800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.31478', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2394, 'Carmo da Cachoeira', 'MG', NULL, NULL, NULL, 3113909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.31565', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2395, 'Carmo da Mata', 'MG', NULL, NULL, NULL, 3114006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.316547', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2396, 'Carmo de Minas', 'MG', NULL, NULL, NULL, 3114105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.317444', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2397, 'Carmo do Cajuru', 'MG', NULL, NULL, NULL, 3114204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.318302', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2398, 'Carmo do Paranaiba', 'MG', NULL, NULL, NULL, 3114303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.319164', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2399, 'Carmo do Rio Claro', 'MG', NULL, NULL, NULL, 3114402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.320006', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2400, 'Carmopolis de Minas', 'MG', NULL, NULL, NULL, 3114501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.326946', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2401, 'Carneirinho', 'MG', NULL, NULL, NULL, 3114550, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.328069', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2402, 'Carrancas', 'MG', NULL, NULL, NULL, 3114600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.328901', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2403, 'Carvalhopolis', 'MG', NULL, NULL, NULL, 3114709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.329932', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2404, 'Carvalhos', 'MG', NULL, NULL, NULL, 3114808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.33101', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2405, 'Casa Grande', 'MG', NULL, NULL, NULL, 3114907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.331982', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2406, 'Cascalho Rico', 'MG', NULL, NULL, NULL, 3115003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.333627', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2407, 'Cassia', 'MG', NULL, NULL, NULL, 3115102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.334661', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2431, 'Conceicao da Barra de Minas', 'MG', NULL, NULL, NULL, 3115201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.356084', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2408, 'Cataguases', 'MG', NULL, NULL, NULL, 3115300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.335576', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2409, 'Catas Altas', 'MG', NULL, NULL, NULL, 3115359, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.336441', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2410, 'Catas Altas da Noruega', 'MG', NULL, NULL, NULL, 3115409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.337408', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2411, 'Catuji', 'MG', NULL, NULL, NULL, 3115458, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.338303', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2412, 'Catuti', 'MG', NULL, NULL, NULL, 3115474, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.339177', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2413, 'Caxambu', 'MG', NULL, NULL, NULL, 3115508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.340022', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2414, 'Cedro do Abaete', 'MG', NULL, NULL, NULL, 3115607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.3409', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2415, 'Central de Minas', 'MG', NULL, NULL, NULL, 3115706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.341802', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2416, 'Centralina', 'MG', NULL, NULL, NULL, 3115805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.342707', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2417, 'Chacara', 'MG', NULL, NULL, NULL, 3115904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.343615', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2418, 'Chale', 'MG', NULL, NULL, NULL, 3116001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.344519', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2419, 'Chapada do Norte', 'MG', NULL, NULL, NULL, 3116100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.345402', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2420, 'Chapada Gaucha', 'MG', NULL, NULL, NULL, 3116159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.346221', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2421, 'Chiador', 'MG', NULL, NULL, NULL, 3116209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.347172', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2422, 'Cipotanea', 'MG', NULL, NULL, NULL, 3116308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.348109', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2423, 'Claraval', 'MG', NULL, NULL, NULL, 3116407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.349067', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2424, 'Claro dos Pocoes', 'MG', NULL, NULL, NULL, 3116506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.349954', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2425, 'Claudio', 'MG', NULL, NULL, NULL, 3116605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.350815', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2426, 'Coimbra', 'MG', NULL, NULL, NULL, 3116704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.351681', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2427, 'Coluna', 'MG', NULL, NULL, NULL, 3116803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.352366', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2428, 'Comendador Gomes', 'MG', NULL, NULL, NULL, 3116902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.353256', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2429, 'Comercinho', 'MG', NULL, NULL, NULL, 3117009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.354197', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2430, 'Conceicao da Aparecida', 'MG', NULL, NULL, NULL, 3117108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.355049', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2433, 'Conceicao das Pedras', 'MG', NULL, NULL, NULL, 3117207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.357787', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2432, 'Conceicao das Alagoas', 'MG', NULL, NULL, NULL, 3117306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.356889', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2434, 'Conceicao de Ipanema', 'MG', NULL, NULL, NULL, 3117405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.358793', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2435, 'Conceicao do Mato Dentro', 'MG', NULL, NULL, NULL, 3117504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.35965', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2436, 'Conceicao do Para', 'MG', NULL, NULL, NULL, 3117603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.360602', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2437, 'Conceicao do Rio Verde', 'MG', NULL, NULL, NULL, 3117702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.367362', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2438, 'Conceicao dos Ouros', 'MG', NULL, NULL, NULL, 3117801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.368535', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2439, 'Conego Marinho', 'MG', NULL, NULL, NULL, 3117836, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.369512', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2440, 'Confins', 'MG', NULL, NULL, NULL, 3117876, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.370463', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2441, 'Congonhal', 'MG', NULL, NULL, NULL, 3117900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.371375', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2442, 'Congonhas', 'MG', NULL, NULL, NULL, 3118007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.372194', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2443, 'Congonhas do Norte', 'MG', NULL, NULL, NULL, 3118106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.37302', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2444, 'Conquista', 'MG', NULL, NULL, NULL, 3118205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.373929', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2445, 'Conselheiro Lafaiete', 'MG', NULL, NULL, NULL, 3118304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.374849', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2446, 'Conselheiro Pena', 'MG', NULL, NULL, NULL, 3118403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.375761', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2447, 'Consolacao', 'MG', NULL, NULL, NULL, 3118502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.376643', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2448, 'Contagem', 'MG', NULL, NULL, NULL, 3118601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.377562', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2449, 'Coqueiral', 'MG', NULL, NULL, NULL, 3118700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.37849', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2450, 'Coracao de Jesus', 'MG', NULL, NULL, NULL, 3118809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.379263', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2451, 'Cordisburgo', 'MG', NULL, NULL, NULL, 3118908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.380177', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2452, 'Cordislandia', 'MG', NULL, NULL, NULL, 3119005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.381011', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2453, 'Corinto', 'MG', NULL, NULL, NULL, 3119104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.381868', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2454, 'Coroaci', 'MG', NULL, NULL, NULL, 3119203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.38272', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2455, 'Coromandel', 'MG', NULL, NULL, NULL, 3119302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.38355', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2456, 'Coronel Fabriciano', 'MG', NULL, NULL, NULL, 3119401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.384524', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2457, 'Coronel Murta', 'MG', NULL, NULL, NULL, 3119500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.385391', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2458, 'Coronel Pacheco', 'MG', NULL, NULL, NULL, 3119609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.386312', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2459, 'Coronel Xavier Chaves', 'MG', NULL, NULL, NULL, 3119708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.387358', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2460, 'Corrego Danta', 'MG', NULL, NULL, NULL, 3119807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.388301', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2461, 'Corrego do Bom Jesus', 'MG', NULL, NULL, NULL, 3119906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.389213', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2462, 'Corrego Fundo', 'MG', NULL, NULL, NULL, 3119955, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.390263', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2463, 'Corrego Novo', 'MG', NULL, NULL, NULL, 3120003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.391202', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2464, 'Couto de Magalhaes de Minas', 'MG', NULL, NULL, NULL, 3120102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.392311', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2465, 'Crisolita', 'MG', NULL, NULL, NULL, 3120151, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.393212', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2466, 'Cristais', 'MG', NULL, NULL, NULL, 3120201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.394167', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2467, 'Cristalia', 'MG', NULL, NULL, NULL, 3120300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.394971', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2468, 'Cristiano Otoni', 'MG', NULL, NULL, NULL, 3120409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.395888', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2469, 'Cristina', 'MG', NULL, NULL, NULL, 3120508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.396852', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2470, 'Crucilandia', 'MG', NULL, NULL, NULL, 3120607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.397656', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2471, 'Cruzeiro da Fortaleza', 'MG', NULL, NULL, NULL, 3120706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.398422', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2472, 'Cruzilia', 'MG', NULL, NULL, NULL, 3120805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.399226', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2473, 'Cuparaque', 'MG', NULL, NULL, NULL, 3120839, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.400152', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2474, 'Curral de Dentro', 'MG', NULL, NULL, NULL, 3120870, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.401352', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2475, 'Curvelo', 'MG', NULL, NULL, NULL, 3120904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.41163', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2476, 'Datas', 'MG', NULL, NULL, NULL, 3121001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.412738', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2477, 'Delfim Moreira', 'MG', NULL, NULL, NULL, 3121100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.413631', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2478, 'Delfinopolis', 'MG', NULL, NULL, NULL, 3121209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.414454', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2479, 'Delta', 'MG', NULL, NULL, NULL, 3121258, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.415301', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2480, 'Descoberto', 'MG', NULL, NULL, NULL, 3121308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.416181', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2481, 'Desterro de Entre Rios', 'MG', NULL, NULL, NULL, 3121407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.417061', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2482, 'Desterro do Melo', 'MG', NULL, NULL, NULL, 3121506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.417919', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2483, 'Diamantina', 'MG', NULL, NULL, NULL, 3121605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.418797', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2484, 'Diogo de Vasconcelos', 'MG', NULL, NULL, NULL, 3121704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.41969', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2485, 'Dionisio', 'MG', NULL, NULL, NULL, 3121803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.420606', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2486, 'Divinesia', 'MG', NULL, NULL, NULL, 3121902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.421506', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2487, 'Divino', 'MG', NULL, NULL, NULL, 3122009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.422311', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2488, 'Divino das Laranjeiras', 'MG', NULL, NULL, NULL, 3122108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.423584', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2489, 'Divinolandia de Minas', 'MG', NULL, NULL, NULL, 3122207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.424526', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2490, 'Divinopolis', 'MG', NULL, NULL, NULL, 3122306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.425468', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2491, 'Divisa Alegre', 'MG', NULL, NULL, NULL, 3122355, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.426294', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2492, 'Divisa Nova', 'MG', NULL, NULL, NULL, 3122405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.427201', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2493, 'Divisopolis', 'MG', NULL, NULL, NULL, 3122454, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.428217', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2494, 'Dom Bosco', 'MG', NULL, NULL, NULL, 3122470, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.429142', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2495, 'Dom Cavati', 'MG', NULL, NULL, NULL, 3122504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.430042', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2496, 'Dom Joaquim', 'MG', NULL, NULL, NULL, 3122603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.430968', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2497, 'Dom Silverio', 'MG', NULL, NULL, NULL, 3122702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.43188', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2498, 'Dom Vicoso', 'MG', NULL, NULL, NULL, 3122801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.432759', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2499, 'Dona Eusebia', 'MG', NULL, NULL, NULL, 3122900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.433829', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2500, 'Dores de Campos', 'MG', NULL, NULL, NULL, 3123007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.434737', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2501, 'Dores de Guanhaes', 'MG', NULL, NULL, NULL, 3123106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.435545', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2502, 'Dores do Indaia', 'MG', NULL, NULL, NULL, 3123205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.436568', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2503, 'Dores do Turvo', 'MG', NULL, NULL, NULL, 3123304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.437482', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2504, 'Doresopolis', 'MG', NULL, NULL, NULL, 3123403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.438283', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2505, 'Douradoquara', 'MG', NULL, NULL, NULL, 3123502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.439165', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2506, 'Durande', 'MG', NULL, NULL, NULL, 3123528, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.439988', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2507, 'Eloi Mendes', 'MG', NULL, NULL, NULL, 3123601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.440884', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2508, 'Engenheiro Caldas', 'MG', NULL, NULL, NULL, 3123700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.441795', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2509, 'Engenheiro Navarro', 'MG', NULL, NULL, NULL, 3123809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.442634', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2510, 'Entre Folhas', 'MG', NULL, NULL, NULL, 3123858, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.44354', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2511, 'Entre Rios de Minas', 'MG', NULL, NULL, NULL, 3123908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.444453', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2512, 'Ervalia', 'MG', NULL, NULL, NULL, 3124005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.445278', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2513, 'Esmeraldas', 'MG', NULL, NULL, NULL, 3124104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.451797', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2514, 'Espera Feliz', 'MG', NULL, NULL, NULL, 3124203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.452981', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2515, 'Espinosa', 'MG', NULL, NULL, NULL, 3124302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.453778', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2516, 'Espirito Santo do Dourado', 'MG', NULL, NULL, NULL, 3124401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.454654', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2517, 'Estiva', 'MG', NULL, NULL, NULL, 3124500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.4555', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2518, 'Estrela Dalva', 'MG', NULL, NULL, NULL, 3124609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.456458', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2519, 'Estrela do Indaia', 'MG', NULL, NULL, NULL, 3124708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.457559', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2520, 'Estrela do Sul', 'MG', NULL, NULL, NULL, 3124807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.458485', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2521, 'Eugenopolis', 'MG', NULL, NULL, NULL, 3124906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.459407', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2522, 'Ewbank da Camara', 'MG', NULL, NULL, NULL, 3125002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.460227', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2523, 'Extrema', 'MG', NULL, NULL, NULL, 3125101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.461085', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2524, 'Fama', 'MG', NULL, NULL, NULL, 3125200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.461955', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2525, 'Faria Lemos', 'MG', NULL, NULL, NULL, 3125309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.462875', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2526, 'Felicio dos Santos', 'MG', NULL, NULL, NULL, 3125408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.463927', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2965, 'Sao Goncalo do Rio Preto', 'MG', NULL, NULL, NULL, 3125507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.947525', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2527, 'Felisburgo', 'MG', NULL, NULL, NULL, 3125606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.464686', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2528, 'Felixlandia', 'MG', NULL, NULL, NULL, 3125705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.465613', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2529, 'Fernandes Tourinho', 'MG', NULL, NULL, NULL, 3125804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.46651', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2530, 'Ferros', 'MG', NULL, NULL, NULL, 3125903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.467262', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2531, 'Fervedouro', 'MG', NULL, NULL, NULL, 3125952, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.468075', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2532, 'Florestal', 'MG', NULL, NULL, NULL, 3126000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.469065', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2533, 'Formiga', 'MG', NULL, NULL, NULL, 3126109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.469915', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2534, 'Formoso', 'MG', NULL, NULL, NULL, 3126208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.470866', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2535, 'Fortaleza de Minas', 'MG', NULL, NULL, NULL, 3126307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.4718', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2536, 'Fortuna de Minas', 'MG', NULL, NULL, NULL, 3126406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.472649', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2537, 'Francisco Badaro', 'MG', NULL, NULL, NULL, 3126505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.47366', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2538, 'Francisco Dumont', 'MG', NULL, NULL, NULL, 3126604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.474555', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2539, 'Francisco Sa', 'MG', NULL, NULL, NULL, 3126703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.47544', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2540, 'Franciscopolis', 'MG', NULL, NULL, NULL, 3126752, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.476315', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2541, 'Frei Gaspar', 'MG', NULL, NULL, NULL, 3126802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.477184', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2542, 'Frei Inocencio', 'MG', NULL, NULL, NULL, 3126901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.478085', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2543, 'Frei Lagonegro', 'MG', NULL, NULL, NULL, 3126950, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.478996', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2544, 'Fronteira', 'MG', NULL, NULL, NULL, 3127008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.479756', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2545, 'Fronteira dos Vales', 'MG', NULL, NULL, NULL, 3127057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.480618', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2546, 'Fruta de Leite', 'MG', NULL, NULL, NULL, 3127073, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.481494', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2547, 'Frutal', 'MG', NULL, NULL, NULL, 3127107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.482274', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2548, 'Funilandia', 'MG', NULL, NULL, NULL, 3127206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.483177', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2549, 'Galileia', 'MG', NULL, NULL, NULL, 3127305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.484093', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2550, 'Gameleiras', 'MG', NULL, NULL, NULL, 3127339, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.484955', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2551, 'Glaucilandia', 'MG', NULL, NULL, NULL, 3127354, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.485777', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2552, 'Goiabeira', 'MG', NULL, NULL, NULL, 3127370, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.493322', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2553, 'Goiana', 'MG', NULL, NULL, NULL, 3127388, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.494496', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2554, 'Goncalves', 'MG', NULL, NULL, NULL, 3127404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.49536', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2555, 'Gonzaga', 'MG', NULL, NULL, NULL, 3127503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.496231', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2556, 'Gouveia', 'MG', NULL, NULL, NULL, 3127602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.497133', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2557, 'Governador Valadares', 'MG', NULL, NULL, NULL, 3127701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.498098', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2558, 'Grao Mogol', 'MG', NULL, NULL, NULL, 3127800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.498957', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2559, 'Grupiara', 'MG', NULL, NULL, NULL, 3127909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.499849', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2560, 'Guanhaes', 'MG', NULL, NULL, NULL, 3128006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.500653', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2561, 'Guape', 'MG', NULL, NULL, NULL, 3128105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.501713', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2562, 'Guaraciaba', 'MG', NULL, NULL, NULL, 3128204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.502633', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2563, 'Guaraciama', 'MG', NULL, NULL, NULL, 3128253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.503502', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2564, 'Guaranesia', 'MG', NULL, NULL, NULL, 3128303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.504369', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2565, 'Guarani', 'MG', NULL, NULL, NULL, 3128402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.505195', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2566, 'Guarara', 'MG', NULL, NULL, NULL, 3128501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.506059', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2567, 'Guarda-mor', 'MG', NULL, NULL, NULL, 3128600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.506895', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2568, 'Guaxupe', 'MG', NULL, NULL, NULL, 3128709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.507726', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2569, 'Guidoval', 'MG', NULL, NULL, NULL, 3128808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.508808', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2570, 'Guimarania', 'MG', NULL, NULL, NULL, 3128907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.509736', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2571, 'Guiricema', 'MG', NULL, NULL, NULL, 3129004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.510664', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2572, 'Gurinhata', 'MG', NULL, NULL, NULL, 3129103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.51156', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2573, 'Heliodora', 'MG', NULL, NULL, NULL, 3129202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.512439', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2574, 'Iapu', 'MG', NULL, NULL, NULL, 3129301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.513288', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2575, 'Ibertioga', 'MG', NULL, NULL, NULL, 3129400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.514211', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2576, 'Ibia', 'MG', NULL, NULL, NULL, 3129509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.515149', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2577, 'Ibiai', 'MG', NULL, NULL, NULL, 3129608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.515973', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2578, 'Ibiracatu', 'MG', NULL, NULL, NULL, 3129657, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.516767', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2579, 'Ibiraci', 'MG', NULL, NULL, NULL, 3129707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.51756', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2580, 'Ibirite', 'MG', NULL, NULL, NULL, 3129806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.518486', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2581, 'Ibitiura de Minas', 'MG', NULL, NULL, NULL, 3129905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.519415', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2582, 'Ibituruna', 'MG', NULL, NULL, NULL, 3130002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.520237', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2583, 'Icarai de Minas', 'MG', NULL, NULL, NULL, 3130051, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.521141', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2584, 'Igarape', 'MG', NULL, NULL, NULL, 3130101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.522171', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2585, 'Igaratinga', 'MG', NULL, NULL, NULL, 3130200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.523975', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2586, 'Iguatama', 'MG', NULL, NULL, NULL, 3130309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.524916', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2587, 'Ijaci', 'MG', NULL, NULL, NULL, 3130408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.525818', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2588, 'Ilicinea', 'MG', NULL, NULL, NULL, 3130507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.526807', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2589, 'Imbe de Minas', 'MG', NULL, NULL, NULL, 3130556, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.527566', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2590, 'Inconfidentes', 'MG', NULL, NULL, NULL, 3130606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.534284', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2591, 'Indaiabira', 'MG', NULL, NULL, NULL, 3130655, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.535355', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2592, 'Indianopolis', 'MG', NULL, NULL, NULL, 3130705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.536141', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2593, 'Ingai', 'MG', NULL, NULL, NULL, 3130804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.53695', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2594, 'Inhapim', 'MG', NULL, NULL, NULL, 3130903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.537926', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2595, 'Inhauma', 'MG', NULL, NULL, NULL, 3131000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.538866', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2596, 'Inimutaba', 'MG', NULL, NULL, NULL, 3131109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.539693', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2597, 'Ipaba', 'MG', NULL, NULL, NULL, 3131158, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.540615', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2598, 'Ipanema', 'MG', NULL, NULL, NULL, 3131208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.541477', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2599, 'Ipatinga', 'MG', NULL, NULL, NULL, 3131307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.542301', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2600, 'Ipiacu', 'MG', NULL, NULL, NULL, 3131406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.543088', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2601, 'Ipuiuna', 'MG', NULL, NULL, NULL, 3131505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.544006', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2602, 'Irai de Minas', 'MG', NULL, NULL, NULL, 3131604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.544877', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2603, 'Itabira', 'MG', NULL, NULL, NULL, 3131703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.545641', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2604, 'Itabirinha', 'MG', NULL, NULL, NULL, 3131802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.546423', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2605, 'Itabirito', 'MG', NULL, NULL, NULL, 3131901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.547264', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2606, 'Itacambira', 'MG', NULL, NULL, NULL, 3132008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.54826', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2607, 'Itacarambi', 'MG', NULL, NULL, NULL, 3132107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.549333', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2608, 'Itaguara', 'MG', NULL, NULL, NULL, 3132206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.550259', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2609, 'Itaipe', 'MG', NULL, NULL, NULL, 3132305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.551156', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2610, 'Itajuba', 'MG', NULL, NULL, NULL, 3132404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.552041', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2611, 'Itamarandiba', 'MG', NULL, NULL, NULL, 3132503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.55291', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2612, 'Itamarati de Minas', 'MG', NULL, NULL, NULL, 3132602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.553968', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2613, 'Itambacuri', 'MG', NULL, NULL, NULL, 3132701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.554843', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2614, 'Itambe do Mato Dentro', 'MG', NULL, NULL, NULL, 3132800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.555903', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2615, 'Itamogi', 'MG', NULL, NULL, NULL, 3132909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.556785', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2616, 'Itamonte', 'MG', NULL, NULL, NULL, 3133006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.557679', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2617, 'Itanhandu', 'MG', NULL, NULL, NULL, 3133105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.558486', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2618, 'Itanhomi', 'MG', NULL, NULL, NULL, 3133204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.559343', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2619, 'Itaobim', 'MG', NULL, NULL, NULL, 3133303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.560182', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2620, 'Itapagipe', 'MG', NULL, NULL, NULL, 3133402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.561129', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2621, 'Itapecerica', 'MG', NULL, NULL, NULL, 3133501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.562045', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2622, 'Itapeva', 'MG', NULL, NULL, NULL, 3133600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.562886', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2623, 'Itatiaiucu', 'MG', NULL, NULL, NULL, 3133709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.56382', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2624, 'Itau de Minas', 'MG', NULL, NULL, NULL, 3133758, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.564738', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2625, 'Itauna', 'MG', NULL, NULL, NULL, 3133808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.565631', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2626, 'Itaverava', 'MG', NULL, NULL, NULL, 3133907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.566539', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2627, 'Itinga', 'MG', NULL, NULL, NULL, 3134004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.567443', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2628, 'Itueta', 'MG', NULL, NULL, NULL, 3134103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.574206', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2629, 'Ituiutaba', 'MG', NULL, NULL, NULL, 3134202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.575462', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2630, 'Itumirim', 'MG', NULL, NULL, NULL, 3134301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.576278', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2631, 'Iturama', 'MG', NULL, NULL, NULL, 3134400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.577299', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2632, 'Itutinga', 'MG', NULL, NULL, NULL, 3134509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.578215', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2633, 'Jaboticatubas', 'MG', NULL, NULL, NULL, 3134608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.579155', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2634, 'Jacinto', 'MG', NULL, NULL, NULL, 3134707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.579934', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2635, 'Jacui', 'MG', NULL, NULL, NULL, 3134806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.580977', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2636, 'Jacutinga', 'MG', NULL, NULL, NULL, 3134905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.581851', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2637, 'Jaguaracu', 'MG', NULL, NULL, NULL, 3135001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.582674', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2638, 'Jaiba', 'MG', NULL, NULL, NULL, 3135050, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.583605', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2639, 'Jampruca', 'MG', NULL, NULL, NULL, 3135076, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.584486', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2640, 'Janauba', 'MG', NULL, NULL, NULL, 3135100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.585356', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2641, 'Januaria', 'MG', NULL, NULL, NULL, 3135209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.586257', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2642, 'Japaraiba', 'MG', NULL, NULL, NULL, 3135308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.587138', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2643, 'Japonvar', 'MG', NULL, NULL, NULL, 3135357, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.58822', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2644, 'Jeceaba', 'MG', NULL, NULL, NULL, 3135407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.589312', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2645, 'Jenipapo de Minas', 'MG', NULL, NULL, NULL, 3135456, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.590255', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2646, 'Jequeri', 'MG', NULL, NULL, NULL, 3135506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.591033', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2647, 'Jequitai', 'MG', NULL, NULL, NULL, 3135605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.592039', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2648, 'Jequitiba', 'MG', NULL, NULL, NULL, 3135704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.592846', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2649, 'Jequitinhonha', 'MG', NULL, NULL, NULL, 3135803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.593621', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2650, 'Jesuania', 'MG', NULL, NULL, NULL, 3135902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.594594', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2651, 'Joaima', 'MG', NULL, NULL, NULL, 3136009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.595575', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2652, 'Joanesia', 'MG', NULL, NULL, NULL, 3136108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.596474', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2653, 'Joao Monlevade', 'MG', NULL, NULL, NULL, 3136207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.597362', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2654, 'Joao Pinheiro', 'MG', NULL, NULL, NULL, 3136306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.59822', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2655, 'Joaquim Felicio', 'MG', NULL, NULL, NULL, 3136405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.599054', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2656, 'Jordania', 'MG', NULL, NULL, NULL, 3136504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.600016', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2657, 'Jose Goncalves de Minas', 'MG', NULL, NULL, NULL, 3136520, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.600945', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2658, 'Jose Raydan', 'MG', NULL, NULL, NULL, 3136553, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.602108', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2659, 'Josenopolis', 'MG', NULL, NULL, NULL, 3136579, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.603016', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2768, 'Nova Uniao', 'MG', NULL, NULL, NULL, 3136603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.723765', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2660, 'Juatuba', 'MG', NULL, NULL, NULL, 3136652, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.604047', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2661, 'Juiz de Fora', 'MG', NULL, NULL, NULL, 3136702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.604952', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2662, 'Juramento', 'MG', NULL, NULL, NULL, 3136801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.605847', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2663, 'Juruaia', 'MG', NULL, NULL, NULL, 3136900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.606705', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2664, 'Juvenilia', 'MG', NULL, NULL, NULL, 3136959, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.607706', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2665, 'Ladainha', 'MG', NULL, NULL, NULL, 3137007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.614724', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2666, 'Lagamar', 'MG', NULL, NULL, NULL, 3137106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.615844', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2667, 'Lagoa da Prata', 'MG', NULL, NULL, NULL, 3137205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.616813', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2668, 'Lagoa dos Patos', 'MG', NULL, NULL, NULL, 3137304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.617738', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2669, 'Lagoa Dourada', 'MG', NULL, NULL, NULL, 3137403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.618698', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2670, 'Lagoa Formosa', 'MG', NULL, NULL, NULL, 3137502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.619622', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2671, 'Lagoa Grande', 'MG', NULL, NULL, NULL, 3137536, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.620559', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2672, 'Lagoa Santa', 'MG', NULL, NULL, NULL, 3137601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.621608', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2673, 'Lajinha', 'MG', NULL, NULL, NULL, 3137700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.622616', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2674, 'Lambari', 'MG', NULL, NULL, NULL, 3137809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.623675', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2675, 'Lamim', 'MG', NULL, NULL, NULL, 3137908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.624505', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2676, 'Laranjal', 'MG', NULL, NULL, NULL, 3138005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.625461', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2677, 'Lassance', 'MG', NULL, NULL, NULL, 3138104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.626399', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2678, 'Lavras', 'MG', NULL, NULL, NULL, 3138203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.62728', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2679, 'Leandro Ferreira', 'MG', NULL, NULL, NULL, 3138302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.6282', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2680, 'Leme do Prado', 'MG', NULL, NULL, NULL, 3138351, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.629003', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2681, 'Leopoldina', 'MG', NULL, NULL, NULL, 3138401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.629801', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2682, 'Liberdade', 'MG', NULL, NULL, NULL, 3138500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.630694', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2683, 'Lima Duarte', 'MG', NULL, NULL, NULL, 3138609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.631701', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2684, 'Limeira do Oeste', 'MG', NULL, NULL, NULL, 3138625, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.632595', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2685, 'Lontra', 'MG', NULL, NULL, NULL, 3138658, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.633499', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2686, 'Luisburgo', 'MG', NULL, NULL, NULL, 3138674, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.634802', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2687, 'Luislandia', 'MG', NULL, NULL, NULL, 3138682, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.635773', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2688, 'Luminarias', 'MG', NULL, NULL, NULL, 3138708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.636597', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2689, 'Luz', 'MG', NULL, NULL, NULL, 3138807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.637763', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2690, 'Machacalis', 'MG', NULL, NULL, NULL, 3138906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.638736', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2691, 'Machado', 'MG', NULL, NULL, NULL, 3139003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.639667', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2692, 'Madre de Deus de Minas', 'MG', NULL, NULL, NULL, 3139102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.640612', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2693, 'Malacacheta', 'MG', NULL, NULL, NULL, 3139201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.641441', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2694, 'Mamonas', 'MG', NULL, NULL, NULL, 3139250, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.642344', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2695, 'Manga', 'MG', NULL, NULL, NULL, 3139300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.643242', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2696, 'Manhuacu', 'MG', NULL, NULL, NULL, 3139409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.644213', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2697, 'Manhumirim', 'MG', NULL, NULL, NULL, 3139508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.64516', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2698, 'Mantena', 'MG', NULL, NULL, NULL, 3139607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.646202', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2700, 'Maravilhas', 'MG', NULL, NULL, NULL, 3139706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.647968', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2699, 'Mar de Espanha', 'MG', NULL, NULL, NULL, 3139805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.647012', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2701, 'Maria da Fe', 'MG', NULL, NULL, NULL, 3139904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.655614', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2702, 'Mariana', 'MG', NULL, NULL, NULL, 3140001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.656908', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2703, 'Marilac', 'MG', NULL, NULL, NULL, 3140100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.65784', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2704, 'Mario Campos', 'MG', NULL, NULL, NULL, 3140159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.658689', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2705, 'Maripa de Minas', 'MG', NULL, NULL, NULL, 3140209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.65953', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2706, 'Marlieria', 'MG', NULL, NULL, NULL, 3140308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.66046', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2707, 'Marmelopolis', 'MG', NULL, NULL, NULL, 3140407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.661483', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2708, 'Martinho Campos', 'MG', NULL, NULL, NULL, 3140506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.662437', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2709, 'Martins Soares', 'MG', NULL, NULL, NULL, 3140530, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.663486', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2710, 'Mata Verde', 'MG', NULL, NULL, NULL, 3140555, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.664361', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2711, 'Materlandia', 'MG', NULL, NULL, NULL, 3140605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.665305', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2712, 'Mateus Leme', 'MG', NULL, NULL, NULL, 3140704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.666284', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2714, 'Matias Barbosa', 'MG', NULL, NULL, NULL, 3140803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.668037', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2715, 'Matias Cardoso', 'MG', NULL, NULL, NULL, 3140852, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.668913', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2716, 'Matipo', 'MG', NULL, NULL, NULL, 3140902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.669963', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2717, 'Mato Verde', 'MG', NULL, NULL, NULL, 3141009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.670864', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2718, 'Matozinhos', 'MG', NULL, NULL, NULL, 3141108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.671823', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2719, 'Matutina', 'MG', NULL, NULL, NULL, 3141207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.672635', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2720, 'Medeiros', 'MG', NULL, NULL, NULL, 3141306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.673506', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2721, 'Medina', 'MG', NULL, NULL, NULL, 3141405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.674315', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2722, 'Mendes Pimentel', 'MG', NULL, NULL, NULL, 3141504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.675195', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2723, 'Merces', 'MG', NULL, NULL, NULL, 3141603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.676123', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2724, 'Mesquita', 'MG', NULL, NULL, NULL, 3141702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.677029', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2725, 'Minas Novas', 'MG', NULL, NULL, NULL, 3141801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.677866', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2726, 'Minduri', 'MG', NULL, NULL, NULL, 3141900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.67889', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2727, 'Mirabela', 'MG', NULL, NULL, NULL, 3142007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.680059', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2728, 'Miradouro', 'MG', NULL, NULL, NULL, 3142106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.681017', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2729, 'Mirai', 'MG', NULL, NULL, NULL, 3142205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.681974', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2730, 'Miravania', 'MG', NULL, NULL, NULL, 3142254, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.682921', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2731, 'Moeda', 'MG', NULL, NULL, NULL, 3142304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.683889', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2732, 'Moema', 'MG', NULL, NULL, NULL, 3142403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.684839', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2733, 'Monjolos', 'MG', NULL, NULL, NULL, 3142502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.685732', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2734, 'Monsenhor Paulo', 'MG', NULL, NULL, NULL, 3142601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.686645', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2735, 'Montalvania', 'MG', NULL, NULL, NULL, 3142700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.687406', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2736, 'Monte Alegre de Minas', 'MG', NULL, NULL, NULL, 3142809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.688289', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2737, 'Monte Azul', 'MG', NULL, NULL, NULL, 3142908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.689257', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2738, 'Monte Belo', 'MG', NULL, NULL, NULL, 3143005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.696044', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2739, 'Monte Carmelo', 'MG', NULL, NULL, NULL, 3143104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.697125', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2740, 'Monte Formoso', 'MG', NULL, NULL, NULL, 3143153, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.698007', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2741, 'Monte Santo de Minas', 'MG', NULL, NULL, NULL, 3143203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.699102', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2743, 'Montes Claros', 'MG', NULL, NULL, NULL, 3143302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.700683', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2742, 'Monte Siao', 'MG', NULL, NULL, NULL, 3143401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.699867', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2744, 'Montezuma', 'MG', NULL, NULL, NULL, 3143450, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.701663', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2745, 'Morada Nova de Minas', 'MG', NULL, NULL, NULL, 3143500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.702366', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2746, 'Morro da Garca', 'MG', NULL, NULL, NULL, 3143609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.703301', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2747, 'Morro do Pilar', 'MG', NULL, NULL, NULL, 3143708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.70427', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2748, 'Munhoz', 'MG', NULL, NULL, NULL, 3143807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.705223', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2749, 'Muriae', 'MG', NULL, NULL, NULL, 3143906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.706065', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2750, 'Mutum', 'MG', NULL, NULL, NULL, 3144003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.706975', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2751, 'Muzambinho', 'MG', NULL, NULL, NULL, 3144102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.707858', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2752, 'Nacip Raydan', 'MG', NULL, NULL, NULL, 3144201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.70873', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2753, 'Nanuque', 'MG', NULL, NULL, NULL, 3144300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.709584', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2754, 'Naque', 'MG', NULL, NULL, NULL, 3144359, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.710678', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2755, 'Natalandia', 'MG', NULL, NULL, NULL, 3144375, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.711561', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2756, 'Natercia', 'MG', NULL, NULL, NULL, 3144409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.712473', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2757, 'Nazareno', 'MG', NULL, NULL, NULL, 3144508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.71354', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2758, 'Nepomuceno', 'MG', NULL, NULL, NULL, 3144607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.714525', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2759, 'Ninheira', 'MG', NULL, NULL, NULL, 3144656, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.715406', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2760, 'Nova Belem', 'MG', NULL, NULL, NULL, 3144672, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.716339', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2761, 'Nova Era', 'MG', NULL, NULL, NULL, 3144706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.71725', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2762, 'Nova Lima', 'MG', NULL, NULL, NULL, 3144805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.718111', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2763, 'Nova Modica', 'MG', NULL, NULL, NULL, 3144904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.719056', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2764, 'Nova Ponte', 'MG', NULL, NULL, NULL, 3145000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.720149', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2765, 'Nova Porteirinha', 'MG', NULL, NULL, NULL, 3145059, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.721149', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2766, 'Nova Resende', 'MG', NULL, NULL, NULL, 3145109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.722075', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2767, 'Nova Serrana', 'MG', NULL, NULL, NULL, 3145208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.7229', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2769, 'Novo Cruzeiro', 'MG', NULL, NULL, NULL, 3145307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.724744', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2770, 'Novo Oriente de Minas', 'MG', NULL, NULL, NULL, 3145356, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.725723', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2771, 'Novorizonte', 'MG', NULL, NULL, NULL, 3145372, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.726657', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2772, 'Olaria', 'MG', NULL, NULL, NULL, 3145406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.727589', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2774, 'Olimpio Noronha', 'MG', NULL, NULL, NULL, 3145505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.729493', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2775, 'Oliveira', 'MG', NULL, NULL, NULL, 3145604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.740384', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2776, 'Oliveira Fortes', 'MG', NULL, NULL, NULL, 3145703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.74145', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2777, 'Onca de Pitangui', 'MG', NULL, NULL, NULL, 3145802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.742313', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2778, 'Oratorios', 'MG', NULL, NULL, NULL, 3145851, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.7431', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2779, 'Orizania', 'MG', NULL, NULL, NULL, 3145877, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.743935', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2780, 'Ouro Branco', 'MG', NULL, NULL, NULL, 3145901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.744933', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2781, 'Ouro Fino', 'MG', NULL, NULL, NULL, 3146008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.745729', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2782, 'Ouro Preto', 'MG', NULL, NULL, NULL, 3146107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.746597', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2783, 'Ouro Verde de Minas', 'MG', NULL, NULL, NULL, 3146206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.747426', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2784, 'Padre Carvalho', 'MG', NULL, NULL, NULL, 3146255, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.748246', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2785, 'Padre Paraiso', 'MG', NULL, NULL, NULL, 3146305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.749321', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2787, 'Paineiras', 'MG', NULL, NULL, NULL, 3146404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.75118', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2788, 'Pains', 'MG', NULL, NULL, NULL, 3146503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.752016', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2786, 'Pai Pedro', 'MG', NULL, NULL, NULL, 3146552, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.750259', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2789, 'Paiva', 'MG', NULL, NULL, NULL, 3146602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.753119', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2790, 'Palma', 'MG', NULL, NULL, NULL, 3146701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.754061', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2791, 'Palmopolis', 'MG', NULL, NULL, NULL, 3146750, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.755117', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2792, 'Papagaios', 'MG', NULL, NULL, NULL, 3146909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.75607', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2794, 'Paracatu', 'MG', NULL, NULL, NULL, 3147006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.757955', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2793, 'Para de Minas', 'MG', NULL, NULL, NULL, 3147105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.756968', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2795, 'Paraguacu', 'MG', NULL, NULL, NULL, 3147204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.758826', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2796, 'Paraisopolis', 'MG', NULL, NULL, NULL, 3147303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.759698', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2797, 'Paraopeba', 'MG', NULL, NULL, NULL, 3147402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.76053', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2801, 'Passabem', 'MG', NULL, NULL, NULL, 3147501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.764189', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2798, 'Passa Quatro', 'MG', NULL, NULL, NULL, 3147600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.761404', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2799, 'Passa Tempo', 'MG', NULL, NULL, NULL, 3147709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.762299', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2802, 'Passos', 'MG', NULL, NULL, NULL, 3147907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.765124', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2803, 'Patis', 'MG', NULL, NULL, NULL, 3147956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.766075', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2804, 'Patos de Minas', 'MG', NULL, NULL, NULL, 3148004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.766987', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2805, 'Patrocinio', 'MG', NULL, NULL, NULL, 3148103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.767808', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2806, 'Patrocinio do Muriae', 'MG', NULL, NULL, NULL, 3148202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.768792', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2807, 'Paula Candido', 'MG', NULL, NULL, NULL, 3148301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.769602', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2808, 'Paulistas', 'MG', NULL, NULL, NULL, 3148400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.770548', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2809, 'Pavao', 'MG', NULL, NULL, NULL, 3148509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.771502', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2810, 'Pecanha', 'MG', NULL, NULL, NULL, 3148608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.772442', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2811, 'Pedra Azul', 'MG', NULL, NULL, NULL, 3148707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.773367', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2812, 'Pedra Bonita', 'MG', NULL, NULL, NULL, 3148756, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.774198', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2813, 'Pedra do Anta', 'MG', NULL, NULL, NULL, 3148806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.781051', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2814, 'Pedra do Indaia', 'MG', NULL, NULL, NULL, 3148905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.782165', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2815, 'Pedra Dourada', 'MG', NULL, NULL, NULL, 3149002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.783151', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2816, 'Pedralva', 'MG', NULL, NULL, NULL, 3149101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.784071', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2817, 'Pedras de Maria da Cruz', 'MG', NULL, NULL, NULL, 3149150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.784969', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2818, 'Pedrinopolis', 'MG', NULL, NULL, NULL, 3149200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.785949', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2819, 'Pedro Leopoldo', 'MG', NULL, NULL, NULL, 3149309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.786904', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2820, 'Pedro Teixeira', 'MG', NULL, NULL, NULL, 3149408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.787893', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2821, 'Pequeri', 'MG', NULL, NULL, NULL, 3149507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.788918', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2822, 'Pequi', 'MG', NULL, NULL, NULL, 3149606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.789785', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2823, 'Perdigao', 'MG', NULL, NULL, NULL, 3149705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.790748', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2824, 'Perdizes', 'MG', NULL, NULL, NULL, 3149804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.791688', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2825, 'Perdoes', 'MG', NULL, NULL, NULL, 3149903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.792564', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2826, 'Periquito', 'MG', NULL, NULL, NULL, 3149952, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.793428', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2827, 'Pescador', 'MG', NULL, NULL, NULL, 3150000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.79428', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2828, 'Piau', 'MG', NULL, NULL, NULL, 3150109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.795255', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2829, 'Piedade de Caratinga', 'MG', NULL, NULL, NULL, 3150158, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.796196', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2830, 'Piedade de Ponte Nova', 'MG', NULL, NULL, NULL, 3150208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.797037', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2831, 'Piedade do Rio Grande', 'MG', NULL, NULL, NULL, 3150307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.797938', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2832, 'Piedade dos Gerais', 'MG', NULL, NULL, NULL, 3150406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.798806', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2833, 'Pimenta', 'MG', NULL, NULL, NULL, 3150505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.799797', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2835, 'Pintopolis', 'MG', NULL, NULL, NULL, 3150570, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.801687', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2836, 'Piracema', 'MG', NULL, NULL, NULL, 3150604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.802868', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2837, 'Pirajuba', 'MG', NULL, NULL, NULL, 3150703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.803785', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2838, 'Piranga', 'MG', NULL, NULL, NULL, 3150802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.804725', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2839, 'Pirangucu', 'MG', NULL, NULL, NULL, 3150901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.805698', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2840, 'Piranguinho', 'MG', NULL, NULL, NULL, 3151008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.806615', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2841, 'Pirapetinga', 'MG', NULL, NULL, NULL, 3151107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.807535', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2842, 'Pirapora', 'MG', NULL, NULL, NULL, 3151206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.80837', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2843, 'Pirauba', 'MG', NULL, NULL, NULL, 3151305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.809281', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2844, 'Pitangui', 'MG', NULL, NULL, NULL, 3151404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.810255', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2845, 'Piumhi', 'MG', NULL, NULL, NULL, 3151503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.811233', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2846, 'Planura', 'MG', NULL, NULL, NULL, 3151602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.812132', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2847, 'Poco Fundo', 'MG', NULL, NULL, NULL, 3151701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.813128', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2848, 'Pocos de Caldas', 'MG', NULL, NULL, NULL, 3151800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.814049', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2849, 'Pocrane', 'MG', NULL, NULL, NULL, 3151909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.814882', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2850, 'Pompeu', 'MG', NULL, NULL, NULL, 3152006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.822131', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2851, 'Ponte Nova', 'MG', NULL, NULL, NULL, 3152105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.823253', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2852, 'Ponto Chique', 'MG', NULL, NULL, NULL, 3152131, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.824088', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2853, 'Ponto dos Volantes', 'MG', NULL, NULL, NULL, 3152170, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.825103', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2854, 'Porteirinha', 'MG', NULL, NULL, NULL, 3152204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.82606', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2855, 'Porto Firme', 'MG', NULL, NULL, NULL, 3152303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.827004', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2856, 'Pote', 'MG', NULL, NULL, NULL, 3152402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.828002', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2857, 'Pouso Alegre', 'MG', NULL, NULL, NULL, 3152501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.828959', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2858, 'Pouso Alto', 'MG', NULL, NULL, NULL, 3152600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.830054', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2859, 'Prados', 'MG', NULL, NULL, NULL, 3152709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.830956', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2860, 'Prata', 'MG', NULL, NULL, NULL, 3152808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.831842', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2861, 'Pratapolis', 'MG', NULL, NULL, NULL, 3152907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.832742', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2862, 'Pratinha', 'MG', NULL, NULL, NULL, 3153004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.833628', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2863, 'Presidente Bernardes', 'MG', NULL, NULL, NULL, 3153103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.834501', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2864, 'Presidente Juscelino', 'MG', NULL, NULL, NULL, 3153202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.836256', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2865, 'Presidente Kubitschek', 'MG', NULL, NULL, NULL, 3153301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.837166', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2866, 'Presidente Olegario', 'MG', NULL, NULL, NULL, 3153400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.838125', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2265, 'Alto Jequitiba', 'MG', NULL, NULL, NULL, 3153509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.182618', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2867, 'Prudente de Morais', 'MG', NULL, NULL, NULL, 3153608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.839006', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2868, 'Quartel Geral', 'MG', NULL, NULL, NULL, 3153707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.839868', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2869, 'Queluzito', 'MG', NULL, NULL, NULL, 3153806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.840797', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2870, 'Raposos', 'MG', NULL, NULL, NULL, 3153905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.84164', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2871, 'Raul Soares', 'MG', NULL, NULL, NULL, 3154002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.842576', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2872, 'Recreio', 'MG', NULL, NULL, NULL, 3154101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.843754', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2873, 'Reduto', 'MG', NULL, NULL, NULL, 3154150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.844654', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2874, 'Resende Costa', 'MG', NULL, NULL, NULL, 3154200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.845628', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2875, 'Resplendor', 'MG', NULL, NULL, NULL, 3154309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.846633', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2876, 'Ressaquinha', 'MG', NULL, NULL, NULL, 3154408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.847458', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2877, 'Riachinho', 'MG', NULL, NULL, NULL, 3154457, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.848378', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2878, 'Riacho dos Machados', 'MG', NULL, NULL, NULL, 3154507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.849254', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2879, 'Ribeirao das Neves', 'MG', NULL, NULL, NULL, 3154606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.850149', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2880, 'Ribeirao Vermelho', 'MG', NULL, NULL, NULL, 3154705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.851048', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2881, 'Rio Acima', 'MG', NULL, NULL, NULL, 3154804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.852061', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2882, 'Rio Casca', 'MG', NULL, NULL, NULL, 3154903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.852976', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2884, 'Rio Doce', 'MG', NULL, NULL, NULL, 3155009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.854683', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2883, 'Rio do Prado', 'MG', NULL, NULL, NULL, 3155108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.853875', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2885, 'Rio Espera', 'MG', NULL, NULL, NULL, 3155207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.855684', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2886, 'Rio Manso', 'MG', NULL, NULL, NULL, 3155306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.856476', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2887, 'Rio Novo', 'MG', NULL, NULL, NULL, 3155405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.863208', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2888, 'Rio Paranaiba', 'MG', NULL, NULL, NULL, 3155504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.86423', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2889, 'Rio Pardo de Minas', 'MG', NULL, NULL, NULL, 3155603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.865113', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2890, 'Rio Piracicaba', 'MG', NULL, NULL, NULL, 3155702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.866003', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2891, 'Rio Pomba', 'MG', NULL, NULL, NULL, 3155801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.866718', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2892, 'Rio Preto', 'MG', NULL, NULL, NULL, 3155900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.86757', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2893, 'Rio Vermelho', 'MG', NULL, NULL, NULL, 3156007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.868466', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2894, 'Ritapolis', 'MG', NULL, NULL, NULL, 3156106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.86965', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2895, 'Rochedo de Minas', 'MG', NULL, NULL, NULL, 3156205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.870574', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2896, 'Rodeiro', 'MG', NULL, NULL, NULL, 3156304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.87147', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2897, 'Romaria', 'MG', NULL, NULL, NULL, 3156403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.872334', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2898, 'Rosario da Limeira', 'MG', NULL, NULL, NULL, 3156452, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.873188', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2899, 'Rubelita', 'MG', NULL, NULL, NULL, 3156502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.873986', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2900, 'Rubim', 'MG', NULL, NULL, NULL, 3156601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.874865', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2901, 'Sabara', 'MG', NULL, NULL, NULL, 3156700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.875998', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2902, 'Sabinopolis', 'MG', NULL, NULL, NULL, 3156809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.876908', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2903, 'Sacramento', 'MG', NULL, NULL, NULL, 3156908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.877892', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2904, 'Salinas', 'MG', NULL, NULL, NULL, 3157005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.878715', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2905, 'Salto da Divisa', 'MG', NULL, NULL, NULL, 3157104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.87963', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2906, 'Santa Barbara', 'MG', NULL, NULL, NULL, 3157203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.880788', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2907, 'Santa Barbara do Leste', 'MG', NULL, NULL, NULL, 3157252, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.881713', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2908, 'Santa Barbara do Monte Verde', 'MG', NULL, NULL, NULL, 3157278, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.882576', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2909, 'Santa Barbara do Tugurio', 'MG', NULL, NULL, NULL, 3157302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.883499', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2910, 'Santa Cruz de Minas', 'MG', NULL, NULL, NULL, 3157336, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.884331', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2911, 'Santa Cruz de Salinas', 'MG', NULL, NULL, NULL, 3157377, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.885373', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2912, 'Santa Cruz do Escalvado', 'MG', NULL, NULL, NULL, 3157401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.886231', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2913, 'Santa Efigenia de Minas', 'MG', NULL, NULL, NULL, 3157500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.887023', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2914, 'Santa Fe de Minas', 'MG', NULL, NULL, NULL, 3157609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.887823', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2915, 'Santa Helena de Minas', 'MG', NULL, NULL, NULL, 3157658, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.888613', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2916, 'Santa Juliana', 'MG', NULL, NULL, NULL, 3157708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.889436', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2917, 'Santa Luzia', 'MG', NULL, NULL, NULL, 3157807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.890286', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2918, 'Santa Margarida', 'MG', NULL, NULL, NULL, 3157906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.891179', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2919, 'Santa Maria de Itabira', 'MG', NULL, NULL, NULL, 3158003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.892071', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2920, 'Santa Maria do Salto', 'MG', NULL, NULL, NULL, 3158102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.893033', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2921, 'Santa Maria do Suacui', 'MG', NULL, NULL, NULL, 3158201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.893934', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2930, 'Santana da Vargem', 'MG', NULL, NULL, NULL, 3158300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.90782', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2931, 'Santana de Cataguases', 'MG', NULL, NULL, NULL, 3158409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.908562', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2932, 'Santana de Pirapama', 'MG', NULL, NULL, NULL, 3158508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.909396', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2933, 'Santana do Deserto', 'MG', NULL, NULL, NULL, 3158607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.91025', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2934, 'Santana do Garambeu', 'MG', NULL, NULL, NULL, 3158706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.911172', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2935, 'Santana do Jacare', 'MG', NULL, NULL, NULL, 3158805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.912087', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2936, 'Santana do Manhuacu', 'MG', NULL, NULL, NULL, 3158904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.912919', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2937, 'Santana do Paraiso', 'MG', NULL, NULL, NULL, 3158953, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.913893', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2938, 'Santana do Riacho', 'MG', NULL, NULL, NULL, 3159001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.914701', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2939, 'Santana dos Montes', 'MG', NULL, NULL, NULL, 3159100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.915635', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2922, 'Santa Rita de Caldas', 'MG', NULL, NULL, NULL, 3159209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.894802', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2924, 'Santa Rita de Jacutinga', 'MG', NULL, NULL, NULL, 3159308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.896554', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2925, 'Santa Rita de Minas', 'MG', NULL, NULL, NULL, 3159357, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.90317', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2923, 'Santa Rita de Ibitipoca', 'MG', NULL, NULL, NULL, 3159407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.895661', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2926, 'Santa Rita do Itueto', 'MG', NULL, NULL, NULL, 3159506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.904334', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2927, 'Santa Rita do Sapucai', 'MG', NULL, NULL, NULL, 3159605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.905188', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2928, 'Santa Rosa da Serra', 'MG', NULL, NULL, NULL, 3159704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.906002', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2929, 'Santa Vitoria', 'MG', NULL, NULL, NULL, 3159803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.906897', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2940, 'Santo Antonio do Amparo', 'MG', NULL, NULL, NULL, 3159902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.916561', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2941, 'Santo Antonio do Aventureiro', 'MG', NULL, NULL, NULL, 3160009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.917522', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2942, 'Santo Antonio do Grama', 'MG', NULL, NULL, NULL, 3160108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.918259', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2943, 'Santo Antonio do Itambe', 'MG', NULL, NULL, NULL, 3160207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.919652', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2944, 'Santo Antonio do Jacinto', 'MG', NULL, NULL, NULL, 3160306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.920493', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2945, 'Santo Antonio do Monte', 'MG', NULL, NULL, NULL, 3160405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.921488', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2946, 'Santo Antonio do Retiro', 'MG', NULL, NULL, NULL, 3160454, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.922448', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2947, 'Santo Antonio do Rio Abaixo', 'MG', NULL, NULL, NULL, 3160504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.923338', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2948, 'Santo Hipolito', 'MG', NULL, NULL, NULL, 3160603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.924169', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2949, 'Santos Dumont', 'MG', NULL, NULL, NULL, 3160702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.925463', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2950, 'Sao Bento Abade', 'MG', NULL, NULL, NULL, 3160801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.926405', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2951, 'Sao Bras do Suacui', 'MG', NULL, NULL, NULL, 3160900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.927261', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2952, 'Sao Domingos das Dores', 'MG', NULL, NULL, NULL, 3160959, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.928137', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2953, 'Sao Domingos do Prata', 'MG', NULL, NULL, NULL, 3161007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.928974', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2954, 'Sao Felix de Minas', 'MG', NULL, NULL, NULL, 3161056, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.929859', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2955, 'Sao Francisco', 'MG', NULL, NULL, NULL, 3161106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.930685', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2956, 'Sao Francisco de Paula', 'MG', NULL, NULL, NULL, 3161205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.931488', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2957, 'Sao Francisco de Sales', 'MG', NULL, NULL, NULL, 3161304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.932267', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2958, 'Sao Francisco do Gloria', 'MG', NULL, NULL, NULL, 3161403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.933213', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2959, 'Sao Geraldo', 'MG', NULL, NULL, NULL, 3161502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.934103', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2960, 'Sao Geraldo da Piedade', 'MG', NULL, NULL, NULL, 3161601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.935011', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2961, 'Sao Geraldo do Baixio', 'MG', NULL, NULL, NULL, 3161650, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.935934', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2962, 'Sao Goncalo do Abaete', 'MG', NULL, NULL, NULL, 3161700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.936778', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2963, 'Sao Goncalo do Para', 'MG', NULL, NULL, NULL, 3161809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.944008', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2964, 'Sao Goncalo do Rio Abaixo', 'MG', NULL, NULL, NULL, 3161908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.945446', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2966, 'Sao Goncalo do Sapucai', 'MG', NULL, NULL, NULL, 3162005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.948415', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2967, 'Sao Gotardo', 'MG', NULL, NULL, NULL, 3162104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.949358', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2968, 'Sao Joao Batista do Gloria', 'MG', NULL, NULL, NULL, 3162203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.950284', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2969, 'Sao Joao da Lagoa', 'MG', NULL, NULL, NULL, 3162252, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.951373', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2970, 'Sao Joao da Mata', 'MG', NULL, NULL, NULL, 3162302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.952414', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2971, 'Sao Joao da Ponte', 'MG', NULL, NULL, NULL, 3162401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.95334', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2972, 'Sao Joao das Missoes', 'MG', NULL, NULL, NULL, 3162450, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.954242', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2973, 'Sao Joao Del Rei', 'MG', NULL, NULL, NULL, 3162500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.955094', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2974, 'Sao Joao do Manhuacu', 'MG', NULL, NULL, NULL, 3162559, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.955927', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2975, 'Sao Joao do Manteninha', 'MG', NULL, NULL, NULL, 3162575, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.956767', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2976, 'Sao Joao do Oriente', 'MG', NULL, NULL, NULL, 3162609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.957553', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2977, 'Sao Joao do Pacui', 'MG', NULL, NULL, NULL, 3162658, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.958462', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2978, 'Sao Joao do Paraiso', 'MG', NULL, NULL, NULL, 3162708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.959259', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2979, 'Sao Joao Evangelista', 'MG', NULL, NULL, NULL, 3162807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.960178', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2980, 'Sao Joao Nepomuceno', 'MG', NULL, NULL, NULL, 3162906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.961059', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2981, 'Sao Joaquim de Bicas', 'MG', NULL, NULL, NULL, 3162922, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.962029', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2982, 'Sao Jose da Barra', 'MG', NULL, NULL, NULL, 3162948, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.962922', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2983, 'Sao Jose da Lapa', 'MG', NULL, NULL, NULL, 3162955, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.963826', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2984, 'Sao Jose da Safira', 'MG', NULL, NULL, NULL, 3163003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.964717', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2985, 'Sao Jose da Varginha', 'MG', NULL, NULL, NULL, 3163102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.965573', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2986, 'Sao Jose do Alegre', 'MG', NULL, NULL, NULL, 3163201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.966464', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2987, 'Sao Jose do Divino', 'MG', NULL, NULL, NULL, 3163300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.967302', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2988, 'Sao Jose do Goiabal', 'MG', NULL, NULL, NULL, 3163409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.968161', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2989, 'Sao Jose do Jacuri', 'MG', NULL, NULL, NULL, 3163508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.969054', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2990, 'Sao Jose do Mantimento', 'MG', NULL, NULL, NULL, 3163607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.970124', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2991, 'Sao Lourenco', 'MG', NULL, NULL, NULL, 3163706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.97104', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2992, 'Sao Miguel do Anta', 'MG', NULL, NULL, NULL, 3163805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.971941', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2993, 'Sao Pedro da Uniao', 'MG', NULL, NULL, NULL, 3163904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.972841', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2995, 'Sao Pedro dos Ferros', 'MG', NULL, NULL, NULL, 3164001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.974488', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2994, 'Sao Pedro do Suacui', 'MG', NULL, NULL, NULL, 3164100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.973711', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2996, 'Sao Romao', 'MG', NULL, NULL, NULL, 3164209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.975409', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2997, 'Sao Roque de Minas', 'MG', NULL, NULL, NULL, 3164308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.976377', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2998, 'Sao Sebastiao da Bela Vista', 'MG', NULL, NULL, NULL, 3164407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.977178', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2999, 'Sao Sebastiao da Vargem Alegre', 'MG', NULL, NULL, NULL, 3164431, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.97811', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3000, 'Sao Sebastiao do Anta', 'MG', NULL, NULL, NULL, 3164472, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.984627', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3001, 'Sao Sebastiao do Maranhao', 'MG', NULL, NULL, NULL, 3164506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.985785', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3002, 'Sao Sebastiao do Oeste', 'MG', NULL, NULL, NULL, 3164605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.986709', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3003, 'Sao Sebastiao do Paraiso', 'MG', NULL, NULL, NULL, 3164704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.987623', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3004, 'Sao Sebastiao do Rio Preto', 'MG', NULL, NULL, NULL, 3164803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.988553', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3005, 'Sao Sebastiao do Rio Verde', 'MG', NULL, NULL, NULL, 3164902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.989525', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3007, 'Sao Tiago', 'MG', NULL, NULL, NULL, 3165008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.991371', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3008, 'Sao Tomas de Aquino', 'MG', NULL, NULL, NULL, 3165107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.992485', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3006, 'Sao Thome das Letras', 'MG', NULL, NULL, NULL, 3165206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.990503', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3009, 'Sao Vicente de Minas', 'MG', NULL, NULL, NULL, 3165305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.993316', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3010, 'Sapucai-mirim', 'MG', NULL, NULL, NULL, 3165404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.994126', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3011, 'Sardoa', 'MG', NULL, NULL, NULL, 3165503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.995033', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3012, 'Sarzedo', 'MG', NULL, NULL, NULL, 3165537, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.995979', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3033, 'Setubinha', 'MG', NULL, NULL, NULL, 3165552, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.014708', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3014, 'Senador Amaral', 'MG', NULL, NULL, NULL, 3165578, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.997785', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3015, 'Senador Cortes', 'MG', NULL, NULL, NULL, 3165602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.998572', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3016, 'Senador Firmino', 'MG', NULL, NULL, NULL, 3165701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.999432', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3017, 'Senador Jose Bento', 'MG', NULL, NULL, NULL, 3165800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.000242', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3018, 'Senador Modestino Goncalves', 'MG', NULL, NULL, NULL, 3165909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.001181', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3019, 'Senhora de Oliveira', 'MG', NULL, NULL, NULL, 3166006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.002238', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3020, 'Senhora do Porto', 'MG', NULL, NULL, NULL, 3166105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.003123', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3021, 'Senhora dos Remedios', 'MG', NULL, NULL, NULL, 3166204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.003942', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3022, 'Sericita', 'MG', NULL, NULL, NULL, 3166303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.004806', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3023, 'Seritinga', 'MG', NULL, NULL, NULL, 3166402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.00583', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3024, 'Serra Azul de Minas', 'MG', NULL, NULL, NULL, 3166501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.006724', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3025, 'Serra da Saudade', 'MG', NULL, NULL, NULL, 3166600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.007597', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3027, 'Serra dos Aimores', 'MG', NULL, NULL, NULL, 3166709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.00936', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3026, 'Serra do Salitre', 'MG', NULL, NULL, NULL, 3166808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.008494', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3028, 'Serrania', 'MG', NULL, NULL, NULL, 3166907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.010257', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3029, 'Serranopolis de Minas', 'MG', NULL, NULL, NULL, 3166956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.011126', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3030, 'Serranos', 'MG', NULL, NULL, NULL, 3167004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.011947', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3031, 'Serro', 'MG', NULL, NULL, NULL, 3167103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.012745', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3032, 'Sete Lagoas', 'MG', NULL, NULL, NULL, 3167202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.013654', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3034, 'Silveirania', 'MG', NULL, NULL, NULL, 3167301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.015627', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3035, 'Silvianopolis', 'MG', NULL, NULL, NULL, 3167400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.016489', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3036, 'Simao Pereira', 'MG', NULL, NULL, NULL, 3167509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.017459', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3037, 'Simonesia', 'MG', NULL, NULL, NULL, 3167608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.018331', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3038, 'Sobralia', 'MG', NULL, NULL, NULL, 3167707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.024929', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3039, 'Soledade de Minas', 'MG', NULL, NULL, NULL, 3167806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.026211', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3040, 'Tabuleiro', 'MG', NULL, NULL, NULL, 3167905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.027116', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3041, 'Taiobeiras', 'MG', NULL, NULL, NULL, 3168002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.027909', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3042, 'Taparuba', 'MG', NULL, NULL, NULL, 3168051, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.028691', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3043, 'Tapira', 'MG', NULL, NULL, NULL, 3168101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.029455', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3044, 'Tapirai', 'MG', NULL, NULL, NULL, 3168200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.030502', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3045, 'Taquaracu de Minas', 'MG', NULL, NULL, NULL, 3168309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.031405', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3046, 'Tarumirim', 'MG', NULL, NULL, NULL, 3168408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.032341', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3047, 'Teixeiras', 'MG', NULL, NULL, NULL, 3168507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.033084', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3048, 'Teofilo Otoni', 'MG', NULL, NULL, NULL, 3168606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.034005', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3049, 'Timoteo', 'MG', NULL, NULL, NULL, 3168705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.034877', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3050, 'Tiradentes', 'MG', NULL, NULL, NULL, 3168804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.035717', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3051, 'Tiros', 'MG', NULL, NULL, NULL, 3168903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.036438', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3052, 'Tocantins', 'MG', NULL, NULL, NULL, 3169000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.037378', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3054, 'Toledo', 'MG', NULL, NULL, NULL, 3169109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.039162', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3055, 'Tombos', 'MG', NULL, NULL, NULL, 3169208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.040058', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3056, 'Tres Coracoes', 'MG', NULL, NULL, NULL, 3169307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.040906', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3057, 'Tres Marias', 'MG', NULL, NULL, NULL, 3169356, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.0418', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3058, 'Tres Pontas', 'MG', NULL, NULL, NULL, 3169406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.042593', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3059, 'Tumiritinga', 'MG', NULL, NULL, NULL, 3169505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.043498', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3060, 'Tupaciguara', 'MG', NULL, NULL, NULL, 3169604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.044437', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3061, 'Turmalina', 'MG', NULL, NULL, NULL, 3169703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.045367', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3062, 'Turvolandia', 'MG', NULL, NULL, NULL, 3169802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.04633', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3063, 'Uba', 'MG', NULL, NULL, NULL, 3169901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.047362', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3064, 'Ubai', 'MG', NULL, NULL, NULL, 3170008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.048359', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3065, 'Ubaporanga', 'MG', NULL, NULL, NULL, 3170057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.049243', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3066, 'Uberaba', 'MG', NULL, NULL, NULL, 3170107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.050224', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3067, 'Uberlandia', 'MG', NULL, NULL, NULL, 3170206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.051156', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3068, 'Umburatiba', 'MG', NULL, NULL, NULL, 3170305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.052078', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3069, 'Unai', 'MG', NULL, NULL, NULL, 3170404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.052956', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3070, 'Uniao de Minas', 'MG', NULL, NULL, NULL, 3170438, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.05387', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3071, 'Uruana de Minas', 'MG', NULL, NULL, NULL, 3170479, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.054766', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3072, 'Urucania', 'MG', NULL, NULL, NULL, 3170503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.055651', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3073, 'Urucuia', 'MG', NULL, NULL, NULL, 3170529, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.056552', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3074, 'Vargem Alegre', 'MG', NULL, NULL, NULL, 3170578, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.057453', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3075, 'Vargem Bonita', 'MG', NULL, NULL, NULL, 3170602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.058481', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3076, 'Vargem Grande do Rio Pardo', 'MG', NULL, NULL, NULL, 3170651, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.05921', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3077, 'Varginha', 'MG', NULL, NULL, NULL, 3170701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.065668', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3078, 'Varjao de Minas', 'MG', NULL, NULL, NULL, 3170750, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.066741', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3079, 'Varzea da Palma', 'MG', NULL, NULL, NULL, 3170800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.067629', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3080, 'Varzelandia', 'MG', NULL, NULL, NULL, 3170909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.068499', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3081, 'Vazante', 'MG', NULL, NULL, NULL, 3171006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.069738', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3082, 'Verdelandia', 'MG', NULL, NULL, NULL, 3171030, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.070607', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3083, 'Veredinha', 'MG', NULL, NULL, NULL, 3171071, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.071486', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3084, 'Verissimo', 'MG', NULL, NULL, NULL, 3171105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.072355', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3085, 'Vermelho Novo', 'MG', NULL, NULL, NULL, 3171154, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.073251', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3086, 'Vespasiano', 'MG', NULL, NULL, NULL, 3171204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.074104', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3087, 'Vicosa', 'MG', NULL, NULL, NULL, 3171303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.074933', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3088, 'Vieiras', 'MG', NULL, NULL, NULL, 3171402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.075846', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (2713, 'Mathias Lobato', 'MG', NULL, NULL, NULL, 3171501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:36.667155', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3089, 'Virgem da Lapa', 'MG', NULL, NULL, NULL, 3171600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.076853', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3090, 'Virginia', 'MG', NULL, NULL, NULL, 3171709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.077734', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3091, 'Virginopolis', 'MG', NULL, NULL, NULL, 3171808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.078589', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3092, 'Virgolandia', 'MG', NULL, NULL, NULL, 3171907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.079515', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3093, 'Visconde do Rio Branco', 'MG', NULL, NULL, NULL, 3172004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.080291', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3094, 'Volta Grande', 'MG', NULL, NULL, NULL, 3172103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.081204', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3095, 'Wenceslau Braz', 'MG', NULL, NULL, NULL, 3172202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.081973', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3096, 'Afonso Claudio', 'ES', NULL, NULL, NULL, 3200102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.082886', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3098, 'Aguia Branca', 'ES', NULL, NULL, NULL, 3200136, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.084678', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3097, 'Agua Doce do Norte', 'ES', NULL, NULL, NULL, 3200169, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.08375', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3099, 'Alegre', 'ES', NULL, NULL, NULL, 3200201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.085605', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3100, 'Alfredo Chaves', 'ES', NULL, NULL, NULL, 3200300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.086469', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3101, 'Alto Rio Novo', 'ES', NULL, NULL, NULL, 3200359, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.087312', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3102, 'Anchieta', 'ES', NULL, NULL, NULL, 3200409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.088204', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3103, 'Apiaca', 'ES', NULL, NULL, NULL, 3200508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.089062', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3104, 'Aracruz', 'ES', NULL, NULL, NULL, 3200607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.089943', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3105, 'Atilio Vivacqua', 'ES', NULL, NULL, NULL, 3200706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.09086', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3106, 'Baixo Guandu', 'ES', NULL, NULL, NULL, 3200805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.091737', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3107, 'Barra de Sao Francisco', 'ES', NULL, NULL, NULL, 3200904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.092835', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3108, 'Boa Esperanca', 'ES', NULL, NULL, NULL, 3201001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.093704', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3109, 'Bom Jesus do Norte', 'ES', NULL, NULL, NULL, 3201100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.094622', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3110, 'Brejetuba', 'ES', NULL, NULL, NULL, 3201159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.095495', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3111, 'Cachoeiro de Itapemirim', 'ES', NULL, NULL, NULL, 3201209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.096312', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3112, 'Cariacica', 'ES', NULL, NULL, NULL, 3201308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.097169', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3113, 'Castelo', 'ES', NULL, NULL, NULL, 3201407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.09809', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3114, 'Colatina', 'ES', NULL, NULL, NULL, 3201506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.099011', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3115, 'Conceicao da Barra', 'ES', NULL, NULL, NULL, 3201605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.105545', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3116, 'Conceicao do Castelo', 'ES', NULL, NULL, NULL, 3201704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.106749', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3117, 'Divino de Sao Lourenco', 'ES', NULL, NULL, NULL, 3201803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.107684', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3118, 'Domingos Martins', 'ES', NULL, NULL, NULL, 3201902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.108581', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3119, 'Dores do Rio Preto', 'ES', NULL, NULL, NULL, 3202009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.109452', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3120, 'Ecoporanga', 'ES', NULL, NULL, NULL, 3202108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.110394', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3121, 'Fundao', 'ES', NULL, NULL, NULL, 3202207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.111308', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3122, 'Governador Lindenberg', 'ES', NULL, NULL, NULL, 3202256, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.112208', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3123, 'Guacui', 'ES', NULL, NULL, NULL, 3202306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.113153', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3124, 'Guarapari', 'ES', NULL, NULL, NULL, 3202405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.11402', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3125, 'Ibatiba', 'ES', NULL, NULL, NULL, 3202454, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.11507', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3126, 'Ibiracu', 'ES', NULL, NULL, NULL, 3202504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.115945', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3127, 'Ibitirama', 'ES', NULL, NULL, NULL, 3202553, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.116851', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3128, 'Iconha', 'ES', NULL, NULL, NULL, 3202603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.117854', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3129, 'Irupi', 'ES', NULL, NULL, NULL, 3202652, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.118674', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3130, 'Itaguacu', 'ES', NULL, NULL, NULL, 3202702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.119498', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3131, 'Itapemirim', 'ES', NULL, NULL, NULL, 3202801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.120273', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3132, 'Itarana', 'ES', NULL, NULL, NULL, 3202900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.12108', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3133, 'Iuna', 'ES', NULL, NULL, NULL, 3203007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.122057', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3134, 'Jaguare', 'ES', NULL, NULL, NULL, 3203056, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.122973', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3135, 'Jeronimo Monteiro', 'ES', NULL, NULL, NULL, 3203106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.123854', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3136, 'Joao Neiva', 'ES', NULL, NULL, NULL, 3203130, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.124735', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3137, 'Laranja da Terra', 'ES', NULL, NULL, NULL, 3203163, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.125741', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3138, 'Linhares', 'ES', NULL, NULL, NULL, 3203205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.126641', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3139, 'Mantenopolis', 'ES', NULL, NULL, NULL, 3203304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.127556', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3140, 'Marataizes', 'ES', NULL, NULL, NULL, 3203320, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.128435', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3141, 'Marechal Floriano', 'ES', NULL, NULL, NULL, 3203346, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.129304', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3142, 'Marilandia', 'ES', NULL, NULL, NULL, 3203353, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.130149', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3143, 'Mimoso do Sul', 'ES', NULL, NULL, NULL, 3203403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.131032', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3144, 'Montanha', 'ES', NULL, NULL, NULL, 3203502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.131767', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3145, 'Mucurici', 'ES', NULL, NULL, NULL, 3203601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.132669', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3146, 'Muniz Freire', 'ES', NULL, NULL, NULL, 3203700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.133579', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3147, 'Muqui', 'ES', NULL, NULL, NULL, 3203809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.13436', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3148, 'Nova Venecia', 'ES', NULL, NULL, NULL, 3203908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.135185', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3149, 'Pancas', 'ES', NULL, NULL, NULL, 3204005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.136062', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3150, 'Pedro Canario', 'ES', NULL, NULL, NULL, 3204054, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.137029', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3151, 'Pinheiros', 'ES', NULL, NULL, NULL, 3204104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.13779', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3152, 'Piuma', 'ES', NULL, NULL, NULL, 3204203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.138726', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3153, 'Ponto Belo', 'ES', NULL, NULL, NULL, 3204252, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.139504', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3154, 'Presidente Kennedy', 'ES', NULL, NULL, NULL, 3204302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.146339', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3155, 'Rio Bananal', 'ES', NULL, NULL, NULL, 3204351, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.150463', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3156, 'Rio Novo do Sul', 'ES', NULL, NULL, NULL, 3204401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.151418', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3157, 'Santa Leopoldina', 'ES', NULL, NULL, NULL, 3204500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.152323', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3158, 'Santa Maria de Jetiba', 'ES', NULL, NULL, NULL, 3204559, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.153183', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3159, 'Santa Teresa', 'ES', NULL, NULL, NULL, 3204609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.154075', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3160, 'Sao Domingos do Norte', 'ES', NULL, NULL, NULL, 3204658, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.154905', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3161, 'Sao Gabriel da Palha', 'ES', NULL, NULL, NULL, 3204708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.15581', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3162, 'Sao Jose do Calcado', 'ES', NULL, NULL, NULL, 3204807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.156713', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3163, 'Sao Mateus', 'ES', NULL, NULL, NULL, 3204906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.157706', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3164, 'Sao Roque do Canaa', 'ES', NULL, NULL, NULL, 3204955, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.158648', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3165, 'Serra', 'ES', NULL, NULL, NULL, 3205002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.159594', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3166, 'Sooretama', 'ES', NULL, NULL, NULL, 3205010, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.160485', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3167, 'Vargem Alta', 'ES', NULL, NULL, NULL, 3205036, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.161405', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3168, 'Venda Nova do Imigrante', 'ES', NULL, NULL, NULL, 3205069, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.162222', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3169, 'Viana', 'ES', NULL, NULL, NULL, 3205101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.163119', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3170, 'Vila Pavao', 'ES', NULL, NULL, NULL, 3205150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.164134', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3171, 'Vila Valerio', 'ES', NULL, NULL, NULL, 3205176, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.165005', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3172, 'Vila Velha', 'ES', NULL, NULL, NULL, 3205200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.165861', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3173, 'Vitoria', 'ES', NULL, NULL, NULL, 3205309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.166749', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3174, 'Angra dos Reis', 'RJ', NULL, NULL, NULL, 3300100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.16759', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3175, 'Aperibe', 'RJ', NULL, NULL, NULL, 3300159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.168353', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3176, 'Araruama', 'RJ', NULL, NULL, NULL, 3300209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.169167', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3177, 'Areal', 'RJ', NULL, NULL, NULL, 3300225, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.170131', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3178, 'Armacao dos Buzios', 'RJ', NULL, NULL, NULL, 3300233, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.171024', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3179, 'Arraial do Cabo', 'RJ', NULL, NULL, NULL, 3300258, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.171933', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3180, 'Barra do Pirai', 'RJ', NULL, NULL, NULL, 3300308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.172817', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3181, 'Barra Mansa', 'RJ', NULL, NULL, NULL, 3300407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.173722', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3182, 'Belford Roxo', 'RJ', NULL, NULL, NULL, 3300456, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.174593', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3183, 'Bom Jardim', 'RJ', NULL, NULL, NULL, 3300506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.175369', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3184, 'Bom Jesus do Itabapoana', 'RJ', NULL, NULL, NULL, 3300605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.17623', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3185, 'Cabo Frio', 'RJ', NULL, NULL, NULL, 3300704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.177146', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3186, 'Cachoeiras de Macacu', 'RJ', NULL, NULL, NULL, 3300803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.178064', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3187, 'Cambuci', 'RJ', NULL, NULL, NULL, 3300902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.178988', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3190, 'Carapebus', 'RJ', NULL, NULL, NULL, 3300936, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.188539', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3194, 'Comendador Levy Gasparian', 'RJ', NULL, NULL, NULL, 3300951, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.192154', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3188, 'Campos dos Goytacazes', 'RJ', NULL, NULL, NULL, 3301009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.17996', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3189, 'Cantagalo', 'RJ', NULL, NULL, NULL, 3301108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.187376', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3191, 'Cardoso Moreira', 'RJ', NULL, NULL, NULL, 3301157, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.189489', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3192, 'Carmo', 'RJ', NULL, NULL, NULL, 3301207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.190376', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3193, 'Casimiro de Abreu', 'RJ', NULL, NULL, NULL, 3301306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.191224', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3195, 'Conceicao de Macabu', 'RJ', NULL, NULL, NULL, 3301405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.193182', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3196, 'Cordeiro', 'RJ', NULL, NULL, NULL, 3301504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.194114', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3197, 'Duas Barras', 'RJ', NULL, NULL, NULL, 3301603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.195152', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3198, 'Duque de Caxias', 'RJ', NULL, NULL, NULL, 3301702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.195978', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3199, 'Engenheiro Paulo de Frontin', 'RJ', NULL, NULL, NULL, 3301801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.197016', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3200, 'Guapimirim', 'RJ', NULL, NULL, NULL, 3301850, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.197975', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3201, 'Iguaba Grande', 'RJ', NULL, NULL, NULL, 3301876, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.198896', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3202, 'Itaborai', 'RJ', NULL, NULL, NULL, 3301900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.199823', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3203, 'Itaguai', 'RJ', NULL, NULL, NULL, 3302007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.200615', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3204, 'Italva', 'RJ', NULL, NULL, NULL, 3302056, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.201573', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3205, 'Itaocara', 'RJ', NULL, NULL, NULL, 3302106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.202472', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3206, 'Itaperuna', 'RJ', NULL, NULL, NULL, 3302205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.203303', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3207, 'Itatiaia', 'RJ', NULL, NULL, NULL, 3302254, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.204383', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3208, 'Japeri', 'RJ', NULL, NULL, NULL, 3302270, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.20529', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3209, 'Laje do Muriae', 'RJ', NULL, NULL, NULL, 3302304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.206148', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3210, 'Macae', 'RJ', NULL, NULL, NULL, 3302403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.207034', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3211, 'Macuco', 'RJ', NULL, NULL, NULL, 3302452, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.207887', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3212, 'Mage', 'RJ', NULL, NULL, NULL, 3302502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.208742', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3213, 'Mangaratiba', 'RJ', NULL, NULL, NULL, 3302601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.209642', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3214, 'Marica', 'RJ', NULL, NULL, NULL, 3302700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.210561', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3215, 'Mendes', 'RJ', NULL, NULL, NULL, 3302809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.211426', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3216, 'Mesquita', 'RJ', NULL, NULL, NULL, 3302858, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.212248', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3217, 'Miguel Pereira', 'RJ', NULL, NULL, NULL, 3302908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.21322', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3218, 'Miracema', 'RJ', NULL, NULL, NULL, 3303005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.214025', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3219, 'Natividade', 'RJ', NULL, NULL, NULL, 3303104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.214987', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3220, 'Nilopolis', 'RJ', NULL, NULL, NULL, 3303203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.215631', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3221, 'Niteroi', 'RJ', NULL, NULL, NULL, 3303302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.216575', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3222, 'Nova Friburgo', 'RJ', NULL, NULL, NULL, 3303401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.217505', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3223, 'Nova Iguacu', 'RJ', NULL, NULL, NULL, 3303500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.218374', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3224, 'Paracambi', 'RJ', NULL, NULL, NULL, 3303609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.219241', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3225, 'Paraiba do Sul', 'RJ', NULL, NULL, NULL, 3303708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.22011', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3227, 'Paty do Alferes', 'RJ', NULL, NULL, NULL, 3303856, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.227898', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3228, 'Petropolis', 'RJ', NULL, NULL, NULL, 3303906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.22905', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3229, 'Pinheiral', 'RJ', NULL, NULL, NULL, 3303955, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.229964', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3230, 'Pirai', 'RJ', NULL, NULL, NULL, 3304003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.230972', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3231, 'Porciuncula', 'RJ', NULL, NULL, NULL, 3304102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.231958', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3232, 'Porto Real', 'RJ', NULL, NULL, NULL, 3304110, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.232847', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3233, 'Quatis', 'RJ', NULL, NULL, NULL, 3304128, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.233751', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3234, 'Queimados', 'RJ', NULL, NULL, NULL, 3304144, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.234722', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3235, 'Quissama', 'RJ', NULL, NULL, NULL, 3304151, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.235676', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3236, 'Resende', 'RJ', NULL, NULL, NULL, 3304201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.236633', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3237, 'Rio Bonito', 'RJ', NULL, NULL, NULL, 3304300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.238008', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3238, 'Rio Claro', 'RJ', NULL, NULL, NULL, 3304409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.238923', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3239, 'Rio das Flores', 'RJ', NULL, NULL, NULL, 3304508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.239799', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3240, 'Rio das Ostras', 'RJ', NULL, NULL, NULL, 3304524, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.24067', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3241, 'Rio de Janeiro', 'RJ', NULL, NULL, NULL, 3304557, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.241514', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3242, 'Santa Maria Madalena', 'RJ', NULL, NULL, NULL, 3304607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.242392', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3243, 'Santo Antonio de Padua', 'RJ', NULL, NULL, NULL, 3304706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.24326', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3245, 'Sao Francisco de Itabapoana', 'RJ', NULL, NULL, NULL, 3304755, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.244999', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3244, 'Sao Fidelis', 'RJ', NULL, NULL, NULL, 3304805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.244209', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3246, 'Sao Goncalo', 'RJ', NULL, NULL, NULL, 3304904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.245904', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3247, 'Sao Joao da Barra', 'RJ', NULL, NULL, NULL, 3305000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.24683', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3248, 'Sao Joao de Meriti', 'RJ', NULL, NULL, NULL, 3305109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.24777', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3249, 'Sao Jose de Uba', 'RJ', NULL, NULL, NULL, 3305133, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.248945', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3250, 'Sao Jose do Vale do Rio Preto', 'RJ', NULL, NULL, NULL, 3305158, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.249825', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3251, 'Sao Pedro da Aldeia', 'RJ', NULL, NULL, NULL, 3305208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.250587', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3252, 'Sao Sebastiao do Alto', 'RJ', NULL, NULL, NULL, 3305307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.251419', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3253, 'Sapucaia', 'RJ', NULL, NULL, NULL, 3305406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.252236', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3254, 'Saquarema', 'RJ', NULL, NULL, NULL, 3305505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.253149', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3255, 'Seropedica', 'RJ', NULL, NULL, NULL, 3305554, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.254076', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3256, 'Silva Jardim', 'RJ', NULL, NULL, NULL, 3305604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.254876', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3257, 'Sumidouro', 'RJ', NULL, NULL, NULL, 3305703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.255796', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3258, 'Tangua', 'RJ', NULL, NULL, NULL, 3305752, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.256693', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3259, 'Teresopolis', 'RJ', NULL, NULL, NULL, 3305802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.257579', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3261, 'Tres Rios', 'RJ', NULL, NULL, NULL, 3306008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.259558', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3262, 'Valenca', 'RJ', NULL, NULL, NULL, 3306107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.260357', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3263, 'Varre-sai', 'RJ', NULL, NULL, NULL, 3306156, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.261201', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3264, 'Vassouras', 'RJ', NULL, NULL, NULL, 3306206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.262061', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3265, 'Volta Redonda', 'RJ', NULL, NULL, NULL, 3306305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.268581', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3266, 'Adamantina', 'SP', NULL, NULL, NULL, 3500105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.269835', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3267, 'Adolfo', 'SP', NULL, NULL, NULL, 3500204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.27087', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3268, 'Aguai', 'SP', NULL, NULL, NULL, 3500303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.27173', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3269, 'Aguas da Prata', 'SP', NULL, NULL, NULL, 3500402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.272445', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3270, 'Aguas de Lindoia', 'SP', NULL, NULL, NULL, 3500501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.273402', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3271, 'Aguas de Santa Barbara', 'SP', NULL, NULL, NULL, 3500550, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.274253', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3272, 'Aguas de Sao Pedro', 'SP', NULL, NULL, NULL, 3500600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.275125', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3273, 'Agudos', 'SP', NULL, NULL, NULL, 3500709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.276017', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3274, 'Alambari', 'SP', NULL, NULL, NULL, 3500758, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.276922', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3275, 'Alfredo Marcondes', 'SP', NULL, NULL, NULL, 3500808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.277864', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3276, 'Altair', 'SP', NULL, NULL, NULL, 3500907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.278774', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3277, 'Altinopolis', 'SP', NULL, NULL, NULL, 3501004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.279605', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3278, 'Alto Alegre', 'SP', NULL, NULL, NULL, 3501103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.280491', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3279, 'Aluminio', 'SP', NULL, NULL, NULL, 3501152, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.281409', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3280, 'Alvares Florence', 'SP', NULL, NULL, NULL, 3501202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.282369', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3281, 'Alvares Machado', 'SP', NULL, NULL, NULL, 3501301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.283238', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3282, 'Alvaro de Carvalho', 'SP', NULL, NULL, NULL, 3501400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.284169', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3283, 'Alvinlandia', 'SP', NULL, NULL, NULL, 3501509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.285077', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3284, 'Americana', 'SP', NULL, NULL, NULL, 3501608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.286013', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3285, 'Americo Brasiliense', 'SP', NULL, NULL, NULL, 3501707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.286803', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3286, 'Americo de Campos', 'SP', NULL, NULL, NULL, 3501806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.287738', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3287, 'Amparo', 'SP', NULL, NULL, NULL, 3501905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.288607', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3288, 'Analandia', 'SP', NULL, NULL, NULL, 3502002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.2895', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3289, 'Andradina', 'SP', NULL, NULL, NULL, 3502101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.290456', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3290, 'Angatuba', 'SP', NULL, NULL, NULL, 3502200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.291244', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3291, 'Anhembi', 'SP', NULL, NULL, NULL, 3502309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.29216', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3292, 'Anhumas', 'SP', NULL, NULL, NULL, 3502408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.293119', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3293, 'Aparecida', 'SP', NULL, NULL, NULL, 3502507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.293914', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3294, 'Aparecida D''oeste', 'SP', NULL, NULL, NULL, 3502606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.294812', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3295, 'Apiai', 'SP', NULL, NULL, NULL, 3502705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.295701', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3296, 'Aracariguama', 'SP', NULL, NULL, NULL, 3502754, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.29661', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3297, 'Aracatuba', 'SP', NULL, NULL, NULL, 3502804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.297483', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3298, 'Aracoiaba da Serra', 'SP', NULL, NULL, NULL, 3502903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.298305', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3299, 'Aramina', 'SP', NULL, NULL, NULL, 3503000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.299187', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3300, 'Arandu', 'SP', NULL, NULL, NULL, 3503109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.299986', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3301, 'Arapei', 'SP', NULL, NULL, NULL, 3503158, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.300898', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3302, 'Araraquara', 'SP', NULL, NULL, NULL, 3503208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.301802', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3303, 'Araras', 'SP', NULL, NULL, NULL, 3503307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.308817', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3304, 'Arco-iris', 'SP', NULL, NULL, NULL, 3503356, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.31001', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3305, 'Arealva', 'SP', NULL, NULL, NULL, 3503406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.311055', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3306, 'Areias', 'SP', NULL, NULL, NULL, 3503505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.31192', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3307, 'Areiopolis', 'SP', NULL, NULL, NULL, 3503604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.312751', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3308, 'Ariranha', 'SP', NULL, NULL, NULL, 3503703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.313577', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3309, 'Artur Nogueira', 'SP', NULL, NULL, NULL, 3503802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.314489', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3310, 'Aruja', 'SP', NULL, NULL, NULL, 3503901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.315495', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3311, 'Aspasia', 'SP', NULL, NULL, NULL, 3503950, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.316308', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3312, 'Assis', 'SP', NULL, NULL, NULL, 3504008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.317358', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3313, 'Atibaia', 'SP', NULL, NULL, NULL, 3504107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.318277', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3314, 'Auriflama', 'SP', NULL, NULL, NULL, 3504206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.319244', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3315, 'Avai', 'SP', NULL, NULL, NULL, 3504305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.320115', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3316, 'Avanhandava', 'SP', NULL, NULL, NULL, 3504404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.320988', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3317, 'Avare', 'SP', NULL, NULL, NULL, 3504503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.321877', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3318, 'Bady Bassitt', 'SP', NULL, NULL, NULL, 3504602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.322788', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3319, 'Balbinos', 'SP', NULL, NULL, NULL, 3504701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.32373', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3320, 'Balsamo', 'SP', NULL, NULL, NULL, 3504800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.324586', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3321, 'Bananal', 'SP', NULL, NULL, NULL, 3504909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.325482', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3322, 'Barao de Antonina', 'SP', NULL, NULL, NULL, 3505005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.326512', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3323, 'Barbosa', 'SP', NULL, NULL, NULL, 3505104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.327365', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3324, 'Bariri', 'SP', NULL, NULL, NULL, 3505203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.328252', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3325, 'Barra Bonita', 'SP', NULL, NULL, NULL, 3505302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.329113', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3326, 'Barra do Chapeu', 'SP', NULL, NULL, NULL, 3505351, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.329955', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3327, 'Barra do Turvo', 'SP', NULL, NULL, NULL, 3505401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.330965', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3328, 'Barretos', 'SP', NULL, NULL, NULL, 3505500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.331935', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3329, 'Barrinha', 'SP', NULL, NULL, NULL, 3505609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.332765', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3330, 'Barueri', 'SP', NULL, NULL, NULL, 3505708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.333592', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3331, 'Bastos', 'SP', NULL, NULL, NULL, 3505807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.334547', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3332, 'Batatais', 'SP', NULL, NULL, NULL, 3505906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.33538', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3333, 'Bauru', 'SP', NULL, NULL, NULL, 3506003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.336251', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3334, 'Bebedouro', 'SP', NULL, NULL, NULL, 3506102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.337171', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3335, 'Bento de Abreu', 'SP', NULL, NULL, NULL, 3506201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.338264', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3336, 'Bernardino de Campos', 'SP', NULL, NULL, NULL, 3506300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.339179', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3337, 'Bertioga', 'SP', NULL, NULL, NULL, 3506359, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.340015', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3338, 'Bilac', 'SP', NULL, NULL, NULL, 3506409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.340826', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3339, 'Birigui', 'SP', NULL, NULL, NULL, 3506508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.341697', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3340, 'Biritiba-mirim', 'SP', NULL, NULL, NULL, 3506607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.342549', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3341, 'Boa Esperanca do Sul', 'SP', NULL, NULL, NULL, 3506706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.350287', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3342, 'Bocaina', 'SP', NULL, NULL, NULL, 3506805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.351429', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3343, 'Bofete', 'SP', NULL, NULL, NULL, 3506904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.352408', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3344, 'Boituva', 'SP', NULL, NULL, NULL, 3507001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.353564', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3345, 'Bom Jesus dos Perdoes', 'SP', NULL, NULL, NULL, 3507100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.354421', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3346, 'Bom Sucesso de Itarare', 'SP', NULL, NULL, NULL, 3507159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.355449', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3347, 'Bora', 'SP', NULL, NULL, NULL, 3507209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.356379', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3348, 'Boraceia', 'SP', NULL, NULL, NULL, 3507308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.357481', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3349, 'Borborema', 'SP', NULL, NULL, NULL, 3507407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.358426', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3350, 'Borebi', 'SP', NULL, NULL, NULL, 3507456, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.359296', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3351, 'Botucatu', 'SP', NULL, NULL, NULL, 3507506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.360376', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3352, 'Braganca Paulista', 'SP', NULL, NULL, NULL, 3507605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.361423', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3353, 'Brauna', 'SP', NULL, NULL, NULL, 3507704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.362273', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3354, 'Brejo Alegre', 'SP', NULL, NULL, NULL, 3507753, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.363155', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3355, 'Brodowski', 'SP', NULL, NULL, NULL, 3507803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.364124', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3356, 'Brotas', 'SP', NULL, NULL, NULL, 3507902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.365052', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3357, 'Buri', 'SP', NULL, NULL, NULL, 3508009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.366004', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3358, 'Buritama', 'SP', NULL, NULL, NULL, 3508108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.366945', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3359, 'Buritizal', 'SP', NULL, NULL, NULL, 3508207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.367895', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3360, 'Cabralia Paulista', 'SP', NULL, NULL, NULL, 3508306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.368816', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3361, 'Cabreuva', 'SP', NULL, NULL, NULL, 3508405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.369719', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3362, 'Cacapava', 'SP', NULL, NULL, NULL, 3508504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.370627', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3363, 'Cachoeira Paulista', 'SP', NULL, NULL, NULL, 3508603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.371763', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3364, 'Caconde', 'SP', NULL, NULL, NULL, 3508702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.372711', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3365, 'Cafelandia', 'SP', NULL, NULL, NULL, 3508801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.373562', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3366, 'Caiabu', 'SP', NULL, NULL, NULL, 3508900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.374476', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3367, 'Caieiras', 'SP', NULL, NULL, NULL, 3509007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.375453', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3368, 'Caiua', 'SP', NULL, NULL, NULL, 3509106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.37635', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3369, 'Cajamar', 'SP', NULL, NULL, NULL, 3509205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.377277', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3370, 'Cajati', 'SP', NULL, NULL, NULL, 3509254, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.378209', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3371, 'Cajobi', 'SP', NULL, NULL, NULL, 3509304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.379165', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3372, 'Cajuru', 'SP', NULL, NULL, NULL, 3509403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.380188', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3373, 'Campina do Monte Alegre', 'SP', NULL, NULL, NULL, 3509452, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.381138', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3374, 'Campinas', 'SP', NULL, NULL, NULL, 3509502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.381967', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3375, 'Campo Limpo Paulista', 'SP', NULL, NULL, NULL, 3509601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.382892', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3376, 'Campos do Jordao', 'SP', NULL, NULL, NULL, 3509700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.384015', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3377, 'Campos Novos Paulista', 'SP', NULL, NULL, NULL, 3509809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.390894', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3378, 'Cananeia', 'SP', NULL, NULL, NULL, 3509908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.392104', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3379, 'Canas', 'SP', NULL, NULL, NULL, 3509957, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.393199', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3380, 'Candido Mota', 'SP', NULL, NULL, NULL, 3510005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.394055', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3381, 'Candido Rodrigues', 'SP', NULL, NULL, NULL, 3510104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.39493', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3382, 'Canitar', 'SP', NULL, NULL, NULL, 3510153, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.395858', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3383, 'Capao Bonito', 'SP', NULL, NULL, NULL, 3510203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.39675', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3384, 'Capela do Alto', 'SP', NULL, NULL, NULL, 3510302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.397713', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3385, 'Capivari', 'SP', NULL, NULL, NULL, 3510401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.398691', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3386, 'Caraguatatuba', 'SP', NULL, NULL, NULL, 3510500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.399692', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3387, 'Carapicuiba', 'SP', NULL, NULL, NULL, 3510609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.400634', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3388, 'Cardoso', 'SP', NULL, NULL, NULL, 3510708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.401562', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3389, 'Casa Branca', 'SP', NULL, NULL, NULL, 3510807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.40251', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3390, 'Cassia dos Coqueiros', 'SP', NULL, NULL, NULL, 3510906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.403415', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3391, 'Castilho', 'SP', NULL, NULL, NULL, 3511003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.4044', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3392, 'Catanduva', 'SP', NULL, NULL, NULL, 3511102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.405192', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3393, 'Catigua', 'SP', NULL, NULL, NULL, 3511201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.406069', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3394, 'Cedral', 'SP', NULL, NULL, NULL, 3511300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.407007', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3395, 'Cerqueira Cesar', 'SP', NULL, NULL, NULL, 3511409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.407879', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3396, 'Cerquilho', 'SP', NULL, NULL, NULL, 3511508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.408712', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3397, 'Cesario Lange', 'SP', NULL, NULL, NULL, 3511607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.409578', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3398, 'Charqueada', 'SP', NULL, NULL, NULL, 3511706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.410493', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3400, 'Clementina', 'SP', NULL, NULL, NULL, 3511904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.412407', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3401, 'Colina', 'SP', NULL, NULL, NULL, 3512001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.413332', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3402, 'Colombia', 'SP', NULL, NULL, NULL, 3512100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.41435', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3403, 'Conchal', 'SP', NULL, NULL, NULL, 3512209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.415259', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3404, 'Conchas', 'SP', NULL, NULL, NULL, 3512308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.416408', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3405, 'Cordeiropolis', 'SP', NULL, NULL, NULL, 3512407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.417364', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3406, 'Coroados', 'SP', NULL, NULL, NULL, 3512506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.418209', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3407, 'Coronel Macedo', 'SP', NULL, NULL, NULL, 3512605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.41912', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3408, 'Corumbatai', 'SP', NULL, NULL, NULL, 3512704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.420001', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3409, 'Cosmopolis', 'SP', NULL, NULL, NULL, 3512803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.420964', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3410, 'Cosmorama', 'SP', NULL, NULL, NULL, 3512902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.421879', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3411, 'Cotia', 'SP', NULL, NULL, NULL, 3513009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.422822', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3412, 'Cravinhos', 'SP', NULL, NULL, NULL, 3513108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.423659', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3413, 'Cristais Paulista', 'SP', NULL, NULL, NULL, 3513207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.424565', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3414, 'Cruzalia', 'SP', NULL, NULL, NULL, 3513306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.433202', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3415, 'Cruzeiro', 'SP', NULL, NULL, NULL, 3513405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.43419', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3416, 'Cubatao', 'SP', NULL, NULL, NULL, 3513504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.435124', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3417, 'Cunha', 'SP', NULL, NULL, NULL, 3513603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.436005', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3418, 'Descalvado', 'SP', NULL, NULL, NULL, 3513702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.436909', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3419, 'Diadema', 'SP', NULL, NULL, NULL, 3513801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.43802', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3420, 'Dirce Reis', 'SP', NULL, NULL, NULL, 3513850, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.438961', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3421, 'Divinolandia', 'SP', NULL, NULL, NULL, 3513900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.439881', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3422, 'Dobrada', 'SP', NULL, NULL, NULL, 3514007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.44092', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3423, 'Dois Corregos', 'SP', NULL, NULL, NULL, 3514106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.441834', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3424, 'Dolcinopolis', 'SP', NULL, NULL, NULL, 3514205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.442609', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3425, 'Dourado', 'SP', NULL, NULL, NULL, 3514304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.443543', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3426, 'Dracena', 'SP', NULL, NULL, NULL, 3514403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.444476', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3427, 'Duartina', 'SP', NULL, NULL, NULL, 3514502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.445394', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3428, 'Dumont', 'SP', NULL, NULL, NULL, 3514601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.44637', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3429, 'Echapora', 'SP', NULL, NULL, NULL, 3514700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.447249', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3430, 'Eldorado', 'SP', NULL, NULL, NULL, 3514809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.448152', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3431, 'Elias Fausto', 'SP', NULL, NULL, NULL, 3514908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.449197', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3432, 'Elisiario', 'SP', NULL, NULL, NULL, 3514924, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.450013', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3433, 'Embauba', 'SP', NULL, NULL, NULL, 3514957, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.450854', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3435, 'Embu-guacu', 'SP', NULL, NULL, NULL, 3515103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.452864', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3436, 'Emilianopolis', 'SP', NULL, NULL, NULL, 3515129, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.453877', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3437, 'Engenheiro Coelho', 'SP', NULL, NULL, NULL, 3515152, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.454824', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3438, 'Espirito Santo do Pinhal', 'SP', NULL, NULL, NULL, 3515186, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.455702', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3439, 'Espirito Santo do Turvo', 'SP', NULL, NULL, NULL, 3515194, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.456596', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3442, 'Estrela D''oeste', 'SP', NULL, NULL, NULL, 3515202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.464626', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3441, 'Estrela do Norte', 'SP', NULL, NULL, NULL, 3515301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.463187', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3443, 'Euclides da Cunha Paulista', 'SP', NULL, NULL, NULL, 3515350, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.465815', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3444, 'Fartura', 'SP', NULL, NULL, NULL, 3515400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.467149', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3446, 'Fernandopolis', 'SP', NULL, NULL, NULL, 3515509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.474339', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3445, 'Fernando Prestes', 'SP', NULL, NULL, NULL, 3515608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.468296', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3447, 'Fernao', 'SP', NULL, NULL, NULL, 3515657, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.475403', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3448, 'Ferraz de Vasconcelos', 'SP', NULL, NULL, NULL, 3515707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.476418', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3449, 'Flora Rica', 'SP', NULL, NULL, NULL, 3515806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.477443', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3450, 'Floreal', 'SP', NULL, NULL, NULL, 3515905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.478415', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3451, 'Florida Paulista', 'SP', NULL, NULL, NULL, 3516002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.479622', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3452, 'Florinia', 'SP', NULL, NULL, NULL, 3516101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.480544', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3453, 'Franca', 'SP', NULL, NULL, NULL, 3516200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.481469', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3454, 'Francisco Morato', 'SP', NULL, NULL, NULL, 3516309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.482394', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3455, 'Franco da Rocha', 'SP', NULL, NULL, NULL, 3516408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.483499', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3456, 'Gabriel Monteiro', 'SP', NULL, NULL, NULL, 3516507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.484411', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3457, 'Galia', 'SP', NULL, NULL, NULL, 3516606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.485277', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3458, 'Garca', 'SP', NULL, NULL, NULL, 3516705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.486137', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3459, 'Gastao Vidigal', 'SP', NULL, NULL, NULL, 3516804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.487262', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3460, 'Gaviao Peixoto', 'SP', NULL, NULL, NULL, 3516853, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.488275', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3461, 'General Salgado', 'SP', NULL, NULL, NULL, 3516903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.489182', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3462, 'Getulina', 'SP', NULL, NULL, NULL, 3517000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.490105', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3463, 'Glicerio', 'SP', NULL, NULL, NULL, 3517109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.491081', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3464, 'Guaicara', 'SP', NULL, NULL, NULL, 3517208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.49205', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3465, 'Guaimbe', 'SP', NULL, NULL, NULL, 3517307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.492981', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3466, 'Guaira', 'SP', NULL, NULL, NULL, 3517406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.493861', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3467, 'Guapiacu', 'SP', NULL, NULL, NULL, 3517505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.494824', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3468, 'Guapiara', 'SP', NULL, NULL, NULL, 3517604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.495711', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3469, 'Guara', 'SP', NULL, NULL, NULL, 3517703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.49662', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3470, 'Guaracai', 'SP', NULL, NULL, NULL, 3517802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.497498', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3471, 'Guaraci', 'SP', NULL, NULL, NULL, 3517901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.498609', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3472, 'Guarani D''oeste', 'SP', NULL, NULL, NULL, 3518008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.499582', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3473, 'Guaranta', 'SP', NULL, NULL, NULL, 3518107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.500522', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3474, 'Guararapes', 'SP', NULL, NULL, NULL, 3518206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.501478', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3475, 'Guararema', 'SP', NULL, NULL, NULL, 3518305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.502457', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3476, 'Guaratingueta', 'SP', NULL, NULL, NULL, 3518404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.503375', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3477, 'Guarei', 'SP', NULL, NULL, NULL, 3518503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.504252', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3478, 'Guariba', 'SP', NULL, NULL, NULL, 3518602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.50542', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3479, 'Guaruja', 'SP', NULL, NULL, NULL, 3518701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.506355', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3480, 'Guarulhos', 'SP', NULL, NULL, NULL, 3518800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.50736', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3481, 'Guatapara', 'SP', NULL, NULL, NULL, 3518859, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.514491', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3482, 'Guzolandia', 'SP', NULL, NULL, NULL, 3518909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.51563', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3483, 'Herculandia', 'SP', NULL, NULL, NULL, 3519006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.516787', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3484, 'Holambra', 'SP', NULL, NULL, NULL, 3519055, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.517506', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3485, 'Hortolandia', 'SP', NULL, NULL, NULL, 3519071, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.518326', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3486, 'Iacanga', 'SP', NULL, NULL, NULL, 3519105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.519603', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3487, 'Iacri', 'SP', NULL, NULL, NULL, 3519204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.520661', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3488, 'Iaras', 'SP', NULL, NULL, NULL, 3519253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.521549', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3489, 'Ibate', 'SP', NULL, NULL, NULL, 3519303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.522424', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3490, 'Ibira', 'SP', NULL, NULL, NULL, 3519402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.52329', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3491, 'Ibirarema', 'SP', NULL, NULL, NULL, 3519501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.524224', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3492, 'Ibitinga', 'SP', NULL, NULL, NULL, 3519600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.525141', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3493, 'Ibiuna', 'SP', NULL, NULL, NULL, 3519709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.526048', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3494, 'Icem', 'SP', NULL, NULL, NULL, 3519808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.526892', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3495, 'Iepe', 'SP', NULL, NULL, NULL, 3519907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.527707', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3496, 'Igaracu do Tiete', 'SP', NULL, NULL, NULL, 3520004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.528553', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3497, 'Igarapava', 'SP', NULL, NULL, NULL, 3520103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.5295', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3498, 'Igarata', 'SP', NULL, NULL, NULL, 3520202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.530465', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3499, 'Iguape', 'SP', NULL, NULL, NULL, 3520301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.531632', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3502, 'Ilhabela', 'SP', NULL, NULL, NULL, 3520400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.534591', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3500, 'Ilha Comprida', 'SP', NULL, NULL, NULL, 3520426, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.532647', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3501, 'Ilha Solteira', 'SP', NULL, NULL, NULL, 3520442, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.533656', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3503, 'Indaiatuba', 'SP', NULL, NULL, NULL, 3520509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.53556', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3504, 'Indiana', 'SP', NULL, NULL, NULL, 3520608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.536463', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3505, 'Indiapora', 'SP', NULL, NULL, NULL, 3520707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.537406', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3506, 'Inubia Paulista', 'SP', NULL, NULL, NULL, 3520806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.538346', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3507, 'Ipaussu', 'SP', NULL, NULL, NULL, 3520905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.539122', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3508, 'Ipero', 'SP', NULL, NULL, NULL, 3521002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.540114', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3509, 'Ipeuna', 'SP', NULL, NULL, NULL, 3521101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.54106', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3510, 'Ipigua', 'SP', NULL, NULL, NULL, 3521150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.542009', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3511, 'Iporanga', 'SP', NULL, NULL, NULL, 3521200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.542934', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3512, 'Ipua', 'SP', NULL, NULL, NULL, 3521309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.543761', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3513, 'Iracemapolis', 'SP', NULL, NULL, NULL, 3521408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.544853', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3514, 'Irapua', 'SP', NULL, NULL, NULL, 3521507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.545807', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3515, 'Irapuru', 'SP', NULL, NULL, NULL, 3521606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.546727', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3516, 'Itabera', 'SP', NULL, NULL, NULL, 3521705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.54776', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3517, 'Itai', 'SP', NULL, NULL, NULL, 3521804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.555415', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3518, 'Itajobi', 'SP', NULL, NULL, NULL, 3521903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.556639', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3519, 'Itaju', 'SP', NULL, NULL, NULL, 3522000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.557538', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3520, 'Itanhaem', 'SP', NULL, NULL, NULL, 3522109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.558368', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3521, 'Itaoca', 'SP', NULL, NULL, NULL, 3522158, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.559349', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3522, 'Itapecerica da Serra', 'SP', NULL, NULL, NULL, 3522208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.560304', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3523, 'Itapetininga', 'SP', NULL, NULL, NULL, 3522307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.561226', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3524, 'Itapeva', 'SP', NULL, NULL, NULL, 3522406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.562042', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3525, 'Itapevi', 'SP', NULL, NULL, NULL, 3522505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.563', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3526, 'Itapira', 'SP', NULL, NULL, NULL, 3522604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.564035', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3527, 'Itapirapua Paulista', 'SP', NULL, NULL, NULL, 3522653, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.564976', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3528, 'Itapolis', 'SP', NULL, NULL, NULL, 3522703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.565875', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3529, 'Itaporanga', 'SP', NULL, NULL, NULL, 3522802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.566665', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3530, 'Itapui', 'SP', NULL, NULL, NULL, 3522901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.567469', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3531, 'Itapura', 'SP', NULL, NULL, NULL, 3523008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.568248', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3532, 'Itaquaquecetuba', 'SP', NULL, NULL, NULL, 3523107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.569268', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3533, 'Itarare', 'SP', NULL, NULL, NULL, 3523206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.570327', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3534, 'Itariri', 'SP', NULL, NULL, NULL, 3523305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.571116', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3535, 'Itatiba', 'SP', NULL, NULL, NULL, 3523404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.572068', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3536, 'Itatinga', 'SP', NULL, NULL, NULL, 3523503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.572867', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3537, 'Itirapina', 'SP', NULL, NULL, NULL, 3523602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.57366', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3538, 'Itirapua', 'SP', NULL, NULL, NULL, 3523701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.574547', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3539, 'Itobi', 'SP', NULL, NULL, NULL, 3523800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.57546', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3540, 'Itu', 'SP', NULL, NULL, NULL, 3523909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.576321', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3541, 'Itupeva', 'SP', NULL, NULL, NULL, 3524006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.577536', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3542, 'Ituverava', 'SP', NULL, NULL, NULL, 3524105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.578426', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3543, 'Jaborandi', 'SP', NULL, NULL, NULL, 3524204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.579392', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3544, 'Jaboticabal', 'SP', NULL, NULL, NULL, 3524303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.58031', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3545, 'Jacarei', 'SP', NULL, NULL, NULL, 3524402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.581242', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3546, 'Jaci', 'SP', NULL, NULL, NULL, 3524501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.582181', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3547, 'Jacupiranga', 'SP', NULL, NULL, NULL, 3524600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.583183', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3548, 'Jaguariuna', 'SP', NULL, NULL, NULL, 3524709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.583988', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3549, 'Jales', 'SP', NULL, NULL, NULL, 3524808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.584901', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3550, 'Jambeiro', 'SP', NULL, NULL, NULL, 3524907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.585854', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3551, 'Jandira', 'SP', NULL, NULL, NULL, 3525003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.586757', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3552, 'Jardinopolis', 'SP', NULL, NULL, NULL, 3525102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.587586', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3553, 'Jarinu', 'SP', NULL, NULL, NULL, 3525201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.588515', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3554, 'Jau', 'SP', NULL, NULL, NULL, 3525300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.589433', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3555, 'Jeriquara', 'SP', NULL, NULL, NULL, 3525409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.590483', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3556, 'Joanopolis', 'SP', NULL, NULL, NULL, 3525508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.596351', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3557, 'Joao Ramalho', 'SP', NULL, NULL, NULL, 3525607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.597603', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3558, 'Jose Bonifacio', 'SP', NULL, NULL, NULL, 3525706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.59875', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3559, 'Julio Mesquita', 'SP', NULL, NULL, NULL, 3525805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.599726', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3560, 'Jumirim', 'SP', NULL, NULL, NULL, 3525854, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.600794', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3561, 'Jundiai', 'SP', NULL, NULL, NULL, 3525904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.601706', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3562, 'Junqueiropolis', 'SP', NULL, NULL, NULL, 3526001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.602591', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3563, 'Juquia', 'SP', NULL, NULL, NULL, 3526100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.603635', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3564, 'Juquitiba', 'SP', NULL, NULL, NULL, 3526209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.604582', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3565, 'Lagoinha', 'SP', NULL, NULL, NULL, 3526308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.605474', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3566, 'Laranjal Paulista', 'SP', NULL, NULL, NULL, 3526407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.607194', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3567, 'Lavinia', 'SP', NULL, NULL, NULL, 3526506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.608188', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3568, 'Lavrinhas', 'SP', NULL, NULL, NULL, 3526605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.60912', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3569, 'Leme', 'SP', NULL, NULL, NULL, 3526704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.609957', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3570, 'Lencois Paulista', 'SP', NULL, NULL, NULL, 3526803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.611063', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3571, 'Limeira', 'SP', NULL, NULL, NULL, 3526902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.612034', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3572, 'Lindoia', 'SP', NULL, NULL, NULL, 3527009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.613045', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3573, 'Lins', 'SP', NULL, NULL, NULL, 3527108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.613865', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3574, 'Lorena', 'SP', NULL, NULL, NULL, 3527207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.61467', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3575, 'Lourdes', 'SP', NULL, NULL, NULL, 3527256, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.615605', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3576, 'Louveira', 'SP', NULL, NULL, NULL, 3527306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.616624', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3577, 'Lucelia', 'SP', NULL, NULL, NULL, 3527405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.617438', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3578, 'Lucianopolis', 'SP', NULL, NULL, NULL, 3527504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.618341', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3579, 'Luis Antonio', 'SP', NULL, NULL, NULL, 3527603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.619193', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3580, 'Luiziania', 'SP', NULL, NULL, NULL, 3527702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.620134', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3581, 'Lupercio', 'SP', NULL, NULL, NULL, 3527801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.621094', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3582, 'Lutecia', 'SP', NULL, NULL, NULL, 3527900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.62201', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3583, 'Macatuba', 'SP', NULL, NULL, NULL, 3528007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.622926', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3584, 'Macaubal', 'SP', NULL, NULL, NULL, 3528106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.623778', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3585, 'Macedonia', 'SP', NULL, NULL, NULL, 3528205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.624723', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3586, 'Magda', 'SP', NULL, NULL, NULL, 3528304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.625616', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3587, 'Mairinque', 'SP', NULL, NULL, NULL, 3528403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.62654', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3588, 'Mairipora', 'SP', NULL, NULL, NULL, 3528502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.627638', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3589, 'Manduri', 'SP', NULL, NULL, NULL, 3528601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.628439', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3590, 'Maraba Paulista', 'SP', NULL, NULL, NULL, 3528700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.629383', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3591, 'Maracai', 'SP', NULL, NULL, NULL, 3528809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.636541', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3592, 'Marapoama', 'SP', NULL, NULL, NULL, 3528858, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.63785', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3593, 'Mariapolis', 'SP', NULL, NULL, NULL, 3528908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.638856', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3594, 'Marilia', 'SP', NULL, NULL, NULL, 3529005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.639554', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3595, 'Marinopolis', 'SP', NULL, NULL, NULL, 3529104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.640522', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3596, 'Martinopolis', 'SP', NULL, NULL, NULL, 3529203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.641428', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3597, 'Matao', 'SP', NULL, NULL, NULL, 3529302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.642269', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3598, 'Maua', 'SP', NULL, NULL, NULL, 3529401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.643236', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3599, 'Mendonca', 'SP', NULL, NULL, NULL, 3529500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.644256', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3600, 'Meridiano', 'SP', NULL, NULL, NULL, 3529609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.645169', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3601, 'Mesopolis', 'SP', NULL, NULL, NULL, 3529658, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.64605', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3602, 'Miguelopolis', 'SP', NULL, NULL, NULL, 3529708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.646934', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3603, 'Mineiros do Tiete', 'SP', NULL, NULL, NULL, 3529807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.647811', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3605, 'Miracatu', 'SP', NULL, NULL, NULL, 3529906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.649539', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3604, 'Mira Estrela', 'SP', NULL, NULL, NULL, 3530003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.648659', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3606, 'Mirandopolis', 'SP', NULL, NULL, NULL, 3530102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.650507', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3607, 'Mirante do Paranapanema', 'SP', NULL, NULL, NULL, 3530201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.651428', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3608, 'Mirassol', 'SP', NULL, NULL, NULL, 3530300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.652283', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3609, 'Mirassolandia', 'SP', NULL, NULL, NULL, 3530409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.653107', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3610, 'Mococa', 'SP', NULL, NULL, NULL, 3530508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.65403', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3611, 'Mogi das Cruzes', 'SP', NULL, NULL, NULL, 3530607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.654934', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3612, 'Mogi Guacu', 'SP', NULL, NULL, NULL, 3530706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.655912', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3614, 'Mombuca', 'SP', NULL, NULL, NULL, 3530904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.65768', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3615, 'Moncoes', 'SP', NULL, NULL, NULL, 3531001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.658653', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3616, 'Mongagua', 'SP', NULL, NULL, NULL, 3531100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.6595', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3617, 'Monte Alegre do Sul', 'SP', NULL, NULL, NULL, 3531209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.66052', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3618, 'Monte Alto', 'SP', NULL, NULL, NULL, 3531308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.661636', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3619, 'Monte Aprazivel', 'SP', NULL, NULL, NULL, 3531407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.662504', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3620, 'Monte Azul Paulista', 'SP', NULL, NULL, NULL, 3531506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.663455', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3621, 'Monte Castelo', 'SP', NULL, NULL, NULL, 3531605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.664378', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3623, 'Monteiro Lobato', 'SP', NULL, NULL, NULL, 3531704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.66621', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3622, 'Monte Mor', 'SP', NULL, NULL, NULL, 3531803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.665291', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3624, 'Morro Agudo', 'SP', NULL, NULL, NULL, 3531902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.667129', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3625, 'Morungaba', 'SP', NULL, NULL, NULL, 3532009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.6681', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3626, 'Motuca', 'SP', NULL, NULL, NULL, 3532058, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.669012', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3627, 'Murutinga do Sul', 'SP', NULL, NULL, NULL, 3532108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.669991', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3628, 'Nantes', 'SP', NULL, NULL, NULL, 3532157, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.677087', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3629, 'Narandiba', 'SP', NULL, NULL, NULL, 3532207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.678371', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3630, 'Natividade da Serra', 'SP', NULL, NULL, NULL, 3532306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.6794', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3631, 'Nazare Paulista', 'SP', NULL, NULL, NULL, 3532405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.680367', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3632, 'Neves Paulista', 'SP', NULL, NULL, NULL, 3532504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.681221', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3633, 'Nhandeara', 'SP', NULL, NULL, NULL, 3532603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.682247', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3634, 'Nipoa', 'SP', NULL, NULL, NULL, 3532702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.683209', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3635, 'Nova Alianca', 'SP', NULL, NULL, NULL, 3532801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.684071', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3636, 'Nova Campina', 'SP', NULL, NULL, NULL, 3532827, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.685019', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3637, 'Nova Canaa Paulista', 'SP', NULL, NULL, NULL, 3532843, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.685923', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3638, 'Nova Castilho', 'SP', NULL, NULL, NULL, 3532868, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.68688', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3639, 'Nova Europa', 'SP', NULL, NULL, NULL, 3532900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.687744', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3640, 'Nova Granada', 'SP', NULL, NULL, NULL, 3533007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.688615', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3641, 'Nova Guataporanga', 'SP', NULL, NULL, NULL, 3533106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.689453', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3642, 'Nova Independencia', 'SP', NULL, NULL, NULL, 3533205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.69033', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3645, 'Novais', 'SP', NULL, NULL, NULL, 3533254, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.693025', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3643, 'Nova Luzitania', 'SP', NULL, NULL, NULL, 3533304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.69125', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3644, 'Nova Odessa', 'SP', NULL, NULL, NULL, 3533403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.692148', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3646, 'Novo Horizonte', 'SP', NULL, NULL, NULL, 3533502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.693881', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3647, 'Nuporanga', 'SP', NULL, NULL, NULL, 3533601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.694756', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3648, 'Ocaucu', 'SP', NULL, NULL, NULL, 3533700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.695695', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3649, 'Oleo', 'SP', NULL, NULL, NULL, 3533809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.696598', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3650, 'Olimpia', 'SP', NULL, NULL, NULL, 3533908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.697503', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3651, 'Onda Verde', 'SP', NULL, NULL, NULL, 3534005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.698381', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3652, 'Oriente', 'SP', NULL, NULL, NULL, 3534104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.699328', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3653, 'Orindiuva', 'SP', NULL, NULL, NULL, 3534203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.700226', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3654, 'Orlandia', 'SP', NULL, NULL, NULL, 3534302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.70113', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3655, 'Osasco', 'SP', NULL, NULL, NULL, 3534401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.702113', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3656, 'Oscar Bressane', 'SP', NULL, NULL, NULL, 3534500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.703017', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3657, 'Osvaldo Cruz', 'SP', NULL, NULL, NULL, 3534609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.703902', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3658, 'Ourinhos', 'SP', NULL, NULL, NULL, 3534708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.704848', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3660, 'Ouroeste', 'SP', NULL, NULL, NULL, 3534757, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.706649', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3659, 'Ouro Verde', 'SP', NULL, NULL, NULL, 3534807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.705842', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3661, 'Pacaembu', 'SP', NULL, NULL, NULL, 3534906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.707503', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3662, 'Palestina', 'SP', NULL, NULL, NULL, 3535002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.708316', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3663, 'Palmares Paulista', 'SP', NULL, NULL, NULL, 3535101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.7091', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3664, 'Palmeira D''oeste', 'SP', NULL, NULL, NULL, 3535200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.709909', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3665, 'Palmital', 'SP', NULL, NULL, NULL, 3535309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.710909', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3666, 'Panorama', 'SP', NULL, NULL, NULL, 3535408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.71165', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3667, 'Paraguacu Paulista', 'SP', NULL, NULL, NULL, 3535507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.7191', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3668, 'Paraibuna', 'SP', NULL, NULL, NULL, 3535606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.720228', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3669, 'Paraiso', 'SP', NULL, NULL, NULL, 3535705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.721111', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3670, 'Paranapanema', 'SP', NULL, NULL, NULL, 3535804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.722043', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3671, 'Paranapua', 'SP', NULL, NULL, NULL, 3535903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.72293', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3672, 'Parapua', 'SP', NULL, NULL, NULL, 3536000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.723768', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3673, 'Pardinho', 'SP', NULL, NULL, NULL, 3536109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.72461', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3674, 'Pariquera-acu', 'SP', NULL, NULL, NULL, 3536208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.725544', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3675, 'Parisi', 'SP', NULL, NULL, NULL, 3536257, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.726416', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3676, 'Patrocinio Paulista', 'SP', NULL, NULL, NULL, 3536307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.727324', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3677, 'Pauliceia', 'SP', NULL, NULL, NULL, 3536406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.728179', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3678, 'Paulinia', 'SP', NULL, NULL, NULL, 3536505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.729059', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3679, 'Paulistania', 'SP', NULL, NULL, NULL, 3536570, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.730037', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3680, 'Paulo de Faria', 'SP', NULL, NULL, NULL, 3536604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.730894', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3681, 'Pederneiras', 'SP', NULL, NULL, NULL, 3536703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.731757', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3682, 'Pedra Bela', 'SP', NULL, NULL, NULL, 3536802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.732587', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3683, 'Pedranopolis', 'SP', NULL, NULL, NULL, 3536901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.733429', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3684, 'Pedregulho', 'SP', NULL, NULL, NULL, 3537008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.73431', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3685, 'Pedreira', 'SP', NULL, NULL, NULL, 3537107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.735221', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3686, 'Pedrinhas Paulista', 'SP', NULL, NULL, NULL, 3537156, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.736151', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3687, 'Pedro de Toledo', 'SP', NULL, NULL, NULL, 3537206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.737085', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3688, 'Penapolis', 'SP', NULL, NULL, NULL, 3537305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.738028', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3689, 'Pereira Barreto', 'SP', NULL, NULL, NULL, 3537404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.738983', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3690, 'Pereiras', 'SP', NULL, NULL, NULL, 3537503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.73982', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3691, 'Peruibe', 'SP', NULL, NULL, NULL, 3537602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.740635', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3692, 'Piacatu', 'SP', NULL, NULL, NULL, 3537701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.741532', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3693, 'Piedade', 'SP', NULL, NULL, NULL, 3537800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.742468', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3694, 'Pilar do Sul', 'SP', NULL, NULL, NULL, 3537909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.743483', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3695, 'Pindamonhangaba', 'SP', NULL, NULL, NULL, 3538006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.744333', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3696, 'Pindorama', 'SP', NULL, NULL, NULL, 3538105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.745185', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3697, 'Pinhalzinho', 'SP', NULL, NULL, NULL, 3538204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.746103', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3698, 'Piquerobi', 'SP', NULL, NULL, NULL, 3538303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.747239', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3699, 'Piquete', 'SP', NULL, NULL, NULL, 3538501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.748177', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3700, 'Piracaia', 'SP', NULL, NULL, NULL, 3538600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.749108', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3701, 'Piracicaba', 'SP', NULL, NULL, NULL, 3538709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.750017', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3702, 'Piraju', 'SP', NULL, NULL, NULL, 3538808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.751064', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3703, 'Pirajui', 'SP', NULL, NULL, NULL, 3538907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.752015', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3704, 'Pirangi', 'SP', NULL, NULL, NULL, 3539004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.759139', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3705, 'Pirapora do Bom Jesus', 'SP', NULL, NULL, NULL, 3539103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.760398', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3706, 'Pirapozinho', 'SP', NULL, NULL, NULL, 3539202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.761455', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3707, 'Pirassununga', 'SP', NULL, NULL, NULL, 3539301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.762332', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3708, 'Piratininga', 'SP', NULL, NULL, NULL, 3539400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.76325', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3709, 'Pitangueiras', 'SP', NULL, NULL, NULL, 3539509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.764242', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3710, 'Planalto', 'SP', NULL, NULL, NULL, 3539608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.76523', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3711, 'Platina', 'SP', NULL, NULL, NULL, 3539707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.766168', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3712, 'Poa', 'SP', NULL, NULL, NULL, 3539806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.767481', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3713, 'Poloni', 'SP', NULL, NULL, NULL, 3539905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.768419', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3714, 'Pompeia', 'SP', NULL, NULL, NULL, 3540002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.769298', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3715, 'Pongai', 'SP', NULL, NULL, NULL, 3540101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.770243', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3716, 'Pontal', 'SP', NULL, NULL, NULL, 3540200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.771057', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3717, 'Pontalinda', 'SP', NULL, NULL, NULL, 3540259, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.772236', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3718, 'Pontes Gestal', 'SP', NULL, NULL, NULL, 3540309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.77305', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3719, 'Populina', 'SP', NULL, NULL, NULL, 3540408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.773915', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3720, 'Porangaba', 'SP', NULL, NULL, NULL, 3540507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.774851', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3721, 'Porto Feliz', 'SP', NULL, NULL, NULL, 3540606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.77596', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3722, 'Porto Ferreira', 'SP', NULL, NULL, NULL, 3540705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.77695', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3723, 'Potim', 'SP', NULL, NULL, NULL, 3540754, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.777852', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3724, 'Potirendaba', 'SP', NULL, NULL, NULL, 3540804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.778757', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3725, 'Pracinha', 'SP', NULL, NULL, NULL, 3540853, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.779736', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3726, 'Pradopolis', 'SP', NULL, NULL, NULL, 3540903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.780653', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3727, 'Praia Grande', 'SP', NULL, NULL, NULL, 3541000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.781557', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3728, 'Pratania', 'SP', NULL, NULL, NULL, 3541059, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.782464', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3729, 'Presidente Alves', 'SP', NULL, NULL, NULL, 3541109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.783493', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3730, 'Presidente Bernardes', 'SP', NULL, NULL, NULL, 3541208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.784379', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3731, 'Presidente Epitacio', 'SP', NULL, NULL, NULL, 3541307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.785224', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3732, 'Presidente Prudente', 'SP', NULL, NULL, NULL, 3541406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.786107', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3733, 'Presidente Venceslau', 'SP', NULL, NULL, NULL, 3541505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.786904', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3734, 'Promissao', 'SP', NULL, NULL, NULL, 3541604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.787815', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3735, 'Quadra', 'SP', NULL, NULL, NULL, 3541653, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.788698', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3736, 'Quata', 'SP', NULL, NULL, NULL, 3541703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.789628', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3737, 'Queiroz', 'SP', NULL, NULL, NULL, 3541802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.790503', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3738, 'Queluz', 'SP', NULL, NULL, NULL, 3541901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.791388', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3739, 'Quintana', 'SP', NULL, NULL, NULL, 3542008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.792194', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3740, 'Rafard', 'SP', NULL, NULL, NULL, 3542107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.799849', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3741, 'Rancharia', 'SP', NULL, NULL, NULL, 3542206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.801147', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3742, 'Redencao da Serra', 'SP', NULL, NULL, NULL, 3542305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.802051', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3743, 'Regente Feijo', 'SP', NULL, NULL, NULL, 3542404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.802929', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3744, 'Reginopolis', 'SP', NULL, NULL, NULL, 3542503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.80391', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3745, 'Registro', 'SP', NULL, NULL, NULL, 3542602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.804743', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3746, 'Restinga', 'SP', NULL, NULL, NULL, 3542701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.80577', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3747, 'Ribeira', 'SP', NULL, NULL, NULL, 3542800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.806596', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3748, 'Ribeirao Bonito', 'SP', NULL, NULL, NULL, 3542909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.807499', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3749, 'Ribeirao Branco', 'SP', NULL, NULL, NULL, 3543006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.808385', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3750, 'Ribeirao Corrente', 'SP', NULL, NULL, NULL, 3543105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.809327', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3751, 'Ribeirao do Sul', 'SP', NULL, NULL, NULL, 3543204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.810148', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3752, 'Ribeirao dos Indios', 'SP', NULL, NULL, NULL, 3543238, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.811033', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3753, 'Ribeirao Grande', 'SP', NULL, NULL, NULL, 3543253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.811878', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3754, 'Ribeirao Pires', 'SP', NULL, NULL, NULL, 3543303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.812751', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3755, 'Ribeirao Preto', 'SP', NULL, NULL, NULL, 3543402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.813744', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3763, 'Riversul', 'SP', NULL, NULL, NULL, 3543501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.821112', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3756, 'Rifaina', 'SP', NULL, NULL, NULL, 3543600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.814689', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3757, 'Rincao', 'SP', NULL, NULL, NULL, 3543709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.815604', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3758, 'Rinopolis', 'SP', NULL, NULL, NULL, 3543808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.81658', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3759, 'Rio Claro', 'SP', NULL, NULL, NULL, 3543907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.817501', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3760, 'Rio das Pedras', 'SP', NULL, NULL, NULL, 3544004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.8183', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3761, 'Rio Grande da Serra', 'SP', NULL, NULL, NULL, 3544103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.819205', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3762, 'Riolandia', 'SP', NULL, NULL, NULL, 3544202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.820129', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3764, 'Rosana', 'SP', NULL, NULL, NULL, 3544251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.822033', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3765, 'Roseira', 'SP', NULL, NULL, NULL, 3544301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.822953', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3766, 'Rubiacea', 'SP', NULL, NULL, NULL, 3544400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.823779', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3767, 'Rubineia', 'SP', NULL, NULL, NULL, 3544509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.824722', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3768, 'Sabino', 'SP', NULL, NULL, NULL, 3544608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.825716', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3769, 'Sagres', 'SP', NULL, NULL, NULL, 3544707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.826657', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3770, 'Sales', 'SP', NULL, NULL, NULL, 3544806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.827569', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3771, 'Sales Oliveira', 'SP', NULL, NULL, NULL, 3544905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.8286', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3772, 'Salesopolis', 'SP', NULL, NULL, NULL, 3545001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.829388', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3773, 'Salmourao', 'SP', NULL, NULL, NULL, 3545100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.830267', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3774, 'Saltinho', 'SP', NULL, NULL, NULL, 3545159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.831174', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3775, 'Salto', 'SP', NULL, NULL, NULL, 3545209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.832063', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3776, 'Salto de Pirapora', 'SP', NULL, NULL, NULL, 3545308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.832983', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3777, 'Salto Grande', 'SP', NULL, NULL, NULL, 3545407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.833872', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3778, 'Sandovalina', 'SP', NULL, NULL, NULL, 3545506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.841128', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3779, 'Santa Adelia', 'SP', NULL, NULL, NULL, 3545605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.842526', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3780, 'Santa Albertina', 'SP', NULL, NULL, NULL, 3545704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.843562', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3781, 'Santa Barbara D''oeste', 'SP', NULL, NULL, NULL, 3545803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.844486', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3782, 'Santa Branca', 'SP', NULL, NULL, NULL, 3546009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.845468', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3783, 'Santa Clara D''oeste', 'SP', NULL, NULL, NULL, 3546108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.846438', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3784, 'Santa Cruz da Conceicao', 'SP', NULL, NULL, NULL, 3546207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.847281', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3785, 'Santa Cruz da Esperanca', 'SP', NULL, NULL, NULL, 3546256, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.848235', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3786, 'Santa Cruz das Palmeiras', 'SP', NULL, NULL, NULL, 3546306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.849206', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3787, 'Santa Cruz do Rio Pardo', 'SP', NULL, NULL, NULL, 3546405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.850133', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3788, 'Santa Ernestina', 'SP', NULL, NULL, NULL, 3546504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.851253', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3789, 'Santa Fe do Sul', 'SP', NULL, NULL, NULL, 3546603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.852223', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3790, 'Santa Gertrudes', 'SP', NULL, NULL, NULL, 3546702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.853156', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3791, 'Santa Isabel', 'SP', NULL, NULL, NULL, 3546801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.854113', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3792, 'Santa Lucia', 'SP', NULL, NULL, NULL, 3546900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.854982', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3793, 'Santa Maria da Serra', 'SP', NULL, NULL, NULL, 3547007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.85605', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3794, 'Santa Mercedes', 'SP', NULL, NULL, NULL, 3547106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.857003', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3799, 'Santana da Ponte Pensa', 'SP', NULL, NULL, NULL, 3547205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.861535', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3800, 'Santana de Parnaiba', 'SP', NULL, NULL, NULL, 3547304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.862612', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3796, 'Santa Rita D''oeste', 'SP', NULL, NULL, NULL, 3547403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.85865', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3795, 'Santa Rita do Passa Quatro', 'SP', NULL, NULL, NULL, 3547502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.857824', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3797, 'Santa Rosa de Viterbo', 'SP', NULL, NULL, NULL, 3547601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.859396', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3798, 'Santa Salete', 'SP', NULL, NULL, NULL, 3547650, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.860312', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3801, 'Santo Anastacio', 'SP', NULL, NULL, NULL, 3547700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.863652', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3802, 'Santo Andre', 'SP', NULL, NULL, NULL, 3547809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.864564', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3803, 'Santo Antonio da Alegria', 'SP', NULL, NULL, NULL, 3547908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.865523', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3804, 'Santo Antonio de Posse', 'SP', NULL, NULL, NULL, 3548005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.866439', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3805, 'Santo Antonio do Aracangua', 'SP', NULL, NULL, NULL, 3548054, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.867468', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3806, 'Santo Antonio do Jardim', 'SP', NULL, NULL, NULL, 3548104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.868427', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3807, 'Santo Antonio do Pinhal', 'SP', NULL, NULL, NULL, 3548203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.869308', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3808, 'Santo Expedito', 'SP', NULL, NULL, NULL, 3548302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.870137', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3809, 'Santopolis do Aguapei', 'SP', NULL, NULL, NULL, 3548401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.871076', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3810, 'Santos', 'SP', NULL, NULL, NULL, 3548500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.872026', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3811, 'Sao Bento do Sapucai', 'SP', NULL, NULL, NULL, 3548609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.873071', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3812, 'Sao Bernardo do Campo', 'SP', NULL, NULL, NULL, 3548708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.873885', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3813, 'Sao Caetano do Sul', 'SP', NULL, NULL, NULL, 3548807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.874902', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3814, 'Sao Carlos', 'SP', NULL, NULL, NULL, 3548906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.882174', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3815, 'Sao Francisco', 'SP', NULL, NULL, NULL, 3549003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.883328', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3816, 'Sao Joao da Boa Vista', 'SP', NULL, NULL, NULL, 3549102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.884221', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3817, 'Sao Joao das Duas Pontes', 'SP', NULL, NULL, NULL, 3549201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.8851', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3818, 'Sao Joao de Iracema', 'SP', NULL, NULL, NULL, 3549250, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.885978', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3819, 'Sao Joao do Pau D''alho', 'SP', NULL, NULL, NULL, 3549300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.886912', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3820, 'Sao Joaquim da Barra', 'SP', NULL, NULL, NULL, 3549409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.88779', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3821, 'Sao Jose da Bela Vista', 'SP', NULL, NULL, NULL, 3549508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.888824', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3822, 'Sao Jose do Barreiro', 'SP', NULL, NULL, NULL, 3549607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.889708', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3823, 'Sao Jose do Rio Pardo', 'SP', NULL, NULL, NULL, 3549706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.890643', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3824, 'Sao Jose do Rio Preto', 'SP', NULL, NULL, NULL, 3549805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.891636', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3825, 'Sao Jose dos Campos', 'SP', NULL, NULL, NULL, 3549904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.892511', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3826, 'Sao Lourenco da Serra', 'SP', NULL, NULL, NULL, 3549953, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.893511', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3827, 'Sao Luis do Paraitinga', 'SP', NULL, NULL, NULL, 3550001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.89439', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3828, 'Sao Manuel', 'SP', NULL, NULL, NULL, 3550100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.89529', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3829, 'Sao Miguel Arcanjo', 'SP', NULL, NULL, NULL, 3550209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.89607', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3830, 'Sao Paulo', 'SP', NULL, NULL, NULL, 3550308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.897057', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3831, 'Sao Pedro', 'SP', NULL, NULL, NULL, 3550407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.898029', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3832, 'Sao Pedro do Turvo', 'SP', NULL, NULL, NULL, 3550506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.898933', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3833, 'Sao Roque', 'SP', NULL, NULL, NULL, 3550605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.899785', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3834, 'Sao Sebastiao', 'SP', NULL, NULL, NULL, 3550704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.900715', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3835, 'Sao Sebastiao da Grama', 'SP', NULL, NULL, NULL, 3550803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.901548', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3836, 'Sao Simao', 'SP', NULL, NULL, NULL, 3550902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.902471', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3837, 'Sao Vicente', 'SP', NULL, NULL, NULL, 3551009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.903454', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3838, 'Sarapui', 'SP', NULL, NULL, NULL, 3551108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.904302', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3839, 'Sarutaia', 'SP', NULL, NULL, NULL, 3551207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.905087', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3840, 'Sebastianopolis do Sul', 'SP', NULL, NULL, NULL, 3551306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.906039', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3841, 'Serra Azul', 'SP', NULL, NULL, NULL, 3551405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.907223', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3843, 'Serrana', 'SP', NULL, NULL, NULL, 3551504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.908962', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3842, 'Serra Negra', 'SP', NULL, NULL, NULL, 3551603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.907989', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3844, 'Sertaozinho', 'SP', NULL, NULL, NULL, 3551702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.909863', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3845, 'Sete Barras', 'SP', NULL, NULL, NULL, 3551801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.910813', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3846, 'Severinia', 'SP', NULL, NULL, NULL, 3551900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.911767', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3847, 'Silveiras', 'SP', NULL, NULL, NULL, 3552007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.912684', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3848, 'Socorro', 'SP', NULL, NULL, NULL, 3552106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.913618', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3849, 'Sorocaba', 'SP', NULL, NULL, NULL, 3552205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.914527', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3850, 'Sud Mennucci', 'SP', NULL, NULL, NULL, 3552304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.915419', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3851, 'Sumare', 'SP', NULL, NULL, NULL, 3552403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.923764', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3853, 'Suzano', 'SP', NULL, NULL, NULL, 3552502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.925611', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3852, 'Suzanapolis', 'SP', NULL, NULL, NULL, 3552551, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.924737', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3854, 'Tabapua', 'SP', NULL, NULL, NULL, 3552601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.926641', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3855, 'Tabatinga', 'SP', NULL, NULL, NULL, 3552700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.92753', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3856, 'Taboao da Serra', 'SP', NULL, NULL, NULL, 3552809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.928379', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3857, 'Taciba', 'SP', NULL, NULL, NULL, 3552908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.929364', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3858, 'Taguai', 'SP', NULL, NULL, NULL, 3553005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.930327', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3859, 'Taiacu', 'SP', NULL, NULL, NULL, 3553104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.931198', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3860, 'Taiuva', 'SP', NULL, NULL, NULL, 3553203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.932199', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3861, 'Tambau', 'SP', NULL, NULL, NULL, 3553302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.933029', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3862, 'Tanabi', 'SP', NULL, NULL, NULL, 3553401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.933885', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3863, 'Tapirai', 'SP', NULL, NULL, NULL, 3553500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.934819', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3864, 'Tapiratiba', 'SP', NULL, NULL, NULL, 3553609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.935627', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3865, 'Taquaral', 'SP', NULL, NULL, NULL, 3553658, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.936569', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3866, 'Taquaritinga', 'SP', NULL, NULL, NULL, 3553708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.937462', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3867, 'Taquarituba', 'SP', NULL, NULL, NULL, 3553807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.938413', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3868, 'Taquarivai', 'SP', NULL, NULL, NULL, 3553856, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.939268', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3869, 'Tarabai', 'SP', NULL, NULL, NULL, 3553906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.940097', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3870, 'Taruma', 'SP', NULL, NULL, NULL, 3553955, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.941071', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3871, 'Tatui', 'SP', NULL, NULL, NULL, 3554003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.942017', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3872, 'Taubate', 'SP', NULL, NULL, NULL, 3554102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.942943', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3873, 'Tejupa', 'SP', NULL, NULL, NULL, 3554201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.94383', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3874, 'Teodoro Sampaio', 'SP', NULL, NULL, NULL, 3554300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.944695', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3875, 'Terra Roxa', 'SP', NULL, NULL, NULL, 3554409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.945558', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3876, 'Tiete', 'SP', NULL, NULL, NULL, 3554508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.946495', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3877, 'Timburi', 'SP', NULL, NULL, NULL, 3554607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.94729', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3878, 'Torre de Pedra', 'SP', NULL, NULL, NULL, 3554656, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.948168', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3879, 'Torrinha', 'SP', NULL, NULL, NULL, 3554706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.949077', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3880, 'Trabiju', 'SP', NULL, NULL, NULL, 3554755, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.949993', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3881, 'Tremembe', 'SP', NULL, NULL, NULL, 3554805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.950947', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3882, 'Tres Fronteiras', 'SP', NULL, NULL, NULL, 3554904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.951742', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3883, 'Tuiuti', 'SP', NULL, NULL, NULL, 3554953, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.952496', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3884, 'Tupa', 'SP', NULL, NULL, NULL, 3555000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.953395', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3885, 'Tupi Paulista', 'SP', NULL, NULL, NULL, 3555109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.954217', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3886, 'Turiuba', 'SP', NULL, NULL, NULL, 3555208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.955145', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3887, 'Turmalina', 'SP', NULL, NULL, NULL, 3555307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.956025', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3888, 'Ubarana', 'SP', NULL, NULL, NULL, 3555356, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.957522', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3889, 'Ubatuba', 'SP', NULL, NULL, NULL, 3555406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.964282', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3890, 'Ubirajara', 'SP', NULL, NULL, NULL, 3555505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.965379', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3891, 'Uchoa', 'SP', NULL, NULL, NULL, 3555604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.966314', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3892, 'Uniao Paulista', 'SP', NULL, NULL, NULL, 3555703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.967227', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3893, 'Urania', 'SP', NULL, NULL, NULL, 3555802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.968222', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3894, 'Uru', 'SP', NULL, NULL, NULL, 3555901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.969163', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3895, 'Urupes', 'SP', NULL, NULL, NULL, 3556008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.970073', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3896, 'Valentim Gentil', 'SP', NULL, NULL, NULL, 3556107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.970972', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3897, 'Valinhos', 'SP', NULL, NULL, NULL, 3556206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.971951', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3898, 'Valparaiso', 'SP', NULL, NULL, NULL, 3556305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.972883', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3899, 'Vargem', 'SP', NULL, NULL, NULL, 3556354, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.974064', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3900, 'Vargem Grande do Sul', 'SP', NULL, NULL, NULL, 3556404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.974954', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3901, 'Vargem Grande Paulista', 'SP', NULL, NULL, NULL, 3556453, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.976387', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3902, 'Varzea Paulista', 'SP', NULL, NULL, NULL, 3556503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.97738', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3903, 'Vera Cruz', 'SP', NULL, NULL, NULL, 3556602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.97827', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3904, 'Vinhedo', 'SP', NULL, NULL, NULL, 3556701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.979112', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3905, 'Viradouro', 'SP', NULL, NULL, NULL, 3556800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.980046', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3906, 'Vista Alegre do Alto', 'SP', NULL, NULL, NULL, 3556909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.980934', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3907, 'Vitoria Brasil', 'SP', NULL, NULL, NULL, 3556958, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.981804', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3908, 'Votorantim', 'SP', NULL, NULL, NULL, 3557006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.982726', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3909, 'Votuporanga', 'SP', NULL, NULL, NULL, 3557105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.983575', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3910, 'Zacarias', 'SP', NULL, NULL, NULL, 3557154, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.984592', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3399, 'Chavantes', 'SP', NULL, NULL, NULL, 3557204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.411516', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3440, 'Estiva Gerbi', 'SP', NULL, NULL, NULL, 3557303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.459826', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3911, 'Abatia', 'PR', NULL, NULL, NULL, 4100103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.985397', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3912, 'Adrianopolis', 'PR', NULL, NULL, NULL, 4100202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.986287', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3913, 'Agudos do Sul', 'PR', NULL, NULL, NULL, 4100301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.987196', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3914, 'Almirante Tamandare', 'PR', NULL, NULL, NULL, 4100400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.988188', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3915, 'Altamira do Parana', 'PR', NULL, NULL, NULL, 4100459, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.989098', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3919, 'Altonia', 'PR', NULL, NULL, NULL, 4100509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.992748', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3917, 'Alto Parana', 'PR', NULL, NULL, NULL, 4100608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.990938', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3918, 'Alto Piquiri', 'PR', NULL, NULL, NULL, 4100707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.991839', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3920, 'Alvorada do Sul', 'PR', NULL, NULL, NULL, 4100806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.99372', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3921, 'Amapora', 'PR', NULL, NULL, NULL, 4100905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.99467', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3922, 'Ampere', 'PR', NULL, NULL, NULL, 4101002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.995648', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3923, 'Anahy', 'PR', NULL, NULL, NULL, 4101051, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.996625', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3924, 'Andira', 'PR', NULL, NULL, NULL, 4101101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.997681', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3925, 'Angulo', 'PR', NULL, NULL, NULL, 4101150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.004728', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3926, 'Antonina', 'PR', NULL, NULL, NULL, 4101200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.005854', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3927, 'Antonio Olinto', 'PR', NULL, NULL, NULL, 4101309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.007012', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3928, 'Apucarana', 'PR', NULL, NULL, NULL, 4101408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.007903', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3929, 'Arapongas', 'PR', NULL, NULL, NULL, 4101507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.008811', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3930, 'Arapoti', 'PR', NULL, NULL, NULL, 4101606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.009634', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3931, 'Arapua', 'PR', NULL, NULL, NULL, 4101655, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.010641', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3932, 'Araruna', 'PR', NULL, NULL, NULL, 4101705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.011512', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3933, 'Araucaria', 'PR', NULL, NULL, NULL, 4101804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.012356', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3934, 'Ariranha do Ivai', 'PR', NULL, NULL, NULL, 4101853, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.013245', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3935, 'Assai', 'PR', NULL, NULL, NULL, 4101903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.014083', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3936, 'Assis Chateaubriand', 'PR', NULL, NULL, NULL, 4102000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.014967', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3937, 'Astorga', 'PR', NULL, NULL, NULL, 4102109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.015824', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3938, 'Atalaia', 'PR', NULL, NULL, NULL, 4102208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.016716', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3939, 'Balsa Nova', 'PR', NULL, NULL, NULL, 4102307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.017615', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3940, 'Bandeirantes', 'PR', NULL, NULL, NULL, 4102406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.018653', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3941, 'Barbosa Ferraz', 'PR', NULL, NULL, NULL, 4102505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.019459', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3943, 'Barracao', 'PR', NULL, NULL, NULL, 4102604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.021205', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3942, 'Barra do Jacare', 'PR', NULL, NULL, NULL, 4102703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.020318', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3945, 'Bela Vista do Paraiso', 'PR', NULL, NULL, NULL, 4102802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.023032', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3946, 'Bituruna', 'PR', NULL, NULL, NULL, 4102901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.023906', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3947, 'Boa Esperanca', 'PR', NULL, NULL, NULL, 4103008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.02483', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3948, 'Boa Esperanca do Iguacu', 'PR', NULL, NULL, NULL, 4103024, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.025742', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3949, 'Boa Ventura de Sao Roque', 'PR', NULL, NULL, NULL, 4103040, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.026662', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3950, 'Boa Vista da Aparecida', 'PR', NULL, NULL, NULL, 4103057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.027576', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3951, 'Bocaiuva do Sul', 'PR', NULL, NULL, NULL, 4103107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.028487', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3952, 'Bom Jesus do Sul', 'PR', NULL, NULL, NULL, 4103156, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.02933', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3953, 'Bom Sucesso', 'PR', NULL, NULL, NULL, 4103206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.030115', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3954, 'Bom Sucesso do Sul', 'PR', NULL, NULL, NULL, 4103222, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.031027', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3955, 'Borrazopolis', 'PR', NULL, NULL, NULL, 4103305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.031843', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3956, 'Braganey', 'PR', NULL, NULL, NULL, 4103354, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.032806', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3957, 'Brasilandia do Sul', 'PR', NULL, NULL, NULL, 4103370, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.033978', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3958, 'Cafeara', 'PR', NULL, NULL, NULL, 4103404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.034819', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3959, 'Cafelandia', 'PR', NULL, NULL, NULL, 4103453, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.03574', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3960, 'Cafezal do Sul', 'PR', NULL, NULL, NULL, 4103479, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.036649', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3961, 'California', 'PR', NULL, NULL, NULL, 4103503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.037542', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3962, 'Cambara', 'PR', NULL, NULL, NULL, 4103602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.038936', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3963, 'Cambe', 'PR', NULL, NULL, NULL, 4103701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.045765', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3964, 'Cambira', 'PR', NULL, NULL, NULL, 4103800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.047133', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3965, 'Campina da Lagoa', 'PR', NULL, NULL, NULL, 4103909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.04815', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3966, 'Campina do Simao', 'PR', NULL, NULL, NULL, 4103958, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.049097', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3967, 'Campina Grande do Sul', 'PR', NULL, NULL, NULL, 4104006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.050115', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3968, 'Campo Bonito', 'PR', NULL, NULL, NULL, 4104055, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.051104', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3969, 'Campo do Tenente', 'PR', NULL, NULL, NULL, 4104105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.05197', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3970, 'Campo Largo', 'PR', NULL, NULL, NULL, 4104204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.053224', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3971, 'Campo Magro', 'PR', NULL, NULL, NULL, 4104253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.054079', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3972, 'Campo Mourao', 'PR', NULL, NULL, NULL, 4104303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.054986', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3973, 'Candido de Abreu', 'PR', NULL, NULL, NULL, 4104402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.055886', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3974, 'Candoi', 'PR', NULL, NULL, NULL, 4104428, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.056861', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3975, 'Cantagalo', 'PR', NULL, NULL, NULL, 4104451, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.057749', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3976, 'Capanema', 'PR', NULL, NULL, NULL, 4104501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.05867', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3977, 'Capitao Leonidas Marques', 'PR', NULL, NULL, NULL, 4104600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.059635', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3978, 'Carambei', 'PR', NULL, NULL, NULL, 4104659, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.060504', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3979, 'Carlopolis', 'PR', NULL, NULL, NULL, 4104709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.061386', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3980, 'Cascavel', 'PR', NULL, NULL, NULL, 4104808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.062316', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3981, 'Castro', 'PR', NULL, NULL, NULL, 4104907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.063137', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3982, 'Catanduvas', 'PR', NULL, NULL, NULL, 4105003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.064188', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3983, 'Centenario do Sul', 'PR', NULL, NULL, NULL, 4105102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.065187', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3984, 'Cerro Azul', 'PR', NULL, NULL, NULL, 4105201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.066246', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3985, 'Ceu Azul', 'PR', NULL, NULL, NULL, 4105300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.06723', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3986, 'Chopinzinho', 'PR', NULL, NULL, NULL, 4105409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.068245', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3987, 'Cianorte', 'PR', NULL, NULL, NULL, 4105508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.069317', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3988, 'Cidade Gaucha', 'PR', NULL, NULL, NULL, 4105607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.070245', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3989, 'Clevelandia', 'PR', NULL, NULL, NULL, 4105706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.071239', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3990, 'Colombo', 'PR', NULL, NULL, NULL, 4105805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.072161', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3991, 'Colorado', 'PR', NULL, NULL, NULL, 4105904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.073279', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3992, 'Congonhinhas', 'PR', NULL, NULL, NULL, 4106001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.074223', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3993, 'Conselheiro Mairinck', 'PR', NULL, NULL, NULL, 4106100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.075146', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3994, 'Contenda', 'PR', NULL, NULL, NULL, 4106209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.07629', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3995, 'Corbelia', 'PR', NULL, NULL, NULL, 4106308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.077225', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3996, 'Cornelio Procopio', 'PR', NULL, NULL, NULL, 4106407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.078202', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3997, 'Coronel Domingos Soares', 'PR', NULL, NULL, NULL, 4106456, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.079407', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3998, 'Coronel Vivida', 'PR', NULL, NULL, NULL, 4106506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.086559', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3999, 'Corumbatai do Sul', 'PR', NULL, NULL, NULL, 4106555, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.087675', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4001, 'Cruzeiro do Iguacu', 'PR', NULL, NULL, NULL, 4106571, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.089408', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4002, 'Cruzeiro do Oeste', 'PR', NULL, NULL, NULL, 4106605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.090379', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4003, 'Cruzeiro do Sul', 'PR', NULL, NULL, NULL, 4106704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.09129', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4000, 'Cruz Machado', 'PR', NULL, NULL, NULL, 4106803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.088592', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4004, 'Cruzmaltina', 'PR', NULL, NULL, NULL, 4106852, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.092294', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4005, 'Curitiba', 'PR', NULL, NULL, NULL, 4106902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.093188', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4006, 'Curiuva', 'PR', NULL, NULL, NULL, 4107009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.094161', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4007, 'Diamante do Norte', 'PR', NULL, NULL, NULL, 4107108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.095041', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4008, 'Diamante do Sul', 'PR', NULL, NULL, NULL, 4107124, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.096391', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4009, 'Diamante D''oeste', 'PR', NULL, NULL, NULL, 4107157, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.097438', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4010, 'Dois Vizinhos', 'PR', NULL, NULL, NULL, 4107207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.098274', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4011, 'Douradina', 'PR', NULL, NULL, NULL, 4107256, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.099183', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4012, 'Doutor Camargo', 'PR', NULL, NULL, NULL, 4107306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.100098', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4014, 'Eneas Marques', 'PR', NULL, NULL, NULL, 4107405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.10187', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4015, 'Engenheiro Beltrao', 'PR', NULL, NULL, NULL, 4107504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.102709', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4017, 'Esperanca Nova', 'PR', NULL, NULL, NULL, 4107520, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.104368', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4016, 'Entre Rios do Oeste', 'PR', NULL, NULL, NULL, 4107538, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.103512', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4018, 'Espigao Alto do Iguacu', 'PR', NULL, NULL, NULL, 4107546, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.105422', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4019, 'Farol', 'PR', NULL, NULL, NULL, 4107553, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.106399', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4020, 'Faxinal', 'PR', NULL, NULL, NULL, 4107603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.107374', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4021, 'Fazenda Rio Grande', 'PR', NULL, NULL, NULL, 4107652, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.108241', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4022, 'Fenix', 'PR', NULL, NULL, NULL, 4107702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.109288', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4023, 'Fernandes Pinheiro', 'PR', NULL, NULL, NULL, 4107736, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.110161', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4024, 'Figueira', 'PR', NULL, NULL, NULL, 4107751, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.111065', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4026, 'Florai', 'PR', NULL, NULL, NULL, 4107801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.112881', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4025, 'Flor da Serra do Sul', 'PR', NULL, NULL, NULL, 4107850, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.111977', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4027, 'Floresta', 'PR', NULL, NULL, NULL, 4107900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.113867', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4028, 'Florestopolis', 'PR', NULL, NULL, NULL, 4108007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.114779', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4029, 'Florida', 'PR', NULL, NULL, NULL, 4108106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.115752', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4030, 'Formosa do Oeste', 'PR', NULL, NULL, NULL, 4108205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.116721', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4031, 'Foz do Iguacu', 'PR', NULL, NULL, NULL, 4108304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.117707', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4033, 'Francisco Alves', 'PR', NULL, NULL, NULL, 4108320, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.119613', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4034, 'Francisco Beltrao', 'PR', NULL, NULL, NULL, 4108403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.120558', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4032, 'Foz do Jordao', 'PR', NULL, NULL, NULL, 4108452, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.118639', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4035, 'General Carneiro', 'PR', NULL, NULL, NULL, 4108502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.127423', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4036, 'Godoy Moreira', 'PR', NULL, NULL, NULL, 4108551, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.128645', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4038, 'Goioxim', 'PR', NULL, NULL, NULL, 4108650, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.13055', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4039, 'Grandes Rios', 'PR', NULL, NULL, NULL, 4108700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.131638', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4040, 'Guaira', 'PR', NULL, NULL, NULL, 4108809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.13242', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4041, 'Guairaca', 'PR', NULL, NULL, NULL, 4108908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.133372', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4042, 'Guamiranga', 'PR', NULL, NULL, NULL, 4108957, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.134252', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4043, 'Guapirama', 'PR', NULL, NULL, NULL, 4109005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.135191', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4044, 'Guaporema', 'PR', NULL, NULL, NULL, 4109104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.136151', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4045, 'Guaraci', 'PR', NULL, NULL, NULL, 4109203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.137079', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4046, 'Guaraniacu', 'PR', NULL, NULL, NULL, 4109302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.138006', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4047, 'Guarapuava', 'PR', NULL, NULL, NULL, 4109401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.138945', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4048, 'Guaraquecaba', 'PR', NULL, NULL, NULL, 4109500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.139847', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4049, 'Guaratuba', 'PR', NULL, NULL, NULL, 4109609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.140817', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4050, 'Honorio Serpa', 'PR', NULL, NULL, NULL, 4109658, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.141648', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4051, 'Ibaiti', 'PR', NULL, NULL, NULL, 4109708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.142752', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4052, 'Ibema', 'PR', NULL, NULL, NULL, 4109757, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.143584', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4053, 'Ibipora', 'PR', NULL, NULL, NULL, 4109807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.14439', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4054, 'Icaraima', 'PR', NULL, NULL, NULL, 4109906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.145266', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4055, 'Iguaracu', 'PR', NULL, NULL, NULL, 4110003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.146086', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4056, 'Iguatu', 'PR', NULL, NULL, NULL, 4110052, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.146981', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4057, 'Imbau', 'PR', NULL, NULL, NULL, 4110078, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.147856', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4058, 'Imbituva', 'PR', NULL, NULL, NULL, 4110102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.148856', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4059, 'Inacio Martins', 'PR', NULL, NULL, NULL, 4110201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.149748', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4060, 'Inaja', 'PR', NULL, NULL, NULL, 4110300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.150609', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4061, 'Indianopolis', 'PR', NULL, NULL, NULL, 4110409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.151462', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4062, 'Ipiranga', 'PR', NULL, NULL, NULL, 4110508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.15233', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4063, 'Ipora', 'PR', NULL, NULL, NULL, 4110607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.153244', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4064, 'Iracema do Oeste', 'PR', NULL, NULL, NULL, 4110656, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.154171', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4065, 'Irati', 'PR', NULL, NULL, NULL, 4110706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.155067', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4066, 'Iretama', 'PR', NULL, NULL, NULL, 4110805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.155943', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4067, 'Itaguaje', 'PR', NULL, NULL, NULL, 4110904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.156929', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4068, 'Itaipulandia', 'PR', NULL, NULL, NULL, 4110953, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.157878', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4069, 'Itambaraca', 'PR', NULL, NULL, NULL, 4111001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.158813', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4070, 'Itambe', 'PR', NULL, NULL, NULL, 4111100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.159654', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4071, 'Itapejara D''oeste', 'PR', NULL, NULL, NULL, 4111209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.160601', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4072, 'Itaperucu', 'PR', NULL, NULL, NULL, 4111258, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.161482', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4073, 'Itauna do Sul', 'PR', NULL, NULL, NULL, 4111308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.162479', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4074, 'Ivai', 'PR', NULL, NULL, NULL, 4111407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.173191', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4075, 'Ivaipora', 'PR', NULL, NULL, NULL, 4111506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.174405', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4076, 'Ivate', 'PR', NULL, NULL, NULL, 4111555, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.175489', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4077, 'Ivatuba', 'PR', NULL, NULL, NULL, 4111605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.176411', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4078, 'Jaboti', 'PR', NULL, NULL, NULL, 4111704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.177343', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4079, 'Jacarezinho', 'PR', NULL, NULL, NULL, 4111803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.178223', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4080, 'Jaguapita', 'PR', NULL, NULL, NULL, 4111902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.17908', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4081, 'Jaguariaiva', 'PR', NULL, NULL, NULL, 4112009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.179969', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4082, 'Jandaia do Sul', 'PR', NULL, NULL, NULL, 4112108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.180921', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4083, 'Janiopolis', 'PR', NULL, NULL, NULL, 4112207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.181768', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4084, 'Japira', 'PR', NULL, NULL, NULL, 4112306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.182695', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4085, 'Japura', 'PR', NULL, NULL, NULL, 4112405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.183595', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4086, 'Jardim Alegre', 'PR', NULL, NULL, NULL, 4112504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.184551', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4087, 'Jardim Olinda', 'PR', NULL, NULL, NULL, 4112603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.185484', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4088, 'Jataizinho', 'PR', NULL, NULL, NULL, 4112702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.186508', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4089, 'Jesuitas', 'PR', NULL, NULL, NULL, 4112751, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.187505', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4090, 'Joaquim Tavora', 'PR', NULL, NULL, NULL, 4112801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.188472', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4091, 'Jundiai do Sul', 'PR', NULL, NULL, NULL, 4112900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.189369', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4092, 'Juranda', 'PR', NULL, NULL, NULL, 4112959, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.190237', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4093, 'Jussara', 'PR', NULL, NULL, NULL, 4113007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.191189', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4094, 'Kalore', 'PR', NULL, NULL, NULL, 4113106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.192042', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4095, 'Lapa', 'PR', NULL, NULL, NULL, 4113205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.192994', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4096, 'Laranjal', 'PR', NULL, NULL, NULL, 4113254, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.193967', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4097, 'Laranjeiras do Sul', 'PR', NULL, NULL, NULL, 4113304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.194892', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4098, 'Leopolis', 'PR', NULL, NULL, NULL, 4113403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.195946', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4099, 'Lidianopolis', 'PR', NULL, NULL, NULL, 4113429, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.196969', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4100, 'Lindoeste', 'PR', NULL, NULL, NULL, 4113452, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.197979', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4101, 'Loanda', 'PR', NULL, NULL, NULL, 4113502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.198786', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4102, 'Lobato', 'PR', NULL, NULL, NULL, 4113601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.199695', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4103, 'Londrina', 'PR', NULL, NULL, NULL, 4113700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.200588', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4104, 'Luiziana', 'PR', NULL, NULL, NULL, 4113734, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.2014', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4105, 'Lunardelli', 'PR', NULL, NULL, NULL, 4113759, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.202191', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4106, 'Lupionopolis', 'PR', NULL, NULL, NULL, 4113809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.203083', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4107, 'Mallet', 'PR', NULL, NULL, NULL, 4113908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.204071', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4108, 'Mambore', 'PR', NULL, NULL, NULL, 4114005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.205131', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4109, 'Mandaguacu', 'PR', NULL, NULL, NULL, 4114104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.206396', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4110, 'Mandaguari', 'PR', NULL, NULL, NULL, 4114203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.207255', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4111, 'Mandirituba', 'PR', NULL, NULL, NULL, 4114302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.213506', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4112, 'Manfrinopolis', 'PR', NULL, NULL, NULL, 4114351, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.214574', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4113, 'Mangueirinha', 'PR', NULL, NULL, NULL, 4114401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.21538', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4114, 'Manoel Ribas', 'PR', NULL, NULL, NULL, 4114500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.216194', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4115, 'Marechal Candido Rondon', 'PR', NULL, NULL, NULL, 4114609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.217021', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4116, 'Maria Helena', 'PR', NULL, NULL, NULL, 4114708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.217924', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4117, 'Marialva', 'PR', NULL, NULL, NULL, 4114807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.218808', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4118, 'Marilandia do Sul', 'PR', NULL, NULL, NULL, 4114906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.219675', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4119, 'Marilena', 'PR', NULL, NULL, NULL, 4115002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.221127', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4120, 'Mariluz', 'PR', NULL, NULL, NULL, 4115101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.22202', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4121, 'Maringa', 'PR', NULL, NULL, NULL, 4115200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.222938', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4122, 'Mariopolis', 'PR', NULL, NULL, NULL, 4115309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.223854', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4123, 'Maripa', 'PR', NULL, NULL, NULL, 4115358, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.224672', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4124, 'Marmeleiro', 'PR', NULL, NULL, NULL, 4115408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.22564', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4125, 'Marquinho', 'PR', NULL, NULL, NULL, 4115457, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.22658', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4126, 'Marumbi', 'PR', NULL, NULL, NULL, 4115507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.227421', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4127, 'Matelandia', 'PR', NULL, NULL, NULL, 4115606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.228228', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4128, 'Matinhos', 'PR', NULL, NULL, NULL, 4115705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.229194', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4129, 'Mato Rico', 'PR', NULL, NULL, NULL, 4115739, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.230144', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4130, 'Maua da Serra', 'PR', NULL, NULL, NULL, 4115754, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.231029', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4131, 'Medianeira', 'PR', NULL, NULL, NULL, 4115804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.232254', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4132, 'Mercedes', 'PR', NULL, NULL, NULL, 4115853, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.233069', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4133, 'Mirador', 'PR', NULL, NULL, NULL, 4115903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.233941', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4134, 'Miraselva', 'PR', NULL, NULL, NULL, 4116000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.234818', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4135, 'Missal', 'PR', NULL, NULL, NULL, 4116059, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.23558', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4136, 'Moreira Sales', 'PR', NULL, NULL, NULL, 4116109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.236433', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4137, 'Morretes', 'PR', NULL, NULL, NULL, 4116208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.237286', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4138, 'Munhoz de Melo', 'PR', NULL, NULL, NULL, 4116307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.238297', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4139, 'Nossa Senhora das Gracas', 'PR', NULL, NULL, NULL, 4116406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.239216', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4140, 'Nova Alianca do Ivai', 'PR', NULL, NULL, NULL, 4116505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.240118', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4141, 'Nova America da Colina', 'PR', NULL, NULL, NULL, 4116604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.240981', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4142, 'Nova Aurora', 'PR', NULL, NULL, NULL, 4116703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.24191', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4143, 'Nova Cantu', 'PR', NULL, NULL, NULL, 4116802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.242841', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4144, 'Nova Esperanca', 'PR', NULL, NULL, NULL, 4116901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.243604', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4145, 'Nova Esperanca do Sudoeste', 'PR', NULL, NULL, NULL, 4116950, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.244503', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4146, 'Nova Fatima', 'PR', NULL, NULL, NULL, 4117008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.24551', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4147, 'Nova Laranjeiras', 'PR', NULL, NULL, NULL, 4117057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.246408', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4148, 'Nova Londrina', 'PR', NULL, NULL, NULL, 4117107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.247175', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4149, 'Nova Olimpia', 'PR', NULL, NULL, NULL, 4117206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.254111', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4151, 'Nova Santa Barbara', 'PR', NULL, NULL, NULL, 4117214, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.256208', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4152, 'Nova Santa Rosa', 'PR', NULL, NULL, NULL, 4117222, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.257126', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4150, 'Nova Prata do Iguacu', 'PR', NULL, NULL, NULL, 4117255, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.255272', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4153, 'Nova Tebas', 'PR', NULL, NULL, NULL, 4117271, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.258244', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4154, 'Novo Itacolomi', 'PR', NULL, NULL, NULL, 4117297, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.259008', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4155, 'Ortigueira', 'PR', NULL, NULL, NULL, 4117305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.259923', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4156, 'Ourizona', 'PR', NULL, NULL, NULL, 4117404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.260801', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4157, 'Ouro Verde do Oeste', 'PR', NULL, NULL, NULL, 4117453, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.261512', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4158, 'Paicandu', 'PR', NULL, NULL, NULL, 4117503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.262398', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4159, 'Palmas', 'PR', NULL, NULL, NULL, 4117602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.263241', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4160, 'Palmeira', 'PR', NULL, NULL, NULL, 4117701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.264126', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4161, 'Palmital', 'PR', NULL, NULL, NULL, 4117800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.264963', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4162, 'Palotina', 'PR', NULL, NULL, NULL, 4117909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.265805', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4163, 'Paraiso do Norte', 'PR', NULL, NULL, NULL, 4118006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.266633', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4164, 'Paranacity', 'PR', NULL, NULL, NULL, 4118105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.267515', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4165, 'Paranagua', 'PR', NULL, NULL, NULL, 4118204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.268404', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4166, 'Paranapoema', 'PR', NULL, NULL, NULL, 4118303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.269214', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4167, 'Paranavai', 'PR', NULL, NULL, NULL, 4118402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.270026', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4168, 'Pato Bragado', 'PR', NULL, NULL, NULL, 4118451, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.27079', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4169, 'Pato Branco', 'PR', NULL, NULL, NULL, 4118501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.271724', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4170, 'Paula Freitas', 'PR', NULL, NULL, NULL, 4118600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.272627', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4171, 'Paulo Frontin', 'PR', NULL, NULL, NULL, 4118709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.273639', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4172, 'Peabiru', 'PR', NULL, NULL, NULL, 4118808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.274646', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4173, 'Perobal', 'PR', NULL, NULL, NULL, 4118857, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.275641', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4174, 'Perola', 'PR', NULL, NULL, NULL, 4118907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.276605', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4175, 'Perola D''oeste', 'PR', NULL, NULL, NULL, 4119004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.277426', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4176, 'Pien', 'PR', NULL, NULL, NULL, 4119103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.278261', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4177, 'Pinhais', 'PR', NULL, NULL, NULL, 4119152, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.279077', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4179, 'Pinhalao', 'PR', NULL, NULL, NULL, 4119202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.280779', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4178, 'Pinhal de Sao Bento', 'PR', NULL, NULL, NULL, 4119251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.279898', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4180, 'Pinhao', 'PR', NULL, NULL, NULL, 4119301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.281602', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4181, 'Pirai do Sul', 'PR', NULL, NULL, NULL, 4119400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.282487', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4182, 'Piraquara', 'PR', NULL, NULL, NULL, 4119509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.283295', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4183, 'Pitanga', 'PR', NULL, NULL, NULL, 4119608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.2841', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4184, 'Pitangueiras', 'PR', NULL, NULL, NULL, 4119657, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.285074', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4185, 'Planaltina do Parana', 'PR', NULL, NULL, NULL, 4119707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.28605', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4186, 'Planalto', 'PR', NULL, NULL, NULL, 4119806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.286973', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4187, 'Ponta Grossa', 'PR', NULL, NULL, NULL, 4119905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.287832', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4188, 'Pontal do Parana', 'PR', NULL, NULL, NULL, 4119954, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.294545', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4189, 'Porecatu', 'PR', NULL, NULL, NULL, 4120002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.295833', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4190, 'Porto Amazonas', 'PR', NULL, NULL, NULL, 4120101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.296693', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4191, 'Porto Barreiro', 'PR', NULL, NULL, NULL, 4120150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.297591', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4192, 'Porto Rico', 'PR', NULL, NULL, NULL, 4120200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.298581', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4193, 'Porto Vitoria', 'PR', NULL, NULL, NULL, 4120309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.299373', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4194, 'Prado Ferreira', 'PR', NULL, NULL, NULL, 4120333, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.300209', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4195, 'Pranchita', 'PR', NULL, NULL, NULL, 4120358, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.301016', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4196, 'Presidente Castelo Branco', 'PR', NULL, NULL, NULL, 4120408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.301937', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4197, 'Primeiro de Maio', 'PR', NULL, NULL, NULL, 4120507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.30282', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4198, 'Prudentopolis', 'PR', NULL, NULL, NULL, 4120606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.303849', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4199, 'Quarto Centenario', 'PR', NULL, NULL, NULL, 4120655, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.304786', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4200, 'Quatigua', 'PR', NULL, NULL, NULL, 4120705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.305711', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4201, 'Quatro Barras', 'PR', NULL, NULL, NULL, 4120804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.306515', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4202, 'Quatro Pontes', 'PR', NULL, NULL, NULL, 4120853, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.307399', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4203, 'Quedas do Iguacu', 'PR', NULL, NULL, NULL, 4120903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.308241', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4204, 'Querencia do Norte', 'PR', NULL, NULL, NULL, 4121000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.309072', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4205, 'Quinta do Sol', 'PR', NULL, NULL, NULL, 4121109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.31021', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4206, 'Quitandinha', 'PR', NULL, NULL, NULL, 4121208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.311014', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4207, 'Ramilandia', 'PR', NULL, NULL, NULL, 4121257, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.3117', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4208, 'Rancho Alegre', 'PR', NULL, NULL, NULL, 4121307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.312592', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4209, 'Rancho Alegre D''oeste', 'PR', NULL, NULL, NULL, 4121356, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.313489', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4210, 'Realeza', 'PR', NULL, NULL, NULL, 4121406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.314376', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4211, 'Reboucas', 'PR', NULL, NULL, NULL, 4121505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.315317', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4212, 'Renascenca', 'PR', NULL, NULL, NULL, 4121604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.316337', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4213, 'Reserva', 'PR', NULL, NULL, NULL, 4121703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.317368', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4214, 'Reserva do Iguacu', 'PR', NULL, NULL, NULL, 4121752, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.318231', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4215, 'Ribeirao Claro', 'PR', NULL, NULL, NULL, 4121802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.31911', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4216, 'Ribeirao do Pinhal', 'PR', NULL, NULL, NULL, 4121901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.319989', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4217, 'Rio Azul', 'PR', NULL, NULL, NULL, 4122008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.320821', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4218, 'Rio Bom', 'PR', NULL, NULL, NULL, 4122107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.32181', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4219, 'Rio Bonito do Iguacu', 'PR', NULL, NULL, NULL, 4122156, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.322764', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4220, 'Rio Branco do Ivai', 'PR', NULL, NULL, NULL, 4122172, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.323713', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4221, 'Rio Branco do Sul', 'PR', NULL, NULL, NULL, 4122206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.324646', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4222, 'Rio Negro', 'PR', NULL, NULL, NULL, 4122305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.325554', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4223, 'Rolandia', 'PR', NULL, NULL, NULL, 4122404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.326432', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4224, 'Roncador', 'PR', NULL, NULL, NULL, 4122503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.327306', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4225, 'Rondon', 'PR', NULL, NULL, NULL, 4122602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.328245', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4226, 'Rosario do Ivai', 'PR', NULL, NULL, NULL, 4122651, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.338376', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4227, 'Sabaudia', 'PR', NULL, NULL, NULL, 4122701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.339508', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4228, 'Salgado Filho', 'PR', NULL, NULL, NULL, 4122800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.34043', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4229, 'Salto do Itarare', 'PR', NULL, NULL, NULL, 4122909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.341281', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4230, 'Salto do Lontra', 'PR', NULL, NULL, NULL, 4123006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.342375', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4231, 'Santa Amelia', 'PR', NULL, NULL, NULL, 4123105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.343545', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4232, 'Santa Cecilia do Pavao', 'PR', NULL, NULL, NULL, 4123204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.344438', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4233, 'Santa Cruz de Monte Castelo', 'PR', NULL, NULL, NULL, 4123303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.345319', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4234, 'Santa Fe', 'PR', NULL, NULL, NULL, 4123402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.346188', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4235, 'Santa Helena', 'PR', NULL, NULL, NULL, 4123501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.347091', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4236, 'Santa Ines', 'PR', NULL, NULL, NULL, 4123600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.347973', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4237, 'Santa Isabel do Ivai', 'PR', NULL, NULL, NULL, 4123709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.348934', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4238, 'Santa Izabel do Oeste', 'PR', NULL, NULL, NULL, 4123808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.349861', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4239, 'Santa Lucia', 'PR', NULL, NULL, NULL, 4123824, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.350735', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4240, 'Santa Maria do Oeste', 'PR', NULL, NULL, NULL, 4123857, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.351637', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4241, 'Santa Mariana', 'PR', NULL, NULL, NULL, 4123907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.352468', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4242, 'Santa Monica', 'PR', NULL, NULL, NULL, 4123956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.353319', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4245, 'Santana do Itarare', 'PR', NULL, NULL, NULL, 4124004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.355964', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4243, 'Santa Tereza do Oeste', 'PR', NULL, NULL, NULL, 4124020, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.35425', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4244, 'Santa Terezinha de Itaipu', 'PR', NULL, NULL, NULL, 4124053, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.355024', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4246, 'Santo Antonio da Platina', 'PR', NULL, NULL, NULL, 4124103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.356885', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4247, 'Santo Antonio do Caiua', 'PR', NULL, NULL, NULL, 4124202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.357831', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4248, 'Santo Antonio do Paraiso', 'PR', NULL, NULL, NULL, 4124301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.358771', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4249, 'Santo Antonio do Sudoeste', 'PR', NULL, NULL, NULL, 4124400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.359666', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4250, 'Santo Inacio', 'PR', NULL, NULL, NULL, 4124509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.360623', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4251, 'Sao Carlos do Ivai', 'PR', NULL, NULL, NULL, 4124608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.361502', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4252, 'Sao Jeronimo da Serra', 'PR', NULL, NULL, NULL, 4124707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.362324', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4253, 'Sao Joao', 'PR', NULL, NULL, NULL, 4124806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.363192', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4254, 'Sao Joao do Caiua', 'PR', NULL, NULL, NULL, 4124905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.364281', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4255, 'Sao Joao do Ivai', 'PR', NULL, NULL, NULL, 4125001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.365215', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4256, 'Sao Joao do Triunfo', 'PR', NULL, NULL, NULL, 4125100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.366215', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4259, 'Sao Jorge D''oeste', 'PR', NULL, NULL, NULL, 4125209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.368953', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4257, 'Sao Jorge do Ivai', 'PR', NULL, NULL, NULL, 4125308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.367092', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4258, 'Sao Jorge do Patrocinio', 'PR', NULL, NULL, NULL, 4125357, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.368034', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4260, 'Sao Jose da Boa Vista', 'PR', NULL, NULL, NULL, 4125407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.369834', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4261, 'Sao Jose das Palmeiras', 'PR', NULL, NULL, NULL, 4125456, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.370542', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4262, 'Sao Jose dos Pinhais', 'PR', NULL, NULL, NULL, 4125506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.371509', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4263, 'Sao Manoel do Parana', 'PR', NULL, NULL, NULL, 4125555, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.372312', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4264, 'Sao Mateus do Sul', 'PR', NULL, NULL, NULL, 4125605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.37923', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4265, 'Sao Miguel do Iguacu', 'PR', NULL, NULL, NULL, 4125704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.380624', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4266, 'Sao Pedro do Iguacu', 'PR', NULL, NULL, NULL, 4125753, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.381553', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4267, 'Sao Pedro do Ivai', 'PR', NULL, NULL, NULL, 4125803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.382512', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4268, 'Sao Pedro do Parana', 'PR', NULL, NULL, NULL, 4125902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.383505', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4269, 'Sao Sebastiao da Amoreira', 'PR', NULL, NULL, NULL, 4126009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.384423', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4270, 'Sao Tome', 'PR', NULL, NULL, NULL, 4126108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.38532', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4271, 'Sapopema', 'PR', NULL, NULL, NULL, 4126207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.386212', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4272, 'Sarandi', 'PR', NULL, NULL, NULL, 4126256, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.38714', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4273, 'Saudade do Iguacu', 'PR', NULL, NULL, NULL, 4126272, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.388048', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4274, 'Senges', 'PR', NULL, NULL, NULL, 4126306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.388983', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4275, 'Serranopolis do Iguacu', 'PR', NULL, NULL, NULL, 4126355, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.389954', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4276, 'Sertaneja', 'PR', NULL, NULL, NULL, 4126405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.390851', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4277, 'Sertanopolis', 'PR', NULL, NULL, NULL, 4126504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.391827', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4278, 'Siqueira Campos', 'PR', NULL, NULL, NULL, 4126603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.392833', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4279, 'Sulina', 'PR', NULL, NULL, NULL, 4126652, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.393627', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4280, 'Tamarana', 'PR', NULL, NULL, NULL, 4126678, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.394497', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4281, 'Tamboara', 'PR', NULL, NULL, NULL, 4126702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.395464', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4282, 'Tapejara', 'PR', NULL, NULL, NULL, 4126801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.396622', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4283, 'Tapira', 'PR', NULL, NULL, NULL, 4126900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.397553', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4284, 'Teixeira Soares', 'PR', NULL, NULL, NULL, 4127007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.398411', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4285, 'Telemaco Borba', 'PR', NULL, NULL, NULL, 4127106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.399685', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4286, 'Terra Boa', 'PR', NULL, NULL, NULL, 4127205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.400592', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4287, 'Terra Rica', 'PR', NULL, NULL, NULL, 4127304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.401465', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4288, 'Terra Roxa', 'PR', NULL, NULL, NULL, 4127403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.402543', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4289, 'Tibagi', 'PR', NULL, NULL, NULL, 4127502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.403763', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4290, 'Tijucas do Sul', 'PR', NULL, NULL, NULL, 4127601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.404751', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4291, 'Toledo', 'PR', NULL, NULL, NULL, 4127700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.405658', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4292, 'Tomazina', 'PR', NULL, NULL, NULL, 4127809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.406592', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4293, 'Tres Barras do Parana', 'PR', NULL, NULL, NULL, 4127858, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.407465', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4294, 'Tunas do Parana', 'PR', NULL, NULL, NULL, 4127882, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.408366', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4295, 'Tuneiras do Oeste', 'PR', NULL, NULL, NULL, 4127908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.409234', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4296, 'Tupassi', 'PR', NULL, NULL, NULL, 4127957, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.41021', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4297, 'Turvo', 'PR', NULL, NULL, NULL, 4127965, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.410984', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4298, 'Ubirata', 'PR', NULL, NULL, NULL, 4128005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.411853', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4299, 'Umuarama', 'PR', NULL, NULL, NULL, 4128104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.412765', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4300, 'Uniao da Vitoria', 'PR', NULL, NULL, NULL, 4128203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.413578', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4301, 'Uniflor', 'PR', NULL, NULL, NULL, 4128302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.42009', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4302, 'Urai', 'PR', NULL, NULL, NULL, 4128401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.421232', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4308, 'Wenceslau Braz', 'PR', NULL, NULL, NULL, 4128500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.426895', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4303, 'Ventania', 'PR', NULL, NULL, NULL, 4128534, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.422122', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4304, 'Vera Cruz do Oeste', 'PR', NULL, NULL, NULL, 4128559, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.422901', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4305, 'Vere', 'PR', NULL, NULL, NULL, 4128609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.423951', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (3916, 'Alto Paraiso', 'PR', NULL, NULL, NULL, 4128625, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.99001', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4013, 'Doutor Ulysses', 'PR', NULL, NULL, NULL, 4128633, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.100967', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4306, 'Virmond', 'PR', NULL, NULL, NULL, 4128658, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.424896', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4307, 'Vitorino', 'PR', NULL, NULL, NULL, 4128708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.425982', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4309, 'Xambre', 'PR', NULL, NULL, NULL, 4128807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.427805', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4310, 'Abdon Batista', 'SC', NULL, NULL, NULL, 4200051, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.428638', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4311, 'Abelardo Luz', 'SC', NULL, NULL, NULL, 4200101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.429547', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4312, 'Agrolandia', 'SC', NULL, NULL, NULL, 4200200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.430478', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4313, 'Agronomica', 'SC', NULL, NULL, NULL, 4200309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.431358', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4314, 'Agua Doce', 'SC', NULL, NULL, NULL, 4200408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.43226', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4315, 'Aguas de Chapeco', 'SC', NULL, NULL, NULL, 4200507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.433055', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4316, 'Aguas Frias', 'SC', NULL, NULL, NULL, 4200556, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.43394', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4317, 'Aguas Mornas', 'SC', NULL, NULL, NULL, 4200606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.434905', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4318, 'Alfredo Wagner', 'SC', NULL, NULL, NULL, 4200705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.435771', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4319, 'Alto Bela Vista', 'SC', NULL, NULL, NULL, 4200754, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.43669', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4320, 'Anchieta', 'SC', NULL, NULL, NULL, 4200804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.43753', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4321, 'Angelina', 'SC', NULL, NULL, NULL, 4200903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.43846', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4322, 'Anita Garibaldi', 'SC', NULL, NULL, NULL, 4201000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.439314', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4323, 'Anitapolis', 'SC', NULL, NULL, NULL, 4201109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.440162', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4324, 'Antonio Carlos', 'SC', NULL, NULL, NULL, 4201208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.440943', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4325, 'Apiuna', 'SC', NULL, NULL, NULL, 4201257, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.441712', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4326, 'Arabuta', 'SC', NULL, NULL, NULL, 4201273, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.442617', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4327, 'Araquari', 'SC', NULL, NULL, NULL, 4201307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.44364', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4328, 'Ararangua', 'SC', NULL, NULL, NULL, 4201406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.444439', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4329, 'Armazem', 'SC', NULL, NULL, NULL, 4201505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.445254', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4330, 'Arroio Trinta', 'SC', NULL, NULL, NULL, 4201604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.446176', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4331, 'Arvoredo', 'SC', NULL, NULL, NULL, 4201653, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.447106', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4332, 'Ascurra', 'SC', NULL, NULL, NULL, 4201703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.44797', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4333, 'Atalanta', 'SC', NULL, NULL, NULL, 4201802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.448887', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4334, 'Aurora', 'SC', NULL, NULL, NULL, 4201901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.449795', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4335, 'Balneario Arroio do Silva', 'SC', NULL, NULL, NULL, 4201950, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.450698', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4337, 'Balneario Camboriu', 'SC', NULL, NULL, NULL, 4202008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.45249', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4336, 'Balneario Barra do Sul', 'SC', NULL, NULL, NULL, 4202057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.451594', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4338, 'Balneario Gaivota', 'SC', NULL, NULL, NULL, 4202073, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.453461', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4339, 'Bandeirante', 'SC', NULL, NULL, NULL, 4202081, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.460344', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4340, 'Barra Bonita', 'SC', NULL, NULL, NULL, 4202099, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.461537', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4341, 'Barra Velha', 'SC', NULL, NULL, NULL, 4202107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.462448', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4342, 'Bela Vista do Toldo', 'SC', NULL, NULL, NULL, 4202131, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.463399', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4343, 'Belmonte', 'SC', NULL, NULL, NULL, 4202156, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.464282', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4344, 'Benedito Novo', 'SC', NULL, NULL, NULL, 4202206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.465195', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4345, 'Biguacu', 'SC', NULL, NULL, NULL, 4202305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.466322', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4346, 'Blumenau', 'SC', NULL, NULL, NULL, 4202404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.467185', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4347, 'Bocaina do Sul', 'SC', NULL, NULL, NULL, 4202438, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.468115', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4352, 'Bombinhas', 'SC', NULL, NULL, NULL, 4202453, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.472717', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4348, 'Bom Jardim da Serra', 'SC', NULL, NULL, NULL, 4202503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.469091', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4349, 'Bom Jesus', 'SC', NULL, NULL, NULL, 4202537, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.469971', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4350, 'Bom Jesus do Oeste', 'SC', NULL, NULL, NULL, 4202578, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.470938', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4351, 'Bom Retiro', 'SC', NULL, NULL, NULL, 4202602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.471851', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4353, 'Botuvera', 'SC', NULL, NULL, NULL, 4202701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.473586', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4354, 'Braco do Norte', 'SC', NULL, NULL, NULL, 4202800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.474511', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4355, 'Braco do Trombudo', 'SC', NULL, NULL, NULL, 4202859, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.47539', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4356, 'Brunopolis', 'SC', NULL, NULL, NULL, 4202875, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.476535', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4357, 'Brusque', 'SC', NULL, NULL, NULL, 4202909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.477593', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4358, 'Cacador', 'SC', NULL, NULL, NULL, 4203006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.478494', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4359, 'Caibi', 'SC', NULL, NULL, NULL, 4203105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.479391', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4360, 'Calmon', 'SC', NULL, NULL, NULL, 4203154, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.480305', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4361, 'Camboriu', 'SC', NULL, NULL, NULL, 4203204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.481266', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4368, 'Capao Alto', 'SC', NULL, NULL, NULL, 4203253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.488426', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4362, 'Campo Alegre', 'SC', NULL, NULL, NULL, 4203303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.482024', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4363, 'Campo Belo do Sul', 'SC', NULL, NULL, NULL, 4203402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.483299', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4364, 'Campo Ere', 'SC', NULL, NULL, NULL, 4203501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.484528', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4365, 'Campos Novos', 'SC', NULL, NULL, NULL, 4203600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.48539', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4366, 'Canelinha', 'SC', NULL, NULL, NULL, 4203709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.486284', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4367, 'Canoinhas', 'SC', NULL, NULL, NULL, 4203808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.487206', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4369, 'Capinzal', 'SC', NULL, NULL, NULL, 4203907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.489197', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4370, 'Capivari de Baixo', 'SC', NULL, NULL, NULL, 4203956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.490106', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4371, 'Catanduvas', 'SC', NULL, NULL, NULL, 4204004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.491025', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4372, 'Caxambu do Sul', 'SC', NULL, NULL, NULL, 4204103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.491954', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4373, 'Celso Ramos', 'SC', NULL, NULL, NULL, 4204152, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.492847', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4374, 'Cerro Negro', 'SC', NULL, NULL, NULL, 4204178, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.493856', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4375, 'Chapadao do Lageado', 'SC', NULL, NULL, NULL, 4204194, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.500523', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4376, 'Chapeco', 'SC', NULL, NULL, NULL, 4204202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.501768', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4377, 'Cocal do Sul', 'SC', NULL, NULL, NULL, 4204251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.502784', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4378, 'Concordia', 'SC', NULL, NULL, NULL, 4204301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.50375', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4379, 'Cordilheira Alta', 'SC', NULL, NULL, NULL, 4204350, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.504637', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4380, 'Coronel Freitas', 'SC', NULL, NULL, NULL, 4204400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.50575', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4381, 'Coronel Martins', 'SC', NULL, NULL, NULL, 4204459, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.506666', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4383, 'Corupa', 'SC', NULL, NULL, NULL, 4204509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.508452', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4382, 'Correia Pinto', 'SC', NULL, NULL, NULL, 4204558, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.507531', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4384, 'Criciuma', 'SC', NULL, NULL, NULL, 4204608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.509451', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4385, 'Cunha Pora', 'SC', NULL, NULL, NULL, 4204707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.510481', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4386, 'Cunhatai', 'SC', NULL, NULL, NULL, 4204756, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.511334', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4387, 'Curitibanos', 'SC', NULL, NULL, NULL, 4204806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.512194', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4388, 'Descanso', 'SC', NULL, NULL, NULL, 4204905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.513047', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4389, 'Dionisio Cerqueira', 'SC', NULL, NULL, NULL, 4205001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.513922', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4390, 'Dona Emma', 'SC', NULL, NULL, NULL, 4205100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.514778', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4391, 'Doutor Pedrinho', 'SC', NULL, NULL, NULL, 4205159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.515649', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4392, 'Entre Rios', 'SC', NULL, NULL, NULL, 4205175, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.516534', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4393, 'Ermo', 'SC', NULL, NULL, NULL, 4205191, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.517512', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4394, 'Erval Velho', 'SC', NULL, NULL, NULL, 4205209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.518414', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4395, 'Faxinal dos Guedes', 'SC', NULL, NULL, NULL, 4205308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.519319', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4396, 'Flor do Sertao', 'SC', NULL, NULL, NULL, 4205357, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.520213', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4397, 'Florianopolis', 'SC', NULL, NULL, NULL, 4205407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.521114', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4398, 'Formosa do Sul', 'SC', NULL, NULL, NULL, 4205431, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.522109', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4399, 'Forquilhinha', 'SC', NULL, NULL, NULL, 4205456, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.523012', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4400, 'Fraiburgo', 'SC', NULL, NULL, NULL, 4205506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.523979', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4401, 'Frei Rogerio', 'SC', NULL, NULL, NULL, 4205555, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.524846', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4402, 'Galvao', 'SC', NULL, NULL, NULL, 4205605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.525743', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4403, 'Garopaba', 'SC', NULL, NULL, NULL, 4205707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.526646', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4404, 'Garuva', 'SC', NULL, NULL, NULL, 4205803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.527531', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4405, 'Gaspar', 'SC', NULL, NULL, NULL, 4205902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.528459', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4406, 'Governador Celso Ramos', 'SC', NULL, NULL, NULL, 4206009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.529386', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4407, 'Grao Para', 'SC', NULL, NULL, NULL, 4206108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.530212', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4408, 'Gravatal', 'SC', NULL, NULL, NULL, 4206207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.531116', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4409, 'Guabiruba', 'SC', NULL, NULL, NULL, 4206306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.53194', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4410, 'Guaraciaba', 'SC', NULL, NULL, NULL, 4206405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.532863', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4411, 'Guaramirim', 'SC', NULL, NULL, NULL, 4206504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.533779', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4412, 'Guaruja do Sul', 'SC', NULL, NULL, NULL, 4206603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.535074', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4413, 'Guatambu', 'SC', NULL, NULL, NULL, 4206652, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.541376', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4414, 'Herval D''oeste', 'SC', NULL, NULL, NULL, 4206702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.542596', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4415, 'Ibiam', 'SC', NULL, NULL, NULL, 4206751, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.543705', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4416, 'Ibicare', 'SC', NULL, NULL, NULL, 4206801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.544411', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4417, 'Ibirama', 'SC', NULL, NULL, NULL, 4206900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.54531', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4418, 'Icara', 'SC', NULL, NULL, NULL, 4207007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.546167', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4419, 'Ilhota', 'SC', NULL, NULL, NULL, 4207106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.546952', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4420, 'Imarui', 'SC', NULL, NULL, NULL, 4207205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.547891', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4421, 'Imbituba', 'SC', NULL, NULL, NULL, 4207304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.548745', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4422, 'Imbuia', 'SC', NULL, NULL, NULL, 4207403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.549615', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4423, 'Indaial', 'SC', NULL, NULL, NULL, 4207502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.550745', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4424, 'Iomere', 'SC', NULL, NULL, NULL, 4207577, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.551707', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4425, 'Ipira', 'SC', NULL, NULL, NULL, 4207601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.552628', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4426, 'Ipora do Oeste', 'SC', NULL, NULL, NULL, 4207650, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.553489', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4427, 'Ipuacu', 'SC', NULL, NULL, NULL, 4207684, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.554353', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4428, 'Ipumirim', 'SC', NULL, NULL, NULL, 4207700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.555764', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4429, 'Iraceminha', 'SC', NULL, NULL, NULL, 4207759, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.556864', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4430, 'Irani', 'SC', NULL, NULL, NULL, 4207809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.557716', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4431, 'Irati', 'SC', NULL, NULL, NULL, 4207858, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.558657', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4432, 'Irineopolis', 'SC', NULL, NULL, NULL, 4207908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.559588', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4433, 'Ita', 'SC', NULL, NULL, NULL, 4208005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.56052', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4434, 'Itaiopolis', 'SC', NULL, NULL, NULL, 4208104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.5614', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4435, 'Itajai', 'SC', NULL, NULL, NULL, 4208203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.562258', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4436, 'Itapema', 'SC', NULL, NULL, NULL, 4208302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.563129', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4437, 'Itapiranga', 'SC', NULL, NULL, NULL, 4208401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.564104', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4438, 'Itapoa', 'SC', NULL, NULL, NULL, 4208450, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.565082', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4439, 'Ituporanga', 'SC', NULL, NULL, NULL, 4208500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.566056', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4440, 'Jabora', 'SC', NULL, NULL, NULL, 4208609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.566836', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4441, 'Jacinto Machado', 'SC', NULL, NULL, NULL, 4208708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.567842', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4442, 'Jaguaruna', 'SC', NULL, NULL, NULL, 4208807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.568806', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4443, 'Jaragua do Sul', 'SC', NULL, NULL, NULL, 4208906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.569621', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4444, 'Jardinopolis', 'SC', NULL, NULL, NULL, 4208955, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.570517', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4445, 'Joacaba', 'SC', NULL, NULL, NULL, 4209003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.571308', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4446, 'Joinville', 'SC', NULL, NULL, NULL, 4209102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.572209', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4447, 'Jose Boiteux', 'SC', NULL, NULL, NULL, 4209151, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.573179', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4448, 'Jupia', 'SC', NULL, NULL, NULL, 4209177, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.574057', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4449, 'Lacerdopolis', 'SC', NULL, NULL, NULL, 4209201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.574936', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4450, 'Lages', 'SC', NULL, NULL, NULL, 4209300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.581911', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4451, 'Laguna', 'SC', NULL, NULL, NULL, 4209409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.583305', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4452, 'Lajeado Grande', 'SC', NULL, NULL, NULL, 4209458, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.584135', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4453, 'Laurentino', 'SC', NULL, NULL, NULL, 4209508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.584973', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4454, 'Lauro Muller', 'SC', NULL, NULL, NULL, 4209607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.585797', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4455, 'Lebon Regis', 'SC', NULL, NULL, NULL, 4209706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.586737', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4456, 'Leoberto Leal', 'SC', NULL, NULL, NULL, 4209805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.587727', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4457, 'Lindoia do Sul', 'SC', NULL, NULL, NULL, 4209854, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.589095', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4458, 'Lontras', 'SC', NULL, NULL, NULL, 4209904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.590019', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4459, 'Luiz Alves', 'SC', NULL, NULL, NULL, 4210001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.590917', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4460, 'Luzerna', 'SC', NULL, NULL, NULL, 4210035, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.591816', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4461, 'Macieira', 'SC', NULL, NULL, NULL, 4210050, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.592688', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4462, 'Mafra', 'SC', NULL, NULL, NULL, 4210100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.593594', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4463, 'Major Gercino', 'SC', NULL, NULL, NULL, 4210209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.594511', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4464, 'Major Vieira', 'SC', NULL, NULL, NULL, 4210308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.595378', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4465, 'Maracaja', 'SC', NULL, NULL, NULL, 4210407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.59623', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4466, 'Maravilha', 'SC', NULL, NULL, NULL, 4210506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.597301', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4467, 'Marema', 'SC', NULL, NULL, NULL, 4210555, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.598234', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4468, 'Massaranduba', 'SC', NULL, NULL, NULL, 4210605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.59912', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4469, 'Matos Costa', 'SC', NULL, NULL, NULL, 4210704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.600611', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4470, 'Meleiro', 'SC', NULL, NULL, NULL, 4210803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.601584', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4471, 'Mirim Doce', 'SC', NULL, NULL, NULL, 4210852, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.602525', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4472, 'Modelo', 'SC', NULL, NULL, NULL, 4210902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.603369', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4473, 'Mondai', 'SC', NULL, NULL, NULL, 4211009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.604263', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4474, 'Monte Carlo', 'SC', NULL, NULL, NULL, 4211058, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.605228', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4475, 'Monte Castelo', 'SC', NULL, NULL, NULL, 4211108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.606147', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4476, 'Morro da Fumaca', 'SC', NULL, NULL, NULL, 4211207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.607036', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4477, 'Morro Grande', 'SC', NULL, NULL, NULL, 4211256, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.607994', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4478, 'Navegantes', 'SC', NULL, NULL, NULL, 4211306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.608914', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4479, 'Nova Erechim', 'SC', NULL, NULL, NULL, 4211405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.60984', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4480, 'Nova Itaberaba', 'SC', NULL, NULL, NULL, 4211454, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.610808', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4481, 'Nova Trento', 'SC', NULL, NULL, NULL, 4211504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.611579', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4482, 'Nova Veneza', 'SC', NULL, NULL, NULL, 4211603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.612402', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4483, 'Novo Horizonte', 'SC', NULL, NULL, NULL, 4211652, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.61326', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4484, 'Orleans', 'SC', NULL, NULL, NULL, 4211702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.614203', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4485, 'Otacilio Costa', 'SC', NULL, NULL, NULL, 4211751, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.615091', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4486, 'Ouro', 'SC', NULL, NULL, NULL, 4211801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.615915', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4487, 'Ouro Verde', 'SC', NULL, NULL, NULL, 4211850, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.622292', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4488, 'Paial', 'SC', NULL, NULL, NULL, 4211876, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.624172', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4489, 'Painel', 'SC', NULL, NULL, NULL, 4211892, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.625092', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4490, 'Palhoca', 'SC', NULL, NULL, NULL, 4211900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.625997', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4491, 'Palma Sola', 'SC', NULL, NULL, NULL, 4212007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.626836', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4492, 'Palmeira', 'SC', NULL, NULL, NULL, 4212056, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.627753', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4493, 'Palmitos', 'SC', NULL, NULL, NULL, 4212106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.628577', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4494, 'Papanduva', 'SC', NULL, NULL, NULL, 4212205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.629483', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4495, 'Paraiso', 'SC', NULL, NULL, NULL, 4212239, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.630489', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4496, 'Passo de Torres', 'SC', NULL, NULL, NULL, 4212254, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.631393', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4497, 'Passos Maia', 'SC', NULL, NULL, NULL, 4212270, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.632217', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4498, 'Paulo Lopes', 'SC', NULL, NULL, NULL, 4212304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.633094', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4499, 'Pedras Grandes', 'SC', NULL, NULL, NULL, 4212403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.634126', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4500, 'Penha', 'SC', NULL, NULL, NULL, 4212502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.635075', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4501, 'Peritiba', 'SC', NULL, NULL, NULL, 4212601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.635905', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4502, 'Petrolandia', 'SC', NULL, NULL, NULL, 4212700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.636576', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4503, 'Picarras', 'SC', NULL, NULL, NULL, 4212809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.637358', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4504, 'Pinhalzinho', 'SC', NULL, NULL, NULL, 4212908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.638178', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4505, 'Pinheiro Preto', 'SC', NULL, NULL, NULL, 4213005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.639052', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4506, 'Piratuba', 'SC', NULL, NULL, NULL, 4213104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.640027', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4507, 'Planalto Alegre', 'SC', NULL, NULL, NULL, 4213153, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.640907', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4508, 'Pomerode', 'SC', NULL, NULL, NULL, 4213203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.641749', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4509, 'Ponte Alta', 'SC', NULL, NULL, NULL, 4213302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.642696', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4510, 'Ponte Alta do Norte', 'SC', NULL, NULL, NULL, 4213351, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.643679', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4511, 'Ponte Serrada', 'SC', NULL, NULL, NULL, 4213401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.644826', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4512, 'Porto Belo', 'SC', NULL, NULL, NULL, 4213500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.645727', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4513, 'Porto Uniao', 'SC', NULL, NULL, NULL, 4213609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.646532', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4514, 'Pouso Redondo', 'SC', NULL, NULL, NULL, 4213708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.647333', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4515, 'Praia Grande', 'SC', NULL, NULL, NULL, 4213807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.648213', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4516, 'Presidente Castello Branco', 'SC', NULL, NULL, NULL, 4213906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.64913', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4517, 'Presidente Getulio', 'SC', NULL, NULL, NULL, 4214003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.650041', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4518, 'Presidente Nereu', 'SC', NULL, NULL, NULL, 4214102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.650912', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4519, 'Princesa', 'SC', NULL, NULL, NULL, 4214151, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.651836', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4520, 'Quilombo', 'SC', NULL, NULL, NULL, 4214201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.65283', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4521, 'Rancho Queimado', 'SC', NULL, NULL, NULL, 4214300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.65372', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4522, 'Rio das Antas', 'SC', NULL, NULL, NULL, 4214409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.654634', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4523, 'Rio do Campo', 'SC', NULL, NULL, NULL, 4214508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.65549', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4524, 'Rio do Oeste', 'SC', NULL, NULL, NULL, 4214607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.656406', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4526, 'Rio dos Cedros', 'SC', NULL, NULL, NULL, 4214706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.664346', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4525, 'Rio do Sul', 'SC', NULL, NULL, NULL, 4214805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.663037', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4527, 'Rio Fortuna', 'SC', NULL, NULL, NULL, 4214904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.665268', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4528, 'Rio Negrinho', 'SC', NULL, NULL, NULL, 4215000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.666145', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4529, 'Rio Rufino', 'SC', NULL, NULL, NULL, 4215059, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.667136', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4530, 'Riqueza', 'SC', NULL, NULL, NULL, 4215075, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.667883', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4531, 'Rodeio', 'SC', NULL, NULL, NULL, 4215109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.668722', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4532, 'Romelandia', 'SC', NULL, NULL, NULL, 4215208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.669664', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4533, 'Salete', 'SC', NULL, NULL, NULL, 4215307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.670537', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4534, 'Saltinho', 'SC', NULL, NULL, NULL, 4215356, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.671426', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4535, 'Salto Veloso', 'SC', NULL, NULL, NULL, 4215406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.672315', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4536, 'Sangao', 'SC', NULL, NULL, NULL, 4215455, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.67311', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4537, 'Santa Cecilia', 'SC', NULL, NULL, NULL, 4215505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.674081', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4538, 'Santa Helena', 'SC', NULL, NULL, NULL, 4215554, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.674964', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4539, 'Santa Rosa de Lima', 'SC', NULL, NULL, NULL, 4215604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.675907', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4540, 'Santa Rosa do Sul', 'SC', NULL, NULL, NULL, 4215653, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.676772', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4541, 'Santa Terezinha', 'SC', NULL, NULL, NULL, 4215679, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.677855', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4542, 'Santa Terezinha do Progresso', 'SC', NULL, NULL, NULL, 4215687, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.678617', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4543, 'Santiago do Sul', 'SC', NULL, NULL, NULL, 4215695, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.679531', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4544, 'Santo Amaro da Imperatriz', 'SC', NULL, NULL, NULL, 4215703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.680401', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4546, 'Sao Bernardino', 'SC', NULL, NULL, NULL, 4215752, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.682107', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4545, 'Sao Bento do Sul', 'SC', NULL, NULL, NULL, 4215802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.681233', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4547, 'Sao Bonifacio', 'SC', NULL, NULL, NULL, 4215901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.683118', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4548, 'Sao Carlos', 'SC', NULL, NULL, NULL, 4216008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.683978', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4549, 'Sao Cristovao do Sul', 'SC', NULL, NULL, NULL, 4216057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.684896', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4550, 'Sao Domingos', 'SC', NULL, NULL, NULL, 4216107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.685665', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4551, 'Sao Francisco do Sul', 'SC', NULL, NULL, NULL, 4216206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.686536', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4554, 'Sao Joao do Oeste', 'SC', NULL, NULL, NULL, 4216255, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.689546', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4552, 'Sao Joao Batista', 'SC', NULL, NULL, NULL, 4216305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.687673', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4553, 'Sao Joao do Itaperiu', 'SC', NULL, NULL, NULL, 4216354, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.688602', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4555, 'Sao Joao do Sul', 'SC', NULL, NULL, NULL, 4216404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.690449', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4556, 'Sao Joaquim', 'SC', NULL, NULL, NULL, 4216503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.691291', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4557, 'Sao Jose', 'SC', NULL, NULL, NULL, 4216602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.692211', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4558, 'Sao Jose do Cedro', 'SC', NULL, NULL, NULL, 4216701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.693112', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4559, 'Sao Jose do Cerrito', 'SC', NULL, NULL, NULL, 4216800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.694047', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4560, 'Sao Lourenco do Oeste', 'SC', NULL, NULL, NULL, 4216909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.694964', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4561, 'Sao Ludgero', 'SC', NULL, NULL, NULL, 4217006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.695892', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4562, 'Sao Martinho', 'SC', NULL, NULL, NULL, 4217105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.696805', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4563, 'Sao Miguel da Boa Vista', 'SC', NULL, NULL, NULL, 4217154, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.704183', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4564, 'Sao Miguel do Oeste', 'SC', NULL, NULL, NULL, 4217204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.705337', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4565, 'Sao Pedro de Alcantara', 'SC', NULL, NULL, NULL, 4217253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.706219', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4566, 'Saudades', 'SC', NULL, NULL, NULL, 4217303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.707271', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4567, 'Schroeder', 'SC', NULL, NULL, NULL, 4217402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.708028', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4568, 'Seara', 'SC', NULL, NULL, NULL, 4217501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.70891', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4569, 'Serra Alta', 'SC', NULL, NULL, NULL, 4217550, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.709735', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4570, 'Sideropolis', 'SC', NULL, NULL, NULL, 4217600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.710532', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4571, 'Sombrio', 'SC', NULL, NULL, NULL, 4217709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.711816', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4572, 'Sul Brasil', 'SC', NULL, NULL, NULL, 4217758, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.712836', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4573, 'Taio', 'SC', NULL, NULL, NULL, 4217808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.713717', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4574, 'Tangara', 'SC', NULL, NULL, NULL, 4217907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.714564', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4575, 'Tigrinhos', 'SC', NULL, NULL, NULL, 4217956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.715422', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4576, 'Tijucas', 'SC', NULL, NULL, NULL, 4218004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.716342', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4577, 'Timbe do Sul', 'SC', NULL, NULL, NULL, 4218103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.717364', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4578, 'Timbo', 'SC', NULL, NULL, NULL, 4218202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.718247', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4579, 'Timbo Grande', 'SC', NULL, NULL, NULL, 4218251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.719183', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4580, 'Tres Barras', 'SC', NULL, NULL, NULL, 4218301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.720092', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4581, 'Treviso', 'SC', NULL, NULL, NULL, 4218350, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.720922', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4582, 'Treze de Maio', 'SC', NULL, NULL, NULL, 4218400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.72182', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4583, 'Treze Tilias', 'SC', NULL, NULL, NULL, 4218509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.723155', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4584, 'Trombudo Central', 'SC', NULL, NULL, NULL, 4218608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.724091', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4585, 'Tubarao', 'SC', NULL, NULL, NULL, 4218707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.725008', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4586, 'Tunapolis', 'SC', NULL, NULL, NULL, 4218756, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.725919', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4587, 'Turvo', 'SC', NULL, NULL, NULL, 4218806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.726812', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4588, 'Uniao do Oeste', 'SC', NULL, NULL, NULL, 4218855, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.727766', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4589, 'Urubici', 'SC', NULL, NULL, NULL, 4218905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.728589', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4590, 'Urupema', 'SC', NULL, NULL, NULL, 4218954, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.729355', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4591, 'Urussanga', 'SC', NULL, NULL, NULL, 4219002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.730223', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4592, 'Vargeao', 'SC', NULL, NULL, NULL, 4219101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.731004', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4593, 'Vargem', 'SC', NULL, NULL, NULL, 4219150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.73178', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4594, 'Vargem Bonita', 'SC', NULL, NULL, NULL, 4219176, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.732992', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4595, 'Vidal Ramos', 'SC', NULL, NULL, NULL, 4219200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.734534', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4596, 'Videira', 'SC', NULL, NULL, NULL, 4219309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.735701', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4597, 'Vitor Meireles', 'SC', NULL, NULL, NULL, 4219358, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.736573', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4598, 'Witmarsum', 'SC', NULL, NULL, NULL, 4219408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.73748', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4599, 'Xanxere', 'SC', NULL, NULL, NULL, 4219507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.738315', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4600, 'Xavantina', 'SC', NULL, NULL, NULL, 4219606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.744776', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4601, 'Xaxim', 'SC', NULL, NULL, NULL, 4219705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.745932', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4602, 'Zortea', 'SC', NULL, NULL, NULL, 4219853, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.746831', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4603, 'Acegua', 'RS', NULL, NULL, NULL, 4300034, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.747752', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4604, 'Agua Santa', 'RS', NULL, NULL, NULL, 4300059, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.748623', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4605, 'Agudo', 'RS', NULL, NULL, NULL, 4300109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.749535', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4606, 'Ajuricaba', 'RS', NULL, NULL, NULL, 4300208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.750335', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4607, 'Alecrim', 'RS', NULL, NULL, NULL, 4300307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.751293', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4608, 'Alegrete', 'RS', NULL, NULL, NULL, 4300406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.75216', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4609, 'Alegria', 'RS', NULL, NULL, NULL, 4300455, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.752979', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4610, 'Almirante Tamandare do Sul', 'RS', NULL, NULL, NULL, 4300471, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.75392', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4611, 'Alpestre', 'RS', NULL, NULL, NULL, 4300505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.754809', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4612, 'Alto Alegre', 'RS', NULL, NULL, NULL, 4300554, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.755767', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4613, 'Alto Feliz', 'RS', NULL, NULL, NULL, 4300570, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.756681', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4614, 'Alvorada', 'RS', NULL, NULL, NULL, 4300604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.75756', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4615, 'Amaral Ferrador', 'RS', NULL, NULL, NULL, 4300638, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.758517', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4616, 'Ametista do Sul', 'RS', NULL, NULL, NULL, 4300646, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.759328', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4617, 'Andre da Rocha', 'RS', NULL, NULL, NULL, 4300661, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.760208', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4618, 'Anta Gorda', 'RS', NULL, NULL, NULL, 4300703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.760999', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4619, 'Antonio Prado', 'RS', NULL, NULL, NULL, 4300802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.76193', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4620, 'Arambare', 'RS', NULL, NULL, NULL, 4300851, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.763109', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4621, 'Ararica', 'RS', NULL, NULL, NULL, 4300877, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.76479', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4622, 'Aratiba', 'RS', NULL, NULL, NULL, 4300901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.765569', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4623, 'Arroio do Meio', 'RS', NULL, NULL, NULL, 4301008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.766691', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4625, 'Arroio do Sal', 'RS', NULL, NULL, NULL, 4301057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.768531', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4624, 'Arroio do Padre', 'RS', NULL, NULL, NULL, 4301073, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.767588', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4627, 'Arroio dos Ratos', 'RS', NULL, NULL, NULL, 4301107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.770348', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4626, 'Arroio do Tigre', 'RS', NULL, NULL, NULL, 4301206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.769457', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4628, 'Arroio Grande', 'RS', NULL, NULL, NULL, 4301305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.771225', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4629, 'Arvorezinha', 'RS', NULL, NULL, NULL, 4301404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.772101', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4630, 'Augusto Pestana', 'RS', NULL, NULL, NULL, 4301503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.772977', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4631, 'Aurea', 'RS', NULL, NULL, NULL, 4301552, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.773902', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4632, 'Bage', 'RS', NULL, NULL, NULL, 4301602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.774733', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4633, 'Balneario Pinhal', 'RS', NULL, NULL, NULL, 4301636, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.775604', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4634, 'Barao', 'RS', NULL, NULL, NULL, 4301651, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.776395', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4635, 'Barao de Cotegipe', 'RS', NULL, NULL, NULL, 4301701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.777163', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4636, 'Barao do Triunfo', 'RS', NULL, NULL, NULL, 4301750, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.778243', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4642, 'Barracao', 'RS', NULL, NULL, NULL, 4301800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.789888', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4637, 'Barra do Guarita', 'RS', NULL, NULL, NULL, 4301859, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.784613', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4638, 'Barra do Quarai', 'RS', NULL, NULL, NULL, 4301875, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.786135', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4639, 'Barra do Ribeiro', 'RS', NULL, NULL, NULL, 4301909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.787083', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4640, 'Barra do Rio Azul', 'RS', NULL, NULL, NULL, 4301925, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.787963', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4641, 'Barra Funda', 'RS', NULL, NULL, NULL, 4301958, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.788957', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4643, 'Barros Cassal', 'RS', NULL, NULL, NULL, 4302006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.790848', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4644, 'Benjamin Constant do Sul', 'RS', NULL, NULL, NULL, 4302055, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.791749', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4645, 'Bento Goncalves', 'RS', NULL, NULL, NULL, 4302105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.792666', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4646, 'Boa Vista das Missoes', 'RS', NULL, NULL, NULL, 4302154, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.793467', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4647, 'Boa Vista do Burica', 'RS', NULL, NULL, NULL, 4302204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.794351', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4648, 'Boa Vista do Cadeado', 'RS', NULL, NULL, NULL, 4302220, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.795209', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4649, 'Boa Vista do Incra', 'RS', NULL, NULL, NULL, 4302238, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.79609', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4650, 'Boa Vista do Sul', 'RS', NULL, NULL, NULL, 4302253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.796974', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4651, 'Bom Jesus', 'RS', NULL, NULL, NULL, 4302303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.797947', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4652, 'Bom Principio', 'RS', NULL, NULL, NULL, 4302352, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.799093', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4653, 'Bom Progresso', 'RS', NULL, NULL, NULL, 4302378, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.80005', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4654, 'Bom Retiro do Sul', 'RS', NULL, NULL, NULL, 4302402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.800999', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4655, 'Boqueirao do Leao', 'RS', NULL, NULL, NULL, 4302451, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.801898', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4656, 'Bossoroca', 'RS', NULL, NULL, NULL, 4302501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.802916', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4657, 'Bozano', 'RS', NULL, NULL, NULL, 4302584, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.803916', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4658, 'Braga', 'RS', NULL, NULL, NULL, 4302600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.804862', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4659, 'Brochier', 'RS', NULL, NULL, NULL, 4302659, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.805735', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4660, 'Butia', 'RS', NULL, NULL, NULL, 4302709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.806615', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4661, 'Cacapava do Sul', 'RS', NULL, NULL, NULL, 4302808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.807519', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4662, 'Cacequi', 'RS', NULL, NULL, NULL, 4302907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.808337', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4663, 'Cachoeira do Sul', 'RS', NULL, NULL, NULL, 4303004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.809202', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4664, 'Cachoeirinha', 'RS', NULL, NULL, NULL, 4303103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.810127', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4665, 'Cacique Doble', 'RS', NULL, NULL, NULL, 4303202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.811004', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4666, 'Caibate', 'RS', NULL, NULL, NULL, 4303301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.812204', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4667, 'Caicara', 'RS', NULL, NULL, NULL, 4303400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.813081', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4668, 'Camaqua', 'RS', NULL, NULL, NULL, 4303509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.813986', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4669, 'Camargo', 'RS', NULL, NULL, NULL, 4303558, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.814864', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4670, 'Cambara do Sul', 'RS', NULL, NULL, NULL, 4303608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.815791', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4671, 'Campestre da Serra', 'RS', NULL, NULL, NULL, 4303673, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.816669', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4672, 'Campina das Missoes', 'RS', NULL, NULL, NULL, 4303707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.817629', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4673, 'Campinas do Sul', 'RS', NULL, NULL, NULL, 4303806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.818566', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4674, 'Campo Bom', 'RS', NULL, NULL, NULL, 4303905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.819422', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4675, 'Campo Novo', 'RS', NULL, NULL, NULL, 4304002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.825975', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4676, 'Campos Borges', 'RS', NULL, NULL, NULL, 4304101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.827145', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4677, 'Candelaria', 'RS', NULL, NULL, NULL, 4304200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.828029', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4678, 'Candido Godoi', 'RS', NULL, NULL, NULL, 4304309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.828872', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4679, 'Candiota', 'RS', NULL, NULL, NULL, 4304358, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.829693', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4680, 'Canela', 'RS', NULL, NULL, NULL, 4304408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.830636', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4681, 'Cangucu', 'RS', NULL, NULL, NULL, 4304507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.831498', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4682, 'Canoas', 'RS', NULL, NULL, NULL, 4304606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.8323', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4683, 'Canudos do Vale', 'RS', NULL, NULL, NULL, 4304614, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.833266', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4684, 'Capao Bonito do Sul', 'RS', NULL, NULL, NULL, 4304622, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.834669', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4685, 'Capao da Canoa', 'RS', NULL, NULL, NULL, 4304630, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.835592', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4686, 'Capao do Cipo', 'RS', NULL, NULL, NULL, 4304655, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.836576', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4687, 'Capao do Leao', 'RS', NULL, NULL, NULL, 4304663, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.83748', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4690, 'Capivari do Sul', 'RS', NULL, NULL, NULL, 4304671, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.840285', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4688, 'Capela de Santana', 'RS', NULL, NULL, NULL, 4304689, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.838512', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4689, 'Capitao', 'RS', NULL, NULL, NULL, 4304697, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.839442', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4692, 'Carazinho', 'RS', NULL, NULL, NULL, 4304705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.842067', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4691, 'Caraa', 'RS', NULL, NULL, NULL, 4304713, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.841208', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4693, 'Carlos Barbosa', 'RS', NULL, NULL, NULL, 4304804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.842932', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4694, 'Carlos Gomes', 'RS', NULL, NULL, NULL, 4304853, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.843835', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4695, 'Casca', 'RS', NULL, NULL, NULL, 4304903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.844744', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4696, 'Caseiros', 'RS', NULL, NULL, NULL, 4304952, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.845669', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4697, 'Catuipe', 'RS', NULL, NULL, NULL, 4305009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.846536', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4698, 'Caxias do Sul', 'RS', NULL, NULL, NULL, 4305108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.847409', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4699, 'Centenario', 'RS', NULL, NULL, NULL, 4305116, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.848283', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4700, 'Cerrito', 'RS', NULL, NULL, NULL, 4305124, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.849096', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4701, 'Cerro Branco', 'RS', NULL, NULL, NULL, 4305132, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.849907', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4702, 'Cerro Grande', 'RS', NULL, NULL, NULL, 4305157, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.850689', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4703, 'Cerro Grande do Sul', 'RS', NULL, NULL, NULL, 4305173, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.851567', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4704, 'Cerro Largo', 'RS', NULL, NULL, NULL, 4305207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.852471', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4705, 'Chapada', 'RS', NULL, NULL, NULL, 4305306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.853292', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4706, 'Charqueadas', 'RS', NULL, NULL, NULL, 4305355, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.854176', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4707, 'Charrua', 'RS', NULL, NULL, NULL, 4305371, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.855027', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4708, 'Chiapeta', 'RS', NULL, NULL, NULL, 4305405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.85595', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4709, 'Chui', 'RS', NULL, NULL, NULL, 4305439, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.856725', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4710, 'Chuvisca', 'RS', NULL, NULL, NULL, 4305447, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.857603', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4711, 'Cidreira', 'RS', NULL, NULL, NULL, 4305454, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.85851', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4712, 'Ciriaco', 'RS', NULL, NULL, NULL, 4305504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.859474', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4713, 'Colinas', 'RS', NULL, NULL, NULL, 4305587, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.866184', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4714, 'Colorado', 'RS', NULL, NULL, NULL, 4305603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.86748', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4715, 'Condor', 'RS', NULL, NULL, NULL, 4305702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.868275', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4716, 'Constantina', 'RS', NULL, NULL, NULL, 4305801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.869145', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4717, 'Coqueiro Baixo', 'RS', NULL, NULL, NULL, 4305835, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.870084', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4718, 'Coqueiros do Sul', 'RS', NULL, NULL, NULL, 4305850, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.87097', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4719, 'Coronel Barros', 'RS', NULL, NULL, NULL, 4305871, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.871889', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4720, 'Coronel Bicaco', 'RS', NULL, NULL, NULL, 4305900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.872786', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4721, 'Coronel Pilar', 'RS', NULL, NULL, NULL, 4305934, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.873768', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4722, 'Cotipora', 'RS', NULL, NULL, NULL, 4305959, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.874553', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4723, 'Coxilha', 'RS', NULL, NULL, NULL, 4305975, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.875317', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4724, 'Crissiumal', 'RS', NULL, NULL, NULL, 4306007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.876204', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4725, 'Cristal', 'RS', NULL, NULL, NULL, 4306056, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.877062', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4726, 'Cristal do Sul', 'RS', NULL, NULL, NULL, 4306072, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.877944', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4727, 'Cruz Alta', 'RS', NULL, NULL, NULL, 4306106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.879136', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4728, 'Cruzaltense', 'RS', NULL, NULL, NULL, 4306130, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.88005', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4729, 'Cruzeiro do Sul', 'RS', NULL, NULL, NULL, 4306205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.880928', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4730, 'David Canabarro', 'RS', NULL, NULL, NULL, 4306304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.881777', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4731, 'Derrubadas', 'RS', NULL, NULL, NULL, 4306320, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.882651', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4732, 'Dezesseis de Novembro', 'RS', NULL, NULL, NULL, 4306353, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.883767', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4733, 'Dilermando de Aguiar', 'RS', NULL, NULL, NULL, 4306379, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.884831', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4734, 'Dois Irmaos', 'RS', NULL, NULL, NULL, 4306403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.885678', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4735, 'Dois Irmaos das Missoes', 'RS', NULL, NULL, NULL, 4306429, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.886822', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4736, 'Dois Lajeados', 'RS', NULL, NULL, NULL, 4306452, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.887804', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4737, 'Dom Feliciano', 'RS', NULL, NULL, NULL, 4306502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.889073', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4739, 'Dom Pedro de Alcantara', 'RS', NULL, NULL, NULL, 4306551, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.891631', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4738, 'Dom Pedrito', 'RS', NULL, NULL, NULL, 4306601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.890589', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4740, 'Dona Francisca', 'RS', NULL, NULL, NULL, 4306700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.892557', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4741, 'Doutor Mauricio Cardoso', 'RS', NULL, NULL, NULL, 4306734, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.893417', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4742, 'Doutor Ricardo', 'RS', NULL, NULL, NULL, 4306759, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.894387', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4743, 'Eldorado do Sul', 'RS', NULL, NULL, NULL, 4306767, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.895258', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4744, 'Encantado', 'RS', NULL, NULL, NULL, 4306809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.896204', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4745, 'Encruzilhada do Sul', 'RS', NULL, NULL, NULL, 4306908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.89707', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4746, 'Engenho Velho', 'RS', NULL, NULL, NULL, 4306924, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.898021', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4748, 'Entre-ijuis', 'RS', NULL, NULL, NULL, 4306932, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.899999', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4747, 'Entre Rios do Sul', 'RS', NULL, NULL, NULL, 4306957, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.899076', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4749, 'Erebango', 'RS', NULL, NULL, NULL, 4306973, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.906919', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4750, 'Erechim', 'RS', NULL, NULL, NULL, 4307005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.908132', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4751, 'Ernestina', 'RS', NULL, NULL, NULL, 4307054, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.909116', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4793, 'Herval', 'RS', NULL, NULL, NULL, 4307104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.952112', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4752, 'Erval Grande', 'RS', NULL, NULL, NULL, 4307203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.910038', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4753, 'Erval Seco', 'RS', NULL, NULL, NULL, 4307302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.910899', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4754, 'Esmeralda', 'RS', NULL, NULL, NULL, 4307401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.91172', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4755, 'Esperanca do Sul', 'RS', NULL, NULL, NULL, 4307450, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.912737', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4756, 'Espumoso', 'RS', NULL, NULL, NULL, 4307500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.913602', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4757, 'Estacao', 'RS', NULL, NULL, NULL, 4307559, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.914491', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4758, 'Estancia Velha', 'RS', NULL, NULL, NULL, 4307609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.915345', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4759, 'Esteio', 'RS', NULL, NULL, NULL, 4307708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.916206', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4760, 'Estrela', 'RS', NULL, NULL, NULL, 4307807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.917135', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4761, 'Estrela Velha', 'RS', NULL, NULL, NULL, 4307815, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.918019', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4762, 'Eugenio de Castro', 'RS', NULL, NULL, NULL, 4307831, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.918923', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4763, 'Fagundes Varela', 'RS', NULL, NULL, NULL, 4307864, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.919878', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4764, 'Farroupilha', 'RS', NULL, NULL, NULL, 4307906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.920693', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4765, 'Faxinal do Soturno', 'RS', NULL, NULL, NULL, 4308003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.92163', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4766, 'Faxinalzinho', 'RS', NULL, NULL, NULL, 4308052, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.922524', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4767, 'Fazenda Vilanova', 'RS', NULL, NULL, NULL, 4308078, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.923302', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4768, 'Feliz', 'RS', NULL, NULL, NULL, 4308102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.924228', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4769, 'Flores da Cunha', 'RS', NULL, NULL, NULL, 4308201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.925172', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4770, 'Floriano Peixoto', 'RS', NULL, NULL, NULL, 4308250, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.926129', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4771, 'Fontoura Xavier', 'RS', NULL, NULL, NULL, 4308300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.927051', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4772, 'Formigueiro', 'RS', NULL, NULL, NULL, 4308409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.928008', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4773, 'Forquetinha', 'RS', NULL, NULL, NULL, 4308433, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.928929', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4774, 'Fortaleza dos Valos', 'RS', NULL, NULL, NULL, 4308458, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.929825', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4775, 'Frederico Westphalen', 'RS', NULL, NULL, NULL, 4308508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.93063', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4776, 'Garibaldi', 'RS', NULL, NULL, NULL, 4308607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.931355', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4777, 'Garruchos', 'RS', NULL, NULL, NULL, 4308656, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.932182', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4778, 'Gaurama', 'RS', NULL, NULL, NULL, 4308706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.933069', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4779, 'General Camara', 'RS', NULL, NULL, NULL, 4308805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.934026', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4780, 'Gentil', 'RS', NULL, NULL, NULL, 4308854, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.934915', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4781, 'Getulio Vargas', 'RS', NULL, NULL, NULL, 4308904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.935839', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4782, 'Girua', 'RS', NULL, NULL, NULL, 4309001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.936719', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4783, 'Glorinha', 'RS', NULL, NULL, NULL, 4309050, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.937632', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4784, 'Gramado', 'RS', NULL, NULL, NULL, 4309100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.938533', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4785, 'Gramado dos Loureiros', 'RS', NULL, NULL, NULL, 4309126, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.939344', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4786, 'Gramado Xavier', 'RS', NULL, NULL, NULL, 4309159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.940203', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4787, 'Gravatai', 'RS', NULL, NULL, NULL, 4309209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.941029', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4788, 'Guabiju', 'RS', NULL, NULL, NULL, 4309258, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.947441', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4789, 'Guaiba', 'RS', NULL, NULL, NULL, 4309308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.9486', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4790, 'Guapore', 'RS', NULL, NULL, NULL, 4309407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.949507', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4791, 'Guarani das Missoes', 'RS', NULL, NULL, NULL, 4309506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.950373', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4792, 'Harmonia', 'RS', NULL, NULL, NULL, 4309555, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.951225', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4794, 'Herveiras', 'RS', NULL, NULL, NULL, 4309571, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.953031', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4795, 'Horizontina', 'RS', NULL, NULL, NULL, 4309605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.953898', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4796, 'Hulha Negra', 'RS', NULL, NULL, NULL, 4309654, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.954845', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4797, 'Humaita', 'RS', NULL, NULL, NULL, 4309704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.955805', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4798, 'Ibarama', 'RS', NULL, NULL, NULL, 4309753, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.95672', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4799, 'Ibiaca', 'RS', NULL, NULL, NULL, 4309803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.957546', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4800, 'Ibiraiaras', 'RS', NULL, NULL, NULL, 4309902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.958417', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4801, 'Ibirapuita', 'RS', NULL, NULL, NULL, 4309951, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.959294', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4802, 'Ibiruba', 'RS', NULL, NULL, NULL, 4310009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.96032', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4803, 'Igrejinha', 'RS', NULL, NULL, NULL, 4310108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.96119', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4804, 'Ijui', 'RS', NULL, NULL, NULL, 4310207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.96206', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4805, 'Ilopolis', 'RS', NULL, NULL, NULL, 4310306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.962987', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4806, 'Imbe', 'RS', NULL, NULL, NULL, 4310330, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.963785', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4807, 'Imigrante', 'RS', NULL, NULL, NULL, 4310363, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.965082', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4808, 'Independencia', 'RS', NULL, NULL, NULL, 4310405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.96594', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4809, 'Inhacora', 'RS', NULL, NULL, NULL, 4310413, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.966873', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4810, 'Ipe', 'RS', NULL, NULL, NULL, 4310439, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.967679', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4811, 'Ipiranga do Sul', 'RS', NULL, NULL, NULL, 4310462, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.968588', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4812, 'Irai', 'RS', NULL, NULL, NULL, 4310504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.969396', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4813, 'Itaara', 'RS', NULL, NULL, NULL, 4310538, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.970351', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4814, 'Itacurubi', 'RS', NULL, NULL, NULL, 4310553, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.971294', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4815, 'Itapuca', 'RS', NULL, NULL, NULL, 4310579, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.972165', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4816, 'Itaqui', 'RS', NULL, NULL, NULL, 4310603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.973061', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4817, 'Itati', 'RS', NULL, NULL, NULL, 4310652, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.974002', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4818, 'Itatiba do Sul', 'RS', NULL, NULL, NULL, 4310702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.974873', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4819, 'Ivora', 'RS', NULL, NULL, NULL, 4310751, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.975784', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4820, 'Ivoti', 'RS', NULL, NULL, NULL, 4310801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.976642', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4821, 'Jaboticaba', 'RS', NULL, NULL, NULL, 4310850, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.977503', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4822, 'Jacuizinho', 'RS', NULL, NULL, NULL, 4310876, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.978423', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4823, 'Jacutinga', 'RS', NULL, NULL, NULL, 4310900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.979538', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4824, 'Jaguarao', 'RS', NULL, NULL, NULL, 4311007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.980338', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4825, 'Jaguari', 'RS', NULL, NULL, NULL, 4311106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.981152', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4826, 'Jaquirana', 'RS', NULL, NULL, NULL, 4311122, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.987939', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4827, 'Jari', 'RS', NULL, NULL, NULL, 4311130, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.989393', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4828, 'Joia', 'RS', NULL, NULL, NULL, 4311155, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.990672', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4829, 'Julio de Castilhos', 'RS', NULL, NULL, NULL, 4311205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.991636', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4830, 'Lagoa Bonita do Sul', 'RS', NULL, NULL, NULL, 4311239, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.992696', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4833, 'Lagoao', 'RS', NULL, NULL, NULL, 4311254, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.995228', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4831, 'Lagoa dos Tres Cantos', 'RS', NULL, NULL, NULL, 4311270, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.993546', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4832, 'Lagoa Vermelha', 'RS', NULL, NULL, NULL, 4311304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.99444', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4834, 'Lajeado', 'RS', NULL, NULL, NULL, 4311403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.996115', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4835, 'Lajeado do Bugre', 'RS', NULL, NULL, NULL, 4311429, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.996989', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4836, 'Lavras do Sul', 'RS', NULL, NULL, NULL, 4311502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.998102', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4837, 'Liberato Salzano', 'RS', NULL, NULL, NULL, 4311601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.999038', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4838, 'Lindolfo Collor', 'RS', NULL, NULL, NULL, 4311627, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:38.999932', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4839, 'Linha Nova', 'RS', NULL, NULL, NULL, 4311643, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.00075', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4841, 'Machadinho', 'RS', NULL, NULL, NULL, 4311700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.002707', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4840, 'Macambara', 'RS', NULL, NULL, NULL, 4311718, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.001806', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4842, 'Mampituba', 'RS', NULL, NULL, NULL, 4311734, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.003651', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4843, 'Manoel Viana', 'RS', NULL, NULL, NULL, 4311759, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.004534', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4844, 'Maquine', 'RS', NULL, NULL, NULL, 4311775, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.005502', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4845, 'Marata', 'RS', NULL, NULL, NULL, 4311791, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.006454', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4846, 'Marau', 'RS', NULL, NULL, NULL, 4311809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.007402', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4847, 'Marcelino Ramos', 'RS', NULL, NULL, NULL, 4311908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.008247', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4848, 'Mariana Pimentel', 'RS', NULL, NULL, NULL, 4311981, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.009044', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4849, 'Mariano Moro', 'RS', NULL, NULL, NULL, 4312005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.009911', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4850, 'Marques de Souza', 'RS', NULL, NULL, NULL, 4312054, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.010831', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4851, 'Mata', 'RS', NULL, NULL, NULL, 4312104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.011716', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4852, 'Mato Castelhano', 'RS', NULL, NULL, NULL, 4312138, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.012915', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4853, 'Mato Leitao', 'RS', NULL, NULL, NULL, 4312153, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.013882', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4854, 'Mato Queimado', 'RS', NULL, NULL, NULL, 4312179, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.014734', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4855, 'Maximiliano de Almeida', 'RS', NULL, NULL, NULL, 4312203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.01553', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4856, 'Minas do Leao', 'RS', NULL, NULL, NULL, 4312252, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.016287', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4857, 'Miraguai', 'RS', NULL, NULL, NULL, 4312302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.017159', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4858, 'Montauri', 'RS', NULL, NULL, NULL, 4312351, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.018117', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4859, 'Monte Alegre dos Campos', 'RS', NULL, NULL, NULL, 4312377, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.018991', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4860, 'Monte Belo do Sul', 'RS', NULL, NULL, NULL, 4312385, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.019902', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4861, 'Montenegro', 'RS', NULL, NULL, NULL, 4312401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.020835', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4862, 'Mormaco', 'RS', NULL, NULL, NULL, 4312427, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.02173', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4863, 'Morrinhos do Sul', 'RS', NULL, NULL, NULL, 4312443, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.028527', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4864, 'Morro Redondo', 'RS', NULL, NULL, NULL, 4312450, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.02965', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4865, 'Morro Reuter', 'RS', NULL, NULL, NULL, 4312476, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.030692', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4866, 'Mostardas', 'RS', NULL, NULL, NULL, 4312500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.032073', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4867, 'Mucum', 'RS', NULL, NULL, NULL, 4312609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.033021', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4868, 'Muitos Capoes', 'RS', NULL, NULL, NULL, 4312617, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.033894', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4869, 'Muliterno', 'RS', NULL, NULL, NULL, 4312625, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.03487', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4870, 'Nao-me-toque', 'RS', NULL, NULL, NULL, 4312658, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.035708', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4871, 'Nicolau Vergueiro', 'RS', NULL, NULL, NULL, 4312674, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.036634', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4872, 'Nonoai', 'RS', NULL, NULL, NULL, 4312708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.037482', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4873, 'Nova Alvorada', 'RS', NULL, NULL, NULL, 4312757, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.038493', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4874, 'Nova Araca', 'RS', NULL, NULL, NULL, 4312807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.039364', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4875, 'Nova Bassano', 'RS', NULL, NULL, NULL, 4312906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.040191', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4876, 'Nova Boa Vista', 'RS', NULL, NULL, NULL, 4312955, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.041367', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4877, 'Nova Brescia', 'RS', NULL, NULL, NULL, 4313003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.042406', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4878, 'Nova Candelaria', 'RS', NULL, NULL, NULL, 4313011, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.043243', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4879, 'Nova Esperanca do Sul', 'RS', NULL, NULL, NULL, 4313037, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.044148', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4880, 'Nova Hartz', 'RS', NULL, NULL, NULL, 4313060, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.044942', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4881, 'Nova Padua', 'RS', NULL, NULL, NULL, 4313086, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.045858', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4882, 'Nova Palma', 'RS', NULL, NULL, NULL, 4313102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.04664', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4883, 'Nova Petropolis', 'RS', NULL, NULL, NULL, 4313201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.047523', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4884, 'Nova Prata', 'RS', NULL, NULL, NULL, 4313300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.04839', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4885, 'Nova Ramada', 'RS', NULL, NULL, NULL, 4313334, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.049254', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4886, 'Nova Roma do Sul', 'RS', NULL, NULL, NULL, 4313359, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.050199', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4887, 'Nova Santa Rita', 'RS', NULL, NULL, NULL, 4313375, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.051107', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4889, 'Novo Cabrais', 'RS', NULL, NULL, NULL, 4313391, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.052834', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4890, 'Novo Hamburgo', 'RS', NULL, NULL, NULL, 4313409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.053668', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4891, 'Novo Machado', 'RS', NULL, NULL, NULL, 4313425, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.054539', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4892, 'Novo Tiradentes', 'RS', NULL, NULL, NULL, 4313441, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.055463', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4893, 'Novo Xingu', 'RS', NULL, NULL, NULL, 4313466, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.056358', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4888, 'Novo Barreiro', 'RS', NULL, NULL, NULL, 4313490, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.052035', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4894, 'Osorio', 'RS', NULL, NULL, NULL, 4313508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.057633', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4895, 'Paim Filho', 'RS', NULL, NULL, NULL, 4313607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.058522', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4896, 'Palmares do Sul', 'RS', NULL, NULL, NULL, 4313656, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.0594', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4897, 'Palmeira das Missoes', 'RS', NULL, NULL, NULL, 4313706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.06019', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4898, 'Palmitinho', 'RS', NULL, NULL, NULL, 4313805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.061164', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4899, 'Panambi', 'RS', NULL, NULL, NULL, 4313904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.062045', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4900, 'Pantano Grande', 'RS', NULL, NULL, NULL, 4313953, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.062725', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4901, 'Parai', 'RS', NULL, NULL, NULL, 4314001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.069617', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4902, 'Paraiso do Sul', 'RS', NULL, NULL, NULL, 4314027, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.07061', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4903, 'Pareci Novo', 'RS', NULL, NULL, NULL, 4314035, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.07147', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4904, 'Parobe', 'RS', NULL, NULL, NULL, 4314050, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.072404', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4905, 'Passa Sete', 'RS', NULL, NULL, NULL, 4314068, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.073291', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4906, 'Passo do Sobrado', 'RS', NULL, NULL, NULL, 4314076, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.074185', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4907, 'Passo Fundo', 'RS', NULL, NULL, NULL, 4314100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.075119', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4908, 'Paulo Bento', 'RS', NULL, NULL, NULL, 4314134, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.076016', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4909, 'Paverama', 'RS', NULL, NULL, NULL, 4314159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.076943', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4910, 'Pedras Altas', 'RS', NULL, NULL, NULL, 4314175, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.077899', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4911, 'Pedro Osorio', 'RS', NULL, NULL, NULL, 4314209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.078764', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4912, 'Pejucara', 'RS', NULL, NULL, NULL, 4314308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.08024', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4913, 'Pelotas', 'RS', NULL, NULL, NULL, 4314407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.081029', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4914, 'Picada Cafe', 'RS', NULL, NULL, NULL, 4314423, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.082336', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4915, 'Pinhal', 'RS', NULL, NULL, NULL, 4314456, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.083171', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4916, 'Pinhal da Serra', 'RS', NULL, NULL, NULL, 4314464, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.083953', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4917, 'Pinhal Grande', 'RS', NULL, NULL, NULL, 4314472, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.084872', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4918, 'Pinheirinho do Vale', 'RS', NULL, NULL, NULL, 4314498, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.08576', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4919, 'Pinheiro Machado', 'RS', NULL, NULL, NULL, 4314506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.086681', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4920, 'Pirapo', 'RS', NULL, NULL, NULL, 4314555, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.087579', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4921, 'Piratini', 'RS', NULL, NULL, NULL, 4314605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.088495', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4922, 'Planalto', 'RS', NULL, NULL, NULL, 4314704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.089514', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4923, 'Poco das Antas', 'RS', NULL, NULL, NULL, 4314753, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.090675', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4924, 'Pontao', 'RS', NULL, NULL, NULL, 4314779, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.091762', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4925, 'Ponte Preta', 'RS', NULL, NULL, NULL, 4314787, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.092594', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4926, 'Portao', 'RS', NULL, NULL, NULL, 4314803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.093566', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4927, 'Porto Alegre', 'RS', NULL, NULL, NULL, 4314902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.094539', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4928, 'Porto Lucena', 'RS', NULL, NULL, NULL, 4315008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.095462', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4929, 'Porto Maua', 'RS', NULL, NULL, NULL, 4315057, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.09633', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4930, 'Porto Vera Cruz', 'RS', NULL, NULL, NULL, 4315073, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.097306', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4931, 'Porto Xavier', 'RS', NULL, NULL, NULL, 4315107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.098217', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4932, 'Pouso Novo', 'RS', NULL, NULL, NULL, 4315131, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.099245', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4933, 'Presidente Lucena', 'RS', NULL, NULL, NULL, 4315149, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.10017', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4934, 'Progresso', 'RS', NULL, NULL, NULL, 4315156, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.101105', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4935, 'Protasio Alves', 'RS', NULL, NULL, NULL, 4315172, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.102143', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4936, 'Putinga', 'RS', NULL, NULL, NULL, 4315206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.103128', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4937, 'Quarai', 'RS', NULL, NULL, NULL, 4315305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.10406', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4938, 'Quatro Irmaos', 'RS', NULL, NULL, NULL, 4315313, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.110644', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4939, 'Quevedos', 'RS', NULL, NULL, NULL, 4315321, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.111825', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4940, 'Quinze de Novembro', 'RS', NULL, NULL, NULL, 4315354, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.112857', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4941, 'Redentora', 'RS', NULL, NULL, NULL, 4315404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.113697', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4942, 'Relvado', 'RS', NULL, NULL, NULL, 4315453, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.114655', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4943, 'Restinga Seca', 'RS', NULL, NULL, NULL, 4315503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.115499', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4944, 'Rio dos Indios', 'RS', NULL, NULL, NULL, 4315552, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.116294', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4945, 'Rio Grande', 'RS', NULL, NULL, NULL, 4315602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.117266', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4946, 'Rio Pardo', 'RS', NULL, NULL, NULL, 4315701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.118179', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4947, 'Riozinho', 'RS', NULL, NULL, NULL, 4315750, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.119135', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4948, 'Roca Sales', 'RS', NULL, NULL, NULL, 4315800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.119995', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4949, 'Rodeio Bonito', 'RS', NULL, NULL, NULL, 4315909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.120924', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4950, 'Rolador', 'RS', NULL, NULL, NULL, 4315958, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.121849', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4951, 'Rolante', 'RS', NULL, NULL, NULL, 4316006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.122777', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4952, 'Ronda Alta', 'RS', NULL, NULL, NULL, 4316105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.123656', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4953, 'Rondinha', 'RS', NULL, NULL, NULL, 4316204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.124514', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4954, 'Roque Gonzales', 'RS', NULL, NULL, NULL, 4316303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.125383', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4955, 'Rosario do Sul', 'RS', NULL, NULL, NULL, 4316402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.126163', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4956, 'Sagrada Familia', 'RS', NULL, NULL, NULL, 4316428, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.127151', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4957, 'Saldanha Marinho', 'RS', NULL, NULL, NULL, 4316436, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.128127', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4958, 'Salto do Jacui', 'RS', NULL, NULL, NULL, 4316451, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.129107', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4959, 'Salvador das Missoes', 'RS', NULL, NULL, NULL, 4316477, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.13005', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4960, 'Salvador do Sul', 'RS', NULL, NULL, NULL, 4316501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.130968', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4961, 'Sananduva', 'RS', NULL, NULL, NULL, 4316600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.131942', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4962, 'Santa Barbara do Sul', 'RS', NULL, NULL, NULL, 4316709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.132733', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4963, 'Santa Cecilia do Sul', 'RS', NULL, NULL, NULL, 4316733, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.133677', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4964, 'Santa Clara do Sul', 'RS', NULL, NULL, NULL, 4316758, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.134621', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4965, 'Santa Cruz do Sul', 'RS', NULL, NULL, NULL, 4316808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.135859', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4967, 'Santa Maria', 'RS', NULL, NULL, NULL, 4316907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.137745', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4968, 'Santa Maria do Herval', 'RS', NULL, NULL, NULL, 4316956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.138656', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4966, 'Santa Margarida do Sul', 'RS', NULL, NULL, NULL, 4316972, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.136798', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4972, 'Santana da Boa Vista', 'RS', NULL, NULL, NULL, 4317004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.142334', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4973, 'Santana do Livramento', 'RS', NULL, NULL, NULL, 4317103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.143302', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4969, 'Santa Rosa', 'RS', NULL, NULL, NULL, 4317202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.139651', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4970, 'Santa Tereza', 'RS', NULL, NULL, NULL, 4317251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.140575', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4971, 'Santa Vitoria do Palmar', 'RS', NULL, NULL, NULL, 4317301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.141428', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4974, 'Santiago', 'RS', NULL, NULL, NULL, 4317400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.144184', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4975, 'Santo Angelo', 'RS', NULL, NULL, NULL, 4317509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.150861', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4978, 'Santo Antonio do Palma', 'RS', NULL, NULL, NULL, 4317558, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.153811', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4976, 'Santo Antonio da Patrulha', 'RS', NULL, NULL, NULL, 4317608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.151967', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4977, 'Santo Antonio das Missoes', 'RS', NULL, NULL, NULL, 4317707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.152911', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4979, 'Santo Antonio do Planalto', 'RS', NULL, NULL, NULL, 4317756, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.154666', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4980, 'Santo Augusto', 'RS', NULL, NULL, NULL, 4317806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.155574', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4981, 'Santo Cristo', 'RS', NULL, NULL, NULL, 4317905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.156456', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4982, 'Santo Expedito do Sul', 'RS', NULL, NULL, NULL, 4317954, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.157362', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4983, 'Sao Borja', 'RS', NULL, NULL, NULL, 4318002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.158226', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4984, 'Sao Domingos do Sul', 'RS', NULL, NULL, NULL, 4318051, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.159172', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4985, 'Sao Francisco de Assis', 'RS', NULL, NULL, NULL, 4318101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.160002', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4986, 'Sao Francisco de Paula', 'RS', NULL, NULL, NULL, 4318200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.160916', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4987, 'Sao Gabriel', 'RS', NULL, NULL, NULL, 4318309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.161758', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4988, 'Sao Jeronimo', 'RS', NULL, NULL, NULL, 4318408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.162555', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4989, 'Sao Joao da Urtiga', 'RS', NULL, NULL, NULL, 4318424, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.163489', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4990, 'Sao Joao do Polesine', 'RS', NULL, NULL, NULL, 4318432, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.164452', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4991, 'Sao Jorge', 'RS', NULL, NULL, NULL, 4318440, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.165471', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4992, 'Sao Jose das Missoes', 'RS', NULL, NULL, NULL, 4318457, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.166514', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4993, 'Sao Jose do Herval', 'RS', NULL, NULL, NULL, 4318465, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.167402', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4994, 'Sao Jose do Hortencio', 'RS', NULL, NULL, NULL, 4318481, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.168302', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4995, 'Sao Jose do Inhacora', 'RS', NULL, NULL, NULL, 4318499, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.169448', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4996, 'Sao Jose do Norte', 'RS', NULL, NULL, NULL, 4318507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.170483', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4997, 'Sao Jose do Ouro', 'RS', NULL, NULL, NULL, 4318606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.171355', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4998, 'Sao Jose do Sul', 'RS', NULL, NULL, NULL, 4318614, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.172279', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (4999, 'Sao Jose dos Ausentes', 'RS', NULL, NULL, NULL, 4318622, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.173227', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5000, 'Sao Leopoldo', 'RS', NULL, NULL, NULL, 4318705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.174112', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5001, 'Sao Lourenco do Sul', 'RS', NULL, NULL, NULL, 4318804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.175066', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5002, 'Sao Luiz Gonzaga', 'RS', NULL, NULL, NULL, 4318903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.176058', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5003, 'Sao Marcos', 'RS', NULL, NULL, NULL, 4319000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.176959', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5004, 'Sao Martinho', 'RS', NULL, NULL, NULL, 4319109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.177897', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5005, 'Sao Martinho da Serra', 'RS', NULL, NULL, NULL, 4319125, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.178867', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5006, 'Sao Miguel das Missoes', 'RS', NULL, NULL, NULL, 4319158, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.17986', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5007, 'Sao Nicolau', 'RS', NULL, NULL, NULL, 4319208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.180803', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5008, 'Sao Paulo das Missoes', 'RS', NULL, NULL, NULL, 4319307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.181651', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5009, 'Sao Pedro da Serra', 'RS', NULL, NULL, NULL, 4319356, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.18264', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5010, 'Sao Pedro das Missoes', 'RS', NULL, NULL, NULL, 4319364, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.183578', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5011, 'Sao Pedro do Butia', 'RS', NULL, NULL, NULL, 4319372, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.184568', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5012, 'Sao Pedro do Sul', 'RS', NULL, NULL, NULL, 4319406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.191638', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5013, 'Sao Sebastiao do Cai', 'RS', NULL, NULL, NULL, 4319505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.192927', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5014, 'Sao Sepe', 'RS', NULL, NULL, NULL, 4319604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.193953', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5015, 'Sao Valentim', 'RS', NULL, NULL, NULL, 4319703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.194793', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5016, 'Sao Valentim do Sul', 'RS', NULL, NULL, NULL, 4319711, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.195665', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5017, 'Sao Valerio do Sul', 'RS', NULL, NULL, NULL, 4319737, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.196491', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5018, 'Sao Vendelino', 'RS', NULL, NULL, NULL, 4319752, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.197532', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5019, 'Sao Vicente do Sul', 'RS', NULL, NULL, NULL, 4319802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.198462', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5020, 'Sapiranga', 'RS', NULL, NULL, NULL, 4319901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.199365', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5021, 'Sapucaia do Sul', 'RS', NULL, NULL, NULL, 4320008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.200245', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5022, 'Sarandi', 'RS', NULL, NULL, NULL, 4320107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.201335', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5023, 'Seberi', 'RS', NULL, NULL, NULL, 4320206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.202194', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5024, 'Sede Nova', 'RS', NULL, NULL, NULL, 4320230, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.203247', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5025, 'Segredo', 'RS', NULL, NULL, NULL, 4320263, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.204153', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5026, 'Selbach', 'RS', NULL, NULL, NULL, 4320305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.205013', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5027, 'Senador Salgado Filho', 'RS', NULL, NULL, NULL, 4320321, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.205893', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5028, 'Sentinela do Sul', 'RS', NULL, NULL, NULL, 4320354, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.206792', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5029, 'Serafina Correa', 'RS', NULL, NULL, NULL, 4320404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.207836', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5030, 'Serio', 'RS', NULL, NULL, NULL, 4320453, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.208802', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5031, 'Sertao', 'RS', NULL, NULL, NULL, 4320503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.209619', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5032, 'Sertao Santana', 'RS', NULL, NULL, NULL, 4320552, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.210595', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5033, 'Sete de Setembro', 'RS', NULL, NULL, NULL, 4320578, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.211625', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5034, 'Severiano de Almeida', 'RS', NULL, NULL, NULL, 4320602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.21262', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5035, 'Silveira Martins', 'RS', NULL, NULL, NULL, 4320651, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.213555', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5036, 'Sinimbu', 'RS', NULL, NULL, NULL, 4320677, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.21458', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5037, 'Sobradinho', 'RS', NULL, NULL, NULL, 4320701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.215477', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5038, 'Soledade', 'RS', NULL, NULL, NULL, 4320800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.216332', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5039, 'Tabai', 'RS', NULL, NULL, NULL, 4320859, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.21724', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5040, 'Tapejara', 'RS', NULL, NULL, NULL, 4320909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.218094', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5041, 'Tapera', 'RS', NULL, NULL, NULL, 4321006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.219034', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5042, 'Tapes', 'RS', NULL, NULL, NULL, 4321105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.219964', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5043, 'Taquara', 'RS', NULL, NULL, NULL, 4321204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.220879', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5044, 'Taquari', 'RS', NULL, NULL, NULL, 4321303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.221862', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5045, 'Taquarucu do Sul', 'RS', NULL, NULL, NULL, 4321329, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.222788', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5046, 'Tavares', 'RS', NULL, NULL, NULL, 4321352, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.223707', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5047, 'Tenente Portela', 'RS', NULL, NULL, NULL, 4321402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.225347', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5048, 'Terra de Areia', 'RS', NULL, NULL, NULL, 4321436, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.232849', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5049, 'Teutonia', 'RS', NULL, NULL, NULL, 4321451, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.234121', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5050, 'Tio Hugo', 'RS', NULL, NULL, NULL, 4321469, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.235123', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5051, 'Tiradentes do Sul', 'RS', NULL, NULL, NULL, 4321477, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.23607', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5052, 'Toropi', 'RS', NULL, NULL, NULL, 4321493, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.236996', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5053, 'Torres', 'RS', NULL, NULL, NULL, 4321501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.237913', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5054, 'Tramandai', 'RS', NULL, NULL, NULL, 4321600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.23885', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5055, 'Travesseiro', 'RS', NULL, NULL, NULL, 4321626, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.239806', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5056, 'Tres Arroios', 'RS', NULL, NULL, NULL, 4321634, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.240805', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5057, 'Tres Cachoeiras', 'RS', NULL, NULL, NULL, 4321667, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.241777', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5058, 'Tres Coroas', 'RS', NULL, NULL, NULL, 4321709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.242724', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5059, 'Tres de Maio', 'RS', NULL, NULL, NULL, 4321808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.243769', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5060, 'Tres Forquilhas', 'RS', NULL, NULL, NULL, 4321832, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.244655', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5061, 'Tres Palmeiras', 'RS', NULL, NULL, NULL, 4321857, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.245532', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5062, 'Tres Passos', 'RS', NULL, NULL, NULL, 4321907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.246606', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5063, 'Trindade do Sul', 'RS', NULL, NULL, NULL, 4321956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.247562', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5064, 'Triunfo', 'RS', NULL, NULL, NULL, 4322004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.248414', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5065, 'Tucunduva', 'RS', NULL, NULL, NULL, 4322103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.249233', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5066, 'Tunas', 'RS', NULL, NULL, NULL, 4322152, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.250107', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5067, 'Tupanci do Sul', 'RS', NULL, NULL, NULL, 4322186, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.250953', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5068, 'Tupancireta', 'RS', NULL, NULL, NULL, 4322202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.251821', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5069, 'Tupandi', 'RS', NULL, NULL, NULL, 4322251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.252708', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5070, 'Tuparendi', 'RS', NULL, NULL, NULL, 4322301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.253578', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5071, 'Turucu', 'RS', NULL, NULL, NULL, 4322327, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.254432', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5072, 'Ubiretama', 'RS', NULL, NULL, NULL, 4322343, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.255333', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5073, 'Uniao da Serra', 'RS', NULL, NULL, NULL, 4322350, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.256245', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5074, 'Unistalda', 'RS', NULL, NULL, NULL, 4322376, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.257204', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5075, 'Uruguaiana', 'RS', NULL, NULL, NULL, 4322400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.258629', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5076, 'Vacaria', 'RS', NULL, NULL, NULL, 4322509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.259601', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5079, 'Vale Verde', 'RS', NULL, NULL, NULL, 4322525, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.262431', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5077, 'Vale do Sol', 'RS', NULL, NULL, NULL, 4322533, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.260531', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5078, 'Vale Real', 'RS', NULL, NULL, NULL, 4322541, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.261524', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5080, 'Vanini', 'RS', NULL, NULL, NULL, 4322558, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.263447', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5081, 'Venancio Aires', 'RS', NULL, NULL, NULL, 4322608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.264406', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5082, 'Vera Cruz', 'RS', NULL, NULL, NULL, 4322707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.265345', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5083, 'Veranopolis', 'RS', NULL, NULL, NULL, 4322806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.26647', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5084, 'Vespasiano Correa', 'RS', NULL, NULL, NULL, 4322855, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.273349', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5085, 'Viadutos', 'RS', NULL, NULL, NULL, 4322905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.274527', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5086, 'Viamao', 'RS', NULL, NULL, NULL, 4323002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.275464', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5087, 'Vicente Dutra', 'RS', NULL, NULL, NULL, 4323101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.276287', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5088, 'Victor Graeff', 'RS', NULL, NULL, NULL, 4323200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.27728', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5089, 'Vila Flores', 'RS', NULL, NULL, NULL, 4323309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.278305', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5090, 'Vila Langaro', 'RS', NULL, NULL, NULL, 4323358, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.279156', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5091, 'Vila Maria', 'RS', NULL, NULL, NULL, 4323408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.280109', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5092, 'Vila Nova do Sul', 'RS', NULL, NULL, NULL, 4323457, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.281043', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5093, 'Vista Alegre', 'RS', NULL, NULL, NULL, 4323507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.281928', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5094, 'Vista Alegre do Prata', 'RS', NULL, NULL, NULL, 4323606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.282888', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5095, 'Vista Gaucha', 'RS', NULL, NULL, NULL, 4323705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.283856', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5096, 'Vitoria das Missoes', 'RS', NULL, NULL, NULL, 4323754, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.284731', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5097, 'Westfalia', 'RS', NULL, NULL, NULL, 4323770, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.285646', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5098, 'Xangri-la', 'RS', NULL, NULL, NULL, 4323804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.286521', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5099, 'Agua Clara', 'MS', NULL, NULL, NULL, 5000203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.287518', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5100, 'Alcinopolis', 'MS', NULL, NULL, NULL, 5000252, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.288446', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5101, 'Amambai', 'MS', NULL, NULL, NULL, 5000609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.289301', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5102, 'Anastacio', 'MS', NULL, NULL, NULL, 5000708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.290239', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5103, 'Anaurilandia', 'MS', NULL, NULL, NULL, 5000807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.291232', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5104, 'Angelica', 'MS', NULL, NULL, NULL, 5000856, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.292032', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5105, 'Antonio Joao', 'MS', NULL, NULL, NULL, 5000906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.293133', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5106, 'Aparecida do Taboado', 'MS', NULL, NULL, NULL, 5001003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.294053', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5107, 'Aquidauana', 'MS', NULL, NULL, NULL, 5001102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.294884', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5108, 'Aral Moreira', 'MS', NULL, NULL, NULL, 5001243, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.29572', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5109, 'Bandeirantes', 'MS', NULL, NULL, NULL, 5001508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.296713', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5110, 'Bataguassu', 'MS', NULL, NULL, NULL, 5001904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.29763', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5112, 'Bela Vista', 'MS', NULL, NULL, NULL, 5002100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.299542', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5113, 'Bodoquena', 'MS', NULL, NULL, NULL, 5002159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.300463', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5114, 'Bonito', 'MS', NULL, NULL, NULL, 5002209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.301372', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5115, 'Brasilandia', 'MS', NULL, NULL, NULL, 5002308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.302327', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5116, 'Caarapo', 'MS', NULL, NULL, NULL, 5002407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.303136', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5117, 'Camapua', 'MS', NULL, NULL, NULL, 5002605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.304018', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5118, 'Campo Grande', 'MS', NULL, NULL, NULL, 5002704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.30485', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5119, 'Caracol', 'MS', NULL, NULL, NULL, 5002803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.305697', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5120, 'Cassilandia', 'MS', NULL, NULL, NULL, 5002902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.306539', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5121, 'Chapadao do Sul', 'MS', NULL, NULL, NULL, 5002951, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.313766', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5122, 'Corguinho', 'MS', NULL, NULL, NULL, 5003108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.314832', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5123, 'Coronel Sapucaia', 'MS', NULL, NULL, NULL, 5003157, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.315886', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5124, 'Corumba', 'MS', NULL, NULL, NULL, 5003207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.316677', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5125, 'Costa Rica', 'MS', NULL, NULL, NULL, 5003256, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.317565', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5126, 'Coxim', 'MS', NULL, NULL, NULL, 5003306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.318438', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5127, 'Deodapolis', 'MS', NULL, NULL, NULL, 5003454, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.319156', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5128, 'Dois Irmaos do Buriti', 'MS', NULL, NULL, NULL, 5003488, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.320079', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5129, 'Douradina', 'MS', NULL, NULL, NULL, 5003504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.320958', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5130, 'Dourados', 'MS', NULL, NULL, NULL, 5003702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.321841', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5131, 'Eldorado', 'MS', NULL, NULL, NULL, 5003751, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.322753', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5132, 'Fatima do Sul', 'MS', NULL, NULL, NULL, 5003801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.323883', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5133, 'Figueirao', 'MS', NULL, NULL, NULL, 5003900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.324801', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5134, 'Gloria de Dourados', 'MS', NULL, NULL, NULL, 5004007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.325637', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5135, 'Guia Lopes da Laguna', 'MS', NULL, NULL, NULL, 5004106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.326641', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5136, 'Iguatemi', 'MS', NULL, NULL, NULL, 5004304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.327619', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5137, 'Inocencia', 'MS', NULL, NULL, NULL, 5004403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.328612', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5138, 'Itapora', 'MS', NULL, NULL, NULL, 5004502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.329508', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5139, 'Itaquirai', 'MS', NULL, NULL, NULL, 5004601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.33029', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5140, 'Ivinhema', 'MS', NULL, NULL, NULL, 5004700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.331111', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5141, 'Japora', 'MS', NULL, NULL, NULL, 5004809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.332023', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5142, 'Jaraguari', 'MS', NULL, NULL, NULL, 5004908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.332947', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5143, 'Jardim', 'MS', NULL, NULL, NULL, 5005004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.333891', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5144, 'Jatei', 'MS', NULL, NULL, NULL, 5005103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.334815', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5145, 'Juti', 'MS', NULL, NULL, NULL, 5005152, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.335804', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5146, 'Ladario', 'MS', NULL, NULL, NULL, 5005202, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.336612', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5147, 'Laguna Carapa', 'MS', NULL, NULL, NULL, 5005251, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.337536', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5148, 'Maracaju', 'MS', NULL, NULL, NULL, 5005400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.338444', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5149, 'Miranda', 'MS', NULL, NULL, NULL, 5005608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.33931', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5150, 'Mundo Novo', 'MS', NULL, NULL, NULL, 5005681, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.340178', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5151, 'Navirai', 'MS', NULL, NULL, NULL, 5005707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.341075', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5152, 'Nioaque', 'MS', NULL, NULL, NULL, 5005806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.341888', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5153, 'Nova Alvorada do Sul', 'MS', NULL, NULL, NULL, 5006002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.342697', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5154, 'Nova Andradina', 'MS', NULL, NULL, NULL, 5006200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.343615', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5155, 'Novo Horizonte do Sul', 'MS', NULL, NULL, NULL, 5006259, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.344527', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5156, 'Paranaiba', 'MS', NULL, NULL, NULL, 5006309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.345447', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5157, 'Paranhos', 'MS', NULL, NULL, NULL, 5006358, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.346394', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5158, 'Pedro Gomes', 'MS', NULL, NULL, NULL, 5006408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.347493', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5159, 'Ponta Pora', 'MS', NULL, NULL, NULL, 5006606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.35418', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5160, 'Porto Murtinho', 'MS', NULL, NULL, NULL, 5006903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.355395', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5161, 'Ribas do Rio Pardo', 'MS', NULL, NULL, NULL, 5007109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.356263', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5162, 'Rio Brilhante', 'MS', NULL, NULL, NULL, 5007208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.357159', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5163, 'Rio Negro', 'MS', NULL, NULL, NULL, 5007307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.358428', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5164, 'Rio Verde de Mato Grosso', 'MS', NULL, NULL, NULL, 5007406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.359236', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5165, 'Rochedo', 'MS', NULL, NULL, NULL, 5007505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.360185', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5166, 'Santa Rita do Pardo', 'MS', NULL, NULL, NULL, 5007554, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.360982', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5167, 'Sao Gabriel do Oeste', 'MS', NULL, NULL, NULL, 5007695, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.362003', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5169, 'Sete Quedas', 'MS', NULL, NULL, NULL, 5007703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.363971', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5168, 'Selviria', 'MS', NULL, NULL, NULL, 5007802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.362991', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5170, 'Sidrolandia', 'MS', NULL, NULL, NULL, 5007901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.364965', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5171, 'Sonora', 'MS', NULL, NULL, NULL, 5007935, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.366069', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5172, 'Tacuru', 'MS', NULL, NULL, NULL, 5007950, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.366911', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5173, 'Taquarussu', 'MS', NULL, NULL, NULL, 5007976, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.368294', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5174, 'Terenos', 'MS', NULL, NULL, NULL, 5008008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.369444', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5175, 'Tres Lagoas', 'MS', NULL, NULL, NULL, 5008305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.370315', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5176, 'Vicentina', 'MS', NULL, NULL, NULL, 5008404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.371201', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5177, 'Acorizal', 'MT', NULL, NULL, NULL, 5100102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.372079', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5178, 'Agua Boa', 'MT', NULL, NULL, NULL, 5100201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.372947', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5179, 'Alta Floresta', 'MT', NULL, NULL, NULL, 5100250, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.373825', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5180, 'Alto Araguaia', 'MT', NULL, NULL, NULL, 5100300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.374753', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5181, 'Alto Boa Vista', 'MT', NULL, NULL, NULL, 5100359, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.375625', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5182, 'Alto Garcas', 'MT', NULL, NULL, NULL, 5100409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.376478', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5183, 'Alto Paraguai', 'MT', NULL, NULL, NULL, 5100508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.37727', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5184, 'Alto Taquari', 'MT', NULL, NULL, NULL, 5100607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.378248', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5185, 'Apiacas', 'MT', NULL, NULL, NULL, 5100805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.379176', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5186, 'Araguaiana', 'MT', NULL, NULL, NULL, 5101001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.380109', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5187, 'Araguainha', 'MT', NULL, NULL, NULL, 5101209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.381101', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5188, 'Araputanga', 'MT', NULL, NULL, NULL, 5101258, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.382033', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5189, 'Arenapolis', 'MT', NULL, NULL, NULL, 5101308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.383142', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5190, 'Aripuana', 'MT', NULL, NULL, NULL, 5101407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.383975', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5191, 'Barao de Melgaco', 'MT', NULL, NULL, NULL, 5101605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.384902', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5192, 'Barra do Bugres', 'MT', NULL, NULL, NULL, 5101704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.385821', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5193, 'Barra do Garcas', 'MT', NULL, NULL, NULL, 5101803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.386784', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5194, 'Bom Jesus do Araguaia', 'MT', NULL, NULL, NULL, 5101852, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.387912', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5195, 'Brasnorte', 'MT', NULL, NULL, NULL, 5101902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.395783', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5196, 'Caceres', 'MT', NULL, NULL, NULL, 5102504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.396886', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5197, 'Campinapolis', 'MT', NULL, NULL, NULL, 5102603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.397801', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5198, 'Campo Novo do Parecis', 'MT', NULL, NULL, NULL, 5102637, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.398624', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5199, 'Campo Verde', 'MT', NULL, NULL, NULL, 5102678, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.399594', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5200, 'Campos de Julio', 'MT', NULL, NULL, NULL, 5102686, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.400449', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5201, 'Canabrava do Norte', 'MT', NULL, NULL, NULL, 5102694, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.401301', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5202, 'Canarana', 'MT', NULL, NULL, NULL, 5102702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.402031', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5203, 'Carlinda', 'MT', NULL, NULL, NULL, 5102793, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.403458', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5204, 'Castanheira', 'MT', NULL, NULL, NULL, 5102850, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.404495', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5205, 'Chapada dos Guimaraes', 'MT', NULL, NULL, NULL, 5103007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.405573', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5206, 'Claudia', 'MT', NULL, NULL, NULL, 5103056, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.406653', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5207, 'Cocalinho', 'MT', NULL, NULL, NULL, 5103106, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.407608', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5208, 'Colider', 'MT', NULL, NULL, NULL, 5103205, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.408507', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5209, 'Colniza', 'MT', NULL, NULL, NULL, 5103254, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.409412', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5210, 'Comodoro', 'MT', NULL, NULL, NULL, 5103304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.410397', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5211, 'Confresa', 'MT', NULL, NULL, NULL, 5103353, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.411332', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5212, 'Conquista D''oeste', 'MT', NULL, NULL, NULL, 5103361, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.412235', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5213, 'Cotriguacu', 'MT', NULL, NULL, NULL, 5103379, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.413221', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5214, 'Cuiaba', 'MT', NULL, NULL, NULL, 5103403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.414149', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5216, 'Denise', 'MT', NULL, NULL, NULL, 5103452, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.416081', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5217, 'Diamantino', 'MT', NULL, NULL, NULL, 5103502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.417014', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5218, 'Dom Aquino', 'MT', NULL, NULL, NULL, 5103601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.417947', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5219, 'Feliz Natal', 'MT', NULL, NULL, NULL, 5103700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.418926', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5220, 'Figueiropolis D''oeste', 'MT', NULL, NULL, NULL, 5103809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.419849', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5221, 'Gaucha do Norte', 'MT', NULL, NULL, NULL, 5103858, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.4207', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5222, 'General Carneiro', 'MT', NULL, NULL, NULL, 5103908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.421639', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5223, 'Gloria D''oeste', 'MT', NULL, NULL, NULL, 5103957, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.422532', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5224, 'Guaranta do Norte', 'MT', NULL, NULL, NULL, 5104104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.423784', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5225, 'Guiratinga', 'MT', NULL, NULL, NULL, 5104203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.424887', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5226, 'Indiavai', 'MT', NULL, NULL, NULL, 5104500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.425733', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5227, 'Ipiranga do Norte', 'MT', NULL, NULL, NULL, 5104526, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.426779', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5228, 'Itanhanga', 'MT', NULL, NULL, NULL, 5104542, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.427777', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5229, 'Itauba', 'MT', NULL, NULL, NULL, 5104559, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.42877', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5230, 'Itiquira', 'MT', NULL, NULL, NULL, 5104609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.429726', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5231, 'Jaciara', 'MT', NULL, NULL, NULL, 5104807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.436354', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5232, 'Jangada', 'MT', NULL, NULL, NULL, 5104906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.437631', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5233, 'Jauru', 'MT', NULL, NULL, NULL, 5105002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.438623', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5234, 'Juara', 'MT', NULL, NULL, NULL, 5105101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.439558', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5235, 'Juina', 'MT', NULL, NULL, NULL, 5105150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.440473', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5236, 'Juruena', 'MT', NULL, NULL, NULL, 5105176, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.441383', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5237, 'Juscimeira', 'MT', NULL, NULL, NULL, 5105200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.442317', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5238, 'Lambari D''oeste', 'MT', NULL, NULL, NULL, 5105234, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.443327', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5239, 'Lucas do Rio Verde', 'MT', NULL, NULL, NULL, 5105259, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.444223', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5240, 'Luciara', 'MT', NULL, NULL, NULL, 5105309, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.445157', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5316, 'Vila Bela da Santissima Trindade', 'MT', NULL, NULL, NULL, 5105507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.528916', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5241, 'Marcelandia', 'MT', NULL, NULL, NULL, 5105580, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.446077', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5242, 'Matupa', 'MT', NULL, NULL, NULL, 5105606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.447134', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5243, 'Mirassol D''oeste', 'MT', NULL, NULL, NULL, 5105622, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.448029', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5244, 'Nobres', 'MT', NULL, NULL, NULL, 5105903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.448969', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5245, 'Nortelandia', 'MT', NULL, NULL, NULL, 5106000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.449889', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5246, 'Nossa Senhora do Livramento', 'MT', NULL, NULL, NULL, 5106109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.450756', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5247, 'Nova Bandeirantes', 'MT', NULL, NULL, NULL, 5106158, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.451561', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5256, 'Nova Nazare', 'MT', NULL, NULL, NULL, 5106174, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.459757', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5251, 'Nova Lacerda', 'MT', NULL, NULL, NULL, 5106182, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.455047', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5258, 'Nova Santa Helena', 'MT', NULL, NULL, NULL, 5106190, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.461782', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5248, 'Nova Brasilandia', 'MT', NULL, NULL, NULL, 5106208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.452363', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5249, 'Nova Canaa do Norte', 'MT', NULL, NULL, NULL, 5106216, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.453308', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5255, 'Nova Mutum', 'MT', NULL, NULL, NULL, 5106224, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.458788', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5257, 'Nova Olimpia', 'MT', NULL, NULL, NULL, 5106232, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.460794', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5259, 'Nova Ubirata', 'MT', NULL, NULL, NULL, 5106240, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.462711', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5260, 'Nova Xavantina', 'MT', NULL, NULL, NULL, 5106257, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.463694', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5262, 'Novo Mundo', 'MT', NULL, NULL, NULL, 5106265, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.465458', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5261, 'Novo Horizonte do Norte', 'MT', NULL, NULL, NULL, 5106273, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.464598', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5264, 'Novo Sao Joaquim', 'MT', NULL, NULL, NULL, 5106281, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.467249', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5265, 'Paranaita', 'MT', NULL, NULL, NULL, 5106299, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.468084', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5266, 'Paranatinga', 'MT', NULL, NULL, NULL, 5106307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.469197', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5263, 'Novo Santo Antonio', 'MT', NULL, NULL, NULL, 5106315, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.466329', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5267, 'Pedra Preta', 'MT', NULL, NULL, NULL, 5106372, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.470265', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5268, 'Peixoto de Azevedo', 'MT', NULL, NULL, NULL, 5106422, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.471267', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5269, 'Planalto da Serra', 'MT', NULL, NULL, NULL, 5106455, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.477744', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5270, 'Pocone', 'MT', NULL, NULL, NULL, 5106505, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.478832', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5271, 'Pontal do Araguaia', 'MT', NULL, NULL, NULL, 5106653, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.479747', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5272, 'Ponte Branca', 'MT', NULL, NULL, NULL, 5106703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.480811', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5273, 'Pontes e Lacerda', 'MT', NULL, NULL, NULL, 5106752, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.481784', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5274, 'Porto Alegre do Norte', 'MT', NULL, NULL, NULL, 5106778, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.482693', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5275, 'Porto dos Gauchos', 'MT', NULL, NULL, NULL, 5106802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.483624', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5276, 'Porto Esperidiao', 'MT', NULL, NULL, NULL, 5106828, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.484579', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5277, 'Porto Estrela', 'MT', NULL, NULL, NULL, 5106851, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.485413', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5279, 'Primavera do Leste', 'MT', NULL, NULL, NULL, 5107040, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.487239', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5280, 'Querencia', 'MT', NULL, NULL, NULL, 5107065, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.48811', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5300, 'Sao Jose dos Quatro Marcos', 'MT', NULL, NULL, NULL, 5107107, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.506858', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5281, 'Reserva do Cabacal', 'MT', NULL, NULL, NULL, 5107156, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.489033', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5282, 'Ribeirao Cascalheira', 'MT', NULL, NULL, NULL, 5107180, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.489983', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5283, 'Ribeiraozinho', 'MT', NULL, NULL, NULL, 5107198, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.490955', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5284, 'Rio Branco', 'MT', NULL, NULL, NULL, 5107206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.491842', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5289, 'Santa Carmem', 'MT', NULL, NULL, NULL, 5107248, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.496894', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5293, 'Santo Afonso', 'MT', NULL, NULL, NULL, 5107263, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.50045', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5297, 'Sao Jose do Povo', 'MT', NULL, NULL, NULL, 5107297, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.504015', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5298, 'Sao Jose do Rio Claro', 'MT', NULL, NULL, NULL, 5107305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.504954', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5299, 'Sao Jose do Xingu', 'MT', NULL, NULL, NULL, 5107354, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.505931', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5301, 'Sao Pedro da Cipa', 'MT', NULL, NULL, NULL, 5107404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.507799', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5285, 'Rondolandia', 'MT', NULL, NULL, NULL, 5107578, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.492869', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5286, 'Rondonopolis', 'MT', NULL, NULL, NULL, 5107602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.493854', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5287, 'Rosario Oeste', 'MT', NULL, NULL, NULL, 5107701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.494826', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5290, 'Santa Cruz do Xingu', 'MT', NULL, NULL, NULL, 5107743, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.497687', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5288, 'Salto do Ceu', 'MT', NULL, NULL, NULL, 5107750, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.495786', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5291, 'Santa Rita do Trivelato', 'MT', NULL, NULL, NULL, 5107768, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.498595', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5292, 'Santa Terezinha', 'MT', NULL, NULL, NULL, 5107776, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.499475', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5294, 'Santo Antonio do Leste', 'MT', NULL, NULL, NULL, 5107792, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.50133', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5295, 'Santo Antonio do Leverger', 'MT', NULL, NULL, NULL, 5107800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.502127', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5296, 'Sao Felix do Araguaia', 'MT', NULL, NULL, NULL, 5107859, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.503103', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5302, 'Sapezal', 'MT', NULL, NULL, NULL, 5107875, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.508718', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5303, 'Serra Nova Dourada', 'MT', NULL, NULL, NULL, 5107883, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.509707', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5304, 'Sinop', 'MT', NULL, NULL, NULL, 5107909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.510666', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5305, 'Sorriso', 'MT', NULL, NULL, NULL, 5107925, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.51148', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5306, 'Tabapora', 'MT', NULL, NULL, NULL, 5107941, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.51804', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5307, 'Tangara da Serra', 'MT', NULL, NULL, NULL, 5107958, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.51929', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5308, 'Tapurah', 'MT', NULL, NULL, NULL, 5108006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.520225', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5309, 'Terra Nova do Norte', 'MT', NULL, NULL, NULL, 5108055, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.521047', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5310, 'Tesouro', 'MT', NULL, NULL, NULL, 5108105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.521974', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5311, 'Torixoreu', 'MT', NULL, NULL, NULL, 5108204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.52294', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5312, 'Uniao do Sul', 'MT', NULL, NULL, NULL, 5108303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.523883', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5313, 'Vale de Sao Domingos', 'MT', NULL, NULL, NULL, 5108352, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.524972', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5314, 'Varzea Grande', 'MT', NULL, NULL, NULL, 5108402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.526086', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5315, 'Vera', 'MT', NULL, NULL, NULL, 5108501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.526999', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5317, 'Vila Rica', 'MT', NULL, NULL, NULL, 5108600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.530101', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5250, 'Nova Guarita', 'MT', NULL, NULL, NULL, 5108808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.45418', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5252, 'Nova Marilandia', 'MT', NULL, NULL, NULL, 5108857, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.455908', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5253, 'Nova Maringa', 'MT', NULL, NULL, NULL, 5108907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.456789', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5254, 'Nova Monte Verde', 'MT', NULL, NULL, NULL, 5108956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.457859', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5318, 'Abadia de Goias', 'GO', NULL, NULL, NULL, 5200050, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.531009', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5319, 'Abadiania', 'GO', NULL, NULL, NULL, 5200100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.53199', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5320, 'Acreuna', 'GO', NULL, NULL, NULL, 5200134, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.532886', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5321, 'Adelandia', 'GO', NULL, NULL, NULL, 5200159, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.533668', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5322, 'Agua Fria de Goias', 'GO', NULL, NULL, NULL, 5200175, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.534826', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5323, 'Agua Limpa', 'GO', NULL, NULL, NULL, 5200209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.535749', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5324, 'Aguas Lindas de Goias', 'GO', NULL, NULL, NULL, 5200258, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.53668', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5325, 'Alexania', 'GO', NULL, NULL, NULL, 5200308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.537739', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5326, 'Aloandia', 'GO', NULL, NULL, NULL, 5200506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.53862', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5327, 'Alto Horizonte', 'GO', NULL, NULL, NULL, 5200555, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.539517', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5328, 'Alto Paraiso de Goias', 'GO', NULL, NULL, NULL, 5200605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.540454', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5329, 'Alvorada do Norte', 'GO', NULL, NULL, NULL, 5200803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.541418', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5330, 'Amaralina', 'GO', NULL, NULL, NULL, 5200829, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.542313', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5331, 'Americano do Brasil', 'GO', NULL, NULL, NULL, 5200852, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.543192', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5332, 'Amorinopolis', 'GO', NULL, NULL, NULL, 5200902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.544118', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5333, 'Anapolis', 'GO', NULL, NULL, NULL, 5201108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.544995', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5334, 'Anhanguera', 'GO', NULL, NULL, NULL, 5201207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.545877', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5335, 'Anicuns', 'GO', NULL, NULL, NULL, 5201306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.54685', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5336, 'Aparecida de Goiania', 'GO', NULL, NULL, NULL, 5201405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.547789', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5337, 'Aparecida do Rio Doce', 'GO', NULL, NULL, NULL, 5201454, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.548635', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5338, 'Apore', 'GO', NULL, NULL, NULL, 5201504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.549452', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5339, 'Aracu', 'GO', NULL, NULL, NULL, 5201603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.550511', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5340, 'Aragarcas', 'GO', NULL, NULL, NULL, 5201702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.551456', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5341, 'Aragoiania', 'GO', NULL, NULL, NULL, 5201801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.558409', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5342, 'Araguapaz', 'GO', NULL, NULL, NULL, 5202155, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.559799', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5343, 'Arenopolis', 'GO', NULL, NULL, NULL, 5202353, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.5608', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5344, 'Aruana', 'GO', NULL, NULL, NULL, 5202502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.561736', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5345, 'Aurilandia', 'GO', NULL, NULL, NULL, 5202601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.562641', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5346, 'Avelinopolis', 'GO', NULL, NULL, NULL, 5202809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.563516', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5347, 'Baliza', 'GO', NULL, NULL, NULL, 5203104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.564819', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5348, 'Barro Alto', 'GO', NULL, NULL, NULL, 5203203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.56604', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5349, 'Bela Vista de Goias', 'GO', NULL, NULL, NULL, 5203302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.566961', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5350, 'Bom Jardim de Goias', 'GO', NULL, NULL, NULL, 5203401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.567928', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5351, 'Bom Jesus de Goias', 'GO', NULL, NULL, NULL, 5203500, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.568869', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5352, 'Bonfinopolis', 'GO', NULL, NULL, NULL, 5203559, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.569784', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5353, 'Bonopolis', 'GO', NULL, NULL, NULL, 5203575, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.570757', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5354, 'Brazabrantes', 'GO', NULL, NULL, NULL, 5203609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.571611', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5355, 'Britania', 'GO', NULL, NULL, NULL, 5203807, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.572486', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5356, 'Buriti Alegre', 'GO', NULL, NULL, NULL, 5203906, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.57334', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5357, 'Buriti de Goias', 'GO', NULL, NULL, NULL, 5203939, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.57425', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5358, 'Buritinopolis', 'GO', NULL, NULL, NULL, 5203962, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.575213', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5359, 'Cabeceiras', 'GO', NULL, NULL, NULL, 5204003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.57613', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5360, 'Cachoeira Alta', 'GO', NULL, NULL, NULL, 5204102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.577058', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5361, 'Cachoeira de Goias', 'GO', NULL, NULL, NULL, 5204201, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.577887', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5362, 'Cachoeira Dourada', 'GO', NULL, NULL, NULL, 5204250, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.578836', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5363, 'Cacu', 'GO', NULL, NULL, NULL, 5204300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.579767', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5364, 'Caiaponia', 'GO', NULL, NULL, NULL, 5204409, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.580695', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5365, 'Caldas Novas', 'GO', NULL, NULL, NULL, 5204508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.581988', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5366, 'Caldazinha', 'GO', NULL, NULL, NULL, 5204557, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.582914', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5367, 'Campestre de Goias', 'GO', NULL, NULL, NULL, 5204607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.583775', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5368, 'Campinacu', 'GO', NULL, NULL, NULL, 5204656, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.584712', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5369, 'Campinorte', 'GO', NULL, NULL, NULL, 5204706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.585668', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5370, 'Campo Alegre de Goias', 'GO', NULL, NULL, NULL, 5204805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.586525', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5371, 'Campo Limpo de Goias', 'GO', NULL, NULL, NULL, 5204854, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.587364', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5372, 'Campos Belos', 'GO', NULL, NULL, NULL, 5204904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.588237', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5373, 'Campos Verdes', 'GO', NULL, NULL, NULL, 5204953, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.589202', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5374, 'Carmo do Rio Verde', 'GO', NULL, NULL, NULL, 5205000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.590143', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5375, 'Castelandia', 'GO', NULL, NULL, NULL, 5205059, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.591002', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5376, 'Catalao', 'GO', NULL, NULL, NULL, 5205109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.592188', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5377, 'Caturai', 'GO', NULL, NULL, NULL, 5205208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.603004', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5378, 'Cavalcante', 'GO', NULL, NULL, NULL, 5205307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.604319', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5379, 'Ceres', 'GO', NULL, NULL, NULL, 5205406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.605372', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5380, 'Cezarina', 'GO', NULL, NULL, NULL, 5205455, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.606325', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5381, 'Chapadao do Ceu', 'GO', NULL, NULL, NULL, 5205471, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.607336', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5382, 'Cidade Ocidental', 'GO', NULL, NULL, NULL, 5205497, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.608275', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5383, 'Cocalzinho de Goias', 'GO', NULL, NULL, NULL, 5205513, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.609119', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5384, 'Colinas do Sul', 'GO', NULL, NULL, NULL, 5205521, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.609959', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5385, 'Corrego do Ouro', 'GO', NULL, NULL, NULL, 5205703, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.610872', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5386, 'Corumba de Goias', 'GO', NULL, NULL, NULL, 5205802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.611794', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5387, 'Corumbaiba', 'GO', NULL, NULL, NULL, 5205901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.612763', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5388, 'Cristalina', 'GO', NULL, NULL, NULL, 5206206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.613699', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5389, 'Cristianopolis', 'GO', NULL, NULL, NULL, 5206305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.614727', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5390, 'Crixas', 'GO', NULL, NULL, NULL, 5206404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.615553', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5391, 'Crominia', 'GO', NULL, NULL, NULL, 5206503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.616462', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5392, 'Cumari', 'GO', NULL, NULL, NULL, 5206602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.61735', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5393, 'Damianopolis', 'GO', NULL, NULL, NULL, 5206701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.618249', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5394, 'Damolandia', 'GO', NULL, NULL, NULL, 5206800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.619199', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5395, 'Davinopolis', 'GO', NULL, NULL, NULL, 5206909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.620154', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5396, 'Diorama', 'GO', NULL, NULL, NULL, 5207105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.621073', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5398, 'Doverlandia', 'GO', NULL, NULL, NULL, 5207253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.623068', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5399, 'Edealina', 'GO', NULL, NULL, NULL, 5207352, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.623962', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5400, 'Edeia', 'GO', NULL, NULL, NULL, 5207402, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.624932', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5401, 'Estrela do Norte', 'GO', NULL, NULL, NULL, 5207501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.625947', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5402, 'Faina', 'GO', NULL, NULL, NULL, 5207535, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.626774', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5403, 'Fazenda Nova', 'GO', NULL, NULL, NULL, 5207600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.627692', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5404, 'Firminopolis', 'GO', NULL, NULL, NULL, 5207808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.628612', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5405, 'Flores de Goias', 'GO', NULL, NULL, NULL, 5207907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.629589', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5406, 'Formosa', 'GO', NULL, NULL, NULL, 5208004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.630429', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5407, 'Formoso', 'GO', NULL, NULL, NULL, 5208103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.631268', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5408, 'Gameleira de Goias', 'GO', NULL, NULL, NULL, 5208152, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.632204', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5397, 'Divinopolis de Goias', 'GO', NULL, NULL, NULL, 5208301, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.622032', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5409, 'Goianapolis', 'GO', NULL, NULL, NULL, 5208400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.633039', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5410, 'Goiandira', 'GO', NULL, NULL, NULL, 5208509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.633983', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5411, 'Goianesia', 'GO', NULL, NULL, NULL, 5208608, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.634918', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5412, 'Goiania', 'GO', NULL, NULL, NULL, 5208707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.635858', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5413, 'Goianira', 'GO', NULL, NULL, NULL, 5208806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.636781', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5414, 'Goias', 'GO', NULL, NULL, NULL, 5208905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.643396', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5415, 'Goiatuba', 'GO', NULL, NULL, NULL, 5209101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.644646', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5416, 'Gouvelandia', 'GO', NULL, NULL, NULL, 5209150, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.645672', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5417, 'Guapo', 'GO', NULL, NULL, NULL, 5209200, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.646555', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5418, 'Guaraita', 'GO', NULL, NULL, NULL, 5209291, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.647553', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5419, 'Guarani de Goias', 'GO', NULL, NULL, NULL, 5209408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.648866', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5420, 'Guarinos', 'GO', NULL, NULL, NULL, 5209457, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.649863', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5421, 'Heitorai', 'GO', NULL, NULL, NULL, 5209606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.650692', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5422, 'Hidrolandia', 'GO', NULL, NULL, NULL, 5209705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.651434', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5423, 'Hidrolina', 'GO', NULL, NULL, NULL, 5209804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.65227', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5424, 'Iaciara', 'GO', NULL, NULL, NULL, 5209903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.653174', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5425, 'Inaciolandia', 'GO', NULL, NULL, NULL, 5209937, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.654174', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5426, 'Indiara', 'GO', NULL, NULL, NULL, 5209952, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.655008', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5427, 'Inhumas', 'GO', NULL, NULL, NULL, 5210000, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.655851', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5428, 'Ipameri', 'GO', NULL, NULL, NULL, 5210109, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.656848', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5429, 'Ipiranga de Goias', 'GO', NULL, NULL, NULL, 5210158, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.657863', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5430, 'Ipora', 'GO', NULL, NULL, NULL, 5210208, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.658736', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5431, 'Israelandia', 'GO', NULL, NULL, NULL, 5210307, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.659837', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5432, 'Itaberai', 'GO', NULL, NULL, NULL, 5210406, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.660714', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5433, 'Itaguari', 'GO', NULL, NULL, NULL, 5210562, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.66169', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5434, 'Itaguaru', 'GO', NULL, NULL, NULL, 5210604, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.662571', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5435, 'Itaja', 'GO', NULL, NULL, NULL, 5210802, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.663372', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5436, 'Itapaci', 'GO', NULL, NULL, NULL, 5210901, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.664184', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5437, 'Itapirapua', 'GO', NULL, NULL, NULL, 5211008, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.665155', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5438, 'Itapuranga', 'GO', NULL, NULL, NULL, 5211206, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.666064', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5439, 'Itaruma', 'GO', NULL, NULL, NULL, 5211305, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.666945', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5440, 'Itaucu', 'GO', NULL, NULL, NULL, 5211404, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.667766', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5441, 'Itumbiara', 'GO', NULL, NULL, NULL, 5211503, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.668731', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5442, 'Ivolandia', 'GO', NULL, NULL, NULL, 5211602, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.669617', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5443, 'Jandaia', 'GO', NULL, NULL, NULL, 5211701, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.670602', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5444, 'Jaragua', 'GO', NULL, NULL, NULL, 5211800, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.671381', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5445, 'Jatai', 'GO', NULL, NULL, NULL, 5211909, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.672203', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5446, 'Jaupaci', 'GO', NULL, NULL, NULL, 5212006, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.673077', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5447, 'Jesupolis', 'GO', NULL, NULL, NULL, 5212055, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.67413', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5448, 'Joviania', 'GO', NULL, NULL, NULL, 5212105, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.675038', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5449, 'Jussara', 'GO', NULL, NULL, NULL, 5212204, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.675958', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5450, 'Lagoa Santa', 'GO', NULL, NULL, NULL, 5212253, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.676927', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5451, 'Leopoldo de Bulhoes', 'GO', NULL, NULL, NULL, 5212303, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.687916', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5452, 'Luziania', 'GO', NULL, NULL, NULL, 5212501, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.689054', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5453, 'Mairipotaba', 'GO', NULL, NULL, NULL, 5212600, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.689933', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5454, 'Mambai', 'GO', NULL, NULL, NULL, 5212709, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.69083', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5455, 'Mara Rosa', 'GO', NULL, NULL, NULL, 5212808, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.691716', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5456, 'Marzagao', 'GO', NULL, NULL, NULL, 5212907, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.692635', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5457, 'Matrincha', 'GO', NULL, NULL, NULL, 5212956, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.693504', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5458, 'Maurilandia', 'GO', NULL, NULL, NULL, 5213004, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.694336', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5459, 'Mimoso de Goias', 'GO', NULL, NULL, NULL, 5213053, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.695216', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5460, 'Minacu', 'GO', NULL, NULL, NULL, 5213087, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.696172', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5461, 'Mineiros', 'GO', NULL, NULL, NULL, 5213103, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.697089', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5462, 'Moipora', 'GO', NULL, NULL, NULL, 5213400, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.698025', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5463, 'Monte Alegre de Goias', 'GO', NULL, NULL, NULL, 5213509, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.69892', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5464, 'Montes Claros de Goias', 'GO', NULL, NULL, NULL, 5213707, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.699882', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5465, 'Montividiu', 'GO', NULL, NULL, NULL, 5213756, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.700799', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5466, 'Montividiu do Norte', 'GO', NULL, NULL, NULL, 5213772, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.701715', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5467, 'Morrinhos', 'GO', NULL, NULL, NULL, 5213806, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.702638', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5468, 'Morro Agudo de Goias', 'GO', NULL, NULL, NULL, 5213855, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.703663', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5469, 'Mossamedes', 'GO', NULL, NULL, NULL, 5213905, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.704418', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5470, 'Mozarlandia', 'GO', NULL, NULL, NULL, 5214002, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.705276', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5471, 'Mundo Novo', 'GO', NULL, NULL, NULL, 5214051, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.706025', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5472, 'Mutunopolis', 'GO', NULL, NULL, NULL, 5214101, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.706843', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5473, 'Nazario', 'GO', NULL, NULL, NULL, 5214408, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.707701', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5474, 'Neropolis', 'GO', NULL, NULL, NULL, 5214507, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.708646', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5475, 'Niquelandia', 'GO', NULL, NULL, NULL, 5214606, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.709625', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5476, 'Nova America', 'GO', NULL, NULL, NULL, 5214705, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.710551', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5477, 'Nova Aurora', 'GO', NULL, NULL, NULL, 5214804, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.711502', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5478, 'Nova Crixas', 'GO', NULL, NULL, NULL, 5214838, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.712452', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5479, 'Nova Gloria', 'GO', NULL, NULL, NULL, 5214861, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.713407', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5480, 'Nova Iguacu de Goias', 'GO', NULL, NULL, NULL, 5214879, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.714282', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5481, 'Nova Roma', 'GO', NULL, NULL, NULL, 5214903, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.715252', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5482, 'Nova Veneza', 'GO', NULL, NULL, NULL, 5215009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.716088', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5483, 'Novo Brasil', 'GO', NULL, NULL, NULL, 5215207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.717048', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5484, 'Novo Gama', 'GO', NULL, NULL, NULL, 5215231, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.71804', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5485, 'Novo Planalto', 'GO', NULL, NULL, NULL, 5215256, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.718969', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5486, 'Orizona', 'GO', NULL, NULL, NULL, 5215306, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.71987', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5487, 'Ouro Verde de Goias', 'GO', NULL, NULL, NULL, 5215405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.720782', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5488, 'Ouvidor', 'GO', NULL, NULL, NULL, 5215504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.721647', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5489, 'Padre Bernardo', 'GO', NULL, NULL, NULL, 5215603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.730377', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5490, 'Palestina de Goias', 'GO', NULL, NULL, NULL, 5215652, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.731494', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5491, 'Palmeiras de Goias', 'GO', NULL, NULL, NULL, 5215702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.732416', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5492, 'Palmelo', 'GO', NULL, NULL, NULL, 5215801, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.733286', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5493, 'Palminopolis', 'GO', NULL, NULL, NULL, 5215900, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.734292', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5494, 'Panama', 'GO', NULL, NULL, NULL, 5216007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.735177', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5495, 'Paranaiguara', 'GO', NULL, NULL, NULL, 5216304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.736027', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5496, 'Parauna', 'GO', NULL, NULL, NULL, 5216403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.736912', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5497, 'Perolandia', 'GO', NULL, NULL, NULL, 5216452, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.738016', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5498, 'Petrolina de Goias', 'GO', NULL, NULL, NULL, 5216809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.738872', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5499, 'Pilar de Goias', 'GO', NULL, NULL, NULL, 5216908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.739682', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5500, 'Piracanjuba', 'GO', NULL, NULL, NULL, 5217104, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.740598', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5501, 'Piranhas', 'GO', NULL, NULL, NULL, 5217203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.741497', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5502, 'Pirenopolis', 'GO', NULL, NULL, NULL, 5217302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.742364', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5503, 'Pires do Rio', 'GO', NULL, NULL, NULL, 5217401, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.743286', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5504, 'Planaltina', 'GO', NULL, NULL, NULL, 5217609, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.744194', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5505, 'Pontalina', 'GO', NULL, NULL, NULL, 5217708, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.745138', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5506, 'Porangatu', 'GO', NULL, NULL, NULL, 5218003, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.746057', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5507, 'Porteirao', 'GO', NULL, NULL, NULL, 5218052, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.746977', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5508, 'Portelandia', 'GO', NULL, NULL, NULL, 5218102, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.747798', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5509, 'Posse', 'GO', NULL, NULL, NULL, 5218300, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.74865', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5510, 'Professor Jamil', 'GO', NULL, NULL, NULL, 5218391, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.749443', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5511, 'Quirinopolis', 'GO', NULL, NULL, NULL, 5218508, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:37.606333', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5512, 'Rialma', 'GO', NULL, NULL, NULL, 5218607, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:34.339363', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5513, 'Rianapolis', 'GO', NULL, NULL, NULL, 5218706, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.527984', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5514, 'Rio Quente', 'GO', NULL, NULL, NULL, 5218789, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.750281', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5515, 'Rio Verde', 'GO', NULL, NULL, NULL, 5218805, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.75147', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5516, 'Rubiataba', 'GO', NULL, NULL, NULL, 5218904, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.752375', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5517, 'Sanclerlandia', 'GO', NULL, NULL, NULL, 5219001, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.75327', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5518, 'Santa Barbara de Goias', 'GO', NULL, NULL, NULL, 5219100, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.754126', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5519, 'Santa Cruz de Goias', 'GO', NULL, NULL, NULL, 5219209, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.754942', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5520, 'Santa Fe de Goias', 'GO', NULL, NULL, NULL, 5219258, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.755933', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5521, 'Santa Helena de Goias', 'GO', NULL, NULL, NULL, 5219308, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.756965', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5522, 'Santa Isabel', 'GO', NULL, NULL, NULL, 5219357, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.757965', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5523, 'Santa Rita do Araguaia', 'GO', NULL, NULL, NULL, 5219407, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.758958', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5524, 'Santa Rita do Novo Destino', 'GO', NULL, NULL, NULL, 5219456, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.759916', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5525, 'Santa Rosa de Goias', 'GO', NULL, NULL, NULL, 5219506, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.760746', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5526, 'Santa Tereza de Goias', 'GO', NULL, NULL, NULL, 5219605, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.76171', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5527, 'Santa Terezinha de Goias', 'GO', NULL, NULL, NULL, 5219704, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.762654', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5528, 'Santo Antonio da Barra', 'GO', NULL, NULL, NULL, 5219712, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.763614', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5529, 'Santo Antonio de Goias', 'GO', NULL, NULL, NULL, 5219738, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.764441', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5530, 'Santo Antonio do Descoberto', 'GO', NULL, NULL, NULL, 5219753, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.771458', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5531, 'Sao Domingos', 'GO', NULL, NULL, NULL, 5219803, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.77252', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5532, 'Sao Francisco de Goias', 'GO', NULL, NULL, NULL, 5219902, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.773455', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5534, 'Sao Joao D''alianca', 'GO', NULL, NULL, NULL, 5220009, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.775239', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5533, 'Sao Joao da Parauna', 'GO', NULL, NULL, NULL, 5220058, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.774354', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5535, 'Sao Luis de Montes Belos', 'GO', NULL, NULL, NULL, 5220108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.77614', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5536, 'Sao Luiz do Norte', 'GO', NULL, NULL, NULL, 5220157, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.776981', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5537, 'Sao Miguel do Araguaia', 'GO', NULL, NULL, NULL, 5220207, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.777896', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5538, 'Sao Miguel do Passa Quatro', 'GO', NULL, NULL, NULL, 5220264, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.778808', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5539, 'Sao Patricio', 'GO', NULL, NULL, NULL, 5220280, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.779725', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5540, 'Sao Simao', 'GO', NULL, NULL, NULL, 5220405, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.780665', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5541, 'Senador Canedo', 'GO', NULL, NULL, NULL, 5220454, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.7816', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5542, 'Serranopolis', 'GO', NULL, NULL, NULL, 5220504, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.78277', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5543, 'Silvania', 'GO', NULL, NULL, NULL, 5220603, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.783748', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5544, 'Simolandia', 'GO', NULL, NULL, NULL, 5220686, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.784751', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5545, 'Sitio D''abadia', 'GO', NULL, NULL, NULL, 5220702, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.785701', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5546, 'Taquaral de Goias', 'GO', NULL, NULL, NULL, 5221007, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.786631', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5547, 'Teresina de Goias', 'GO', NULL, NULL, NULL, 5221080, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.787611', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5548, 'Terezopolis de Goias', 'GO', NULL, NULL, NULL, 5221197, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.788494', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5549, 'Tres Ranchos', 'GO', NULL, NULL, NULL, 5221304, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.789421', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5550, 'Trindade', 'GO', NULL, NULL, NULL, 5221403, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.790358', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5551, 'Trombas', 'GO', NULL, NULL, NULL, 5221452, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.791247', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5552, 'Turvania', 'GO', NULL, NULL, NULL, 5221502, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.792226', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5553, 'Turvelandia', 'GO', NULL, NULL, NULL, 5221551, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.793204', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5554, 'Uirapuru', 'GO', NULL, NULL, NULL, 5221577, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.794106', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5555, 'Uruacu', 'GO', NULL, NULL, NULL, 5221601, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.795058', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5556, 'Uruana', 'GO', NULL, NULL, NULL, 5221700, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.796026', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5557, 'Urutai', 'GO', NULL, NULL, NULL, 5221809, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.796933', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5558, 'Valparaiso de Goias', 'GO', NULL, NULL, NULL, 5221858, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.797818', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5559, 'Varjao', 'GO', NULL, NULL, NULL, 5221908, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.798714', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5560, 'Vianopolis', 'GO', NULL, NULL, NULL, 5222005, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.799587', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5561, 'Vicentinopolis', 'GO', NULL, NULL, NULL, 5222054, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.800364', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5562, 'Vila Boa', 'GO', NULL, NULL, NULL, 5222203, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.801199', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5563, 'Vila Propicio', 'GO', NULL, NULL, NULL, 5222302, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.802078', 'M', 'I', NULL, 9);
INSERT INTO municipio (idmun, nome, sigla_uf, area_km2, idmreg, idasmun, cod_ibge, geom, tipo, idmun_pai, idpes_rev, idpes_cad, data_rev, data_cad, origem_gravacao, operacao, idsis_rev, idsis_cad) VALUES (5564, 'Brasilia', 'DF', NULL, NULL, NULL, 5300108, NULL, 'M', NULL, NULL, 1, NULL, '2010-01-06 18:30:39.80332', 'M', 'I', NULL, 9);


--
-- Data for Name: pais; Type: TABLE DATA; Schema: public; Owner: postgres
--

INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (1, 'Abissínia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (2, 'Açores', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (3, 'Afar Francês', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (4, 'Afeganistão', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (5, 'Albânia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (6, 'Alemanha', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (7, 'Alto Volta', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (8, 'Andorra', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (9, 'Angola', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (10, 'Antártica Francesa', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (11, 'Antártico Argentino', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (12, 'Antártico Britânico, Território', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (13, 'Antártico Chileno', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (14, 'Antártico Noruegues', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (15, 'Antígua E. Dep. Barbuda', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (16, 'Antilhas Holandesas', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (17, 'Apátrida', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (18, 'Arábia Saudita', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (19, 'Argélia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (20, 'Argentina', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (21, 'Armênia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (22, 'Arquipélago de Bismark', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (23, 'Arquipélago Manahiki', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (24, 'Arquipélago Midway', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (25, 'Aruba', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (26, 'Ascensão e Tristão da Cunha,is', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (27, 'Ashmore e Cartier', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (28, 'Austrália', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (29, 'áustria', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (30, 'Azerbaijão', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (31, 'Bahrein', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (32, 'Bangladesh', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (33, 'Barbados', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (34, 'Bashkista', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (35, 'Bechuanalândia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (36, 'Bélgica', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (37, 'Belize', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (38, 'Benin', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (39, 'Bermudas', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (40, 'Bhutan', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (41, 'Birmânia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (42, 'Bolívia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (43, 'Bósnia Herzegovina', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (44, 'Botsuana', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (45, 'Brasil', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (46, 'Brunei', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (47, 'Bulgária', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (48, 'Burkina Fasso', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (49, 'Burundi', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (50, 'Buryat', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (51, 'Cabo Verde', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (52, 'Camarões', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (53, 'Canadá', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (54, 'Carélia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (55, 'Catar', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (56, 'Cazaquistão', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (57, 'Ceilão', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (58, 'Ceuta e Melilla', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (59, 'Chade', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (60, 'Chechen Ingusth', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (61, 'Chile', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (62, 'China', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (63, 'China (taiwan)', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (64, 'Chipre', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (65, 'Chuvash', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (66, 'Cingapura', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (67, 'Colômbia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (68, 'Comunidade das Bahamas', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (69, 'Comunidade Dominicana', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (70, 'Congo', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (71, 'Coréia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (72, 'Costa do Marfim', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (73, 'Costa Rica', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (74, 'Coveite', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (75, 'Croácia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (76, 'Cuba', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (77, 'Curaçao', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (78, 'Dagesta', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (79, 'Daomé', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (80, 'Dependência de Ross', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (81, 'Dinamarca', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (82, 'Djibuti', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (83, 'Eire', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (84, 'Emirados árabes Unidos', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (85, 'Equador', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (86, 'Escócia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (87, 'Eslováquia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (88, 'Eslovênia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (89, 'Espanha', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (90, 'Estado da Cidade do Vaticano', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (91, 'Estados Assoc. das Antilhas', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (92, 'Estados Unidos da América (eua)', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (93, 'Estônia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (94, 'Etiópia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (95, 'Filipinas', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (96, 'Finlândia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (97, 'França', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (98, 'Gâmbia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (99, 'Gana', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (100, 'Gaza', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (101, 'Geórgia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (102, 'Gibraltar', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (103, 'Gorno Altai', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (104, 'Grã-bretanha', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (105, 'Granada', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (106, 'Grécia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (107, 'Groenlândia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (108, 'Guam', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (109, 'Guatemala', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (110, 'Guiana Francesa', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (111, 'Guiné', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (112, 'Guiné Bissau', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (113, 'Guiné Equatorial', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (114, 'Holanda', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (115, 'Honduras', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (116, 'Honduras Britânicas', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (117, 'Hong-kong', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (118, 'Hungria', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (119, 'Iemen', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (120, 'Iemen do Sul', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (121, 'Ifni', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (122, 'Ilha Johnston e Sand', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (123, 'Ilha Milhos', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (124, 'Ilhas Baker', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (125, 'Ilhas Baleares', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (126, 'Ilhas Canárias', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (127, 'Ilhas Cantão e Enderburg', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (128, 'Ilhas Carolinas', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (129, 'Ilhas Christmas', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (130, 'Ilhas Comores', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (131, 'Ilhas Cook', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (132, 'Ilhas Cosmoledo (lomores)', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (133, 'Ilhas de Man', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (134, 'Ilhas do Canal', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (135, 'Ilhas do Pacífico', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (136, 'Ilhas Falklands', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (137, 'Ilhas Faroes', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (138, 'Ilhas Gilbert', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (139, 'Ilhas Guadalupe', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (140, 'Ilhas Howland e Jarvis', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (141, 'Ilhas Kingman Reef', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (142, 'Ilhas Linha', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (143, 'Ilhas Macdonal e Heard', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (144, 'Ilhas Macquaire', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (145, 'Ilhas Malvinas', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (146, 'Ilhas Marianas', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (147, 'Ilhas Marshall', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (148, 'Ilhas Niue', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (149, 'Ilhas Norfolk', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (150, 'Ilhas Nova Caledônia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (151, 'Ilhas Novas Hebridas', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (152, 'Ilhas Palau', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (153, 'Ilhas Páscoa', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (154, 'Ilhas Pitcairin', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (155, 'Ilhas Salomão', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (156, 'Ilhas Santa Cruz', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (157, 'Ilhas Serranas', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (158, 'Ilhas Tokelau', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (159, 'Ilhas Turca', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (160, 'Ilhas Turks e Caicos', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (161, 'Ilhas Virgens Americanas', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (162, 'Ilhas Virgens Britânicas', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (163, 'Ilhas Wake', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (164, 'Ilhas Wallis e Futuna', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (165, 'índia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (166, 'Indonésia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (167, 'Inglaterra', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (168, 'Irã', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (169, 'Iraque', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (170, 'Irlanda', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (171, 'Irlanda do Norte', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (172, 'Islândia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (173, 'Israel', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (174, 'Itália', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (175, 'Iugoslávia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (176, 'Jamaica', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (177, 'Japão', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (178, 'Jordânia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (179, 'Kabardino Balkar', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (180, 'Kalimatan', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (181, 'Kalmir', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (182, 'Kara Kalpak', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (183, 'Karachaevocherkess', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (184, 'Khakass', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (185, 'Kmer/camboja', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (186, 'Komi', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (187, 'Kuwait', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (188, 'Laos', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (189, 'Lesoto', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (190, 'Letônia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (191, 'Líbano', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (192, 'Libéria', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (193, 'Líbia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (194, 'Liechtenstein', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (195, 'Lituânia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (196, 'Luxemburgo', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (197, 'Macau', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (198, 'Madagascar', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (199, 'Madeira', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (200, 'Malásia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (201, 'Malawi', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (202, 'Maldivas,is', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (203, 'Mali', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (204, 'Mari', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (205, 'Marrocos', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (206, 'Martinica', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (207, 'Mascate', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (208, 'Maurício', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (209, 'Mauritânia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (210, 'México', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (211, 'Mianma', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (212, 'Moçambique', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (213, 'Moldávia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (214, 'Mônaco', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (215, 'Mongólia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (216, 'Monte Serrat', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (217, 'Montenegro', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (218, 'Namíbia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (219, 'Nauru', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (220, 'Nepal', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (221, 'Nguane', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (222, 'Nicarágua', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (223, 'Nigéria', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (224, 'Noruega', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (225, 'Nova Guiné', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (226, 'Nova Zelândia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (227, 'Oman', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (228, 'Ossetia Setentrional', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (229, 'País de Gales', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (230, 'Países Baixos', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (231, 'Palestina', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (232, 'Panamá', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (233, 'Panamá - Zona do Canal', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (234, 'Papua Nova Guiné', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (235, 'Paquistão', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (236, 'Paraguai', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (237, 'Peru', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (238, 'Polinésia Francesa', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (239, 'Polônia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (240, 'Porto Rico', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (241, 'Portugal', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (242, 'Praças Norte Africanas', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (243, 'Protetor do Sudoeste Africano', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (244, 'Quênia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (245, 'Quirguistão', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (246, 'Quitasueno', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (247, 'República árabe do Egito', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (248, 'República Centro Africana', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (249, 'República da áfrica do Sul', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (250, 'República da Bielorrússia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (251, 'República da Macedônia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (252, 'República de El Salvador', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (253, 'República de Fiji', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (254, 'República de Malta', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (255, 'República do Gabão', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (256, 'República do Haiti', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (257, 'República do Níger', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (258, 'República Dominicana', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (259, 'República Guiana', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (260, 'República Tcheca', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (261, 'Reservado', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (262, 'Reservado', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (263, 'Reservado', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (264, 'Reservado', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (265, 'Reunião', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (266, 'Rodésia (zimbábwe)', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (267, 'Romênia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (268, 'Roncador', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (269, 'Ruanda', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (270, 'Ruiquiu,is', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (271, 'Rússia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (272, 'Saara Espanhol', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (273, 'Sabah', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (274, 'Samoa Americana', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (275, 'Samoa Ocidental', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (276, 'San Marino', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (277, 'Santa Helena', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (278, 'Santa Lúcia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (279, 'São Cristóvão', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (280, 'São Tomé e Príncipe', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (281, 'São Vicente', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (282, 'Sarawak', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (283, 'Senegal', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (284, 'Sequin', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (285, 'Serra Leoa', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (286, 'Sérvia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (287, 'Seychelles', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (288, 'Síria', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (289, 'Somália, República', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (290, 'Sri-lanka', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (291, 'St. Pierre et Miquelon', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (292, 'Suazilândia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (293, 'Sudão', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (294, 'Suécia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (295, 'Suíça', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (296, 'Suriname', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (297, 'Svalbard e Jan Mayer,is', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (298, 'Tadjiquistão', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (299, 'Tailândia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (300, 'Tanganica', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (301, 'Tanzânia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (302, 'Tartaria', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (303, 'Tchecoslováquia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (304, 'Terr. Antártico da Austrália', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (305, 'Terras Austrais', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (306, 'Territ. Britânico do Oceano índico', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (307, 'Território de Cocos', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (308, 'Território de Papua', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (309, 'Timor', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (310, 'Togo', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (311, 'Tonga', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (312, 'Transkei', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (313, 'Trégua, Estado', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (314, 'Trinidad e Tobago', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (315, 'Tunísia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (316, 'Turcomenistão', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (317, 'Turquia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (318, 'Tuvalu', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (319, 'Tuvin', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (320, 'Ucrânia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (321, 'Udmurt', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (322, 'Uganda', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (323, 'União Soviética', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (324, 'Uruguai', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (325, 'Uzbequistão', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (326, 'Venezuela', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (327, 'Vietnã do Norte', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (328, 'Vietnã do Sul', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (329, 'Yakut', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (330, 'Zaire', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (331, 'Zâmbia', NULL, NULL);
INSERT INTO pais (idpais, nome, geom, cod_ibge) VALUES (332, 'Zimbábwe', NULL, NULL);


--
-- Data for Name: pghero_query_stats; Type: TABLE DATA; Schema: public; Owner: ieducar
--



--
-- Name: pghero_query_stats_id_seq; Type: SEQUENCE SET; Schema: public; Owner: ieducar
--

SELECT pg_catalog.setval('pghero_query_stats_id_seq', 1, false);

--
-- Data for Name: portal_banner; Type: TABLE DATA; Schema: public; Owner: ieducar
--



--
-- Name: portal_banner_cod_portal_banner_seq; Type: SEQUENCE SET; Schema: public; Owner: ieducar
--

SELECT pg_catalog.setval('portal_banner_cod_portal_banner_seq', 1, false);


--
-- Data for Name: regiao; Type: TABLE DATA; Schema: public; Owner: postgres
--



--
-- Name: regiao_cod_regiao_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('regiao_cod_regiao_seq', 1, false);


--
-- Name: seq_bairro; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('seq_bairro', 1, false);


--
-- Name: seq_distrito; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('seq_distrito', 5565, true);


--
-- Name: seq_logradouro; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('seq_logradouro', 1, false);


--
-- Name: seq_municipio; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('seq_municipio', 5565, false);


--
-- Name: seq_setor_bai; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('seq_setor_bai', 1, false);


--
-- Data for Name: setor; Type: TABLE DATA; Schema: public; Owner: postgres
--



--
-- Data for Name: setor_bai; Type: TABLE DATA; Schema: public; Owner: postgres
--



--
-- Name: setor_idset_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('setor_idset_seq', 1, false);


--
-- Data for Name: uf; Type: TABLE DATA; Schema: public; Owner: postgres
--

INSERT INTO uf (sigla_uf, nome, geom, idpais, cod_ibge) VALUES ('RO', 'Rondônia', NULL, 45, 11);
INSERT INTO uf (sigla_uf, nome, geom, idpais, cod_ibge) VALUES ('AC', 'Acre', NULL, 45, 12);
INSERT INTO uf (sigla_uf, nome, geom, idpais, cod_ibge) VALUES ('AM', 'Amazonas', NULL, 45, 13);
INSERT INTO uf (sigla_uf, nome, geom, idpais, cod_ibge) VALUES ('RR', 'Roraima', NULL, 45, 14);
INSERT INTO uf (sigla_uf, nome, geom, idpais, cod_ibge) VALUES ('PA', 'Pará', NULL, 45, 15);
INSERT INTO uf (sigla_uf, nome, geom, idpais, cod_ibge) VALUES ('AP', 'Amapá', NULL, 45, 16);
INSERT INTO uf (sigla_uf, nome, geom, idpais, cod_ibge) VALUES ('TO', 'Tocantins', NULL, 45, 17);
INSERT INTO uf (sigla_uf, nome, geom, idpais, cod_ibge) VALUES ('MA', 'Maranhão', NULL, 45, 21);
INSERT INTO uf (sigla_uf, nome, geom, idpais, cod_ibge) VALUES ('PI', 'Piauí', NULL, 45, 22);
INSERT INTO uf (sigla_uf, nome, geom, idpais, cod_ibge) VALUES ('CE', 'Ceará', NULL, 45, 23);
INSERT INTO uf (sigla_uf, nome, geom, idpais, cod_ibge) VALUES ('RN', 'Rio Grande do Norte', NULL, 45, 24);
INSERT INTO uf (sigla_uf, nome, geom, idpais, cod_ibge) VALUES ('PB', 'Paraíba', NULL, 45, 25);
INSERT INTO uf (sigla_uf, nome, geom, idpais, cod_ibge) VALUES ('PE', 'Pernambuco', NULL, 45, 26);
INSERT INTO uf (sigla_uf, nome, geom, idpais, cod_ibge) VALUES ('AL', 'Alagoas', NULL, 45, 27);
INSERT INTO uf (sigla_uf, nome, geom, idpais, cod_ibge) VALUES ('SE', 'Sergipe', NULL, 45, 28);
INSERT INTO uf (sigla_uf, nome, geom, idpais, cod_ibge) VALUES ('BA', 'Bahia', NULL, 45, 29);
INSERT INTO uf (sigla_uf, nome, geom, idpais, cod_ibge) VALUES ('MG', 'Minas Gerais', NULL, 45, 31);
INSERT INTO uf (sigla_uf, nome, geom, idpais, cod_ibge) VALUES ('ES', 'Espírito Santo', NULL, 45, 32);
INSERT INTO uf (sigla_uf, nome, geom, idpais, cod_ibge) VALUES ('RJ', 'Rio de Janeiro', NULL, 45, 33);
INSERT INTO uf (sigla_uf, nome, geom, idpais, cod_ibge) VALUES ('SP', 'São Paulo', NULL, 45, 35);
INSERT INTO uf (sigla_uf, nome, geom, idpais, cod_ibge) VALUES ('PR', 'Paraná', NULL, 45, 41);
INSERT INTO uf (sigla_uf, nome, geom, idpais, cod_ibge) VALUES ('SC', 'Santa Catarina', NULL, 45, 42);
INSERT INTO uf (sigla_uf, nome, geom, idpais, cod_ibge) VALUES ('RS', 'Rio Grande do Sul', NULL, 45, 43);
INSERT INTO uf (sigla_uf, nome, geom, idpais, cod_ibge) VALUES ('MS', 'Mato Grosso do Sul', NULL, 45, 50);
INSERT INTO uf (sigla_uf, nome, geom, idpais, cod_ibge) VALUES ('MT', 'Mato Grosso', NULL, 45, 51);
INSERT INTO uf (sigla_uf, nome, geom, idpais, cod_ibge) VALUES ('GO', 'Goiás', NULL, 45, 52);
INSERT INTO uf (sigla_uf, nome, geom, idpais, cod_ibge) VALUES ('DF', 'Distrito Federal', NULL, 45, 53);


--
-- Data for Name: vila; Type: TABLE DATA; Schema: public; Owner: postgres
--

SET search_path = serieciasc, pg_catalog;

--
-- Data for Name: aluno_cod_aluno; Type: TABLE DATA; Schema: serieciasc; Owner: postgres
--



--
-- Data for Name: aluno_uniforme; Type: TABLE DATA; Schema: serieciasc; Owner: postgres
--



--
-- Data for Name: escola_agua; Type: TABLE DATA; Schema: serieciasc; Owner: postgres
--



--
-- Data for Name: escola_energia; Type: TABLE DATA; Schema: serieciasc; Owner: postgres
--



--
-- Data for Name: escola_lingua_indigena; Type: TABLE DATA; Schema: serieciasc; Owner: postgres
--



--
-- Data for Name: escola_lixo; Type: TABLE DATA; Schema: serieciasc; Owner: postgres
--



--
-- Data for Name: escola_projeto; Type: TABLE DATA; Schema: serieciasc; Owner: postgres
--



--
-- Data for Name: escola_regulamentacao; Type: TABLE DATA; Schema: serieciasc; Owner: postgres
--



--
-- Data for Name: escola_sanitario; Type: TABLE DATA; Schema: serieciasc; Owner: postgres
--



SET search_path = urbano, pg_catalog;

--
-- Data for Name: cep_logradouro; Type: TABLE DATA; Schema: urbano; Owner: postgres
--



--
-- Data for Name: cep_logradouro_bairro; Type: TABLE DATA; Schema: urbano; Owner: postgres
--



--
-- Data for Name: tipo_logradouro; Type: TABLE DATA; Schema: urbano; Owner: postgres
--

INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('CORRE', 'Corredor');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('DESCI', 'Descida');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('AEROP', 'Aeroporto');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('DESVI', 'Desvio');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ELEVA', 'Elevada');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ENTRP', 'Entrada Particular');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ESCA', 'Escada');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ESCAD', 'Escadaria');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ESTAC', 'Estacionamento');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ESPLA', 'Esplanada');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('GALER', 'Galeria');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ILHA', 'Ilha');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('JDNET', 'Jardinete');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('LAGO', 'Lago');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('LAGOA', 'Lagoa');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('MONTE', 'Monte');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('MARIN', 'Marina');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('VERED', 'Vereda');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('CORRG', 'Córrego');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('PASSE', 'Passeio');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('BULEV', 'Bulevar');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('COLON', 'Colônia');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('PATIO', 'Pátio');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('TUNEL', 'Túnel');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ROTUL', 'Rótula');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ESTAD', 'Estádio');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('MODUL', 'Módulo');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('SERVI', 'Servidão');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ALM', 'Alameda');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ALTO', 'Alto');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('AV', 'Avenida');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('BEC', 'Beco');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('COND', 'Condomínio');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('CONJ', 'Conjunto');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('DIV', 'Divisa');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('EST', 'Estrada');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('FEIRA', 'Feira');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('JD', 'Jardim');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('LAD', 'Ladeira');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('LTM', 'Loteamento');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('LRG', 'Largo');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('MRG', 'Margem');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('PORTO', 'Porto');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('PQE', 'Parque');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('PRAIA', 'Praia');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('QDA', 'Quadra');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('REC', 'Recanto');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('RES', 'Residencial');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('RET', 'Retorno');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ROD', 'Rodovia');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ROT', 'Rotatória');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('RUA', 'Rua');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('TER', 'Terminal');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('TRV', 'Travessa');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('UND', 'Unidade');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('VIA', 'Via');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('VLA', 'Vila');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ACAMP', 'Acampamento');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ACESS', 'Acesso');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('VIACE', 'Via de Acesso');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ADRO', 'Adro');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ANTES', 'Antiga Estrada');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('AREA', 'Área');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ARESP', 'Área Especial');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ATALH', 'Atalho');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('AVCON', 'Avenida Contorno');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('AVMAR', 'Avenida Marginal');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('AVVEL', 'Avenida Velha');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('PARAL', 'Paralela');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ENTRQ', 'Entre Quadra');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('PRQMU', 'Parque Municipal');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('PRQRE', 'Parque Residencial');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('BAIXA', 'Baixa');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('PASSG', 'Passagem');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('PASPE', 'Passagem de Pedestres');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('PASSB', 'Passagem Subterrânea');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('BELVE', 'Belvedere');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('PASSA', 'Passarela');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('BLOCO', 'Bloco');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('BOSQU', 'Bosque');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('PONTA', 'Ponta');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('BOULE', 'Boulevard');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ZIGUE', 'Zigue-Zague');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('VIELA', 'Viela');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('VIDUT', 'Viaduto');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('VIALO', 'Via Local');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('VIAPE', 'Via de Pedestre');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('VIALI', 'Via Litorânea');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('VIAEL', 'Via Elevado');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('VIAEX', 'Via Expressa');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('VIACO', 'Via Coletora');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('CAMIN', 'Caminho');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('VALE', 'Vale');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('VALA', 'Vala');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('TRAVP', 'Travessa Particular');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('TRAVV', 'Travessa Velha');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('TRECH', 'Trecho');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('TREVO', 'Trevo');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('RUAPE', 'Rua de Pedestre');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('RUAPA', 'Rua Particular');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('RUAVE', 'Rua Velha');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('SUBID', 'Subida');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('PONTE', 'Ponte');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('RAMPA', 'Rampa');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('BURAC', 'Buraco');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('QUINT', 'Quinta');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('RETIR', 'Retiro');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('CAIS', 'Cais');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('FONTE', 'Fonte');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('PROLO', 'Prolongamento');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('PARAD', 'Parada');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('SETOR', 'Setor');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('RETA', 'Reta');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('MORRO', 'Morro');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('RODAN', 'Rodo Anel');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('RAMAL', 'Ramal');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('FERRO', 'Ferrovia');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('CANAL', 'Canal');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('FORT', 'Forte');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('DISTR', 'Distrito');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ESTRE', 'Estrada Estadual');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ESTRM', 'Estrada Municipal');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ESTRP', 'Estrada Particular');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ESTRV', 'Estrada Velha');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ESTRC', 'Estrada Vicinal');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('CICLO', 'Ciclovia');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('GRANJ', 'Granja');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('FAZEN', 'Fazenda');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('CAMPO', 'Campo');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('FAVEL', 'Favela');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('CIRCU', 'Circular');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('CONTO', 'Contorno');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('RUALI', 'Rua de Ligação');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ROTAT', 'Rotatória');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('NUCLE', 'Núcleo');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ESTRL', 'Estrada de Ligação');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ARTER', 'Artéria');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('COMVI', 'Complexo Viário');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('CJOMU', 'Conjunto Mutirão');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('BALAO', 'Balão');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('CALCA', 'Calçada');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('CHAC', 'Chácara');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ESTAO', 'Estação');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('PCA', 'Praça');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('PCAES', 'Praça Esportes');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('SITIO', 'Sítio');
INSERT INTO tipo_logradouro (idtlog, descricao) VALUES ('ASSEN', 'Assentamento');


SET search_path = acesso, pg_catalog;

--
-- Name: pk_funcao; Type: CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY funcao
    ADD CONSTRAINT pk_funcao PRIMARY KEY (idfunc, idsis, idmen);


--
-- Name: pk_grupo; Type: CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY grupo
    ADD CONSTRAINT pk_grupo PRIMARY KEY (idgrp);


--
-- Name: pk_grupo_funcao; Type: CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY grupo_funcao
    ADD CONSTRAINT pk_grupo_funcao PRIMARY KEY (idmen, idsis, idgrp, idfunc);


--
-- Name: pk_grupo_menu; Type: CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY grupo_menu
    ADD CONSTRAINT pk_grupo_menu PRIMARY KEY (idgrp, idsis, idmen);


--
-- Name: pk_grupo_operacao; Type: CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY grupo_operacao
    ADD CONSTRAINT pk_grupo_operacao PRIMARY KEY (idfunc, idgrp, idsis, idmen, idope);


--
-- Name: pk_grupo_sistema; Type: CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY grupo_sistema
    ADD CONSTRAINT pk_grupo_sistema PRIMARY KEY (idsis, idgrp);


--
-- Name: pk_historico_senha; Type: CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY historico_senha
    ADD CONSTRAINT pk_historico_senha PRIMARY KEY (login, senha);


--
-- Name: pk_instituicao; Type: CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY instituicao
    ADD CONSTRAINT pk_instituicao PRIMARY KEY (idins);


--
-- Name: pk_menu; Type: CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY menu
    ADD CONSTRAINT pk_menu PRIMARY KEY (idsis, idmen);


--
-- Name: pk_operacao; Type: CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY operacao
    ADD CONSTRAINT pk_operacao PRIMARY KEY (idope);


--
-- Name: pk_operacao_funcao; Type: CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY operacao_funcao
    ADD CONSTRAINT pk_operacao_funcao PRIMARY KEY (idmen, idsis, idfunc, idope);


--
-- Name: pk_pessoa_instituicao; Type: CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY pessoa_instituicao
    ADD CONSTRAINT pk_pessoa_instituicao PRIMARY KEY (idins, idpes);


--
-- Name: pk_sistema; Type: CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY sistema
    ADD CONSTRAINT pk_sistema PRIMARY KEY (idsis);


--
-- Name: pk_usuario; Type: CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY usuario
    ADD CONSTRAINT pk_usuario PRIMARY KEY (login);


--
-- Name: pk_usuario_grupo; Type: CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY usuario_grupo
    ADD CONSTRAINT pk_usuario_grupo PRIMARY KEY (idgrp, login);


SET search_path = alimentos, pg_catalog;

--
-- Name: pk_baixa_guia_produto; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY baixa_guia_produto
    ADD CONSTRAINT pk_baixa_guia_produto PRIMARY KEY (idbap);


--
-- Name: pk_baixa_guia_remessa; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY baixa_guia_remessa
    ADD CONSTRAINT pk_baixa_guia_remessa PRIMARY KEY (idbai);


--
-- Name: pk_calendario; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY calendario
    ADD CONSTRAINT pk_calendario PRIMARY KEY (idcad);


--
-- Name: pk_cardapio; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY cardapio
    ADD CONSTRAINT pk_cardapio PRIMARY KEY (idcar);


--
-- Name: pk_cardapio_faixa_unidade; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY cardapio_faixa_unidade
    ADD CONSTRAINT pk_cardapio_faixa_unidade PRIMARY KEY (idfeu, idcar);


--
-- Name: pk_cardapio_produto; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY cardapio_produto
    ADD CONSTRAINT pk_cardapio_produto PRIMARY KEY (idcpr);


--
-- Name: pk_cardapio_receita; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY cardapio_receita
    ADD CONSTRAINT pk_cardapio_receita PRIMARY KEY (idcar, idrec);


--
-- Name: pk_cliente; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY cliente
    ADD CONSTRAINT pk_cliente PRIMARY KEY (idcli);


--
-- Name: pk_contrato; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY contrato
    ADD CONSTRAINT pk_contrato PRIMARY KEY (idcon);


--
-- Name: pk_contrato_produto; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY contrato_produto
    ADD CONSTRAINT pk_contrato_produto PRIMARY KEY (idcop);


--
-- Name: pk_cp_quimico; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY composto_quimico
    ADD CONSTRAINT pk_cp_quimico PRIMARY KEY (idcom);


--
-- Name: pk_evento; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY evento
    ADD CONSTRAINT pk_evento PRIMARY KEY (ideve);


--
-- Name: pk_faixa_composto_quimico; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY faixa_composto_quimico
    ADD CONSTRAINT pk_faixa_composto_quimico PRIMARY KEY (idfcp);


--
-- Name: pk_faixa_etaria; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY faixa_etaria
    ADD CONSTRAINT pk_faixa_etaria PRIMARY KEY (idfae);


--
-- Name: pk_fornecedor; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY fornecedor
    ADD CONSTRAINT pk_fornecedor PRIMARY KEY (idfor);


--
-- Name: pk_grp_quimico; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY grupo_quimico
    ADD CONSTRAINT pk_grp_quimico PRIMARY KEY (idgrpq);


--
-- Name: pk_guia_produto_diario; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY guia_produto_diario
    ADD CONSTRAINT pk_guia_produto_diario PRIMARY KEY (idguiaprodiario);


--
-- Name: pk_guia_remessa; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY guia_remessa
    ADD CONSTRAINT pk_guia_remessa PRIMARY KEY (idgui);


--
-- Name: pk_guia_remessa_produto; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY guia_remessa_produto
    ADD CONSTRAINT pk_guia_remessa_produto PRIMARY KEY (idgup);


--
-- Name: pk_log_guia_remessa; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY log_guia_remessa
    ADD CONSTRAINT pk_log_guia_remessa PRIMARY KEY (idlogguia);


--
-- Name: pk_medidas_caseiras; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY medidas_caseiras
    ADD CONSTRAINT pk_medidas_caseiras PRIMARY KEY (idmedcas, idcli);


--
-- Name: pk_pessoa; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY pessoa
    ADD CONSTRAINT pk_pessoa PRIMARY KEY (idpes);


--
-- Name: pk_prod_cp_quimico; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY produto_composto_quimico
    ADD CONSTRAINT pk_prod_cp_quimico PRIMARY KEY (idpcq);


--
-- Name: pk_produto; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY produto
    ADD CONSTRAINT pk_produto PRIMARY KEY (idpro);


--
-- Name: pk_produto_fornecedor; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY produto_fornecedor
    ADD CONSTRAINT pk_produto_fornecedor PRIMARY KEY (idprf);


--
-- Name: pk_produto_medida_caseira; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY produto_medida_caseira
    ADD CONSTRAINT pk_produto_medida_caseira PRIMARY KEY (idpmc);


--
-- Name: pk_rec_cp_quimico; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY receita_composto_quimico
    ADD CONSTRAINT pk_rec_cp_quimico PRIMARY KEY (idrcq);


--
-- Name: pk_rec_prod; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY receita_produto
    ADD CONSTRAINT pk_rec_prod PRIMARY KEY (idrpr);


--
-- Name: pk_receita; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY receita
    ADD CONSTRAINT pk_receita PRIMARY KEY (idrec);


--
-- Name: pk_tipo_unidade; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY tipo_unidade
    ADD CONSTRAINT pk_tipo_unidade PRIMARY KEY (idtip);


--
-- Name: pk_tp_produto; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY tipo_produto
    ADD CONSTRAINT pk_tp_produto PRIMARY KEY (idtip);


--
-- Name: pk_tp_refeicao; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY tipo_refeicao
    ADD CONSTRAINT pk_tp_refeicao PRIMARY KEY (idtre);


--
-- Name: pk_uni_faixa_etaria; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY unidade_faixa_etaria
    ADD CONSTRAINT pk_uni_faixa_etaria PRIMARY KEY (idfeu);


--
-- Name: pk_uni_produto; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY unidade_produto
    ADD CONSTRAINT pk_uni_produto PRIMARY KEY (idunp, idcli);


--
-- Name: pk_unidade_atendida; Type: CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY unidade_atendida
    ADD CONSTRAINT pk_unidade_atendida PRIMARY KEY (iduni);


SET search_path = cadastro, pg_catalog;

--
-- Name: fisica_foto_pkey; Type: CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica_foto
    ADD CONSTRAINT fisica_foto_pkey PRIMARY KEY (idpes);


--
-- Name: fisica_sangue_pkey; Type: CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica_sangue
    ADD CONSTRAINT fisica_sangue_pkey PRIMARY KEY (idpes);


--
-- Name: pk_aviso_nome; Type: CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY aviso_nome
    ADD CONSTRAINT pk_aviso_nome PRIMARY KEY (idpes, aviso);


--
-- Name: pk_cadastro_escolaridade; Type: CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY deficiencia
    ADD CONSTRAINT pk_cadastro_escolaridade PRIMARY KEY (cod_deficiencia);


--
-- Name: pk_documento; Type: CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY documento
    ADD CONSTRAINT pk_documento PRIMARY KEY (idpes);


--
-- Name: pk_endereco_externo; Type: CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY endereco_externo
    ADD CONSTRAINT pk_endereco_externo PRIMARY KEY (idpes, tipo);


--
-- Name: pk_endereco_pessoa; Type: CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY endereco_pessoa
    ADD CONSTRAINT pk_endereco_pessoa PRIMARY KEY (idpes, tipo);


--
-- Name: pk_escolaridade; Type: CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY escolaridade
    ADD CONSTRAINT pk_escolaridade PRIMARY KEY (idesco);


--
-- Name: pk_estado_civil; Type: CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY estado_civil
    ADD CONSTRAINT pk_estado_civil PRIMARY KEY (ideciv);


--
-- Name: pk_fisica; Type: CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica
    ADD CONSTRAINT pk_fisica PRIMARY KEY (idpes);


--
-- Name: pk_fisica_cpf; Type: CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica_cpf
    ADD CONSTRAINT pk_fisica_cpf PRIMARY KEY (idpes);


--
-- Name: pk_fisica_deficiencia; Type: CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica_deficiencia
    ADD CONSTRAINT pk_fisica_deficiencia PRIMARY KEY (ref_idpes, ref_cod_deficiencia);


--
-- Name: pk_fisica_raca; Type: CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica_raca
    ADD CONSTRAINT pk_fisica_raca PRIMARY KEY (ref_idpes);


--
-- Name: pk_fone_pessoa; Type: CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fone_pessoa
    ADD CONSTRAINT pk_fone_pessoa PRIMARY KEY (idpes, tipo);


--
-- Name: pk_funcionario; Type: CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY funcionario
    ADD CONSTRAINT pk_funcionario PRIMARY KEY (matricula, idins);


--
-- Name: pk_juridica; Type: CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY juridica
    ADD CONSTRAINT pk_juridica PRIMARY KEY (idpes);


--
-- Name: pk_ocupacao; Type: CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY ocupacao
    ADD CONSTRAINT pk_ocupacao PRIMARY KEY (idocup);


--
-- Name: pk_orgao_emissor_rg; Type: CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY orgao_emissor_rg
    ADD CONSTRAINT pk_orgao_emissor_rg PRIMARY KEY (idorg_rg);


--
-- Name: pk_pessoa; Type: CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY pessoa
    ADD CONSTRAINT pk_pessoa PRIMARY KEY (idpes);


--
-- Name: pk_pessoa_fonetico; Type: CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY pessoa_fonetico
    ADD CONSTRAINT pk_pessoa_fonetico PRIMARY KEY (fonema, idpes);


--
-- Name: pk_socio; Type: CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY socio
    ADD CONSTRAINT pk_socio PRIMARY KEY (idpes_juridica, idpes_fisica);


--
-- Name: raca_pkey; Type: CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY raca
    ADD CONSTRAINT raca_pkey PRIMARY KEY (cod_raca);


--
-- Name: religiao_pkey; Type: CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY religiao
    ADD CONSTRAINT religiao_pkey PRIMARY KEY (cod_religiao);


SET search_path = consistenciacao, pg_catalog;

--
-- Name: pk_campo_consistenciacao; Type: CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY campo_consistenciacao
    ADD CONSTRAINT pk_campo_consistenciacao PRIMARY KEY (idcam);


--
-- Name: pk_campo_metadado; Type: CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY campo_metadado
    ADD CONSTRAINT pk_campo_metadado PRIMARY KEY (id_campo_met);


--
-- Name: pk_confrontacao; Type: CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY confrontacao
    ADD CONSTRAINT pk_confrontacao PRIMARY KEY (idcon);


--
-- Name: pk_fonte; Type: CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY fonte
    ADD CONSTRAINT pk_fonte PRIMARY KEY (idfon);


--
-- Name: pk_historico_campo; Type: CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY historico_campo
    ADD CONSTRAINT pk_historico_campo PRIMARY KEY (idpes, idcam);


--
-- Name: pk_inc_pessoa_possivel; Type: CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY incoerencia_pessoa_possivel
    ADD CONSTRAINT pk_inc_pessoa_possivel PRIMARY KEY (idinc, idpes);


--
-- Name: pk_incoerencia; Type: CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY incoerencia
    ADD CONSTRAINT pk_incoerencia PRIMARY KEY (idinc);


--
-- Name: pk_incoerencia_documento; Type: CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY incoerencia_documento
    ADD CONSTRAINT pk_incoerencia_documento PRIMARY KEY (id_inc_doc);


--
-- Name: pk_incoerencia_endereco; Type: CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY incoerencia_endereco
    ADD CONSTRAINT pk_incoerencia_endereco PRIMARY KEY (id_inc_end);


--
-- Name: pk_incoerencia_fone; Type: CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY incoerencia_fone
    ADD CONSTRAINT pk_incoerencia_fone PRIMARY KEY (id_inc_fone);


--
-- Name: pk_incoerencia_tipo_incoerencia; Type: CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY incoerencia_tipo_incoerencia
    ADD CONSTRAINT pk_incoerencia_tipo_incoerencia PRIMARY KEY (id_tipo_inc, idinc);


--
-- Name: pk_metadado; Type: CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY metadado
    ADD CONSTRAINT pk_metadado PRIMARY KEY (idmet);


--
-- Name: pk_ocorrencia_regra_campo; Type: CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY ocorrencia_regra_campo
    ADD CONSTRAINT pk_ocorrencia_regra_campo PRIMARY KEY (idreg, conteudo_padrao);


--
-- Name: pk_regra_campo; Type: CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY regra_campo
    ADD CONSTRAINT pk_regra_campo PRIMARY KEY (idreg);


--
-- Name: pk_temp_cadastro_unificacao_cmf; Type: CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY temp_cadastro_unificacao_cmf
    ADD CONSTRAINT pk_temp_cadastro_unificacao_cmf PRIMARY KEY (idpes);


--
-- Name: pk_temp_cadastro_unificacao_siam; Type: CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY temp_cadastro_unificacao_siam
    ADD CONSTRAINT pk_temp_cadastro_unificacao_siam PRIMARY KEY (idpes);


--
-- Name: pk_tipo_incoerencia; Type: CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY tipo_incoerencia
    ADD CONSTRAINT pk_tipo_incoerencia PRIMARY KEY (id_tipo_inc);


SET search_path = modules, pg_catalog;

--
-- Name: area_conhecimento_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY area_conhecimento
    ADD CONSTRAINT area_conhecimento_pkey PRIMARY KEY (id, instituicao_id);


--
-- Name: calendario_turma_pk; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY calendario_turma
    ADD CONSTRAINT calendario_turma_pk PRIMARY KEY (calendario_ano_letivo_id, ano, mes, dia, turma_id);


--
-- Name: componente_curricular_ano_escolar_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY componente_curricular_ano_escolar
    ADD CONSTRAINT componente_curricular_ano_escolar_pkey PRIMARY KEY (componente_curricular_id, ano_escolar_id);


--
-- Name: componente_curricular_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY componente_curricular
    ADD CONSTRAINT componente_curricular_pkey PRIMARY KEY (id, instituicao_id);


--
-- Name: componente_curricular_turma_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY componente_curricular_turma
    ADD CONSTRAINT componente_curricular_turma_pkey PRIMARY KEY (componente_curricular_id, turma_id);


--
-- Name: docente_licenciatura_curso_unique; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY docente_licenciatura
    ADD CONSTRAINT docente_licenciatura_curso_unique UNIQUE (servidor_id, curso_id, ies_id);


--
-- Name: docente_licenciatura_pk; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY docente_licenciatura
    ADD CONSTRAINT docente_licenciatura_pk PRIMARY KEY (id);


--
-- Name: educacenso_cod_aluno_pk; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY educacenso_cod_aluno
    ADD CONSTRAINT educacenso_cod_aluno_pk PRIMARY KEY (cod_aluno, cod_aluno_inep);


--
-- Name: educacenso_cod_docente_pk; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY educacenso_cod_docente
    ADD CONSTRAINT educacenso_cod_docente_pk PRIMARY KEY (cod_servidor, cod_docente_inep);


--
-- Name: educacenso_cod_escola_pk; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY educacenso_cod_escola
    ADD CONSTRAINT educacenso_cod_escola_pk PRIMARY KEY (cod_escola, cod_escola_inep);


--
-- Name: educacenso_cod_turma_pk; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY educacenso_cod_turma
    ADD CONSTRAINT educacenso_cod_turma_pk PRIMARY KEY (cod_turma, cod_turma_inep);


--
-- Name: educacenso_curso_superior_pk; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY educacenso_curso_superior
    ADD CONSTRAINT educacenso_curso_superior_pk PRIMARY KEY (id);


--
-- Name: educacenso_ies_pk; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY educacenso_ies
    ADD CONSTRAINT educacenso_ies_pk PRIMARY KEY (id);


--
-- Name: empresa_transporte_escolar_cod_empresa_transporte_escolar_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY empresa_transporte_escolar
    ADD CONSTRAINT empresa_transporte_escolar_cod_empresa_transporte_escolar_pkey PRIMARY KEY (cod_empresa_transporte_escolar);


--
-- Name: etapas_curso_educacenso_pk; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY etapas_curso_educacenso
    ADD CONSTRAINT etapas_curso_educacenso_pk PRIMARY KEY (etapa_id, curso_id);


--
-- Name: etapas_educacenso_pk; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY etapas_educacenso
    ADD CONSTRAINT etapas_educacenso_pk PRIMARY KEY (id);


--
-- Name: falta_aluno_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY falta_aluno
    ADD CONSTRAINT falta_aluno_pkey PRIMARY KEY (id);


--
-- Name: falta_componente_curricular_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY falta_componente_curricular
    ADD CONSTRAINT falta_componente_curricular_pkey PRIMARY KEY (falta_aluno_id, componente_curricular_id, etapa);


--
-- Name: falta_geral_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY falta_geral
    ADD CONSTRAINT falta_geral_pkey PRIMARY KEY (falta_aluno_id, etapa);


--
-- Name: ficha_medica_cod_aluno_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY ficha_medica_aluno
    ADD CONSTRAINT ficha_medica_cod_aluno_pkey PRIMARY KEY (ref_cod_aluno);


--
-- Name: formula_media_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY formula_media
    ADD CONSTRAINT formula_media_pkey PRIMARY KEY (id, instituicao_id);


--
-- Name: itinerario_transporte_escolar_cod_itinerario_transporte_escolar; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY itinerario_transporte_escolar
    ADD CONSTRAINT itinerario_transporte_escolar_cod_itinerario_transporte_escolar PRIMARY KEY (cod_itinerario_transporte_escolar);


--
-- Name: lingua_indigena_educacenso_pk; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY lingua_indigena_educacenso
    ADD CONSTRAINT lingua_indigena_educacenso_pk PRIMARY KEY (id);


--
-- Name: media_geral_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY media_geral
    ADD CONSTRAINT media_geral_pkey PRIMARY KEY (nota_aluno_id, etapa);


--
-- Name: moradia_aluno_pkei; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY moradia_aluno
    ADD CONSTRAINT moradia_aluno_pkei PRIMARY KEY (ref_cod_aluno);


--
-- Name: motorista_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY motorista
    ADD CONSTRAINT motorista_pkey PRIMARY KEY (cod_motorista);


--
-- Name: nota_aluno_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY nota_aluno
    ADD CONSTRAINT nota_aluno_pkey PRIMARY KEY (id);


--
-- Name: nota_componente_curricular_media_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY nota_componente_curricular_media
    ADD CONSTRAINT nota_componente_curricular_media_pkey PRIMARY KEY (nota_aluno_id, componente_curricular_id);


--
-- Name: nota_componente_curricular_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY nota_componente_curricular
    ADD CONSTRAINT nota_componente_curricular_pkey PRIMARY KEY (nota_aluno_id, componente_curricular_id, etapa);


--
-- Name: nota_geral_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY nota_geral
    ADD CONSTRAINT nota_geral_pkey PRIMARY KEY (id);


--
-- Name: parecer_aluno_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY parecer_aluno
    ADD CONSTRAINT parecer_aluno_pkey PRIMARY KEY (id);


--
-- Name: parecer_componente_curricular_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY parecer_componente_curricular
    ADD CONSTRAINT parecer_componente_curricular_pkey PRIMARY KEY (id);


--
-- Name: parecer_geral_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY parecer_geral
    ADD CONSTRAINT parecer_geral_pkey PRIMARY KEY (id);


--
-- Name: pessoa_transporte_cod_pessoa_transporte_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY pessoa_transporte
    ADD CONSTRAINT pessoa_transporte_cod_pessoa_transporte_pkey PRIMARY KEY (cod_pessoa_transporte);


--
-- Name: ponto_transporte_escolar_cod_ponto_transporte_escolar_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY ponto_transporte_escolar
    ADD CONSTRAINT ponto_transporte_escolar_cod_ponto_transporte_escolar_pkey PRIMARY KEY (cod_ponto_transporte_escolar);


--
-- Name: professor_turma_disciplina_pk; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY professor_turma_disciplina
    ADD CONSTRAINT professor_turma_disciplina_pk PRIMARY KEY (professor_turma_id, componente_curricular_id);


--
-- Name: professor_turma_id_pk; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY professor_turma
    ADD CONSTRAINT professor_turma_id_pk PRIMARY KEY (id);


--
-- Name: regra_avaliacao_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY regra_avaliacao
    ADD CONSTRAINT regra_avaliacao_pkey PRIMARY KEY (id, instituicao_id);


--
-- Name: regra_avaliacao_recuperacao_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY regra_avaliacao_recuperacao
    ADD CONSTRAINT regra_avaliacao_recuperacao_pkey PRIMARY KEY (id);


--
-- Name: rota_transporte_escolar_cod_rota_transporte_escolar_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY rota_transporte_escolar
    ADD CONSTRAINT rota_transporte_escolar_cod_rota_transporte_escolar_pkey PRIMARY KEY (cod_rota_transporte_escolar);


--
-- Name: tabela_arredondamento_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY tabela_arredondamento
    ADD CONSTRAINT tabela_arredondamento_pkey PRIMARY KEY (id, instituicao_id);


--
-- Name: tabela_arredondamento_valor_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY tabela_arredondamento_valor
    ADD CONSTRAINT tabela_arredondamento_valor_pkey PRIMARY KEY (id);


--
-- Name: tipo_veiculo_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY tipo_veiculo
    ADD CONSTRAINT tipo_veiculo_pkey PRIMARY KEY (cod_tipo_veiculo);


--
-- Name: transporte_aluno_pk; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY transporte_aluno
    ADD CONSTRAINT transporte_aluno_pk PRIMARY KEY (aluno_id);


--
-- Name: uniforme_aluno_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY uniforme_aluno
    ADD CONSTRAINT uniforme_aluno_pkey PRIMARY KEY (ref_cod_aluno);


--
-- Name: veiculo_pkey; Type: CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY veiculo
    ADD CONSTRAINT veiculo_pkey PRIMARY KEY (cod_veiculo);


SET search_path = pmiacoes, pg_catalog;

--
-- Name: acao_governo_arquivo_pkey; Type: CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY acao_governo_arquivo
    ADD CONSTRAINT acao_governo_arquivo_pkey PRIMARY KEY (cod_acao_governo_arquivo);


--
-- Name: acao_governo_categoria_pkey; Type: CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY acao_governo_categoria
    ADD CONSTRAINT acao_governo_categoria_pkey PRIMARY KEY (ref_cod_categoria, ref_cod_acao_governo);


--
-- Name: acao_governo_foto_pkey; Type: CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY acao_governo_foto
    ADD CONSTRAINT acao_governo_foto_pkey PRIMARY KEY (cod_acao_governo_foto);


--
-- Name: acao_governo_foto_portal_pkey; Type: CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY acao_governo_foto_portal
    ADD CONSTRAINT acao_governo_foto_portal_pkey PRIMARY KEY (ref_cod_acao_governo, ref_cod_foto_portal);


--
-- Name: acao_governo_noticia_pkey; Type: CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY acao_governo_noticia
    ADD CONSTRAINT acao_governo_noticia_pkey PRIMARY KEY (ref_cod_acao_governo, ref_cod_not_portal);


--
-- Name: acao_governo_pkey; Type: CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY acao_governo
    ADD CONSTRAINT acao_governo_pkey PRIMARY KEY (cod_acao_governo);


--
-- Name: acao_governo_setor_pkey; Type: CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY acao_governo_setor
    ADD CONSTRAINT acao_governo_setor_pkey PRIMARY KEY (ref_cod_acao_governo, ref_cod_setor);


--
-- Name: categoria_pkey; Type: CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY categoria
    ADD CONSTRAINT categoria_pkey PRIMARY KEY (cod_categoria);


--
-- Name: secretaria_responsavel_pkey; Type: CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY secretaria_responsavel
    ADD CONSTRAINT secretaria_responsavel_pkey PRIMARY KEY (ref_cod_setor);


SET search_path = pmicontrolesis, pg_catalog;

--
-- Name: acontecimento_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY acontecimento
    ADD CONSTRAINT acontecimento_pkey PRIMARY KEY (cod_acontecimento);


--
-- Name: artigo_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY artigo
    ADD CONSTRAINT artigo_pkey PRIMARY KEY (cod_artigo);


--
-- Name: foto_evento_pk; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY foto_evento
    ADD CONSTRAINT foto_evento_pk PRIMARY KEY (cod_foto_evento);


--
-- Name: foto_vinc_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY foto_vinc
    ADD CONSTRAINT foto_vinc_pkey PRIMARY KEY (cod_foto_vinc);


--
-- Name: itinerario_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY itinerario
    ADD CONSTRAINT itinerario_pkey PRIMARY KEY (cod_itinerario);


--
-- Name: menu_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY menu
    ADD CONSTRAINT menu_pkey PRIMARY KEY (cod_menu);


--
-- Name: menu_portal_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY menu_portal
    ADD CONSTRAINT menu_portal_pkey PRIMARY KEY (cod_menu_portal);


--
-- Name: portais_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY portais
    ADD CONSTRAINT portais_pkey PRIMARY KEY (cod_portais);


--
-- Name: servicos_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY servicos
    ADD CONSTRAINT servicos_pkey PRIMARY KEY (cod_servicos);


--
-- Name: sistema_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY sistema
    ADD CONSTRAINT sistema_pkey PRIMARY KEY (cod_sistema);


--
-- Name: submenu_portal_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY submenu_portal
    ADD CONSTRAINT submenu_portal_pkey PRIMARY KEY (cod_submenu_portal);


--
-- Name: telefones_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY telefones
    ADD CONSTRAINT telefones_pkey PRIMARY KEY (cod_telefones);


--
-- Name: tipo_acontecimento_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY tipo_acontecimento
    ADD CONSTRAINT tipo_acontecimento_pkey PRIMARY KEY (cod_tipo_acontecimento);


--
-- Name: topo_portal_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY topo_portal
    ADD CONSTRAINT topo_portal_pkey PRIMARY KEY (cod_topo_portal);


--
-- Name: tutormenu_pkey; Type: CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY tutormenu
    ADD CONSTRAINT tutormenu_pkey PRIMARY KEY (cod_tutormenu);


SET search_path = pmidrh, pg_catalog;

--
-- Name: diaria_grupo_pkey; Type: CONSTRAINT; Schema: pmidrh; Owner: postgres
--

ALTER TABLE ONLY diaria_grupo
    ADD CONSTRAINT diaria_grupo_pkey PRIMARY KEY (cod_diaria_grupo);


--
-- Name: diaria_pkey; Type: CONSTRAINT; Schema: pmidrh; Owner: postgres
--

ALTER TABLE ONLY diaria
    ADD CONSTRAINT diaria_pkey PRIMARY KEY (cod_diaria);


--
-- Name: diaria_valores_pkey; Type: CONSTRAINT; Schema: pmidrh; Owner: postgres
--

ALTER TABLE ONLY diaria_valores
    ADD CONSTRAINT diaria_valores_pkey PRIMARY KEY (cod_diaria_valores);


--
-- Name: setor_pkey; Type: CONSTRAINT; Schema: pmidrh; Owner: postgres
--

ALTER TABLE ONLY setor
    ADD CONSTRAINT setor_pkey PRIMARY KEY (cod_setor);


SET search_path = pmieducar, pg_catalog;

--
-- Name: acervo_acervo_assunto_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_acervo_assunto
    ADD CONSTRAINT acervo_acervo_assunto_pkey PRIMARY KEY (ref_cod_acervo, ref_cod_acervo_assunto);


--
-- Name: acervo_acervo_autor_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_acervo_autor
    ADD CONSTRAINT acervo_acervo_autor_pkey PRIMARY KEY (ref_cod_acervo_autor, ref_cod_acervo);


--
-- Name: acervo_assunto_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_assunto
    ADD CONSTRAINT acervo_assunto_pkey PRIMARY KEY (cod_acervo_assunto);


--
-- Name: acervo_autor_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_autor
    ADD CONSTRAINT acervo_autor_pkey PRIMARY KEY (cod_acervo_autor);


--
-- Name: acervo_colecao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_colecao
    ADD CONSTRAINT acervo_colecao_pkey PRIMARY KEY (cod_acervo_colecao);


--
-- Name: acervo_editora_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_editora
    ADD CONSTRAINT acervo_editora_pkey PRIMARY KEY (cod_acervo_editora);


--
-- Name: acervo_idioma_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_idioma
    ADD CONSTRAINT acervo_idioma_pkey PRIMARY KEY (cod_acervo_idioma);


--
-- Name: acervo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo
    ADD CONSTRAINT acervo_pkey PRIMARY KEY (cod_acervo);


--
-- Name: aluno_aluno_beneficio_pk; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY aluno_aluno_beneficio
    ADD CONSTRAINT aluno_aluno_beneficio_pk PRIMARY KEY (aluno_id, aluno_beneficio_id);


--
-- Name: aluno_beneficio_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY aluno_beneficio
    ADD CONSTRAINT aluno_beneficio_pkey PRIMARY KEY (cod_aluno_beneficio);


--
-- Name: aluno_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY aluno
    ADD CONSTRAINT aluno_pkey PRIMARY KEY (cod_aluno);


--
-- Name: aluno_ref_idpes_un; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY aluno
    ADD CONSTRAINT aluno_ref_idpes_un UNIQUE (ref_idpes);


--
-- Name: ano_letivo_modulo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY ano_letivo_modulo
    ADD CONSTRAINT ano_letivo_modulo_pkey PRIMARY KEY (ref_ano, ref_ref_cod_escola, sequencial, ref_cod_modulo);


--
-- Name: auditoria_falta_componente_dispensa_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: ieducar
--

ALTER TABLE ONLY auditoria_falta_componente_dispensa
    ADD CONSTRAINT auditoria_falta_componente_dispensa_pkey PRIMARY KEY (id);


--
-- Name: auditoria_nota_dispensa_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: ieducar
--

ALTER TABLE ONLY auditoria_nota_dispensa
    ADD CONSTRAINT auditoria_nota_dispensa_pkey PRIMARY KEY (id);


--
-- Name: avaliacao_desempenho_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY avaliacao_desempenho
    ADD CONSTRAINT avaliacao_desempenho_pkey PRIMARY KEY (sequencial, ref_cod_servidor, ref_ref_cod_instituicao);


--
-- Name: backup_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: ieducar
--

ALTER TABLE ONLY backup
    ADD CONSTRAINT backup_pkey PRIMARY KEY (id);


--
-- Name: biblioteca_dia_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY biblioteca_dia
    ADD CONSTRAINT biblioteca_dia_pkey PRIMARY KEY (ref_cod_biblioteca, dia);


--
-- Name: biblioteca_feriados_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY biblioteca_feriados
    ADD CONSTRAINT biblioteca_feriados_pkey PRIMARY KEY (cod_feriado);


--
-- Name: biblioteca_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY biblioteca
    ADD CONSTRAINT biblioteca_pkey PRIMARY KEY (cod_biblioteca);


--
-- Name: biblioteca_usuario_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY biblioteca_usuario
    ADD CONSTRAINT biblioteca_usuario_pkey PRIMARY KEY (ref_cod_biblioteca, ref_cod_usuario);


--
-- Name: calendario_ano_letivo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY calendario_ano_letivo
    ADD CONSTRAINT calendario_ano_letivo_pkey PRIMARY KEY (cod_calendario_ano_letivo);


--
-- Name: calendario_anotacao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY calendario_anotacao
    ADD CONSTRAINT calendario_anotacao_pkey PRIMARY KEY (cod_calendario_anotacao);


--
-- Name: calendario_dia_anotacao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY calendario_dia_anotacao
    ADD CONSTRAINT calendario_dia_anotacao_pkey PRIMARY KEY (ref_dia, ref_mes, ref_ref_cod_calendario_ano_letivo, ref_cod_calendario_anotacao);


--
-- Name: calendario_dia_motivo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY calendario_dia_motivo
    ADD CONSTRAINT calendario_dia_motivo_pkey PRIMARY KEY (cod_calendario_dia_motivo);


--
-- Name: calendario_dia_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY calendario_dia
    ADD CONSTRAINT calendario_dia_pkey PRIMARY KEY (ref_cod_calendario_ano_letivo, mes, dia);


--
-- Name: categoria_nivel_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY categoria_nivel
    ADD CONSTRAINT categoria_nivel_pkey PRIMARY KEY (cod_categoria_nivel);


--
-- Name: categoria_obra_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY categoria_obra
    ADD CONSTRAINT categoria_obra_pkey PRIMARY KEY (id);


--
-- Name: cliente_login_ukey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY cliente
    ADD CONSTRAINT cliente_login_ukey UNIQUE (login);


--
-- Name: cliente_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY cliente
    ADD CONSTRAINT cliente_pkey PRIMARY KEY (cod_cliente);


--
-- Name: cliente_suspensao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY cliente_suspensao
    ADD CONSTRAINT cliente_suspensao_pkey PRIMARY KEY (sequencial, ref_cod_cliente, ref_cod_motivo_suspensao);


--
-- Name: cliente_tipo_cliente_pk; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY cliente_tipo_cliente
    ADD CONSTRAINT cliente_tipo_cliente_pk PRIMARY KEY (ref_cod_cliente_tipo, ref_cod_cliente);


--
-- Name: cliente_tipo_exemplar_tipo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY cliente_tipo_exemplar_tipo
    ADD CONSTRAINT cliente_tipo_exemplar_tipo_pkey PRIMARY KEY (ref_cod_cliente_tipo, ref_cod_exemplar_tipo);


--
-- Name: cliente_tipo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY cliente_tipo
    ADD CONSTRAINT cliente_tipo_pkey PRIMARY KEY (cod_cliente_tipo);


--
-- Name: cod_candidato_reserva_vaga_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY candidato_reserva_vaga
    ADD CONSTRAINT cod_candidato_reserva_vaga_pkey PRIMARY KEY (cod_candidato_reserva_vaga);


--
-- Name: cod_disciplina_dependencia_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY disciplina_dependencia
    ADD CONSTRAINT cod_disciplina_dependencia_pkey PRIMARY KEY (cod_disciplina_dependencia);


--
-- Name: cod_dispensa_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY dispensa_disciplina
    ADD CONSTRAINT cod_dispensa_pkey PRIMARY KEY (cod_dispensa);


--
-- Name: cod_serie_vaga_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY serie_vaga
    ADD CONSTRAINT cod_serie_vaga_pkey PRIMARY KEY (cod_serie_vaga);


--
-- Name: cod_serie_vaga_unique; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY serie_vaga
    ADD CONSTRAINT cod_serie_vaga_unique UNIQUE (ano, ref_cod_instituicao, ref_cod_escola, ref_cod_curso, ref_cod_serie, turno);


--
-- Name: cod_servidor_funcao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor_funcao
    ADD CONSTRAINT cod_servidor_funcao_pkey PRIMARY KEY (cod_servidor_funcao);


--
-- Name: coffebreak_tipo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY coffebreak_tipo
    ADD CONSTRAINT coffebreak_tipo_pkey PRIMARY KEY (cod_coffebreak_tipo);


--
-- Name: curso_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY curso
    ADD CONSTRAINT curso_pkey PRIMARY KEY (cod_curso);


--
-- Name: disciplina_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY disciplina
    ADD CONSTRAINT disciplina_pkey PRIMARY KEY (cod_disciplina);


--
-- Name: disciplina_serie_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY disciplina_serie
    ADD CONSTRAINT disciplina_serie_pkey PRIMARY KEY (ref_cod_disciplina, ref_cod_serie);


--
-- Name: disciplina_topico_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY disciplina_topico
    ADD CONSTRAINT disciplina_topico_pkey PRIMARY KEY (cod_disciplina_topico);


--
-- Name: distribuicao_uniforme_cod_distribuicao_uniforme_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY distribuicao_uniforme
    ADD CONSTRAINT distribuicao_uniforme_cod_distribuicao_uniforme_pkey PRIMARY KEY (cod_distribuicao_uniforme);


--
-- Name: escola_ano_letivo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola_ano_letivo
    ADD CONSTRAINT escola_ano_letivo_pkey PRIMARY KEY (ref_cod_escola, ano);


--
-- Name: escola_complemento_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola_complemento
    ADD CONSTRAINT escola_complemento_pkey PRIMARY KEY (ref_cod_escola);


--
-- Name: escola_curso_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola_curso
    ADD CONSTRAINT escola_curso_pkey PRIMARY KEY (ref_cod_escola, ref_cod_curso);


--
-- Name: escola_localizacao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola_localizacao
    ADD CONSTRAINT escola_localizacao_pkey PRIMARY KEY (cod_escola_localizacao);


--
-- Name: escola_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola
    ADD CONSTRAINT escola_pkey PRIMARY KEY (cod_escola);


--
-- Name: escola_rede_ensino_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola_rede_ensino
    ADD CONSTRAINT escola_rede_ensino_pkey PRIMARY KEY (cod_escola_rede_ensino);


--
-- Name: escola_serie_disciplina_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola_serie_disciplina
    ADD CONSTRAINT escola_serie_disciplina_pkey PRIMARY KEY (ref_ref_cod_serie, ref_ref_cod_escola, ref_cod_disciplina);


--
-- Name: escola_serie_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola_serie
    ADD CONSTRAINT escola_serie_pkey PRIMARY KEY (ref_cod_escola, ref_cod_serie);


--
-- Name: escola_usuario_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: ieducar
--

ALTER TABLE ONLY escola_usuario
    ADD CONSTRAINT escola_usuario_pkey PRIMARY KEY (id);


--
-- Name: exemplar_emprestimo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY exemplar_emprestimo
    ADD CONSTRAINT exemplar_emprestimo_pkey PRIMARY KEY (cod_emprestimo);


--
-- Name: exemplar_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY exemplar
    ADD CONSTRAINT exemplar_pkey PRIMARY KEY (cod_exemplar);


--
-- Name: exemplar_tipo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY exemplar_tipo
    ADD CONSTRAINT exemplar_tipo_pkey PRIMARY KEY (cod_exemplar_tipo);


--
-- Name: falta_aluno_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY falta_aluno
    ADD CONSTRAINT falta_aluno_pkey PRIMARY KEY (cod_falta_aluno);


--
-- Name: falta_atraso_compensado_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY falta_atraso_compensado
    ADD CONSTRAINT falta_atraso_compensado_pkey PRIMARY KEY (cod_compensado);


--
-- Name: falta_atraso_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY falta_atraso
    ADD CONSTRAINT falta_atraso_pkey PRIMARY KEY (cod_falta_atraso);


--
-- Name: faltas_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY faltas
    ADD CONSTRAINT faltas_pkey PRIMARY KEY (ref_cod_matricula, sequencial);


--
-- Name: fk_bloqueio_lancamento_faltas_notas; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY bloqueio_lancamento_faltas_notas
    ADD CONSTRAINT fk_bloqueio_lancamento_faltas_notas PRIMARY KEY (cod_bloqueio);


--
-- Name: fonte_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY fonte
    ADD CONSTRAINT fonte_pkey PRIMARY KEY (cod_fonte);


--
-- Name: funcao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY funcao
    ADD CONSTRAINT funcao_pkey PRIMARY KEY (cod_funcao);


--
-- Name: habilitacao_curso_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY habilitacao_curso
    ADD CONSTRAINT habilitacao_curso_pkey PRIMARY KEY (ref_cod_habilitacao, ref_cod_curso);


--
-- Name: habilitacao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY habilitacao
    ADD CONSTRAINT habilitacao_pkey PRIMARY KEY (cod_habilitacao);


--
-- Name: historico_disciplinas_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY historico_disciplinas
    ADD CONSTRAINT historico_disciplinas_pkey PRIMARY KEY (sequencial, ref_ref_cod_aluno, ref_sequencial);


--
-- Name: historico_escolar_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY historico_escolar
    ADD CONSTRAINT historico_escolar_pkey PRIMARY KEY (ref_cod_aluno, sequencial);


--
-- Name: historico_grade_curso_pk; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY historico_grade_curso
    ADD CONSTRAINT historico_grade_curso_pk PRIMARY KEY (id);


--
-- Name: infra_comodo_funcao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY infra_comodo_funcao
    ADD CONSTRAINT infra_comodo_funcao_pkey PRIMARY KEY (cod_infra_comodo_funcao);


--
-- Name: infra_predio_comodo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY infra_predio_comodo
    ADD CONSTRAINT infra_predio_comodo_pkey PRIMARY KEY (cod_infra_predio_comodo);


--
-- Name: infra_predio_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY infra_predio
    ADD CONSTRAINT infra_predio_pkey PRIMARY KEY (cod_infra_predio);


--
-- Name: instituicao_documentacao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY instituicao_documentacao
    ADD CONSTRAINT instituicao_documentacao_pkey PRIMARY KEY (id);


--
-- Name: instituicao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY instituicao
    ADD CONSTRAINT instituicao_pkey PRIMARY KEY (cod_instituicao);


--
-- Name: material_didatico_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY material_didatico
    ADD CONSTRAINT material_didatico_pkey PRIMARY KEY (cod_material_didatico);


--
-- Name: material_tipo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY material_tipo
    ADD CONSTRAINT material_tipo_pkey PRIMARY KEY (cod_material_tipo);


--
-- Name: matricula_excessao_pk; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY matricula_excessao
    ADD CONSTRAINT matricula_excessao_pk PRIMARY KEY (cod_aluno_excessao);


--
-- Name: matricula_ocorrencia_disciplinar_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY matricula_ocorrencia_disciplinar
    ADD CONSTRAINT matricula_ocorrencia_disciplinar_pkey PRIMARY KEY (ref_cod_matricula, ref_cod_tipo_ocorrencia_disciplinar, sequencial);


--
-- Name: matricula_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY matricula
    ADD CONSTRAINT matricula_pkey PRIMARY KEY (cod_matricula);


--
-- Name: matricula_turma_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY matricula_turma
    ADD CONSTRAINT matricula_turma_pkey PRIMARY KEY (ref_cod_matricula, ref_cod_turma, sequencial);


--
-- Name: menu_tipo_usuario_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY menu_tipo_usuario
    ADD CONSTRAINT menu_tipo_usuario_pkey PRIMARY KEY (ref_cod_tipo_usuario, ref_cod_menu_submenu);


--
-- Name: modulo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY modulo
    ADD CONSTRAINT modulo_pkey PRIMARY KEY (cod_modulo);


--
-- Name: motivo_afastamento_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY motivo_afastamento
    ADD CONSTRAINT motivo_afastamento_pkey PRIMARY KEY (cod_motivo_afastamento);


--
-- Name: motivo_baixa_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY motivo_baixa
    ADD CONSTRAINT motivo_baixa_pkey PRIMARY KEY (cod_motivo_baixa);


--
-- Name: motivo_suspensao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY motivo_suspensao
    ADD CONSTRAINT motivo_suspensao_pkey PRIMARY KEY (cod_motivo_suspensao);


--
-- Name: nivel_ensino_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY nivel_ensino
    ADD CONSTRAINT nivel_ensino_pkey PRIMARY KEY (cod_nivel_ensino);


--
-- Name: nivel_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY nivel
    ADD CONSTRAINT nivel_pkey PRIMARY KEY (cod_nivel);


--
-- Name: nota_aluno_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY nota_aluno
    ADD CONSTRAINT nota_aluno_pkey PRIMARY KEY (cod_nota_aluno);


--
-- Name: operador_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY operador
    ADD CONSTRAINT operador_pkey PRIMARY KEY (cod_operador);


--
-- Name: pagamento_multa_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY pagamento_multa
    ADD CONSTRAINT pagamento_multa_pkey PRIMARY KEY (cod_pagamento_multa);


--
-- Name: pk_cod_abandono_tipo; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY abandono_tipo
    ADD CONSTRAINT pk_cod_abandono_tipo PRIMARY KEY (cod_abandono_tipo);


--
-- Name: pmieducar_bloqueio_ano_letivo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY bloqueio_ano_letivo
    ADD CONSTRAINT pmieducar_bloqueio_ano_letivo_pkey PRIMARY KEY (ref_cod_instituicao, ref_ano);


--
-- Name: pmieducar_projeto_aluno_pk; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY projeto_aluno
    ADD CONSTRAINT pmieducar_projeto_aluno_pk PRIMARY KEY (ref_cod_projeto, ref_cod_aluno);


--
-- Name: pmieducar_projeto_cod_projeto; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY projeto
    ADD CONSTRAINT pmieducar_projeto_cod_projeto PRIMARY KEY (cod_projeto);


--
-- Name: pre_requisito_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY pre_requisito
    ADD CONSTRAINT pre_requisito_pkey PRIMARY KEY (cod_pre_requisito);


--
-- Name: quadro_horario_horarios_aux_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY quadro_horario_horarios_aux
    ADD CONSTRAINT quadro_horario_horarios_aux_pkey PRIMARY KEY (ref_cod_quadro_horario, sequencial);


--
-- Name: quadro_horario_horarios_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY quadro_horario_horarios
    ADD CONSTRAINT quadro_horario_horarios_pkey PRIMARY KEY (ref_cod_quadro_horario, sequencial);


--
-- Name: quadro_horario_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY quadro_horario
    ADD CONSTRAINT quadro_horario_pkey PRIMARY KEY (cod_quadro_horario);


--
-- Name: quantidade_reserva_externa_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY quantidade_reserva_externa
    ADD CONSTRAINT quantidade_reserva_externa_pkey PRIMARY KEY (ref_cod_instituicao, ref_cod_escola, ref_cod_curso, ref_cod_serie, ref_turma_turno_id, ano);


--
-- Name: religiao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY religiao
    ADD CONSTRAINT religiao_pkey PRIMARY KEY (cod_religiao);


--
-- Name: reserva_vaga_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY reserva_vaga
    ADD CONSTRAINT reserva_vaga_pkey PRIMARY KEY (cod_reserva_vaga);


--
-- Name: reservas_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY reservas
    ADD CONSTRAINT reservas_pkey PRIMARY KEY (cod_reserva);


--
-- Name: sequencia_serie_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY sequencia_serie
    ADD CONSTRAINT sequencia_serie_pkey PRIMARY KEY (ref_serie_origem, ref_serie_destino);


--
-- Name: serie_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY serie
    ADD CONSTRAINT serie_pkey PRIMARY KEY (cod_serie);


--
-- Name: serie_pre_requisito_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY serie_pre_requisito
    ADD CONSTRAINT serie_pre_requisito_pkey PRIMARY KEY (ref_cod_pre_requisito, ref_cod_operador, ref_cod_serie);


--
-- Name: servidor_afastamento_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor_afastamento
    ADD CONSTRAINT servidor_afastamento_pkey PRIMARY KEY (ref_cod_servidor, sequencial, ref_ref_cod_instituicao);


--
-- Name: servidor_alocacao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor_alocacao
    ADD CONSTRAINT servidor_alocacao_pkey PRIMARY KEY (cod_servidor_alocacao);


--
-- Name: servidor_curso_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor_curso
    ADD CONSTRAINT servidor_curso_pkey PRIMARY KEY (cod_servidor_curso);


--
-- Name: servidor_cuso_ministra_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor_curso_ministra
    ADD CONSTRAINT servidor_cuso_ministra_pkey PRIMARY KEY (ref_cod_curso, ref_ref_cod_instituicao, ref_cod_servidor);


--
-- Name: servidor_disciplina_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor_disciplina
    ADD CONSTRAINT servidor_disciplina_pkey PRIMARY KEY (ref_cod_disciplina, ref_ref_cod_instituicao, ref_cod_servidor, ref_cod_curso);


--
-- Name: servidor_formacao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor_formacao
    ADD CONSTRAINT servidor_formacao_pkey PRIMARY KEY (cod_formacao);


--
-- Name: servidor_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor
    ADD CONSTRAINT servidor_pkey PRIMARY KEY (cod_servidor, ref_cod_instituicao);


--
-- Name: servidor_titulo_concurso_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor_titulo_concurso
    ADD CONSTRAINT servidor_titulo_concurso_pkey PRIMARY KEY (cod_servidor_titulo);


--
-- Name: situacao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY situacao
    ADD CONSTRAINT situacao_pkey PRIMARY KEY (cod_situacao);


--
-- Name: subnivel_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY subnivel
    ADD CONSTRAINT subnivel_pkey PRIMARY KEY (cod_subnivel);


--
-- Name: tipo_avaliacao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY tipo_avaliacao
    ADD CONSTRAINT tipo_avaliacao_pkey PRIMARY KEY (cod_tipo_avaliacao);


--
-- Name: tipo_avaliacao_valores_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY tipo_avaliacao_valores
    ADD CONSTRAINT tipo_avaliacao_valores_pkey PRIMARY KEY (ref_cod_tipo_avaliacao, sequencial);


--
-- Name: tipo_dispensa_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY tipo_dispensa
    ADD CONSTRAINT tipo_dispensa_pkey PRIMARY KEY (cod_tipo_dispensa);


--
-- Name: tipo_ensino_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY tipo_ensino
    ADD CONSTRAINT tipo_ensino_pkey PRIMARY KEY (cod_tipo_ensino);


--
-- Name: tipo_ocorrencia_disciplinar_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY tipo_ocorrencia_disciplinar
    ADD CONSTRAINT tipo_ocorrencia_disciplinar_pkey PRIMARY KEY (cod_tipo_ocorrencia_disciplinar);


--
-- Name: tipo_regime_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY tipo_regime
    ADD CONSTRAINT tipo_regime_pkey PRIMARY KEY (cod_tipo_regime);


--
-- Name: tipo_usuario_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY tipo_usuario
    ADD CONSTRAINT tipo_usuario_pkey PRIMARY KEY (cod_tipo_usuario);


--
-- Name: transferencia_solicitacao_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY transferencia_solicitacao
    ADD CONSTRAINT transferencia_solicitacao_pkey PRIMARY KEY (cod_transferencia_solicitacao);


--
-- Name: transferencia_tipo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY transferencia_tipo
    ADD CONSTRAINT transferencia_tipo_pkey PRIMARY KEY (cod_transferencia_tipo);


--
-- Name: turma_dia_semana_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY turma_dia_semana
    ADD CONSTRAINT turma_dia_semana_pkey PRIMARY KEY (dia_semana, ref_cod_turma);


--
-- Name: turma_modulo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY turma_modulo
    ADD CONSTRAINT turma_modulo_pkey PRIMARY KEY (ref_cod_turma, ref_cod_modulo, sequencial);


--
-- Name: turma_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY turma
    ADD CONSTRAINT turma_pkey PRIMARY KEY (cod_turma);


--
-- Name: turma_tipo_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY turma_tipo
    ADD CONSTRAINT turma_tipo_pkey PRIMARY KEY (cod_turma_tipo);


--
-- Name: turma_turno_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY turma_turno
    ADD CONSTRAINT turma_turno_pkey PRIMARY KEY (id);


--
-- Name: usuario_pkey; Type: CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY usuario
    ADD CONSTRAINT usuario_pkey PRIMARY KEY (cod_usuario);


SET search_path = pmiotopic, pg_catalog;

--
-- Name: funcionario_su_pkey; Type: CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY funcionario_su
    ADD CONSTRAINT funcionario_su_pkey PRIMARY KEY (ref_ref_cod_pessoa_fj);


--
-- Name: grupomoderador_pkey; Type: CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY grupomoderador
    ADD CONSTRAINT grupomoderador_pkey PRIMARY KEY (ref_ref_cod_pessoa_fj, ref_cod_grupos);


--
-- Name: grupopessoa_pkey; Type: CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY grupopessoa
    ADD CONSTRAINT grupopessoa_pkey PRIMARY KEY (ref_idpes, ref_cod_grupos);


--
-- Name: grupos_pkey; Type: CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY grupos
    ADD CONSTRAINT grupos_pkey PRIMARY KEY (cod_grupos);


--
-- Name: notas_pkey; Type: CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY notas
    ADD CONSTRAINT notas_pkey PRIMARY KEY (sequencial, ref_idpes);


--
-- Name: participante_pkey; Type: CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY participante
    ADD CONSTRAINT participante_pkey PRIMARY KEY (sequencial, ref_ref_cod_grupos, ref_ref_idpes, ref_cod_reuniao);


--
-- Name: reuniao_pkey; Type: CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY reuniao
    ADD CONSTRAINT reuniao_pkey PRIMARY KEY (cod_reuniao);


--
-- Name: topico_pkey; Type: CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY topico
    ADD CONSTRAINT topico_pkey PRIMARY KEY (cod_topico);


--
-- Name: topicoreuniao_pkey; Type: CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY topicoreuniao
    ADD CONSTRAINT topicoreuniao_pkey PRIMARY KEY (ref_cod_topico, ref_cod_reuniao);


SET search_path = portal, pg_catalog;

--
-- Name: acesso_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY acesso
    ADD CONSTRAINT acesso_pk PRIMARY KEY (cod_acesso);


--
-- Name: agenda_compromisso_pkey; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY agenda_compromisso
    ADD CONSTRAINT agenda_compromisso_pkey PRIMARY KEY (cod_agenda_compromisso, versao, ref_cod_agenda);


--
-- Name: agenda_pkey; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY agenda
    ADD CONSTRAINT agenda_pkey PRIMARY KEY (cod_agenda);


--
-- Name: agenda_pref_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY agenda_pref
    ADD CONSTRAINT agenda_pref_pk PRIMARY KEY (cod_comp);


--
-- Name: agenda_responsavel_pkey; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY agenda_responsavel
    ADD CONSTRAINT agenda_responsavel_pkey PRIMARY KEY (ref_cod_agenda, ref_ref_cod_pessoa_fj);


--
-- Name: compras_editais_editais_empresas_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY compras_editais_editais_empresas
    ADD CONSTRAINT compras_editais_editais_empresas_pk PRIMARY KEY (ref_cod_compras_editais_editais, ref_cod_compras_editais_empresa, data_hora);


--
-- Name: compras_editais_editais_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY compras_editais_editais
    ADD CONSTRAINT compras_editais_editais_pk PRIMARY KEY (cod_compras_editais_editais);


--
-- Name: compras_editais_empresa_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY compras_editais_empresa
    ADD CONSTRAINT compras_editais_empresa_pk PRIMARY KEY (cod_compras_editais_empresa);


--
-- Name: compras_final_pregao_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY compras_final_pregao
    ADD CONSTRAINT compras_final_pregao_pk PRIMARY KEY (cod_compras_final_pregao);


--
-- Name: compras_funcionarios_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY compras_funcionarios
    ADD CONSTRAINT compras_funcionarios_pk PRIMARY KEY (ref_ref_cod_pessoa_fj);


--
-- Name: compras_licitacoes_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY compras_licitacoes
    ADD CONSTRAINT compras_licitacoes_pk PRIMARY KEY (cod_compras_licitacoes);


--
-- Name: compras_modalidade_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY compras_modalidade
    ADD CONSTRAINT compras_modalidade_pk PRIMARY KEY (cod_compras_modalidade);


--
-- Name: compras_pregao_execucao_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY compras_pregao_execucao
    ADD CONSTRAINT compras_pregao_execucao_pk PRIMARY KEY (cod_compras_pregao_execucao);


--
-- Name: compras_prestacao_contas_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY compras_prestacao_contas
    ADD CONSTRAINT compras_prestacao_contas_pk PRIMARY KEY (cod_compras_prestacao_contas);


--
-- Name: foto_portal_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY foto_portal
    ADD CONSTRAINT foto_portal_pk PRIMARY KEY (cod_foto_portal);


--
-- Name: foto_secao_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY foto_secao
    ADD CONSTRAINT foto_secao_pk PRIMARY KEY (cod_foto_secao);


--
-- Name: funcionario_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY funcionario
    ADD CONSTRAINT funcionario_pk PRIMARY KEY (ref_cod_pessoa_fj);


--
-- Name: funcionario_vinculo_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY funcionario_vinculo
    ADD CONSTRAINT funcionario_vinculo_pk PRIMARY KEY (cod_funcionario_vinculo);


--
-- Name: imagem_pkey; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY imagem
    ADD CONSTRAINT imagem_pkey PRIMARY KEY (cod_imagem);


--
-- Name: imagem_tipo_pkey; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY imagem_tipo
    ADD CONSTRAINT imagem_tipo_pkey PRIMARY KEY (cod_imagem_tipo);


--
-- Name: intranet_segur_permissao_negada_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY intranet_segur_permissao_negada
    ADD CONSTRAINT intranet_segur_permissao_negada_pk PRIMARY KEY (cod_intranet_segur_permissao_negada);


--
-- Name: jor_arquivo_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY jor_arquivo
    ADD CONSTRAINT jor_arquivo_pk PRIMARY KEY (ref_cod_jor_edicao, jor_arquivo);


--
-- Name: jor_edicao_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY jor_edicao
    ADD CONSTRAINT jor_edicao_pk PRIMARY KEY (cod_jor_edicao);


--
-- Name: mailling_email_conteudo_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY mailling_email_conteudo
    ADD CONSTRAINT mailling_email_conteudo_pk PRIMARY KEY (cod_mailling_email_conteudo);


--
-- Name: mailling_email_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY mailling_email
    ADD CONSTRAINT mailling_email_pk PRIMARY KEY (cod_mailling_email);


--
-- Name: mailling_fila_envio_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY mailling_fila_envio
    ADD CONSTRAINT mailling_fila_envio_pk PRIMARY KEY (cod_mailling_fila_envio);


--
-- Name: mailling_grupo_email_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY mailling_grupo_email
    ADD CONSTRAINT mailling_grupo_email_pk PRIMARY KEY (ref_cod_mailling_email, ref_cod_mailling_grupo);


--
-- Name: mailling_grupo_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY mailling_grupo
    ADD CONSTRAINT mailling_grupo_pk PRIMARY KEY (cod_mailling_grupo);


--
-- Name: mailling_historico_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY mailling_historico
    ADD CONSTRAINT mailling_historico_pk PRIMARY KEY (cod_mailling_historico);


--
-- Name: menu_funcionario_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY menu_funcionario
    ADD CONSTRAINT menu_funcionario_pk PRIMARY KEY (ref_ref_cod_pessoa_fj, ref_cod_menu_submenu);


--
-- Name: menu_menu_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY menu_menu
    ADD CONSTRAINT menu_menu_pk PRIMARY KEY (cod_menu_menu);


--
-- Name: menu_submenu_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY menu_submenu
    ADD CONSTRAINT menu_submenu_pk PRIMARY KEY (cod_menu_submenu);


--
-- Name: not_portal_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY not_portal
    ADD CONSTRAINT not_portal_pk PRIMARY KEY (cod_not_portal);


--
-- Name: not_portal_tipo_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY not_portal_tipo
    ADD CONSTRAINT not_portal_tipo_pk PRIMARY KEY (ref_cod_not_portal, ref_cod_not_tipo);


--
-- Name: not_tipo_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY not_tipo
    ADD CONSTRAINT not_tipo_pk PRIMARY KEY (cod_not_tipo);


--
-- Name: not_vinc_portal_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY not_vinc_portal
    ADD CONSTRAINT not_vinc_portal_pk PRIMARY KEY (ref_cod_not_portal, vic_num);


--
-- Name: pessoa_atividade_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY pessoa_atividade
    ADD CONSTRAINT pessoa_atividade_pk PRIMARY KEY (cod_pessoa_atividade);


--
-- Name: pessoa_fj_pessoa_atividade_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY pessoa_fj_pessoa_atividade
    ADD CONSTRAINT pessoa_fj_pessoa_atividade_pk PRIMARY KEY (ref_cod_pessoa_atividade, ref_cod_pessoa_fj);


--
-- Name: pessoa_fj_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY pessoa_fj
    ADD CONSTRAINT pessoa_fj_pk PRIMARY KEY (cod_pessoa_fj);


--
-- Name: pessoa_ramo_atividade_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY pessoa_ramo_atividade
    ADD CONSTRAINT pessoa_ramo_atividade_pk PRIMARY KEY (cod_ramo_atividade);


--
-- Name: portal_concurso_pk; Type: CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY portal_concurso
    ADD CONSTRAINT portal_concurso_pk PRIMARY KEY (cod_portal_concurso);


SET search_path = public, pg_catalog;

--
-- Name: bairro_regiao_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY bairro_regiao
    ADD CONSTRAINT bairro_regiao_pkey PRIMARY KEY (ref_cod_regiao, ref_idbai);


--
-- Name: pghero_query_stats_pkey; Type: CONSTRAINT; Schema: public; Owner: ieducar
--

ALTER TABLE ONLY pghero_query_stats
    ADD CONSTRAINT pghero_query_stats_pkey PRIMARY KEY (id);


--
-- Name: pk_bairro; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY bairro
    ADD CONSTRAINT pk_bairro PRIMARY KEY (idbai);


--
-- Name: pk_distrito; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY distrito
    ADD CONSTRAINT pk_distrito PRIMARY KEY (iddis);


--
-- Name: pk_logradouro; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY logradouro
    ADD CONSTRAINT pk_logradouro PRIMARY KEY (idlog);


--
-- Name: pk_logradouro_fonetico; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY logradouro_fonetico
    ADD CONSTRAINT pk_logradouro_fonetico PRIMARY KEY (fonema, idlog);


--
-- Name: pk_municipio; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY municipio
    ADD CONSTRAINT pk_municipio PRIMARY KEY (idmun);


--
-- Name: pk_pais; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY pais
    ADD CONSTRAINT pk_pais PRIMARY KEY (idpais);


--
-- Name: pk_setor; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY setor
    ADD CONSTRAINT pk_setor PRIMARY KEY (idset);


--
-- Name: pk_setorbai; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY setor_bai
    ADD CONSTRAINT pk_setorbai PRIMARY KEY (idsetorbai);


--
-- Name: pk_uf; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY uf
    ADD CONSTRAINT pk_uf PRIMARY KEY (sigla_uf);


--
-- Name: pk_vila; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY vila
    ADD CONSTRAINT pk_vila PRIMARY KEY (idvil);


--
-- Name: pkchangelog; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY changelog
    ADD CONSTRAINT pkchangelog PRIMARY KEY (change_number, delta_set);


--
-- Name: regiao_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY regiao
    ADD CONSTRAINT regiao_pkey PRIMARY KEY (cod_regiao);

SET search_path = serieciasc, pg_catalog;

--
-- Name: aluno_uniforme_ref_cod_aluno_pk; Type: CONSTRAINT; Schema: serieciasc; Owner: postgres
--

ALTER TABLE ONLY aluno_uniforme
    ADD CONSTRAINT aluno_uniforme_ref_cod_aluno_pk PRIMARY KEY (ref_cod_aluno, data_recebimento);


--
-- Name: cod_aluno_serie_ref_cod_aluno_pk; Type: CONSTRAINT; Schema: serieciasc; Owner: postgres
--

ALTER TABLE ONLY aluno_cod_aluno
    ADD CONSTRAINT cod_aluno_serie_ref_cod_aluno_pk PRIMARY KEY (cod_aluno, cod_ciasc);


--
-- Name: educacenso_ref_cod_escola_pk; Type: CONSTRAINT; Schema: serieciasc; Owner: postgres
--

ALTER TABLE ONLY escola_regulamentacao
    ADD CONSTRAINT educacenso_ref_cod_escola_pk PRIMARY KEY (ref_cod_escola);


--
-- Name: escola_agua_ref_cod_escola_pk; Type: CONSTRAINT; Schema: serieciasc; Owner: postgres
--

ALTER TABLE ONLY escola_agua
    ADD CONSTRAINT escola_agua_ref_cod_escola_pk PRIMARY KEY (ref_cod_escola);


--
-- Name: escola_energia_ref_cod_escola_pk; Type: CONSTRAINT; Schema: serieciasc; Owner: postgres
--

ALTER TABLE ONLY escola_energia
    ADD CONSTRAINT escola_energia_ref_cod_escola_pk PRIMARY KEY (ref_cod_escola);


--
-- Name: escola_lingua_indigena_pk; Type: CONSTRAINT; Schema: serieciasc; Owner: postgres
--

ALTER TABLE ONLY escola_lingua_indigena
    ADD CONSTRAINT escola_lingua_indigena_pk PRIMARY KEY (ref_cod_escola);


--
-- Name: escola_lixo_ref_cod_escola_pk; Type: CONSTRAINT; Schema: serieciasc; Owner: postgres
--

ALTER TABLE ONLY escola_lixo
    ADD CONSTRAINT escola_lixo_ref_cod_escola_pk PRIMARY KEY (ref_cod_escola);


--
-- Name: escola_projeto_ref_cod_escola_pk; Type: CONSTRAINT; Schema: serieciasc; Owner: postgres
--

ALTER TABLE ONLY escola_projeto
    ADD CONSTRAINT escola_projeto_ref_cod_escola_pk PRIMARY KEY (ref_cod_escola);


--
-- Name: escola_sanitario_ref_cod_escola_pk; Type: CONSTRAINT; Schema: serieciasc; Owner: postgres
--

ALTER TABLE ONLY escola_sanitario
    ADD CONSTRAINT escola_sanitario_ref_cod_escola_pk PRIMARY KEY (ref_cod_escola);


SET search_path = urbano, pg_catalog;

--
-- Name: pk_cep_logradouro; Type: CONSTRAINT; Schema: urbano; Owner: postgres
--

ALTER TABLE ONLY cep_logradouro
    ADD CONSTRAINT pk_cep_logradouro PRIMARY KEY (cep, idlog);


--
-- Name: pk_cep_logradouro_bairro; Type: CONSTRAINT; Schema: urbano; Owner: postgres
--

ALTER TABLE ONLY cep_logradouro_bairro
    ADD CONSTRAINT pk_cep_logradouro_bairro PRIMARY KEY (idbai, idlog, cep);


--
-- Name: pk_tipo_logradouro; Type: CONSTRAINT; Schema: urbano; Owner: postgres
--

ALTER TABLE ONLY tipo_logradouro
    ADD CONSTRAINT pk_tipo_logradouro PRIMARY KEY (idtlog);


SET search_path = acesso, pg_catalog;

--
-- Name: un_usuario_idpes; Type: INDEX; Schema: acesso; Owner: postgres
--

CREATE UNIQUE INDEX un_usuario_idpes ON usuario USING btree (idpes);


SET search_path = alimentos, pg_catalog;

--
-- Name: un_baixa_guia_remessa; Type: INDEX; Schema: alimentos; Owner: postgres
--

CREATE UNIQUE INDEX un_baixa_guia_remessa ON baixa_guia_remessa USING btree (idgui, dt_recebimento);


--
-- Name: un_cardapio_produto; Type: INDEX; Schema: alimentos; Owner: postgres
--

CREATE UNIQUE INDEX un_cardapio_produto ON cardapio_produto USING btree (idcar, idpro);


--
-- Name: un_cliente; Type: INDEX; Schema: alimentos; Owner: postgres
--

CREATE UNIQUE INDEX un_cliente ON cliente USING btree (idcli, identificacao);


--
-- Name: un_contrato; Type: INDEX; Schema: alimentos; Owner: postgres
--

CREATE UNIQUE INDEX un_contrato ON contrato USING btree (idcli, codigo, num_aditivo);


--
-- Name: un_contrato_produto; Type: INDEX; Schema: alimentos; Owner: postgres
--

CREATE UNIQUE INDEX un_contrato_produto ON contrato_produto USING btree (idcon, idpro);


--
-- Name: un_evento; Type: INDEX; Schema: alimentos; Owner: postgres
--

CREATE UNIQUE INDEX un_evento ON evento USING btree (idcad, mes, dia);


--
-- Name: un_faixa_cp_quimico; Type: INDEX; Schema: alimentos; Owner: postgres
--

CREATE UNIQUE INDEX un_faixa_cp_quimico ON faixa_composto_quimico USING btree (idcom, idfae);


--
-- Name: un_fornecedor; Type: INDEX; Schema: alimentos; Owner: postgres
--

CREATE UNIQUE INDEX un_fornecedor ON fornecedor USING btree (idcli, nome_fantasia);


--
-- Name: un_fornecedor_unidade_atend; Type: INDEX; Schema: alimentos; Owner: postgres
--

CREATE UNIQUE INDEX un_fornecedor_unidade_atend ON fornecedor_unidade_atendida USING btree (iduni, idfor);


--
-- Name: un_guia_remessa; Type: INDEX; Schema: alimentos; Owner: postgres
--

CREATE UNIQUE INDEX un_guia_remessa ON guia_remessa USING btree (idcli, ano, sequencial);


--
-- Name: un_guia_remessa_produto; Type: INDEX; Schema: alimentos; Owner: postgres
--

CREATE UNIQUE INDEX un_guia_remessa_produto ON guia_remessa_produto USING btree (idgui, idpro);


--
-- Name: un_prod_cp_quimico; Type: INDEX; Schema: alimentos; Owner: postgres
--

CREATE UNIQUE INDEX un_prod_cp_quimico ON produto_composto_quimico USING btree (idpro, idcom);


--
-- Name: un_produto; Type: INDEX; Schema: alimentos; Owner: postgres
--

CREATE UNIQUE INDEX un_produto ON produto USING btree (idcli, nome_compra);


--
-- Name: un_produto_fornecedor; Type: INDEX; Schema: alimentos; Owner: postgres
--

CREATE UNIQUE INDEX un_produto_fornecedor ON produto_fornecedor USING btree (idfor, idpro);


--
-- Name: un_produto_medida_caseira; Type: INDEX; Schema: alimentos; Owner: postgres
--

CREATE UNIQUE INDEX un_produto_medida_caseira ON produto_medida_caseira USING btree (idmedcas, idcli, idpro);


--
-- Name: un_rec_cp_quimico; Type: INDEX; Schema: alimentos; Owner: postgres
--

CREATE UNIQUE INDEX un_rec_cp_quimico ON receita_composto_quimico USING btree (idcom, idrec);


--
-- Name: un_rec_prod; Type: INDEX; Schema: alimentos; Owner: postgres
--

CREATE UNIQUE INDEX un_rec_prod ON receita_produto USING btree (idpro, idrec);


--
-- Name: un_uni_faixa_etaria; Type: INDEX; Schema: alimentos; Owner: postgres
--

CREATE UNIQUE INDEX un_uni_faixa_etaria ON unidade_faixa_etaria USING btree (iduni, idfae);


--
-- Name: un_unidade_atendida; Type: INDEX; Schema: alimentos; Owner: postgres
--

CREATE UNIQUE INDEX un_unidade_atendida ON unidade_atendida USING btree (idcli, codigo);


SET search_path = cadastro, pg_catalog;

--
-- Name: un_fisica_cpf; Type: INDEX; Schema: cadastro; Owner: postgres
--

CREATE UNIQUE INDEX un_fisica_cpf ON fisica_cpf USING btree (cpf);


--
-- Name: un_juridica_cnpj; Type: INDEX; Schema: cadastro; Owner: postgres
--

CREATE UNIQUE INDEX un_juridica_cnpj ON juridica USING btree (cnpj);


SET search_path = modules, pg_catalog;

--
-- Name: alunocomponenteetapa; Type: INDEX; Schema: modules; Owner: postgres
--

CREATE UNIQUE INDEX alunocomponenteetapa ON parecer_componente_curricular USING btree (parecer_aluno_id, componente_curricular_id, etapa);


--
-- Name: area_conhecimento_nome_key; Type: INDEX; Schema: modules; Owner: postgres
--

CREATE INDEX area_conhecimento_nome_key ON area_conhecimento USING btree (nome);


--
-- Name: componente_curricular_area_conhecimento_key; Type: INDEX; Schema: modules; Owner: postgres
--

CREATE INDEX componente_curricular_area_conhecimento_key ON componente_curricular USING btree (area_conhecimento_id);


--
-- Name: componente_curricular_id_key; Type: INDEX; Schema: modules; Owner: postgres
--

CREATE UNIQUE INDEX componente_curricular_id_key ON componente_curricular USING btree (id);


--
-- Name: componente_curricular_turma_turma_idx; Type: INDEX; Schema: modules; Owner: postgres
--

CREATE INDEX componente_curricular_turma_turma_idx ON componente_curricular_turma USING btree (turma_id);


--
-- Name: docente_licenciatura_ies_idx; Type: INDEX; Schema: modules; Owner: postgres
--

CREATE INDEX docente_licenciatura_ies_idx ON docente_licenciatura USING btree (ies_id);


--
-- Name: idx_falta_aluno_matricula_id; Type: INDEX; Schema: modules; Owner: postgres
--

CREATE INDEX idx_falta_aluno_matricula_id ON falta_aluno USING btree (matricula_id);


--
-- Name: idx_falta_aluno_matricula_id_tipo; Type: INDEX; Schema: modules; Owner: postgres
--

CREATE INDEX idx_falta_aluno_matricula_id_tipo ON falta_aluno USING btree (matricula_id, tipo_falta);


--
-- Name: idx_falta_componente_curricular_id1; Type: INDEX; Schema: modules; Owner: postgres
--

CREATE INDEX idx_falta_componente_curricular_id1 ON falta_componente_curricular USING btree (falta_aluno_id, componente_curricular_id, etapa);


--
-- Name: idx_falta_geral_falta_aluno_id; Type: INDEX; Schema: modules; Owner: postgres
--

CREATE INDEX idx_falta_geral_falta_aluno_id ON falta_geral USING btree (falta_aluno_id);


--
-- Name: idx_nota_aluno_matricula; Type: INDEX; Schema: modules; Owner: postgres
--

CREATE INDEX idx_nota_aluno_matricula ON nota_aluno USING btree (matricula_id);


--
-- Name: idx_nota_aluno_matricula_id; Type: INDEX; Schema: modules; Owner: postgres
--

CREATE INDEX idx_nota_aluno_matricula_id ON nota_aluno USING btree (id, matricula_id);


--
-- Name: idx_nota_componente_curricular_etapa; Type: INDEX; Schema: modules; Owner: postgres
--

CREATE INDEX idx_nota_componente_curricular_etapa ON nota_componente_curricular USING btree (nota_aluno_id, componente_curricular_id, etapa);


--
-- Name: idx_nota_componente_curricular_etp; Type: INDEX; Schema: modules; Owner: postgres
--

CREATE INDEX idx_nota_componente_curricular_etp ON nota_componente_curricular USING btree (componente_curricular_id, etapa);


--
-- Name: idx_nota_componente_curricular_id; Type: INDEX; Schema: modules; Owner: postgres
--

CREATE INDEX idx_nota_componente_curricular_id ON nota_componente_curricular USING btree (componente_curricular_id);


--
-- Name: idx_parecer_aluno_matricula_id; Type: INDEX; Schema: modules; Owner: postgres
--

CREATE INDEX idx_parecer_aluno_matricula_id ON parecer_aluno USING btree (matricula_id);


--
-- Name: idx_parecer_geral_parecer_aluno_etp; Type: INDEX; Schema: modules; Owner: postgres
--

CREATE INDEX idx_parecer_geral_parecer_aluno_etp ON parecer_geral USING btree (parecer_aluno_id, etapa);


--
-- Name: idx_tabela_arredondamento_valor_tabela_id; Type: INDEX; Schema: modules; Owner: postgres
--

CREATE INDEX idx_tabela_arredondamento_valor_tabela_id ON tabela_arredondamento_valor USING btree (tabela_arredondamento_id);


--
-- Name: regra_avaliacao_id_key; Type: INDEX; Schema: modules; Owner: postgres
--

CREATE UNIQUE INDEX regra_avaliacao_id_key ON regra_avaliacao USING btree (id);


--
-- Name: tabela_arredondamento_id_key; Type: INDEX; Schema: modules; Owner: postgres
--

CREATE UNIQUE INDEX tabela_arredondamento_id_key ON tabela_arredondamento USING btree (id);


SET search_path = pmieducar, pg_catalog;

--
-- Name: exemplar_tombo_idx; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX exemplar_tombo_idx ON exemplar USING btree (tombo);


--
-- Name: fki_biblioteca_usuario_ref_cod_biblioteca_fk; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX fki_biblioteca_usuario_ref_cod_biblioteca_fk ON biblioteca_usuario USING btree (ref_cod_biblioteca);


--
-- Name: fki_servidor_ref_cod_subnivel; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX fki_servidor_ref_cod_subnivel ON servidor USING btree (ref_cod_subnivel);


--
-- Name: fki_servidor_ref_cod_subnivel_; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX fki_servidor_ref_cod_subnivel_ ON servidor USING btree (ref_cod_subnivel);


--
-- Name: historico_escolar_ano_idx; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX historico_escolar_ano_idx ON historico_escolar USING btree (ano);


--
-- Name: historico_escolar_ativo_idx; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX historico_escolar_ativo_idx ON historico_escolar USING btree (ativo);


--
-- Name: historico_escolar_nm_serie_idx; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX historico_escolar_nm_serie_idx ON historico_escolar USING btree (nm_serie);


--
-- Name: i_aluno_ativo; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_aluno_ativo ON aluno USING btree (ativo);


--
-- Name: i_aluno_beneficio_ativo; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_aluno_beneficio_ativo ON aluno_beneficio USING btree (ativo);


--
-- Name: i_aluno_beneficio_nm_beneficio; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_aluno_beneficio_nm_beneficio ON aluno_beneficio USING btree (nm_beneficio);


--
-- Name: i_aluno_beneficio_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_aluno_beneficio_ref_usuario_cad ON aluno_beneficio USING btree (ref_usuario_cad);


--
-- Name: i_aluno_ref_cod_religiao; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_aluno_ref_cod_religiao ON aluno USING btree (ref_cod_religiao);


--
-- Name: i_aluno_ref_idpes; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_aluno_ref_idpes ON aluno USING btree (ref_idpes);


--
-- Name: i_aluno_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_aluno_ref_usuario_cad ON aluno USING btree (ref_usuario_cad);


--
-- Name: i_calendario_ano_letivo_ano; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_calendario_ano_letivo_ano ON calendario_ano_letivo USING btree (ano);


--
-- Name: i_calendario_ano_letivo_ativo; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_calendario_ano_letivo_ativo ON calendario_ano_letivo USING btree (ativo);


--
-- Name: i_calendario_ano_letivo_ref_cod_escola; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_calendario_ano_letivo_ref_cod_escola ON calendario_ano_letivo USING btree (ref_cod_escola);


--
-- Name: i_calendario_ano_letivo_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_calendario_ano_letivo_ref_usuario_cad ON calendario_ano_letivo USING btree (ref_usuario_cad);


--
-- Name: i_calendario_dia_ativo; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_calendario_dia_ativo ON calendario_dia USING btree (ativo);


--
-- Name: i_calendario_dia_dia; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_calendario_dia_dia ON calendario_dia USING btree (dia);


--
-- Name: i_calendario_dia_mes; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_calendario_dia_mes ON calendario_dia USING btree (mes);


--
-- Name: i_calendario_dia_motivo_ativo; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_calendario_dia_motivo_ativo ON calendario_dia_motivo USING btree (ativo);


--
-- Name: i_calendario_dia_motivo_ref_cod_escola; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_calendario_dia_motivo_ref_cod_escola ON calendario_dia_motivo USING btree (ref_cod_escola);


--
-- Name: i_calendario_dia_motivo_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_calendario_dia_motivo_ref_usuario_cad ON calendario_dia_motivo USING btree (ref_usuario_cad);


--
-- Name: i_calendario_dia_motivo_sigla; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_calendario_dia_motivo_sigla ON calendario_dia_motivo USING btree (sigla);


--
-- Name: i_calendario_dia_motivo_tipo; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_calendario_dia_motivo_tipo ON calendario_dia_motivo USING btree (tipo);


--
-- Name: i_calendario_dia_ref_cod_calendario_dia_motivo; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_calendario_dia_ref_cod_calendario_dia_motivo ON calendario_dia USING btree (ref_cod_calendario_dia_motivo);


--
-- Name: i_calendario_dia_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_calendario_dia_ref_usuario_cad ON calendario_dia USING btree (ref_usuario_cad);


--
-- Name: i_coffebreak_tipo_ativo; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_coffebreak_tipo_ativo ON coffebreak_tipo USING btree (ativo);


--
-- Name: i_coffebreak_tipo_custo_unitario; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_coffebreak_tipo_custo_unitario ON coffebreak_tipo USING btree (custo_unitario);


--
-- Name: i_coffebreak_tipo_nm_tipo; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_coffebreak_tipo_nm_tipo ON coffebreak_tipo USING btree (nm_tipo);


--
-- Name: i_coffebreak_tipo_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_coffebreak_tipo_ref_usuario_cad ON coffebreak_tipo USING btree (ref_usuario_cad);


--
-- Name: i_curso_ativo; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_curso_ativo ON curso USING btree (ativo);


--
-- Name: i_curso_ato_poder_publico; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_curso_ato_poder_publico ON curso USING btree (ato_poder_publico);


--
-- Name: i_curso_carga_horaria; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_curso_carga_horaria ON curso USING btree (carga_horaria);


--
-- Name: i_curso_nm_curso; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_curso_nm_curso ON curso USING btree (nm_curso);


--
-- Name: i_curso_objetivo_curso; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_curso_objetivo_curso ON curso USING btree (objetivo_curso);


--
-- Name: i_curso_qtd_etapas; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_curso_qtd_etapas ON curso USING btree (qtd_etapas);


--
-- Name: i_curso_ref_cod_nivel_ensino; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_curso_ref_cod_nivel_ensino ON curso USING btree (ref_cod_nivel_ensino);


--
-- Name: i_curso_ref_cod_tipo_ensino; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_curso_ref_cod_tipo_ensino ON curso USING btree (ref_cod_tipo_ensino);


--
-- Name: i_curso_ref_cod_tipo_regime; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_curso_ref_cod_tipo_regime ON curso USING btree (ref_cod_tipo_regime);


--
-- Name: i_curso_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_curso_ref_usuario_cad ON curso USING btree (ref_usuario_cad);


--
-- Name: i_curso_sgl_curso; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_curso_sgl_curso ON curso USING btree (sgl_curso);


--
-- Name: i_disciplina_abreviatura; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_disciplina_abreviatura ON disciplina USING btree (abreviatura);


--
-- Name: i_disciplina_apura_falta; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_disciplina_apura_falta ON disciplina USING btree (apura_falta);


--
-- Name: i_disciplina_ativo; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_disciplina_ativo ON disciplina USING btree (ativo);


--
-- Name: i_disciplina_carga_horaria; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_disciplina_carga_horaria ON disciplina USING btree (carga_horaria);


--
-- Name: i_disciplina_nm_disciplina; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_disciplina_nm_disciplina ON disciplina USING btree (nm_disciplina);


--
-- Name: i_disciplina_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_disciplina_ref_usuario_cad ON disciplina USING btree (ref_usuario_cad);


--
-- Name: i_disciplina_topico_ativo; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_disciplina_topico_ativo ON disciplina_topico USING btree (ativo);


--
-- Name: i_disciplina_topico_nm_topico; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_disciplina_topico_nm_topico ON disciplina_topico USING btree (nm_topico);


--
-- Name: i_disciplina_topico_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_disciplina_topico_ref_usuario_cad ON disciplina_topico USING btree (ref_usuario_cad);


--
-- Name: i_dispensa_disciplina_ref_cod_matricula; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_dispensa_disciplina_ref_cod_matricula ON dispensa_disciplina USING btree (ref_cod_matricula);


--
-- Name: i_escola_ativo; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_ativo ON escola USING btree (ativo);


--
-- Name: i_escola_complemento_ativo; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_complemento_ativo ON escola_complemento USING btree (ativo);


--
-- Name: i_escola_complemento_bairro; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_complemento_bairro ON escola_complemento USING btree (bairro);


--
-- Name: i_escola_complemento_cep; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_complemento_cep ON escola_complemento USING btree (cep);


--
-- Name: i_escola_complemento_complemento; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_complemento_complemento ON escola_complemento USING btree (complemento);


--
-- Name: i_escola_complemento_email; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_complemento_email ON escola_complemento USING btree (email);


--
-- Name: i_escola_complemento_logradouro; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_complemento_logradouro ON escola_complemento USING btree (logradouro);


--
-- Name: i_escola_complemento_municipio; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_complemento_municipio ON escola_complemento USING btree (municipio);


--
-- Name: i_escola_complemento_nm_escola; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_complemento_nm_escola ON escola_complemento USING btree (nm_escola);


--
-- Name: i_escola_complemento_numero; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_complemento_numero ON escola_complemento USING btree (numero);


--
-- Name: i_escola_complemento_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_complemento_ref_usuario_cad ON escola_complemento USING btree (ref_usuario_cad);


--
-- Name: i_escola_curso_ativo; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_curso_ativo ON escola_curso USING btree (ativo);


--
-- Name: i_escola_curso_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_curso_ref_usuario_cad ON escola_curso USING btree (ref_usuario_cad);


--
-- Name: i_escola_localizacao_ativo; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_localizacao_ativo ON escola_localizacao USING btree (ativo);


--
-- Name: i_escola_localizacao_nm_localizacao; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_localizacao_nm_localizacao ON escola_localizacao USING btree (nm_localizacao);


--
-- Name: i_escola_localizacao_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_localizacao_ref_usuario_cad ON escola_localizacao USING btree (ref_usuario_cad);


--
-- Name: i_escola_rede_ensino_ativo; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_rede_ensino_ativo ON escola_rede_ensino USING btree (ativo);


--
-- Name: i_escola_rede_ensino_nm_rede; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_rede_ensino_nm_rede ON escola_rede_ensino USING btree (nm_rede);


--
-- Name: i_escola_rede_ensino_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_rede_ensino_ref_usuario_cad ON escola_rede_ensino USING btree (ref_usuario_cad);


--
-- Name: i_escola_ref_cod_escola_localizacao; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_ref_cod_escola_localizacao ON escola USING btree (ref_cod_escola_localizacao);


--
-- Name: i_escola_ref_cod_escola_rede_ensino; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_ref_cod_escola_rede_ensino ON escola USING btree (ref_cod_escola_rede_ensino);


--
-- Name: i_escola_ref_cod_instituicao; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_ref_cod_instituicao ON escola USING btree (ref_cod_instituicao);


--
-- Name: i_escola_ref_idpes; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_ref_idpes ON escola USING btree (ref_idpes);


--
-- Name: i_escola_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_ref_usuario_cad ON escola USING btree (ref_usuario_cad);


--
-- Name: i_escola_serie_ensino_ativo; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_serie_ensino_ativo ON escola_serie USING btree (ativo);


--
-- Name: i_escola_serie_hora_final; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_serie_hora_final ON escola_serie USING btree (hora_final);


--
-- Name: i_escola_serie_hora_inicial; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_serie_hora_inicial ON escola_serie USING btree (hora_inicial);


--
-- Name: i_escola_serie_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_serie_ref_usuario_cad ON escola_serie USING btree (ref_usuario_cad);


--
-- Name: i_escola_sigla; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_escola_sigla ON escola USING btree (sigla);


--
-- Name: i_funcao_abreviatura; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_funcao_abreviatura ON funcao USING btree (abreviatura);


--
-- Name: i_funcao_ativo; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_funcao_ativo ON funcao USING btree (ativo);


--
-- Name: i_funcao_nm_funcao; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_funcao_nm_funcao ON funcao USING btree (nm_funcao);


--
-- Name: i_funcao_professor; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_funcao_professor ON funcao USING btree (professor);


--
-- Name: i_funcao_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_funcao_ref_usuario_cad ON funcao USING btree (ref_usuario_cad);


--
-- Name: i_habilitacao_ativo; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_habilitacao_ativo ON habilitacao USING btree (ativo);


--
-- Name: i_habilitacao_nm_tipo; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_habilitacao_nm_tipo ON habilitacao USING btree (nm_tipo);


--
-- Name: i_habilitacao_ref_usuario_cad; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_habilitacao_ref_usuario_cad ON habilitacao USING btree (ref_usuario_cad);


--
-- Name: i_matricula_turma_ref_cod_turma; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_matricula_turma_ref_cod_turma ON matricula_turma USING btree (ref_cod_turma);


--
-- Name: i_nota_aluno_ref_cod_matricula; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_nota_aluno_ref_cod_matricula ON nota_aluno USING btree (ref_cod_matricula);


--
-- Name: i_turma_nm_turma; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX i_turma_nm_turma ON turma USING btree (nm_turma);


--
-- Name: idx_historico_disciplinas_id; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX idx_historico_disciplinas_id ON historico_disciplinas USING btree (sequencial, ref_ref_cod_aluno, ref_sequencial);


--
-- Name: idx_historico_disciplinas_id1; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX idx_historico_disciplinas_id1 ON historico_disciplinas USING btree (ref_ref_cod_aluno, ref_sequencial);


--
-- Name: idx_historico_escolar_aluno_ativo; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX idx_historico_escolar_aluno_ativo ON historico_escolar USING btree (ref_cod_aluno, ativo);


--
-- Name: idx_historico_escolar_id1; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX idx_historico_escolar_id1 ON historico_escolar USING btree (ref_cod_aluno, sequencial);


--
-- Name: idx_historico_escolar_id2; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX idx_historico_escolar_id2 ON historico_escolar USING btree (ref_cod_aluno, sequencial, ano);


--
-- Name: idx_historico_escolar_id3; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX idx_historico_escolar_id3 ON historico_escolar USING btree (ref_cod_aluno, ano);


--
-- Name: idx_matricula_cod_escola_aluno; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX idx_matricula_cod_escola_aluno ON matricula USING btree (ref_ref_cod_escola, ref_cod_aluno);


--
-- Name: idx_serie_cod_regra_avaliacao_id; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX idx_serie_cod_regra_avaliacao_id ON serie USING btree (cod_serie, regra_avaliacao_id);


--
-- Name: idx_serie_regra_avaliacao_id; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX idx_serie_regra_avaliacao_id ON serie USING btree (regra_avaliacao_id);


--
-- Name: matricula_ano_idx; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX matricula_ano_idx ON matricula USING btree (ano);


--
-- Name: matricula_ativo_idx; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX matricula_ativo_idx ON matricula USING btree (ativo);


--
-- Name: quadro_horario_horarios_busca_horarios_idx; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX quadro_horario_horarios_busca_horarios_idx ON quadro_horario_horarios USING btree (ref_servidor, ref_cod_instituicao_servidor, dia_semana, hora_inicial, hora_final, ativo);


--
-- Name: INDEX quadro_horario_horarios_busca_horarios_idx; Type: COMMENT; Schema: pmieducar; Owner: postgres
--

COMMENT ON INDEX quadro_horario_horarios_busca_horarios_idx IS 'Índice para otimizar a busca por professores na criação de quadro de horários.';


--
-- Name: servidor_alocacao_busca_horarios_idx; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX servidor_alocacao_busca_horarios_idx ON servidor_alocacao USING btree (ref_ref_cod_instituicao, ref_cod_escola, ativo, periodo, carga_horaria);


--
-- Name: servidor_idx; Type: INDEX; Schema: pmieducar; Owner: postgres
--

CREATE INDEX servidor_idx ON servidor USING btree (cod_servidor, ref_cod_instituicao, ativo);


--
-- Name: INDEX servidor_idx; Type: COMMENT; Schema: pmieducar; Owner: postgres
--

COMMENT ON INDEX servidor_idx IS 'Índice para otimização de acesso aos campos mais usados para queries na tabela.';


SET search_path = portal, pg_catalog;

--
-- Name: mailling_fila_envio_data_envio_idx; Type: INDEX; Schema: portal; Owner: postgres
--

CREATE INDEX mailling_fila_envio_data_envio_idx ON mailling_fila_envio USING btree (data_envio);


--
-- Name: mailling_fila_envio_ref_cod_mailling_email; Type: INDEX; Schema: portal; Owner: postgres
--

CREATE INDEX mailling_fila_envio_ref_cod_mailling_email ON mailling_fila_envio USING btree (ref_cod_mailling_email);


--
-- Name: mailling_fila_envio_ref_cod_mailling_email_conteudo; Type: INDEX; Schema: portal; Owner: postgres
--

CREATE INDEX mailling_fila_envio_ref_cod_mailling_email_conteudo ON mailling_fila_envio USING btree (ref_cod_mailling_email_conteudo);


--
-- Name: mailling_fila_envio_ref_cod_mailling_fila_envio; Type: INDEX; Schema: portal; Owner: postgres
--

CREATE INDEX mailling_fila_envio_ref_cod_mailling_fila_envio ON mailling_fila_envio USING btree (cod_mailling_fila_envio);


SET search_path = public, pg_catalog;

--
-- Name: pghero_query_stats_database_captured_at_idx; Type: INDEX; Schema: public; Owner: ieducar
--

CREATE INDEX pghero_query_stats_database_captured_at_idx ON pghero_query_stats USING btree (database, captured_at);


SET search_path = cadastro, pg_catalog;

--
-- Name: trg_aft_documento; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_aft_documento AFTER INSERT OR UPDATE ON documento FOR EACH ROW EXECUTE PROCEDURE fcn_aft_documento();


--
-- Name: trg_aft_documento_historico_campo; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_aft_documento_historico_campo AFTER INSERT OR UPDATE ON documento FOR EACH ROW EXECUTE PROCEDURE consistenciacao.fcn_documento_historico_campo();


--
-- Name: trg_aft_documento_provisorio; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_aft_documento_provisorio AFTER INSERT OR UPDATE ON documento FOR EACH ROW EXECUTE PROCEDURE fcn_aft_documento_provisorio();


--
-- Name: trg_aft_endereco_externo_historico_campo; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_aft_endereco_externo_historico_campo AFTER INSERT OR UPDATE ON endereco_externo FOR EACH ROW EXECUTE PROCEDURE consistenciacao.fcn_endereco_externo_historico_campo();


--
-- Name: trg_aft_endereco_pessoa_historico_campo; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_aft_endereco_pessoa_historico_campo AFTER INSERT OR UPDATE ON endereco_pessoa FOR EACH ROW EXECUTE PROCEDURE consistenciacao.fcn_endereco_pessoa_historico_campo();


--
-- Name: trg_aft_fisica; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_aft_fisica AFTER INSERT OR UPDATE ON fisica FOR EACH ROW EXECUTE PROCEDURE fcn_aft_fisica();


--
-- Name: trg_aft_fisica_cpf_provisorio; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_aft_fisica_cpf_provisorio AFTER INSERT OR UPDATE ON fisica_cpf FOR EACH ROW EXECUTE PROCEDURE fcn_aft_fisica_cpf_provisorio();


--
-- Name: trg_aft_fisica_historico_campo; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_aft_fisica_historico_campo AFTER INSERT OR UPDATE ON fisica FOR EACH ROW EXECUTE PROCEDURE consistenciacao.fcn_fisica_historico_campo();


--
-- Name: trg_aft_fisica_provisorio; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_aft_fisica_provisorio AFTER INSERT OR UPDATE ON fisica FOR EACH ROW EXECUTE PROCEDURE fcn_aft_fisica_provisorio();


--
-- Name: trg_aft_fone_historico_campo; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_aft_fone_historico_campo AFTER INSERT OR UPDATE ON fone_pessoa FOR EACH ROW EXECUTE PROCEDURE consistenciacao.fcn_fone_historico_campo();


--
-- Name: trg_aft_fone_pessoa_historico; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_aft_fone_pessoa_historico AFTER DELETE ON fone_pessoa FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_fone_pessoa();


--
-- Name: trg_aft_funcionario_historico; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_aft_funcionario_historico AFTER DELETE ON funcionario FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_funcionario();


--
-- Name: trg_aft_ins_endereco_externo; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_aft_ins_endereco_externo AFTER INSERT OR UPDATE ON endereco_externo FOR EACH ROW EXECUTE PROCEDURE fcn_aft_ins_endereco_externo();


--
-- Name: trg_aft_ins_endereco_pessoa; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_aft_ins_endereco_pessoa AFTER INSERT OR UPDATE ON endereco_pessoa FOR EACH ROW EXECUTE PROCEDURE fcn_aft_ins_endereco_pessoa();


--
-- Name: trg_aft_juridica_historico_campo; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_aft_juridica_historico_campo AFTER INSERT OR UPDATE ON juridica FOR EACH ROW EXECUTE PROCEDURE consistenciacao.fcn_juridica_historico_campo();


--
-- Name: trg_aft_pessoa_fonetiza; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_aft_pessoa_fonetiza AFTER INSERT OR UPDATE ON pessoa FOR EACH ROW EXECUTE PROCEDURE public.fcn_aft_pessoa_fonetiza();


--
-- Name: trg_aft_pessoa_historico_campo; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_aft_pessoa_historico_campo AFTER INSERT OR UPDATE ON pessoa FOR EACH ROW EXECUTE PROCEDURE consistenciacao.fcn_pessoa_historico_campo();


--
-- Name: trg_bef_documento_historico; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_bef_documento_historico BEFORE UPDATE ON documento FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_documento();


--
-- Name: trg_bef_endereco_externo_historico; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_bef_endereco_externo_historico BEFORE UPDATE ON endereco_externo FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_endereco_externo();


--
-- Name: trg_bef_endereco_pessoa_historico; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_bef_endereco_pessoa_historico BEFORE UPDATE ON endereco_pessoa FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_endereco_pessoa();


--
-- Name: trg_bef_fisica_cpf_historico; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_bef_fisica_cpf_historico BEFORE UPDATE ON fisica_cpf FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_fisica_cpf();


--
-- Name: trg_bef_fisica_historico; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_bef_fisica_historico BEFORE UPDATE ON fisica FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_fisica();


--
-- Name: trg_bef_fone_pessoa_historico; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_bef_fone_pessoa_historico BEFORE UPDATE ON fone_pessoa FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_fone_pessoa();


--
-- Name: trg_bef_funcionario_historico; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_bef_funcionario_historico BEFORE UPDATE ON funcionario FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_funcionario();


--
-- Name: trg_bef_ins_fisica; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_bef_ins_fisica BEFORE INSERT ON fisica FOR EACH ROW EXECUTE PROCEDURE public.fcn_bef_ins_fisica();


--
-- Name: trg_bef_ins_juridica; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_bef_ins_juridica BEFORE INSERT ON juridica FOR EACH ROW EXECUTE PROCEDURE public.fcn_bef_ins_juridica();


--
-- Name: trg_bef_juridica_historico; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_bef_juridica_historico BEFORE UPDATE ON juridica FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_juridica();


--
-- Name: trg_bef_pessoa_fonetiza; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_bef_pessoa_fonetiza BEFORE DELETE ON pessoa FOR EACH ROW EXECUTE PROCEDURE public.fcn_bef_pessoa_fonetiza();


--
-- Name: trg_bef_pessoa_historico; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_bef_pessoa_historico BEFORE UPDATE ON pessoa FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_pessoa();


--
-- Name: trg_bef_socio_historico; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_bef_socio_historico BEFORE UPDATE ON socio FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_socio();


--
-- Name: trg_delete_documento_historico; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_delete_documento_historico AFTER DELETE ON documento FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_documento();


--
-- Name: trg_delete_endereco_externo_historico; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_delete_endereco_externo_historico AFTER DELETE ON endereco_externo FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_endereco_externo();


--
-- Name: trg_delete_endereco_pessoa_historico; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_delete_endereco_pessoa_historico AFTER DELETE ON endereco_pessoa FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_endereco_pessoa();


--
-- Name: trg_delete_fisica_cpf_historico; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_delete_fisica_cpf_historico AFTER DELETE ON fisica_cpf FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_fisica_cpf();


--
-- Name: trg_delete_fisica_historico; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_delete_fisica_historico AFTER DELETE ON fisica FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_fisica();


--
-- Name: trg_delete_fone_pessoa_historico; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_delete_fone_pessoa_historico AFTER DELETE ON fone_pessoa FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_fone_pessoa();


--
-- Name: trg_delete_funcionario_historico; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_delete_funcionario_historico AFTER DELETE ON funcionario FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_funcionario();


--
-- Name: trg_delete_juridica_historico; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_delete_juridica_historico AFTER DELETE ON juridica FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_juridica();


--
-- Name: trg_delete_pessoa_historico; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_delete_pessoa_historico AFTER DELETE ON pessoa FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_pessoa();


--
-- Name: trg_delete_socio_historico; Type: TRIGGER; Schema: cadastro; Owner: postgres
--

CREATE TRIGGER trg_delete_socio_historico AFTER DELETE ON socio FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_socio();


SET search_path = pmieducar, pg_catalog;

--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON instituicao FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON acervo FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON acervo_acervo_assunto FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON acervo_acervo_autor FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON acervo_assunto FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON acervo_autor FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON acervo_colecao FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON acervo_editora FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON acervo_idioma FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON aluno FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON aluno_beneficio FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON ano_letivo_modulo FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON avaliacao_desempenho FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON biblioteca FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON biblioteca_dia FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON biblioteca_feriados FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON biblioteca_usuario FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON calendario_ano_letivo FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON calendario_anotacao FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON calendario_dia FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON calendario_dia_anotacao FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON calendario_dia_motivo FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON cliente FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON cliente_suspensao FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON cliente_tipo FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON cliente_tipo_cliente FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON cliente_tipo_exemplar_tipo FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON coffebreak_tipo FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON curso FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON disciplina FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON disciplina_topico FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON escola FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON escola_ano_letivo FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON escola_complemento FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON escola_curso FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON escola_localizacao FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON escola_rede_ensino FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON escola_serie FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON exemplar FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON exemplar_emprestimo FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON exemplar_tipo FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON falta_atraso FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON falta_atraso_compensado FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON fonte FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON funcao FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON habilitacao FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON habilitacao_curso FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON historico_disciplinas FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON historico_escolar FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON infra_comodo_funcao FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON infra_predio FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON infra_predio_comodo FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON material_didatico FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON material_tipo FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON matricula FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON matricula_ocorrencia_disciplinar FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON menu_tipo_usuario FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON modulo FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON motivo_afastamento FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON motivo_baixa FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON motivo_suspensao FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON nivel_ensino FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON operador FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pagamento_multa FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON pre_requisito FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON quadro_horario FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON religiao FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON reserva_vaga FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON reservas FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON sequencia_serie FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON serie FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON serie_pre_requisito FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON servidor FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON servidor_afastamento FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON servidor_alocacao FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON servidor_curso FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON servidor_formacao FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON servidor_titulo_concurso FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON situacao FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON tipo_avaliacao FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON tipo_avaliacao_valores FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON tipo_dispensa FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON tipo_ensino FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON tipo_ocorrencia_disciplinar FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON tipo_regime FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON tipo_usuario FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON transferencia_solicitacao FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON transferencia_tipo FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON turma FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON turma_dia_semana FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON turma_modulo FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON turma_tipo FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: fcn_aft_update; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER fcn_aft_update AFTER INSERT OR UPDATE ON usuario FOR EACH ROW EXECUTE PROCEDURE fcn_aft_update();


--
-- Name: retira_data_cancel_matricula_trg; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER retira_data_cancel_matricula_trg AFTER UPDATE ON matricula FOR EACH ROW EXECUTE PROCEDURE public.retira_data_cancel_matricula_fun();


--
-- Name: trigger_updated_at_matricula; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER trigger_updated_at_matricula BEFORE UPDATE ON matricula FOR EACH ROW EXECUTE PROCEDURE updated_at_matricula();


--
-- Name: trigger_updated_at_matricula_turma; Type: TRIGGER; Schema: pmieducar; Owner: postgres
--

CREATE TRIGGER trigger_updated_at_matricula_turma BEFORE UPDATE ON matricula_turma FOR EACH ROW EXECUTE PROCEDURE updated_at_matricula_turma();


SET search_path = public, pg_catalog;

--
-- Name: trg_aft_logradouro_fonetiza; Type: TRIGGER; Schema: public; Owner: postgres
--

CREATE TRIGGER trg_aft_logradouro_fonetiza AFTER INSERT OR UPDATE ON logradouro FOR EACH ROW EXECUTE PROCEDURE fcn_aft_logradouro_fonetiza();


--
-- Name: trg_bef_bairro_historico; Type: TRIGGER; Schema: public; Owner: postgres
--

CREATE TRIGGER trg_bef_bairro_historico BEFORE UPDATE ON bairro FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_bairro();


--
-- Name: trg_bef_logradouro_fonetiza; Type: TRIGGER; Schema: public; Owner: postgres
--

CREATE TRIGGER trg_bef_logradouro_fonetiza BEFORE DELETE ON logradouro FOR EACH ROW EXECUTE PROCEDURE fcn_bef_logradouro_fonetiza();


--
-- Name: trg_bef_logradouro_historico; Type: TRIGGER; Schema: public; Owner: postgres
--

CREATE TRIGGER trg_bef_logradouro_historico BEFORE UPDATE ON logradouro FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_logradouro();


--
-- Name: trg_bef_municipio_historico; Type: TRIGGER; Schema: public; Owner: postgres
--

CREATE TRIGGER trg_bef_municipio_historico BEFORE UPDATE ON municipio FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_municipio();


--
-- Name: trg_delete_bairro_historico; Type: TRIGGER; Schema: public; Owner: postgres
--

CREATE TRIGGER trg_delete_bairro_historico AFTER DELETE ON bairro FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_bairro();


--
-- Name: trg_delete_logradouro_historico; Type: TRIGGER; Schema: public; Owner: postgres
--

CREATE TRIGGER trg_delete_logradouro_historico AFTER DELETE ON logradouro FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_logradouro();


--
-- Name: trg_delete_municipio_historico; Type: TRIGGER; Schema: public; Owner: postgres
--

CREATE TRIGGER trg_delete_municipio_historico AFTER DELETE ON municipio FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_municipio();


SET search_path = urbano, pg_catalog;

--
-- Name: trg_bef_cep_logradouro_bairro_historico; Type: TRIGGER; Schema: urbano; Owner: postgres
--

CREATE TRIGGER trg_bef_cep_logradouro_bairro_historico BEFORE UPDATE ON cep_logradouro_bairro FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_cep_logradouro_bairro();


--
-- Name: trg_bef_cep_logradouro_historico; Type: TRIGGER; Schema: urbano; Owner: postgres
--

CREATE TRIGGER trg_bef_cep_logradouro_historico BEFORE UPDATE ON cep_logradouro FOR EACH ROW EXECUTE PROCEDURE historico.fcn_grava_historico_cep_logradouro();


--
-- Name: trg_delete_cep_logradouro_bairro_historico; Type: TRIGGER; Schema: urbano; Owner: postgres
--

CREATE TRIGGER trg_delete_cep_logradouro_bairro_historico AFTER DELETE ON cep_logradouro_bairro FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_cep_logradouro_bairro();


--
-- Name: trg_delete_cep_logradouro_historico; Type: TRIGGER; Schema: urbano; Owner: postgres
--

CREATE TRIGGER trg_delete_cep_logradouro_historico AFTER DELETE ON cep_logradouro FOR EACH ROW EXECUTE PROCEDURE historico.fcn_delete_grava_historico_cep_logradouro();


SET search_path = acesso, pg_catalog;

--
-- Name: fk_funcao_grp_funcao; Type: FK CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY grupo_funcao
    ADD CONSTRAINT fk_funcao_grp_funcao FOREIGN KEY (idfunc, idsis, idmen) REFERENCES funcao(idfunc, idsis, idmen);


--
-- Name: fk_funcao_operacao_funcao; Type: FK CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY operacao_funcao
    ADD CONSTRAINT fk_funcao_operacao_funcao FOREIGN KEY (idfunc, idsis, idmen) REFERENCES funcao(idfunc, idsis, idmen);


--
-- Name: fk_grp_fun_grp_operacao; Type: FK CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY grupo_operacao
    ADD CONSTRAINT fk_grp_fun_grp_operacao FOREIGN KEY (idmen, idsis, idgrp, idfunc) REFERENCES grupo_funcao(idmen, idsis, idgrp, idfunc);


--
-- Name: fk_grp_menu_grp_funcao; Type: FK CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY grupo_funcao
    ADD CONSTRAINT fk_grp_menu_grp_funcao FOREIGN KEY (idgrp, idsis, idmen) REFERENCES grupo_menu(idgrp, idsis, idmen);


--
-- Name: fk_grp_sis_grp_menu; Type: FK CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY grupo_menu
    ADD CONSTRAINT fk_grp_sis_grp_menu FOREIGN KEY (idsis, idgrp) REFERENCES grupo_sistema(idsis, idgrp);


--
-- Name: fk_grupo_grupo_sistema; Type: FK CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY grupo_sistema
    ADD CONSTRAINT fk_grupo_grupo_sistema FOREIGN KEY (idgrp) REFERENCES grupo(idgrp);


--
-- Name: fk_grupo_usuario_grupo; Type: FK CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY usuario_grupo
    ADD CONSTRAINT fk_grupo_usuario_grupo FOREIGN KEY (idgrp) REFERENCES grupo(idgrp);


--
-- Name: fk_inst_pessoa_instituicao; Type: FK CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY pessoa_instituicao
    ADD CONSTRAINT fk_inst_pessoa_instituicao FOREIGN KEY (idins) REFERENCES instituicao(idins);


--
-- Name: fk_menu_funcao; Type: FK CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY funcao
    ADD CONSTRAINT fk_menu_funcao FOREIGN KEY (idmen, idsis) REFERENCES menu(idmen, idsis);


--
-- Name: fk_menu_grp_menu; Type: FK CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY grupo_menu
    ADD CONSTRAINT fk_menu_grp_menu FOREIGN KEY (idmen, idsis) REFERENCES menu(idmen, idsis);


--
-- Name: fk_menu_menu; Type: FK CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY menu
    ADD CONSTRAINT fk_menu_menu FOREIGN KEY (menu_idsis, menu_idmen) REFERENCES menu(idsis, idmen);


--
-- Name: fk_oper_func_grp_oper; Type: FK CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY grupo_operacao
    ADD CONSTRAINT fk_oper_func_grp_oper FOREIGN KEY (idmen, idsis, idfunc, idope) REFERENCES operacao_funcao(idmen, idsis, idfunc, idope);


--
-- Name: fk_operacao_operacao_funcao; Type: FK CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY operacao_funcao
    ADD CONSTRAINT fk_operacao_operacao_funcao FOREIGN KEY (idope) REFERENCES operacao(idope);


--
-- Name: fk_pes_pessoa_instituicao; Type: FK CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY pessoa_instituicao
    ADD CONSTRAINT fk_pes_pessoa_instituicao FOREIGN KEY (idpes) REFERENCES cadastro.pessoa(idpes);


--
-- Name: fk_pessoa_usuario; Type: FK CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY usuario
    ADD CONSTRAINT fk_pessoa_usuario FOREIGN KEY (idpes) REFERENCES cadastro.pessoa(idpes);


--
-- Name: fk_sistema_grupo_sistema; Type: FK CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY grupo_sistema
    ADD CONSTRAINT fk_sistema_grupo_sistema FOREIGN KEY (idsis) REFERENCES sistema(idsis);


--
-- Name: fk_sistema_menu; Type: FK CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY menu
    ADD CONSTRAINT fk_sistema_menu FOREIGN KEY (idsis) REFERENCES sistema(idsis);


--
-- Name: fk_sistema_operacao; Type: FK CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY operacao
    ADD CONSTRAINT fk_sistema_operacao FOREIGN KEY (idsis) REFERENCES sistema(idsis);


--
-- Name: fk_usuario_usuario_grupo; Type: FK CONSTRAINT; Schema: acesso; Owner: postgres
--

ALTER TABLE ONLY usuario_grupo
    ADD CONSTRAINT fk_usuario_usuario_grupo FOREIGN KEY (login) REFERENCES usuario(login);


SET search_path = alimentos, pg_catalog;

--
-- Name: fk_alterar_usuario_cardapio; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY cardapio
    ADD CONSTRAINT fk_alterar_usuario_cardapio FOREIGN KEY (login_alteracao) REFERENCES acesso.usuario(login);


--
-- Name: fk_baixa_guia_baixa_produto; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY baixa_guia_produto
    ADD CONSTRAINT fk_baixa_guia_baixa_produto FOREIGN KEY (idbai) REFERENCES baixa_guia_remessa(idbai);


--
-- Name: fk_calendario_evento; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY evento
    ADD CONSTRAINT fk_calendario_evento FOREIGN KEY (idcad) REFERENCES calendario(idcad);


--
-- Name: fk_calendario_unidade; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY unidade_atendida
    ADD CONSTRAINT fk_calendario_unidade FOREIGN KEY (idcad) REFERENCES calendario(idcad);


--
-- Name: fk_cancelar_usuario_guia_remessa; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY guia_remessa
    ADD CONSTRAINT fk_cancelar_usuario_guia_remessa FOREIGN KEY (login_cancelamento) REFERENCES acesso.usuario(login);


--
-- Name: fk_cardapio_cardapio_faixa_unidade; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY cardapio_faixa_unidade
    ADD CONSTRAINT fk_cardapio_cardapio_faixa_unidade FOREIGN KEY (idcar) REFERENCES cardapio(idcar);


--
-- Name: fk_cardapio_cardapio_produto; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY cardapio_produto
    ADD CONSTRAINT fk_cardapio_cardapio_produto FOREIGN KEY (idcar) REFERENCES cardapio(idcar);


--
-- Name: fk_cardapio_cardapio_receita; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY cardapio_receita
    ADD CONSTRAINT fk_cardapio_cardapio_receita FOREIGN KEY (idcar) REFERENCES cardapio(idcar);


--
-- Name: fk_cliente_calendario; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY calendario
    ADD CONSTRAINT fk_cliente_calendario FOREIGN KEY (idcli) REFERENCES cliente(idcli);


--
-- Name: fk_cliente_cardapio; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY cardapio
    ADD CONSTRAINT fk_cliente_cardapio FOREIGN KEY (idcli) REFERENCES cliente(idcli);


--
-- Name: fk_cliente_contrato; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY contrato
    ADD CONSTRAINT fk_cliente_contrato FOREIGN KEY (idcli) REFERENCES cliente(idcli);


--
-- Name: fk_cliente_cpquimico; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY composto_quimico
    ADD CONSTRAINT fk_cliente_cpquimico FOREIGN KEY (idcli) REFERENCES cliente(idcli);


--
-- Name: fk_cliente_fornecedor; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY fornecedor
    ADD CONSTRAINT fk_cliente_fornecedor FOREIGN KEY (idcli) REFERENCES cliente(idcli);


--
-- Name: fk_cliente_grpatencao; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY faixa_etaria
    ADD CONSTRAINT fk_cliente_grpatencao FOREIGN KEY (idcli) REFERENCES cliente(idcli);


--
-- Name: fk_cliente_grpquimico; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY grupo_quimico
    ADD CONSTRAINT fk_cliente_grpquimico FOREIGN KEY (idcli) REFERENCES cliente(idcli);


--
-- Name: fk_cliente_guia_remessa; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY guia_remessa
    ADD CONSTRAINT fk_cliente_guia_remessa FOREIGN KEY (idcli) REFERENCES cliente(idcli);


--
-- Name: fk_cliente_log_guia; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY log_guia_remessa
    ADD CONSTRAINT fk_cliente_log_guia FOREIGN KEY (idcli) REFERENCES cliente(idcli);


--
-- Name: fk_cliente_receita; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY receita
    ADD CONSTRAINT fk_cliente_receita FOREIGN KEY (idcli) REFERENCES cliente(idcli);


--
-- Name: fk_cliente_tpproduto; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY tipo_produto
    ADD CONSTRAINT fk_cliente_tpproduto FOREIGN KEY (idcli) REFERENCES cliente(idcli);


--
-- Name: fk_cliente_tprefeicao; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY tipo_refeicao
    ADD CONSTRAINT fk_cliente_tprefeicao FOREIGN KEY (idcli) REFERENCES cliente(idcli);


--
-- Name: fk_cliente_tpunidade; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY tipo_unidade
    ADD CONSTRAINT fk_cliente_tpunidade FOREIGN KEY (idcli) REFERENCES cliente(idcli);


--
-- Name: fk_cliente_unidade; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY unidade_atendida
    ADD CONSTRAINT fk_cliente_unidade FOREIGN KEY (idcli) REFERENCES cliente(idcli);


--
-- Name: fk_cliente_uniproduto; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY unidade_produto
    ADD CONSTRAINT fk_cliente_uniproduto FOREIGN KEY (idcli) REFERENCES cliente(idcli);


--
-- Name: fk_contrato_contrato_produto; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY contrato_produto
    ADD CONSTRAINT fk_contrato_contrato_produto FOREIGN KEY (idcon) REFERENCES contrato(idcon);


--
-- Name: fk_contrato_guia_remessa; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY guia_remessa
    ADD CONSTRAINT fk_contrato_guia_remessa FOREIGN KEY (idcon) REFERENCES contrato(idcon);


--
-- Name: fk_cp_quimico_faixa_cp_quimico; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY faixa_composto_quimico
    ADD CONSTRAINT fk_cp_quimico_faixa_cp_quimico FOREIGN KEY (idcom) REFERENCES composto_quimico(idcom);


--
-- Name: fk_emitir_usuario_guia_remessa; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY guia_remessa
    ADD CONSTRAINT fk_emitir_usuario_guia_remessa FOREIGN KEY (login_emissao) REFERENCES acesso.usuario(login);


--
-- Name: fk_faixa_etaria_unidade_faixa; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY unidade_faixa_etaria
    ADD CONSTRAINT fk_faixa_etaria_unidade_faixa FOREIGN KEY (idfae) REFERENCES faixa_etaria(idfae);


--
-- Name: fk_faixa_faixa_cp_quimico; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY faixa_composto_quimico
    ADD CONSTRAINT fk_faixa_faixa_cp_quimico FOREIGN KEY (idfae) REFERENCES faixa_etaria(idfae);


--
-- Name: fk_faixa_uni_cardapio_faixa_unidade; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY cardapio_faixa_unidade
    ADD CONSTRAINT fk_faixa_uni_cardapio_faixa_unidade FOREIGN KEY (idfeu) REFERENCES unidade_faixa_etaria(idfeu);


--
-- Name: fk_fornecedor_contrato; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY contrato
    ADD CONSTRAINT fk_fornecedor_contrato FOREIGN KEY (idfor) REFERENCES fornecedor(idfor);


--
-- Name: fk_fornecedor_guia_remessa; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY guia_remessa
    ADD CONSTRAINT fk_fornecedor_guia_remessa FOREIGN KEY (idfor) REFERENCES fornecedor(idfor);


--
-- Name: fk_fornecedor_produto_fornecedor; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY produto_fornecedor
    ADD CONSTRAINT fk_fornecedor_produto_fornecedor FOREIGN KEY (idfor) REFERENCES fornecedor(idfor);


--
-- Name: fk_fornecedor_unidade; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY fornecedor_unidade_atendida
    ADD CONSTRAINT fk_fornecedor_unidade FOREIGN KEY (idfor) REFERENCES fornecedor(idfor);


--
-- Name: fk_grupo_cp_quimico_cp_quimico; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY composto_quimico
    ADD CONSTRAINT fk_grupo_cp_quimico_cp_quimico FOREIGN KEY (idgrpq) REFERENCES grupo_quimico(idgrpq);


--
-- Name: fk_guia_guia_remessa_produto; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY guia_remessa_produto
    ADD CONSTRAINT fk_guia_guia_remessa_produto FOREIGN KEY (idgui) REFERENCES guia_remessa(idgui);


--
-- Name: fk_guia_produto_baixa_produto; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY baixa_guia_produto
    ADD CONSTRAINT fk_guia_produto_baixa_produto FOREIGN KEY (idgup) REFERENCES guia_remessa_produto(idgup);


--
-- Name: fk_guia_remessa_baixa_guia; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY baixa_guia_remessa
    ADD CONSTRAINT fk_guia_remessa_baixa_guia FOREIGN KEY (idgui) REFERENCES guia_remessa(idgui);


--
-- Name: fk_guia_remessa_guia_pro_diario; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY guia_produto_diario
    ADD CONSTRAINT fk_guia_remessa_guia_pro_diario FOREIGN KEY (idgui) REFERENCES guia_remessa(idgui);


--
-- Name: fk_incluir_usuario_cardapio; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY cardapio
    ADD CONSTRAINT fk_incluir_usuario_cardapio FOREIGN KEY (login_inclusao) REFERENCES acesso.usuario(login);


--
-- Name: fk_medidas_caseiras_cliente; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY medidas_caseiras
    ADD CONSTRAINT fk_medidas_caseiras_cliente FOREIGN KEY (idcli) REFERENCES cliente(idcli);


--
-- Name: fk_pessoa_cliente; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY cliente
    ADD CONSTRAINT fk_pessoa_cliente FOREIGN KEY (idpes) REFERENCES pessoa(idpes);


--
-- Name: fk_pessoa_fornecedor; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY fornecedor
    ADD CONSTRAINT fk_pessoa_fornecedor FOREIGN KEY (idpes) REFERENCES pessoa(idpes);


--
-- Name: fk_pessoa_unidade_atend; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY unidade_atendida
    ADD CONSTRAINT fk_pessoa_unidade_atend FOREIGN KEY (idpes) REFERENCES pessoa(idpes);


--
-- Name: fk_prod_cp_quimico_cp_quimico; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY produto_composto_quimico
    ADD CONSTRAINT fk_prod_cp_quimico_cp_quimico FOREIGN KEY (idcom) REFERENCES composto_quimico(idcom);


--
-- Name: fk_prod_cp_quimico_produto; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY produto_composto_quimico
    ADD CONSTRAINT fk_prod_cp_quimico_produto FOREIGN KEY (idpro) REFERENCES produto(idpro);


--
-- Name: fk_produto_cardapio_produto; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY cardapio_produto
    ADD CONSTRAINT fk_produto_cardapio_produto FOREIGN KEY (idpro) REFERENCES produto(idpro);


--
-- Name: fk_produto_cliente; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY produto
    ADD CONSTRAINT fk_produto_cliente FOREIGN KEY (idcli) REFERENCES cliente(idcli);


--
-- Name: fk_produto_contrato_produto; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY contrato_produto
    ADD CONSTRAINT fk_produto_contrato_produto FOREIGN KEY (idpro) REFERENCES produto(idpro);


--
-- Name: fk_produto_fornecedor; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY produto
    ADD CONSTRAINT fk_produto_fornecedor FOREIGN KEY (idfor) REFERENCES fornecedor(idfor);


--
-- Name: fk_produto_guia_pro_diario; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY guia_produto_diario
    ADD CONSTRAINT fk_produto_guia_pro_diario FOREIGN KEY (idpro) REFERENCES produto(idpro);


--
-- Name: fk_produto_guia_remessa_produto; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY guia_remessa_produto
    ADD CONSTRAINT fk_produto_guia_remessa_produto FOREIGN KEY (idpro) REFERENCES produto(idpro);


--
-- Name: fk_produto_medida_caseira_cliente; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY produto_medida_caseira
    ADD CONSTRAINT fk_produto_medida_caseira_cliente FOREIGN KEY (idcli) REFERENCES cliente(idcli);


--
-- Name: fk_produto_medida_caseira_medidas; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY produto_medida_caseira
    ADD CONSTRAINT fk_produto_medida_caseira_medidas FOREIGN KEY (idmedcas, idcli) REFERENCES medidas_caseiras(idmedcas, idcli);


--
-- Name: fk_produto_medida_caseira_produto; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY produto_medida_caseira
    ADD CONSTRAINT fk_produto_medida_caseira_produto FOREIGN KEY (idpro) REFERENCES produto(idpro);


--
-- Name: fk_produto_produto_fornecedor; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY produto_fornecedor
    ADD CONSTRAINT fk_produto_produto_fornecedor FOREIGN KEY (idpro) REFERENCES produto(idpro);


--
-- Name: fk_produto_tipo; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY produto
    ADD CONSTRAINT fk_produto_tipo FOREIGN KEY (idtip) REFERENCES tipo_produto(idtip);


--
-- Name: fk_produto_unidade; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY produto
    ADD CONSTRAINT fk_produto_unidade FOREIGN KEY (idunp, idcli) REFERENCES unidade_produto(idunp, idcli);


--
-- Name: fk_rec_cp_quimico_cp_quimico; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY receita_composto_quimico
    ADD CONSTRAINT fk_rec_cp_quimico_cp_quimico FOREIGN KEY (idcom) REFERENCES composto_quimico(idcom);


--
-- Name: fk_rec_cp_quimico_receita; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY receita_composto_quimico
    ADD CONSTRAINT fk_rec_cp_quimico_receita FOREIGN KEY (idrec) REFERENCES receita(idrec);


--
-- Name: fk_rec_prod_produto; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY receita_produto
    ADD CONSTRAINT fk_rec_prod_produto FOREIGN KEY (idpro) REFERENCES produto(idpro);


--
-- Name: fk_rec_prod_receita; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY receita_produto
    ADD CONSTRAINT fk_rec_prod_receita FOREIGN KEY (idrec) REFERENCES receita(idrec);


--
-- Name: fk_receita_cardapio_receita; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY cardapio_receita
    ADD CONSTRAINT fk_receita_cardapio_receita FOREIGN KEY (idrec) REFERENCES receita(idrec);


--
-- Name: fk_tipo_uni_uni_atendida; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY unidade_atendida
    ADD CONSTRAINT fk_tipo_uni_uni_atendida FOREIGN KEY (idtip) REFERENCES tipo_unidade(idtip);


--
-- Name: fk_tp_refeicao_cardapio; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY cardapio
    ADD CONSTRAINT fk_tp_refeicao_cardapio FOREIGN KEY (idtre) REFERENCES tipo_refeicao(idtre);


--
-- Name: fk_uni_atend_guia_remessa; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY guia_remessa
    ADD CONSTRAINT fk_uni_atend_guia_remessa FOREIGN KEY (iduni) REFERENCES unidade_atendida(iduni);


--
-- Name: fk_uni_atend_uni_faixa_eta; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY unidade_faixa_etaria
    ADD CONSTRAINT fk_uni_atend_uni_faixa_eta FOREIGN KEY (iduni) REFERENCES unidade_atendida(iduni);


--
-- Name: fk_unidade_atendida_guia_pro_diario; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY guia_produto_diario
    ADD CONSTRAINT fk_unidade_atendida_guia_pro_diario FOREIGN KEY (iduni) REFERENCES unidade_atendida(iduni);


--
-- Name: fk_unidade_fornecedor; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY fornecedor_unidade_atendida
    ADD CONSTRAINT fk_unidade_fornecedor FOREIGN KEY (iduni) REFERENCES unidade_atendida(iduni);


--
-- Name: fk_usuario_baixa_guia; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY baixa_guia_produto
    ADD CONSTRAINT fk_usuario_baixa_guia FOREIGN KEY (login_baixa) REFERENCES acesso.usuario(login);


--
-- Name: fk_usuario_baixa_guia_remessa; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY baixa_guia_remessa
    ADD CONSTRAINT fk_usuario_baixa_guia_remessa FOREIGN KEY (login_baixa) REFERENCES acesso.usuario(login);


--
-- Name: fk_usuario_contrato; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY contrato
    ADD CONSTRAINT fk_usuario_contrato FOREIGN KEY (login) REFERENCES acesso.usuario(login);


--
-- Name: fk_usuario_log_guia; Type: FK CONSTRAINT; Schema: alimentos; Owner: postgres
--

ALTER TABLE ONLY log_guia_remessa
    ADD CONSTRAINT fk_usuario_log_guia FOREIGN KEY (login) REFERENCES acesso.usuario(login);


SET search_path = cadastro, pg_catalog;

--
-- Name: fisica_foto_idpes_fkey; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica_foto
    ADD CONSTRAINT fisica_foto_idpes_fkey FOREIGN KEY (idpes) REFERENCES pessoa(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: fisica_ref_cod_religiao; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica
    ADD CONSTRAINT fisica_ref_cod_religiao FOREIGN KEY (ref_cod_religiao) REFERENCES pmieducar.religiao(cod_religiao);


--
-- Name: fisica_sangue_idpes_fkey; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica_sangue
    ADD CONSTRAINT fisica_sangue_idpes_fkey FOREIGN KEY (idpes) REFERENCES fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: fk_aviso_nome_fisica; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY aviso_nome
    ADD CONSTRAINT fk_aviso_nome_fisica FOREIGN KEY (idpes) REFERENCES fisica(idpes) ON DELETE RESTRICT;


--
-- Name: fk_documento_fisica; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY documento
    ADD CONSTRAINT fk_documento_fisica FOREIGN KEY (idpes) REFERENCES fisica(idpes);


--
-- Name: fk_documento_orgao_emissor_rg; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY documento
    ADD CONSTRAINT fk_documento_orgao_emissor_rg FOREIGN KEY (idorg_exp_rg) REFERENCES orgao_emissor_rg(idorg_rg) ON DELETE RESTRICT;


--
-- Name: fk_documento_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY documento
    ADD CONSTRAINT fk_documento_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_documento_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY documento
    ADD CONSTRAINT fk_documento_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_documento_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY documento
    ADD CONSTRAINT fk_documento_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_documento_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY documento
    ADD CONSTRAINT fk_documento_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_documento_uf_cart_trabalho; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY documento
    ADD CONSTRAINT fk_documento_uf_cart_trabalho FOREIGN KEY (sigla_uf_cart_trabalho) REFERENCES public.uf(sigla_uf);


--
-- Name: fk_documento_uf_cert_civil; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY documento
    ADD CONSTRAINT fk_documento_uf_cert_civil FOREIGN KEY (sigla_uf_cert_civil) REFERENCES public.uf(sigla_uf);


--
-- Name: fk_documento_uf_rg; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY documento
    ADD CONSTRAINT fk_documento_uf_rg FOREIGN KEY (sigla_uf_exp_rg) REFERENCES public.uf(sigla_uf);


--
-- Name: fk_endereco_externo_pessoa; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY endereco_externo
    ADD CONSTRAINT fk_endereco_externo_pessoa FOREIGN KEY (idpes) REFERENCES pessoa(idpes);


--
-- Name: fk_endereco_externo_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY endereco_externo
    ADD CONSTRAINT fk_endereco_externo_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_endereco_externo_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY endereco_externo
    ADD CONSTRAINT fk_endereco_externo_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_endereco_externo_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY endereco_externo
    ADD CONSTRAINT fk_endereco_externo_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_endereco_externo_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY endereco_externo
    ADD CONSTRAINT fk_endereco_externo_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_endereco_externo_tipo_log; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY endereco_externo
    ADD CONSTRAINT fk_endereco_externo_tipo_log FOREIGN KEY (idtlog) REFERENCES urbano.tipo_logradouro(idtlog);


--
-- Name: fk_endereco_externo_uf; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY endereco_externo
    ADD CONSTRAINT fk_endereco_externo_uf FOREIGN KEY (sigla_uf) REFERENCES public.uf(sigla_uf);


--
-- Name: fk_endereco_pes_cep_log_bai; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY endereco_pessoa
    ADD CONSTRAINT fk_endereco_pes_cep_log_bai FOREIGN KEY (cep, idbai, idlog) REFERENCES urbano.cep_logradouro_bairro(cep, idbai, idlog) ON UPDATE CASCADE;


--
-- Name: fk_endereco_pessoa_pessoa; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY endereco_pessoa
    ADD CONSTRAINT fk_endereco_pessoa_pessoa FOREIGN KEY (idpes) REFERENCES pessoa(idpes);


--
-- Name: fk_endereco_pessoa_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY endereco_pessoa
    ADD CONSTRAINT fk_endereco_pessoa_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_endereco_pessoa_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY endereco_pessoa
    ADD CONSTRAINT fk_endereco_pessoa_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_endereco_pessoa_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY endereco_pessoa
    ADD CONSTRAINT fk_endereco_pessoa_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_endereco_pessoa_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY endereco_pessoa
    ADD CONSTRAINT fk_endereco_pessoa_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_fisica_cpf_fisica; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica_cpf
    ADD CONSTRAINT fk_fisica_cpf_fisica FOREIGN KEY (idpes) REFERENCES fisica(idpes) ON DELETE RESTRICT;


--
-- Name: fk_fisica_cpf_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica_cpf
    ADD CONSTRAINT fk_fisica_cpf_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_fisica_cpf_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica_cpf
    ADD CONSTRAINT fk_fisica_cpf_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_fisica_cpf_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica_cpf
    ADD CONSTRAINT fk_fisica_cpf_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_fisica_cpf_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica_cpf
    ADD CONSTRAINT fk_fisica_cpf_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_fisica_escolaridade; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica
    ADD CONSTRAINT fk_fisica_escolaridade FOREIGN KEY (idesco) REFERENCES escolaridade(idesco);


--
-- Name: fk_fisica_estado_civil; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica
    ADD CONSTRAINT fk_fisica_estado_civil FOREIGN KEY (ideciv) REFERENCES estado_civil(ideciv);


--
-- Name: fk_fisica_municipio; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica
    ADD CONSTRAINT fk_fisica_municipio FOREIGN KEY (idmun_nascimento) REFERENCES public.municipio(idmun);


--
-- Name: fk_fisica_ocupacao; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica
    ADD CONSTRAINT fk_fisica_ocupacao FOREIGN KEY (idocup) REFERENCES ocupacao(idocup);


--
-- Name: fk_fisica_pais; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica
    ADD CONSTRAINT fk_fisica_pais FOREIGN KEY (idpais_estrangeiro) REFERENCES public.pais(idpais);


--
-- Name: fk_fisica_pessoa; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica
    ADD CONSTRAINT fk_fisica_pessoa FOREIGN KEY (idpes) REFERENCES pessoa(idpes) ON DELETE RESTRICT;


--
-- Name: fk_fisica_pessoa_conjuge; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica
    ADD CONSTRAINT fk_fisica_pessoa_conjuge FOREIGN KEY (idpes_con) REFERENCES pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_fisica_pessoa_mae; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica
    ADD CONSTRAINT fk_fisica_pessoa_mae FOREIGN KEY (idpes_mae) REFERENCES pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_fisica_pessoa_pai; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica
    ADD CONSTRAINT fk_fisica_pessoa_pai FOREIGN KEY (idpes_pai) REFERENCES pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_fisica_pessoa_responsavel; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica
    ADD CONSTRAINT fk_fisica_pessoa_responsavel FOREIGN KEY (idpes_responsavel) REFERENCES pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_fisica_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica
    ADD CONSTRAINT fk_fisica_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_fisica_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica
    ADD CONSTRAINT fk_fisica_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_fisica_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica
    ADD CONSTRAINT fk_fisica_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_fisica_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica
    ADD CONSTRAINT fk_fisica_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_fone_pessoa_pessoa; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fone_pessoa
    ADD CONSTRAINT fk_fone_pessoa_pessoa FOREIGN KEY (idpes) REFERENCES pessoa(idpes);


--
-- Name: fk_fone_pessoa_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fone_pessoa
    ADD CONSTRAINT fk_fone_pessoa_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_fone_pessoa_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fone_pessoa
    ADD CONSTRAINT fk_fone_pessoa_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_fone_pessoa_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fone_pessoa
    ADD CONSTRAINT fk_fone_pessoa_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_fone_pessoa_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fone_pessoa
    ADD CONSTRAINT fk_fone_pessoa_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_funcionario_fisica; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY funcionario
    ADD CONSTRAINT fk_funcionario_fisica FOREIGN KEY (idpes) REFERENCES fisica(idpes);


--
-- Name: fk_funcionario_instituicao; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY funcionario
    ADD CONSTRAINT fk_funcionario_instituicao FOREIGN KEY (idins) REFERENCES acesso.instituicao(idins);


--
-- Name: fk_funcionario_setor; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY funcionario
    ADD CONSTRAINT fk_funcionario_setor FOREIGN KEY (idset) REFERENCES public.setor(idset);


--
-- Name: fk_funcionario_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY funcionario
    ADD CONSTRAINT fk_funcionario_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_funcionario_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY funcionario
    ADD CONSTRAINT fk_funcionario_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_funcionario_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY funcionario
    ADD CONSTRAINT fk_funcionario_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_funcionario_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY funcionario
    ADD CONSTRAINT fk_funcionario_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_hist_cartao_pes_cidadao; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY historico_cartao
    ADD CONSTRAINT fk_hist_cartao_pes_cidadao FOREIGN KEY (idpes_cidadao) REFERENCES pessoa(idpes);


--
-- Name: fk_hist_cartao_pes_emitiu; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY historico_cartao
    ADD CONSTRAINT fk_hist_cartao_pes_emitiu FOREIGN KEY (idpes_emitiu) REFERENCES pessoa(idpes);


--
-- Name: fk_juridica_pessoa; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY juridica
    ADD CONSTRAINT fk_juridica_pessoa FOREIGN KEY (idpes) REFERENCES pessoa(idpes);


--
-- Name: fk_juridica_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY juridica
    ADD CONSTRAINT fk_juridica_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_juridica_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY juridica
    ADD CONSTRAINT fk_juridica_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_juridica_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY juridica
    ADD CONSTRAINT fk_juridica_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_juridica_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY juridica
    ADD CONSTRAINT fk_juridica_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_juridica_socio; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY socio
    ADD CONSTRAINT fk_juridica_socio FOREIGN KEY (idpes_juridica) REFERENCES juridica(idpes);


--
-- Name: fk_pessoa_fonetico_pessoa; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY pessoa_fonetico
    ADD CONSTRAINT fk_pessoa_fonetico_pessoa FOREIGN KEY (idpes) REFERENCES pessoa(idpes);


--
-- Name: fk_pessoa_pessoa_idpes_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY pessoa
    ADD CONSTRAINT fk_pessoa_pessoa_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_pessoa_pessoa_idpes_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY pessoa
    ADD CONSTRAINT fk_pessoa_pessoa_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_pessoa_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY pessoa
    ADD CONSTRAINT fk_pessoa_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_pessoa_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY pessoa
    ADD CONSTRAINT fk_pessoa_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_pessoa_socio; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY socio
    ADD CONSTRAINT fk_pessoa_socio FOREIGN KEY (idpes_fisica) REFERENCES pessoa(idpes);


--
-- Name: fk_socio_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY socio
    ADD CONSTRAINT fk_socio_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_socio_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY socio
    ADD CONSTRAINT fk_socio_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_socio_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY socio
    ADD CONSTRAINT fk_socio_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_socio_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY socio
    ADD CONSTRAINT fk_socio_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: pessoa_deficiencia_ref_cod_deficiencia_fkey; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica_deficiencia
    ADD CONSTRAINT pessoa_deficiencia_ref_cod_deficiencia_fkey FOREIGN KEY (ref_cod_deficiencia) REFERENCES deficiencia(cod_deficiencia) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: pessoa_deficiencia_ref_idpes_fkey; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica_deficiencia
    ADD CONSTRAINT pessoa_deficiencia_ref_idpes_fkey FOREIGN KEY (ref_idpes) REFERENCES fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: pessoa_raca_ref_cod_deficiencia_fkey; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica_raca
    ADD CONSTRAINT pessoa_raca_ref_cod_deficiencia_fkey FOREIGN KEY (ref_cod_raca) REFERENCES raca(cod_raca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: pessoa_raca_ref_idpes_fkey; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY fisica_raca
    ADD CONSTRAINT pessoa_raca_ref_idpes_fkey FOREIGN KEY (ref_idpes) REFERENCES fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: religiao_idpes_cad_fkey; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY religiao
    ADD CONSTRAINT religiao_idpes_cad_fkey FOREIGN KEY (idpes_cad) REFERENCES fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: religiao_idpes_exc_fkey; Type: FK CONSTRAINT; Schema: cadastro; Owner: postgres
--

ALTER TABLE ONLY religiao
    ADD CONSTRAINT religiao_idpes_exc_fkey FOREIGN KEY (idpes_exc) REFERENCES fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


SET search_path = consistenciacao, pg_catalog;

--
-- Name: fk_campo_metadado_campo_consis; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY campo_metadado
    ADD CONSTRAINT fk_campo_metadado_campo_consis FOREIGN KEY (idcam) REFERENCES campo_consistenciacao(idcam);


--
-- Name: fk_campo_metadado_metadado; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY campo_metadado
    ADD CONSTRAINT fk_campo_metadado_metadado FOREIGN KEY (idmet) REFERENCES metadado(idmet);


--
-- Name: fk_campo_metadado_regra_campo; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY campo_metadado
    ADD CONSTRAINT fk_campo_metadado_regra_campo FOREIGN KEY (idreg) REFERENCES regra_campo(idreg);


--
-- Name: fk_confrontacao_metadado; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY confrontacao
    ADD CONSTRAINT fk_confrontacao_metadado FOREIGN KEY (idmet) REFERENCES metadado(idmet);


--
-- Name: fk_confrontacao_pessoa_instituicao; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY confrontacao
    ADD CONSTRAINT fk_confrontacao_pessoa_instituicao FOREIGN KEY (idins, idpes) REFERENCES acesso.pessoa_instituicao(idins, idpes);


--
-- Name: fk_hist_campo_campo_consist; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY historico_campo
    ADD CONSTRAINT fk_hist_campo_campo_consist FOREIGN KEY (idcam) REFERENCES campo_consistenciacao(idcam) ON DELETE CASCADE;


--
-- Name: fk_historico_campo_pessoa; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY historico_campo
    ADD CONSTRAINT fk_historico_campo_pessoa FOREIGN KEY (idpes) REFERENCES cadastro.pessoa(idpes) ON DELETE CASCADE;


--
-- Name: fk_inc_pessoa_possivel_incoerencia; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY incoerencia_pessoa_possivel
    ADD CONSTRAINT fk_inc_pessoa_possivel_incoerencia FOREIGN KEY (idinc) REFERENCES incoerencia(idinc) ON DELETE CASCADE;


--
-- Name: fk_inc_pessoa_possivel_pessoa; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY incoerencia_pessoa_possivel
    ADD CONSTRAINT fk_inc_pessoa_possivel_pessoa FOREIGN KEY (idpes) REFERENCES cadastro.pessoa(idpes);


--
-- Name: fk_inc_tipo_inc_incoerencia; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY incoerencia_tipo_incoerencia
    ADD CONSTRAINT fk_inc_tipo_inc_incoerencia FOREIGN KEY (idinc) REFERENCES incoerencia(idinc) ON DELETE CASCADE;


--
-- Name: fk_inc_tipo_inc_tipo_incoerencia; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY incoerencia_tipo_incoerencia
    ADD CONSTRAINT fk_inc_tipo_inc_tipo_incoerencia FOREIGN KEY (id_tipo_inc) REFERENCES tipo_incoerencia(id_tipo_inc);


--
-- Name: fk_incoerencia_confrontacao; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY incoerencia
    ADD CONSTRAINT fk_incoerencia_confrontacao FOREIGN KEY (idcon) REFERENCES confrontacao(idcon);


--
-- Name: fk_incoerencia_documento_incoerencia; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY incoerencia_documento
    ADD CONSTRAINT fk_incoerencia_documento_incoerencia FOREIGN KEY (idinc) REFERENCES incoerencia(idinc) ON DELETE CASCADE;


--
-- Name: fk_incoerencia_endereco_incoerencia; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY incoerencia_endereco
    ADD CONSTRAINT fk_incoerencia_endereco_incoerencia FOREIGN KEY (idinc) REFERENCES incoerencia(idinc) ON DELETE CASCADE;


--
-- Name: fk_incoerencia_fone_incoerencia; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY incoerencia_fone
    ADD CONSTRAINT fk_incoerencia_fone_incoerencia FOREIGN KEY (idinc) REFERENCES incoerencia(idinc) ON DELETE CASCADE;


--
-- Name: fk_metadado_fonte; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY metadado
    ADD CONSTRAINT fk_metadado_fonte FOREIGN KEY (idfon) REFERENCES fonte(idfon);


--
-- Name: fk_oco_reg_cam_regra_campo; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY ocorrencia_regra_campo
    ADD CONSTRAINT fk_oco_reg_cam_regra_campo FOREIGN KEY (idreg) REFERENCES regra_campo(idreg);


--
-- Name: fk_tipo_incoerencia_campo_consis; Type: FK CONSTRAINT; Schema: consistenciacao; Owner: postgres
--

ALTER TABLE ONLY tipo_incoerencia
    ADD CONSTRAINT fk_tipo_incoerencia_campo_consis FOREIGN KEY (idcam) REFERENCES campo_consistenciacao(idcam);


SET search_path = modules, pg_catalog;

--
-- Name: calendario_turma_calendario_dia_fk; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY calendario_turma
    ADD CONSTRAINT calendario_turma_calendario_dia_fk FOREIGN KEY (calendario_ano_letivo_id, mes, dia) REFERENCES pmieducar.calendario_dia(ref_cod_calendario_ano_letivo, mes, dia) MATCH FULL ON DELETE CASCADE;


--
-- Name: componente_curricular_ano_escolar_fk; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY componente_curricular_ano_escolar
    ADD CONSTRAINT componente_curricular_ano_escolar_fk FOREIGN KEY (componente_curricular_id) REFERENCES componente_curricular(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: componente_curricular_area_conhecimento_fk; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY componente_curricular
    ADD CONSTRAINT componente_curricular_area_conhecimento_fk FOREIGN KEY (area_conhecimento_id, instituicao_id) REFERENCES area_conhecimento(id, instituicao_id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: componente_curricular_turma_componente_curricular_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY componente_curricular_turma
    ADD CONSTRAINT componente_curricular_turma_componente_curricular_fkey FOREIGN KEY (componente_curricular_id) REFERENCES componente_curricular(id) ON DELETE RESTRICT;


--
-- Name: componente_curricular_turma_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY componente_curricular_turma
    ADD CONSTRAINT componente_curricular_turma_fkey FOREIGN KEY (turma_id) REFERENCES pmieducar.turma(cod_turma) ON DELETE CASCADE;


--
-- Name: docente_licenciatura_ies_fk; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY docente_licenciatura
    ADD CONSTRAINT docente_licenciatura_ies_fk FOREIGN KEY (ies_id) REFERENCES educacenso_ies(id) ON DELETE RESTRICT;


--
-- Name: educacenso_cod_aluno_cod_aluno_fk; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY educacenso_cod_aluno
    ADD CONSTRAINT educacenso_cod_aluno_cod_aluno_fk FOREIGN KEY (cod_aluno) REFERENCES pmieducar.aluno(cod_aluno) ON DELETE CASCADE;


--
-- Name: educacenso_cod_escola_cod_escola_fk; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY educacenso_cod_escola
    ADD CONSTRAINT educacenso_cod_escola_cod_escola_fk FOREIGN KEY (cod_escola) REFERENCES pmieducar.escola(cod_escola) ON DELETE CASCADE;


--
-- Name: educacenso_cod_turma_cod_turma_fk; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY educacenso_cod_turma
    ADD CONSTRAINT educacenso_cod_turma_cod_turma_fk FOREIGN KEY (cod_turma) REFERENCES pmieducar.turma(cod_turma) ON DELETE CASCADE;


--
-- Name: empresa_transporte_escolar_ref_idpes_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY empresa_transporte_escolar
    ADD CONSTRAINT empresa_transporte_escolar_ref_idpes_fkey FOREIGN KEY (ref_idpes) REFERENCES cadastro.juridica(idpes);


--
-- Name: empresa_transporte_escolar_ref_resp_idpes_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY empresa_transporte_escolar
    ADD CONSTRAINT empresa_transporte_escolar_ref_resp_idpes_fkey FOREIGN KEY (ref_resp_idpes) REFERENCES cadastro.fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: etapas_curso_educacenso_curso_fk; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY etapas_curso_educacenso
    ADD CONSTRAINT etapas_curso_educacenso_curso_fk FOREIGN KEY (curso_id) REFERENCES pmieducar.curso(cod_curso);


--
-- Name: etapas_curso_educacenso_etapa_fk; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY etapas_curso_educacenso
    ADD CONSTRAINT etapas_curso_educacenso_etapa_fk FOREIGN KEY (etapa_id) REFERENCES etapas_educacenso(id);


--
-- Name: falta_componente_curricular_falta_aluno_fk; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY falta_componente_curricular
    ADD CONSTRAINT falta_componente_curricular_falta_aluno_fk FOREIGN KEY (falta_aluno_id) REFERENCES falta_aluno(id) ON DELETE CASCADE;


--
-- Name: falta_geral_falta_aluno_fk; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY falta_geral
    ADD CONSTRAINT falta_geral_falta_aluno_fk FOREIGN KEY (falta_aluno_id) REFERENCES falta_aluno(id) ON DELETE CASCADE;


--
-- Name: ficha_medica_aluno_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY ficha_medica_aluno
    ADD CONSTRAINT ficha_medica_aluno_fkey FOREIGN KEY (ref_cod_aluno) REFERENCES pmieducar.aluno(cod_aluno) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: fk_ponto_cep_log_bai; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY ponto_transporte_escolar
    ADD CONSTRAINT fk_ponto_cep_log_bai FOREIGN KEY (idbai, idlog, cep) REFERENCES urbano.cep_logradouro_bairro(idbai, idlog, cep);


--
-- Name: itinerario_transporte_escolar_ref_cod_rota_transporte_escolar_f; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY itinerario_transporte_escolar
    ADD CONSTRAINT itinerario_transporte_escolar_ref_cod_rota_transporte_escolar_f FOREIGN KEY (ref_cod_rota_transporte_escolar) REFERENCES rota_transporte_escolar(cod_rota_transporte_escolar);


--
-- Name: media_geral_nota_aluno_fk; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY media_geral
    ADD CONSTRAINT media_geral_nota_aluno_fk FOREIGN KEY (nota_aluno_id) REFERENCES nota_aluno(id) ON DELETE CASCADE;


--
-- Name: moradia_aluno_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY moradia_aluno
    ADD CONSTRAINT moradia_aluno_fkey FOREIGN KEY (ref_cod_aluno) REFERENCES pmieducar.aluno(cod_aluno) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: moradia_aluno_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY nota_exame
    ADD CONSTRAINT moradia_aluno_fkey FOREIGN KEY (ref_cod_matricula) REFERENCES pmieducar.matricula(cod_matricula) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: motorista_ref_cod_empresa_transporte_escolar_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY motorista
    ADD CONSTRAINT motorista_ref_cod_empresa_transporte_escolar_fkey FOREIGN KEY (ref_cod_empresa_transporte_escolar) REFERENCES empresa_transporte_escolar(cod_empresa_transporte_escolar) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: motorista_ref_idpes_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY motorista
    ADD CONSTRAINT motorista_ref_idpes_fkey FOREIGN KEY (ref_idpes) REFERENCES cadastro.fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: nota_componente_curricular_media_nota_aluno_fk; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY nota_componente_curricular_media
    ADD CONSTRAINT nota_componente_curricular_media_nota_aluno_fk FOREIGN KEY (nota_aluno_id) REFERENCES nota_aluno(id) ON DELETE CASCADE;


--
-- Name: nota_componente_curricular_nota_aluno_fk; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY nota_componente_curricular
    ADD CONSTRAINT nota_componente_curricular_nota_aluno_fk FOREIGN KEY (nota_aluno_id) REFERENCES nota_aluno(id) ON DELETE CASCADE;


--
-- Name: nota_nota_geral_nota_aluno_fk; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY nota_geral
    ADD CONSTRAINT nota_nota_geral_nota_aluno_fk FOREIGN KEY (nota_aluno_id) REFERENCES nota_aluno(id) ON DELETE CASCADE;


--
-- Name: parecer_componente_curricular_parecer_aluno_fk; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY parecer_componente_curricular
    ADD CONSTRAINT parecer_componente_curricular_parecer_aluno_fk FOREIGN KEY (parecer_aluno_id) REFERENCES parecer_aluno(id) ON DELETE CASCADE;


--
-- Name: parecer_geral_parecer_aluno_fk; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY parecer_geral
    ADD CONSTRAINT parecer_geral_parecer_aluno_fk FOREIGN KEY (parecer_aluno_id) REFERENCES parecer_aluno(id) ON DELETE CASCADE;


--
-- Name: pessoa_transporte_ref_cod_ponto_transporte_escolar_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY pessoa_transporte
    ADD CONSTRAINT pessoa_transporte_ref_cod_ponto_transporte_escolar_fkey FOREIGN KEY (ref_cod_ponto_transporte_escolar) REFERENCES ponto_transporte_escolar(cod_ponto_transporte_escolar);


--
-- Name: pessoa_transporte_ref_cod_rota_transporte_escolar_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY pessoa_transporte
    ADD CONSTRAINT pessoa_transporte_ref_cod_rota_transporte_escolar_fkey FOREIGN KEY (ref_cod_rota_transporte_escolar) REFERENCES rota_transporte_escolar(cod_rota_transporte_escolar);


--
-- Name: pessoa_transporte_ref_idpes_destino_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY pessoa_transporte
    ADD CONSTRAINT pessoa_transporte_ref_idpes_destino_fkey FOREIGN KEY (ref_idpes_destino) REFERENCES cadastro.juridica(idpes);


--
-- Name: pessoa_transporte_ref_idpes_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY pessoa_transporte
    ADD CONSTRAINT pessoa_transporte_ref_idpes_fkey FOREIGN KEY (ref_idpes) REFERENCES cadastro.fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: ponto_transporte_escolar_ref_cod_veiculo_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY itinerario_transporte_escolar
    ADD CONSTRAINT ponto_transporte_escolar_ref_cod_veiculo_fkey FOREIGN KEY (ref_cod_veiculo) REFERENCES veiculo(cod_veiculo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: professor_turma_disciplina_componente_curricular_id_fk; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY professor_turma_disciplina
    ADD CONSTRAINT professor_turma_disciplina_componente_curricular_id_fk FOREIGN KEY (componente_curricular_id) REFERENCES componente_curricular(id) MATCH FULL ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: professor_turma_disciplina_professor_turma_id_fk; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY professor_turma_disciplina
    ADD CONSTRAINT professor_turma_disciplina_professor_turma_id_fk FOREIGN KEY (professor_turma_id) REFERENCES professor_turma(id) MATCH FULL ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: professor_turma_servidor_id_fk; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY professor_turma
    ADD CONSTRAINT professor_turma_servidor_id_fk FOREIGN KEY (servidor_id, instituicao_id) REFERENCES pmieducar.servidor(cod_servidor, ref_cod_instituicao) MATCH FULL ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: professor_turma_turma_id_fk; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY professor_turma
    ADD CONSTRAINT professor_turma_turma_id_fk FOREIGN KEY (turma_id) REFERENCES pmieducar.turma(cod_turma) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: regra_avaliacao_formula_media_formula_media_fk; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY regra_avaliacao
    ADD CONSTRAINT regra_avaliacao_formula_media_formula_media_fk FOREIGN KEY (formula_media_id, instituicao_id) REFERENCES formula_media(id, instituicao_id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: regra_avaliacao_formula_media_formula_recuperacao_fk; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY regra_avaliacao
    ADD CONSTRAINT regra_avaliacao_formula_media_formula_recuperacao_fk FOREIGN KEY (formula_recuperacao_id, instituicao_id) REFERENCES formula_media(id, instituicao_id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: regra_avaliacao_regra_avaliacao_recuperacao_fk; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY regra_avaliacao_recuperacao
    ADD CONSTRAINT regra_avaliacao_regra_avaliacao_recuperacao_fk FOREIGN KEY (regra_avaliacao_id) REFERENCES regra_avaliacao(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: regra_avaliacao_tabela_arredondamento_fk; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY regra_avaliacao
    ADD CONSTRAINT regra_avaliacao_tabela_arredondamento_fk FOREIGN KEY (tabela_arredondamento_id, instituicao_id) REFERENCES tabela_arredondamento(id, instituicao_id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: rota_transporte_escolar_ref_cod_empresa_transporte_escolar_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY rota_transporte_escolar
    ADD CONSTRAINT rota_transporte_escolar_ref_cod_empresa_transporte_escolar_fkey FOREIGN KEY (ref_cod_empresa_transporte_escolar) REFERENCES empresa_transporte_escolar(cod_empresa_transporte_escolar) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: rota_transporte_escolar_ref_idpes_destino_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY rota_transporte_escolar
    ADD CONSTRAINT rota_transporte_escolar_ref_idpes_destino_fkey FOREIGN KEY (ref_idpes_destino) REFERENCES cadastro.juridica(idpes);


--
-- Name: tabela_arredondamento_tabela_arredondamento_valor_fk; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY tabela_arredondamento_valor
    ADD CONSTRAINT tabela_arredondamento_tabela_arredondamento_valor_fk FOREIGN KEY (tabela_arredondamento_id) REFERENCES tabela_arredondamento(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: transporte_aluno_aluno_fk; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY transporte_aluno
    ADD CONSTRAINT transporte_aluno_aluno_fk FOREIGN KEY (aluno_id) REFERENCES pmieducar.aluno(cod_aluno) ON DELETE CASCADE;


--
-- Name: uniforme_aluno_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY uniforme_aluno
    ADD CONSTRAINT uniforme_aluno_fkey FOREIGN KEY (ref_cod_aluno) REFERENCES pmieducar.aluno(cod_aluno) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: veiculo_ref_cod_empresa_transporte_escolar_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY veiculo
    ADD CONSTRAINT veiculo_ref_cod_empresa_transporte_escolar_fkey FOREIGN KEY (ref_cod_empresa_transporte_escolar) REFERENCES empresa_transporte_escolar(cod_empresa_transporte_escolar);


--
-- Name: veiculo_ref_cod_tipo_veiculo_fkey; Type: FK CONSTRAINT; Schema: modules; Owner: postgres
--

ALTER TABLE ONLY veiculo
    ADD CONSTRAINT veiculo_ref_cod_tipo_veiculo_fkey FOREIGN KEY (ref_cod_tipo_veiculo) REFERENCES tipo_veiculo(cod_tipo_veiculo) ON UPDATE RESTRICT ON DELETE RESTRICT;


SET search_path = pmiacoes, pg_catalog;

--
-- Name: acao_governo_arquivo_ref_cod_acao_governo_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY acao_governo_arquivo
    ADD CONSTRAINT acao_governo_arquivo_ref_cod_acao_governo_fkey FOREIGN KEY (ref_cod_acao_governo) REFERENCES acao_governo(cod_acao_governo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acao_governo_arquivo_ref_funcionario_cad_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY acao_governo_arquivo
    ADD CONSTRAINT acao_governo_arquivo_ref_funcionario_cad_fkey FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acao_governo_categoria_ref_cod_acao_governo_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY acao_governo_categoria
    ADD CONSTRAINT acao_governo_categoria_ref_cod_acao_governo_fkey FOREIGN KEY (ref_cod_acao_governo) REFERENCES acao_governo(cod_acao_governo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acao_governo_categoria_ref_cod_categoria_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY acao_governo_categoria
    ADD CONSTRAINT acao_governo_categoria_ref_cod_categoria_fkey FOREIGN KEY (ref_cod_categoria) REFERENCES categoria(cod_categoria) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acao_governo_foto_portal_ref_cod_acao_governo_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY acao_governo_foto_portal
    ADD CONSTRAINT acao_governo_foto_portal_ref_cod_acao_governo_fkey FOREIGN KEY (ref_cod_acao_governo) REFERENCES acao_governo(cod_acao_governo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acao_governo_foto_portal_ref_cod_foto_portal_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY acao_governo_foto_portal
    ADD CONSTRAINT acao_governo_foto_portal_ref_cod_foto_portal_fkey FOREIGN KEY (ref_cod_foto_portal) REFERENCES portal.foto_portal(cod_foto_portal) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acao_governo_foto_portal_ref_funcionario_cad_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY acao_governo_foto_portal
    ADD CONSTRAINT acao_governo_foto_portal_ref_funcionario_cad_fkey FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acao_governo_foto_ref_cod_acao_governo_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY acao_governo_foto
    ADD CONSTRAINT acao_governo_foto_ref_cod_acao_governo_fkey FOREIGN KEY (ref_cod_acao_governo) REFERENCES acao_governo(cod_acao_governo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acao_governo_foto_ref_funcionario_cad_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY acao_governo_foto
    ADD CONSTRAINT acao_governo_foto_ref_funcionario_cad_fkey FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acao_governo_noticia_ref_cod_acao_governo_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY acao_governo_noticia
    ADD CONSTRAINT acao_governo_noticia_ref_cod_acao_governo_fkey FOREIGN KEY (ref_cod_acao_governo) REFERENCES acao_governo(cod_acao_governo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acao_governo_noticia_ref_cod_not_portal_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY acao_governo_noticia
    ADD CONSTRAINT acao_governo_noticia_ref_cod_not_portal_fkey FOREIGN KEY (ref_cod_not_portal) REFERENCES portal.not_portal(cod_not_portal) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acao_governo_noticia_ref_funcionario_cad_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY acao_governo_noticia
    ADD CONSTRAINT acao_governo_noticia_ref_funcionario_cad_fkey FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acao_governo_ref_funcionario_cad_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY acao_governo
    ADD CONSTRAINT acao_governo_ref_funcionario_cad_fkey FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acao_governo_ref_funcionario_exc_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY acao_governo
    ADD CONSTRAINT acao_governo_ref_funcionario_exc_fkey FOREIGN KEY (ref_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acao_governo_setor_ref_cod_acao_governo_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY acao_governo_setor
    ADD CONSTRAINT acao_governo_setor_ref_cod_acao_governo_fkey FOREIGN KEY (ref_cod_acao_governo) REFERENCES acao_governo(cod_acao_governo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acao_governo_setor_ref_cod_setor_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY acao_governo_setor
    ADD CONSTRAINT acao_governo_setor_ref_cod_setor_fkey FOREIGN KEY (ref_cod_setor) REFERENCES pmidrh.setor(cod_setor) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acao_governo_setor_ref_funcionario_cad_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY acao_governo_setor
    ADD CONSTRAINT acao_governo_setor_ref_funcionario_cad_fkey FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: categoria_ref_funcionario_cad_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY categoria
    ADD CONSTRAINT categoria_ref_funcionario_cad_fkey FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: categoria_ref_funcionario_exc_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY categoria
    ADD CONSTRAINT categoria_ref_funcionario_exc_fkey FOREIGN KEY (ref_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: secretaria_responsavel_ref_cod_funcionario_cad_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY secretaria_responsavel
    ADD CONSTRAINT secretaria_responsavel_ref_cod_funcionario_cad_fkey FOREIGN KEY (ref_cod_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: secretaria_responsavel_ref_cod_setor_fkey; Type: FK CONSTRAINT; Schema: pmiacoes; Owner: postgres
--

ALTER TABLE ONLY secretaria_responsavel
    ADD CONSTRAINT secretaria_responsavel_ref_cod_setor_fkey FOREIGN KEY (ref_cod_setor) REFERENCES pmidrh.setor(cod_setor) ON UPDATE RESTRICT ON DELETE RESTRICT;


SET search_path = pmicontrolesis, pg_catalog;

--
-- Name: acontecimento_ref_funcionario_cad_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY acontecimento
    ADD CONSTRAINT acontecimento_ref_funcionario_cad_fk FOREIGN KEY (ref_cod_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- Name: acontecimento_ref_funcionario_cad_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY tipo_acontecimento
    ADD CONSTRAINT acontecimento_ref_funcionario_cad_fk FOREIGN KEY (ref_cod_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- Name: acontecimento_ref_funcionario_exc_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY acontecimento
    ADD CONSTRAINT acontecimento_ref_funcionario_exc_fk FOREIGN KEY (ref_cod_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- Name: acontecimento_ref_funcionario_exc_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY tipo_acontecimento
    ADD CONSTRAINT acontecimento_ref_funcionario_exc_fk FOREIGN KEY (ref_cod_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- Name: fk_to_imagem_ico; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY menu
    ADD CONSTRAINT fk_to_imagem_ico FOREIGN KEY (ref_cod_ico) REFERENCES portal.imagem(cod_imagem) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: fk_to_tutor; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY menu
    ADD CONSTRAINT fk_to_tutor FOREIGN KEY (ref_cod_tutormenu) REFERENCES tutormenu(cod_tutormenu);


--
-- Name: foto_evento_ibfk_1; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY foto_evento
    ADD CONSTRAINT foto_evento_ibfk_1 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: foto_vinc_ref_cod_acontecimento_fkey; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY foto_vinc
    ADD CONSTRAINT foto_vinc_ref_cod_acontecimento_fkey FOREIGN KEY (ref_cod_acontecimento) REFERENCES acontecimento(cod_acontecimento);


--
-- Name: foto_vinc_ref_cod_foto_evento_fkey; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY foto_vinc
    ADD CONSTRAINT foto_vinc_ref_cod_foto_evento_fkey FOREIGN KEY (ref_cod_foto_evento) REFERENCES foto_evento(cod_foto_evento);


--
-- Name: itinerario_ref_funcionario_cad_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY itinerario
    ADD CONSTRAINT itinerario_ref_funcionario_cad_fk FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- Name: itinerario_ref_funcionario_exc_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY itinerario
    ADD CONSTRAINT itinerario_ref_funcionario_exc_fk FOREIGN KEY (ref_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- Name: menu_portal_ref_funcionario_cad_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY menu_portal
    ADD CONSTRAINT menu_portal_ref_funcionario_cad_fk FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- Name: menu_portal_ref_funcionario_exc_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY menu_portal
    ADD CONSTRAINT menu_portal_ref_funcionario_exc_fk FOREIGN KEY (ref_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- Name: menu_ref_cod_menu_pai_fkey; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY menu
    ADD CONSTRAINT menu_ref_cod_menu_pai_fkey FOREIGN KEY (ref_cod_menu_pai) REFERENCES menu(cod_menu) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: menu_ref_cod_menu_submenu_fkey; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY menu
    ADD CONSTRAINT menu_ref_cod_menu_submenu_fkey FOREIGN KEY (ref_cod_menu_submenu) REFERENCES portal.menu_submenu(cod_menu_submenu) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: portais_ref_funcionario_cad_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY portais
    ADD CONSTRAINT portais_ref_funcionario_cad_fk FOREIGN KEY (ref_cod_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- Name: portais_ref_funcionario_exc_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY portais
    ADD CONSTRAINT portais_ref_funcionario_exc_fk FOREIGN KEY (ref_cod_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- Name: servicos_ref_funcionario_cad_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY servicos
    ADD CONSTRAINT servicos_ref_funcionario_cad_fk FOREIGN KEY (ref_cod_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- Name: servicos_ref_funcionario_exc_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY servicos
    ADD CONSTRAINT servicos_ref_funcionario_exc_fk FOREIGN KEY (ref_cod_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- Name: sistema_ref_funcionario_cad_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY sistema
    ADD CONSTRAINT sistema_ref_funcionario_cad_fk FOREIGN KEY (ref_cod_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- Name: sistema_ref_funcionario_exc_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY sistema
    ADD CONSTRAINT sistema_ref_funcionario_exc_fk FOREIGN KEY (ref_cod_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- Name: submenu_portal_ref_cod_menu_portal_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY submenu_portal
    ADD CONSTRAINT submenu_portal_ref_cod_menu_portal_fk FOREIGN KEY (ref_cod_menu_portal) REFERENCES menu_portal(cod_menu_portal);


--
-- Name: submenu_portal_ref_funcionario_cad_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY submenu_portal
    ADD CONSTRAINT submenu_portal_ref_funcionario_cad_fk FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- Name: submenu_portal_ref_funcionario_cad_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY topo_portal
    ADD CONSTRAINT submenu_portal_ref_funcionario_cad_fk FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- Name: submenu_portal_ref_funcionario_exc_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY submenu_portal
    ADD CONSTRAINT submenu_portal_ref_funcionario_exc_fk FOREIGN KEY (ref_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- Name: submenu_portal_ref_funcionario_exc_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY topo_portal
    ADD CONSTRAINT submenu_portal_ref_funcionario_exc_fk FOREIGN KEY (ref_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- Name: telefones_ref_funcionario_cad_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY telefones
    ADD CONSTRAINT telefones_ref_funcionario_cad_fk FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- Name: telefones_ref_funcionario_exc_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY telefones
    ADD CONSTRAINT telefones_ref_funcionario_exc_fk FOREIGN KEY (ref_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj);


--
-- Name: tipo_acontecimento_ref_funcionario_cad_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY acontecimento
    ADD CONSTRAINT tipo_acontecimento_ref_funcionario_cad_fk FOREIGN KEY (ref_cod_tipo_acontecimento) REFERENCES tipo_acontecimento(cod_tipo_acontecimento);


--
-- Name: topo_portal_ref_cod_menu_portal_fk; Type: FK CONSTRAINT; Schema: pmicontrolesis; Owner: postgres
--

ALTER TABLE ONLY topo_portal
    ADD CONSTRAINT topo_portal_ref_cod_menu_portal_fk FOREIGN KEY (ref_cod_menu_portal) REFERENCES menu_portal(cod_menu_portal);


SET search_path = pmidrh, pg_catalog;

--
-- Name: diaria_ref_cod_diaria_grupo_fkey; Type: FK CONSTRAINT; Schema: pmidrh; Owner: postgres
--

ALTER TABLE ONLY diaria
    ADD CONSTRAINT diaria_ref_cod_diaria_grupo_fkey FOREIGN KEY (ref_cod_diaria_grupo) REFERENCES diaria_grupo(cod_diaria_grupo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: diaria_ref_cod_setor; Type: FK CONSTRAINT; Schema: pmidrh; Owner: postgres
--

ALTER TABLE ONLY diaria
    ADD CONSTRAINT diaria_ref_cod_setor FOREIGN KEY (ref_cod_setor) REFERENCES setor(cod_setor);


--
-- Name: diaria_ref_funcionario_cadastro_fkey; Type: FK CONSTRAINT; Schema: pmidrh; Owner: postgres
--

ALTER TABLE ONLY diaria
    ADD CONSTRAINT diaria_ref_funcionario_cadastro_fkey FOREIGN KEY (ref_funcionario_cadastro) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: diaria_ref_funcionario_fkey; Type: FK CONSTRAINT; Schema: pmidrh; Owner: postgres
--

ALTER TABLE ONLY diaria
    ADD CONSTRAINT diaria_ref_funcionario_fkey FOREIGN KEY (ref_funcionario) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: diaria_valores_ref_cod_diaria_grupo_fkey; Type: FK CONSTRAINT; Schema: pmidrh; Owner: postgres
--

ALTER TABLE ONLY diaria_valores
    ADD CONSTRAINT diaria_valores_ref_cod_diaria_grupo_fkey FOREIGN KEY (ref_cod_diaria_grupo) REFERENCES diaria_grupo(cod_diaria_grupo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: diaria_valores_ref_funcionario_cadastro_fkey; Type: FK CONSTRAINT; Schema: pmidrh; Owner: postgres
--

ALTER TABLE ONLY diaria_valores
    ADD CONSTRAINT diaria_valores_ref_funcionario_cadastro_fkey FOREIGN KEY (ref_funcionario_cadastro) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: fk_setor_pai; Type: FK CONSTRAINT; Schema: pmidrh; Owner: postgres
--

ALTER TABLE ONLY setor
    ADD CONSTRAINT fk_setor_pai FOREIGN KEY (ref_cod_setor) REFERENCES setor(cod_setor) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: fk_to_idpes_resp; Type: FK CONSTRAINT; Schema: pmidrh; Owner: postgres
--

ALTER TABLE ONLY setor
    ADD CONSTRAINT fk_to_idpes_resp FOREIGN KEY (ref_idpes_resp) REFERENCES cadastro.fisica(idpes);


--
-- Name: setor_ref_cod_pessoa_cad_fkey; Type: FK CONSTRAINT; Schema: pmidrh; Owner: postgres
--

ALTER TABLE ONLY setor
    ADD CONSTRAINT setor_ref_cod_pessoa_cad_fkey FOREIGN KEY (ref_cod_pessoa_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: setor_ref_cod_pessoa_exc_fkey; Type: FK CONSTRAINT; Schema: pmidrh; Owner: postgres
--

ALTER TABLE ONLY setor
    ADD CONSTRAINT setor_ref_cod_pessoa_exc_fkey FOREIGN KEY (ref_cod_pessoa_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


SET search_path = pmieducar, pg_catalog;

--
-- Name: acervo_acervo_assunto_ref_cod_acervo_assunto_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_acervo_assunto
    ADD CONSTRAINT acervo_acervo_assunto_ref_cod_acervo_assunto_fkey FOREIGN KEY (ref_cod_acervo_assunto) REFERENCES acervo_assunto(cod_acervo_assunto) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_acervo_assunto_ref_cod_acervo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_acervo_assunto
    ADD CONSTRAINT acervo_acervo_assunto_ref_cod_acervo_fkey FOREIGN KEY (ref_cod_acervo) REFERENCES acervo(cod_acervo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_acervo_autor_ref_cod_acervo_autor_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_acervo_autor
    ADD CONSTRAINT acervo_acervo_autor_ref_cod_acervo_autor_fkey FOREIGN KEY (ref_cod_acervo_autor) REFERENCES acervo_autor(cod_acervo_autor) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_acervo_autor_ref_cod_acervo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_acervo_autor
    ADD CONSTRAINT acervo_acervo_autor_ref_cod_acervo_fkey FOREIGN KEY (ref_cod_acervo) REFERENCES acervo(cod_acervo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_assunto_ref_cod_biblioteca_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_assunto
    ADD CONSTRAINT acervo_assunto_ref_cod_biblioteca_fkey FOREIGN KEY (ref_cod_biblioteca) REFERENCES biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_assunto_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_assunto
    ADD CONSTRAINT acervo_assunto_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_assunto_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_assunto
    ADD CONSTRAINT acervo_assunto_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_autor_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_autor
    ADD CONSTRAINT acervo_autor_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_autor_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_autor
    ADD CONSTRAINT acervo_autor_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_colecao_ref_cod_biblioteca_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_colecao
    ADD CONSTRAINT acervo_colecao_ref_cod_biblioteca_fkey FOREIGN KEY (ref_cod_biblioteca) REFERENCES biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_colecao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_colecao
    ADD CONSTRAINT acervo_colecao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_colecao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_colecao
    ADD CONSTRAINT acervo_colecao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_editora_ref_cod_biblioteca_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_editora
    ADD CONSTRAINT acervo_editora_ref_cod_biblioteca_fkey FOREIGN KEY (ref_cod_biblioteca) REFERENCES biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_editora_ref_idtlog_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_editora
    ADD CONSTRAINT acervo_editora_ref_idtlog_fkey FOREIGN KEY (ref_idtlog) REFERENCES urbano.tipo_logradouro(idtlog) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_editora_ref_sigla_uf_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_editora
    ADD CONSTRAINT acervo_editora_ref_sigla_uf_fkey FOREIGN KEY (ref_sigla_uf) REFERENCES public.uf(sigla_uf) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_editora_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_editora
    ADD CONSTRAINT acervo_editora_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_editora_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_editora
    ADD CONSTRAINT acervo_editora_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_idioma_ref_cod_biblioteca_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_idioma
    ADD CONSTRAINT acervo_idioma_ref_cod_biblioteca_fkey FOREIGN KEY (ref_cod_biblioteca) REFERENCES biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_idioma_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_idioma
    ADD CONSTRAINT acervo_idioma_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_idioma_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_idioma
    ADD CONSTRAINT acervo_idioma_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_ref_cod_acervo_colecao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo
    ADD CONSTRAINT acervo_ref_cod_acervo_colecao_fkey FOREIGN KEY (ref_cod_acervo_colecao) REFERENCES acervo_colecao(cod_acervo_colecao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_ref_cod_acervo_editora_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo
    ADD CONSTRAINT acervo_ref_cod_acervo_editora_fkey FOREIGN KEY (ref_cod_acervo_editora) REFERENCES acervo_editora(cod_acervo_editora) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_ref_cod_acervo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo
    ADD CONSTRAINT acervo_ref_cod_acervo_fkey FOREIGN KEY (ref_cod_acervo) REFERENCES acervo(cod_acervo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_ref_cod_acervo_idioma_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo
    ADD CONSTRAINT acervo_ref_cod_acervo_idioma_fkey FOREIGN KEY (ref_cod_acervo_idioma) REFERENCES acervo_idioma(cod_acervo_idioma) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_ref_cod_biblioteca; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo
    ADD CONSTRAINT acervo_ref_cod_biblioteca FOREIGN KEY (ref_cod_biblioteca) REFERENCES biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_ref_cod_biblioteca_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo_autor
    ADD CONSTRAINT acervo_ref_cod_biblioteca_fkey FOREIGN KEY (ref_cod_biblioteca) REFERENCES biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_ref_cod_exemplar_tipo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo
    ADD CONSTRAINT acervo_ref_cod_exemplar_tipo_fkey FOREIGN KEY (ref_cod_exemplar_tipo) REFERENCES exemplar_tipo(cod_exemplar_tipo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo
    ADD CONSTRAINT acervo_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: acervo_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY acervo
    ADD CONSTRAINT acervo_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: aluno_aluno_beneficio_aluno_beneficio_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY aluno_aluno_beneficio
    ADD CONSTRAINT aluno_aluno_beneficio_aluno_beneficio_fk FOREIGN KEY (aluno_beneficio_id) REFERENCES aluno_beneficio(cod_aluno_beneficio);


--
-- Name: aluno_aluno_beneficio_aluno_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY aluno_aluno_beneficio
    ADD CONSTRAINT aluno_aluno_beneficio_aluno_fk FOREIGN KEY (aluno_id) REFERENCES aluno(cod_aluno);


--
-- Name: aluno_beneficio_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY aluno_beneficio
    ADD CONSTRAINT aluno_beneficio_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: aluno_beneficio_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY aluno_beneficio
    ADD CONSTRAINT aluno_beneficio_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: aluno_historico_altura_peso_ref_cod_aluno_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: ieducar
--

ALTER TABLE ONLY aluno_historico_altura_peso
    ADD CONSTRAINT aluno_historico_altura_peso_ref_cod_aluno_fkey FOREIGN KEY (ref_cod_aluno) REFERENCES aluno(cod_aluno);


--
-- Name: aluno_ref_idpes_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY aluno
    ADD CONSTRAINT aluno_ref_idpes_fkey FOREIGN KEY (ref_idpes) REFERENCES cadastro.fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: aluno_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY aluno
    ADD CONSTRAINT aluno_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: aluno_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY aluno
    ADD CONSTRAINT aluno_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: ano_letivo_modulo_ref_cod_modulo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY ano_letivo_modulo
    ADD CONSTRAINT ano_letivo_modulo_ref_cod_modulo_fkey FOREIGN KEY (ref_cod_modulo) REFERENCES modulo(cod_modulo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: ano_letivo_modulo_ref_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY ano_letivo_modulo
    ADD CONSTRAINT ano_letivo_modulo_ref_ref_cod_escola_fkey FOREIGN KEY (ref_ref_cod_escola, ref_ano) REFERENCES escola_ano_letivo(ref_cod_escola, ano) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: auditoria_falta_componente_di_ref_cod_componente_curricula_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: ieducar
--

ALTER TABLE ONLY auditoria_falta_componente_dispensa
    ADD CONSTRAINT auditoria_falta_componente_di_ref_cod_componente_curricula_fkey FOREIGN KEY (ref_cod_componente_curricular) REFERENCES modules.componente_curricular(id);


--
-- Name: auditoria_falta_componente_dispensa_ref_cod_matricula_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: ieducar
--

ALTER TABLE ONLY auditoria_falta_componente_dispensa
    ADD CONSTRAINT auditoria_falta_componente_dispensa_ref_cod_matricula_fkey FOREIGN KEY (ref_cod_matricula) REFERENCES matricula(cod_matricula);


--
-- Name: auditoria_nota_dispensa_ref_cod_componente_curricular_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: ieducar
--

ALTER TABLE ONLY auditoria_nota_dispensa
    ADD CONSTRAINT auditoria_nota_dispensa_ref_cod_componente_curricular_fkey FOREIGN KEY (ref_cod_componente_curricular) REFERENCES modules.componente_curricular(id);


--
-- Name: auditoria_nota_dispensa_ref_cod_matricula_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: ieducar
--

ALTER TABLE ONLY auditoria_nota_dispensa
    ADD CONSTRAINT auditoria_nota_dispensa_ref_cod_matricula_fkey FOREIGN KEY (ref_cod_matricula) REFERENCES matricula(cod_matricula);


--
-- Name: avaliacao_desempenho_ref_cod_servidor_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY avaliacao_desempenho
    ADD CONSTRAINT avaliacao_desempenho_ref_cod_servidor_fkey FOREIGN KEY (ref_cod_servidor, ref_ref_cod_instituicao) REFERENCES servidor(cod_servidor, ref_cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: avaliacao_desempenho_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY avaliacao_desempenho
    ADD CONSTRAINT avaliacao_desempenho_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: avaliacao_desempenho_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY avaliacao_desempenho
    ADD CONSTRAINT avaliacao_desempenho_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: biblioteca_dia_ref_cod_biblioteca_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY biblioteca_dia
    ADD CONSTRAINT biblioteca_dia_ref_cod_biblioteca_fkey FOREIGN KEY (ref_cod_biblioteca) REFERENCES biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: biblioteca_feriados_ref_cod_biblioteca_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY biblioteca_feriados
    ADD CONSTRAINT biblioteca_feriados_ref_cod_biblioteca_fkey FOREIGN KEY (ref_cod_biblioteca) REFERENCES biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: biblioteca_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY biblioteca
    ADD CONSTRAINT biblioteca_ref_cod_escola_fkey FOREIGN KEY (ref_cod_escola) REFERENCES escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: biblioteca_ref_cod_instituicao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY biblioteca
    ADD CONSTRAINT biblioteca_ref_cod_instituicao_fkey FOREIGN KEY (ref_cod_instituicao) REFERENCES instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: biblioteca_usuario_ref_cod_biblioteca_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY biblioteca_usuario
    ADD CONSTRAINT biblioteca_usuario_ref_cod_biblioteca_fk FOREIGN KEY (ref_cod_biblioteca) REFERENCES biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: bloqueio_lancamento_faltas_notas_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY bloqueio_lancamento_faltas_notas
    ADD CONSTRAINT bloqueio_lancamento_faltas_notas_ref_cod_escola_fkey FOREIGN KEY (ref_cod_escola) REFERENCES escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: calendario_ano_letivo_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY calendario_ano_letivo
    ADD CONSTRAINT calendario_ano_letivo_ref_cod_escola_fkey FOREIGN KEY (ref_cod_escola) REFERENCES escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: calendario_ano_letivo_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY calendario_ano_letivo
    ADD CONSTRAINT calendario_ano_letivo_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: calendario_ano_letivo_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY calendario_ano_letivo
    ADD CONSTRAINT calendario_ano_letivo_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: calendario_anotacao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY calendario_anotacao
    ADD CONSTRAINT calendario_anotacao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: calendario_anotacao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY calendario_anotacao
    ADD CONSTRAINT calendario_anotacao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: calendario_dia_anotacao_ref_cod_calendario_anotacao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY calendario_dia_anotacao
    ADD CONSTRAINT calendario_dia_anotacao_ref_cod_calendario_anotacao_fkey FOREIGN KEY (ref_cod_calendario_anotacao) REFERENCES calendario_anotacao(cod_calendario_anotacao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: calendario_dia_anotacao_ref_ref_cod_calendario_ano_letivo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY calendario_dia_anotacao
    ADD CONSTRAINT calendario_dia_anotacao_ref_ref_cod_calendario_ano_letivo_fkey FOREIGN KEY (ref_ref_cod_calendario_ano_letivo, ref_mes, ref_dia) REFERENCES calendario_dia(ref_cod_calendario_ano_letivo, mes, dia) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: calendario_dia_motivo_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY calendario_dia_motivo
    ADD CONSTRAINT calendario_dia_motivo_ref_cod_escola_fkey FOREIGN KEY (ref_cod_escola) REFERENCES escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: calendario_dia_motivo_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY calendario_dia_motivo
    ADD CONSTRAINT calendario_dia_motivo_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: calendario_dia_motivo_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY calendario_dia_motivo
    ADD CONSTRAINT calendario_dia_motivo_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: calendario_dia_ref_cod_calendario_ano_letivo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY calendario_dia
    ADD CONSTRAINT calendario_dia_ref_cod_calendario_ano_letivo_fkey FOREIGN KEY (ref_cod_calendario_ano_letivo) REFERENCES calendario_ano_letivo(cod_calendario_ano_letivo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: calendario_dia_ref_cod_calendario_dia_motivo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY calendario_dia
    ADD CONSTRAINT calendario_dia_ref_cod_calendario_dia_motivo_fkey FOREIGN KEY (ref_cod_calendario_dia_motivo) REFERENCES calendario_dia_motivo(cod_calendario_dia_motivo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: calendario_dia_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY calendario_dia
    ADD CONSTRAINT calendario_dia_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: calendario_dia_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY calendario_dia
    ADD CONSTRAINT calendario_dia_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: candidato_reserva_vaga_ref_cod_escola; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY candidato_reserva_vaga
    ADD CONSTRAINT candidato_reserva_vaga_ref_cod_escola FOREIGN KEY (ref_cod_escola) REFERENCES escola(cod_escola);


--
-- Name: categoria_nivel_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY categoria_nivel
    ADD CONSTRAINT categoria_nivel_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: categoria_nivel_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY categoria_nivel
    ADD CONSTRAINT categoria_nivel_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: cliente_ref_idpes_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY cliente
    ADD CONSTRAINT cliente_ref_idpes_fkey FOREIGN KEY (ref_idpes) REFERENCES cadastro.fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: cliente_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY cliente
    ADD CONSTRAINT cliente_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: cliente_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY cliente
    ADD CONSTRAINT cliente_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: cliente_suspensao_ref_cod_cliente_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY cliente_suspensao
    ADD CONSTRAINT cliente_suspensao_ref_cod_cliente_fkey FOREIGN KEY (ref_cod_cliente) REFERENCES cliente(cod_cliente) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: cliente_suspensao_ref_cod_motivo_suspensao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY cliente_suspensao
    ADD CONSTRAINT cliente_suspensao_ref_cod_motivo_suspensao_fkey FOREIGN KEY (ref_cod_motivo_suspensao) REFERENCES motivo_suspensao(cod_motivo_suspensao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: cliente_suspensao_ref_usuario_libera_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY cliente_suspensao
    ADD CONSTRAINT cliente_suspensao_ref_usuario_libera_fkey FOREIGN KEY (ref_usuario_libera) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: cliente_suspensao_ref_usuario_suspende_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY cliente_suspensao
    ADD CONSTRAINT cliente_suspensao_ref_usuario_suspende_fkey FOREIGN KEY (ref_usuario_suspende) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: cliente_tipo_cliente_ibfk1; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY cliente_tipo_cliente
    ADD CONSTRAINT cliente_tipo_cliente_ibfk1 FOREIGN KEY (ref_cod_cliente) REFERENCES cliente(cod_cliente) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: cliente_tipo_cliente_ibfk2; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY cliente_tipo_cliente
    ADD CONSTRAINT cliente_tipo_cliente_ibfk2 FOREIGN KEY (ref_cod_cliente_tipo) REFERENCES cliente_tipo(cod_cliente_tipo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: cliente_tipo_exemplar_tipo_ref_cod_cliente_tipo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY cliente_tipo_exemplar_tipo
    ADD CONSTRAINT cliente_tipo_exemplar_tipo_ref_cod_cliente_tipo_fkey FOREIGN KEY (ref_cod_cliente_tipo) REFERENCES cliente_tipo(cod_cliente_tipo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: cliente_tipo_exemplar_tipo_ref_cod_exemplar_tipo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY cliente_tipo_exemplar_tipo
    ADD CONSTRAINT cliente_tipo_exemplar_tipo_ref_cod_exemplar_tipo_fkey FOREIGN KEY (ref_cod_exemplar_tipo) REFERENCES exemplar_tipo(cod_exemplar_tipo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: cliente_tipo_ref_cod_biblioteca_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY cliente_tipo
    ADD CONSTRAINT cliente_tipo_ref_cod_biblioteca_fkey FOREIGN KEY (ref_cod_biblioteca) REFERENCES biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: cliente_tipo_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY cliente_tipo
    ADD CONSTRAINT cliente_tipo_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: cliente_tipo_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY cliente_tipo
    ADD CONSTRAINT cliente_tipo_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: codigo_curso_superior_1_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor
    ADD CONSTRAINT codigo_curso_superior_1_fk FOREIGN KEY (codigo_curso_superior_1) REFERENCES modules.educacenso_curso_superior(id);


--
-- Name: codigo_curso_superior_2_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor
    ADD CONSTRAINT codigo_curso_superior_2_fk FOREIGN KEY (codigo_curso_superior_2) REFERENCES modules.educacenso_curso_superior(id);


--
-- Name: codigo_curso_superior_3_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor
    ADD CONSTRAINT codigo_curso_superior_3_fk FOREIGN KEY (codigo_curso_superior_3) REFERENCES modules.educacenso_curso_superior(id);


--
-- Name: coffebreak_tipo_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY coffebreak_tipo
    ADD CONSTRAINT coffebreak_tipo_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: coffebreak_tipo_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY coffebreak_tipo
    ADD CONSTRAINT coffebreak_tipo_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: curso_ref_cod_instituicao_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY curso
    ADD CONSTRAINT curso_ref_cod_instituicao_fk FOREIGN KEY (ref_cod_instituicao) REFERENCES instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: curso_ref_cod_nivel_ensino_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY curso
    ADD CONSTRAINT curso_ref_cod_nivel_ensino_fkey FOREIGN KEY (ref_cod_nivel_ensino) REFERENCES nivel_ensino(cod_nivel_ensino) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: curso_ref_cod_tipo_ensino_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY curso
    ADD CONSTRAINT curso_ref_cod_tipo_ensino_fkey FOREIGN KEY (ref_cod_tipo_ensino) REFERENCES tipo_ensino(cod_tipo_ensino) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: curso_ref_cod_tipo_regime_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY curso
    ADD CONSTRAINT curso_ref_cod_tipo_regime_fkey FOREIGN KEY (ref_cod_tipo_regime) REFERENCES tipo_regime(cod_tipo_regime) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: curso_ref_cod_usuario_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY curso
    ADD CONSTRAINT curso_ref_cod_usuario_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: curso_ref_usuario_exc_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY curso
    ADD CONSTRAINT curso_ref_usuario_exc_fk FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: disciplina_dependencia_ref_cod_matricula_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY disciplina_dependencia
    ADD CONSTRAINT disciplina_dependencia_ref_cod_matricula_fkey FOREIGN KEY (ref_cod_matricula) REFERENCES matricula(cod_matricula) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: disciplina_dependencia_ref_cod_serie_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY disciplina_dependencia
    ADD CONSTRAINT disciplina_dependencia_ref_cod_serie_fkey FOREIGN KEY (ref_cod_serie, ref_cod_escola, ref_cod_disciplina) REFERENCES escola_serie_disciplina(ref_ref_cod_serie, ref_ref_cod_escola, ref_cod_disciplina) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: disciplina_ref_cod_curso; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY disciplina
    ADD CONSTRAINT disciplina_ref_cod_curso FOREIGN KEY (ref_cod_curso) REFERENCES curso(cod_curso) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: disciplina_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY disciplina
    ADD CONSTRAINT disciplina_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: disciplina_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY disciplina
    ADD CONSTRAINT disciplina_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: disciplina_serie_ref_cod_disciplina_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY disciplina_serie
    ADD CONSTRAINT disciplina_serie_ref_cod_disciplina_fkey FOREIGN KEY (ref_cod_disciplina) REFERENCES disciplina(cod_disciplina) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: disciplina_serie_ref_cod_serie_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY disciplina_serie
    ADD CONSTRAINT disciplina_serie_ref_cod_serie_fkey FOREIGN KEY (ref_cod_serie) REFERENCES serie(cod_serie) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: disciplina_topico_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY disciplina_topico
    ADD CONSTRAINT disciplina_topico_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: disciplina_topico_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY disciplina_topico
    ADD CONSTRAINT disciplina_topico_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: dispensa_disciplina_ref_cod_matricula_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY dispensa_disciplina
    ADD CONSTRAINT dispensa_disciplina_ref_cod_matricula_fkey FOREIGN KEY (ref_cod_matricula) REFERENCES matricula(cod_matricula) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: dispensa_disciplina_ref_cod_serie_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY dispensa_disciplina
    ADD CONSTRAINT dispensa_disciplina_ref_cod_serie_fkey FOREIGN KEY (ref_cod_serie, ref_cod_escola, ref_cod_disciplina) REFERENCES escola_serie_disciplina(ref_ref_cod_serie, ref_ref_cod_escola, ref_cod_disciplina) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: dispensa_disciplina_ref_cod_tipo_dispensa_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY dispensa_disciplina
    ADD CONSTRAINT dispensa_disciplina_ref_cod_tipo_dispensa_fkey FOREIGN KEY (ref_cod_tipo_dispensa) REFERENCES tipo_dispensa(cod_tipo_dispensa) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: dispensa_disciplina_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY dispensa_disciplina
    ADD CONSTRAINT dispensa_disciplina_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: dispensa_disciplina_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY dispensa_disciplina
    ADD CONSTRAINT dispensa_disciplina_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: distribuicao_uniforme_ref_cod_aluno_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY distribuicao_uniforme
    ADD CONSTRAINT distribuicao_uniforme_ref_cod_aluno_fkey FOREIGN KEY (ref_cod_aluno) REFERENCES aluno(cod_aluno) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_ano_letivo_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola_ano_letivo
    ADD CONSTRAINT escola_ano_letivo_ref_cod_escola_fkey FOREIGN KEY (ref_cod_escola) REFERENCES escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_ano_letivo_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola_ano_letivo
    ADD CONSTRAINT escola_ano_letivo_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_ano_letivo_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola_ano_letivo
    ADD CONSTRAINT escola_ano_letivo_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_codigo_indigena_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola
    ADD CONSTRAINT escola_codigo_indigena_fk FOREIGN KEY (codigo_lingua_indigena) REFERENCES modules.lingua_indigena_educacenso(id);


--
-- Name: escola_complemento_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola_complemento
    ADD CONSTRAINT escola_complemento_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_complemento_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola_complemento
    ADD CONSTRAINT escola_complemento_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_curso_ref_cod_curso_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola_curso
    ADD CONSTRAINT escola_curso_ref_cod_curso_fkey FOREIGN KEY (ref_cod_curso) REFERENCES curso(cod_curso) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_curso_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola_curso
    ADD CONSTRAINT escola_curso_ref_cod_escola_fkey FOREIGN KEY (ref_cod_escola) REFERENCES escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_curso_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola_curso
    ADD CONSTRAINT escola_curso_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_curso_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola_curso
    ADD CONSTRAINT escola_curso_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_localizacao_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola_localizacao
    ADD CONSTRAINT escola_localizacao_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_localizacao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola_localizacao
    ADD CONSTRAINT escola_localizacao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_localizacao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola_localizacao
    ADD CONSTRAINT escola_localizacao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_rede_ensino_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola_rede_ensino
    ADD CONSTRAINT escola_rede_ensino_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_rede_ensino_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola_rede_ensino
    ADD CONSTRAINT escola_rede_ensino_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_ref_cod_escola_localizacao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola
    ADD CONSTRAINT escola_ref_cod_escola_localizacao_fkey FOREIGN KEY (ref_cod_escola_localizacao) REFERENCES escola_localizacao(cod_escola_localizacao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_ref_cod_escola_rede_ensino_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola
    ADD CONSTRAINT escola_ref_cod_escola_rede_ensino_fkey FOREIGN KEY (ref_cod_escola_rede_ensino) REFERENCES escola_rede_ensino(cod_escola_rede_ensino) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_ref_cod_instituicao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola
    ADD CONSTRAINT escola_ref_cod_instituicao_fkey FOREIGN KEY (ref_cod_instituicao) REFERENCES instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_ref_idpes_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola
    ADD CONSTRAINT escola_ref_idpes_fkey FOREIGN KEY (ref_idpes) REFERENCES cadastro.juridica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_ref_idpes_gestor_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola
    ADD CONSTRAINT escola_ref_idpes_gestor_fk FOREIGN KEY (ref_idpes_gestor) REFERENCES cadastro.pessoa(idpes);


--
-- Name: escola_ref_idpes_secretario_escolar_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola
    ADD CONSTRAINT escola_ref_idpes_secretario_escolar_fkey FOREIGN KEY (ref_idpes_secretario_escolar) REFERENCES cadastro.pessoa(idpes);


--
-- Name: escola_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola
    ADD CONSTRAINT escola_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola
    ADD CONSTRAINT escola_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_serie_disciplina_ref_cod_disciplina_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola_serie_disciplina
    ADD CONSTRAINT escola_serie_disciplina_ref_cod_disciplina_fkey FOREIGN KEY (ref_cod_disciplina) REFERENCES modules.componente_curricular(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_serie_disciplina_ref_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola_serie_disciplina
    ADD CONSTRAINT escola_serie_disciplina_ref_ref_cod_escola_fkey FOREIGN KEY (ref_ref_cod_escola, ref_ref_cod_serie) REFERENCES escola_serie(ref_cod_escola, ref_cod_serie) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_serie_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola_serie
    ADD CONSTRAINT escola_serie_ref_cod_escola_fkey FOREIGN KEY (ref_cod_escola) REFERENCES escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_serie_ref_cod_serie_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola_serie
    ADD CONSTRAINT escola_serie_ref_cod_serie_fkey FOREIGN KEY (ref_cod_serie) REFERENCES serie(cod_serie) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_serie_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola_serie
    ADD CONSTRAINT escola_serie_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_serie_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY escola_serie
    ADD CONSTRAINT escola_serie_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_usuario_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: ieducar
--

ALTER TABLE ONLY escola_usuario
    ADD CONSTRAINT escola_usuario_ref_cod_escola_fkey FOREIGN KEY (ref_cod_escola) REFERENCES escola(cod_escola);


--
-- Name: escola_usuario_ref_cod_usuario_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: ieducar
--

ALTER TABLE ONLY escola_usuario
    ADD CONSTRAINT escola_usuario_ref_cod_usuario_fkey FOREIGN KEY (ref_cod_usuario) REFERENCES usuario(cod_usuario);


--
-- Name: exemplar_emprestimo_ref_cod_cliente_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY exemplar_emprestimo
    ADD CONSTRAINT exemplar_emprestimo_ref_cod_cliente_fkey FOREIGN KEY (ref_cod_cliente) REFERENCES cliente(cod_cliente) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: exemplar_emprestimo_ref_cod_exemplar_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY exemplar_emprestimo
    ADD CONSTRAINT exemplar_emprestimo_ref_cod_exemplar_fkey FOREIGN KEY (ref_cod_exemplar) REFERENCES exemplar(cod_exemplar) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: exemplar_emprestimo_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY exemplar_emprestimo
    ADD CONSTRAINT exemplar_emprestimo_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: exemplar_emprestimo_ref_usuario_devolucao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY exemplar_emprestimo
    ADD CONSTRAINT exemplar_emprestimo_ref_usuario_devolucao_fkey FOREIGN KEY (ref_usuario_devolucao) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: exemplar_ref_cod_acervo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY exemplar
    ADD CONSTRAINT exemplar_ref_cod_acervo_fkey FOREIGN KEY (ref_cod_acervo) REFERENCES acervo(cod_acervo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: exemplar_ref_cod_fonte_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY exemplar
    ADD CONSTRAINT exemplar_ref_cod_fonte_fkey FOREIGN KEY (ref_cod_fonte) REFERENCES fonte(cod_fonte) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: exemplar_ref_cod_motivo_baixa_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY exemplar
    ADD CONSTRAINT exemplar_ref_cod_motivo_baixa_fkey FOREIGN KEY (ref_cod_motivo_baixa) REFERENCES motivo_baixa(cod_motivo_baixa) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: exemplar_ref_cod_situacao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY exemplar
    ADD CONSTRAINT exemplar_ref_cod_situacao_fkey FOREIGN KEY (ref_cod_situacao) REFERENCES situacao(cod_situacao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: exemplar_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY exemplar
    ADD CONSTRAINT exemplar_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: exemplar_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY exemplar
    ADD CONSTRAINT exemplar_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: exemplar_tipo_ref_cod_biblioteca_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY exemplar_tipo
    ADD CONSTRAINT exemplar_tipo_ref_cod_biblioteca_fkey FOREIGN KEY (ref_cod_biblioteca) REFERENCES biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: exemplar_tipo_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY exemplar_tipo
    ADD CONSTRAINT exemplar_tipo_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: exemplar_tipo_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY exemplar_tipo
    ADD CONSTRAINT exemplar_tipo_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: falta_aluno_ref_cod_curso_disciplina; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY falta_aluno
    ADD CONSTRAINT falta_aluno_ref_cod_curso_disciplina FOREIGN KEY (ref_cod_curso_disciplina) REFERENCES disciplina(cod_disciplina) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: falta_aluno_ref_cod_serie_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY falta_aluno
    ADD CONSTRAINT falta_aluno_ref_cod_serie_fkey FOREIGN KEY (ref_cod_serie, ref_cod_escola, ref_cod_disciplina) REFERENCES escola_serie_disciplina(ref_ref_cod_serie, ref_ref_cod_escola, ref_cod_disciplina) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: falta_aluno_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY falta_aluno
    ADD CONSTRAINT falta_aluno_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: falta_aluno_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY falta_aluno
    ADD CONSTRAINT falta_aluno_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: falta_atraso_compensado_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY falta_atraso_compensado
    ADD CONSTRAINT falta_atraso_compensado_ref_cod_escola_fkey FOREIGN KEY (ref_cod_escola) REFERENCES escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: falta_atraso_compensado_ref_cod_servidor_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY falta_atraso_compensado
    ADD CONSTRAINT falta_atraso_compensado_ref_cod_servidor_fkey FOREIGN KEY (ref_cod_servidor, ref_ref_cod_instituicao) REFERENCES servidor(cod_servidor, ref_cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: falta_atraso_compensado_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY falta_atraso_compensado
    ADD CONSTRAINT falta_atraso_compensado_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: falta_atraso_compensado_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY falta_atraso_compensado
    ADD CONSTRAINT falta_atraso_compensado_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: falta_atraso_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY falta_atraso
    ADD CONSTRAINT falta_atraso_ref_cod_escola_fkey FOREIGN KEY (ref_cod_escola) REFERENCES escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: falta_atraso_ref_cod_servidor_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY falta_atraso
    ADD CONSTRAINT falta_atraso_ref_cod_servidor_fkey FOREIGN KEY (ref_cod_servidor, ref_ref_cod_instituicao) REFERENCES servidor(cod_servidor, ref_cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: falta_atraso_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY falta_atraso
    ADD CONSTRAINT falta_atraso_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: falta_atraso_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY falta_atraso
    ADD CONSTRAINT falta_atraso_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: faltas_ref_cod_matricula_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY faltas
    ADD CONSTRAINT faltas_ref_cod_matricula_fkey FOREIGN KEY (ref_cod_matricula) REFERENCES matricula(cod_matricula) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: faltas_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY faltas
    ADD CONSTRAINT faltas_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: fk_abandono_tipo_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY abandono_tipo
    ADD CONSTRAINT fk_abandono_tipo_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES instituicao(cod_instituicao);


--
-- Name: fk_abandono_tipo_usuario_cad; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY abandono_tipo
    ADD CONSTRAINT fk_abandono_tipo_usuario_cad FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario);


--
-- Name: fk_abandono_tipo_usuario_exc; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY abandono_tipo
    ADD CONSTRAINT fk_abandono_tipo_usuario_exc FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario);


--
-- Name: fk_distribuicao_uniforme_escola; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY distribuicao_uniforme
    ADD CONSTRAINT fk_distribuicao_uniforme_escola FOREIGN KEY (ref_cod_escola) REFERENCES escola(cod_escola);


--
-- Name: fk_matricula_abandono_tipo; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY matricula
    ADD CONSTRAINT fk_matricula_abandono_tipo FOREIGN KEY (ref_cod_abandono_tipo) REFERENCES abandono_tipo(cod_abandono_tipo);


--
-- Name: fk_ref_cod_biblioteca_cliente; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY cliente_tipo_cliente
    ADD CONSTRAINT fk_ref_cod_biblioteca_cliente FOREIGN KEY (ref_cod_biblioteca) REFERENCES biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: fk_ref_cod_exemplar; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY reservas
    ADD CONSTRAINT fk_ref_cod_exemplar FOREIGN KEY (ref_cod_exemplar) REFERENCES exemplar(cod_exemplar) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: fk_servidor_pessoa; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor
    ADD CONSTRAINT fk_servidor_pessoa FOREIGN KEY (cod_servidor) REFERENCES cadastro.pessoa(idpes);


--
-- Name: fk_turma_disciplina_dispensada; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY turma
    ADD CONSTRAINT fk_turma_disciplina_dispensada FOREIGN KEY (ref_cod_disciplina_dispensada) REFERENCES modules.componente_curricular(id);


--
-- Name: fonte_ref_cod_biblioteca_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY fonte
    ADD CONSTRAINT fonte_ref_cod_biblioteca_fkey FOREIGN KEY (ref_cod_biblioteca) REFERENCES biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: fonte_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY fonte
    ADD CONSTRAINT fonte_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: fonte_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY fonte
    ADD CONSTRAINT fonte_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: funca_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY funcao
    ADD CONSTRAINT funca_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: funcao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY funcao
    ADD CONSTRAINT funcao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: funcao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY funcao
    ADD CONSTRAINT funcao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: habilitacao_curso_ref_cod_curso_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY habilitacao_curso
    ADD CONSTRAINT habilitacao_curso_ref_cod_curso_fkey FOREIGN KEY (ref_cod_curso) REFERENCES curso(cod_curso) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: habilitacao_curso_ref_cod_habilitacao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY habilitacao_curso
    ADD CONSTRAINT habilitacao_curso_ref_cod_habilitacao_fkey FOREIGN KEY (ref_cod_habilitacao) REFERENCES habilitacao(cod_habilitacao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: habilitacao_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY habilitacao
    ADD CONSTRAINT habilitacao_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: habilitacao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY habilitacao
    ADD CONSTRAINT habilitacao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: habilitacao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY habilitacao
    ADD CONSTRAINT habilitacao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: historico_disciplinas_ref_ref_cod_aluno_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY historico_disciplinas
    ADD CONSTRAINT historico_disciplinas_ref_ref_cod_aluno_fkey FOREIGN KEY (ref_ref_cod_aluno, ref_sequencial) REFERENCES historico_escolar(ref_cod_aluno, sequencial) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: historico_escolar_ref_cod_aluno_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY historico_escolar
    ADD CONSTRAINT historico_escolar_ref_cod_aluno_fkey FOREIGN KEY (ref_cod_aluno) REFERENCES aluno(cod_aluno) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: historico_escolar_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY historico_escolar
    ADD CONSTRAINT historico_escolar_ref_cod_escola_fkey FOREIGN KEY (ref_cod_escola) REFERENCES escola(cod_escola);


--
-- Name: historico_escolar_ref_cod_escola_fkey1; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY historico_escolar
    ADD CONSTRAINT historico_escolar_ref_cod_escola_fkey1 FOREIGN KEY (ref_cod_escola) REFERENCES escola(cod_escola);


--
-- Name: historico_escolar_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY historico_escolar
    ADD CONSTRAINT historico_escolar_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: historico_escolar_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY historico_escolar
    ADD CONSTRAINT historico_escolar_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: historico_grade_curso_id_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY historico_escolar
    ADD CONSTRAINT historico_grade_curso_id_fkey FOREIGN KEY (historico_grade_curso_id) REFERENCES historico_grade_curso(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: infra_comodo_funcao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY infra_comodo_funcao
    ADD CONSTRAINT infra_comodo_funcao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: infra_comodo_funcao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY infra_comodo_funcao
    ADD CONSTRAINT infra_comodo_funcao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: infra_comodo_ref_cod_escola; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY infra_comodo_funcao
    ADD CONSTRAINT infra_comodo_ref_cod_escola FOREIGN KEY (ref_cod_escola) REFERENCES escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: infra_predio_comodo_ref_cod_infra_comodo_funcao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY infra_predio_comodo
    ADD CONSTRAINT infra_predio_comodo_ref_cod_infra_comodo_funcao_fkey FOREIGN KEY (ref_cod_infra_comodo_funcao) REFERENCES infra_comodo_funcao(cod_infra_comodo_funcao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: infra_predio_comodo_ref_cod_infra_predio_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY infra_predio_comodo
    ADD CONSTRAINT infra_predio_comodo_ref_cod_infra_predio_fkey FOREIGN KEY (ref_cod_infra_predio) REFERENCES infra_predio(cod_infra_predio) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: infra_predio_comodo_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY infra_predio_comodo
    ADD CONSTRAINT infra_predio_comodo_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: infra_predio_comodo_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY infra_predio_comodo
    ADD CONSTRAINT infra_predio_comodo_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: infra_predio_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY infra_predio
    ADD CONSTRAINT infra_predio_ref_cod_escola_fkey FOREIGN KEY (ref_cod_escola) REFERENCES escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: infra_predio_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY infra_predio
    ADD CONSTRAINT infra_predio_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: infra_predio_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY infra_predio
    ADD CONSTRAINT infra_predio_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: instituicao_curso_superior_1_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor
    ADD CONSTRAINT instituicao_curso_superior_1_fk FOREIGN KEY (instituicao_curso_superior_1) REFERENCES modules.educacenso_ies(id);


--
-- Name: instituicao_curso_superior_2_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor
    ADD CONSTRAINT instituicao_curso_superior_2_fk FOREIGN KEY (instituicao_curso_superior_2) REFERENCES modules.educacenso_ies(id);


--
-- Name: instituicao_curso_superior_3_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor
    ADD CONSTRAINT instituicao_curso_superior_3_fk FOREIGN KEY (instituicao_curso_superior_3) REFERENCES modules.educacenso_ies(id);


--
-- Name: instituicao_id_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY instituicao_documentacao
    ADD CONSTRAINT instituicao_id_fkey FOREIGN KEY (instituicao_id) REFERENCES instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: instituicao_ref_idtlog_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY instituicao
    ADD CONSTRAINT instituicao_ref_idtlog_fkey FOREIGN KEY (ref_idtlog) REFERENCES urbano.tipo_logradouro(idtlog) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: instituicao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY instituicao
    ADD CONSTRAINT instituicao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: instituicao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY instituicao
    ADD CONSTRAINT instituicao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: material_didatico_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY material_didatico
    ADD CONSTRAINT material_didatico_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: material_didatico_ref_cod_material_tipo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY material_didatico
    ADD CONSTRAINT material_didatico_ref_cod_material_tipo_fkey FOREIGN KEY (ref_cod_material_tipo) REFERENCES material_tipo(cod_material_tipo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: material_didatico_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY material_didatico
    ADD CONSTRAINT material_didatico_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: material_didatico_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY material_didatico
    ADD CONSTRAINT material_didatico_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: material_tipo_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY material_tipo
    ADD CONSTRAINT material_tipo_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: material_tipo_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY material_tipo
    ADD CONSTRAINT material_tipo_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: material_tipo_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY material_tipo
    ADD CONSTRAINT material_tipo_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: matricula_excessao_ref_cod_disciplina_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY matricula_excessao
    ADD CONSTRAINT matricula_excessao_ref_cod_disciplina_fkey FOREIGN KEY (ref_cod_serie, ref_cod_escola, ref_cod_disciplina) REFERENCES escola_serie_disciplina(ref_ref_cod_serie, ref_ref_cod_escola, ref_cod_disciplina) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: matricula_excessao_ref_cod_matricula_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY matricula_excessao
    ADD CONSTRAINT matricula_excessao_ref_cod_matricula_fkey FOREIGN KEY (ref_cod_matricula, ref_cod_turma, ref_sequencial) REFERENCES matricula_turma(ref_cod_matricula, ref_cod_turma, sequencial) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: matricula_ocorrencia_discipli_ref_cod_tipo_ocorrencia_disc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY matricula_ocorrencia_disciplinar
    ADD CONSTRAINT matricula_ocorrencia_discipli_ref_cod_tipo_ocorrencia_disc_fkey FOREIGN KEY (ref_cod_tipo_ocorrencia_disciplinar) REFERENCES tipo_ocorrencia_disciplinar(cod_tipo_ocorrencia_disciplinar) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: matricula_ocorrencia_disciplinar_ref_cod_matricula_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY matricula_ocorrencia_disciplinar
    ADD CONSTRAINT matricula_ocorrencia_disciplinar_ref_cod_matricula_fkey FOREIGN KEY (ref_cod_matricula) REFERENCES matricula(cod_matricula) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: matricula_ocorrencia_disciplinar_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY matricula_ocorrencia_disciplinar
    ADD CONSTRAINT matricula_ocorrencia_disciplinar_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: matricula_ocorrencia_disciplinar_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY matricula_ocorrencia_disciplinar
    ADD CONSTRAINT matricula_ocorrencia_disciplinar_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: matricula_ref_cod_aluno_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY matricula
    ADD CONSTRAINT matricula_ref_cod_aluno_fkey FOREIGN KEY (ref_cod_aluno) REFERENCES aluno(cod_aluno) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: matricula_ref_cod_curso; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY matricula
    ADD CONSTRAINT matricula_ref_cod_curso FOREIGN KEY (ref_cod_curso) REFERENCES curso(cod_curso) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: matricula_ref_cod_reserva_vaga_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY matricula
    ADD CONSTRAINT matricula_ref_cod_reserva_vaga_fkey FOREIGN KEY (ref_cod_reserva_vaga) REFERENCES reserva_vaga(cod_reserva_vaga) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: matricula_ref_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY matricula
    ADD CONSTRAINT matricula_ref_ref_cod_escola_fkey FOREIGN KEY (ref_ref_cod_escola) REFERENCES escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: matricula_ref_ref_cod_serie_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY matricula
    ADD CONSTRAINT matricula_ref_ref_cod_serie_fkey FOREIGN KEY (ref_ref_cod_serie) REFERENCES serie(cod_serie) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: matricula_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY matricula
    ADD CONSTRAINT matricula_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: matricula_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY matricula
    ADD CONSTRAINT matricula_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: matricula_turma_ref_cod_matricula_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY matricula_turma
    ADD CONSTRAINT matricula_turma_ref_cod_matricula_fkey FOREIGN KEY (ref_cod_matricula) REFERENCES matricula(cod_matricula) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: matricula_turma_ref_cod_turma_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY matricula_turma
    ADD CONSTRAINT matricula_turma_ref_cod_turma_fkey FOREIGN KEY (ref_cod_turma) REFERENCES turma(cod_turma) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: matricula_turma_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY matricula_turma
    ADD CONSTRAINT matricula_turma_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: matricula_turma_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY matricula_turma
    ADD CONSTRAINT matricula_turma_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: modulo_ref_cod_instituicao_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY modulo
    ADD CONSTRAINT modulo_ref_cod_instituicao_fk FOREIGN KEY (ref_cod_instituicao) REFERENCES instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: modulo_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY modulo
    ADD CONSTRAINT modulo_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: modulo_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY modulo
    ADD CONSTRAINT modulo_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: motivo_afastamento_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY motivo_afastamento
    ADD CONSTRAINT motivo_afastamento_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: motivo_afastamento_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY motivo_afastamento
    ADD CONSTRAINT motivo_afastamento_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: motivo_afastamento_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY motivo_afastamento
    ADD CONSTRAINT motivo_afastamento_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: motivo_baixa_ref_cod_biblioteca_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY motivo_baixa
    ADD CONSTRAINT motivo_baixa_ref_cod_biblioteca_fkey FOREIGN KEY (ref_cod_biblioteca) REFERENCES biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: motivo_baixa_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY motivo_baixa
    ADD CONSTRAINT motivo_baixa_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: motivo_baixa_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY motivo_baixa
    ADD CONSTRAINT motivo_baixa_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: motivo_suspensao_ref_cod_biblioteca_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY motivo_suspensao
    ADD CONSTRAINT motivo_suspensao_ref_cod_biblioteca_fkey FOREIGN KEY (ref_cod_biblioteca) REFERENCES biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: motivo_suspensao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY motivo_suspensao
    ADD CONSTRAINT motivo_suspensao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: motivo_suspensao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY motivo_suspensao
    ADD CONSTRAINT motivo_suspensao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: nivel_ensino_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY nivel_ensino
    ADD CONSTRAINT nivel_ensino_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: nivel_ensino_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY nivel_ensino
    ADD CONSTRAINT nivel_ensino_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: nivel_ensino_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY nivel_ensino
    ADD CONSTRAINT nivel_ensino_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: nivel_ref_cod_categoria_nivel_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY nivel
    ADD CONSTRAINT nivel_ref_cod_categoria_nivel_fkey FOREIGN KEY (ref_cod_categoria_nivel) REFERENCES categoria_nivel(cod_categoria_nivel) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: nivel_ref_cod_nivel_anterior_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY nivel
    ADD CONSTRAINT nivel_ref_cod_nivel_anterior_fkey FOREIGN KEY (ref_cod_nivel_anterior) REFERENCES nivel(cod_nivel) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: nivel_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY nivel
    ADD CONSTRAINT nivel_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: nivel_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY nivel
    ADD CONSTRAINT nivel_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: nota_aluno_ref_cod_curso_disciplina; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY nota_aluno
    ADD CONSTRAINT nota_aluno_ref_cod_curso_disciplina FOREIGN KEY (ref_cod_curso_disciplina) REFERENCES disciplina(cod_disciplina) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: nota_aluno_ref_cod_matricula_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY nota_aluno
    ADD CONSTRAINT nota_aluno_ref_cod_matricula_fkey FOREIGN KEY (ref_cod_matricula) REFERENCES matricula(cod_matricula) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: nota_aluno_ref_cod_serie_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY nota_aluno
    ADD CONSTRAINT nota_aluno_ref_cod_serie_fkey FOREIGN KEY (ref_cod_serie, ref_cod_escola, ref_cod_disciplina) REFERENCES escola_serie_disciplina(ref_ref_cod_serie, ref_ref_cod_escola, ref_cod_disciplina) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: nota_aluno_ref_ref_cod_tipo_avaliacao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY nota_aluno
    ADD CONSTRAINT nota_aluno_ref_ref_cod_tipo_avaliacao_fkey FOREIGN KEY (ref_ref_cod_tipo_avaliacao, ref_sequencial) REFERENCES tipo_avaliacao_valores(ref_cod_tipo_avaliacao, sequencial) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: nota_aluno_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY nota_aluno
    ADD CONSTRAINT nota_aluno_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: nota_aluno_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY nota_aluno
    ADD CONSTRAINT nota_aluno_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: operador_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY operador
    ADD CONSTRAINT operador_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: operador_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY operador
    ADD CONSTRAINT operador_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: pagamento_divida_ref_cod_biblioteca; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY pagamento_multa
    ADD CONSTRAINT pagamento_divida_ref_cod_biblioteca FOREIGN KEY (ref_cod_biblioteca) REFERENCES biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: pagamento_multa_ref_cod_cliente_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY pagamento_multa
    ADD CONSTRAINT pagamento_multa_ref_cod_cliente_fkey FOREIGN KEY (ref_cod_cliente) REFERENCES cliente(cod_cliente) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: pagamento_multa_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY pagamento_multa
    ADD CONSTRAINT pagamento_multa_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: pmieducar_bloqueio_ano_letivo_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY bloqueio_ano_letivo
    ADD CONSTRAINT pmieducar_bloqueio_ano_letivo_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES instituicao(cod_instituicao);


--
-- Name: pmieducar_projeto_aluno_ref_cod_aluno; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY projeto_aluno
    ADD CONSTRAINT pmieducar_projeto_aluno_ref_cod_aluno FOREIGN KEY (ref_cod_aluno) REFERENCES aluno(cod_aluno);


--
-- Name: pmieducar_projeto_aluno_ref_cod_projeto; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY projeto_aluno
    ADD CONSTRAINT pmieducar_projeto_aluno_ref_cod_projeto FOREIGN KEY (ref_cod_projeto) REFERENCES projeto(cod_projeto);


--
-- Name: pre_requisito_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY pre_requisito
    ADD CONSTRAINT pre_requisito_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: pre_requisito_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY pre_requisito
    ADD CONSTRAINT pre_requisito_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: quadro_horario_horarios_ref_cod_quadro_horario_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY quadro_horario_horarios_aux
    ADD CONSTRAINT quadro_horario_horarios_ref_cod_quadro_horario_fkey FOREIGN KEY (ref_cod_quadro_horario) REFERENCES quadro_horario(cod_quadro_horario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: quadro_horario_horarios_ref_cod_quadro_horario_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY quadro_horario_horarios
    ADD CONSTRAINT quadro_horario_horarios_ref_cod_quadro_horario_fkey FOREIGN KEY (ref_cod_quadro_horario) REFERENCES quadro_horario(cod_quadro_horario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: quadro_horario_horarios_ref_cod_serie_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY quadro_horario_horarios_aux
    ADD CONSTRAINT quadro_horario_horarios_ref_cod_serie_fkey FOREIGN KEY (ref_cod_serie, ref_cod_escola, ref_cod_disciplina) REFERENCES escola_serie_disciplina(ref_ref_cod_serie, ref_ref_cod_escola, ref_cod_disciplina) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: quadro_horario_horarios_ref_servidor_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY quadro_horario_horarios_aux
    ADD CONSTRAINT quadro_horario_horarios_ref_servidor_fkey FOREIGN KEY (ref_servidor, ref_cod_instituicao_servidor) REFERENCES servidor(cod_servidor, ref_cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: quadro_horario_horarios_ref_servidor_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY quadro_horario_horarios
    ADD CONSTRAINT quadro_horario_horarios_ref_servidor_fkey FOREIGN KEY (ref_servidor, ref_cod_instituicao_servidor) REFERENCES servidor(cod_servidor, ref_cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: quadro_horario_horarios_ref_servidor_substituto_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY quadro_horario_horarios
    ADD CONSTRAINT quadro_horario_horarios_ref_servidor_substituto_fkey FOREIGN KEY (ref_servidor_substituto, ref_cod_instituicao_substituto) REFERENCES servidor(cod_servidor, ref_cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: quadro_horario_ref_cod_turma_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY quadro_horario
    ADD CONSTRAINT quadro_horario_ref_cod_turma_fkey FOREIGN KEY (ref_cod_turma) REFERENCES turma(cod_turma) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: quadro_horario_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY quadro_horario
    ADD CONSTRAINT quadro_horario_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: quadro_horario_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY quadro_horario
    ADD CONSTRAINT quadro_horario_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: ref_cod_aluno_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY candidato_reserva_vaga
    ADD CONSTRAINT ref_cod_aluno_fkey FOREIGN KEY (ref_cod_aluno) REFERENCES aluno(cod_aluno);


--
-- Name: ref_cod_disciplina; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY dispensa_etapa
    ADD CONSTRAINT ref_cod_disciplina FOREIGN KEY (ref_cod_dispensa) REFERENCES dispensa_disciplina(cod_dispensa);


--
-- Name: ref_cod_pessoa_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY candidato_reserva_vaga
    ADD CONSTRAINT ref_cod_pessoa_cad_fkey FOREIGN KEY (ref_cod_pessoa_cad) REFERENCES cadastro.pessoa(idpes);

--
-- Name: ref_cod_serie_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY candidato_reserva_vaga
    ADD CONSTRAINT ref_cod_serie_fkey FOREIGN KEY (ref_cod_serie) REFERENCES serie(cod_serie);


--
-- Name: ref_cod_turno_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY candidato_reserva_vaga
    ADD CONSTRAINT ref_cod_turno_fkey FOREIGN KEY (ref_cod_turno) REFERENCES turma_turno(id);


--
-- Name: relacao_categoria_acervo_categoria_id_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY relacao_categoria_acervo
    ADD CONSTRAINT relacao_categoria_acervo_categoria_id_fkey FOREIGN KEY (categoria_id) REFERENCES categoria_obra(id);


--
-- Name: relacao_categoria_acervo_ref_cod_acervo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY relacao_categoria_acervo
    ADD CONSTRAINT relacao_categoria_acervo_ref_cod_acervo_fkey FOREIGN KEY (ref_cod_acervo) REFERENCES acervo(cod_acervo);


--
-- Name: religiao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY religiao
    ADD CONSTRAINT religiao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: religiao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY religiao
    ADD CONSTRAINT religiao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: reserva_vaga_ref_cod_aluno_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY reserva_vaga
    ADD CONSTRAINT reserva_vaga_ref_cod_aluno_fkey FOREIGN KEY (ref_cod_aluno) REFERENCES aluno(cod_aluno) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: reserva_vaga_ref_ref_cod_serie_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY reserva_vaga
    ADD CONSTRAINT reserva_vaga_ref_ref_cod_serie_fkey FOREIGN KEY (ref_ref_cod_serie, ref_ref_cod_escola) REFERENCES escola_serie(ref_cod_serie, ref_cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: reserva_vaga_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY reserva_vaga
    ADD CONSTRAINT reserva_vaga_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: reserva_vaga_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY reserva_vaga
    ADD CONSTRAINT reserva_vaga_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: reservas_ref_cod_cliente_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY reservas
    ADD CONSTRAINT reservas_ref_cod_cliente_fkey FOREIGN KEY (ref_cod_cliente) REFERENCES cliente(cod_cliente) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: reservas_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY reservas
    ADD CONSTRAINT reservas_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: reservas_ref_usuario_libera_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY reservas
    ADD CONSTRAINT reservas_ref_usuario_libera_fkey FOREIGN KEY (ref_usuario_libera) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: sequencia_serie_ref_serie_destino_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY sequencia_serie
    ADD CONSTRAINT sequencia_serie_ref_serie_destino_fkey FOREIGN KEY (ref_serie_destino) REFERENCES serie(cod_serie) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: sequencia_serie_ref_serie_origem_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY sequencia_serie
    ADD CONSTRAINT sequencia_serie_ref_serie_origem_fkey FOREIGN KEY (ref_serie_origem) REFERENCES serie(cod_serie) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: sequencia_serie_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY sequencia_serie
    ADD CONSTRAINT sequencia_serie_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: sequencia_serie_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY sequencia_serie
    ADD CONSTRAINT sequencia_serie_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: serie_pre_requisito_ref_cod_operador_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY serie_pre_requisito
    ADD CONSTRAINT serie_pre_requisito_ref_cod_operador_fkey FOREIGN KEY (ref_cod_operador) REFERENCES operador(cod_operador) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: serie_pre_requisito_ref_cod_pre_requisito_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY serie_pre_requisito
    ADD CONSTRAINT serie_pre_requisito_ref_cod_pre_requisito_fkey FOREIGN KEY (ref_cod_pre_requisito) REFERENCES pre_requisito(cod_pre_requisito) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: serie_pre_requisito_ref_cod_serie_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY serie_pre_requisito
    ADD CONSTRAINT serie_pre_requisito_ref_cod_serie_fkey FOREIGN KEY (ref_cod_serie) REFERENCES serie(cod_serie) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: serie_ref_cod_curso_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY serie
    ADD CONSTRAINT serie_ref_cod_curso_fkey FOREIGN KEY (ref_cod_curso) REFERENCES curso(cod_curso) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: serie_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY serie
    ADD CONSTRAINT serie_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: serie_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY serie
    ADD CONSTRAINT serie_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: serie_regra_avaliacao_diferenciada_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY serie
    ADD CONSTRAINT serie_regra_avaliacao_diferenciada_fk FOREIGN KEY (regra_avaliacao_diferenciada_id) REFERENCES modules.regra_avaliacao(id) ON DELETE RESTRICT;


--
-- Name: serie_regra_avaliacao_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY serie
    ADD CONSTRAINT serie_regra_avaliacao_fk FOREIGN KEY (regra_avaliacao_id) REFERENCES modules.regra_avaliacao(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: serie_vaga_ref_cod_curso_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY serie_vaga
    ADD CONSTRAINT serie_vaga_ref_cod_curso_fk FOREIGN KEY (ref_cod_curso) REFERENCES curso(cod_curso) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: serie_vaga_ref_cod_escola_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY serie_vaga
    ADD CONSTRAINT serie_vaga_ref_cod_escola_fk FOREIGN KEY (ref_cod_escola) REFERENCES escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: serie_vaga_ref_cod_instituicao_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY serie_vaga
    ADD CONSTRAINT serie_vaga_ref_cod_instituicao_fk FOREIGN KEY (ref_cod_instituicao) REFERENCES instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: serie_vaga_ref_cod_serie_fk; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY serie_vaga
    ADD CONSTRAINT serie_vaga_ref_cod_serie_fk FOREIGN KEY (ref_cod_serie) REFERENCES serie(cod_serie) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: servidor_afastamento_ref_cod_motivo_afastamento_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor_afastamento
    ADD CONSTRAINT servidor_afastamento_ref_cod_motivo_afastamento_fkey FOREIGN KEY (ref_cod_motivo_afastamento) REFERENCES motivo_afastamento(cod_motivo_afastamento) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: servidor_afastamento_ref_cod_servidor_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor_afastamento
    ADD CONSTRAINT servidor_afastamento_ref_cod_servidor_fkey FOREIGN KEY (ref_cod_servidor, ref_ref_cod_instituicao) REFERENCES servidor(cod_servidor, ref_cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: servidor_afastamento_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor_afastamento
    ADD CONSTRAINT servidor_afastamento_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: servidor_afastamento_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor_afastamento
    ADD CONSTRAINT servidor_afastamento_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: servidor_alocacao_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor_alocacao
    ADD CONSTRAINT servidor_alocacao_ref_cod_escola_fkey FOREIGN KEY (ref_cod_escola) REFERENCES escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: servidor_alocacao_ref_cod_servidor_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor_alocacao
    ADD CONSTRAINT servidor_alocacao_ref_cod_servidor_fkey FOREIGN KEY (ref_cod_servidor, ref_ref_cod_instituicao) REFERENCES servidor(cod_servidor, ref_cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: servidor_alocacao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor_alocacao
    ADD CONSTRAINT servidor_alocacao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: servidor_alocacao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor_alocacao
    ADD CONSTRAINT servidor_alocacao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: servidor_curso_ref_cod_formacao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor_curso
    ADD CONSTRAINT servidor_curso_ref_cod_formacao_fkey FOREIGN KEY (ref_cod_formacao) REFERENCES servidor_formacao(cod_formacao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: servidor_cuso_ministra_ref_cod_curso_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor_curso_ministra
    ADD CONSTRAINT servidor_cuso_ministra_ref_cod_curso_fkey FOREIGN KEY (ref_cod_curso) REFERENCES curso(cod_curso) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: servidor_cuso_ministra_ref_cod_servidor_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor_curso_ministra
    ADD CONSTRAINT servidor_cuso_ministra_ref_cod_servidor_fkey FOREIGN KEY (ref_cod_servidor, ref_ref_cod_instituicao) REFERENCES servidor(cod_servidor, ref_cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: servidor_disciplina_ref_cod_disciplina_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor_disciplina
    ADD CONSTRAINT servidor_disciplina_ref_cod_disciplina_fkey FOREIGN KEY (ref_cod_disciplina) REFERENCES modules.componente_curricular(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: servidor_disciplina_ref_cod_servidor_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor_disciplina
    ADD CONSTRAINT servidor_disciplina_ref_cod_servidor_fkey FOREIGN KEY (ref_cod_servidor, ref_ref_cod_instituicao) REFERENCES servidor(cod_servidor, ref_cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: servidor_formacao_ref_cod_servidor_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor_formacao
    ADD CONSTRAINT servidor_formacao_ref_cod_servidor_fkey FOREIGN KEY (ref_cod_servidor, ref_ref_cod_instituicao) REFERENCES servidor(cod_servidor, ref_cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: servidor_formacao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor_formacao
    ADD CONSTRAINT servidor_formacao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: servidor_formacao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor_formacao
    ADD CONSTRAINT servidor_formacao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: servidor_funcao_ref_cod_funcao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor_funcao
    ADD CONSTRAINT servidor_funcao_ref_cod_funcao_fkey FOREIGN KEY (ref_cod_funcao) REFERENCES funcao(cod_funcao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: servidor_funcao_ref_cod_servidor_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor_funcao
    ADD CONSTRAINT servidor_funcao_ref_cod_servidor_fkey FOREIGN KEY (ref_cod_servidor, ref_ref_cod_instituicao) REFERENCES servidor(cod_servidor, ref_cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: servidor_ref_cod_instituicao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor
    ADD CONSTRAINT servidor_ref_cod_instituicao_fkey FOREIGN KEY (ref_cod_instituicao) REFERENCES instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: servidor_ref_cod_subnivel_; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor
    ADD CONSTRAINT servidor_ref_cod_subnivel_ FOREIGN KEY (ref_cod_subnivel) REFERENCES subnivel(cod_subnivel) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: servidor_ref_idesco_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor
    ADD CONSTRAINT servidor_ref_idesco_fkey FOREIGN KEY (ref_idesco) REFERENCES cadastro.escolaridade(idesco) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: servidor_titulo_concurso_ref_cod_formacao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY servidor_titulo_concurso
    ADD CONSTRAINT servidor_titulo_concurso_ref_cod_formacao_fkey FOREIGN KEY (ref_cod_formacao) REFERENCES servidor_formacao(cod_formacao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: situacao_ref_cod_biblioteca; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY situacao
    ADD CONSTRAINT situacao_ref_cod_biblioteca FOREIGN KEY (ref_cod_biblioteca) REFERENCES biblioteca(cod_biblioteca) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: situacao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY situacao
    ADD CONSTRAINT situacao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: situacao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY situacao
    ADD CONSTRAINT situacao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: subnivel_ref_cod_nivel_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY subnivel
    ADD CONSTRAINT subnivel_ref_cod_nivel_fkey FOREIGN KEY (ref_cod_nivel) REFERENCES nivel(cod_nivel) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: subnivel_ref_cod_subnivel_anterior_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY subnivel
    ADD CONSTRAINT subnivel_ref_cod_subnivel_anterior_fkey FOREIGN KEY (ref_cod_subnivel_anterior) REFERENCES subnivel(cod_subnivel) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: subnivel_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY subnivel
    ADD CONSTRAINT subnivel_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: subnivel_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY subnivel
    ADD CONSTRAINT subnivel_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: tipo_avaliacao_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY tipo_avaliacao
    ADD CONSTRAINT tipo_avaliacao_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: tipo_avaliacao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY tipo_avaliacao
    ADD CONSTRAINT tipo_avaliacao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: tipo_avaliacao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY tipo_avaliacao
    ADD CONSTRAINT tipo_avaliacao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: tipo_avaliacao_valores_ref_cod_tipo_avaliacao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY tipo_avaliacao_valores
    ADD CONSTRAINT tipo_avaliacao_valores_ref_cod_tipo_avaliacao_fkey FOREIGN KEY (ref_cod_tipo_avaliacao) REFERENCES tipo_avaliacao(cod_tipo_avaliacao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: tipo_dispensa_ref_cod_instituicao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY tipo_dispensa
    ADD CONSTRAINT tipo_dispensa_ref_cod_instituicao_fkey FOREIGN KEY (ref_cod_instituicao) REFERENCES instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: tipo_dispensa_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY tipo_dispensa
    ADD CONSTRAINT tipo_dispensa_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: tipo_dispensa_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY tipo_dispensa
    ADD CONSTRAINT tipo_dispensa_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: tipo_ensino_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY tipo_ensino
    ADD CONSTRAINT tipo_ensino_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: tipo_ensino_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY tipo_ensino
    ADD CONSTRAINT tipo_ensino_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: tipo_ensino_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY tipo_ensino
    ADD CONSTRAINT tipo_ensino_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: tipo_ocorrencia_disciplinar_ref_cod_instituicao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY tipo_ocorrencia_disciplinar
    ADD CONSTRAINT tipo_ocorrencia_disciplinar_ref_cod_instituicao_fkey FOREIGN KEY (ref_cod_instituicao) REFERENCES instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: tipo_ocorrencia_disciplinar_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY tipo_ocorrencia_disciplinar
    ADD CONSTRAINT tipo_ocorrencia_disciplinar_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: tipo_ocorrencia_disciplinar_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY tipo_ocorrencia_disciplinar
    ADD CONSTRAINT tipo_ocorrencia_disciplinar_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: tipo_regime_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY tipo_regime
    ADD CONSTRAINT tipo_regime_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: tipo_regime_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY tipo_regime
    ADD CONSTRAINT tipo_regime_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: tipo_regime_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY tipo_regime
    ADD CONSTRAINT tipo_regime_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: tipo_usuario_ref_funcionario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY tipo_usuario
    ADD CONSTRAINT tipo_usuario_ref_funcionario_cad_fkey FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: tipo_usuario_ref_funcionario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY tipo_usuario
    ADD CONSTRAINT tipo_usuario_ref_funcionario_exc_fkey FOREIGN KEY (ref_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: transferencia_solicitacao_ref_cod_matricula_entrada_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY transferencia_solicitacao
    ADD CONSTRAINT transferencia_solicitacao_ref_cod_matricula_entrada_fkey FOREIGN KEY (ref_cod_matricula_entrada) REFERENCES matricula(cod_matricula) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: transferencia_solicitacao_ref_cod_matricula_saida_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY transferencia_solicitacao
    ADD CONSTRAINT transferencia_solicitacao_ref_cod_matricula_saida_fkey FOREIGN KEY (ref_cod_matricula_saida) REFERENCES matricula(cod_matricula) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: transferencia_solicitacao_ref_cod_transferencia_tipo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY transferencia_solicitacao
    ADD CONSTRAINT transferencia_solicitacao_ref_cod_transferencia_tipo_fkey FOREIGN KEY (ref_cod_transferencia_tipo) REFERENCES transferencia_tipo(cod_transferencia_tipo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: transferencia_solicitacao_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY transferencia_solicitacao
    ADD CONSTRAINT transferencia_solicitacao_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: transferencia_solicitacao_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY transferencia_solicitacao
    ADD CONSTRAINT transferencia_solicitacao_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: transferencia_tipo_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY transferencia_tipo
    ADD CONSTRAINT transferencia_tipo_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: transferencia_tipo_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY transferencia_tipo
    ADD CONSTRAINT transferencia_tipo_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: transferencia_tipo_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY transferencia_tipo
    ADD CONSTRAINT transferencia_tipo_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: turma_dia_semana_ref_cod_turma_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY turma_dia_semana
    ADD CONSTRAINT turma_dia_semana_ref_cod_turma_fkey FOREIGN KEY (ref_cod_turma) REFERENCES turma(cod_turma) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: turma_escola_serie_muil; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY turma
    ADD CONSTRAINT turma_escola_serie_muil FOREIGN KEY (ref_ref_cod_serie_mult, ref_ref_cod_escola_mult) REFERENCES escola_serie(ref_cod_serie, ref_cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: turma_modulo_ref_cod_modulo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY turma_modulo
    ADD CONSTRAINT turma_modulo_ref_cod_modulo_fkey FOREIGN KEY (ref_cod_modulo) REFERENCES modulo(cod_modulo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: turma_modulo_ref_cod_turma_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY turma_modulo
    ADD CONSTRAINT turma_modulo_ref_cod_turma_fkey FOREIGN KEY (ref_cod_turma) REFERENCES turma(cod_turma) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: turma_ref_cod_curso; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY turma
    ADD CONSTRAINT turma_ref_cod_curso FOREIGN KEY (ref_cod_curso) REFERENCES curso(cod_curso) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: turma_ref_cod_infra_predio_comodo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY turma
    ADD CONSTRAINT turma_ref_cod_infra_predio_comodo_fkey FOREIGN KEY (ref_cod_infra_predio_comodo) REFERENCES infra_predio_comodo(cod_infra_predio_comodo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: turma_ref_cod_instituicao; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY turma
    ADD CONSTRAINT turma_ref_cod_instituicao FOREIGN KEY (ref_cod_instituicao) REFERENCES instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: turma_ref_cod_regente; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY turma
    ADD CONSTRAINT turma_ref_cod_regente FOREIGN KEY (ref_cod_regente, ref_cod_instituicao_regente) REFERENCES servidor(cod_servidor, ref_cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: turma_ref_ref_cod_escola_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY turma
    ADD CONSTRAINT turma_ref_ref_cod_escola_fkey FOREIGN KEY (ref_ref_cod_escola, ref_ref_cod_serie) REFERENCES escola_serie(ref_cod_escola, ref_cod_serie) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: turma_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY turma
    ADD CONSTRAINT turma_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: turma_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY turma
    ADD CONSTRAINT turma_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: turma_tipo_ref_usuario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY turma_tipo
    ADD CONSTRAINT turma_tipo_ref_usuario_cad_fkey FOREIGN KEY (ref_usuario_cad) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: turma_tipo_ref_usuario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY turma_tipo
    ADD CONSTRAINT turma_tipo_ref_usuario_exc_fkey FOREIGN KEY (ref_usuario_exc) REFERENCES usuario(cod_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: turma_turma_tipo_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY turma
    ADD CONSTRAINT turma_turma_tipo_fkey FOREIGN KEY (ref_cod_turma_tipo) REFERENCES turma_tipo(cod_turma_tipo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: turma_turno_id_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY turma
    ADD CONSTRAINT turma_turno_id_fkey FOREIGN KEY (turma_turno_id) REFERENCES turma_turno(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: usuario_cod_usuario_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY usuario
    ADD CONSTRAINT usuario_cod_usuario_fkey FOREIGN KEY (cod_usuario) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: usuario_ref_cod_instituicao_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY usuario
    ADD CONSTRAINT usuario_ref_cod_instituicao_fkey FOREIGN KEY (ref_cod_instituicao) REFERENCES instituicao(cod_instituicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: usuario_ref_cod_tipo_usuario_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY usuario
    ADD CONSTRAINT usuario_ref_cod_tipo_usuario_fkey FOREIGN KEY (ref_cod_tipo_usuario) REFERENCES tipo_usuario(cod_tipo_usuario) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: usuario_ref_funcionario_cad_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY usuario
    ADD CONSTRAINT usuario_ref_funcionario_cad_fkey FOREIGN KEY (ref_funcionario_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: usuario_ref_funcionario_exc_fkey; Type: FK CONSTRAINT; Schema: pmieducar; Owner: postgres
--

ALTER TABLE ONLY usuario
    ADD CONSTRAINT usuario_ref_funcionario_exc_fkey FOREIGN KEY (ref_funcionario_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


SET search_path = pmiotopic, pg_catalog;

--
-- Name: funcionario_su_ref_ref_cod_pessoa_fj_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY funcionario_su
    ADD CONSTRAINT funcionario_su_ref_ref_cod_pessoa_fj_fkey FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: grupomoderador_ref_cod_grupos_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY grupomoderador
    ADD CONSTRAINT grupomoderador_ref_cod_grupos_fkey FOREIGN KEY (ref_cod_grupos) REFERENCES grupos(cod_grupos) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: grupomoderador_ref_pessoa_cad_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY grupomoderador
    ADD CONSTRAINT grupomoderador_ref_pessoa_cad_fkey FOREIGN KEY (ref_pessoa_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: grupomoderador_ref_pessoa_exc_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY grupomoderador
    ADD CONSTRAINT grupomoderador_ref_pessoa_exc_fkey FOREIGN KEY (ref_pessoa_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: grupomoderador_ref_ref_cod_pessoa_fj_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY grupomoderador
    ADD CONSTRAINT grupomoderador_ref_ref_cod_pessoa_fj_fkey FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: grupopessoa_ref_cod_grupos_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY grupopessoa
    ADD CONSTRAINT grupopessoa_ref_cod_grupos_fkey FOREIGN KEY (ref_cod_grupos) REFERENCES grupos(cod_grupos) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: grupopessoa_ref_idpes_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY grupopessoa
    ADD CONSTRAINT grupopessoa_ref_idpes_fkey FOREIGN KEY (ref_idpes) REFERENCES cadastro.fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: grupopessoa_ref_pessoa_cadatro_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY grupopessoa
    ADD CONSTRAINT grupopessoa_ref_pessoa_cadatro_fkey FOREIGN KEY (ref_pessoa_cad, ref_grupos_cad) REFERENCES grupomoderador(ref_ref_cod_pessoa_fj, ref_cod_grupos) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: grupopessoa_ref_pessoa_exclusao_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY grupopessoa
    ADD CONSTRAINT grupopessoa_ref_pessoa_exclusao_fkey FOREIGN KEY (ref_pessoa_exc, ref_grupos_exc) REFERENCES grupomoderador(ref_ref_cod_pessoa_fj, ref_cod_grupos) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: grupos_ref_pessoa_cad_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY grupos
    ADD CONSTRAINT grupos_ref_pessoa_cad_fkey FOREIGN KEY (ref_pessoa_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: grupos_ref_pessoa_exc_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY grupos
    ADD CONSTRAINT grupos_ref_pessoa_exc_fkey FOREIGN KEY (ref_pessoa_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: notas_ref_idpes_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY notas
    ADD CONSTRAINT notas_ref_idpes_fkey FOREIGN KEY (ref_idpes) REFERENCES cadastro.fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: notas_ref_pessoa_cad_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY notas
    ADD CONSTRAINT notas_ref_pessoa_cad_fkey FOREIGN KEY (ref_pessoa_cad) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: notas_ref_pessoa_exc_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY notas
    ADD CONSTRAINT notas_ref_pessoa_exc_fkey FOREIGN KEY (ref_pessoa_exc) REFERENCES portal.funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: participante_ref_cod_reuniao_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY participante
    ADD CONSTRAINT participante_ref_cod_reuniao_fkey FOREIGN KEY (ref_cod_reuniao) REFERENCES reuniao(cod_reuniao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: participante_ref_ref_idpes_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY participante
    ADD CONSTRAINT participante_ref_ref_idpes_fkey FOREIGN KEY (ref_ref_idpes, ref_ref_cod_grupos) REFERENCES grupopessoa(ref_idpes, ref_cod_grupos) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: reuniao_ref_moderador_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY reuniao
    ADD CONSTRAINT reuniao_ref_moderador_fkey FOREIGN KEY (ref_moderador, ref_grupos_moderador) REFERENCES grupomoderador(ref_ref_cod_pessoa_fj, ref_cod_grupos) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: topicoreuniao_ref_cod_reuniao_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY topicoreuniao
    ADD CONSTRAINT topicoreuniao_ref_cod_reuniao_fkey FOREIGN KEY (ref_cod_reuniao) REFERENCES reuniao(cod_reuniao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: topicoreuniao_ref_cod_topico_fkey; Type: FK CONSTRAINT; Schema: pmiotopic; Owner: postgres
--

ALTER TABLE ONLY topicoreuniao
    ADD CONSTRAINT topicoreuniao_ref_cod_topico_fkey FOREIGN KEY (ref_cod_topico) REFERENCES topico(cod_topico) ON UPDATE RESTRICT ON DELETE RESTRICT;


SET search_path = portal, pg_catalog;

--
-- Name: agenda_compromisso_ref_cod_agenda_fkey; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY agenda_compromisso
    ADD CONSTRAINT agenda_compromisso_ref_cod_agenda_fkey FOREIGN KEY (ref_cod_agenda) REFERENCES agenda(cod_agenda) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: agenda_compromisso_ref_ref_cod_pessoa_cad_fkey; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY agenda_compromisso
    ADD CONSTRAINT agenda_compromisso_ref_ref_cod_pessoa_cad_fkey FOREIGN KEY (ref_ref_cod_pessoa_cad) REFERENCES funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: agenda_ref_ref_cod_pessoa_cad_fkey; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY agenda
    ADD CONSTRAINT agenda_ref_ref_cod_pessoa_cad_fkey FOREIGN KEY (ref_ref_cod_pessoa_cad) REFERENCES funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: agenda_ref_ref_cod_pessoa_exc_fkey; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY agenda
    ADD CONSTRAINT agenda_ref_ref_cod_pessoa_exc_fkey FOREIGN KEY (ref_ref_cod_pessoa_exc) REFERENCES funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: agenda_ref_ref_cod_pessoa_own_fkey; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY agenda
    ADD CONSTRAINT agenda_ref_ref_cod_pessoa_own_fkey FOREIGN KEY (ref_ref_cod_pessoa_own) REFERENCES funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: agenda_responsavel_ref_cod_agenda_fkey; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY agenda_responsavel
    ADD CONSTRAINT agenda_responsavel_ref_cod_agenda_fkey FOREIGN KEY (ref_cod_agenda) REFERENCES agenda(cod_agenda) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: agenda_responsavel_ref_ref_cod_pessoa_fj_fkey; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY agenda_responsavel
    ADD CONSTRAINT agenda_responsavel_ref_ref_cod_pessoa_fj_fkey FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: compras_editais_editais_empresas_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY compras_editais_editais_empresas
    ADD CONSTRAINT compras_editais_editais_empresas_ibfk_1 FOREIGN KEY (ref_cod_compras_editais_editais) REFERENCES compras_editais_editais(cod_compras_editais_editais) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: compras_editais_editais_empresas_ibfk_2; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY compras_editais_editais_empresas
    ADD CONSTRAINT compras_editais_editais_empresas_ibfk_2 FOREIGN KEY (ref_cod_compras_editais_empresa) REFERENCES compras_editais_empresa(cod_compras_editais_empresa) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: compras_editais_editais_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY compras_editais_editais
    ADD CONSTRAINT compras_editais_editais_ibfk_1 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: compras_editais_editais_ibfk_2; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY compras_editais_editais
    ADD CONSTRAINT compras_editais_editais_ibfk_2 FOREIGN KEY (ref_cod_compras_licitacoes) REFERENCES compras_licitacoes(cod_compras_licitacoes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: compras_editais_empresa_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY compras_editais_empresa
    ADD CONSTRAINT compras_editais_empresa_ibfk_1 FOREIGN KEY (ref_sigla_uf) REFERENCES public.uf(sigla_uf) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: compras_funcionarios_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY compras_funcionarios
    ADD CONSTRAINT compras_funcionarios_ibfk_1 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: compras_licitacoes_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY compras_licitacoes
    ADD CONSTRAINT compras_licitacoes_ibfk_1 FOREIGN KEY (ref_cod_compras_modalidade) REFERENCES compras_modalidade(cod_compras_modalidade) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: compras_licitacoes_ibfk_2; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY compras_licitacoes
    ADD CONSTRAINT compras_licitacoes_ibfk_2 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: compras_pregao_execucao_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY compras_pregao_execucao
    ADD CONSTRAINT compras_pregao_execucao_ibfk_1 FOREIGN KEY (ref_equipe3) REFERENCES compras_funcionarios(ref_ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: compras_pregao_execucao_ibfk_2; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY compras_pregao_execucao
    ADD CONSTRAINT compras_pregao_execucao_ibfk_2 FOREIGN KEY (ref_pregoeiro) REFERENCES compras_funcionarios(ref_ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: compras_pregao_execucao_ibfk_3; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY compras_pregao_execucao
    ADD CONSTRAINT compras_pregao_execucao_ibfk_3 FOREIGN KEY (ref_equipe1) REFERENCES compras_funcionarios(ref_ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: compras_pregao_execucao_ibfk_4; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY compras_pregao_execucao
    ADD CONSTRAINT compras_pregao_execucao_ibfk_4 FOREIGN KEY (ref_equipe2) REFERENCES compras_funcionarios(ref_ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: compras_pregao_execucao_ibfk_5; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY compras_pregao_execucao
    ADD CONSTRAINT compras_pregao_execucao_ibfk_5 FOREIGN KEY (ref_cod_compras_final_pregao) REFERENCES compras_final_pregao(cod_compras_final_pregao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: compras_pregao_execucao_ibfk_6; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY compras_pregao_execucao
    ADD CONSTRAINT compras_pregao_execucao_ibfk_6 FOREIGN KEY (ref_cod_compras_licitacoes) REFERENCES compras_licitacoes(cod_compras_licitacoes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: fk_to_setor_new; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY funcionario
    ADD CONSTRAINT fk_to_setor_new FOREIGN KEY (ref_cod_setor_new) REFERENCES pmidrh.setor(cod_setor) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: foto_portal_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY foto_portal
    ADD CONSTRAINT foto_portal_ibfk_1 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: foto_portal_ibfk_2; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY foto_portal
    ADD CONSTRAINT foto_portal_ibfk_2 FOREIGN KEY (ref_cod_credito) REFERENCES cadastro.fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: funcionario_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY funcionario
    ADD CONSTRAINT funcionario_ibfk_1 FOREIGN KEY (ref_cod_pessoa_fj) REFERENCES cadastro.fisica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: funcionario_ibfk_5; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY funcionario
    ADD CONSTRAINT funcionario_ibfk_5 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: imagem_ref_cod_imagem_tipo_fkey; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY imagem
    ADD CONSTRAINT imagem_ref_cod_imagem_tipo_fkey FOREIGN KEY (ref_cod_imagem_tipo) REFERENCES imagem_tipo(cod_imagem_tipo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: imagem_ref_cod_pessoa_cad_fkey; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY imagem
    ADD CONSTRAINT imagem_ref_cod_pessoa_cad_fkey FOREIGN KEY (ref_cod_pessoa_cad) REFERENCES funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: imagem_ref_cod_pessoa_exc_fkey; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY imagem
    ADD CONSTRAINT imagem_ref_cod_pessoa_exc_fkey FOREIGN KEY (ref_cod_pessoa_exc) REFERENCES funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: intranet_segur_permissao_negada_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY intranet_segur_permissao_negada
    ADD CONSTRAINT intranet_segur_permissao_negada_ibfk_1 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: jor_arquivo_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY jor_arquivo
    ADD CONSTRAINT jor_arquivo_ibfk_1 FOREIGN KEY (ref_cod_jor_edicao) REFERENCES jor_edicao(cod_jor_edicao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: jor_edicao_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY jor_edicao
    ADD CONSTRAINT jor_edicao_ibfk_1 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: mailling_email_conteudo_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY mailling_email_conteudo
    ADD CONSTRAINT mailling_email_conteudo_ibfk_1 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: mailling_fila_envio_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY mailling_fila_envio
    ADD CONSTRAINT mailling_fila_envio_ibfk_1 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: mailling_fila_envio_ibfk_2; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY mailling_fila_envio
    ADD CONSTRAINT mailling_fila_envio_ibfk_2 FOREIGN KEY (ref_cod_mailling_email) REFERENCES mailling_email(cod_mailling_email);


--
-- Name: mailling_fila_envio_ibfk_3; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY mailling_fila_envio
    ADD CONSTRAINT mailling_fila_envio_ibfk_3 FOREIGN KEY (ref_cod_mailling_email_conteudo) REFERENCES mailling_email_conteudo(cod_mailling_email_conteudo);


--
-- Name: mailling_grupo_email_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY mailling_grupo_email
    ADD CONSTRAINT mailling_grupo_email_ibfk_1 FOREIGN KEY (ref_cod_mailling_email) REFERENCES mailling_email(cod_mailling_email) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: mailling_grupo_email_ibfk_2; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY mailling_grupo_email
    ADD CONSTRAINT mailling_grupo_email_ibfk_2 FOREIGN KEY (ref_cod_mailling_grupo) REFERENCES mailling_grupo(cod_mailling_grupo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: mailling_historico_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY mailling_historico
    ADD CONSTRAINT mailling_historico_ibfk_1 FOREIGN KEY (ref_cod_not_portal) REFERENCES not_portal(cod_not_portal) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: mailling_historico_ibfk_2; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY mailling_historico
    ADD CONSTRAINT mailling_historico_ibfk_2 FOREIGN KEY (ref_cod_mailling_grupo) REFERENCES mailling_grupo(cod_mailling_grupo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: mailling_historico_ibfk_3; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY mailling_historico
    ADD CONSTRAINT mailling_historico_ibfk_3 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: menu_funcionario_ibfk_2; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY menu_funcionario
    ADD CONSTRAINT menu_funcionario_ibfk_2 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: menu_submenu_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY menu_submenu
    ADD CONSTRAINT menu_submenu_ibfk_1 FOREIGN KEY (ref_cod_menu_menu) REFERENCES menu_menu(cod_menu_menu) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: not_portal_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY not_portal
    ADD CONSTRAINT not_portal_ibfk_1 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: not_portal_tipo_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY not_portal_tipo
    ADD CONSTRAINT not_portal_tipo_ibfk_1 FOREIGN KEY (ref_cod_not_portal) REFERENCES not_portal(cod_not_portal) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: not_portal_tipo_ibfk_2; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY not_portal_tipo
    ADD CONSTRAINT not_portal_tipo_ibfk_2 FOREIGN KEY (ref_cod_not_tipo) REFERENCES not_tipo(cod_not_tipo) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: not_vinc_portal_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY not_vinc_portal
    ADD CONSTRAINT not_vinc_portal_ibfk_1 FOREIGN KEY (ref_cod_not_portal) REFERENCES not_portal(cod_not_portal) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: notificacao_ref_cod_funcionario_fkey; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY notificacao
    ADD CONSTRAINT notificacao_ref_cod_funcionario_fkey FOREIGN KEY (ref_cod_funcionario) REFERENCES funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: pessoa_atividade_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY pessoa_atividade
    ADD CONSTRAINT pessoa_atividade_ibfk_1 FOREIGN KEY (ref_cod_ramo_atividade) REFERENCES pessoa_ramo_atividade(cod_ramo_atividade) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: pessoa_fj_pessoa_atividade_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY pessoa_fj_pessoa_atividade
    ADD CONSTRAINT pessoa_fj_pessoa_atividade_ibfk_1 FOREIGN KEY (ref_cod_pessoa_atividade) REFERENCES pessoa_atividade(cod_pessoa_atividade) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: pessoa_fj_pessoa_atividade_ibfk_2; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY pessoa_fj_pessoa_atividade
    ADD CONSTRAINT pessoa_fj_pessoa_atividade_ibfk_2 FOREIGN KEY (ref_cod_pessoa_fj) REFERENCES cadastro.juridica(idpes) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: portal_concurso_ibfk_1; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY portal_concurso
    ADD CONSTRAINT portal_concurso_ibfk_1 FOREIGN KEY (ref_ref_cod_pessoa_fj) REFERENCES funcionario(ref_cod_pessoa_fj) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: ref_cod_menu_pai_fk; Type: FK CONSTRAINT; Schema: portal; Owner: postgres
--

ALTER TABLE ONLY menu_menu
    ADD CONSTRAINT ref_cod_menu_pai_fk FOREIGN KEY (ref_cod_menu_pai) REFERENCES menu_menu(cod_menu_menu) ON UPDATE RESTRICT ON DELETE RESTRICT;


SET search_path = public, pg_catalog;

--
-- Name: bairro_idsetorbai_fk; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY bairro
    ADD CONSTRAINT bairro_idsetorbai_fk FOREIGN KEY (idsetorbai) REFERENCES setor_bai(idsetorbai);


--
-- Name: bairro_regiao_ref_cod_regiao_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY bairro_regiao
    ADD CONSTRAINT bairro_regiao_ref_cod_regiao_fkey FOREIGN KEY (ref_cod_regiao) REFERENCES regiao(cod_regiao) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: bairro_regiao_ref_idbai_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY bairro_regiao
    ADD CONSTRAINT bairro_regiao_ref_idbai_fkey FOREIGN KEY (ref_idbai) REFERENCES bairro(idbai) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: fk_bairro_distrito; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY bairro
    ADD CONSTRAINT fk_bairro_distrito FOREIGN KEY (iddis) REFERENCES distrito(iddis);


--
-- Name: fk_bairro_municipio; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY bairro
    ADD CONSTRAINT fk_bairro_municipio FOREIGN KEY (idmun) REFERENCES municipio(idmun);


--
-- Name: fk_bairro_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY bairro
    ADD CONSTRAINT fk_bairro_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_bairro_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY bairro
    ADD CONSTRAINT fk_bairro_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_bairro_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY bairro
    ADD CONSTRAINT fk_bairro_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_bairro_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY bairro
    ADD CONSTRAINT fk_bairro_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_distrito_municipio; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY distrito
    ADD CONSTRAINT fk_distrito_municipio FOREIGN KEY (idmun) REFERENCES municipio(idmun);


--
-- Name: fk_distrito_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY distrito
    ADD CONSTRAINT fk_distrito_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_distrito_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY distrito
    ADD CONSTRAINT fk_distrito_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_distrito_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY distrito
    ADD CONSTRAINT fk_distrito_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_distrito_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY distrito
    ADD CONSTRAINT fk_distrito_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_logr_logr_fonetico; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY logradouro_fonetico
    ADD CONSTRAINT fk_logr_logr_fonetico FOREIGN KEY (idlog) REFERENCES logradouro(idlog);


--
-- Name: fk_logradouro_municipio; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY municipio
    ADD CONSTRAINT fk_logradouro_municipio FOREIGN KEY (idmun) REFERENCES municipio(idmun);


--
-- Name: fk_logradouro_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY logradouro
    ADD CONSTRAINT fk_logradouro_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_logradouro_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY logradouro
    ADD CONSTRAINT fk_logradouro_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_logradouro_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY logradouro
    ADD CONSTRAINT fk_logradouro_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_logradouro_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY logradouro
    ADD CONSTRAINT fk_logradouro_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_logradouro_tipo_log; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY logradouro
    ADD CONSTRAINT fk_logradouro_tipo_log FOREIGN KEY (idtlog) REFERENCES urbano.tipo_logradouro(idtlog);


--
-- Name: fk_municipio_municipiopai; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY municipio
    ADD CONSTRAINT fk_municipio_municipiopai FOREIGN KEY (idmun_pai) REFERENCES municipio(idmun);


--
-- Name: fk_municipio_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY municipio
    ADD CONSTRAINT fk_municipio_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_municipio_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY municipio
    ADD CONSTRAINT fk_municipio_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_municipio_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY municipio
    ADD CONSTRAINT fk_municipio_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_municipio_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY municipio
    ADD CONSTRAINT fk_municipio_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_municipio_uf; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY municipio
    ADD CONSTRAINT fk_municipio_uf FOREIGN KEY (sigla_uf) REFERENCES uf(sigla_uf);


--
-- Name: fk_setor_idsetredir; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY setor
    ADD CONSTRAINT fk_setor_idsetredir FOREIGN KEY (idsetredir) REFERENCES setor(idset) ON DELETE RESTRICT;


--
-- Name: fk_setor_idsetsub; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY setor
    ADD CONSTRAINT fk_setor_idsetsub FOREIGN KEY (idsetsub) REFERENCES setor(idset) ON DELETE CASCADE;


--
-- Name: fk_uf_pais; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY uf
    ADD CONSTRAINT fk_uf_pais FOREIGN KEY (idpais) REFERENCES pais(idpais);


--
-- Name: fk_vila_municipio; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY vila
    ADD CONSTRAINT fk_vila_municipio FOREIGN KEY (idmun) REFERENCES municipio(idmun);


SET search_path = serieciasc, pg_catalog;

--
-- Name: aluno_cod_aluno_cod_aluno_fk; Type: FK CONSTRAINT; Schema: serieciasc; Owner: postgres
--

ALTER TABLE ONLY aluno_cod_aluno
    ADD CONSTRAINT aluno_cod_aluno_cod_aluno_fk FOREIGN KEY (cod_aluno) REFERENCES pmieducar.aluno(cod_aluno) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: aluno_uniforme_ref_cod_aluno_fkey; Type: FK CONSTRAINT; Schema: serieciasc; Owner: postgres
--

ALTER TABLE ONLY aluno_uniforme
    ADD CONSTRAINT aluno_uniforme_ref_cod_aluno_fkey FOREIGN KEY (ref_cod_aluno) REFERENCES pmieducar.aluno(cod_aluno) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_agua_ref_cod_escola_fk; Type: FK CONSTRAINT; Schema: serieciasc; Owner: postgres
--

ALTER TABLE ONLY escola_agua
    ADD CONSTRAINT escola_agua_ref_cod_escola_fk FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_energia_ref_cod_escola_fk; Type: FK CONSTRAINT; Schema: serieciasc; Owner: postgres
--

ALTER TABLE ONLY escola_energia
    ADD CONSTRAINT escola_energia_ref_cod_escola_fk FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_lingua_indigena_ref_cod_escola_fk; Type: FK CONSTRAINT; Schema: serieciasc; Owner: postgres
--

ALTER TABLE ONLY escola_lingua_indigena
    ADD CONSTRAINT escola_lingua_indigena_ref_cod_escola_fk FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_lixo_ref_cod_escola_fk; Type: FK CONSTRAINT; Schema: serieciasc; Owner: postgres
--

ALTER TABLE ONLY escola_lixo
    ADD CONSTRAINT escola_lixo_ref_cod_escola_fk FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_projeto_ref_cod_escola_fk; Type: FK CONSTRAINT; Schema: serieciasc; Owner: postgres
--

ALTER TABLE ONLY escola_projeto
    ADD CONSTRAINT escola_projeto_ref_cod_escola_fk FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_regulamentacao_ref_cod_escola_fk; Type: FK CONSTRAINT; Schema: serieciasc; Owner: postgres
--

ALTER TABLE ONLY escola_regulamentacao
    ADD CONSTRAINT escola_regulamentacao_ref_cod_escola_fk FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: escola_sanitario_ref_cod_escola_fk; Type: FK CONSTRAINT; Schema: serieciasc; Owner: postgres
--

ALTER TABLE ONLY escola_sanitario
    ADD CONSTRAINT escola_sanitario_ref_cod_escola_fk FOREIGN KEY (ref_cod_escola) REFERENCES pmieducar.escola(cod_escola) ON UPDATE RESTRICT ON DELETE RESTRICT;


SET search_path = urbano, pg_catalog;

--
-- Name: fk_cep_log_bairro_bai; Type: FK CONSTRAINT; Schema: urbano; Owner: postgres
--

ALTER TABLE ONLY cep_logradouro_bairro
    ADD CONSTRAINT fk_cep_log_bairro_bai FOREIGN KEY (idbai) REFERENCES public.bairro(idbai);


--
-- Name: fk_cep_log_bairro_cep_log; Type: FK CONSTRAINT; Schema: urbano; Owner: postgres
--

ALTER TABLE ONLY cep_logradouro_bairro
    ADD CONSTRAINT fk_cep_log_bairro_cep_log FOREIGN KEY (cep, idlog) REFERENCES cep_logradouro(cep, idlog) ON DELETE CASCADE;


--
-- Name: fk_cep_logradouro_bairro_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: urbano; Owner: postgres
--

ALTER TABLE ONLY cep_logradouro_bairro
    ADD CONSTRAINT fk_cep_logradouro_bairro_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_cep_logradouro_bairro_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: urbano; Owner: postgres
--

ALTER TABLE ONLY cep_logradouro_bairro
    ADD CONSTRAINT fk_cep_logradouro_bairro_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_cep_logradouro_bairro_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: urbano; Owner: postgres
--

ALTER TABLE ONLY cep_logradouro_bairro
    ADD CONSTRAINT fk_cep_logradouro_bairro_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_cep_logradouro_bairro_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: urbano; Owner: postgres
--

ALTER TABLE ONLY cep_logradouro_bairro
    ADD CONSTRAINT fk_cep_logradouro_bairro_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_cep_logradouro_logradouro; Type: FK CONSTRAINT; Schema: urbano; Owner: postgres
--

ALTER TABLE ONLY cep_logradouro
    ADD CONSTRAINT fk_cep_logradouro_logradouro FOREIGN KEY (idlog) REFERENCES public.logradouro(idlog) ON DELETE CASCADE;


--
-- Name: fk_cep_logradouro_sistema_idpes_cad; Type: FK CONSTRAINT; Schema: urbano; Owner: postgres
--

ALTER TABLE ONLY cep_logradouro
    ADD CONSTRAINT fk_cep_logradouro_sistema_idpes_cad FOREIGN KEY (idpes_cad) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_cep_logradouro_sistema_idpes_rev; Type: FK CONSTRAINT; Schema: urbano; Owner: postgres
--

ALTER TABLE ONLY cep_logradouro
    ADD CONSTRAINT fk_cep_logradouro_sistema_idpes_rev FOREIGN KEY (idpes_rev) REFERENCES cadastro.pessoa(idpes) ON DELETE SET NULL;


--
-- Name: fk_cep_logradouro_sistema_idsis_cad; Type: FK CONSTRAINT; Schema: urbano; Owner: postgres
--

ALTER TABLE ONLY cep_logradouro
    ADD CONSTRAINT fk_cep_logradouro_sistema_idsis_cad FOREIGN KEY (idsis_cad) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: fk_cep_logradouro_sistema_idsis_rev; Type: FK CONSTRAINT; Schema: urbano; Owner: postgres
--

ALTER TABLE ONLY cep_logradouro
    ADD CONSTRAINT fk_cep_logradouro_sistema_idsis_rev FOREIGN KEY (idsis_rev) REFERENCES acesso.sistema(idsis) ON DELETE SET NULL;


--
-- Name: SCHEMA modules; Type: ACL; Schema: -; Owner: postgres
--

REVOKE ALL ON SCHEMA modules FROM PUBLIC;
REVOKE ALL ON SCHEMA modules FROM postgres;
GRANT ALL ON SCHEMA modules TO postgres;
GRANT ALL ON SCHEMA modules TO ieducar;


--
-- Name: SCHEMA public; Type: ACL; Schema: -; Owner: postgres
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM postgres;
GRANT ALL ON SCHEMA public TO postgres;
GRANT ALL ON SCHEMA public TO PUBLIC;


SET search_path = cadastro, pg_catalog;

--
-- Name: TABLE endereco_externo; Type: ACL; Schema: cadastro; Owner: postgres
--

REVOKE ALL ON TABLE endereco_externo FROM PUBLIC;
REVOKE ALL ON TABLE endereco_externo FROM postgres;
GRANT ALL ON TABLE endereco_externo TO postgres;
GRANT ALL ON TABLE endereco_externo TO ieducar;


--
-- Name: TABLE endereco_pessoa; Type: ACL; Schema: cadastro; Owner: postgres
--

REVOKE ALL ON TABLE endereco_pessoa FROM PUBLIC;
REVOKE ALL ON TABLE endereco_pessoa FROM postgres;
GRANT ALL ON TABLE endereco_pessoa TO postgres;
GRANT ALL ON TABLE endereco_pessoa TO ieducar;


--
-- Name: TABLE fisica; Type: ACL; Schema: cadastro; Owner: postgres
--

REVOKE ALL ON TABLE fisica FROM PUBLIC;
REVOKE ALL ON TABLE fisica FROM postgres;
GRANT ALL ON TABLE fisica TO postgres;
GRANT ALL ON TABLE fisica TO ieducar;


--
-- Name: TABLE pessoa; Type: ACL; Schema: cadastro; Owner: postgres
--

REVOKE ALL ON TABLE pessoa FROM PUBLIC;
REVOKE ALL ON TABLE pessoa FROM postgres;
GRANT ALL ON TABLE pessoa TO postgres;
GRANT ALL ON TABLE pessoa TO ieducar;


SET search_path = public, pg_catalog;

--
-- Name: TABLE bairro; Type: ACL; Schema: public; Owner: postgres
--

REVOKE ALL ON TABLE bairro FROM PUBLIC;
REVOKE ALL ON TABLE bairro FROM postgres;
GRANT ALL ON TABLE bairro TO postgres;
GRANT ALL ON TABLE bairro TO ieducar;


--
-- Name: TABLE logradouro; Type: ACL; Schema: public; Owner: postgres
--

REVOKE ALL ON TABLE logradouro FROM PUBLIC;
REVOKE ALL ON TABLE logradouro FROM postgres;
GRANT ALL ON TABLE logradouro TO postgres;
GRANT ALL ON TABLE logradouro TO ieducar;


--
-- Name: TABLE municipio; Type: ACL; Schema: public; Owner: postgres
--

REVOKE ALL ON TABLE municipio FROM PUBLIC;
REVOKE ALL ON TABLE municipio FROM postgres;
GRANT ALL ON TABLE municipio TO postgres;
GRANT ALL ON TABLE municipio TO ieducar;


SET search_path = modules, pg_catalog;

--
-- Name: TABLE area_conhecimento; Type: ACL; Schema: modules; Owner: postgres
--

REVOKE ALL ON TABLE area_conhecimento FROM PUBLIC;
REVOKE ALL ON TABLE area_conhecimento FROM postgres;
GRANT ALL ON TABLE area_conhecimento TO postgres;
GRANT ALL ON TABLE area_conhecimento TO ieducar;


--
-- Name: TABLE auditoria; Type: ACL; Schema: modules; Owner: postgres
--

REVOKE ALL ON TABLE auditoria FROM PUBLIC;
REVOKE ALL ON TABLE auditoria FROM postgres;
GRANT ALL ON TABLE auditoria TO postgres;
GRANT ALL ON TABLE auditoria TO ieducar;


--
-- Name: TABLE componente_curricular; Type: ACL; Schema: modules; Owner: postgres
--

REVOKE ALL ON TABLE componente_curricular FROM PUBLIC;
REVOKE ALL ON TABLE componente_curricular FROM postgres;
GRANT ALL ON TABLE componente_curricular TO postgres;
GRANT ALL ON TABLE componente_curricular TO ieducar;


--
-- Name: TABLE componente_curricular_turma; Type: ACL; Schema: modules; Owner: postgres
--

REVOKE ALL ON TABLE componente_curricular_turma FROM PUBLIC;
REVOKE ALL ON TABLE componente_curricular_turma FROM postgres;
GRANT ALL ON TABLE componente_curricular_turma TO postgres;
GRANT ALL ON TABLE componente_curricular_turma TO ieducar;


--
-- Name: TABLE educacenso_cod_aluno; Type: ACL; Schema: modules; Owner: postgres
--

REVOKE ALL ON TABLE educacenso_cod_aluno FROM PUBLIC;
REVOKE ALL ON TABLE educacenso_cod_aluno FROM postgres;
GRANT ALL ON TABLE educacenso_cod_aluno TO postgres;
GRANT ALL ON TABLE educacenso_cod_aluno TO ieducar;


--
-- Name: TABLE educacenso_cod_escola; Type: ACL; Schema: modules; Owner: postgres
--

REVOKE ALL ON TABLE educacenso_cod_escola FROM PUBLIC;
REVOKE ALL ON TABLE educacenso_cod_escola FROM postgres;
GRANT ALL ON TABLE educacenso_cod_escola TO postgres;
GRANT ALL ON TABLE educacenso_cod_escola TO ieducar;


SET search_path = pmieducar, pg_catalog;

--
-- Name: TABLE abandono_tipo; Type: ACL; Schema: pmieducar; Owner: postgres
--

REVOKE ALL ON TABLE abandono_tipo FROM PUBLIC;
REVOKE ALL ON TABLE abandono_tipo FROM postgres;
GRANT ALL ON TABLE abandono_tipo TO postgres;
GRANT ALL ON TABLE abandono_tipo TO ieducar;


--
-- Name: TABLE ano_letivo_modulo; Type: ACL; Schema: pmieducar; Owner: postgres
--

REVOKE ALL ON TABLE ano_letivo_modulo FROM PUBLIC;
REVOKE ALL ON TABLE ano_letivo_modulo FROM postgres;
GRANT ALL ON TABLE ano_letivo_modulo TO postgres;
GRANT ALL ON TABLE ano_letivo_modulo TO ieducar;


--
-- Name: TABLE curso; Type: ACL; Schema: pmieducar; Owner: postgres
--

REVOKE ALL ON TABLE curso FROM PUBLIC;
REVOKE ALL ON TABLE curso FROM postgres;
GRANT ALL ON TABLE curso TO postgres;
GRANT ALL ON TABLE curso TO ieducar;


--
-- Name: TABLE escola; Type: ACL; Schema: pmieducar; Owner: postgres
--

REVOKE ALL ON TABLE escola FROM PUBLIC;
REVOKE ALL ON TABLE escola FROM postgres;
GRANT ALL ON TABLE escola TO postgres;
GRANT ALL ON TABLE escola TO ieducar;


--
-- Name: TABLE escola_serie_disciplina; Type: ACL; Schema: pmieducar; Owner: postgres
--

REVOKE ALL ON TABLE escola_serie_disciplina FROM PUBLIC;
REVOKE ALL ON TABLE escola_serie_disciplina FROM postgres;
GRANT ALL ON TABLE escola_serie_disciplina TO postgres;
GRANT ALL ON TABLE escola_serie_disciplina TO ieducar;


--
-- Name: TABLE matricula; Type: ACL; Schema: pmieducar; Owner: postgres
--

REVOKE ALL ON TABLE matricula FROM PUBLIC;
REVOKE ALL ON TABLE matricula FROM postgres;
GRANT ALL ON TABLE matricula TO postgres;
GRANT ALL ON TABLE matricula TO ieducar;


--
-- Name: TABLE matricula_turma; Type: ACL; Schema: pmieducar; Owner: postgres
--

REVOKE ALL ON TABLE matricula_turma FROM PUBLIC;
REVOKE ALL ON TABLE matricula_turma FROM postgres;
GRANT ALL ON TABLE matricula_turma TO postgres;
GRANT ALL ON TABLE matricula_turma TO ieducar;


--
-- Name: TABLE modulo; Type: ACL; Schema: pmieducar; Owner: postgres
--

REVOKE ALL ON TABLE modulo FROM PUBLIC;
REVOKE ALL ON TABLE modulo FROM postgres;
GRANT ALL ON TABLE modulo TO postgres;
GRANT ALL ON TABLE modulo TO ieducar;


--
-- Name: TABLE transferencia_solicitacao; Type: ACL; Schema: pmieducar; Owner: postgres
--

REVOKE ALL ON TABLE transferencia_solicitacao FROM PUBLIC;
REVOKE ALL ON TABLE transferencia_solicitacao FROM postgres;
GRANT ALL ON TABLE transferencia_solicitacao TO postgres;
GRANT ALL ON TABLE transferencia_solicitacao TO ieducar;


--
-- Name: TABLE turma; Type: ACL; Schema: pmieducar; Owner: postgres
--

REVOKE ALL ON TABLE turma FROM PUBLIC;
REVOKE ALL ON TABLE turma FROM postgres;
GRANT ALL ON TABLE turma TO postgres;
GRANT ALL ON TABLE turma TO ieducar;


--
-- Name: TABLE turma_modulo; Type: ACL; Schema: pmieducar; Owner: postgres
--

REVOKE ALL ON TABLE turma_modulo FROM PUBLIC;
REVOKE ALL ON TABLE turma_modulo FROM postgres;
GRANT ALL ON TABLE turma_modulo TO postgres;
GRANT ALL ON TABLE turma_modulo TO ieducar;

DO $$
BEGIN
EXECUTE '
ALTER DATABASE ' || current_database() || ' SET search_path TO "$user", public, portal, cadastro, acesso, alimentos, consistenciacao, historico, pmiacoes, pmicontrolesis, pmidrh, pmieducar, pmiotopic, urbano, modules;';
END; $$;

SET search_path = public, pg_catalog;

--
-- Name: relatorio; Type: SCHEMA; Schema: -; Owner: postgres
--

CREATE SCHEMA relatorio;

ALTER SCHEMA relatorio OWNER TO postgres;

SET search_path = relatorio, pmieducar, public, pg_catalog;

--
-- Name: get_texto_sem_caracter_especial(character varying); Type: FUNCTION; Schema: relatorio; Owner: postgres
--

CREATE FUNCTION get_texto_sem_caracter_especial(character varying) RETURNS character varying
LANGUAGE sql
AS $_$SELECT translate(public.fcn_upper($1),
                       'åáàãâäéèêëíìîïóòõôöúùüûçÿýñÅÁÀÃÂÄÉÈÊËÍÌÎÏÓÒÕÔÖÚÙÛÜÇÝÑ',
                       'aaaaaaeeeeiiiiooooouuuucyynAAAAAAEEEEIIIIOOOOOUUUUCYN');$_$;


ALTER FUNCTION relatorio.get_texto_sem_caracter_especial(character varying) OWNER TO postgres;

--
-- Name: get_texto_sem_espaco(character varying); Type: FUNCTION; Schema: relatorio; Owner: postgres
--

CREATE FUNCTION get_texto_sem_espaco(character varying) RETURNS character varying
LANGUAGE sql
AS $_$
SELECT translate(public.fcn_upper(regexp_replace($1,' ','','g')), 'åáàãâäéèêëíìîïóòõôöúùüûçÿýñÅÁÀÃÂÄÉÈÊËÍÌÎÏÓÒÕÔÖÚÙÛÜÇÝÑ', 'aaaaaaeeeeiiiiooooouuuucyynAAAAAAEEEEIIIIOOOOOUUUUCYN');$_$;

ALTER FUNCTION relatorio.get_texto_sem_espaco(character varying) OWNER TO postgres;

--
-- Name: count_weekdays(date, date); Type: FUNCTION; Schema: relatorio; Owner: ieducar
--

CREATE FUNCTION count_weekdays(start_date date, end_date date) RETURNS integer
    LANGUAGE plpgsql
    AS $$
                        DECLARE
                          tmp_date date;
                          tmp_dow integer;
                          -- double precision returned from extract
                          tot_dow integer;
                        BEGIN
                          tmp_date := start_date;
                          tot_dow := 0;

                          WHILE (tmp_date <= end_date) LOOP
                            SELECT INTO tmp_dow cast(extract(dow
                              FROM tmp_date) AS integer);

                            IF ((tmp_dow >= 2) AND (tmp_dow <= 6)) THEN
                              tot_dow := (tot_dow + 1);
                            END IF;

                            SELECT INTO tmp_date (tmp_date + interval '1 DAY ');

                          END LOOP;

                          RETURN tot_dow;
                        END; $$;


ALTER FUNCTION relatorio.count_weekdays(start_date date, end_date date) OWNER TO ieducar;

--
-- Name: formata_nome(text); Type: FUNCTION; Schema: relatorio; Owner: ieducar
--

CREATE FUNCTION formata_nome(var text) RETURNS text
    LANGUAGE sql
    AS $_$
                        SELECT array_to_string(array_agg(nomes),' ')
                          FROM(
                               SELECT CASE WHEN lower(x.id_unico[i]) = 'de' THEN lower(x.id_unico[i])
                                           WHEN lower(x.id_unico[i]) = 'dos' THEN lower(x.id_unico[i])
                                           WHEN lower(x.id_unico[i]) = 'da' THEN lower(x.id_unico[i])
                                           WHEN lower(x.id_unico[i]) = 'e' THEN lower(x.id_unico[i])
                                           ELSE upper(substring(x.id_unico[i],1,1)) || lower(substring(x.id_unico[i],2))
                                            END AS nomes
                                 FROM(
                                      SELECT *
                                        FROM string_to_array(cast($1 AS text),' ') AS id_unico) AS x,
            generate_series(1,array_upper(string_to_array(cast($1 as text),' '),1)) AS i) AS x;
                        $_$;


ALTER FUNCTION relatorio.formata_nome(var text) OWNER TO ieducar;

--
-- Name: FUNCTION formata_nome(var text); Type: COMMENT; Schema: relatorio; Owner: ieducar
--

COMMENT ON FUNCTION formata_nome(var text) IS 'Função que formata um nome, colocando iniciais em maiúsculas e demais em minúsculas';